DataFrames.jl
=============

[![codecov](https://codecov.io/gh/JuliaData/DataFrames.jl/graph/badge.svg?token=DHYzeKcumV)](https://codecov.io/gh/JuliaData/DataFrames.jl)
[![CI Testing](https://github.com/JuliaData/DataFrames.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/DataFrames.jl/actions?query=workflow%3ACI+branch%3Amain)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.7632427.svg)](https://doi.org/10.5281/zenodo.7632427)

Tools for working with tabular data in Julia.

**Installation**: at the Julia REPL, `using Pkg; Pkg.add("DataFrames")`

**Documentation**: [![][docs-stable-img]][docs-stable-url] [![][docs-latest-img]][docs-latest-url]

**Reporting Issues and Contributing**: See [CONTRIBUTING.md](CONTRIBUTING.md)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

**Maintenance**: DataFrames is maintained collectively by the [JuliaData collaborators](https://github.com/orgs/JuliaData/people).
Responsiveness to pull requests and issues can vary, depending on the availability of key collaborators.

**Learning**: New to DataFrames.jl? Check out our
[free Julia Academy course](https://juliaacademy.com/p/introduction-to-dataframes-jl)
which will walk you through how to use DataFrames.jl.
You can also check out
[Bogumił Kamiński's DataFrames.jl tutorial](https://github.com/bkamins/Julia-DataFrames-Tutorial)
that is available on GitHub.

[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: http://dataframes.juliadata.org/latest/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: http://dataframes.juliadata.org/stable/

**Citing**: We encourage you to cite our work if you have used DataFrames.jl package.
Starring the DataFrames.jl repository on GitHub is also appreciated.

The citation information may be found in the [CITATION.bib](CITATION.bib) file within the repository:

> Bouchet-Valat, M., & Kamiński, B. (2023). DataFrames.jl: Flexible and Fast Tabular Data in Julia. Journal of Statistical Software, 107(4), 1–32. https://doi.org/10.18637/jss.v107.i04

# Introduction

In this folder we store the following data sets:

- german_credit.csv
- iris.csv

# German Credit data set

## License:
https://opendatacommons.org/licenses/dbcl/1-0/

## Source:
https://archive.ics.uci.edu/ml/datasets/statlog+(german+credit+data)
Professor Dr. Hans Hofmann
Institut für Statistik und Ökonometrie
Universität Hamburg
FB Wirtschaftswissenschaften
Von-Melle-Park 5
2000 Hamburg 13

The original data is from [UCI](https://archive.ics.uci.edu/ml/datasets/statlog+(german+credit+data)),
and the file stored here is from [Kaggle](https://www.kaggle.com/uciml/german-credit)

# Iris data set

## License
https://creativecommons.org/publicdomain/zero/1.0/

## Source:
https://archive.ics.uci.edu/ml/datasets/Iris
Creator:
R.A. Fisher

module TestIndexingSubDataFrame

using Test, DataFrames, CategoricalArrays, PooledArrays

const ≅ = isequal

@testset "mutating SubDataFrame with assignment to [!, col]" begin
    df = DataFrame()
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(a=[])

    df = DataFrame()
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = Int[]
    @test isempty(df)

    df = DataFrame()
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(a=[])

    df = DataFrame()
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = Int[]
    @test isempty(df)

    df = DataFrame(x=Int[])
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(x=Int[], a=[])
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = Int[]
    @test df == DataFrame(x=Int[])
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(x=Int[], a=[])
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = Int[]
    @test df == DataFrame(x=Int[])
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = Int[]
    @test df ≅ DataFrame(x=1:5)
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=1:5)

    df = DataFrame(x=1:5)
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[!, :a] = [1]
    sdf[!, :a] = 11:15
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=11:15)
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = fill(nothing, 5)
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=nothing, a=11:15)

    df = DataFrame(x=1:5)
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :a] = 11:15
    @test df ≅ DataFrame(x=1:5)
    @test_throws DimensionMismatch sdf[!, :x] = ["a"]
    sdf[!, :x] = fill(nothing, 5)
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=fill(nothing, 5))

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], :]
    sdf[!, :d] = [101, 103]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[101, missing, 103, missing, missing])
    sdf[!, :a] = [-1.0, -3.0]
    @test eltype(df.a) === Float64
    @test df ≅ DataFrame(a=[-1.0, 2, -3.0, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 103, missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], 1:end]
    @test_throws ArgumentError sdf[!, :d] = [101, 103]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[!, :a] = [-1.0, -3.0]
    @test eltype(df.a) === Float64
    @test df ≅ DataFrame(a=[-1.0, 2, -3.0, 4, 5],
                         b=11:15, c=21:25)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    sdf[!, :d] = [103, 102]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing])
    sdf[!, "e"] = [1003, 1002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws ArgumentError sdf[!, 0] = [10003, 10002]
    @test_throws ArgumentError sdf[!, 6] = [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[!, 1] = ["10003", "10002"]
    @test eltype(df.a) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[!, :b] = [-13.0, -12.0]
    @test eltype(df.b) === Float64
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws ArgumentError sdf[!, :x] = 1
    @test_throws ArgumentError sdf[!, :x] = [1]
    @test_throws ArgumentError sdf[!, :a] = 1
    @test_throws DimensionMismatch sdf[!, :a] = [1]
    sdf[!, :f] = categorical(["3", "2"])
    @test df.f isa CategoricalArray
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    tmpc = df.c
    sdf[!, 3] = [33, 22]
    @test tmpc == 21:25
    @test tmpc != df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    sdf[!, 3] = categorical(["33", "22"])
    @test eltype(df.c) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, "22", "33", 24, 25],
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    @test df.c[2] isa CategoricalValue
    @test df.c[3] isa CategoricalValue

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], 1:3]
    @test_throws ArgumentError sdf[!, :d] = [103, 102]
    @test_throws ArgumentError sdf[!, "e"] = [1003, 1002]
    @test_throws ArgumentError sdf[!, 0] = [10003, 10002]
    @test_throws ArgumentError sdf[!, 6] = [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[!, 1] = ["10003", "10002"]
    @test eltype(df.a) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=11:15, c=21:25)
    sdf[!, :b] = [-13.0, -12.0]
    @test eltype(df.b) === Float64
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=21:25)
    @test_throws ArgumentError sdf[!, :x] = 1
    @test_throws ArgumentError sdf[!, :x] = [1]
    @test_throws ArgumentError sdf[!, :a] = 1
    @test_throws DimensionMismatch sdf[!, :a] = [1]
    @test_throws ArgumentError sdf[!, :f] = categorical(["3", "2"])
    tmpc = df.c
    sdf[!, 3] = [33, 22]
    @test tmpc == 21:25
    @test tmpc != df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, 22, 33, 24, 25])
    sdf[!, 3] = categorical(["33", "22"])
    @test eltype(df.c) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, "22", "33", 24, 25])
    @test df.c[2] isa CategoricalValue
    @test df.c[3] isa CategoricalValue

    sdf = @view df[[3, 2], 1:2]
    @test_throws ArgumentError sdf[!, :c] = 1:2
end

@testset "mutating SubDataFrame with broadcasting assignment to [!, col]" begin
    df = DataFrame()
    sdf = @view df[:, :]
    sdf[!, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[!, :b] .= 1
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)
    @test_throws DimensionMismatch sdf[!, :c] .= 1:2
    @test_throws DimensionMismatch sdf[!, :a] .= 1:2
    sdf[!, :a] .= [1.0]
    @test df.a isa Vector{Union{Missing, Float64}}
    @test isempty(df.a)
    sdf[!, :b] .= 1.0
    @test df.b isa Vector{Union{Missing, Float64}}
    @test isempty(df.b)

    df = DataFrame()
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[!, :a] .= [1]
    @test_throws ArgumentError sdf[!, :b] .= 1
    @test isempty(df)

    df = DataFrame()
    sdf = @view df[1:0, :]
    sdf[!, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[!, :b] .= 1
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)
    @test_throws DimensionMismatch sdf[!, :c] .= 1:2
    @test_throws DimensionMismatch sdf[!, :a] .= 1:2
    sdf[!, :a] .= [1.0]
    @test df.a isa Vector{Union{Missing, Float64}}
    @test isempty(df.a)
    sdf[!, :b] .= 1.0
    @test df.b isa Vector{Union{Missing, Float64}}
    @test isempty(df.b)

    df = DataFrame()
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[!, :a] .= [1]
    @test_throws ArgumentError sdf[!, :b] .= 1
    @test isempty(df)

    df = DataFrame(x=Int[])
    sdf = @view df[:, :]
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[:, 1:end]
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, :]
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, 1:end]
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, :]
    sdf[!, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)
    sdf[!, :x] .= Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[!, :a] .= [1]
    @test df == DataFrame(x=1:5)
    sdf[!, :x] .= Nothing[]
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=1:5)

    df = DataFrame(x=1:5)
    sdf = @view df[:, :]
    sdf[!, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=1)
    sdf[!, :b] .= 2
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=1, b=2)
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=fill(nothing, 5), a=1, b=2)

    df = DataFrame(x=1:5)
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[!, :a] .= [1]
    @test_throws ArgumentError sdf[!, :b] .= 2
    @test df == DataFrame(x=1:5)
    sdf[!, :x] .= nothing
    @test df.x isa Vector{Union{Nothing, Int}}
    @test df ≅ DataFrame(x=fill(nothing, 5))

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], :]
    sdf[!, :d] .= 101
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    sdf[!, :a] .= -1.0
    @test eltype(df.a) === Float64
    @test df ≅ DataFrame(a=[-1.0, 2, -1.0, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    @test_throws DimensionMismatch sdf[!, :a] .= [-1.0, -2.0, -3.0]
    sdf[!, :a] .= [-1.0, -2.0]
    @test df ≅ DataFrame(a=[-1.0, 2, -2.0, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    sdf[!, :e] .= 1:2
    @test df ≅ DataFrame(a=[-1.0, 2, -2.0, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing],
                         e=[1, missing, 2, missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], 1:end]
    @test_throws ArgumentError sdf[!, :d] .= 101
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[!, :a] .= -1.0
    @test eltype(df.a) === Float64
    @test df ≅ DataFrame(a=[-1.0, 2, -1.0, 4, 5],
                         b=11:15, c=21:25)
    @test_throws DimensionMismatch sdf[!, :a] .= [-1.0, -2.0, -3.0]
    sdf[!, :a] .= [-1.0, -2.0]
    @test df ≅ DataFrame(a=[-1.0, 2, -2.0, 4, 5],
                         b=11:15, c=21:25)
    @test_throws ArgumentError sdf[!, :e] .= 1:2
    @test df ≅ DataFrame(a=[-1.0, 2, -2.0, 4, 5],
                         b=11:15, c=21:25)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    sdf[!, :d] .= 102
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing])
    sdf[!, "e"] .= [1003, 1002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws ArgumentError sdf[!, 0] .= [10003, 10002]
    @test_throws ArgumentError sdf[!, 6] .= 10002
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[!, 1] .= "10002"
    @test eltype(df.a) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10002", 4, 5],
                         b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[!, :b] .= [-13.0, -12.0]
    @test eltype(df.b) === Float64
    @test df ≅ DataFrame(a=[1, "10002", "10002", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws DimensionMismatch sdf[!, :x] .= 1:3
    @test_throws DimensionMismatch sdf[!, :a] .= 1:3
    sdf[!, :f] .= categorical(["3", "2"])
    @test df.f isa CategoricalArray
    @test df ≅ DataFrame(a=[1, "10002", "10002", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    tmpc = df.c
    sdf[!, 3] .= [33, 22]
    @test tmpc == 21:25
    @test tmpc != df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, "10002", "10002", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    sdf[!, 3] .= categorical(["33", "22"])[2]
    @test eltype(df.c) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10002", 4, 5],
                         b=[11, -12.0, -13.0, 14, 15],
                         c=[21, "22", "22", 24, 25],
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    @test df.c[2] isa CategoricalValue
    @test df.c[3] isa CategoricalValue

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], 1:3]
    @test_throws ArgumentError sdf[!, :d] .= [103, 102]
    @test_throws ArgumentError sdf[!, "e"] .= [1003, 1002]
    @test_throws ArgumentError sdf[!, 0] .= [10003, 10002]
    @test_throws ArgumentError sdf[!, 6] .= [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[!, 1] .= ["10003", "10002"]
    @test eltype(df.a) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=11:15, c=21:25)
    sdf[!, :b] .= -12.0
    @test eltype(df.b) === Float64
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -12.0, 14, 15],
                         c=21:25)
    @test_throws ArgumentError sdf[!, :x] .= 1
    @test_throws ArgumentError sdf[!, :x] .= [1]
    @test_throws ArgumentError sdf[!, :f] .= categorical(["3", "2"])
    tmpc = df.c
    sdf[!, 3] .= [33, 22]
    @test tmpc == 21:25
    @test tmpc != df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -12.0, 14, 15],
                         c=[21, 22, 33, 24, 25])
    sdf[!, 3] .= categorical(["33", "22"])[2]
    @test eltype(df.c) === Any
    @test df ≅ DataFrame(a=[1, "10002", "10003", 4, 5],
                         b=[11, -12.0, -12.0, 14, 15],
                         c=[21, "22", "22", 24, 25])
    @test df.c[2] isa CategoricalValue
    @test df.c[3] isa CategoricalValue

    sdf = @view df[[3, 2], 1:2]
    @test_throws ArgumentError sdf[!, :c] .= 1:2
end

@testset "mutating SubDataFrame with assignment to [!, cols]" begin
    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, [:c, :b, :a]] = DataFrame(c=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=[21, "d", "c", 24, 25])
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64
        @test eltype(df.c) == Any

        @test_throws ArgumentError sdf[!, [:c, :b, :a]] = DataFrame(d=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test_throws ArgumentError sdf[!, [:c, :b, :a]] = DataFrame(a=["c", "d"], b=[1.0, 2.0], c=[13, 12])
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64

        @test_throws ArgumentError sdf[!, cols] = DataFrame(b=[1.0, 2.0], a=[13, 12])
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[!, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64
        @test_throws ArgumentError sdf[!, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0], c=1)
    end

    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, [:c, :b, :a]] = ["b" "d" "f"; "a" "c" "e"]
        @test df == DataFrame(a=[1, "e", "f", 4, 5],
                            b=[11.0, "c", "d", 14.0, 15.0],
                            c=[21, "a", "b", 24, 25])
        @test tmpa !== df.a
        @test eltype(df.a) == Any
        @test eltype(df.b) == Any
        @test eltype(df.c) == Any

        @test_throws DimensionMismatch sdf[!, [:c, :b, :a]] = ones(2, 2)
        @test_throws DimensionMismatch sdf[!, [:c, :b, :a]] = ones(1, 3)
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, cols] = [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2.0, 1.0, 4, 5],
                            b=[11.0, 4.0, 3.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Float64
        @test eltype(df.b) == Float64

        @test_throws DimensionMismatch sdf[!, cols] = ones(1, 3)
        @test_throws DimensionMismatch sdf[!, cols] = ones(3, 1)
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[!, cols] = [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2.0, 1.0, 4, 5],
                            b=[11.0, 4.0, 3.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Float64
        @test eltype(df.b) == Float64
        @test_throws DimensionMismatch sdf[!, cols] = ones(1, 3)
        @test_throws DimensionMismatch sdf[!, cols] = ones(3, 1)
    end
end

@testset "mutating SubDataFrame with broadcasting assignment to [!, cols]" begin
    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, [:c, :b, :a]] .= DataFrame(c=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=[21, "d", "c", 24, 25])
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64
        @test eltype(df.c) == Any

        sdf[!, [:c, :b, :a]] .= [100, 200]
        @test df == DataFrame(a=[1, 200, 100, 4, 5],
                            b=[11.0, 200.0, 100.0, 14.0, 15.0],
                            c=[21, 200, 100, 24, 25])

        @test_throws ArgumentError sdf[!, [:c, :b, :a]] .= DataFrame(d=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test_throws ArgumentError sdf[!, [:c, :b, :a]] .= DataFrame(a=["c", "d"], b=[1.0, 2.0], c=[13, 12])
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64

        sdf[!, cols] .= [100 200]
        @test df == DataFrame(a=[1, 100, 100, 4, 5],
                            b=[11.0, 200.0, 200.0, 14.0, 15.0],
                            c=21:25)

        @test_throws ArgumentError sdf[!, cols] .= DataFrame(b=[1.0, 2.0], a=[13, 12])
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[!, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                            b=[11.0, 2.0, 1.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Float64

        sdf[!, cols] .= 100
        @test df == DataFrame(a=[1, 100, 100, 4, 5],
                            b=[11.0, 100.0, 100.0, 14.0, 15.0],
                            c=21:25)

        @test_throws DimensionMismatch sdf[!, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0], c=1)
    end

    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, [:c, :b, :a]] .= ["b" "d" "f"; "a" "c" "e"]
        @test df == DataFrame(a=[1, "e", "f", 4, 5],
                            b=[11.0, "c", "d", 14.0, 15.0],
                            c=[21, "a", "b", 24, 25])
        @test tmpa !== df.a
        @test eltype(df.a) == Any
        @test eltype(df.b) == Any
        @test eltype(df.c) == Any

        @test_throws DimensionMismatch sdf[!, [:c, :b, :a]] .= ones(2, 2)
        @test_throws DimensionMismatch sdf[!, [:c, :b, :a]] .= ones(4, 3)
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[!, cols] .= [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2.0, 1.0, 4, 5],
                            b=[11.0, 4.0, 3.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Float64
        @test eltype(df.b) == Float64

        @test_throws DimensionMismatch sdf[!, cols] .= ones(4, 3)
        @test_throws DimensionMismatch sdf[!, cols] .= ones(3, 4)
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[!, cols] .= [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2.0, 1.0, 4, 5],
                            b=[11.0, 4.0, 3.0, 14.0, 15.0],
                            c=21:25)
        @test tmpa !== df.a
        @test eltype(df.a) == Float64
        @test eltype(df.b) == Float64
        @test_throws DimensionMismatch sdf[!, cols] .= ones(4, 3)
        @test_throws DimensionMismatch sdf[!, cols] .= ones(3, 4)
    end
end

@testset "mutating SubDataFrame with assignment to [:, col]" begin
    df = DataFrame()
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(a=[])

    df = DataFrame()
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = Int[]
    @test isempty(df)

    df = DataFrame()
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(a=[])

    df = DataFrame()
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = Int[]
    @test isempty(df)

    df = DataFrame(x=Int[])
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(x=Int[], a=[])
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = Int[]
    @test df == DataFrame(x=Int[])
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df == DataFrame(x=Int[], a=[])
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = Int[]
    @test df == DataFrame(x=Int[])
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = Int[]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}
    @test df ≅ DataFrame(x=1:5, a=missing)

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = Int[]
    @test df ≅ DataFrame(x=1:5)
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    sdf[:, :x] = Nothing[]
    @test df.x isa Vector{Int}
    @test df ≅ DataFrame(x=1:5)

    df = DataFrame(x=1:5)
    sdf = @view df[:, :]
    @test_throws ArgumentError sdf[:, :a] = [1]
    sdf[:, :a] = 11:15
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=11:15)
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    @test_throws MethodError sdf[:, :x] = fill(nothing, 5)
    @test df ≅ DataFrame(x=1:5, a=11:15)

    df = DataFrame(x=1:5)
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :a] = 11:15
    @test df ≅ DataFrame(x=1:5)
    @test_throws DimensionMismatch sdf[:, :x] = ["a"]
    @test_throws MethodError sdf[:, :x] = fill(nothing, 5)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], :]
    sdf[:, :d] = [101, 103]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[101, missing, 103, missing, missing])
    sdf[:, :a] = [-1.0, -3.0]
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[-1, 2, -3, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 103, missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], 1:end]
    @test_throws ArgumentError sdf[:, :d] = [101, 103]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[:, :a] = [-1.0, -3.0]
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[-1, 2, -3, 4, 5],
                         b=11:15, c=21:25)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    sdf[:, :d] = [103, 102]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing])
    sdf[:, "e"] = [1003, 1002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws BoundsError sdf[:, 0] = [10003, 10002]
    @test_throws BoundsError sdf[:, 6] = [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws MethodError sdf[:, 1] = ["10003", "10002"]
    sdf[:, 1] = [10003, 10002]
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=11:15, c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[:, :b] = [-13.0, -12.0]
    @test eltype(df.b) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws ArgumentError sdf[:, :x] = 1
    @test_throws ArgumentError sdf[:, :x] = [1]
    @test_throws MethodError sdf[:, :a] = 1
    @test_throws DimensionMismatch sdf[:, :a] = [1]
    sdf[:, :f] = categorical(["3", "2"])
    @test df.f isa CategoricalArray
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=21:25,
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    tmpc = df.c
    sdf[:, 3] = [33, 22]
    @test tmpc === df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    @test_throws MethodError sdf[:, 3] = categorical(["33", "22"])
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 103, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], 1:3]
    @test_throws ArgumentError sdf[:, :d] = [103, 102]
    @test_throws ArgumentError sdf[:, "e"] = [1003, 1002]
    @test_throws BoundsError sdf[:, 0] = [10003, 10002]
    @test_throws BoundsError sdf[:, 6] = [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    @test_throws MethodError sdf[:, 1] = ["10003", "10002"]
    sdf[:, 1] = [10003, 10002]
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=11:15, c=21:25)
    sdf[:, :b] = [-13.0, -12.0]
    @test eltype(df.b) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=21:25)
    @test_throws ArgumentError sdf[:, :x] = 1
    @test_throws ArgumentError sdf[:, :x] = [1]
    @test_throws MethodError sdf[:, :a] = 1
    @test_throws DimensionMismatch sdf[:, :a] = [1]
    @test_throws ArgumentError sdf[:, :f] = categorical(["3", "2"])
    tmpc = df.c
    sdf[:, 3] = [33, 22]
    @test tmpc === df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25])
    @test_throws MethodError sdf[:, 3] = categorical(["33", "22"])
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25])

    sdf = @view df[[3, 2], 1:2]
    @test_throws ArgumentError df[!, :c] = 1:2
end

@testset "mutating SubDataFrame with broadcasting assignment to [:, col]" begin
    df = DataFrame()
    sdf = @view df[:, :]
    sdf[:, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[:, :b] .= 1
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)
    @test_throws DimensionMismatch sdf[:, :c] .= 1:2
    @test_throws DimensionMismatch sdf[:, :a] .= 1:2
    sdf[:, :a] .= [1.0]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[:, :b] .= 1.0
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)

    df = DataFrame()
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[:, :a] .= [1]
    @test_throws ArgumentError sdf[:, :b] .= 1
    @test isempty(df)

    df = DataFrame()
    sdf = @view df[1:0, :]
    sdf[:, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[:, :b] .= 1
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)
    @test_throws DimensionMismatch sdf[:, :c] .= 1:2
    @test_throws DimensionMismatch sdf[:, :a] .= 1:2
    sdf[:, :a] .= [1.0]
    @test df.a isa Vector{Union{Missing, Int}}
    @test isempty(df.a)
    sdf[:, :b] .= 1.0
    @test df.b isa Vector{Union{Missing, Int}}
    @test isempty(df.b)

    df = DataFrame()
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[:, :a] .= [1]
    @test_throws ArgumentError sdf[:, :b] .= 1
    @test isempty(df)

    df = DataFrame(x=Int[])
    sdf = @view df[:, :]
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[:, 1:end]
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, :]
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}

    df = DataFrame(x=Int[])
    sdf = @view df[1:0, 1:end]
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, :]
    sdf[:, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=missing)
    sdf[:, :x] .= Nothing[]
    @test df.x isa Vector{Int}
    @test df ≅ DataFrame(x=1:5, a=missing)

    df = DataFrame(x=1:5)
    sdf = @view df[1:0, 1:end]
    @test_throws ArgumentError sdf[:, :a] .= [1]
    @test df == DataFrame(x=1:5)
    sdf[:, :x] .= Nothing[]
    @test df.x isa Vector{Int}
    @test df ≅ DataFrame(x=1:5)

    df = DataFrame(x=1:5)
    sdf = @view df[:, :]
    sdf[:, :a] .= [1]
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=1)
    sdf[:, :b] .= 2
    @test df.a isa Vector{Union{Missing, Int}}
    @test df ≅ DataFrame(x=1:5, a=1, b=2)
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}
    sdf[:, :x] .= 1
    @test df ≅ DataFrame(x=fill(1, 5), a=1, b=2)

    df = DataFrame(x=1:5)
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError sdf[:, :a] .= [1]
    @test_throws ArgumentError sdf[:, :b] .= 2
    @test df == DataFrame(x=1:5)
    @test_throws MethodError sdf[:, :x] .= nothing
    @test df.x isa Vector{Int}
    sdf[:, :x] .= 1
    @test df ≅ DataFrame(x=fill(1, 5))

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], :]
    sdf[:, :d] .= 101
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    sdf[:, :a] .= -1.0
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[-1, 2, -1, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    @test_throws DimensionMismatch sdf[:, :a] .= [-1.0, -2.0, -3.0]
    sdf[:, :a] .= [-1.0, -2.0]
    @test df ≅ DataFrame(a=[-1, 2, -2, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing])
    sdf[:, :e] .= 1:2
    @test df ≅ DataFrame(a=[-1, 2, -2, 4, 5],
                         b=11:15, c=21:25,
                         d=[101, missing, 101, missing, missing],
                         e=[1, missing, 2, missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[1, 3], 1:end]
    @test_throws ArgumentError sdf[:, :d] .= 101
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    sdf[:, :a] .= -1.0
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[-1, 2, -1, 4, 5],
                         b=11:15, c=21:25)
    @test_throws DimensionMismatch sdf[:, :a] .= [-1.0, -2.0, -3.0]
    sdf[:, :a] .= [-1.0, -2.0]
    @test df ≅ DataFrame(a=[-1, 2, -2, 4, 5],
                         b=11:15, c=21:25)
    @test_throws ArgumentError sdf[:, :e] .= 1:2
    @test df ≅ DataFrame(a=[-1, 2, -2, 4, 5],
                         b=11:15, c=21:25)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    sdf[:, :d] .= 102
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing])
    sdf[:, "e"] .= [1003, 1002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws ArgumentError sdf[:, 0] .= [10003, 10002]
    @test_throws ArgumentError sdf[:, 6] .= 10002
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws MethodError sdf[:, 1] .= "10002"
    sdf[:, 1] .= 10002
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10002, 4, 5],
                         b=11:15, c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    sdf[:, :b] .= [-13.0, -12.0]
    @test eltype(df.b) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10002, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing])
    @test_throws DimensionMismatch sdf[:, :x] .= 1:3
    @test_throws DimensionMismatch sdf[:, :a] .= 1:3
    sdf[:, :f] .= categorical(["3", "2"])
    @test df.f isa CategoricalArray
    @test df ≅ DataFrame(a=[1, 10002, 10002, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=21:25,
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    tmpc = df.c
    sdf[:, 3] .= [33, 22]
    @test tmpc === df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10002, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])
    @test_throws MethodError sdf[:, 3] .= categorical(["33", "22"])[2]
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10002, 4, 5],
                         b=[11, -12, -13, 14, 15],
                         c=[21, 22, 33, 24, 25],
                         d=[missing, 102, 102, missing, missing],
                         e=[missing, 1002, 1003, missing, missing],
                         f=[missing, "2", "3", missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], 1:3]
    @test_throws ArgumentError sdf[:, :d] .= [103, 102]
    @test_throws ArgumentError sdf[:, "e"] .= [1003, 1002]
    @test_throws ArgumentError sdf[:, 0] .= [10003, 10002]
    @test_throws ArgumentError sdf[:, 6] .= [10003, 10002]
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25)
    @test_throws MethodError sdf[:, 1] .= ["10003", "10002"]
    sdf[:, 1] .= [10003, 10002]
    @test eltype(df.a) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=11:15, c=21:25)
    sdf[:, :b] .= -12.0
    @test eltype(df.b) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -12, 14, 15],
                         c=21:25)
    @test_throws ArgumentError sdf[:, :x] .= 1
    @test_throws ArgumentError sdf[:, :x] .= [1]
    @test_throws ArgumentError sdf[:, :f] .= categorical(["3", "2"])
    tmpc = df.c
    sdf[:, 3] .= [33, 22]
    @test tmpc === df.c
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -12, 14, 15],
                         c=[21, 22, 33, 24, 25])
    @test_throws MethodError sdf[:, 3] .= categorical(["33", "22"])[2]
    @test eltype(df.c) === Int
    @test df ≅ DataFrame(a=[1, 10002, 10003, 4, 5],
                         b=[11, -12, -12, 14, 15],
                         c=[21, 22, 33, 24, 25])

    sdf = @view df[[3, 2], 1:2]
    @test_throws ArgumentError sdf[:, :c] .= 1:2
end

@testset "mutating SubDataFrame with assignment to [:, cols]" begin
    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, [:c, :b, :a]] = DataFrame(c=[5, 6], b=[1.0, 2.0], a=[13, 12])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11.0, 2.0, 1.0, 14.0, 15.0],
                              c=[21, 6, 5, 24, 25])
        @test tmpa === df.a

        @test_throws ArgumentError sdf[:, [:c, :b, :a]] = DataFrame(d=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test_throws ArgumentError sdf[:, [:c, :b, :a]] = DataFrame(a=["c", "d"], b=[1.0, 2.0], c=[13, 12])
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11, 2, 1, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int

        @test_throws ArgumentError sdf[:, cols] = DataFrame(b=[1.0, 2.0], a=[13, 12])
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[:, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11, 2, 1, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test_throws ArgumentError sdf[:, cols] = DataFrame(a=[13, 12], b=[1.0, 2.0], c=1)
    end

    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, [:c, :b, :a]] = [100 101 102; 103 104 105]
        @test df == DataFrame(a=[1, 105, 102, 4, 5],
                              b=[11.0, 104, 101, 14.0, 15.0],
                              c=[21, 103, 100, 24, 25])
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test eltype(df.c) == Int

        @test_throws DimensionMismatch sdf[:, [:c, :b, :a]] = ones(2, 2)
        @test_throws DimensionMismatch sdf[:, [:c, :b, :a]] = ones(1, 3)
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, cols] = [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2, 1, 4, 5],
                              b=[11, 4, 3, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int

        @test_throws DimensionMismatch sdf[:, cols] = ones(1, 3)
        @test_throws DimensionMismatch sdf[:, cols] = ones(3, 1)
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[:, cols] = [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2, 1, 4, 5],
                              b=[11, 4, 3, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test_throws DimensionMismatch sdf[:, cols] = ones(1, 3)
        @test_throws DimensionMismatch sdf[:, cols] = ones(3, 1)
    end
end

@testset "mutating SubDataFrame with broadcasting assignment to [:, cols]" begin
    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, [:c, :b, :a]] .= DataFrame(c=[100, 101], b=[1.0, 2.0], a=[13, 12])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11, 2, 1, 14, 15],
                              c=[21, 101, 100, 24, 25])
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test eltype(df.c) == Int

        sdf[:, [:c, :b, :a]] .= [100, 200]
        @test df == DataFrame(a=[1, 200, 100, 4, 5],
                              b=[11, 200, 100, 14, 15],
                              c=[21, 200, 100, 24, 25])

        @test_throws ArgumentError sdf[:, [:c, :b, :a]] .= DataFrame(d=["c", "d"], b=[1.0, 2.0], a=[13, 12])
        @test_throws ArgumentError sdf[:, [:c, :b, :a]] .= DataFrame(a=["c", "d"], b=[1.0, 2.0], c=[13, 12])
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11, 2, 1, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int

        sdf[:, cols] .= [100 200]
        @test df == DataFrame(a=[1, 100, 100, 4, 5],
                              b=[11, 200, 200, 14, 15],
                              c=21:25)

        @test_throws ArgumentError sdf[:, cols] .= DataFrame(b=[1.0, 2.0], a=[13, 12])
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[:, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0])
        @test df == DataFrame(a=[1, 12, 13, 4, 5],
                              b=[11, 2, 1, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int

        sdf[:, cols] .= 100
        @test df == DataFrame(a=[1, 100, 100, 4, 5],
                              b=[11, 100, 100, 14, 15],
                              c=21:25)

        @test_throws DimensionMismatch sdf[:, cols] .= DataFrame(a=[13, 12], b=[1.0, 2.0], c=1)
    end

    for sel in (:, 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, [:c, :b, :a]] .= [100 101 102; 103 104 105]
        @test df == DataFrame(a=[1, 105, 102, 4, 5],
                              b=[11.0, 104, 101, 14.0, 15.0],
                              c=[21, 103, 100, 24, 25])
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test eltype(df.c) == Int

        @test_throws DimensionMismatch sdf[:, [:c, :b, :a]] .= ones(2, 2)
        @test_throws DimensionMismatch sdf[:, [:c, :b, :a]] .= ones(4, 3)
    end

    for sel in (:, 1:3), cols in (Between(:a, :b), Not(:c), r"[ab]", [true, true, false])
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], sel]
        tmpa = df.a
        sdf[:, cols] .= [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2, 1, 4, 5],
                              b=[11, 4, 3, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int

        @test_throws DimensionMismatch sdf[:, cols] .= ones(4, 3)
        @test_throws DimensionMismatch sdf[:, cols] .= ones(3, 4)
    end

    for cols in (All(), :, Cols(:a, :b))
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        sdf = @view df[[3, 2], 1:2]
        tmpa = df.a
        sdf[:, cols] .= [1.0 3.0; 2.0 4.0]
        @test df == DataFrame(a=[1, 2, 1, 4, 5],
                              b=[11, 4, 3, 14, 15],
                              c=21:25)
        @test tmpa === df.a
        @test eltype(df.a) == Int
        @test eltype(df.b) == Int
        @test_throws DimensionMismatch sdf[:, cols] .= ones(4, 3)
        @test_throws DimensionMismatch sdf[:, cols] .= ones(3, 4)
    end
end

@testset "mutating SubDataFrame with assignment to sdf.col" begin
    df = DataFrame(a=1:3)
    sdf = @view df[[3, 2], :]
    sdf.c = [5, 6]
    @test df ≅ DataFrame(a=1:3, c=[missing, 6, 5])
    sdf.a = [13.0, 12.0]
    @test eltype(sdf.a) === Float64
    @test df ≅ DataFrame(a=[1.0, 12.0, 13.0], c=[missing, 6, 5])

    df = DataFrame(a=1:3)
    sdf = @view df[[3, 2], 1:1]
    @test_throws ArgumentError sdf.c = [5, 6]
    sdf.a = [13.0, 12.0]
    @test eltype(sdf.a) === Float64
    @test df ≅ DataFrame(a=[1.0, 12.0, 13.0])
end

@testset "mutating SubDataFrame with broadcasting assignment to sdf.col" begin
    df = DataFrame(a=1:3)
    sdf = @view df[[3, 2], :]
    sdf.a .= 12.0
    @test eltype(sdf.a) === Float64
    @test df ≅ DataFrame(a=[1, 12, 12])

    sdf.c .= 100
    @test df ≅ DataFrame(a=[1, 12, 12], c=[missing, 100, 100])

    df = DataFrame(a=1:3)
    sdf = @view df[[3, 2], 1:1]
    @test_throws ArgumentError sdf.c = [5, 6]
    sdf.a .= 12.0
    @test eltype(sdf.a) === Float64
    @test df ≅ DataFrame(a=[1, 12, 12])
end

@testset "insertcols! for SubDataFrame" begin
    df = DataFrame(a=1:5, b=11:15)
    sdf = @view df[:, 1:end]
    @test_throws ArgumentError insertcols!(sdf, :c => 1)
    @test df == DataFrame(a=1:5, b=11:15)

    df = DataFrame(a=1:5, b=11:15)
    sdf = @view df[:, :]
    @test_throws ArgumentError insertcols!(sdf, :c => 1, copycols=false)
    @test df == DataFrame(a=1:5, b=11:15)
    insertcols!(sdf, :c => 1)
    @test df == DataFrame(a=1:5, b=11:15, c=1)
    @test eltype(df.c) === Union{Int, Missing}
    @test_throws DimensionMismatch insertcols!(sdf, :d => [1])
    insertcols!(sdf, :d => 101:105)
    @test df == DataFrame(a=1:5, b=11:15, c=1, d=101:105)
    @test eltype(df.d) === Union{Int, Missing}

    df = DataFrame(a=1:5, b=11:15)
    sdf = @view df[[3, 2], :]
    insertcols!(sdf, :c => 1)
    @test df ≅ DataFrame(a=1:5, b=11:15, c=[missing, 1, 1, missing, missing])
    @test eltype(df.c) === Union{Int, Missing}
    @test_throws DimensionMismatch insertcols!(sdf, :d => [1])
    insertcols!(sdf, :d => [103, 102])
    @test df ≅ DataFrame(a=1:5, b=11:15, c=[missing, 1, 1, missing, missing],
                         d=[missing, 102, 103, missing, missing])
    @test eltype(df.d) === Union{Int, Missing}

    df = DataFrame(a=1:5, b=11:15)
    sdf = @view df[3:2, :]
    insertcols!(sdf, :c => 1)
    @test df ≅ DataFrame(a=1:5, b=11:15, c=[missing, missing, missing, missing, missing])
    @test eltype(df.c) === Union{Int, Missing}
    @test_throws DimensionMismatch insertcols!(sdf, :d => [1])
    insertcols!(sdf, :d => Int[])
    @test df ≅ DataFrame(a=1:5, b=11:15, c=[missing, missing, missing, missing, missing],
                         d=[missing, missing, missing, missing, missing])
    @test eltype(df.d) === Union{Int, Missing}
end

@testset "select! on SubDataFrame" begin
    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    @test_throws ArgumentError select!(sdf, :c => :b, :b => :c)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    select!(sdf, :b => :c, :c => :b)
    @test df == DataFrame(a=1:5,
                          b=[11, 22, 23, 14, 15],
                          c=[21, 12, 13, 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    @test_throws ArgumentError select!(sdf, :b => x -> ["b3", "b2"], :c => (x -> ["c3", "c2"]), renamecols=false)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    select!(sdf, :c => x -> ["c3", "c2"], :b => (x -> ["b3", "b2"]), renamecols=false)
    @test df == DataFrame(a=1:5,
                          b=[11, "b2", "b3", 14, 15],
                          c=[21, "c2", "c3", 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    select!(sdf, :a, :b => :c, :c => :b)
    @test df == DataFrame(a=1:5,
                          c=[21, 12, 13, 24, 25],
                          b=[11, 22, 23, 14, 15])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    select!(sdf, :b => :d, :c => :b)
    @test df ≅ DataFrame(d=[missing, 12, 13, missing, missing],
                         b=[11, 22, 23, 14, 15])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    @test_throws ArgumentError select!(sdf)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    select!(sdf)
    @test df == DataFrame()

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[3:2, [3, 2]]
    @test_throws ArgumentError select!(sdf, :c => (x -> Int[]) => :d)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[3:2, :]
    select!(sdf, :c => (x -> Int[]) => :d)
    @test df ≅ DataFrame(d=missings(Int, 5))
    @test df.d isa Vector{Union{Int, Missing}}
end

@testset "transform! on SubDataFrame" begin
    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    transform!(sdf, :c => :b, :b => :c)
    @test df == DataFrame(a=1:5,
                          b=[11, 22, 23, 14, 15],
                          c=[21, 12, 13, 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    transform!(sdf, :b => :c, :c => :b)
    @test df == DataFrame(a=1:5,
                          b=[11, 22, 23, 14, 15],
                          c=[21, 12, 13, 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    transform!(sdf, :b => x -> ["b3", "b2"], :c => (x -> ["c3", "c2"]), renamecols=false)
    @test df == DataFrame(a=1:5,
                          b=[11, "b2", "b3", 14, 15],
                          c=[21, "c2", "c3", 24, 25])
    transform!(sdf, :c => x -> ["c3", "c2"], :b => (x -> ["b3", "b2"]), renamecols=false)
    @test df == DataFrame(a=1:5,
                          b=[11, "b2", "b3", 14, 15],
                          c=[21, "c2", "c3", 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    transform!(sdf, :b => :c, :c => :b)
    @test df == DataFrame(a=1:5,
                          b=[11, 22, 23, 14, 15],
                          c=[21, 12, 13, 24, 25])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    transform!(sdf, :b => :d, :c => :b)
    @test df ≅ DataFrame(a=1:5,
                         b=[11, 22, 23, 14, 15],
                         c=21:25,
                         d=[missing, 12, 13, missing, missing])

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], [3, 2]]
    transform!(sdf)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[[3, 2], :]
    transform!(sdf)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)

    df = DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[3:2, [3, 2]]
    @test_throws ArgumentError transform!(sdf, :c => (x -> Int[]) => :d)
    @test df == DataFrame(a=1:5, b=11:15, c=21:25)
    sdf = @view df[3:2, :]
    transform!(sdf, :c => (x -> Int[]) => :d)
    @test df ≅ DataFrame(a=1:5, b=11:15, c=21:25, d=missings(Int, 5))
    @test df.d isa Vector{Union{Int, Missing}}
end

@testset "select! on GroupedDataFrame{SubDataFrame}" begin
    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [2, 1, 3]]
    gsdf = groupby(sdf, :a)
    @test_throws ArgumentError select!(gsdf, :b => x -> x .+ 100, renamecols=false)
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [2, 1]]
    gsdf = groupby(sdf, :a)
    @test_throws ArgumentError select!(gsdf, :b => x -> x .+ 100, renamecols=false)
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [1, 3, 2]]
    gsdf = groupby(sdf, :a)
    @test select!(gsdf, :c, :b => x -> x .+ 100, renamecols=false, ungroup=false) === gsdf
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3],
                          b=[11, 112, 113, 114, 15, 16], c=21:26, d=31:36)

    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[[3, 4, 2], :]
    gsdf = groupby(sdf, :a)
    @test select!(gsdf, :b => x -> x .+ 100, :c => :e, renamecols=false) === sdf
    @test df ≅ DataFrame(a=[1, 1, 1, 2, 2, 3],
                         b=[11, 112, 113, 114, 15, 16],
                         e=[missing, 22, 23, 24, missing, missing])
end

@testset "transform! on GroupedDataFrame{SubDataFrame}" begin
    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [2, 1, 3]]
    gsdf = groupby(sdf, :a)
    transform!(gsdf, :b => x -> x .+ 100, renamecols=false)
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3],
                          b=[11, 112, 113, 114, 15, 16], c=21:26, d=31:36)

    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [2, 1]]
    gsdf = groupby(sdf, :a)
    transform!(gsdf, :b => x -> x .+ 100, renamecols=false)
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3],
                          b=[11, 112, 113, 114, 15, 16], c=21:26, d=31:36)

    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[2:4, [1, 3, 2]]
    gsdf = groupby(sdf, :a)
    @test transform!(gsdf, :c, :b => x -> x .+ 100, renamecols=false, ungroup=false) == gsdf
    @test df == DataFrame(a=[1, 1, 1, 2, 2, 3],
                          b=[11, 112, 113, 114, 15, 16], c=21:26, d=31:36)

    df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=11:16, c=21:26, d=31:36)
    sdf = @view df[[3, 4, 2], :]
    gsdf = groupby(sdf, :a)
    @test transform!(gsdf, :b => x -> x .+ 100, :c => :e, renamecols=false) === sdf
    @test df ≅ DataFrame(a=[1, 1, 1, 2, 2, 3],
                         b=[11, 112, 113, 114, 15, 16],
                         c=21:26, d=31:36,
                         e=[missing, 22, 23, 24, missing, missing])
end

@testset "promote_type tests" begin
    df = DataFrame(a=1:4)
    a = df.a
    sdf = @view df[1:1, :]
    sdf[!, 1] = [0]
    @test df.a == [0, 2, 3, 4]
    @test df.a != a
    @test a == 1:4
    @test eltype(df.a) === Int
    a = df.a
    sdf[!, 1] = [1.5]
    @test df.a == [1.5, 2, 3, 4]
    @test df.a != a
    @test a == [0, 2, 3, 4]
    @test eltype(df.a) === Float64

    # note that CategoricalVector is dropped as
    # similar(::CategoricalVector, String, length)
    # produces a Vector{String}
    df = DataFrame(a=categorical(string.(1:4)))
    sdf = @view df[1:1, :]
    sdf[!, 1] = ["a"]
    @test df.a == ["a", "2", "3", "4"]
    @test df.a isa Vector{String}

    df = DataFrame(a=categorical(string.(1:4)))
    sdf = @view df[1:1, :]
    sdf[!, 1] = categorical(["a"])
    @test df.a isa CategoricalVector{String}
    @test df.a == ["a", "2", "3", "4"]
    @test levels(df.a) == ["1", "2", "3", "4", "a"]

    df = DataFrame(a=1:4)
    a = df.a
    sdf = @view df[1:1, :]
    select!(sdf, :a => (x -> x) => :a)
    @test df.a !== a
    @test df.a == a == 1:4
    @test eltype(df.a) === Int
    a = df.a
    select!(sdf, :a => (x -> [1]) => :a)
    @test df.a !== a
    @test df.a == a == 1:4
    @test eltype(df.a) === Int
    a = df.a
    select!(sdf, :a => (x -> [1.5]) => :a)
    @test df.a == [1.5, 2, 3, 4]
    @test eltype(df.a) === Float64
    @test a == 1:4

    df = DataFrame(a=collect(Any, 1:4))
    a = df.a
    sdf = @view df[1:1, :]
    select!(sdf, :a => (x -> x) => :a)
    @test df.a == a
    @test a == 1:4
    @test df.a !== a
    @test eltype(df.a) === Any
    a = df.a
    select!(sdf, :a => (x -> [1]) => :a)
    @test df.a == a
    @test a == 1:4
    @test df.a !== a
    @test eltype(df.a) === Any
    a = df.a
    select!(sdf, :a => (x -> [1.5]) => :a)
    @test df.a == [1.5, 2, 3, 4]
    @test df.a !== a
    @test a == 1:4
    @test eltype(df.a) === Any

    df = DataFrame(a=PooledArray(1:4))
    a = df.a
    sdf = @view df[1:1, :]
    select!(sdf, :a => (x -> x) => :a)
    @test df.a == a
    @test df.a !== a
    @test a == 1:4
    # we keep PooledVector though as similar of PooledVector is PooledVector
    @test df.a isa PooledVector{Int}
    select!(sdf, :a => (x -> [1]) => :a)
    @test df.a == a
    @test a == 1:4
    @test df.a !== a
    @test df.a isa PooledVector{Int}
    a = df.a
    select!(sdf, :a => (x -> [1.5]) => :a)
    @test df.a == [1.5, 2, 3, 4]
    @test df.a !== a
    @test a == 1:4
    @test df.a isa PooledVector{Float64}
end

end # module

# this needs to be defined outside of the module to make
# Julia print type name without module name when displaying it
struct ⛵⛵⛵⛵⛵
end
Base.show(io::IO, ::⛵⛵⛵⛵⛵) = show(io, "⛵")

struct F<:AbstractFloat
    i::Int
end

Base.show(io::IO, f::F) = show(io, f.i)

module TestShow

using DataFrames, Dates, Random, Test, CategoricalArrays, InlineStrings

import Main: ⛵⛵⛵⛵⛵, F

function capture_stdout(f::Function)
    oldstdout = stdout
    rd, wr = redirect_stdout()
    f()
    redirect_stdout(oldstdout)
    size = displaysize(rd)
    close(wr)
    str = read(rd, String)
    close(rd)
    str, size
end

@testset "Basic show test with allrows and allcols" begin
    df = DataFrame(A=Int64[1:4;], B=["x\"", "∀ε>0: x+ε>x", "z\$", "A\nC"],
                   C=Float32[1.0, 2.0, 3.0, 4.0], D=['\'', '∀', '$', '\n'])

    refstr = """
    4×4 DataFrame
     Row │ A      B            C        D
         │ Int64  String       Float32  Char
    ─────┼───────────────────────────────────
       1 │     1  x"               1.0  '
       2 │     2  ∀ε>0: x+ε>x      2.0  ∀
       3 │     3  z\$               3.0  \$
       4 │     4  A\\nC             4.0  \\n"""

    for allrows in [true, false], allcols in [true, false]
        io = IOBuffer()
        show(io, df, allcols=allcols, allrows=allrows)
        str = String(take!(io))
        @test str == refstr
        io = IOBuffer()
        show(io, MIME("text/plain"), df, allcols=allcols, allrows=allrows)
        str = String(take!(io))
        @test str == refstr
    end

    df = DataFrame(A=Vector{String}(undef, 3))
    @test sprint(show, df) == """
        3×1 DataFrame
         Row │ A
             │ String
        ─────┼────────
           1 │ #undef
           2 │ #undef
           3 │ #undef"""
end

@testset "displaysize test" begin
    df_big = DataFrame(reshape(Int64(10000001):Int64(10000000+25*5), 25, 5),
                       :auto)

    io = IOContext(IOBuffer(), :displaysize=>(11, 40), :limit=>true)
    show(io, df_big)
    str = String(take!(io.io))
    @test str == """
        25×5 DataFrame
         Row │ x1        x2        x3        x ⋯
             │ Int64     Int64     Int64     I ⋯
        ─────┼──────────────────────────────────
           1 │ 10000001  10000026  10000051  1 ⋯
          ⋮  │    ⋮         ⋮         ⋮        ⋱
          25 │ 10000025  10000050  10000075  1
                   2 columns and 23 rows omitted"""

    io = IOContext(IOBuffer(), :displaysize=>(11, 40), :limit=>true)
    show(io, df_big, allcols=true)
    str = String(take!(io.io))
    @test str == """
        25×5 DataFrame
         Row │ x1        x2        x3        x4        x5
             │ Int64     Int64     Int64     Int64     Int64
        ─────┼──────────────────────────────────────────────────
           1 │ 10000001  10000026  10000051  10000076  10000101
          ⋮  │    ⋮         ⋮         ⋮         ⋮         ⋮
          25 │ 10000025  10000050  10000075  10000100  10000125
                                                 23 rows omitted"""

    io = IOContext(IOBuffer(), :displaysize=>(11, 40), :limit=>true)
    show(io, df_big, allrows=true, allcols=true)
    str = String(take!(io.io))
    @test str == """
        25×5 DataFrame
         Row │ x1        x2        x3        x4        x5
             │ Int64     Int64     Int64     Int64     Int64
        ─────┼──────────────────────────────────────────────────
           1 │ 10000001  10000026  10000051  10000076  10000101
           2 │ 10000002  10000027  10000052  10000077  10000102
           3 │ 10000003  10000028  10000053  10000078  10000103
           4 │ 10000004  10000029  10000054  10000079  10000104
           5 │ 10000005  10000030  10000055  10000080  10000105
           6 │ 10000006  10000031  10000056  10000081  10000106
           7 │ 10000007  10000032  10000057  10000082  10000107
           8 │ 10000008  10000033  10000058  10000083  10000108
           9 │ 10000009  10000034  10000059  10000084  10000109
          10 │ 10000010  10000035  10000060  10000085  10000110
          11 │ 10000011  10000036  10000061  10000086  10000111
          12 │ 10000012  10000037  10000062  10000087  10000112
          13 │ 10000013  10000038  10000063  10000088  10000113
          14 │ 10000014  10000039  10000064  10000089  10000114
          15 │ 10000015  10000040  10000065  10000090  10000115
          16 │ 10000016  10000041  10000066  10000091  10000116
          17 │ 10000017  10000042  10000067  10000092  10000117
          18 │ 10000018  10000043  10000068  10000093  10000118
          19 │ 10000019  10000044  10000069  10000094  10000119
          20 │ 10000020  10000045  10000070  10000095  10000120
          21 │ 10000021  10000046  10000071  10000096  10000121
          22 │ 10000022  10000047  10000072  10000097  10000122
          23 │ 10000023  10000048  10000073  10000098  10000123
          24 │ 10000024  10000049  10000074  10000099  10000124
          25 │ 10000025  10000050  10000075  10000100  10000125"""

    io = IOContext(IOBuffer(), :displaysize=>(11, 40), :limit=>true)
    show(io, df_big, allrows=true, allcols=false)
    str = String(take!(io.io))
    @test str == """
        25×5 DataFrame
         Row │ x1        x2        x3        x ⋯
             │ Int64     Int64     Int64     I ⋯
        ─────┼──────────────────────────────────
           1 │ 10000001  10000026  10000051  1 ⋯
           2 │ 10000002  10000027  10000052  1
           3 │ 10000003  10000028  10000053  1
           4 │ 10000004  10000029  10000054  1
           5 │ 10000005  10000030  10000055  1 ⋯
           6 │ 10000006  10000031  10000056  1
           7 │ 10000007  10000032  10000057  1
           8 │ 10000008  10000033  10000058  1
           9 │ 10000009  10000034  10000059  1 ⋯
          10 │ 10000010  10000035  10000060  1
          11 │ 10000011  10000036  10000061  1
          12 │ 10000012  10000037  10000062  1
          13 │ 10000013  10000038  10000063  1 ⋯
          14 │ 10000014  10000039  10000064  1
          15 │ 10000015  10000040  10000065  1
          16 │ 10000016  10000041  10000066  1
          17 │ 10000017  10000042  10000067  1 ⋯
          18 │ 10000018  10000043  10000068  1
          19 │ 10000019  10000044  10000069  1
          20 │ 10000020  10000045  10000070  1
          21 │ 10000021  10000046  10000071  1 ⋯
          22 │ 10000022  10000047  10000072  1
          23 │ 10000023  10000048  10000073  1
          24 │ 10000024  10000049  10000074  1
          25 │ 10000025  10000050  10000075  1 ⋯
                               2 columns omitted"""
end

@testset "GroupedDataFrame displaysize test" begin
    df = DataFrame(x = (1:50) .> 5, y = (1:50) .> 25, z = (1:50) .> 45)
    io = IOContext(IOBuffer(), :displaysize=>(30, 40), :limit=>true)

    show(io, groupby(df, :x), allcols=true)
    str = String(take!(io.io))
    @test str == """
        GroupedDataFrame with 2 groups based on key: x
        First Group (5 rows): x = false
         Row │ x      y      z
             │ Bool   Bool   Bool
        ─────┼─────────────────────
           1 │ false  false  false
           2 │ false  false  false
           3 │ false  false  false
           4 │ false  false  false
           5 │ false  false  false
        ⋮
        Last Group (45 rows): x = true
         Row │ x     y      z
             │ Bool  Bool   Bool
        ─────┼────────────────────
           1 │ true  false  false
           2 │ true  false  false
           3 │ true  false  false
           4 │ true  false  false
           5 │ true  false  false
          ⋮  │  ⋮      ⋮      ⋮
          41 │ true   true   true
          42 │ true   true   true
          43 │ true   true   true
          44 │ true   true   true
          45 │ true   true   true
                   35 rows omitted"""

    show(io, groupby(df, :y), allcols=true)
    str = String(take!(io.io))
    @test str == """
        GroupedDataFrame with 2 groups based on key: y
        First Group (25 rows): y = false
         Row │ x      y      z
             │ Bool   Bool   Bool
        ─────┼─────────────────────
           1 │ false  false  false
           2 │ false  false  false
           3 │ false  false  false
           4 │ false  false  false
          ⋮  │   ⋮      ⋮      ⋮
          23 │  true  false  false
          24 │  true  false  false
          25 │  true  false  false
                    18 rows omitted
        ⋮
        Last Group (25 rows): y = true
         Row │ x     y     z
             │ Bool  Bool  Bool
        ─────┼───────────────────
           1 │ true  true  false
           2 │ true  true  false
           3 │ true  true  false
          ⋮  │  ⋮     ⋮      ⋮
          23 │ true  true   true
          24 │ true  true   true
          25 │ true  true   true
                  19 rows omitted"""

    show(io, groupby(df, :z), allcols=true)
    str = String(take!(io.io))
    @test str == """
        GroupedDataFrame with 2 groups based on key: z
        First Group (45 rows): z = false
         Row │ x      y      z
             │ Bool   Bool   Bool
        ─────┼─────────────────────
           1 │ false  false  false
           2 │ false  false  false
           3 │ false  false  false
           4 │ false  false  false
           5 │ false  false  false
          ⋮  │   ⋮      ⋮      ⋮
          41 │  true   true  false
          42 │  true   true  false
          43 │  true   true  false
          44 │  true   true  false
          45 │  true   true  false
                    35 rows omitted
        ⋮
        Last Group (5 rows): z = true
         Row │ x     y     z
             │ Bool  Bool  Bool
        ─────┼──────────────────
           1 │ true  true  true
           2 │ true  true  true
           3 │ true  true  true
           4 │ true  true  true
           5 │ true  true  true"""

    show(io, groupby(df, :x), allcols=true, allrows=true)
    str = String(take!(io.io))
    @test str == """
        GroupedDataFrame with 2 groups based on key: x
        First Group (5 rows): x = false
         Row │ x      y      z
             │ Bool   Bool   Bool
        ─────┼─────────────────────
           1 │ false  false  false
           2 │ false  false  false
           3 │ false  false  false
           4 │ false  false  false
           5 │ false  false  false
        ⋮
        Last Group (45 rows): x = true
         Row │ x     y      z
             │ Bool  Bool   Bool
        ─────┼────────────────────
           1 │ true  false  false
           2 │ true  false  false
           3 │ true  false  false
           4 │ true  false  false
           5 │ true  false  false
           6 │ true  false  false
           7 │ true  false  false
           8 │ true  false  false
           9 │ true  false  false
          10 │ true  false  false
          11 │ true  false  false
          12 │ true  false  false
          13 │ true  false  false
          14 │ true  false  false
          15 │ true  false  false
          16 │ true  false  false
          17 │ true  false  false
          18 │ true  false  false
          19 │ true  false  false
          20 │ true  false  false
          21 │ true   true  false
          22 │ true   true  false
          23 │ true   true  false
          24 │ true   true  false
          25 │ true   true  false
          26 │ true   true  false
          27 │ true   true  false
          28 │ true   true  false
          29 │ true   true  false
          30 │ true   true  false
          31 │ true   true  false
          32 │ true   true  false
          33 │ true   true  false
          34 │ true   true  false
          35 │ true   true  false
          36 │ true   true  false
          37 │ true   true  false
          38 │ true   true  false
          39 │ true   true  false
          40 │ true   true  false
          41 │ true   true   true
          42 │ true   true   true
          43 │ true   true   true
          44 │ true   true   true
          45 │ true   true   true"""

    # height is zero or invalid -> print all rows
    for h in -1:0
        io = IOContext(IOBuffer(), :displaysize=>(h, 40), :limit=>true)
        show(io, groupby(df, :x), allcols=true)
        str_hrows = String(take!(io.io))
        show(io, groupby(df, :x), allcols=true, allrows=true)
        str_allrows = String(take!(io.io))
        @test str_hrows == str_allrows
    end

    # printed height always matches desired height, above a reasonable minimum
    for a in 1:50, b in 1:50, h in 17:40
        df = DataFrame(x = [fill(1, a); fill(2, b)])
        io = IOContext(IOBuffer(), :displaysize=>(h, 40), :limit=>true)
        show(io, groupby(df, :x), allcols=true)
        str = String(take!(io.io))
        nlines = length(split(str, '\n'))
        # leave one line for last REPL prompt at top, two for new prompt
        # (this is the same behavior as ungrouped data frames)
        desired = min(a + b + 10, h - 3)
        @test nlines == desired
    end

    for a in 1:50, h in 17:40
        df = DataFrame(x = fill(1, a))
        io = IOContext(IOBuffer(), :displaysize=>(h, 40), :limit=>true)
        show(io, groupby(df, :x), allcols=true)
        str = String(take!(io.io))
        nlines = length(split(str, '\n'))
        # leave one line for last REPL prompt at top, two for new prompt
        # (this is the same behavior as ungrouped data frames)
        desired = min(a + 5, h - 3)
        @test nlines == desired
    end

    # one group
    io = IOContext(IOBuffer(), :displaysize=>(15, 40), :limit=>true)
    df = DataFrame(x = Int64.(1:15), y = Int64(1))
    show(io, groupby(df, :y))
    str = String(take!(io.io))
    @test str == """
        GroupedDataFrame with 1 group based on key: y
        First Group (15 rows): y = 1
         Row │ x      y
             │ Int64  Int64
        ─────┼──────────────
           1 │     1      1
           2 │     2      1
           3 │     3      1
          ⋮  │   ⋮      ⋮
          14 │    14      1
          15 │    15      1
             10 rows omitted"""

    # zero groups
    io = IOContext(IOBuffer())
    df = DataFrame(x=[], y=Int[])
    show(io, groupby(df, :x))
    str = String(take!(io.io))
    @test str == "GroupedDataFrame with 0 groups based on key: x"
end

@testset "IOContext parameters test" begin
    df = DataFrame(A=Int64[1:4;], B=["x\"", "∀ε>0: x+ε>x", "z\$", "A\nC"],
                   C=Float32[1.0, 2.0, 3.0, 4.0])
    str1, size = capture_stdout() do
        show(df)
    end
    io = IOContext(IOBuffer(), :limit=>true, :displaysize=>size)
    show(io, df)
    str2 = String(take!(io.io))
    @test str1 == str2

    Random.seed!(1)
    df_big = DataFrame(rand(25, 5), :auto)
    str1, size = capture_stdout() do
        show(df_big)
    end
    io = IOContext(IOBuffer(), :limit=>true, :displaysize=>size)
    show(io, df_big)
    str2 = String(take!(io.io))
    @test str1 == str2
end

@testset "SubDataFrame show test" begin
    df = DataFrame(A=Int64[1:4;], B=["x\"", "∀ε>0: x+ε>x", "z\$", "A\nC"],
                   C=Float32[1.0, 2.0, 3.0, 4.0])
    subdf = view(df, [2, 3], :)
    io = IOBuffer()
    show(io, subdf, allrows=true, allcols=false)
    str = String(take!(io))
    @test str == """
        2×3 SubDataFrame
         Row │ A      B            C
             │ Int64  String       Float32
        ─────┼─────────────────────────────
           1 │     2  ∀ε>0: x+ε>x      2.0
           2 │     3  z\$               3.0"""
    show(io, subdf, allrows=true)
    show(io, subdf, allcols=true)
    show(io, subdf, allcols=true, allrows=true)
end

@testset "Test showing StackedVector and RepeatedVector" begin
    A = DataFrames.StackedVector(Any[[1, 2, 3], [4, 5, 6], [7, 8, 9]])
    @test sprint(show, A) == "[1, 2, 3, 4, 5, 6, 7, 8, 9]"
    A = DataFrames.RepeatedVector([1, 2, 3], 5, 1)
    @test sprint(show, A) == "[1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3]"
    A = DataFrames.RepeatedVector([1, 2, 3], 1, 5)
    @test sprint(show, A) == "[1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3]"
end

@testset "Test colors and non-standard values: missing and nothing" begin
    # TODO: update when https://github.com/KristofferC/Crayons.jl/issues/47 is resolved
    if Base.get_have_color()
        df = DataFrame(Fish=["Suzy", "Amir"], Mass=[1.5, missing])
        @test sprint(show, df, context=:color=>true) == """
            \e[1m2×2 DataFrame\e[0m
            \e[1m Row \e[0m│\e[1m Fish   \e[0m\e[1m Mass      \e[0m
            \e[1m     \e[0m│\e[90m String \e[0m\e[90m Float64?  \e[0m
            ─────┼───────────────────
               1 │ Suzy          1.5
               2 │ Amir   \e[90m missing   \e[0m"""

        df = DataFrame(A=[:Symbol, missing, :missing],
                       B=[missing, "String", "missing"],
                       C=[:missing, "missing", missing])
        @test sprint(show, df, context=:color=>true) == """
            \e[1m3×3 DataFrame\e[0m
            \e[1m Row \e[0m│\e[1m A       \e[0m\e[1m B       \e[0m\e[1m C       \e[0m
            \e[1m     \e[0m│\e[90m Symbol? \e[0m\e[90m String? \e[0m\e[90m Any     \e[0m
            ─────┼───────────────────────────
               1 │ Symbol  \e[90m missing \e[0m missing
               2 │\e[90m missing \e[0m String   missing
               3 │ missing  missing \e[90m missing \e[0m"""
    end

    df_nothing = DataFrame(A=[1.0, 2.0, 3.0], B=["g", "g", nothing])
    @test sprint(show, df_nothing) == """
        3×2 DataFrame
         Row │ A        B
             │ Float64  Union…
        ─────┼─────────────────
           1 │     1.0  g
           2 │     2.0  g
           3 │     3.0"""
end

@testset "Test correct width computation" begin
    df = DataFrame([["a"]], [:x])
    @test sprint(show, df) == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼────────
           1 │ a"""
end

@testset "Test showing special types" begin
    # strings with escapes
    df = DataFrame(a=["1\n1", "2\t2", "3\r3", "4\$4", "5\"5", "6\\6"])
    @test sprint(show, df) == """
        6×1 DataFrame
         Row │ a
             │ String
        ─────┼────────
           1 │ 1\\n1
           2 │ 2\\t2
           3 │ 3\\r3
           4 │ 4\$4
           5 │ 5"5
           6 │ 6\\\\6"""

    # categorical
    df = DataFrame(a=categorical([1, 2, 3]), b=categorical(["a", "b", missing]))
    @test sprint(show, df) == """
        3×2 DataFrame
         Row │ a     b
             │ Cat…  Cat…?
        ─────┼───────────────
           1 │ 1     a
           2 │ 2     b
           3 │ 3     missing"""

    # BigFloat
    df = DataFrame(a=[big(1.0), missing])
    @test sprint(show, df) == """
        2×1 DataFrame
         Row │ a
             │ BigFloat?
        ─────┼───────────
           1 │       1.0
           2 │ missing"""

    # date types
    df = DataFrame(a=Date(2020, 2, 11), b=DateTime(2020, 2, 11, 15), c=Day(1))
    @test sprint(show, df) == """
        1×3 DataFrame
         Row │ a           b                    c
             │ Date        DateTime             Day
        ─────┼────────────────────────────────────────
           1 │ 2020-02-11  2020-02-11T15:00:00  1 day"""

    # Irrational
    df = DataFrame(a=π)
    @test sprint(show, df) == """
        1×1 DataFrame
         Row │ a
             │ Irration…
        ─────┼───────────
           1 │         π"""
end

@testset "Test using :compact parameter of IOContext" begin
    df = DataFrame(x=[float(pi)])
    @test sprint(show, df) == """
        1×1 DataFrame
         Row │ x
             │ Float64
        ─────┼─────────
           1 │ 3.14159"""

    @test sprint(show, df, context=:compact=>false) == """
        1×1 DataFrame
         Row │ x
             │ Float64
        ─────┼───────────────────
           1 │ 3.141592653589793"""
end

@testset "Test of DataFrameRows and DataFrameColumns" begin
    df = DataFrame(x=[float(pi)])
    @test sprint(show, eachrow(df)) == """
        1×1 DataFrameRows
         Row │ x
             │ Float64
        ─────┼─────────
           1 │ 3.14159"""

    @test sprint((io, x) -> show(io, x, summary=false), eachrow(df)) == """
         Row │ x
             │ Float64
        ─────┼─────────
           1 │ 3.14159"""

    @test sprint(show, eachcol(df)) == """
        1×1 DataFrameColumns
         Row │ x
             │ Float64
        ─────┼─────────
           1 │ 3.14159"""

    @test sprint((io, x) -> show(io, x, summary=false), eachcol(df)) == """
         Row │ x
             │ Float64
        ─────┼─────────
           1 │ 3.14159"""
end

@testset "Test empty data frame and DataFrameRow" begin
    df = DataFrame(x=[float(pi)])
    @test sprint(show, df[:, 2:1]) == "0×0 DataFrame"
    @test sprint(show, @view df[:, 2:1]) == "0×0 SubDataFrame"
    @test sprint(show, df[1, 2:1]) == "DataFrameRow"
end

@testset "consistency" begin
    df = DataFrame(a=[1, 1, 2, 2], b=[5, 6, 7, 8], c=1:4)
    push!(df.c, 5)
    @test_throws AssertionError sprint(show, df)

    df = DataFrame(a=[1, 1, 2, 2], b=[5, 6, 7, 8], c=1:4)
    push!(DataFrames._columns(df), df[:, :a])
    @test_throws AssertionError sprint(show, df)
end

@testset "wide type name" begin
    @test sprint(show, DataFrame(a=⛵⛵⛵⛵⛵())) == """
        1×1 DataFrame
         Row │ a
             │ ⛵⛵⛵⛵…
        ─────┼───────────
           1 │ "⛵\""""

    @test sprint(show, DataFrame(a=categorical([Int64(2)^54]))) == """
        1×1 DataFrame
         Row │ a
             │ Cat…
        ─────┼───────────────────
           1 │ 18014398509481984"""

    @test sprint(show, DataFrame(a=categorical([Int64(2)^53]))) == """
        1×1 DataFrame
         Row │ a
             │ Cat…
        ─────┼──────────────────
           1 │ 9007199254740992"""

    @test sprint(show, DataFrame(a=categorical([Int64(2)^37]))) == """
        1×1 DataFrame
         Row │ a
             │ Cat…
        ─────┼──────────────
           1 │ 137438953472"""

    @test sprint(show, DataFrame(a=categorical([Int64(2)^36]))) == """
        1×1 DataFrame
         Row │ a
             │ Cat…
        ─────┼─────────────
           1 │ 68719476736"""

    @test sprint(show, DataFrame(a=Union{Function, Missing}[missing])) == """
        1×1 DataFrame
         Row │ a
             │ Function?
        ─────┼───────────
           1 │ missing"""
end

@testset "wide type name" begin
    df = DataFrame(A=Int32.(1:3), B=["x", "y", "z"])

    io = IOBuffer()
    show(io, df, eltypes=true)
    str = String(take!(io))
    @test str == """
        3×2 DataFrame
         Row │ A      B
             │ Int32  String
        ─────┼───────────────
           1 │     1  x
           2 │     2  y
           3 │     3  z"""

    io = IOBuffer()
    show(io, df, eltypes=false)
    str = String(take!(io))
    @test str == """
        3×2 DataFrame
         Row │ A  B
        ─────┼──────
           1 │ 1  x
           2 │ 2  y
           3 │ 3  z"""
end

@testset "UnionAll" begin
    df = DataFrame(x=AbstractVector[1:2])

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ Abstract…
        ─────┼───────────
           1 │ 1:2"""
end

@testset "wide output and column trimming" begin
    df = DataFrame(x="0123456789"^4)
    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼───────────────────────────────────
           1 │ 01234567890123456789012345678901…"""

    io = IOContext(IOBuffer(), :displaysize=>(10, 10), :limit=>true)
    show(io, df)
    str = String(take!(io.io))
    @test str === """
        1×1 Data ⋯
         Row │ x ⋯
             │ S ⋯
        ─────┼────
           1 │ 0 ⋯
        1 column omitted"""

    df = DataFrame(x="😄"^20)
    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str === """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼───────────────────────────────────
           1 │ 😄😄😄😄😄😄😄😄😄😄😄😄😄😄😄😄…"""
end

@testset "Floating point alignment" begin
    df = DataFrame(a=[i == 2 ? missing : 10^i for i = -7:1.0:7],
                   b=Int64.(1:1:15),
                   c=[i % 2 == 0 for i = 1:15],
                   d=[i == 2 ? "test" : 10^i for i = -7:1.0:7],
                   e=[i == 2 ? -0.0 : i == 3 ? +0.0 : 10^i for i = -7:1.0:7])

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        15×5 DataFrame
         Row │ a             b      c      d         e
             │ Float64?      Int64  Bool   Any       Float64
        ─────┼───────────────────────────────────────────────────
           1 │       1.0e-7      1  false  1.0e-7         1.0e-7
           2 │       1.0e-6      2   true  1.0e-6         1.0e-6
           3 │       1.0e-5      3  false  1.0e-5         1.0e-5
           4 │       0.0001      4   true  0.0001         0.0001
           5 │       0.001       5  false  0.001          0.001
           6 │       0.01        6   true  0.01           0.01
           7 │       0.1         7  false  0.1            0.1
           8 │       1.0         8   true  1.0            1.0
           9 │      10.0         9  false  10.0          10.0
          10 │ missing          10   true  test          -0.0
          11 │    1000.0        11  false  1000.0         0.0
          12 │   10000.0        12   true  10000.0    10000.0
          13 │  100000.0        13  false  100000.0  100000.0
          14 │       1.0e6      14   true  1.0e6          1.0e6
          15 │       1.0e7      15  false  1.0e7          1.0e7"""


    io = IOBuffer()
    show(io, df, eltypes = false)
    str = String(take!(io))
    @test str == """
        15×5 DataFrame
         Row │ a             b   c      d         e
        ─────┼────────────────────────────────────────────────
           1 │       1.0e-7   1  false  1.0e-7         1.0e-7
           2 │       1.0e-6   2   true  1.0e-6         1.0e-6
           3 │       1.0e-5   3  false  1.0e-5         1.0e-5
           4 │       0.0001   4   true  0.0001         0.0001
           5 │       0.001    5  false  0.001          0.001
           6 │       0.01     6   true  0.01           0.01
           7 │       0.1      7  false  0.1            0.1
           8 │       1.0      8   true  1.0            1.0
           9 │      10.0      9  false  10.0          10.0
          10 │ missing       10   true  test          -0.0
          11 │    1000.0     11  false  1000.0         0.0
          12 │   10000.0     12   true  10000.0    10000.0
          13 │  100000.0     13  false  100000.0  100000.0
          14 │       1.0e6   14   true  1.0e6          1.0e6
          15 │       1.0e7   15  false  1.0e7          1.0e7"""

    df = DataFrame(This_is_a_very_big_name=1.0, b=2.0, c=3.0)

    io = IOBuffer()
    show(io, df, eltypes = false)
    str = String(take!(io))
    @test str == """
        1×3 DataFrame
         Row │ This_is_a_very_big_name  b    c
        ─────┼───────────────────────────────────
           1 │                     1.0  2.0  3.0"""

    df = DataFrame(This_is_a_very_big_name=[10.0^i for i = -5:1:5],
                   This_is_smaller=1.0:2:22,
                   T=100001:1.0:100011)

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        11×3 DataFrame
         Row │ This_is_a_very_big_name  This_is_smaller  T
             │ Float64                  Float64          Float64
        ─────┼────────────────────────────────────────────────────
           1 │                  1.0e-5              1.0  100001.0
           2 │                  0.0001              3.0  100002.0
           3 │                  0.001               5.0  100003.0
           4 │                  0.01                7.0  100004.0
           5 │                  0.1                 9.0  100005.0
           6 │                  1.0                11.0  100006.0
           7 │                 10.0                13.0  100007.0
           8 │                100.0                15.0  100008.0
           9 │               1000.0                17.0  100009.0
          10 │              10000.0                19.0  100010.0
          11 │             100000.0                21.0  100011.0"""

    df = DataFrame(😄😄😄😄😄😄😄=[10.0^i for i = -5:1:5],
                   🚀🚀🚀🚀🚀=1.0:2:22)

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        11×2 DataFrame
         Row │ 😄😄😄😄😄😄😄  🚀🚀🚀🚀🚀
             │ Float64         Float64
        ─────┼────────────────────────────
           1 │         1.0e-5         1.0
           2 │         0.0001         3.0
           3 │         0.001          5.0
           4 │         0.01           7.0
           5 │         0.1            9.0
           6 │         1.0           11.0
           7 │        10.0           13.0
           8 │       100.0           15.0
           9 │      1000.0           17.0
          10 │     10000.0           19.0
          11 │    100000.0           21.0"""

    df = DataFrame(😄😄😄😄😄😄😄😄😄=[10.0^i + pi for i = -5:1:5],
                   🚀🚀🚀🚀🚀🚀🚀=collect(1.0:2:22) .+ pi)

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        11×2 DataFrame
         Row │ 😄😄😄😄😄😄😄😄😄  🚀🚀🚀🚀🚀🚀🚀
             │ Float64             Float64
        ─────┼────────────────────────────────────
           1 │          3.1416            4.14159
           2 │          3.14169           6.14159
           3 │          3.14259           8.14159
           4 │          3.15159          10.1416
           5 │          3.24159          12.1416
           6 │          4.14159          14.1416
           7 │         13.1416           16.1416
           8 │        103.142            18.1416
           9 │       1003.14             20.1416
          10 │      10003.1              22.1416
          11 │          1.00003e5        24.1416"""

    io = IOContext(IOBuffer(), :compact => false)
    show(io, df)
    str = String(take!(io.io))
    @test str == """
        11×2 DataFrame
         Row │ 😄😄😄😄😄😄😄😄😄       🚀🚀🚀🚀🚀🚀🚀
             │ Float64                  Float64
        ─────┼─────────────────────────────────────────────
           1 │      3.141602653589793    4.141592653589793
           2 │      3.1416926535897933   6.141592653589793
           3 │      3.142592653589793    8.141592653589793
           4 │      3.151592653589793   10.141592653589793
           5 │      3.241592653589793   12.141592653589793
           6 │      4.141592653589793   14.141592653589793
           7 │     13.141592653589793   16.141592653589793
           8 │    103.1415926535898     18.141592653589793
           9 │   1003.1415926535898     20.141592653589793
          10 │  10003.14159265359       22.141592653589793
          11 │ 100003.14159265358       24.141592653589793"""

    df = DataFrame(This_is_a_very_long_header =
                   Union{F, Float64, Missing}[i == 6 ? F(1234567) : i == 4 ? missing : 10.0^i for i = -6:1:6])

    io = IOContext(IOBuffer())
    show(io, df)
    str = String(take!(io.io))
    @test str == """
        13×1 DataFrame
         Row │ This_is_a_very_long_header
             │ Union{Missing, Float64, F}
        ─────┼────────────────────────────
           1 │                     1.0e-6
           2 │                     1.0e-5
           3 │                     0.0001
           4 │                     0.001
           5 │                     0.01
           6 │                     0.1
           7 │                     1.0
           8 │                    10.0
           9 │                   100.0
          10 │                  1000.0
          11 │               missing
          12 │                100000.0
          13 │               1234567"""

end

@testset "Complex number alignment" begin
    a = Union{Missing, Number}[
        im,
        1 + im,
        -1 - im,
        1.123 + 123im,
        -2.323 - 32im,
        -1//3 - 4//5im,
        1028.23123,
        missing,
        -0.304105,
        2123123,
        +0.304105,
        1.3123e-10 + 1.123e-5im
    ]
    b = Int64[i ≤ 6 ? -1 * 10^(i - 1) : 10^(i - 7) for i = 1:12]
    c = Union{Missing, Float64}[i == 5 ? missing : 10.0^(i-4) for i = 1:12]
    d = ComplexF64[(-1)^(i % 3 == 0) * 10.0^(i-6) + (-1)^i * (10.0)^(11-i-6) * im for i = 1:12]
    df = DataFrame(very_big_column_name_1=a,
                   very_big_column_name_2=b,
                   very_big_column_name_3=c,
                   very_big_column_name_4=d)

    io = IOContext(IOBuffer())
    show(io, df)
    str = String(take!(io.io))

    @test str == """
        12×4 DataFrame
         Row │ very_big_column_name_1  very_big_column_name_2  very_big_column_name_3  very_big_column_name_4
             │ Union{Missing, Number}  Int64                   Float64?                $(Complex{Float64})
        ─────┼────────────────────────────────────────────────────────────────────────────────────────────────
           1 │                     im                      -1                   0.001        1.0e-5-10000.0im
           2 │                  1+1im                     -10                   0.01         0.0001+1000.0im
           3 │                 -1-1im                    -100                   0.1          -0.001-100.0im
           4 │          1.123+123.0im                   -1000                   1.0            0.01+10.0im
           5 │          -2.323-32.0im                  -10000             missing               0.1-1.0im
           6 │          -1//3+4//5*im                 -100000                 100.0            -1.0+0.1im
           7 │                1028.23                       1                1000.0            10.0-0.01im
           8 │                missing                      10               10000.0           100.0+0.001im
           9 │              -0.304105                     100              100000.0         -1000.0-0.0001im
          10 │                2123123                    1000                   1.0e6       10000.0+1.0e-5im
          11 │               0.304105                   10000                   1.0e7      100000.0-1.0e-6im
          12 │  1.3123e-10+1.123e-5im                  100000                   1.0e8        -1.0e6+1.0e-7im"""
end

@testset "Invalid keywords in text mode" begin
    df = DataFrame(a=[1, 1, 2, 2], b=[5, 6, 7, 8], c=1:4)
    @test_throws ArgumentError show(stdout, df, max_column_width="100px")
    @test_throws ArgumentError show(stdout, MIME("text/plain"), df, max_column_width="100px")
end

@testset "Issue #2673 - Vertical line when not showing row numbers" begin
    df = DataFrame(a=Int64[10, 20], b=Int64[30, 40], c=Int64[50, 60])

    io = IOContext(IOBuffer())
    show(io, df)
    str = String(take!(io.io))
    @test str == """
        2×3 DataFrame
         Row │ a      b      c
             │ Int64  Int64  Int64
        ─────┼─────────────────────
           1 │    10     30     50
           2 │    20     40     60"""


    io = IOContext(IOBuffer())
    show(io, df, show_row_number=false)
    str = String(take!(io.io))
    @test str == """
        2×3 DataFrame
         a      b      c
         Int64  Int64  Int64
        ─────────────────────
            10     30     50
            20     40     60"""

    io = IOContext(IOBuffer())
    show(io, df[2, :])
    str = String(take!(io.io))
    @test str == """
        DataFrameRow
         Row │ a      b      c
             │ Int64  Int64  Int64
        ─────┼─────────────────────
           2 │    20     40     60"""


    io = IOContext(IOBuffer())
    show(io, df[2, :], show_row_number=false)
    str = String(take!(io.io))
    @test str == """
        DataFrameRow
         a      b      c
         Int64  Int64  Int64
        ─────────────────────
            20     40     60"""
end

@testset "Issue #3346 - Showing Base.UUID" begin
    rand_uuid = Base.UUID("36cea533-4597-132e-557c-08487c42ef97")
    df = DataFrame(
        integer = [Int64(10)^n for n in 1:10],
        uuid    = [i % 2 == 0 ? missing : rand_uuid for i in 1:10],
        float   = [10.0^n for n in 1:10], string = ["A"^100 for _ in 1:10]
    )
    io = IOContext(IOBuffer())
    show(io, df)
    str = String(take!(io.io))

    @test str == """
        10×4 DataFrame
         Row │ integer      uuid                                  float        string
             │ Int64        Base.UUID?                            Float64      String
        ─────┼───────────────────────────────────────────────────────────────────────────────────────────────────
           1 │          10  36cea533-4597-132e-557c-08487c42ef97      10.0     AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           2 │         100  missing                                  100.0     AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           3 │        1000  36cea533-4597-132e-557c-08487c42ef97    1000.0     AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           4 │       10000  missing                                10000.0     AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           5 │      100000  36cea533-4597-132e-557c-08487c42ef97  100000.0     AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           6 │     1000000  missing                                    1.0e6   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           7 │    10000000  36cea533-4597-132e-557c-08487c42ef97       1.0e7   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           8 │   100000000  missing                                    1.0e8   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
           9 │  1000000000  36cea533-4597-132e-557c-08487c42ef97       1.0e9   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…
          10 │ 10000000000  missing                                    1.0e10  AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA…"""
end

@testset "cover all corner cases of compacttype" begin
    df = DataFrame(x2345678901234567=categorical(["1"]))
    @test sprint(show, df) === """
        1×1 DataFrame
         Row │ x2345678901234567
             │ CategoricalValue…
        ─────┼───────────────────
           1 │ 1"""
end

@testset "InlineStrings with GroupedDataFrame" begin
    df = DataFrame(id=inlinestrings(["a", "b", "c"]), value=collect(Int64, 1:3))

    io = IOContext(IOBuffer(), :limit=>true)
    show(io, groupby(df, :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 3 groups based on key: id
        First Group (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1
        ⋮
        Last Group (1 row): id = "c"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ c            3"""

    io = IOContext(IOBuffer(), :limit=>true)
    show(io, MIME("text/plain"), groupby(df, :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 3 groups based on key: id
        First Group (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1
        ⋮
        Last Group (1 row): id = "c"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ c            3"""

    io = IOContext(IOBuffer(), :limit=>false)
    show(io, groupby(df, :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 3 groups based on key: id
        Group 1 (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1
        Group 2 (1 row): id = "b"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ b            2
        Group 3 (1 row): id = "c"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ c            3"""


    io = IOContext(IOBuffer(), :limit=>false)
    show(io, MIME("text/plain"), groupby(df, :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 3 groups based on key: id
        Group 1 (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1
        Group 2 (1 row): id = "b"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ b            2
        Group 3 (1 row): id = "c"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ c            3"""

    io = IOContext(IOBuffer(), :limit=>true)
    show(io, groupby(df[1:1, :], :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 1 group based on key: id
        First Group (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1"""

    io = IOContext(IOBuffer(), :limit=>false)
    show(io, groupby(df[1:1, :], :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 1 group based on key: id
        Group 1 (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1"""

    io = IOContext(IOBuffer(), :limit=>true)
    show(io, MIME("text/plain"), groupby(df[1:1, :], :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 1 group based on key: id
        First Group (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1"""

    io = IOContext(IOBuffer(), :limit=>false)
    show(io, MIME("text/plain"), groupby(df[1:1, :], :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 1 group based on key: id
        Group 1 (1 row): id = "a"
         Row │ id       value
             │ String1  Int64
        ─────┼────────────────
           1 │ a            1"""

    io = IOContext(IOBuffer())
    show(io, MIME("text/html"), groupby(df, :id))
    @test String(take!(io.io)) ===
        "<p><b>GroupedDataFrame with 3 groups based on key: id</b></p>" *
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>First Group (1 row): id = &quot;a&quot;</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "<thead>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
        "<th style = \"text-align: left;\">id</th>" *
        "<th style = \"text-align: left;\">value</th>" *
        "</tr>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
        "</th>" *
        "<th title = \"String1\" style = \"text-align: left;\">String1</th>" *
        "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
        "</tr>" *
        "</thead>" *
        "<tbody>" *
        "<tr class = \"dataRow\">" *
        "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
        "<td style = \"text-align: left;\">a</td>" *
        "<td style = \"text-align: right;\">1</td>" *
        "</tr>" *
        "</tbody>" *
        "</table>" *
        "</div>" *
        "<p>&vellip;</p>" *
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>Last Group (1 row): id = &quot;c&quot;</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "<thead>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
        "<th style = \"text-align: left;\">id</th>" *
        "<th style = \"text-align: left;\">value</th>" *
        "</tr>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
        "</th>" *
        "<th title = \"String1\" style = \"text-align: left;\">String1</th>" *
        "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
        "</tr>" *
        "</thead>" *
        "<tbody>" *
        "<tr class = \"dataRow\">" *
        "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
        "<td style = \"text-align: left;\">c</td>" *
        "<td style = \"text-align: right;\">3</td>" *
        "</tr>" *
        "</tbody>" *
        "</table>" *
        "</div>"

    io = IOContext(IOBuffer())
    show(io, MIME("text/html"), groupby(df[1:1, :], :id))
    @test String(take!(io.io)) ===
        "<p><b>GroupedDataFrame with 1 group based on key: id</b></p>" *
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>First Group (1 row): id = &quot;a&quot;</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "<thead>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
        "<th style = \"text-align: left;\">id</th>" *
        "<th style = \"text-align: left;\">value</th>" *
        "</tr>" *
        "<tr class = \"columnLabelRow\">" *
        "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
        "</th>" *
        "<th title = \"String1\" style = \"text-align: left;\">String1</th>" *
        "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
        "</tr>" *
        "</thead>" *
        "<tbody>" *
        "<tr class = \"dataRow\">" *
        "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
        "<td style = \"text-align: left;\">a</td>" *
        "<td style = \"text-align: right;\">1</td>" *
        "</tr>" *
        "</tbody>" *
        "</table>" *
        "</div>"

    io = IOContext(IOBuffer())
    show(io, MIME("text/latex"), groupby(df, :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 3 groups based on key: id

        First Group (1 row): id = "a"

        \\begin{tabular}{r|cc}
        \t& id & value\\\\
        \t\\hline
        \t& String1 & Int64\\\\
        \t\\hline
        \t1 & a & 1 \\\\
        \\end{tabular}

        \$\\dots\$

        Last Group (1 row): id = "c"

        \\begin{tabular}{r|cc}
        \t& id & value\\\\
        \t\\hline
        \t& String1 & Int64\\\\
        \t\\hline
        \t1 & c & 3 \\\\
        \\end{tabular}
        """

    io = IOContext(IOBuffer())
    show(io, MIME("text/latex"), groupby(df[1:1, :], :id))
    @test String(take!(io.io)) === """
        GroupedDataFrame with 1 group based on key: id

        First Group (1 row): id = "a"

        \\begin{tabular}{r|cc}
        \t& id & value\\\\
        \t\\hline
        \t& String1 & Int64\\\\
        \t\\hline
        \t1 & a & 1 \\\\
        \\end{tabular}
        """
end

end # module

module TestIndexing

using Test, DataFrames, Unicode, Random

@testset "getindex DataFrame" begin
    df = DataFrame(a=1:3, b=4:6, c=7:9)

    @test df[!, 1] == [1, 2, 3]
    @test df[!, 1] === eachcol(df)[1]
    @test df[!, :a] == [1, 2, 3]
    @test df[!, :a] === df[!, "a"] === eachcol(df)[1]
    @test df.a == [1, 2, 3]
    @test df.a === df."a" === eachcol(df)[1]

    for selector in [1:2, r"[ab]", Not(Not(r"[ab]")), Not(r"ab"), Not(3), Not(1:0), Not(1:2), :]
        dfx = df[!, selector]
        @test dfx == select(df, selector, copycols=false)
        @test dfx isa DataFrame
        @test dfx[!, 1] === df[!, names(dfx)[1]]
    end

    @test df[!, Not(1, 2)] == DataFrame(c=7:9)
    @test df[!, Not(1, 1, 2)] == DataFrame(c=7:9)
    @test df[!, Not([1, 1, 2])] == DataFrame(c=7:9)
    @test df[!, Not(:b, 1)] == DataFrame(c=7:9)
    @test df[!, Not(:b, :b, 1)] == DataFrame(c=7:9)
    @test df[!, Not("c", :a)] == DataFrame(b=4:6)
    @test df[!, Not("c", "c", :a)] == DataFrame(b=4:6)
    @test df[!, Not(:c, :c, :a)] == DataFrame(b=4:6)
    @test df[!, Not([:c, :c, :a])] == DataFrame(b=4:6)
    @test df[!, Not("c", "c", "a")] == DataFrame(b=4:6)
    @test df[!, Not(["c", "c", "a"])] == DataFrame(b=4:6)
    @test df[!, Not(:b, "c", :a)] == DataFrame()
    @test df[!, Not([1, 2], :b)] == DataFrame(c=7:9)
    @test df[!, Not([:c, :a], :b)] == DataFrame()
    @test df[!, Not([1, 2], 2)] == DataFrame(c=7:9)
    @test df[!, Not([1, 2], [1, 2])] == DataFrame(c=7:9)

    @test df[1, 1] == 1
    @test df[1, 1:2] isa DataFrameRow
    @test df[1, r"[ab]"] isa DataFrameRow
    @test df[1, Not(3)] isa DataFrameRow
    @test copy(df[1, 1:2]) == (a=1, b=4)
    @test copy(df[1, r"[ab]"]) == (a=1, b=4)
    @test copy(df[1, Not(Not(r"[ab]"))]) == (a=1, b=4)
    @test copy(df[1, Not(:c)]) == (a=1, b=4)
    @test df[1, :] isa DataFrameRow
    @test copy(df[1, :]) == (a=1, b=4, c=7)
    @test parent(df[1, :]) === df
    @test df[1, r""] isa DataFrameRow
    @test copy(df[1, r""]) == (a=1, b=4, c=7)
    @test parent(df[1, r""]) === df
    @test df[1, Not([])] isa DataFrameRow
    @test copy(df[1, Not([])]) == (a=1, b=4, c=7)
    @test parent(df[1, Not([])]) === df
    @test_throws ArgumentError df[true, 1]
    @test_throws ArgumentError df[true, 1:2]
    @test_throws BoundsError df[5, "a"]

    @test df[1:2, 1] == [1, 2]
    @test df[1:2, 1:2] == DataFrame(a=1:2, b=4:5)
    @test df[1:2, r"[ab]"] == DataFrame(a=1:2, b=4:5)
    @test df[1:2, Not([3])] == DataFrame(a=1:2, b=4:5)
    @test df[1:2, :] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test df[1:2, r""] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test df[1:2, Not(1:0)] == DataFrame(a=1:2, b=4:5, c=7:8)

    @test df[Not(Not(1:2)), 1] == [1, 2]
    @test df[Not(Not(1:2)), 1:2] == DataFrame(a=1:2, b=4:5)
    @test df[Not(Not(1:2)), r"[ab]"] == DataFrame(a=1:2, b=4:5)
    @test df[Not(Not(1:2)), Not([3])] == DataFrame(a=1:2, b=4:5)
    @test df[Not(Not(1:2)), :] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test df[Not(Not(1:2)), r""] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test df[Not(Not(1:2)), Not(1:0)] == DataFrame(a=1:2, b=4:5, c=7:8)

    @test df[:, 1] == [1, 2, 3]
    @test df[:, 1] !== df[!, 1]
    @test df[:, 1:2] == DataFrame(a=1:3, b=4:6)
    @test df[:, r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test df[:, Not(r"c")] == DataFrame(a=1:3, b=4:6)
    @test eachcol(df[:, 1:2])[1] !== df[!, 1]
    @test df[:, :] == df
    @test df[:, r""] == df
    @test df[:, Not(Not(r""))] == df
    @test eachcol(df[:, :])[1] !== df[!, 1]
    @test eachcol(df[:, r""])[1] !== df[!, 1]
    @test eachcol(df[:, Not([])])[1] !== df[!, 1]

    @test df[Not(Int[]), 1] == [1, 2, 3]
    @test df[Not(Int[]), 1] !== df[!, 1]
    @test df[Not(Int[]), 1:2] == DataFrame(a=1:3, b=4:6)
    @test df[Not(Int[]), r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test df[Not(Int[]), Not(r"c")] == DataFrame(a=1:3, b=4:6)
    @test eachcol(df[Not(Int[]), 1:2])[1] !== df[!, 1]
    @test df[Not(Int[]), :] == df
    @test df[Not(Int[]), r""] == df
    @test df[Not(Int[]), Not(Not(r""))] == df
    @test eachcol(df[Not(Int[]), :])[1] !== df[!, 1]
    @test eachcol(df[Not(Int[]), r""])[1] !== df[!, 1]
    @test eachcol(df[Not(Int[]), Not([])])[1] !== df[!, 1]
end

@testset "getindex df[!, col]" begin
    x = [1, 2, 3]
    df = DataFrame(x=x, copycols=false)
    @test df.x === df."x" === x
    @test df[!, :x] === df[!, "x"] === x
    @test df[!, 1] === x
    @test df[:, [:x]].x !== x
    @test df[:, :].x !== x
    @test df[:, r"x"].x !== x
    @test df[:, r""].x !== x
    @test df[:, Not(1:0)].x !== x
    @test df[!, [:x]].x === x
    @test df[!, :].x === x
    @test df[!, r"x"].x === x
    @test df[!, r""].x === x
    @test df[!, Not(1:0)].x === x
end

@testset "view DataFrame" begin
    df = DataFrame(a=1:3, b=4:6, c=7:9)

    @test view(df, !, 1) == [1, 2, 3]
    @test view(df, !, 1) isa SubArray
    @test view(df, !, :a) == [1, 2, 3]
    @test view(df, !, :a) isa SubArray
    @test view(df, !, "a") == [1, 2, 3]
    @test view(df, !, "a") isa SubArray

    for selector in [1:2, r"[ab]", Not(Not(r"[ab]")), Not(r"ab"), Not(3), Not(1:0), Not(1:2), :]
        dfx = @view df[!, selector]
        @test dfx == select(df, selector, copycols=false)
        @test dfx isa SubDataFrame
        @test parent(dfx[!, 1]) === df[!, names(dfx)[1]]
    end

    @test view(df, :, :) == df
    @test parent(view(df, :, :)) === df
    @test view(df, :, r"") isa SubDataFrame
    @test view(df, :, r"") == df
    @test parent(view(df, :, r"")) === df
    @test view(df, :, Not(1:0)) isa SubDataFrame
    @test view(df, :, Not(1:0)) == df
    @test parent(view(df, :, Not(1:0))) === df

    @test view(df, !, :) == df
    @test parent(view(df, !, :)) === df
    @test view(df, !, r"") isa SubDataFrame
    @test view(df, !, r"") == df
    @test parent(view(df, !, r"")) === df
    @test view(df, !, Not(1:0)) isa SubDataFrame
    @test view(df, !, Not(1:0)) == df
    @test parent(view(df, !, Not(1:0))) === df

    @test view(df, 1, 1) isa SubArray
    @test view(df, 1, 1)[] == 1
    @test view(df, 1, 1:2) isa DataFrameRow
    @test copy(view(df, 1, 1:2)) == (a=1, b=4)
    @test view(df, 1, r"[ab]") isa DataFrameRow
    @test copy(view(df, 1, r"[ab]")) == (a=1, b=4)
    @test view(df, 1, Not(Not(r"[ab]"))) isa DataFrameRow
    @test copy(view(df, 1, Not(Not(r"[ab]")))) == (a=1, b=4)
    @test view(df, 1, :) isa DataFrameRow
    @test copy(view(df, 1, :)) == (a=1, b=4, c=7)
    @test parent(view(df, 1, :)) === df
    @test view(df, 1, r"") isa DataFrameRow
    @test copy(view(df, 1, r"")) == (a=1, b=4, c=7)
    @test parent(view(df, 1, r"")) === df
    @test view(df, 1, Not(Symbol[])) isa DataFrameRow
    @test copy(view(df, 1, Not(Symbol[]))) == (a=1, b=4, c=7)
    @test parent(view(df, 1, Not(Symbol[]))) === df

    @test view(df, 1:2, 1) == [1, 2]
    @test view(df, 1:2, 1) isa SubArray
    @test view(df, 1:2, 1:2) isa SubDataFrame
    @test view(df, 1:2, 1:2) == DataFrame(a=1:2, b=4:5)
    @test view(df, 1:2, r"[ab]") isa SubDataFrame
    @test view(df, 1:2, r"[ab]") == DataFrame(a=1:2, b=4:5)
    @test view(df, 1:2, Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(df, 1:2, Not(Not(r"[ab]"))) == DataFrame(a=1:2, b=4:5)
    @test view(df, 1:2, :) isa SubDataFrame
    @test view(df, 1:2, :) == df[1:2, :]
    @test view(df, 1:2, r"") isa SubDataFrame
    @test view(df, 1:2, r"") == df[1:2, :]
    @test view(df, 1:2, Not(Int[])) isa SubDataFrame
    @test view(df, 1:2, Not(Int[])) == df[1:2, :]
    @test parent(view(df, 1:2, :)) === df
    @test parent(view(df, 1:2, r"")) === df
    @test parent(view(df, 1:2, Not(1:0))) === df

    @test view(df, Not(Not(1:2)), 1) == [1, 2]
    @test view(df, Not(Not(1:2)), 1) isa SubArray
    @test view(df, Not(Not(1:2)), 1:2) isa SubDataFrame
    @test view(df, Not(Not(1:2)), 1:2) == DataFrame(a=1:2, b=4:5)
    @test view(df, Not(Not(1:2)), r"[ab]") isa SubDataFrame
    @test view(df, Not(Not(1:2)), r"[ab]") == DataFrame(a=1:2, b=4:5)
    @test view(df, Not(Not(1:2)), Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(df, Not(Not(1:2)), Not(Not(r"[ab]"))) == DataFrame(a=1:2, b=4:5)
    @test view(df, Not(Not(1:2)), :) isa SubDataFrame
    @test view(df, Not(Not(1:2)), :) == df[1:2, :]
    @test view(df, Not(Not(1:2)), r"") isa SubDataFrame
    @test view(df, Not(Not(1:2)), r"") == df[1:2, :]
    @test view(df, Not(Not(1:2)), Not(Int[])) isa SubDataFrame
    @test view(df, Not(Not(1:2)), Not(Int[])) == df[1:2, :]
    @test parent(view(df, Not(Not(1:2)), :)) === df
    @test parent(view(df, Not(Not(1:2)), r"")) === df
    @test parent(view(df, Not(Not(1:2)), Not(1:0))) === df

    @test view(df, :, 1) == [1, 2, 3]
    @test view(df, :, 1) isa SubArray
    @test view(df, :, 1:2) isa SubDataFrame
    @test view(df, :, 1:2) == DataFrame(a=1:3, b=4:6)
    @test view(df, :, r"[ab]") isa SubDataFrame
    @test view(df, :, r"[ab]") == DataFrame(a=1:3, b=4:6)
    @test view(df, :, Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(df, :, Not(Not(r"[ab]"))) == DataFrame(a=1:3, b=4:6)
    @test view(df, :, :) isa SubDataFrame
    @test view(df, :, :) == df[:, :]
    @test view(df, :, r"") isa SubDataFrame
    @test view(df, :, r"") == df[:, :]
    @test view(df, :, Not(1:0)) isa SubDataFrame
    @test view(df, :, Not(1:0)) == df[:, :]
    @test parent(view(df, :, :)) === df
    @test parent(view(df, :, r"")) === df
    @test parent(view(df, :, Not(1:0))) === df

    @test view(df, Not(1:0), 1) == [1, 2, 3]
    @test view(df, Not(1:0), 1) isa SubArray
    @test view(df, Not(1:0), 1:2) isa SubDataFrame
    @test view(df, Not(1:0), 1:2) == DataFrame(a=1:3, b=4:6)
    @test view(df, Not(1:0), r"[ab]") isa SubDataFrame
    @test view(df, Not(1:0), r"[ab]") == DataFrame(a=1:3, b=4:6)
    @test view(df, Not(1:0), Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(df, Not(1:0), Not(Not(r"[ab]"))) == DataFrame(a=1:3, b=4:6)
    @test view(df, Not(1:0), :) isa SubDataFrame
    @test view(df, Not(1:0), :) == df[:, :]
    @test view(df, Not(1:0), r"") isa SubDataFrame
    @test view(df, Not(1:0), r"") == df[:, :]
    @test view(df, Not(1:0), Not(1:0)) isa SubDataFrame
    @test view(df, Not(1:0), Not(1:0)) == df[:, :]
    @test parent(view(df, Not(1:0), :)) === df
    @test parent(view(df, Not(1:0), r"")) === df
    @test parent(view(df, Not(1:0), Not(1:0))) === df
end

@testset "getindex SubDataFrame" begin
    df = DataFrame(x=-1:3, a=0:4, b=3:7, c=6:10, d=9:13)
    sdf = view(df, 2:4, 2:4)

    @test sdf[!, 1] == [1, 2, 3]
    @test sdf[!, 1] isa SubArray
    @test sdf[!, :a] == [1, 2, 3]
    @test sdf[!, :a] isa SubArray
    @test sdf[!, "a"] == [1, 2, 3]
    @test sdf[!, "a"] isa SubArray
    @test sdf.a == [1, 2, 3]
    @test sdf.a isa SubArray
    @test sdf.a === sdf."a"

    for selector in [1:2, r"[ab]", Not(Not(r"[ab]")), Not(r"ab"), Not(3), Not(1:0), Not(1:2), :]
        dfx = @view sdf[!, selector]
        @test dfx == select(sdf, selector, copycols=false)
        @test dfx isa SubDataFrame
        @test parent(dfx[!, 1]) === df[!, names(dfx)[1]]
    end

    @test sdf[:, 1:2] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, 1:2] isa DataFrame
    @test sdf[:, r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, r"[ab]"] isa DataFrame
    @test sdf[:, Not(Not(r"[ab]"))] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, Not(Not(r"[ab]"))] isa DataFrame
    @test sdf[:, :] == df[2:4, 2:4]
    @test sdf[:, :] isa DataFrame
    @test sdf[:, r""] == df[2:4, 2:4]
    @test sdf[:, r""] isa DataFrame
    @test sdf[:, Not(1:0)] == df[2:4, 2:4]
    @test sdf[:, Not(1:0)] isa DataFrame

    @test sdf[!, 1:2] == DataFrame(a=1:3, b=4:6)
    @test sdf[!, 1:2] isa SubDataFrame
    @test sdf[!, r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test sdf[!, r"[ab]"] isa SubDataFrame
    @test sdf[!, Not(Not(r"[ab]"))] == DataFrame(a=1:3, b=4:6)
    @test sdf[!, Not(Not(r"[ab]"))] isa SubDataFrame
    @test sdf[!, :] == df[2:4, 2:4]
    @test sdf[!, :] isa SubDataFrame
    @test sdf[!, r""] == df[2:4, 2:4]
    @test sdf[!, r""] isa SubDataFrame
    @test sdf[!, Not(1:0)] == df[2:4, 2:4]
    @test sdf[!, Not(1:0)] isa SubDataFrame
    @test parent(sdf[!, :]) === parent(sdf)
    @test parent(sdf[!, r""]) === parent(sdf)
    @test parent(sdf[!, Not([])]) === parent(sdf)

    @test sdf[1, 1] == 1
    @test sdf[1, 1:2] isa DataFrameRow
    @test copy(sdf[1, 1:2]) == (a=1, b=4)
    @test sdf[1, r"[ab]"] isa DataFrameRow
    @test copy(sdf[1, r"[ab]"]) == (a=1, b=4)
    @test sdf[1, Not(Not(r"[ab]"))] isa DataFrameRow
    @test copy(sdf[1, Not(Not(r"[ab]"))]) == (a=1, b=4)
    @test sdf[1, :] isa DataFrameRow
    @test copy(sdf[1, :]) == (a=1, b=4, c=7)
    @test sdf[1, r""] isa DataFrameRow
    @test copy(sdf[1, r""]) == (a=1, b=4, c=7)
    @test sdf[1, Not(1:0)] isa DataFrameRow
    @test copy(sdf[1, Not(1:0)]) == (a=1, b=4, c=7)
    @test parent(sdf[1, :]) === parent(sdf)
    @test parent(sdf[1, r""]) === parent(sdf)
    @test parent(sdf[1, Not(1:0)]) === parent(sdf)
    @test_throws ArgumentError sdf[true, 1]
    @test_throws ArgumentError sdf[true, 1:2]

    @test sdf[1:2, 1] == [1, 2]
    @test sdf[1:2, 1] isa Vector
    @test sdf[1:2, 1:2] == DataFrame(a=1:2, b=4:5)
    @test sdf[1:2, 1:2] isa DataFrame
    @test sdf[1:2, r"[ab]"] == DataFrame(a=1:2, b=4:5)
    @test sdf[1:2, r"[ab]"] isa DataFrame
    @test sdf[1:2, Not(Not(r"[ab]"))] == DataFrame(a=1:2, b=4:5)
    @test sdf[1:2, Not(Not(r"[ab]"))] isa DataFrame
    @test sdf[1:2, :] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[1:2, :] isa DataFrame
    @test sdf[1:2, r""] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[1:2, r""] isa DataFrame
    @test sdf[1:2, Not(Int[])] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[1:2, Not(Int[])] isa DataFrame

    @test sdf[Not(Not(1:2)), 1] == [1, 2]
    @test sdf[Not(Not(1:2)), 1] isa Vector
    @test sdf[Not(Not(1:2)), 1:2] == DataFrame(a=1:2, b=4:5)
    @test sdf[Not(Not(1:2)), 1:2] isa DataFrame
    @test sdf[Not(Not(1:2)), r"[ab]"] == DataFrame(a=1:2, b=4:5)
    @test sdf[Not(Not(1:2)), r"[ab]"] isa DataFrame
    @test sdf[Not(Not(1:2)), Not(Not(r"[ab]"))] == DataFrame(a=1:2, b=4:5)
    @test sdf[Not(Not(1:2)), Not(Not(r"[ab]"))] isa DataFrame
    @test sdf[Not(Not(1:2)), :] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[Not(Not(1:2)), :] isa DataFrame
    @test sdf[Not(Not(1:2)), r""] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[Not(Not(1:2)), r""] isa DataFrame
    @test sdf[Not(Not(1:2)), Not(Int[])] == DataFrame(a=1:2, b=4:5, c=7:8)
    @test sdf[Not(Not(1:2)), Not(Int[])] isa DataFrame

    @test sdf[:, 1] == [1, 2, 3]
    @test sdf[:, 1] isa Vector
    @test sdf[:, :a] == [1, 2, 3]
    @test sdf[:, :a] isa Vector
    @test sdf[:, "a"] == [1, 2, 3]
    @test sdf[:, "a"] isa Vector
    @test sdf[:, 1] !== df[!, 1]
    @test sdf[:, 1:2] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, 1:2] isa DataFrame
    @test sdf[:, r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, r"[ab]"] isa DataFrame
    @test sdf[:, Not(Not(1:2))] == DataFrame(a=1:3, b=4:6)
    @test sdf[:, Not(Not(1:2))] isa DataFrame
    @test sdf[:, :] == df[2:4, 2:4]
    @test sdf[:, :] isa DataFrame
    @test sdf[:, r""] == df[2:4, 2:4]
    @test sdf[:, r""] isa DataFrame
    @test sdf[:, Not(1:0)] == df[2:4, 2:4]
    @test sdf[:, Not(1:0)] isa DataFrame

    @test sdf[Not(Not(:)), 1] == [1, 2, 3]
    @test sdf[Not(Not(:)), 1] isa Vector
    @test sdf[Not(Not(:)), 1] !== df[!, 1]
    @test sdf[Not(Not(:)), 1:2] == DataFrame(a=1:3, b=4:6)
    @test sdf[Not(Not(:)), 1:2] isa DataFrame
    @test sdf[Not(Not(:)), r"[ab]"] == DataFrame(a=1:3, b=4:6)
    @test sdf[Not(Not(:)), r"[ab]"] isa DataFrame
    @test sdf[Not(Not(:)), Not(Not(1:2))] == DataFrame(a=1:3, b=4:6)
    @test sdf[Not(Not(:)), Not(Not(1:2))] isa DataFrame
    @test sdf[Not(Not(:)), :] == df[2:4, 2:4]
    @test sdf[Not(Not(:)), :] isa DataFrame
    @test sdf[Not(Not(:)), r""] == df[2:4, 2:4]
    @test sdf[Not(Not(:)), r""] isa DataFrame
    @test sdf[Not(Not(:)), Not(1:0)] == df[2:4, 2:4]
    @test sdf[Not(Not(:)), Not(1:0)] isa DataFrame
end

@testset "view SubDataFrame" begin
    df = DataFrame(x=-1:3, a=0:4, b=3:7, c=6:10, d=9:13)
    sdf = view(df, 2:4, 2:4)

    @test view(sdf, !, 1) == [1, 2, 3]
    @test view(sdf, !, 1) isa SubArray
    @test view(sdf, !, :a) == [1, 2, 3]
    @test view(sdf, !, :a) isa SubArray
    @test view(sdf, !, "a") == [1, 2, 3]
    @test view(sdf, !, "a") isa SubArray

    for selector in [1:2, r"[ab]", Not(Not(r"[ab]")), Not(r"ab"), Not(3), Not(1:0), Not(1:2), :]
        dfx = @view sdf[!, selector]
        @test dfx == select(sdf, selector, copycols=false)
        @test dfx isa SubDataFrame
        @test parent(dfx[!, 1]) === df[!, names(dfx)[1]]
    end

    @test view(sdf, :, :) isa SubDataFrame
    @test view(sdf, :, :) == df[2:4, 2:4]
    @test view(sdf, :, r"") isa SubDataFrame
    @test view(sdf, :, r"") == df[2:4, 2:4]
    @test view(sdf, :, Not(1:0)) isa SubDataFrame
    @test view(sdf, :, Not(1:0)) == df[2:4, 2:4]

    @test view(sdf, !, :) isa SubDataFrame
    @test view(sdf, !, :) == df[2:4, 2:4]
    @test view(sdf, !, r"") isa SubDataFrame
    @test view(sdf, !, r"") == df[2:4, 2:4]
    @test view(sdf, !, Not(1:0)) isa SubDataFrame
    @test view(sdf, !, Not(1:0)) == df[2:4, 2:4]
    @test parent(view(sdf, !, :)) == parent(sdf)
    @test parent(view(sdf, !, r"")) == parent(sdf)
    @test parent(view(sdf, !, Not(1:0))) == parent(sdf)

    @test view(sdf, 1, 1) isa SubArray
    @test view(sdf, 1, 1)[] == 1
    @test view(sdf, 1, :a) isa SubArray
    @test view(sdf, 1, :a)[] == 1
    @test view(sdf, 1, "a") isa SubArray
    @test view(sdf, 1, "a")[] == 1
    @test view(sdf, 1, 1:2) isa DataFrameRow
    @test copy(view(sdf, 1, 1:2)) == (a=1, b=4)
    @test view(sdf, 1, r"[ab]") isa DataFrameRow
    @test copy(view(sdf, 1, r"[ab]")) == (a=1, b=4)
    @test view(sdf, 1, Not(Not(r"[ab]"))) isa DataFrameRow
    @test copy(view(sdf, 1, Not(Not(r"[ab]")))) == (a=1, b=4)
    @test view(sdf, 1, :) isa DataFrameRow
    @test copy(view(sdf, 1, :)) == (a=1, b=4, c=7)
    @test view(sdf, 1, r"") isa DataFrameRow
    @test copy(view(sdf, 1, r"")) == (a=1, b=4, c=7)
    @test view(sdf, 1, Not(1:0)) isa DataFrameRow
    @test copy(view(sdf, 1, Not(1:0))) == (a=1, b=4, c=7)
    @test parent(view(sdf, 1, :)) === parent(sdf)
    @test parent(view(sdf, 1, r"")) === parent(sdf)
    @test parent(view(sdf, 1, Not(1:0))) === parent(sdf)

    @test view(sdf, 1:2, 1) == [1, 2]
    @test view(sdf, 1:2, 1) isa SubArray
    @test view(sdf, 1:2, 1:2) isa SubDataFrame
    @test view(sdf, 1:2, 1:2) == DataFrame(a=1:2, b=4:5)
    @test view(sdf, 1:2, r"[ab]") isa SubDataFrame
    @test view(sdf, 1:2, r"[ab]") == DataFrame(a=1:2, b=4:5)
    @test view(sdf, 1:2, Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(sdf, 1:2, Not(Not(r"[ab]"))) == DataFrame(a=1:2, b=4:5)
    @test view(sdf, 1:2, :) isa SubDataFrame
    @test view(sdf, 1:2, :) == df[2:3, 2:4]
    @test view(sdf, 1:2, r"") isa SubDataFrame
    @test view(sdf, 1:2, r"") == df[2:3, 2:4]
    @test view(sdf, 1:2, Not(1:0)) isa SubDataFrame
    @test view(sdf, 1:2, Not(1:0)) == df[2:3, 2:4]
    @test parent(view(sdf, 1:2, :)) === parent(sdf)
    @test parent(view(sdf, 1:2, r"")) === parent(sdf)
    @test parent(view(sdf, 1:2, Not(1:0))) === parent(sdf)

    @test view(sdf, Not(Not(1:2)), 1) == [1, 2]
    @test view(sdf, Not(Not(1:2)), 1) isa SubArray
    @test view(sdf, Not(Not(1:2)), :a) == [1, 2]
    @test view(sdf, Not(Not(1:2)), :a) isa SubArray
    @test view(sdf, Not(Not(1:2)), "a") == [1, 2]
    @test view(sdf, Not(Not(1:2)), "a") isa SubArray
    @test view(sdf, Not(Not(1:2)), 1:2) isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), 1:2) == DataFrame(a=1:2, b=4:5)
    @test view(sdf, Not(Not(1:2)), r"[ab]") isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), r"[ab]") == DataFrame(a=1:2, b=4:5)
    @test view(sdf, Not(Not(1:2)), Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), Not(Not(r"[ab]"))) == DataFrame(a=1:2, b=4:5)
    @test view(sdf, Not(Not(1:2)), :) isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), :) == df[2:3, 2:4]
    @test view(sdf, Not(Not(1:2)), r"") isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), r"") == df[2:3, 2:4]
    @test view(sdf, Not(Not(1:2)), Not(1:0)) isa SubDataFrame
    @test view(sdf, Not(Not(1:2)), Not(1:0)) == df[2:3, 2:4]
    @test parent(view(sdf, Not(Not(1:2)), :)) === parent(sdf)
    @test parent(view(sdf, Not(Not(1:2)), r"")) === parent(sdf)
    @test parent(view(sdf, Not(Not(1:2)), Not(1:0))) === parent(sdf)

    @test view(sdf, :, 1) == [1, 2, 3]
    @test view(sdf, :, 1) isa SubArray
    @test view(sdf, :, :a) == [1, 2, 3]
    @test view(sdf, :, :a) isa SubArray
    @test view(sdf, :, "a") == [1, 2, 3]
    @test view(sdf, :, "a") isa SubArray
    @test view(sdf, :, 1:2) isa SubDataFrame
    @test view(sdf, :, 1:2) == DataFrame(a=1:3, b=4:6)
    @test view(sdf, :, r"[ab]") isa SubDataFrame
    @test view(sdf, :, r"[ab]") == DataFrame(a=1:3, b=4:6)
    @test view(sdf, :, Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(sdf, :, Not(Not(r"[ab]"))) == DataFrame(a=1:3, b=4:6)
    @test view(sdf, :, :) isa SubDataFrame
    @test parent(view(sdf, :, :)) === parent(sdf)
    @test view(sdf, :, r"") isa SubDataFrame
    @test parent(view(sdf, :, r"")) === parent(sdf)
    @test view(sdf, :, Not(1:0)) isa SubDataFrame
    @test parent(view(sdf, :, Not(1:0))) === parent(sdf)
    @test view(sdf, :, :) == df[2:4, 2:4]
    @test view(sdf, :, r"") == df[2:4, 2:4]
    @test view(sdf, :, Not(1:0)) == df[2:4, 2:4]

    @test view(sdf, Not(Int[]), 1) == [1, 2, 3]
    @test view(sdf, Not(Int[]), 1) isa SubArray
    @test view(sdf, Not(Int[]), 1:2) isa SubDataFrame
    @test view(sdf, Not(Int[]), 1:2) == DataFrame(a=1:3, b=4:6)
    @test view(sdf, Not(Int[]), r"[ab]") isa SubDataFrame
    @test view(sdf, Not(Int[]), r"[ab]") == DataFrame(a=1:3, b=4:6)
    @test view(sdf, Not(Int[]), Not(Not(r"[ab]"))) isa SubDataFrame
    @test view(sdf, Not(Int[]), Not(Not(r"[ab]"))) == DataFrame(a=1:3, b=4:6)
    @test view(sdf, Not(Int[]), :) isa SubDataFrame
    @test parent(view(sdf, Not(Int[]), :)) === parent(sdf)
    @test view(sdf, Not(Int[]), r"") isa SubDataFrame
    @test parent(view(sdf, Not(Int[]), r"")) === parent(sdf)
    @test view(sdf, Not(Int[]), Not(1:0)) isa SubDataFrame
    @test parent(view(sdf, Not(Int[]), Not(1:0))) === parent(sdf)
    @test view(sdf, Not(Int[]), :) == df[2:4, 2:4]
    @test view(sdf, Not(Int[]), r"") == df[2:4, 2:4]
    @test view(sdf, Not(Int[]), Not(1:0)) == df[2:4, 2:4]

    @test ncol(view(sdf, 1:2, [])) == 0
end

@testset "getindex DataFrameRow" begin
    df = DataFrame(a=1:4, b=4:7, c=7:10)
    dfr = df[1, :]

    @test dfr[1] == 1
    @test dfr[:a] == 1
    @test dfr["a"] == 1
    @test dfr[1:2] isa DataFrameRow
    @test copy(dfr[1:2]) == (a=1, b=4)
    @test dfr[[:a, :b]] isa DataFrameRow
    @test copy(dfr[[:a, :b]]) == (a=1, b=4)
    @test dfr[["a", "b"]] isa DataFrameRow
    @test copy(dfr[["a", "b"]]) == (a=1, b=4)
    @test dfr[r"[ab]"] isa DataFrameRow
    @test copy(dfr[r"[ab]"]) == (a=1, b=4)
    @test dfr[Not(Not(r"[ab]"))] isa DataFrameRow
    @test copy(dfr[Not(Not(r"[ab]"))]) == (a=1, b=4)
    @test dfr[:] isa DataFrameRow
    @test copy(dfr[:]) == (a=1, b=4, c=7)
    @test dfr[r""] isa DataFrameRow
    @test copy(dfr[r""]) == (a=1, b=4, c=7)
    @test dfr[Not(1:0)] isa DataFrameRow
    @test copy(dfr[Not(1:0)]) == (a=1, b=4, c=7)
    @test parent(dfr[:]) === df
    @test parent(dfr[r""]) === df
    @test parent(dfr[Not(Not(:))]) === df
end

@testset "view DataFrameRow" begin
    df = DataFrame(a=1:4, b=4:7, c=7:10)
    dfr = df[1, :]

    @test view(dfr, 1)[] == 1
    @test view(dfr, 1) isa SubArray
    @test view(dfr, :a)[] == 1
    @test view(dfr, :a) isa SubArray
    @test view(dfr, "a")[] == 1
    @test view(dfr, "a") isa SubArray
    @test view(dfr, 1:2) isa DataFrameRow
    @test copy(view(dfr, 1:2)) == (a=1, b=4)
    @test view(dfr, [:a, :b]) isa DataFrameRow
    @test copy(view(dfr, [:a, :b])) == (a=1, b=4)
    @test view(dfr, ["a", "b"]) isa DataFrameRow
    @test copy(view(dfr, ["a", "b"])) == (a=1, b=4)
    @test view(dfr, r"[ab]") isa DataFrameRow
    @test copy(view(dfr, r"[ab]")) == (a=1, b=4)
    @test view(dfr, Not(Not(r"[ab]"))) isa DataFrameRow
    @test copy(view(dfr, Not(Not(r"[ab]")))) == (a=1, b=4)
    @test dfr[:] isa DataFrameRow
    @test copy(view(dfr, :)) == (a=1, b=4, c=7)
    @test dfr[r""] isa DataFrameRow
    @test copy(view(dfr, r"")) == (a=1, b=4, c=7)
    @test dfr[Not(Not(:))] isa DataFrameRow
    @test copy(view(dfr, Not(Not(:)))) == (a=1, b=4, c=7)
    @test parent(dfr[:]) === df
    @test parent(dfr[r""]) === df
    @test parent(dfr[Not([])]) === df
end

@testset "additional tests of post-! getindex rules" begin
    df = DataFrame(reshape(1.5:16.5, (4, 4)), :auto)

    @test df[2, 2] == df[!, 2][2] == 6.5
    @test_throws BoundsError df[0, 2]
    @test_throws BoundsError df[5, 2]
    @test_throws BoundsError df[2, 0]
    @test_throws BoundsError df[2, 5]

    @test df[CartesianIndex(2, 2)] == df[!, 2][2] == 6.5
    @test_throws BoundsError df[CartesianIndex(0, 2)]
    @test_throws BoundsError df[CartesianIndex(5, 2)]
    @test_throws BoundsError df[CartesianIndex(2, 0)]
    @test_throws BoundsError df[CartesianIndex(2, 5)]

    df2 = copy(df)
    dfr = df2[2, :]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 100]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 1000]

    df2 = copy(df)
    dfr = df2[2, 1:4]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]

    @test df[2:3, :x2] == df[!, :x2][2:3] == [6.5, 7.5]
    @test df[2:3, "x2"] == df[!, "x2"][2:3] == [6.5, 7.5]
    @test_throws ArgumentError df[2:3, :x]
    @test_throws BoundsError df[0:3, :x2]
    @test_throws BoundsError df[1:5, :x2]
    @test_throws ArgumentError df[2:3, "x"]
    @test_throws BoundsError df[0:3, "x2"]
    @test_throws BoundsError df[1:5, "x2"]

    @test df[:, :x2] == df[!, :x2]
    @test df[:, :x2] !== df[!, :x2]
    @test df[:, "x2"] == df[!, "x2"]
    @test df[:, "x2"] !== df[!, "x2"]

    @test df[1:2, 1:2] == df[Not(3:4), Not(3:4)] == select(df, r"[12]")[1:2, :]
    @test df[1:2, 1:2] isa DataFrame
    @test df[:, 1:2] == df[Not(1:0), Not(3:4)] == select(df, r"[12]")
    @test df[:, 1:2][!, :x1] !== df.x1
    @test df[:, 1:2] isa DataFrame
    @test df[:, :] == df
    @test df[:, :] isa DataFrame
    @test df[:, :][!, 1] == df.x1
    @test df[:, :][!, 1] !== df.x1

    @test df[!, :x2] === df.x2 === DataFrames._columns(df)[2]
    @test_throws ArgumentError df[!, :x]
    @test df[!, "x2"] === df.x2 === DataFrames._columns(df)[2]
    @test_throws ArgumentError df[!, "x"]

    v = @view df[2, 2]
    @test v isa SubArray
    @test size(v) == ()
    @test  v[] == 6.5
    @test_throws BoundsError @view df[0, 2]
    @test_throws BoundsError @view df[5, 2]
    @test_throws BoundsError @view df[2, 0]
    @test_throws BoundsError @view df[2, 5]

    v = @view df[CartesianIndex(2, 2)]
    @test v isa SubArray
    @test size(v) == ()
    @test  v[] == 6.5
    @test_throws BoundsError @view df[CartesianIndex(0, 2)]
    @test_throws BoundsError @view df[CartesianIndex(5, 2)]
    @test_throws BoundsError @view df[CartesianIndex(2, 0)]
    @test_throws BoundsError @view df[CartesianIndex(2, 5)]

    df2 = copy(df)
    dfr = @view df2[2, :]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 100]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 1000]

    df2 = copy(df)
    dfr = @view df2[2, 1:4]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]

    v = @view df[2:3, :x2]
    @test v == [6.5, 7.5]
    @test v isa SubArray
    @test parent(v) === df.x2
    @test_throws ArgumentError @view df[2:3, :x]
    @test_throws BoundsError @view df[0:3, :x2]
    @test_throws BoundsError @view df[1:5, :x2]

    v = @view df[2:3, "x2"]
    @test v == [6.5, 7.5]
    @test v isa SubArray
    @test parent(v) === df.x2
    @test_throws ArgumentError @view df[2:3, "x"]
    @test_throws BoundsError @view df[0:3, "x2"]
    @test_throws BoundsError @view df[1:5, "x2"]

    @test @view(df[:, :x2]) == df[!, :x2]
    @test parent(@view(df[:, :x2])) === df[!, :x2]

    @test @view(df[:, "x2"]) == df[!, "x2"]
    @test parent(@view(df[:, "x2"])) === df[!, "x2"]

    sdf = @view df[1:2, 1:2]
    @test sdf == df[1:2, 1:2]
    @test sdf isa SubDataFrame
    @test parent(sdf) === df
    sdf = @view df[:, 1:2]
    @test sdf == df[:, 1:2]
    @test sdf isa SubDataFrame
    @test parent(sdf) === df
    sdf = @view df[:, :]
    @test sdf == df[:, :]
    @test sdf isa SubDataFrame
    @test parent(sdf) === df

    @test @view(df[!, :x2]) === @view(df[:, :x2])
    @test @view(df[!, :x2]) isa SubArray
    @test parent(@view(df[!, :x2])) === df.x2
    @test_throws ArgumentError @view df[!, :x]

    @test @view(df[!, "x2"]) === @view(df[:, "x2"])
    @test @view(df[!, "x2"]) isa SubArray
    @test parent(@view(df[!, "x2"])) === df.x2
    @test_throws ArgumentError @view df[!, "x"]

    sdf = @view df[Not(1:0), Not(r"zzz")]

    @test sdf[2, 2] == sdf[!, 2][2] == 6.5
    @test_throws BoundsError sdf[0, 2]
    @test_throws BoundsError sdf[5, 2]
    @test_throws BoundsError sdf[2, 0]
    @test_throws BoundsError sdf[2, 5]

    @test sdf[CartesianIndex(2, 2)] == sdf[!, 2][2] == 6.5
    @test_throws BoundsError sdf[CartesianIndex(0, 2)]
    @test_throws BoundsError sdf[CartesianIndex(5, 2)]
    @test_throws BoundsError sdf[CartesianIndex(2, 0)]
    @test_throws BoundsError sdf[CartesianIndex(2, 5)]

    df2 = copy(df)
    dfr = view(df2, 1:4, :)[2, :]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 100]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 1000]

    df2 = copy(df)
    dfr = view(df2, 1:4, :)[2, 1:4]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]

    @test sdf[2:3, :x2] == sdf[!, :x2][2:3] == [6.5, 7.5]
    @test sdf[2:3, :x2] isa Vector
    @test_throws ArgumentError sdf[2:3, :x]
    @test_throws BoundsError sdf[0:3, :x2]
    @test_throws BoundsError sdf[1:5, :x2]

    @test sdf[:, :x2] == sdf[!, :x2]
    @test sdf[:, :x2] !== sdf[!, :x2]
    @test sdf[:, :x2] isa Vector

    @test sdf[2:3, "x2"] == sdf[!, "x2"][2:3] == [6.5, 7.5]
    @test sdf[2:3, "x2"] isa Vector
    @test_throws ArgumentError sdf[2:3, "x"]
    @test_throws BoundsError sdf[0:3, "x2"]
    @test_throws BoundsError sdf[1:5, "x2"]

    @test sdf[:, "x2"] == sdf[!, "x2"]
    @test sdf[:, "x2"] !== sdf[!, "x2"]
    @test sdf[:, "x2"] isa Vector

    @test sdf[1:2, 1:2] == sdf[Not(3:4), Not(3:4)] == select(sdf, r"[12]")[1:2, :]
    @test sdf[1:2, 1:2] isa DataFrame
    @test sdf[:, 1:2] == sdf[Not(1:0), Not(3:4)] == select(sdf, r"[12]")
    @test sdf[:, 1:2][!, :x1] !== sdf.x1
    @test sdf[:, 1:2][!, "x1"] !== sdf.x1
    @test sdf[:, 1:2] isa DataFrame
    @test sdf[:, :] == sdf
    @test sdf[:, :] isa DataFrame
    @test sdf[:, :][!, 1] == sdf.x1
    @test sdf[:, :][!, 1] !== sdf.x1

    @test sdf[!, :x2] === sdf.x2
    @test sdf.x2 == DataFrames._columns(df)[2]
    @test sdf.x2 isa SubArray
    @test sdf[!, :x2] isa SubArray

    @test_throws ArgumentError sdf[!, :x]

    @test sdf[!, "x2"] === sdf."x2"
    @test sdf."x2" == DataFrames._columns(df)[2]
    @test sdf."x2" isa SubArray
    @test sdf[!, "x2"] isa SubArray

    @test_throws ArgumentError sdf[!, "x"]

    v = @view sdf[2, 2]
    @test v isa SubArray
    @test size(v) == ()
    @test  v[] == 6.5
    @test_throws BoundsError @view sdf[0, 2]
    @test_throws BoundsError @view sdf[5, 2]
    @test_throws BoundsError @view sdf[2, 0]
    @test_throws BoundsError @view sdf[2, 5]

    v = @view sdf[CartesianIndex(2, 2)]
    @test v isa SubArray
    @test size(v) == ()
    @test  v[] == 6.5
    @test_throws BoundsError @view sdf[CartesianIndex(0, 2)]
    @test_throws BoundsError @view sdf[CartesianIndex(5, 2)]
    @test_throws BoundsError @view sdf[CartesianIndex(2, 0)]
    @test_throws BoundsError @view sdf[CartesianIndex(2, 5)]

    df2 = copy(df)
    dfr = @view view(df2, 1:4, :)[2, :]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 100]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5, 1000]

    df2 = copy(df)
    dfr = @view view(df2, 1:4, :)[2, 1:4]
    @test dfr isa DataFrameRow
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    @test parent(dfr) === df2
    df2[!, :y] .= 100
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]
    df2[!, "y"] .= 1000
    @test Vector(dfr) == [2.5, 6.5, 10.5, 14.5]

    v = @view sdf[2:3, :x2]
    @test v == [6.5, 7.5]
    @test v isa SubArray
    @test parent(v) === df.x2
    @test_throws ArgumentError @view sdf[2:3, :x]
    @test_throws BoundsError @view sdf[0:3, :x2]
    @test_throws BoundsError @view sdf[1:5, :x2]

    @test @view(sdf[:, :x2]) == sdf[!, :x2]
    @test parent(@view(sdf[:, :x2])) === df[!, :x2]

    @test @view(sdf[:, "x2"]) == sdf[!, "x2"]
    @test parent(@view(sdf[:, "x2"])) === df[!, "x2"]

    sdf2 = @view sdf[1:2, 1:2]
    @test sdf2 == sdf[1:2, 1:2]
    @test sdf2 isa SubDataFrame
    @test parent(sdf2) === df
    sdf2 = @view sdf[:, 1:2]
    @test sdf2 == sdf[:, 1:2]
    @test sdf2 isa SubDataFrame
    @test parent(sdf2) === df
    sdf2 = @view sdf[:, :]
    @test sdf2 == sdf[:, :]
    @test sdf2 isa SubDataFrame
    @test parent(sdf2) === df

    @test @view(sdf[!, :x2]) == df.x2
    @test sdf[!, :x2] isa SubArray
    @test parent(sdf[!, :x2]) === df.x2
    @test_throws ArgumentError @view sdf[!, :x]
    @test select(sdf, 1:2, copycols=false) == @view sdf[!, 1:2]

    @test @view(sdf[!, "x2"]) == df."x2"
    @test sdf[!, "x2"] isa SubArray
    @test parent(sdf[!, "x2"]) === df."x2"
    @test_throws ArgumentError @view sdf[!, "x"]

    dfr = df[2, :]
    @test dfr[2] == dfr.x2 == dfr."x2" == 6.5
    @test_throws BoundsError dfr[0]
    @test_throws BoundsError dfr[5]
    @test_throws ArgumentError dfr[:z]
    @test_throws ArgumentError dfr.z
    @test_throws ArgumentError dfr["z"]
    @test_throws ArgumentError dfr."z"

    @test Vector(dfr[2:3]) == [6.5, 10.5]
    @test dfr[2:3] isa DataFrameRow
    @test parent(dfr[2:3]) === df

    v = @view dfr[2]
    @test v[] == 6.5
    @test v isa SubArray
    @test size(v) == ()
    @test_throws BoundsError @view dfr[0]
    @test_throws BoundsError @view dfr[5]
    @test_throws ArgumentError @view dfr[:z]
    @test_throws ArgumentError @view dfr["z"]

    @test Vector(@view(dfr[2:3])) == [6.5, 10.5]
    @test @view(dfr[2:3]) isa DataFrameRow
    @test parent(@view(dfr[2:3])) === df
end

@testset "setindex! on DataFrame" begin
    # `df[row, col] = v` -> set value of `col` in row `row` to `v` in-place
    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[1, 1] = 10
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test df.a === x
    @test_throws BoundsError df[0, 1] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test_throws ArgumentError df[1, 10] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test_throws ArgumentError df[true, 1] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test_throws MethodError df[1.0, 1] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    df[BigInt(1), 1] = 100
    @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
    df[BigInt(1), :a] = 'a'
    @test df == DataFrame(a=[97, 2, 3], b=4:6, c=7:9)
    @test_throws ArgumentError df[BigInt(1), :z] = 'z'
    df[BigInt(1), "a"] = 'b'
    @test df == DataFrame(a=[98, 2, 3], b=4:6, c=7:9)
    @test_throws ArgumentError df[BigInt(1), "z"] = 'z'
    @test df == DataFrame(a=[98, 2, 3], b=4:6, c=7:9)
    @test_throws MethodError df[1, 1] = "a"
    @test df == DataFrame(a=[98, 2, 3], b=4:6, c=7:9)

    # `df[CartesianIndex(row, col)] = v` -> the same as `df[row, col] = v`
    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[CartesianIndex(1, 1)] = 10
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test df.a === x
    @test_throws BoundsError df[CartesianIndex(0, 1)] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    @test_throws ArgumentError df[CartesianIndex(1, 10)] = 100
    @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    df[CartesianIndex(BigInt(1), 1)] = 100
    @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
    @test_throws MethodError df[CartesianIndex(1, 1)] = "a"
    @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)

    # `df[row, cols] = v` -> set row `row` of columns `cols` in-place;
    # the same as `dfr = df[row, cols]; dfr[:] = v`

    df = DataFrame(a=[[1, 2]], b=[[1, 2]])
    dfr = df[1, :]
    @test_throws MethodError dfr[:] = [10, 11]
    @test df == DataFrame(a=[[1, 2]], b=[[1, 2]])
    @test_throws MethodError df[1, :] = [10, 11]
    @test df == DataFrame(a=[[1, 2]], b=[[1, 2]])

    df = DataFrame(a=1, b=2)
    df[1, :] = [10, 11]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = [10, 11]
    @test df == DataFrame(a=10, b=11)

    df = DataFrame(a=1, b=2)
    df[1, ["a", "b"]] = [10, 11]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, ["a", "b"]]
    dfr[["a", "b"]] = [10, 11]
    @test df == DataFrame(a=10, b=11)

    df = DataFrame(a=1, b=2)
    df[1, :] = (10, 11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = (10, 11)
    @test df == DataFrame(a=10, b=11)

    @test_throws DimensionMismatch df[1, :] = [1, 2, 3]
    @test_throws DimensionMismatch dfr[:] = [1, 2, 3]

    df = DataFrame(a=1, b=2)
    df[1, :] = Dict(:a=>10, :b=>11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, :] = Dict(:a=>10, :c=>11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws DimensionMismatch df[1, :] = Dict(:a=>10, :b=>11, :c=>12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    df[1, ["a", "b"]] = Dict("a"=>10, "b"=>11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, ["a", "b"]] = Dict("a"=>10, "c"=>11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws DimensionMismatch df[1, ["a", "b"]] = Dict("a"=>10, "b"=>11, "c"=>12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    df[1, :] = (a=10, b=11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, :] = (a=10, c=11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, :] = (b=10, a=11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws DimensionMismatch df[1, :] = (a=10, b=11, c=12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    df[1, :] = DataFrame(a=10, b=11)[1, :]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, :] = DataFrame(a=10, c=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df[1, :] = DataFrame(b=10, a=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    @test_throws DimensionMismatch df[1, :] = DataFrame(a=10, b=11, c=12)[1, :]
    @test df == DataFrame(a=1, b=2)

    # `df[rows, col] = v` -> set rows `rows` of column `col` in-place; `v` must be an `AbstractVector`
    # the exception is `df[:, col] = v`, when col is not present in df, in which case `v` is copied
    # and column `col` is created

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[1:3, 1] = 10:12
    @test df == DataFrame(a=10:12, b=4:6, c=7:9)
    @test df.a === x
    @test_throws MethodError df[1:3, 1] = ["a", "b", "c"]
    @test_throws DimensionMismatch df[1:3, 1] = [1]
    @test_throws MethodError df[1:3, 1] = 1
    @test_throws ArgumentError df[1:3, :z] = ["a", "b", "c"]
    @test_throws ArgumentError df[1:3, "z"] = ["a", "b", "c"]
    @test_throws BoundsError df[1:3, 4] = ["a", "b", "c"]

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[1:3, "a"] = 10:12
    @test df == DataFrame(a=10:12, b=4:6, c=7:9)
    @test df.a === x

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[:, 1] = 10:12
    @test df == DataFrame(a=10:12, b=4:6, c=7:9)
    @test df.a === x

    y = ["a", "b", "c"]
    df[:, :y] = y
    @test df.y == y
    @test df.y !== y

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    x = df.a
    df[:, "a"] = 10:12
    @test df == DataFrame(a=10:12, b=4:6, c=7:9)
    @test df."a" === x

    y = ["a", "b", "c"]
    df[:, "y"] = y
    @test df."y" == y
    @test df."y" !== y

    @test_throws MethodError df[:, 1] = ["a", "b", "c"]
    @test_throws DimensionMismatch df[:, 1] = [1]
    @test_throws MethodError df[:, 1] = 1
    @test_throws MethodError df[:, 2] = ["a", "b", "c"]
    @test_throws ArgumentError df[:, 10] = ["a", "b", "c"]

    # `df[rows, cols] = v` -> set rows `rows` of columns `cols` in-place;
    #                         `v` must be an `AbstractMatrix` or an `AbstractDataFrame`
    #                         (in this case column names must match)

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    df2 = DataFrame(a=11:13, b=14:16, c=17:19)
    x = df.a
    df[1:3, 1:3] = df2
    @test df == df2
    @test df.a == x
    @test_throws ArgumentError df[1:2, 1:2] = df2

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    df2 = DataFrame(a=11:13, b=14:16, c=17:19)
    m = Matrix(df2)
    x = df.a
    df[1:3, 1:3] = m
    @test df == df2
    @test df.a == x
    @test_throws DimensionMismatch df[1:2, 1:2] = m

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    df2 = df[!, :]
    @test_throws MethodError df[1:2, 1:2] = 1
    @test_throws ArgumentError df[1:2, 1:2] = DataFrame(ones(2, 2), :auto)
    @test df == DataFrame(a=1:3, b=4:6, c=7:9)
    df[:, :] = DataFrame(a=11:13, b=14:16, c=17:19)
    @test df2 == DataFrame(a=11:13, b=14:16, c=17:19)
    df[:, [1, 3]] = DataFrame(a=111:113, c=117:119)
    @test df2 == DataFrame(a=111:113, b=14:16, c=117:119)
    df[:, 2] = 1114:1116
    @test df2 == DataFrame(a=111:113, b=1114:1116, c=117:119)

    # `df[!, col] = v` -> replaces `col` with `v` without copying
    #                     (with the exception that if `v` is an `AbstractRange` it gets converted to a `Vector`);
    #                     also if `col` is a `Symbol` that is not present in `df` then a new column in `df` is created and holds `v`;
    #                     equivalent to `df.col = v` if `col` is a valid identifier

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    df[!, 1] = ["a", "b", "c"]
    @test df == DataFrame(a=["a", "b", "c"], b=4:6, c=7:9)
    @test_throws ArgumentError df[!, 1] = ["a", "b"]
    @test_throws ArgumentError df[!, 1] = ["a"]
    @test_throws ArgumentError df[!, 5] = ["a", "b", "c"]
    df[!, :a] = 'a':'c'
    @test df == DataFrame(a='a':'c', b=4:6, c=7:9)
    df.a = ["aaa", "bbb", 1]
    @test df == DataFrame(a=["aaa", "bbb", 1], b=4:6, c=7:9)
    df.z = 11:13
    @test df == DataFrame(a=["aaa", "bbb", 1], b=4:6, c=7:9, z=11:13)

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    @test_throws MethodError df[:, :a] = 1
    @test_throws ArgumentError df[:, 4] = 1:3
    @test df == DataFrame(a=1:3, b=4:6, c=7:9)
    df[:, :x] = 10:12
    @test df == DataFrame(a=1:3, b=4:6, c=7:9, x=10:12)

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    df[!, "a"] = ["a", "b", "c"]
    @test df == DataFrame(a=["a", "b", "c"], b=4:6, c=7:9)
    @test_throws ArgumentError df[!, "a"] = ["a", "b"]
    @test_throws ArgumentError df[!, "a"] = ["a"]
    df[!, "a"] = 'a':'c'
    @test df == DataFrame(a='a':'c', b=4:6, c=7:9)
    df."a" = ["aaa", "bbb", 1]
    @test df == DataFrame(a=["aaa", "bbb", 1], b=4:6, c=7:9)
    df."z" = 11:13
    @test df == DataFrame(a=["aaa", "bbb", 1], b=4:6, c=7:9, z=11:13)
end

@testset "setindex! on SubDataFrame" begin
    # `sdf[row, col] = v` -> set value of `col` in row `row` to `v` in-place;

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:2), view(df, 1:2, :), view(df, 1:2, 1:2)]
        df.a = [1, 2, 3] # make sure we have a fresh first column in each iteration
        x = df.a
        sdf[1, 1] = 10
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
        @test x === df.a
        @test_throws BoundsError sdf[0, 1] = 100
        @test_throws BoundsError sdf[1, 0] = 100
        @test_throws ArgumentError sdf[1, true] = 100
        @test_throws ArgumentError sdf[true, 1] = 100
        @test_throws MethodError sdf[1, 1] = "a"
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    end

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:2), view(df, 1:2, :), view(df, 1:2, 1:2)]
        df.a = [1, 2, 3] # make sure we have a fresh first column in each iteration
        x = df.a
        sdf[1, names(sdf)[1]] = 10
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
        @test x === df.a
        @test_throws BoundsError sdf[0, names(sdf)[1]] = 100
        @test_throws ArgumentError sdf[true, names(sdf)[1]] = 100
        @test_throws MethodError sdf[1, names(sdf)[1]] = "a"
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    end

    # `sdf[CartesianIndex(row, col)] = v` -> the same as `sdf[row, col] = v`;

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:2), view(df, 1:2, :), view(df, 1:2, 1:2)]
        df.a = [1, 2, 3] # make sure we have a fresh first column in each iteration
        x = df.a
        sdf[CartesianIndex(1, 1)] = 10
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
        @test x === df.a
        @test_throws BoundsError sdf[CartesianIndex(0, 1)] = 100
        @test_throws BoundsError sdf[CartesianIndex(1, 0)] = 100
        @test_throws MethodError sdf[CartesianIndex(1, 1)] = "a"
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
    end

    # `sdf[row, cols] = v` -> the same as `dfr = df[row, cols]; dfr[:] = v` in-place;

    df = view(DataFrame(a=[[1, 2]], b=[[1, 2]]), :, :)
    dfr = df[1, :];
    @test_throws MethodError dfr[:] = [10, 11]
    @test df == DataFrame(a=[[1, 2]], b=[[1, 2]])
    @test_throws MethodError df[1, :] = [10, 11]
    @test df == DataFrame(a=[[1, 2]], b=[[1, 2]])

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = [10, 11]
    @test df == DataFrame(a=10, b=11)
    df = view(DataFrame(a=1, b=2), :, :)
    dfr = df[1, :]
    dfr[:] = [10, 11]
    @test df == DataFrame(a=10, b=11)

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = (10, 11)
    @test df == DataFrame(a=10, b=11)
    df = view(DataFrame(a=1, b=2), :, :)
    dfr = df[1, :]
    dfr[:] = (10, 11)
    @test df == DataFrame(a=10, b=11)

    @test_throws DimensionMismatch df[1, :] = [1, 2, 3]
    @test_throws DimensionMismatch dfr[:] = [1, 2, 3]
    @test_throws MethodError df[1, 1:2] = 3
    @test_throws MethodError dfr[:] = 3
    @test_throws MethodError dfr[1:1] = 100
    @test_throws MethodError df[1, 1:1] = 1000
    @test_throws MethodError dfr[1:1] = "d"
    @test_throws MethodError df[1, 1:1] = "e"

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = Dict(:a=>10, :b=>11)
    @test df == DataFrame(a=10, b=11)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = Dict(:a=>10, :c=>11)
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws DimensionMismatch df[1, :] = Dict(:a=>10, :b=>11, :c=>12)
    @test df == DataFrame(a=1, b=2)

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = Dict("a"=>101, "b"=>111)
    @test df == DataFrame(a=101, b=111)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = Dict("a"=>10, "c"=>11)
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws DimensionMismatch df[1, :] = Dict("a"=>10, "b"=>11, "c"=>12)
    @test df == DataFrame(a=1, b=2)

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = (a=10, b=11)
    @test df == DataFrame(a=10, b=11)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = (a=10, c=11)
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = (b=10, a=11)
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws DimensionMismatch df[1, :] = (a=10, b=11, c=12)
    @test df == DataFrame(a=1, b=2)

    df = view(DataFrame(a=1, b=2), :, :)
    df[1, :] = DataFrame(a=10, b=11)[1, :]
    @test df == DataFrame(a=10, b=11)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = DataFrame(a=10, c=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws ArgumentError df[1, :] = DataFrame(b=10, a=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = view(DataFrame(a=1, b=2), :, :)
    @test_throws DimensionMismatch df[1, :] = DataFrame(a=10, b=11, c=12)[1, :]
    @test df == DataFrame(a=1, b=2)

    # `sdf[rows, col] = v` -> set rows `rows` of column `col`, in-place; `v` must be an abstract vector;

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:3), view(df, 1:3, :), view(df, 1:3, 1:3)]
        df.a = [1, 2, 3]
        x = df.a
        sdf[1:3, 1] = 10:12
        @test sdf == DataFrame(a=10:12, b=4:6, c=7:9)
        @test df.a === x
        @test_throws MethodError sdf[1:3, 1] = ["a", "b", "c"]
        @test_throws DimensionMismatch sdf[1:3, 1] = [1]
        @test_throws MethodError sdf[1:3, 1] = 1
        @test_throws ArgumentError sdf[1:3, :z] = ["a", "b", "c"]
        @test_throws BoundsError sdf[1:3, 4] = ["a", "b", "c"]
    end

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:3), view(df, 1:3, :),
                view(df, 1:3, 1:3), view(df, 1:3, ["a", "b", "c"])]
        df."a" = [1, 2, 3]
        x = df."a"
        sdf[1:3, names(sdf)[1]] = 10:12
        @test sdf == DataFrame(a=10:12, b=4:6, c=7:9)
        @test df.a === x
        @test_throws MethodError sdf[1:3, names(sdf)[1]] = ["a", "b", "c"]
        @test_throws ArgumentError sdf[1:3, "z"] = ["a", "b", "c"]
    end

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:3), view(df, 1:3, :),
                view(df, 1:3, 1:3), view(df, 1:3, ["a", "b", "c"])]
        df.a = [1, 2, 3]
        x = df.a
        sdf[:, 1] = 10:12
        @test df == DataFrame(a=10:12, b=4:6, c=7:9)
        @test_throws MethodError sdf[:, 1] = ["a", "b", "c"]
        @test_throws BoundsError sdf[:, 4] = ["a", "b", "c"]
        @test_throws DimensionMismatch sdf[:, 1] = [1]
        @test_throws MethodError sdf[:, 1] = 1
        @test DataFrames.is_column_insertion_allowed(sdf) == (DataFrames.index(sdf) isa DataFrames.Index)
        if DataFrames.is_column_insertion_allowed(sdf)
            sdf[:, :z] = ["a", "b", "c"]
            @test df.z == ["a", "b", "c"]
            @test eltype(df.z) == Union{String, Missing}
            select!(df, 1:3)
        else
            @test_throws ArgumentError sdf[:, :z] = ["a", "b", "c"]
        end
    end

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for sdf in [view(df, :, :), view(df, :, 1:3), view(df, 1:3, :),
                view(df, 1:3, 1:3), view(df, 1:3, ["a", "b", "c"])]
        df.a = [1, 2, 3]
        x = df.a
        sdf[:, names(sdf)[1]] = 10:12
        @test df == DataFrame(a=10:12, b=4:6, c=7:9)
        @test_throws MethodError sdf[:, names(sdf)[1]] = ["a", "b", "c"]
        @test DataFrames.is_column_insertion_allowed(sdf) == (DataFrames.index(sdf) isa DataFrames.Index)
        if DataFrames.is_column_insertion_allowed(sdf)
            sdf[:, "z"] = ["a", "b", "c"]
            @test df.z == ["a", "b", "c"]
            select!(df, 1:3)
        else
            @test_throws ArgumentError sdf[:, "z"] = ["a", "b", "c"]
        end
    end

    # `sdf[rows, cols] = v` -> set rows `rows` of columns `cols` in-place;
    #                          `v` can be an `AbstractMatrix` or `v` can be `AbstractDataFrame` when column names must match;

    for (row_sel, col_sel) in [(:, :), (:, 1:3), (1:3, :),
                               (1:3, 1:3), (1:3, ["a", "b", "c"])]
        df = DataFrame(a=1:3, b=4:6, c=7:9)
        sdf = view(df, row_sel, col_sel)
        df2 = DataFrame(a=11:13, b=14:16, c=17:19)
        x = df.a
        sdf[1:3, 1:3] = df2
        @test sdf == df2
        @test df.a == x
        @test_throws ArgumentError sdf[1:2, 1:2] = df2

        df = DataFrame(a=1:3, b=4:6, c=7:9)
        sdf = view(df, row_sel, col_sel)
        df2 = DataFrame(a=11:13, b=14:16, c=17:19)
        m = Matrix(df2)
        x = df.a
        sdf[1:3, 1:3] = m
        @test sdf == df2
        @test sdf.a == x
        @test_throws DimensionMismatch df[1:2, 1:2] = m

        @test_throws MethodError sdf[row_sel, col_sel] = 1
        @test_throws ArgumentError sdf[row_sel, col_sel] = DataFrame(ones(3, 3), :auto)
        @test (sdf[row_sel, col_sel] = df2) == df2
        @test df == df2
    end

    for (row_sel, col_sel) in [(:, :), (:, 1:3), (1:3, :), (1:3, 1:3), (1:3, ["a", "b", "c"])]
        df = DataFrame(a=1:3, b=4:6, c=7:9)
        sdf = view(df, row_sel, col_sel)
        sdf[!, 1] = [11, 12, 13]
        sdf[!, "b"] = [14, 15, 16]
        sdf[!, 3:3] = ones(Int, 3, 1)
        @test df == DataFrame(a=11:13, b=14:16, c=1)
    end
end

@testset "setindex! on DataFrameRow" begin
    # `dfr[col] = v` -> set value of `col` in row `row` to `v` in-place;
    #                   equivalent to `dfr.col = v` if `col` is a valid identifier;

    df = DataFrame(a=1:3, b=4:6, c=7:9)
    for dfr in [df[1, :], df[1, 1:2]]
        df.a = 1:3
        x = df.a
        dfr = df[1, :]
        dfr[1] = 10
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
        @test df.a === x
        @test_throws BoundsError dfr[10] = 10
        @test_throws ArgumentError dfr[true] = 10
        @test df == DataFrame(a=[10, 2, 3], b=4:6, c=7:9)
        dfr[BigInt(1)] = 100
        @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
        dfr[:a] = 'a'
        @test df == DataFrame(a=[97, 2, 3], b=4:6, c=7:9)
        dfr["a"] = 'b'
        @test df == DataFrame(a=[98, 2, 3], b=4:6, c=7:9)
        @test_throws ArgumentError dfr[:z] = 'z'
        @test_throws ArgumentError dfr["z"] = 'z'
        @test df == DataFrame(a=[98, 2, 3], b=4:6, c=7:9)
        dfr.a = 'c'
        @test df == DataFrame(a=[99, 2, 3], b=4:6, c=7:9)
        @test_throws ArgumentError dfr.z = 'z'
        @test df == DataFrame(a=[99, 2, 3], b=4:6, c=7:9)
        @test_throws MethodError dfr.a = "a"
        @test df == DataFrame(a=[99, 2, 3], b=4:6, c=7:9)
        dfr."a" = 'd'
        @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
        @test_throws ArgumentError dfr.z = 'z'
        @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
        @test_throws MethodError dfr.a = "a"
        @test df == DataFrame(a=[100, 2, 3], b=4:6, c=7:9)
    end

    # * `dfr[cols] = v` -> set values of entries in columns `cols` in `dfr` by elements of `v` in place;
    #                      `v` can be:
    #                      1) a `Tuple` or an `AbstractArray`
    #                         in which cases it must have a number of elements equal to `length(dfr)`,
    #                      2) an `AbstractDict`, in which case column names must match,
    #                      3) a `NamedTuple` or `DataFrameRow`, in which case column names and order must match;

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = (10, 11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = (10, 11, 12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = [10, 11]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = [10, 11, 12]
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = [10  11]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = [10 11 12]
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws MethodError dfr[:] = (i for i in 10:11, _ in 1:1, _ in 1:1)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = Dict(:a=>10, :b=>11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[:] = Dict(:a=>10, :c=>11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = Dict(:a=>10, :b=>11, :c=>12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = (a=10, b=11)
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[:] = (a=10, c=11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[:] = (b=10, a=11)
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = (a=10, b=11, c=12)
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    dfr[:] = DataFrame(a=10, b=11)[1, :]
    @test df == DataFrame(a=10, b=11)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[:] = DataFrame(a=10, c=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[:] = DataFrame(b=10, a=11)[1, :]
    @test df == DataFrame(a=1, b=2)
    df = DataFrame(a=1, b=2)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[:] = DataFrame(a=10, b=11, c=12)[1, :]
    @test df == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = (10, 11)
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = (10, 11, 12)
    @test df == DataFrame(a=1, b=2, c=3)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = [10, 11]
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = [10, 11, 12]
    @test df == DataFrame(a=1, b=2, c=3)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = [10 11]
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = [10 11 12]
    @test df == DataFrame(a=1, b=2, c=3)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws MethodError dfr[Not(3)] = (i for i in 10:11, _ in 1:1, _ in 1:1)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = Dict(:a=>10, :b=>11)
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[Not(3)] = Dict(:a=>10, :c=>11)
    @test df == DataFrame(a=1, b=2, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = Dict(:a=>10, :b=>11, :c=>12)
    @test df == DataFrame(a=1, b=2, c=3)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = (a=10, b=11)
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[Not(3)] = (a=10, c=11)
    @test df == DataFrame(a=1, b=2, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[Not(3)] = (b=10, a=11)
    @test df == DataFrame(a=1, b=2, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = (a=10, b=11, c=12)
    @test df == DataFrame(a=1, b=2, c=3)

    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    dfr[Not(3)] = DataFrame(a=10, b=11)[1, :]
    @test df == DataFrame(a=10, b=11, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[Not(3)] = DataFrame(a=10, c=11)[1, :]
    @test df == DataFrame(a=1, b=2, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws ArgumentError dfr[Not(3)] = DataFrame(b=10, a=11)[1, :]
    @test df == DataFrame(a=1, b=2, c=3)
    df = DataFrame(a=1, b=2, c=3)
    dfr = df[1, :]
    @test_throws DimensionMismatch dfr[Not(3)] = DataFrame(a=10, b=11, c=12)[1, :]
    @test df == DataFrame(a=1, b=2, c=3)

    @test_throws MethodError dfr[:] = "ab"
end

@testset "setindex! with ! or : and multiple cols" begin
    df = DataFrame(fill("x", 3, 4), :auto)
    df[!, :] = DataFrame(reshape(1:12, 3, :), :auto)
    @test df == DataFrame(reshape(1:12, 3, :), :auto)
    @test_throws ArgumentError df[!, :] = DataFrame(fill(1, 3, 4), :auto)[:, [3, 2, 1]]
    @test_throws ArgumentError df[!, :] = DataFrame(fill(1, 3, 4), :auto)[1:2, :]

    df = DataFrame(fill("x", 3, 4), :auto)
    df[!, Not(4)] = DataFrame(reshape(1:12, 3, :), :auto)[:, 1:3]
    @test df[:, 1:3] == DataFrame(reshape(1:12, 3, :), :auto)[:, 1:3]

    df = DataFrame(fill("x", 3, 4), :auto)
    df[!, :] = reshape(1:12, 3, :)
    @test df == DataFrame(reshape(1:12, 3, :), :auto)

    df = DataFrame(fill("x", 3, 4), :auto)
    df[!, Not(4)] = reshape(1:12, 3, :)[:, 1:3]
    @test df[:, 1:3] == DataFrame(reshape(1:12, 3, :), :auto)[:, 1:3]

    dfv = view(df, :, :)
    dfv[!, :] = DataFrame(reshape(1:12, 3, :), :auto)
    @test df == DataFrame(reshape(1:12, 3, :), :auto)
    dfv[!, :] = reshape(1:12, 3, :)
    @test df == DataFrame(reshape(1:12, 3, :), :auto)

    for rows in [:, 1:3], cols in [:, r"", Not(r"xx"), 1:4]
        df = DataFrame(ones(3, 4), :auto)
        df[rows, cols] = DataFrame(reshape(1:12, 3, :), :auto)
        @test df == DataFrame(reshape(1:12, 3, :), :auto)
    end

    for rows in [:, 1:3], cols in [:, r"", Not(r"xx"), 1:4]
        df = DataFrame(ones(3, 4), :auto)
        df[rows, cols] = reshape(1:12, 3, :)
        @test df == DataFrame(reshape(1:12, 3, :), :auto)
    end
end

@testset "additional setindex! tests" begin
    df = DataFrame(reshape(1:12, 4, :), :auto)
    df[1:2, :] = df[3:4, :]
    @test df == DataFrame([3  7  11
                          4  8  12
                          3  7  11
                          4  8  12], :auto)

    df[[true, false, true, false], :] = df[[2, 4], :]
    @test df == DataFrame([4  8  12
                          4  8  12
                          4  8  12
                          4  8  12], :auto)

    @test_throws MethodError df[1, :] = 1

    df[:, 2] = ones(4)
    @test df == DataFrame([4  1  12
                          4  1  12
                          4  1  12
                          4  1  12], :auto)

    @test_throws InexactError df[:, 2] = fill(1.5, 4)
end

@testset "invalid view tests" begin
    dfr = DataFrame(ones(2, 3), :auto)
    for df in (dfr, view(dfr, 1:2, 1:3))
        for r in (1, 1:1)
            @test_throws BoundsError view(df, r, 0:1)
            @test_throws BoundsError view(df, r, 1:4)
            @test_throws BoundsError view(df, r, [0, 1])
            @test_throws BoundsError view(df, r, [1, 4])
            @test_throws ArgumentError view(df, r, [1, 2, 1])
            @test_throws ArgumentError view(df, r, [:x1, :x2, :x1])
            @test_throws ArgumentError view(df, r, ["x1", "x2", "x1"])
        end
    end
end

# just to check that dispatch works correctly
@testset "string indexing" begin
    df_ref = DataFrame(a=1:3, b=4:6, c=7:9)
    for df in (df_ref[1:2, [2, 1]], df_ref[1:2, ["b", "a"]],
               view(df_ref, 1:2, [2, 1]), view(df_ref, 1:2, ["b", "a"]))
        @test df[1, "a"] == df[1, 2]
        @test df[1:2, "a"] == df[1:2, 2]
        @test df[1, ["a", "b"]] == df[1, [2, 1]]
        @test df[1:2, ["a", "b"]] == df[1:2, [2, 1]]
        @test df[:, ["a", "b"]] == df[:, [2, 1]]
        @test df[!, ["a", "b"]] == df[!, [2, 1]]

        @test view(df, 1, "a") == view(df, 1, 2)
        @test view(df, 1:2, "a") == view(df, 1:2, 2)
        @test view(df, 1, ["a", "b"]) == view(df, 1, [2, 1])
        @test view(df, 1:2, ["a", "b"]) == view(df, 1:2, [2, 1])
        @test view(df, :, ["a", "b"]) == view(df, :, [2, 1])
        @test view(df, !, ["a", "b"]) == view(df, !, [2, 1])

        df[1, "a"] = 100
        @test df[1, "a"] == 100
        df[1:2, "a"] = [20, 30]
        @test df[1:2, "a"] == [20, 30]
        df[:, "a"] = [30, 40]
        @test df[:, "a"] == [30, 40]
        df[!, "a"] = [1, 2]
        @test df[!, "a"] == [1, 2]

        df[1, ["a", "b"]] = (a=1000, b=2000)
        @test copy(df[1, ["a", "b"]]) == (a=1000, b=2000)
        df[1:1, ["a"]] = ones(1, 1)
        @test df[1, "a"] == 1
        df[1, ["a", "b"]] .= 50
        @test copy(df[1, ["a", "b"]]) == (a=50, b=50)
        df[1:1, ["a"]] .= 1
        @test df[1, "a"] == 1
    end

    df_ref."g1" = 11:13
    @test df_ref."g1" == 11:13
    df_ref[!, "g2"] = 11:13
    @test df_ref."g2" == 11:13
    df_ref[:, "g3"] = 11:13
    @test df_ref."g3" == 11:13

    for dfr in (df_ref[1, [2, 1]], df_ref[1, ["b", "a"]],
               view(df_ref, 1, [2, 1]), view(df_ref, 1, ["b", "a"]))
        @test dfr["a"] == dfr[2]
        @test dfr[["a", "b"]] == dfr[[2, 1]]
        @test view(dfr, "a") == view(dfr, 2)
        @test view(dfr, ["a", "b"]) == view(dfr, [2, 1])

        dfr["a"] = 100
        @test dfr."a" == 100
        dfr[["a", "b"]] = (a=1000, b=2000)
        @test copy(dfr) == (b=2000, a=1000)

        @test_throws MethodError dfr["a"] .= 100
        dfr[["a", "b"]] .= 50
        @test copy(dfr) == (b=50, a=50)
    end
end

@testset "setindex! for DataFrameRow" begin
    for selector in ([:y2, :y1], [4, 2])
        df = DataFrame(x=1:2, y1=3:4, z=5:6, y2=7:8)
        df[1, selector] = [100, 200]
        @test df == DataFrame(x=1:2, y1=[200, 4], z=5:6, y2=[100, 8])

        df = DataFrame(x=1:2, y1=3:4, z=5:6, y2=7:8)
        df[1, selector] .= [100, 200]
        @test df == DataFrame(x=1:2, y1=[200, 4], z=5:6, y2=[100, 8])
    end

    for selector in ([:y1, :y2], [2, 4], r"y", Not([:x, :z]))
        df = DataFrame(x=1:2, y1=3:4, z=5:6, y2=7:8)
        df[1, selector] = [200, 100]
        @test df == DataFrame(x=1:2, y1=[200, 4], z=5:6, y2=[100, 8])

        df = DataFrame(x=1:2, y1=3:4, z=5:6, y2=7:8)
        df[1, selector] .= [200, 100]
        @test df == DataFrame(x=1:2, y1=[200, 4], z=5:6, y2=[100, 8])
    end
end

@testset "setindex! for ncols(df)+1 and old tests" begin
    df = DataFrame()
    @test_throws ArgumentError df[:, 1] = 1:3

    df = DataFrame(a=1:3)
    @test_throws DimensionMismatch df[1:2, 1] = 1:3
    @test_throws ArgumentError df[1:2, 1:1] = DataFrame(b=1:2)
end

include("indexing_begin_tests.jl")

@testset "unsupported df[col] and df[col] for getindex, view, and setindex!" begin
    @testset "getindex DataFrame" begin
        df = DataFrame(a=1:3, b=4:6, c=7:9)
        @test_throws ArgumentError df[1]
        @test_throws MethodError df[end]
        @test_throws MethodError df[1:2]
        @test_throws MethodError df[r"[ab]"]
        @test_throws MethodError df[Not(3)]
        @test_throws MethodError df[:]
        @test_throws ArgumentError df[:a]
        @test_throws ArgumentError df["a"]
    end
    @testset "view DataFrame" begin
        df = DataFrame(a=1:3, b=4:6, c=7:9)
        @test_throws MethodError view(df, 1)
        @test_throws MethodError view(df, :a)
        @test_throws MethodError view(df, "a")
        @test_throws MethodError view(df, 1:2)
        @test_throws MethodError view(df, r"[ab]")
        @test_throws MethodError view(df, Not(Not(r"[ab]")))
        @test_throws MethodError view(df, :)
    end
    @testset "getindex SubDataFrame" begin
        df = DataFrame(x=-1:3, a=0:4, b=3:7, c=6:10, d=9:13)
        sdf = view(df, 2:4, 2:4)
        @test_throws ArgumentError sdf[1]
        @test_throws MethodError sdf[end]
        @test_throws ArgumentError sdf[:x]
        @test_throws ArgumentError sdf["x"]
        @test_throws MethodError sdf[1:2]
        @test_throws MethodError sdf[r"[ab]"]
        @test_throws MethodError sdf[Not(Not(r"[ab]"))]
        @test_throws MethodError sdf[:]
    end
    @testset "view SubDataFrame" begin
        df = DataFrame(x=-1:3, a=0:4, b=3:7, c=6:10, d=9:13)
        sdf = view(df, 2:4, 2:4)
        @test_throws MethodError view(sdf, 1)
        @test_throws MethodError view(sdf, :a)
        @test_throws MethodError view(sdf, "a")
        @test_throws MethodError view(sdf, 1:2)
        @test_throws MethodError view(sdf, r"[ab]")
        @test_throws MethodError view(sdf, Not(Not(r"[ab]")))
        @test_throws MethodError view(sdf, :)
    end

    @testset "old setindex! tests" begin
        df = DataFrame(reshape(1:12, 4, :), :auto)
        @test_throws MethodError df[1, :] = df[1:1, :]

        df = DataFrame(reshape(1:12, 4, :), :auto)

        # Scalar broadcasting assignment of rows
        @test_throws MethodError df[1:2, :] = 1
        @test_throws MethodError df[[true, false, false, true], :] = 3

        # Vector broadcasting assignment of rows
        @test_throws MethodError df[1:2, :] = [2, 3]
        @test_throws MethodError df[[true, false, false, true], :] = [2, 3]

        # Broadcasting assignment of columns
        @test_throws MethodError df[:, 1] = 1
        @test_throws ArgumentError df[:x3] = 2

        # assignment of subtables
        @test_throws MethodError df[1, 1:2] = df[2:2, 2:3]
        @test_throws ArgumentError df[[true, false, false, true], 2:3] = df[1:2, 1:2]

        # this is a different case - column names do not match
        @test_throws ArgumentError df[1:2, 1:2] = df[2:3, 2:3]

        # scalar broadcasting assignment of subtables
        @test_throws MethodError df[1:2, 1:2] = 3
        @test_throws MethodError df[[true, false, false, true], 2:3] = 3

        # vector broadcasting assignment of subtables
        @test_throws MethodError df[1:2, 1:2] = [3, 2]
        @test_throws MethodError df[[true, false, false, true], 2:3] = [2, 3]

        # test of 1-row DataFrame assignment
        df = DataFrame([1 2 3], :auto)
        @test_throws MethodError df[1, 2:3] = DataFrame([11 12], :auto)
        @test_throws MethodError df[1, [false, true, true]] = DataFrame([11 12], :auto)
    end

    @testset "cornercase of view indexing" begin
        df = DataFrame(reshape(1:12, 4, :), :auto)
        dfr = df[1, 3:2]
        for idx in [:x1, :x2, :x3, :x4]
            @test_throws ArgumentError dfr[idx]
        end

        sdf = @view df[1:1, 3:2]
        for idx in [:x1, :x2, :x3, :x4]
            @test_throws ArgumentError sdf[1, idx]
        end
    end
end

@testset "setproperty! corner cases" begin
    df = DataFrame(a=1)
    @test_throws ArgumentError df.a = 1
    @test_throws ArgumentError df."a" = 1
    dfv = @view df[:, :]
    dfv.a = [5]
    @test df == DataFrame(a=5)
    @test eltype(df.a) === Int
    dfv."a" = [6]
    @test df == DataFrame(a=6)
    @test eltype(df.a) === Int
    @test_throws ArgumentError dfv.a = 1
    @test_throws ArgumentError dfv."a" = 1
end

@testset "disallowed getindex and setindex! methods" begin
    df = DataFrame(a=1)
    @test_throws ArgumentError df[:a]
    @test_throws ArgumentError df[:a] = [2]
    @test_throws ArgumentError df["a"]
    @test_throws ArgumentError df["a"] = [2]
    @test_throws ArgumentError df[1]
    @test_throws ArgumentError df[1] = [2]
end

@testset "array interface tests for all types" begin
    df = DataFrame(reshape(1:12, 3, 4), :auto)
    @test_throws MethodError length(df)
    @test ndims(df) == ndims(typeof(df)) == 2
    @test size(df) == (3, 4)
    @test size(df, 1) == 3
    @test size(df, 2) == 4
    @test_throws ArgumentError size(df, 3)
    @test_throws ArgumentError size(df, 0)
    @test axes(df) == (1:3, 1:4)
    @test axes(df, 1) == 1:3
    @test axes(df, 2) == 1:4
    @test_throws ArgumentError axes(df, 3)
    @test_throws ArgumentError axes(df, 0)
    @test_throws MethodError firstindex(df)
    @test firstindex(df, 1) == 1
    @test firstindex(df, 2) == 1
    @test_throws ArgumentError firstindex(df, 3)
    @test_throws ArgumentError firstindex(df, 0)
    @test_throws MethodError lastindex(df)
    @test lastindex(df, 1) == 3
    @test lastindex(df, 2) == 4
    @test_throws ArgumentError lastindex(df, 3)
    @test_throws ArgumentError lastindex(df, 0)

    dfr = df[1, 1:3]
    @test length(dfr) == 3
    @test ndims(dfr) == ndims(typeof(dfr)) == 1
    @test size(dfr) == (3,)
    @test size(dfr, 1) == 3
    @test_throws BoundsError size(dfr, 2)
    @test_throws BoundsError size(dfr, 0)
    @test axes(dfr) == (1:3,)
    @test axes(dfr, 1) == 1:3
    @test_throws BoundsError axes(dfr, 2)
    @test_throws BoundsError axes(dfr, 0)
    @test firstindex(dfr) == 1
    @test firstindex(dfr, 1) == 1
    @test_throws BoundsError firstindex(dfr, 2)
    @test_throws BoundsError firstindex(dfr, 0)
    @test lastindex(dfr) == 3
    @test lastindex(dfr, 1) == 3
    @test_throws BoundsError lastindex(dfr, 2)
    @test_throws BoundsError lastindex(dfr, 0)

    er = eachrow(df)
    @test length(er) == 3
    @test ndims(er) == ndims(typeof(er)) == 1
    @test size(er) == (3,)
    @test size(er, 1) == 3
    @test size(er, 2) == 1
    @test_throws BoundsError size(er, 0)
    @test axes(er) == (1:3,)
    @test axes(er, 1) == 1:3
    @test axes(er, 2) == 1:1
    @test_throws BoundsError axes(er, 0)
    @test firstindex(er) == 1
    @test firstindex(er, 1) == 1
    @test firstindex(er, 2) == 1
    @test_throws BoundsError firstindex(er, 0)
    @test lastindex(er) == 3
    @test lastindex(er, 1) == 3
    @test lastindex(er, 2) == 1
    @test_throws BoundsError lastindex(er, 0)

    ec = eachcol(df)
    @test length(ec) == 4
    @test ndims(ec) == ndims(typeof(ec)) == 1
    @test size(ec) == (4,)
    @test size(ec, 1) == 4
    @test_throws ArgumentError size(ec, 2)
    @test_throws ArgumentError size(ec, 0)
    @test axes(ec) == (1:4,)
    @test axes(ec, 1) == 1:4
    @test_throws ArgumentError axes(ec, 2)
    @test_throws ArgumentError axes(ec, 0)
    @test firstindex(ec) == 1
    @test firstindex(ec, 1) == 1
    @test_throws ArgumentError firstindex(ec, 2)
    @test_throws ArgumentError firstindex(ec, 0)
    @test lastindex(ec) == 4
    @test lastindex(ec, 1) == 4
    @test_throws ArgumentError lastindex(ec, 2)
    @test_throws ArgumentError lastindex(ec, 0)

    gdf = groupby(df, [:x1, :x2, :x3])
    @test length(gdf) == 3
    @test ndims(gdf) == ndims(typeof(gdf)) == 1
    @test size(gdf) == (3,)
    @test size(gdf, 1) == 3
    @test_throws BoundsError size(gdf, 2)
    @test_throws BoundsError size(gdf, 0)
    @test axes(gdf) == (1:3,)
    @test axes(gdf, 1) == 1:3
    @test_throws BoundsError axes(gdf, 2)
    @test_throws BoundsError axes(gdf, 0)
    @test firstindex(gdf) == 1
    @test firstindex(gdf, 1) == 1
    @test_throws BoundsError firstindex(gdf, 2)
    @test_throws BoundsError firstindex(gdf, 0)
    @test lastindex(gdf) == 3
    @test lastindex(gdf, 1) == 3
    @test_throws BoundsError lastindex(gdf, 2)
    @test_throws BoundsError lastindex(gdf, 0)

    kgdf = keys(gdf)
    @test length(kgdf) == 3
    @test ndims(kgdf) == ndims(typeof(kgdf)) == 1
    @test size(kgdf) == (3,)
    @test size(kgdf, 1) == 3
    @test size(kgdf, 2) == 1
    @test_throws BoundsError size(kgdf, 0)
    @test axes(kgdf) == (1:3,)
    @test axes(kgdf, 1) == 1:3
    @test axes(kgdf, 2) == 1:1
    @test_throws BoundsError axes(kgdf, 0)
    @test firstindex(kgdf) == 1
    @test firstindex(kgdf, 1) == 1
    @test firstindex(kgdf, 2) == 1
    @test_throws BoundsError firstindex(kgdf, 0)
    @test lastindex(kgdf) == 3
    @test lastindex(kgdf, 1) == 3
    @test lastindex(kgdf, 2) == 1
    @test_throws BoundsError lastindex(kgdf, 0)

    gk = kgdf[1]
    @test length(gk) == 3
    @test ndims(gk) == ndims(typeof(gk)) == 1
    @test size(gk) == (3,)
    @test size(gk, 1) == 3
    @test_throws BoundsError size(gk, 2)
    @test_throws BoundsError size(gk, 0)
    @test axes(gk) == (1:3,)
    @test axes(gk, 1) == 1:3
    @test_throws BoundsError axes(gk, 2)
    @test_throws BoundsError axes(gk, 0)
    @test firstindex(gk) == 1
    @test firstindex(gk, 1) == 1
    @test_throws BoundsError firstindex(gk, 2)
    @test_throws BoundsError firstindex(gk, 0)
    @test lastindex(gk) == 3
    @test lastindex(gk, 1) == 3
    @test_throws BoundsError lastindex(gk, 2)
    @test_throws BoundsError lastindex(gk, 0)
end

include("indexing_offset.jl")

@testset "threading correctness tests" begin
    for x in (10, 110_000), y in 1:4
        vecvec = [rand(Int8, x) for _ in 1:y]
        df = DataFrame(vecvec, :auto, copycols=false)
        for rowrange in [:, 1:nrow(df)-5, collect(1:nrow(df)-5), axes(df, 1) .< nrow(df)-5],
            colrange in [:, axes(df, 2), collect(axes(df, 2)), 1:ncol(df) - 1]
            df2 = df[rowrange, colrange]
            for j in axes(df2, 2)
                @test df2[!, j] == view(vecvec[j], rowrange)
            end
        end
    end
end

@testset "name normalization" begin
    Random.seed!(1234)

    for (a1, a2) in [("", ""), ("", "1"), ("1", ""),
                     ("a", "a"), ("a", "a1"), ("a1", "a"),
                     ("ab", "ab"), ("ab", "ac"), ("ab", "ab1"), ("ab1", "ab"),]
        @test DataFrames._norm_eq(a1, a2, Symbol(a1)) == (a1 == a2)
    end

    for _ in 1:100
        x = randstring(5)
        y1 = String(chop(x))
        y2 = y1 * "α"
        y3 = x * "α"

        @test DataFrames._norm_eq(x, x, :x)
        @test !DataFrames._norm_eq(x, y1, :x)
        @test !DataFrames._norm_eq(x, y2, :x)
        @test !DataFrames._norm_eq(x, y3, :x)
    end

    d1 = DataFrame("no\u00EBl" => 1)
    d2 = DataFrame("noe\u0308l" => 1)
    d3 = DataFrame("noe\u0308\u00EBl" => 1)
    @test d1[:, "no\u00EBl"] == [1]
    @test_throws ArgumentError d1[:, "noe\u0308l"]
    @test d1[:, Unicode.normalize("noe\u0308l")] == [1]
    @test_throws ArgumentError d2[:, "no\u00EBl"]
    @test rename(Unicode.normalize, d2)[:, "no\u00EBl"] == [1]
    @test d2[:, "noe\u0308l"] == [1]
    @test_throws ArgumentError d3[:, "no\u00EBe\u0308l"]
    @test rename(Unicode.normalize, d3)[:, Unicode.normalize("no\u00EBe\u0308l")] == [1]
    @test d3[:, "noe\u0308\u00EBl"] == [1]

    rename!(DataFrames.Unicode.normalize, d1)
    rename!(DataFrames.Unicode.normalize, d2)
    rename!(DataFrames.Unicode.normalize, d3)
    @test d1[:, DataFrames.Unicode.normalize("no\u00EBl")] == [1]
    @test d1[:, DataFrames.Unicode.normalize("noe\u0308l")] == [1]
    @test d2[:, DataFrames.Unicode.normalize("no\u00EBl")] == [1]
    @test d2[:, DataFrames.Unicode.normalize("noe\u0308l")] == [1]
    @test d3[:, DataFrames.Unicode.normalize("no\u00EBe\u0308l")] == [1]
    @test d3[:, DataFrames.Unicode.normalize("noe\u0308\u00EBl")] == [1]

    d = DataFrame("power_µW" => 1:3)
    @test_throws ArgumentError d.power_µW
    @test d."power_µW" == 1:3

    for (a, b) in pairs(DataFrames._julia_charmap)
        # needed for cdot
        a = Unicode.normalize(string(a))[1]
        idx = Symbol(b)
        d = DataFrame(string(a) => 1)
        @test_throws ArgumentError d[:, string(b)]
        @test d[:, string(a)] == [1]

        idx = Symbol(a)
        d = DataFrame(string(b) => 1)
        @test_throws ArgumentError d[:, string(a)]
        @test d[:, string(b)] == [1]
    end

    for a in keys(DataFrames._julia_charmap)
        d = DataFrame(string(a) => 1)
        @test d[:, string(a)] == [1]
        @test d[:, Symbol(a)] == [1]
    end

    for a in values(DataFrames._julia_charmap)
        d = DataFrame(string(a) => 1)
        @test d[:, string(a)] == [1]
        @test d[:, Symbol(a)] == [1]
    end

    d = DataFrame("\u00B7" => 1)
    a = "\u0387"
    @test_throws ArgumentError d[:, string(a)]
    d = DataFrame("\u0387" => 1)
    a = "\u00B7"
    @test_throws ArgumentError d[:, string(a)]

end

@testset "haskey method error" begin
    df = DataFrame(a=1:2, b=2:3)
    sdf = view(df, 1:1, 1:1)
    for x in [df, sdf]
        @test_throws ArgumentError haskey(DataFrames.index(x), 1.0)
        @test_throws ArgumentError haskey(DataFrames.index(x), true)
        @test_throws ArgumentError haskey(x[1, :], 1.0)
        @test_throws ArgumentError haskey(x[1, :], true)
        gdf = groupby(df, :a)
        @test_throws ArgumentError haskey(gdf, 1.0)
        @test_throws ArgumentError haskey(gdf, true)
        key = first(keys(gdf))
        @test_throws ArgumentError haskey(key, 1.0)
        @test_throws ArgumentError haskey(key, true)
    end
end

@testset "fix #2969 (passing Pairs as selectors)" begin
    df = DataFrame(a=1:3, b=4:6)
    @test_throws ArgumentError  df[:, [:a => sum]]
    @test_throws ArgumentError  df[!, [:a => sum]]
    @test_throws ArgumentError  df[1:2, [:a => sum]]
    @test_throws ArgumentError  df[1, [:a => sum]]

    for rowsel in [:, 1:2, 1], colsel in [:, 1:2, 1:1]
        dfv = @view df[:, :]
        @test_throws ArgumentError  df[:, [:a => sum]]
        @test_throws ArgumentError  df[!, [:a => sum]]
        @test_throws ArgumentError  df[1:2, [:a => sum]]
        @test_throws ArgumentError  df[1, [:a => sum]]
    end
end

end # module

### Common preprocessing

struct OnColRow{T}
    row::Int
    cols::T
    h::Vector{UInt}

    OnColRow(row::Union{Signed,Unsigned},
             cols::NTuple{<:Any, AbstractVector}, h::Vector{UInt}) =
        new{typeof(cols)}(Int(row), cols, h)
end

struct OnCol{T,N} <: AbstractVector{OnColRow{T}}
    len::Int
    cols::T
    h::Vector{UInt}

    function OnCol(cs::AbstractVector...)
        @assert length(cs) > 1
        len = length(cs[1])
        @assert all(x -> firstindex(x) == 1, cs)
        @assert all(x -> lastindex(x) == len, cs)
        new{typeof(cs), length(cs)}(len, cs, UInt[])
    end
end

Base.IndexStyle(::Type{<:OnCol}) = Base.IndexLinear()

@inline Base.size(oc::OnCol) = (oc.len,)

@inline function Base.getindex(oc::OnCol, i::Int)
    @boundscheck checkbounds(oc, i)
    return OnColRow(i, oc.cols, oc.h)
end

# Note second argument is ignored as it is always zero in practice
@inline Base.hash(ocr1::OnColRow, ::UInt) = @inbounds ocr1.h[ocr1.row]

# Hashing one column at a time is faster since it can use SIMD
function _prehash(oc::OnCol)
    h = oc.h
    resize!(h, oc.len)
    h0 = @static Base.VERSION >= v"1.13.0-DEV" ? Base.HASH_SEED : UInt(0)
    h0 ⊻= Base.tuplehash_seed
    fill!(h, h0)
    for col in reverse(oc.cols)
        h .= hash.(col, h)
    end
end

# TODO: rewrite isequal and isless to use @generated
# or some other approach that would keep them efficient and avoid code duplication

Base.:(==)(x::OnColRow, y::OnColRow) = throw(MethodError(==, (x, y)))

@inline function Base.isequal(ocr1::OnColRow{<:NTuple{2, AbstractVector}},
                              ocr2::OnColRow{<:NTuple{2, AbstractVector}})
    r1 = ocr1.row
    c11, c12 = ocr1.cols
    r2 = ocr2.row
    c21, c22 = ocr2.cols

    return @inbounds isequal(c11[r1], c21[r2]) && isequal(c12[r1], c22[r2])
end

Base.isequal(ocr1::OnColRow{<:NTuple{N,AbstractVector}},
             ocr2::OnColRow{<:NTuple{N,AbstractVector}}) where {N} =
    isequal(ntuple(i -> @inbounds(ocr1.cols[i][ocr1.row]), N),
            ntuple(i -> @inbounds(ocr2.cols[i][ocr2.row]), N))

@inline function Base.isless(ocr1::OnColRow{<:NTuple{2, AbstractVector}},
                             ocr2::OnColRow{<:NTuple{2, AbstractVector}})
    r1 = ocr1.row
    c11, c12 = ocr1.cols
    r2 = ocr2.row
    c21, c22 = ocr2.cols

    c11r = @inbounds c11[r1]
    c12r = @inbounds c12[r1]
    c21r = @inbounds c21[r2]
    c22r = @inbounds c22[r2]

    isless(c11r, c21r) || (isequal(c11r, c21r) && isless(c12r, c22r))
end

@inline Base.isless(ocr1::OnColRow{<:NTuple{N,AbstractVector}},
                    ocr2::OnColRow{<:NTuple{N,AbstractVector}}) where {N} =
    isless(ntuple(i -> @inbounds(ocr1.cols[i][ocr1.row]), N),
           ntuple(i -> @inbounds(ocr2.cols[i][ocr2.row]), N))

prepare_on_col() = throw(ArgumentError("at least one on column required when joining"))
prepare_on_col(c::AbstractVector) = c
prepare_on_col(cs::AbstractVector...) = OnCol(cs...)

# Return if it is allowed to use refpool instead of the original array for joining.
# There are multiple conditions that must be met to allow for this.
# If it is allowed we are sure that missing can be used as a sentinel
check_mapping_allowed(short::AbstractVector, refarray_long::AbstractVector,
                      refpool_long, invrefpool_long) =
    !isempty(short) && !isnothing(refpool_long) && !isnothing(invrefpool_long) &&
        eltype(refarray_long) <: Union{Signed, Unsigned}

@noinline map_refarray(mapping::AbstractVector, refarray::AbstractVector,
                       ::Val{fi})  where {fi} =
    [@inbounds mapping[r - fi + 1] for r in refarray]

function map2refs(x::AbstractVector, invrefpool)
    x_refpool = DataAPI.refpool(x)
    if x_refpool isa AbstractVector{<:Integer} && 0 <= firstindex(x_refpool) <= 1
        # here we know that x_refpool is AbstractVector that allows integer indexing
        # and its firstindex must be an integer
        # if firstindex is not 0 or 1 then we fallback to slow path for safety reasons
        # all refpool we currently know have firstindex 0 or 1
        # if there is some very strange firstindex we might run into overflow issues
        # below use function barrier as mapping is not type stable
        mapping = [get(invrefpool, v, missing) for v in x_refpool]
        return map_refarray(mapping, DataAPI.refarray(x), Val(Int(firstindex(x_refpool))))
    else
        return [get(invrefpool, v, missing) for v in x]
    end
end

function preprocess_columns(joiner::DataFrameJoiner)
    right_len = length(joiner.dfr_on[!, 1])
    left_len = length(joiner.dfl_on[!, 1])
    right_shorter = right_len < left_len

    left_cols = collect(eachcol(joiner.dfl_on))
    right_cols = collect(eachcol(joiner.dfr_on))

    # if column of the longer table supports DataAPI.refpool and DataAPI.invrefpool
    # remap matching left and right columns to use refs
    if right_shorter
        for i in eachindex(left_cols, right_cols)
            rc = right_cols[i]
            lc = left_cols[i]

            lc_refs = DataAPI.refarray(lc)
            lc_refpool = DataAPI.refpool(lc)
            lc_invrefpool = DataAPI.invrefpool(lc)
            if check_mapping_allowed(rc, lc_refs, lc_refpool, lc_invrefpool)
                right_cols[i] = map2refs(rc, lc_invrefpool)
                left_cols[i] = lc_refs
            end
        end
    else
        for i in eachindex(left_cols, right_cols)
            rc = right_cols[i]
            lc = left_cols[i]

            rc_refs = DataAPI.refarray(rc)
            rc_refpool = DataAPI.refpool(rc)
            rc_invrefpool = DataAPI.invrefpool(rc)
            if check_mapping_allowed(lc, rc_refs, rc_refpool, rc_invrefpool)
                right_cols[i] = rc_refs
                left_cols[i] = map2refs(lc, rc_invrefpool)
            end
        end
    end

    disallow_sorted = false

    for (lc, rc) in zip(left_cols, right_cols)
        @assert length(lc) == left_len
        @assert length(rc) == right_len
        lc_et = nonmissingtype(eltype(lc))
        rc_et = nonmissingtype(eltype(rc))

        # special case common safe scenarios when eltype between left and right
        # column can be different or non-concrete
        lc_et <: Real && rc_et <: Real && continue
        lc_et <: AbstractString && rc_et <: AbstractString && continue

        # otherwise we require non-missing eltype of both sides to be the same and concrete
        lc_et === rc_et && isconcretetype(lc_et) && continue

        # we disallow using sorted branch for some columns that theoretically
        # could be safely sorted (e.g. having Any eltype but holding strings)
        # for safety reasons assuming that such cases will be rare in practice
        disallow_sorted = true
    end

    # TODO:
    # If DataAPI.invrefpool vectors are found in the "on" columns
    # then potentially the following optimizations can be done:
    # 1. identify rows in shorter table that should be dropped
    # 2. develop custom _innerjoin_sorted and _innerjoin_unsorted that drop rows
    #    from shorter table that do not match rows from longer table based on
    #    PooledArray refpool check
    # This optimization would significantly complicate the code (especially
    # sorted path). It should be added if in practice we find that the use case
    # is often enough and that the benefits are significant. The two cases when
    # the benefits should be expected are:
    # 1. Shorter table is sorted when we drop rows not matching longer table rows
    # 2. Shorter table does not have duplicates when we drop rows not matching
    #    longer table rows

    left_col = prepare_on_col(left_cols...)
    right_col = prepare_on_col(right_cols...)

    return left_col, right_col, right_shorter, disallow_sorted
end

### innerjoin logic

@inline function find_next_range(x::AbstractArray, start::Int, start_value)
    stop_value = start_value
    n = length(x)
    stop = start + 1
    while stop <= n
        @inbounds stop_value = x[stop]
        isequal(start_value, stop_value) || break
        stop += 1
    end
    return stop, stop_value
end

function _innerjoin_sorted(left::AbstractArray, right::AbstractArray)
    left_n = length(left)
    right_n = length(right)

    left_ixs = Int[]
    right_ixs = Int[]

    (left_n == 0 || right_n == 0) && return left_ixs, right_ixs

    # lower bound assuming we get matches
    sizehint!(left_ixs, min(left_n, right_n))
    sizehint!(right_ixs, min(left_n, right_n))

    left_cur = 1
    left_val = left[left_cur]
    left_new, left_tmp = find_next_range(left, left_cur, left_val)

    right_cur = 1
    right_val = right[right_cur]
    right_new, right_tmp = find_next_range(right, right_cur, right_val)

    while left_cur <= left_n && right_cur <= right_n
        if isequal(left_val, right_val)
            if left_new - left_cur == right_new - right_cur == 1
                push!(left_ixs, left_cur)
                push!(right_ixs, right_cur)
            else
                idx = length(left_ixs)
                left_range = left_cur:left_new - 1
                right_range = right_cur:right_new - 1
                to_grow = Base.checked_add(idx, Base.checked_mul(length(left_range),
                                                                 length(right_range)))
                resize!(left_ixs, to_grow)
                resize!(right_ixs, to_grow)
                @inbounds for right_i in right_range, left_i in left_range
                    idx += 1
                    left_ixs[idx] = left_i
                    right_ixs[idx] = right_i
                end
            end
            left_cur, left_val = left_new, left_tmp
            left_new, left_tmp = find_next_range(left, left_cur, left_val)
            right_cur, right_val = right_new, right_tmp
            right_new, right_tmp = find_next_range(right, right_cur, right_val)
        elseif isless(left_val, right_val)
            left_cur, left_val = left_new, left_tmp
            left_new, left_tmp = find_next_range(left, left_cur, left_val)
        else
            right_cur, right_val = right_new, right_tmp
            right_new, right_tmp = find_next_range(right, right_cur, right_val)
        end
    end

    return left_ixs, right_ixs
end

# optimistically assume that shorter table does not have duplicates in on column
# if this is not the case we call _innerjoin_dup
# which efficiently uses the work already done and continues with the more
# memory expensive algorithm that allows for duplicates
function _innerjoin_unsorted(left::AbstractArray, right::AbstractArray{T}) where {T}
    dict = Dict{T, Int}()

    right_len = length(right)
    # we make sure that:
    # * we do not preallocate dict of size larger than half of size of Int
    #   (this is relevant in 32 bit architectures)
    # * dict has at least 2x more slots than the number of values we
    #   might store in it to avoid reallocations of internal structures when
    #   we populate it later and to minimize the number of hash collisions;
    #   typically Dict allows for 16 probes;
    #   the value of multiplier is heuristic was determined by empirical tests
    sizehint!(dict, 2 * min(right_len, typemax(Int) >> 2))

    right isa OnCol && _prehash(right)
    left isa OnCol && _prehash(left)

    for (idx_r, val_r) in enumerate(right)
        haskey(dict, val_r) && return _innerjoin_dup(left, right, dict, idx_r)
        dict[val_r] = idx_r
    end

    left_ixs = Int[]
    right_ixs = Int[]

    # lower bound assuming we get matches
    sizehint!(left_ixs, right_len)
    sizehint!(right_ixs, right_len)

    for (idx_l, val_l) in enumerate(left)
        # we know that dict contains only positive values
        idx_r = get(dict, val_l, -1)
        if idx_r != -1
            push!(left_ixs, idx_l)
            push!(right_ixs, idx_r)
        end
    end
    return left_ixs, right_ixs
end

extrema_missing(x::AbstractVector{Missing}) = (1, 0)

function extrema_missing(x::AbstractVector{T}) where {T<:Union{Integer, Missing}}
    try
        return extrema(skipmissing(x))
    catch
        S = nonmissingtype(T)
        return S(1), S(0)
    end
end

function _innerjoin_unsorted_int(left::AbstractVector{<:Union{Integer, Missing}},
                                 right::AbstractVector{<:Union{Integer, Missing}})
    minv, maxv = extrema_missing(right)

    val_range = BigInt(maxv) - BigInt(minv)
    if val_range > typemax(Int) - 3 || val_range ÷ 2 > max(64, length(right)) ||
       minv < typemin(Int) + 2 || maxv > typemax(Int) - 3
       return _innerjoin_unsorted(left, right)
    end

    offset = 1 - Int(minv) # we are now sure it does not overflow
    len = Int(maxv) - Int(minv) + 2
    group_map = zeros(Int, len)

    @inbounds for (idx_r, val_r) in enumerate(right)
        i = val_r === missing ? length(group_map) : Int(val_r) + offset
        if group_map[i] > 0
            return _innerjoin_dup_int(left, right, group_map, idx_r, offset,
                                      Int(minv), Int(maxv))
        end
        group_map[i] = idx_r
    end

    left_ixs = Int[]
    right_ixs = Int[]

    right_len = length(right)
    sizehint!(left_ixs, right_len)
    sizehint!(right_ixs, right_len)

    @inbounds for (idx_l, val_l) in enumerate(left)
        if val_l === missing
            idx_r = group_map[end]
            if idx_r > 0
                push!(left_ixs, idx_l)
                push!(right_ixs, idx_r)
            end
        elseif minv <= val_l <= maxv
            idx_r = group_map[Int(val_l) + offset]
            if idx_r > 0
                push!(left_ixs, idx_l)
                push!(right_ixs, idx_r)
            end
        end
    end
    return left_ixs, right_ixs
end

# we fall back to general case if we have duplicates
# normally it should happen fast as we reuse work already done
function _innerjoin_dup(left::AbstractArray, right::AbstractArray{T},
                        dict::Dict{T, Int}, idx_r_start::Int) where {T}
    ngroups = idx_r_start - 1
    right_len = length(right)
    groups = Vector{Int}(undef, right_len)
    groups[1:ngroups] = 1:ngroups

    @inbounds for idx_r in idx_r_start:right_len
        val_r = right[idx_r]
        # we know that group ids are positive
        group_id = get(dict, val_r, -1)
        if group_id == -1
            ngroups += 1
            groups[idx_r] = ngroups
            dict[val_r] = ngroups
        else
            groups[idx_r] = group_id
        end
    end

    @assert ngroups > 0 # we should not get here with 0-length right
    return _innerjoin_postprocess(left, dict, groups, ngroups, right_len)
end

function _innerjoin_dup_int(left::AbstractVector{<:Union{Integer, Missing}},
                            right::AbstractVector{<:Union{Integer, Missing}},
                            group_map::Vector{Int}, idx_r_start::Int, offset::Int,
                            minv::Int, maxv::Int)
    ngroups = idx_r_start - 1
    right_len = length(right)
    groups = Vector{Int}(undef, right_len)
    groups[1:ngroups] = 1:ngroups

    @inbounds for idx_r in idx_r_start:right_len
        val_r = right[idx_r]
        i = val_r === missing ? length(group_map) : Int(val_r) + offset
        group_map_val = group_map[i]
        if group_map_val > 0
            groups[idx_r] = group_map_val
        else
            ngroups += 1
            groups[idx_r] = ngroups
            group_map[i] = ngroups
        end
    end

    @assert ngroups > 0 # we should not get here with 0-length right
    return _innerjoin_postprocess_int(left, group_map, groups, ngroups, right_len,
                                      offset, minv, maxv)
end

function compute_join_indices!(groups::Vector{Int},
                               starts::Vector, rperm::Vector)
    @inbounds for gix in groups
        starts[gix] += 1
    end

    cumsum!(starts, starts)

    @inbounds for (i, gix) in enumerate(groups)
        rperm[starts[gix]] = i
        starts[gix] -= 1
    end
    push!(starts, length(groups))
    return nothing
end

function _innerjoin_postprocess(left::AbstractArray, dict::Dict{T, Int},
                                groups::Vector{Int}, ngroups::Int,
                                right_len::Int) where {T}
    starts = zeros(Int, ngroups)
    rperm = Vector{Int}(undef, right_len)

    left_ixs = Int[]
    right_ixs = Int[]

    # lower bound assuming we get matches
    sizehint!(left_ixs, right_len)
    sizehint!(right_ixs, right_len)

    compute_join_indices!(groups, starts, rperm)

    n = 0
    @inbounds for (idx_l, val_l) in enumerate(left)
        group_id = get(dict, val_l, -1)
        if group_id != -1
            ref_stop = starts[group_id + 1]
            l = ref_stop - starts[group_id]
            newn = n + l
            resize!(left_ixs, newn)
            for i in n+1:n+l
                left_ixs[i] = idx_l
            end
            resize!(right_ixs, newn)
            for i in 1:l
                right_ixs[n + i] = rperm[ref_stop - i + 1]
            end
            n = newn
        end
    end

    return left_ixs, right_ixs
end

function _innerjoin_postprocess_int(left::AbstractVector{<:Union{Integer, Missing}},
                                    group_map::Vector{Int},
                                    groups::Vector{Int}, ngroups::Int, right_len::Int,
                                    offset::Int, minv::Int, maxv::Int)
    starts = zeros(Int, ngroups)
    rperm = Vector{Int}(undef, right_len)

    left_ixs = Int[]
    right_ixs = Int[]

    sizehint!(left_ixs, right_len)
    sizehint!(right_ixs, right_len)

    compute_join_indices!(groups, starts, rperm)

    n = 0
    @inbounds for (idx_l, val_l) in enumerate(left)
        if val_l === missing
            group_id = group_map[end]
        elseif minv <= val_l <= maxv
            group_id = group_map[Int(val_l) + offset]
        else
            group_id = 0
        end

        if group_id > 0
            ref_stop = starts[group_id + 1]
            l = ref_stop - starts[group_id]
            newn = n + l
            resize!(left_ixs, newn)
            for i in n+1:n+l
                left_ixs[i] = idx_l
            end
            resize!(right_ixs, newn)
            for i in 1:l
                right_ixs[n + i] = rperm[ref_stop - i + 1]
            end
            n = newn
        end
    end

    return left_ixs, right_ixs
end

function find_inner_rows(joiner::DataFrameJoiner)

    left_col, right_col, right_shorter, disallow_sorted = preprocess_columns(joiner)

    # we treat this case separately so we know we have at least one element later
    (isempty(left_col) || isempty(right_col)) && return Int[], Int[]

    # if sorting is not disallowed try using a fast algorithm that works
    # on sorted columns; if it is not run or errors fall back to the unsorted case
    # the try-catch is used to handle the case when columns on which we join
    # contain values that are not comparable
    if !disallow_sorted
        try
            if issorted(left_col) && issorted(right_col)
                return _innerjoin_sorted(left_col, right_col)
            end
        catch
            # nothing to do - one of the columns is not sortable
        end
    end

    if right_shorter
        if left_col isa AbstractVector{<:Union{Integer, Missing}} &&
           right_col isa AbstractVector{<:Union{Integer, Missing}}
            return _innerjoin_unsorted_int(left_col, right_col)
        else
            return _innerjoin_unsorted(left_col, right_col)
        end
    else
        if left_col isa AbstractVector{<:Union{Integer, Missing}} &&
           right_col isa AbstractVector{<:Union{Integer, Missing}}
            return reverse(_innerjoin_unsorted_int(right_col, left_col))
        else
            return reverse(_innerjoin_unsorted(right_col, left_col))
        end
    end

    error("unreachable reached")
end

### semijoin logic

function _semijoin_sorted(left::AbstractArray, right::AbstractArray,
                          seen_rows::AbstractVector{Bool})
    left_n = length(left)
    right_n = length(right)

    @assert left_n > 0 && right_n > 0

    left_cur = 1
    left_val = left[left_cur]
    left_new, left_tmp = find_next_range(left, left_cur, left_val)

    right_cur = 1
    right_val = right[right_cur]
    right_new, right_tmp = find_next_range(right, right_cur, right_val)

    while left_cur <= left_n && right_cur <= right_n
        if isequal(left_val, right_val)
            seen_rows[left_cur:left_new - 1] .= true
            left_cur, left_val = left_new, left_tmp
            left_new, left_tmp = find_next_range(left, left_cur, left_val)
            right_cur, right_val = right_new, right_tmp
            right_new, right_tmp = find_next_range(right, right_cur, right_val)
        elseif isless(left_val, right_val)
            left_cur, left_val = left_new, left_tmp
            left_new, left_tmp = find_next_range(left, left_cur, left_val)
        else
            right_cur, right_val = right_new, right_tmp
            right_new, right_tmp = find_next_range(right, right_cur, right_val)
        end
    end

    return seen_rows
end

# optimistically assume that shorter table does not have duplicates in on column
# if this is not the case we call _semijoin_dup
# which efficiently uses the work already done and continues with the more
# memory expensive algorithm that allows for duplicates
# note that in semijoin and antijoin we do not have to do it if right table is
# shorter as then we process left table row by row anyway
function _semijoin_unsorted(left::AbstractArray, right::AbstractArray{T},
                            seen_rows::AbstractVector{Bool},
                            right_shorter::Bool) where {T}
    right_len = length(right)
    right isa OnCol && _prehash(right)
    left isa OnCol && _prehash(left)

    if right_shorter
        @assert length(left) == length(seen_rows)
        set = Set{T}()
        sizehint!(set, 2 * min(right_len, typemax(Int) >> 2))
        for val_r in right
            push!(set, val_r)
        end
        @inbounds for (idx_l, val_l) in enumerate(left)
            seen_rows[idx_l] = val_l in set
        end
    else
        @assert length(right) == length(seen_rows)
        dict = Dict{T, Int}()
        sizehint!(dict, 2 * min(right_len, typemax(Int) >> 2))
        for (idx_r, val_r) in enumerate(right)
            haskey(dict, val_r) && return _semijoin_dup(left, right, dict, idx_r,
                                                        seen_rows)
            dict[val_r] = idx_r
        end
        @inbounds for (idx_l, val_l) in enumerate(left)
            # we know that dict contains only positive values
            idx_r = get(dict, val_l, -1)
            if idx_r != -1
                seen_rows[idx_r] = true
            end
        end
    end

    return seen_rows
end

function _semijoin_unsorted_int(left::AbstractVector{<:Union{Integer, Missing}},
                                right::AbstractVector{<:Union{Integer, Missing}},
                                seen_rows::AbstractVector{Bool},
                                right_shorter::Bool)
    minv, maxv = extrema_missing(right)

    val_range = BigInt(maxv) - BigInt(minv)
    if val_range > typemax(Int) - 3 || val_range ÷ 2 > max(64, length(right)) ||
       minv < typemin(Int) + 2 || maxv > typemax(Int) - 3
       return _semijoin_unsorted(left, right, seen_rows, right_shorter)
    end

    offset = 1 - Int(minv) # we are now sure it does not overflow
    len = Int(maxv) - Int(minv) + 2
    group_map = zeros(Int, len)

    if right_shorter
        @inbounds for (idx_r, val_r) in enumerate(right)
            i = val_r === missing ? length(group_map) : Int(val_r) + offset
            group_map[i] = idx_r
        end
        @inbounds for (idx_l, val_l) in enumerate(left)
            if val_l === missing
                idx_r = group_map[end]
                seen_rows[idx_l] = idx_r > 0
            elseif minv <= val_l <= maxv
                idx_r = group_map[Int(val_l) + offset]
                seen_rows[idx_l] = idx_r > 0
            end
        end
    else
        @inbounds for (idx_r, val_r) in enumerate(right)
            i = val_r === missing ? length(group_map) : Int(val_r) + offset
            if group_map[i] > 0
                return _semijoin_dup_int(left, right, group_map, idx_r, offset,
                                         Int(minv), Int(maxv), seen_rows)
            end
            group_map[i] = idx_r
        end
        @inbounds for (idx_l, val_l) in enumerate(left)
            if val_l === missing
                idx_r = group_map[end]
                if idx_r > 0
                    seen_rows[idx_r] = true
                end
            elseif minv <= val_l <= maxv
                idx_r = group_map[Int(val_l) + offset]
                if idx_r > 0
                    seen_rows[idx_r] = true
                end
            end
        end
    end

    return seen_rows
end

# we fall back to general case if we have duplicates
# normally it should happen fast as we reuse work already done
function _semijoin_dup(left::AbstractArray, right::AbstractArray{T},
                       dict::Dict{T, Int}, idx_r_start::Int,
                       seen_rows::AbstractVector{Bool}) where {T}
    ngroups = idx_r_start - 1
    right_len = length(right)
    groups = Vector{Int}(undef, right_len)
    groups[1:ngroups] = 1:ngroups

    @inbounds for idx_r in idx_r_start:right_len
        val_r = right[idx_r]
        # we know that group ids are positive
        group_id = get(dict, val_r, -1)
        if group_id == -1
            ngroups += 1
            groups[idx_r] = ngroups
            dict[val_r] = ngroups
        else
            groups[idx_r] = group_id
        end
    end

    @assert ngroups > 0 # we should not get here with 0-length right
    @assert length(right) == length(seen_rows)
    return _semijoin_postprocess(left, dict, groups, ngroups, right_len,
                                 seen_rows)
end

function _semijoin_dup_int(left::AbstractVector{<:Union{Integer, Missing}},
                           right::AbstractVector{<:Union{Integer, Missing}},
                           group_map::Vector{Int}, idx_r_start::Int, offset::Int,
                           minv::Int, maxv::Int, seen_rows::AbstractVector{Bool})
    ngroups = idx_r_start - 1
    right_len = length(right)
    groups = Vector{Int}(undef, right_len)
    groups[1:ngroups] = 1:ngroups

    @inbounds for idx_r in idx_r_start:right_len
        val_r = right[idx_r]
        i = val_r === missing ? length(group_map) : Int(val_r) + offset
        group_map_val = group_map[i]
        if group_map_val > 0
            groups[idx_r] = group_map_val
        else
            ngroups += 1
            groups[idx_r] = ngroups
            group_map[i] = ngroups
        end
    end

    @assert ngroups > 0 # we should not get here with 0-length right
    @assert length(right) == length(seen_rows)
    return _semijoin_postprocess_int(left, group_map, groups, ngroups, right_len,
                                     offset, minv, maxv, seen_rows)
end

function _semijoin_postprocess(left::AbstractArray, dict::Dict{T, Int},
                               groups::Vector{Int}, ngroups::Int, right_len::Int,
                               seen_rows::AbstractVector{Bool}) where {T}
    starts = zeros(Int, ngroups)
    rperm = Vector{Int}(undef, right_len)

    compute_join_indices!(groups, starts, rperm)

    @inbounds for (idx_l, val_l) in enumerate(left)
        group_id = get(dict, val_l, -1)
        if group_id != -1
            ref_stop = starts[group_id + 1]
            l = ref_stop - starts[group_id]
            for i in 1:l
                seen_rows[rperm[ref_stop - i + 1]] = true
            end
        end
    end

    return seen_rows
end

function _semijoin_postprocess_int(left::AbstractVector{<:Union{Integer, Missing}},
                                   group_map::Vector{Int},
                                   groups::Vector{Int}, ngroups::Int, right_len::Int,
                                   offset::Int, minv::Int, maxv::Int,
                                   seen_rows::AbstractVector{Bool})
    starts = zeros(Int, ngroups)
    rperm = Vector{Int}(undef, right_len)

    compute_join_indices!(groups, starts, rperm)

    @inbounds for (idx_l, val_l) in enumerate(left)
        if val_l === missing
            group_id = group_map[end]
        elseif minv <= val_l <= maxv
            group_id = group_map[Int(val_l) + offset]
        else
            group_id = 0
        end

        if group_id > 0
            ref_stop = starts[group_id + 1]
            l = ref_stop - starts[group_id]
            for i in 1:l
                seen_rows[rperm[ref_stop - i + 1]] = true
            end
        end
    end

    return seen_rows
end

function find_semi_rows(joiner::DataFrameJoiner)
    left_col, right_col, right_shorter, disallow_sorted = preprocess_columns(joiner)

    seen_rows = falses(length(left_col))

    # we treat this case separately so we know we have at least one element later
    (isempty(left_col) || isempty(right_col)) && return falses(length(left_col))

    # if sorting is not disallowed try using a fast algorithm that works
    # on sorted columns; if it is not run or errors fall back to the unsorted case
    # the try-catch is used to handle the case when columns on which we join
    # contain values that are not comparable
    if !disallow_sorted
        try
            if issorted(left_col) && issorted(right_col)
                return _semijoin_sorted(left_col, right_col, seen_rows)
            end
        catch
            # nothing to do - one of the columns is not sortable
        end
    end

    if right_shorter
        if left_col isa AbstractVector{<:Union{Integer, Missing}} &&
           right_col isa AbstractVector{<:Union{Integer, Missing}}
            return _semijoin_unsorted_int(left_col, right_col, seen_rows, right_shorter)
        else
            return _semijoin_unsorted(left_col, right_col, seen_rows, right_shorter)
        end
    else
        if left_col isa AbstractVector{<:Union{Integer, Missing}} &&
           right_col isa AbstractVector{<:Union{Integer, Missing}}
            return _semijoin_unsorted_int(right_col, left_col, seen_rows, right_shorter)
        else
            return _semijoin_unsorted(right_col, left_col, seen_rows, right_shorter)
        end
    end
    error("unreachable reached")
end

module TestSubDataFrame

using Test, DataFrames

@testset "copy - SubDataFrame" begin
    df = DataFrame(x=1:10, y=1.0:10.0)
    sdf = view(df, 1:2, 1:1)
    @test sdf isa SubDataFrame
    @test copy(sdf) isa DataFrame
    @test sdf == copy(sdf)
    @test view(sdf, :, :) === sdf
    @test view(sdf, :, r"") == sdf
end

@testset "view -- DataFrame" begin
    df = DataFrame(x=1:10, y=1.0:10.0)
    @test view(df, 1, :) == DataFrameRow(df, 1, :)
    @test view(df, UInt(1), :) == DataFrameRow(df, 1, :)
    @test view(df, BigInt(1), :) == DataFrameRow(df, 1, :)
    @test view(df, UInt(1):UInt(1), :) == SubDataFrame(df, 1:1, :)
    @test view(df, BigInt(1):BigInt(1), :) == SubDataFrame(df, 1:1, :)
    @test view(df, 1:2, :) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), :) == first(df, 2)
    @test view(df, [1, 2], :) == first(df, 2)

    @test view(df, 1, r"") == DataFrameRow(df, 1, :)
    @test view(df, UInt(1), r"") == DataFrameRow(df, 1, :)
    @test view(df, BigInt(1), r"") == DataFrameRow(df, 1, :)
    @test view(df, UInt(1):UInt(1), r"") == SubDataFrame(df, 1:1, :)
    @test view(df, BigInt(1):BigInt(1), r"") == SubDataFrame(df, 1:1, :)
    @test view(df, 1:2, r"") == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), r"") == first(df, 2)
    @test view(df, [1, 2], r"") == first(df, 2)

    @test view(df, 1, r"") == DataFrameRow(df, 1, r"")
    @test view(df, UInt(1), r"") == DataFrameRow(df, 1, r"")
    @test view(df, BigInt(1), r"") == DataFrameRow(df, 1, r"")
    @test view(df, UInt(1):UInt(1), r"") == SubDataFrame(df, 1:1, r"")
    @test view(df, BigInt(1):BigInt(1), r"") == SubDataFrame(df, 1:1, r"")

    @test view(df, 1, :x) == view(df[!, :x], 1)
    @test view(df, 1, :x) isa SubArray
    @test size(view(df, 1, :x)) == ()
    @test view(df, 1:2, :x) == df[!, :x][1:2]
    @test view(df, 1:2, :x) isa SubArray
    @test view(df, vcat(trues(2), falses(8)), :x) == view(df[!, :x], vcat(trues(2), falses(8)))
    @test view(df, [1, 2], :x) == view(df[!, :x], [1, 2])
    @test view(df, 1, 1) == view(df[!, 1], 1)
    @test view(df, 1, 1) isa SubArray
    @test size(view(df, 1, 1)) == ()
    @test view(df, 1:2, 1) == df[!, 1][1:2]
    @test view(df, 1:2, 1) isa SubArray
    @test view(df, vcat(trues(2), falses(8)), 1) == view(df[!, 1], vcat(trues(2), falses(8)))
    @test view(df, [1, 2], 1) == view(df[!, 1], [1, 2])
    @test view(df, 1:2, 1) == df[!, 1][1:2]
    @test view(df, 1:2, 1) isa SubArray

    @test view(df, 1, [:x, :y]) == DataFrameRow(df[:, [:x, :y]], 1, :)
    @test view(df, 1, [:x, :y]) == DataFrameRow(df, 1, [:x, :y])
    @test view(df, 1:2, [:x, :y]) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), [:x, :y]) == first(df, 2)
    @test view(df, [1, 2], [:x, :y]) == first(df, 2)

    @test view(df, 1, r"[xy]") == DataFrameRow(df[:, [:x, :y]], 1, :)
    @test view(df, 1, r"[xy]") == DataFrameRow(df, 1, [:x, :y])
    @test view(df, 1:2, r"[xy]") == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), r"[xy]") == first(df, 2)
    @test view(df, [1, 2], r"[xy]") == first(df, 2)

    @test view(df, 1, [1, 2]) == DataFrameRow(df[:, 1:2], 1, :)
    @test view(df, 1, [1, 2]) == DataFrameRow(df, 1, 1:2)
    @test view(df, 1:2, [1, 2]) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), [1, 2]) == first(df, 2)
    @test view(df, [1, 2], [1, 2]) == first(df, 2)

    @test view(df, 1, trues(2)) == DataFrameRow(df[:, trues(2)], 1, :)
    @test view(df, 1, trues(2)) == DataFrameRow(df, 1, trues(2))
    @test view(df, 1:2, trues(2)) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), trues(2)) == first(df, 2)
    @test view(df, [1, 2], trues(2)) == first(df, 2)

    @test view(df, Integer[1, 2], :) == first(df, 2)
    @test view(df, UInt[1, 2], :) == first(df, 2)
    @test view(df, BigInt[1, 2], :) == first(df, 2)
    @test view(df, Union{Int, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{Integer, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{UInt, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{BigInt, Missing}[1, 2], :) == first(df, 2)

    @test view(df, :, :) == df
    @test view(df, 1, :) == DataFrameRow(df, 1, :)
    @test view(df, :, 1) == df[:, 1]
    @test view(df, :, 1) isa SubArray

    @test view(df, 1, r"") == DataFrameRow(df, 1, :)
    @test view(df, :, 1) == df[:, 1]
    @test view(df, :, 1) isa SubArray

    @test size(view(df, :, r"a")) == (0, 0)
    @test size(view(df, 1:2, r"a")) == (0, 0)
    @test size(view(df, 2, r"a")) == (0,)

    @test_throws ArgumentError view(df, :, [missing, 1])
    @test_throws ArgumentError view(df, [missing, 1], :)
    @test_throws ArgumentError view(df, [missing, 1], r"")
end

@testset "view -- SubDataFrame" begin
    df = view(DataFrame(x=1:10, y=1.0:10.0), 1:10, :)

    @test view(df, 1, :) == DataFrameRow(df, 1, :)
    @test view(df, UInt(1), :) == DataFrameRow(df, 1, :)
    @test view(df, BigInt(1), :) == DataFrameRow(df, 1, :)
    @test view(df, 1:2, :) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), :) == first(df, 2)
    @test view(df, [1, 2], :) == first(df, 2)

    @test view(df, 1, r"") == DataFrameRow(df, 1, :)
    @test view(df, UInt(1), r"") == DataFrameRow(df, 1, :)
    @test view(df, BigInt(1), r"") == DataFrameRow(df, 1, :)
    @test view(df, 1:2, r"") == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), r"") == first(df, 2)
    @test view(df, [1, 2], r"") == first(df, 2)

    @test view(df, 1, r"") == DataFrameRow(df, 1, r"")
    @test view(df, UInt(1), r"") == DataFrameRow(df, 1, r"")
    @test view(df, BigInt(1), r"") == DataFrameRow(df, 1, r"")

    @test view(df, 1, :x) == view(df[!, :x], 1)
    @test view(df, 1, 1) isa SubArray
    @test size(view(df, 1, 1)) == ()
    @test view(df, 1:2, :x) == view(df[!, :x], 1:2)
    @test view(df, vcat(trues(2), falses(8)), :x) == view(df[!, :x], vcat(trues(2), falses(8)))
    @test view(df, [1, 2], :x) == view(df[!, :x], [1, 2])

    @test view(df, 1, 1) == view(df[!, 1], 1)
    @test view(df, 1, 1) isa SubArray
    @test size(view(df, 1, 1)) == ()
    @test view(df, 1:2, 1) == view(df[!, :x], 1:2)
    @test view(df, vcat(trues(2), falses(8)), 1) == view(df[!, :x], vcat(trues(2), falses(8)))
    @test view(df, [1, 2], 1) == view(df[!, :x], [1, 2])

    @test view(df, 1, [:x, :y]) == DataFrameRow(df[:, [:x, :y]], 1, :)
    @test view(df, 1, [:x, :y]) == DataFrameRow(df, 1, [:x, :y])
    @test view(df, 1:2, [:x, :y]) == first(df, 2)

    @test view(df, 1, r"[xy]") == DataFrameRow(df[:, [:x, :y]], 1, :)
    @test view(df, 1, r"[xy]") == DataFrameRow(df, 1, [:x, :y])
    @test view(df, 1:2, r"[xy]") == first(df, 2)

    @test view(df, vcat(trues(2), falses(8)), [:x, :y]) == first(df, 2)
    @test view(df, [1, 2], [:x, :y]) == first(df, 2)
    @test view(df, 1, [1, 2]) == DataFrameRow(df[:, 1:2], 1, :)
    @test view(df, 1, [1, 2]) == DataFrameRow(df, 1, 1:2)
    @test view(df, 1:2, [1, 2]) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), [1, 2]) == first(df, 2)
    @test view(df, [1, 2], [1, 2]) == first(df, 2)
    @test view(df, 1, trues(2)) == DataFrameRow(df[:, trues(2)], 1, :)
    @test view(df, 1, trues(2)) == DataFrameRow(df, 1, trues(2))
    @test view(df, 1:2, trues(2)) == first(df, 2)
    @test view(df, vcat(trues(2), falses(8)), trues(2)) == first(df, 2)
    @test view(df, [1, 2], trues(2)) == first(df, 2)
    @test view(df, Integer[1, 2], :) == first(df, 2)
    @test view(df, UInt[1, 2], :) == first(df, 2)
    @test view(df, BigInt[1, 2], :) == first(df, 2)
    @test view(df, Union{Int, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{Integer, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{UInt, Missing}[1, 2], :) == first(df, 2)
    @test view(df, Union{BigInt, Missing}[1, 2], :) == first(df, 2)

    @test view(df, :, :) == df
    @test view(df, 1, :) == DataFrameRow(df, 1, :)
    @test view(df, :, 1) == df[:, 1]
    @test view(df, :, 1) isa SubArray

    @test view(df, :, r"") == df
    @test view(df, 1, r"") == DataFrameRow(df, 1, :)

    @test_throws ArgumentError view(df, :, [missing, 1])
    @test_throws ArgumentError view(df, [missing, 1], :)
    @test_throws ArgumentError view(df, [missing, 1], r"")
    @test_throws ArgumentError view(df, :, true)
end

@testset "getproperty, setproperty! and propertynames" begin
    x = collect(1:10)
    y = collect(1.0:10.0)
    df = view(DataFrame(:x=>x, :y=>y, copycols=false), 2:6, :)

    @test propertynames(df) == Symbol.(names(df))

    @test df.x == 2:6
    @test df.y == 2:6
    @test_throws ArgumentError df.z

    df[:, :x] = 1:5
    @test df.x == 1:5
    @test x == [1; 1:5; 7:10]
    df[:, :y] .= 1
    @test df.y == [1, 1, 1, 1, 1]
    @test y == [1; 1; 1; 1; 1; 1; 7:10]
end

@testset "index" begin
    y = 1.0:10.0
    df = view(DataFrame(y=y), 2:6, :)
    df2 = view(DataFrame(x=y, y=y), 2:6, 2:2)
    @test DataFrames.index(df) == DataFrames.index(df2)
    @test haskey(DataFrames.index(df2), :y)
    @test !haskey(DataFrames.index(df2), :x)
    @test haskey(DataFrames.index(df2), 1)
    @test !haskey(DataFrames.index(df2), 2)
    @test !haskey(DataFrames.index(df2), 0)
    @test_throws ArgumentError haskey(DataFrames.index(df2), true)
    @test names(DataFrames.index(df2)) == ["y"]
    @test DataFrames._names(DataFrames.index(df2)) == [:y]

    x = DataFrame(ones(5, 4), :auto)
    df = view(x, 2:3, 2:3)
    @test names(df) == names(x)[2:3]
    df = view(x, 2:3, [4, 2])
    @test names(df) == names(x)[[4, 2]]
end

@testset "deleteat!" begin
    y = 1.0:10.0
    df = view(DataFrame(y=y), 2:6, :)
    @test_throws ArgumentError deleteat!(df, 1)
end

@testset "parent" begin
    df = DataFrame(a=Union{Int, Missing}[1, 2, 3, 1, 2, 2],
                   b=[2.0, missing, 1.2, 2.0, missing, missing],
                   c=["A", "B", "C", "A", "B", missing])
    @test parent(view(df, [4, 2], :)) === df
    @test parent(view(df, [4, 2], r"")) === df
    @test parentindices(view(df, [4, 2], :)) == ([4, 2], Base.OneTo(3))
    @test parentindices(view(df, [4, 2], r"")) == ([4, 2], [1, 2, 3])
    @test parent(view(df, [4, 2], 1:3)) === df
    @test parentindices(view(df, [4, 2], 1:3)) == ([4, 2], Base.OneTo(3))
end

@testset "duplicate column" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)
    @test_throws ArgumentError view(df, [3, 1, 4], [3, 3, 3])
end

@testset "conversion to DataFrame" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)
    sdf = view(df, [3, 1, 4], [3, 2, 1])
    df2 = DataFrame(sdf)
    @test df2 isa DataFrame
    @test df2 == df[[3, 1, 4], [3, 2, 1]]
    @test all(x -> x isa Vector{Int}, eachcol(df2))
    df2 = convert(DataFrame, sdf)
    @test df2 isa DataFrame
    @test df2 == df[[3, 1, 4], [3, 2, 1]]
    @test all(x -> x isa Vector{Int}, eachcol(df2))

    df = DataFrame(x=1:4, y=11:14, z=21:24)
    sdf = @view df[2:3, [2]]
    df2 = DataFrame(sdf)
    @test size(df2) == (2, 1)
    @test df2.y isa Vector{Int}
    @test df2.y == [12, 13]
    df2 = DataFrame(sdf, copycols=false)
    @test size(df2) == (2, 1)
    @test df2.y isa SubArray{Int, 1, Vector{Int}, Tuple{UnitRange{Int}}, true}
    @test df2.y == [12, 13]
end

@testset "setindex! in view" begin
    df = DataFrame(A=Vector{Union{Int, Missing}}(1:4), B=Union{String, Missing}["M", "F", "F", "M"])

    s1 = view(df, 1:3, :)
    s1[2, :A] = 4
    @test df[2, :A] == 4
    @test view(s1, 1:2, :) == view(df, 1:2, :)

    s2 = view(df, 1:2:3, :)
    s2[2, :B] = "M"
    @test df[3, :B] == "M"
    @test view(s2, 1:1:2, :) == view(df, [1, 3], :)
end

@testset "SubDataFrame corner cases" begin
    df = DataFrame(a=[1, 2], b=[3, 4])
    @test_throws ArgumentError SubDataFrame(df, Integer[true], 1)
    @test_throws ArgumentError SubDataFrame(df, [true], 1)

    sdf = @view df[:, :]
    @test_throws ArgumentError SubDataFrame(sdf, true, 1)
    @test_throws ArgumentError SubDataFrame(sdf, true, :)
    @test_throws ArgumentError SubDataFrame(sdf, Integer[true], 1)
    @test_throws ArgumentError SubDataFrame(sdf, Integer[true, true, true], :)
end

@testset "disallowed use of SubDataFrame constructor" begin
    df = DataFrame(a=1)
    sdf = view(df, :, :)
    @test_throws ArgumentError SubDataFrame(sdf, DataFrames.index(sdf), [1])
end

@testset "subdataframe with no columns" begin
    df = DataFrame(a=1:3, b=4:6)
    dfv = @view df[[3, 1], 2:1]
    @test nrow(SubDataFrame(dfv, Int[], :)) == 0
    @test nrow(SubDataFrame(dfv, Bool[], :)) == 0
    @test nrow(SubDataFrame(dfv, :, :)) == 0
    @test nrow(SubDataFrame(dfv, Not(:), :)) == 0
    @test nrow(SubDataFrame(dfv, Int[], [])) == 0
    @test nrow(SubDataFrame(dfv, Bool[], [])) == 0
    @test nrow(SubDataFrame(dfv, :, [])) == 0
    @test nrow(SubDataFrame(dfv, Not(:), [])) == 0
    @test_throws BoundsError SubDataFrame(dfv, [1, 2], :)

    @test nrow(view(dfv, Int[], :)) == 0
    @test nrow(view(dfv, Bool[], :)) == 0
    @test nrow(view(dfv, :, :)) == 0
    @test nrow(view(dfv, !, :)) == 0
    @test nrow(view(dfv, Not(:), :)) == 0
    @test nrow(view(dfv, Int[], [])) == 0
    @test nrow(view(dfv, Bool[], [])) == 0
    @test nrow(view(dfv, :, [])) == 0
    @test nrow(view(dfv, !, [])) == 0
    @test nrow(view(dfv, Not(:), [])) == 0
    @test_throws BoundsError view(dfv, [1, 2], :)

    @test_throws BoundsError dfv[1, 1]
    @test_throws BoundsError dfv[[1, 2], 1]

    @test nrow(getindex(dfv, Int[], :)) == 0
    @test nrow(getindex(dfv, Bool[], :)) == 0
    @test nrow(getindex(dfv, :, :)) == 0
    @test nrow(getindex(dfv, !, :)) == 0
    @test nrow(getindex(dfv, Not(:), :)) == 0
    @test nrow(getindex(dfv, Int[], [])) == 0
    @test nrow(getindex(dfv, Bool[], [])) == 0
    @test nrow(getindex(dfv, :, [])) == 0
    @test nrow(getindex(dfv, !, [])) == 0
    @test nrow(getindex(dfv, Not(:), [])) == 0
    @test_throws BoundsError getindex(dfv, [1, 2], :)
end

end # module

module TestSelect

using DataFrames, Test, Random, SparseArrays, Statistics
using CategoricalArrays, PooledArrays
using ShiftedArrays: lag, ShiftedVector

const ≅ = isequal

isequal_coltyped(df1::AbstractDataFrame, df2::AbstractDataFrame) =
    isequal(df1, df2) && typeof.(eachcol(df1)) == typeof.(eachcol(df2))

isequal_coltyped(v1::AbstractVector, v2::AbstractVector) =
    isequal(v1, v2) && typeof(v1) == typeof(v2)

const ≃ = isequal_coltyped

Random.seed!(1234)

@testset "select! Not" begin
    df = DataFrame(a=1, b=2, c=3, d=4, e=5)
    @test_throws BoundsError select!(df, Not(0))
    @test_throws BoundsError select!(df, Not(6))
    @test_throws ArgumentError select!(df, Not(:f))
    @test_throws BoundsError select!(df, Not([true, false]))

    @test select!(copy(df), Not([1, 1])) == df[!, 2:end]

    d = copy(df)
    select!(d, Not([:a, :e, :c]))
    @test d == DataFrame(b=2, d=4)
    DataFrames._check_consistency(d)
    select!(d, Not(:b))
    @test d == DataFrame(d=4)
    DataFrames._check_consistency(d)

    d = copy(df)
    select!(d, Not(r"[aec]"))
    @test d == DataFrame(b=2, d=4)
    DataFrames._check_consistency(d)
    select!(d, Not(r"b"))
    @test d == DataFrame(d=4)
    DataFrames._check_consistency(d)

    d = copy(df)
    select!(d, Not([2, 5, 3]))
    @test d == DataFrame(a=1, d=4)
    DataFrames._check_consistency(d)
    select!(d, Not(2))
    @test d == DataFrame(a=1)
    DataFrames._check_consistency(d)

    d = copy(df)
    select!(d, Not(2:3))
    @test d == DataFrame(a=1, d=4, e=5)
    DataFrames._check_consistency(d)

    d = copy(df)
    select!(d, Not([false, true, true, false, false]))
    @test d == DataFrame(a=1, d=4, e=5)
    DataFrames._check_consistency(d)
end

@testset "select Not" begin
    df = DataFrame(a=1, b=2, c=3, d=4, e=5)
    @test_throws BoundsError select(df, Not(0))
    @test_throws BoundsError select(df, Not(6))
    @test_throws ArgumentError select(df, Not(:f))
    @test_throws BoundsError select(df, Not([true, false]))

    @test select(df, Not([1, 1])) == df[!, 2:end]

    df2 = copy(df)
    d = select(df, Not([:a, :e, :c]))
    @test d == df[:, [:b, :d]]
    @test d.b !== df.b
    @test d.d !== df.d
    @test df == df2

    df2 = copy(df)
    d = select(df, Not(r"[aec]"))
    @test d == df[:, [:b, :d]]
    @test d == df[:, r"[bd]"]
    @test d.b !== df.b
    @test d.d !== df.d
    @test df == df2

    d = select(df, Not([2, 5, 3]))
    @test d.a !== df.a
    @test d.d !== df.d
    @test d == df[:, [:a, :d]]
    @test df == df2

    d = select(df, Not(2:3))
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a !== df.a
    @test d.d !== df.d
    @test d.e !== df.e
    @test df == df2

    d = select(df, Not([false, true, true, false, false]))
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a !== df.a
    @test d.d !== df.d
    @test d.e !== df.e
    @test df == df2

    d = select(df, Not(1))
    @test d == DataFrame(b=2, c=3, d=4, e=5)
    @test d.b !== df.b
    @test d.b == df.b
    @test df == df2

    d = select(df, Not([:a, :e, :c]), copycols=false)
    @test d == df[:, [:b, :d]]
    @test d.b === df.b
    @test d.d === df.d
    @test df == df2

    d = select(df, Not(r"[aec]"), copycols=false)
    @test d == df[:, [:b, :d]]
    @test d == df[:, r"[bd]"]
    @test d.b === df.b
    @test d.d === df.d
    @test df == df2

    d = select(df, Not([2, 5, 3]), copycols=false)
    @test d.a === df.a
    @test d.d === df.d
    @test d == df[:, [:a, :d]]
    @test df == df2

    d = select(df, Not(2:3), copycols=false)
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a === df.a
    @test d.d === df.d
    @test d.e === df.e
    @test df == df2

    d = select(df, Not([false, true, true, false, false]), copycols=false)
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a === df.a
    @test d.d === df.d
    @test d.e === df.e
    @test df == df2

    d = select(df, Not(1), copycols=false)
    @test d == DataFrame(b=2, c=3, d=4, e=5)
    @test d.b === df.b
    @test df == df2
end

@testset "select Not on SubDataFrame" begin
    df = view(DataFrame(a=1, b=2, c=3, d=4, e=5), :, :)
    @test_throws BoundsError select(df, Not(0))
    @test_throws BoundsError select(df, Not(6))
    @test_throws ArgumentError select(df, Not(:f))
    @test_throws BoundsError select(df, Not([true, false]))

    @test select(df, Not([1, 1])) == df[!, 2:end]

    df2 = copy(df)
    d = select(df, Not([:a, :e, :c]))
    @test d isa DataFrame
    @test d == df[:, [:b, :d]]
    @test d.b !== df.b
    @test d.d !== df.d
    @test df == df2

    df2 = copy(df)
    d = select(df, Not(r"[aec]"))
    @test d isa DataFrame
    @test d == df[:, [:b, :d]]
    @test d == df[:, r"[bd]"]
    @test d.b !== df.b
    @test d.d !== df.d
    @test df == df2

    d = select(df, Not([2, 5, 3]))
    @test d isa DataFrame
    @test d.a !== df.a
    @test d.d !== df.d
    @test d == df[:, [:a, :d]]
    @test df == df2

    d = select(df, Not(2:3))
    @test d isa DataFrame
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a !== df.a
    @test d.d !== df.d
    @test d.e !== df.e
    @test df == df2

    d = select(df, Not([false, true, true, false, false]))
    @test d isa DataFrame
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a !== df.a
    @test d.d !== df.d
    @test d.e !== df.e
    @test df == df2

    d = select(df, Not(1))
    @test d isa DataFrame
    @test d == DataFrame(b=2, c=3, d=4, e=5)
    @test d.b !== df.b
    @test d.b == df.b
    @test df == df2

    d = select(df, Not([:a, :e, :c]), copycols=false)
    @test d isa SubDataFrame
    @test d == df[:, [:b, :d]]
    @test d.b === df.b
    @test d.d === df.d
    @test df == df2

    d = select(df, Not(r"[aec]"), copycols=false)
    @test d isa SubDataFrame
    @test d == df[:, [:b, :d]]
    @test d == df[:, r"[bd]"]
    @test d.b === df.b
    @test d.d === df.d
    @test df == df2

    d = select(df, Not([2, 5, 3]), copycols=false)
    @test d isa SubDataFrame
    @test d.a === df.a
    @test d.d === df.d
    @test d == df[:, [:a, :d]]
    @test df == df2

    d = select(df, Not(2:3), copycols=false)
    @test d isa SubDataFrame
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a === df.a
    @test d.d === df.d
    @test d.e === df.e
    @test df == df2

    d = select(df, Not([false, true, true, false, false]), copycols=false)
    @test d isa SubDataFrame
    @test d == DataFrame(a=1, d=4, e=5)
    @test d.a === df.a
    @test d.d === df.d
    @test d.e === df.e
    @test df == df2

    d = select(df, Not(1), copycols=false)
    @test d isa SubDataFrame
    @test d == DataFrame(b=2, c=3, d=4, e=5)
    @test d.b === df.b
    @test df == df2
end

@testset "select!" begin
    df = DataFrame(a=1, b=2, c=3, d=4, e=5)
    @test_throws BoundsError select!(df, 0)
    @test_throws BoundsError select!(df, 6)
    @test_throws ArgumentError select!(df, [1, 1])
    @test_throws ArgumentError select!(df, :f)
    @test_throws BoundsError select!(df, [true, false])

    @test select!(view(df, :, :), 1:2) == DataFrame(a=1, b=2)

    df = DataFrame(a=1, b=2, c=3, d=4, e=5)
    d = copy(df, copycols=false)
    @test select!(d, 1:0) == DataFrame()
    @test select!(d, Not(r"")) == DataFrame()

    d = copy(df, copycols=false)
    select!(d, [:a, :e, :c])
    @test propertynames(d) == [:a, :e, :c]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = copy(df, copycols=false)
    select!(d, r"[aec]")
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = copy(df, copycols=false)
    select!(d, [true, false, true, false, true])
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.c === df.c
    @test d.e === df.e

    d = copy(df, copycols=false)
    select!(d, [:d, :e, :a, :c, :b])
    @test propertynames(d) == [:d, :e, :a, :c, :b]
    for i in [:d, :e, :a, :c, :b]
        @test d[!, i] === df[!, i]
    end

    d = copy(df, copycols=false)
    select!(d, [2, 5, 3])
    @test propertynames(d) == [:b, :e, :c]
    @test d.b === df.b
    @test d.e === df.e
    @test d.c === df.c

    d = copy(df, copycols=false)
    select!(d, 2:3)
    @test propertynames(d) == [:b, :c]
    @test d.b === df.b
    @test d.c === df.c

    d = copy(df, copycols=false)
    select!(d, 2)
    @test propertynames(d) == [:b]
    @test d.b === df.b
end

@testset "select" begin
    df = DataFrame(a=1, b=2, c=3, d=4, e=5)
    @test_throws BoundsError select(df, 0)
    @test_throws BoundsError select(df, 6)
    @test_throws ArgumentError select(df, [1, 1])
    @test_throws ArgumentError select(df, :f)
    @test_throws ArgumentError select(df, 1.0)
    @test_throws ArgumentError select(df, true)
    @test_throws BoundsError select!(df, [true, false])

    @test select(df, 1:0) == DataFrame()
    @test select(df, Not(r"")) == DataFrame()
    @test select(df, 1:0, copycols=false) == DataFrame()
    @test select(df, Not(r""), copycols=false) == DataFrame()

    d = select(df, [:a, :e, :c])
    @test propertynames(d) == [:a, :e, :c]
    @test d.a !== df.a
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.a == df.a
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, r"[aec]")
    @test propertynames(d) == [:a, :c, :e]
    @test d.a !== df.a
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.a == df.a
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, [true, false, true, false, true])
    @test propertynames(d) == [:a, :c, :e]
    @test d.a !== df.a
    @test d.c !== df.c
    @test d.e !== df.e
    @test d.a == df.a
    @test d.c == df.c
    @test d.e == df.e

    d = select(df, [2, 5, 3])
    @test propertynames(d) == [:b, :e, :c]
    @test d.b !== df.b
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.b == df.b
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, 2:3)
    @test propertynames(d) == [:b, :c]
    @test d.b !== df.b
    @test d.c !== df.c
    @test d.b == df.b
    @test d.c == df.c

    d = select(df, 2)
    @test propertynames(d) == [:b]
    @test d.b !== df.b
    @test d.b == df.b

    d = select(df, [:a, :e, :c], copycols=false)
    @test propertynames(d) == [:a, :e, :c]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, r"[aec]", copycols=false)
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, [true, false, true, false, true], copycols=false)
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.c === df.c
    @test d.e === df.e

    d = select(df, [2, 5, 3], copycols=false)
    @test propertynames(d) == [:b, :e, :c]
    @test d.b === df.b
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, 2:3, copycols=false)
    @test propertynames(d) == [:b, :c]
    @test d.b === df.b
    @test d.c === df.c

    d = select(df, 2, copycols=false)
    @test propertynames(d) == [:b]
    @test d.b === df.b
end

@testset "select on SubDataFrame" begin
    df = view(DataFrame(a=1, b=2, c=3, d=4, e=5), :, :)
    @test_throws BoundsError select(df, 0)
    @test_throws BoundsError select(df, 6)
    @test_throws ArgumentError select(df, [1, 1])
    @test_throws ArgumentError select(df, :f)
    @test_throws BoundsError select!(df, [true, false])

    df = view(DataFrame(a=1, b=2, c=3, d=4, e=5), :, :)
    @test select(df, 1:0) == DataFrame()
    @test select(df, Not(r"")) == DataFrame()
    @test select(df, 1:0, copycols=false) == DataFrame()
    @test select(df, Not(r""), copycols=false) == DataFrame()

    d = select(df, [:a, :e, :c])
    @test d isa DataFrame
    @test propertynames(d) == [:a, :e, :c]
    @test d.a !== df.a
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.a == df.a
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, r"[aec]")
    @test d isa DataFrame
    @test propertynames(d) == [:a, :c, :e]
    @test d.a !== df.a
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.a == df.a
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, [true, false, true, false, true])
    @test d isa DataFrame
    @test propertynames(d) == [:a, :c, :e]
    @test d.a !== df.a
    @test d.c !== df.c
    @test d.e !== df.e
    @test d.a == df.a
    @test d.c == df.c
    @test d.e == df.e

    d = select(df, [2, 5, 3])
    @test d isa DataFrame
    @test propertynames(d) == [:b, :e, :c]
    @test d.b !== df.b
    @test d.e !== df.e
    @test d.c !== df.c
    @test d.b == df.b
    @test d.e == df.e
    @test d.c == df.c

    d = select(df, 2:3)
    @test d isa DataFrame
    @test propertynames(d) == [:b, :c]
    @test d.b !== df.b
    @test d.c !== df.c
    @test d.b == df.b
    @test d.c == df.c

    d = select(df, 2)
    @test d isa DataFrame
    @test propertynames(d) == [:b]
    @test d.b !== df.b
    @test d.b == df.b

    d = select(df, [:a, :e, :c], copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:a, :e, :c]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, r"[aec]", copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, [true, false, true, false, true], copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:a, :c, :e]
    @test d.a === df.a
    @test d.c === df.c
    @test d.e === df.e

    d = select(df, [2, 5, 3], copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:b, :e, :c]
    @test d.b === df.b
    @test d.e === df.e
    @test d.c === df.c

    d = select(df, 2:3, copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:b, :c]
    @test d.b === df.b
    @test d.c === df.c

    d = select(df, 2, copycols=false)
    @test d isa SubDataFrame
    @test propertynames(d) == [:b]
    @test d.b === df.b
end

@testset "select! on all columns" begin
    a, b, c = 1:5, 2:6, 3:7
    original = DataFrame(a=a, b=b, c=c)

    df = deepcopy(original)
    expected = deepcopy(original)
    @test select!(df, [:a, :b, :c]) === df
    @test df == expected
    @test select!(df, 1:3) === df
    @test df == expected

    df = deepcopy(original)
    expected = DataFrame(b=b, c=c, a=a)
    select!(df, [:b, :c, :a]) === df
    @test df == expected
    df = deepcopy(original)
    select!(df, [2, 3, 1]) === df
    @test df == expected

    df = deepcopy(original)
    expected = DataFrame(c=c, a=a, b=b)
    select!(df, [:c, :a, :b]) === df
    @test df == expected
    df = deepcopy(original)
    select!(df, [3, 1, 2]) === df
    @test df == expected

    df = deepcopy(original)
    expected = DataFrame(a=a, c=c, b=b)
    select!(df, [:a, :c, :b]) === df
    @test df == expected
    df = deepcopy(original)
    select!(df, [1, 3, 2]) === df
    @test df == expected

    df = deepcopy(original)
    expected = DataFrame(b=b, a=a, c=c)
    select!(df, [:b, :a, :c]) === df
    @test df == expected
    df = deepcopy(original)
    select!(df, [2, 1, 3]) === df
    @test df == expected

    df = deepcopy(original)
    expected = DataFrame(c=c, b=b, a=a)
    select!(df, [:c, :b, :a]) === df
    @test df == expected
    df = deepcopy(original)
    select!(df, [3, 2, 1]) === df
    @test df == expected

    df = DataFrame(a=a, b=b, c=c)
    @test_throws BoundsError select!(df, 1:4)
    @test_throws ArgumentError select!(df, [:a, :b, :c, :d])
    @test_throws ArgumentError select!(df, [1, 2, 3, 1])
    @test_throws ArgumentError select!(df, [:a, :b, :c, :a])

    # but this works
    @test select!(copy(df), [:a, :c]) == df[:, [:a, :c]]
    @test select!(copy(df), [:a, :b]) == df[:, [:a, :b]]
    @test select!(copy(df), [1, 3]) == df[:, [1, 3]]
end

@testset "select and select! with multiple selectors passed" begin
    df = DataFrame(rand(10, 4), :auto)
    @test select(df, :x2, :x4, All()) == select(df, :x2, :x4, :x1, :x3)
    @test select(df, :x2, :x4, Cols(:)) == select(df, :x2, :x4, :x1, :x3)
    @test select(df, :x2, :x4, Cols()) == select(df, :x2, :x4)
    @test select(df, :x4, Between(:x2, :x4), All()) == select(df, :x4, :x2, :x3, :x1)

    dfv = view(df, :, :)
    @test select(dfv, :x2, :x4, All()) == select(df, :x2, :x4, :x1, :x3)
    @test select(dfv, :x2, :x4, Cols(:)) == select(df, :x2, :x4, :x1, :x3)
    @test select(dfv, :x2, :x4, Cols()) == select(df, :x2, :x4)
    @test select(dfv, :x4, Between(:x2, :x4), All()) == select(df, :x4, :x2, :x3, :x1)
    @test select(dfv, :x4, Between(:x2, :x4), Cols(:)) == select(df, :x4, :x2, :x3, :x1)
    @test select(dfv, :x4, Between(:x2, :x4), Cols()) == select(df, :x4, :x2, :x3)
    @test select(dfv, :x2, :x4, All()) == select(dfv, :x2, :x4, :x1, :x3)
    @test select(dfv, :x4, Between(:x2, :x4), All()) == select(dfv, :x4, :x2, :x3, :x1)
    @test select(dfv, :x4, Between(:x2, :x4), Cols(:)) == select(dfv, :x4, :x2, :x3, :x1)
    @test select(dfv, :x4, Between(:x2, :x4), Cols()) == select(dfv, :x4, :x2, :x3)

    dfc = copy(df)
    @test select!(dfc, :x2, :x4, All()) == dfc
    @test select!(dfc, :x2, :x4, Cols(:)) == dfc
    @test dfc == select(df, :x2, :x4, :x1, :x3)
    dfc = copy(df)
    @test select!(dfc, :x4, Between(:x2, :x4), All()) == dfc
    @test select!(dfc, :x4, Between(:x2, :x4), Cols(:)) == dfc
    @test dfc == select(df, :x4, :x2, :x3, :x1)

    @test select(df, Not([:x2, :x3]), All()) == select(df, :x1, :x4, :x2, :x3)
    @test select(df, Not([:x2, :x3]), Cols(:)) == select(df, :x1, :x4, :x2, :x3)
end

@testset "select and select! renaming" begin
    df = DataFrame(rand(10, 4), :auto)
    @test select(df, :x1 => :x2, :x2 => :x1) == rename(df[:, 1:2], [:x2, :x1])
    @test select(df, :x2 => :x1, :x1 => :x2) == DataFrame(x1=df.x2, x2=df.x1)
    @test_throws ArgumentError select(df, [:x1, :x2] => :x3)
    @test_throws ArgumentError select!(df, [:x1, :x2] => :x3)
    @test_throws BoundsError select(df, 0 => :x3)
    @test_throws BoundsError select!(df, 0 => :x3)

    df2 = select(df, :x1 => :x2, :x2 => :x1)
    @test df2.x1 == df.x2
    @test df2.x1 !== df.x2
    df2 = select(df, :x1 => :x2, :x2 => :x1, copycols=false)
    @test df2.x1 === df.x2

    df2 = select(df, :x1, :x1 => :x2)
    @test df2.x1 == df2.x2
    @test df2.x1 !== df2.x2

    df2 = select(df, :x1, :x1 => :x2, copycols=false)
    @test df2.x1 == df2.x2
    @test df2.x1 !== df2.x2

    x1 = df.x1
    x2 = df.x2
    select!(df, :x1 => :x2, :x2 => :x1)
    @test x1 === df.x2
    @test x2 === df.x1
    @test names(df) == ["x2", "x1"]

    df = DataFrame(rand(10, 4), :auto)
    select!(df, :x1, :x1 => :x2)
    @test df2.x1 !== df2.x2
    @test df2.x1 == df2.x2

    df = DataFrame(rand(10, 4), :auto)
    df2 = select(df, :, :x1 => :x3)
    @test df2 == DataFrame(collect(eachcol(df))[[1, 2, 1, 4]], :auto)
    @test df2.x1 !== df2.x3
    df2 = select(df, :, :x1 => :x3, copycols=false)
    @test df2 == DataFrame(collect(eachcol(df))[[1, 2, 1, 4]], :auto)
    @test df2.x1 == df2.x3
    @test df2.x1 !== df2.x3
    @test select(df, :x1 => :x3, :) == DataFrame(collect(eachcol(df))[[1, 1, 2, 4]],
                                                 [:x3, :x1, :x2, :x4])
    select!(df, :, :x1 => :x3)
    @test df2 == df
    @test all(i -> df2[!, i] === df[!, i], ncol(df2))
end

@testset "select and select! many columns naming" begin
    df = DataFrame(rand(10, 4), :auto)
    for fun in (+, ByRow(+)), copycols in [true, false]
        @test select(df, 1 => fun, copycols=copycols) ==
              DataFrame(Symbol("x1_+") => df.x1)
        @test select(df, 1:2 => fun, copycols=copycols) ==
              DataFrame(Symbol("x1_x2_+") => df.x1 + df.x2)
        @test select(df, 1:3 => fun, copycols=copycols) ==
              DataFrame(Symbol("x1_x2_x3_+") => df.x1 + df.x2 + df.x3)
        @test select(df, 1:4 => fun, copycols=copycols) ==
              DataFrame(Symbol("x1_x2_etc_+") => sum.(eachrow(df)))
    end
    for fun in (+, ByRow(+))
        dfc = copy(df)
        select!(dfc, 1 => fun)
        @test dfc == DataFrame(Symbol("x1_+") => df.x1)
        dfc = copy(df)
        select!(dfc, 1:2 => fun)
        @test dfc == DataFrame(Symbol("x1_x2_+") => df.x1 + df.x2)
        dfc = copy(df)
        select!(dfc, 1:3 => fun)
        @test dfc == DataFrame(Symbol("x1_x2_x3_+") => df.x1 + df.x2 + df.x3)
        dfc = copy(df)
        select!(dfc, 1:4 => fun)
        @test dfc == DataFrame(Symbol("x1_x2_etc_+") => sum.(eachrow(df)))
    end
end

@testset "select and select! many different transforms" begin
    df = DataFrame(rand(10, 4), :auto)

    df2 = select(df, :x2, :, :x1 => ByRow(x -> x^2) => :r1, :x1 => (x -> x .^ 2) => :r2,
                 [:x1, :x2] => (+) => :x1, 1:2 => ByRow(/) => :x3, :x1 => :x4)
    @test propertynames(df2) == [:x2, :x1, :x3, :x4, :r1, :r2]
    @test df.x2 == df2.x2
    @test df.x2 !== df2.x2
    @test df.x1 == df2.x4
    @test df.x4 !== df2.x1
    @test df2.r1 == df.x1 .^ 2
    @test df2.r1 == df2.r2
    @test df2.x1 == df.x1 + df.x2
    @test df2.x3 == df.x1 ./ df.x2

    @test select(df, [:x1, :x1] => +) == DataFrame(Symbol("x1_x1_+") => 2*df.x1)
    @test select(df, [1, 1] => +) == DataFrame(Symbol("x1_x1_+") => 2*df.x1)

    df2 = select(df, :x2, :, :x1 => ByRow(x -> x^2) => :r1, :x1 => (x -> x .^ 2) => :r2,
                 [:x1, :x2] => (+) => :x1, 1:2 => ByRow(/) => :x3, :x1 => :x4, copycols=false)
    @test propertynames(df2) == [:x2, :x1, :x3, :x4, :r1, :r2]
    @test df.x2 === df2.x2
    @test df.x1 == df2.x4
    @test df.x1 == df2.x4
    # a copy is made as we earlier used ":" selector, although later :x1 gets overwritten
    @test df.x1 !== df2.x4
    @test df2.r1 == df.x1 .^ 2
    @test df2.r1 == df2.r2
    @test df2.x1 == df.x1 + df.x2
    @test df2.x3 == df.x1 ./ df.x2

    x1, x2, x3, x4 = df.x1, df.x2, df.x3, df.x4
    select!(df, :x2, :, :x1 => ByRow(x -> x^2) => :r1, :x1 => (x -> x .^ 2) => :r2,
            [:x1, :x2] => (+) => :x1, 1:2 => ByRow(/) => :x3, :x1 => :x4)
    @test propertynames(df2) == [:x2, :x1, :x3, :x4, :r1, :r2]
    @test x2 === df.x2
    # a copy is made as we earlier used ":" selector, although later :x1 gets overwritten
    @test x1 !== df.x4
    @test df.r1 == x1 .^ 2
    @test df.r1 == df.r2
    @test df.x1 == x1 + x2
    @test df.x3 == x1 ./ x2
end

@testset "nrow in select" begin
    df_ref = DataFrame(ones(3, 4), :auto)
    for df in [df_ref, view(df_ref, 1:2, 1:2),
               df_ref[1:2, []], view(df_ref, 1:2, []),
               df_ref[[], 1:2], view(df_ref, [], 1:2)]
        @test select(df, nrow => :z, nrow, [nrow => :z2]) ==
              repeat(DataFrame(z=nrow(df), nrow=nrow(df), z2=nrow(df)), nrow(df))
        @test combine(df, nrow => :z, nrow, [nrow => :z2]) ==
              DataFrame(z=nrow(df), nrow=nrow(df), z2=nrow(df))
        @test_throws ArgumentError select(df, nrow, nrow)
        @test_throws ArgumentError select(df, [nrow])
    end
end

@testset "select and select! reserved return values" begin
    df = DataFrame(x=1)
    df2 = copy(df)
    for retval in [df2, (a=1, b=2), df2[1, :], ones(2, 2), Tables.Row(df2[1, :]), Tables.Row((a=1, b=2))]
        @test_throws ArgumentError select(df, :x => x -> retval)
        @test_throws ArgumentError select(df, :x => x -> retval, copycols=false)
        @test_throws ArgumentError select!(df, :x => x -> retval)

        @test select(df, :x => ByRow(x -> retval)) == DataFrame(x_function=[retval])
        cdf = copy(df)
        select!(cdf, :x => ByRow(x -> retval))
        @test cdf == DataFrame(x_function=[retval])

        if retval isa Union{NamedTuple, DataFrameRow}
            @test select(df, :x => ByRow(x -> retval) => AsTable) == DataFrame(; retval...)
        elseif retval isa Tables.AbstractRow
            @test select(df, :x => ByRow(x -> retval) => AsTable) ==
                  DataFrame([col => retval[col] for col in Tables.columnnames(retval)]...)
        elseif retval isa DataFrame
            @test_throws MethodError select(df, :x => ByRow(x -> retval) => AsTable)
        else # Matrix: wrong type of keys
            @test_throws ArgumentError select(df, :x => ByRow(x -> retval) => AsTable)
            @test_throws ArgumentError select(df, :x => ByRow(x -> retval) => [:a, :b, :c, :d])
        end
    end

    for retval in [(1, 2), ones(2, 2, 2)]
        @test select(df, :x => x -> retval) == DataFrame(x_function=[retval])
        @test select(df, :x => ByRow(x -> retval)) == DataFrame(x_function=[retval])
        if retval isa Tuple
            @test select(df, :x => ByRow(x -> retval) => AsTable) == DataFrame(x1=1, x2=2)
        else
            @test_throws ArgumentError select(df, :x => ByRow(x -> retval) => AsTable)
        end
        cdf = copy(df)
        select!(cdf, :x => x -> retval)
        @test cdf == DataFrame(x_function=[retval])
        cdf = copy(df)
        select!(cdf, :x => ByRow(x -> retval))
        @test cdf == DataFrame(x_function=[retval])
    end
end

@testset "select and select! empty selection" begin
    df = DataFrame(rand(10, 4), :auto)
    x = [1:10;]
    y = [1, 2, 3]

    @test select(df, r"z") == DataFrame()
    @test select(df, r"z" => () -> x) == DataFrame(:function => x)
    @test_throws ArgumentError select(df, r"z" => () -> y)
    @test combine(df, r"z" => () -> y) == DataFrame(:function => y)
    @test select(df, r"z" => () -> x)[!, 1] === x # no copy even for copycols=true
    @test_throws MethodError select(df, r"z" => x -> 1)
    @test select(df, r"z" => ByRow(() -> 1)) == DataFrame(:function => fill(1, 10))

    @test select(df, r"z", copycols=false) == DataFrame()
    @test select(df, r"z" => () -> x, copycols=false) == DataFrame(:function => x)
    @test select(df, r"z" => () -> x, copycols=false)[!, 1] === x
    @test_throws MethodError select(df, r"z" => x -> 1, copycols=false)
    @test select(df, r"z" => ByRow(() -> 1)) == DataFrame(:function => fill(1, 10), copycols=false)

    @test_throws MethodError select!(df, r"z" => x -> 1)
    @test select!(df, r"z" => ByRow(() -> 1)) == DataFrame(:function => fill(1, 10))
    @test_throws MethodError select!(df, r"z" => () -> x, copycols=false)

    select!(df, r"z" => () -> x)
    @test df == DataFrame(:function => x)
end

@testset "wrong selection patterns" begin
    df = DataFrame(rand(10, 4), :auto)

    @test_throws ArgumentError select(df, "z")
    @test_throws ArgumentError select(df, "z" => :x1)
    @test_throws ArgumentError select(df, "z" => identity)
    @test_throws ArgumentError select(df, "z" => identity => :x1)
end

@testset "select and select! duplicates" begin
    df = DataFrame(rand(10, 4), :auto)
    df_ref = copy(df)

    @test_throws ArgumentError select(df, :x1, :x1)
    @test_throws ArgumentError select(df, :x1, :x5)
    @test select(df, :x2, r"x", :x1, :) == df[:, [:x2, :x1, :x3, :x4]]

    @test_throws ArgumentError select(df, :x1, :x2 => :x1)
    @test_throws ArgumentError select(df, :x3 => :x1, :x2 => :x1)
    @test_throws ArgumentError select(df, :x1, :x2 => identity => :x1)
    @test_throws ArgumentError select(df, :x1 => :x1, :x2 => identity => :x1)
    @test_throws ArgumentError select(df, :x3 => identity => :x1, :x2 => identity => :x1)
    @test select(df, [:x1], :x2 => :x1) == DataFrame(x1=df.x2)

    @test_throws ArgumentError select!(df, :x1, :x1)
    @test_throws ArgumentError select!(df, :x1, :x5)
    @test df == df_ref

    select!(df, :x2, r"x", :x1, :)
    @test df == df_ref[:, [:x2, :x1, :x3, :x4]]

    df = DataFrame(rand(10, 2), [:x1, :x2])
    @test select(df, [:x1, :x1] => -) == DataFrame(Symbol("x1_x1_-") => zeros(10))
    select!(df, [:x1, :x1] => -)
    @test df == DataFrame(Symbol("x1_x1_-") => zeros(10))
end

@testset "SubDataFrame selection" begin
    df = DataFrame(rand(12, 5), :auto)
    sdf = view(df, 1:10, 1:4)
    df_ref = copy(sdf)

    @test select(sdf, :x2, :, :x1 => ByRow(x -> x^2) => :r1, :x1 => (x -> x .^ 2) => :r2,
                 [:x1, :x2] => (+) => :x1, 1:2 => ByRow(/) => :x3, :x1 => :x4) ==
          select(df_ref, :x2, :, :x1 => ByRow(x -> x^2) => :r1, :x1 => (x -> x .^ 2) => :r2,
                 [:x1, :x2] => (+) => :x1, 1:2 => ByRow(/) => :x3, :x1 => :x4)

    for fun in (+, ByRow(+))
        @test select(sdf, 1 => fun) ==
              DataFrame(Symbol("x1_+") => sdf.x1)
        @test select(sdf, 1:2 => fun) ==
              DataFrame(Symbol("x1_x2_+") => sdf.x1 + sdf.x2)
        @test select(sdf, 1:3 => fun) ==
              DataFrame(Symbol("x1_x2_x3_+") => sdf.x1 + sdf.x2 + sdf.x3)
        @test select(sdf, 1:4 => fun) ==
              DataFrame(Symbol("x1_x2_etc_+") => sum.(eachrow(sdf)))
    end

    @test_throws ArgumentError select(sdf, :x1, :x1)
    @test_throws ArgumentError select(sdf, :x1, :x1, copycols=false)
    @test select(sdf, :x1, [:x1]) == sdf[:, [:x1]]
    @test select(sdf, :x1, [:x1]) isa DataFrame
    @test select(sdf, :x1, [:x1], copycols=false) == sdf[:, [:x1]]
    @test select(sdf, :x1, [:x1], copycols=false) isa SubDataFrame
    @test_throws ArgumentError select(sdf, :x1 => :r1, copycols=false)
    @test_throws ArgumentError select(sdf, :x1 => identity => :r1, copycols=false)
    @test_throws ArgumentError select(sdf, identity, copycols=false)
end

@testset "pseudo-broadcasting" begin
    df = DataFrame([1 2 3
                    4 5 6], :auto)
    df2 = DataFrame([1 2 3], :auto)
    df3 = DataFrame(x1=Char[], x2=Int[], x3=Int[])
    for v in [9, Ref(9), view([9], 1)]
        @test select(df, [] => (() -> v) => :a, :, (:) => (+) => :d) ==
              DataFrame([9 1 2 3 6
                         9 4 5 6 15], [:a, :x1, :x2, :x3, :d])
        @test select(df, (:) => (+) => :d, :, r"z" => (() -> v)  => :a) ==
              DataFrame([6  1 2 3 9
                         15 4 5 6 9], [:d, :x1, :x2, :x3, :a])
        @test select(df, [] => (() -> v) => :a, :x1 => :b, (:) => (+) => :d) ==
              DataFrame([9 1 6
                         9 4 15], [:a, :b, :d])
        @test select(df, (:) => (+) => :d, :x1 => :b, [] => (() -> v) => :a) ==
              DataFrame([6  1 9
                         15 4 9], [:d, :b, :a])
        @test select(df, [] => (() -> v) => :a, :x1 => (x -> x) => :b, (:) => (+) => :d) ==
              DataFrame([9 1 6
                         9 4 15], [:a, :b, :d])
        @test select(df, (:) => (+) => :d, :x1 => (x -> x) => :b, [] => (() -> v) => :a) ==
              DataFrame([6  1 9
                         15 4 9], [:d, :b, :a])
        @test select(df2, [] => (() -> v) => :a, :, (:) => (+) => :d) ==
              DataFrame([9 1 2 3 6], [:a, :x1, :x2, :x3, :d])
        @test select(df2, (:) => (+) => :d, :, r"z" => (() -> v)  => :a) ==
              DataFrame([6 1 2 3 9], [:d, :x1, :x2, :x3, :a])
        @test select(df2, [] => (() -> v) => :a, :x1 => :b, (:) => (+) => :d) ==
              DataFrame([9 1 6], [:a, :b, :d])
        @test select(df2, (:) => (+) => :d, :x1 => :b, [] => (() -> v) => :a) ==
              DataFrame([6 1 9], [:d, :b, :a])
        @test select(df2, [] => (() -> v) => :a, :x1 => (x -> x) => :b, (:) => (+) => :d) ==
              DataFrame([9 1 6], [:a, :b, :d])
        @test select(df2, (:) => (+) => :d, :x1 => (x -> x) => :b, [] => (() -> v) => :a) ==
              DataFrame([6 1 9], [:d, :b, :a])

        @test select(df3, [] => (() -> v) => :a, :x1 => x -> []) ≃
              DataFrame(a=Int[], x1_function=Any[])
        @test select(df3, :x1 => x -> [], [] => (() -> v) => :a) ≃
              DataFrame(x1_function=Any[], a=Int[])
        @test select(df3, [] => (() -> v) => :a, :x1) ≃
              DataFrame(a=Int[], x1=Char[])
        @test select(df3, :x1, [] => (() -> v) => :a) ≃
              DataFrame(x1=Char[], a=Int[])
    end
    @test_throws ArgumentError select(df, [] => (() -> [9]) => :a, :)
    @test_throws ArgumentError select(df, :, [] => (() -> [9]) => :a)
    @test transform(df, names(df) .=> (x -> 9) .=> names(df)) ==
          repeat(DataFrame([9 9 9], :auto), nrow(df))
    @test combine(df, names(df) .=> (x -> 9) .=> names(df)) ==
          DataFrame([9 9 9], :auto)
    @test transform(df, names(df) .=> (x -> 9) .=> names(df), :x1 => :x4) ==
          DataFrame([9 9 9 1; 9 9 9 4], :auto)
    @test transform(df3, names(df3) .=> (x -> 9) .=> names(df3)) ==
          repeat(DataFrame([9 9 9], :auto), nrow(df3))
    @test combine(df3, names(df3) .=> (x -> 9) .=> names(df3)) ==
          DataFrame([9 9 9], :auto)
    @test transform(df3, names(df3) .=> (x -> 9) .=> names(df3), :x1 => :x4) ==
          DataFrame(ones(0, 4), :auto)

    df = DataFrame(x1=1:2, x2=categorical(1:2),
                   x3=[missing, 2], x4=categorical([missing, 2]))

    df2 = select(df, names(df) .=> first)
    @test df2 ≅ repeat(DataFrame(x1_first=1, x2_first=1, x3_first=missing,
                                 x4_first=missing), nrow(df2))
    @test df2.x1_first isa Vector{Int}
    @test df2.x2_first isa CategoricalVector{Int}
    @test df2.x3_first isa Vector{Missing}
    @test df2.x4_first isa Vector{Missing}

    df2 = combine(df, names(df) .=> first)
    @test df2 ≅ DataFrame(x1_first=1, x2_first=1, x3_first=missing,
                          x4_first=missing)
    @test df2.x1_first isa Vector{Int}
    @test df2.x2_first isa CategoricalVector{Int}
    @test df2.x3_first isa Vector{Missing}
    @test df2.x4_first isa Vector{Missing}

    df2 = select(df, names(df) .=> last)
    @test df2 ≅ repeat(DataFrame(x1_last=2, x2_last=2, x3_last=2,
                                 x4_last=2), nrow(df2))
    @test df2.x1_last isa Vector{Int}
    @test df2.x2_last isa CategoricalVector{Int}
    @test df2.x3_last isa Vector{Int}
    @test df2.x4_last isa CategoricalVector{Int}

    df2 = combine(df, names(df) .=> last)
    @test df2 ≅ DataFrame(x1_last=2, x2_last=2, x3_last=2,
                          x4_last=2)
    @test df2.x1_last isa Vector{Int}
    @test df2.x2_last isa CategoricalVector{Int}
    @test df2.x3_last isa Vector{Int}
    @test df2.x4_last isa CategoricalVector{Int}

    for v in [:x1, :x1 => (x -> x) => :x1]
        df2 = select(df, names(df) .=> first, v)
        @test df2 ≅ DataFrame(x1_first=1, x2_first=1, x3_first=missing,
                              x4_first=missing, x1=[1, 2])
        @test df2.x1_first isa Vector{Int}
        @test df2.x2_first isa CategoricalVector{Int}
        @test df2.x3_first isa Vector{Missing}
        @test df2.x4_first isa Vector{Missing}


        df2 = select(df, names(df) .=> last, v)
        @test df2 ≅ DataFrame(x1_last=2, x2_last=2, x3_last=2,
                              x4_last=2, x1=[1, 2])
        @test df2.x1_last isa Vector{Int}
        @test df2.x2_last isa CategoricalVector{Int}
        @test df2.x3_last isa Vector{Int}
        @test df2.x4_last isa CategoricalVector{Int}


        df2 = select(df, v, names(df) .=> first)
        @test df2 ≅ DataFrame(x1=[1, 2], x1_first=1, x2_first=1, x3_first=missing,
                              x4_first=missing)
        @test df2.x1_first isa Vector{Int}
        @test df2.x2_first isa CategoricalVector{Int}
        @test df2.x3_first isa Vector{Missing}
        @test df2.x4_first isa Vector{Missing}


        df2 = select(df, v, names(df) .=> last)
        @test df2 ≅ DataFrame(x1=[1, 2], x1_last=2, x2_last=2, x3_last=2,
                              x4_last=2)
        @test df2.x1_last isa Vector{Int}
        @test df2.x2_last isa CategoricalVector{Int}
        @test df2.x3_last isa Vector{Int}
        @test df2.x4_last isa CategoricalVector{Int}
    end

    @test_throws ArgumentError select(df, names(df) .=> first, [] => (() -> Int[]) => :x1)
    df2 = combine(df, names(df) .=> first, [] => (() -> Int[]) => :x1)
    @test size(df2) == (0, 5)
    @test df2.x1_first isa Vector{Int}
    @test df2.x2_first isa CategoricalVector{Int}
    @test df2.x3_first isa Vector{Missing}
    @test df2.x4_first isa Vector{Missing}

    @test_throws ArgumentError select(df, names(df) .=> last, [] => (() -> Int[]) => :x1)
    df2 = combine(df, names(df) .=> last, [] => (() -> Int[]) => :x1)
    @test size(df2) == (0, 5)
    @test df2.x1_last isa Vector{Int}
    @test df2.x2_last isa CategoricalVector{Int}
    @test df2.x3_last isa Vector{Int}
    @test df2.x4_last isa CategoricalVector{Int}

    @test_throws ArgumentError select(df, [] => (() -> Int[]) => :x1, names(df) .=> first)
    df2 = combine(df, [] => (() -> Int[]) => :x1, names(df) .=> first)
    @test size(df2) == (0, 5)
    @test df2.x1_first isa Vector{Int}
    @test df2.x2_first isa CategoricalVector{Int}
    @test df2.x3_first isa Vector{Missing}
    @test df2.x4_first isa Vector{Missing}

    @test_throws ArgumentError select(df, [] => (() -> Int[]) => :x1, names(df) .=> last)
    df2 = combine(df, [] => (() -> Int[]) => :x1, names(df) .=> last)
    @test size(df2) == (0, 5)
    @test df2.x1_last isa Vector{Int}
    @test df2.x2_last isa CategoricalVector{Int}
    @test df2.x3_last isa Vector{Int}
    @test df2.x4_last isa CategoricalVector{Int}
end

@testset "copycols special cases" begin
    df = DataFrame(a=1:3, b=4:6)
    c = [7, 8]
    @test_throws ArgumentError select(df, :a => (x -> c) => :c1, :b => (x -> c) => :c2)
    df2 = combine(df, :a => (x -> c) => :c1, :b => (x -> c) => :c2)
    @test df2.c1 === df2.c2
    df2 = select(df, :a => identity => :c1, :a => :c2)
    @test df2.c1 !== df2.c2
    df2 = select(df, :a => identity => :c1)
    @test df2.c1 !== df.a
    df2 = select(df, :a => (x -> df.b) => :c1)
    @test df2.c1 === df.b
    @test_throws ArgumentError select(view(df, 1:2, :), :a => parent => :c1)
    df2 = combine(view(df, 1:2, :), :a => parent => :c1)
    @test df2.c1 !== df.a
    @test_throws ArgumentError select(view(df, 1:2, :), :a => (x -> view(x, 1:1)) => :c1)
    df2 = combine(view(df, 1:2, :), :a => (x -> view(x, 1:1)) => :c1)
    @test df2.c1 isa Vector
    df2 = select(df, :a, :a => :b, :a => identity => :c, copycols=false)
    @test df2.b == df2.c == df.a
    @test df2.b !== df2.c
    @test df2.b !== df2.a
    @test df2.c !== df2.a
    @test df.a === df2.a
    a = df.a
    select!(df, :a, :a => :b, :a => identity => :c)
    @test df2.b == df2.c == df.a
    @test df2.b !== df2.c
    @test df2.b !== df2.a
    @test df2.c !== df2.a
    @test a === df2.a
end

@testset "empty select" begin
    df_ref = DataFrame(rand(10, 4), :auto)

    for df in (df_ref, view(df_ref, 1:9, 1:3))
        @test ncol(select(df)) == 0
        @test ncol(select(df, copycols=false)) == 0
    end
    select!(df_ref)
    @test ncol(df_ref) == 0
end

@testset "transform and transform!" begin
    df = DataFrame(rand(10, 4), :auto)

    for dfx in (df, view(df, :, :))
        df2 = transform(dfx, [:x1, :x2] => +, :x2 => :x3)
        @test df2 == select(dfx, :, [:x1, :x2] => +, :x2 => :x3)
        @test df2.x2 == df2.x3
        @test df2.x2 !== df2.x3
        @test dfx.x2 == df2.x3
        @test dfx.x2 !== df2.x3
        @test dfx.x2 !== df2.x2
    end

    df2 = transform(df, [:x1, :x2] => +, :x2 => :x3, copycols=false)
    @test df2 == select(df, :, [:x1, :x2] => +, :x2 => :x3)
    @test df.x2 == df2.x2 == df2.x3
    @test df.x2 === df2.x2
    @test df.x2 !== df2.x3
    @test_throws ArgumentError transform(view(df, :, :), [:x1, :x2] => +, :x2 => :x3, copycols=false)

    x2 = df.x2
    transform!(df, [:x1, :x2] => +, :x2 => :x3)
    @test df == df2
    @test x2 == df.x2 == df.x3
    @test x2 === df.x2
    @test x2 !== df.x3

    @test transform(df) == df
    df2 = transform(df, copycols=false)
    @test df2 == df
    for (a, b) in zip(eachcol(df), eachcol(df2))
        @test a === b
    end
    cols = collect(eachcol(df))
    transform!(df)
    @test df2 == df
    for (a, b) in zip(eachcol(df), cols)
        @test a === b
    end
end

@testset "vectors of pairs" begin
    df_ref = DataFrame(a=1:3, b=4:6)
    for df in [df_ref, view(df_ref, :, :)]
        @test select(df, [] .=> sum) == DataFrame()
        @test select(df, names(df) .=> sum) == repeat(DataFrame(a_sum=6, b_sum=15), nrow(df))
        @test combine(df, names(df) .=> sum) == DataFrame(a_sum=6, b_sum=15)
        @test transform(df, names(df) .=> ByRow(-)) ==
              DataFrame(:a => 1:3, :b => 4:6,
                        Symbol("a_-") => -1:-1:-3,
                        Symbol("b_-") => -4:-1:-6)
        @test select(df, :a, [] .=> sum, :b => :x, [:b, :a] .=> identity) ==
              DataFrame(a=1:3, x=4:6, b_identity=4:6, a_identity=1:3)
        @test select(df, names(df) .=> sum .=> [:A, :B]) == repeat(DataFrame(A=6, B=15), nrow(df))
        @test combine(df, names(df) .=> sum .=> [:A, :B]) == DataFrame(A=6, B=15)
        @test Base.broadcastable(ByRow(+)) isa Base.RefValue{ByRow{typeof(+)}}
        @test identity.(ByRow(+)) == ByRow(+)
    end
end

@testset "AsTable tests" begin
    df = DataFrame(a=1:3, b=4:6, c=7:9)
    @test select(df, AsTable(:) => sum) ==
          DataFrame(a_b_c_sum=map(sum, eachrow(df)))
    @test transform(df, AsTable(:) => sum) ==
          DataFrame(a=1:3, b=4:6, c=7:9, a_b_c_sum=map(sum, eachrow(df)))

    @test select(df, AsTable(:) => sum ∘ sum) ==
          repeat(DataFrame(a_b_c_sum_sum=45), nrow(df))
    @test combine(df, AsTable(:) => sum ∘ sum) ==
          DataFrame(a_b_c_sum_sum=45)
    @test transform(df, AsTable(:) => sum ∘ sum) ==
          DataFrame(a=1:3, b=4:6, c=7:9, a_b_c_sum_sum=45)

    @test select(df, AsTable(:) => ByRow(x -> [x])) ==
          DataFrame(a_b_c_function=[[(a=1, b=4, c=7)],
                                    [(a=2, b=5, c=8)],
                                    [(a=3, b=6, c=9)]])
    @test transform(df, AsTable(:) => ByRow(x -> [x])) ==
          hcat(df, DataFrame(a_b_c_function=[[(a=1, b=4, c=7)],
                                             [(a=2, b=5, c=8)],
                                             [(a=3, b=6, c=9)]]))
    @test select(df, AsTable(:) => ByRow(identity)) ==
          DataFrame(a_b_c_identity=[(a=1, b=4, c=7), (a=2, b=5, c=8), (a=3, b=6, c=9)])
    @test select(df, AsTable(:) => ByRow(identity) => AsTable) == df
    @test select(df, AsTable(:) => ByRow(x -> df[1, :])) ==
          DataFrame(a_b_c_function=fill(df[1, :], 3))
    @test select(df, AsTable(:) => ByRow(x -> df[1, :]) => AsTable) ==
          DataFrame(a=[1, 1, 1], b=4, c=7)
    @test select(df, AsTable(:) => ByRow(x -> Tables.Row(df[1, :]))) ==
          DataFrame(a_b_c_function=fill(Tables.Row(df[1, :]), 3))
    @test select(df, AsTable(:) => ByRow(x -> Tables.Row(df[1, :])) => AsTable) ==
          DataFrame(a=[1, 1, 1], b=4, c=7)
    @test transform(df, AsTable(Not(:)) =>
          ByRow(identity)) == [df DataFrame(:identity => fill(NamedTuple(), nrow(df)))]

    @test select(df, AsTable(Not(:)) => Ref) == repeat(DataFrame(Ref=NamedTuple()), nrow(df))
    @test combine(df, AsTable(Not(:)) => Ref) == DataFrame(Ref=NamedTuple())
    @test transform(df, AsTable(Not(:)) => Ref) ==
          DataFrame(a=1:3, b=4:6, c=7:9, Ref=NamedTuple())

    df = DataFrame(x=[1, 2, missing], y=[1, missing, missing])
    @test transform(df, AsTable(:) .=>
                        ByRow.([sum∘skipmissing,
                                x -> count(!ismissing, x),
                                mean∘skipmissing]) .=>
                        [:sum, :n, :mean]) ≅
            [df DataFrame(sum=[2, 2, 0], n=[2, 1, 0], mean=[1, 2, NaN])]
end

@testset "make sure select! is safe on error" begin
    a = [1]
    df = DataFrame()
    df.a = a
    @test_throws DomainError select!(df, :a => x -> sqrt(-1))
    @test df.a === a
    @test propertynames(df) == [:a, ]
end

@testset "combine AbstractDataFrame" begin
    df = DataFrame(x=1:3, y=4:6)

    @test combine(x -> Matrix(x), df) == rename(df, [:x1, :x2])
    @test combine(x -> Ref(1:3), df) == DataFrame(x1=[1:3])
    @test combine(df, x -> Ref(1:3)) == DataFrame(x1=[1:3])

    @test_throws ArgumentError combine(df, AsTable(:) => identity)
    @test combine(df, AsTable(:) => identity => AsTable) == df
    @test combine(df, (:) => cor) == DataFrame(x_y_cor=1.0)
    @test combine(df, :x => x -> Ref(1:3)) == DataFrame(x_function=[1:3])
    @test_throws ArgumentError combine(df, :x => x -> ones(1, 1))
    @test combine(df, :x => (x -> ones(1, 1)) => AsTable) == DataFrame(x1=1.0)

    df2 = combine(df, :x => identity)
    @test df2[:, 1] == df.x
    @test df2[:, 1] !== df.x

    @test combine(df, :x => sum, :y => collect ∘ extrema) ==
          DataFrame(x_sum=[6, 6], y_collect_extrema=[4, 6])
    @test combine(df, :y => collect ∘ extrema, :x => sum) ==
          DataFrame(y_collect_extrema=[4, 6], x_sum=[6, 6])
    @test combine(df, :x => sum, :y => x -> []) ==
          DataFrame(x_sum=[], y_function=[])
    @test combine(df, :y => x -> [], :x => sum) ==
          DataFrame(y_function=[], x_sum=[])

    dfv = view(df, [2, 1], [2, 1])

    @test combine(x -> Matrix(x), dfv) == rename(dfv, [:x1, :x2])

    @test_throws ArgumentError combine(dfv, AsTable(:) => identity)
    @test combine(dfv, AsTable(:) => identity => AsTable) == dfv
    @test combine(dfv, (:) => cor) == DataFrame(y_x_cor=1.0)

    df2 = combine(dfv, :x => identity)
    @test df2[:, 1] == dfv.x
    @test df2[:, 1] !== dfv.x

    @test combine(dfv, :x => sum, :y => collect ∘ extrema) ==
          DataFrame(x_sum=[3, 3], y_collect_extrema=[4, 5])
    @test combine(dfv, :y => collect ∘ extrema, :x => sum) ==
          DataFrame(y_collect_extrema=[4, 5], x_sum=[3, 3])
end

@testset "select and transform AbstractDataFrame" begin
    df = DataFrame(x=1:3, y=4:6)

    @test select(df) == DataFrame()

    @test select(df, :x => first) == DataFrame(x_first=fill(1, 3))
    df2 = select(df, :x, :x => first, copycols=true)
    @test df2 == DataFrame(x=df.x, x_first=fill(1, 3))
    @test df2.x !== df.x
    df2 = select(df, :x, :x => first, copycols=false)
    @test df2 == DataFrame(x=df.x, x_first=fill(1, 3))
    @test df2.x === df.x
    @test_throws ArgumentError select(df, :x => x -> [first(x)], copycols=true)
    @test_throws ArgumentError select(df, :x => x -> [first(x)], copycols=false)

    df2 = transform(df, :x => first, copycols=true)
    @test df2 == [df DataFrame(x_first=fill(1, 3))]
    @test df2.x !== df.x
    @test df2.y !== df.y
    df2 = transform(df, :x => first, copycols=false)
    @test df2 == [df DataFrame(x_first=fill(1, 3))]
    @test df2.x === df.x
    @test df2.y === df.y
    @test transform(df, names(df) .=> first .=> names(df)) ==
          DataFrame(x=fill(1, 3), y=fill(4, 3))
    @test_throws ArgumentError transform(df, :x => x -> [first(x)], copycols=true)
    @test_throws ArgumentError transform(df, :x => x -> [first(x)], copycols=false)

    dfv = view(df, [2, 1], [2, 1])
    @test select(dfv, :x => first) == DataFrame(x_first=fill(2, 2))
    df2 = select(dfv, :x, :x => first, copycols=true)
    @test df2 == DataFrame(x=dfv.x, x_first=fill(2, 2))
    @test df2.x !== dfv.x
    @test_throws ArgumentError select(dfv, :x, :x => first, copycols=false)
    @test_throws ArgumentError select(dfv, :x => x -> [first(x)], copycols=true)
    @test_throws ArgumentError select(dfv, :x => x -> [first(x)], copycols=false)

    df2 = transform(dfv, :x => first, copycols=true)
    @test df2 == [dfv DataFrame(x_first=fill(2, 2))]
    @test df2.x !== dfv.x
    @test df2.y !== dfv.y
    @test_throws ArgumentError transform(dfv, :x => first, copycols=false)
    @test transform(dfv, names(dfv) .=> first .=> names(dfv)) ==
          DataFrame(y=fill(5, 2), x=fill(2, 2))
    @test_throws ArgumentError transform(df, :x => x -> [first(x)], copycols=true)
    @test_throws ArgumentError transform(df, :x => x -> [first(x)], copycols=false)
end

@testset "select! and transform! AbstractDataFrame" begin
    df = DataFrame(x=1:3, y=4:6)
    select!(df, :x => first)
    @test df == DataFrame(x_first=fill(1, 3))


    # if we select! we do copycols=false, so we do not get aliases
    df = DataFrame(x=1:3, y=4:6)
    x = df.x
    select!(df, :x => (x->x), :x)
    @test x === df.x_function
    @test x == df.x
    @test x !== df.x

    df = DataFrame(x=1:3, y=4:6)
    @test_throws ArgumentError select!(df, :x => x -> [1])
    @test df == DataFrame(x=1:3, y=4:6)

    df = DataFrame(x=1:3, y=4:6)
    x = df.x
    y = df.y
    transform!(df, :x => first)
    @test df == DataFrame(x=x, y=y, x_first=fill(1, 3))
    @test df.x == x
    @test df.y == y

    df = DataFrame(x=1:3, y=4:6)
    transform!(df, names(df) .=> first .=> names(df))
    @test df == DataFrame(x=fill(1, 3), y=fill(4, 3))

    df = DataFrame(x=1:3, y=4:6)
    @test_throws ArgumentError transform!(df, :x => x -> [1])
    @test df == DataFrame(x=1:3, y=4:6)

    dfv = view(df, [2, 1], [2, 1])
    @test_throws ArgumentError select!(dfv, 1)
    @test transform!(dfv, 1) == dfv
    @test df == DataFrame(x=1:3, y=4:6)
end

@testset "renamecols=false tests" begin
    df = DataFrame(a=1:3, b=4:6, c=7:9, d=10:12)
    @test select(df, :a => +, [:a, :b] => +, All() => +, renamecols=false) ==
          DataFrame(a=1:3, a_b=5:2:9, a_b_etc=22:4:30)
    @test select(df, :a => +, [:a, :b] => +, Cols(:) => +, renamecols=false) ==
          DataFrame(a=1:3, a_b=5:2:9, a_b_etc=22:4:30)
    @test_throws ArgumentError select(df, [] => () -> 10, renamecols=false)
    @test transform(df, :a => +, [:a, :b] => +, All() => +, renamecols=false) ==
          DataFrame(a=1:3, b=4:6, c=7:9, d=10:12, a_b=5:2:9, a_b_etc=22:4:30)
    @test combine(df, :a => +, [:a, :b] => +, All() => +, renamecols=false) ==
          DataFrame(a=1:3, a_b=5:2:9, a_b_etc=22:4:30)
    @test combine(df, [:a, :b] => +, renamecols=false) == DataFrame(a_b=5:2:9)
    @test combine(identity, df, renamecols=false) == df

    df = DataFrame(a=1:3, b=4:6, c=7:9, d=10:12)
    @test select!(df, :a => +, [:a, :b] => +, All() => +, renamecols=false) == df
    @test df == DataFrame(a=1:3, a_b=5:2:9, a_b_etc=22:4:30)

    df = DataFrame(a=1:3, b=4:6, c=7:9, d=10:12)
    @test transform!(df, :a => +, [:a, :b] => +, All() => +, renamecols=false) == df
    @test df == DataFrame(a=1:3, b=4:6, c=7:9, d=10:12, a_b=5:2:9, a_b_etc=22:4:30)

    df = DataFrame(a=1:3, b=4:6, c=7:9, d=10:12)
    @test transform!(df, :a => +, [:a, :b] => +, Cols(:) => +, renamecols=false) == df
    @test df == DataFrame(a=1:3, b=4:6, c=7:9, d=10:12, a_b=5:2:9, a_b_etc=22:4:30)
end

@testset "transformation function with a function as first argument" begin
    for df in (DataFrame(a=1:2, b=3:4, c=5:6), view(DataFrame(a=1:3, b=3:5, c=5:7, d=11:13), 1:2, 1:3))
        @test select(sdf -> sdf.b, df) == DataFrame(x1=3:4)
        @test select(sdf -> (b = 2sdf.b,), df) == DataFrame(b=[6, 8])
        @test select(sdf -> (b = 1,), df) == DataFrame(b=[1, 1])
        @test_throws ArgumentError select(sdf -> (b = [1],), df)
        @test select(sdf -> (b = [1, 5],), df) == DataFrame(b=[1, 5])
        @test select(sdf -> 1, df) == DataFrame(x1=[1, 1])
        @test select(sdf -> fill([1]), df) == DataFrame(x1=[[1], [1]])
        @test select(sdf -> Ref([1]), df) == DataFrame(x1=[[1], [1]])
        @test select(sdf -> "x", df) == DataFrame(x1=["x", "x"])
        @test select(sdf -> [[1, 2], [3, 4]], df) == DataFrame(x1=[[1, 2], [3, 4]])
        for ret in (DataFrame(), NamedTuple(), zeros(0, 0), DataFrame(t=1)[1, 1:0], Tables.Row(DataFrame(t=1)[1, 1:0]))
            @test select(sdf -> ret, df) == DataFrame()
        end
        @test_throws ArgumentError select(sdf -> DataFrame(a=10), df)
        @test_throws ArgumentError select(sdf -> zeros(1, 2), df)
        @test select(sdf -> DataFrame(a=[10, 11]), df) == DataFrame(a=[10, 11])
        @test select(sdf -> [10 11; 12 13], df) == DataFrame(x1=[10, 12], x2=[11, 13])
        @test select(sdf -> DataFrame(a=10)[1, :], df) == DataFrame(a=[10, 10])

        @test transform(sdf -> sdf.b, df) == [df DataFrame(x1=3:4)]
        @test transform(sdf -> (b = 2sdf.b,), df) == DataFrame(a=1:2, b=[6, 8], c=5:6)
        @test transform(sdf -> (b = 1,), df) == DataFrame(a=[1, 2], b=[1, 1], c=[5, 6])
        @test_throws ArgumentError transform(sdf -> (b = [1],), df)
        @test transform(sdf -> (b = [1, 5],), df) == DataFrame(a=[1, 2], b=[1, 5], c=[5, 6])
        @test transform(sdf -> 1, df) == DataFrame(a=1:2, b=3:4, c=5:6, x1=1)
        @test transform(sdf -> fill([1]), df) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1], [1]])
        @test transform(sdf -> Ref([1]), df) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1], [1]])
        @test transform(sdf -> "x", df) == DataFrame(a=1:2, b=3:4, c=5:6, x1="x")
        @test transform(sdf -> [[1, 2], [3, 4]], df) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1, 2], [3, 4]])
        for ret in (DataFrame(), NamedTuple(), zeros(0, 0), DataFrame(t=1)[1, 1:0])
            @test transform(sdf -> ret, df) == df
        end
        @test_throws ArgumentError transform(sdf -> DataFrame(a=10), df)
        @test_throws ArgumentError transform(sdf -> zeros(1, 2), df)
        @test transform(sdf -> DataFrame(a=[10, 11]), df) == DataFrame(a=[10, 11], b=3:4, c=5:6)
        @test transform(sdf -> [10 11; 12 13], df) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[10, 12], x2=[11, 13])
        @test transform(sdf -> DataFrame(a=10)[1, :], df) == DataFrame(a=[10, 10], b=3:4, c=5:6)

        @test combine(sdf -> sdf.b, df) == DataFrame(x1=3:4)
        @test combine(sdf -> (b = 2sdf.b,), df) == DataFrame(b=[6, 8])
        @test combine(sdf -> (b = 1,), df) == DataFrame(b=[1])
        @test combine(sdf -> (b = [1],), df) == DataFrame(b=[1])
        @test combine(sdf -> (b = [1, 5],), df) == DataFrame(b=[1, 5])
        @test combine(sdf -> 1, df) == DataFrame(x1=[1])
        @test combine(sdf -> fill([1]), df) == DataFrame(x1=[[1]])
        @test combine(sdf -> Ref([1]), df) == DataFrame(x1=[[1]])
        @test combine(sdf -> "x", df) == DataFrame(x1=["x"])
        @test combine(sdf -> [[1, 2], [3, 4]], df) == DataFrame(x1=[[1, 2], [3, 4]])
        for ret in (DataFrame(), NamedTuple(), zeros(0, 0), DataFrame(t=1)[1, 1:0])
            @test combine(sdf -> ret, df) == DataFrame()
        end
        @test combine(sdf -> DataFrame(a=10), df) == DataFrame(a=10)
        @test combine(sdf -> zeros(1, 2), df) == DataFrame(x1=0, x2=0)
        @test combine(sdf -> DataFrame(a=[10, 11]), df) == DataFrame(a=[10, 11])
        @test combine(sdf -> [10 11; 12 13], df) == DataFrame(x1=[10, 12], x2=[11, 13])
        @test combine(sdf -> DataFrame(a=10)[1, :], df) == DataFrame(a=[10])
    end

    df = DataFrame(a=1:2, b=3:4, c=5:6)
    @test select!(sdf -> sdf.b, copy(df)) == DataFrame(x1=3:4)
    @test select!(sdf -> (b = 2sdf.b,), copy(df)) == DataFrame(b=[6, 8])
    @test select!(sdf -> (b = 1,), copy(df)) == DataFrame(b=[1, 1])
    @test_throws ArgumentError select!(sdf -> (b = [1],), copy(df))
    @test select!(sdf -> (b = [1, 5],), copy(df)) == DataFrame(b=[1, 5])
    @test select!(sdf -> 1, copy(df)) == DataFrame(x1=[1, 1])
    @test select!(sdf -> fill([1]), copy(df)) == DataFrame(x1=[[1], [1]])
    @test select!(sdf -> Ref([1]), copy(df)) == DataFrame(x1=[[1], [1]])
    @test select!(sdf -> "x", copy(df)) == DataFrame(x1=["x", "x"])
    @test select!(sdf -> [[1, 2], [3, 4]], copy(df)) == DataFrame(x1=[[1, 2], [3, 4]])
    for ret in (DataFrame(), NamedTuple(), zeros(0, 0), DataFrame(t=1)[1, 1:0])
        @test select!(sdf -> ret, copy(df)) == DataFrame()
    end
    @test_throws ArgumentError select!(sdf -> DataFrame(a=10), copy(df))
    @test_throws ArgumentError select!(sdf -> zeros(1, 2), copy(df))
    @test select!(sdf -> DataFrame(a=[10, 11]), copy(df)) == DataFrame(a=[10, 11])
    @test select!(sdf -> [10 11; 12 13], copy(df)) == DataFrame(x1=[10, 12], x2=[11, 13])
    @test select!(sdf -> DataFrame(a=10)[1, :], copy(df)) == DataFrame(a=[10, 10])

    @test transform!(sdf -> sdf.b, copy(df)) == [df DataFrame(x1=3:4)]
    @test transform!(sdf -> (b = 2sdf.b,), copy(df)) == DataFrame(a=1:2, b=[6, 8], c=5:6)
    @test transform!(sdf -> (b = 1,), copy(df)) == DataFrame(a=[1, 2], b=[1, 1], c=[5, 6])
    @test_throws ArgumentError transform!(sdf -> (b = [1],), copy(df))
    @test transform!(sdf -> (b = [1, 5],), copy(df)) == DataFrame(a=[1, 2], b=[1, 5], c=[5, 6])
    @test transform!(sdf -> 1, copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1=1)
    @test transform!(sdf -> fill([1]), copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1], [1]])
    @test transform!(sdf -> Ref([1]), copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1], [1]])
    @test transform!(sdf -> "x", copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1="x")
    @test transform!(sdf -> [[1, 2], [3, 4]], copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[[1, 2], [3, 4]])
    for ret in (DataFrame(), NamedTuple(), zeros(0, 0), DataFrame(t=1)[1, 1:0])
        @test transform!(sdf -> ret, copy(df)) == df
    end
    @test_throws ArgumentError transform!(sdf -> DataFrame(a=10), copy(df))
    @test_throws ArgumentError transform!(sdf -> zeros(1, 2), copy(df))
    @test transform!(sdf -> DataFrame(a=[10, 11]), copy(df)) == DataFrame(a=[10, 11], b=3:4, c=5:6)
    @test transform!(sdf -> [10 11; 12 13], copy(df)) == DataFrame(a=1:2, b=3:4, c=5:6, x1=[10, 12], x2=[11, 13])
    @test transform!(sdf -> DataFrame(a=10)[1, :], copy(df)) == DataFrame(a=[10, 10], b=3:4, c=5:6)

    @test_throws ArgumentError combine(:x => identity, DataFrame(x=[1, 2, 3]))
end

@testset "transformation function with multiple columns as destination" begin
    for df in (DataFrame(a=1:2, b=3:4, c=5:6), view(DataFrame(a=1:3, b=3:5, c=5:7, d=11:13), 1:2, 1:3))
        for fun in (select, combine, transform),
            res in (DataFrame(), DataFrame(a=1, b=2)[1, :], ones(1, 1),
                    (a=1, b=2), (a=[1], b=[2]), (a=1, b=[2]))
            @test_throws ArgumentError fun(df, :a => x -> res)
            @test_throws ArgumentError fun(df, :a => (x -> res) => :z)
        end
        for res in (DataFrame(x1=1, x2=2)[1, :], (x1=1, x2=2))
            @test select(df, :a => (x -> res) => AsTable) == DataFrame(x1=[1, 1], x2=[2, 2])
            @test transform(df, :a => (x -> res) => AsTable) == [df DataFrame(x1=[1, 1], x2=[2, 2])]
            @test combine(df, :a => (x -> res) => AsTable) == DataFrame(x1=[1], x2=[2])
            @test select(df, :a => (x -> res) => [:p, :q]) == DataFrame(p=[1, 1], q=[2, 2])
            @test transform(df, :a => (x -> res) => [:p, :q]) == [df DataFrame(p=[1, 1], q=[2, 2])]
            @test combine(df, :a => (x -> res) => [:p, :q]) == DataFrame(p=[1], q=[2])
            @test_throws ArgumentError select(df, :a => (x -> res) => [:p, :q, :r])
            @test_throws ArgumentError select(df, :a => (x -> res) => [:p])
        end
        for res in (DataFrame(x1=1, x2=2), [1 2], Tables.table([1 2], header=[:x1, :x2]),
                    (x1=[1], x2=[2]))
            @test combine(df, :a => (x -> res) => AsTable) == DataFrame(x1=1, x2=2)
            @test combine(df, :a => (x -> res) => [:p, :q]) == DataFrame(p=1, q=2)
            @test_throws ArgumentError combine(df, :a => (x -> res) => [:p])
            @test_throws ArgumentError select(df, :a => (x -> res) => AsTable)
            @test_throws ArgumentError transform(df, :a => (x -> res) => AsTable)
        end
        @test combine(df, :a => ByRow(x -> [x, x+1]),
                      :a => ByRow(x -> [x, x+1]) => AsTable,
                      :a => ByRow(x -> [x, x+1]) => [:p, :q],
                      :a => ByRow(x -> (s=x, t=x+1)) => AsTable,
                      :a => (x -> (k=x, l=x.+1)) => AsTable,
                      :a => ByRow(x -> (s=x, t=x+1)) => :z) ==
              DataFrame(a_function=[[1, 2], [2, 3]], x1=[1, 2], x2=[2, 3],
                        p=[1, 2], q=[2, 3], s=[1, 2], t=[2, 3], k=[1, 2], l=[2, 3],
                        z=[(s=1, t=2), (s=2, t=3)])
        @test select(df, :a => ByRow(x -> [x, x+1]),
                     :a => ByRow(x -> [x, x+1]) => AsTable,
                     :a => ByRow(x -> [x, x+1]) => [:p, :q],
                     :a => ByRow(x -> (s=x, t=x+1)) => AsTable,
                     :a => (x -> (k=x, l=x.+1)) => AsTable,
                     :a => ByRow(x -> (s=x, t=x+1)) => :z) ==
              DataFrame(a_function=[[1, 2], [2, 3]], x1=[1, 2], x2=[2, 3],
                        p=[1, 2], q=[2, 3], s=[1, 2], t=[2, 3], k=[1, 2], l=[2, 3],
                        z=[(s=1, t=2), (s=2, t=3)])
        @test transform(df, :a => ByRow(x -> [x, x+1]),
                        :a => ByRow(x -> [x, x+1]) => AsTable,
                        :a => ByRow(x -> [x, x+1]) => [:p, :q],
                        :a => ByRow(x -> (s=x, t=x+1)) => AsTable,
                        :a => (x -> (k=x, l=x.+1)) => AsTable,
                        :a => ByRow(x -> (s=x, t=x+1)) => :z) ==
              [df DataFrame(a_function=[[1, 2], [2, 3]], x1=[1, 2], x2=[2, 3],
                            p=[1, 2], q=[2, 3], s=[1, 2], t=[2, 3], k=[1, 2], l=[2, 3],
                            z=[(s=1, t=2), (s=2, t=3)])]
        @test_throws ArgumentError select(df, :a => (x -> [(a=1, b=2), (a=1, b=2, c=3)]) => AsTable)
        @test_throws ArgumentError select(df, :a => (x -> [(a=1, b=2), (a=1, c=3)]) => AsTable)
        @test_throws ArgumentError combine(df, :a => (x -> (a=1, b=2)) => :x)
    end
end

@testset "check correctness of duplicate column names" begin
    for df in (DataFrame(a=1:2, b=3:4, c=5:6), view(DataFrame(a=1:3, b=3:5, c=5:7, d=11:13), 1:2, 1:3))
        @test select(df, :b, :) == DataFrame(b=3:4, a=1:2, c=5:6)
        @test select(df, :b => :c, :) == DataFrame(c=3:4, a=1:2, b=3:4)
        @test_throws ArgumentError select(df, :b => [:c, :d], :)
        @test_throws ArgumentError select(df, :a, :a => x -> (a=[1, 2], b=[3, 4]))
        @test_throws ArgumentError select(df, :a, :a => (x -> (a=[1, 2], b=[3, 4])) => AsTable)
        @test select(df, [:b, :a], :a => (x -> (a=[11, 12], b=[13, 14])) => AsTable, :) ==
              DataFrame(b=[13, 14], a=[11, 12], c=[5, 6])
        @test select(df, [:b, :a], :a => (x -> (a=[11, 12], b=[13, 14])) => [:b, :a], :) ==
              DataFrame(b=[11, 12], a=[13, 14], c=[5, 6])
    end
end

@testset "empty ByRow" begin
    df = DataFrame(a=1:3)

    @test select(df, [] => ByRow(() -> 1)) == DataFrame("function" => [1, 1, 1])
    @test combine(df, [] => ByRow(() -> 1)) == DataFrame("function" => [1, 1, 1])
    @test transform(df, [] => ByRow(() -> 1)) == DataFrame("a" => 1:3, "function" => [1, 1, 1])

    for df in (DataFrame(), DataFrame(a=[]))
        @test select(df, [] => ByRow(() -> 1)) == DataFrame("function" => [])
        @test combine(df, [] => ByRow(() -> 1)) == DataFrame("function" => [])
        if ncol(df) == 0
            @test transform(df, [] => ByRow(() -> 1)) == DataFrame("function" => [])
        else
            @test transform(df, [] => ByRow(() -> 1)) == DataFrame("a" => [], "function" => [])
        end
        @test eltype(select(df, [] => ByRow(() -> 1)).function) == Int
        @test eltype(combine(df, [] => ByRow(() -> 1)).function) == Int
        @test eltype(transform(df, [] => ByRow(() -> 1)).function) == Int

        @test select(df, [] => ByRow(() -> (a=1, b="1")) => AsTable) ≃
              DataFrame(a=Int[], b=String[])
        @test select(df, [] => ByRow(() -> (a=1, b="1")) => [:p, :q]) ≃
              DataFrame(p=Int[], q=String[])

        # here this follows Tables.jl behavior
        @test select(df, [] => ByRow(() -> [1, "1"]) => AsTable) == DataFrame()
        @test_throws ArgumentError select(df, [] => ByRow(() -> [1, "1"]) => [:p, :q])
        @test select(df, [] => ByRow(() -> (1, "1")) => AsTable) ≃
              DataFrame(Column1=Int[], Column2=String[])
        @test select(df, [] => ByRow(() -> (1, "1")) => [:p, :q]) ≃
              DataFrame(p=Int[], q=String[])
    end

    @test select(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("function" => [1, 1, 1])
    @test combine(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("function" => [1, 1, 1])
    @test transform(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("a" => 1:3, "function" => [1, 1, 1])

    for df in (DataFrame(), DataFrame(a=[]))
        @test select(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("function" => [])
        @test combine(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("function" => [])
        if ncol(df) == 0
            @test transform(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("function" => [])
        else
            @test transform(df, AsTable([]) => ByRow(x -> 1)) == DataFrame("a" => [], "function" => [])
        end
        @test eltype(select(df, AsTable([]) => ByRow(x -> 1)).function) == Int
        @test eltype(combine(df, AsTable([]) => ByRow(x -> 1)).function) == Int
        @test eltype(transform(df, AsTable([]) => ByRow(x -> 1)).function) == Int

        @test select(df, AsTable([]) => ByRow(x -> (a=1, b="1")) => AsTable) ≃
              DataFrame(a=Int[], b=String[])
        @test select(df, AsTable([]) => ByRow(x -> (a=1, b="1")) => [:p, :q]) ≃
              DataFrame(p=Int[], q=String[])

        # here this follows Tables.jl behavior
        @test select(df, [] => ByRow(() -> [1, "1"]) => AsTable) == DataFrame()
        @test_throws ArgumentError select(df, [] => ByRow(() -> [1, "1"]) => [:p, :q])
        @test select(df, [] => ByRow(() -> (1, "1")) => AsTable) ≃
              DataFrame(Column1=Int[], Column2=String[])
        @test select(df, [] => ByRow(() -> (1, "1")) => [:p, :q]) ≃
              DataFrame(p=Int[], q=String[])
    end
end

@testset "selection special cases" begin
    df = DataFrame(a=1)
    @test_throws ArgumentError select(df, '1' => sum => "b")
    @test_throws ArgumentError select(df, '1' => sum)
    @test select(df, ["a", "a"] => (+) => "b") == DataFrame(b=2)
    @test_throws ArgumentError combine(df, :a => (x -> (a=1, b=[2])) => AsTable)
    @test_throws ArgumentError combine(:, df)
    @test_throws ArgumentError select(:, df)
    @test_throws ArgumentError select!(:, df)
    @test_throws ArgumentError transform(:, df)
    @test_throws ArgumentError transform!(:, df)
    @test combine(df, :a => (x -> 1) => :x1, :a => (x -> [1, 2]) => :x2) ==
          DataFrame(x1=1, x2=[1, 2])
    @test combine(df, :a => (x -> 1) => :x1, :a => (x -> []) => :x2) ≃
          DataFrame(x1=Int[], x2=[])
end

@testset "test resizing via a vector of columns after scalars" begin
    df = DataFrame(a=1:2)
    @test combine(df, :a => (x -> 1) => :a1, :a => (x -> 2) => :a2, [:a]) ==
          DataFrame(a1=1, a2=2, a=1:2)
    @test select(df, :a => (x -> 1) => :a1, :a => (x -> 2) => :a2, [:a]) ==
          DataFrame(a1=1, a2=2, a=1:2)
    @test_throws ArgumentError combine(df, :a => (x -> 1) => :a1, :a => (x -> [2]) => :a2, [:a])
    @test_throws ArgumentError select(df, :a => (x -> 1) => :a1, :a => (x -> [2]) => :a2, [:a])
end

@testset "normalize_selection" begin
    @test DataFrames.normalize_selection(DataFrames.Index(Dict(:a => 1, :b => 2), [:a, :b]),
                                         [:a] => sum, false) == (1 => (sum => :a))

    @test DataFrames.normalize_selection(DataFrames.Index(Dict(:a => 1, :b => 2), [:a, :b]),
                                         [:a] => sum => [:new],  false) == (1 => (sum => [:new]))

    # Test that target col strings are converted to Symbols
    @test DataFrames.normalize_selection(DataFrames.Index(Dict(:a => 1, :b => 2), [:a, :b]),
                                         [:a] => sum => ["new"],  false) == (1 => (sum => [:new]))
end

@testset "copying in transform when renaming" begin
    for oldcol in (:a, "a", 1), newcol in (:b, "b")
        df = DataFrame(a=1)
        df2 = transform(df, oldcol => newcol)
        @test df2.b == df2.a == df.a
        @test df2.b !== df2.a
        @test df2.b !== df.a
        @test df2.a !== df.a

        df2 = transform(df, oldcol => newcol, copycols=false)
        @test df2.b == df2.a == df.a
        @test df2.b !== df2.a
        @test df2.b !== df.a
        @test df2.a === df.a

        a = df.a
        transform!(df, oldcol => newcol)
        @test df.b == df.a == a
        @test df.b !== df.a
        @test df.b !== a
        @test df.a === a
    end
end

@testset ":col => AsTable and :col => cols" begin
    df = DataFrame(id=1:2, c1=[(a=1, b=2), (a=3, b=4)], c2=[(11, 12), (13, 14)])
    @test select(df, :c1 => AsTable) == DataFrame(a=[1, 3], b=[2, 4])
    @test select(df, :c1 => [:p, :q]) == DataFrame(p=[1, 3], q=[2, 4])
    @test select(df, :c2 => AsTable) == DataFrame(x1=[11, 13], x2=[12, 14])
    @test select(df, :c2 => [:p, :q]) == DataFrame(p=[11, 13], q=[12, 14])
    @test_throws ArgumentError select(df, [:c1, :c2] => AsTable)
    @test_throws ArgumentError select(df, [:c1, :c2] => AsTable)
    gdf = groupby(df, :id)
    @test select(gdf, :c1 => AsTable) == DataFrame(id=1:2, a=[1, 3], b=[2, 4])
    @test select(gdf, :c1 => [:p, :q]) == DataFrame(id=1:2, p=[1, 3], q=[2, 4])
    @test select(gdf, :c2 => AsTable) == DataFrame(id=1:2, x1=[11, 13], x2=[12, 14])
    @test select(gdf, :c2 => [:p, :q]) == DataFrame(id=1:2, p=[11, 13], q=[12, 14])
    @test_throws ArgumentError select(gdf, [:c1, :c2] => AsTable)
    @test_throws ArgumentError select(gdf, [:c1, :c2] => AsTable)
end

@testset "ByRow on PooledArray calls function on each entry" begin
    id = 0
    df = DataFrame(a=PooledArray([1, 1, 1]))
    function f(x)
        id += 1
        return id
    end
    @test select(df, :a => ByRow(f) => :a) == DataFrame(a=1:3)
end

@testset "wide reductions" begin
    Random.seed!(1234)
    df = DataFrame(rand(Int64(1):Int64(10^6), 2, 20_000), :auto)
    df2 = Int32.(df)
    df.x100 = [1, 2]
    df.x1000 = Union{Int, Missing}[1, 2]
    df.x10000 = Union{Float64, Missing}[1, missing]

    @test @elapsed(select(df, All() => (+) => :res)) < 10.0
    @test @elapsed(select(df, Between(:x2,:x19999) => ByRow(+) => :res)) < 10.0
    @test @elapsed(select(df, AsTable(All()) => sum => :res)) < 10.0
    @test @elapsed(select(df, AsTable(Not(:x99)) => ByRow(sum) => :res)) < 10.0

    for sel in (All(), Between(:x2,:x19999), Not(:x99))
        @test select(df, sel => (+) => :res) ≅
              select(df, sel => ByRow(+) => :res) ≅
              select(df, AsTable(sel) => sum => :res) ≅
              select(df, AsTable(sel) => ByRow(sum) => :res) ≅
              DataFrame(res=sum(collect(eachcol(select(df, sel)))))
        @test select(df, AsTable(sel) => mean => :res) ≅
              select(df, AsTable(sel) => ByRow(mean) => :res) ≅
              DataFrame(res=mean(collect(eachcol(select(df, sel)))))
    end

    df2.x100 = Int32[1, 2]
    df2.x1000 = Union{Int32, Missing}[1, 2]
    df2.x10000 = Union{Float64, Missing}[1, missing]

    @test @elapsed(select(df2, All() => (+) => :res)) < 10.0
    @test @elapsed(select(df2, Between(:x2,:x19999) => ByRow(+) => :res)) < 10.0
    @test @elapsed(select(df2, AsTable(All()) => sum => :res)) < 10.0
    @test @elapsed(select(df2, AsTable(Not(:x99)) => ByRow(sum) => :res)) < 10.0

    for sel in (All(), Between(:x2,:x19999), Not(:x99))
        @test select(df2, sel => (+) => :res) ≅
              select(df2, sel => ByRow(+) => :res) ≅
              select(df2, AsTable(sel) => sum => :res) ≅
              DataFrame(res=sum(collect(eachcol(select(df2, sel)))))

        # Note that this is exact as opposed to other options for Int32 type
        @test select(df2, AsTable(sel) => ByRow(sum) => :res) ≅
              select(df, AsTable(sel) => ByRow(sum) => :res)

        @test select(df2, AsTable(sel) => mean => :res) ≅
              DataFrame(res=mean(collect(eachcol(select(df2, sel)))))

        # Note that this is exact as opposed to other options for
        # Int32 type on Julia 1.0
        @test select(df2, AsTable(sel) => ByRow(mean) => :res) ≅
              select(df, AsTable(sel) => ByRow(mean) => :res)
    end
end

@testset "vectors of pairs with non-specific type are accepted" begin
    df = DataFrame(x=[1,2,3])
    @test combine(df, [1 => length => :a, 1 => length => "b"]) == DataFrame(a=3, b=3)
    @test combine(df, [:x => length => :a, 1 => :b]) == DataFrame(a=3, b=1:3)
    gdf = groupby(df, :x)
    @test combine(gdf, [1 => length => :a, 1 => length => "b"]) == DataFrame(x=1:3, a=1, b=1)
    @test combine(gdf, [:x => length => :a, 1 => :b]) == DataFrame(x=1:3, a=1, b=1:3)
    sdf = view(df, :, :)
    @test select(sdf, [1 => length => :a, 1 => length => "b"]) == DataFrame(a=[3, 3, 3], b=[3, 3, 3])
    @test select(sdf, [:x => length => :a, 1 => :b]) == DataFrame(a=3, b=1:3)
    @test_throws ArgumentError select(sdf, [1 => length => :a, 1 => length => "b"], copycols=false)
    @test_throws ArgumentError select(sdf, [:x => length => :a, 1 => :b], copycols=false)
end

@testset "fast reductions positional: cols => ..." begin
    Random.seed!(1234)
    m = rand(10, 10000)
    df = DataFrame(m, :auto)
    @test combine(df, All() => (+) => :sum).sum ≃
          combine(df, All() => ByRow(+) => :sum).sum ≃
          reduce(+, collect(eachcol(df)))
    @test combine(df, All() => ByRow(min) => :min).min ≃ minimum.(eachrow(m))
    @test combine(df, All() => ByRow(max) => :max).max ≃ maximum.(eachrow(m))

    df = DataFrame(ones(UInt8, 10, 256), :auto)
    @test combine(df, All() => (+) => :sum).sum ≃
          combine(df, All() => ByRow(+) => :sum).sum ≃
          zeros(UInt8, 10)

    m = rand([big(1),big(2)], 10, 10000)
    df = DataFrame(m, :auto)
    df.x1000 = fill(1.5, 10)
    @test combine(df, All() => (+) => :sum).sum ≃
          combine(df, All() => ByRow(+) => :sum).sum ≃
          reduce(+, collect(eachcol(df)))
    @test combine(df, All() => ByRow(min) => :min).min == minimum.(eachrow(m))
    @test combine(df, All() => ByRow(max) => :max).max == maximum.(eachrow(m))
    @test combine(df, All() => (+) => :sum).sum isa Vector{BigFloat}
    @test combine(df, All() => ByRow(+) => :sum).sum isa Vector{BigFloat}
    @test combine(df, All() => ByRow(min) => :min).min isa Vector{BigFloat}
    @test combine(df, All() => ByRow(max) => :max).max isa Vector{BigFloat}

    df.x2000 = fill('a', 10)
    @test_throws MethodError combine(df, All() => (+) => :sum)
    @test_throws MethodError combine(df, All() => ByRow(+) => :sum)
    @test_throws MethodError combine(df, All() => ByRow(min) => :min)
    @test_throws MethodError combine(df, All() => ByRow(max) => :max)

    m = rand([1, missing], 10, 10000)
    df = DataFrame(m, :auto)
    @test combine(df, All() => (+) => :sum).sum ≃ fill(missing, 10)
    @test combine(df, All() => ByRow(+) => :sum).sum ≃ fill(missing, 10)
    @test combine(df, All() => ByRow(min) => :min).min ≃ missings(Int, 10)
    @test combine(df, All() => ByRow(max) => :max).max ≃ missings(Int, 10)
end

@testset "fast reductions: AsTable(cols)=>sum, mean, minimum, maximum variants" begin
    Random.seed!(1234)
    m = rand(10, 10000)
    df = DataFrame(m, :auto)

    # note that the sums below are not the same due to how Julia Base works
    @test combine(df, AsTable(:) => sum => :sum).sum ≃
          sum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃
          combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum ≃
          sum.(eachrow(df))

    @test combine(df, AsTable(:) => mean => :mean).mean ≃
          mean(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃
          combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean ≃
          mean.(eachrow(df))

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃
          minimum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃
          combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum ≃
          minimum.(eachrow(df))

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃
          maximum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃
          combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum ≃
          maximum.(eachrow(df))

    m = fill(UInt8(1), 10, 10000)
    df = DataFrame(m, :auto)

    # note that the sums below are not the same due to how Julia Base works
    @test combine(df, AsTable(:) => sum => :sum).sum ≃ fill(0x10, 10)
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃
          combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum ≃
          fill(UInt(10000), 10)

    @test combine(df, AsTable(:) => mean => :mean).mean ≃ fill(1.0, 10)

    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃
          combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean ≃
          fill(1.0, 10)

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃
          combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃
          combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum ≃
          fill(0x1, 10)

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃
          combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃
          combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum ≃
          fill(0x1, 10)

    m = rand([1, missing], 10, 10000)
    df = DataFrame(m, :auto)
    @test combine(df, AsTable(:) => sum => :sum).sum ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum ≃ count.(!ismissing, eachrow(m))

    @test combine(df, AsTable(:) => mean => :mean).mean ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃ missings(Float64, 10)
    @test combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean ≃ fill(1.0, 10)

    m = rand([1, 2, missing], 10, 10000)
    df = DataFrame(m, :auto)

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃
        minimum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum ≃ fill(1, 10)

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃
        maximum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum ≃ fill(2, 10)

    m = fill(missing, 10, 100)
    df = DataFrame(m, :auto)
    @test combine(df, AsTable(:) => sum => :sum).sum ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃ fill(missing, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum
    @test combine(df, AsTable(:) => mean => :mean).mean ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃ fill(missing, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃ fill(missing, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃ fill(missing, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum

    m = missings(Int, 10, 10000)
    df = DataFrame(m, :auto)
    @test combine(df, AsTable(:) => sum => :sum).sum ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum ≃ fill(0, 10)

    @test combine(df, AsTable(:) => mean => :mean).mean ≃ fill(missing, 10)
    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃ missings(Float64, 10)
    @test combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean ≃ fill(NaN, 10)

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃ missings(Int, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃ missings(Int, 10)
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃ missings(Int, 10)
    @test_throws ArgumentError combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum

    m = rand([big(1),big(2)], 10, 100)
    df = DataFrame(m, :auto)
    df.x10 = fill(1.5, 10)
    @test combine(df, AsTable(:) => sum => :sum).sum ≃
          combine(df, AsTable(:) => ByRow(sum) => :sum).sum ≃
          combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum ≃
          sum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => sum => :sum).sum isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(sum) => :sum).sum isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum).sum isa Vector{BigFloat}

    @test combine(df, AsTable(:) => mean => :mean).mean ≃
          combine(df, AsTable(:) => ByRow(mean) => :mean).mean ≃
          combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean ≃
          mean(collect(eachcol(df)))
    @test combine(df, AsTable(:) => mean => :mean).mean isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(mean) => :mean).mean isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean).mean isa Vector{BigFloat}

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃
          minimum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum ≃
          combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum ≃
          fill(big(1.0), 10)
    @test combine(df, AsTable(:) => minimum => :minimum).minimum isa Vector{BigInt}
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum).minimum isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum).minimum isa Vector{BigFloat}

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃
          maximum(collect(eachcol(df)))
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum ≃
          combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum ≃
          fill(big(2.0), 10)
    @test combine(df, AsTable(:) => maximum => :maximum).maximum isa Vector{BigInt}
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum).maximum isa Vector{BigFloat}
    @test combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum).maximum isa Vector{BigFloat}

    df.x20 = fill('a', 10)
    @test_throws MethodError combine(df, AsTable(:) => sum => :sum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(sum) => :sum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum)

    @test_throws MethodError combine(df, AsTable(:) => mean => :mean)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(mean) => :mean)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean)

    @test_throws MethodError combine(df, AsTable(:) => minimum => :minimum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(minimum) => :minimum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum)

    @test_throws MethodError combine(df, AsTable(:) => minimum => :minimum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(minimum) => :minimum)
    @test_throws MethodError combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum)

    m = rand(Any[1], 10, 100)
    df = DataFrame(m, :auto)
    @test combine(df, AsTable(:) => sum => :sum) ≃
          combine(df, AsTable(:) => ByRow(sum) => :sum) ≃
          combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :sum) ≃
          DataFrame(sum=fill(100, 10))

    @test combine(df, AsTable(:) => mean => :mean) ≃
          combine(df, AsTable(:) => ByRow(mean) => :mean) ≃
          combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :mean) ≃
          DataFrame(mean=fill(1.0, 10))

    m = rand(Any[1, 2], 10, 100)
    df = DataFrame(m, :auto)

    @test combine(df, AsTable(:) => minimum => :minimum).minimum ≃
          minimum(eachcol(df))
    @test combine(df, AsTable(:) => ByRow(minimum) => :minimum) ≃
          combine(df, AsTable(:) => ByRow(minimum∘skipmissing) => :minimum) ≃
          DataFrame(minimum=Any[1 for i in 1:10])

    @test combine(df, AsTable(:) => maximum => :maximum).maximum ≃
          maximum(eachcol(df))
    @test combine(df, AsTable(:) => ByRow(maximum) => :maximum) ≃
          combine(df, AsTable(:) => ByRow(maximum∘skipmissing) => :maximum) ≃
          DataFrame(maximum=Any[2 for i in 1:10])
end

@testset "fast reductions: AsTable(cols)=>length variants" begin
    Random.seed!(1234)
    m = rand([1, missing], 10, 10000)
    df = DataFrame(m, :auto)
    @test combine(df, AsTable(:) => length => :len) ≃ DataFrame(len=10000)
    @test combine(df, AsTable(:) => ByRow(length) => :len) ≃
          DataFrame(len=fill(10000, 10))
    @test combine(df, AsTable(:) => ByRow(length∘skipmissing) => :len) ≃
          DataFrame(len=count.(!ismissing, eachrow(m)))
    @test select(df, AsTable(:) => length => :len) ≃
          select(df, AsTable(:) => ByRow(length) => :len) ≃
          DataFrame(len=fill(10000, 10))
    @test select(df, AsTable(:) => ByRow(length∘skipmissing) => :len) ≃
          DataFrame(len=count.(!ismissing, eachrow(m)))
end

@testset "pathological cases that get custom eltype promotion" begin
    # in this tests we make sure that result columns with concrete eltype are created
    df = DataFrame(a=Any[1, 1.0], b=Any[1, 1.0])
    @test combine(df, AsTable(:) => ByRow(sum) => :res).res ≃  [2.0, 2.0]
    @test combine(df, AsTable(:) => ByRow(sum∘skipmissing) => :res).res ≃ [2.0, 2.0]
    df = DataFrame(a=Any[big(1), 1//1], b=Any[big(1), 1//1])
    @test combine(df, AsTable(:) => ByRow(mean) => :res).res ≃ BigFloat[1, 1]
    @test combine(df, AsTable(:) => ByRow(mean∘skipmissing) => :res).res ≃ BigFloat[1, 1]
end

@testset "tests of reductions over empty selections" begin
    df = DataFrame(zeros(3, 5), :auto)
    for fun in (+, min, max, ByRow(+), ByRow(min), ByRow(max))
        @test_throws MethodError combine(df, Cols() => fun)
        @test_throws MethodError combine(df, AsTable(Cols()) => fun)
    end
    for fun in (sum, ByRow(sum), ByRow(sum∘skipmissing),
                mean, ByRow(mean), ByRow(mean∘skipmissing),
                minimum, ByRow(minimum), ByRow(minimum∘skipmissing),
                maximum, ByRow(maximum), ByRow(maximum∘skipmissing))
        @test_throws MethodError combine(df, Cols() => fun)
        # need union as the error type is not stable across Julia versions
        @test_throws Union{MethodError,ArgumentError} combine(df, AsTable(Cols()) => fun)
    end
    @test_throws MethodError combine(df, Cols() => length)
    @test_throws MethodError combine(df, Cols() => ByRow(length))
    @test_throws MethodError combine(df, Cols() => ByRow(length∘skipmissing))
    @test combine(df, AsTable(Cols()) => length) == DataFrame(length=0)
    @test combine(df, AsTable(Cols()) => ByRow(length)) ==
          DataFrame(length=[0, 0, 0])
    @test combine(df, AsTable(Cols()) => ByRow(length∘skipmissing)) ==
          DataFrame(length_skipmissing=[0, 0, 0])
end

@testset "test AsTable(...) => fun∘collect and ByRow(fun∘collect)" begin
    Random.seed!(1234)
    df1 = DataFrame(rand(10, 100), :auto)
    df1.id = repeat(1:2, 5)
    df2 = copy(df1)
    df2.x50 = 1:10
    df3 = copy(df1)
    df3.x60 = [1.0:9.0; missing]
    df4 = copy(df3)
    df4.x50 = 1:10

    for df in (df1, df2, df3, df4)
        dfv = view(df, 2:10, 2:101)
        for x in (df, dfv), fun in (sum, prod, first, x -> first(x) - sum(x))
            @test combine(x, AsTable(r"x") => ByRow(fun∘collect) => :res) ≃
                  combine(x, AsTable(r"x") => ByRow(x -> (fun∘collect)(x)) => :res)
            @test combine(x, AsTable(r"x") => ByRow(fun∘skipmissing∘collect) => :res) ≃
                  combine(x, AsTable(r"x") => ByRow(x -> (fun∘skipmissing∘collect)(x)) => :res)
        end
    end

    for df in (df1, df2, df3, df4)
        dfv = view(df, 2:10, 2:101)
        for x in (df, dfv), fun in (mean, std, var)
            @test combine(x, AsTable(r"x") => ByRow(fun∘skipmissing∘collect) => :res) ≃
                  combine(x, AsTable(r"x") => ByRow(x -> (fun∘skipmissing∘collect)(x)) => :res)
        end
    end

    for df in (df1, df2, df3, df4)
        dfv = view(df, 2:10, 2:101)
        for x in (df, dfv), fun in (std, var, median)
            if df === df2 || df === df4
                # mixing Int and Float64 invokes a different implementation of these functions
                @test combine(x, AsTable(r"x") => ByRow(fun∘skipmissing) => :res) ≈
                    combine(x, AsTable(r"x") => ByRow(x -> (fun∘skipmissing)(x)) => :res)
            else
                @test combine(x, AsTable(r"x") => ByRow(fun∘skipmissing) => :res) ≃
                    combine(x, AsTable(r"x") => ByRow(x -> (fun∘skipmissing)(x)) => :res)
            end
        end
    end

    df3 .= coalesce.(df3, 0.0)
    df4 .= coalesce.(df4, 0.0)

    for df in (df1, df2, df3, df4)
        dfv = view(df, 2:10, 2:101)
        for x in (df, dfv), fun in (mean, std, var)
            if df === df2 || df === df4
                # mixing Int and Float64 invokes a different implementation of these functions
                @test combine(x, AsTable(r"x") => ByRow(fun∘collect) => :res) ≈
                    combine(x, AsTable(r"x") => ByRow(x -> (fun∘collect)(x)) => :res)
            else
                @test combine(x, AsTable(r"x") => ByRow(fun∘collect) => :res) ≃
                    combine(x, AsTable(r"x") => ByRow(x -> (fun∘collect)(x)) => :res)
            end
        end
    end

    for df in (df1, df2, df3, df4)
        dfv = view(df, 2:10, 2:101)
        for x in (df, dfv), fun in (std, var, median)
            if fun !== median
                # mixing Int and Float64 invokes a different implementation of these functions
                @test combine(x, AsTable(r"x") => ByRow(fun) => :res) ≈
                    combine(x, AsTable(r"x") => ByRow(x -> fun(x)) => :res)
            else
                @test combine(x, AsTable(r"x") => ByRow(fun) => :res) ≃
                    combine(x, AsTable(r"x") => ByRow(x -> fun(x)) => :res)
            end
        end
    end

    # make sure we are not mutating not reusing worker vector if we are not in reduction mode
    push0!(x) = push!(x, 0.0)
    for df in (DataFrame(rand(10, 1000), :auto), DataFrame(rand(1000, 100), :auto))
        @test combine(df, AsTable(All()) => ByRow(pop!∘collect) => :res) ≃
            combine(df, AsTable(All()) => ByRow(x -> x |> collect |> pop!) => :res)
        @test combine(df, AsTable(All()) => ByRow(push0!∘collect) => :res) ≃
            combine(df, AsTable(All()) => ByRow(x -> x |> collect |> push0!) => :res)
        @test combine(df, AsTable(All()) => ByRow(identity∘collect) => :res) ≃
            combine(df, AsTable(All()) => ByRow(x -> x |> collect |> identity) => :res)
    end

    # test of fast reductions
    for df in (DataFrame(rand(5, 10), :auto),
               DataFrame(rand([1:10; missing], 5, 10), :auto)),
        fun in (sum, sum∘skipmissing, length,
                mean, mean∘skipmissing, var, var∘skipmissing,
                std, std∘skipmissing, median, median∘skipmissing,
                minimum, minimum∘skipmissing, maximum, maximum∘skipmissing,
                prod, prod∘skipmissing, first, first∘skipmissing, last)
        @test combine(df, AsTable(All()) => ByRow(fun∘collect) => :res) ≃
              combine(df, AsTable(All()) => ByRow(x -> x |> collect |> fun) => :res)
    end

    # test promotion for two or more distinct types of columns
    df = DataFrame(x=[true, false], y=1:2, z=1.0:2.0)
    df2 = DataFrame(rand(1:10, 10, 10_000), :auto)
    df2.y = 1.0:10.0
    df2.z = repeat([true, false], 5)
    df3 = DataFrame(rand(1:10, 10, 10_000), :auto)
    df3.y = 1.0:10.0
    fun(v::AbstractVector{<:Real}) = sum(v)
    for x in (df, df2, df3)
        @test combine(x, AsTable(All()) => ByRow(fun∘collect) => :res) ≃
            combine(x, AsTable(All()) => ByRow(sum) => :res)
        @test combine(df, AsTable(All()) => ByRow(eltype∘collect) => :res) ≃
              combine(df, AsTable(All()) => ByRow(x -> (eltype∘collect)(x)) => :res) ≃
              DataFrame(res=[Real, Real])
    end

    df4 = DataFrame(rand(1:10, 2, 1000), :auto)
    df4.y = fill(missing, 2)
    df5 = copy(df4)
    df5.z = fill(0x0, 2)

    @test combine(df4, AsTable(All()) => ByRow(eltype∘collect) => :res) ≃
            combine(df4, AsTable(All()) => ByRow(x -> (eltype∘collect)(x)) => :res) ≃
            DataFrame(res=[Union{Int, Missing}, Union{Int, Missing}])
    # T is Any under Julia 1.0, but Union{Missing, Integer} currently
    T = Base.promote_typejoin(Missing, Base.promote_typejoin(Int, UInt8))
    @test combine(df5, AsTable(All()) => ByRow(eltype∘collect) => :res) ≃
            combine(df5, AsTable(All()) => ByRow(x -> (eltype∘collect)(x)) => :res) ≃
            DataFrame(res=[T, T])

    df = DataFrame(x=1:2, y=PooledArray(1:2), z=view([1, 2], 1:2), copycols=false)
    df2 = DataFrame(rand(1:10, 10, 10_000), :auto)
    df2.y = PooledArray(1:10)
    df2.z = view([1:10;], 1:10)
    df3 = DataFrame(rand(1:10, 10, 10_000), :auto)
    df3.y = PooledArray(1:10)
    fun2(v::Vector{Int}) = sum(v)
    for x in (df, df2)
        @test combine(x, AsTable(All()) => ByRow(fun∘collect) => :res) ≃
            combine(x, AsTable(All()) => ByRow(sum) => :res)
        @test combine(df, AsTable(All()) => ByRow(eltype∘collect) => :res) ≃
              combine(df, AsTable(All()) => ByRow(x -> (eltype∘collect)(x)) => :res) ≃
              DataFrame(res=[Int, Int])
    end

    # test without ByRow
    df = DataFrame(rand(10, 1000), :auto)
    @test combine(df, AsTable(All()) => sum∘collect => :res) ≃
          combine(df, AsTable(All()) => sum => :res)
    @test combine(df, AsTable(All()) => first∘collect => :res) ≃
          combine(df, :x1 => :res)
    @test combine(df, AsTable(All()) => last∘collect => :res) ≃
          combine(df, :x1000 => :res)
end

@testset "function as target column names specifier" begin
    df_ref = DataFrame(x=[[1, 2], [3, 4]], id=1:2)
    for v in (df_ref, groupby(df_ref, :id))
        @test select(v, :id, :x => ByRow(first) => identity) == DataFrame(id=1:2, x=[1, 3])
        @test select(v, :id, "x" => ByRow(first) => identity) == DataFrame(id=1:2, x=[1, 3])
        @test select(v, :id, 1 => ByRow(first) => identity) == DataFrame(id=1:2, x=[1, 3])
        @test select(v, :id, 1 => ByRow(first) => uppercase) == DataFrame(id=1:2, X=[1, 3])
        @test select(v, :id, 1 => ByRow(first) => string) == DataFrame(id=1:2, x=[1, 3])
        @test select(v, :id, 1 => ByRow(first) => x -> Symbol(x)) == DataFrame(id=1:2, x=[1, 3])
        @test select(v, :id, 1 => identity => x -> ["p", "q"]) ==
              DataFrame(id=1:2, p=[1, 3], q=[2, 4])
        @test select(v, :id, 1 => identity => x -> [:p, :q]) ==
              DataFrame(id=1:2, p=[1, 3], q=[2, 4])
        @test_throws ArgumentError select(v, :id, 1 => identity => x -> [:p, "q"])
        @test_throws ArgumentError select(v, :id, 1 => identity => x -> AsTable)
        @test select(v, :id, AsTable(1) => first => string) ==
              DataFrame("id" => 1:2, "[\"x\"]" => [[1, 2], [3, 4]])
        @test select(v, :id, ["x", "x"] => ByRow((p,q) -> first(p)) => string) ==
            DataFrame("id" => 1:2, "[\"x\", \"x\"]" => [1, 3])
        @test select(v, :id, 1:2 => ((p, q) -> q) => x -> join(x, "_")) ==
              DataFrame(id=1:2, x_id=1:2)
        @test select(v, :id, AsTable(1:2) => last => x -> join(x, "_")) ==
              DataFrame(id=1:2, x_id=1:2)
        # we could make this work, but I skip it to keep the code simpler
        # The problem is that Symbol and String are not Function
        @test_throws ArgumentError select(v, :id, 1 => ByRow(first) => Symbol)
        @test_throws ArgumentError select(v, :id, 1 => ByRow(first) => String)
    end
end

@testset "broadcasting column selectors: All, Cols, Between, Not" begin
    df = DataFrame(reshape(1:200, 20, 10), :auto)
    insertcols!(df, 1, :id => repeat(["a", "b"], 10))
    dfv = @view df[1:end-1, 1:end-1]

    for sel in (All(), Cols(2:8), Between(:x3, :x5), Not(:x1),
                Cols(), Between(:x5, :x3), Not(:)),
                tab in (df, dfv),
                op in (select, select!, transform, transform!, combine)

        @test op(copy(tab), sel .=> first) == op(copy(tab), names(tab, sel) .=> first)
        @test op(copy(tab), sel .=> [first]) == op(copy(tab), names(tab, sel) .=> [first])
        @test op(copy(tab), sel .=> [first length]) ==
              op(copy(tab), names(tab, sel) .=> [first length])
        @test op(copy(tab), sel .=> sel) ==
              op(copy(tab), names(tab, sel) .=> sel) ==
              op(copy(tab), sel .=> names(tab, sel)) ==
              op(copy(tab), names(tab, sel) .=> names(tab, sel))
        @test op(copy(tab), sel .=> first .=> sel) ==
              op(copy(tab), names(tab, sel) .=> first .=> sel) ==
              op(copy(tab), sel .=> first .=> names(tab, sel)) ==
              op(copy(tab), names(tab, sel) .=> first .=> names(tab, sel))
        @test op(copy(tab), sel .=> [first] .=> sel) ==
              op(copy(tab), names(tab, sel) .=> [first] .=> sel) ==
              op(copy(tab), sel .=> [first] .=> names(tab, sel)) ==
              op(copy(tab), names(tab, sel) .=> [first] .=> names(tab, sel))

        @test op(groupby(copy(tab), :id), sel .=> first) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> first)
        @test op(groupby(copy(tab), :id), sel .=> [first length]) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> [first length])
        @test op(groupby(copy(tab), :id), sel .=> sel) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> sel) ==
              op(groupby(copy(tab), :id), sel .=> names(tab, sel)) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> names(tab, sel))
        @test op(groupby(copy(tab), :id), sel .=> first .=> sel) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> first .=> sel) ==
              op(groupby(copy(tab), :id), sel .=> first .=> names(tab, sel)) ==
              op(groupby(copy(tab), :id), names(tab, sel) .=> first .=> names(tab, sel))

        res = names(tab, sel) .=> sum
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> sum) == res

        res = names(tab, sel) .=> [sum]
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> [sum]) == res

        res = names(tab, sel) .=> [sum length]
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> [sum length]) ==
              res

        res = names(tab, sel) .=> names(tab, sel)
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> sel) ==
              DataFrames.broadcast_pair(tab, names(tab, sel) .=> sel) ==
              DataFrames.broadcast_pair(tab, sel .=> names(tab, sel)) ==
              res

        res = names(tab, sel) .=> sum .=> names(tab, sel)
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> sum .=> sel) ==
              DataFrames.broadcast_pair(tab, names(tab, sel) .=> sum .=> sel) ==
              DataFrames.broadcast_pair(tab, sel .=> sum .=> names(tab, sel)) ==
              res

        res = names(tab, sel) .=> [sum] .=> names(tab, sel)
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> [sum] .=> sel) ==
              DataFrames.broadcast_pair(tab, names(tab, sel) .=> [sum] .=> sel) ==
              DataFrames.broadcast_pair(tab, sel .=> [sum] .=> names(tab, sel)) ==
              res

        # this is an invalid transformation, but we can check if a correct result
        # is produced in the preprocessing step
        res = names(tab, sel) .=> [sum length] .=> names(tab, sel)
        res = isempty(res) ? [] : res
        @test DataFrames.broadcast_pair(tab, sel .=> [sum length] .=> sel) ==
              DataFrames.broadcast_pair(tab, names(tab, sel) .=> [sum length] .=> sel) ==
              DataFrames.broadcast_pair(tab, sel .=> [sum length] .=> names(tab, sel)) ==
              res
    end

    @test_throws DimensionMismatch DataFrames.broadcast_pair(df, Not(:x1) .=> Between(:x2, :x4))
    @test_throws DimensionMismatch DataFrames.broadcast_pair(df, Not(:x1) .=> sum .=> Between(:x2, :x4))
    @test_throws DimensionMismatch DataFrames.broadcast_pair(df, Not(:x1) .=> Between(:x2, :x1))
    @test_throws DimensionMismatch DataFrames.broadcast_pair(df, Not(:x1) .=> sum .=> Between(:x2, :x1))
    # this is allowed due to how broadcasting rules are defined
    @test combine(df, Between(:x2, :x2) .=> sum .=> Between(:x1, :x3)) ==
          DataFrame(x1=610, x2=610, x3=610)
    @test combine(df, Between(:x2, :x2) .=> Between(:x1, :x3)) ==
          DataFrame(x1=df.x2, x2=df.x2, x3=df.x2)
    @test_throws ArgumentError DataFrames.broadcast_pair(df,
        [Between(:x1, :x2) .=> sin Between(:x2, :x3) .=> sin])
    @test_throws ArgumentError DataFrames.broadcast_pair(df,
        [1 .=> Between(:x1, :x2) 1 .=> Between(:x2, :x3)])
    @test_throws ArgumentError DataFrames.broadcast_pair(df,
        [1 .=> sum .=> Between(:x1, :x2) 1 .=> sum .=> Between(:x2, :x3)])
    # this is a case that we cannot handle correctly, note that properly
    # this broadcasting operation should error
    @test DataFrames.broadcast_pair(df, Between(:x1, :x2) .=> []) == []
    @test_throws ArgumentError DataFrames.broadcast_pair(df, Between(:x1, :x2) .=> [sin, cos, sin])
    @test_throws ArgumentError DataFrames.broadcast_pair(df, Between(:x1, :x2) .=> [sin cos
                                                                                   sin cos
                                                                                   sin cos])
    @test_throws ArgumentError DataFrames.broadcast_pair(df, 1:3 .=> Between(:x1, :x2))
    @test_throws ArgumentError DataFrames.broadcast_pair(df, 1:3 .=> sum .=> Between(:x1, :x2))
end

@testset "correct handling of copying" begin
    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a => :b, :a => :c)
    @test df.b !== df.c
    @test df.b === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a, :a => :c)
    @test df.a !== df.c
    @test df.a === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a => :c, :a)
    @test df.a !== df.c
    @test df.c === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a => :c, :)
    @test df.a !== df.c
    @test df.c === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a .=> [:c], :)
    @test df.a !== df.c
    @test df.c === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a .=> [:c], :, :a => :b)
    @test df.a !== df.c
    @test df.b !== df.c
    @test df.a !== df.b
    @test df.c === x

    df = DataFrame(a=1:3)
    x = df.a
    select!(df, :a .=> [:x1, :x2, :x3])
    @test df.x1 !== df.x2
    @test df.x1 !== df.x3
    @test df.x2 !== df.x3
    @test df.x1 === x

    df = DataFrame(a=1:3)
    x = df.a
    transform!(df, :a .=> [:b])
    @test df.a !== df.b
    @test df.a === x

    df = DataFrame(a=1:3)
    x = df.a
    transform!(df, :a .=> [:x1, :x2, :x3])
    @test df.a !== df.x1
    @test df.a !== df.x2
    @test df.a !== df.x3
    @test df.x1 !== df.x2
    @test df.x1 !== df.x3
    @test df.x2 !== df.x3
    @test df.a === x

    for cc in (true, false)
        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a => :b, :a => :c, copycols=cc)
        @test df2.b !== df2.c
        @test (df2.b === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a, :a => :c, copycols=cc)
        @test df2.a !== df2.c
        @test (df2.a === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a => :c, :a, copycols=cc)
        @test df2.a !== df2.c
        @test (df2.c === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a => :c, :, copycols=cc)
        @test df2.a !== df2.c
        @test (df2.c === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a .=> [:c], :, copycols=cc)
        @test df2.a !== df2.c
        @test (df2.c === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a .=> [:c], :, :a => :b, copycols=cc)
        @test df2.a !== df2.c
        @test df2.b !== df2.c
        @test df2.a !== df2.b
        @test (df2.c === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = select(df, :a .=> [:x1, :x2, :x3], copycols=cc)
        @test df2.x1 !== df2.x2
        @test df2.x1 !== df2.x3
        @test df2.x2 !== df2.x3
        @test (df2.x1 === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = transform(df, :a .=> [:b], copycols=cc)
        @test df2.a !== df2.b
        @test (df2.a === x) ⊻ cc

        df = DataFrame(a=1:3)
        x = df.a
        df2 = transform(df, :a .=> [:x1, :x2, :x3], copycols=cc)
        @test df2.a !== df2.x1
        @test df2.a !== df2.x2
        @test df2.a !== df2.x3
        @test df2.x1 !== df2.x2
        @test df2.x1 !== df2.x3
        @test df2.x2 !== df2.x3
        @test (df2.a === x) ⊻ cc
    end

    for sel in (:a, [:a], r"a")
        df = DataFrame(a=1:3)
        x = df.a
        select!(df, sel => identity => :b, sel => identity => :c)
        @test df.b !== df.c
        @test df.b === x

        df = DataFrame(a=1:3)
        x = df.a
        select!(df, :a, sel => identity => :c)
        @test df.a !== df.c
        @test df.a === x

        df = DataFrame(a=1:3)
        x = df.a
        select!(df, sel => identity => :c, :a)
        @test df.a !== df.c
        @test df.c === x

        df = DataFrame(a=1:3)
        x = df.a
        select!(df, sel => identity => :c, :)
        @test df.a !== df.c
        @test df.c === x

        for cc in (true, false)
            df = DataFrame(a=1:3)
            x = df.a
            df2 = select(df, sel => identity => :b, sel => identity => :c, copycols=cc)
            @test df2.b !== df2.c
            @test (df2.b === x) ⊻ cc

            df = DataFrame(a=1:3)
            x = df.a
            df2 = select(df, :a, sel => identity => :c, copycols=cc)
            @test df2.a !== df2.c
            @test (df2.a === x) ⊻ cc

            df = DataFrame(a=1:3)
            x = df.a
            df2 = select(df, sel => identity => :c, :a, copycols=cc)
            @test df2.a !== df2.c
            @test (df2.c === x) ⊻ cc

            df = DataFrame(a=1:3)
            x = df.a
            df2 = select(df, sel => identity => :c, :, copycols=cc)
            @test df2.a !== df2.c
            @test (df2.c === x) ⊻ cc
        end

        df = DataFrame(a=1:3)
        df2 = select(df, sel => (x -> (b=x, c=x)) => AsTable, copycols=false)
        @test df.a === df2.b
        @test df.a !== df2.c
        df = DataFrame(a=1:3)
        df2 = select(df, sel => (x -> DataFrame(b=x, c=x, copycols=false)) => AsTable, copycols=false)
        @test df.a === df2.b
        @test df.a !== df2.c
        df = DataFrame(a=1:3)
        df2 = transform(df, sel => (x -> (b=x, c=x)) => AsTable, copycols=false)
        @test df.a === df2.a
        @test df.a !== df2.b
        @test df.a !== df2.c
        @test df2.b !== df2.c
        df = DataFrame(a=1:3)
        df2 = transform(df, sel => (x -> DataFrame(b=x, c=x, copycols=false)) => AsTable, copycols=false)
        @test df.a === df2.a
        @test df.a !== df2.b
        @test df.a !== df2.c
        @test df2.b !== df2.c

        df = DataFrame(a=1:3)
        a = df.a
        select!(df, sel => (x -> (b=x, c=x)) => AsTable)
        @test a === df.b
        @test a !== df.c
        df = DataFrame(a=1:3)
        a = df.a
        select!(df, sel => (x -> DataFrame(b=x, c=x, copycols=false)) => AsTable)
        @test a === df.b
        @test a !== df.c
        df = DataFrame(a=1:3)
        a = df.a
        transform!(df, sel => (x -> (b=x, c=x)) => AsTable)
        @test a === df.a
        @test a !== df.b
        @test a !== df.c
        @test df.b !== df.c
        df = DataFrame(a=1:3)
        a = df.a
        transform!(df, sel => (x -> DataFrame(b=x, c=x, copycols=false)) => AsTable)
        @test a === df.a
        @test a !== df.b
        @test a !== df.c
        @test df.b !== df.c
    end

    df = DataFrame(a=1:3)
    df2 = select(df, :a, [:a, :a] => ((x, y) -> x) => :b, copycols=false)
    @test df.a === df2.a
    @test df.a == df2.b
    @test df.a !== df2.b
    @test df2.a !== df2.b
    df2 = transform(df, [:a, :a] => ((x, y) -> x) => :b, copycols=false)
    @test df.a === df2.a
    @test df.a == df2.b
    @test df.a !== df2.b
    @test df2.a !== df2.b

    df = DataFrame(a=1:3)
    df2 = select(df, :a, [:a, :a] => ((x, y) -> (b=x, c=y)) => AsTable, copycols=false)
    @test df.a === df2.a
    @test df.a == df2.b
    @test df.a !== df2.b
    @test df2.a !== df2.b
    @test df.a == df2.c
    @test df.a !== df2.c
    @test df2.a !== df2.c
    df2 = transform(df, [:a, :a] => ((x, y) -> (b=x, c=y)) => AsTable, copycols=false)
    @test df.a === df2.a
    @test df.a == df2.b
    @test df.a !== df2.b
    @test df2.a !== df2.b
    @test df.a == df2.c
    @test df.a !== df2.c
    @test df2.a !== df2.c
    df2 = transform(df, [:a, :a] => ((x, y) -> (b=x, c=y)) => AsTable, :a => :d, copycols=false)
    @test df.a === df2.a
    @test df.a == df2.b
    @test df.a !== df2.b
    @test df2.a !== df2.b
    @test df.a == df2.c
    @test df.a !== df2.c
    @test df2.a !== df2.c
    @test df.a == df2.d
    @test df.a !== df2.d
    @test df2.a !== df2.d

    df = DataFrame(a=1:3, b=11:13, c=21:23)
    df2 = select(df, [:a, :b, :c] => ((x, y, z) -> (c=x, d=y)) => AsTable, :, :c => :e, copycols=false)
    @test df2.c === df.a
    @test df2.d === df.b
    @test df2.a !== df.a
    @test df2.b !== df.b
    @test df2.a !== df2.c
    @test df2.b !== df2.d
    @test df2.a == df2.c
    @test df2.b == df2.d
    @test df2.e === df.c

    # multialias detection
    df = DataFrame(a=1:3)
    df.b = df.a
    df2 = select(df, [:a, :b] => ((x, y) -> x) => :c, :a, :b, copycols=false)
    @test df2.c === df.a === df.b
    @test df2.a == df2.b == df.a
    @test df2.a !== df.a
    @test df2.b !== df.b
    @test df2.a !== df2.c
    @test df2.b !== df2.c

    df = DataFrame(a=1:3)
    df2 = transform(df, :a => lag)
    # note that here a copy of `lag(df.a)` was performed as the result of this
    # transformation is a view of `df.a` and `copycols=true` so we make sure
    # that `df2.a_lag` column does not share data with `df.a` column.
    @test df2.a_lag isa Vector
    df2 = transform(df, :a => lag, copycols=false)
    @test df2.a_lag isa ShiftedVector
    transform!(df, :a => lag)
    @test df.a_lag isa ShiftedVector

    df = DataFrame(x=1:3)
    x = df.x
    select!(df, :x => copy => :y, :x => :z)
    @test df.y == df.z == x
    @test df.y !== x
    @test df.z === x
end

struct Identity
end

function (::Identity)(x)
    return x
end

@testset "correct handling of functors" begin
    i = Identity()
    df = DataFrame(x=1:3)
    @test_throws ArgumentError combine(df, :x => i) # i is not Callable
    @test combine(df, :x => identity∘i) == DataFrame(x_identity_function=1:3)
end

@testset "map on sparse array" begin
    Random.seed!(1234)
    df = DataFrame(x=spzeros(10))
    df2 = select(df, :x => ByRow(i -> rand()) => :y)
    @test allunique(df2.y)
end

@testset "improved error message when numbers requested and returned columns does not match" begin
    df = DataFrame(id=1:2, a=[(a=1,b=2),(a=3,b=4)])
    gdf = groupby(df, :id)
    @test_throws ArgumentError select(df, :a => [:x])
    @test_throws ArgumentError select(gdf, :a => [:x])
    @test select(df, :id, :a => [:x, :y]) == DataFrame(id=1:2, x=[1, 3], y=[2, 4])
    @test select(gdf, :a => [:x, :y]) == DataFrame(id=1:2, x=[1, 3], y=[2, 4])
    @test_throws ArgumentError select(df, :a => [:x, :y, :z])
    @test_throws ArgumentError select(gdf, :a => [:x, :y, :z])
end

@testset "handling of operation specification in select!/transform!" begin
    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    select!(df, :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df == DataFrame(b='a':'d', d=["p", "q", "r", "s"], e=[2, 4, 6, 8])

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    transform!(df, :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df == DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"],
                          d=["p", "q", "r", "s"], e=[2, 4, 6, 8])
    @test df.c !== df.d

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    select!(groupby(df, :c), :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df == DataFrame(c=["p", "q", "r", "s"], b='a':'d',
                          d=["p", "q", "r", "s"], e=[2, 4, 6, 8])
    @test df.c !== df.d

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    transform!(groupby(df, :c), :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df == DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"],
                          d=["p", "q", "r", "s"], e=[2, 4, 6, 8])
    @test df.c !== df.d

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    sdf = @view df[[2, 4], :]
    # note that in this test a column from parent of sdf is dropped
    select!(sdf, :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df ≅ DataFrame(b='a':'d', d=[missing, "q", missing, "s"],
                         e=[missing, 4, missing, 8])

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    sdf = @view df[[2, 4], :]
    transform!(sdf, :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df ≅ DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"],
                         d=[missing, "q", missing, "s"],
                         e=[missing, 4, missing, 8])

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    sdf = @view df[[2, 4], :]
    # note that in this test a column from parent of sdf is dropped
    select!(groupby(sdf, :c), :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df ≅ DataFrame(c=["p", "q", "r", "s"], b='a':'d',
                         d=[missing, "q", missing, "s"],
                         e=[missing, 4, missing, 8])

    df = DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"])
    sdf = @view df[[2, 4], :]
    transform!(groupby(sdf, :c), :b, :c => :d, :a => (x -> 2 * x) => :e)
    @test df ≅ DataFrame(a=1:4, b='a':'d', c=["p", "q", "r", "s"],
                         d=[missing, "q", missing, "s"],
                         e=[missing, 4, missing, 8])
end

@testset "selection on a view without copying" begin
    df = DataFrame(a=1:2)
    for dfv in (view(df, :, :), view(df, 1:2, 1:1))
        @test_throws ArgumentError select(dfv, x -> true, copycols=false)
        @test_throws ArgumentError select(dfv, :a => identity, copycols=false)
    end
end

@testset "corner cases of fast aggregations" begin
    df = DataFrame(id=[1, 1, 2],
                   a=[1, 2, 4], a2=Any[1, 2, 4],
                   b=Any[2, 3, 3],
                   c1=missing, c2=missing,
                   d1=missings(Int, 3), d2=missings(Int, 3))
    gdf = groupby(df, [])

    for table in (df, gdf)
        for mode in [true, false]
            p, q = mode ? (:a, :b) : (:b, :a)
            @test combine(table, AsTable([p, q]) => sum => :x) ==
                  DataFrame(x=3:2:7)
            @test combine(table, AsTable([p, q]) => ByRow(sum) => :x) ==
                  DataFrame(x=3:2:7)
            @test combine(table, AsTable([p, q]) => ByRow(sum∘skipmissing) => :x) ==
                  DataFrame(x=3:2:7)
            @test combine(table, AsTable([p, q]) => length => :x) ==
                  DataFrame(x=2)
            @test combine(table, AsTable([p, q]) => ByRow(length) => :x) ==
                  DataFrame(x=[2, 2, 2])
            if table isa DataFrame
                @test combine(table, AsTable([p, q]) => ByRow(length∘skipmissing) => :x) ==
                      DataFrame(x=[2, 2, 2])
            end
            @test combine(table, AsTable([p, q]) => mean => :x) ==
                  DataFrame(x=[1.5, 2.5, 3.5])
            @test combine(table, AsTable([p, q]) => ByRow(mean) => :x) ==
                  DataFrame(x=[1.5, 2.5, 3.5])
            @test combine(table, AsTable([p, q]) => ByRow(mean∘skipmissing) => :x) ==
                  DataFrame(x=[1.5, 2.5, 3.5])
            @test combine(table, AsTable([p, q]) => ByRow(var) => :x) ==
                  DataFrame(x=[0.5, 0.5, 0.5])
            @test combine(table, AsTable([p, q]) => ByRow(var∘skipmissing) => :x) ==
                  DataFrame(x=[0.5, 0.5, 0.5])
            @test combine(table, AsTable([p, q]) => ByRow(std) => :x) ≈
                  DataFrame(x=.√[0.5, 0.5, 0.5])
            @test combine(table, AsTable([p, q]) => ByRow(std∘skipmissing) => :x) ≈
                  DataFrame(x=.√[0.5, 0.5, 0.5])
            @test combine(table, AsTable([p, q]) => ByRow(median) => :x) ==
                  DataFrame(x=[1.5, 2.5, 3.5])
            @test combine(table, AsTable([p, q]) => ByRow(median∘skipmissing) => :x) ==
                  DataFrame(x=[1.5, 2.5, 3.5])
            @test combine(table, AsTable([p, q]) => minimum => :x) ==
                  DataFrame(x=[1, 2, 4])
            @test combine(table, AsTable([p, q]) => ByRow(minimum) => :x) ==
                  DataFrame(x=[1, 2, 3])
            @test combine(table, AsTable([p, q]) => ByRow(minimum∘skipmissing) => :x) ==
                  DataFrame(x=[1, 2, 3])
            @test combine(table, AsTable([p, q]) => maximum => :x) ==
                  DataFrame(x=[2, 3, 3])
            @test combine(table, AsTable([p, q]) => ByRow(maximum) => :x) ==
                  DataFrame(x=[2, 3, 4])
            @test combine(table, AsTable([p, q]) => ByRow(maximum∘skipmissing) => :x) ==
                  DataFrame(x=[2, 3, 4])
            @test combine(table, AsTable([p, q]) => ByRow(extrema) => :x) ==
                  DataFrame(x=[(1, 2), (2, 3), (3, 4)])
            @test combine(table, AsTable([p, q]) => ByRow(extrema∘skipmissing) => :x) ==
                  DataFrame(x=[(1, 2), (2, 3), (3, 4)])
        end

        for p in [:a, :a2], q in [:c1, :d1], mode in [true, false]
            if mode
                p, q = q, p
            end
            @test combine(table, AsTable([p, q]) => sum => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(sum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(sum∘skipmissing) => :x) ≅
                  DataFrame(x=[1, 2, 4])
            @test combine(table, AsTable([p, q]) => length => :x) ==
                  DataFrame(x=2)
            @test combine(table, AsTable([p, q]) => ByRow(length) => :x) ==
                  DataFrame(x=[2, 2, 2])
            if table isa DataFrame
                @test combine(table, AsTable([p, q]) => ByRow(length∘skipmissing) => :x) ==
                      DataFrame(x=[1, 1, 1])
            end
            @test combine(table, AsTable([p, q]) => mean => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(mean) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(mean∘skipmissing) => :x) ≅
                  DataFrame(x=[1, 2, 4])
            if table isa DataFrame
                @test combine(table, AsTable([p, q]) => ByRow(var) => :x) ≅
                      DataFrame(x=[missing, missing, missing])
                @test combine(table, AsTable([p, q]) => ByRow(var∘skipmissing) => :x) ≅
                      DataFrame(x=[NaN, NaN, NaN])
                @test combine(table, AsTable([p, q]) => ByRow(std) => :x) ≅
                      DataFrame(x=[missing, missing, missing])
                @test combine(table, AsTable([p, q]) => ByRow(std∘skipmissing) => :x) ≅
                      DataFrame(x=[NaN, NaN, NaN])
            end
            @test combine(table, AsTable([p, q]) => ByRow(median) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(median∘skipmissing) => :x) ==
                  DataFrame(x=[1, 2, 4])
            # a bit surprising how non-broadcasted and broadcasted minimum works
            @test combine(table, AsTable([p, q]) => minimum => :x) ==
                  DataFrame(x=[1, 2, 4])
            @test combine(table, AsTable([p, q]) => ByRow(minimum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(minimum∘skipmissing) => :x) ==
                  DataFrame(x=[1, 2, 4])
            @test combine(table, AsTable([p, q]) => maximum => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(maximum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(maximum∘skipmissing) => :x) ==
                  DataFrame(x=[1, 2, 4])
            @test combine(table, AsTable([p, q]) => ByRow(extrema) => :x) ≅
                  DataFrame(x=[(missing, missing), (missing, missing), (missing, missing)])
            @test combine(table, AsTable([p, q]) => ByRow(extrema∘skipmissing) => :x) ==
                  DataFrame(x=[(1, 1), (2, 2), (4, 4)])
        end

        for p in [:c1, :d1], q in [:c2, :d2]
            @test combine(table, AsTable([p, q]) => sum => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(sum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            if p == :c1 && q == :c2
                @test_throws ArgumentError combine(table, AsTable([p, q]) =>
                                                          ByRow(sum∘skipmissing) => :x)
            else
                @test combine(table, AsTable([p, q]) => ByRow(sum∘skipmissing) => :x) ≅
                      DataFrame(x=[0, 0, 0])
            end
            @test combine(table, AsTable([p, q]) => length => :x) ==
                  DataFrame(x=2)
            @test combine(table, AsTable([p, q]) => ByRow(length) => :x) ==
                  DataFrame(x=[2, 2, 2])
            if table isa DataFrame
                @test combine(table, AsTable([p, q]) => ByRow(length∘skipmissing) => :x) ==
                      DataFrame(x=[0, 0, 0])
            end
            @test combine(table, AsTable([p, q]) => mean => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(mean) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            if p == :c1 && q == :c2
                @test_throws ArgumentError combine(table, AsTable([p, q]) =>
                                                          ByRow(mean∘skipmissing) => :x)
            else
                @test combine(table, AsTable([p, q]) => ByRow(mean∘skipmissing) => :x) ≅
                      DataFrame(x=[NaN, NaN, NaN])
            end
            if table isa DataFrame
                @test combine(table, AsTable([p, q]) => ByRow(var) => :x) ≅
                      DataFrame(x=[missing, missing, missing])
                if p == :c1 && q == :c2
                    @test_throws Exception combine(table, AsTable([p, q]) =>
                                                   ByRow(var∘skipmissing) => :x)
                else
                    @test combine(table, AsTable([p, q]) => ByRow(var∘skipmissing) => :x) ≅
                          DataFrame(x=[NaN, NaN, NaN])
                end
                @test combine(table, AsTable([p, q]) => ByRow(std) => :x) ≅
                      DataFrame(x=[missing, missing, missing])
                if p == :c1 && q == :c2
                    @test_throws Exception combine(table, AsTable([p, q]) =>
                                                   ByRow(std∘skipmissing) => :x)
                else
                    @test combine(table, AsTable([p, q]) => ByRow(std∘skipmissing) => :x) ≅
                          DataFrame(x=[NaN, NaN, NaN])
                end
            end
            @test combine(table, AsTable([p, q]) => ByRow(median) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test_throws ArgumentError combine(table, AsTable([p, q]) => ByRow(median∘skipmissing) => :x)
            @test combine(table, AsTable([p, q]) => minimum => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(minimum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test_throws Union{MethodError, ArgumentError} combine(table, AsTable([p, q]) =>
                                                                          ByRow(minimum∘skipmissing) => :x)
            @test combine(table, AsTable([p, q]) => maximum => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test combine(table, AsTable([p, q]) => ByRow(maximum) => :x) ≅
                  DataFrame(x=[missing, missing, missing])
            @test_throws Union{MethodError, ArgumentError} combine(table, AsTable([p, q]) =>
                                                                          ByRow(maximum∘skipmissing) => :x)
            @test combine(table, AsTable([p, q]) => ByRow(extrema) => :x) ≅
                  DataFrame(x=[(missing, missing), (missing, missing), (missing, missing)])
            @test_throws Union{MethodError, ArgumentError} combine(table, AsTable([p, q]) =>
                                                                          ByRow(extrema∘skipmissing) => :x)
        end
    end
end

@testset "Tables.AbstractRow interface" begin
    cr = first(Tables.rows((a=1:2, b=3:4)))
    dr = first(Tables.dictrowtable((a=1:2, b=3:4)))
    ir1 = first(Tables.IteratorWrapper(Tables.rows((a=1:2, b=3:4))))
    ir2 = first(Tables.IteratorWrapper([(a=1, b=3), (a=2, b=4)]))
    mr = first(Tables.rows(Tables.table([1 3; 2 4], header=[:a, :b])))
    dfr = DataFrame(a=1:2, b=3:4)[1, :]
    for row in (cr, dr, ir1, ir2, mr, dfr,
                Tables.Row(cr), Tables.Row(dr), Tables.Row(ir1),
                Tables.Row(ir2), Tables.Row(mr), Tables.Row(dfr))
        df = DataFrame(x=[1, 1, 2])
        @test combine(df, :x => (x -> row) => AsTable) ==
            DataFrame(a=1, b=3)
        @test combine(df, x -> row) ==
            DataFrame(a=1, b=3)
        @test select(df, :x => (x -> row) => AsTable) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test select(df, x -> row) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test combine(df, :x => ByRow(x -> row) => AsTable) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test select(df, :x => ByRow(x -> row) => AsTable) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test select(df, :x => (x -> row) => AsTable) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test combine(df, :x => (x -> row) => [:p, :q]) ==
            DataFrame(p=1, q=3)
        @test select(df, :x => (x -> row) => [:p, :q]) ==
            DataFrame(p=[1, 1, 1], q=[3, 3, 3])
        @test combine(groupby(df, :x), :x => (x -> row) => AsTable) ==
            DataFrame(x=[1, 2], a=[1, 1], b=[3, 3])
        @test combine(groupby(df, :x), x -> row) ==
            DataFrame(x=[1, 2], a=[1, 1], b=[3, 3])
        @test select(groupby(df, :x), :x => (x -> row) => AsTable) ==
            DataFrame(x=[1, 1, 2], a=[1, 1, 1], b=[3, 3, 3])
        @test select(groupby(df, :x), x -> row) ==
            DataFrame(x=[1, 1, 2], a=[1, 1, 1], b=[3, 3, 3])
        @test combine(groupby(df, :x), :x => ByRow(x -> row) => AsTable) ==
            DataFrame(x=[1, 1, 2], a=[1, 1, 1], b=[3, 3, 3])
        @test select(groupby(df, :x), :x => ByRow(x -> row) => AsTable) ==
            DataFrame(x=[1, 1, 2], a=[1, 1, 1], b=[3, 3, 3])
        @test combine(groupby(df, :x), :x => (x -> row) => [:p, :q]) ==
            DataFrame(x=[1, 2], p=[1, 1], q=[3, 3])
        @test select(groupby(df, :x), :x => (x -> row) => [:p, :q]) ==
            DataFrame(x=[1, 1, 2], p=[1, 1, 1], q=[3, 3, 3])
        @test_throws ArgumentError combine(df, :x => x -> row)
        @test_throws ArgumentError select(df, :x => x -> row)
        @test combine(df, :x => ByRow(x -> row) => :v) ==
              DataFrame(v=[row, row, row])
        @test_throws ArgumentError combine(groupby(df, :x), :x => x -> row)
        @test_throws ArgumentError select(groupby(df, :x), :x => x -> row)
        @test combine(groupby(df, :x), :x => ByRow(x -> row) => :v) ==
              DataFrame(x=[1, 1, 2], v=[row, row, row])
    end

    # note the grouping of Tables.AbstractRow types
    # they have a matching type of return value of keys (tuple vs vector)
    for df in (DataFrame(id=[1, 1, 2], x=Any[cr, ir1, ir2]),
               DataFrame(id=[1, 1, 2], x=Any[dr, dfr, mr]))
        @test combine(df, :x => AsTable) ==
            DataFrame(a=[1, 1, 1], b=[3, 3, 3])
        @test combine(groupby(df, :id), :x => AsTable) ==
            DataFrame(id=[1, 1, 2], a=[1, 1, 1], b=[3, 3, 3])
    end

    # example from issue https://github.com/JuliaData/DataFrames.jl/issues/3335
    @test combine(groupby(DataFrame(:group=>[1, 1, 2, 2]), :group),
                  sdf -> Tables.Row((; foo="foo", boo=[1, 2]))) ==
          DataFrame(group=1:2, foo=["foo", "foo"], boo=[[1, 2], [1, 2]])
    @test combine(DataFrame(:group=>[1, 1, 2, 2]),
                  sdf -> Tables.Row((; foo="foo", boo=[1, 2]))) ==
          DataFrame(foo=["foo"], boo=[[1, 2]])

    gdf = groupby(DataFrame(x=1:2), :x)
    @test_throws ArgumentError combine(gdf, :x => (x -> x[1] == 1 ? "x" : cr))
    @test_throws ArgumentError combine(gdf, :x => (x -> x[1] == 2 ? "x" : cr) => AsTable)
end

@testset "empty vector" begin
    df = DataFrame(a=1:3)

    @test_throws ArgumentError select(df, :a => (x -> Vector{Any}[]))

    for T in (Vector{Any}, Any, NamedTuple{(:x,),Tuple{Int64}})
        v = combine(df, :a => (x -> T[])).a_function
        @test isempty(v)
        @test eltype(v) === T
    end

    @test size(combine(df, :a => (x -> Vector{Any}[]) => AsTable)) == (0, 0)
    @test size(combine(df, :a => (x -> Any[]) => AsTable)) == (0, 0)
    df2 = combine(df, :a => (x -> NamedTuple{(:x,),Tuple{Int64}}[]) => AsTable)
    @test size(df2) == (0, 1)
    @test eltype(df2.x) === Int64
end

end # module

module TestIndex

using Test, DataFrames
using DataFrames: Index, SubIndex, fuzzymatch

@testset "Index indexing" begin
    i = Index()
    push!(i, :A)
    push!(i, :B)
    @test_throws ArgumentError push!(i, :A)

    inds = Any[1, big(1), :A, "A",
               [true, false],
               [1], [big(1)], big(1):big(1), [:A], ["A"],
               Union{Int, Missing}[1], Union{BigInt, Missing}[big(1)],
               Union{Symbol, Missing}[:A], Union{String, Missing}["A"],
               Any[1], Any[:A], Any["A"]]

    for ind in inds
        if ind == :A || ind == "A" || ndims(ind) == 0
            @test i[ind] == 1
        else
            @test (i[ind] == [1])
        end
    end

    @test_throws ArgumentError i[1.0]
    @test_throws ArgumentError i[true]
    @test_throws ArgumentError i[false]
    @test_throws ArgumentError i[Union{Bool, Missing}[true, false]]
    @test_throws ArgumentError i[Any[1, missing]]
    @test_throws ArgumentError i[[1, missing]]
    @test_throws ArgumentError i[[true, missing]]
    @test_throws ArgumentError i[Any[true, missing]]
    @test_throws ArgumentError i[[:A, missing]]
    @test_throws ArgumentError i[Any[:A, missing]]
    @test_throws ArgumentError i[1.0:1.0]
    @test_throws ArgumentError i[[1.0]]
    @test_throws ArgumentError i[Any[1.0]]
    @test_throws BoundsError i[0]
    @test_throws BoundsError i[10]
    @test_throws ArgumentError i[:x]
    @test_throws ArgumentError i["x"]
    @test_throws BoundsError i[1:3]
    @test_throws ArgumentError i[[1, 1]]
    @test_throws ArgumentError i[[:A, :A]]
    @test_throws ArgumentError i[["A", "A"]]
    @test_throws BoundsError i[Not(0)]
    @test_throws BoundsError i[Not(10)]
    @test_throws ArgumentError i[Not(:x)]
    @test_throws ArgumentError i[Not("x")]
    @test_throws BoundsError i[Not(1:3)]

    @test i[Not([1, 1])] == [2]
    @test i[Not([:A, :A])] == [2]
    @test i[Not(["A", "A"])] == [2]
    @test isempty(i[Not([true, true])])
    @test i[Not([false, false])] == 1:2
    @test i[Not([true, false])] == [2]

    @test i[1:1] == 1:1

    @test_throws BoundsError i[[true]]
    @test_throws BoundsError i[true:true]
    @test_throws BoundsError i[[true, false, true]]

    @test i[[]] == Int[]
    @test i[Int[]] == Int[]
    @test i[Symbol[]] == Int[]
    @test i[:] == 1:length(i)
    @test i[Not(Not(:))] == 1:length(i)
    @test i[Not(1:0)] == 1:length(i)
end

@testset "rename!" begin
    i = Index([:A, :B])
    @test names(i) == ["A", "B"]
    @test rename!(i, [:a, :a], makeunique=true) == Index([:a, :a_1])
    @test_throws ArgumentError rename!(i, [:a, :a])
    @test_throws DimensionMismatch rename!(i, [:a, :b, :c])
    @test rename!(copy(i), [:a, :b]) == Index([:a, :b])
    @test names(i) == ["a", "a_1"]
    @test rename!(i, [:a, :b]) == Index([:a, :b])
    @test rename!(copy(i), [:a => :A]) == Index([:A, :b])
    @test rename!(copy(i), [:a => :a]) == Index([:a, :b])
    @test rename!(copy(i), [:a => :b, :b => :a]) == Index([:b, :a])

    @test delete!(i, :a) == Index([:b])
    push!(i, :C)
    @test delete!(i, 1) == Index([:C])
    push!(i, :D)
    @test delete!(i, "C") == Index([:D])
    insert!(i, 1, :x2)
    insert!(i, 1, "x1")
    @test i == Index([:x1, :x2, :D])

    i = Index([:A, :B, :C, :D, :E])
    i2 = copy(i)
    rename!(i2, reverse(DataFrames._names(i2)))
    rename!(i2, reverse(DataFrames._names(i2)))
    @test names(i2) == names(i)
    for name in names(i)
        i2[name] # Issue #715
    end
end

@testset "SubIndex" begin
    i = Index([:A, :B, :C, :D, :E])
    si1 = SubIndex(i, :)
    si2 = SubIndex(i, 3:5)
    si3 = SubIndex(i, [3, 4, 5])
    si4 = SubIndex(i, [false, false, true, true, true])
    si5 = SubIndex(i, [:C, :D, :E])
    si6 = SubIndex(i, Not(Not([:C, :D, :E])))
    si7 = SubIndex(i, Not(1:2))
    si8 = SubIndex(i, ["C", "D", "E"])
    si9 = SubIndex(i, Not(Not(["C", "D", "E"])))
    si10 = SubIndex(i, Not(1, 2))
    si11 = SubIndex(i, Not(:A, :B))
    si12 = SubIndex(i, Not(2, "A"))

    @test copy(si1) == i
    @test copy(si2) == Index([:C, :D, :E])
    @test copy(si3) == Index([:C, :D, :E])
    @test copy(si4) == Index([:C, :D, :E])
    @test copy(si5) == Index([:C, :D, :E])
    @test copy(si6) == Index([:C, :D, :E])
    @test copy(si7) == Index([:C, :D, :E])
    @test copy(si8) == Index([:C, :D, :E])
    @test copy(si9) == Index([:C, :D, :E])
    @test copy(si10) == Index([:C, :D, :E])
    @test copy(si11) == Index([:C, :D, :E])
    @test copy(si12) == Index([:C, :D, :E])

    @test_throws ArgumentError SubIndex(i, 1)
    @test_throws ArgumentError SubIndex(i, :A)
    @test_throws ArgumentError SubIndex(i, "A")
    @test_throws ArgumentError SubIndex(i, true)
    @test si1 isa Index
    @test si2.cols == 3:5
    @test si2.remap == -1:3
    @test si3.cols == 3:5
    @test si3.remap == [0, 0, 1, 2, 3]
    @test !haskey(si3, :A)
    @test !haskey(si3, "A")
    @test si3.remap == [0, 0, 1, 2, 3]
    @test si4.cols == 3:5
    @test si4.remap == -1:3
    @test !haskey(si4, :A)
    @test !haskey(si4, "A")
    @test si4.remap == -1:3
    # === passes as both si2 and si4 use ranges for indicating indexes
    @test si2 === si4
    @test si5.cols == 3:5
    @test si5.remap == [0, 0, 1, 2, 3]
    @test !haskey(si5, :A)
    @test !haskey(si5, "A")
    @test si5.remap == [0, 0, 1, 2, 3]
    @test si6.cols == 3:5
    @test si6.remap == [0, 0, 1, 2, 3]
    @test !haskey(si6, :A)
    @test !haskey(si6, "A")
    @test si6.remap == [0, 0, 1, 2, 3]
    @test si7.cols == 3:5
    @test si7.remap == [0, 0, 1, 2, 3]
    @test !haskey(si7, :A)
    @test !haskey(si7, "A")
    @test si7.remap == [0, 0, 1, 2, 3]

    @test length(si1) == 5
    @test length(si2) == 3
    @test length(si3) == 3
    @test length(si4) == 3
    @test length(si5) == 3
    @test length(si6) == 3
    @test length(si7) == 3

    @test DataFrames._names(si1) == [:A, :B, :C, :D, :E]
    @test DataFrames._names(si2) == [:C, :D, :E]
    @test DataFrames._names(si3) == [:C, :D, :E]
    @test DataFrames._names(si4) == [:C, :D, :E]
    @test DataFrames._names(si5) == [:C, :D, :E]
    @test DataFrames._names(si6) == [:C, :D, :E]
    @test DataFrames._names(si7) == [:C, :D, :E]

    @test names(si1) == ["A", "B", "C", "D", "E"]
    @test names(si2) == ["C", "D", "E"]
    @test names(si3) == ["C", "D", "E"]
    @test names(si4) == ["C", "D", "E"]
    @test names(si5) == ["C", "D", "E"]
    @test names(si6) == ["C", "D", "E"]
    @test names(si7) == ["C", "D", "E"]

    @test_throws ArgumentError haskey(si3, true)
    @test haskey(si3, 1)
    @test !haskey(si3, 0)
    @test !haskey(si3, 4)
    @test haskey(si3, :D)
    @test !haskey(si3, :A)
    @test si3[:C] == 1
    @test haskey(si3, "D")
    @test !haskey(si3, "A")
    @test si3["C"] == 1
    @test si3[DataFrames._names(i)] == [0, 0, 1, 2, 3]
    @test si3[names(i)] == [0, 0, 1, 2, 3]
end

@testset "selector mutation" begin
    df = DataFrame(a=1:5, b=11:15, c=21:25)
    selector1 = [3, 2]
    dfv1 = view(df, :, selector1)
    dfr1 = view(df, 2, selector1)
    selector2 = [1]
    dfv2 = view(dfv1, :, selector2)
    dfr2 = view(dfr1, selector2)
    @test names(dfv1) == ["c", "b"]
    @test names(dfv2) == ["c"]
    @test names(dfr1) == ["c", "b"]
    @test names(dfr2) == ["c"]
    selector1[1] = 1
    @test names(dfv1) == ["a", "b"]
    @test names(dfv2) == ["c"]
    @test names(dfr1) == ["a", "b"]
    @test names(dfr2) == ["c"]
    selector3 = [:c, :b]
    dfv3 = view(df, :, selector3)
    dfr3 = view(df, 2, selector3)
    @test names(dfv3) == ["c", "b"]
    @test names(dfr3) == ["c", "b"]
    selector3[1] = :a
    @test names(dfv3) == ["c", "b"]
    @test names(dfr3) == ["c", "b"]
    selector3 = ["c", "b"]
    dfv3 = view(df, :, selector3)
    dfr3 = view(df, 2, selector3)
    @test names(dfv3) == ["c", "b"]
    @test names(dfr3) == ["c", "b"]
    selector3[1] = "a"
    @test names(dfv3) == ["c", "b"]
    @test names(dfr3) == ["c", "b"]
end

@testset "fuzzy matching" begin
    i = Index()
    push!(i, :x1)
    push!(i, :x12)
    push!(i, :x131)
    push!(i, :y13)
    push!(i, :yy13)
    @test_throws ArgumentError i[:x13]
    @test_throws ArgumentError i[:xx13]
    @test_throws ArgumentError i[:yy14]
    @test_throws ArgumentError i[:abcd]
    @test_throws ArgumentError i["x13"]
    @test_throws ArgumentError i["xx13"]
    @test_throws ArgumentError i["yy14"]
    @test_throws ArgumentError i["abcd"]
    @test fuzzymatch(i.lookup, :x13) == [:x1, :x12, :x131, :y13, :yy13]
    @test fuzzymatch(i.lookup, :xx1314) == [:x131]
    @test fuzzymatch(i.lookup, :yy14) == [:yy13, :y13]
    @test isempty(fuzzymatch(i.lookup, :abcd))
end

@testset "Regex indexing" begin
    i = Index()
    push!(i, :x1)
    push!(i, :x12)
    push!(i, :x131)
    push!(i, :y13)
    push!(i, :yy13)
    @test i[r"x1."] == [2, 3]
    @test isempty(i[r"xx"])
    @test i[r""] == 1:5
    @test DataFrames._names(SubIndex(i, r"x1.")) == [:x12, :x131]
    @test isempty(names(SubIndex(i, r"xx")))
    @test names(SubIndex(i, r"")) == names(i)
    @test DataFrames._names(SubIndex(i, r"x1.")) == [:x12, :x131]
    @test isempty(DataFrames._names(SubIndex(i, r"xx")))
    @test DataFrames._names(SubIndex(i, r"")) == DataFrames._names(i)
    @test DataFrames.parentcols(SubIndex(i, r"x1.")) == [2, 3]
    @test isempty(DataFrames.parentcols(SubIndex(i, r"xx")))
    @test DataFrames.parentcols(SubIndex(i, r"")) == 1:5
    @test DataFrames.parentcols(SubIndex(i, All())) == 1:5
    @test DataFrames.parentcols(SubIndex(i, Cols(:))) == 1:5
    @test DataFrames.parentcols(SubIndex(i, Cols())) == Int[]
    @test DataFrames.parentcols(SubIndex(i, Between(:x1, :x12))) == 1:2
    @test isempty(DataFrames.parentcols(SubIndex(i, [])))

    i2 = SubIndex(i, r"")
    @test i2[r"x1."] == [2, 3]
    @test isempty(i2[r"xx"])
    @test i2[r""] == 1:5
    @test DataFrames._names(SubIndex(i2, r"x1.")) == [:x12, :x131]
    @test isempty(names(SubIndex(i2, r"xx")))
    @test names(SubIndex(i2, r"")) == names(i)
    @test DataFrames._names(SubIndex(i2, r"x1.")) == [:x12, :x131]
    @test isempty(DataFrames._names(SubIndex(i2, r"xx")))
    @test DataFrames._names(SubIndex(i2, r"")) == DataFrames._names(i2)
    @test DataFrames.parentcols(SubIndex(i2, r"x1.")) == [2, 3]
    @test isempty(DataFrames.parentcols(SubIndex(i2, r"xx")))
    @test DataFrames.parentcols(SubIndex(i2, r"")) == 1:5
    @test DataFrames.parentcols(SubIndex(i2, All())) == 1:5
    @test DataFrames.parentcols(SubIndex(i2, Cols(:))) == 1:5
    @test DataFrames.parentcols(SubIndex(i2, Cols())) == Int[]
    @test DataFrames.parentcols(SubIndex(i2, Between(:x1, :x12))) == 1:2
    @test isempty(DataFrames.parentcols(SubIndex(i2, [])))

    i3 = SubIndex(i, r"x1.")
    @test i3[r"x1.$"] == [1]
    @test isempty(i3[r"xx"])
    @test i3[r""] == 1:2
    @test DataFrames._names(SubIndex(i3, r"x1.$")) == [:x12]
    @test isempty(names(SubIndex(i3, r"xx")))
    @test names(SubIndex(i3, r"")) == names(i3)
    @test DataFrames._names(SubIndex(i3, r"x1.$")) == [:x12]
    @test isempty(DataFrames._names(SubIndex(i3, r"xx")))
    @test DataFrames._names(SubIndex(i3, r"")) == DataFrames._names(i3)
    @test DataFrames.parentcols(SubIndex(i3, r"x1.$")) == [1]
    @test isempty(DataFrames.parentcols(SubIndex(i3, r"xx")))
    @test DataFrames.parentcols(SubIndex(i3, r"")) == 1:2
    @test DataFrames.parentcols(SubIndex(i3, All())) == 1:2
    @test DataFrames.parentcols(SubIndex(i3, Cols(:))) == 1:2
    @test DataFrames.parentcols(SubIndex(i3, Cols())) == Int[]
    @test_throws BoundsError DataFrames.parentcols(SubIndex(i3, Between(:x1, :x12))) == 1:2
    @test DataFrames.parentcols(SubIndex(i3, Between(:x12, :x12))) == 1:1
    @test isempty(DataFrames.parentcols(SubIndex(i3, [])))
end

@testset "Not indexing" begin
    i = Index()
    push!(i, :x1)
    push!(i, :x12)
    push!(i, :x131)
    push!(i, :y13)
    push!(i, :yy13)
    @test i[Not(2, 4, 5)] == [1, 3]
    @test i[Not(2, :y13, "yy13")] == [1, 3]
    @test i[Not(Not(r"x1."))] == [2, 3]
    @test isempty(i[Not(Not(r"xx"))])
    @test i[Not(Not(r""))] == 1:5
    @test DataFrames._names(SubIndex(i, Not(Not(r"x1.")))) == [:x12, :x131]
    @test isempty(names(SubIndex(i, Not(Not(r"xx")))))
    @test names(SubIndex(i, Not(Not(r"")))) == names(i)
    @test DataFrames._names(SubIndex(i, Not(Not(r"x1.")))) == [:x12, :x131]
    @test isempty(DataFrames._names(SubIndex(i, Not(Not(r"xx")))))
    @test DataFrames._names(SubIndex(i, Not(Not(r"")))) == DataFrames._names(i)
    @test DataFrames.parentcols(SubIndex(i, Not(Not(r"x1.")))) == [2, 3]
    @test isempty(DataFrames.parentcols(SubIndex(i, Not(Not(r"xx")))))
    @test DataFrames.parentcols(SubIndex(i, Not(Not(r"")))) == 1:5

    i2 = SubIndex(i, Not(Not(r"")))
    @test i2[Not(Not(r"x1."))] == [2, 3]
    @test isempty(i2[Not(Not(r"xx"))])
    @test i2[Not(Not(r""))] == 1:5
    @test DataFrames._names(SubIndex(i2, Not(Not(r"x1.")))) == [:x12, :x131]
    @test isempty(names(SubIndex(i2, Not(Not(r"xx")))))
    @test names(SubIndex(i2, Not(Not(r"")))) == names(i)
    @test DataFrames._names(SubIndex(i2, Not(Not(r"x1.")))) == [:x12, :x131]
    @test isempty(DataFrames._names(SubIndex(i2, Not(Not(r"xx")))))
    @test DataFrames._names(SubIndex(i2, Not(Not(r"")))) == DataFrames._names(i2)
    @test DataFrames.parentcols(SubIndex(i2, Not(Not(r"x1.")))) == [2, 3]
    @test isempty(DataFrames.parentcols(SubIndex(i2, Not(Not(r"xx")))))
    @test DataFrames.parentcols(SubIndex(i2, Not(Not(r"")))) == 1:5

    i3 = SubIndex(i, Not(Not(r"x1.")))
    @test i3[Not(Not(r"x1.$"))] == [1]
    @test isempty(i3[Not(Not(r"xx"))])
    @test i3[Not(Not(r""))] == 1:2
    @test DataFrames._names(SubIndex(i3, Not(Not(r"x1.$")))) == [:x12]
    @test isempty(names(SubIndex(i3, Not(Not(r"xx")))))
    @test names(SubIndex(i3, Not(Not(r"")))) == names(i3)
    @test DataFrames._names(SubIndex(i3, Not(Not(r"x1.$")))) == [:x12]
    @test isempty(DataFrames._names(SubIndex(i3, Not(Not(r"xx")))))
    @test DataFrames._names(SubIndex(i3, Not(Not(r"")))) == DataFrames._names(i3)
    @test DataFrames.parentcols(SubIndex(i3, Not(Not(r"x1.$")))) == [1]
    @test isempty(DataFrames.parentcols(SubIndex(i3, Not(Not(r"xx")))))
    @test DataFrames.parentcols(SubIndex(i3, Not(Not(r"")))) == 1:2
end

@testset "Between indexing" begin
    df = DataFrame(a=1, b=2, c=3)
    @test select(df, Between(1, 2)) == df[:, 1:2]
    @test select(df, Between(1, :b)) == df[:, 1:2]
    @test select(df, Between(1, "b")) == df[:, 1:2]
    @test select(df, Between(:a, 2)) == df[:, 1:2]
    @test select(df, Between("a", 2)) == df[:, 1:2]
    @test select(df, Between(:a, :b)) == df[:, 1:2]
    @test select(df, Between("a", "b")) == df[:, 1:2]
    @test select(df, Between(2, 1)) == df[:, 2:1]
    @test select(df, Between(:b, 1)) == df[:, 2:1]
    @test select(df, Between("b", 1)) == df[:, 2:1]
    @test select(df, Between(2, :a)) == df[:, 2:1]
    @test select(df, Between(2, "a")) == df[:, 2:1]
    @test select(df, Between("b", "a")) == df[:, 2:1]
    @test select(df, Between("b", "a")) == df[:, 2:1]

    @test df[:, Between(1, 2)] == df[:, 1:2]
    @test df[:, Between(1, :b)] == df[:, 1:2]
    @test df[:, Between(1, "b")] == df[:, 1:2]
    @test df[:, Between(:a, 2)] == df[:, 1:2]
    @test df[:, Between("a", 2)] == df[:, 1:2]
    @test df[:, Between(:a, :b)] == df[:, 1:2]
    @test df[:, Between("a", "b")] == df[:, 1:2]
    @test df[:, Between(2, 1)] == df[:, 2:1]
    @test df[:, Between(:b, 1)] == df[:, 2:1]
    @test df[:, Between("b", 1)] == df[:, 2:1]
    @test df[:, Between(2, :a)] == df[:, 2:1]
    @test df[:, Between(2, "a")] == df[:, 2:1]
    @test df[:, Between(:b, :a)] == df[:, 2:1]
    @test df[:, Between("b", "a")] == df[:, 2:1]

    @test_throws BoundsError df[:, Between(:b, 0)]
    @test_throws BoundsError df[:, Between(0, :b)]
    @test_throws ArgumentError df[:, Between(:b, :z)]
    @test_throws ArgumentError df[:, Between(:z, :b)]
    @test_throws BoundsError df[:, Between("b", 0)]
    @test_throws BoundsError df[:, Between(0, "b")]
    @test_throws ArgumentError df[:, Between("b", "z")]
    @test_throws ArgumentError df[:, Between("z", "b")]
end

@testset "All indexing" begin
    df = DataFrame(a=1, b=2, c=3)
    @test select(df, All()) == df[:, :]
    @test df[:, All()] == df[:, :]
    @test_throws ArgumentError select(df, All(1))
    @test_throws ArgumentError df[:, All(1)]
end

@testset "Cols indexing" begin
    df = DataFrame(a=1, b=2, c=3)

    @test ncol(select(df, Cols())) == 0
    @test ncol(df[:, Cols()]) == 0

    @test select(df, Cols(:)) == df[:, :]
    @test df[:, Cols(:)] == df[:, :]

    @test select(df, Cols(1, 2)) == df[:, 1:2]
    @test select(df, Cols(1, :b)) == df[:, 1:2]
    @test select(df, Cols(:a, 2)) == df[:, 1:2]
    @test select(df, Cols(:a, :b)) == df[:, 1:2]
    @test select(df, Cols(2, 1)) == df[:, [2, 1]]
    @test select(df, Cols(:b, 1)) == df[:, [2, 1]]
    @test select(df, Cols(2, :a)) == df[:, [2, 1]]
    @test select(df, Cols(:b, :a)) == df[:, [2, 1]]

    @test df[:, Cols(1, 2)] == df[:, 1:2]
    @test df[:, Cols(1, :b)] == df[:, 1:2]
    @test df[:, Cols(:a, 2)] == df[:, 1:2]
    @test df[:, Cols(:a, :b)] == df[:, 1:2]
    @test df[:, Cols(2, 1)] == df[:, [2, 1]]
    @test df[:, Cols(:b, 1)] == df[:, [2, 1]]
    @test df[:, Cols(2, :a)] == df[:, [2, 1]]
    @test df[:, Cols(:b, :a)] == df[:, [2, 1]]

    @test df[:, Cols(1, 1, 2)] == df[:, 1:2]
    @test df[:, Cols(:a, 1, :b)] == df[:, 1:2]
    @test df[:, Cols(:a, 2, :b)] == df[:, 1:2]
    @test df[:, Cols(:a, :b, 2)] == df[:, 1:2]
    @test df[:, Cols(2, 1, :a)] == df[:, [2, 1]]

    @test select(df, Cols(1, "b")) == df[:, 1:2]
    @test select(df, Cols("a", 2)) == df[:, 1:2]
    @test select(df, Cols("a", "b")) == df[:, 1:2]
    @test select(df, Cols("b", 1)) == df[:, [2, 1]]
    @test select(df, Cols(2, "a")) == df[:, [2, 1]]
    @test select(df, Cols("b", "a")) == df[:, [2, 1]]

    @test df[:, Cols(1, "b")] == df[:, 1:2]
    @test df[:, Cols("a", 2)] == df[:, 1:2]
    @test df[:, Cols("a", "b")] == df[:, 1:2]
    @test df[:, Cols("b", 1)] == df[:, [2, 1]]
    @test df[:, Cols(2, "a")] == df[:, [2, 1]]
    @test df[:, Cols("b", "a")] == df[:, [2, 1]]

    @test df[:, Cols("a", 1, "b")] == df[:, 1:2]
    @test df[:, Cols("a", 2, "b")] == df[:, 1:2]
    @test df[:, Cols("a", "b", 2)] == df[:, 1:2]
    @test df[:, Cols(2, 1, "a")] == df[:, [2, 1]]

    df = DataFrame(a1=1, a2=2, b1=3, b2=4)
    @test df[:, Cols(r"a", Not(r"1"))] == df[:, [1, 2, 4]]
    @test df[:, Cols(Not(r"1"), r"a")] == df[:, [2, 4, 1]]
    @test df[:, Cols(x -> x[1] == 'a')] == df[:, [1, 2]]
    @test df[:, Cols(x -> x[end] == '1')] == df[:, [1, 3]]
    @test df[:, Cols(x -> x[end] == '3')] == DataFrame()
    @test df[:, Cols(x -> true, 1)] == df
    @test df[:, Cols(1, x -> true)] == df
    @test df[:, Cols(x -> true, 1, operator=intersect)] == DataFrame(a1=1)
    @test df[:, Cols(1, x -> true, operator=intersect)] == DataFrame(a1=1)

    @test ncol(select(df, Cols(operator=intersect))) == 0
    @test ncol(df[:, Cols(operator=intersect)]) == 0

    @test select(df, Cols(:, operator=intersect)) == df[:, :]
    @test df[:, Cols(:, operator=intersect)] == df[:, :]

    df = DataFrame(a=1, b=2, c=3)
    @test select(df, Cols(1, 2, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(1, :b, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(:a, 2, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(:a, :b, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(2, 1, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(:b, 1, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(2, :a, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(:b, :a, operator=intersect)) == df[:, 2:1]

    @test df[:, Cols(1, 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(1, :b, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:a, 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:a, :b, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(2, 1, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:b, 1, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(2, :a, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:b, :a, operator=intersect)] == df[:, 2:1]

    @test df[:, Cols(1, 1, 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:a, 1, :b, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:a, 2, :b, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(:a, :b, 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(2, 1, :a, operator=intersect)] == df[:, 2:1]

    @test select(df, Cols(1, "b", operator=intersect)) == df[:, 2:1]
    @test select(df, Cols("a", 2, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols("a", "b", operator=intersect)) == df[:, 2:1]
    @test select(df, Cols("b", 1, operator=intersect)) == df[:, 2:1]
    @test select(df, Cols(2, "a", operator=intersect)) == df[:, 2:1]
    @test select(df, Cols("b", "a", operator=intersect)) == df[:, 2:1]

    @test df[:, Cols(1, "b", operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("a", 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("a", "b", operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("b", 1, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(2, "a", operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("b", "a", operator=intersect)] == df[:, 2:1]

    @test df[:, Cols("a", 1, "b", operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("a", 2, "b", operator=intersect)] == df[:, 2:1]
    @test df[:, Cols("a", "b", 2, operator=intersect)] == df[:, 2:1]
    @test df[:, Cols(2, 1, "a", operator=intersect)] == df[:, 2:1]

    df = DataFrame(a1=1, a2=2, b1=3, b2=4)
    @test df[:, Cols(r"a", Not(r"1"), operator=intersect)] == df[:, [:a2]]
    @test df[:, Cols(Not(r"1"), r"a", operator=intersect)] == df[:, [:a2]]
    @test df[:, Cols(4:-1:1, 2:3, operator=intersect)] == df[:, [3, 2]]
    @test df[:, Cols(1:3, 4:-1:1, 2:3, operator=intersect)] == df[:, [2, 3]]
    @test df[:, Cols(1:3, 4:-1:1, 1:3, :b1, operator=intersect)] == df[:, [:b1]]
    @test df[:, Cols(x -> x[1] == 'a', operator=intersect)] == df[:, [1, 2]]
    @test df[:, Cols(x -> x[end] == '1', operator=intersect)] == df[:, [1, 3]]
    @test df[:, Cols(x -> x[end] == '3', operator=intersect)] == DataFrame()
    @test df[:, Cols(x -> true, 1, operator=intersect)] == df[:, 1:1]
    @test df[:, Cols(1, x -> true, operator=intersect)] == df[:, 1:1]

    @test df[:, Cols(startswith("a"), endswith("2"))] ==
          select(df, Cols(startswith("a"), endswith("2"))) ==
          df[:, ["a1", "a2", "b2"]]
    @test df[:, Cols(startswith("a"), endswith("2"), operator=intersect)] ==
          df[:, Cols(startswith("a"), :, endswith("2"), operator=intersect)] ==
          select(df, Cols(startswith("a"), endswith("2"), operator=intersect)) ==
          df[:, ["a2"]]
    @test df[:, Cols(startswith("a"), endswith("2"), operator=setdiff)] ==
          select(df, Cols(startswith("a"), endswith("2"), operator=setdiff)) ==
          df[:, ["a1"]]
    @test df[:, Cols(startswith("a"), endswith("2"), :, operator=setdiff)] == DataFrame()
end

@testset "views" begin
    df = DataFrame(a=1, b=2, c=3)
    dfv = view(df, 1:1, [:a, :c])
    @test DataFrames.parentcols(DataFrames.index(dfv)) == [1, 3]
    @test DataFrames.parentcols(DataFrames.index(dfv), :c) == 3
    @test DataFrames.parentcols(DataFrames.index(dfv), "c") == 3
    @test DataFrames.parentcols(DataFrames.index(dfv), 2) == 3
    @test DataFrames.parentcols(DataFrames.index(dfv), [:c, :c]) == [3, 3]
    @test DataFrames.parentcols(DataFrames.index(dfv), ["c", "c"]) == [3, 3]
    @test DataFrames.parentcols(DataFrames.index(dfv), [2, 2]) == [3, 3]
    @test DataFrames.index(dfv)["c"] == 2
    @test DataFrames.index(dfv)[:c] == 2
    @test DataFrames.index(dfv)[["a", "c"]] == [1, 2]
    @test DataFrames.index(dfv)[[:a, :c]] == [1, 2]
end

@testset "merge" begin
    i1 = Index([:a, :b, :c])
    si11 = SubIndex(i1, 1:2)
    si12 = SubIndex(i1, 2:3)
    i2 = Index([:c, :d, :e])
    si21 = SubIndex(i2, 1:2)
    si22 = SubIndex(i2, 2:3)

    @test_throws ArgumentError merge(i1, i2)
    @test merge(i1, i2, makeunique=true) isa Index
    @test names(merge(i1, i2, makeunique=true)) == ["a", "b", "c", "c_1", "d", "e"]
    @test_throws ArgumentError merge(i1, si21)
    @test merge(i1, si21, makeunique=true) isa Index
    @test names(merge(i1, si21, makeunique=true)) == ["a", "b", "c", "c_1", "d"]
    @test merge(i1, si22) isa Index
    @test names(merge(i1, si22)) == ["a", "b", "c", "d", "e"]
    @test merge(si11, i2) isa Index
    @test names(merge(si11, i2)) == ["a", "b", "c", "d", "e"]
    @test merge(si11, si22) isa Index
    @test names(merge(si11, si22)) == ["a", "b", "d", "e"]
    @test_throws ArgumentError merge(si12, si21)
    @test merge(si12, si21, makeunique=true) isa Index
    @test names(merge(si12, si21, makeunique=true)) == ["b", "c", "c_1", "d"]

    df = DataFrame(a=1)
    dfv = view(df, 1:1, 1:1)
    @test_throws ArgumentError crossjoin(df, df)
    @test_throws ArgumentError crossjoin(dfv, dfv)
    @test crossjoin(df, df, makeunique=true) == DataFrame(a=1, a_1=1)
    @test crossjoin(dfv, dfv, makeunique=true) == DataFrame(a=1, a_1=1)
end

@testset "AsTable constructor" begin
    @test_throws ArgumentError AsTable(1.0)
    @test_throws ArgumentError AsTable(true)
    @test_throws ArgumentError AsTable(false)
    @test_throws ArgumentError AsTable(Any[1, missing])
    @test_throws ArgumentError AsTable([1, missing])
    @test_throws ArgumentError AsTable([true, missing])
    @test_throws ArgumentError AsTable(Any[true, missing])
    @test_throws ArgumentError AsTable([:A, missing])
    @test_throws ArgumentError AsTable(Any[:A, missing])
    @test_throws ArgumentError AsTable(1.0:1.0)
    @test_throws ArgumentError AsTable([1.0])
    @test_throws ArgumentError AsTable(Any[1.0])
    @test_throws ArgumentError AsTable([:a, "a", 1, true, 1.0])
    @test_throws ArgumentError AsTable(:a => :b)

    @test AsTable(Union{Bool, Missing}[true, false]).cols == [true, false]
    @test AsTable([:a, "a", 1, true]).cols == [:a, "a", 1, true]
    @test AsTable([]).cols == []
    @test AsTable(Int[]).cols == []
    @test AsTable(Symbol[]).cols == []
    @test AsTable(:).cols == Colon()
    @test AsTable(Not(Not(:))).cols == Not(Not(:))
    @test AsTable(Not(1:0)).cols == Not(1:0)
    @test AsTable(Between(1, 2)).cols == Between(1, 2)
    @test AsTable(All()).cols == All()
    @test AsTable(r"x").cols == r"x"
    @test AsTable("a").cols == "a"
    @test AsTable(1).cols == 1
    @test AsTable(0x1).cols == 0x1
    @test AsTable([:a, :b]).cols == [:a, :b]
    @test AsTable(["a", "b"]).cols == ["a", "b"]
    @test AsTable([1, 2]).cols == [1, 2]
    @test AsTable(Integer[1, true]).cols == Integer[1, true]
end

end # module

module TestUtils

using Test, Random, DataFrames

@testset "make_unique" begin
    @test DataFrames.make_unique([:x, :x, :x_1, :x2], makeunique=true) == [:x, :x_2, :x_1, :x2]
    @test_throws ArgumentError DataFrames.make_unique([:x, :x, :x_1, :x2], makeunique=false)
    @test DataFrames.make_unique([:x, :x_1, :x2], makeunique=false) == [:x, :x_1, :x2]
end

@testset "repeat count" begin
    df = DataFrame(a=1:2, b=3:4)
    ref = DataFrame(a=repeat(1:2, 2),
                    b=repeat(3:4, 2))
    @test repeat(df, 2) == ref
    @test repeat(view(df, 1:2, :), 2) == ref

    @test size(repeat(df, 0)) == (0, 2)
    @test size(repeat(df, false)) == (0, 2)
    @test_throws ArgumentError repeat(df, -1)
end

@testset "repeat inner_outer" begin
    df = DataFrame(a=1:2, b=3:4)
    ref = DataFrame(a=repeat(1:2, inner=2, outer=3),
                    b=repeat(3:4, inner=2, outer=3))
    @test repeat(df, inner=2, outer=3) == ref
    @test repeat(view(df, 1:2, :), inner=2, outer=3) == ref

    @test size(repeat(df, inner=2, outer=0)) == (0, 2)
    @test size(repeat(df, inner=0, outer=3)) == (0, 2)
    @test size(repeat(df, inner=2, outer=false)) == (0, 2)
    @test size(repeat(df, inner=false, outer=3)) == (0, 2)
    @test_throws ArgumentError repeat(df, inner=2, outer=-1)
    @test_throws ArgumentError repeat(df, inner=-1, outer=3)
end

@testset "repeat! count" begin
    df = DataFrame(a=1:2, b=3:4)
    ref = DataFrame(a=repeat(1:2, 2),
                    b=repeat(3:4, 2))
    a = df.a
    b = df.b
    repeat!(df, 2)
    @test df == ref
    @test a == 1:2
    @test b == 3:4

    for v in (0, false)
        df = DataFrame(a=1:2, b=3:4)
        repeat!(df, v)
        @test size(df) == (0, 2)
    end

    df = DataFrame(a=1:2, b=3:4)
    @test_throws ArgumentError repeat(df, -1)
    @test df == DataFrame(a=1:2, b=3:4)

    @test_throws MethodError repeat!(view(df, 1:2, :), 2)
end

@testset "repeat! inner_outer" begin
    df = DataFrame(a=1:2, b=3:4)
    ref = DataFrame(a=repeat(1:2, inner=2, outer=3),
                    b=repeat(3:4, inner=2, outer=3))
    a = df.a
    b = df.b
    repeat!(df, inner = 2, outer = 3)
    @test df == ref
    @test a == 1:2
    @test b == 3:4

    for v in (0, false)
        df = DataFrame(a=1:2, b=3:4)
        repeat!(df, inner=2, outer=v)
        @test size(df) == (0, 2)

        df = DataFrame(a=1:2, b=3:4)
        repeat!(df, inner=v, outer=3)
        @test size(df) == (0, 2)
    end

    df = DataFrame(a=1:2, b=3:4)
    @test_throws ArgumentError repeat(df, inner = 2, outer = -1)
    @test_throws ArgumentError repeat(df, inner = -1, outer = 3)
    @test df == DataFrame(a=1:2, b=3:4)

    @test_throws MethodError repeat!(view(df, 1:2, :), inner = 2, outer = 3)
end

@testset "funname" begin
    @test DataFrames.funname(sum ∘ skipmissing ∘ Base.div12) ==
          :sum_skipmissing_div12
end

@testset "_findall(B::BitVector)" begin
    Random.seed!(1234)
    BD = Dict(
        "Empty" => (BitVector([]), UnitRange{Int}),
        "T Big" => (trues(100000), UnitRange{Int}),
        "F Big" => (falses(100000), UnitRange{Int}),
        "T64 F64" => ([trues(64); falses(64)], UnitRange{Int}),
        "F64 T64" => ([falses(64); trues(64)], UnitRange{Int}),
        "F80 T100" => ([falses(85); trues(100)], UnitRange{Int}),
        "F256 T32" => ([falses(256); trues(32)], UnitRange{Int}),
        "F260 T32" => ([falses(260); trues(32)], UnitRange{Int}),
        "TF Big" => ([trues(100000); falses(100000)], UnitRange{Int}),
        "FT Big" => ([falses(100000); trues(100000)], UnitRange{Int}),

        # some edge cases
        "TFT small" => ([trues(85); falses(100); trues(85)], Vector{Int}),
        "FTFFT small" => ([falses(64 + 32); trues(32); falses(128); trues(32)], Vector{Int}),
        "TFTF small" => ([falses(64); trues(64); falses(64); trues(64)], Vector{Int}),
        "TFT small2" => ([trues(64); falses(10); trues(100)], Vector{Int}),

        "FTF Big" => ([falses(8500); trues(100000); falses(65000)], UnitRange{Int}),
        "TFT Big" => ([trues(8500); falses(100000); trues(65000)], Vector{Int}),
        "FTFTFTF Big" => ([falses(65000); trues(65000); falses(65000); trues(65000); falses(65000); trues(65000); falses(65000)], Vector{Int}),

        "FTFR small" => ([falses(85); trues(100); falses(65); rand([true, false], 2000)], Vector{Int}),
        "R Big" => (BitVector(rand([true, false], 2000000)), Vector{Int}),
        "RF Big" => ([BitVector(rand([true, false], 1000000)); falses(1000000)], Vector{Int}),
        "RT Big" => ([BitVector(rand([true, false], 1000000));  trues(1000000)], Vector{Int}),
        "FR Big" => ([falses(1000000); BitVector(rand([true, false], 1000000))], Vector{Int}),
        "TR Big" => ([trues(1000000);  BitVector(rand([true, false], 1000000))], Vector{Int}),
        "FRT Big" => ([falses(1000000); BitVector(rand([true, false], 1000000)); trues(1000000)], Vector{Int}),
        "TRF Big" => ([trues(1000000); BitVector(rand([true, false], 1000000)); falses(1000000)], Vector{Int}),
        "FRF Big" => ([falses(1000000); BitVector(rand([true, false], 1000000)); falses(1000000)], Vector{Int}),
        "TRT Big" => ([trues(1000000); BitVector(rand([true, false], 1000000)); trues(1000000)], Vector{Int}),
        "RFR Big" => ([BitVector(rand([true, false], 1000000)); falses(1000000); BitVector(rand([true, false], 1000000))], Vector{Int}),
        "FTFR Big" => ([falses(65000);  trues(65000);  falses(65000); rand([true, false], 20000)], Vector{Int}),
        "T256 R100" => ([trues(256);  rand([true, false], 2000)], Vector{Int}),
        "F256 R100" => ([falses(256); rand([true, false], 2000)], Vector{Int}),
    )
    for (_, (B, T)) in BD
        res = DataFrames._findall(B)
        @test Base.findall(B) == res
        @test res isa T
        res = DataFrames._findall(Vector{Bool}(B))
        @test Base.findall(B) == res
        @test res isa T
    end

    # 1:200 is to test all small cases
    # 1000 is to test skipping multiple 64-bit blocks of 0 and 1
    for n in [1:200; 1000], i in 1:n, j in i:n
        x = falses(n)
        x[i:j] .= true
        res = DataFrames._findall(x)
        @test res == i:j
        @test res isa UnitRange{Int}
        res = DataFrames._findall(Vector{Bool}(x))
        @test res == i:j
        @test res isa UnitRange{Int}
        if j + 1 < n
            x[j + 2] = true
            # add one false and then true
            @test  DataFrames._findall(x) == [i:j; j+2]
            @test  DataFrames._findall(Vector{Bool}(x)) == [i:j; j+2]
            # sprinkle trues randomly after one false
            rand!(view(x, j + 2:n), Bool)
            @test  DataFrames._findall(x) == findall(x)
            @test  DataFrames._findall(Vector{Bool}(x)) == findall(x)
        end
    end
end

end # module

module TestDataFrame

using Dates, DataFrames, Statistics, Random, Test, Logging, DataStructures,
      CategoricalArrays, StableRNGs
using DataFrames: _columns, index
using OffsetArrays: OffsetArray
const ≅ = isequal
const ≇ = !isequal

isequal_coltyped(df1::AbstractDataFrame, df2::AbstractDataFrame) =
    isequal(df1, df2) && typeof.(eachcol(df1)) == typeof.(eachcol(df2))

# randomized test from https://github.com/JuliaData/DataFrames.jl/pull/1974
@testset "randomized tests for rename!" begin
    n = Symbol.('a':'z')
    Random.seed!(1234)
    for k in 1:20
        sn = shuffle(n)
        df = DataFrame(zeros(1, 26), n)
        p = Dict(Pair.(n, sn))
        cyclelength = Int[]
        for x in n
            i = 0
            y = x
            while true
                y = p[y]
                i += 1
                x == y && break
            end
            push!(cyclelength, i)
        end
        i = lcm(cyclelength)
        while true
            rename!(df, p)
            @test sort(propertynames(df)) == n
            @test sort(names(df)) == string.(n)
            @test sort(collect(keys(index(df).lookup))) == n
            @test sort(collect(values(index(df).lookup))) == 1:26
            @test all(index(df).lookup[x] == i for (i, x) in enumerate(propertynames(df)))
            i -= 1
            propertynames(df) == n && break
        end
        @test i == 0
    end
end

# additional randomized tests of renaming only part of the columns
# they cover both cases leading to duplicate names and not leading to them
# but possibly allowing for cyclical renaming and non-cyclical renaming that
# would lead to duplicates if we did the renaming sequentially as before
@testset "additional rename! tests" begin
    Random.seed!(123)
    for i in 1:1000
        oldnames = Symbol.(rand('a':'z', 8))
        while !allunique(oldnames)
            oldnames .= Symbol.(rand('a':'z', 8))
        end
        newnames = [Symbol.(rand('a':'z', 4)); oldnames[5:end]]
        df = DataFrame([[] for i in 1:8], oldnames)
        if allunique(newnames)
            @test names(rename(df, Pair.(oldnames[1:4], newnames[1:4])...)) == string.(newnames)
            @test propertynames(df) == oldnames
            rename!(df, Pair.(oldnames[1:4], newnames[1:4])...)
            @test propertynames(df) == newnames
        else
            @test_throws ArgumentError rename(df, Pair.(oldnames[1:4], newnames[1:4])...)
            @test propertynames(df) == oldnames
            @test_throws ArgumentError rename!(df, Pair.(oldnames[1:4], newnames[1:4])...)
            @test propertynames(df) == oldnames
        end

        newnames = [oldnames[1:2]; reverse(oldnames[3:6]); oldnames[7:end]]
        df = DataFrame([[] for i in 1:8], oldnames)
        @test names(rename(df, Pair.(oldnames[3:6], newnames[3:6])...)) == string.(newnames)
        @test propertynames(df) == oldnames
        rename!(df, Pair.(oldnames[3:6], newnames[3:6])...)
        @test propertynames(df) == newnames
    end
end

@testset "rename with integer source" begin
    df = DataFrame(a=1, b=2)
    @test rename(df, 1=>:c) == DataFrame(c=1, b=2)
    @test rename(df, big(1)=>:c) == DataFrame(c=1, b=2)
    @test rename(df, 0x1=>:c) == DataFrame(c=1, b=2)
    @test rename(df, 1=>:a) == DataFrame(a=1, b=2)
    @test rename(df, 1=>"c") == DataFrame(c=1, b=2)
    @test rename(df, [1=>:b, 2=>:a]) == DataFrame(b=1, a=2)
    @test rename(df, [1=>"b", 2=>"a"]) == DataFrame(b=1, a=2)
    @test rename(df, Dict(1=>:b, 2=>:a)) == DataFrame(b=1, a=2)
    @test rename(df, Dict(1=>"b", 2=>"a")) == DataFrame(b=1, a=2)
    @test_throws ArgumentError rename(df, 1=>:b)
    @test_throws ArgumentError rename(df, true=>:b)
    @test_throws BoundsError rename(df, 0=>:b)
    @test_throws BoundsError rename(df, 3=>:b)
    @test_throws DimensionMismatch rename(df, [:p, :q, :r])

    @test rename!(copy(df), 1=>:c) == DataFrame(c=1, b=2)
    @test rename!(copy(df), big(1)=>:c) == DataFrame(c=1, b=2)
    @test rename!(copy(df), 0x1=>:c) == DataFrame(c=1, b=2)
    @test rename!(copy(df), 1=>:a) == DataFrame(a=1, b=2)
    @test rename!(copy(df), 1=>"c") == DataFrame(c=1, b=2)
    @test rename!(copy(df), [1=>:b, 2=>:a]) == DataFrame(b=1, a=2)
    @test rename!(copy(df), [1=>"b", 2=>"a"]) == DataFrame(b=1, a=2)
    @test rename!(copy(df), Dict(1=>:b, 2=>:a)) == DataFrame(b=1, a=2)
    @test rename!(copy(df), Dict(1=>"b", 2=>"a")) == DataFrame(b=1, a=2)
    @test_throws ArgumentError rename!(df, 1=>:b)
    @test_throws ArgumentError rename!(df, true=>:b)
    @test_throws BoundsError rename!(df, 0=>:b)
    @test_throws BoundsError rename!(df, 3=>:b)
    @test_throws DimensionMismatch rename!(df, [:p, :q, :r])
    @test df == DataFrame(a=1, b=2)
end

@testset "equality" begin
    @test DataFrame(a=[1, 2, 3], b=[4, 5, 6]) == DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    @test DataFrame(a=[1, 2], b=[4, 5]) != DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    @test DataFrame(a=[1, 2, 3], b=[4, 5, 6]) != DataFrame(a=[1, 2, 3])
    @test DataFrame(a=[1, 2, 3], b=[4, 5, 6]) != DataFrame(a=[1, 2, 3], c=[4, 5, 6])
    @test DataFrame(a=[1, 2, 3], b=[4, 5, 6]) != DataFrame(b=[4, 5, 6], a=[1, 2, 3])
    @test DataFrame(a=[1, 2, 2], b=[4, 5, 6]) != DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    @test DataFrame(a=[1, 3, missing], b=[4, 5, 6]) != DataFrame(a=[1, 2, missing], b=[4, 5, 6])
    @test DataFrame(a=[1, 2, missing], b=[4, 5, 6]) ≅ DataFrame(a=[1, 2, missing], b=[4, 5, 6])
    @test DataFrame(a=[1, 2, missing], b=[4, 5, 6]) ≇ DataFrame(a=[1, 2, 3], b=[4, 5, 6])
end

@testset "copying" begin
    df = DataFrame(a=Union{Int, Missing}[2, 3],
                   b=Union{DataFrame, Missing}[DataFrame(c=1), DataFrame(d=2)])
    dfc = copy(df)
    dfcc = copy(df, copycols=false)
    dfdc = deepcopy(df)

    @test dfc == df
    @test dfc.a !== df.a
    @test dfc.b !== df.b
    @test DataFrames._columns(dfc) == DataFrames._columns(df)
    @test DataFrames._columns(dfc) !== DataFrames._columns(df)
    @test dfcc == df
    @test dfcc.a === df.a
    @test dfcc.b === df.b
    @test DataFrames._columns(dfcc) == DataFrames._columns(df)
    @test DataFrames._columns(dfcc) !== DataFrames._columns(df)
    @test dfdc == df
    @test dfdc.a !== df.a
    @test dfdc.b !== df.b
    @test DataFrames._columns(dfdc) == DataFrames._columns(df)
    @test DataFrames._columns(dfdc) !== DataFrames._columns(df)

    df[1, :a] = 4
    df[1, :b][!, :e] .= 5

    @test names(rename(df, [:f, :g])) == ["f", "g"]
    @test names(rename(df, [:f, :f], makeunique=true)) == ["f", "f_1"]
    @test names(df) == ["a", "b"]

    rename!(df, [:f, :g])

    @test names(dfc) == ["a", "b"]
    @test names(dfdc) == ["a", "b"]

    @test dfc[1, :a] === 2
    @test dfdc[1, :a] === 2

    @test names(dfc[1, :b]) == ["c", "e"]
    @test names(dfdc[1, :b]) == ["c"]
end

@testset "similar / missings" begin
    df = DataFrame(a=Union{Int, Missing}[1],
                   b=Union{String, Missing}["b"],
                   c=CategoricalArray{Union{Float64, Missing}}([3.3]))
    missingdf = DataFrame(a=missings(Int, 2),
                          b=missings(String, 2),
                          c=CategoricalArray{Union{Float64, Missing}}(undef, 2))
    # https://github.com/JuliaData/Missings.jl/issues/66
    # @test missingdf ≅ similar(df, 2)
    @test typeof.(eachcol(similar(df, 2))) == typeof.(eachcol(missingdf))
    @test size(similar(df, 2)) == size(missingdf)
end

@testset "hasproperty" begin
    df = DataFrame(a=[1, 2])
    @test hasproperty(df, :a)
    @test !hasproperty(df, :c)
    @test_throws MethodError hasproperty(df, 1)
    @test_throws MethodError hasproperty(df, 1.5)
    @test_throws MethodError hasproperty(df, true)
end

@testset "insertcols!" begin
    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test_throws ArgumentError insertcols!(df, 5, :newcol => ["a", "b"])
    @test_throws ArgumentError insertcols!(df, 0, :newcol => ["a", "b"])
    @test_throws ArgumentError insertcols!(df, :z, :newcol => ["a", "b"])
    @test_throws ArgumentError insertcols!(df, "z", :newcol => ["a", "b"])
    @test_throws MethodError insertcols!(df, true, :newcol => ["a", "b"])
    @test_throws DimensionMismatch insertcols!(df, 1, :newcol => ["a"])
    @test_throws DimensionMismatch insertcols!(df, :a, :newcol => ["a"])
    @test_throws DimensionMismatch insertcols!(df, "a", :newcol => ["a"])
    ref1 = insertcols!(copy(df), :a, :newcol => ["a", "b"])
    ref2 = insertcols!(copy(df), "a", :newcol => ["a", "b"])
    @test insertcols!(df, 1, :newcol => ["a", "b"]) == df
    @test ref1 == ref2 == df
    @test names(df) == ["newcol", "a", "b"]
    @test df.a == [1, 2]
    @test df.b == [3.0, 4.0]
    @test df.newcol == ["a", "b"]

    @test_throws ArgumentError insertcols!(df, 1, :newcol => ["a1", "b1"])
    @test insertcols!(df, 1, :newcol => ["a1", "b1"], makeunique=true) == df
    @test propertynames(df) == [:newcol_1, :newcol, :a, :b]
    @test df.a == [1, 2]
    @test df.b == [3.0, 4.0]
    @test df.newcol == ["a", "b"]
    @test df.newcol_1 == ["a1", "b1"]

    @test insertcols!(df, 1, :c1 => 1:2) === df
    @test df.c1 isa Vector{Int}
    x = [1, 2]
    @test insertcols!(df, 1, :c2 => x, copycols=true) === df
    @test df.c2 == x
    @test df.c2 !== x
    @test insertcols!(df, 1, :c3 => x, copycols=false) === df
    @test df.c3 === x

    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test_throws ArgumentError insertcols!(df, 5, "newcol" => ["a", "b"])
    @test_throws ArgumentError insertcols!(df, 0, "newcol" => ["a", "b"])
    @test_throws DimensionMismatch insertcols!(df, 1, "newcol" => ["a"])
    @test insertcols!(df, 1, "newcol" => ["a", "b"]) == df
    @test names(df) == ["newcol", "a", "b"]
    @test df.a == [1, 2]
    @test df.b == [3.0, 4.0]
    @test df.newcol == ["a", "b"]

    @test_throws ArgumentError insertcols!(df, 1, "newcol" => ["a1", "b1"])
    @test insertcols!(df, 1, "newcol" => ["a1", "b1"], makeunique=true) == df
    @test propertynames(df) == [:newcol_1, :newcol, :a, :b]
    @test df.a == [1, 2]
    @test df.b == [3.0, 4.0]
    @test df.newcol == ["a", "b"]
    @test df.newcol_1 == ["a1", "b1"]

    @test insertcols!(df, 1, "c1" => 1:2) === df
    @test df.c1 isa Vector{Int}
    x = [1, 2]
    @test insertcols!(df, 1, "c2" => x, copycols=true) === df
    @test df.c2 == x
    @test df.c2 !== x
    @test insertcols!(df, 1, "c3" => x, copycols=false) === df
    @test df.c3 === x

    df = DataFrame(a=[1, 2], a_1=[3, 4])
    @test_throws ArgumentError insertcols!(df, 1, :a => [11, 12])
    @test df == DataFrame(a=[1, 2], a_1=[3, 4])
    insertcols!(df, 1, :a => [11, 12], makeunique=true)
    @test propertynames(df) == [:a_2, :a, :a_1]
    insertcols!(df, 4, :a => [11, 12], makeunique=true)
    @test propertynames(df) == [:a_2, :a, :a_1, :a_3]
    @test_throws ArgumentError insertcols!(df, 10, :a => [11, 12], makeunique=true)

    dfc = copy(df)
    @test insertcols!(df, 2) == dfc
    @test_throws ArgumentError insertcols!(df, 10)
    @test_throws MethodError insertcols!(df, 2, a=1, b=2)

    df = DataFrame()
    @test insertcols!(df, 1, :x=>[1]) == DataFrame(x=[1])
    df = DataFrame()
    @test_throws ArgumentError insertcols!(df, 2, :x=>[1])
    df = DataFrame()
    @test insertcols!(df, 1, :x=>1:2) == DataFrame(x=1:2)
    @test df.x isa Vector{Int}
    x = [1, 2]
    df = DataFrame()
    @test insertcols!(df, 1, :x=>x, copycols=true) == DataFrame(x=1:2)
    @test df.x !== x
    df = DataFrame()
    @test insertcols!(df, 1, :x=>x, copycols=false) == DataFrame(x=1:2)
    @test df.x === x

    df = DataFrame()
    v1 = 1:2
    v2 = [3, 4]
    v3 = [5, 6]
    @test insertcols!(df, 1, :a=>v1, :b=>v2, :c=>v3, copycols=false) == DataFrame(a=v1, b=v2, c=v3)
    @test df.a isa Vector{Int}
    @test df.b === v2
    @test df.c === v3

    df = DataFrame()
    @test insertcols!(df, 1, :a=>v1, :b=>v2, :c=>v3, copycols=true) ==
          DataFrame(a=v1, b=v2, c=v3)
    @test df.a isa Vector{Int}
    @test df.b !== v2
    @test df.c !== v3

    df = DataFrame()
    @test insertcols!(df, 1, :a=>v1, :a=>v2, :a=>v3, makeunique=true, copycols=false) ==
          DataFrame(a=v1, a_1=v2, a_2=v3)
    @test df.a isa Vector{Int}
    @test df.a_1 === v2
    @test df.a_2 === v3

    df = DataFrame(p='a':'b', q='r':'s')
    @test insertcols!(df, 2, :a=>v1, :b=>v2, :c=>v3) ==
          DataFrame(p='a':'b', a=v1, b=v2, c=v3, q='r':'s')

    df = DataFrame(p='a':'b', q='r':'s')
    @test insertcols!(df, 2, "a"=>v1, "b"=>v2, "c"=>v3) ==
          DataFrame(p='a':'b', a=v1, b=v2, c=v3, q='r':'s')

    df = DataFrame(p='a':'b', q='r':'s')
    @test_throws ArgumentError insertcols!(df, 2, :p=>v1, :q=>v2, :p=>v3)
    @test insertcols!(df, 2, :p=>v1, :q=>v2, :p=>v3, makeunique=true, copycols=true) ==
          DataFrame(p='a':'b', p_1=v1, q_1=v2, p_2=v3, q='r':'s')
    @test df.p_1 isa Vector{Int}
    @test df.q_1 !== v2
    @test df.p_2 !== v3

    df = DataFrame(a=1:3, b=4:6)
    @test insertcols!(copy(df), :c=>7:9) == insertcols!(copy(df), 3, :c=>7:9)
    df = DataFrame()
    @test insertcols!(df, :a=>1:3) == DataFrame(a=1:3)

    df = DataFrame(a=[1, 2], a_1=[3, 4])
    insertcols!(df, 1, :a => 11, makeunique=true)
    @test propertynames(df) == [:a_2, :a, :a_1]
    @test df[!, 1] == [11, 11]
    insertcols!(df, 4, :a => 12, makeunique=true)
    @test propertynames(df) == [:a_2, :a, :a_1, :a_3]
    @test df[!, 4] == [12, 12]
    df = DataFrame()
    @test insertcols!(df, :a => "a", :b => 1:2) == DataFrame(a=["a", "a"], b=1:2)

    df = DataFrame()
    insertcols!(df, :a => Ref(1), :b => fill(1))
    @test df == DataFrame(a=[1], b=[1])
    df = DataFrame()
    insertcols!(df, :a => Ref(1), :b => fill(1), :c => 1:3)
    @test df == DataFrame(a=[1, 1, 1], b=[1, 1, 1], c=1:3)
    df = DataFrame(c=1:3)
    insertcols!(df, 1, :a => Ref(1), :b => fill(1))
    @test df == DataFrame(a=[1, 1, 1], b=[1, 1, 1], c=1:3)

    df = DataFrame(a=1)
    @test insertcols!(df, "a" => 2, makeunique=true) == DataFrame(a=1, a_1=2)
end

@testset "insertcols! old tests" begin
    df = DataFrame(a=1:3, b=4:6)
    df2 = insertcols(df, :c => 1)
    @test df == DataFrame(a=1:3, b=4:6)
    @test df2 == DataFrame(a=1:3, b=4:6, c=1)
    @test df.a !== df2.a
    @test df.b !== df2.b
    x = [7, 8, 9]
    df2 = insertcols(df, 0, :a => x, after=true, makeunique=true, copycols=false)
    @test df2 == DataFrame(a_1=x, a=1:3, b=4:6)
    @test df2[!, 1] === x
end

@testset "insertcols! with no cols" begin
    df = DataFrame(x=1:2)
    @test_throws ArgumentError insertcols!(df, 0)
    @test insertcols!(df, 2) === df
    @test insertcols!(df, 2) == DataFrame(x=1:2)
    @test insertcols!(df, :x) == DataFrame(x=1:2)
    @test insertcols!(df, "x") == DataFrame(x=1:2)
    @test insertcols!(df, "x", after=true, makeunique=true, copycols=true) == DataFrame(x=1:2)
    @test insertcols!(df, 0, after=true) == DataFrame(x=1:2)
    @test_throws ArgumentError insertcols!(df, 2, after=true)
    @test insertcols!(df) === df
    @test insertcols!(df) == DataFrame(x=1:2)
    @test insertcols!(df, after=true, makeunique=true, copycols=true) == DataFrame(x=1:2)
    @test_throws ArgumentError insertcols!(DataFrame(), :b)
end

@testset "insertcols! after" begin
    df = DataFrame(a=1:3)
    insertcols!(df, :a, "b" => 2:4, after=true)
    @test df == DataFrame(a=1:3, b=2:4)
    insertcols!(df, :b, "b" => 2:4, after=true, makeunique=true)
    @test df == DataFrame(a=1:3, b=2:4, b_1=2:4)
    insertcols!(df, 0, :e => 1:3, after=true)
    @test df == DataFrame(e=1:3, a=1:3, b=2:4, b_1=2:4)

    @test_throws ArgumentError insertcols!(df, :a, "b" => 2:4, after=true)
    @test_throws DimensionMismatch insertcols!(df, :a, :c => 2:5, after=true)
    @test_throws ArgumentError insertcols!(df, :c, :b => 2:4, after=true, makeunique=true)
    @test_throws ArgumentError insertcols!(df, ncol(df)+1, :d => 1:3, after=true)
    @test_throws ArgumentError insertcols!(df, -1, :d => 1:3, after=true)

    df = DataFrame(a=1:3, b=2:4)
    insertcols!(df, 1, :c => 7:9, after=true)
    @test df == DataFrame(a=1:3, c=7:9, b=2:4)

    df = DataFrame(a=1:3)
    insertcols!(df, 1, :b => 2:4, :c => 7:9, after=true)
    @test df == DataFrame(a=1:3, b=2:4, c=7:9)
    insertcols!(df, "b", :b => 2:4, :c => 7:9, after=true, makeunique=true)
    @test df == DataFrame(a=1:3, b=2:4, b_1=2:4, c_1=7:9, c=7:9)
end

@testset "DataFrame constructors" begin
    @test DataFrame([Union{Int, Missing}[1, 2, 3], Union{Float64, Missing}[2.5, 4.5, 6.5]],
                    [:A, :B]) ==
        DataFrame(A=Union{Int, Missing}[1, 2, 3], B=Union{Float64, Missing}[2.5, 4.5, 6.5])

    # This assignment was missing before
    df = DataFrame(Column=[:A])
    df[1, :Column] = :Testing

    # zero-row DataFrame and subDataFrame test
    df = DataFrame(x=[], y=[])
    @test nrow(df) == 0
    df = DataFrame(x=[1:3;], y=[3:5;])
    sdf = view(df, df[!, :x] .== 4, :)
    @test size(sdf, 1) == 0

    # Test that vector type is correctly determined from scalar type
    df = DataFrame(x=categorical(["a"])[1])
    @test df.x isa CategoricalVector{String}

    @test hash(DataFrame([1 2; 3 4], :auto)) == hash(DataFrame([1 2; 3 4], :auto))
    @test hash(DataFrame([1 2; 3 4], :auto)) != hash(DataFrame([1 3; 2 4], :auto))
    @test hash(DataFrame([1 2; 3 4], :auto)) != hash(DataFrame([1 2; 3 4], [:x2, :x1]))

    @test hash(DataFrame([1 2; 3 4], :auto), UInt(10)) == hash(DataFrame([1 2; 3 4], :auto), UInt(10))
    @test hash(DataFrame([1 2; 3 4], :auto), UInt(10)) != hash(DataFrame([1 2; 3 4], :auto), UInt(11))
    @test hash(DataFrame([1 2; 3 4], :auto), UInt(10)) != hash(DataFrame([1 3; 2 4], :auto), UInt(10))
    @test hash(DataFrame([1 2; 3 4], :auto), UInt(10)) != hash(DataFrame([1 2; 3 4], [:x2, :x1]), UInt(10))
end

@testset "deleteat!" begin
    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test_throws BoundsError deleteat!(df, [true, true, true])
    @test deleteat!(df, 1) === df
    @test df == DataFrame(a=[2], b=[4.0])

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test deleteat!(df, 2) === df
    @test df == DataFrame(a=[1], b=[3.0])

    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test deleteat!(df, 1) === df
    @test df == DataFrame(a=[2], b=[4.0])

    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test deleteat!(df, 2) === df
    @test df == DataFrame(a=[1], b=[3.0])

    for v in (2:3, [2, 3])
        df = DataFrame(a=Union{Int, Missing}[1, 2, 3], b=Union{Float64, Missing}[3.0, 4.0, 5.0])
        @test deleteat!(df, v) === df
        @test df == DataFrame(a=[1], b=[3.0])

        df = DataFrame(a=[1, 2, 3], b=[3.0, 4.0, 5.0])
        @test deleteat!(df, v) === df
        @test df == DataFrame(a=[1], b=[3.0])
    end

    df = DataFrame()
    @test_throws BoundsError deleteat!(df, 10)
    @test_throws BoundsError deleteat!(df, [10])

    df = DataFrame(a=[])
    @test_throws BoundsError deleteat!(df, 10)
    @test_throws BoundsError deleteat!(df, [10])

    df = DataFrame(a=[1, 2, 3], b=[3, 2, 1])
    @test_throws ArgumentError deleteat!(df, [3, 2])
    @test_throws ArgumentError deleteat!(df, [2, 2])
    @test deleteat!(df, [false, true, false]) === df
    @test df == DataFrame(a=[1, 3], b=[3, 1])

    for v in (1, [1], 1:1, [true, false, false])
        x = [1, 2, 3]
        df = DataFrame(x=x)
        @test deleteat!(df, v) == DataFrame(x=[2, 3])
        @test x == [1, 2, 3]
    end

    for v in (1, [1], 1:1, [true, false, false], Not(2, 3), Not([false, true, true]))
        x = [1, 2, 3]
        df = DataFrame(x=x, copycols=false)
        @test deleteat!(df, v) == DataFrame(x=[2, 3])
        @test x == [2, 3]
    end

    for inds in (1, [1], [true, false])
        df = DataFrame(x1=[1, 2])
        df.x2 = df.x1
        @test deleteat!(df, inds) === df
        @test df == DataFrame(x1=[2], x2=[2])
    end

    df = DataFrame(a=1, b=2)
    push!(df.b, 3)
    @test_throws AssertionError deleteat!(df, 1)

    df = DataFrame(a=[1, 2], b=[3, 4])
    @test_throws ArgumentError deleteat!(df, true)

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test isempty(deleteat!(df, :))

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test_throws MethodError deleteat!(df, "a")
    @test_throws MethodError deleteat!(df, zeros(Int, 0, 0))
    @test_throws ArgumentError deleteat!(df, [1.5])
    @test_throws ArgumentError deleteat!(df, Integer[1, true])
    @test_throws ArgumentError deleteat!(df, Integer[true, 2])
    @test deleteat!(df, []) == DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test_throws BoundsError deleteat!(DataFrame(), Not(1))

    df = DataFrame(a=[1, 2, 3], b=[3.0, 4.0, 5.0])
    @test deleteat!(df, UnitRange{Integer}(1,2)) == DataFrame(a=3, b=5.0)
    df = DataFrame(a=[1, 2, 3], b=[3.0, 4.0, 5.0])
    @test_throws ArgumentError deleteat!(df, UnitRange{Integer}(true,true))
    @test_throws BoundsError deleteat!(df, true:true)
    df = DataFrame(a=1, b=3.0)
    @test isempty(deleteat!(df, true:true))

    df = DataFrame(a=[false, true, true], b=1:3, c=4:6)
    @test deleteat!(df, df.a) == DataFrame(a=false, b=1, c=4)
    df = DataFrame(a=1:3, b=[false, true, true], c=4:6)
    @test deleteat!(df, df.b) == DataFrame(a=1, b=false, c=4)
    df = DataFrame(a=1:3, b=4:6, c=[false, true, true])
    @test deleteat!(df, df.c) == DataFrame(a=1, b=4, c=false)

    Random.seed!(1234)
    for t in 0:0.005:1.0
        # two columns are needed as the second column is affected
        # by the adaptive algorithm
        df = DataFrame(i=1:10^5, j=1:10^5)
        idxs = rand(10^5) .< t
        deleteat!(df, idxs)
        df.i == df.j == findall(idxs)
    end
end

@testset "describe" begin
    # Construct the test dataframe
    df = DataFrame(number=[1, 2, 3, 4],
                   number_missing=[1, 2, 3, missing],
                   string=["a", "b", "c", "d"],
                   string_missing=["a", "b", "c", missing],
                   dates=Date.([2000, 2001, 2003, 2004]),
                   catarray=CategoricalArray([1, 2, 1, 2]))

    describe_output = DataFrame(variable=[:number, :number_missing, :string,
                                          :string_missing, :dates, :catarray],
                                mean=[2.5, 2.0, nothing, nothing, nothing, nothing],
                                std=[std(df[!, :number]), 1.0, nothing,
                                       nothing, nothing, nothing],
                                min=[1.0, 1.0, "a", "a", Date(2000), 1],
                                q25=[1.75, 1.5, nothing, nothing, nothing, nothing],
                                median=[2.5, 2.0, nothing, nothing, Date(2002), nothing],
                                q75=[3.25, 2.5, nothing, nothing, nothing, nothing],
                                max=[4.0, 3.0, "d", "c", Date(2004), 2],
                                sum=[10, 6, nothing, nothing, nothing, nothing],
                                nunique=[nothing, nothing, 4, 3, 4, 2],
                                nuniqueall=[4, 3, 4, 3, 4, 2],
                                nmissing=[0, 1, 0, 1, 0, 0],
                                nnonmissing=[4, 3, 4, 3, 4, 4],
                                first=[1, 1, "a", "a", Date(2000), 1],
                                last=[4, missing, "d", missing, Date(2004), 2],
                                eltype=[Int, Union{Missing, Int}, String,
                                        Union{Missing, String}, Date, CategoricalValue{Int, UInt32}])

    default_fields = [:mean, :min, :median, :max, :nmissing, :eltype]

    # Test that it works as a whole, without keyword arguments
    @test describe_output[:, [:variable; default_fields]] == describe(df)

    # Test that it works with one stats argument
    @test describe_output[:, [:variable, :mean]] == describe(df, :mean)

    # Test that it works with :all
    @test describe_output ≅ describe(df, :all)

    # Test that it works with :detailed
    @test describe_output[:, [:variable, :mean, :std, :min, :q25, :median, :q75,
                              :max, :nunique, :nmissing, :eltype]] ≅
        describe(df, :detailed)

    # Test that it works on a custom function
    describe_output.test_std = describe_output.std
    # Test that describe works with a Pair and a symbol
    @test describe_output[:, [:variable, :mean, :test_std]] ≅
          describe(df, :mean, std => :test_std)
    @test describe_output[:, [:variable, :mean, :test_std]] ≅
          describe(df, :mean, std => "test_std")

    @test describe(df, cols=[:number => identity => :number, :number => ByRow(string) => :string]) ==
          DataFrame(variable=[:number, :string], mean=[2.5, nothing], min=[1, "1"],
                    median=[2.5, nothing], max=[4, "4"], nmissing=[0, 0], eltype=[Int, String])

    # Test that describe works with a dataframe with no observations
    df = DataFrame(a=Int[], b=String[], c=[])
    @test describe(df, :mean) ≅ DataFrame(variable=[:a, :b, :c],
                                          mean=[NaN, nothing, nothing])

    @test describe(df, :all, cols=Not(1)) ≅ describe(select(df, Not(1)), :all)
    @test describe(df, cols=Not(1)) ≅ describe(select(df, Not(1)))
    @test describe(df, cols=Not("a")) ≅ describe(select(df, Not(1)))

    @test describe(DataFrame(a=[1, 2]), cols=:a, :min, minimum => :min2, maximum => "max2", :max, :sum) ==
          DataFrame(variable=:a, min=1, min2=1, max2=2, max=2, sum=3)

    @test_throws ArgumentError describe(df, :mean, :all)
    @test_throws MethodError describe(DataFrame(a=[1, 2]), cols=:a, "max2" => maximum)
    @test_throws ArgumentError describe(df, :min, :min)
    @test_throws ArgumentError describe(df, :minimum)
end

@testset "append!" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)
    df = DataFrame(A=1:2, B=1:2)
    df2 = DataFrame(A=1:4, B=1:4)
    @test append!(df, DataFrame(A=3:4, B=[3.0, 4.0])) == df2
    with_logger(sl) do
        @test_throws InexactError append!(df, DataFrame(A=3:4, B=[3.5, 4.5]))
    end
    @test df == df2
    @test occursin("Error adding value to column :B", String(take!(buf)))
    with_logger(sl) do
        @test_throws MethodError append!(df, DataFrame(A=3:4, B=["a", "b"]))
    end
    @test df == df2
    @test occursin("Error adding value to column :B", String(take!(buf)))
    @test_throws ArgumentError append!(df, DataFrame(A=1:4, C=1:4))
    @test df == df2

    dfx = DataFrame()
    df3 = append!(dfx, df)
    @test dfx === df3
    @test df3 == df
    @test df3[!, 1] !== df[!, 1]
    @test df3[!, 2] !== df[!, 2]

    df4 = append!(df3, DataFrame())
    @test df4 === df3
    @test df4 == df

    df = DataFrame()
    df.a = [1, 2, 3]
    df.b = df.a
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError append!(df, dfc)
    end
    @test df == dfc
    @test occursin("Error adding value to column :a", String(take!(buf)))

    df = DataFrame()
    df.a = [1, 2, 3, 4]
    df.b = df.a
    df.c = [1, 2, 3, 4]
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError append!(df, dfc)
    end
    @test df == dfc
    @test occursin("Error adding value to column :a", String(take!(buf)))

    rename!(df, [:a, :b, :z])
    @test_throws ArgumentError append!(df, dfc)

    df = DataFrame(A=1:2, B=1:2)
    df2 = DataFrame(A=1:4, B=1:4)
    @test append!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0])) == df2
    @test append!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0]), cols=:setequal) == df2
    @test append!(copy(df), DataFrame(B=3:4, A=[3.0, 4.0])) == df2
    @test append!(copy(df), DataFrame(B=3:4, A=[3.0, 4.0]), cols=:setequal) == df2
    @test append!(copy(df), Dict(:A => 3:4, :B => [3.0, 4.0])) == df2
    @test append!(copy(df), Dict(:A => 3:4, :B => [3.0, 4.0]), cols=:setequal) == df2
    @test append!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0]), cols=:orderequal) == df2
    @test append!(copy(df), OrderedDict(:A => 3:4, :B => [3.0, 4.0]), cols=:orderequal) == df2
    @test_throws ArgumentError append!(df, Dict(:A => 3:4, :B => [3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError append!(df, DataFrame(B=3:4, A=[3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError append!(df, OrderedDict(:B => 3:4, :A => [3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError append!(df, DataFrame(B=3:4, A=[3.0, 4.0]), cols=:xxx)
    @test df == DataFrame(A=1:2, B=1:2)
end

@testset "prepend!" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)
    df = DataFrame(A=1:2, B=1:2)
    df2 = DataFrame(A=[3, 4, 1, 2], B=[3, 4, 1, 2])
    @test prepend!(df, DataFrame(A=3:4, B=[3.0, 4.0])) == df2
    with_logger(sl) do
        @test_throws InexactError prepend!(df, DataFrame(A=3:4, B=[3.5, 4.5]))
    end
    @test df == df2
    @test occursin("Error adding value to column :B", String(take!(buf)))
    with_logger(sl) do
        @test_throws MethodError prepend!(df, DataFrame(A=3:4, B=["a", "b"]))
    end
    @test df == df2
    @test occursin("Error adding value to column :B", String(take!(buf)))
    @test_throws ArgumentError prepend!(df, DataFrame(A=1:4, C=1:4))
    @test df == df2

    dfx = DataFrame()
    df3 = prepend!(dfx, df)
    @test dfx === df3
    @test df3 == df
    @test df3[!, 1] !== df[!, 1]
    @test df3[!, 2] !== df[!, 2]

    df4 = prepend!(df3, DataFrame())
    @test df4 === df3
    @test df4 == df

    df = DataFrame()
    df.a = [1, 2, 3]
    df.b = df.a
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError prepend!(df, dfc)
    end
    @test df == dfc
    @test occursin("Error adding value to column :a", String(take!(buf)))

    df = DataFrame()
    df.a = [1, 2, 3, 4]
    df.b = df.a
    df.c = [1, 2, 3, 4]
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError prepend!(df, dfc)
    end
    @test df == dfc
    @test occursin("Error adding value to column :a", String(take!(buf)))

    rename!(df, [:a, :b, :z])
    @test_throws ArgumentError prepend!(df, dfc)

    df = DataFrame(A=1:2, B=1:2)
    df2 = DataFrame(A=[3, 4, 1, 2], B=[3, 4, 1, 2])
    @test prepend!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0])) == df2
    @test prepend!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0]), cols=:setequal) == df2
    @test prepend!(copy(df), DataFrame(B=3:4, A=[3.0, 4.0])) == df2
    @test prepend!(copy(df), DataFrame(B=3:4, A=[3.0, 4.0]), cols=:setequal) == df2
    @test prepend!(copy(df), Dict(:A => 3:4, :B => [3.0, 4.0])) == df2
    @test prepend!(copy(df), Dict(:A => 3:4, :B => [3.0, 4.0]), cols=:setequal) == df2
    @test prepend!(copy(df), DataFrame(A=3:4, B=[3.0, 4.0]), cols=:orderequal) == df2
    @test prepend!(copy(df), OrderedDict(:A => 3:4, :B => [3.0, 4.0]), cols=:orderequal) == df2
    @test_throws ArgumentError prepend!(df, Dict(:A => 3:4, :B => [3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError prepend!(df, DataFrame(B=3:4, A=[3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError prepend!(df, OrderedDict(:B => 3:4, :A => [3.0, 4.0]), cols=:orderequal)
    @test_throws ArgumentError prepend!(df, DataFrame(B=3:4, A=[3.0, 4.0]), cols=:xxx)
    @test df == DataFrame(A=1:2, B=1:2)
end

@testset "append! default options" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df1 = DataFrame(x=1:3, y=1:3)
    df2 = DataFrame(y=4:6, x=1:3)
    append!(df1, df2)
    @test df1 == DataFrame(x=[1:3;1:3], y=1:6)

    df2 = DataFrame(y=4:6, x=1:3, z=1)
    @test_throws ArgumentError append!(df1, df2)
    @test df1 == DataFrame(x=[1:3;1:3], y=1:6)

    df2 = DataFrame(y=4:6, x=[missing, missing, missing])
    with_logger(sl) do
        @test_throws MethodError append!(df1, df2)
    end
    @test df1 == DataFrame(x=[1:3;1:3], y=1:6)

    df2 = DataFrame(x=[missing, missing, missing], y=4:6)
    for cols in (:orderequal, :intersect)
        with_logger(sl) do
            @test_throws MethodError append!(df1, df2, cols=cols)
        end
        @test df1 == DataFrame(x=[1:3;1:3], y=1:6)
    end

    for cols in (:subset, :union)
        df1 = DataFrame(x=1:3, y=1:3)
        df2 = DataFrame(y=4:6)
        append!(df1, df2, cols=cols)
        @test df1 ≅ DataFrame(x=[1:3; missing; missing; missing], y=1:6)
    end
end

@testset "prepend! default options" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df1 = DataFrame(x=1:3, y=1:3)
    df2 = DataFrame(y=4:6, x=1:3)
    prepend!(df1, df2)
    @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])

    df2 = DataFrame(y=4:6, x=1:3, z=1)
    @test_throws ArgumentError prepend!(df1, df2)
    @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])

    df2 = DataFrame(y=4:6, x=[missing, missing, missing])
    with_logger(sl) do
        @test_throws MethodError prepend!(df1, df2)
    end
    @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])

    df2 = DataFrame(x=[missing, missing, missing], y=4:6)
    for cols in (:orderequal, :intersect)
        with_logger(sl) do
            @test_throws MethodError prepend!(df1, df2, cols=cols)
        end
        @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])
    end

    for cols in (:subset, :union)
        df1 = DataFrame(x=1:3, y=1:3)
        df2 = DataFrame(y=4:6)
        prepend!(df1, df2, cols=cols)
        @test df1 ≅ DataFrame(x=[missing; missing; missing; 1:3], y=[4:6; 1:3])
    end
end

@testset "append! advanced options" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    for cols in (:orderequal, :setequal, :intersect, :subset, :union)
        for promote in (true, false)
            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=4:6)
            append!(df1, df2, cols=cols, promote=promote)
            @test df1 == DataFrame(x=[1:3;1:3], y=1:6)
            @test eltype(df1.x) == Int
            @test eltype(df1.y) == Int

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(y=4:6, x=1:3)
            if cols == :orderequal
                @test_throws ArgumentError append!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=1:3, y=1:3)
            else
                append!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=[1:3;1:3], y=1:6)
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
            end

            df1 = DataFrame()
            df1.x = 1:3
            df1.y = df1.x
            df2 = DataFrame(x=1:3, y=4:6)
            with_logger(sl) do
                @test_throws AssertionError append!(df1, df2, cols=cols, promote=promote)
            end
            @test df1 == DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(y=4:6, x=1:3)
            with_logger(sl) do
                @test_throws (cols == :orderequal ? ArgumentError :
                              AssertionError) append!(df1, df2, cols=cols, promote=promote)
            end
            @test df1 == DataFrame(x=1:3, y=1:3)

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=4:6, z=11:13)
            if cols in [:orderequal, :setequal]
                @test_throws ArgumentError append!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=1:3, y=1:3)
            elseif cols == :union
                append!(df1, df2, cols=cols, promote=promote)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=1:6,
                                      z=[missing; missing; missing; 11:13])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
                @test eltype(df1.z) == Union{Missing, Int}
            else
                append!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=[1:3;1:3], y=1:6)
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
            end

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=[missing, missing, missing])
            if promote
                append!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[1:3; missing; missing; missing])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
            else
                with_logger(sl) do
                    @test_throws MethodError append!(df1, df2, cols=cols, promote=promote)
                end
                @test df1 == DataFrame(x=1:3, y=1:3)
            end

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, z=11:13)
            if !promote || cols in [:orderequal, :setequal, :intersect]
                with_logger(sl) do
                    @test_throws ArgumentError append!(df1, df2, cols=cols, promote=promote)
                end
                @test df1 == DataFrame(x=1:3, y=1:3)
            elseif cols == :union
                append!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[1:3; missing; missing; missing],
                                      z=[missing; missing; missing; 11:13])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
                @test eltype(df1.z) == Union{Missing, Int}
            else
                append!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[1:3; missing; missing; missing])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
            end
        end
    end

    for df in [DataFrame(a=Any[1]), DataFrame(a=1)]
        @test append!(df, DataFrame(b=1), cols=:union) ≅
              DataFrame(a=[1, missing], b=[missing, 1])
        @test append!(df, DataFrame(b=2), cols=:union) ≅
              DataFrame(a=[1, missing, missing], b=[missing, 1, 2])
        df.x = 1:3
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws ArgumentError append!(df, DataFrame(b=1), cols=:union,
                                               promote=false)
        end
        @test df ≅ DataFrame(a=[1, missing, missing], b=[missing, 1, 2], x=1:3)
        allowmissing!(df, :x)
        @test append!(df, DataFrame(b=3), cols=:union, promote=false) ≅
              DataFrame(a=[1, missing, missing, missing], b=[missing, 1, 2, 3],
                        x=[1:3; missing])
    end
end

@testset "prepend! advanced options" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    for cols in (:orderequal, :setequal, :intersect, :subset, :union)
        for promote in (true, false)
            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=4:6)
            prepend!(df1, df2, cols=cols, promote=promote)
            @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])
            @test eltype(df1.x) == Int
            @test eltype(df1.y) == Int

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(y=4:6, x=1:3)
            if cols == :orderequal
                @test_throws ArgumentError prepend!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=1:3, y=1:3)
            else
                prepend!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
            end

            df1 = DataFrame()
            df1.x = 1:3
            df1.y = df1.x
            df2 = DataFrame(x=1:3, y=4:6)
            with_logger(sl) do
                @test_throws AssertionError prepend!(df1, df2, cols=cols, promote=promote)
            end
            @test df1 == DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(y=4:6, x=1:3)
            with_logger(sl) do
                @test_throws (cols == :orderequal ? ArgumentError :
                              AssertionError) prepend!(df1, df2, cols=cols, promote=promote)
            end
            @test df1 == DataFrame(x=1:3, y=1:3)

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=4:6, z=11:13)
            if cols in [:orderequal, :setequal]
                @test_throws ArgumentError prepend!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=1:3, y=1:3)
            elseif cols == :union
                prepend!(df1, df2, cols=cols, promote=promote)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[4:6; 1:3],
                                      z=[11:13; missing; missing; missing])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
                @test eltype(df1.z) == Union{Missing, Int}
            else
                prepend!(df1, df2, cols=cols, promote=promote)
                @test df1 == DataFrame(x=[1:3;1:3], y=[4:6; 1:3])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Int
            end

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, y=[missing, missing, missing])
            if promote
                prepend!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[missing; missing; missing; 1:3])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
            else
                with_logger(sl) do
                    @test_throws MethodError prepend!(df1, df2, cols=cols, promote=promote)
                end
                @test df1 == DataFrame(x=1:3, y=1:3)
            end

            df1 = DataFrame(x=1:3, y=1:3)
            df2 = DataFrame(x=1:3, z=11:13)
            if !promote || cols in [:orderequal, :setequal, :intersect]
                with_logger(sl) do
                    @test_throws ArgumentError prepend!(df1, df2, cols=cols, promote=promote)
                end
                @test df1 == DataFrame(x=1:3, y=1:3)
            elseif cols == :union
                prepend!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[missing; missing; missing; 1:3],
                                      z=[11:13; missing; missing; missing])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
                @test eltype(df1.z) == Union{Missing, Int}
            else
                prepend!(df1, df2, cols=cols, promote=true)
                @test df1 ≅ DataFrame(x=[1:3;1:3], y=[missing; missing; missing; 1:3])
                @test eltype(df1.x) == Int
                @test eltype(df1.y) == Union{Missing, Int}
            end
        end
    end

    for df in [DataFrame(a=Any[1]), DataFrame(a=1)]
        @test prepend!(df, DataFrame(b=1), cols=:union) ≅
              DataFrame(a=[missing, 1], b=[1, missing])
        @test prepend!(df, DataFrame(b=2), cols=:union) ≅
              DataFrame(a=[missing, missing, 1], b=[2, 1, missing])
        df.x = 1:3
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws ArgumentError prepend!(df, DataFrame(b=1), cols=:union,
                                                promote=false)
        end
        @test df ≅ DataFrame(a=[missing, missing, 1], b=[2, 1, missing], x=1:3)
        allowmissing!(df, :x)
        @test prepend!(df, DataFrame(b=3), cols=:union, promote=false) ≅
              DataFrame(a=[missing, missing, missing, 1], b=[3, 2, 1, missing],
                        x=[missing; 1:3])
    end

end

@testset "rename" begin
    for asview in (false, true)
        df = DataFrame(A=1:3, B='A':'C')
        asview && (df=view(df, :, :))
        @test names(rename(df, :A => :A_1)) == ["A_1", "B"]
        @test names(df) == ["A", "B"]
        @test names(rename(df, :A => :A_1, :B => :B_1)) == ["A_1", "B_1"]
        @test names(df) == ["A", "B"]
        @test names(rename(df, [:A => :A_1, :B => :B_1])) == ["A_1", "B_1"]
        @test names(df) == ["A", "B"]
        @test names(rename(df, Dict(:A => :A_1, :B => :B_1))) == ["A_1", "B_1"]
        @test names(df) == ["A", "B"]
        @test names(rename(lowercase, df)) == ["a", "b"]
        @test names(df) == ["A", "B"]

        @test rename!(df, :A => :A_1) === df
        @test propertynames(df) == [:A_1, :B]
        @test rename!(df, :A_1 => :A_2, :B => :B_2) === df
        @test propertynames(df) == [:A_2, :B_2]
        @test rename!(df, [:A_2 => :A_3, :B_2 => :B_3]) === df
        @test propertynames(df) == [:A_3, :B_3]
        @test rename!(df, Dict(:A_3 => :A_4, :B_3 => :B_4)) === df
        @test propertynames(df) == [:A_4, :B_4]
        @test rename!(lowercase, df) === df
        @test propertynames(df) == [:a_4, :b_4]

        df = DataFrame(A=1:3, B='A':'C', C=[:x, :y, :z])
        asview && (df = view(df, :, :))
        @test rename!(df, :A => :B, :B => :A) === df
        @test propertynames(df) == [:B, :A, :C]
        @test rename!(df, :A => :B, :B => :A, :C => :D) === df
        @test propertynames(df) == [:A, :B, :D]
        @test rename!(df, :A => :B, :B => :C, :D => :A) === df
        @test propertynames(df) == [:B, :C, :A]
        @test rename!(df, :A => :C, :B => :A, :C => :B) === df
        @test propertynames(df) == [:A, :B, :C]
        @test rename!(df, :A => :A, :B => :B, :C => :C) === df
        @test propertynames(df) == [:A, :B, :C]

        cdf = copy(df)
        @test_throws ArgumentError rename!(df, :X => :Y)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :X, :X => :Y)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :B)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :X, :A => :X)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :X, :A => :Y)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :X, :B => :X)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :B, :B => :A, :C => :B)
        @test df == cdf
        @test_throws ArgumentError rename!(df, :A => :B, :B => :A, :A => :X)
        @test df == cdf

        df = DataFrame(A=1)
        asview && (df=view(df, :, :))
        @test rename(x -> 1, df) == DataFrame(Symbol("1") => 1)

        for cols in (:B, Not("A"), Cols(2), Char, contains('B'))
            df = DataFrame(A=1:3, B='A':'C')
            asview && (df = view(df, :, :))
            @test names(rename(lowercase, df, cols=cols)) == ["A", "b"]
            @test names(df) == ["A", "B"]
            rename!(lowercase, df, cols=cols)
            @test names(df) == ["A", "b"]
        end
        df = DataFrame(A=1:3, B='A':'C')
        asview && (df = view(df, :, :))
        @test names(rename(lowercase, df, cols=[:A, :B])) == ["a", "b"]
        @test names(rename(lowercase, df, cols=Not(:))) == ["A", "B"]
    end

    sdf = view(DataFrame(ones(2, 3), :auto), 1:2, 1:3)
    @test_throws ArgumentError rename!(uppercase, sdf)
    @test_throws ArgumentError rename!(sdf, :x1 => :y1)
    @test_throws ArgumentError rename!(sdf, [:a, :b, :c])
end

@testset "flexible rename arguments" begin
    df = DataFrame(x=1, y=2, z=3)
    for ren in ([:a, :b, :c], ["a", "b", "c"],
                ["x"=>:a, "y"=>:b, "z"=>:c],
                [:x=>"a", :y=>"b", :z=>"c"],
                ["x"=>"a", "y"=>"b", "z"=>"c"],
                [:x=>:a, :y=>:b, :z=>:c],
                Dict(["x"=>:a, "y"=>:b, "z"=>:c]),
                Dict([:x=>"a", :y=>"b", :z=>"c"]),
                Dict(["x"=>"a", "y"=>"b", "z"=>"c"]),
                Dict([:x=>:a, :y=>:b, :z=>:c]))
        @test rename(df, ren) == DataFrame(a=1, b=2, c=3)
        df == DataFrame(x=1, y=2, z=3)
        if eltype(ren) isa Pair
            @test rename(df, ren...) == DataFrame(a=1, b=2, c=3)
            @test df == DataFrame(x=1, y=2, z=3)
        end
        df2 = copy(df)
        @test rename!(df2, ren) == DataFrame(a=1, b=2, c=3)
        @test df2 == DataFrame(a=1, b=2, c=3)
        df2 = copy(df)
        if eltype(ren) isa Pair
            @test rename!(df2, ren...) == DataFrame(a=1, b=2, c=3)
            @test df2 == DataFrame(a=1, b=2, c=3)
        end
    end
end

@testset "size" begin
    df = DataFrame(A=1:3, B='A':'C')
    @test_throws ArgumentError size(df, 3)
    @test ndims(df) == 2
    @test ndims(typeof(df)) == 2
    @test (nrow(df), ncol(df)) == (3, 2)
    @test size(df) == (3, 2)
    @inferred nrow(df)
    @inferred ncol(df)
end

@testset "first, last and only" begin
    df = DataFrame(A=1:10)

    @test first(df) == df[1, :]
    @test last(df) == df[end, :]
    @test_throws BoundsError first(DataFrame(x=[]))
    @test_throws BoundsError last(DataFrame(x=[]))

    for v in (true, false)
        @test first(df, 6, view=v) == DataFrame(A=1:6)
        @test first(df, 1, view=v) == DataFrame(A=1)
        @test first(df, 0, view=v) == DataFrame(A=Int[])
        @test_throws ArgumentError first(df, -1, view=v)
        @test last(df, 6, view=v) == DataFrame(A=5:10)
        @test last(df, 1, view=v) == DataFrame(A=10)
        @test last(df, 0, view=v) == DataFrame(A=Int[])
        @test_throws ArgumentError last(df, -1, view=v)
    end

    @inferred first(df, 6)
    @inferred last(df, 6)
    @inferred first(df)
    @inferred last(df)

    @test first(df, 6, view=true) == DataFrame(A=1:6)
    @test last(df, 6, view=true) == DataFrame(A=5:10)

    @test first(df, 6, view=true) isa SubDataFrame
    @test first(df, 6, view=false) isa DataFrame
    @test last(df, 6, view=true) isa SubDataFrame
    @test last(df, 6, view=false) isa DataFrame

    @test_throws ArgumentError only(df)
    @test_throws ArgumentError only(DataFrame())
    df = DataFrame(a=1, b=2)
    @test only(df) === df[1, :]
end

@testset "column conversions" begin
    df = DataFrame([collect(1:10), collect(1:10)], :auto)
    @test !isa(df[!, 1], Vector{Union{Int, Missing}})
    @test allowmissing!(df, 1) === df
    @test isa(df[!, 1], Vector{Union{Int, Missing}})
    @test !isa(df[!, 2], Vector{Union{Int, Missing}})
    df[1, 1] = missing
    @test_throws ArgumentError disallowmissing!(df, 1)
    tmpcol = df[!, 1]
    disallowmissing!(df, 1, error=false)
    @test df[!, 1] === tmpcol
    df[1, 1] = 1
    @test disallowmissing!(df, 1) === df
    @test isa(df[!, 1], Vector{Int})

    df = DataFrame([collect(1:10), collect(1:10)], :auto)
    @test !isa(df[!, 1], Vector{Union{Int, Missing}})
    @test allowmissing!(df, Not(Not(1))) === df
    @test isa(df[!, 1], Vector{Union{Int, Missing}})
    @test !isa(df[!, 2], Vector{Union{Int, Missing}})
    df[1, 1] = missing
    @test_throws ArgumentError disallowmissing!(df, Not(Not(1)))
    tmpcol = df[!, 1]
    disallowmissing!(df, Not(Not(1)), error=false)
    @test df[!, 1] === tmpcol
    df[1, 1] = 1
    @test disallowmissing!(df, Not(Not(1))) === df
    @test isa(df[!, 1], Vector{Int})

    for em in [true, false]
        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df, [1, 2]) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, [1, 2], error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df, Not(Not([1, 2]))) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, Not(Not([1, 2])), error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test_throws BoundsError allowmissing!(df, [true])
        @test allowmissing!(df, [true, true]) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test_throws BoundsError disallowmissing!(df, [true], error=em)
        @test disallowmissing!(df, [true, true], error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df, :) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, :, error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df, r"") === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, r"", error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})

        df = DataFrame([collect(1:10), collect(1:10)], :auto)
        @test allowmissing!(df, Not(1:0)) === df
        @test isa(df[!, 1], Vector{Union{Int, Missing}}) && isa(df[!, 2], Vector{Union{Int, Missing}})
        @test disallowmissing!(df, Not(1:0), error=em) === df
        @test isa(df[!, 1], Vector{Int}) && isa(df[!, 2], Vector{Int})
    end

    df = DataFrame(Any[CategoricalArray(1:10),
                       CategoricalArray(string.('a':'j'))], :auto)
    @test allowmissing!(df) === df
    @test all(x->x <: CategoricalVector, typeof.(eachcol(df)))
    @test eltype(df[!, 1]) <: Union{CategoricalValue{Int}, Missing}
    @test eltype(df[!, 2]) <: Union{CategoricalValue{String}, Missing}
    df[1, 2] = missing
    @test_throws ArgumentError disallowmissing!(df)
    tmpcol =df[!, 2]
    disallowmissing!(df, error=false)
    @test df[!, 2] === tmpcol
    df[1, 2] = "a"
    @test disallowmissing!(df) === df
    @test all(x->x <: CategoricalVector, typeof.(eachcol(df)))
    @test eltype(df[!, 1]) <: CategoricalValue{Int}
    @test eltype(df[!, 2]) <: CategoricalValue{String}

    for em in [true, false]
        df = DataFrame(b=[1, 2], c=[1, 2], d=[1, 2])
        @test allowmissing!(df, [:b, :c]) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Union{Int, Missing}
        @test eltype(df.d) == Int
        @test disallowmissing!(df, :c, error=em) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Int
        @test allowmissing!(df, [:d]) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Union{Int, Missing}
        @test disallowmissing!(df, [:c, :d], error=em) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Int
        @test allowmissing!(df, [false, false, true]) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Union{Int, Missing}
        @test disallowmissing!(df, [true, false, false], error=em) === df
        @test eltype(df.b) == Int
        @test eltype(df.c) == Int
        @test eltype(df.d) == Union{Int, Missing}
    end

    for em in [true, false]
        df = DataFrame(b=[1, 2], c=[1, 2], d=[1, 2])
        @test allowmissing!(df, ["b", "c"]) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Union{Int, Missing}
        @test eltype(df.d) == Int
        @test disallowmissing!(df, "c", error=em) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Int
        @test allowmissing!(df, ["d"]) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Union{Int, Missing}
        @test disallowmissing!(df, ["c", "d"], error=em) === df
        @test eltype(df.b) == Union{Int, Missing}
        @test eltype(df.c) == Int
        @test eltype(df.d) == Int
    end

    df = DataFrame(x=[1], y=Union{Int, Missing}[1], z=[missing])
    disallowmissing!(df, error=false)
    @test eltype(df.x) == Int
    @test eltype(df.y) == Int
    @test eltype(df.z) == Missing

    df = DataFrame(x=[1], y=Union{Int, Missing}[1], z=[missing])
    disallowmissing!(df, 2:3, error=false)
    @test eltype(df.x) == Int
    @test eltype(df.y) == Int
    @test eltype(df.z) == Missing
end

@testset "test disallowmissing" begin
    df = DataFrame(x=Union{Int, Missing}[1, 2, 3],
                   y=Union{Int, Missing}[1, 2, 3],
                   z=[1, 2, 3])
    for x in [df, view(df, :, :)], em in [true, false]
        y = disallowmissing(x, error=em)
        @test y isa DataFrame
        @test x == y
        @test x.x !== y.x
        @test x.y !== y.y
        @test x.z !== y.z
        @test eltype.(eachcol(y)) == [Int, Int, Int]

        for colsel in [:, names(x), [1, 2, 3], [true, true, true], r"", Not(r"a")]
            y = disallowmissing(x, colsel, error=em)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Int, Int, Int]
        end

        for colsel in [:x, "x", 1, [:x], ["x"], [1], [true, false, false], r"x", Not(2:3)]
            y = disallowmissing(x, colsel, error=em)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Int, Union{Missing, Int}, Int]
        end

        for colsel in [:z, "z", 3, [:z], ["z"], [3], [false, false, true], r"z", Not(1:2)]
            y = disallowmissing(x, colsel, error=em)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Union{Int, Missing}, Union{Int, Missing}, Int]
        end

        for colsel in [Int[], Symbol[], [false, false, false], r"a", Not(:)]
            y = disallowmissing(x, colsel, error=em)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Union{Int, Missing}, Union{Int, Missing}, Int]
        end
    end

    @test_throws ArgumentError disallowmissing(DataFrame(x=[missing]))
    @test disallowmissing(DataFrame(x=[missing]), error=false) ≅ DataFrame(x=[missing])
    @test_throws ArgumentError disallowmissing(DataFrame(x=[1, missing]))
    @test disallowmissing(DataFrame(x=[1, missing]), error=false) ≅ DataFrame(x=[1, missing])

    df = DataFrame(x=[1], y=Union{Int, Missing}[1], z=[missing])
    df2 = disallowmissing(df, error=false)
    @test eltype(df2.x) == Int
    @test eltype(df2.y) == Int
    @test eltype(df2.z) == Missing

    df2 = disallowmissing(df, 2:3, error=false)
    @test eltype(df2.x) == Int
    @test eltype(df2.y) == Int
    @test eltype(df2.z) == Missing
end

@testset "test allowmissing" begin
    df = DataFrame(x=Union{Int, Missing}[1, 2, 3],
                   y=[1, 2, 3],
                   z=[1, 2, 3])
    for x in [df, view(df, :, :)]
        y = allowmissing(x)
        @test y isa DataFrame
        @test x == y
        @test x.x !== y.x
        @test x.y !== y.y
        @test x.z !== y.z
        @test eltype.(eachcol(y)) == fill(Union{Missing, Int}, 3)

        for colsel in [:, names(x), [1, 2, 3], [true, true, true], r"", Not(r"a")]
            y = allowmissing(x, colsel)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == fill(Union{Missing, Int}, 3)
        end

        for colsel in [:x, "x", 1, [:x], ["x"], [1], [true, false, false], r"x", Not(2:3)]
            y = allowmissing(x, colsel)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Union{Missing, Int}, Int, Int]
        end

        for colsel in [:z, "z", 3, [:z], ["z"], [3], [false, false, true], r"z", Not(1:2)]
            y = allowmissing(x, colsel)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Union{Int, Missing}, Int, Union{Missing, Int}]
        end

        for colsel in [Int[], Symbol[], [false, false, false], r"a", Not(:)]
            y = allowmissing(x, colsel)
            @test y isa DataFrame
            @test x == y
            @test x.x !== y.x
            @test x.y !== y.y
            @test x.z !== y.z
            @test eltype.(eachcol(y)) == [Union{Int, Missing}, Int, Int]
        end
    end
end

@testset "similar" begin
    df = DataFrame(a=["foo"],
                   b=CategoricalArray(["foo"]),
                   c=[0.0],
                   d=CategoricalArray([0.0]))
    @test eltype.(eachcol(similar(df))) == eltype.(eachcol(df))
    @test size(similar(df)) == size(df)

    rows = size(df, 1) + 5
    @test size(similar(df, rows)) == (rows, size(df, 2))
    @test eltype.(eachcol(similar(df, rows))) == eltype.(eachcol(df))

    @test size(similar(df, 0)) == (0, size(df, 2))
    @test eltype.(eachcol(similar(df, 0))) == eltype.(eachcol(df))

    e = @test_throws ArgumentError similar(df, -1)
    @test e.value.msg == "the number of rows must be non-negative"
end

@testset "passing range to a DataFrame" begin
    df = DataFrame(a=1:3, b='a':'c')
    df[!, :c] = 1:3
    df[!, :d] = 'a':'c'
    @test all(typeof(df[!, i]) <: Vector for i in 1:ncol(df))
end

@testset "test getindex using ! syntax" begin
    x = [1]
    y = [1]
    df = DataFrame(x=x, y=y, copycols=false)
    @test df.x === x
    @test df[!, :y] === y
    @test df[!, 1] === x
    @test df[:, 1:1][!, 1] == x
    @test df[:, r"x"][!, 1] == x
    @test df[:, 1:1][!, 1] !== x
    @test df[:, r"x"][!, 1] !== x
    @test df[:, 1:2][!, :y] == y
    @test df[:, 1:2][!, :y] !== y
    @test df[:, r""][!, :y] == y
    @test df[:, r""][!, :y] !== y
    @test df[:, :][!, :x] == x
    @test df[:, :][!, :x] !== x
    @test df[:, [:y, :x]][!, :x] == x
    @test df[:, [:y, :x]][!, :x] !== x
end

@testset "test corner case of getindex" begin
    df = DataFrame(x=[1], y=[1])
    @test_throws ArgumentError df[true, 1:2]
    @test_throws ArgumentError df[true, r""]
end

@testset "empty data frame getindex" begin
    @test_throws BoundsError DataFrame(x=[])[1, :]
    @test_throws BoundsError DataFrame()[1, :]
    @test_throws BoundsError DataFrame()[1:2, :]
    @test_throws BoundsError DataFrame()[1, Bool[]]
    @test_throws BoundsError DataFrame()[1:2, Bool[]]
    @test_throws BoundsError DataFrame(x=[1])[1:2, [false]]
    @test_throws BoundsError DataFrame(x=[1])[2, [false]]
    #but this is OK:
    @test DataFrame(x=[1])[1:1, [false]] == DataFrame()
    @test DataFrame(x=[1])[1:1, r"xx"] == DataFrame()
end

@testset "handling of end in indexing" begin
    z = DataFrame(rand(4, 5), :auto)
    x = z
    y = deepcopy(x)
    @test x[:, end] == x[:, 5]
    @test x[:, end:end] == x[:, 5:5]
    @test x[end, :] == x[4, :]
    @test x[end:end, :] == x[4:4, :]
    @test x[end, end] == x[4, 5]
    @test x[2:end, 2:end] == x[2:4, 2:5]
    x[!, end] = 1:4
    y[!, 5] = 1:4
    @test x == y
    x[:, 4:end] .= DataFrame([11:14, 21:24], [:x4, :x5])
    y[!, 4] = [11:14;]
    y[!, 5] = [21:24;]
    @test x == y
    x[end, :] .= 111
    y[4, :] .= 111
    @test x == y
    x[end, end] = 1000
    y[4, 5] = 1000
    @test x == y
    x[2:end, 2:end] .= 0
    y[2:4, 2:5] .= 0
    @test x == y

    x = view(z, 1:4, :)
    y = deepcopy(x)
    @test x[:, end] == x[:, 5]
    @test x[:, end:end] == x[:, 5:5]
    @test x[end, :] == x[4, :]
    @test x[end:end, :] == x[4:4, :]
    @test x[end, end] == x[4, 5]
    @test x[2:end, 2:end] == x[2:4, 2:5]
    x[:, end] = 1:4
    y[:, 5] = 1:4
    @test x == y
    x[:, 4:end] .= DataFrame([11:14, 21:24], [:x4, :x5])
    y[:, 4] = [11:14;]
    y[:, 5] = [21:24;]
    @test x == y
    x[end, :] .= 111
    y[4, :] .= 111
    @test x == y
    x[end, end] = 1000
    y[4, 5] = 1000
    @test x == y
    x[2:end, 2:end] .= 0
    y[2:4, 2:5] .= 0
    @test x == y
end

@testset "aliasing in indexing" begin
    # columns should not alias if scalar broadcasted
    df = DataFrame(A=[0], B=[0])
    df[:, 1:end] .= 0.0
    df[1, :A] = 1.0
    @test df[1, :B] === 0

    df = DataFrame(A=[0], B=[0])
    df[:, 1:end] .= 0.0
    df[1, :A] = 1.0
    @test df[1, :B] === 0

    df = DataFrame(A=[0], B=[0])
    x = [0.0]
    df[:, 1:end] .= x
    x[1] = 1.0
    @test df[1, :A] === 0
    @test df[1, :B] === 0
    df[1, :A] = 1.0
    @test df[1, :B] === 0
end

@testset "getproperty, setproperty! and propertynames" begin
    x = collect(1:10)
    y = collect(1.0:10.0)
    z = collect(10:-1:1)
    df = DataFrame(x=x, y=y, copycols=false)

    @test propertynames(df) == Symbol.(names(df))

    @test df.x === x
    @test df.y === y
    @test_throws ArgumentError df.z

    df.x = 2:11
    @test df.x == 2:11
    @test x == 1:10
    df.y .= 1
    @test df.y == [1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
    @test y == 1.0:10.0
    df.z = z
    @test df.z === z
    df[!, :zz] .= 1
    @test df.zz == df.y
end

@testset "duplicate column names" begin
    x = DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    v = DataFrame(a=[5, 6, 7], b=[8, 9, 10])
    z = vcat(v, x)
    @test_throws ArgumentError z[:, [1, 1, 2]]
end

@testset "parent, size and axes" begin
    x = DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    @test parent(x) === x
    @test parentindices(x) === (Base.OneTo(3), Base.OneTo(2))
    @test size(x) == (3, 2)
    @test size(x, 1) == 3
    @test size(x, 2) == 2
    @test_throws ArgumentError size(x, 3)
    @test axes(x) === (Base.OneTo(3), Base.OneTo(2))
    @test axes(x, 1) === Base.OneTo(3)
    @test axes(x, 2) === Base.OneTo(2)
    @test_throws ArgumentError axes(x, 3)
    @test size(DataFrame()) == (0, 0)
end

@testset "0-row DataFrame corner cases" begin
    df = DataFrame(a=1:0)
    @test df.a isa Vector{Int}
    v = Int[]
    df = DataFrame(a=v, b=v)
    @test df.a !== df.b
    df = DataFrame(a=v, b=v, copycols=true)
    @test df.a !== df.b
    df = DataFrame(a=v, b=v, copycols=false)
    @test df.a === df.b
end

@testset "All and Between tests" begin
    # we check dispatch here only
    df = DataFrame(a=1, b=2, c=3)
    completecases(df, All())
    completecases(df, Cols(:))
    completecases(df, Between(1, 2))
    dropmissing(df, All())
    dropmissing(df, Cols(:))
    dropmissing(df, Between(1, 2))
    dropmissing!(df, All())
    dropmissing!(df, Cols(:))
    dropmissing!(df, Between(1, 2))
    disallowmissing(df, All())
    disallowmissing(df, Cols(:))
    disallowmissing(df, Between(1, 2))
    allowmissing(df, All())
    allowmissing(df, Cols(:))
    allowmissing(df, Between(1, 2))

    df[1, All()]
    df[1, Cols(:)]
    df[1, Between(1, 2)]
    df[1:1, All()]
    df[1:1, Cols(:)]
    df[1:1, Between(1, 2)]
    df[Not(1), All()]
    df[Not(1), Cols(:)]
    df[Not(1), Between(1, 2)]
    df[:, All()]
    df[:, Cols(:)]
    df[:, Between(1, 2)]
    df[!, All()]
    df[!, Cols(:)]
    df[!, Between(1, 2)]

    @view df[1, All()]
    @view df[1, Cols(:)]
    @view df[1, Between(1, 2)]
    @view df[1:1, All()]
    @view df[1:1, Cols(:)]
    @view df[1:1, Between(1, 2)]
    @view df[Not(1), All()]
    @view df[Not(1), Cols(:)]
    @view df[Not(1), Between(1, 2)]
    @view df[:, All()]
    @view df[:, Cols(:)]
    @view df[:, Between(1, 2)]
    @view df[!, All()]
    @view df[!, Cols(:)]
    @view df[!, Between(1, 2)]

    df[1, All()] = (a=1, b=2, c=3)
    df[1, Cols(:)] = (a=1, b=2, c=3)
    df[1, Between(1, 2)] = (a=1, b=2)
    df[1:1, All()] = df
    df[1:1, Cols(:)] = df
    df[1:1, Between(1, 2)] = df[!, 1:2]
    df[:, All()] = df
    df[:, Cols(:)] = df
    df[:, Between(1, 2)] = df[!, 1:2]
    df[1:1, All()] = Matrix(df)
    df[1:1, Cols(:)] = Matrix(df)
    df[1:1, Between(1, 2)] = Matrix(df[!, 1:2])
    df[:, All()] = Matrix(df)
    df[:, Cols(:)] = Matrix(df)
    df[:, Between(1, 2)] = Matrix(df[!, 1:2])

    df2 = vcat(df, df)
    df2[Not(1), All()] = df
    df2[Not(1), Cols(:)] = df
    df2[Not(1), Between(1, 2)] = df[!, 1:2]
    df2[Not(1), All()] = Matrix(df)
    df2[Not(1), Cols(:)] = Matrix(df)
    df2[Not(1), Between(1, 2)] = Matrix(df[!, 1:2])

    allowmissing!(df2, All())
    allowmissing!(df2, Cols(:))
    allowmissing!(df2, Between(1, 2))
    disallowmissing!(df2, All())
    disallowmissing!(df2, Cols(:))
    disallowmissing!(df2, Between(1, 2))

    dfr = df[1, :]
    dfr[All()]
    dfr[Cols(:)]
    dfr[Between(1, 2)]
    dfr[All()] = (a=1, b=2, c=3)
    dfr[Cols(:)] = (a=1, b=2, c=3)
    dfr[Between(1, 2)] = (a=1, b=2)
    @view dfr[All()]
    @view dfr[Cols(:)]
    @view dfr[Between(1, 2)]

    dfv = view(df, :, :)

    dfv[1, All()]
    dfv[1, Cols(:)]
    dfv[1, Between(1, 2)]
    dfv[1:1, All()]
    dfv[1:1, Cols(:)]
    dfv[1:1, Between(1, 2)]
    dfv[Not(1), All()]
    dfv[Not(1), Cols(:)]
    dfv[Not(1), Between(1, 2)]
    dfv[:, All()]
    dfv[:, Cols(:)]
    dfv[:, Between(1, 2)]
    dfv[!, All()]
    dfv[!, Cols(:)]
    dfv[!, Between(1, 2)]

    @view dfv[1, All()]
    @view dfv[1, Cols(:)]
    @view dfv[1, Between(1, 2)]
    @view dfv[1:1, All()]
    @view dfv[1:1, Cols(:)]
    @view dfv[1:1, Between(1, 2)]
    @view dfv[Not(1), All()]
    @view dfv[Not(1), Cols(:)]
    @view dfv[Not(1), Between(1, 2)]
    @view dfv[:, All()]
    @view dfv[:, Cols(:)]
    @view dfv[:, Between(1, 2)]
    @view dfv[!, All()]
    @view dfv[!, Cols(:)]
    @view dfv[!, Between(1, 2)]

    dfv[1, All()] = (a=1, b=2, c=3)
    dfv[1, Cols(:)] = (a=1, b=2, c=3)
    dfv[1, Between(1, 2)] = (a=1, b=2)
    dfv[1:1, All()] = df
    dfv[1:1, Cols(:)] = df
    dfv[1:1, Between(1, 2)] = df[!, 1:2]
    dfv[:, All()] = df
    dfv[:, Cols(:)] = df
    dfv[:, Between(1, 2)] = df[!, 1:2]
    dfv[1:1, All()] = Matrix(df)
    dfv[1:1, Cols(:)] = Matrix(df)
    dfv[1:1, Between(1, 2)] = Matrix(df[!, 1:2])
    dfv[:, All()] = Matrix(df)
    dfv[:, Cols(:)] = Matrix(df)
    dfv[:, Between(1, 2)] = Matrix(df[!, 1:2])

    df2v = view(vcat(df, df), :, :)
    df2v[Not(1), All()] = df
    df2v[Not(1), Cols(:)] = df
    df2v[Not(1), Between(1, 2)] = df[!, 1:2]
    df2v[Not(1), All()] = Matrix(df)
    df2v[Not(1), Cols(:)] = Matrix(df)
    df2v[Not(1), Between(1, 2)] = Matrix(df[!, 1:2])

    @test_throws ArgumentError df[1, All(1)]
end

@testset "vcat with :orderequal" begin
    @test vcat(DataFrame(a=1, b=2, c=3), DataFrame(a=10, b=20, c=30),
               cols=:orderequal) == DataFrame(a=[1, 10], b=[2, 20], c=[3, 30])
    @test_throws ArgumentError vcat(DataFrame(a=1, b=2, c=3), DataFrame(a=10, b=20, c=30),
                                    cols=:equal)
    @test_throws ArgumentError vcat(DataFrame(a=1, b=2, c=3), DataFrame(a=10, c=20, b=30),
                                    cols=:orderequal)
    @test_throws ArgumentError vcat(DataFrame(a=1, b=2, c=3), DataFrame(a=10, b=20, d=30),
                                    cols=:orderequal)
    @test_throws ArgumentError vcat(DataFrame(a=1, b=2, c=3), DataFrame(a=10, b=20, c=30, d=0),
                                    cols=:orderequal)
end

@testset "vcat with source and reduce(vcat, ...)" begin
    df1 = DataFrame(A=1:3, B=1:3)
    df2 = DataFrame(A=4:6, B=4:6)
    df3 = DataFrame(A=7:9, C=7:9)
    df4 = DataFrame()

    for col in [:source, "source"]
        @test vcat(df1, df2, df3, df4, cols=:union, source=col) ≅
              vcat(df1, df2, df3, df4, cols=:union, source=col => [1, 2, 3, 4]) ≅
              reduce(vcat, [df1, df2, df3, df4], cols=:union, source=col) ≅
              reduce(vcat, [df1, df2, df3, df4], cols=:union, source=col => [1, 2, 3, 4]) ≅
              DataFrame(A=1:9, B=[1:6; fill(missing, 3)],
                        C=[fill(missing, 6); 7:9],
                        source=[1, 1, 1, 2, 2, 2, 3, 3, 3])
        res = vcat(df1, df2, df3, df4, cols=:union, source=col => categorical(-4:-1))
        @test isequal_coltyped(res, DataFrame(A=1:9, B=[1:6; fill(missing, 3)],
                                              C=[fill(missing, 6); 7:9],
                                              source=categorical([-4, -4, -4, -3, -3, -3, -2, -2, -2])))

        res = reduce(vcat, [df1, df2, df3, df4], cols=:union, source=col => categorical(-4:-1))
        @test isequal_coltyped(res, DataFrame(A=1:9, B=[1:6; fill(missing, 3)],
                                              C=[fill(missing, 6); 7:9],
                                              source=categorical([-4, -4, -4, -3, -3, -3, -2, -2, -2])))

        @test reduce(vcat, DataFrame[]) == DataFrame()
        @test isequal_coltyped(reduce(vcat, DataFrame[], source=:src),
                               DataFrame(src=Int[]))
        @test isequal_coltyped(reduce(vcat, DataFrame[], cols=[:a, :b]),
                               DataFrame(a=Missing[], b=Missing[]))
        @test isequal_coltyped(reduce(vcat, DataFrame[], cols=[:a, :b], source=:src),
                               DataFrame(a=Missing[], b=Missing[], src=Int[]))
    end

    @test_throws TypeError vcat(df1, df2, df3, df4, cols=:union, source=1)
    @test_throws TypeError vcat(df1, df2, df3, df4, cols=:union, source=:a => 1)
    @test_throws ArgumentError vcat(df1, df2, df3, df4, cols=:union, source=:C)
    @test_throws ArgumentError vcat(df1, df2, df3, df4, cols=:union, source=:a => [1])
    @test_throws TypeError reduce(vcat, [df1, df2, df3, df4], cols=:union, source=1)
    @test_throws TypeError reduce(vcat, [df1, df2, df3, df4], cols=:union, source=:a => 1)
    @test_throws ArgumentError reduce(vcat, [df1, df2, df3, df4], cols=:union, source=:C)
    @test_throws ArgumentError reduce(vcat, [df1, df2, df3, df4], cols=:union, source=:a => [1])

    @test vcat(DataFrame(), DataFrame()) ==
          reduce(vcat, [DataFrame(), DataFrame()]) ==
          DataFrame()
    @test isequal_coltyped(vcat(DataFrame(), DataFrame(), cols=[:a, :b]),
                           DataFrame(a=Missing[], b=Missing[]))
    @test isequal_coltyped(reduce(vcat, (DataFrame(), DataFrame()), cols=[:a, :b]),
                           DataFrame(a=Missing[], b=Missing[]))
    @test isequal_coltyped(vcat(DataFrame(a=1:2), DataFrame(), cols=[:a, :b]),
                           DataFrame(a=1:2, b=missing))
    @test isequal_coltyped(reduce(vcat, (DataFrame(a=1:2), DataFrame()), cols=[:a, :b]),
                           DataFrame(a=1:2, b=missing))
    @test vcat(DataFrame(a=1), DataFrame(b=2), cols=[:a]) ≅ DataFrame(a=[1, missing])
    @test vcat(DataFrame(a=1), DataFrame(b=2), cols=[:b]) ≅ DataFrame(b=[missing, 2])
    @test vcat(DataFrame(a=1), DataFrame(b=2), cols=Symbol[]) == DataFrame()
    @test isequal_coltyped(vcat(DataFrame(a=1), DataFrame(b=2), cols=[:c]),
                           DataFrame(c=[missing, missing]))
end

@testset "vcat init" begin
    dfs = [DataFrame(a=1), DataFrame(b=2)]
    @test reduce(vcat, dfs, cols=:union, source=:x, init=DataFrame(c=[])) ≅
          DataFrame(c=missing, a=[1, missing], b=[missing, 2], x=1:2)
    @test reduce(vcat, dfs, cols=:union, source=:x => ["a", "b"], init=DataFrame(c=[])) ≅
          DataFrame(c=missing, a=[1, missing], b=[missing, 2], x=["a", "b"])

    dfs = [DataFrame(a=1), DataFrame(a=2)]
    df_init = DataFrame(c=[])
    metadata!(df_init, "k1", "v1", style=:note)
    colmetadata!(df_init, :c, "kc", "vc", style=:note)
    metadata!(dfs[1], "k2", "v2", style=:note)
    metadata!(dfs[2], "k2", "v2", style=:note)
    colmetadata!(dfs[1], :a, "ka", "va", style=:note)
    colmetadata!(dfs[2], :a, "ka", "va", style=:note)
    res = reduce(vcat, dfs, cols=:union, source=:x => ["a", "b"], init=df_init)
    @test metadata(res) == Dict("k2" => "v2")
    @test colmetadata(res) == Dict(:a => Dict("ka" => "va"))

    @test_throws ArgumentError reduce(vcat, dfs, cols=:union, source=:x, init=DataFrame(c=[1]))
end

@testset "vcat ChainedVector ambiguity" begin
    dfs = DataFrames.SentinelArrays.ChainedVector([[DataFrame(a=1)], [DataFrame(a=2)]])
    @test reduce(vcat, dfs) == DataFrame(a=1:2)
    dfs = DataFrames.SentinelArrays.ChainedVector([[DataFrame(a=1)], [DataFrame(b=2)]])
    @test reduce(vcat, dfs, cols=:union, source=:x, init=DataFrame(c=[])) ≅
          DataFrame(c=missing, a=[1, missing], b=[missing, 2], x=1:2)
end

@testset "names for Type, predicate + standard tests of cols" begin
    df_long = DataFrame(a1=1:3, a2=[1, missing, 3],
                        b1=1.0:3.0, b2=[1.0, missing, 3.0],
                        c1='1':'3', c2=['1', missing, '3'], x=1:3)
    for x in (df_long[:, Not(end)], @view(df_long[:, Not(end)]),
              groupby(df_long[:, Not(end)], :a1), groupby(@view(df_long[:, Not(end)]), :a1),
              eachrow(df_long[:, Not(end)]), eachrow(@view(df_long[:, Not(end)])),
              eachcol(df_long[:, Not(end)]), eachcol(@view(df_long[:, Not(end)])),
              df_long[1, Not(end)])
        @test names(x, 1) == ["a1"]
        @test names(x, "a1") == ["a1"]
        @test names(x, :a1) == ["a1"]
        @test names(x, [2, 1]) == ["a2", "a1"]
        @test names(x, ["a2", "a1"]) == ["a2", "a1"]
        @test names(x, [:a2, :a1]) == ["a2", "a1"]
        @test names(x, Int) == ["a1"]
        @test names(x, Union{Missing, Int}) == ["a1", "a2"]
        @test names(x, Real) == ["a1", "b1"]
        @test names(x, Union{Missing, Real}) == ["a1", "a2", "b1", "b2"]
        @test names(x, Any) == names(x)
        @test isempty(names(x, BigInt))
        @test names(x, Union{Char, Float64, Missing}) == ["b1", "b2", "c1", "c2"]
        @test names(x, startswith("a")) == ["a1", "a2"]
        @test names(x, :) == names(x)
        @test names(x, <("a2")) == ["a1"]

        @test_throws TypeError names(x, x -> 1)
    end
end

@testset "reverse DataFrame" begin
    df = DataFrame(a=1:5, b=5:-1:1)
    @test reverse(df) == DataFrame(a=5:-1:1, b=1:5)
    @test reverse(DataFrame(a=1, b=1)) == DataFrame(a=1, b=1)
    @test typeof(reverse(df)) == DataFrame
    @test reverse(df, 2, 3) == df[[1; 3; 2; 4:end], :]
    @test reverse(df, 3) == df[[1; 2; end:-1:3], :]

    df = DataFrame(a=1:5)
    df.b = df.a
    @test reverse(df) == DataFrame(a=5:-1:1, b=5:-1:1)
end

@testset "reverse! DataFrame" begin
    df = DataFrame(a=1:5, b=5:-1:1)
    cdf = copy(df)
    @test reverse!(df) === df
    @test df == DataFrame(a=5:-1:1, b=1:5)
    @test reverse!(DataFrame(a=1, b=1)) == DataFrame(a=1, b=1)
    df = DataFrame(a=1:5, b=5:-1:1)
    @test reverse!(df, 2, 3) == cdf[[1; 3; 2; 4:end], :]
    df = DataFrame(a=1:5, b=5:-1:1)
    @test reverse!(df, 3) == cdf[[1; 2; end:-1:3], :]

    df = DataFrame(a=1:5)
    df.b = df.a
    df.c = 11:15
    @test reverse!(df) == DataFrame(a=5:-1:1, b=5:-1:1, c=15:-1:11)

    x = collect(1:6)
    df = DataFrame()
    df.a = view(x, 1:5)
    df.b = view(x, 2:6)
    @test reverse(df) == DataFrame(a=5:-1:1, b=6:-1:2)
    # incorrect result due to aliasing
    @test reverse!(df) != DataFrame(a=5:-1:1, b=6:-1:2)
end

@testset "reverse! SubDataFrame" begin
    df = DataFrame(a=1:10, b=10:-1:1, c=11:20)
    cdf = copy(df)
    dfv = view(df, 1:3, 1:2)
    @test reverse!(dfv) === dfv
    @test dfv == DataFrame(a=[3, 2, 1], b=[8, 9, 10])
    @test df == insertcols!(reverse(cdf[:, 1:2], 1, 3), :c => 11:20)

    df = DataFrame(a=1:10, b=10:-1:1, c=11:20)
    @test reverse!(view(df, 1:5, 1:3)) == DataFrame(a=5:-1:1, b=6:10, c=15:-1:11)
    df = DataFrame(a=1:10, b=10:-1:1, c=11:20)
    @test reverse!(view(df, :, 1:2)) == DataFrame(a=10:-1:1, b=1:10)
    @test reverse!(view(df, :, 1:2)) isa SubDataFrame
    df = DataFrame(a=1:10, b=10:-1:1, c=11:20)
    @test reverse(view(df, 2:5, 2:3), 2) == DataFrame(b=[9; 6:8], c=[12; 15:-1:13])
    df = DataFrame(a=1:10, b=10:-1:1, c=11:20)
    @test reverse(view(df, 2:5, 2:3), 2, 3) == DataFrame(b=[9, 7, 8, 6], c=[12, 14, 13, 15])

    df = DataFrame(a=1:5)
    df.b = df.a
    @test reverse!(view(df, 2:4, 1:2)) == DataFrame(a=4:-1:2, b=4:-1:2)

    x = collect(1:6)
    df = DataFrame()
    df.a = view(x, 1:5)
    df.b = view(x, 2:6)
    dfv = view(df, 2:4, :)
    @test reverse(dfv) == DataFrame(a=4:-1:2, b=5:-1:3)
    # incorrect result due to aliasing
    @test reverse!(dfv) != DataFrame(a=4:-1:2, b=5:-1:3)

end

@testset "permute!, invpermute!" begin
    df = DataFrame(a=1:5, b=6:10, c=11:15)
    df.d = df.a
    dfc = copy(df)
    @test permute!(df, [5, 3, 1, 2, 4]) === df
    @test df == dfc[[5, 3, 1, 2, 4], :]
    @test invpermute!(df, [5, 3, 1, 2, 4]) === df
    @test df == dfc

    df = DataFrame(a=1:5, b=6:10, c=11:15)
    df.d = df.a
    dfc = copy(df)
    @test permute!(df, [5, 3, 1, 2, 4]) === df
    @test df == dfc[[5, 3, 1, 2, 4], :]
    @test invpermute!(df, df.d) === df
    @test df == dfc

    df2 = copy(dfc)
    dfv = view(df2, 1:4, :)
    @test permute!(dfv, [3, 1, 2, 4]) === dfv
    @test dfv == dfc[[3, 1, 2, 4], :]
    @test invpermute!(dfv, [3, 1, 2, 4]) === dfv
    @test df2 == dfc

    df2 = copy(dfc)
    dfv = view(df2, 1:4, :)
    @test permute!(dfv, [3, 1, 2, 4]) === dfv
    @test dfv == dfc[[3, 1, 2, 4], :]
    @test invpermute!(dfv, dfv.d) === dfv
    @test df2 == dfc

    @test DataFrame(x=[17]) == invpermute!(DataFrame(x=[17]), [1])
    @test DataFrame(x=[17, 29]) == invpermute!(DataFrame(x=[29, 17]), [2, 1])

    @test_throws DimensionMismatch permute!(df, [1, 4, 3, 2, 5, 6])
    @test_throws DimensionMismatch permute!(df, [1, 3, 2])
    @test_throws ArgumentError permute!(df, [4, 4, 2, 5, 3])
    @test_throws ArgumentError DataFrames._compile_permutation!([3, 3, 1])
    @test_throws ArgumentError invpermute!(df, OffsetArray([5,4,7,8,6], 4:8))
end

@testset "exhaustive permute!, invpermute!" begin
    Random.seed!(1729)
    for perm_len in 0:6
        p = fill(0, perm_len)
        for len in (perm_len > 4 ? [perm_len] : (max(0, perm_len-1):perm_len+1))
            df = DataFrame([rand(len) for _ in 1:3], :auto)
            dfc = copy(df)
            for i in 0:(perm_len+3)^perm_len
                digits!(p, i, base=perm_len+3)
                p .-= 2
                if perm_len != len
                    @test_throws DimensionMismatch permute!(df, p)
                    @test_throws DimensionMismatch invpermute!(df, p)
                elseif sort(p) != collect(1:perm_len)
                    if perm_len <= 5 || rand() < 0.01
                        @test_throws ArgumentError permute!(df, p)
                        @test_throws ArgumentError invpermute!(df, p)
                    end
                else
                    @test df[p, :] == permute!(df, p)
                    @test dfc == invpermute!(df, p)
                end
            end
        end
    end
    for _ in 1:1000
        len = rand(1:1000)
        p = shuffle!(collect(1:len))
        v = rand(len)
        df = DataFrame([v, v, rand(len), v], :auto)
        dfc = copy(df)
        @test df[p, :] == permute!(df, p)
        @test dfc == invpermute!(df, p)
        df = DataFrame([v, v, rand(len), v], :auto, copycols=false)
        dfc = copy(df)
        @test df[p, :] == permute!(df, p)
        @test dfc == invpermute!(df, p)
    end
end

@testset "shuffle, shuffle!" begin
    refdf = DataFrame(a=1:5, b=11:15)
    refdf.c = refdf.a
    for df in (refdf, view(refdf, 2:5, [2, 1]))
        x = randperm(StableRNG(1234), nrow(df))
        mt = StableRNG(1234)
        @test shuffle(mt, df) == df[x, :]
        Random.seed!(1234)
        x = randperm(nrow(df))
        Random.seed!(1234)
        @test shuffle(df) == df[x, :]
    end
    df = copy(refdf)
    x = randperm(StableRNG(1234), nrow(df))
    mt = StableRNG(1234)
    @test shuffle!(mt, df) === df
    @test df == refdf[x, :]
    df = copy(refdf)
    Random.seed!(1234)
    x = randperm(nrow(df))
    Random.seed!(1234)
    @test shuffle!(df) === df
    @test df == refdf[x, :]

    df = copy(refdf)
    dfv = view(df, 2:4, [3, 1])
    x = randperm(StableRNG(1234), nrow(dfv))
    mt = StableRNG(1234)
    @test shuffle!(mt, dfv) === dfv
    @test dfv == view(refdf, 2:4, [3, 1])[x, :]
    @test df[1, :] == refdf[1, :]
    @test df[5, :] == refdf[5, :]
    @test df.b == refdf.b
end

@testset "keepat!" begin
    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test_throws BoundsError keepat!(df, [true, true, true])
    @test keepat!(df, 2) === df
    @test df == DataFrame(a=[2], b=[4.0])

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test keepat!(df, 1) === df
    @test df == DataFrame(a=[1], b=[3.0])

    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test keepat!(df, 2) === df
    @test df == DataFrame(a=[2], b=[4.0])

    df = DataFrame(a=Union{Int, Missing}[1, 2], b=Union{Float64, Missing}[3.0, 4.0])
    @test keepat!(df, 1) === df
    @test df == DataFrame(a=[1], b=[3.0])

    for v in (2:3, [2, 3])
        df = DataFrame(a=Union{Int, Missing}[1, 2, 3], b=Union{Float64, Missing}[3.0, 4.0, 5.0])
        @test keepat!(df, v) === df
        @test df == DataFrame(a=[2, 3], b=[4.0, 5.0])

        df = DataFrame(a=[1, 2, 3], b=[3.0, 4.0, 5.0])
        @test keepat!(df, v) === df
        @test df == DataFrame(a=[2, 3], b=[4.0, 5.0])
    end

    df = DataFrame()
    @test_throws BoundsError keepat!(df, 10)
    @test_throws BoundsError keepat!(df, [10])

    df = DataFrame(a=[])
    @test_throws BoundsError keepat!(df, 10)
    @test_throws BoundsError keepat!(df, [10])

    df = DataFrame(a=[1, 2, 3], b=[3, 2, 1])
    @test_throws ArgumentError keepat!(df, [3, 2])
    @test_throws ArgumentError keepat!(df, [2, 2])
    @test keepat!(df, [true, false, true]) === df
    @test df == DataFrame(a=[1, 3], b=[3, 1])

    for v in (2:3, [2, 3], [false, true, true])
        x = [1, 2, 3]
        df = DataFrame(x=x)
        @test keepat!(df, v) == DataFrame(x=[2, 3])
        @test x == [1, 2, 3]
    end

    for v in ([2, 3], 2:3, [false, true, true], Not(1), Not([true, false, false]))
        x = [1, 2, 3]
        df = DataFrame(x=x, copycols=false)
        @test keepat!(df, v) == DataFrame(x=[2, 3])
        @test x == [2, 3]
    end

    for inds in (2, [2], [false, true])
        df = DataFrame(x1=[1, 2])
        df.x2 = df.x1
        @test keepat!(df, inds) === df
        @test df == DataFrame(x1=[2], x2=[2])
    end

    df = DataFrame(a=1, b=2)
    push!(df.b, 3)
    @test_throws AssertionError keepat!(df, 1)

    df = DataFrame(a=[1, 2], b=[3, 4])
    @test_throws ArgumentError keepat!(df, true)
    @test_throws ArgumentError keepat!(df, false)

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test keepat!(df, :) == DataFrame(a=[1, 2], b=[3.0, 4.0])

    df = DataFrame(a=[1, 2], b=[3.0, 4.0])
    @test_throws MethodError keepat!(df, "a")
    @test_throws MethodError keepat!(df, zeros(Int, 0, 0))
    @test_throws ArgumentError keepat!(df, [1.5])
    @test_throws ArgumentError keepat!(df, Integer[1, true])
    @test_throws ArgumentError keepat!(df, Integer[true, 2])
    @test isempty(keepat!(df, []))
    @test_throws BoundsError keepat!(DataFrame(), Not(1))
end

@testset "resize!" begin
    df = DataFrame()
    @test_throws ArgumentError resize!(df, 1)
    @test resize!(df, 0) == DataFrame()

    df = DataFrame(a=Int[], b=Float64[])
    resize!(df, 0)
    @test size(df) == (0, 2)
    @test names(df) == ["a", "b"]
    @test eltype.(eachcol(df)) == [Int, Float64]
    resize!(df, 1)
    @test size(df) == (1, 2)
    @test names(df) == ["a", "b"]
    @test eltype.(eachcol(df)) == [Int, Float64]

    df = DataFrame(a=[1, 2, 3], b=[11.0, 12.0, 13.0])
    @test resize!(df, 1) == DataFrame(a=[1], b=[11.0])
    resize!(df, 5)
    @test size(df) == (5, 2)
    @test names(df) == ["a", "b"]
    @test eltype.(eachcol(df)) == [Int, Float64]
    @test df[1:1, :] == DataFrame(a=[1], b=[11.0])

    df = DataFrame(a=[1, 2, 3], b=[11.0, 12.0, 13.0])
    @test resize!(df, true) == DataFrame(a=[1], b=[11.0])

    df = DataFrame(a=[1, 2, 3], b=[11.0, 12.0, 13.0])
    resize!(df, false)
    @test size(df) == (0, 2)
    @test names(df) == ["a", "b"]
    @test eltype.(eachcol(df)) == [Int, Float64]
end

@testset "pop!, popfirst!, popat!" begin
    df = DataFrame(a=Integer[1, 2, 3], b=[11.0, 12.0, 13.0])
    nt = pop!(df)
    @test nt == (a=3, b=13.0)
    @test typeof(nt) == NamedTuple{(:a, :b), Tuple{Integer, Float64}}
    @test df == DataFrame(a=[1, 2], b=[11.0, 12.0])

    df = DataFrame(a=Integer[1, 2, 3], b=[11.0, 12.0, 13.0])
    nt = popfirst!(df)
    @test nt == (a=1, b=11.0)
    @test typeof(nt) == NamedTuple{(:a, :b), Tuple{Integer, Float64}}
    @test df == DataFrame(a=[2, 3], b=[12.0, 13.0])

    df = DataFrame(a=Integer[1, 2, 3], b=[11.0, 12.0, 13.0])
    nt = popat!(df, 2)
    @test nt == (a=2, b=12.0)
    @test typeof(nt) == NamedTuple{(:a, :b), Tuple{Integer, Float64}}
    @test df == DataFrame(a=[1, 3], b=[11.0, 13.0])
    @test_throws ArgumentError popat!(df, true)
    @test_throws ArgumentError popat!(df, false)
    @test_throws BoundsError popat!(df, 0)
    @test_throws BoundsError popat!(df, 5)

    for df in (DataFrame(), DataFrame(a=[]))
        @test_throws BoundsError pop!(df)
        @test_throws BoundsError popfirst!(df)
        @test_throws BoundsError popat!(df, 0)
        @test_throws BoundsError popat!(df, 1)
    end
end

@testset "isempty" begin
    @test isempty(DataFrame())
    @test isempty(DataFrame(a=[]))
    @test !isempty(DataFrame(a=1))
end

@testset "allunique" begin
    refdf = DataFrame(a=[1, 1, 2, 2, 3], b=[1, 2, 1, 2, 3], c=[1, 2, 1, 2, 3])
    for df in (refdf[1:4, 1:2], view(refdf, 1:4, 1:2))
        @test allunique(df)
        @test !allunique(df, 1)
        @test !allunique(df, :b)
        @test allunique(df, All())
        @test allunique(df, [])
        @test allunique(df, x -> 1:4)
        @test allunique(df, [:a, :b] => ByRow(string))
        @test_throws ArgumentError allunique(df, ())
    end
end

@testset "extra tests describe, nonunique, allunique for SubDataFrame" begin
    refdf = DataFrame(a=[1, 1, 2, 2, 3], b=[1, 2, 1, 2, 3], c=[1, 2, 1, 2, 3])
    sdf = @view refdf[1:4, 1:2]
    @test describe(sdf, cols=:a => ByRow(string)) ==
          DataFrame(variable=:a_string, mean=nothing, min="1",
                    median=nothing, max="2", nmissing=0, eltype=String)
    @test describe(sdf, :min, :max, cols=x -> DataFrame(x=11:14)) ==
          DataFrame(variable=:x, min=11, max=14)
    @test nonunique(sdf, x->[1, 1, 2, 2]) == [false, true, false, true]
    @test nonunique(sdf, :a => x -> true) == [false, true, true, true]
    @test !allunique(sdf, x -> [1, 1, 2, 2])
    @test allunique(sdf, :a => x -> 1:4)
    @test !allunique(sdf, :a => x -> true)
end

@testset "Iterators.partition" begin
    for df in (DataFrame(x=1:5), view(DataFrame(x=1:6, y=11:16), 1:5, 1:1))
        p = Iterators.partition(df, 2)
        @test p isa Iterators.PartitionIterator
        @test Tables.partitions(p) === p
        @test eltype(p) === AbstractDataFrame
        @test Base.IteratorEltype(typeof(p)) === Base.EltypeUnknown()
        @test length(p) == 3
        @test Base.IteratorSize(typeof(p)) === Base.HasLength()
        res = collect(p)
        @test res == [DataFrame(x=1:2), DataFrame(x=3:4), DataFrame(x=5)]
        @test all(v -> v isa SubDataFrame, res)
        @test_throws ArgumentError Iterators.partition(df, false)
        @test_throws ArgumentError Iterators.partition(df, -1)

        dfr = eachrow(df)
        p = Iterators.partition(dfr, 2)
        @test p isa Iterators.PartitionIterator
        @test Tables.partitions(p) === p
        @test eltype(p) === DataFrames.DataFrameRows
        @test Base.IteratorEltype(typeof(p)) === Base.EltypeUnknown()
        @test length(p) == 3
        @test Base.IteratorSize(typeof(p)) === Base.HasLength()
        res = collect(p)
        @test res == eachrow.([DataFrame(x=1:2), DataFrame(x=3:4), DataFrame(x=5)])
        @test all(v -> v isa DataFrames.DataFrameRows, res)
        @test_throws ArgumentError Iterators.partition(df, false)
        @test_throws ArgumentError Iterators.partition(df, -1)
    end
    p = Iterators.partition(DataFrame(), 1)
    @test p isa Iterators.PartitionIterator
    @test Tables.partitions(p) === p
    @test isempty(p)
    @test length(p) == 0
    @test eltype(collect(p)) <: SubDataFrame

    p = Iterators.partition(eachrow(DataFrame()), 1)
    @test p isa Iterators.PartitionIterator
    @test Tables.partitions(p) === p
    @test isempty(p)
    @test length(p) == 0
    @test eltype(collect(p)) <: DataFrames.DataFrameRows
end

end # module

using DataFrames
using PooledArrays
using BenchmarkTools
using Random

Random.seed!(1)

grouping_benchmarks = BenchmarkGroup()

for n in (1000, 10_000_000),
    k in (10, 10_000),
    x in (rand(1:k, n),
          rand([1:k; missing], n),
          rand(string.(1:k), n),
          rand([string.(1:k); missing], n),
          PooledArray(rand(1:k, n)),
          PooledArray(rand([missing; 1:k], n)))
        df = DataFrame(x=x)

        grouping_benchmarks[n, k, typeof(x), "skipmissing=false"] =
            @benchmarkable groupby($df, :x)

        # Skipping missing values
        grouping_benchmarks[n, k, typeof(x), "skipmissing=true"] =
            @benchmarkable groupby($df, :x, skipmissing=true)

        for l in (10, 10_000),
            y in (rand(1:l, n),
                  rand([1:l; missing], n),
                  rand(string.(1:l), n),
                  rand([string.(1:l); missing], n),
                  PooledArray(rand(1:l, n)),
                  PooledArray(rand([missing; 1:l], n)))
            df.y = y

            grouping_benchmarks[n, (k, l), (typeof(x), typeof(y)),
                                "skipmissing=false"] =
                @benchmarkable groupby($df, [:x, :y])

            # Skipping missing values
            grouping_benchmarks[n, (k, l), (typeof(x), typeof(y)),
                                "skipmissing=true"] =
                @benchmarkable groupby($df, [:x, :y], skipmissing=true)
        end

        if df.x isa PooledArray
            # Empty group which requires adjusting group indices
            replace!(df.x, levels(df.x)[1] => levels(df.x)[2])
            grouping_benchmarks[n, k, typeof(x), "empty group"] =
                @benchmarkable groupby($df, :x)
        end
end


# If a cache of tuned parameters already exists, use it, otherwise, tune and cache
# the benchmark parameters. Reusing cached parameters is faster and more reliable
# than re-tuning `suite` every time the file is included.
paramspath = joinpath(dirname(@__FILE__), "params.json")

if isfile(paramspath)
    loadparams!(grouping_benchmarks, BenchmarkTools.load(paramspath)[1], :evals);
else
    tune!(grouping_benchmarks)
    BenchmarkTools.save(paramspath, params(grouping_benchmarks));
end

grouping_results = run(grouping_benchmarks, verbose=true)
# using Serialization
# serialize("grouping_results.jls", grouping_results)
# leaves(judge(median(grouping_results1), median(grouping_results2)))
# leaves(regressions(judge(median(grouping_results1), median(grouping_results2))))
# leaves(improvements(judge(median(grouping_results1), median(grouping_results2))))

module TestTableTraits

using Test, DataFrames, IteratorInterfaceExtensions, TableTraits, DataValues

struct ColumnSource
end

TableTraits.supports_get_columns_copy_using_missing(::ColumnSource) = true
TableTraits.isiterabletable(::ColumnSource) = true

function TableTraits.get_columns_copy_using_missing(x::ColumnSource)
    return (a=[1 ,2, 3], b=[4.0, 5.0, 6.0], c=["A", "B", "C"])
end

@testset "TableTraits" begin
    df = DataFrame(a=[1, 2 ,3], b=[1.0, missing, 3.0])
    @test IteratorInterfaceExtensions.isiterable(df)
    @test TableTraits.isiterabletable(df)
    @test collect(IteratorInterfaceExtensions.getiterator(df)) ==
        [(a=1, b=DataValue(1.0)), (a=2, b=DataValue{Float64}()), (a=3, b=DataValue(3.0))]
    sdf = view(df, 1:2, :)
    @test IteratorInterfaceExtensions.isiterable(sdf)
    @test TableTraits.isiterabletable(sdf)
    @test collect(IteratorInterfaceExtensions.getiterator(sdf)) ==
        [(a=1, b=DataValue(1.0)), (a=2, b=DataValue{Float64}())]

    df = DataFrame(ColumnSource())

    @test size(df)==(3, 3)
    @test df.a==[1, 2, 3]
    @test df.b==[4.0, 5.0, 6.0]
    @test df.c==["A", "B", "C"]
end

end # module

module DataFrames

using Base.Sort,
      Base.Order,
      Base.Iterators,
      Base.Threads,
      Statistics,
      Printf,
      Reexport,
      SortingAlgorithms,
      Compat,
      Unicode,
      PooledArrays,
      TableTraits,
      IteratorInterfaceExtensions,
      Markdown,
      PrettyTables,
      Random

@reexport using Missings, InvertedIndices

using Tables: ByRow

import Base.keepat!,
       Base.stack,
       LinearAlgebra.norm,
       PrecompileTools,
       SentinelArrays,
       InlineStrings,
       DataAPI,
       DataAPI.allcombinations,
       DataAPI.All,
       DataAPI.Between,
       DataAPI.Cols,
       DataAPI.describe,
       DataAPI.groupby,
       DataAPI.innerjoin,
       DataAPI.outerjoin,
       DataAPI.rightjoin,
       DataAPI.leftjoin,
       DataAPI.semijoin,
       DataAPI.antijoin,
       DataAPI.crossjoin,
       DataAPI.nrow,
       DataAPI.ncol,
       DataAPI.metadata,
       DataAPI.metadatakeys,
       DataAPI.metadata!,
       DataAPI.deletemetadata!,
       DataAPI.emptymetadata!,
       DataAPI.colmetadata,
       DataAPI.colmetadatakeys,
       DataAPI.colmetadata!,
       DataAPI.deletecolmetadata!,
       DataAPI.emptycolmetadata!,
       DataAPI.rownumber,
       Tables,
       Tables.columnindex,
       Future.copy!

export AbstractDataFrame,
       All,
       AsTable,
       Between,
       ByRow,
       Cols,
       DataFrame,
       DataFrameRow,
       GroupedDataFrame,
       SubDataFrame,
       Tables,
       allcombinations,
       allowmissing!,
       antijoin,
       columnindex,
       combine,
       completecases,
       crossjoin,
       describe,
       disallowmissing!,
       dropmissing!,
       dropmissing,
       fillcombinations,
       flatten,
       groupby,
       groupindices,
       groupcols,
       innerjoin,
       insertcols,
       insertcols!,
       leftjoin,
       leftjoin!,
       mapcols,
       mapcols!,
       ncol,
       nonunique,
       nrow,
       order,
       outerjoin,
       PrettyTables,
       proprow,
       rename!,
       rename,
       repeat!,
       rightjoin,
       rownumber,
       select!,
       select,
       semijoin,
       subset,
       subset!,
       transform,
       transform!,
       unique!,
       unstack,
       valuecols,
       metadata,
       metadatakeys,
       metadata!,
       deletemetadata!,
       emptymetadata!,
       colmetadata,
       colmetadatakeys,
       colmetadata!,
       deletecolmetadata!,
       emptycolmetadata!

const METADATA_FIXED =
    """
    Metadata: this function preserves table-level and column-level `:note`-style metadata.
    """

include("other/utils.jl")
include("other/index.jl")

include("abstractdataframe/abstractdataframe.jl")
include("abstractdataframe/unique.jl")
include("dataframe/dataframe.jl")
include("subdataframe/subdataframe.jl")
include("dataframerow/dataframerow.jl")
include("dataframe/insertion.jl")

include("abstractdataframe/sort.jl")

include("groupeddataframe/groupeddataframe.jl")
include("groupeddataframe/utils.jl")

include("other/broadcasting.jl")

include("abstractdataframe/selection.jl")
include("abstractdataframe/selectionfast.jl")
include("abstractdataframe/subset.jl")
include("abstractdataframe/iteration.jl")
include("abstractdataframe/reshape.jl")

include("join/composer.jl")
include("join/core.jl")
include("join/inplace.jl")

include("groupeddataframe/splitapplycombine.jl")
include("groupeddataframe/callprocessing.jl")
include("groupeddataframe/fastaggregates.jl")
include("groupeddataframe/complextransforms.jl")

@static if pkgversion(PrettyTables).major == 2
    # When PrettyTables v2 is more widely adopted in the ecosystem, we can remove this file.
    # In this case, we should also update the compat bounds in Project.toml to list only
    # PrettyTables v3.
    include("abstractdataframe/prettytables_v2.jl")
else
    include("abstractdataframe/prettytables.jl")
end

include("abstractdataframe/show.jl")
include("groupeddataframe/show.jl")
include("dataframerow/show.jl")
include("abstractdataframe/io.jl")

include("other/tables.jl")
include("other/names.jl")
include("other/metadata.jl")

include("deprecated.jl")

include("other/precompile.jl")

end # module DataFrames

### Metadata API from DataAPI.jl

# private type that is passed as a default value in the metadata and colmetadata
# functions to detect the fact that no default was passed
struct MetadataMissingDefault end

# DataAPI.metadatasupport and DataAPI.colmetadatasupport are not exported
DataAPI.metadatasupport(::Type{<:AbstractDataFrame}) = (read=true, write=true)
DataAPI.metadatasupport(::Type{<:DataFrameRow}) = (read=true, write=true)
DataAPI.metadatasupport(::Type{<:DataFrameRows}) = (read=true, write=true)
DataAPI.metadatasupport(::Type{<:DataFrameColumns}) = (read=true, write=true)
DataAPI.colmetadatasupport(::Type{<:AbstractDataFrame}) = (read=true, write=true)
DataAPI.colmetadatasupport(::Type{<:DataFrameRow}) = (read=true, write=true)
DataAPI.colmetadatasupport(::Type{<:DataFrameRows}) = (read=true, write=true)
DataAPI.colmetadatasupport(::Type{<:DataFrameColumns}) = (read=true, write=true)

const TABLEMETA_EXAMPLE =
    """
    # Examples

    ```jldoctest
    julia> df = DataFrame(a=1, b=2);

    julia> metadatakeys(df)
    ()

    julia> metadata!(df, "name", "example", style=:note);

    julia> metadatakeys(df)
    KeySet for a Dict{String, Tuple{Any, Any}} with 1 entry. Keys:
      "name"

    julia> metadata(df, "name")
    "example"

    julia> metadata(df, "name", style=true)
    ("example", :note)

    julia> deletemetadata!(df, "name");

    julia> metadatakeys(df)
    ()
    ```
    """

const COLMETADATA_EXAMPLE =
    """
    # Examples

    ```jldoctest
    julia> df = DataFrame(a=1, b=2);

    julia> colmetadatakeys(df)
    ()

    julia> colmetadata!(df, :a, "name", "example", style=:note);

    julia> collect(colmetadatakeys(df))
    1-element Vector{Pair{Symbol, Base.KeySet{String, Dict{String, Tuple{Any, Any}}}}}:
     :a => ["name"]

    julia> colmetadatakeys(df, :a)
    KeySet for a Dict{String, Tuple{Any, Any}} with 1 entry. Keys:
      "name"

    julia> colmetadata(df, :a, "name")
    "example"

    julia> colmetadata(df, :a, "name", style=true)
    ("example", :note)

    julia> deletecolmetadata!(df, :a, "name");

    julia> colmetadatakeys(df)
    ()
    ```
    """

"""
    metadata(df::AbstractDataFrame, key::AbstractString, [default]; style::Bool=false)
    metadata(dfr::DataFrameRow, key::AbstractString, [default]; style::Bool=false)
    metadata(dfc::DataFrameColumns, key::AbstractString, [default]; style::Bool=false)
    metadata(dfr::DataFrameRows, key::AbstractString, [default]; style::Bool=false)

Return table-level metadata value associated with `df` for key `key`.
If `style=true` return a tuple of metadata value and metadata style.

`SubDataFrame` and `DataFrameRow` expose only `:note`-style metadata of their
parent.

If `default` is passed then return it if `key` does not exist;
if `style=true` return `(default, :default)`.

See also: [`metadatakeys`](@ref), [`metadata!`](@ref),
[`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$TABLEMETA_EXAMPLE
```
"""
function metadata(df::DataFrame, key::AbstractString,
                  default=MetadataMissingDefault(); style::Bool=false)
    meta = getfield(df, :metadata)
    if meta === nothing || !haskey(meta, key)
        if default === MetadataMissingDefault()
            throw(ArgumentError("\"$key\" not found in table-level metadata"))
        else
            return style ? (default, :default) : default
        end
    end
    return style ? meta[key] : meta[key][1]
end

metadata(x::Union{DataFrameRows, DataFrameColumns}, key::AbstractString,
         default=MetadataMissingDefault(); style::Bool=false) =
    metadata(parent(x), key, default, style=style)

function metadata(x::Union{DataFrameRow, SubDataFrame}, key::AbstractString,
                  default=MetadataMissingDefault(); style::Bool=false)
    meta_value, meta_style = metadata(parent(x), key, default, style=true)
    # the `key in metadatakeys(parent(x))` check
    # allows returning default value as it has :default style
    if meta_style !== :note && key in metadatakeys(parent(x))
        throw(ArgumentError("\"$key\" was found in table-level metadata of parent " *
                            "data frame, but it does not have :note style"))
    end
    return style ? (meta_value, meta_style) : meta_value
end

"""
    metadatakeys(df::AbstractDataFrame)
    metadatakeys(dfr::DataFrameRow)
    metadatakeys(dfc::DataFrameColumns)
    metadatakeys(dfr::DataFrameRows)

Return an iterator of table-level metadata keys which are set in the object.

Values can be accessed using [`metadata(df, key)`](@ref).

`SubDataFrame` and `DataFrameRow` expose only `:note`-style metadata keys of
their parent.

See also: [`metadata`](@ref), [`metadata!`](@ref),
[`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$TABLEMETA_EXAMPLE
"""
function metadatakeys(df::DataFrame)
    meta = getfield(df, :metadata)
    meta === nothing && return ()
    metakeys = keys(meta)
    @assert !isempty(metakeys) # by design if isempty(metakeys) then meta === nothing should be met
    return metakeys
end

metadatakeys(x::Union{DataFrameRows, DataFrameColumns}) =
    metadatakeys(parent(x))

function metadatakeys(x::Union{DataFrameRow, SubDataFrame})
    df = parent(x)
    meta = getfield(df, :metadata)
    meta === nothing && return ()
    @assert !isempty(meta)
    return (k for (k, (_, s)) in pairs(meta) if s === :note)
end

"""
    metadata!(df::AbstractDataFrame, key::AbstractString, value; style::Symbol=:default)
    metadata!(dfr::DataFrameRow, key::AbstractString, value; style::Symbol=:default)
    metadata!(dfc::DataFrameColumns, key::AbstractString, value; style::Symbol=:default)
    metadata!(dfr::DataFrameRows, key::AbstractString, value; style::Symbol=:default)

Set table-level metadata for object `df` for key `key` to have value `value`
and style `style` (`:default` by default) and return `df`.

For `SubDataFrame` and `DataFrameRow` only `:note`-style is allowed.
Trying to set a key-value pair for which the key already exists in the parent
data frame with another style throws an error.

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$TABLEMETA_EXAMPLE
```
"""
function metadata!(df::DataFrame, key::AbstractString, value::Any;
                   style::Symbol=:default)
    premeta = getfield(df, :metadata)
    if premeta === nothing
        meta = Dict{String, Tuple{Any, Any}}()
        setfield!(df, :metadata, meta)
    else
        meta = premeta
    end
    meta[key] = (value, style)
    if style !== :note
        setfield!(df, :allnotemetadata, false)
    end
    return df
end

function metadata!(x::Union{DataFrameRows, DataFrameColumns},
                   key::AbstractString, value::Any; style::Symbol=:default)
    metadata!(parent(x), key, value, style=style)
    return x
end

function metadata!(x::Union{DataFrameRow, SubDataFrame},
                   key::AbstractString, value::Any; style::Symbol=:default)
    if style !== :note
        throw(ArgumentError("only :note-style metadata is supported for " *
                            "DataFrameRow and SubDataFrame"))
    end
    df = parent(x)
    meta = getfield(df, :metadata)
    if meta !== nothing && haskey(meta, key) && meta[key][2] !== :note
        throw(ArgumentError("setting metadata for DataFrameRow and SubDataFrame" *
                            "that is already present in the parent and does not " *
                            "have :note style is not allowed"))
    end
    metadata!(df, key, value, style=style)
    return x
end

"""
    deletemetadata!(df::AbstractDataFrame, key::AbstractString)
    deletemetadata!(dfr::DataFrameRow, key::AbstractString)
    deletemetadata!(dfc::DataFrameColumns, key::AbstractString)
    deletemetadata!(dfr::DataFrameRows, key::AbstractString)

Delete table-level metadata from object `df` for key `key` and return `df`.
If key does not exist, return `df` without modification.

For `SubDataFrame` and `DataFrameRow` only `:note`-style metadata from their
parent can be deleted (as other styles are not propagated to views).

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$TABLEMETA_EXAMPLE
```
"""
function deletemetadata!(df::DataFrame, key::AbstractString)
    meta = getfield(df, :metadata)
    # if metadata is nothing or key is missing in metadata this is a no-op
    meta === nothing && return df
    delete!(meta, key)
    isempty(meta) && setfield!(df, :metadata, nothing)
    return df
end

function deletemetadata!(x::Union{DataFrameRows, DataFrameColumns},
                         key::AbstractString)
    deletemetadata!(parent(x), key)
    return x
end

function deletemetadata!(x::Union{DataFrameRow, SubDataFrame},
                         key::AbstractString)
    df = parent(x)
    # key in metadatakeys(df) is more efficient than key in metadatakeys(x)
    # as it is an O(1) operation
    if key in metadatakeys(df)
        _, s = metadata(df, key, style=true)
        s == :note && deletemetadata!(df, key)
    end
    return x
end

"""
    emptymetadata!(df::AbstractDataFrame)
    emptymetadata!(dfr::DataFrameRow)
    emptymetadata!(dfc::DataFrameColumns)
    emptymetadata!(dfr::DataFrameRows)

Delete all table-level metadata from object `df`.

For `SubDataFrame` and `DataFrameRow` only `:note`-style metadata from their
parent can be deleted (as other styles are not propagated to views).

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(a=1, b=2);

julia> metadatakeys(df)
()

julia> metadata!(df, "name", "example", style=:note);

julia> metadatakeys(df)
KeySet for a Dict{String, Tuple{Any, Any}} with 1 entry. Keys:
  "name"

julia> metadata(df, "name")
"example"

julia> metadata(df, "name", style=true)
("example", :note)

julia> emptymetadata!(df);

julia> metadatakeys(df)
()
```
"""
function emptymetadata!(df::DataFrame)
    setfield!(df, :metadata, nothing)
    return df
end

function emptymetadata!(x::Union{DataFrameRows, DataFrameColumns})
    emptymetadata!(parent(x))
    return x
end

function emptymetadata!(x::Union{DataFrameRow, SubDataFrame})
    df = parent(x)
    for key in metadatakeys(df)
        _, s = metadata(df, key, style=true)
        s == :note && deletemetadata!(df, key)
    end
    return x
end

"""
    colmetadata(df::AbstractDataFrame, col::ColumnIndex, key::AbstractString, [default]; style::Bool=false)
    colmetadata(dfr::DataFrameRow, col::ColumnIndex, key::AbstractString, [default]; style::Bool=false)
    colmetadata(dfc::DataFrameColumns, col::ColumnIndex, key::AbstractString, [default]; style::Bool=false)
    colmetadata(dfr::DataFrameRows, col::ColumnIndex, key::AbstractString, [default]; style::Bool=false)

Return column-level metadata value associated with `df` for column `col` and key `key`.

`SubDataFrame` and `DataFrameRow` expose only `:note`-style metadata of their parent.

If `default` is passed then return it if `key` does not exist for column `col`;
if `style=true` return `(default, :default)`.
If `col` does not exist in `df` always throw an error.

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadatakeys`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$COLMETADATA_EXAMPLE
```
"""
function colmetadata(df::DataFrame, col::ColumnIndex, key::AbstractString,
                     default=MetadataMissingDefault(); style::Bool=false)
    idx = index(df)[col] # check if column exists and get its integer number
    cols_meta = getfield(df, :colmetadata)
    if cols_meta === nothing || !haskey(cols_meta, idx)
        if default === MetadataMissingDefault()
            colname = names(df)[idx]
            throw(ArgumentError("no column-level metadata found for column \"$colname\""))
        else
            return style ? (default, :default) : default
        end
    end
    col_meta = cols_meta[idx]
    if !haskey(col_meta, key)
        if default === MetadataMissingDefault()
            colname = names(df)[idx]
            throw(ArgumentError("\"$key\" not found in column-level metadata for column \"$colname\""))
        else
            return style ? (default, :default) : default
        end
    end
    return style ? col_meta[key] : col_meta[key][1]
end

colmetadata(x::Union{DataFrameRows, DataFrameColumns}, col::ColumnIndex,
            key::AbstractString, default=MetadataMissingDefault(); style::Bool=false) =
    colmetadata(parent(x), col, key, default; style=style)


function colmetadata(x::Union{DataFrameRow, SubDataFrame}, col::ColumnIndex,
                     key::AbstractString, default=MetadataMissingDefault(); style::Bool=false)
    col_name = _names(x)[index(x)[col]]
    df = parent(x)
    meta_value, meta_style = colmetadata(df, col_name, key, default, style=true)
    # the `key in colmetadatakeys(parent(x), col)` check
    # allows returning default value as it has :default style
    if meta_style !== :note && key in colmetadatakeys(parent(x), col)
        throw(ArgumentError("\"$key\" for column \"$(string(col_name))\" was found in column-level metadata " *
                            "of parent data frame, but it does not have :note style"))
    end
    return style ? (meta_value, meta_style) : meta_value
end

"""
    colmetadatakeys(df::AbstractDataFrame, [col::ColumnIndex])
    colmetadatakeys(dfr::DataFrameRow, [col::ColumnIndex])
    colmetadatakeys(dfc::DataFrameColumns, [col::ColumnIndex])
    colmetadatakeys(dfr::DataFrameRows, [col::ColumnIndex])

If `col` is passed return an iterator of column-level metadata keys
which are set for column `col`.
If `col` is not passed return an iterator of `col => colmetadatakeys(x, col)`
pairs for all columns that have metadata, where `col` are `Symbol`.

Values can be accessed using [`colmetadata(df, col, key)`](@ref).

`SubDataFrame` and `DataFrameRow` expose only `:note`-style metadata of their parent.

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadata!`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$COLMETADATA_EXAMPLE
```
"""
function colmetadatakeys(df::DataFrame, col::ColumnIndex)
    idx = index(df)[col] # check if column exists and get its integer index
    cols_meta = getfield(df, :colmetadata)
    cols_meta === nothing && return ()
    haskey(cols_meta, idx) || return ()
    col_meta = keys(cols_meta[idx])
    @assert !isempty(col_meta) # by design if isempty(col_meta) then cols_meta should not have an entry for idx
    return col_meta
end

function colmetadatakeys(df::DataFrame)
    cols_meta = getfield(df, :colmetadata)
    cols_meta === nothing && return ()
    return (_names(df)[idx] => colmetadatakeys(df, idx) for idx in keys(cols_meta))
end

colmetadatakeys(x::Union{DataFrameRows, DataFrameColumns}, col::ColumnIndex) =
    colmetadatakeys(parent(x), col)

colmetadatakeys(x::Union{DataFrameRows, DataFrameColumns}) =
    colmetadatakeys(parent(x))

function colmetadatakeys(x::Union{DataFrameRow, SubDataFrame}, col::ColumnIndex)
    col_name = _names(x)[index(x)[col]]
    df = parent(x)
    idx = index(df)[col_name]
    cols_meta = getfield(df, :colmetadata)
    cols_meta === nothing && return ()
    haskey(cols_meta, idx) || return ()
    col_meta = cols_meta[idx]
    @assert !isempty(col_meta) # by design if isempty(col_meta) then cols_meta should not have an entry for idx
    return (k for (k, (_, s)) in pairs(col_meta) if s === :note)
end

function colmetadatakeys(x::Union{DataFrameRow, SubDataFrame})
    df = parent(x)
    cols_meta = getfield(df, :colmetadata)
    cols_meta === nothing && return ()
    return (col => colmetadatakeys(x, col) for col in _names(x) if !isempty(colmetadatakeys(x, col)))
end

"""
    colmetadata!(df::AbstractDataFrame, col::ColumnIndex, key::AbstractString, value; style::Symbol=:default)
    colmetadata!(dfr::DataFrameRow, col::ColumnIndex, key::AbstractString, value; style::Symbol=:default)
    colmetadata!(dfc::DataFrameColumns, col::ColumnIndex, key::AbstractString, value; style::Symbol=:default)
    colmetadata!(dfr::DataFrameRows, col::ColumnIndex, key::AbstractString, value; style::Symbol=:default)

Set column-level metadata in `df` for column `col` and key `key` to have value `value`
and style `style` (`:default` by default) and return `df`.

For `SubDataFrame` and `DataFrameRow` only `:note` style is allowed.
Trying to set a key-value pair for which the key already exists in the parent
data frame with another style throws an error.

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref),
[`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$COLMETADATA_EXAMPLE
```
"""
function colmetadata!(df::DataFrame, col::ColumnIndex, key::AbstractString, value::Any;
                      style::Symbol=:default)
    idx = index(df)[col] # check if column exists and get its integer index
    pre_cols_meta = getfield(df, :colmetadata)
    if pre_cols_meta === nothing
        cols_meta = Dict{Int, Dict{String,Tuple{Any, Any}}}()
        setfield!(df, :colmetadata, cols_meta)
    else
        cols_meta = pre_cols_meta
    end
    col_meta = get!(Dict{String, Tuple{Any, Any}}, cols_meta, idx)
    col_meta[key] = (value, style)
    if style !== :note
        setfield!(df, :allnotemetadata, false)
    end
    return df
end

function colmetadata!(x::Union{DataFrameRows, DataFrameColumns},
                      col::ColumnIndex, key::AbstractString, value::Any;
                      style::Symbol=:default)
    colmetadata!(parent(x), col, key, value; style=style)
    return x
end

function colmetadata!(x::Union{DataFrameRow, SubDataFrame},
                      col::ColumnIndex, key::AbstractString, value::Any;
                      style::Symbol=:default)
    col_name = _names(x)[index(x)[col]]
    if style !== :note
        throw(ArgumentError("only :note-style metadata is supported for " *
                            "DataFrameRow and SubDataFrame"))
    end
    df = parent(x)
    cols_meta = getfield(df, :colmetadata)
    idx = index(df)[col_name]
    if cols_meta !== nothing && haskey(cols_meta, idx) &&
        haskey(cols_meta[idx], key) && cols_meta[idx][key][2] !== :note
        throw(ArgumentError("setting metadata for DataFrameRow and SubDataFrame" *
                            "that is already present in the parent and does not " *
                            "have :note style is not allowed"))
    end
    colmetadata!(df, idx, key, value, style=style)
    return x
end

"""
    deletecolmetadata!(df::AbstractDataFrame, col::ColumnIndex, key::AbstractString)
    deletecolmetadata!(dfr::DataFrameRow, col::ColumnIndex, key::AbstractString)
    deletecolmetadata!(dfc::DataFrameColumns, col::ColumnIndex, key::AbstractString)
    deletecolmetadata!(dfr::DataFrameRows, col::ColumnIndex, key::AbstractString)

Delete column-level metadata set in `df` for column `col` and key `key` and return `df`.

For `SubDataFrame` and `DataFrameRow` only `:note`-style metadata from their
parent can be deleted (as other styles are not propagated to views).

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref),
[`colmetadata!`](@ref), [`emptycolmetadata!`](@ref).

$COLMETADATA_EXAMPLE
"""
function deletecolmetadata!(df::DataFrame, col::ColumnIndex, key::AbstractString)
    idx = index(df)[col] # check if column exists and get its integer index
    cols_meta = getfield(df, :colmetadata)
    # if metadata is nothing or key is missing in metadata this is a no-op
    cols_meta === nothing && return df
    haskey(cols_meta, idx) || return df
    col_meta = cols_meta[idx]
    delete!(col_meta, key)
    isempty(col_meta) && delete!(cols_meta, idx)
    isempty(cols_meta) && setfield!(df, :colmetadata, nothing)
    return df
end

function deletecolmetadata!(x::Union{DataFrameRows, DataFrameColumns},
                                  col::ColumnIndex, key::AbstractString)
    deletecolmetadata!(parent(x), col, key)
    return x
end

function deletecolmetadata!(x::Union{DataFrameRow, SubDataFrame},
                            col::ColumnIndex, key::AbstractString)
    col_name = _names(x)[index(x)[col]]
    df = parent(x)
    idx = index(df)[col_name]

    # key in colmetadatakeys(df, idx) is more efficient than key in colmetadatakeys(x, idx)
    # as it is an O(1) operation
    if key in colmetadatakeys(df, idx)
        _, s = colmetadata(df, idx, key, style=true)
        s == :note && deletecolmetadata!(df, idx, key)
    end
    return x
end

"""
    emptycolmetadata!(df::AbstractDataFrame, [col::ColumnIndex])
    emptycolmetadata!(dfr::DataFrameRow, [col::ColumnIndex])
    emptycolmetadata!(dfc::DataFrameColumns, [col::ColumnIndex])
    emptycolmetadata!(dfr::DataFrameRows, [col::ColumnIndex])

Delete column-level metadata set in `df` for column `col` and key `key` and return `df`.

For `SubDataFrame` and `DataFrameRow` only `:note`-style metadata from their
parent can be deleted (as other styles are not propagated to views).

See also: [`metadata`](@ref), [`metadatakeys`](@ref),
[`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref),
[`colmetadata`](@ref), [`colmetadatakeys`](@ref),
[`colmetadata!`](@ref), [`deletecolmetadata!`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(a=1, b=2);

julia> colmetadata!(df, :a, "name", "example", style=:note);

julia> collect(colmetadatakeys(df))
1-element Vector{Pair{Symbol, Base.KeySet{String, Dict{String, Tuple{Any, Any}}}}}:
 :a => ["name"]

julia> colmetadatakeys(df, :a)
KeySet for a Dict{String, Tuple{Any, Any}} with 1 entry. Keys:
  "name"

julia> colmetadata(df, :a, "name")
"example"

julia> colmetadata(df, :a, "name", style=true)
("example", :note)

julia> emptycolmetadata!(df, :a);

julia> colmetadatakeys(df)
()
```
"""
function emptycolmetadata!(df::DataFrame, col::ColumnIndex)
    idx = index(df)[col] # check if column exists and get its integer index
    cols_meta = getfield(df, :colmetadata)
    cols_meta === nothing && return df
    delete!(cols_meta, idx)
    isempty(cols_meta) && setfield!(df, :colmetadata, nothing)
    return df
end

function emptycolmetadata!(df::DataFrame)
    setfield!(df, :colmetadata, nothing)
    return df
end

function emptycolmetadata!(x::Union{DataFrameRows, DataFrameColumns}, col::ColumnIndex)
    emptycolmetadata!(parent(x), col)
    return x
end

function emptycolmetadata!(x::Union{DataFrameRows, DataFrameColumns})
    emptycolmetadata!(parent(x))
    return x
end

function emptycolmetadata!(x::Union{DataFrameRow, SubDataFrame}, col::ColumnIndex)
    col_name = _names(x)[index(x)[col]]
    df = parent(x)
    idx = index(df)[col_name]

    for key in colmetadatakeys(df, idx)
        _, s = colmetadata(df, idx, key, style=true)
        s == :note && deletecolmetadata!(df, idx, key)
    end
    return x
end

function emptycolmetadata!(x::DataFrameRow)
    for i in 1:length(x)
        emptycolmetadata!(x, i)
    end
    return x
end

function emptycolmetadata!(x::SubDataFrame)
    for i in 1:ncol(x)
        emptycolmetadata!(x, i)
    end
    return x
end

### Internal utility functions for metadata handling

# copy table-level :note-style metadata from Tables.jl table src to dst
# discarding previous metadata contents of dst
function _copy_table_note_metadata!(dst::DataFrame, src)
    emptymetadata!(dst)
    if DataAPI.metadatasupport(typeof(src)).read
        for key in metadatakeys(src)
            val, style = metadata(src, key, style=true)
            style === :note && metadata!(dst, key, val, style=:note)
        end
    end
    return nothing
end

# copy column-level :note-style metadata from Tables.jl table src to dst
# from column src_col to dst_col
# discarding previous metadata contents of dst
function _copy_col_note_metadata!(dst::DataFrame, dst_col, src, src_col)
    emptycolmetadata!(dst, dst_col)
    if DataAPI.colmetadatasupport(typeof(src)).read
        for key in colmetadatakeys(src, src_col)
            val, style = colmetadata(src, src_col, key, style=true)
            style === :note && colmetadata!(dst, dst_col, key, val, style=:note)
        end
    end
    return nothing
end

# this is a function used to copy table-level and column-level :note-style metadata
# from Tables.jl table src to dst, discarding previous metadata contents of dst
function _copy_all_note_metadata!(dst::DataFrame, src)
    _copy_table_note_metadata!(dst, src)
    emptycolmetadata!(dst)
    if DataAPI.colmetadatasupport(typeof(src)).read
        for (col, col_keys) in colmetadatakeys(src)
            if hasproperty(dst, col)
                for key in col_keys
                    val, style = colmetadata(src, col, key, style=true)
                    style === :note && colmetadata!(dst, col, key, val, style=:note)
                end
            end
        end
    end
    return nothing
end

# this is a function used to copy all table and column-level metadata
# from Tables.jl table src to dst, discarding previous metadata contents of dst
function _copy_all_all_metadata!(dst::DataFrame, src)
    emptymetadata!(dst)
    if DataAPI.metadatasupport(typeof(src)).read
        for key in metadatakeys(src)
            val, style = metadata(src, key, style=true)
            metadata!(dst, key, val, style=style)
        end
    end
    emptycolmetadata!(dst)
    if DataAPI.colmetadatasupport(typeof(src)).read
        for (col, col_keys) in colmetadatakeys(src)
            if hasproperty(dst, col)
                for key in col_keys
                    val, style = colmetadata(src, col, key, style=true)
                    colmetadata!(dst, col, key, val, style=style)
                end
            end
        end
    end
    return nothing
end

# this is a function used to drop table-level metadata that is not :note-style
function _drop_table_nonnote_metadata!(df::DataFrame)
    getfield(df, :allnotemetadata) && return nothing
    for key in metadatakeys(df)
        _, style = metadata(df, key, style=true)
        style === :note || deletemetadata!(df, key)
    end
    return nothing
end

# this is a function used to drop table and column-level metadata that is not :note-style
function _drop_all_nonnote_metadata!(df::DataFrame)
    getfield(df, :allnotemetadata) && return nothing
    _drop_table_nonnote_metadata!(df)
    for (col, col_keys) in colmetadatakeys(df)
        for key in col_keys
            _, style = colmetadata(df, col, key, style=true)
            style === :note || deletecolmetadata!(df, col, key)
        end
    end
    setfield!(df, :allnotemetadata, true)
    return nothing
end

# this is a function used to merge matching table-level metadata that has
# :note style and store it in `res`
# it removes all table-level metadata previously stored in `res`
# key-value metadata pair is matching if it has :note style and is present
# in all tables passed in dfs collection
function _merge_matching_table_note_metadata!(res::DataFrame,
                                              dfs::Union{AbstractVector{<:AbstractDataFrame},
                                                         Tuple{AbstractDataFrame, Vararg{AbstractDataFrame}}})
    emptymetadata!(res)
    @assert firstindex(dfs) == 1
    if !isempty(dfs) && all(x -> !isempty(metadatakeys(x)), dfs)
        df1 = dfs[1]
        for key1 in metadatakeys(df1)
            meta_val1, meta_style1 = metadata(df1, key1, style=true)
            if meta_style1 === :note
                good_key = true
                for i in 2:length(dfs)
                    dfi = dfs[i]
                    if key1 in metadatakeys(dfi)
                        meta_vali, meta_stylei = metadata(dfi, key1, style=true)
                        if !(meta_stylei === :note && isequal(meta_val1, meta_vali))
                            good_key = false
                            break
                        end
                    else
                        good_key = false
                        break
                    end
                end
                good_key && metadata!(res, key1, meta_val1, style=:note)
            end
        end
    end
    return nothing
end

# this is a function used to keep in dst only table-level :note-style metadata
# matching between dst and src all other table-level metadata is dropped
# key-value metadata pair is matching if it has :note style and is present
# both in dst and src
function _keep_matching_table_note_metadata!(dst::DataFrame, src::AbstractDataFrame)
    _drop_table_nonnote_metadata!(dst)
    src_keys = metadatakeys(src)

    # here we know it is only :note-style metadata
    for key in metadatakeys(dst)
        if key in src_keys
            src_val, src_style = metadata(src, key, style=true)
            if src_style == :note
                isequal(metadata(dst, key), src_val) || deletemetadata!(dst, key)
            else
                deletemetadata!(dst, key)
            end
        else
            deletemetadata!(dst, key)
        end
    end
    return nothing
end

##
## Join / merge
##
## Implements methods for join functions defined in DataAPI.jl
##

# Like similar, but returns a array that can have missings and is initialized with missings
similar_missing(dv::AbstractArray{T}, dims::Union{Int, Tuple{Vararg{Int}}}) where {T} =
    fill!(similar(dv, Union{T, Missing}, dims), missing)

similar_outer(leftcol::AbstractVector, rightcol::AbstractVector, n::Int) =
    Tables.allocatecolumn(promote_type(eltype(leftcol), eltype(rightcol)), n)

const OnType = Union{SymbolOrString, NTuple{2, Symbol}, Pair{Symbol, Symbol},
                     Pair{<:AbstractString, <:AbstractString}}

# helper structure for DataFrames joining
struct DataFrameJoiner
    dfl::AbstractDataFrame
    dfr::AbstractDataFrame
    dfl_on::AbstractDataFrame
    dfr_on::AbstractDataFrame
    left_on::Vector{Symbol}
    right_on::Vector{Symbol}

    function DataFrameJoiner(dfl::AbstractDataFrame, dfr::AbstractDataFrame,
                             on::Union{<:OnType, AbstractVector},
                             matchmissing::Symbol,
                             kind::Symbol)
        on_cols = isa(on, AbstractVector) ? on : [on]
        left_on = Symbol[]
        right_on = Symbol[]
        for v in on_cols
            if v isa SymbolOrString
                push!(left_on, Symbol(v))
                push!(right_on, Symbol(v))
            elseif v isa Union{Pair{Symbol, Symbol},
                               Pair{<:AbstractString, <:AbstractString}}
                push!(left_on, Symbol(first(v)))
                push!(right_on, Symbol(last(v)))
            elseif v isa NTuple{2, Symbol}
                # an explicit error is thrown as Tuple{Symbol, Symbol} was supported in the past
                throw(ArgumentError("Using a `Tuple{Symbol, Symbol}` or a vector containing " *
                                    "such tuples as a value of `on` keyword argument is " *
                                    "not supported: use `Pair{Symbol, Symbol}` instead."))
            else
                throw(ArgumentError("All elements of `on` argument to `join` must be " *
                                    "Symbol or Pair{Symbol, Symbol}."))
            end
        end

        for col in left_on
            if !hasproperty(dfl, col)
                throw(ArgumentError("column :$col not found in the left data frame"))
            end
        end
        for col in right_on
            if !hasproperty(dfr, col)
                throw(ArgumentError("column :$col not found in the right data frame"))
            end
        end

        if matchmissing === :notequal
            if kind in (:left, :semi, :anti)
                dfr = dropmissing(dfr, right_on, view=true)
            elseif kind === :right
                dfl = dropmissing(dfl, left_on, view=true)
            elseif kind === :inner
                # it possible to drop only left or right df
                # to gain some performance but needs more testing, see #2724
                dfl = dropmissing(dfl, left_on, view=true)
                dfr = dropmissing(dfr, right_on, view=true)
            elseif kind === :outer
                throw(ArgumentError("matchmissing == :notequal for `outerjoin` is not allowed"))
            else
                throw(ArgumentError("matchmissing == :notequal not implemented for kind == :$kind"))
            end
        end
        dfl_on = select(dfl, left_on, copycols=false)
        dfr_on = select(dfr, right_on, copycols=false)
        if matchmissing === :error
            for (df_i, df) in enumerate((dfl_on, dfr_on)),
                (col_name, col) in pairs(eachcol(df))
                if any(ismissing, col)
                    throw(ArgumentError("Missing values in key columns are not allowed " *
                                        "when matchmissing == :error. " *
                                        "`missing` found in column :$col_name in " *
                                        (df_i == 1 ? "left" : "right") * " data frame."))
                end
            end
        elseif !(matchmissing in (:equal, :notequal))
            throw(ArgumentError("matchmissing allows only :error, :equal, or :notequal"))
        end
        for (df_i, df) in enumerate((dfl_on, dfr_on)),
            (col_name, col) in pairs(eachcol(df))
            if any(x -> (x isa Union{Complex, Real}) &&
                        (isnan(x) || isequal(real(x), -0.0) || isequal(imag(x), -0.0)), col)
                throw(ArgumentError("Currently for numeric values `NaN` and `-0.0` " *
                                    "in their real or imaginary components are not " *
                                    "allowed. " *
                                    "Such value was found in column :$col_name in " *
                                    (df_i == 1 ? "left" : "right") * " data frame. " *
                                    "Use CategoricalArrays.jl to wrap " *
                                    "these values in a CategoricalVector to perform " *
                                    "the requested join."))
            end
        end

        new(dfl, dfr, dfl_on, dfr_on, left_on, right_on)
    end
end

_rename_cols(old_names::AbstractVector{Symbol},
             renamecols::Union{Function, Symbol, AbstractString},
             exclude::AbstractVector{Symbol} = Symbol[]) =
    Symbol[n in exclude ? n :
           (renamecols isa Function ? Symbol(renamecols(string(n))) : Symbol(n, renamecols))
           for n in old_names]

function _propagate_join_metadata!(joiner::DataFrameJoiner, dfr_noon::AbstractDataFrame,
                                   res::DataFrame, kind::Symbol)
    @assert kind == :left || kind == :right || kind == :outer || kind == :inner

    # The steps taken in this function are (all applies only to :note-style metadata):
    # We initially copy metadata from left table as left table is always used
    # to populate starting columns of a data frame
    #
    # We copy non-key column-level metadata from right table.
    # For table-level metadata and column-level metadata for key columns
    # processing depends on the type of join:
    # 1. inner and outer joins treat both tables as equivalent so:
    #    a. for key columns we intersect column metadata from left table with
    #       column metadata from right table
    #    b. we merge table-level metadata
    # 2. right join treats right table as main so:
    #    a. for key columns we copy column metadata from right table to left table
    #       (dropping any previously present metadata).
    #    b. we copy right table table-level metadata
    # 3. left join treats left table as main so:
    #    a. column-level metadata does not require changing
    #    b. we copy left table table-level metadata

    for i in 1:ncol(joiner.dfl)
        _copy_col_note_metadata!(res, i, joiner.dfl, i)
    end

    if kind == :outer || kind == :inner
        for i in eachindex(joiner.left_on, joiner.right_on)
            l = joiner.left_on[i]
            l_idx = columnindex(joiner.dfl, l)
            r = joiner.right_on[i]
            rkeys = colmetadatakeys(joiner.dfr, r)
            if isempty(rkeys)
                emptycolmetadata!(res, l_idx)
            else
                for lkey in colmetadatakeys(res, l_idx)
                    if lkey in rkeys
                        rval, rstyle = colmetadata(joiner.dfr, r, lkey, style=true)
                        if !(rstyle === :note && isequal(rval, colmetadata(res, l_idx, lkey)))
                            deletecolmetadata!(res, l_idx, lkey)
                        end
                    else
                        deletecolmetadata!(res, l_idx, lkey)
                    end
                end
            end
        end
    elseif kind == :right
        for i in eachindex(joiner.left_on, joiner.right_on)
            l = joiner.left_on[i]
            l_idx = columnindex(joiner.dfl, l)
            r = joiner.right_on[i]
            _copy_col_note_metadata!(res, l_idx, joiner.dfr, r)
        end
    end

    for i in 1:ncol(dfr_noon)
        _copy_col_note_metadata!(res, ncol(joiner.dfl) + i, dfr_noon, i)
    end

    if kind == :outer || kind == :inner
        _merge_matching_table_note_metadata!(res, (joiner.dfl, joiner.dfr))
    elseif kind == :right
        _copy_table_note_metadata!(res, joiner.dfr)
    else # :left
        _copy_table_note_metadata!(res, joiner.dfl)
    end

    return nothing
end

# return a permutation vector that puts `input` into sorted order
# using counting sort algorithm
function _count_sortperm(input::Vector{Int})
    isempty(input) && return UInt32[]
    vmin, vmax = extrema(input)
    delta = vmin - 1
    Tc = vmax - delta < typemax(UInt32) ? UInt32 : Int
    Tp = length(input) < typemax(UInt32) ? UInt32 : Int
    return _count_sortperm!(input, zeros(Tc, vmax - delta + 1),
                            Vector{Tp}(undef, length(input)), delta)
end

# put into `output` a permutation that puts `input` into sorted order;
# changes `count` vector.
#
# `delta` is by how much integers in `input` need to be shifted so that
# smallest of them has index 1
#
# After the first loop `count` vector holds in location `i-delta` the number of
# times an integer `i` is present in `input`.
# After the second loop a cumulative sum of these values is stored.
# Third loop updates `count` to determine the locations where data should go.
# It is assumed that initially `count` vector holds only zeros.
# Length of `count` is by 2 greater than the difference between maximal and
# minimal element of `input` (i.e. number of unique values plus 1)
function _count_sortperm!(input::Vector{Int}, count::Vector,
                          output::Vector, delta::Int)
    @assert firstindex(input) == 1
    # consider adding @inbounds to these loops in the future after the code
    # has been used enough in production
    for j in input
        count[j - delta] += 1
    end
    prev = count[1]
    for i in 2:length(count)
        prev = (count[i] += prev)
    end
    for i in length(input):-1:1
        j = input[i] - delta
        v = (count[j] -= 1)
        output[v + 1] = i
    end
    return output
end

function compose_inner_table(joiner::DataFrameJoiner,
                             makeunique::Bool,
                             left_rename::Union{Function, AbstractString, Symbol},
                             right_rename::Union{Function, AbstractString, Symbol},
                             order::Symbol)
    left_ixs, right_ixs = find_inner_rows(joiner)
    @assert left_ixs isa Vector{Int}
    @assert right_ixs isa Vector{Int}
    @assert length(left_ixs) == length(right_ixs)

    if order == :left && !issorted(left_ixs)
        csp_l = _count_sortperm(left_ixs)
        left_ixs = left_ixs[csp_l]
        right_ixs = right_ixs[csp_l]
    end

    if order == :right && !issorted(right_ixs)
        csp_r = _count_sortperm(right_ixs)
        left_ixs = left_ixs[csp_r]
        right_ixs = right_ixs[csp_r]
    end

    if Threads.nthreads() > 1 && length(left_ixs) >= 100_000
        dfl_task = @spawn joiner.dfl[left_ixs, :]
        dfr_noon_task = @spawn joiner.dfr[right_ixs, Not(joiner.right_on)]
        dfl = fetch(dfl_task)
        dfr_noon = fetch(dfr_noon_task)
    else
        dfl = joiner.dfl[left_ixs, :]
        dfr_noon = joiner.dfr[right_ixs, Not(joiner.right_on)]
    end

    ncleft = ncol(dfl)
    cols = Vector{AbstractVector}(undef, ncleft + ncol(dfr_noon))

    for (i, col) in enumerate(eachcol(dfl))
        cols[i] = col
    end
    for (i, col) in enumerate(eachcol(dfr_noon))
        cols[i+ncleft] = col
    end

    new_names = vcat(_rename_cols(_names(joiner.dfl), left_rename, joiner.left_on),
                     _rename_cols(_names(dfr_noon), right_rename))
    res = DataFrame(cols, new_names, makeunique=makeunique, copycols=false)

    _propagate_join_metadata!(joiner, dfr_noon, res, :inner)
    return res
end

function find_missing_idxs(present::Vector{Int}, target_len::Int)
    not_seen = trues(target_len)
    @inbounds for v in present
        not_seen[v] = false
    end
    return _findall(not_seen)
end

function compose_joined_table(joiner::DataFrameJoiner, kind::Symbol, makeunique::Bool,
                              left_rename::Union{Function, AbstractString, Symbol},
                              right_rename::Union{Function, AbstractString, Symbol},
                              indicator::Union{Nothing, Symbol, AbstractString},
                              order::Symbol)
    @assert kind == :left || kind == :right || kind == :outer
    left_ixs, right_ixs = find_inner_rows(joiner)
    @assert left_ixs isa Vector{Int}
    @assert right_ixs isa Vector{Int}
    @assert length(left_ixs) == length(right_ixs)

    if kind == :left || kind == :outer
        leftonly_ixs = find_missing_idxs(left_ixs, nrow(joiner.dfl))
    else
        leftonly_ixs = 1:0
    end

    if kind == :right || kind == :outer
        rightonly_ixs = find_missing_idxs(right_ixs, nrow(joiner.dfr))
    else
        rightonly_ixs = 1:0
    end
    return _compose_joined_table(joiner, kind, makeunique, left_rename, right_rename,
                                 indicator, left_ixs, right_ixs,
                                 leftonly_ixs, rightonly_ixs, order)
end

function _compose_joined_table(joiner::DataFrameJoiner, kind::Symbol, makeunique::Bool,
                               left_rename::Union{Function, AbstractString, Symbol},
                               right_rename::Union{Function, AbstractString, Symbol},
                               indicator::Union{Nothing, Symbol, AbstractString},
                               left_ixs::AbstractVector, right_ixs::AbstractVector,
                               leftonly_ixs::AbstractVector,
                               rightonly_ixs::AbstractVector,
                               order::Symbol)
    lil = length(left_ixs)
    ril = length(right_ixs)
    loil = length(leftonly_ixs)
    roil = length(rightonly_ixs)

    @assert lil == ril

    dfl_noon = select(joiner.dfl, Not(joiner.left_on), copycols=false)
    dfr_noon = select(joiner.dfr, Not(joiner.right_on), copycols=false)

    target_nrow = lil + loil + roil

    _similar_left = kind == :left ? similar : similar_missing
    _similar_right = kind == :right ? similar : similar_missing

    if isnothing(indicator)
        src_indicator = nothing
    else
        src_indicator = Vector{UInt32}(undef, target_nrow)
        src_indicator[1:lil] .= 3
        src_indicator[lil + 1:lil + loil] .= 1
        src_indicator[lil + loil + 1:target_nrow] .= 2
    end

    cols = Vector{AbstractVector}(undef, ncol(joiner.dfl) + ncol(dfr_noon))

    col_idx = 1

    left_idxs = [columnindex(joiner.dfl, n) for n in joiner.left_on]
    append!(left_idxs, setdiff(1:ncol(joiner.dfl), left_idxs))

    if kind == :left
        @assert loil + lil == target_nrow
        for col in eachcol(joiner.dfl_on)
            cols_i = left_idxs[col_idx]
            cols[cols_i] = similar(col, target_nrow)
            copyto!(cols[cols_i], view(col, left_ixs))
            copyto!(cols[cols_i], lil + 1, view(col, leftonly_ixs), 1, loil)
            col_idx += 1
        end
    elseif kind == :right
        @assert roil + ril == target_nrow
        for col in eachcol(joiner.dfr_on)
            cols_i = left_idxs[col_idx]
            cols[cols_i] = similar(col, target_nrow)
            copyto!(cols[cols_i], view(col, right_ixs))
            copyto!(cols[cols_i], lil + 1, view(col, rightonly_ixs), 1, roil)
            col_idx += 1
        end
    else
        @assert kind == :outer
        @assert loil + roil + ril == target_nrow
        for (lcol, rcol) in zip(eachcol(joiner.dfl_on), eachcol(joiner.dfr_on))
            cols_i = left_idxs[col_idx]
            cols[cols_i] = similar_outer(lcol, rcol, target_nrow)
            copyto!(cols[cols_i], view(lcol, left_ixs))
            copyto!(cols[cols_i], lil + 1, view(lcol, leftonly_ixs), 1, loil)
            copyto!(cols[cols_i], lil + loil + 1, view(rcol, rightonly_ixs), 1, roil)
            col_idx += 1
        end
    end

    @assert col_idx == ncol(joiner.dfl_on) + 1

    if Threads.nthreads() > 1 && target_nrow >= 100_000 && length(cols) > col_idx
        @sync begin
            for col in eachcol(dfl_noon)
                cols_i = left_idxs[col_idx]
                @spawn _noon_compose_helper!(cols, _similar_left, cols_i,
                                             col, target_nrow, left_ixs, lil + 1,
                                             leftonly_ixs, loil)
                col_idx += 1
            end
            @assert col_idx == ncol(joiner.dfl) + 1
            for col in eachcol(dfr_noon)
                cols_i = col_idx
                @spawn _noon_compose_helper!(cols, _similar_right, cols_i, col, target_nrow,
                                             right_ixs, lil + loil + 1, rightonly_ixs, roil)
                col_idx += 1
            end
        end
    else
        for col in eachcol(dfl_noon)
            _noon_compose_helper!(cols, _similar_left, left_idxs[col_idx],
                                  col, target_nrow, left_ixs, lil + 1, leftonly_ixs, loil)
            col_idx += 1
        end
        @assert col_idx == ncol(joiner.dfl) + 1
        for col in eachcol(dfr_noon)
            _noon_compose_helper!(cols, _similar_right, col_idx, col, target_nrow,
                                  right_ixs, lil + loil + 1, rightonly_ixs, roil)
            col_idx += 1
        end
    end

    new_order = nothing
    if order == :left && !(issorted(left_ixs) && isempty(leftonly_ixs))
        left_cols_idxs = _sort_compose_helper(nrow(joiner.dfl) + 1,
                                              1:nrow(joiner.dfl), target_nrow,
                                              left_ixs, lil + 1, leftonly_ixs, loil)
        new_order = _count_sortperm(left_cols_idxs)
    end
    if order == :right && !(issorted(right_ixs) && isempty(rightonly_ixs))
        right_cols_idxs = _sort_compose_helper(nrow(joiner.dfr) + 1,
                                               1:nrow(joiner.dfr), target_nrow,
                                               right_ixs, lil + loil + 1, rightonly_ixs, roil)
        new_order = _count_sortperm(right_cols_idxs)
    end

    @assert col_idx == length(cols) + 1

    new_names = vcat(_rename_cols(_names(joiner.dfl), left_rename, joiner.left_on),
                     _rename_cols(_names(dfr_noon), right_rename))
    res = DataFrame(cols, new_names, makeunique=makeunique, copycols=false)

    if new_order !== nothing
        isnothing(src_indicator) || permute!(src_indicator, new_order)
        permute!(res, new_order)
    end

    _propagate_join_metadata!(joiner, dfr_noon, res, kind)

    return res, src_indicator
end

function _noon_compose_helper!(cols::Vector{AbstractVector}, # target container to populate
                               similar_col::Function, # function to use to materialize new column
                               cols_i::Integer, # index in cols to populate
                               col::AbstractVector, # source column
                               target_nrow::Integer, # target number of rows in new column
                               side_ixs::AbstractVector, # indices in col that were matched
                               offset::Integer, # offset to put non-matching indices
                               sideonly_ixs::AbstractVector, # indices in col that were not matched
                               tocopy::Integer) # number on non-matched rows to copy
    @assert tocopy == length(sideonly_ixs)
    cols[cols_i] = similar_col(col, target_nrow)
    copyto!(cols[cols_i], view(col, side_ixs))
    copyto!(cols[cols_i], offset, view(col, sideonly_ixs), 1, tocopy)
end

function _sort_compose_helper(fillval::Int, # value to use to fill unused indices
                              col::AbstractVector, # source column
                              target_nrow::Integer, # target number of rows in new column
                              side_ixs::AbstractVector, # indices in col that were matched
                              offset::Integer, # offset to put non-matching indices
                              sideonly_ixs::AbstractVector, # indices in col that were not matched
                              tocopy::Integer) # number on non-matched rows to copy
    @assert tocopy == length(sideonly_ixs)
    outcol = Vector{Int}(undef, target_nrow)
    copyto!(outcol, view(col, side_ixs))
    fill!(view(outcol, length(side_ixs)+1:offset-1), fillval)
    copyto!(outcol, offset, view(col, sideonly_ixs), 1, tocopy)
    fill!(view(outcol, offset+tocopy:target_nrow), fillval)
    return outcol
end

function _join(df1::AbstractDataFrame, df2::AbstractDataFrame;
               on::Union{<:OnType, AbstractVector}, kind::Symbol, makeunique::Bool,
               indicator::Union{Nothing, Symbol, AbstractString},
               validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}},
               left_rename::Union{Function, AbstractString, Symbol},
               right_rename::Union{Function, AbstractString, Symbol},
               matchmissing::Symbol, order::Symbol)
    _check_consistency(df1)
    _check_consistency(df2)

    if !(order in (:undefined, :left, :right))
        throw(ArgumentError("order argument must be :undefined, :left, or :right."))
    end

    if on == []
        throw(ArgumentError("Missing join argument 'on'."))
    end

    joiner = DataFrameJoiner(df1, df2, on, matchmissing, kind)

    # Check merge key validity
    if validate[1]
        non_unique_left = nonunique(joiner.dfl, joiner.left_on)
        if any(non_unique_left)
            left_invalid = true
            non_unique_left_df = unique(joiner.dfl[non_unique_left, joiner.left_on])
            nrow_nul_df = nrow(non_unique_left_df)
            @assert nrow_nul_df > 0
            if nrow_nul_df == 1
                left_invalid_msg = "df1 contains 1 duplicate key: " *
                                   "$(NamedTuple(non_unique_left_df[1, :])). "
            elseif nrow_nul_df == 2
                left_invalid_msg = "df1 contains 2 duplicate keys: " *
                                   "$(NamedTuple(non_unique_left_df[1, :])) and " *
                                   "$(NamedTuple(non_unique_left_df[2, :])). "
            else
                left_invalid_msg = "df1 contains $(nrow_nul_df) duplicate keys: " *
                                   "$(NamedTuple(non_unique_left_df[1, :])), ..., " *
                                   "$(NamedTuple(non_unique_left_df[end, :])). "
            end

        else
            left_invalid = false
            left_invalid_msg = ""
        end
    else
        left_invalid = false
        left_invalid_msg = ""
    end

    if validate[2]
        non_unique_right = nonunique(joiner.dfr, joiner.right_on)
        if any(non_unique_right)
            right_invalid = true
            non_unique_right_df = unique(joiner.dfr[non_unique_right, joiner.right_on])
            nrow_nur_df = nrow(non_unique_right_df)
            @assert nrow_nur_df > 0
            if nrow_nur_df == 1
                right_invalid_msg = "df2 contains 1 duplicate key: " *
                                    "$(NamedTuple(non_unique_right_df[1, :]))."
            elseif nrow_nur_df == 2
                right_invalid_msg = "df2 contains 2 duplicate keys: " *
                                    "$(NamedTuple(non_unique_right_df[1, :])) and " *
                                    "$(NamedTuple(non_unique_right_df[2, :]))."
            else
                right_invalid_msg = "df2 contains $(nrow_nur_df) duplicate keys: " *
                                    "$(NamedTuple(non_unique_right_df[1, :])), ..., " *
                                    "$(NamedTuple(non_unique_right_df[end, :]))."
            end

        else
            right_invalid = false
            right_invalid_msg = ""
        end
    else
        right_invalid = false
        right_invalid_msg = ""
    end

    if left_invalid && right_invalid
        first_error_df1 = findfirst(nonunique(joiner.dfl, joiner.left_on))
        first_error_df2 = findfirst(nonunique(joiner.dfr, joiner.right_on))
        throw(ArgumentError("Merge key(s) are not unique in both df1 and df2. " *
                            left_invalid_msg * right_invalid_msg))
    elseif left_invalid
        first_error = findfirst(nonunique(joiner.dfl, joiner.left_on))
        throw(ArgumentError("Merge key(s) in df1 are not unique. " *
                            left_invalid_msg))
    elseif right_invalid
        first_error = findfirst(nonunique(joiner.dfr, joiner.right_on))
        throw(ArgumentError("Merge key(s) in df2 are not unique. " *
                            right_invalid_msg))
    end

    src_indicator = nothing
    if kind == :inner
        joined = compose_inner_table(joiner, makeunique, left_rename, right_rename, order)
    elseif kind == :left
        joined, src_indicator =
            compose_joined_table(joiner, kind, makeunique, left_rename, right_rename, indicator, order)
    elseif kind == :right
        joined, src_indicator =
            compose_joined_table(joiner, kind, makeunique, left_rename, right_rename, indicator, order)
    elseif kind == :outer
        joined, src_indicator =
            compose_joined_table(joiner, kind, makeunique, left_rename, right_rename, indicator, order)
    elseif kind == :semi
        joined = joiner.dfl[find_semi_rows(joiner), :]
    elseif kind == :anti
        joined = joiner.dfl[.!find_semi_rows(joiner), :]
    else
        throw(ArgumentError("Unknown kind of join requested: $kind"))
    end

    if indicator !== nothing
        pool = ["left_only", "right_only", "both"]
        invpool = Dict{String, UInt32}("left_only" => 1,
                                       "right_only" => 2,
                                       "both" => 3)
        indicatorcol = PooledArray(PooledArrays.RefArray(src_indicator),
                                   invpool, pool)

        unique_indicator = indicator
        if makeunique
            try_idx = 0
            while hasproperty(joined, unique_indicator)
                try_idx += 1
                unique_indicator = Symbol(indicator, "_", try_idx)
            end
        end

        if hasproperty(joined, unique_indicator)
            throw(ArgumentError("joined data frame already has column " *
                                ":$unique_indicator. Pass makeunique=true to " *
                                "make it unique using a suffix automatically."))
        end
        joined[!, unique_indicator] = indicatorcol
    else
        @assert isnothing(src_indicator)
    end

    return joined
end

"""
    innerjoin(df1, df2; on, makeunique=false, validate=(false, false),
              renamecols=(identity => identity), matchmissing=:error,
              order=:undefined)
    innerjoin(df1, df2, dfs...; on, makeunique=false,
              validate=(false, false), matchmissing=:error,
              order=:undefined)

Perform an inner join of two or more data frame objects and return a `DataFrame`
containing the result. An inner join includes rows with keys that match in all
passed data frames.

In the returned data frame the type of the columns on which the data frames are
joined is determined by the type of these columns in `df1`. This behavior may
change in future releases.

# Arguments
- `df1`, `df2`, `dfs...`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). When joining only two data frames, a `left=>right` pair of names
  can be used instead of a name, for the case where a key has different names
  in `df1` and `df2` (it is allowed to mix names and name pairs in a vector).
  Key values are compared using `isequal`. `on` is a required argument.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `validate` : whether to check that columns passed as the `on` argument
  define unique keys in each input data frame (according to `isequal`).
  Can be a tuple or a pair, with the first element indicating whether to
  run check for `df1` and the second element for `df2`.
  By default no check is performed.
- `renamecols` : a `Pair` specifying how columns of left and right data frames should
  be renamed in the resulting data frame. Each element of the pair can be a
  string or a `Symbol` can be passed in which case it is appended to the original
  column name; alternatively a function can be passed in which case it is applied
  to each column name, which is passed to it as a `String`. Note that `renamecols`
  does not affect `on` columns, whose names are always taken from the left
  data frame and left unchanged.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df1` and `df2`
  `on` columns.
- `order` : if `:undefined` (the default) the order of rows in the result is
   undefined and may change in future releases. If `:left` then the order of
   rows from the left data frame is retained. If `:right` then the order of rows
   from the right data frame is retained.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

If more than two data frames are passed, the join is performed recursively with
left associativity. In this case the `validate` keyword argument is applied
recursively with left associativity.

Metadata: table-level `:note`-style metadata and column-level `:note`-style metadata
for key columns is preserved only for keys which are defined in all passed tables
and have the same value.
Column-level `:note`-style metadata is preserved for all other columns.

See also: [`leftjoin`](@ref), [`rightjoin`](@ref), [`outerjoin`](@ref),
          [`semijoin`](@ref), [`antijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> innerjoin(name, job, on = :ID)
2×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String    String
─────┼─────────────────────────
   1 │     1  John Doe  Lawyer
   2 │     2  Jane Doe  Doctor

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> innerjoin(name, job2, on = :ID => :identifier, renamecols = "_left" => "_right")
2×3 DataFrame
 Row │ ID     Name_left  Job_right
     │ Int64  String     String
─────┼─────────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor

julia> innerjoin(name, job2, on = [:ID => :identifier], renamecols = uppercase => lowercase)
2×3 DataFrame
 Row │ ID     NAME      job
     │ Int64  String    String
─────┼─────────────────────────
   1 │     1  John Doe  Lawyer
   2 │     2  Jane Doe  Doctor
```
"""
function innerjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
                   on::Union{<:OnType, AbstractVector} = Symbol[],
                   makeunique::Bool=false,
                   validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                   renamecols::Pair=identity => identity,
                   matchmissing::Symbol=:error,
                   order::Symbol=:undefined)
    if !all(x -> x isa Union{Function, AbstractString, Symbol}, renamecols)
        throw(ArgumentError("renamecols keyword argument must be a `Pair` " *
                            "containing functions, strings, or `Symbol`s"))
    end
    return _join(df1, df2, on=on, kind=:inner, makeunique=makeunique,
                 indicator=nothing, validate=validate,
                 left_rename=first(renamecols), right_rename=last(renamecols),
                 matchmissing=matchmissing, order=order)
end

function innerjoin(df1::AbstractDataFrame, df2::AbstractDataFrame, dfs::AbstractDataFrame...;
                   on::Union{<:OnType, AbstractVector} = Symbol[],
                   makeunique::Bool=false,
                   validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                   matchmissing::Symbol=:error,
                   order::Symbol=:undefined)
    @assert !isempty(dfs)
    res = innerjoin(df1, df2, on=on, makeunique=makeunique, validate=validate,
                    matchmissing=matchmissing,
                    order=order === :right ? :undefined : order)
    for (i, dfn) in enumerate(dfs)
        res = innerjoin(res, dfn, on=on, makeunique=makeunique, validate=validate,
                        matchmissing=matchmissing,
                        order= order === :right ?
                               (i == length(dfs) ? :right : :undefined) :
                               order)
    end
    return res
end

"""
    leftjoin(df1, df2; on, makeunique=false, source=nothing, validate=(false, false),
             renamecols=(identity => identity), matchmissing=:error, order=:undefined)

Perform a left join of two data frame objects and return a `DataFrame` containing
the result. A left join includes all rows from `df1`.

In the returned data frame the type of the columns on which the data frames are
joined is determined by the type of these columns in `df1`. This behavior may
change in future releases.

# Arguments
- `df1`, `df2`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). A `left=>right` pair of names can be used instead of a name, for
  the case where a key has different names in `df1` and `df2` (it is allowed to
  mix names and name pairs in a vector). Key values are compared using
  `isequal`. `on` is a required argument.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `source` : Default: `nothing`. If a `Symbol` or string, adds indicator
  column with the given name, for whether a row appeared in only `df1` (`"left_only"`)
  or in both (`"both"`). If the name is already in use,
  the column name will be modified if `makeunique=true`.
- `validate` : whether to check that columns passed as the `on` argument
  define unique keys in each input data frame (according to `isequal`).
  Can be a tuple or a pair, with the first element indicating whether to
  run check for `df1` and the second element for `df2`.
  By default no check is performed.
- `renamecols` : a `Pair` specifying how columns of left and right data frames should
  be renamed in the resulting data frame. Each element of the pair can be a
  string or a `Symbol` can be passed in which case it is appended to the original
  column name; alternatively a function can be passed in which case it is applied
  to each column name, which is passed to it as a `String`. Note that `renamecols`
  does not affect `on` columns, whose names are always taken from the left
  data frame and left unchanged.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df2` `on` columns.
- `order` : if `:undefined` (the default) the order of rows in the result is
   undefined and may change in future releases. If `:left` then the order of
   rows from the left data frame is retained. If `:right` then the order of rows
   from the right data frame is retained (non-matching rows are put at the end).

All columns of the returned data frame will support missing values.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

Metadata: table-level and column-level `:note`-style metadata is taken from `df1`
(including key columns), except for columns added to it from `df2`, whose
column-level `:note`-style metadata is taken from `df2`.

See also: [`innerjoin`](@ref), [`rightjoin`](@ref), [`outerjoin`](@ref),
          [`semijoin`](@ref), [`antijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> leftjoin(name, job, on = :ID)
3×3 DataFrame
 Row │ ID     Name       Job
     │ Int64  String     String?
─────┼───────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> leftjoin(name, job2, on = :ID => :identifier, renamecols = "_left" => "_right")
3×3 DataFrame
 Row │ ID     Name_left  Job_right
     │ Int64  String     String?
─────┼─────────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing

julia> leftjoin(name, job2, on = [:ID => :identifier], renamecols = uppercase => lowercase)
3×3 DataFrame
 Row │ ID     NAME       job
     │ Int64  String     String?
─────┼───────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing
```
"""
function leftjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
                  on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
                  source::Union{Nothing, Symbol, AbstractString}=nothing,
                  indicator::Union{Nothing, Symbol, AbstractString}=nothing,
                  validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                  renamecols::Pair=identity => identity, matchmissing::Symbol=:error,
                  order::Symbol=:undefined)
    if !all(x -> x isa Union{Function, AbstractString, Symbol}, renamecols)
        throw(ArgumentError("renamecols keyword argument must be a `Pair` " *
                            "containing functions, strings, or `Symbol`s"))
    end
    if source === nothing
        if indicator !== nothing
            source = indicator
            Base.depwarn("`indicator` keyword argument is deprecated and " *
                         "will be removed in 2.0 release of DataFrames.jl. " *
                         "Use `source` keyword argument instead.", :leftjoin)
        end
    elseif indicator !== nothing
        throw(ArgumentError("`indicator` keyword argument is deprecated. " *
                            "It is not allowed to pass both `indicator` and `source` " *
                            "keyword arguments at the same time."))
    end
    return _join(df1, df2, on=on, kind=:left, makeunique=makeunique,
                 indicator=source, validate=validate,
                 left_rename=first(renamecols), right_rename=last(renamecols),
                 matchmissing=matchmissing, order=order)
end

"""
    rightjoin(df1, df2; on, makeunique=false, source=nothing,
              validate=(false, false), renamecols=(identity => identity),
              matchmissing=:error, order=:undefined)

Perform a right join on two data frame objects and return a `DataFrame` containing
the result. A right join includes all rows from `df2`.

The order of rows in the result is undefined and may change in future releases.

In the returned data frame the type of the columns on which the data frames are
joined is determined by the type of these columns in `df2`. This behavior may
change in future releases.

# Arguments
- `df1`, `df2`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). A `left=>right` pair of names can be used instead of a name, for
  the case where a key has different names in `df1` and `df2` (it is allowed to
  mix names and name pairs in a vector). Key values are compared using
  `isequal`. `on` is a required argument.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `source` : Default: `nothing`. If a `Symbol` or string, adds indicator
  column with the given name for whether a row appeared in only `df2` (`"right_only"`)
  or in both (`"both"`). If the name is already in use,
  the column name will be modified if `makeunique=true`.
- `validate` : whether to check that columns passed as the `on` argument
  define unique keys in each input data frame (according to `isequal`).
  Can be a tuple or a pair, with the first element indicating whether to
  run check for `df1` and the second element for `df2`.
  By default no check is performed.
- `renamecols` : a `Pair` specifying how columns of left and right data frames should
  be renamed in the resulting data frame. Each element of the pair can be a
  string or a `Symbol` can be passed in which case it is appended to the original
  column name; alternatively a function can be passed in which case it is applied
  to each column name, which is passed to it as a `String`. Note that `renamecols`
  does not affect `on` columns, whose names are always taken from the left
  data frame and left unchanged.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df1` `on` columns.
- `order` : if `:undefined` (the default) the order of rows in the result is
   undefined and may change in future releases. If `:left` then the order of
   rows from the left data frame is retained (non-matching rows are put at the end).
   If `:right` then the order of rows from the right data frame is retained.

All columns of the returned data frame will support missing values.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

Metadata: table-level and column-level `:note`-style metadata is taken from `df2`
(including key columns), except for columns added to it from `df1`, whose
column-level `:note`-style metadata is taken from `df1`.

See also: [`innerjoin`](@ref), [`leftjoin`](@ref), [`outerjoin`](@ref),
          [`semijoin`](@ref), [`antijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> rightjoin(name, job, on = :ID)
3×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String?   String
─────┼─────────────────────────
   1 │     1  John Doe  Lawyer
   2 │     2  Jane Doe  Doctor
   3 │     4  missing   Farmer

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> rightjoin(name, job2, on = :ID => :identifier, renamecols = "_left" => "_right")
3×3 DataFrame
 Row │ ID     Name_left  Job_right
     │ Int64  String?    String
─────┼─────────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     4  missing    Farmer

julia> rightjoin(name, job2, on = [:ID => :identifier], renamecols = uppercase => lowercase)
3×3 DataFrame
 Row │ ID     NAME      job
     │ Int64  String?   String
─────┼─────────────────────────
   1 │     1  John Doe  Lawyer
   2 │     2  Jane Doe  Doctor
   3 │     4  missing   Farmer
```
"""
function rightjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
                   on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
                   source::Union{Nothing, Symbol, AbstractString}=nothing,
                   indicator::Union{Nothing, Symbol, AbstractString}=nothing,
                   validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                   renamecols::Pair=identity => identity, matchmissing::Symbol=:error,
                   order::Symbol=:undefined)
    if !all(x -> x isa Union{Function, AbstractString, Symbol}, renamecols)
        throw(ArgumentError("renamecols keyword argument must be a `Pair` " *
                            "containing functions, strings, or `Symbol`s"))
    end
    if source === nothing
        if indicator !== nothing
            source = indicator
            Base.depwarn("`indicator` keyword argument is deprecated and " *
                         "will be removed in 2.0 release of DataFrames.jl. " *
                         "Use `source` keyword argument instead.", :rightjoin)
        end
    elseif indicator !== nothing
        throw(ArgumentError("`indicator` keyword argument is deprecated. " *
                            "It is not allowed to pass both `indicator` and `source` " *
                            "keyword arguments at the same time."))
    end
    return _join(df1, df2, on=on, kind=:right, makeunique=makeunique,
                 indicator=source, validate=validate,
                 left_rename=first(renamecols), right_rename=last(renamecols),
                 matchmissing=matchmissing, order=order)
end

"""
    outerjoin(df1, df2; on, makeunique=false, source=nothing, validate=(false, false),
              renamecols=(identity => identity), matchmissing=:error, order=:undefined)
    outerjoin(df1, df2, dfs...; on, makeunique = false,
              validate = (false, false), matchmissing=:error, order=:undefined)

Perform an outer join of two or more data frame objects and return a `DataFrame`
containing the result. An outer join includes rows with keys that appear in any
of the passed data frames.

The order of rows in the result is undefined and may change in future releases.

In the returned data frame the type of the columns on which the data frames are
joined is determined by the element type of these columns both `df1` and `df2`.
This behavior may change in future releases.

# Arguments
- `df1`, `df2`, `dfs...` : the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). When joining only two data frames, a `left=>right` pair of names
  can be used instead of a name, for the case where a key has different names
  in `df1` and `df2` (it is allowed to mix names and name pairs in a vector).
  Key values are compared using `isequal`. `on` is a required argument.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `source` : Default: `nothing`. If a `Symbol` or string, adds indicator
  column with the given name for whether a row appeared in only `df1` (`"left_only"`),
  only `df2` (`"right_only"`) or in both (`"both"`). If the name is already in use,
  the column name will be modified if `makeunique=true`.
  This argument is only supported when joining exactly two data frames.
- `validate` : whether to check that columns passed as the `on` argument
  define unique keys in each input data frame (according to `isequal`).
  Can be a tuple or a pair, with the first element indicating whether to
  run check for `df1` and the second element for `df2`.
  By default no check is performed.
- `renamecols` : a `Pair` specifying how columns of left and right data frames should
  be renamed in the resulting data frame. Each element of the pair can be a
  string or a `Symbol` can be passed in which case it is appended to the original
  column name; alternatively a function can be passed in which case it is applied
  to each column name, which is passed to it as a `String`. Note that `renamecols`
  does not affect `on` columns, whose names are always taken from the left
  data frame and left unchanged.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched.
- `order` : if `:undefined` (the default) the order of rows in the result is
   undefined and may change in future releases. If `:left` then the order of
   rows from the left data frame is retained (non-matching rows are put at the end).
   If `:right` then the order of rows from the right data frame is retained
   (non-matching rows are put at the end).

All columns of the returned data frame will support missing values.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

If more than two data frames are passed, the join is performed
recursively with left associativity.
In this case the `indicator` keyword argument is not supported
and `validate` keyword argument is applied recursively with left associativity.

Metadata: table-level `:note`-style metadata and column-level `:note`-style metadata
for key columns is preserved only for keys which are defined in all passed tables
and have the same value.
Column-level `:note`-style metadata is preserved for all other columns.

See also: [`innerjoin`](@ref), [`leftjoin`](@ref), [`rightjoin`](@ref),
          [`semijoin`](@ref), [`antijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> outerjoin(name, job, on = :ID)
4×3 DataFrame
 Row │ ID     Name       Job
     │ Int64  String?    String?
─────┼───────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing
   4 │     4  missing    Farmer

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> outerjoin(name, job2, on = :ID => :identifier, renamecols = "_left" => "_right")
4×3 DataFrame
 Row │ ID     Name_left  Job_right
     │ Int64  String?    String?
─────┼─────────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing
   4 │     4  missing    Farmer

julia> outerjoin(name, job2, on = [:ID => :identifier], renamecols = uppercase => lowercase)
4×3 DataFrame
 Row │ ID     NAME       job
     │ Int64  String?    String?
─────┼───────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing
   4 │     4  missing    Farmer
```
"""
function outerjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
                   on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
                   source::Union{Nothing, Symbol, AbstractString}=nothing,
                   indicator::Union{Nothing, Symbol, AbstractString}=nothing,
                   validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                   renamecols::Pair=identity => identity, matchmissing::Symbol=:error,
                   order::Symbol=:undefined)
    if !all(x -> x isa Union{Function, AbstractString, Symbol}, renamecols)
        throw(ArgumentError("renamecols keyword argument must be a `Pair` " *
                            "containing functions, strings, or `Symbol`s"))
    end
    if source === nothing
        if indicator !== nothing
            source = indicator
            Base.depwarn("`indicator` keyword argument is deprecated and " *
                         "will be removed in 2.0 release of DataFrames.jl. " *
                         "Use `source` keyword argument instead.", :outerjoin)
        end
    elseif indicator !== nothing
        throw(ArgumentError("`indicator` keyword argument is deprecated. " *
                            "It is not allowed to pass both `indicator` and `source` " *
                            "keyword arguments at the same time."))
    end
    return _join(df1, df2, on=on, kind=:outer, makeunique=makeunique,
                 indicator=source, validate=validate,
                 left_rename=first(renamecols), right_rename=last(renamecols),
                 matchmissing=matchmissing, order=order)
end

function outerjoin(df1::AbstractDataFrame, df2::AbstractDataFrame, dfs::AbstractDataFrame...;
                   on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
                   validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
                   matchmissing::Symbol=:error, order::Symbol=:undefined)
    res = outerjoin(df1, df2, on=on, makeunique=makeunique, validate=validate,
                        matchmissing=matchmissing, order=order)
    for dfn in dfs
        res = outerjoin(res, dfn, on=on, makeunique=makeunique, validate=validate,
                        matchmissing=matchmissing, order=order)
    end
    return res
end

"""
    semijoin(df1, df2; on, makeunique=false, validate=(false, false), matchmissing=:error)

Perform a semi join of two data frame objects and return a `DataFrame`
containing the result. A semi join returns the subset of rows of `df1` that
match with the keys in `df2`.

The order of rows in the result is kept from `df1`.

# Arguments
- `df1`, `df2`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). A `left=>right` pair of names can be used instead of a name, for
  the case where a key has different names in `df1` and `df2` (it is allowed to
  mix names and name pairs in a vector). Key values are compared using
  `isequal`. `on` is a required argument.
- `makeunique` : ignored as no columns are added to `df1` columns
  (it is provided for consistency with other functions).
- `indicator` : Default: `nothing`. If a `Symbol` or string, adds categorical indicator
   column with the given name for whether a row appeared in only `df1` (`"left_only"`),
   only `df2` (`"right_only"`) or in both (`"both"`). If the name is already in use,
   the column name will be modified if `makeunique=true`.
- `validate` : whether to check that columns passed as the `on` argument
   define unique keys in each input data frame (according to `isequal`).
   Can be a tuple or a pair, with the first element indicating whether to
   run check for `df1` and the second element for `df2`.
   By default no check is performed.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df2` `on` columns.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

Metadata: table-level and column-level `:note`-style metadata are taken from `df1`.

See also: [`innerjoin`](@ref), [`leftjoin`](@ref), [`rightjoin`](@ref),
          [`outerjoin`](@ref), [`antijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> semijoin(name, job, on = :ID)
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> semijoin(name, job2, on = :ID => :identifier)
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe

julia> semijoin(name, job2, on = [:ID => :identifier])
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
```
"""
semijoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
         on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
         validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
         matchmissing::Symbol=:error) =
    _join(df1, df2, on=on, kind=:semi, makeunique=makeunique,
          indicator=nothing, validate=validate,
          left_rename=identity, right_rename=identity, matchmissing=matchmissing,
          order=:left)

"""
    antijoin(df1, df2; on, makeunique=false, validate=(false, false), matchmissing=:error)

Perform an anti join of two data frame objects and return a `DataFrame`
containing the result. An anti join returns the subset of rows of `df1` that do
not match with the keys in `df2`.

The order of rows in the result is kept from `df1`.

# Arguments
- `df1`, `df2`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). A `left=>right` pair of names can be used instead of a name, for
  the case where a key has different names in `df1` and `df2` (it is allowed to
  mix names and name pairs in a vector). Key values are compared using
  `isequal`. `on` is a required argument.
- `makeunique` : ignored as no columns are added to `df1` columns
  (it is provided for consistency with other functions).
- `validate` : whether to check that columns passed as the `on` argument
   define unique keys in each input data frame (according to `isequal`).
   Can be a tuple or a pair, with the first element indicating whether to
   run check for `df1` and the second element for `df2`.
   By default no check is performed.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df2` `on` columns.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

When merging `on` categorical columns that differ in the ordering of their
levels, the ordering of the left data frame takes precedence over the ordering
of the right data frame.

Metadata: table-level and column-level `:note`-style metadata are taken from `df1`.

See also: [`innerjoin`](@ref), [`leftjoin`](@ref), [`rightjoin`](@ref),
          [`outerjoin`](@ref), [`semijoin`](@ref), [`crossjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> antijoin(name, job, on = :ID)
1×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     3  Joe Blogs

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> antijoin(name, job2, on = :ID => :identifier)
1×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     3  Joe Blogs

julia> antijoin(name, job2, on = [:ID => :identifier])
1×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     3  Joe Blogs
```
"""
antijoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
         on::Union{<:OnType, AbstractVector} = Symbol[], makeunique::Bool=false,
         validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false),
         matchmissing::Symbol=:error) =
    _join(df1, df2, on=on, kind=:anti, makeunique=makeunique,
          indicator=nothing, validate=validate,
          left_rename=identity, right_rename=identity,
          matchmissing=matchmissing,
          order=:left)

"""
    crossjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
              makeunique::Bool=false, renamecols=identity => identity)
    crossjoin(df1, df2, dfs...; makeunique = false)

Perform a cross join of two or more data frame objects and return a `DataFrame`
containing the result. A cross join returns the cartesian product of rows from
all passed data frames, where the first passed data frame is assigned to the
dimension that changes the slowest and the last data frame is assigned to the
dimension that changes the fastest.

# Arguments
- `df1`, `df2`, `dfs...` : the `AbstractDataFrames` to be joined

# Keyword Arguments
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `renamecols` : a `Pair` specifying how columns of left and right data frames should
  be renamed in the resulting data frame. Each element of the pair can be a
  string or a `Symbol` can be passed in which case it is appended to the original
  column name; alternatively a function can be passed in which case it is applied
  to each column name, which is passed to it as a `String`.

If more than two data frames are passed, the join is performed
recursively with left associativity.

Metadata: table-level `:note`-style metadata is preserved only for keys
which are defined in all passed tables and have the same value.
Column-level `:note`-style metadata is preserved from both tables.

See also: [`innerjoin`](@ref), [`leftjoin`](@ref), [`rightjoin`](@ref),
          [`outerjoin`](@ref), [`semijoin`](@ref), [`antijoin`](@ref).

# Examples
```jldoctest
julia> df1 = DataFrame(X=1:3)
3×1 DataFrame
 Row │ X
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> df2 = DataFrame(Y=["a", "b"])
2×1 DataFrame
 Row │ Y
     │ String
─────┼────────
   1 │ a
   2 │ b

julia> crossjoin(df1, df2)
6×2 DataFrame
 Row │ X      Y
     │ Int64  String
─────┼───────────────
   1 │     1  a
   2 │     1  b
   3 │     2  a
   4 │     2  b
   5 │     3  a
   6 │     3  b
```
"""
function crossjoin(df1::AbstractDataFrame, df2::AbstractDataFrame;
                   makeunique::Bool=false, renamecols::Pair=identity => identity)
    _check_consistency(df1)
    _check_consistency(df2)
    r1, r2 = size(df1, 1), size(df2, 1)

    new_names = vcat(_rename_cols(_names(df1), first(renamecols)),
                     _rename_cols(_names(df2), last(renamecols)))
    cols = Any[[repeat(c, inner=r2) for c in eachcol(df1)];
               [repeat(c, outer=r1) for c in eachcol(df2)]]
    res = DataFrame(cols, new_names, copycols=false, makeunique=makeunique)

    for i in 1:ncol(df1)
        _copy_col_note_metadata!(res, i, df1, i)
    end
    for i in 1:ncol(df2)
        _copy_col_note_metadata!(res, ncol(df1) + i, df2, i)
    end

    _merge_matching_table_note_metadata!(res, (df1, df2))

    return res
end

crossjoin(df1::AbstractDataFrame, df2::AbstractDataFrame, dfs::AbstractDataFrame...;
          makeunique::Bool=false) =
    crossjoin(crossjoin(df1, df2, makeunique=makeunique), dfs..., makeunique=makeunique)

# an explicit error is thrown as join was supported in the past
Base.join(df1::AbstractDataFrame, df2::AbstractDataFrame, dfs::AbstractDataFrame...;
          on::Union{<:OnType, AbstractVector} = Symbol[],
          kind::Symbol = :inner, makeunique::Bool=false,
          indicator::Union{Nothing, Symbol} = nothing,
          validate::Union{Pair{Bool, Bool}, Tuple{Bool, Bool}}=(false, false)) =
    throw(ArgumentError("join function for data frames is not supported. Use innerjoin, " *
                        "leftjoin, rightjoin, outerjoin, semijoin, antijoin, or crossjoin"))

# This type is for testing the escaping of quotes in HTML output. It needs to be
# outside of the module so that Julia 1.0 would not complain about the type
# being defined in local scope.
struct QuoteTestType{T} end

module TestIO

using Test, DataFrames, CategoricalArrays, Dates, Markdown
import Main: QuoteTestType

# Test LaTeX export
@testset "LaTeX export" begin
    df = DataFrame(A=Int64.( 1:4 ),
                   B=["\$10.0", "M&F", "A~B", "\\alpha"],
                   C=["A", "B", "C", "S"],
                   D=[1.0, 2.0, missing, 3.0],
                   E=CategoricalArray(["a", missing, "c", "d"]),
                   F=Vector{String}(undef, 4),
                   G=[ md"[DataFrames.jl](http://juliadata.github.io/DataFrames.jl)", md"###A", md"``\frac{A}{B}``", md"*A*b**A**"]
                  )
    str = """
        \\begin{tabular}{r|ccccccc}
        \t& A & B & C & D & E & F & G\\\\
        \t\\hline
        \t& Int64 & String & String & Float64? & Cat…? & String & MD\\\\
        \t\\hline
        \t1 & 1 & \\\$10.0 & A & 1.0 & a & \\emph{\\#undef} & \\href{http://juliadata.github.io/DataFrames.jl}{DataFrames.jl} \\\\
        \t2 & 2 & M\\&F & B & 2.0 & \\emph{missing} & \\emph{\\#undef} & \\#\\#\\#A \\\\
        \t3 & 3 & A\\textasciitilde{}B & C & \\emph{missing} & c & \\emph{\\#undef} & \$\\frac{A}{B}\$ \\\\
        \t4 & 4 & \\textbackslash{}\\textbackslash{}alpha & S & 3.0 & d & \\emph{\\#undef} & \\emph{A}b\\textbf{A} \\\\
        \\end{tabular}
        """

    @test repr(MIME("text/latex"), df) == str
    @test repr(MIME("text/latex"), eachcol(df)) == str
    @test repr(MIME("text/latex"), eachrow(df)) == str

    @test_throws ArgumentError DataFrames._show(stdout, MIME("text/latex"),
                                                DataFrame(ones(2,2), :auto), rowid=10)
end

@testset "Huge LaTeX export" begin
    df = DataFrame(a=1:1000)
    ioc = IOContext(IOBuffer(), :displaysize => (10, 10), :limit => false)
    show(ioc, "text/latex", df)
    @test length(String(take!(ioc.io))) > 10000

    ioc = IOContext(IOBuffer(), :displaysize => (10, 10), :limit => true)
    show(ioc, "text/latex", df)
    @test length(String(take!(ioc.io))) < 10000
end

#Test HTML output for IJulia and similar
@testset "HTML output" begin
    df = DataFrame(Fish=["Suzy", "Amir"], Mass=[1.5, missing])
    io = IOBuffer()
    show(io, "text/html", df)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>2×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">Suzy</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">Amir</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    df = DataFrame(Fish=Vector{String}(undef, 2), Mass=[1.5, missing])
    io = IOBuffer()
    show(io, "text/html", df)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>2×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, "text/html", eachrow(df))
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>2×2 DataFrameRows</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, "text/html", eachcol(df))
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>2×2 DataFrameColumns</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, "text/html", df[1, :])
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>DataFrameRow (2 columns)</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), df, summary=false)
    str = String(take!(io))
    @test str == "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), eachrow(df), summary=false)
    str = String(take!(io))
    @test str == "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), eachcol(df), summary=false)
    str = String(take!(io))
    @test str == "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), df[1, :], summary=false)
    str = String(take!(io))
    @test str == "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), df, show_row_number=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>2×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"text-align: right;\">1.5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME"text/html"(), df[2, :], show_row_number=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>DataFrameRow (2 columns)</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th style = \"text-align: left;\">Fish</th>" *
                 "<th style = \"text-align: left;\">Mass</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Union{Missing, Float64}\" style = \"text-align: left;\">Float64?</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "<td style = \"font-style: italic; text-align: right;\">missing</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    ENV["DATAFRAMES_COLUMNS"] = 2
    ENV["DATAFRAMES_ROWS"] = 2
    show(IOContext(io, :limit => true), MIME"text/html"(),
         DataFrame(Int64[1 2 3 4 5 6 7 8 9], :auto))
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>1×9 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"float: right; font-style: italic;\">" *
                 "<span>7 columns omitted</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">x1</th>" *
                 "<th style = \"text-align: left;\">x2</th>" *
                 "<th>&ctdot;</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "<th>&ctdot;</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td>&ctdot;</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    @test_throws ArgumentError DataFrames._show(stdout, MIME("text/html"),
                                                DataFrame(ones(2,2), :auto), rowid=10)

    df = DataFrame(
        A=Int64[1,4,9,16],
        B = [
            md"[DataFrames.jl](http://juliadata.github.io/DataFrames.jl)",
            md"###A",
            md"``\frac{A}{B}``",
            md"*A*b**A**" ]
    )

    str = repr(MIME("text/html"), df)
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>4×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "<th title = \"Markdown.MD\" style = \"text-align: left;\">MD</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>" *
                 "<a href=\"http://juliadata.github.io/DataFrames.jl\">DataFrames.jl</a>" *
                 "</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">4</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>###A</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">9</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>&#36;\\frac&#123;A&#125;&#123;B&#125;&#36;</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">4</td>" *
                 "<td style = \"text-align: right;\">16</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>" *
                 "<em>A</em>b<strong>A</strong>" *
                 "</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    # Test that single and double quotes get escaped properly
    df = DataFrame(
        xs = ["'", "\"", "<foo>'</bar>"],
        ys = [QuoteTestType{'\''}(), QuoteTestType{'"'}, QuoteTestType{Symbol("\"'")}()],
        zs = QuoteTestType{'"'}[QuoteTestType{'"'}(), QuoteTestType{'"'}(), QuoteTestType{'"'}()],
    )
    io = IOBuffer()
    show(io, "text/html", df)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×3 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">xs</th>" *
                 "<th style = \"text-align: left;\">ys</th>" *
                 "<th style = \"text-align: left;\">zs</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Any\" style = \"text-align: left;\">Any</th>" *
                 "<th title = \"QuoteTestType{&apos;&quot;&apos;}\" style = \"text-align: left;\">QuoteTes…</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">&apos;</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{&apos;\\\\&apos;&apos;}()</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{&apos;&quot;&apos;}()</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">&quot;</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{&apos;&quot;&apos;}</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{&apos;&quot;&apos;}()</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">&lt;foo&gt;&apos;&lt;/bar&gt;</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{Symbol(&quot;\\\\&quot;&apos;&quot;)}()</td>" *
                 "<td style = \"text-align: left;\">QuoteTestType{&apos;&quot;&apos;}()</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    # Test invalid data in ENV variables.
    io = IOBuffer()
    ENV["DATAFRAMES_COLUMNS"] = "String"
    ENV["DATAFRAMES_ROWS"] = "String"
    show(IOContext(io, :limit => true), MIME"text/html"(),
         DataFrame(a = Int64.(1:26 |> collect)))
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>26×1 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">a</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">4</td>" *
                 "<td style = \"text-align: right;\">4</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">5</td>" *
                 "<td style = \"text-align: right;\">5</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">6</td>" *
                 "<td style = \"text-align: right;\">6</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">7</td>" *
                 "<td style = \"text-align: right;\">7</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">8</td>" *
                 "<td style = \"text-align: right;\">8</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">9</td>" *
                 "<td style = \"text-align: right;\">9</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">10</td>" *
                 "<td style = \"text-align: right;\">10</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">11</td>" *
                 "<td style = \"text-align: right;\">11</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">12</td>" *
                 "<td style = \"text-align: right;\">12</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">13</td>" *
                 "<td style = \"text-align: right;\">13</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">14</td>" *
                 "<td style = \"text-align: right;\">14</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">15</td>" *
                 "<td style = \"text-align: right;\">15</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">16</td>" *
                 "<td style = \"text-align: right;\">16</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">17</td>" *
                 "<td style = \"text-align: right;\">17</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">18</td>" *
                 "<td style = \"text-align: right;\">18</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">19</td>" *
                 "<td style = \"text-align: right;\">19</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">20</td>" *
                 "<td style = \"text-align: right;\">20</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">21</td>" *
                 "<td style = \"text-align: right;\">21</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">22</td>" *
                 "<td style = \"text-align: right;\">22</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">23</td>" *
                 "<td style = \"text-align: right;\">23</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">24</td>" *
                 "<td style = \"text-align: right;\">24</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">25</td>" *
                 "<td style = \"text-align: right;\">25</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">26</td>" *
                 "<td style = \"text-align: right;\">26</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    # Test invalid keywords when printing to HTML.
    @test_throws ArgumentError show(stdout, MIME("text/html"), df, rowid=10)
    @test_throws ArgumentError show(stdout, MIME("text/html"), df, title="title")
    @test_throws ArgumentError show(stdout, MIME("text/html"), df, truncate=100)
    @test_throws ArgumentError show(stdout, MIME("text/html"), eachcol(df), rowid=10)
    @test_throws ArgumentError show(stdout, MIME("text/html"), eachcol(df), title="title")
    @test_throws ArgumentError show(stdout, MIME("text/html"), eachrow(df), rowid=10)
    @test_throws ArgumentError show(stdout, MIME("text/html"), eachrow(df), title="title")
    @test_throws ArgumentError show(stdout, MIME("text/html"), eachrow(df), truncate=100)
    @test_throws ArgumentError show(stdout, MIME("text/html"), df[1, :], rowid=10)
    @test_throws ArgumentError show(stdout, MIME("text/html"), df[1, :], title="title")
    @test_throws ArgumentError show(stdout, MIME("text/html"), df[1, :], truncate=100)
end

# test limit attribute of IOContext is used
@testset "limit attribute" begin
    df = DataFrame(a=1:1000)
    ioc = IOContext(IOBuffer(), :displaysize => (10, 10), :limit => false)
    show(ioc, "text/html", df)
    @test length(String(take!(ioc.io))) > 10000

    ioc = IOContext(IOBuffer(), :displaysize => (10, 10), :limit => true)
    show(ioc, "text/html", df)
    @test length(String(take!(ioc.io))) < 10000
end

@testset "printtable" begin
    df = DataFrame(A=1:3,
                   B='a':'c',
                   C=["A", "B", "C"],
                   D=CategoricalArray(string.('a':'c')),
                   E=CategoricalArray(["A", "B", missing]),
                   F=Vector{Union{Int, Missing}}(1:3),
                   G=missings(3),
                   H=fill(missing, 3)
                  )

    @test sprint(DataFrames.printtable, df) ==
        """
        "A","B","C","D","E","F","G","H"
        1,"a","A","a","A","1",missing,missing
        2,"b","B","b","B","2",missing,missing
        3,"c","C","c",missing,"3",missing,missing
        """
end

@testset "csv/tsv output" begin
    df = DataFrame(a=[1,2], b=[1.0, 2.0])

    for x in [df, eachcol(df), eachrow(df)]
        @test sprint(show, "text/csv", x) == """
        "a","b"
        1,1.0
        2,2.0
        """
        @test sprint(show, "text/tab-separated-values", x) == """
        "a"\t"b"
        1\t1.0
        2\t2.0
        """
    end
end

@testset "Markdown as text/plain and as text/csv" begin
    df = DataFrame(
        A=Int64[1,4,9,16,25,36,49,64],
        B = [
            md"ABC",
            md"``\frac{x^2}{x^2+y^2}``",
            md"`Header`",
            md"This is *very*, **very**, very, very, very, very, very, very, very long line" ,
            md"",
            Markdown.parse("∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫αγ∞1∫αγ∞2∫αγ∞3"),
            Markdown.parse("∫αγ∞1∫αγ∞\n"*
                           "  * 2∫αγ∞3∫αγ∞4\n"*
                           "  * ∫αγ∞5∫αγ\n"*
                           "  * ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0"),
            Markdown.parse("∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫α\n"*
                           "  * γ∞1∫α\n"*
                           "  * γ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0"),
        ]
    )
    @test sprint(show, "text/plain", df) ==
        """
        8×2 DataFrame
         Row │ A      B
             │ Int64  MD
        ─────┼──────────────────────────────────────────
           1 │     1    ABC
           2 │     4    \\frac{x^2}{x^2+y^2}
           3 │     9    Header
           4 │    16    This is very, very, very, very…
           5 │    25
           6 │    36    ∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6…
           7 │    49    ∫αγ∞1∫αγ∞\\n\\n    •  2∫αγ∞3∫αγ∞…
           8 │    64    ∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6…"""

    @test sprint(show, "text/csv", df) ==
        """
        \"A\",\"B\"
        1,\"ABC\"
        4,\"\$\\\\frac{x^2}{x^2+y^2}\$\"
        9,\"`Header`\"
        16,\"This is *very*, **very**, very, very, very, very, very, very, very long line\"
        25,\"\"
        36,\"∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫αγ∞1∫αγ∞2∫αγ∞3\"
        49,\"∫αγ∞1∫αγ∞\\n\\n  * 2∫αγ∞3∫αγ∞4\\n  * ∫αγ∞5∫αγ\\n  * ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0\"
        64,\"∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫α\\n\\n  * γ∞1∫α\\n  * γ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0\"
        """
end

@testset "Markdown as HTML" begin
    df = DataFrame(
        A=Int64[1,4,9,16,25,36,49,64],
        B = [
            md"[DataFrames.jl](http://juliadata.github.io/DataFrames.jl)",
            md"``\frac{x^2}{x^2+y^2}``",
            md"# Header",
            md"This is *very*, **very**, very, very, very, very, very, very, very long line" ,
            md"",
            Markdown.parse("∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0" *
                           "∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0"),
            Markdown.parse("∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ\n"*
                           "  * ∞7∫αγ\n"*
                           "  * ∞8∫αγ\n"*
                           "  * ∞9∫αγ∞0∫α\nγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0"),
            Markdown.parse("∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫α\n"*
                           "  * γ∞1∫α\n"*
                           "  * γ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0"),
        ]
    )
    str = sprint(show,"text/html",df)
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>8×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "<th title = \"Markdown.MD\" style = \"text-align: left;\">MD</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>" *
                 "<a href=\"http://juliadata.github.io/DataFrames.jl\">DataFrames.jl</a>" *
                 "</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">4</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>&#36;\\frac&#123;x^2&#125;&#123;x^2&#43;y^2&#125;&#36;</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">9</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<h1>Header</h1>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">4</td>" *
                 "<td style = \"text-align: right;\">16</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>This is <em>very</em>, <strong>very</strong>, very, very, very, very, very, very, very long line</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">5</td>" *
                 "<td style = \"text-align: right;\">25</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">6</td>" *
                 "<td style = \"text-align: right;\">36</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">7</td>" *
                 "<td style = \"text-align: right;\">49</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ</p>" *
                 "<ul>" *
                 "<li>" *
                 "<p>∞7∫αγ</p>" *
                 "</li>" *
                 "<li>" *
                 "<p>∞8∫αγ</p>" *
                 "</li>" *
                 "<li>" *
                 "<p>∞9∫αγ∞0∫α</p>" *
                 "</li>" *
                 "</ul>" *
                 "<p>γ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0</p>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">8</td>" *
                 "<td style = \"text-align: right;\">64</td>" *
                 "<td style = \"text-align: left;\">" *
                 "<div class=\"markdown\">" *
                 "<p>∫αγ∞1∫αγ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0∫α</p>" *
                 "<ul>" *
                 "<li>" *
                 "<p>γ∞1∫α</p>" *
                 "</li>" *
                 "<li>" *
                 "<p>γ∞2∫αγ∞3∫αγ∞4∫αγ∞5∫αγ∞6∫αγ∞7∫αγ∞8∫αγ∞9∫αγ∞0</p>" *
                 "</li>" *
                 "</ul>" *
                 "</div>" *
                 "</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"
end

@testset "empty data frame and DataFrameRow" begin
    df = DataFrame(a=[1,2], b=[1.0, 2.0])

    @test sprint(show, "text/csv", df[:, 2:1]) == ""
    @test sprint(show, "text/tab-separated-values", df[:, 2:1]) == ""
    @test sprint(show, "text/html", df[:, 2:1]) ==
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>0×0 DataFrame</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "</table>" *
        "</div>"
    @test sprint(show, "text/latex", df[:, 2:1]) ==
          "\\begin{tabular}{r|}\n\t& \\\\\n\t\\hline\n\t& \\\\\n\t\\hline\n\\end{tabular}\n"

    @test sprint(show, "text/csv", @view df[:, 2:1]) == ""
    @test sprint(show, "text/tab-separated-values", @view df[:, 2:1]) == ""
    @test sprint(show, "text/html", @view df[:, 2:1]) ==
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>0×0 SubDataFrame</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "</table>" *
        "</div>"
    @test sprint(show, "text/latex", @view df[:, 2:1]) ==
          "\\begin{tabular}{r|}\n\t& \\\\\n\t\\hline\n\t& \\\\\n\t\\hline\n\\end{tabular}\n"

    @test sprint(show, "text/csv", df[1, 2:1]) == ""
    @test sprint(show, "text/tab-separated-values", df[1, 2:1]) == ""
    @test sprint(show, "text/html", df[1, 2:1]) ==
        "<div>" *
        "<div style = \"float: left;\">" *
        "<span>DataFrameRow (0 columns)</span>" *
        "</div>" *
        "<div style = \"clear: both;\">" *
        "</div>" *
        "</div>" *
        "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
        "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
        "</table>" *
        "</div>"
    @test sprint(show, "text/latex", df[1, 2:1]) ==
          "\\begin{tabular}{r|}\n\t& \\\\\n\t\\hline\n\t& \\\\\n\t\\hline\n\\end{tabular}\n"
end

@testset "consistency" begin
    df = DataFrame(a=[1, 1, 2, 2], b=[5, 6, 7, 8], c=1:4)
    push!(df.c, 5)
    @test_throws AssertionError sprint(show, "text/html", df)
    @test_throws AssertionError sprint(show, "text/latex", df)
    @test_throws AssertionError sprint(show, "text/csv", df)
    @test_throws AssertionError sprint(show, "text/tab-separated-values", df)

    df = DataFrame(a=[1, 1, 2, 2], b=[5, 6, 7, 8], c=1:4)
    push!(DataFrames._columns(df), df[:, :a])
    @test_throws AssertionError sprint(show, "text/html", df)
    @test_throws AssertionError sprint(show, "text/latex", df)
    @test_throws AssertionError sprint(show, "text/csv", df)
    @test_throws AssertionError sprint(show, "text/tab-separated-values", df)
end

@testset "summary tests" begin
    df = DataFrame(ones(2,3), :auto)

    for (v, s) in [(df, "2×3 DataFrame"),
                   (view(df, :, :), "2×3 SubDataFrame"),
                   (df[1, :], "3-element DataFrameRow"),
                   (DataFrames.index(df), "data frame with 3 columns"),
                   (DataFrames.index(df[1:1, 1:1]), "data frame with 1 column"),
                   (DataFrames.index(view(df, 1:1, 1:1)), "data frame with 1 column"),
                   (eachrow(df), "2-element DataFrameRows"),
                   (eachcol(df), "3-element DataFrameColumns")]
        @test summary(v) == s
        io = IOBuffer()
        summary(io, v)
        @test String(take!(io)) == s
    end
end

@testset "eltypes tests" begin
    df = DataFrame(A=Int32.(1:3), B=["x", "y", "z"])

    io = IOBuffer()
    show(io, MIME("text/plain"), df, eltypes=true)
    str = String(take!(io))
    @test str == """
        3×2 DataFrame
         Row │ A      B
             │ Int32  String
        ─────┼───────────────
           1 │     1  x
           2 │     2  y
           3 │     3  z"""

    io = IOBuffer()
    show(io, MIME("text/plain"), eachcol(df), eltypes=true)
    str = String(take!(io))
    @test str == """
        3×2 DataFrameColumns
         Row │ A      B
             │ Int32  String
        ─────┼───────────────
           1 │     1  x
           2 │     2  y
           3 │     3  z"""

    io = IOBuffer()
    show(io, MIME("text/plain"), eachrow(df), eltypes=true)
    str = String(take!(io))
    @test str == """
        3×2 DataFrameRows
         Row │ A      B
             │ Int32  String
        ─────┼───────────────
           1 │     1  x
           2 │     2  y
           3 │     3  z"""

    io = IOBuffer()
    show(io, MIME("text/plain"), df, eltypes=false)
    str = String(take!(io))
    @test str == """
        3×2 DataFrame
         Row │ A  B
        ─────┼──────
           1 │ 1  x
           2 │ 2  y
           3 │ 3  z"""

    io = IOBuffer()
    show(io, MIME("text/plain"), eachcol(df), eltypes=false)
    str = String(take!(io))
    @test str == """
        3×2 DataFrameColumns
         Row │ A  B
        ─────┼──────
           1 │ 1  x
           2 │ 2  y
           3 │ 3  z"""

    io = IOBuffer()
    show(io, MIME("text/plain"), eachrow(df), eltypes=false)
    str = String(take!(io))
    @test str == """
        3×2 DataFrameRows
         Row │ A  B
        ─────┼──────
           1 │ 1  x
           2 │ 2  y
           3 │ 3  z"""

    io = IOBuffer()
    show(io, MIME("text/html"), df, eltypes=true)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int32\" style = \"text-align: left;\">Int32</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/html"), eachcol(df), eltypes=true)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrameColumns</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int32\" style = \"text-align: left;\">Int32</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/html"), eachrow(df), eltypes=true)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrameRows</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int32\" style = \"text-align: left;\">Int32</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/html"), df, eltypes=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/html"), eachcol(df), eltypes=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrameColumns</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/html"), eachrow(df), eltypes=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>3×2 DataFrameRows</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">x</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">y</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"text-align: left;\">z</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    for x in [df, eachcol(df), eachrow(df)]
        io = IOBuffer()
        show(io, MIME("text/latex"), x, eltypes=true)
        str = String(take!(io))
        @test str == """
        \\begin{tabular}{r|cc}
        \t& A & B\\\\
        \t\\hline
        \t& Int32 & String\\\\
        \t\\hline
        \t1 & 1 & x \\\\
        \t2 & 2 & y \\\\
        \t3 & 3 & z \\\\
        \\end{tabular}
        """

        io = IOBuffer()
        show(io, MIME("text/latex"), x, eltypes=false)
        str = String(take!(io))
        @test str == """
        \\begin{tabular}{r|cc}
        \t& A & B\\\\
        \t\\hline
        \t1 & 1 & x \\\\
        \t2 & 2 & y \\\\
        \t3 & 3 & z \\\\
        \\end{tabular}
        """
    end
end

@testset "improved printing of special types" begin
    df = DataFrame(A=Int64.(1:9), B=Vector{Any}(undef, 9))
    df.B[1:8] = [df, # DataFrame
                 df[1,:], # DataFrameRow
                 view(df,1:1, :), # SubDataFrame
                 eachrow(df), # DataFrameColumns
                 eachcol(df), # DataFrameRows
                 groupby(df, :A), # GroupedDataFrame
                 missing,
                 nothing]

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))

    @test str == """
    9×2 DataFrame
     Row │ A      B
         │ Int64  Any
    ─────┼──────────────────────────────────────────
       1 │     1  9×2 DataFrame
       2 │     2  2-element DataFrameRow
       3 │     3  1×2 SubDataFrame
       4 │     4  9-element DataFrameRows
       5 │     5  2-element DataFrameColumns
       6 │     6  GroupedDataFrame with 9 groups b…
       7 │     7  missing
       8 │     8
       9 │     9  #undef"""

    # TODO: update when https://github.com/KristofferC/Crayons.jl/issues/47 is resolved
    if Base.get_have_color()
        io = IOBuffer()
        show(IOContext(io, :color => true), df)
        str = String(take!(io))
        @test str == """
        \e[1m9×2 DataFrame\e[0m
        \e[1m Row \e[0m│\e[1m A     \e[0m\e[1m B                                 \e[0m
        \e[1m     \e[0m│\e[90m Int64 \e[0m\e[90m Any                               \e[0m
        ─────┼──────────────────────────────────────────
           1 │     1 \e[90m 9×2 DataFrame                     \e[0m
           2 │     2 \e[90m 2-element DataFrameRow            \e[0m
           3 │     3 \e[90m 1×2 SubDataFrame                  \e[0m
           4 │     4 \e[90m 9-element DataFrameRows           \e[0m
           5 │     5 \e[90m 2-element DataFrameColumns        \e[0m
           6 │     6 \e[90m GroupedDataFrame with 9 groups b… \e[0m
           7 │     7 \e[90m missing                           \e[0m
           8 │     8 \e[90m                                   \e[0m
           9 │     9 \e[90m #undef                            \e[0m"""
    end

    io = IOBuffer()
    show(io, MIME("text/html"), df)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>9×2 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">A</th>" *
                 "<th style = \"text-align: left;\">B</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "<th title = \"Any\" style = \"text-align: left;\">Any</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: right;\">1</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">9×2 DataFrame</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: right;\">2</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">2-element DataFrameRow</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">3</td>" *
                 "<td style = \"text-align: right;\">3</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">1×2 SubDataFrame</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">4</td>" *
                 "<td style = \"text-align: right;\">4</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">9-element DataFrameRows</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">5</td>" *
                 "<td style = \"text-align: right;\">5</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">2-element DataFrameColumns</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">6</td>" *
                 "<td style = \"text-align: right;\">6</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">GroupedDataFrame with 9 groups based on key: A</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">7</td>" *
                 "<td style = \"text-align: right;\">7</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">missing</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">8</td>" *
                 "<td style = \"text-align: right;\">8</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">" *
                 "</td>" *
                 "</tr>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">9</td>" *
                 "<td style = \"text-align: right;\">9</td>" *
                 "<td style = \"font-style: italic; text-align: left;\">#undef</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/latex"), df)
    str = String(take!(io))
    @test str == """
    \\begin{tabular}{r|cc}
    \t& A & B\\\\
    \t\\hline
    \t& Int64 & Any\\\\
    \t\\hline
    \t1 & 1 & \\emph{9×2 DataFrame} \\\\
    \t2 & 2 & \\emph{2-element DataFrameRow} \\\\
    \t3 & 3 & \\emph{1×2 SubDataFrame} \\\\
    \t4 & 4 & \\emph{9-element DataFrameRows} \\\\
    \t5 & 5 & \\emph{2-element DataFrameColumns} \\\\
    \t6 & 6 & \\emph{GroupedDataFrame with 9 groups based on key: A} \\\\
    \t7 & 7 & \\emph{missing} \\\\
    \t8 & 8 &  \\\\
    \t9 & 9 & \\emph{\\#undef} \\\\
    \\end{tabular}
    """

    @test_throws UndefRefError show(io, MIME("text/csv"), df)
    @test_throws UndefRefError show(io, MIME("text/tab-separated-values"), df)

    df[end, 2] = "\""
    push!(df, (10, Symbol("\"")))
    push!(df, (11, '"'))
    df.B[6] = groupby(df, :A)
    io = IOBuffer()
    show(io, MIME("text/csv"), df)
    str = String(take!(io))
    @test str == """
    "A","B"
    1,"11×2 DataFrame"
    2,"2-element DataFrameRow"
    3,"1×2 SubDataFrame"
    4,"11-element DataFrameRows"
    5,"2-element DataFrameColumns"
    6,"GroupedDataFrame with 11 groups based on key: A"
    7,missing
    8,nothing
    9,"\\""
    10,"\\""
    11,"\\""
    """

    io = IOBuffer()
    show(io, MIME("text/tab-separated-values"), df)
    str = String(take!(io))
    @test str == """
    "A"\t"B"
    1\t"11×2 DataFrame"
    2\t"2-element DataFrameRow"
    3\t"1×2 SubDataFrame"
    4\t"11-element DataFrameRows"
    5\t"2-element DataFrameColumns"
    6\t"GroupedDataFrame with 11 groups based on key: A"
    7\tmissing
    8\tnothing
    9\t"\\""
    10\t"\\""
    11\t"\\""
    """
end

@testset "check keywords that limit the column width" begin
    df = DataFrame(x="0123456789"^10)

    # no truncation
    io = IOBuffer()
    show(io, MIME("text/html"), df)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>1×1 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">x</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">1</td>" *
                 "<td style = \"text-align: left;\">0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    # With truncation
    io = IOBuffer()
    show(io, MIME("text/html"), df, max_column_width="100px")
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>1×1 DataFrame</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; max-width: 100px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;\">Row</th>" *
                 "<th style = \"max-width: 100px; overflow: hidden; text-align: left; text-overflow: ellipsis; white-space: nowrap;\">x</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; max-width: 100px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"max-width: 100px; overflow: hidden; text-align: left; text-overflow: ellipsis; white-space: nowrap;\">String</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; max-width: 100px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;\">1</td>" *
                 "<td style = \"max-width: 100px; overflow: hidden; text-align: left; text-overflow: ellipsis; white-space: nowrap;\">0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    # no truncation
    io = IOBuffer()
    show(io, MIME("text/latex"), df)
    str = String(take!(io))
    @test str == """
    \\begin{tabular}{r|c}
    \t& x\\\\
    \t\\hline
    \t& String\\\\
    \t\\hline
    \t1 & 0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789 \\\\
    \\end{tabular}
    """

    # no truncation
    io = IOBuffer()
    show(io, MIME("text/csv"), df)
    str = String(take!(io))
    @test str == "\"x\"\n\"01234567890123456789012345678901234567890123456789" *
                 "01234567890123456789012345678901234567890123456789\"\n"

    # no truncation
    io = IOBuffer()
    show(io, MIME("text/tab-separated-values"), df)
    str = String(take!(io))
    @test str == "\"x\"\n\"01234567890123456789012345678901234567890123456789" *
                 "01234567890123456789012345678901234567890123456789\"\n"

    # default truncation
    io = IOBuffer()
    show(io, MIME("text/plain"), df)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼───────────────────────────────────
           1 │ 01234567890123456789012345678901…"""

    io = IOBuffer()
    show(io, df)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼───────────────────────────────────
           1 │ 01234567890123456789012345678901…"""

    # no truncation
    io = IOBuffer()
    show(io, df, truncate=0)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼──────────────────────────────────────────────────────────────────────────────────────────────────────
           1 │ 0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789"""

    # custom truncation
    io = IOBuffer()
    show(io, df, truncate=1)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         Row │ x
             │ String
        ─────┼────────
           1 │ 01234…"""


    df = DataFrame(x12345678901234567890="0123456789"^10)
    io = IOBuffer()
    show(io, df, truncate=1, rowlabel=:r12345678901234567890)
    str = String(take!(io))
    @test str == """
        1×1 DataFrame
         r12345678901234567890 │ x12345678901234567890
                               │ String
        ───────────────────────┼───────────────────────
                             1 │ 01234567890123456789…"""
end

end # module

using BenchmarkTools
using DataFrames
using PooledArrays
using Random

@show Threads.nthreads()

Random.seed!(1234)
ref_dfi = DataFrame(rand(1:10^4, 10^7, 4), :auto)
ref_dfs = string.(ref_dfi)
ref_dfp = mapcols(PooledArray, ref_dfs)

res = DataFrame(rows=Int[],cols=Int[], type=String[], op=String[], time=Float64[])

for x in (10, 10^6-1, 10^6, 10^7), y in 1:4
    dfi = ref_dfi[1:x, 1:y]
    dfs = ref_dfs[1:x, 1:y]
    dfp = ref_dfp[1:x, 1:y]

    @show (x, y) # ping that the process is alive
    push!(res, (x, y, "integer", "copy", @belapsed DataFrame($dfi)))
    push!(res, (x, y, "string", "copy", @belapsed DataFrame($dfs)))
    push!(res, (x, y, "pooled", "copy", @belapsed DataFrame($dfp)))
    push!(res, (x, y, "integer", ":", @belapsed $dfi[:, :]))
    push!(res, (x, y, "string", ":", @belapsed $dfs[:, :]))
    push!(res, (x, y, "pooled", ":", @belapsed $dfp[:, :]))
    push!(res, (x, y, "integer", "1:end-5", @belapsed $dfi[1:end-5, :]))
    push!(res, (x, y, "string", "1:end-5", @belapsed $dfs[1:end-5, :]))
    push!(res, (x, y, "pooled", "1:end-5", @belapsed $dfp[1:end-5, :]))
    push!(res, (x, y, "integer", "1:5", @belapsed $dfi[1:5, :]))
    push!(res, (x, y, "string", "1:5", @belapsed $dfs[1:1:5, :]))
    push!(res, (x, y, "pooled", "1:5", @belapsed $dfp[1:1:5, :]))
end

res.time *= 1_000

@show Threads.nthreads()
@show unstack(res, [:cols, :type, :op], :rows, :time)

module TestOffsetIndexing

using Test, DataFrames, OffsetArrays

@testset "Check allowing only 1-based indexing of vectors" begin
    ov1 = OffsetArray(1:5, 0:4)
    ov2 = OffsetArray(1:5, 1:5)

    @test_throws ArgumentError DataFrame(a=ov1)
    @test DataFrame(a=ov2) == DataFrame(a=1:5)

    @test_throws ArgumentError mapcols!(x -> ov1, DataFrame(a=1))
    @test mapcols!(x -> ov2, DataFrame(a=1)) == DataFrame(a=ov2)

    df = DataFrame(a=1)
    DataFrames._columns(df)[1] = ov1
    @test_throws ArgumentError DataFrames._check_consistency(df)
    DataFrames._columns(df)[1] = ov2
    DataFrames._check_consistency(df)

    @test_throws ArgumentError df.b = ov1
    @test_throws ArgumentError insertcols!(df, :b => ov1)
    @test_throws DimensionMismatch df[!, :b] .= ov1

    @test_throws Base.CanonicalIndexError df[:, :a] = ov1

    # this inconsistency is the consequence how setindex! for vector is defined in Base
    df = DataFrame(a=5:-1:1)
    @test_throws ArgumentError df[:, :b] = ov1
    df[:, :a] = ov1
    @test df == DataFrame(a=1:5)
end

end # module

"""
    SubDataFrame{<:AbstractDataFrame, <:AbstractIndex, <:AbstractVector{Int}} <: AbstractDataFrame

A view of an `AbstractDataFrame`. It is returned by a call to the `view` function
on an `AbstractDataFrame` if a collections of rows and columns are specified.

A `SubDataFrame` is an `AbstractDataFrame`, so expect that most
DataFrame functions should work. Such methods include `describe`,
`summary`, `nrow`, `size`, `by`, `stack`, and `join`.

If the selection of columns in a parent data frame is passed as `:` (a colon)
then `SubDataFrame` will always have all columns from the parent,
even if they are added or removed after its creation.

# Examples
```jldoctest
julia> df = DataFrame(a=repeat([1, 2, 3, 4], outer=[2]),
                      b=repeat([2, 1], outer=[4]),
                      c=1:8)
8×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     2      1      2
   3 │     3      2      3
   4 │     4      1      4
   5 │     1      2      5
   6 │     2      1      6
   7 │     3      2      7
   8 │     4      1      8

julia> sdf1 = view(df, :, 2:3) # column subsetting
8×2 SubDataFrame
 Row │ b      c
     │ Int64  Int64
─────┼──────────────
   1 │     2      1
   2 │     1      2
   3 │     2      3
   4 │     1      4
   5 │     2      5
   6 │     1      6
   7 │     2      7
   8 │     1      8

julia> sdf2 = @view df[end:-1:1, [1, 3]]  # row and column subsetting
8×2 SubDataFrame
 Row │ a      c
     │ Int64  Int64
─────┼──────────────
   1 │     4      8
   2 │     3      7
   3 │     2      6
   4 │     1      5
   5 │     4      4
   6 │     3      3
   7 │     2      2
   8 │     1      1

julia> sdf3 = groupby(df, :a)[1]  # indexing a GroupedDataFrame returns a SubDataFrame
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      2      5
```
"""
struct SubDataFrame{D<:AbstractDataFrame, S<:AbstractIndex, T<:AbstractVector{Int}} <: AbstractDataFrame
    parent::D
    colindex::S
    rows::T # maps from subdf row indexes to parent row indexes
end

# this method should be never called by DataFrames.jl code, but is added for safety
SubDataFrame(parent::SubDataFrame, colindex::AbstractIndex, rows::AbstractVector{Int}) =
    throw(ArgumentError("Creation of a SubDataFrame from a SubDataFrame is not allowed"))

Base.@propagate_inbounds function SubDataFrame(parent::DataFrame, rows::AbstractVector{Int}, cols)
    @boundscheck if !checkindex(Bool, axes(parent, 1), rows)
        throw(BoundsError(parent, (rows, cols)))
    end
    SubDataFrame(parent, SubIndex(index(parent), cols), rows)
end
Base.@propagate_inbounds SubDataFrame(parent::DataFrame, ::Colon, cols) =
    SubDataFrame(parent, axes(parent, 1), cols)
@inline SubDataFrame(parent::DataFrame, row::Integer, cols) =
    throw(ArgumentError("invalid row index: $row of type $(typeof(row))"))

Base.@propagate_inbounds function SubDataFrame(parent::DataFrame, rows::AbstractVector{<:Integer}, cols)
    if any(x -> x isa Bool, rows)
        throw(ArgumentError("invalid row index of type `Bool`"))
    end
    return SubDataFrame(parent, convert(Vector{Int}, rows), cols)
end

Base.@propagate_inbounds function SubDataFrame(parent::DataFrame, rows::AbstractVector{Bool}, cols)
    if length(rows) != nrow(parent)
        throw(ArgumentError("invalid length of `AbstractVector{Bool}` row index " *
                            "(got $(length(rows)), expected $(nrow(parent)))"))
    end
    return SubDataFrame(parent, _findall(rows), cols)
end

Base.@propagate_inbounds function SubDataFrame(parent::DataFrame, rows::AbstractVector, cols)
    if !all(x -> (x isa Integer) && !(x isa Bool), rows)
        throw(ArgumentError("only `Integer` indices are accepted in `rows`"))
    end
    return SubDataFrame(parent, convert(Vector{Int}, rows), cols)
end

Base.@propagate_inbounds function SubDataFrame(sdf::SubDataFrame, rowind, cols)
    new_rows = ncol(sdf) == 0 ? (Int[])[rowind] : rows(sdf)[rowind]
    return SubDataFrame(parent(sdf), new_rows, parentcols(index(sdf), cols))
end

Base.@propagate_inbounds SubDataFrame(sdf::SubDataFrame, rowind::Bool, cols) =
    throw(ArgumentError("invalid row index of type Bool"))

Base.@propagate_inbounds function SubDataFrame(sdf::SubDataFrame, rowind, ::Colon)
    new_rows = ncol(sdf) == 0 ? (Int[])[rowind] : rows(sdf)[rowind]
    if index(sdf) isa Index # sdf was created using : as row selector
        return SubDataFrame(parent(sdf), new_rows, :)
    else
        return SubDataFrame(parent(sdf), new_rows, parentcols(index(sdf), :))
    end
end

Base.@propagate_inbounds SubDataFrame(sdf::SubDataFrame, rowind::Bool, ::Colon) =
    throw(ArgumentError("invalid row index of type Bool"))
Base.@propagate_inbounds SubDataFrame(sdf::SubDataFrame, ::Colon, cols) =
    SubDataFrame(parent(sdf), rows(sdf), parentcols(index(sdf), cols))
@inline SubDataFrame(sdf::SubDataFrame, ::Colon, ::Colon) = sdf

rows(sdf::SubDataFrame) = getfield(sdf, :rows)
Base.parent(sdf::SubDataFrame) = getfield(sdf, :parent)
Base.parentindices(sdf::SubDataFrame) = (rows(sdf), parentcols(index(sdf)))

Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, rowinds, colind::ColumnIndex) =
    view(adf[!, colind], rowinds)
Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, ::typeof(!), colind::ColumnIndex) =
    view(adf[!, colind], :)
@inline Base.view(adf::AbstractDataFrame, rowinds, colind::Bool) =
    throw(ArgumentError("invalid column index $colind of type `Bool`"))
Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, rowinds,
                                   colinds::MultiColumnIndex) =
    SubDataFrame(adf, rowinds, colinds)
Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, rowinds::typeof(!),
                                   colinds::MultiColumnIndex) =
    SubDataFrame(adf, :, colinds)
Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, rowinds::Not,
                                   colinds::MultiColumnIndex) =
    SubDataFrame(adf, axes(adf, 1)[rowinds], colinds)

##############################################################################
##
## AbstractDataFrame interface
##
##############################################################################

index(sdf::SubDataFrame) = getfield(sdf, :colindex)

nrow(sdf::SubDataFrame) = ncol(sdf) > 0 ? length(rows(sdf))::Int : 0

Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, rowind::Integer, colind::ColumnIndex) =
    parent(sdf)[!, parentcols(index(sdf), colind)][rows(sdf)[rowind]]
Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, rowind::Bool, colind::ColumnIndex) =
    throw(ArgumentError("invalid row index of type Bool"))
Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, rowinds::Union{AbstractVector, Not},
                                       colind::ColumnIndex) =
    parent(sdf)[!, parentcols(index(sdf), colind)][rows(sdf)[rowinds]]
Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, ::Colon, colind::ColumnIndex) =
    parent(sdf)[rows(sdf), parentcols(index(sdf), colind)]
Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, ::typeof(!), colind::ColumnIndex) =
    view(parent(sdf), rows(sdf), parentcols(index(sdf), colind))

Base.@propagate_inbounds function Base.getindex(sdf::SubDataFrame,
                                                rowinds::Union{AbstractVector, Not},
                                                colinds::MultiColumnIndex)
    new_rows = ncol(sdf) == 0 ? (Int[])[rowinds] : rows(sdf)[rowinds]
    return parent(sdf)[new_rows, parentcols(index(sdf), colinds)]
end

Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, ::Colon,
                                       colinds::MultiColumnIndex) =
    parent(sdf)[rows(sdf), parentcols(index(sdf), colinds)]
Base.@propagate_inbounds Base.getindex(sdf::SubDataFrame, row_ind::typeof(!),
                                       col_inds::MultiColumnIndex) =
    select(sdf, index(sdf)[col_inds], copycols=false)

Base.@propagate_inbounds function Base.setindex!(sdf::SubDataFrame, val::Any, idx::CartesianIndex{2})
    return setindex!(sdf, val, idx[1], idx[2])
end

Base.@propagate_inbounds function Base.setindex!(sdf::SubDataFrame, val::Any, ::Colon, colinds::Any)
    if colinds isa SymbolOrString && columnindex(sdf, colinds) == 0
        if !is_column_insertion_allowed(sdf)
            throw(ArgumentError("creating new columns in a SubDataFrame that subsets " *
                                "columns of its parent data frame is disallowed"))
        end
        if !(val isa AbstractVector && nrow(sdf) == length(val))
            throw(ArgumentError("Assigned value must be a vector with length " *
                                "equal to number of rows in the SubDataFrame"))
        end
        T = eltype(val)
        newcol = similar(val, Union{T, Missing}, nrow(parent(sdf)))
        fill!(newcol, missing)
        newcol[rows(sdf)] = val
        parent(sdf)[!, colinds] = newcol
    else
        parent(sdf)[rows(sdf), parentcols(index(sdf), colinds)] = val
    end
    return sdf
end

# TODO: in the future, when refactoring source code
# (presumably when we would first define all the types that the package provides
#  and then define methods for them)
# consider merging SubDataFrame and DataFrame setindex! methods

function Base.setindex!(sdf::SubDataFrame, v::AbstractVector,
                        ::typeof(!), col_ind::ColumnIndex)
    if col_ind isa Union{Signed, Unsigned} && !(1 <= col_ind <= ncol(sdf))
        throw(ArgumentError("Cannot assign to non-existent column: $col_ind"))
    end
    if col_ind isa SymbolOrString && columnindex(sdf, col_ind) == 0
        if !is_column_insertion_allowed(sdf)
            throw(ArgumentError("creating new columns in a SubDataFrame that subsets " *
                                "columns of its parent data frame is disallowed"))
        end
        sdf[:, col_ind] = v
    else
        pdf = parent(sdf)
        p_col_ind = parentcols(index(sdf), col_ind)
        old_col = pdf[!, p_col_ind]
        T = eltype(old_col)
        S = eltype(v)
        newcol = similar(old_col, promote_type(T, S), length(old_col))
        newcol .= old_col
        newcol[rows(sdf)] = v
        pdf[!, p_col_ind] = newcol
    end
    return sdf
end

for T in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(sdf::SubDataFrame,
                                  new_df::AbstractDataFrame,
                                  row_inds::typeof(!),
                                  col_inds::$T)
        idxs = index(sdf)[col_inds]
        if view(_names(sdf), idxs) != _names(new_df)
            throw(ArgumentError("Column names in source and target data frames do not match"))
        end
        for (j, col) in enumerate(idxs)
            sdf[!, col] = new_df[!, j]
        end
        return sdf
    end

    @eval function Base.setindex!(sdf::SubDataFrame,
                                  mx::AbstractMatrix,
                                  row_inds::typeof(!),
                                  col_inds::$T)
        idxs = index(sdf)[col_inds]
        if size(mx, 2) != length(idxs)
            throw(DimensionMismatch("number of selected columns ($(length(idxs))) " *
                                    "and number of columns in " *
                                    "matrix ($(size(mx, 2))) do not match"))
        end
        for (j, col) in enumerate(idxs)
            sdf[!, col] = view(mx, :, j)
        end
        return sdf
    end
end

Base.@propagate_inbounds function Base.setindex!(sdf::SubDataFrame, val::Any, rowinds::Any, colinds::Any)
    parent(sdf)[rows(sdf)[rowinds], parentcols(index(sdf), colinds)] = val
    return sdf
end

Base.@propagate_inbounds Base.setindex!(sdf::SubDataFrame, val::Any, rowinds::Bool, colinds::Any) =
    throw(ArgumentError("invalid row index of type Bool"))

Base.setproperty!(df::SubDataFrame, col_ind::Symbol, v::AbstractVector) =
    (df[!, col_ind] = v)
Base.setproperty!(df::SubDataFrame, col_ind::AbstractString, v::AbstractVector) =
    (df[!, col_ind] = v)
Base.setproperty!(::SubDataFrame, col_ind::Symbol, v::Any) =
    throw(ArgumentError("It is only allowed to pass a vector as a column of a SubDataFrame. " *
                        "Instead use `df[!, col_ind] .= v` if you want to use broadcasting."))
Base.setproperty!(::SubDataFrame, col_ind::AbstractString, v::Any) =
    throw(ArgumentError("It is only allowed to pass a vector as a column of a SubDataFrame. " *
                        "Instead use `df[!, col_ind] .= v` if you want to use broadcasting."))

##############################################################################
##
## Miscellaneous
##
##############################################################################

Base.copy(sdf::SubDataFrame) = parent(sdf)[rows(sdf), parentcols(index(sdf), :)]

Base.deleteat!(df::SubDataFrame, ind) =
    throw(ArgumentError("SubDataFrame does not support deleting rows"))

function DataFrame(sdf::SubDataFrame; copycols::Bool=true)
    if copycols
        return sdf[:, :]
    else
        new_df = DataFrame(collect(eachcol(sdf)), _names(sdf), copycols=false)
        _copy_all_note_metadata!(new_df, sdf)
        return new_df
    end
end

Base.convert(::Type{DataFrame}, sdf::SubDataFrame) = DataFrame(sdf)

# this function tests if it is allowed to add/remove/reorder columns to passed SubDataFrame
# currently it is only allowed when SubDataFrame was created with : as column selector
# which results in using Index as its index (as opposed to other columns selectors
# which result in SubIndex)
function is_column_insertion_allowed(df::AbstractDataFrame)
    if df isa DataFrame
        return true
    elseif df isa SubDataFrame
        return getfield(df, :colindex) isa Index
    end
    throw(ArgumentError("Unsupported data frame type"))
end

function _replace_columns!(sdf::SubDataFrame, newdf::DataFrame; keep_present::Bool)
    if keep_present
        colsmatch = issubset(_names(newdf), _names(sdf))
    else
        colsmatch = _names(newdf) == _names(sdf)
    end
    if !(colsmatch || is_column_insertion_allowed(sdf))
        throw(ArgumentError("changing the sequence of column names in a SubDataFrame " *
                            "that subsets columns of its parent data frame is disallowed"))
    end

    for colname in _names(newdf)
        # This will allocate a fresh column in parent(sdf) for each colname
        sdf[!, colname] = newdf[!, colname]
    end

    # if _replace_columns! was called from transform we are done as we want to
    # keep all columns that were previously present.
    # In this case column order will be correct.
    # Otherwise if columns did not match this means that we have either:
    # 1. inserted some columns into newdf
    # or
    # 2. requested to reorder the existing columns
    # or
    # 3. dropped some columns in newdf
    # and that operation was allowed.
    # Therefore we need to update the parent of sdf in place to make sure
    # it holds only the required target columns in a correct order.
    pdf = parent(sdf)
    if !keep_present && !colsmatch
        pdf = parent(sdf)
        @assert pdf isa DataFrame
        select!(pdf, _names(newdf))
    end

    for col in _names(newdf)
        emptycolmetadata!(pdf, col)
    end

    for (col, col_keys) in colmetadatakeys(newdf)
        if hasproperty(pdf, col)
            for key in col_keys
                val, style = colmetadata(newdf, col, key, style=true)
                style === :note && colmetadata!(pdf, col, key, val, style=:note)
            end
        end
    end
    _drop_all_nonnote_metadata!(pdf)

    return sdf
end

# _try_select_no_copy selects cols from df; it tries to avoid copying data if possible;
# for SubDataFrame if cols is not a simple column selector then copying is needed
function _try_select_no_copy(sdf::SubDataFrame, cols)
    # try is needed here as `cols` could be AbstractVector in which case
    # it is not possible to statically check if it is a valid column selector
    colsidx = try
        index(sdf)[cols]
    catch
        nothing
    end 

    return isnothing(colsidx) ? select(sdf, cols) : select(sdf, colsidx, copycols=false)
end

module TestIteration

import Compat
using Test, DataFrames

@testset "eachrow and eachcol" begin
    df = DataFrame(A=Vector{Union{Int, Missing}}(1:2), B=Vector{Union{Int, Missing}}(2:3))

    @test nrow(eachrow(df)) == nrow(df)
    @test ncol(eachrow(df)) == ncol(df)
    @test size(eachrow(df)) == (size(df, 1),)
    @test parent(eachrow(df)) === df
    @test names(eachrow(df)) == names(df)
    @test IndexStyle(eachrow(df)) == IndexLinear()
    @test sprint(summary, eachrow(df)) == "2-element DataFrameRows"
    @test Base.IndexStyle(eachrow(df)) == IndexLinear()
    @test eachrow(df)[1] == DataFrameRow(df, 1, :)
    @test eachrow(df)[CartesianIndex(1)] == DataFrameRow(df, 1, :)
    @test_throws MethodError eachrow(df)[CartesianIndex(1, 1)]
    @test collect(eachrow(df)) isa Vector{<:DataFrameRow}
    @test eltype(eachrow(df)) <: DataFrameRow
    for row in eachrow(df)
        @test isa(row, DataFrameRow)
        @test (row[:B] - row[:A]) == 1
        # issue #683 (https://github.com/JuliaData/DataFrames.jl/pull/683)
        @test collect(pairs(row)) isa Vector{Pair{Symbol, Int}}
    end

    @test nrow(eachcol(df)) == nrow(df)
    @test ncol(eachcol(df)) == ncol(df)
    @test Base.IteratorSize(eachcol(df)) == Base.HasShape{1}()
    @test parent(eachcol(df)) === df
    @test names(eachcol(df)) == names(df)
    @test length(eachcol(df)) == size(df, 2)
    @test size(eachcol(df)) == (size(df, 2),)
    @test size(eachcol(df), 1) == size(df, 2)
    @test_throws ArgumentError size(eachcol(df), 2)
    @test_throws ArgumentError size(eachcol(df), 0)
    @test eachcol(df)[1] == df[:, 1]
    @test eachcol(df)[CartesianIndex(1)] == df[:, 1]
    @test_throws MethodError eachcol(df)[CartesianIndex(1, 1)]
    @test eachcol(df)[:A] === df[!, :A]
    @test eachcol(df)[All()] == eachcol(df)
    @test eachcol(df)[Cols(:)] == eachcol(df)
    @test isequal(eachcol(df)[[1]], eachcol(df[!, [1]]))
    @test eachcol(df).A === df[!, :A]
    @test eachcol(df)["A"] === df[!, "A"]
    @test eachcol(df)."A" === df[!, "A"]
    @test collect(eachcol(df)) isa Vector{AbstractVector}
    @test collect(eachcol(df)) == [[1, 2], [2, 3]]
    @test eltype(eachcol(df)) == AbstractVector
    @test_throws ArgumentError eachcol(df)[[1, 1]]
    @test eachcol(df)[[1]][1] === df.A
    for col in eachcol(df)
        @test isa(col, AbstractVector)
    end

    @test map(x -> minimum(Vector(x)), eachrow(df)) == [1, 2]
    @test map(Vector, eachrow(df)) == [[1, 2], [2, 3]]
    @test mapcols(minimum, df) == DataFrame(A=[1], B=[2])
    @test map(minimum, eachcol(df)) == [1, 2]
    @test eltype.(eachcol(mapcols(Vector{Float64}, df))) == [Float64, Float64]
    @test eltype(map(Vector{Float64}, eachcol(df))) == Vector{Float64}

    @test_throws ErrorException for x in df; end
end

@testset "mapcols" begin
    df_mapcols = DataFrame(a=1:10, b=11:20)
    @test mapcols(sum, df_mapcols) == DataFrame(a=55, b=155)
    @test mapcols(x -> 1, df_mapcols) == DataFrame(a=1, b=1)
    @test_throws ArgumentError mapcols(x -> x[1] == 1 ? 0 : [0], df_mapcols)
    @test_throws DimensionMismatch mapcols(x -> x[1] == 1 ? [1] : [1, 2], df_mapcols)
    @test_throws ArgumentError mapcols(x -> x[1] == 1 ? x : 0, df_mapcols)
    @test_throws ArgumentError mapcols(x -> x[1] != 1 ? x : 0, df_mapcols)
    df_mapcols2 = mapcols(x -> x, df_mapcols)
    @test df_mapcols2 == df_mapcols
    @test df_mapcols2.a !== df_mapcols.a
    @test df_mapcols2.b !== df_mapcols.b

    df = DataFrame(a=1)
    df = mapcols(x -> 2:2, df)
    @test df == DataFrame(a=2)
    @test df.a isa Vector{Int}

    df = DataFrame(a1=[1, 2], a2=[2, 3], b=[3, 4])
    @test mapcols(x -> 2x, df, cols=r"a") == DataFrame(a1=[2, 4], a2=[4, 6], b=[3, 4])
    @test mapcols(x -> 2x, df, cols="b") == DataFrame(a1=[1, 2], a2=[2, 3], b=[6, 8])
    @test mapcols(x -> 2x, df, cols=Not(r"a")) == DataFrame(a1=[1, 2], a2=[2, 3], b=[6, 8])
    @test mapcols(x -> 2x, df, cols=Int) == DataFrame(a1=[2, 4], a2=[4, 6], b=[6, 8])
    @test mapcols(x -> 2x, df, cols=Not(All())) == DataFrame(a1=[1, 2], a2=[2, 3], b=[3, 4])
    @test mapcols(x -> 2x, df, cols=:) == DataFrame(a1=[2, 4], a2=[4, 6], b=[6, 8])

    df2 = mapcols(x -> 2x, df, cols="b")
    @test df2.a1 == df.a1 && df2.a1 !== df.a1
    @test df2.a2 == df.a2 && df2.a2 !== df.a2
    @test df2.b == 2*df.b
end

@testset "mapcols!" begin
    df_empty = DataFrame()
    @test mapcols!(sum, df_empty) === df_empty

    df_mapcols = DataFrame(a=1:10, b=11:20)
    @test mapcols!(sum, df_mapcols) === df_mapcols
    @test df_mapcols == DataFrame(a=55, b=155)

    df_mapcols = DataFrame(a=1:10, b=11:20)
    mapcols!(x -> 1, df_mapcols)
    @test df_mapcols == DataFrame(a=1, b=1)

    df_mapcols = DataFrame(a=1:10, b=11:20)
    @test_throws ArgumentError mapcols!(x -> x[1] == 1 ? 0 : [0], df_mapcols)
    @test_throws DimensionMismatch mapcols!(x -> x[1] == 1 ? [1] : [1, 2], df_mapcols)
    @test_throws ArgumentError mapcols!(x -> x[1] == 1 ? x : 0, df_mapcols)
    @test_throws ArgumentError mapcols!(x -> x[1] != 1 ? x : 0, df_mapcols)
    @test df_mapcols == DataFrame(a=1:10, b=11:20)

    a = df_mapcols.a
    b = df_mapcols.b
    mapcols!(x -> x, df_mapcols)
    @test a === df_mapcols.a
    @test b === df_mapcols.b

    df = DataFrame(a=1)
    mapcols!(x -> 2:2, df)
    @test df == DataFrame(a=2)
    @test df.a isa Vector{Int}

    df = DataFrame(a1=[1, 2], a2=[2, 3], b=[3, 4])
    @test mapcols!(x -> 2x, copy(df), cols=r"a") == DataFrame(a1=[2, 4], a2=[4, 6], b=[3, 4])
    @test mapcols!(x -> 2x, copy(df), cols="b") == DataFrame(a1=[1, 2], a2=[2, 3], b=[6, 8])
    @test mapcols!(x -> 2x, copy(df), cols=Not(r"a")) == DataFrame(a1=[1, 2], a2=[2, 3], b=[6, 8])
    @test mapcols!(x -> 2x, copy(df), cols=Int) == DataFrame(a1=[2, 4], a2=[4, 6], b=[6, 8])
    @test mapcols!(x -> 2x, copy(df), cols=Not(All())) == DataFrame(a1=[1, 2], a2=[2, 3], b=[3, 4])
    @test mapcols!(x -> 2x, copy(df), cols=:) == DataFrame(a1=[2, 4], a2=[4, 6], b=[6, 8])
    a1, a2, b = eachcol(df)
    mapcols!(x -> 2x, df, cols=Not(All()))
    @test df == DataFrame(a1=[1, 2], a2=[2, 3], b=[3, 4])
    @test df.a1 === a1 && df.a2 === a2 && df.b === b
end

@testset "SubDataFrame" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)
    sdf = view(df, [3, 1, 4], [3, 1, 4])
    @test sdf == df[[3, 1, 4], [3, 1, 4]]
    @test eachrow(sdf) == eachrow(df[[3, 1, 4], [3, 1, 4]])
    @test size(eachrow(sdf)) == (3,)
    @test eachcol(sdf) == eachcol(df[[3, 1, 4], [3, 1, 4]])
    @test length(eachcol(sdf)) == 3
end

@testset "parent mutation" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)
    sdf = view(df, [3, 1, 4], [3, 1, 4])
    erd = eachrow(df)
    erv = eachrow(sdf)
    rename!(df, Symbol.(string.("y", 1:4)))
    df[!, 1] = 51:56
    @test df[1, :] == erd[1]
    @test copy(erv[1]) == (y3=33, y1=53, y4=43)
    df[!, :z] .= 1
    @test length(erd[1]) == 5 # the added column is reflected
    select!(df, Not([4, 5]))
    @test copy(erd[1]) == (y1 = 51, y2 = 21, y3 = 31) # the removed columns are reflected
end

@testset "getproperty and propertynames" begin
    df_base = DataFrame([11:16 21:26 31:36 41:46], :auto)
    for df in (df_base, view(df_base, 1:3, 1:3))
        for x in (eachcol(df), eachrow(df))
            @test propertynames(x) == propertynames(df)
            for n in names(df)
                @test getproperty(x, n) === getproperty(df, n)
            end
            @test_throws ArgumentError x.a
        end
    end
end

@testset "overload Compat functions" begin
    @testset "DataFrames.$f === Compat.$f" for f in intersect(names(DataFrames), names(Compat))
        @test getproperty(DataFrames, f) === getproperty(Compat, f)
    end
end

@testset "keys, values and pairs for eachcol" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)

    cols = eachcol(df)

    @test keys(cols) == propertynames(df)
    for (a, b, c) in zip(keys(cols), cols, pairs(cols))
        @test (a => b) == c
    end

    for (i, n) in enumerate(keys(cols))
        @test cols[i] === cols[n]
    end
    @test_throws ArgumentError cols[:non_existent]

    @test values(cols) == collect(cols)
end

@testset "findfirst, findnext, findlast, findprev, findall" begin
    df = DataFrame(a=[1, 2, 1, 2], b=["1", "2", "1", "2"],
                   c=[1, 2, 1, 2], d=["1", "2", "1", "2"])

    rows = eachrow(df)
    @test findfirst(row -> row.a == 1, rows) == 1
    @test findnext(row -> row.a == 1, rows, 2) == 3
    @test findlast(row -> row.a == 1, rows) == 3
    @test findprev(row -> row.a == 1, rows, 2) == 1
    @test findall(row -> row.a == 1, rows) == [1, 3]

    cols = eachcol(df)
    @test findfirst(col -> eltype(col) <: Int, cols) == 1
    @test findnext(col -> eltype(col) <: Int, cols, 2) == 3
    @test findnext(col -> eltype(col) <: Int, cols, 10) === nothing
    @test_throws BoundsError findnext(col -> eltype(col) <: Int, cols, -1)
    @test_throws ArgumentError findnext(col -> eltype(col) <: Int, cols, :x1)
    @test_throws ArgumentError findnext(col -> eltype(col) <: Int, cols, "x1")
    @test findnext(col -> eltype(col) <: Int, cols, :b) == 3
    @test findnext(col -> eltype(col) <: Int, cols, "b") == 3
    @test findlast(col -> eltype(col) <: Int, cols) == 3
    @test findprev(col -> eltype(col) <: Int, cols, 2) == 1
    @test findprev(col -> eltype(col) <: Int, cols, :b) == 1
    @test findprev(col -> eltype(col) <: Int, cols, "b") == 1
    @test findprev(col -> eltype(col) <: Int, cols, -1) === nothing
    @test_throws BoundsError findprev(col -> eltype(col) <: Int, cols, 10)
    @test_throws ArgumentError findprev(col -> eltype(col) <: Int, cols, :x1)
    @test_throws ArgumentError findprev(col -> eltype(col) <: Int, cols, "x1")
    @test findall(col -> eltype(col) <: Int, cols) == [1, 3]
end

@testset "multirow indexing of DataFrameRows" begin
    df = DataFrame(a=1:4, b=11:14)
    er = eachrow(df)
    for sel in (1:2, Not(3:4), [true, true, false, false])
        er2 = er[sel]
        @test er2 isa DataFrames.DataFrameRows
        @test parent(er2) isa SubDataFrame
        @test parent(parent(er2)) === df
        @test collect(er2) == [er[1], er[2]]
    end
    er2 = er[:]
    @test er2 == er
    @test er2 isa DataFrames.DataFrameRows
    er2 = er[2:1]
    @test length(er2) == 0
    @test isempty(parent(er2))

    # this is still allowed
    er2 = er[1:2, 1]
    @test er2 isa Vector{DataFrameRow}
    @test er2 == er[1:2]
end

@testset "test unaliasing of index" begin
    for idx in ([2, 3], [0x2, 0x3], 2:3, Not([1, 4]),
                [false, true, true, false], big.([2, 3]), big.(2:3), :)
        df = DataFrame(a=1:4)
        er = eachrow(df)
        er2 = er[idx]
        len = length(er2)
        @test len == (idx === Colon() ? 4 : 2)
        p = parent(er2)
        @test p isa SubDataFrame
        @test parentindices(p)[1] == (1:4)[idx]
        if !(idx isa UnitRange)
            @test parentindices(p)[1] !== idx
        end
        if idx isa Vector
            empty!(idx)
        end
        @test length(er2) == len

        er3 = filter(x -> x.a <= 2, er)
        @test length(er3) == 2
        @test parent(er3) isa SubDataFrame
        @test parentindices(parent(er3))[1] == 1:2
    end

end

@testset "haskey and get for DataFrameColumns" begin
    df_ref = DataFrame(a=1:3, b=2:4, c=3:5)
    for df in (df_ref, @view df_ref[1:3, 1:2])
        dfc = eachcol(df)
        @test !haskey(dfc, 0)
        @test haskey(dfc, 1)
        @test haskey(dfc, 2)
        @test !haskey(dfc, 4)
        @test !haskey(dfc, 0x0)
        @test haskey(dfc, 0x1)
        @test !haskey(dfc, :x)
        @test !haskey(dfc, "x")
        @test !haskey(dfc, Test.GenericString("x"))
        @test haskey(dfc, :a)
        @test haskey(dfc, "a")
        @test haskey(dfc, Test.GenericString("a"))

        @test get(dfc, 0, "error") == "error"
        @test get(dfc, 1, "error") == 1:3
        @test get(dfc, 4, "error") == "error"
        @test get(dfc, 0x0, "error") == "error"
        @test get(dfc, 0x1, "error") == 1:3
        @test get(dfc, :x, "error") == "error"
        @test get(dfc, "x", "error") == "error"
        @test get(dfc, Test.GenericString("x"), "error") == "error"
        @test get(dfc, :a, "error") == 1:3
        @test get(dfc, "a", "error") == 1:3
        @test get(dfc, Test.GenericString("a"), "error") == 1:3
        @test_throws MethodError get(dfc, "a")
    end
end

end # module

#
# Correctness Tests
#

fatalerrors = length(ARGS) > 0 && ARGS[1] == "-f"
quiet = length(ARGS) > 0 && ARGS[1] == "-q"
anyerrors = false

using DataFrames, Dates, Test, Random, InlineStrings

if Threads.nthreads() < 2
    @warn("Running tests with only one thread: correctness of parallel operations is not checked")
else
    @info("Running tests with $(Threads.nthreads()) threads")
end

ambiguities_vec = Test.detect_ambiguities(DataFrames, recursive=true)
if !isempty(ambiguities_vec)
    @error "Method ambiguities:"
    display(ambiguities_vec)
    throw(AssertionError("method dispatch ambiguities found"))
end

unbound_args_vec = Test.detect_unbound_args(DataFrames, recursive=true)
if !isempty(unbound_args_vec)
    @error "Unbound type parameters:"
    display(unbound_args_vec)
    throw(AssertionError("unbound type parameters found"))
end

my_tests = ["utils.jl",
            "cat.jl",
            "data.jl",
            "index.jl",
            "dataframe.jl",
            "insertion.jl",
            "select.jl",
            "reshape.jl",
            "dataframerow.jl",
            "io.jl",
            "constructors.jl",
            "conversions.jl",
            "sort.jl",
            "grouping.jl",
            "subset.jl",
            "join.jl",
            "iteration.jl",
            "duplicates.jl",
            "show.jl",
            "subdataframe.jl",
            "subdataframe_mutation.jl",
            "tables.jl",
            "tabletraits.jl",
            "indexing.jl",
            "broadcasting.jl",
            "string.jl",
            "multithreading.jl",
            "metadata.jl",
            "deprecated.jl"]

println("Running tests:")

for my_test in my_tests
    try
        include(my_test)
        println("\t\033[1m\033[32mPASSED\033[0m: $(my_test)")
    catch e
        global anyerrors = true
        println("\t\033[1m\033[31mFAILED\033[0m: $(my_test)")
        if fatalerrors
            rethrow(e)
        elseif !quiet
            showerror(stdout, e, backtrace())
            println()
        end
    end
end

if anyerrors
    throw("Tests failed")
end

"""
    AbstractDataFrame

An abstract type for which all concrete types expose an interface
for working with tabular data.

An `AbstractDataFrame` is a two-dimensional table with `Symbol`s or strings
for column names.

DataFrames.jl defines two types that are subtypes of `AbstractDataFrame`:
[`DataFrame`](@ref) and [`SubDataFrame`](@ref).

# Indexing and broadcasting

`AbstractDataFrame` can be indexed by passing two indices specifying
row and column selectors. The allowed indices are a superset of indices
that can be used for standard arrays. You can also access a single column
of an `AbstractDataFrame` using `getproperty` and `setproperty!` functions.
Columns can be selected using integers, `Symbol`s, or strings.
In broadcasting `AbstractDataFrame` behavior is similar to a `Matrix`.

A detailed description of `getindex`, `setindex!`, `getproperty`, `setproperty!`,
broadcasting and broadcasting assignment for data frames is given in the
["Indexing" section](https://juliadata.github.io/DataFrames.jl/stable/lib/indexing/)
of the manual.
"""
abstract type AbstractDataFrame end

"""
    names(df::AbstractDataFrame, cols=:)
    names(df::DataFrameRow, cols=:)
    names(df::GroupedDataFrame, cols=:)
    names(df::DataFrameRows, cols=:)
    names(df::DataFrameColumns, cols=:)
    names(df::GroupKey)

Return a freshly allocated `Vector{String}` of names of columns contained in `df`.

If `cols` is passed then restrict returned column names to those matching the
selector (this is useful in particular with regular expressions, `Cols`, `Not`, and `Between`).
`cols` can be:
* any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR); these column
  selectors are documented in the [General rules](@ref) section of the [Indexing](@ref)
  part of the DataFrames.jl manual
* a `Type`, in which case names of columns whose `eltype` is a subtype of `T`
  are returned
* a `Function` predicate taking the column name as a string and returning `true`
  for columns that should be kept

See also [`propertynames`](@ref) which returns a `Vector{Symbol}`
(except for `GroupedDataFrame` in which case use `Symbol.(names(df))`).

# Examples

```jldoctest
julia> df = DataFrame(x1=[1, missing, missing], x2=[3, 2, 4], x3=[3, missing, 2], x4=Union{Int, Missing}[2, 4, 4])
3×4 DataFrame
 Row │ x1       x2     x3       x4
     │ Int64?   Int64  Int64?   Int64?
─────┼─────────────────────────────────
   1 │       1      3        3       2
   2 │ missing      2  missing       4
   3 │ missing      4        2       4

julia> names(df)
4-element Vector{String}:
 "x1"
 "x2"
 "x3"
 "x4"

julia> names(df, Int) # pick columns whose element type is Int
1-element Vector{String}:
 "x2"

julia> names(df, x -> x[end] == '2') # pick columns for which last character in their name is '2'
1-element Vector{String}:
 "x2"

julia> fun(col) = sum(skipmissing(col)) >= 10
fun (generic function with 1 method)

julia> names(df, fun.(eachcol(df))) # pick columns for which sum of their elements is at least 10
1-element Vector{String}:
 "x4"

julia> names(df, eltype.(eachcol(df)) .>: Missing) # pick columns that allow missing values
3-element Vector{String}:
 "x1"
 "x3"
 "x4"

julia> names(df, any.(ismissing, eachcol(df))) # pick columns that contain missing values
2-element Vector{String}:
 "x1"
 "x3"
```
"""
Base.names(df::AbstractDataFrame, cols::Colon=:) = names(index(df))

function Base.names(df::AbstractDataFrame, cols)
    nms = _names(index(df))
    idx = index(df)[cols]
    idxs = idx isa Int ? (idx:idx) : idx
    return [String(nms[i]) for i in idxs]
end

Base.names(df::AbstractDataFrame, T::Type) =
    [String(n) for (n, c) in pairs(eachcol(df)) if eltype(c) <: T]
Base.names(df::AbstractDataFrame, fun::Function) = filter!(fun, names(df))

# _names returns Vector{Symbol} without copying
_names(df::AbstractDataFrame) = _names(index(df))

# separate methods are needed due to dispatch ambiguity
Compat.hasproperty(df::AbstractDataFrame, s::Symbol) = haskey(index(df), s)
Compat.hasproperty(df::AbstractDataFrame, s::AbstractString) = haskey(index(df), s)

"""
    rename!(df::AbstractDataFrame, vals::AbstractVector{Symbol};
            makeunique::Bool=false)
    rename!(df::AbstractDataFrame, vals::AbstractVector{<:AbstractString};
            makeunique::Bool=false)
    rename!(df::AbstractDataFrame, (from => to)::Pair...)
    rename!(df::AbstractDataFrame, d::AbstractDict)
    rename!(df::AbstractDataFrame, d::AbstractVector{<:Pair})
    rename!(f::Function, df::AbstractDataFrame; cols=All())

Rename columns of `df` in-place.
Each name is changed at most once. Permutation of names is allowed.

# Arguments
- `df` : the `AbstractDataFrame`
- `d` : an `AbstractDict` or an `AbstractVector` of `Pair`s that maps
  the original names or column numbers to new names
- `f` : a function which for each column selected by the `cols` keyword argument
  takes the old name as a `String`
  and returns the new name that gets converted to a `Symbol`; the `cols`
  column selector can be any value accepted as column selector by the `names` function
- `vals` : new column names as a vector of `Symbol`s or `AbstractString`s
  of the same length as the number of columns in `df`
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found; if `true`, duplicate names will be suffixed
  with `_i` (`i` starting at 1 for the first duplicate).

If pairs are passed to `rename!` (as positional arguments or in a dictionary or
a vector) then:
* `from` value can be a `Symbol`, an `AbstractString` or an `Integer`;
* `to` value can be a `Symbol` or an `AbstractString`.

Mixing symbols and strings in `to` and `from` is not allowed.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).
Column-level `:note`-style metadata is considered to be attached to column number:
when a column is renamed, its `:note`-style metadata becomes associated to its new name.

See also: [`rename`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(i=1, x=2, y=3)
1×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename!(df, Dict(:i => "A", :x => "X"))
1×3 DataFrame
 Row │ A      X      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename!(df, [:a, :b, :c])
1×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename!(df, [:a, :b, :a])
ERROR: ArgumentError: Duplicate variable names: :a. Pass makeunique=true to make them unique using a suffix automatically.

julia> rename!(df, [:a, :b, :a], makeunique=true)
1×3 DataFrame
 Row │ a      b      a_1
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename!(uppercase, df)
1×3 DataFrame
 Row │ A      B      A_1
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename!(lowercase, df, cols=contains('A'))
1×3 DataFrame
 Row │ a      B      a_1
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

```
"""
function rename!(df::AbstractDataFrame, vals::AbstractVector{Symbol};
                 makeunique::Bool=false)
    rename!(index(df), vals, makeunique=makeunique)
    # renaming columns of SubDataFrame has to clean non-note metadata in its parent
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function rename!(df::AbstractDataFrame, vals::AbstractVector{<:AbstractString};
                 makeunique::Bool=false)
    rename!(index(df), Symbol.(vals), makeunique=makeunique)
    # renaming columns of SubDataFrame has to clean non-note metadata in its parent
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function rename!(df::AbstractDataFrame, args::AbstractVector{Pair{Symbol, Symbol}})
    rename!(index(df), args)
    # renaming columns of SubDataFrame has to clean non-note metadata in its parent
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function rename!(df::AbstractDataFrame,
                 args::Union{AbstractVector{<:Pair{Symbol, <:AbstractString}},
                             AbstractVector{<:Pair{<:AbstractString, Symbol}},
                             AbstractVector{<:Pair{<:AbstractString, <:AbstractString}},
                             AbstractDict{Symbol, Symbol},
                             AbstractDict{Symbol, <:AbstractString},
                             AbstractDict{<:AbstractString, Symbol},
                             AbstractDict{<:AbstractString, <:AbstractString}})
    rename!(index(df), [Symbol(from) => Symbol(to) for (from, to) in args])
    # renaming columns of SubDataFrame has to clean non-note metadata in its parent
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function rename!(df::AbstractDataFrame,
                 args::Union{AbstractVector{<:Pair{<:Integer, <:AbstractString}},
                             AbstractVector{<:Pair{<:Integer, Symbol}},
                             AbstractDict{<:Integer, <:AbstractString},
                             AbstractDict{<:Integer, Symbol}})
    rename!(index(df), [_names(df)[from] => Symbol(to) for (from, to) in args])
    # renaming columns of SubDataFrame has to clean non-note metadata in its parent
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

 # needed because of dispatch ambiguity
function rename!(df::AbstractDataFrame)
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

rename!(df::AbstractDataFrame, args::Pair...) = rename!(df, collect(args))

rename!(f::Function, df::AbstractDataFrame; cols=All()) =
    rename!(df, [n => Symbol(f(n)) for n in names(df, cols)])

"""
    rename(df::AbstractDataFrame, vals::AbstractVector{Symbol};
           makeunique::Bool=false)
    rename(df::AbstractDataFrame, vals::AbstractVector{<:AbstractString};
           makeunique::Bool=false)
    rename(df::AbstractDataFrame, (from => to)::Pair...)
    rename(df::AbstractDataFrame, d::AbstractDict)
    rename(df::AbstractDataFrame, d::AbstractVector{<:Pair})
    rename(f::Function, df::AbstractDataFrame; cols=All())

Create a new data frame that is a copy of `df` with changed column names.
Each name is changed at most once. Permutation of names is allowed.

# Arguments
- `df` : the `AbstractDataFrame`; if it is a `SubDataFrame` then renaming is
  only allowed if it was created using `:` as a column selector.
- `d` : an `AbstractDict` or an `AbstractVector` of `Pair`s that maps
  the original names or column numbers to new names
- `f` : a function which for each column selected by the `cols` keyword argument
  takes the old name as a `String`
  and returns the new name that gets converted to a `Symbol`; the `cols`
  column selector can be any value accepted as column selector by the `names` function
- `vals` : new column names as a vector of `Symbol`s or `AbstractString`s
  of the same length as the number of columns in `df`
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found; if `true`, duplicate names will be suffixed
  with `_i` (`i` starting at 1 for the first duplicate).

If pairs are passed to `rename` (as positional arguments or in a dictionary or
a vector) then:
* `from` value can be a `Symbol`, an `AbstractString` or an `Integer`;
* `to` value can be a `Symbol` or an `AbstractString`.

Mixing symbols and strings in `to` and `from` is not allowed.

$METADATA_FIXED
Column-level `:note`-style metadata is considered to be attached to column number:
when a column is renamed, its `:note`-style metadata becomes associated to its
new name.

See also: [`rename!`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(i=1, x=2, y=3)
1×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(df, [:a, :b, :c])
1×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(df, :i => "A", :x => "X")
1×3 DataFrame
 Row │ A      X      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(df, :x => :y, :y => :x)
1×3 DataFrame
 Row │ i      y      x
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(df, [1 => :A, 2 => :X])
1×3 DataFrame
 Row │ A      X      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(df, Dict("i" => "A", "x" => "X"))
1×3 DataFrame
 Row │ A      X      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(uppercase, df)
1×3 DataFrame
 Row │ I      X      Y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> rename(uppercase, df, cols=contains('x'))
1×3 DataFrame
 Row │ i      X      y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

```
"""
rename(df::AbstractDataFrame, vals::AbstractVector{Symbol};
       makeunique::Bool=false) = rename!(copy(df), vals, makeunique=makeunique)
rename(df::AbstractDataFrame, vals::AbstractVector{<:AbstractString};
       makeunique::Bool=false) = rename!(copy(df), vals, makeunique=makeunique)
rename(df::AbstractDataFrame, args...) = rename!(copy(df), args...)
rename(f::Function, df::AbstractDataFrame; cols=All()) = rename!(f, copy(df); cols=cols)

"""
    size(df::AbstractDataFrame[, dim])

Return a tuple containing the number of rows and columns of `df`.
Optionally a dimension `dim` can be specified, where `1` corresponds to rows
and `2` corresponds to columns.

See also: [`nrow`](@ref), [`ncol`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(a=1:3, b='a':'c');

julia> size(df)
(3, 2)

julia> size(df, 1)
3
```
"""
Base.size(df::AbstractDataFrame) = (nrow(df), ncol(df))
function Base.size(df::AbstractDataFrame, i::Integer)
    if i == 1
        nrow(df)
    elseif i == 2
        ncol(df)
    else
        throw(ArgumentError("DataFrames only have two dimensions"))
    end
end

"""
    ncol(df::AbstractDataFrame)

Return the number of columns in an `AbstractDataFrame` `df`.

See also [`nrow`](@ref), [`size`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:10, x=rand(10), y=rand(["a", "b", "c"], 10));

julia> ncol(df)
3
```
"""
ncol(df::AbstractDataFrame) = length(index(df))

"""
    isempty(df::AbstractDataFrame)

Return `true` if data frame `df` has zero rows, and `false` otherwise.
"""
Base.isempty(df::AbstractDataFrame) = nrow(df) == 0

Base.axes(df::AbstractDataFrame, i::Integer) = Base.OneTo(size(df, i))

"""
    ndims(::AbstractDataFrame)
    ndims(::Type{<:AbstractDataFrame})

Return the number of dimensions of a data frame, which is always `2`.
"""
Base.ndims(::AbstractDataFrame) = 2
Base.ndims(::Type{<:AbstractDataFrame}) = 2

# separate methods are needed due to dispatch ambiguity
Base.getproperty(df::AbstractDataFrame, col_ind::Symbol) = df[!, col_ind]
Base.getproperty(df::AbstractDataFrame, col_ind::AbstractString) = df[!, col_ind]

# Private fields are never exposed since they can conflict with column names
"""
    propertynames(df::AbstractDataFrame)

Return a freshly allocated `Vector{Symbol}` of names of columns contained in `df`.
"""
Base.propertynames(df::AbstractDataFrame, private::Bool=false) = copy(_names(df))

##############################################################################
##
## Similar
##
##############################################################################

"""
    similar(df::AbstractDataFrame, rows::Integer=nrow(df))

Create a new `DataFrame` with the same column names and column element types
as `df`. An optional second argument can be provided to request a number of rows
that is different than the number of rows present in `df`.

$METADATA_FIXED
"""
function Base.similar(df::AbstractDataFrame, rows::Integer = size(df, 1))
    rows < 0 && throw(ArgumentError("the number of rows must be non-negative"))
    out_df = DataFrame(AbstractVector[similar(x, rows) for x in eachcol(df)],
                       copy(index(df)), copycols=false)
    _copy_all_note_metadata!(out_df, df)
    return out_df
end

"""
    empty(df::AbstractDataFrame)

Create a new `DataFrame` with the same column names and column element types
as `df` but with zero rows.

$METADATA_FIXED
"""
Base.empty(df::AbstractDataFrame) = similar(df, 0)

function Base.:(==)(df1::AbstractDataFrame, df2::AbstractDataFrame)
    size(df1, 2) == size(df2, 2) || return false
    isequal(index(df1), index(df2)) || return false
    eq = true
    for idx in 1:size(df1, 2)
        coleq = df1[!, idx] == df2[!, idx]
        # coleq could be missing
        isequal(coleq, false) && return false
        eq &= coleq
    end
    return eq
end

function Base.isequal(df1::AbstractDataFrame, df2::AbstractDataFrame)
    size(df1, 2) == size(df2, 2) || return false
    isequal(index(df1), index(df2)) || return false
    for idx in 1:size(df1, 2)
        isequal(df1[!, idx], df2[!, idx]) || return false
    end
    return true
end

"""
    isapprox(df1::AbstractDataFrame, df2::AbstractDataFrame;
             rtol::Real=atol>0 ? 0 : √eps, atol::Real=0,
             nans::Bool=false, norm::Function=norm)

Inexact equality comparison. `df1` and `df2` must have the same size and column names.
Return  `true` if `isapprox` with given keyword arguments
applied to all pairs of columns stored in `df1` and `df2` returns `true`.
"""
function Base.isapprox(df1::AbstractDataFrame, df2::AbstractDataFrame;
                       atol::Real=0, rtol::Real=atol>0 ? 0 : √eps(),
                       nans::Bool=false, norm::Function=norm)
    if size(df1) != size(df2)
        throw(DimensionMismatch("dimensions must match: a has dims " *
                                "$(size(df1)), b has dims $(size(df2))"))
    end
    if !isequal(index(df1), index(df2))
        throw(ArgumentError("column names of passed data frames do not match"))
    end
    return all(isapprox.(eachcol(df1), eachcol(df2), atol=atol, rtol=rtol, nans=nans, norm=norm))
end

"""
    only(df::AbstractDataFrame)

If `df` has a single row return it as a `DataFrameRow`; otherwise throw `ArgumentError`.

$METADATA_FIXED
"""
function Base.only(df::AbstractDataFrame)
    n = nrow(df)
    n != 1 && throw(ArgumentError("data frame must contain exactly 1 row, got $n"))
    return df[1, :]
end

"""
    first(df::AbstractDataFrame)

Get the first row of `df` as a `DataFrameRow`.

$METADATA_FIXED
"""
Base.first(df::AbstractDataFrame) = df[1, :]

"""
    first(df::AbstractDataFrame, n::Integer; view::Bool=false)

Get a data frame with the `n` first rows of `df`.
Get all rows if `n` is greater than the number of rows in `df`.
Error if `n` is negative.

If `view=false` a freshly allocated `DataFrame` is returned.
If `view=true` then a `SubDataFrame` view into `df` is returned.

$METADATA_FIXED
"""
@inline function Base.first(df::AbstractDataFrame, n::Integer; view::Bool=false)
    n < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    r = min(n, nrow(df))
    return view ? Base.view(df, 1:r, :) : df[1:r, :]
end

"""
    last(df::AbstractDataFrame)

Get the last row of `df` as a `DataFrameRow`.

$METADATA_FIXED
"""
Base.last(df::AbstractDataFrame) = df[nrow(df), :]

"""
    last(df::AbstractDataFrame, n::Integer; view::Bool=false)

Get a data frame with the `n` last rows of `df`.
Get all rows if `n` is greater than the number of rows in `df`.
Error if `n` is negative.

If `view=false` a freshly allocated `DataFrame` is returned.
If `view=true` then a `SubDataFrame` view into `df` is returned.

$METADATA_FIXED
"""
@inline function Base.last(df::AbstractDataFrame, n::Integer; view::Bool=false)
    n < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    r = max(1, nrow(df) - n + 1)
    return view ? Base.view(df, r:nrow(df), :) : df[r:nrow(df), :]
end

"""
    describe(df::AbstractDataFrame; cols=:)
    describe(df::AbstractDataFrame, stats::Union{Symbol, Pair}...; cols=:)

Return descriptive statistics for a data frame as a new `DataFrame`
where each row represents a variable and each column a summary statistic.

# Arguments
- `df` : the `AbstractDataFrame`
- `stats::Union{Symbol, Pair}...` : the summary statistics to report.
  Arguments can be:
    - A symbol from the list `:mean`, `:std`, `:min`, `:q25`,
      `:median`, `:q75`, `:max`, `:sum`, `:eltype`, `:nunique`, `:nuniqueall`, `:first`,
      `:last`, `:nnonmissing`, and `:nmissing`. The default statistics used are
      `:mean`, `:min`, `:median`, `:max`, `:nmissing`, and `:eltype`.
    - `:detailed` as the only `Symbol` argument to return all statistics
      except `:first`, `:last`, `:sum`, `:nuniqueall`, and `:nnonmissing`.
    - `:all` as the only `Symbol` argument to return all statistics.
    - A `function => name` pair where `name` is a `Symbol` or string. This will
      create a column of summary statistics with the provided name.
- `cols` : a keyword argument allowing to select only a subset or transformation
  of columns from `df` to describe. Can be any column selector or transformation
  accepted by [`select`](@ref).

# Details
For `Real` columns, compute the mean, standard deviation, minimum, first
quantile, median, third quantile, and maximum. If a column does not derive from
`Real`, `describe` will attempt to calculate all statistics, using `nothing` as
a fall-back in the case of an error.

When `stats` contains `:nunique`, `describe` will report the
number of unique values in a column. If a column's base type derives from `Real`,
`:nunique` will return `nothing`s. Use `:nuniqueall` to report the number of
unique values in all columns.

Missing values are filtered in the calculation of all statistics, however the
column `:nmissing` will report the number of missing values of that variable
and `:nnonmissing` the number of non-missing values.

If custom functions are provided, they are called repeatedly with the vector
corresponding to each column as the only argument. For columns allowing for
missing values, the vector is wrapped in a call to `skipmissing`: custom
functions must therefore support such objects (and not only vectors), and cannot
access missing values.

Metadata: this function drops all metadata.

# Examples

```jldoctest
julia> df = DataFrame(i=1:10, x=0.1:0.1:1.0, y='a':'j');

julia> describe(df)
3×7 DataFrame
 Row │ variable  mean    min  median  max  nmissing  eltype
     │ Symbol    Union…  Any  Union…  Any  Int64     DataType
─────┼────────────────────────────────────────────────────────
   1 │ i         5.5     1    5.5     10          0  Int64
   2 │ x         0.55    0.1  0.55    1.0         0  Float64
   3 │ y                 a            j           0  Char

julia> describe(df, :min, :max)
3×3 DataFrame
 Row │ variable  min  max
     │ Symbol    Any  Any
─────┼────────────────────
   1 │ i         1    10
   2 │ x         0.1  1.0
   3 │ y         a    j

julia> describe(df, :min, sum => :sum)
3×3 DataFrame
 Row │ variable  min  sum
     │ Symbol    Any  Union…
─────┼───────────────────────
   1 │ i         1    55
   2 │ x         0.1  5.5
   3 │ y         a

julia> describe(df, :min, sum => :sum, cols=:x)
1×3 DataFrame
 Row │ variable  min      sum
     │ Symbol    Float64  Float64
─────┼────────────────────────────
   1 │ x             0.1      5.5
```
"""
DataAPI.describe(df::AbstractDataFrame,
                 stats::Union{Symbol, Pair{<:Base.Callable, <:SymbolOrString}}...;
                 cols=:) =
    _describe(_try_select_no_copy(df, cols), Any[s for s in stats])

DataAPI.describe(df::AbstractDataFrame; cols=:) =
    _describe(_try_select_no_copy(df, cols),
              Any[:mean, :min, :median, :max, :nmissing, :eltype])

function _describe(df::AbstractDataFrame, stats::AbstractVector)
    predefined_funs = Symbol[s for s in stats if s isa Symbol]

    allowed_fields = [:mean, :std, :min, :q25, :median, :q75, :max, :sum,
                      :nunique, :nuniqueall, :nmissing, :nnonmissing,
                      :first, :last, :eltype]

    if predefined_funs == [:all]
        predefined_funs = allowed_fields
        i = findfirst(s -> s == :all, stats)
        splice!(stats, i, allowed_fields) # insert in the stats vector to get a good order
    elseif predefined_funs == [:detailed]
        predefined_funs = [:mean, :std, :min, :q25, :median, :q75,
                           :max, :nunique, :nmissing, :eltype]
        i = findfirst(s -> s == :detailed, stats)
        splice!(stats, i, predefined_funs) # insert in the stats vector to get a good order
    elseif :all in predefined_funs || :detailed in predefined_funs
        throw(ArgumentError("`:all` and `:detailed` must be the only `Symbol` argument."))
    elseif !issubset(predefined_funs, allowed_fields)
        not_allowed = join(setdiff(predefined_funs, allowed_fields), ", :")
        allowed_msg = "\nAllowed fields are: :" * join(allowed_fields, ", :")
        throw(ArgumentError(":$not_allowed not allowed." * allowed_msg))
    end

    custom_funs = Any[s[1] => Symbol(s[2]) for s in stats if s isa Pair]

    ordered_names = [s isa Symbol ? s : Symbol(last(s)) for s in stats]

    if !allunique(ordered_names)
        df_ord_names = DataFrame(ordered_names = ordered_names)
        duplicate_names = unique(ordered_names[nonunique(df_ord_names)])
        throw(ArgumentError("Duplicate names not allowed. Duplicated value(s) are: " *
                            ":$(join(duplicate_names, ", "))"))
    end

    # Put the summary stats into the return data frame
    data = DataFrame()
    data.variable = propertynames(df)

    # An array of Dicts for summary statistics
    col_stats_dicts = map(eachcol(df)) do col
        if eltype(col) >: Missing
            t = skipmissing(col)
            d = get_stats(t, predefined_funs)
            get_stats!(d, t, custom_funs)
        else
            d = get_stats(col, predefined_funs)
            get_stats!(d, col, custom_funs)
        end

        if :nmissing in predefined_funs
            d[:nmissing] = count(ismissing, col)
        end

        if :nnonmissing in predefined_funs
            d[:nnonmissing] = count(!ismissing, col)
        end

        if :first in predefined_funs
            d[:first] = isempty(col) ? nothing : first(col)
        end

        if :last in predefined_funs
            d[:last] = isempty(col) ? nothing : last(col)
        end

        if :eltype in predefined_funs
            d[:eltype] = eltype(col)
        end

        return d
    end

    for stat in ordered_names
        # for each statistic, loop through the columns array to find values
        # letting the comprehension choose the appropriate type
        data[!, stat] = [d[stat] for d in col_stats_dicts]
    end

    return data
end

# Compute summary statistics
# use a dict because we don't know which measures the user wants
# Outside of the `describe` function due to something with 0.7
function get_stats(@nospecialize(col::Union{AbstractVector, Base.SkipMissing}),
                   stats::AbstractVector{Symbol})
    d = Dict{Symbol, Any}()

    if :q25 in stats || :median in stats || :q75 in stats
        # types that do not support basic arithmetic (like strings) will only fail
        # after sorting the data, so check this beforehand to fail early
        T = eltype(col)
        if isconcretetype(T) && !hasmethod(-, Tuple{T, T})
            d[:q25] = d[:median] = d[:q75] = nothing
        else
            mcol = Base.copymutable(col)
            if :q25 in stats
                d[:q25] = try quantile!(mcol, 0.25) catch; nothing; end
            end
            if :median in stats
                d[:median] = try quantile!(mcol, 0.50) catch; nothing; end
            end
            if :q75 in stats
                d[:q75] = try quantile!(mcol, 0.75) catch; nothing; end
            end
        end
    end

    if :min in stats || :max in stats
        ex = try extrema(col) catch; (nothing, nothing) end
        d[:min] = ex[1]
        d[:max] = ex[2]
    end

    if :mean in stats || :std in stats
        m = try mean(col) catch end
        # we can add non-necessary things to d, because we choose what we need
        # in the main function
        d[:mean] = m

        if :std in stats
            d[:std] = try std(col, mean = m) catch end
        end
    end

    if :nunique in stats
        if eltype(col) <: Real
            d[:nunique] = nothing
        else
            d[:nunique] = try length(Set(col)) catch end
        end
    end

    if :nuniqueall in stats
        d[:nuniqueall] = try length(Set(col)) catch end
    end

    if :sum in stats
        d[:sum] = try sum(col) catch end
    end

    return d
end

function get_stats!(d::Dict, @nospecialize(col::Union{AbstractVector, Base.SkipMissing}),
                    stats::Vector{Any})
    for stat in stats
        d[stat[2]] = try stat[1](col) catch end
    end
end

"""
    completecases(df::AbstractDataFrame, cols=:)

Return a Boolean vector with `true` entries indicating rows without missing values
(complete cases) in data frame `df`.

If `cols` is provided, only missing values in the corresponding columns are considered.
`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR)
that returns at least one column if `df` has at least one column.

See also: [`dropmissing`](@ref) and [`dropmissing!`](@ref).
Use `findall(completecases(df))` to get the indices of the rows.

# Examples

```jldoctest
julia> df = DataFrame(i=1:5,
                      x=[missing, 4, missing, 2, 1],
                      y=[missing, missing, "c", "d", "e"])
5×3 DataFrame
 Row │ i      x        y
     │ Int64  Int64?   String?
─────┼─────────────────────────
   1 │     1  missing  missing
   2 │     2        4  missing
   3 │     3  missing  c
   4 │     4        2  d
   5 │     5        1  e

julia> completecases(df)
5-element BitVector:
 0
 0
 0
 1
 1

julia> completecases(df, :x)
5-element BitVector:
 0
 1
 0
 1
 1

julia> completecases(df, [:x, :y])
5-element BitVector:
 0
 0
 0
 1
 1
```
"""
function completecases(df::AbstractDataFrame, cols::MultiColumnIndex=:)
    colsidx = index(df)[cols]
    length(colsidx) == 1 && return completecases(df, only(colsidx))

    if ncol(df) > 0 && isempty(colsidx)
        throw(ArgumentError("finding complete cases in data frame when " *
                            "`cols` selects no columns is not allowed"))
    end

    res = trues(size(df, 1))
    ncol(df) == 0 && return res
    aux = BitVector(undef, size(df, 1))
    for i in colsidx
        v = df[!, i]
        if Missing <: eltype(v)
            # Disable fused broadcasting as it happens to be much slower
            aux .= .!ismissing.(v)
            res .&= aux
        end
    end
    return res
end

function completecases(df::AbstractDataFrame, col::ColumnIndex)
    v = df[!, col]
    if Missing <: eltype(v)
        res = BitVector(undef, size(df, 1))
        res .= .!ismissing.(v)
        return res
    else
        return trues(size(df, 1))
    end
end

"""
    dropmissing(df::AbstractDataFrame, cols=:; view::Bool=false, disallowmissing::Bool=!view)

Return a data frame excluding rows with missing values in `df`.

If `cols` is provided, only missing values in the corresponding columns are considered.
`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `view=false` a freshly allocated `DataFrame` is returned.
If `view=true` then a `SubDataFrame` view into `df` is returned. In this case
`disallowmissing` must be `false`.

If `disallowmissing` is `true` (the default when `view` is `false`)
then columns specified in `cols` will be converted so as not to allow for missing
values using [`disallowmissing!`](@ref).

See also: [`completecases`](@ref) and [`dropmissing!`](@ref).

$METADATA_FIXED

# Examples

```jldoctest
julia> df = DataFrame(i=1:5,
                      x=[missing, 4, missing, 2, 1],
                      y=[missing, missing, "c", "d", "e"])
5×3 DataFrame
 Row │ i      x        y
     │ Int64  Int64?   String?
─────┼─────────────────────────
   1 │     1  missing  missing
   2 │     2        4  missing
   3 │     3  missing  c
   4 │     4        2  d
   5 │     5        1  e

julia> dropmissing(df)
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e

julia> dropmissing(df, disallowmissing=false)
2×3 DataFrame
 Row │ i      x       y
     │ Int64  Int64?  String?
─────┼────────────────────────
   1 │     4       2  d
   2 │     5       1  e

julia> dropmissing(df, :x)
3×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String?
─────┼───────────────────────
   1 │     2      4  missing
   2 │     4      2  d
   3 │     5      1  e

julia> dropmissing(df, [:x, :y])
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e
```
"""
@inline function dropmissing(df::AbstractDataFrame,
                             cols::Union{ColumnIndex, MultiColumnIndex}=:;
                             view::Bool=false, disallowmissing::Bool=!view)
    # Identify Bool mask of which rows have no missings
    rowidxs = completecases(df, cols)
    if view
        if disallowmissing
            throw(ArgumentError("disallowmissing=true is incompatible with view=true"))
        end
        return Base.view(df, rowidxs, :)
    else
        # Faster when there are many columns (indexing with integers than via Bool mask)
        # or when there are many missings (as we skip a lot of iterations)
        selected_rows = _findall(rowidxs)
        new_columns = Vector{AbstractVector}(undef, ncol(df))

        # What column indices should disallowmissing be applied to
        cols_inds = BitSet(index(df)[cols])

        use_threads = Threads.nthreads() > 1 && ncol(df) > 1 && length(selected_rows) >= 100_000
        @sync for (i, col) in enumerate(eachcol(df))
            @spawn_or_run use_threads if disallowmissing && (i in cols_inds) &&
                          (Missing <: eltype(col) && eltype(col) !== Any)
                # Perform this path only if column eltype allows missing values
                # except Any, as nonmissingtype(Any) == Any.
                # Under these conditions Missings.disallowmissing must allocate
                # a fresh column
                col_sel = Base.view(col, selected_rows)
                new_col = Missings.disallowmissing(col_sel)
                @assert new_col !== col_sel
                new_columns[i] = new_col
            else
                new_columns[i] = col[selected_rows]
            end
        end

        newdf = DataFrame(new_columns, copy(index(df)), copycols=false)

        _copy_all_note_metadata!(newdf, df)
        return newdf
    end
end

"""
    dropmissing!(df::AbstractDataFrame, cols=:; disallowmissing::Bool=true)

Remove rows with missing values from data frame `df` and return it.

If `cols` is provided, only missing values in the corresponding columns are considered.
`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `disallowmissing` is `true` (the default) then the `cols` columns will
get converted using [`disallowmissing!`](@ref).

$METADATA_FIXED

See also: [`dropmissing`](@ref) and [`completecases`](@ref).

```jldoctest
julia> df = DataFrame(i=1:5,
                      x=[missing, 4, missing, 2, 1],
                      y=[missing, missing, "c", "d", "e"])
5×3 DataFrame
 Row │ i      x        y
     │ Int64  Int64?   String?
─────┼─────────────────────────
   1 │     1  missing  missing
   2 │     2        4  missing
   3 │     3  missing  c
   4 │     4        2  d
   5 │     5        1  e

julia> dropmissing!(copy(df))
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e

julia> dropmissing!(copy(df), disallowmissing=false)
2×3 DataFrame
 Row │ i      x       y
     │ Int64  Int64?  String?
─────┼────────────────────────
   1 │     4       2  d
   2 │     5       1  e

julia> dropmissing!(copy(df), :x)
3×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String?
─────┼───────────────────────
   1 │     2      4  missing
   2 │     4      2  d
   3 │     5      1  e

julia> dropmissing!(df, [:x, :y])
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e
```
"""
function dropmissing!(df::AbstractDataFrame,
                      cols::Union{ColumnIndex, MultiColumnIndex}=:;
                      disallowmissing::Bool=true)
    inds = completecases(df, cols)
    inds .= .!(inds)
    deleteat!(df, inds) # drops non :note-style metadata
    disallowmissing && disallowmissing!(df, cols)
    df
end

"""
    filter(fun, df::AbstractDataFrame; view::Bool=false)
    filter(cols => fun, df::AbstractDataFrame; view::Bool=false)

Return a data frame containing only rows from `df` for which `fun` returns
`true`.

If `cols` is not specified then the predicate `fun` is passed `DataFrameRow`s.
Elements of a `DataFrameRow` may be accessed with dot syntax or column indexing inside `fun`.

If `cols` is specified then the predicate `fun` is passed elements of the
corresponding columns as separate positional arguments, unless `cols` is an
`AsTable` selector, in which case a `NamedTuple` of these arguments is passed.
`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR), and
column duplicates are allowed if a vector of `Symbol`s, strings, or integers is
passed.

If `view=false` a freshly allocated `DataFrame` is returned. If `view=true` then
a `SubDataFrame` view into `df` is returned.

Passing `cols` leads to a more efficient execution of the operation for large
data frames.

!!! note

    This method is defined so that DataFrames.jl implements the Julia API for
    collections, but it is generally recommended to use the [`subset`](@ref)
    function instead as it is consistent with other DataFrames.jl functions
    (as opposed to `filter`).

!!! note

    Due to type stability the `filter(cols => fun, df::AbstractDataFrame; view::Bool=false)`
    call is preferred in performance critical applications.

$METADATA_FIXED

See also: [`filter!`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     2  a
   4 │     1  b

julia> filter(row -> row.x > 1, df)
2×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a

julia> filter(row -> row["x"] > 1, df)
2×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a

julia> filter(:x => x -> x > 1, df)
2×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a

julia> filter([:x, :y] => (x, y) -> x == 1 || y == "b", df)
3×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     1  b

julia> filter(AsTable(:) => nt -> nt.x == 1 || nt.y == "b", df)
3×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     1  b
```
"""
@inline function Base.filter(f, df::AbstractDataFrame; view::Bool=false)
    rowidxs = _filter_helper(f, eachrow(df))
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

@inline function Base.filter((cols, f)::Pair, df::AbstractDataFrame; view::Bool=false)
    int_cols = index(df)[cols] # it will be AbstractVector{Int} or Int
    if length(int_cols) == 0
        rowidxs = [f() for _ in axes(df, 1)]
    else
        rowidxs = _filter_helper(f, (df[!, i] for i in int_cols)...)
    end
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

# this method is needed to allow for passing duplicate columns
@inline function Base.filter((cols, f)::Pair{<:Union{AbstractVector{<:Integer},
                                                     AbstractVector{<:AbstractString},
                                                     AbstractVector{<:Symbol}}},
                             df::AbstractDataFrame; view::Bool=false)
    if length(cols) == 0
        rowidxs = [f() for _ in axes(df, 1)]
    else
        rowidxs = _filter_helper(f, (df[!, i] for i in cols)...)
    end
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

_filter_helper(f, cols...)::AbstractVector{Bool} = ((x...) -> f(x...)::Bool).(cols...)

@inline function Base.filter((cols, f)::Pair{AsTable}, df::AbstractDataFrame;
                             view::Bool=false)
    cols = index(df)[cols.cols]
    df_tmp = select(df, cols, copycols=false)
    if ncol(df_tmp) == 0
        rowidxs = [f(NamedTuple()) for _ in axes(df, 1)]
    else
        rowidxs = _filter_helper_astable(f, Tables.namedtupleiterator(df_tmp))
    end
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

_filter_helper_astable(f, nti::Tables.NamedTupleIterator)::AbstractVector{Bool} = (x -> f(x)::Bool).(nti)

"""
    filter!(fun, df::AbstractDataFrame)
    filter!(cols => fun, df::AbstractDataFrame)

Remove rows from data frame `df` for which `fun` returns `false`.

If `cols` is not specified then the predicate `fun` is passed `DataFrameRow`s.
Elements of a `DataFrameRow` may be accessed with dot syntax or column indexing inside `fun`.

If `cols` is specified then the predicate `fun` is passed elements of the
corresponding columns as separate positional arguments, unless `cols` is an
`AsTable` selector, in which case a `NamedTuple` of these arguments is passed.
`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR), and
column duplicates are allowed if a vector of `Symbol`s, strings, or integers is
passed.

Passing `cols` leads to a more efficient execution of the operation for large
data frames.

!!! note

    This method is defined so that DataFrames.jl implements the Julia API for
    collections, but it is generally recommended to use the [`subset!`](@ref)
    function instead as it is consistent with other DataFrames.jl functions
    (as opposed to `filter!`).

!!! note

    Due to type stability the `filter!(cols => fun, df::AbstractDataFrame)`
    call is preferred in performance critical applications.

$METADATA_FIXED

See also: [`filter`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     2  a
   4 │     1  b

julia> filter!(row -> row.x > 1, df)
2×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a

julia> filter!(row -> row["x"] > 1, df)
2×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a

julia> filter!(:x => x -> x == 3, df)
1×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b

julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"]);

julia> filter!([:x, :y] => (x, y) -> x == 1 || y == "b", df)
3×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     1  b

julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"]);

julia> filter!(AsTable(:) => nt -> nt.x == 1 || nt.y == "b", df)
3×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     1  b
```
"""
Base.filter!(f::Function, df::AbstractDataFrame) = deleteat!(df, findall(!f, eachrow(df)))
Base.filter!((col, f)::Pair{<:ColumnIndex}, df::AbstractDataFrame) =
    _filter!_helper(df, f, df[!, col])
Base.filter!((cols, f)::Pair{<:AbstractVector{Symbol}}, df::AbstractDataFrame) =
    filter!([index(df)[col] for col in cols] => f, df)
Base.filter!((cols, f)::Pair{<:AbstractVector{<:AbstractString}}, df::AbstractDataFrame) =
    filter!([index(df)[col] for col in cols] => f, df)
Base.filter!((cols, f)::Pair, df::AbstractDataFrame) =
    filter!(index(df)[cols] => f, df)
Base.filter!((cols, f)::Pair{<:AbstractVector{Int}}, df::AbstractDataFrame) =
    _filter!_helper(df, f, (df[!, i] for i in cols)...)

function _filter!_helper(df::AbstractDataFrame, f, cols...)
    if length(cols) == 0
        rowidxs = findall(x -> !f(), axes(df, 1))
    else
        rowidxs = findall(((x...) -> !(f(x...)::Bool)).(cols...))
    end
    return deleteat!(df, rowidxs)
end

function Base.filter!((cols, f)::Pair{<:AsTable}, df::AbstractDataFrame)
    cols = index(df)[cols.cols]
    dff = select(df, cols, copycols=false)
    if ncol(dff) == 0
        return deleteat!(df, findall(x -> !f(NamedTuple()), axes(df, 1)))
    else
        return _filter!_helper_astable(df, Tables.namedtupleiterator(dff), f)
    end
end

_filter!_helper_astable(df::AbstractDataFrame, nti::Tables.NamedTupleIterator, f) =
    deleteat!(df, _findall((x -> !(f(x)::Bool)).(nti)))

function Base.Matrix(df::AbstractDataFrame)
    T = reduce(promote_type, (eltype(v) for v in eachcol(df)), init=Union{})
    return Matrix{T}(df)
end

function Base.Matrix{T}(df::AbstractDataFrame) where T
    n, p = size(df)
    res = Matrix{T}(undef, n, p)
    idx = 1
    for (name, col) in pairs(eachcol(df))
        try
            copyto!(res, idx, col)
        catch err
            if err isa MethodError && err.f == convert &&
               !(T >: Missing) && any(ismissing, col)
                throw(ArgumentError("cannot convert a DataFrame containing missing " *
                                    "values to Matrix{$T} (found for column $name)"))
            else
                rethrow(err)
            end
        end
        idx += n
    end
    return res
end

Base.Array(df::AbstractDataFrame) = Matrix(df)
Base.Array{T}(df::AbstractDataFrame) where {T} = Matrix{T}(df)

"""
    fillcombinations(df::AbstractDataFrame, indexcols;
                         allowduplicates::Bool=false,
                         fill=missing)

Generate all combinations of levels of column(s) `indexcols` in data frame `df`.
Levels and their order are determined by the `levels` function
(i.e. unique values sorted lexicographically by default, or a custom set
of levels for e.g. `CategoricalArray` columns), in addition to `missing` if present.

For combinations of `indexcols` not present in `df` these columns are
filled with the `fill` value (`missing` by default).

If `allowduplicates=false` (the default) `indexcols` may only contain
unique combinations of `indexcols` values. If `allowduplicates=true`
duplicates are allowed.

$METADATA_FIXED

# Examples

```jldoctest
julia> df = DataFrame(x=1:2, y='a':'b', z=["x", "y"])
2×3 DataFrame
 Row │ x      y     z
     │ Int64  Char  String
─────┼─────────────────────
   1 │     1  a     x
   2 │     2  b     y

julia> fillcombinations(df, [:x, :y])
4×3 DataFrame
 Row │ x      y     z
     │ Int64  Char  String?
─────┼──────────────────────
   1 │     1  a     x
   2 │     2  a     missing
   3 │     1  b     missing
   4 │     2  b     y

julia> fillcombinations(df, [:y, :z], fill=0)
4×3 DataFrame
 Row │ x       y     z
     │ Int64?  Char  String
─────┼──────────────────────
   1 │      1  a     x
   2 │      0  b     x
   3 │      0  a     y
   4 │      2  b     y
```
"""
function fillcombinations(df::AbstractDataFrame, indexcols;
                          allowduplicates::Bool=false, fill=missing)
    _check_consistency(df)

    colind = index(df)[indexcols]

    if length(colind) == 0
        throw(ArgumentError("At least one column to fill combinations " *
                            "must be specified"))
    end

    # we use hashing algorithm here, because we assume that the tables we work with are not huge
    has_duplicates = row_group_slots!(ntuple(i -> df[!, colind[i]], length(colind)),
                                      Val(false), nothing, false, nothing, true)[1] != nrow(df)
    if has_duplicates && !allowduplicates
        throw(ArgumentError("duplicate combinations of `indexcols` are not " *
                            "allowed in input when `allowduplicates=false`"))
    end

    # Create a vector of vectors of unique values in each column
    uniquevals = []
    for col in colind
        # All levels are retained, missing is added only if present
        tempcol = levels(df[!, col], skipmissing=false)
        push!(uniquevals, tempcol)
    end

    # make sure we do not overflow in the target data frame size
    target_rows = Int(prod(x -> BigInt(length(x)), uniquevals))
    if iszero(target_rows)
        @assert iszero(nrow(df))
        cdf = copy(df)
        _drop_all_nonnote_metadata!(cdf)
        return cdf
    end

    # construct expanded columns
    out_df = DataFrame()
    inner = 1
    @assert length(uniquevals) == length(colind)
    for (val, cind) in zip(uniquevals, colind)
        len = length(val)
        target_col = Tables.allocatecolumn(eltype(df[!, cind]), len)
        copy!(target_col, val)
        last_inner = inner
        inner *= len
        outer, remv = divrem(target_rows, inner)
        @assert iszero(remv)
        out_df[!, _names(df)[cind]] = repeat(target_col, inner=last_inner, outer=outer)
    end
    @assert inner == target_rows

    idx_ind = 0
    idx_col = ""
    while true
        idx_col = string("source7249", idx_ind)
        columnindex(df, idx_col) == 0 && break
        idx_ind += 1
    end

    if has_duplicates
        order_ind = 0
        order_col = ""
        while true
            order_col = string("order9427", order_ind)
            columnindex(df, order_col) == 0 && break
            order_ind += 1
        end
        insertcols!(out_df, 1, order_col => 1:nrow(out_df))
        out_df = leftjoin(out_df, df; on=_names(df)[colind],
                          source=idx_col,
                          matchmissing=:equal)
        sort!(out_df, 1)
        select!(out_df, 2:ncol(out_df))
    else
        leftjoin!(out_df, df; on=_names(df)[colind],
                  source=string("source7249", idx_ind),
                  matchmissing=:equal)
    end

    # Replace missing values with the fill
    if !ismissing(fill)
        mask = out_df[!, end] .== "left_only"
        if count(mask) > 0
            for n in length(colind)+1:ncol(out_df)-1
                tmp_col = out_df[!, n]
                out_col = similar(tmp_col,
                                  promote_type(eltype(tmp_col), typeof(fill)),
                                  length(tmp_col))
                out_col .= ifelse.(mask, Ref(fill), out_df[!, n])
                out_df[!, n] = out_col
            end
        end
    end

    # keep only columns from the source in their original order
    select!(out_df, _names(df))
    _copy_all_note_metadata!(out_df, df)

    return out_df
end

"""
    hcat(df::AbstractDataFrame...;
         makeunique::Bool=false, copycols::Bool=true)

Horizontally concatenate data frames.

If `makeunique=false` (the default) column names of passed objects must be unique.
If `makeunique=true` then duplicate column names will be suffixed
with `_i` (`i` starting at 1 for the first duplicate).

If `copycols=true` (the default) then the `DataFrame` returned by `hcat` will
contain copied columns from the source data frames.
If `copycols=false` then it will contain columns as they are stored in the
source (without copying). This option should be used with caution as mutating
either the columns in sources or in the returned `DataFrame` might lead to
the corruption of the other object.

Metadata: `hcat` propagates table-level `:note`-style metadata for keys that are present
in all passed data frames and have the same value;
it propagates column-level `:note`-style metadata.

# Example
```jldoctest
julia> df1 = DataFrame(A=1:3, B=1:3)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> df2 = DataFrame(A=4:6, B=4:6)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     4      4
   2 │     5      5
   3 │     6      6

julia> df3 = hcat(df1, df2, makeunique=true)
3×4 DataFrame
 Row │ A      B      A_1    B_1
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      1      4      4
   2 │     2      2      5      5
   3 │     3      3      6      6

julia> df3.A === df1.A
false

julia> df3 = hcat(df1, df2, makeunique=true, copycols=false);

julia> df3.A === df1.A
true
```
"""
function Base.hcat(df::AbstractDataFrame; makeunique::Bool=false, copycols::Bool=true)
    df = DataFrame(df, copycols=copycols)
    _drop_all_nonnote_metadata!(df)
    return df
end

# TODO: after deprecation remove AbstractVector methods
Base.hcat(df::AbstractDataFrame, x::AbstractVector; makeunique::Bool=false, copycols::Bool=true) =
    hcat!(DataFrame(df, copycols=copycols), x, makeunique=makeunique, copycols=copycols)
Base.hcat(x::AbstractVector, df::AbstractDataFrame; makeunique::Bool=false, copycols::Bool=true) =
    hcat!(x, df, makeunique=makeunique, copycols=copycols)
Base.hcat(df1::AbstractDataFrame, df2::AbstractDataFrame;
          makeunique::Bool=false, copycols::Bool=true) =
    hcat!(DataFrame(df1, copycols=copycols), df2,
          makeunique=makeunique, copycols=copycols)
Base.hcat(df::AbstractDataFrame, x::Union{AbstractVector, AbstractDataFrame},
          y::Union{AbstractVector, AbstractDataFrame}...;
          makeunique::Bool=false, copycols::Bool=true) =
    hcat!(hcat(df, x, makeunique=makeunique, copycols=copycols), y...,
          makeunique=makeunique, copycols=copycols)

"""
    vcat(dfs::AbstractDataFrame...;
         cols::Union{Symbol, AbstractVector{Symbol},
                     AbstractVector{<:AbstractString}}=:setequal,
         source::Union{Nothing, Symbol, AbstractString,
                       Pair{<:Union{Symbol, AbstractString}, <:AbstractVector}}=nothing)

Vertically concatenate `AbstractDataFrame`s.

The `cols` keyword argument determines the columns of the returned data frame:

* `:setequal`: require all data frames to have the same column names
  disregarding order. If they appear in different orders, the order of the first
  provided data frame is used.
* `:orderequal`: require all data frames to have the same column names and in
  the same order.
* `:intersect`: only the columns present in *all* provided data frames are kept.
  If the intersection is empty, an empty data frame is returned.
* `:union`: columns present in *at least one* of the provided data frames are
  kept. Columns not present in some data frames are filled with `missing` where
  necessary.
* A vector of `Symbol`s or strings: only listed columns are kept. Columns not
  present in some data frames are filled with `missing` where necessary.

The `source` keyword argument, if not `nothing` (the default), specifies the
additional column to be added in the last position in the resulting data frame
that will identify the source data frame. It can be a `Symbol` or an
`AbstractString`, in which case the identifier will be the number of the passed
source data frame, or a `Pair` consisting of a `Symbol` or an `AbstractString`
and of a vector specifying the data frame identifiers (which do not have to be
unique). The name of the source column is not allowed to be present in any
source data frame.

The order of columns is determined by the order they appear in the included data
frames, searching through the header of the first data frame, then the second,
etc.

The element types of columns are determined using `promote_type`, as with `vcat`
for `AbstractVector`s.

`vcat` ignores empty data frames when composing the result (except for
metadata), making it possible to initialize an empty data frame at the beginning
of a loop and `vcat` onto it.

Metadata: `vcat` propagates table-level `:note`-style metadata for keys that are
present in all passed data frames and have the same value. `vcat` propagates
column-level `:note`-style metadata for keys that are present in all passed data
frames that contain this column and have the same value.

# Example
```jldoctest
julia> df1 = DataFrame(A=1:3, B=1:3)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> df2 = DataFrame(A=4:6, B=4:6)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     4      4
   2 │     5      5
   3 │     6      6

julia> df3 = DataFrame(A=7:9, C=7:9)
3×2 DataFrame
 Row │ A      C
     │ Int64  Int64
─────┼──────────────
   1 │     7      7
   2 │     8      8
   3 │     9      9

julia> df4 = DataFrame()
0×0 DataFrame

julia> vcat(df1, df2)
6×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3
   4 │     4      4
   5 │     5      5
   6 │     6      6

julia> vcat(df1, df3, cols=:union)
6×3 DataFrame
 Row │ A      B        C
     │ Int64  Int64?   Int64?
─────┼─────────────────────────
   1 │     1        1  missing
   2 │     2        2  missing
   3 │     3        3  missing
   4 │     7  missing        7
   5 │     8  missing        8
   6 │     9  missing        9

julia> vcat(df1, df3, cols=:intersect)
6×1 DataFrame
 Row │ A
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3
   4 │     7
   5 │     8
   6 │     9

julia> vcat(df4, df1)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> vcat(df1, df2, df3, df4, cols=:union, source="source")
9×4 DataFrame
 Row │ A      B        C        source
     │ Int64  Int64?   Int64?   Int64
─────┼─────────────────────────────────
   1 │     1        1  missing       1
   2 │     2        2  missing       1
   3 │     3        3  missing       1
   4 │     4        4  missing       2
   5 │     5        5  missing       2
   6 │     6        6  missing       2
   7 │     7  missing        7       3
   8 │     8  missing        8       3
   9 │     9  missing        9       3

julia> vcat(df1, df2, df4, df3, cols=:union, source=:source => 'a':'d')
9×4 DataFrame
 Row │ A      B        C        source
     │ Int64  Int64?   Int64?   Char
─────┼─────────────────────────────────
   1 │     1        1  missing  a
   2 │     2        2  missing  a
   3 │     3        3  missing  a
   4 │     4        4  missing  b
   5 │     5        5  missing  b
   6 │     6        6  missing  b
   7 │     7  missing        7  d
   8 │     8  missing        8  d
   9 │     9  missing        9  d
```
"""
Base.vcat(dfs::AbstractDataFrame...;
          cols::Union{Symbol, AbstractVector{Symbol},
                      AbstractVector{<:AbstractString}}=:setequal,
          source::Union{Nothing, SymbolOrString,
                           Pair{<:SymbolOrString, <:AbstractVector}}=nothing) =
    reduce(vcat, dfs; cols=cols, source=source)

"""
    repeat(df::AbstractDataFrame; inner::Integer = 1, outer::Integer = 1)

Construct a data frame by repeating rows in `df`. `inner` specifies how many
times each row is repeated, and `outer` specifies how many times the full set
of rows is repeated.

$METADATA_FIXED

# Example
```jldoctest
julia> df = DataFrame(a=1:2, b=3:4)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> repeat(df, inner=2, outer=3)
12×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     1      3
   3 │     2      4
   4 │     2      4
   5 │     1      3
   6 │     1      3
   7 │     2      4
   8 │     2      4
   9 │     1      3
  10 │     1      3
  11 │     2      4
  12 │     2      4
```
"""
function Base.repeat(df::AbstractDataFrame; inner::Integer=1, outer::Integer=1)
    inner < 0 && throw(ArgumentError("inner keyword argument must be non-negative"))
    outer < 0 && throw(ArgumentError("outer keyword argument must be non-negative"))
    return mapcols(x -> repeat(x, inner = Int(inner), outer = Int(outer)), df)
end

"""
    repeat(df::AbstractDataFrame, count::Integer)

Construct a data frame by repeating each row in `df` the number of times
specified by `count`.

$METADATA_FIXED

# Example
```jldoctest
julia> df = DataFrame(a=1:2, b=3:4)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> repeat(df, 2)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4
   3 │     1      3
   4 │     2      4
```
"""
function Base.repeat(df::AbstractDataFrame, count::Integer)
    count < 0 && throw(ArgumentError("count must be non-negative"))
    return mapcols(x -> repeat(x, Int(count)), df)
end

##############################################################################
##
## Hashing
##
##############################################################################

const hashdf_seed = UInt == UInt32 ? 0xfd8bb02e : 0x6215bada8c8c46de

function Base.hash(df::AbstractDataFrame, h::UInt)
    h ⊻= hashdf_seed
    h = hash(size(df), h)
    h = hash(_names(df), h)
    for i in 1:size(df, 2)
        h = hash(df[!, i], h)
    end
    return h
end

Base.parent(adf::AbstractDataFrame) = adf
Base.parentindices(adf::AbstractDataFrame) = axes(adf)

"""
    disallowmissing(df::AbstractDataFrame, cols=:; error::Bool=true)

Return a copy of data frame `df` with columns `cols` converted
from element type `Union{T, Missing}` to `T` to drop support for missing values.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `cols` is omitted all columns in the data frame are converted.

If `error=false` then columns containing a `missing` value will be skipped instead
of throwing an error.

$METADATA_FIXED

# Examples

```jldoctest
julia> df = DataFrame(a=Union{Int, Missing}[1, 2])
2×1 DataFrame
 Row │ a
     │ Int64?
─────┼────────
   1 │      1
   2 │      2

julia> disallowmissing(df)
2×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> df = DataFrame(a=[1, missing])
2×1 DataFrame
 Row │ a
     │ Int64?
─────┼─────────
   1 │       1
   2 │ missing

julia> disallowmissing(df, error=false)
2×1 DataFrame
 Row │ a
     │ Int64?
─────┼─────────
   1 │       1
   2 │ missing
```
"""
function Missings.disallowmissing(df::AbstractDataFrame,
                                  cols::Union{ColumnIndex, MultiColumnIndex}=:;
                                  error::Bool=true)
    idxcols = Set(index(df)[cols])
    newcols = AbstractVector[]
    for i in axes(df, 2)
        x = df[!, i]
        if i in idxcols
            y = x
            if Missing <: eltype(x)
                try
                    y = disallowmissing(x)
                catch e
                    row = findfirst(ismissing, x)
                    if row !== nothing
                        if error
                            col = _names(df)[i]
                            throw(ArgumentError("Missing value found in column " *
                                                ":$col in row $row"))
                        end
                    else
                        rethrow(e)
                    end
                end
            end
            push!(newcols, y === x ? copy(y) : y)
        else
            push!(newcols, copy(x))
        end
    end

    new_df = DataFrame(newcols, _names(df), copycols=false)
    _copy_all_note_metadata!(new_df, df)
    return new_df
end

"""
    allowmissing(df::AbstractDataFrame, cols=:)

Return a copy of data frame `df` with columns `cols` converted
to element type `Union{T, Missing}` from `T` to allow support for missing values.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `cols` is omitted all columns in the data frame are converted.

$METADATA_FIXED

# Examples

```jldoctest
julia> df = DataFrame(a=[1, 2])
2×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> allowmissing(df)
2×1 DataFrame
 Row │ a
     │ Int64?
─────┼────────
   1 │      1
   2 │      2
```
"""
function Missings.allowmissing(df::AbstractDataFrame,
                               cols::Union{ColumnIndex, MultiColumnIndex}=:)
    idxcols = Set(index(df)[cols])
    newcols = AbstractVector[]
    for i in axes(df, 2)
        x = df[!, i]
        if i in idxcols
            y = allowmissing(x)
            push!(newcols, y === x ? copy(y) : y)
        else
            push!(newcols, copy(x))
        end
    end

    new_df = DataFrame(newcols, _names(df), copycols=false)
    _copy_all_note_metadata!(new_df, df)
    return new_df
end

"""
    flatten(df::AbstractDataFrame, cols; scalar::Type=Union{})

When columns `cols` of data frame `df` have iterable elements that define
`length` (for example a `Vector` of `Vector`s), return a `DataFrame` where each
element of each `col` in `cols` is flattened, meaning the column corresponding
to `col` becomes a longer vector where the original entries are concatenated.
Elements of row `i` of `df` in columns other than `cols` will be repeated
according to the length of `df[i, col]`. These lengths must therefore be the
same for each `col` in `cols`, or else an error is raised. Note that these
elements are not copied, and thus if they are mutable changing them in the
returned `DataFrame` will affect `df`.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `scalar` is passed then values that have this type in flattened columns
are treated as scalars and broadcasted as many times as is needed to match
lengths of values stored in other columns. If all values in a row are scalars,
a single row is produced.

$METADATA_FIXED

# Examples

```jldoctest
julia> df1 = DataFrame(a=[1, 2], b=[[1, 2], [3, 4]], c=[[5, 6], [7, 8]])
2×3 DataFrame
 Row │ a      b       c
     │ Int64  Array…  Array…
─────┼───────────────────────
   1 │     1  [1, 2]  [5, 6]
   2 │     2  [3, 4]  [7, 8]

julia> flatten(df1, :b)
4×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Array…
─────┼──────────────────────
   1 │     1      1  [5, 6]
   2 │     1      2  [5, 6]
   3 │     2      3  [7, 8]
   4 │     2      4  [7, 8]

julia> flatten(df1, [:b, :c])
4×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      5
   2 │     1      2      6
   3 │     2      3      7
   4 │     2      4      8

julia> df2 = DataFrame(a=[1, 2], b=[("p", "q"), ("r", "s")])
2×2 DataFrame
 Row │ a      b
     │ Int64  Tuple…
─────┼───────────────────
   1 │     1  ("p", "q")
   2 │     2  ("r", "s")

julia> flatten(df2, :b)
4×2 DataFrame
 Row │ a      b
     │ Int64  String
─────┼───────────────
   1 │     1  p
   2 │     1  q
   3 │     2  r
   4 │     2  s

julia> df3 = DataFrame(a=[1, 2], b=[[1, 2], [3, 4]], c=[[5, 6], [7]])
2×3 DataFrame
 Row │ a      b       c
     │ Int64  Array…  Array…
─────┼───────────────────────
   1 │     1  [1, 2]  [5, 6]
   2 │     2  [3, 4]  [7]

julia> flatten(df3, [:b, :c])
ERROR: ArgumentError: Lengths of iterables stored in columns :b and :c are not the same in row 2

julia> df4 = DataFrame(a=[1, 2, 3],
                       b=[[1, 2], missing, missing],
                       c=[[5, 6], missing, [7, 8]])
3×3 DataFrame
 Row │ a      b        c
     │ Int64  Array…?  Array…?
─────┼─────────────────────────
   1 │     1  [1, 2]   [5, 6]
   2 │     2  missing  missing
   3 │     3  missing  [7, 8]

julia> flatten(df4, [:b, :c], scalar=Missing)
5×3 DataFrame
 Row │ a      b        c
     │ Int64  Int64?   Int64?
─────┼─────────────────────────
   1 │     1        1        5
   2 │     1        2        6
   3 │     2  missing  missing
   4 │     3  missing        7
   5 │     3  missing        8
```
"""
function flatten(df::AbstractDataFrame,
                 cols::Union{ColumnIndex, MultiColumnIndex};
                 scalar::Type=Union{})
    _check_consistency(df)

    idxcols = index(df)[cols]
    if isempty(idxcols)
        cdf = copy(df)
        _drop_all_nonnote_metadata!(cdf)
        return cdf
    end

    col1 = first(idxcols)
    lengths = Int[x isa scalar ? -1 : length(x) for x in df[!, col1]]
    for (i, coli) in enumerate(idxcols)
        i == 1 && continue
        update_lengths!(lengths, df[!, coli], scalar, df, col1, coli)
    end

    # handle case where in all columns we had a scalar
    # in this case we keep it one time
    for i in 1:length(lengths)
        lengths[i] == -1 && (lengths[i] = 1)
    end

    new_df = similar(df[!, Not(cols)], sum(lengths))
    for name in _names(new_df)
        repeat_lengths!(new_df[!, name], df[!, name], lengths)
    end
    length(idxcols) > 1 && sort!(idxcols)
    for col in idxcols
        col_to_flatten = df[!, col]
        fast_path = eltype(col_to_flatten) <: AbstractVector &&
                    !isempty(col_to_flatten)
        flattened_col = if fast_path
                reduce(vcat, col_to_flatten)
            elseif scalar === Union{}
                collect(Iterators.flatten(col_to_flatten))
            else
                collect(Iterators.flatten(v isa scalar ? Iterators.repeated(v, l) : v
                                          for (l, v) in zip(lengths, col_to_flatten)))
            end
        insertcols!(new_df, col, _names(df)[col] => flattened_col)
    end

    _copy_all_note_metadata!(new_df, df)
    return new_df
end

function update_lengths!(lengths::Vector{Int}, col::AbstractVector, scalar::Type,
                         df::AbstractDataFrame, col1::Integer, coli::Integer)
    for (i, v) in enumerate(col)
        v isa scalar && continue
        lv = length(v)
        if lengths[i] == -1
            lengths[i] = lv
        elseif lengths[i] != lv
            colnames = _names(df)
            throw(ArgumentError("Lengths of iterables stored in columns :$(colnames[col1]) " *
                                "and :$(colnames[coli]) are not the same in row $i"))
        end
    end
end

function repeat_lengths!(longnew::AbstractVector, shortold::AbstractVector,
                         lengths::AbstractVector{Int})
    counter = 1
    @inbounds for i in eachindex(shortold)
        l = lengths[i]
        longnew[counter:(counter + l - 1)] .= Ref(shortold[i])
        counter += l
    end
end

# Disallowed getindex and setindex! operations that are a common mistake

Base.getindex(::AbstractDataFrame, ::Union{Symbol, Integer, AbstractString}) =
    throw(ArgumentError("syntax df[column] is not supported use df[!, column] instead"))

Base.setindex!(::AbstractDataFrame, ::Any, ::Union{Symbol, Integer, AbstractString}) =
    throw(ArgumentError("syntax df[column] is not supported use df[!, column] instead"))

"""
    reverse(df::AbstractDataFrame, start=1, stop=nrow(df))

Return a data frame containing the rows in `df` in reversed order.
If `start` and `stop` are provided, only rows in the `start:stop` range are affected.

$METADATA_FIXED

# Examples

```jldoctest
julia> df = DataFrame(a=1:5, b=6:10, c=11:15)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     2      7     12
   3 │     3      8     13
   4 │     4      9     14
   5 │     5     10     15

julia> reverse(df)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     5     10     15
   2 │     4      9     14
   3 │     3      8     13
   4 │     2      7     12
   5 │     1      6     11

julia> reverse(df, 2, 3)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     3      8     13
   3 │     2      7     12
   4 │     4      9     14
   5 │     5     10     15
```
"""
Base.reverse(df::AbstractDataFrame, start::Integer=1, stop::Integer=nrow(df)) =
    mapcols(x -> reverse(x, start, stop), df)

"""
    reverse!(df::AbstractDataFrame, start=1, stop=nrow(df))

Mutate data frame in-place to reverse its row order.
If `start` and `stop` are provided, only rows in the `start:stop` range are affected.

`reverse!` will produce a correct result even if some columns of passed data frame
are identical (checked with `===`). Otherwise, if two columns share some part of
memory but are not identical (e.g. are different views of the same parent
vector) then `reverse!` result might be incorrect.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

# Examples

```jldoctest
julia> df = DataFrame(a=1:5, b=6:10, c=11:15)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     2      7     12
   3 │     3      8     13
   4 │     4      9     14
   5 │     5     10     15

julia> reverse!(df)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     5     10     15
   2 │     4      9     14
   3 │     3      8     13
   4 │     2      7     12
   5 │     1      6     11

julia> reverse!(df, 2, 3)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     5     10     15
   2 │     3      8     13
   3 │     4      9     14
   4 │     2      7     12
   5 │     1      6     11
```
"""
function Base.reverse!(df::AbstractDataFrame, start::Integer=1, stop::Integer=nrow(df))
    _foreach_unique_column!(col -> reverse!(col, start, stop), df)
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function _foreach_unique_column!(f!::Function, df::AbstractDataFrame)
    seen_cols = IdDict{Any, Nothing}()
    for col in eachcol(df)
        if !haskey(seen_cols, col)
            seen_cols[col] = nothing
            f!(col)
        end
    end
    return nothing
end

function _permutation_helper!(fun::Union{typeof(permute!), typeof(invpermute!)},
                              df::AbstractDataFrame, p::AbstractVector{<:Integer})
    nrow(df) != length(p) &&
        throw(DimensionMismatch("Permutation does not have a correct length " *
                                "(expected $(nrow(df)) but got $(length(p)))"))

    cp = _compile_permutation!(Base.copymutable(p))

    if isempty(cp)
        _drop_all_nonnote_metadata!(parent(df))
        return df
    end

    if fun === invpermute!
        reverse!(@view cp[1:end-1])
    end

    _foreach_unique_column!(col -> _cycle_permute!(col, cp), df)

    _drop_all_nonnote_metadata!(parent(df))
    return df
end

# convert a classical permutation to zero terminated cycle
# notation, zeroing the original permutation in the process.
function _compile_permutation!(p::AbstractVector{<:Integer})
    firstindex(p) == 1 ||
        throw(ArgumentError("Permutation vectors must have 1-based indexing"))
    # this length is sufficient because we do not record 1-cycles,
    # so the worst case is all 2-cycles. One extra element gives the
    # algorithm leeway to defer error detection without unsafe reads.
    # trace _compile_permutation!([3,3,1]) for example.
    out = similar(p, 3 * length(p) ÷ 2 + 1)
    out_len = 0
    start = 0
    count = length(p)
    @inbounds while count > 0
        start = findnext(!iszero, p, start + 1)
        start isa Int || throw(ArgumentError("Passed vector p is not a valid permutation"))
        last_k = p[start]
        count -= 1
        last_k == start && continue
        out_len += 1
        out[out_len] = last_k
        p[start] = 0
        start < last_k <= length(p) || throw(ArgumentError("Passed vector p is not a valid permutation"))
        out_len += 1
        k = out[out_len] = p[last_k]
        while true
            count -= 1
            p[last_k] = 0
            last_k = k
            start <= k <= length(p) || throw(ArgumentError("Passed vector p is not a valid permutation"))
            out_len += 1
            k = out[out_len] = p[k]
            k == 0 && break
        end
        last_k == start || throw(ArgumentError("Passed vector p is not a valid permutation"))
    end
    return resize!(out, out_len)
end

# Permute a vector `v` based on a permutation `p` listed in zero terminated
# cycle notation. For example, the permutation 1 -> 2, 2 -> 3, 3 -> 1, 4 -> 6,
# 5 -> 5, 6 -> 4 is traditionally expressed as [2, 3, 1, 6, 5, 4] but in cycle
# notation is expressed as [1, 2, 3, 0, 4, 6, 0]
function _cycle_permute!(v::AbstractVector, p::AbstractVector{<:Integer})
    i = firstindex(p)
    @inbounds while i < lastindex(p)
        last_p_i = p[i]
        start = v[last_p_i]
        while true
            i += 1
            p_i = p[i]
            p_i == 0 && break
            v[last_p_i] = v[p_i]
            last_p_i = p_i
        end
        v[last_p_i] = start
        i += 1
    end
    return v
end

"""
    permute!(df::AbstractDataFrame, p)

Permute data frame `df` in-place, according to permutation `p`.
Throws `ArgumentError` if `p` is not a permutation.

To return a new data frame instead of permuting `df` in-place, use `df[p, :]`.

`permute!` will produce a correct result even if some columns of passed data frame
or permutation `p` are identical (checked with `===`). Otherwise, if two columns share
some part of memory but are not identical (e.g. are different views of the same parent
vector) then `permute!` result might be incorrect.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

# Examples

```jldoctest
julia> df = DataFrame(a=1:5, b=6:10, c=11:15)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     2      7     12
   3 │     3      8     13
   4 │     4      9     14
   5 │     5     10     15

julia> permute!(df, [5, 3, 1, 2, 4])
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     5     10     15
   2 │     3      8     13
   3 │     1      6     11
   4 │     2      7     12
   5 │     4      9     14
```
"""
Base.permute!(df::AbstractDataFrame, p::AbstractVector{<:Integer}) =
    _permutation_helper!(permute!, df, p)

"""
    invpermute!(df::AbstractDataFrame, p)

Like [`permute!`](@ref), but the inverse of the given permutation is applied.

`invpermute!` will produce a correct result even if some columns of passed data
frame or permutation `p` are identical (checked with `===`). Otherwise, if two
columns share some part of memory but are not identical (e.g. are different views
of the same parent vector) then `invpermute!` result might be incorrect.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

# Examples

```jldoctest
julia> df = DataFrame(a=1:5, b=6:10, c=11:15)
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     2      7     12
   3 │     3      8     13
   4 │     4      9     14
   5 │     5     10     15

julia> permute!(df, [5, 3, 1, 2, 4])
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     5     10     15
   2 │     3      8     13
   3 │     1      6     11
   4 │     2      7     12
   5 │     4      9     14

julia> invpermute!(df, [5, 3, 1, 2, 4])
5×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6     11
   2 │     2      7     12
   3 │     3      8     13
   4 │     4      9     14
   5 │     5     10     15
```
"""
Base.invpermute!(df::AbstractDataFrame, p::AbstractVector{<:Integer}) =
    _permutation_helper!(invpermute!, df, p)

"""
    shuffle([rng=GLOBAL_RNG,] df::AbstractDataFrame)

Return a copy of `df` with randomly permuted rows.
The optional `rng` argument specifies a random number generator.

$METADATA_FIXED

# Examples

```jldoctest
julia> using Random, StableRNGs

julia> rng = StableRNG(1234);

julia> shuffle(rng, DataFrame(a=1:5, b=1:5))
5×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     2      2
   2 │     1      1
   3 │     3      3
   4 │     5      5
   5 │     4      4
```
"""
Random.shuffle(df::AbstractDataFrame) =
    df[randperm(nrow(df)), :]
Random.shuffle(r::AbstractRNG, df::AbstractDataFrame) =
    df[randperm(r, nrow(df)), :]

"""
    shuffle!([rng=GLOBAL_RNG,] df::AbstractDataFrame)

Randomly permute rows of `df` in-place.
The optional `rng` argument specifies a random number generator.

`shuffle!` will produce a correct result even if some columns of passed data frame
are identical (checked with `===`). Otherwise, if two columns share some part of
memory but are not identical (e.g. are different views of the same parent
vector) then `shuffle!` result might be incorrect.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

# Examples

```jldoctest
julia> using Random, StableRNGs

julia> rng = StableRNG(1234);

julia> shuffle!(rng, DataFrame(a=1:5, b=1:5))
5×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     2      2
   2 │     1      1
   3 │     3      3
   4 │     5      5
   5 │     4      4
```
"""
Random.shuffle!(df::AbstractDataFrame) =
    permute!(df, randperm(nrow(df)))
Random.shuffle!(r::AbstractRNG, df::AbstractDataFrame) =
    permute!(df, randperm(r, nrow(df)))

const INSERTCOLS_ARGUMENTS =
    """
    If `col` is omitted it is set to `ncol(df)+1`
    (the column is inserted as the last column).

    # Arguments
    - `df` : the data frame to which we want to add columns
    - `col` : a position at which we want to insert a column, passed as an integer
      or a column name (a string or a `Symbol`); the column selected with `col`
      and columns following it are shifted to the right in `df` after the operation
    - `name` : the name of the new column
    - `val` : an `AbstractVector` giving the contents of the new column or a value of any
      type other than `AbstractArray` which will be repeated to fill a new vector;
      As a particular rule a values stored in a `Ref` or a `0`-dimensional `AbstractArray`
      are unwrapped and treated in the same way
    - `after` : if `true` columns are inserted after `col`
    - `makeunique` : defines what to do if `name` already exists in `df`;
      if it is `false` an error will be thrown; if it is `true` a new unique name will
      be generated by adding a suffix
    - `copycols` : whether vectors passed as columns should be copied

    If `val` is an `AbstractRange` then the result of `collect(val)` is inserted.

    If `df` is a `SubDataFrame` then it must have been created with `:` as column selector
    (otherwise an error is thrown). In this case the `copycols` keyword argument
    is ignored (i.e. the added column is always copied) and the parent data frame's
    column is filled with `missing` in rows that are filtered out by `df`.

    If `df` isa `DataFrame` that has no columns and only values
    other than `AbstractVector` are passed then it is used to create a one-element
    column.
    If `df` isa `DataFrame` that has no columns and at least one `AbstractVector` is
    passed then its length is used to determine the number of elements in all
    created columns.
    In all other cases the number of rows in all created columns must match
    `nrow(df)`.
    """

"""
    insertcols(df::AbstractDataFrame[, col], (name=>val)::Pair...;
               after::Bool=false, makeunique::Bool=false, copycols::Bool=true)

Insert a column into a copy of `df` data frame using the [`insertcols!`](@ref)
function and return the newly created data frame.

$INSERTCOLS_ARGUMENTS

$METADATA_FIXED

See also [`insertcols!`](@ref).

# Examples
```jldoctest
julia> df = DataFrame(a=1:3)
3×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> insertcols(df, 1, :b => 'a':'c')
3×2 DataFrame
 Row │ b     a
     │ Char  Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3

julia> insertcols(df, :c => 2:4, :c => 3:5, makeunique=true)
3×3 DataFrame
 Row │ a      c      c_1
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3
   2 │     2      3      4
   3 │     3      4      5

julia> insertcols(df, :a, :d => 7:9, after=true)
3×2 DataFrame
 Row │ a      d
     │ Int64  Int64
─────┼──────────────
   1 │     1      7
   2 │     2      8
   3 │     3      9
```
"""
insertcols(df::AbstractDataFrame, args...;
           after::Bool=false, makeunique::Bool=false, copycols::Bool=true) =
    insertcols!(copy(df), args...;
                after=after, makeunique=makeunique, copycols=copycols)

"""
    insertcols!(df::AbstractDataFrame[, col], (name=>val)::Pair...;
                after::Bool=false, makeunique::Bool=false, copycols::Bool=true)

Insert a column into a data frame in place. Return the updated data frame.

$INSERTCOLS_ARGUMENTS

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

See also [`insertcols`](@ref).

# Examples
```jldoctest
julia> df = DataFrame(a=1:3)
3×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> insertcols!(df, 1, :b => 'a':'c')
3×2 DataFrame
 Row │ b     a
     │ Char  Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3

julia> insertcols!(df, 2, :c => 2:4, :c => 3:5, makeunique=true)
3×4 DataFrame
 Row │ b     c      c_1    a
     │ Char  Int64  Int64  Int64
─────┼───────────────────────────
   1 │ a         2      3      1
   2 │ b         3      4      2
   3 │ c         4      5      3

julia> insertcols!(df, :b, :d => 7:9, after=true)
3×5 DataFrame
 Row │ b     d      c      c_1    a
     │ Char  Int64  Int64  Int64  Int64
─────┼──────────────────────────────────
   1 │ a         7      2      3      1
   2 │ b         8      3      4      2
   3 │ c         9      4      5      3
```
"""
function insertcols!(df::AbstractDataFrame, col::ColumnIndex, name_cols::Pair{Symbol}...;
                     after::Bool=false, makeunique::Bool=false, copycols::Bool=true)
    if !is_column_insertion_allowed(df)
        throw(ArgumentError("insertcols! is only supported for DataFrame, or for " *
                            "SubDataFrame created with `:` as column selector"))
    end
    if !(copycols || df isa DataFrame)
        throw(ArgumentError("copycols=false is only allowed if df isa DataFrame "))
    end
    if col isa SymbolOrString
        col_ind = Int(columnindex(df, col))
        if col_ind == 0
            throw(ArgumentError("column $col does not exist in data frame"))
        end
    else
        col_ind = Int(col)
    end

    if after
        col_ind += 1
    end

    if !(0 < col_ind <= ncol(df) + 1)
        throw(ArgumentError("attempt to insert a column to a data frame with " *
                            "$(ncol(df)) columns at index $col_ind"))
    end

    if !makeunique
        if !allunique(first.(name_cols))
            throw(ArgumentError("Names of columns to be inserted into a data frame " *
                                "must be unique when `makeunique=true`"))
        end
        for (n, _) in name_cols
            if hasproperty(df, n)
                throw(ArgumentError("Column $n is already present in the data frame " *
                                    "which is not allowed when `makeunique=true`"))
            end
        end
    end

    if ncol(df) == 0 && df isa DataFrame
        target_row_count = -1
    else
        target_row_count = nrow(df)
    end

    for (n, v) in name_cols
        if v isa AbstractVector
            if target_row_count == -1
                target_row_count = length(v)
            elseif length(v) != target_row_count
                if target_row_count == nrow(df)
                    throw(DimensionMismatch("length of new column $n which is " *
                                            "$(length(v)) must match the number " *
                                            "of rows in data frame ($(nrow(df)))"))
                else
                    throw(DimensionMismatch("all vectors passed to be inserted into " *
                                            "a data frame must have the same length"))
                end
            end
        elseif v isa AbstractArray && ndims(v) > 1
            throw(ArgumentError("adding AbstractArray other than AbstractVector as " *
                                "a column of a data frame is not allowed"))
        end
    end
    if target_row_count == -1
        target_row_count = 1
    end

    start_col_ind = col_ind
    for (name, item) in name_cols
        if !(item isa AbstractVector)
            if item isa Union{AbstractArray{<:Any, 0}, Ref}
                x = item[]
                item_new = fill!(Tables.allocatecolumn(typeof(x), target_row_count), x)
            else
                @assert !(item isa AbstractArray)
                item_new = fill!(Tables.allocatecolumn(typeof(item), target_row_count), item)
            end
        elseif item isa AbstractRange
            item_new = collect(item)
        elseif copycols && df isa DataFrame
            item_new = copy(item)
        else
            item_new = item
        end

        if df isa DataFrame
            dfp = df
        else
            @assert df isa SubDataFrame
            dfp = parent(df)
            item_new_orig = item_new
            T = eltype(item_new_orig)
            item_new = similar(item_new_orig, Union{T, Missing}, nrow(dfp))
            fill!(item_new, missing)
            item_new[rows(df)] = item_new_orig
        end

        firstindex(item_new) != 1 && _onebased_check_error()

        if ncol(dfp) == 0
            dfp[!, name] = item_new
        else
            if hasproperty(dfp, name)
                @assert makeunique
                k = 1
                while true
                    nn = Symbol("$(name)_$k")
                    if !hasproperty(dfp, nn)
                        name = nn
                        break
                    end
                    k += 1
                end
            end
            insert!(index(dfp), col_ind, name)
            insert!(_columns(dfp), col_ind, item_new)
        end
        col_ind += 1
    end

    delta = col_ind - start_col_ind
    colmetadata_dict = getfield(parent(df), :colmetadata)
    if !isnothing(colmetadata_dict) && delta > 0
        to_move = Int[i for i in keys(colmetadata_dict) if i >= start_col_ind]
        sort!(to_move, rev=true)
        for i in to_move
            colmetadata_dict[i + delta] = pop!(colmetadata_dict, i)
        end
    end
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

insertcols!(df::AbstractDataFrame, col::ColumnIndex, name_cols::Pair{<:AbstractString}...;
            after::Bool=false, makeunique::Bool=false, copycols::Bool=true) =
    insertcols!(df, col, (Symbol(n) => v for (n, v) in name_cols)...,
                after=after, makeunique=makeunique, copycols=copycols)

insertcols!(df::AbstractDataFrame, name_cols::Pair{Symbol}...;
            after::Bool=false, makeunique::Bool=false, copycols::Bool=true) =
    insertcols!(df, ncol(df)+1, name_cols..., after=after,
                makeunique=makeunique, copycols=copycols)

insertcols!(df::AbstractDataFrame, name_cols::Pair{<:AbstractString}...;
            after::Bool=false, makeunique::Bool=false, copycols::Bool=true) =
    insertcols!(df, (Symbol(n) => v for (n, v) in name_cols)...,
                after=after, makeunique=makeunique, copycols=copycols)

function insertcols!(df::AbstractDataFrame, col::ColumnIndex; after::Bool=false,
                     makeunique::Bool=false, copycols::Bool=true)
    if col isa SymbolOrString
        col_ind = Int(columnindex(df, col))
        if col_ind == 0
            throw(ArgumentError("column $col does not exist in data frame"))
        end
    else
        col_ind = Int(col)
    end

    if after
        col_ind += 1
    end

    if !(0 < col_ind <= ncol(df) + 1)
        throw(ArgumentError("attempt to insert a column to a data frame with " *
                            "$(ncol(df)) columns at index $col_ind"))
    end

    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function insertcols!(df::AbstractDataFrame; after::Bool=false,
                     makeunique::Bool=false, copycols::Bool=true)
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

"""
    Iterators.partition(df::AbstractDataFrame, n::Integer)

Iterate over `df` data frame `n` rows at a time, returning each block
as a `SubDataFrame`.

# Examples

```jldoctest
julia> collect(Iterators.partition(DataFrame(x=1:5), 2))
3-element Vector{SubDataFrame{DataFrame, DataFrames.Index, UnitRange{Int64}}}:
 2×1 SubDataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     1
   2 │     2
 2×1 SubDataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     3
   2 │     4
 1×1 SubDataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     5
```
"""
function Iterators.partition(df::AbstractDataFrame, n::Integer)
    n < 1 && throw(ArgumentError("cannot create partitions of length $n"))
    return Iterators.PartitionIterator(df, Int(n))
end

# use autodetection of eltype
Base.IteratorEltype(::Type{<:Iterators.PartitionIterator{<:AbstractDataFrame}}) =
    Base.EltypeUnknown()

# we do not need to be overly specific here as we rely on autodetection of eltype
# this method is needed only to override the fallback for `PartitionIterator`
Base.eltype(::Type{<:Iterators.PartitionIterator{<:AbstractDataFrame}}) =
    AbstractDataFrame

IteratorSize(::Type{<:Iterators.PartitionIterator{<:AbstractDataFrame}}) =
    Base.HasLength()

function Base.length(itr::Iterators.PartitionIterator{<:AbstractDataFrame})
    l = nrow(itr.c)
    return cld(l, itr.n)
end

function Base.iterate(itr::Iterators.PartitionIterator{<:AbstractDataFrame}, state::Int=1)
    last_idx = nrow(itr.c)
    state > last_idx && return nothing
    r = min(state + itr.n - 1, last_idx)
    return view(itr.c, state:r, :), r + 1
end

#!/usr/bin/env julia
#
# Run _join_ benchmarks
#
# Usage: julia runtests.jl [--single-process] <llen> <rlen> <join_type>
#     --single-process      Runs all tests in a single julia process instead of
#                           spawning multiple julia subprocesses
#     <llen>                The length of the left dataframe
#     <rlen>                The length of the right dataframe
#     <join_type>           One of 'inner', 'left', 'right', 'outer', 'semi', 'anti'
#
# Note: Either provide all of <llen>, <rlen>, <join_type> arguments or leave blank
#       to run all test cases (see `run_all_tests` below)


using DataFrames
include("join_performance.jl")

# re-enable "cat" when
# https://github.com/JuliaData/CategoricalArrays.jl/pull/327
# and
# https://github.com/JuliaData/CategoricalArrays.jl/pull/331
# are merged and tagged

const file_loc = joinpath(dirname(@__FILE__), "join_performance.jl")

function run_all_tests(single_process)
    cases = [
        (100000, 50000000, "inner"),
        (5000000, 10000000, "inner"),
        (100000, 50000000, "left"),
        (5000000, 10000000, "left"),
        (100000, 50000000, "right"),
        (5000000, 10000000, "right"),
        (100000, 50000000, "outer"),
        (5000000, 10000000, "outer"),
        (100000, 50000000, "semi"),
        (5000000, 10000000, "semi"),
        (100000, 50000000, "anti"),
        (5000000, 10000000, "anti")
    ]

    for (llen, rlen, join_type) in cases
        run_test(single_process, llen, rlen, join_type)
    end
end

function run_test(single_process, llen, rlen, join_type)
    for
        arr_type in ["str", "int", "pool"], # "cat"],
        dup_mode in ["uniq", "dup", "manydup"],
        sort_mode in ["sort", "rand"],
        num_keys in ["1", "2"]
        dup_mode == "uniq" && arr_type in ["pool", "cat"] && continue

        if single_process
            @info "Running test: $llen $rlen $arr_type $dup_mode $sort_mode $num_keys $join_type"
            flush(stdout)

            t = run_bench(llen, rlen, arr_type, dup_mode, sort_mode, num_keys, join_type)

            @info "Timing: $t seconds"
            flush(stdout)
        else
            run(`julia $file_loc $llen $rlen $arr_type $dup_mode $sort_mode $num_keys $join_type`)
        end
    end
end

if abspath(PROGRAM_FILE) == @__FILE__
    path = pathof(DataFrames)
    @info "DataFrames.jl at $path"

    # do some argument processing
    args = copy(ARGS)
    single_process = false
    pos = []
    while length(args) > 0
        arg = popfirst!(args)
        if arg == "--single-process"
            @info "Using single Julia process"
            global single_process = true
        elseif startswith(arg, "--")
            @error("Unknown option $arg")
            exit(1)
        else
            push!(pos, arg)
        end
    end

    @assert length(args) in [0, 3] "Wrong positional arguments. Expect [llen, rlen, join_type], got $args."

    if length(pos) == 0
        @info "Running all tests"
        run_all_tests(single_process)
    else
        llen, rlen, join_type = pos
        llen = parse(Int, llen)
        rlen = parse(Int, rlen)
        run_test(single_process, llen, rlen, join_type)
    end
end

module TestDeprecated

using Test, DataFrames, CategoricalArrays

const ≅ = isequal

@testset "indicator in joins" begin
    name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
    job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])

    @test outerjoin(name, job, on = :ID, indicator=:source) ≅
          outerjoin(name, job, on = :ID, source=:source)
    @test leftjoin(name, job, on = :ID, indicator=:source) ≅
          leftjoin(name, job, on = :ID, source=:source)
    @test rightjoin(name, job, on = :ID, indicator=:source) ≅
          rightjoin(name, job, on = :ID, source=:source)

    @test_throws ArgumentError outerjoin(name, job, on = :ID,
                                         indicator=:source, source=:source)
    @test_throws ArgumentError leftjoin(name, job, on = :ID,
                                       indicator=:source, source=:source)
    @test_throws ArgumentError rightjoin(name, job, on = :ID,
                                         indicator=:source, source=:source)
end

@testset "hcat with vector" begin
      df = DataFrame(x=1:3)
      x = [4, 5, 6]
      hdf = hcat(df, x)
      @test hdf[!, 1] == df[!, 1]
      @test hdf[!, 1] !== df[!, 1]
      @test hdf[!, 2] !== x
      hdf = hcat(x, df)
      @test hdf[!, 2] == df[!, 1]
      @test hdf[!, 2] !== df[!, 1]
      @test hdf[!, 1] !== x

      df = DataFrame()
      DataFrames.hcat!(df, CategoricalVector{Union{Int, Missing}}(1:10), makeunique=true)
      @test df[!, 1] == CategoricalVector(1:10)
      DataFrames.hcat!(df, 1:10, makeunique=true)
      @test df[!, 2] == collect(1:10)
      DataFrames.hcat!(df, collect(1:10), makeunique=true)
      @test df[!, 3] == collect(1:10)

      df = DataFrame()
      df2 = hcat(CategoricalVector{Union{Int, Missing}}(1:10), df, makeunique=true)
      @test isempty(df)
      @test df2[!, 1] == collect(1:10)
      @test names(df2) == ["x1"]
      ref_df = copy(df2)
      df3 = hcat(11:20, df2, makeunique=true)
      @test df2 == ref_df
      @test df3[!, 1] == collect(11:20)
      @test names(df3) == ["x1", "x1_1"]

      df1 = DataFrame(a=1:3)
      df2 = DataFrame(b=1:3)
      dfv = view(df2, :, :)
      x = [1, 2, 3]

      df3 = hcat(df1, x)
      @test propertynames(df3) == [:a, :x1]
      @test df3.a == df1.a
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.x1 !== x
      df3 = hcat(df1, x, copycols=true)
      @test propertynames(df3) == [:a, :x1]
      @test df3.a == df1.a
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.x1 !== x
      df3 = hcat(df1, x, copycols=false)
      @test propertynames(df3) == [:a, :x1]
      @test df3.a === df1.a
      @test df3.x1 === x

      df3 = hcat(x, df1)
      @test propertynames(df3) == [:x1, :a]
      @test df3.a == df1.a
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.x1 !== x
      df3 = hcat(x, df1, copycols=true)
      @test propertynames(df3) == [:x1, :a]
      @test df3.a == df1.a
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.x1 !== x
      df3 = hcat(x, df1, copycols=false)
      @test propertynames(df3) == [:x1, :a]
      @test df3.a === df1.a
      @test df3.x1 === x

      df3 = hcat(dfv, x, df1)
      @test propertynames(df3) == [:b, :x1, :a]
      @test df3.a == df1.a
      @test df3.b == dfv.b
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.b !== dfv.b
      @test df3.x1 !== x
      df3 = hcat(dfv, x, df1, copycols=true)
      @test propertynames(df3) == [:b, :x1, :a]
      @test df3.a == df1.a
      @test df3.b == dfv.b
      @test df3.x1 == x
      @test df3.a !== df1.a
      @test df3.b !== dfv.b
      @test df3.x1 !== x
      df3 = hcat(dfv, x, df1, copycols=false)
      @test propertynames(df3) == [:b, :x1, :a]
      @test df3.a === df1.a
      @test df3.b === dfv.b
      @test df3.x1 === x
end

@testset "delete!" begin
    df = DataFrame(a=1:4, b=1, c=2)
    @test delete!(copy(df), 1) == deleteat!(copy(df), 1)
    @test delete!(copy(df), [1, 3]) == deleteat!(copy(df), [1, 3])
    @test delete!(copy(df), [true, false, false, true]) == deleteat!(copy(df), [true, false, false, true])
    @test delete!(copy(df), Not(1)) == deleteat!(copy(df), Not(1))
    delete!(df, 2)
    @test df == DataFrame(a=[1, 3, 4], b=1, c=2)
end

@testset "deprecated sort" begin
    df = DataFrame(x=1, y=4:-1:1)
    @test sort(df, []) == DataFrame(x=1, y=1:4)
    @test !issorted(df, [])
    @test sortperm(df, []) == 4:-1:1
    sort!(df, [])
    @test df == DataFrame(x=1, y=1:4)
end

@testset "deprecated allowduplicates in unstack" begin
    df = DataFrame(row=[1, 1, 2, 2], variable=["x", "x", "y", "y"], value=1:4)
    @test_throws ArgumentError unstack(df, :row, :variable, :value)
    @test unstack(df, :row, :variable, :value, allowduplicates=true) ≅
          DataFrame(row=1:2, x=[2, missing], y=[missing, 4])
    @test unstack(df, :variable, :value, allowduplicates=true) ≅
          DataFrame(row=1:2, x=[2, missing], y=[missing, 4])
    @test unstack(df, allowduplicates=true) ≅
          DataFrame(row=1:2, x=[2, missing], y=[missing, 4])
    @test unstack(df, :variable, :value, allowduplicates=true) ≅
          DataFrame(row=1:2, x=[2, missing], y=[missing, 4])
    @test unstack(df, :row, :variable, :value, allowduplicates=true) ≅
          unstack(df, :row, :variable, :value, combine=last)
end

end # module

module TestDuplicates

using Test, DataFrames, CategoricalArrays, Random, PooledArrays
const ≅ = isequal

@testset "nonunique" begin
    df = DataFrame(a=[1, 2, 3, 3, 4])
    udf = DataFrame(a=[1, 2, 3, 4])
    @test nonunique(df) == [false, false, false, true, false]
    @test udf == unique(df)
    unique!(df)
    @test df == udf
    @test_throws ArgumentError unique(df, true)

    pdf = DataFrame(a=CategoricalArray(["a", "a", missing, missing, "b", missing, "a", missing]),
                    b=CategoricalArray(["a", "b", missing, missing, "b", "a", "a", "a"]))
    updf = DataFrame(a=CategoricalArray(["a", "a", missing, "b", missing]),
                    b=CategoricalArray(["a", "b", missing, "b", "a"]))
    @test nonunique(pdf) == [false, false, false, true, false, false, true, true]
    @test nonunique(updf) == falses(5)
    @test updf ≅ unique(pdf)
    unique!(pdf)
    @test pdf ≅ updf
    @test_throws ArgumentError unique(pdf, true)

    df = view(DataFrame(a=[1, 2, 3, 3, 4]), :, :)
    udf = DataFrame(a=[1, 2, 3, 4])
    @test nonunique(df) == [false, false, false, true, false]
    @test udf == unique(df)
    @test_throws ArgumentError unique!(df)
    @test_throws ArgumentError unique(df, true)

    pdf = view(DataFrame(a=CategoricalArray(["a", "a", missing, missing, "b", missing, "a", missing]),
                         b=CategoricalArray(["a", "b", missing, missing, "b", "a", "a", "a"])), :,  :)
    updf = DataFrame(a=CategoricalArray(["a", "a", missing, "b", missing]),
                     b=CategoricalArray(["a", "b", missing, "b", "a"]))
    @test nonunique(pdf) == [false, false, false, true, false, false, true, true]
    @test nonunique(updf) == falses(5)
    @test updf ≅ unique(pdf)
    @test_throws ArgumentError unique!(pdf)
    @test_throws ArgumentError unique(pdf, true)

    @test isempty(nonunique(DataFrame(a=PooledArray(Int[]))))
    @test typeof(nonunique(DataFrame(a=PooledArray(Int[])))) === Vector{Bool}
end

@testset "nonunique, nonunique, unique! with extra argument" begin
    df1 = DataFrame(a=Union{String, Missing}["a", "b", "a", "b", "a", "b"],
                    b=Vector{Union{Int, Missing}}(1:6),
                    c=Union{Int, Missing}[1:3;1:3])
    df = vcat(df1, df1)
    @test findall(nonunique(df)) == collect(7:12)
    @test findall(nonunique(df, :)) == collect(7:12)
    @test findall(nonunique(df, Colon())) == collect(7:12)
    @test findall(nonunique(df, :a)) == collect(3:12)
    @test findall(nonunique(df, "a")) == collect(3:12)
    @test findall(nonunique(df, [:a, :c])) == collect(7:12)
    @test findall(nonunique(df, ["a", "c"])) == collect(7:12)
    @test findall(nonunique(df, r"[ac]")) == collect(7:12)
    @test findall(nonunique(df, Not(2))) == collect(7:12)
    @test findall(nonunique(df, Not([2]))) == collect(7:12)
    @test findall(nonunique(df, Not(:b))) == collect(7:12)
    @test findall(nonunique(df, Not([:b]))) == collect(7:12)
    @test findall(nonunique(df, Not([false, true, false]))) == collect(7:12)
    @test findall(nonunique(df, [1, 3])) == collect(7:12)
    @test findall(nonunique(df, 1)) == collect(3:12)
    @test findall(nonunique(df, :a => x -> 1)) == 2:12

    @test unique(df) == df1
    @test unique(df, :) == df1
    @test unique(df, Colon()) == df1
    @test unique(df, 2:3) == df1
    @test unique(df, 3) == df1[1:3, :]
    @test unique(df, [1, 3]) == df1
    @test unique(df, [:a, :c]) == df1
    @test unique(df, ["a", "c"]) == df1
    @test unique(df, r"[ac]") == df1
    @test unique(df, Not(2)) == df1
    @test unique(df, Not([2])) == df1
    @test unique(df, Not(:b)) == df1
    @test unique(df, Not([:b])) == df1
    @test unique(df, Not([false, true, false])) == df1
    @test unique(df, :a) == df1[1:2, :]
    @test unique(df, "a") == df1[1:2, :]
    @test unique(df, :a => x -> 1) == df[1:1, :]
    @test unique(DataFrame()) == DataFrame()
    @test isempty(nonunique(DataFrame())) && nonunique(DataFrame()) isa Vector{Bool}
    @test_throws ArgumentError nonunique(DataFrame(a=1:3), [])
    @test_throws ArgumentError unique(DataFrame(a=1:3), [])

    @test unique(copy(df1), "a") == unique(copy(df1), :a) == unique(copy(df1), 1) ==
          df1[1:2, :]

    unique!(df, [1, 3])
    @test df == df1
    for cols in (r"[ac]", Not(:b), Not(2), Not([:b]), Not([2]), Not([false, true, false]))
        df = vcat(df1, df1)
        unique!(df, cols)
        @test df == df1
    end
end

@testset "keep argument to nonunique/unique/unique!" begin
    df = DataFrame(a=[1, 2, 3, 1, 2, 1],
                   b=["a", "b", "c", "a", "b", "a"],
                   c=categorical(["a", "b", "c", "a", "b", "a"]))
    for cols in (1, 2, 3, [1, 2], [1, 3], [2, 3], [1, 2, 3])
        @test nonunique(df, cols, keep=:first) ==
              [false, false, false, true, true, true]
        @test nonunique(df, cols, keep=:last) ==
              [true, true, false, true, false, false]
        @test nonunique(df, cols, keep=:noduplicates) ==
              [true, true, false, true, true, true]
        @test nonunique(select(df, cols), keep=:first) ==
              [false, false, false, true, true, true]
        @test nonunique(select(df, cols), keep=:last) ==
              [true, true, false, true, false, false]
        @test nonunique(select(df, cols), keep=:noduplicates) ==
              [true, true, false, true, true, true]

        @test unique(df, cols, keep=:first) ==
              df[.![false, false, false, true, true, true], :]
        @test unique(df, cols, keep=:last) ==
              df[.![true, true, false, true, false, false], :]
        @test unique(df, cols, keep=:noduplicates) ==
              df[.![true, true, false, true, true, true], :]
        @test unique(select(df, cols), keep=:first) ==
              df[.![false, false, false, true, true, true], Cols(cols)]
        @test unique(select(df, cols), keep=:last) ==
              df[.![true, true, false, true, false, false], Cols(cols)]
        @test unique(select(df, cols), keep=:noduplicates) ==
              df[.![true, true, false, true, true, true], Cols(cols)]

        @test unique!(copy(df), cols, keep=:first) ==
              df[.![false, false, false, true, true, true], :]
        @test unique!(copy(df), cols, keep=:last) ==
              df[.![true, true, false, true, false, false], :]
        @test unique!(copy(df), cols, keep=:noduplicates) ==
              df[.![true, true, false, true, true, true], :]
        @test unique!(select(df, cols), keep=:first) ==
              df[.![false, false, false, true, true, true], Cols(cols)]
        @test unique!(select(df, cols), keep=:last) ==
              df[.![true, true, false, true, false, false], Cols(cols)]
        @test unique!(select(df, cols), keep=:noduplicates) ==
              df[.![true, true, false, true, true, true], Cols(cols)]
    end

    # some larger randomized test
    Random.seed!(1234)
    df = DataFrame(a=rand(1:10^5, 10^5))
    df.b = string.(df.a)
    df.c = categorical(df.b)
    df.id = 1:10^5

    for cols in (1, 2, 3, [1, 2], [1, 3], [2, 3], [1, 2, 3])
        @test select(unique(df, cols, keep=:first), cols, Not(cols)) ==
              combine(groupby(df, cols, sort=false), first)
        @test select(unique(df, cols, keep=:last), cols, Not(cols)) ==
              sort(combine(groupby(df, cols, sort=false), last), :id)
        @test select(unique(df, cols, keep=:noduplicates), cols, Not(cols)) ==
              sort(combine(groupby(df, cols, sort=false),
                           sdf -> nrow(sdf) == 1 ? sdf : NamedTuple()), :id)
    end

    @test isempty(nonunique(DataFrame(), keep=:first))
    @test unique(DataFrame(a=[]), keep=:last) == DataFrame(a=[])
    @test unique!(DataFrame(), keep=:noduplicates) == DataFrame()
    @test_throws ArgumentError nonunique(DataFrame(), keep=:a)
    @test_throws ArgumentError unique(DataFrame(), keep=:b)
    @test_throws ArgumentError unique!(DataFrame(), keep=:c)
end

@testset "case when groups are not compressed in row_group_slots!" begin
   df = DataFrame(x=repeat([1:1000; -1], 2));
   @test getindex.(keys(groupby(df, :x, sort=true)), 1) == [-1; 1:1000]
   @test nonunique(df, :x) == [falses(1001); trues(1001)]
   @test nonunique(df, :x, keep=:last) == [trues(1001); falses(1001)]
   @test all(nonunique(df, :x, keep=:noduplicates))
end

end # module

module TestDataFrameRow

using Test, DataFrames, Random, Logging, CategoricalArrays
const ≅ = isequal
const ≇ = !isequal

ref_df = DataFrame(a=Union{Int, Missing}[1, 2, 3, 1, 2, 2],
                   b=[2.0, missing, 1.2, 2.0, missing, missing],
                   c=["A", "B", "C", "A", "B", missing],
                   d=CategoricalArray(["A", missing, "C", "A", missing, "C"]))

@testset "constructors" begin
    df = deepcopy(ref_df)
    sdf = view(df, [5, 3], [3, 1, 2])

    @test names(DataFrameRow(df, 1, :)) == ["a", "b", "c", "d"]
    @test DataFrameRow(df, 1) == DataFrameRow(df, 1, :)
    @test DataFrameRow(df, 1) == DataFrameRow(df, 1, r"")
    @test names(DataFrameRow(df, 3, [3, 2])) == ["c", "b"]
    @test copy(DataFrameRow(df, 3, [3, 2])) == (c="C", b=1.2)
    @test copy(DataFrameRow(df, 3, r"[bc]")) == (b=1.2, c="C")
    @test copy(DataFrameRow(sdf, 2, [3, 2])) == (b=1.2, a=3)
    @test copy(DataFrameRow(sdf, 2, r"[bc]")) == (c="C", b=1.2)
    @test copy(DataFrameRow(sdf, 2, :)) == (c="C", a=3, b=1.2)
    @test DataFrameRow(sdf, 2) == DataFrameRow(sdf, 2, :)
    @test DataFrameRow(df, 3, [3, 2]) == df[3, [3, 2]] == view(df, 3, [3, 2])
    @test DataFrameRow(df, 3, r"[bc]") == df[3, [2, 3]] == df[3, r"[bc]"]
    @test DataFrameRow(sdf, 2, [3, 2]) == sdf[2, [3, 2]] == view(sdf, 2, [3, 2])
    @test DataFrameRow(sdf, 2, r"[bc]") == sdf[2, [1, 3]] == sdf[2, r"[bc]"]
    @test DataFrameRow(sdf, 2, :) == sdf[2, :] == view(sdf, 2, :)
    @test DataFrameRow(df, 3, 2:3) === df[3, 2:3]
    @test view(df, 3, 2:3) === df[3, 2:3]
    for x in (df, sdf)
        @test_throws ArgumentError DataFrameRow(x, 1, :a)
        @test_throws ArgumentError DataFrameRow(x, 1, 1)
        @test_throws BoundsError DataFrameRow(x, 1, 1:10)
        @test_throws BoundsError DataFrameRow(x, 1, [1:10;])
        @test_throws BoundsError DataFrameRow(x, 100, 1:2)
        @test_throws BoundsError DataFrameRow(x, 100, [1:2;])
        @test_throws BoundsError DataFrameRow(x, 100, :)
        @test_throws BoundsError DataFrameRow(x, 100)
        @test_throws ArgumentError DataFrameRow(x, true, 1:2)
        @test_throws ArgumentError DataFrameRow(x, true)
    end
    @test_throws ArgumentError DataFrameRow(sdf, true, 1:2)
end

@testset "getindex and setindex!" begin
    df = deepcopy(ref_df)
    sdf = view(df, [5, 3], [3, 1, 2])

    r = DataFrameRow(df, 2, :)
    @test r[:] === r
    @test r[r""] ≅ r
    @test view(r, :) === r
    @test view(r, r"") ≅ r
    @test r[3] == "B"
    @test r[r"c"] == r[[3]]
    @test_throws BoundsError r[5]
    @test view(r, 3)[] == "B"
    @test view(r, r"c")[1] == "B"
    @test view(r, r"c") == view(r, [3])
    view(r, 3)[] = "BB"
    @test df.c[2] == "BB"
    @test_throws MethodError r[true]
    @test_throws MethodError view(r, true)
    @test copy(r[[:c, :a]]) == (c = "BB", a = 2)
    @test copy(r[r"[ac]"]) == (a = 2, c = "BB")
    @test copy(r[r"x"]) == NamedTuple()
    @test copy(r[2:1]) == NamedTuple()
    @test copy(r[Symbol[]]) == NamedTuple()
    @test copy(view(r, [:c, :a])) == (c = "BB", a = 2)
    @test copy(view(r, r"[ac]")) == (a = 2, c = "BB")
    @test copy(view(r, r"x")) == NamedTuple()
    @test copy(view(r, 2:1)) == NamedTuple()
    @test copy(view(r, Symbol[])) == NamedTuple()
    @test copy(r[[true, false, true, false]]) == (a = 2, c = "BB")
    r.c = "B"
    @test df.c[2] == "B"
    @test_throws BoundsError copy(r[[true, false, true]])

    r = DataFrameRow(sdf, 2, [3, 1])
    @test r[:] == r
    @test r[r""] == r
    @test view(r, :) === r
    @test view(r, r"") == r
    @test r[2] == "C"
    @test r[r"c"] == r[[2]]
    @test r[2:1] == r[r"x"]
    @test_throws BoundsError r[4]
    @test view(r, 2)[] == "C"
    @test view(r, r"c") == view(r, [2])
    view(r, 2)[] = "CC"
    @test df.c[3] == "CC"
    @test_throws MethodError r[true]
    @test_throws MethodError view(r, true)
    @test copy(r[[:c, :b]]) == (c = "CC", b = 1.2)
    @test copy(view(r, [:c, :b])) == (c = "CC", b = 1.2)
    @test copy(view(r, [:c, :b])) == (c = "CC", b = 1.2)
    @test copy(r[[false, true]]) == (c = "CC",)
    @test copy(r[r"[cb]"]) == (b = 1.2, c = "CC")
    @test copy(view(r, r"[cb]")) == (b = 1.2, c = "CC")
    @test copy(view(r, r"[cb]")) == (b = 1.2, c = "CC")
    @test copy(r[r"b"]) == (b = 1.2,)
    @test copy(view(r, r"b")) == (b = 1.2,)
    @test copy(view(r, r"b")) == (b = 1.2,)
    r.c = "C"
    @test df.c[3] == "C"

    df = DataFrame([1 2 3 4
                    5 6 7 8], :auto)
    r = df[1, r"[1-3]"]
    @test names(r) == ["x1", "x2", "x3"]
    r[:] .= 10
    @test df == DataFrame([10 10 10 4
                            5  6  7 8], :auto)
    r[r"[2-3]"] .= 20
    @test df == DataFrame([10 20 20 4
                            5  6  7 8], :auto)
end

@testset "equality" begin
    df = deepcopy(ref_df)
    df2 = DataFrame(a=[1, 2, 3])

    @test !isequal(DataFrameRow(df, 1, :), DataFrameRow(df2, 1, :))
    @test isequal(DataFrame(a=missing)[1, :], DataFrame(a=missing)[1, :])
    @test DataFrameRow(df, 1, :) != DataFrameRow(df2, 1, :)
    @test DataFrameRow(df, 1, [:a]) == DataFrameRow(df2, 1, :)
    @test DataFrameRow(df, 1, [:a]) == DataFrameRow(df2, big(1), :)
    @test DataFrameRow(df, 1, :) != DataFrameRow(df, 2, :)
    @test DataFrameRow(df, 1, :) != DataFrameRow(df, 3, :)
    @test DataFrameRow(df, 1, :) == DataFrameRow(df, 4, :)
    @test ismissing(DataFrameRow(df, 2, :) == DataFrameRow(df, 5, :))
    @test DataFrameRow(df, 2, :) ≅ DataFrameRow(df, 5, :)
    @test ismissing(DataFrameRow(df, 2, :) != DataFrameRow(df, 6, :))
    @test DataFrameRow(df, 2, :) ≇ DataFrameRow(df, 6, :)

    dc_df = deepcopy(df)
    @test DataFrameRow(df, 1, :) == DataFrameRow(dc_df, 1, :)
    @test DataFrameRow(df, 1, 1:2) == DataFrameRow(dc_df, 1, 1:2)
    @test DataFrameRow(df, 1, [1, 2]) != DataFrameRow(dc_df, 1, [2, 1])
    dc_df[1, 1] = 2
    @test DataFrameRow(df, 1, :) != DataFrameRow(dc_df, 1, :)
    @test DataFrameRow(df, 1, 1:2) != DataFrameRow(dc_df, 1, 1:2)
    @test DataFrameRow(df, 1, [2]) == DataFrameRow(dc_df, 1, [2])
    rename!(df, :b=>:z)
    @test DataFrameRow(df, 1, [2]) != DataFrameRow(dc_df, 1, [2])
end

@testset "isless" begin
    df = DataFrame(a=[1, 1, 2, 2, 2, 2, missing, missing],
                   b=Union{Float64, Missing}[2.0, 3.0, 1.0, 2.0, 2.0, 2.0, 2.0, 3.0],
                   c=[:B, missing, :A, :C, :D, :D, :A, :A])

    @test isless(DataFrameRow(df, 1, :), DataFrameRow(df, 2, :))
    @test !isless(DataFrameRow(df, 2, :), DataFrameRow(df, 1, :))
    @test !isless(DataFrameRow(df, 1, :), DataFrameRow(df, 1, :))
    @test isless(DataFrameRow(df, 1, :), DataFrameRow(df, 3, :))
    @test !isless(DataFrameRow(df, 3, :), DataFrameRow(df, 1, :))
    @test isless(DataFrameRow(df, 3, :), DataFrameRow(df, 4, :))
    @test !isless(DataFrameRow(df, 4, :), DataFrameRow(df, 3, :))
    @test isless(DataFrameRow(df, 4, :), DataFrameRow(df, 5, :))
    @test !isless(DataFrameRow(df, 5, :), DataFrameRow(df, 4, :))
    @test !isless(DataFrameRow(df, 6, :), DataFrameRow(df, 5, :))
    @test !isless(DataFrameRow(df, 5, :), DataFrameRow(df, 6, :))
    @test isless(DataFrameRow(df, 7, :), DataFrameRow(df, 8, :))
    @test !isless(DataFrameRow(df, 8, :), DataFrameRow(df, 7, :))

    @test_throws ArgumentError df[1, 1:2] < df[1, 1:3]
    @test_throws ArgumentError df[1, 1:2] < df[1, 2:3]
end

@testset "hashing of DataFrameRow and GroupKey" begin
    df = deepcopy(ref_df)

    @test hash(DataFrameRow(df, 1, :)) != hash(DataFrameRow(df, 2, :))
    @test hash(DataFrameRow(df, 1, :)) != hash(DataFrameRow(df, 3, :))
    @test hash(DataFrameRow(df, 1, :)) == hash(DataFrameRow(df, 4, :))
    @test hash(DataFrameRow(df, 2, :)) == hash(DataFrameRow(df, 5, :))
    @test hash(DataFrameRow(df, 2, :)) != hash(DataFrameRow(df, 6, :))

    df = DataFrame(reshape(1:24, 6, 4), :auto)
    df.x2 = string.(df.x2)
    df.x3 = categorical(df.x3)
    df.x4 = Float64.(df.x4)
    gks = keys(groupby(df, :))

    for i in axes(df, 1), h in UInt(0):UInt(10)
        @test hash(DataFrameRow(df, i, :), h) ==
              hash(gks[i], h) ==
              hash(NamedTuple(DataFrameRow(df, i, :)), h)
    end
end

@testset "getproperty, setproperty! and propertynames" begin
    df = deepcopy(ref_df)

    r = DataFrameRow(df, 1, :)
    @test propertynames(r) == keys(r) == Symbol.(names(df))
    @test r.a === 1
    @test r.b === 2.0
    @test copy(r[[:a, :b]]) == (a=1, b=2.0)

    r.a = 2
    @test r.a === 2
    r.b = 1
    @test r.b === 1.0
end

@testset "keys, values and iteration, size" begin
    df = deepcopy(ref_df)
    r = DataFrameRow(df, 1, :)

    @test keys(r) == propertynames(df)
    @test values(r) == (df[1, 1], df[1, 2], df[1, 3], df[1, 4])
    @test collect(pairs(r)) == [:a=>df[1, 1], :b=>df[1, 2], :c=>df[1, 3], :d=>df[1, 4]]

    @test haskey(r, :a)
    @test haskey(r, 1)
    @test !haskey(r, :zzz)
    @test !haskey(r, 0)
    @test !haskey(r, 1000)
    @test_throws ArgumentError haskey(r, true)

    x = DataFrame(ones(5, 4), :auto)
    dfr = view(x, 2, 2:3)
    @test names(dfr) == names(x)[2:3]
    dfr = view(x, 2, [4, 2])
    @test names(dfr) == names(x)[[4, 2]]

    x = DataFrame(ones(10, 10), :auto)
    r = x[3, [8, 5, 1, 3]]
    @test length(r) == 4
    @test lastindex(r) == 4
    @test ndims(r) == 1
    @test ndims(typeof(r)) == 1
    @test size(r) == (4,)
    @test size(r, 1) == 4
    @test_throws BoundsError size(r, 2)
    @test keys(r) == [:x8, :x5, :x1, :x3]
    r[:] .= 0.0
    r[1:2] .= 2.0
    @test values(r) == (2.0, 2.0, 0.0, 0.0)
    @test collect(pairs(r)) == [:x8 => 2.0, :x5 => 2.0, :x1 => 0.0, :x3 => 0.0]

    r = deepcopy(ref_df)[1, :]
    @test map(identity, r[1:3]) == (a = 1, b = 2.0, c = "A")
    @test map((a, b) -> (a, b), r[1:3], r[1:3]) == (a = (1, 1), b = (2.0, 2.0), c = ("A", "A"))
    @test get(r, 1, 100) == 1
    @test get(r, :a, 100) == 1
    @test get(r, 10, 100) == 100
    @test get(r, :z, 100) == 100
    @test get(() -> 100, r, 1) == 1
    @test get(() -> 100, r, :a) == 1
    @test get(() -> 100, r, 10) == 100
    @test get(() -> 100, r, :z) == 100
end

@testset "convert, copy and merge" begin
    df = DataFrame(a=[1, missing, missing], b=[2.0, 3.0, 0.0])
    dfr = DataFrameRow(df, 1, :)
    nt = first(Tables.namedtupleiterator(df))
    @test copy(dfr) === nt === NamedTuple{(:a, :b), Tuple{Union{Missing, Int}, Float64}}((1, 2.0))
    @test sum(skipmissing(copy(df[3, :]))) == 0
    @test Vector(dfr)::Vector{Union{Float64, Missing}} == [1.0, 2.0]
    @test Vector{Int}(dfr)::Vector{Int} == [1, 2]

    @test Array(dfr)::Vector{Union{Float64, Missing}} == [1.0, 2.0]
    @test Array{Int}(dfr)::Vector{Int} == [1, 2]

    df = ref_df[:, 1:3]
    @test copy(DataFrameRow(df, 1, :)) == (a=1, b=2.0, c="A")
    @test copy(DataFrameRow(df, 2, :)) ≅ (a=2, b=missing, c="B")

    dfr = DataFrame(a=1, b=2)[1, :]
    dfr2 = DataFrame(c=3, d=4)[1, :]
    @test NamedTuple(dfr) == (a=1, b=2)
    @test convert(NamedTuple, dfr) == (a=1, b=2)
    @test merge(dfr) == (a=1, b=2)
    @test merge(dfr, (c=3, d=4)) == (a=1, b=2, c=3, d=4)
    @test merge((c=3, d=4), dfr) == (c=3, d=4, a=1, b=2)
    @test merge(dfr, dfr2) == (a=1, b=2, c=3, d=4)
    @test merge(dfr, pairs((c=3, d=4))) == (a=1, b=2, c=3, d=4)
    @test merge(dfr, pairs(dfr2)) == (a=1, b=2, c=3, d=4)

    testkwargs(;kw...) = collect(kw)
    @test testkwargs(;dfr...) == [:a=>1, :b=>2]
    @test testkwargs(;dfr..., dfr2...) == [:a=>1, :b=>2, :c=>3, :d=>4]
    @test testkwargs(;x=0, dfr..., dfr2..., z=5) == [:x=>0, :a=>1, :b=>2, :c=>3, :d=>4, :z=>5]
end

@testset "parent and parentindices" begin
    df = ref_df[:, 1:3]

    @test parent(df[2, :]) === df
    @test parentindices(df[2, []]) == (2, Int[])
    @test parentindices(df[2, :]) == (2, Base.OneTo(3))
    @test parentindices(df[2, r""]) == (2, [1, 2, 3])
    @test parentindices(df[2, r"[ab]"]) == (2, [1, 2])
    @test parentindices(df[2, r"x"]) == (2, Int[])
    @test parent(df[1, 1:3]) === df
    @test parentindices(df[1, [3, 2]]) == (1, [3, 2])
    sdf = view(df, [4, 3], [:c, :a])
    @test parent(sdf[2, :]) === df
    @test parentindices(sdf[2, :]) == (3, [3, 1])
    @test parentindices(sdf[2, r""]) == (3, [3, 1])
    @test parentindices(sdf[2, r"a"]) == (3, [1])
    @test parentindices(sdf[2, r"x"]) == (3, Int[])
    @test parent(sdf[1, 1:2]) === df
    @test_throws ArgumentError parentindices(sdf[1, [2, 2]])
    @test parent(df[2, r""]) === df
    @test parent(df[2, r"a"]) === df
    @test parent(df[2, r"x"]) === df
    @test parentindices(df[2, :]) == (2, Base.OneTo(3))
    @test parentindices(df[2, r""]) == (2, [1, 2, 3])
    @test parentindices(df[2, r"a"]) == (2, [1])
    @test parentindices(df[2, r"x"]) == (2, Int[])
    @test parent(df[1, 1:3]) === df
    @test parentindices(df[1, [3, 2]]) == (1, [3, 2])
    sdf = view(df, [4, 3], [:c, :a])
    @test parent(sdf[2, :]) === df
    @test parent(sdf[2, r""]) === df
    @test parent(sdf[2, r"a"]) === df
    @test parent(sdf[2, r"x"]) === df
    @test parentindices(sdf[2, :]) == (3, [3, 1])
    @test parentindices(sdf[2, r""]) == (3, [3, 1])
    @test parentindices(sdf[2, r"a"]) == (3, [1])
    @test parentindices(sdf[2, r"x"]) == (3, Int[])
    @test parent(sdf[1, 1:2]) === df
    @test_throws ArgumentError parentindices(sdf[1, [2, 2]])
end

@testset "iteration and collect" begin
    ref = ["a", "b", "c"]
    df = DataFrame(permutedims(ref), :auto)
    dfr = df[1, :]
    @test Base.IteratorEltype(dfr) == Base.EltypeUnknown()
    @test collect(dfr) == ref
    @test eltype(collect(dfr)) === String
    for (v1, v2) in zip(ref, dfr)
        @test v1 == v2
    end
    for (i, v) in enumerate(dfr)
        @test v == ref[i]
    end
    dfr = DataFrame(a=1, b=true, c=1.0)[1, :]
    @test eltype(collect(dfr)) === Real
end

@testset "duplicate column" begin
    df = DataFrame([11:16 21:26 31:36 41:46], :auto)
    sdf = view(df, [3, 1, 4], [3, 1, 4])
    @test_throws ArgumentError df[2, [2, 2, 2]]
    @test_throws ArgumentError sdf[2, [2, 2, 2]]
end

@testset "conversion and push!" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df = DataFrame(x=1, y=2)

    @test df == DataFrame(df[1, :])
    @test df[1:1, [2, 1]] == DataFrame(df[1, [2, 1]])
    @test df[1:1, 1:1] == DataFrame(df[1, 1:1])
    @test_throws ArgumentError DataFrame(df[1, [1, 1]])

    @test_throws ArgumentError push!(df, df[1, 1:1])
    @test df == DataFrame(x=1, y=2)

    with_logger(sl) do
        @test_throws ArgumentError push!(df, df[1, [2, 2]])
    end
    @test df == DataFrame(x=1, y=2)

    @test_throws ArgumentError push!(df, df[1, [2, 1]], cols=:orderequal)
    @test df == DataFrame(x=1, y=2)

    @test push!(df, df[1, :]) == DataFrame(x=[1, 1], y=[2, 2])
    @test push!(df, df[1, [2, 1]], cols=:setequal) == DataFrame(x=[1, 1, 1], y=[2, 2, 2])
    @test_throws ArgumentError push!(df, df[1, [2, 1]], cols=:setequals)

    push!(df, df[1, [2, 1]], cols=:intersect)
    @test df == DataFrame(x=[1, 1, 1, 1], y=[2, 2, 2, 2])

    df2 = DataFrame()
    @test push!(df2, df[1, :]) === df2
    @test df2 == df[1:1, :]
end

@testset "show" begin
    function capture_stdout(f::Function)
        oldstdout = stdout
        rd, wr = redirect_stdout()
        f()
        redirect_stdout(oldstdout)
        size = displaysize(rd)
        close(wr)
        str = read(rd, String)
        close(rd)
        str, size
    end

    df = DataFrame(a=nothing, b=1)

    @test sprint(show, DataFrameRow(df, 1, :)) == """
        DataFrameRow
         Row │ a        b
             │ Nothing  $(Int)
        ─────┼────────────────
           1 │              1"""


    df = DataFrame(a=1:3, b=["a", "b", "c"], c=Int64[1, 0, 1])
    dfr = df[2, 2:3]

    @test sprint(show, dfr) == """
        DataFrameRow
         Row │ b       c
             │ String  Int64
        ─────┼───────────────
           2 │ b           0"""

    # Test two-argument show
    str1, size = capture_stdout() do
        show(dfr)
    end
    io = IOContext(IOBuffer(), :limit=>true, :displaysize=>size)
    show(io, dfr)
    str2 = String(take!(io.io))
    @test str1 == str2

    # Test error when invalid keyword arguments are passed in text backend.
    @test_throws ArgumentError show(stdout, dfr, max_column_width="100px")
    @test_throws ArgumentError show(stdout, MIME("text/plain"), dfr, max_column_width="100px")

    str = sprint(show, "text/html", dfr)
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>DataFrameRow (2 columns)</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">b</th>" *
                 "<th style = \"text-align: left;\">c</th>" *
                 "</tr>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">" *
                 "</th>" *
                 "<th title = \"String\" style = \"text-align: left;\">String</th>" *
                 "<th title = \"Int64\" style = \"text-align: left;\">Int64</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">b</td>" *
                 "<td style = \"text-align: right;\">0</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    @test sprint(show, "text/latex", dfr) == """
        \\begin{tabular}{r|cc}
        \t& b & c\\\\
        \t\\hline
        \t& String & Int64\\\\
        \t\\hline
        \t2 & b & 0 \\\\
        \\end{tabular}
        """

    @test sprint(show, "text/csv", dfr) == """
        \"b\",\"c\"
        \"b\",0
        """

    @test sprint(show, "text/tab-separated-values", dfr) == """
        \"b\"\t\"c\"
        \"b\"\t0
        """

    io = IOBuffer()
    show(io, dfr, eltypes=false)
    str = String(take!(io))
    @test str == """
    DataFrameRow
     Row │ b  c
    ─────┼──────
       2 │ b  0"""

    io = IOBuffer()
    show(io, MIME("text/plain"), dfr, eltypes=false)
    str = String(take!(io))
    @test str == """
    DataFrameRow
     Row │ b  c
    ─────┼──────
       2 │ b  0"""

    io = IOBuffer()
    show(io, MIME("text/html"), dfr, eltypes=false)
    str = String(take!(io))
    @test str == "<div>" *
                 "<div style = \"float: left;\">" *
                 "<span>DataFrameRow (2 columns)</span>" *
                 "</div>" *
                 "<div style = \"clear: both;\">" *
                 "</div>" *
                 "</div>" *
                 "<div class = \"data-frame\" style = \"overflow-x: scroll;\">" *
                 "<table class = \"data-frame\" style = \"margin-bottom: 6px;\">" *
                 "<thead>" *
                 "<tr class = \"columnLabelRow\">" *
                 "<th class = \"stubheadLabel\" style = \"font-weight: bold; text-align: right;\">Row</th>" *
                 "<th style = \"text-align: left;\">b</th>" *
                 "<th style = \"text-align: left;\">c</th>" *
                 "</tr>" *
                 "</thead>" *
                 "<tbody>" *
                 "<tr class = \"dataRow\">" *
                 "<td class = \"rowLabel\" style = \"font-weight: bold; text-align: right;\">2</td>" *
                 "<td style = \"text-align: left;\">b</td>" *
                 "<td style = \"text-align: right;\">0</td>" *
                 "</tr>" *
                 "</tbody>" *
                 "</table>" *
                 "</div>"

    io = IOBuffer()
    show(io, MIME("text/latex"), dfr, eltypes=false)
    str = String(take!(io))
    @test str == "\\begin{tabular}{r|cc}\n\t& b & c\\\\\n\t\\hline\n\t2 & b & 0 \\\\\n\\end{tabular}\n"
end

@testset "check Vector type" begin
    df = DataFrame(a=1, b=1.0, c=1)
    dfr = df[1, [1, 3]]
    @test eltype(Vector(dfr)) == Int
end

@testset "DataFrameRow" begin
    df = DataFrame(A=Vector{Union{Int, Missing}}(1:2), B=Vector{Union{Int, Missing}}(2:3))
    row = DataFrameRow(df, 1, :)

    row[:A] = 100
    @test df[1, :A] == 100

    row[1] = 101
    @test df[1, :A] == 101
end

@testset "rownumber" begin
    df = DataFrame(reshape(1:12, 3, 4), :auto)
    dfr = df[2, :]
    @test rownumber(dfr) == 2
    @test parentindices(dfr) == (2, 1:4)
    @test parent(dfr) === df

    dfr = @view df[2, :]
    @test rownumber(dfr) == 2
    @test parentindices(dfr) == (2, 1:4)
    @test parent(dfr) === df

    dfr = dfr[1:2]
    @test rownumber(dfr) == 2
    @test parentindices(dfr) == (2, 1:2)
    @test parent(dfr) === df

    dfr = @view dfr[1:2]
    @test rownumber(dfr) == 2
    @test parentindices(dfr) == (2, 1:2)
    @test parent(dfr) === df

    for (i, r) in enumerate(eachrow(df))
        @test rownumber(r) == i
        @test parentindices(r) == (i, 1:4)
        @test parent(r) === df
    end

    dfv = @view df[2:3, 1:3]
    dfrv = dfv[2, :]
    @test rownumber(dfrv) == 2
    @test parentindices(dfrv) == (3, 1:3)
    @test parent(dfrv) == df

    dfrv = @view dfv[2, :]
    @test rownumber(dfrv) == 2
    @test parentindices(dfrv) == (3, 1:3)
    @test parent(dfrv) == df

    dfrv = dfrv[1:2]
    @test rownumber(dfrv) == 2
    @test parentindices(dfrv) == (3, 1:2)
    @test parent(dfrv) === df

    dfrv = @view dfrv[1:2]
    @test rownumber(dfrv) == 2
    @test parentindices(dfrv) == (3, 1:2)
    @test parent(dfrv) === df

    for (i, r) in enumerate(eachrow(dfv))
        @test rownumber(r) == i
        @test parentindices(r) == (i + 1, 1:3)
        @test parent(r) === df
    end
end

@testset "broadcasting" begin
    r = DataFrame(a=1)[1, :]
    @test_throws ArgumentError r .+ 1
end

@testset "comparison tests: DataFrameRow, NamedTuple and GroupKey" begin
    df = DataFrame(a=[1, 2], b=[missing, 3])
    dfr = [df[1, :], df[2, :], df[1, 1:1], df[2, 1:1]]
    nt = NamedTuple.(dfr)
    gk = [keys(groupby(df, [:a, :b])); keys(groupby(df, :a))]

    for l in (dfr[1], nt[1], gk[1]), r in (dfr[1], nt[1], gk[1])
        @test ismissing(l == r)
        @test ismissing(l == (a=1, b=2))
        @test l ≅ r
        @test l ≇ (a=1, b=2)
        # work around https://github.com/JuliaLang/julia/pull/40147
        if !(l isa NamedTuple && r isa NamedTuple)
            @test ismissing(l < r)
        end
        @test !isless(l, r)
    end

    for i in 2:4, l in (dfr, nt, gk), r in (dfr, nt, gk)
        @test l[i] == r[i]
        @test l[1] != l[i]
        @test l[1] != r[i]
        @test l[i] ≅ r[i]
        @test l[1] ≇ l[i]
        @test l[1] ≇ r[i]

        @test !(l[i] < r[i])
        @test !isless(l[i], r[i])

        if i > 2
            if l[1] isa NamedTuple && r[i] isa NamedTuple
                @test_throws MethodError l[1] < r[i]
                @test_throws MethodError isless(l[1], r[i])
            else
                @test_throws ArgumentError l[1] < r[i]
                @test_throws ArgumentError isless(l[1], r[i])
            end
        end
    end

    for l in (dfr, nt, gk), r in (dfr, nt, gk)
        @test l[1] < r[2]
        @test isless(l[1], r[2])
        @test !(l[2] < r[1])
        @test !isless(l[2], r[1])

        @test l[3] < r[4]
        @test isless(l[3], r[4])
        @test !(l[4] < r[3])
        @test !isless(l[4], r[3])
    end

    @test !(dfr[1] == (x=1, b=missing))
    @test !(gk[1] == (x=1, b=missing))
    @test !(dfr[1] ≅ (x=1, b=missing))
    @test !(gk[1] ≅ (x=1, b=missing))

    @test_throws ArgumentError dfr[1] < (x=1, b=missing)
    @test_throws ArgumentError gk[1] < (x=1, b=missing)
    @test_throws ArgumentError isless(dfr[1], (x=1, b=missing))
    @test_throws ArgumentError isless(gk[1], (x=1, b=missing))

    df2 = DataFrame(a=1, b=missing)
    df3 = DataFrame(a=2, b=1)
    dfr2 = df2[1, :]
    dfr3 = df3[1, :]
    nt2 = NamedTuple(dfr2)
    nt3 = NamedTuple(dfr3)
    gk2 = keys(groupby(df2, [:a, :b]))[1]
    gk3 = keys(groupby(df3, [:a, :b]))[1]

    for a in (dfr2, nt2, gk2), b in (dfr3, nt3, gk3)
        @test !(a == b)
        @test !(a ≅ b)
        @test a < b
        @test isless(a, b)
    end
end

end # module

##############################################################################
##
## Functions related to the interface with PrettyTables.jl.
##
##############################################################################

# Default DataFrames formatter for text backend.
#
# This formatter changes how the following types are presented when rendering
# the data frame:
#     - missing;
#     - nothing;
#     - Cells with types related to DataFrames.jl.

function _pretty_tables_general_formatter(v, i::Integer, j::Integer)
    if typeof(v) <: Union{AbstractDataFrame, GroupedDataFrame, DataFrameRow,
                          DataFrameRows, DataFrameColumns}

        # Here, we must not use `print` or `show`. Otherwise, we will call
        # `_pretty_table` to render the current table leading to a stack
        # overflow.
        return sprint(summary, v)
    elseif ismissing(v)
        return "missing"
    elseif v === nothing
        return ""
    else
        return v
    end
end

# Default DataFrames highlighter for text backend.
#
# This highlighter changes the text color to gray in cells with `nothing`,
# `missing`, `#undef`, and types related to DataFrames.jl.
function _pretty_tables_highlighter_func(data, i::Integer, j::Integer)
    try
        cell = data[i, j]
        return ismissing(cell) ||
            cell === nothing ||
            cell isa Union{AbstractDataFrame, GroupedDataFrame,
                           DataFrameRow, DataFrameRows,
                           DataFrameColumns}
    catch e
        if isa(e, UndefRefError)
            return true
        else
            rethrow(e)
        end
    end
end

# Constants for the HTML backend.
const _PRETTY_TABLES_HTML_FORMATTER = [_pretty_tables_general_formatter]

const _PRETTY_TABLES_HTML_HIGHLIGHTER = [HtmlHighlighter(_pretty_tables_highlighter_func,
                                                         ["font-style" => "italic"])]

const _PRETTY_TABLES_HTML_TABLE_STYLE = HtmlTableStyle(first_line_column_label = Pair{String, String}[],
                                                       table = ["margin-bottom" => "6px"])

# Constants for the text backend.
const _PRETTY_TABLES_TEXT_FORMATTER = [_pretty_tables_general_formatter]

const _PRETTY_TABLES_TEXT_HIGHLIGHTER = [TextHighlighter(_pretty_tables_highlighter_func,
                                                         Crayon(foreground = :dark_gray))]

const _PRETTY_TABLES_TEXT_TABLE_FORMAT = TextTableFormat(; @text__no_horizontal_lines,
                                                         @text__no_vertical_lines,
                                                         ellipsis_line_skip = 3,
                                                         horizontal_line_after_column_labels = true,
                                                         horizontal_line_before_summary_rows = true,
                                                         vertical_line_after_row_label_column = true,
                                                         vertical_line_after_row_number_column = true)

const _PRETTY_TABLES_TEXT_TABLE_STYLE = TextTableStyle(row_label = Crayon())

module TestTables

using Test, DataFrames, CategoricalArrays

struct NamedTupleIterator{T <: NamedTuple}
    elements::Vector{T}
end
Base.length(n::NamedTupleIterator) = length(n.elements)
Base.IteratorEltype(::Type{<:NamedTupleIterator}) = Base.HasEltype()
Base.eltype(n::NamedTupleIterator{T}) where {T} = T

function Base.iterate(nt::NamedTupleIterator, st=1)
    st > length(nt.elements) && return nothing
    return nt.elements[st], st + 1
end

struct EltypeUnknownIterator
    elements
end
Base.IteratorSize(::Type{EltypeUnknownIterator}) = Base.SizeUnknown()
Base.IteratorEltype(::Type{EltypeUnknownIterator}) = Base.EltypeUnknown()

function Base.iterate(nt::EltypeUnknownIterator, st=1)
    st > length(nt.elements) && return nothing
    return nt.elements[st], st + 1
end

struct DuplicateNamesTable
end
Tables.istable(::Type{DuplicateNamesTable}) = true
Tables.rowaccess(::Type{DuplicateNamesTable}) = true
Tables.rows(x::DuplicateNamesTable) = x
Tables.schema(x::DuplicateNamesTable) = Tables.Schema((:a, :a, :b), Tuple{Float64, Float64, Float64})

Base.length(x::DuplicateNamesTable) = 3
Base.eltype(x::DuplicateNamesTable) = DuplicateRow

function Base.iterate(d::DuplicateNamesTable, st=1)
    st > length(d) && return nothing
    return DuplicateNameRow(), st + 1
end

struct DuplicateNameRow
end
Base.getproperty(d::DuplicateNameRow, nm::Symbol) = 1.0

struct DuplicateNamesColumnTable
end
Tables.istable(::Type{DuplicateNamesColumnTable}) = true
Tables.columnaccess(::Type{DuplicateNamesColumnTable}) = true
Tables.columns(x::DuplicateNamesColumnTable) = x
Tables.schema(x::DuplicateNamesColumnTable) = Tables.Schema((:a, :a, :b), Tuple{Float64, Float64, Float64})
Base.getproperty(d::DuplicateNamesColumnTable, nm::Symbol) = [1.0, 2.0, 3.0]
Base.propertynames(d::DuplicateNamesColumnTable) = (:a, :a, :b)

struct EmptyTableWithNames <: AbstractVector{Any}
end
Tables.isrowtable(::Type{EmptyTableWithNames}) = true
Tables.rows(x::EmptyTableWithNames) = x
Tables.schema(x::EmptyTableWithNames) = Tables.Schema((:a, :b, :c), Tuple{Float64, String, Float64})
Base.size(x::EmptyTableWithNames) = (0,)
Base.eltype(x::EmptyTableWithNames) = NamedTuple
Base.iterate(x::EmptyTableWithNames, st=1) = nothing

struct CopiedCols
end
Tables.istable(::Type{CopiedCols}) = true
Tables.columnaccess(::Type{CopiedCols}) = true
const COPIEDCOLS = (a=[1,2,3], b=[:a, :b, :c])
Tables.columns(x::CopiedCols) = Tables.CopiedColumns(COPIEDCOLS)

@testset "Tables" begin
    df = DataFrame(a=Int64[1, 2, 3], b=[:a, :b, :c])

    @testset "basics $(nameof(typeof(table)))" for table in [
        df,
        view(df, :, :),
        eachrow(df),
        eachcol(df),
    ]
        @test Tables.istable(table)
        @test Tables.rowaccess(table)
        @test Tables.columnaccess(table)
        @test Tables.schema(table) === Tables.Schema((:a, :b), Tuple{Int64, Symbol})
        @test Tables.schema(table) == Tables.schema(Tables.rows(table)) == Tables.schema(Tables.columns(table))
        @test @inferred(Tables.materializer(table)(Tables.columns(table))) isa DataFrame

        row = first(Tables.rows(table))
        @test collect(propertynames(row)) == [:a, :b]
        @test getproperty(row, :a) == 1
        @test getproperty(row, :b) == :a
        @test Tables.getcolumn(row, :a) == 1
        @test Tables.getcolumn(row, 1) == 1
        @test collect(Tables.columnnames(row)) == [:a, :b]
        @test Tables.getcolumn(row, Int64, 1, :a) == 1
    end

    @testset "Row-style" begin
        bare_rows = Tables.rowtable(df)
        bare_rows_iterator = Tables.namedtupleiterator(df)
        for (actual, actual2, expected) in zip(bare_rows, bare_rows_iterator, eachrow(df))
            @test actual isa NamedTuple
            @test actual.a === actual2.a
            @test actual.b === actual2.b
            @test actual.a == expected.a
            @test actual.b == expected.b
        end

        and_back = DataFrame(bare_rows)
        @test and_back isa DataFrame
        @test names(and_back) == ["a", "b"]
        @test and_back.a == df.a
        @test and_back.b == df.b
    end

    @testset "Column-style" begin
        cols = Tables.columntable(df)
        @test cols.b  ==  df.b
        @test cols.a  ==  df.a

        and_back = DataFrame(cols)
        @test and_back isa DataFrame
        @test names(and_back) == ["a", "b"]
        @test and_back.a == df.a == Tables.getcolumn(df, :a) == Tables.getcolumn(df, 1)
        @test and_back.b == df.b
    end

    @testset "Extras" begin
        # with missing values
        df = DataFrame(a=[1, missing, 3], b=[missing, 'a', "hey"])
        @test isequal(df, DataFrame(Tables.rowtable(df)))
        @test isequal(df, DataFrame(Tables.columntable(df)))

        dn = DuplicateNamesTable()
        @test_throws ErrorException (dn |> DataFrame)

        dn = DuplicateNamesColumnTable()
        @test_throws ArgumentError (dn |> DataFrame)

        # non-Tables.jl constructor fallbacks
        @test DataFrame([(a=0,), (a=1,)]) == DataFrame(a=0:1)

        nt = (a=1, b=:a, c=missing)
        nti = NamedTupleIterator([nt, nt, nt])
        df = DataFrame(nti)
        @test size(df) == (3, 3)
        @test df.a == [1, 1, 1]
        @test df.b == [:a, :a, :a]
        @test isequal(df.c, [missing, missing, missing])

        etu = EltypeUnknownIterator([nt, nt, nt])
        df = DataFrame(etu)
        @test size(df) == (3, 3)
        @test df.a == [1, 1, 1]
        @test df.b == [:a, :a, :a]
        @test isequal(df.c, [missing, missing, missing])

        append!(df, etu)
        @test size(df) == (6, 3)

        append!(df, [nt])
        @test size(df) == (7, 3)

        # categorical values
        cat = CategoricalVector(["hey", "there", "sailor"])
        cat2 = [c for c in cat] # Vector of CategoricalValue
        nt = (a=cat, b=cat2)
        df = DataFrame(nt, copycols=false)
        @test df.a === cat
        @test df.b === cat2
        # test in the unknown schema case that a
        # Vector of CategoricalValue is built into CategoricalVector
        ct = Tables.buildcolumns(nothing, Tables.rows(nt))
        @test ct.a !== cat
        @test ct.b !== cat2
        @test ct.a == cat
        @test ct.b == cat == cat2

        # https://github.com/JuliaData/CSV.jl/issues/702
        df = DataFrame(EmptyTableWithNames())
        @test size(df) == (0, 3)
        @test names(df) == ["a", "b", "c"]
        @test eltype.(eachcol(df)) == [Float64, String, Float64]
    end
end

@testset "DataFrame without copying cols" begin
    nt = (a=Int64[1, 2, 3], b=[:a, :b, :c])
    df1 = DataFrame(nt, copycols=false)
    df2 = DataFrame(df1, copycols=false)
    df3 = DataFrame(nt)
    @test Tables.columntable(df1) === nt
    @test Tables.columntable(df2) === nt
    @test Tables.columntable(df3) == nt
    @test Tables.columntable(df3) !== nt

    df4 = DataFrame(Tables.CopiedColumns(nt))
    @test df4.a === nt.a
    df4 = DataFrame(Tables.CopiedColumns(nt), copycols=true)
    @test df4.a !== nt.a

    v = [(a=1, b=2), (a=3, b=4)]
    df = DataFrame(v)
    @test size(df) == (2, 2)
    @test df.a == [1, 3]
    @test df.b == [2, 4]
    @test DataFrame(v, copycols=false) == DataFrame(v, copycols=true) == df

    df = DataFrame(CopiedCols())
    @test df.a === COPIEDCOLS.a
    df = DataFrame(CopiedCols(); copycols=true)
    @test df.a !== COPIEDCOLS.a
    @test df.a == COPIEDCOLS.a
end

@testset "columnindex" begin
    df = DataFrame(rand(3, 4), :auto)

    for x in (df, view(df, 1, :), view(df, 1:1, :))
        @test columnindex.(Ref(x), names(df)) == 1:4
        @test columnindex.(Ref(x), propertynames(df)) == 1:4
        @test columnindex(x, :a) == 0
        @test columnindex(x, "a") == 0
        @test_throws MethodError columnindex(x, 1)
    end

    for x in (view(df, 1, 4:3), view(df, 1:1, 4:3))
        @test all(==(0), columnindex.(Ref(x), [names(df); "a"]))
        @test all(==(0), columnindex.(Ref(x), [propertynames(df); :a]))
    end
    for x in (view(df, 1, [4, 3]), view(df, 1:1, [4, 3]))
        @test columnindex.(Ref(x), [names(df); "a"]) == [0, 0, 2, 1, 0]
        @test columnindex.(Ref(x), [propertynames(df); :a]) == [0, 0, 2, 1, 0]
    end
end

@testset "eachrow and eachcol integration" begin
    df = DataFrame(rand(3, 4), [:a, :b, :c, :d])

    df2 = DataFrame(eachrow(df))
    @test df == df2
    @test !any(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    df2 = DataFrame(eachrow(df), copycols=false)
    @test df == df2
    @test all(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    df2 = DataFrame(pairs(eachcol(df)))
    @test df == df2
    @test !any(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    df2 = DataFrame(pairs(eachcol(df)), copycols=false)
    @test df == df2
    @test all(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    df2 = DataFrame(eachcol(df))
    @test df == df2
    @test all(((a, b),) -> a == b, zip(eachcol(df), eachcol(df2)))
    @test !any(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    df2 = DataFrame(eachcol(df))
    @test df == df2
    @test !any(((a, b),) -> a === b, zip(eachcol(df), eachcol(df2)))

    @test Tables.rowtable(df) == Tables.rowtable(eachrow(df))
    @test Tables.rowtable(df) == Tables.rowtable(eachcol(df))
    @test Tables.columntable(df) == Tables.columntable(eachrow(df))
    @test Tables.columntable(df) == Tables.columntable(eachcol(df))

    for (a, b, c) in zip(Tables.rowtable(df),
                         Tables.namedtupleiterator(eachrow(df)),
                         Tables.namedtupleiterator(eachcol(df)))
        @test a isa NamedTuple
        @test a === b === c
    end

    @test Tables.getcolumn(eachcol(df), 1) == Tables.getcolumn(df, 1)
    @test Tables.getcolumn(eachcol(df), :a) == Tables.getcolumn(df, :a)
    @test Tables.columnnames(eachcol(df)) == Tables.columnnames(df)
    @test Tables.getcolumn(eachrow(df), 1) == Tables.getcolumn(df, 1)
    @test Tables.getcolumn(eachrow(df), :a) == Tables.getcolumn(df, :a)
    @test Tables.columnnames(eachrow(df)) == Tables.columnnames(df)
end

@testset "test constructor with vectors" begin
    @test DataFrame(Any[]) == DataFrame()
    df = DataFrame(typeof((1, 1))[])
    @test names(df) == ["Column1", "Column2"]
    @test size(df) == (0, 2)
    @test eltype(df.Column1) == Int
    df = DataFrame(typeof((a=1, b=1))[])
    @test names(df) == ["a", "b"]
    @test size(df) == (0, 2)
    @test eltype(df.a) == Int
    @test DataFrame(Vector[], :auto) == DataFrame()
    @test DataFrame(Pair{Symbol, Vector}[], :auto) == DataFrame()
    @test DataFrame(Pair[]) == DataFrame()
    @test DataFrame([[1]], :auto) == DataFrame(x1=1)
    @test DataFrame(Any[[1]], :auto) == DataFrame(x1=1)
    @test DataFrame([:a => [1]]) == DataFrame(a=1)
    @test DataFrame(Any[:a => [1]]) == DataFrame(a=1)
    @test DataFrame(["a" => [1]]) == DataFrame(a=1)
    @test DataFrame(Any["a" => [1]]) == DataFrame(a=1)
    @test DataFrame([SubString("a", 1) => [1]]) == DataFrame(a=1)
    @test DataFrame(Any[SubString("a", 1) => [1]]) == DataFrame(a=1)
end

@testset "materializer" begin
    df = DataFrame(a=1)
    sdf1 = view(df, :, :)
    sdf2 = view(df, 1:1, 1:1)
    ec = eachcol(df)
    er = eachrow(df)

    for x in (df, sdf1, sdf2, ec, er)
        @test DataFrame === @inferred Tables.materializer(x)
        @test DataFrame === @inferred Tables.materializer(typeof(x))
    end

    @test DataFrame === @inferred Tables.materializer(AbstractDataFrame)
    @test DataFrame === @inferred Tables.materializer(SubDataFrame)
    @test DataFrame === @inferred Tables.materializer(DataFrames.DataFrameRows)
    @test DataFrame === @inferred Tables.materializer(DataFrames.DataFrameColumns)
end

@testset "Tables.subset" begin
    dfref = DataFrame(a=1:3, b=4:6)

    df = dfref
    res = @inferred Tables.subset(df, :)
    @test res isa DataFrame
    @test res == DataFrame(a=1:3, b=4:6)
    res = Tables.subset(df, :, viewhint=false)
    @test res isa DataFrame
    @test res == DataFrame(a=1:3, b=4:6)
    res = Tables.subset(df, :, viewhint=true)
    @test res isa SubDataFrame
    @test res == DataFrame(a=1:3, b=4:6)

    res = @inferred Tables.subset(df, [3, 1])
    @test res isa DataFrame
    @test res == DataFrame(a=[3, 1], b=[6, 4])
    res = Tables.subset(df, [3, 1], viewhint=false)
    @test res isa DataFrame
    @test res == DataFrame(a=[3, 1], b=[6, 4])
    res = Tables.subset(df, [3, 1], viewhint=true)
    @test res isa SubDataFrame
    @test res == DataFrame(a=[3, 1], b=[6, 4])

    res = @inferred Tables.subset(df, [true, false, true])
    @test res isa DataFrame
    @test res == DataFrame(a=[1, 3], b=[4, 6])
    res = Tables.subset(df, [1, 3], viewhint=false)
    @test res isa DataFrame
    @test res == DataFrame(a=[1, 3], b=[4, 6])
    res = Tables.subset(df, [1, 3], viewhint=true)
    @test res isa SubDataFrame
    @test res == DataFrame(a=[1, 3], b=[4, 6])

    df = eachcol(dfref)
    res = @inferred Tables.subset(df, :)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=1:3, b=4:6))
    res = Tables.subset(df, :, viewhint=false)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=1:3, b=4:6))
    res = Tables.subset(df, :, viewhint=true)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=1:3, b=4:6))

    res = @inferred Tables.subset(df, [3, 1])
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[3, 1], b=[6, 4]))
    res = Tables.subset(df, [3, 1], viewhint=false)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[3, 1], b=[6, 4]))
    res = Tables.subset(df, [3, 1], viewhint=true)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[3, 1], b=[6, 4]))

    res = @inferred Tables.subset(df, [true, false, true])
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[1, 3], b=[4, 6]))
    res = Tables.subset(df, [1, 3], viewhint=false)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[1, 3], b=[4, 6]))
    res = Tables.subset(df, [1, 3], viewhint=true)
    @test res isa DataFrames.DataFrameColumns
    @test res == eachcol(DataFrame(a=[1, 3], b=[4, 6]))

    df = eachrow(dfref)
    res = @inferred Tables.subset(df, :)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=1:3, b=4:6))
    res = Tables.subset(df, :, viewhint=false)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=1:3, b=4:6))
    res = Tables.subset(df, :, viewhint=true)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=1:3, b=4:6))

    res = @inferred Tables.subset(df, [3, 1])
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[3, 1], b=[6, 4]))
    res = Tables.subset(df, [3, 1], viewhint=false)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[3, 1], b=[6, 4]))
    res = Tables.subset(df, [3, 1], viewhint=true)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[3, 1], b=[6, 4]))

    res = @inferred Tables.subset(df, [true, false, true])
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[1, 3], b=[4, 6]))
    res = Tables.subset(df, [1, 3], viewhint=false)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[1, 3], b=[4, 6]))
    res = Tables.subset(df, [1, 3], viewhint=true)
    @test res isa DataFrames.DataFrameRows
    @test res == eachrow(DataFrame(a=[1, 3], b=[4, 6]))

    for df in (dfref, eachcol(dfref), eachrow(dfref))
        res = @inferred Tables.subset(df, 2)
        @test res isa DataFrameRow
        @test res == DataFrame(a=2, b=5)[1, :]
        res = Tables.subset(df, 2, viewhint=false)
        @test res isa NamedTuple{(:a, :b), Tuple{Int, Int}}
        @test res == (a=2, b=5)
        res = Tables.subset(df, 2, viewhint=true)
        @test res isa DataFrameRow
        @test res == DataFrame(a=2, b=5)[1, :]
    end
end

end # module

module TestJoin

using Test, DataFrames, Random, CategoricalArrays, PooledArrays
using DataFrames: similar_missing, OnCol
const ≅ = isequal

"""Check if passed data frames are `isequal` and have the same types of columns"""
isequal_coltyped(df1::AbstractDataFrame, df2::AbstractDataFrame) =
    isequal(df1, df2) && typeof.(eachcol(df1)) == typeof.(eachcol(df2))

name = DataFrame(ID=Union{Int, Missing}[1, 2, 3],
                Name=Union{String, Missing}["John Doe", "Jane Doe", "Joe Blogs"])
job = DataFrame(ID=Union{Int, Missing}[1, 2, 2, 4],
                Job=Union{String, Missing}["Lawyer", "Doctor", "Florist", "Farmer"])

# Test output of various join types
outer = DataFrame(ID=[1, 2, 2, 3, 4],
                  Name=["John Doe", "Jane Doe", "Jane Doe", "Joe Blogs", missing],
                  Job=["Lawyer", "Doctor", "Florist", missing, "Farmer"])

# (Tests use current column ordering but don't promote it)
right = outer[Bool[!ismissing(x) for x in outer.Job], [:ID, :Name, :Job]]
left = outer[Bool[!ismissing(x) for x in outer.Name], :]
inner = left[Bool[!ismissing(x) for x in left.Job], :]
semi = unique(inner[:, [:ID, :Name]])
anti = left[Bool[ismissing(x) for x in left.Job], [:ID, :Name]]

@testset "join types" begin
    # Join on symbols or vectors of symbols
    @test innerjoin(name, job, on=:ID) == inner
    @test innerjoin(name, job, on=[:ID]) == inner
    @test_throws ArgumentError innerjoin(name, job, on=:ID1)
    @test_throws ArgumentError innerjoin(name, job, on=:Name)
    @test_throws ArgumentError innerjoin(name, job, on=:Job)

    @test_throws ArgumentError innerjoin(name, job)
    @test_throws ArgumentError innerjoin(name, job, on=:ID, matchmissing=:errors)
    @test_throws ArgumentError innerjoin(name, job, on=:ID, matchmissing=:weirdmatch)
    @test_throws ArgumentError outerjoin(name, job, on=:ID, matchmissing=:notequal)

    @test innerjoin(name, job, on=:ID) == inner
    @test outerjoin(name, job, on=:ID) ≅ outer
    @test leftjoin(name, job, on=:ID) ≅ left
    @test rightjoin(name, job, on=:ID) ≅ right
    @test semijoin(name, job, on=:ID) == semi
    @test antijoin(name, job, on=:ID) == anti

    # Join with no non-key columns
    on = [:ID]
    nameid = name[:, on]
    jobid = job[:, on]

    @test innerjoin(nameid, jobid, on=:ID) == inner[:, on]
    @test outerjoin(nameid, jobid, on=:ID) == outer[:, on]
    @test leftjoin(nameid, jobid, on=:ID) == left[:, on]
    @test rightjoin(nameid, jobid, on=:ID) == right[:, on]
    @test semijoin(nameid, jobid, on=:ID) == semi[:, on]
    @test antijoin(nameid, jobid, on=:ID) == anti[:, on]

    # Join on multiple keys
    df1 = DataFrame(A=1, B=2, C=3)
    df2 = DataFrame(A=1, B=2, D=4)

    @test innerjoin(df1, df2, on=[:A, :B]) == DataFrame(A=1, B=2, C=3, D=4)

    # Test output of cross joins
    df1 = DataFrame(A=1:2, B='a':'b')
    df2 = DataFrame(C=3:5)

    cross = DataFrame(A=[1, 1, 1, 2, 2, 2],
                      B=['a', 'a', 'a', 'b', 'b', 'b'],
                      C=[3, 4, 5, 3, 4, 5])

    @test crossjoin(df1, df2) == cross
    @test crossjoin(df1, df2, renamecols="_left" => "_right") ==
          crossjoin(df1, df2, renamecols=:_left => :_right) ==
          crossjoin(df1, df2, renamecols="_left" => :_right) ==
          crossjoin(df1, df2, renamecols=:_left => "_right") ==
          rename(cross, [:A_left, :B_left, :C_right])
    @test crossjoin(df1, df2, renamecols=(x -> x * "_left") => x -> x * "_right") ==
          rename(cross, [:A_left, :B_left, :C_right])
    @test crossjoin(df1, df2, renamecols=(x -> Symbol(x * "_left")) => x -> Symbol(x * "_right")) ==
          rename(cross, [:A_left, :B_left, :C_right])
    @test_throws ArgumentError crossjoin(df1, df2, renamecols=(x -> "a") => x -> "a")
    @test crossjoin(df1, df2, renamecols=(x -> "a") => x -> "a", makeunique=true) ==
          rename(cross, [:a, :a_1, :a_2])

    # Cross joins handle naming collisions
    @test size(crossjoin(df1, df1, makeunique=true)) == (4, 4)

    # Cross joins don't take keys
    @test_throws MethodError crossjoin(df1, df2, on=:A)
end

@testset "Test empty inputs 1" begin
    simple_df(len::Int, col=:A) = (df = DataFrame();
                                   df[!, col]=Vector{Union{Int, Missing}}(1:len);
                                   df)
    @test leftjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test leftjoin(simple_df(2), simple_df(0), on=:A) == simple_df(2)
    @test leftjoin(simple_df(0), simple_df(2), on=:A) == simple_df(0)
    @test rightjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test rightjoin(simple_df(0), simple_df(2), on=:A) == simple_df(2)
    @test rightjoin(simple_df(2), simple_df(0), on=:A) == simple_df(0)
    @test innerjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test innerjoin(simple_df(0), simple_df(2), on=:A) == simple_df(0)
    @test innerjoin(simple_df(2), simple_df(0), on=:A) == simple_df(0)
    @test outerjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test outerjoin(simple_df(0), simple_df(2), on=:A) == simple_df(2)
    @test outerjoin(simple_df(2), simple_df(0), on=:A) == simple_df(2)
    @test semijoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test semijoin(simple_df(2), simple_df(0), on=:A) == simple_df(0)
    @test semijoin(simple_df(0), simple_df(2), on=:A) == simple_df(0)
    @test antijoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test antijoin(simple_df(2), simple_df(0), on=:A) == simple_df(2)
    @test antijoin(simple_df(0), simple_df(2), on=:A) == simple_df(0)
    @test crossjoin(simple_df(0), simple_df(0, :B)) == DataFrame(A=Int[], B=Int[])
    @test crossjoin(simple_df(0), simple_df(2, :B)) == DataFrame(A=Int[], B=Int[])
    @test crossjoin(simple_df(2), simple_df(0, :B)) == DataFrame(A=Int[], B=Int[])
end

@testset "Test empty inputs 2" begin
    simple_df(len::Int, col=:A) = (df = DataFrame(); df[!, col]=collect(1:len); df)
    @test leftjoin(simple_df(0), simple_df(0), on=:A) ==  simple_df(0)
    @test leftjoin(simple_df(2), simple_df(0), on=:A) ==  simple_df(2)
    @test leftjoin(simple_df(0), simple_df(2), on=:A) ==  simple_df(0)
    @test rightjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test rightjoin(simple_df(0), simple_df(2), on=:A) == simple_df(2)
    @test rightjoin(simple_df(2), simple_df(0), on=:A) == simple_df(0)
    @test innerjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test innerjoin(simple_df(0), simple_df(2), on=:A) == simple_df(0)
    @test innerjoin(simple_df(2), simple_df(0), on=:A) == simple_df(0)
    @test outerjoin(simple_df(0), simple_df(0), on=:A) == simple_df(0)
    @test outerjoin(simple_df(0), simple_df(2), on=:A) == simple_df(2)
    @test outerjoin(simple_df(2), simple_df(0), on=:A) == simple_df(2)
    @test semijoin(simple_df(0), simple_df(0), on=:A) ==  simple_df(0)
    @test semijoin(simple_df(2), simple_df(0), on=:A) ==  simple_df(0)
    @test semijoin(simple_df(0), simple_df(2), on=:A) ==  simple_df(0)
    @test antijoin(simple_df(0), simple_df(0), on=:A) ==  simple_df(0)
    @test antijoin(simple_df(2), simple_df(0), on=:A) ==  simple_df(2)
    @test antijoin(simple_df(0), simple_df(2), on=:A) ==  simple_df(0)
    @test crossjoin(simple_df(0), simple_df(0, :B)) == DataFrame(A=Int[], B=Int[])
    @test crossjoin(simple_df(0), simple_df(2, :B)) == DataFrame(A=Int[], B=Int[])
    @test crossjoin(simple_df(2), simple_df(0, :B)) == DataFrame(A=Int[], B=Int[])
end

@testset "issue #960" begin
    df1 = DataFrame(A=categorical(1:50),
                    B=categorical(1:50),
                    C=1)
    @test innerjoin(df1, df1, on=[:A, :B], makeunique=true)[!, 1:3] == df1
    # Test that join works when mixing Array{Union{T, Missing}} with Array{T} (issue #1088)
    df = DataFrame(Name=Union{String, Missing}["A", "B", "C"],
                   Mass=[1.5, 2.2, 1.1])
    df2 = DataFrame(Name=["A", "B", "C", "A"],
                    Quantity=[3, 3, 2, 4])
    @test leftjoin(df2, df, on=:Name) == DataFrame(Name=["A", "B", "C", "A"],
                                                   Quantity=[3, 3, 2, 4],
                                                   Mass=[1.5, 2.2, 1.1, 1.5])

    # Test that join works when mixing Array{Union{T, Missing}} with Array{T} (issue #1151)
    df = DataFrame([collect(1:10), collect(2:11)], [:x, :y])
    dfmissing = DataFrame(x=Vector{Union{Int, Missing}}(1:10),
                          z=Vector{Union{Int, Missing}}(3:12))
    @test innerjoin(df, dfmissing, on=:x) ==
        DataFrame([collect(1:10), collect(2:11), collect(3:12)], [:x, :y, :z])
    @test innerjoin(dfmissing, df, on=:x) ==
        DataFrame([Vector{Union{Int, Missing}}(1:10), Vector{Union{Int, Missing}}(3:12),
                collect(2:11)], [:x, :z, :y])
end

@testset "all joins" begin
    df1 = DataFrame(Any[[1, 3, 5], [1.0, 3.0, 5.0]], [:id, :fid])
    df2 = DataFrame(Any[[0, 1, 2, 3, 4], [0.0, 1.0, 2.0, 3.0, 4.0]], [:id, :fid])

    @test crossjoin(df1, df2, makeunique=true) ==
        DataFrame(Any[repeat([1, 3, 5], inner=5),
                      repeat([1, 3, 5], inner=5),
                      repeat([0, 1, 2, 3, 4], outer=3),
                      repeat([0, 1, 2, 3, 4], outer=3)],
                  [:id, :fid, :id_1, :fid_1])
    @test typeof.(eachcol(crossjoin(df1, df2, makeunique=true))) ==
        [Vector{Int}, Vector{Float64}, Vector{Int}, Vector{Float64}]

    i(on) = innerjoin(df1, df2, on=on, makeunique=true)
    l(on) = leftjoin(df1, df2, on=on, makeunique=true)
    r(on) = rightjoin(df1, df2, on=on, makeunique=true)
    o(on) = outerjoin(df1, df2, on=on, makeunique=true)
    s(on) = semijoin(df1, df2, on=on, makeunique=true)
    a(on) = antijoin(df1, df2, on=on, makeunique=true)

    @test s(:id) ==
          s(:fid) ==
          s([:id, :fid]) == DataFrame([[1, 3], [1, 3]], [:id, :fid])
    @test typeof.(eachcol(s(:id))) ==
          typeof.(eachcol(s(:fid))) ==
          typeof.(eachcol(s([:id, :fid]))) == [Vector{Int}, Vector{Float64}]
    @test a(:id) ==
          a(:fid) ==
          a([:id, :fid]) == DataFrame([[5], [5]], [:id, :fid])
    @test typeof.(eachcol(a(:id))) ==
          typeof.(eachcol(a(:fid))) ==
          typeof.(eachcol(a([:id, :fid]))) == [Vector{Int}, Vector{Float64}]

    on = :id
    @test i(on) == DataFrame([[1, 3], [1, 3], [1, 3]], [:id, :fid, :fid_1])
    @test typeof.(eachcol(i(on))) == [Vector{Int}, Vector{Float64}, Vector{Float64}]
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            fid_1=[1, 3, missing])
    @test typeof.(eachcol(l(on))) ==
        [Vector{Int}, Vector{Float64}, Vector{Union{Float64, Missing}}]
    @test r(on) ≅ DataFrame(id=[1, 3, 0, 2, 4],
                            fid=[1, 3, missing, missing, missing],
                            fid_1=[1, 3, 0, 2, 4])
    @test typeof.(eachcol(r(on))) ==
        [Vector{Int}, Vector{Union{Float64, Missing}}, Vector{Float64}]
    @test o(on) ≅ DataFrame(id=[1, 3, 5, 0, 2, 4],
                            fid=[1, 3, 5, missing, missing, missing],
                            fid_1=[1, 3, missing, 0, 2, 4])
    @test typeof.(eachcol(o(on))) ==
        [Vector{Int}, Vector{Union{Float64, Missing}}, Vector{Union{Float64, Missing}}]

    on = :fid
    @test i(on) == DataFrame([[1, 3], [1.0, 3.0], [1, 3]], [:id, :fid, :id_1])
    @test typeof.(eachcol(i(on))) == [Vector{Int}, Vector{Float64}, Vector{Int}]
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            id_1=[1, 3, missing])
    @test typeof.(eachcol(l(on))) == [Vector{Int}, Vector{Float64},
                                     Vector{Union{Int, Missing}}]
    @test r(on) ≅ DataFrame(id=[1, 3, missing, missing, missing],
                            fid=[1, 3, 0, 2, 4],
                            id_1=[1, 3, 0, 2, 4])
    @test typeof.(eachcol(r(on))) == [Vector{Union{Int, Missing}}, Vector{Float64},
                                     Vector{Int}]
    @test o(on) ≅ DataFrame(id=[1, 3, 5, missing, missing, missing],
                            fid=[1, 3, 5, 0, 2, 4],
                            id_1=[1, 3, missing, 0, 2, 4])
    @test typeof.(eachcol(o(on))) == [Vector{Union{Int, Missing}}, Vector{Float64},
                                     Vector{Union{Int, Missing}}]

    on = [:id, :fid]
    @test i(on) == DataFrame([[1, 3], [1, 3]], [:id, :fid])
    @test typeof.(eachcol(i(on))) == [Vector{Int}, Vector{Float64}]
    @test l(on) == DataFrame(id=[1, 3, 5], fid=[1, 3, 5])
    @test typeof.(eachcol(l(on))) == [Vector{Int}, Vector{Float64}]
    @test r(on) == DataFrame(id=[1, 3, 0, 2, 4], fid=[1, 3, 0, 2, 4])
    @test typeof.(eachcol(r(on))) == [Vector{Int}, Vector{Float64}]
    @test o(on) == DataFrame(id=[1, 3, 5, 0, 2, 4], fid=[1, 3, 5, 0, 2, 4])
    @test typeof.(eachcol(o(on))) == [Vector{Int}, Vector{Float64}]
end

@testset "all joins with CategoricalArrays" begin
    df1 = DataFrame(Any[CategoricalArray([1, 3, 5]),
                        CategoricalArray([1.0, 3.0, 5.0])], [:id, :fid])
    df2 = DataFrame(Any[CategoricalArray([0, 1, 2, 3, 4]),
                        CategoricalArray([0.0, 1.0, 2.0, 3.0, 4.0])], [:id, :fid])

    @test crossjoin(df1, df2, makeunique=true) ==
        DataFrame([repeat([1, 3, 5], inner=5),
                   repeat([1, 3, 5], inner=5),
                   repeat([0, 1, 2, 3, 4], outer=3),
                   repeat([0, 1, 2, 3, 4], outer=3)],
                  [:id, :fid, :id_1, :fid_1])
    @test all(isa.(eachcol(crossjoin(df1, df2, makeunique=true)),
                   [CategoricalVector{T} for T in (Int, Float64, Int, Float64)]))

    i(on) = innerjoin(df1, df2, on=on, makeunique=true)
    l(on) = leftjoin(df1, df2, on=on, makeunique=true)
    r(on) = rightjoin(df1, df2, on=on, makeunique=true)
    o(on) = outerjoin(df1, df2, on=on, makeunique=true)
    s(on) = semijoin(df1, df2, on=on, makeunique=true)
    a(on) = antijoin(df1, df2, on=on, makeunique=true)

    @test s(:id) ==
          s(:fid) ==
          s([:id, :fid]) == DataFrame([[1, 3], [1, 3]], [:id, :fid])
    @test typeof.(eachcol(s(:id))) ==
          typeof.(eachcol(s(:fid))) ==
          typeof.(eachcol(s([:id, :fid])))
    @test all(isa.(eachcol(s(:id)),
                   [CategoricalVector{T} for T in (Int, Float64)]))

    @test a(:id) ==
          a(:fid) ==
          a([:id, :fid]) == DataFrame([[5], [5]], [:id, :fid])
    @test typeof.(eachcol(a(:id))) ==
          typeof.(eachcol(a(:fid))) ==
          typeof.(eachcol(a([:id, :fid])))
    @test all(isa.(eachcol(a(:id)),
                   [CategoricalVector{T} for T in (Int, Float64)]))

    on = :id
    @test i(on) == DataFrame([[1, 3], [1, 3], [1, 3]], [:id, :fid, :fid_1])
    @test all(isa.(eachcol(i(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Float64)]))
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            fid_1=[1, 3, missing])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Union{Float64, Missing})]))
    @test r(on) ≅ DataFrame(id=[1, 3, 0, 2, 4],
                            fid=[1, 3, missing, missing, missing],
                            fid_1=[1, 3, 0, 2, 4])
    @test all(isa.(eachcol(r(on)),
                   [CategoricalVector{T} for T in (Int, Union{Float64, Missing}, Float64)]))
    @test o(on) ≅ DataFrame(id=[1, 3, 5, 0, 2, 4],
                            fid=[1, 3, 5, missing, missing, missing],
                            fid_1=[1, 3, missing, 0, 2, 4])
    @test all(isa.(eachcol(o(on)),
                   [CategoricalVector{T} for T in (Int, Union{Float64, Missing}, Union{Float64, Missing})]))

    on = :fid
    @test i(on) == DataFrame([[1, 3], [1.0, 3.0], [1, 3]], [:id, :fid, :id_1])
    @test all(isa.(eachcol(i(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Int)]))
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            id_1=[1, 3, missing])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Union{Int, Missing})]))
    @test r(on) ≅ DataFrame(id=[1, 3, missing, missing, missing],
                            fid=[1, 3, 0, 2, 4],
                            id_1=[1, 3, 0, 2, 4])
    @test all(isa.(eachcol(r(on)),
                   [CategoricalVector{T} for T in (Union{Int, Missing}, Float64, Int)]))
    @test o(on) ≅ DataFrame(id=[1, 3, 5, missing, missing, missing],
                            fid=[1, 3, 5, 0, 2, 4],
                            id_1=[1, 3, missing, 0, 2, 4])
    @test all(isa.(eachcol(o(on)),
                   [CategoricalVector{T} for T in (Union{Int, Missing}, Float64, Union{Int, Missing})]))

    on = [:id, :fid]
    @test i(on) == DataFrame([[1, 3], [1, 3]], [:id, :fid])
    @test all(isa.(eachcol(i(on)),
                   [CategoricalVector{T} for T in (Int, Float64)]))
    @test l(on) == DataFrame(id=[1, 3, 5],
                             fid=[1, 3, 5])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64)]))
    @test r(on) == DataFrame(id=[1, 3, 0, 2, 4],
                             fid=[1, 3, 0, 2, 4])
    @test all(isa.(eachcol(r(on)),
                   [CategoricalVector{T} for T in (Int, Float64)]))
    @test o(on) == DataFrame(id=[1, 3, 5, 0, 2, 4],
                             fid=[1, 3, 5, 0, 2, 4])
    @test all(isa.(eachcol(o(on)),
                   [CategoricalVector{T} for T in (Int, Float64)]))
end

@testset "maintain CategoricalArray levels ordering on join - non-`on` cols" begin
    A = DataFrame(a=[1, 2, 3], b=["a", "b", "c"])
    B = DataFrame(b=["a", "b", "c"], c=CategoricalVector(["a", "b", "b"]))
    levels!(B.c, ["b", "a"])
    @test levels(innerjoin(A, B, on=:b).c) == ["b", "a"]
    @test levels(innerjoin(B, A, on=:b).c) == ["b", "a"]
    @test levels(leftjoin(A, B, on=:b).c) == ["b", "a"]
    @test levels(rightjoin(A, B, on=:b).c) == ["b", "a"]
    @test levels(outerjoin(A, B, on=:b).c) == ["b", "a"]
    @test levels(semijoin(B, A, on=:b).c) == ["b", "a"]
end

@testset "maintain CategoricalArray levels ordering on join - ordering conflicts" begin
    A = DataFrame(a=[1, 2, 3, 4], b=CategoricalVector(["a", "b", "c", "d"]))
    levels!(A.b, ["d", "c", "b", "a"])
    B = DataFrame(b=CategoricalVector(["a", "b", "c"]), c=[5, 6, 7])
    @test levels(innerjoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(innerjoin(B, A, on=:b).b) == ["a", "b", "c"]
    @test levels(leftjoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(leftjoin(B, A, on=:b).b) == ["a", "b", "c"]
    @test levels(rightjoin(A, B, on=:b).b) == ["a", "b", "c"]
    @test levels(rightjoin(B, A, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(outerjoin(B, A, on=:b).b) == ["d", "a", "b", "c"]
    @test levels(outerjoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(semijoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(semijoin(B, A, on=:b).b) == ["a", "b", "c"]
end

@testset "maintain CategoricalArray levels ordering on join - left is categorical" begin
    A = DataFrame(a=[1, 2, 3, 4], b=CategoricalVector(["a", "b", "c", "d"]))
    levels!(A.b, ["d", "c", "b", "a"])
    B = DataFrame(b=["a", "b", "c"], c=[5, 6, 7])
    @test levels(innerjoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(innerjoin(B, A, on=:b).b) == ["a", "b", "c"]
    @test levels(leftjoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(leftjoin(B, A, on=:b).b) == ["a", "b", "c"]
    @test levels(rightjoin(A, B, on=:b).b) == ["a", "b", "c"]
    @test levels(rightjoin(B, A, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(outerjoin(A, B, on=:b).b) == ["a", "b", "c", "d"]
    @test levels(outerjoin(B, A, on=:b).b) == ["a", "b", "c", "d"]
    @test levels(semijoin(A, B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(semijoin(B, A, on=:b).b) == ["a", "b", "c"]
end

@testset "join on columns with different left/right names" begin
    left = DataFrame(id=1:7, sid=string.(1:7))
    right = DataFrame(ID=3:10, SID=string.(3:10))

    @test innerjoin(left, right, on=:id => :ID) ==
        DataFrame(id=3:7, sid=string.(3:7), SID=string.(3:7))
    @test innerjoin(left, right, on=[:id => :ID]) ==
        DataFrame(id=3:7, sid=string.(3:7), SID=string.(3:7))
    @test innerjoin(left, right, on=[:id => :ID, :sid => :SID]) ==
        DataFrame(id=3:7, sid=string.(3:7))

    @test leftjoin(left, right, on=:id => :ID) ≅
        DataFrame(id=[3:7; 1:2], sid=string.([3:7; 1:2]),
                  SID=[string.(3:7)..., missing, missing])
    @test leftjoin(left, right, on=[:id => :ID]) ≅
        DataFrame(id=[3:7; 1:2], sid=string.([3:7; 1:2]),
                  SID=[string.(3:7)..., missing, missing])
    @test leftjoin(left, right, on=[:id => :ID, :sid => :SID]) ==
        DataFrame(id=[3:7; 1:2], sid=string.([3:7; 1:2]))

    @test rightjoin(left, right, on=:id => :ID) ≅
        DataFrame(id=3:10, sid=[string.(3:7)..., missing, missing, missing],
                 SID=string.(3:10))
    @test rightjoin(left, right, on=[:id => :ID]) ≅
        DataFrame(id=3:10, sid=[string.(3:7)..., missing, missing, missing],
                 SID=string.(3:10))
    @test rightjoin(left, right, on=[:id => :ID, :sid => :SID]) ≅
        DataFrame(id=3:10, sid=string.(3:10))

    @test outerjoin(left, right, on=:id => :ID) ≅
        DataFrame(id=[3:7; 1:2; 8:10], sid=[string.([3:7; 1:2])..., missing, missing, missing],
                  SID=[string.(3:7)..., missing, missing, string.(8:10)...])
    @test outerjoin(left, right, on=[:id => :ID]) ≅
        DataFrame(id=[3:7; 1:2; 8:10], sid=[string.([3:7; 1:2])..., missing, missing, missing],
                  SID=[string.(3:7)..., missing, missing, string.(8:10)...])
    @test outerjoin(left, right, on=[:id => :ID, :sid => :SID]) ≅
        DataFrame(id=[3:7; 1:2; 8:10], sid=string.([3:7; 1:2; 8:10]))

    @test semijoin(left, right, on=:id => :ID) ==
        DataFrame(id=3:7, sid=string.(3:7))
    @test semijoin(left, right, on=[:id => :ID]) ==
        DataFrame(id=3:7, sid=string.(3:7))
    @test semijoin(left, right, on=[:id => :ID, :sid => :SID]) ==
        DataFrame(id=3:7, sid=string.(3:7))

    @test antijoin(left, right, on=:id => :ID) ==
        DataFrame(id=1:2, sid=string.(1:2))
    @test antijoin(left, right, on=[:id => :ID]) ==
        DataFrame(id=1:2, sid=string.(1:2))
    @test antijoin(left, right, on=[:id => :ID, :sid => :SID]) ==
        DataFrame(id=1:2, sid=string.(1:2))

    @test_throws ArgumentError innerjoin(left, right, on=(:id, :ID))
end

@testset "join with a column of type Any" begin
    l = DataFrame(a=Any[1:7;], b=[1:7;])
    r = DataFrame(a=Any[3:10;], b=[3:10;])

    # join by :a and :b (Any is the on-column)
    @test innerjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=Any[3:7;], b=3:7)
    @test eltype.(eachcol(innerjoin(l, r, on=[:a, :b]))) == [Any, Int]

    @test leftjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=Any[3:7;1:2], b=[3:7; 1:2])
    @test eltype.(eachcol(leftjoin(l, r, on=[:a, :b]))) == [Any, Int]

    @test rightjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=Any[3:10;], b=3:10)
    @test eltype.(eachcol(rightjoin(l, r, on=[:a, :b]))) == [Any, Int]

    @test outerjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=Any[3:7; 1:2; 8:10], b=[3:7; 1:2; 8:10])
    @test eltype.(eachcol(outerjoin(l, r, on=[:a, :b]))) == [Any, Int]

    # join by :b (Any is not on-column)
    @test innerjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=Any[3:7;], b=3:7, a_1=Any[3:7;])
    @test eltype.(eachcol(innerjoin(l, r, on=:b, makeunique=true))) == [Any, Int, Any]

    @test leftjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=Any[3:7; 1:2], b=[3:7; 1:2], a_1=[3:7; missing; missing])
    @test eltype.(eachcol(leftjoin(l, r, on=:b, makeunique=true))) == [Any, Int, Any]

    @test rightjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=[3:7; fill(missing, 3)], b=3:10, a_1=Any[3:10;])
    @test eltype.(eachcol(rightjoin(l, r, on=:b, makeunique=true))) == [Any, Int, Any]

    @test outerjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=[3:7; 1:2; missing; missing; missing], b=[3:7; 1:2; 8:10],
                  a_1=[3:7; missing; missing; 8:10])
    @test eltype.(eachcol(outerjoin(l, r, on=:b, makeunique=true))) == [Any, Int, Any]
end

@testset "joins with categorical columns and no matching rows" begin
    l = DataFrame(a=1:3, b=categorical(["a", "b", "c"]))
    r = DataFrame(a=4:5, b=categorical(["d", "e"]))
    nl = size(l, 1)
    nr = size(r, 1)

    CS = eltype(l.b)

    # joins by a and b
    @test innerjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=Int[], b=similar(l.a, 0))
    @test eltype.(eachcol(innerjoin(l, r, on=[:a, :b]))) == [Int, CS]

    @test leftjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=l.a, b=l.b)
    @test eltype.(eachcol(leftjoin(l, r, on=[:a, :b]))) == [Int, CS]

    @test rightjoin(l, r, on=[:a, :b]) ≅ DataFrame(a=r.a, b=r.b)
    @test eltype.(eachcol(rightjoin(l, r, on=[:a, :b]))) == [Int, CS]

    @test outerjoin(l, r, on=[:a, :b]) ≅
        DataFrame(a=vcat(l.a, r.a), b=vcat(l.b, r.b))
    @test eltype.(eachcol(outerjoin(l, r, on=[:a, :b]))) == [Int, CS]

    # joins by a
    @test innerjoin(l, r, on=:a, makeunique=true) ≅
        DataFrame(a=Int[], b=similar(l.b, 0), b_1=similar(r.b, 0))
    @test eltype.(eachcol(innerjoin(l, r, on=:a, makeunique=true))) == [Int, CS, CS]

    @test leftjoin(l, r, on=:a, makeunique=true) ≅
        DataFrame(a=l.a, b=l.b, b_1=similar_missing(r.b, nl))
    @test eltype.(eachcol(leftjoin(l, r, on=:a, makeunique=true))) ==
        [Int, CS, Union{CS, Missing}]

    @test rightjoin(l, r, on=:a, makeunique=true) ≅
        DataFrame(a=r.a, b=similar_missing(l.b, nr), b_1=r.b)
    @test eltype.(eachcol(rightjoin(l, r, on=:a, makeunique=true))) ==
        [Int, Union{CS, Missing}, CS]

    @test outerjoin(l, r, on=:a, makeunique=true) ≅
        DataFrame(a=vcat(l.a, r.a),
                  b=vcat(l.b, fill(missing, nr)),
                  b_1=vcat(fill(missing, nl), r.b))
    @test eltype.(eachcol(outerjoin(l, r, on=:a, makeunique=true))) ==
        [Int, Union{CS, Missing}, Union{CS, Missing}]

    # joins by b
    @test innerjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=Int[], b=similar(l.b, 0), a_1=similar(r.b, 0))
    @test eltype.(eachcol(innerjoin(l, r, on=:b, makeunique=true))) == [Int, CS, Int]

    @test leftjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=l.a, b=l.b, a_1=fill(missing, nl))
    @test eltype.(eachcol(leftjoin(l, r, on=:b, makeunique=true))) ==
        [Int, CS, Union{Int, Missing}]

    @test rightjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=fill(missing, nr), b=r.b, a_1=r.a)
    @test eltype.(eachcol(rightjoin(l, r, on=:b, makeunique=true))) ==
        [Union{Int, Missing}, CS, Int]

    @test outerjoin(l, r, on=:b, makeunique=true) ≅
        DataFrame(a=vcat(l.a, fill(missing, nr)),
                  b=vcat(l.b, r.b),
                  a_1=vcat(fill(missing, nl), r.a))
    @test eltype.(eachcol(outerjoin(l, r, on=:b, makeunique=true))) ==
        [Union{Int, Missing}, CS, Union{Int, Missing}]
end

@testset "source columns" begin
    outer_indicator = DataFrame(ID=[1, 2, 2, 3, 4],
                                Name=["John Doe", "Jane Doe", "Jane Doe", "Joe Blogs", missing],
                                Job=["Lawyer", "Doctor", "Florist", missing, "Farmer"],
                                _merge=["both", "both", "both", "left_only", "right_only"])

    # Check that input data frame isn't modified (#1434)
    pre_join_name = copy(name)
    pre_join_job = copy(job)
    @test outerjoin(name, job, on=:ID, source=:_merge,
               makeunique=true) ≅
          outerjoin(name, job, on=:ID, source="_merge",
               makeunique=true) ≅ outer_indicator

    @test name ≅ pre_join_name
    @test job ≅ pre_join_job

    # Works with conflicting names
    name2 = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"],
                     _left=[1, 1, 1])
    job2 = DataFrame(ID=[1, 2, 2, 4], Job=["Lawyer", "Doctor", "Florist", "Farmer"],
                    _left=[1, 1, 1, 1])

    outer_indicator = DataFrame(ID=[1, 2, 2, 3, 4],
                                Name=["John Doe", "Jane Doe", "Jane Doe", "Joe Blogs", missing],
                                _left=[1, 1, 1, 1, missing],
                                Job=["Lawyer", "Doctor", "Florist", missing, "Farmer"],
                                _left_1=[1, 1, 1, missing, 1],
                                _left_2=["both", "both", "both", "left_only", "right_only"])

    @test outerjoin(name2, job2, on=:ID, source=:_left,
               makeunique=true) ≅ outer_indicator
end

@testset "test checks of merge key uniqueness" begin
    @test_throws ArgumentError innerjoin(name, job, on=:ID, validate=(false, true))
    @test_throws ArgumentError innerjoin(name, job, on=:ID, validate=(true, true))
    @test_throws ArgumentError innerjoin(job, name, on=:ID, validate=(true, false))
    @test_throws ArgumentError innerjoin(job, name, on=:ID, validate=(true, true))
    @test_throws ArgumentError innerjoin(job, job, on=:ID, validate=(true, true))

    @test innerjoin(name, job, on=:ID, validate=(true, false)) == inner
    @test innerjoin(name, job, on=:ID, validate=(false, false)) == inner

    # Make sure ok with various special values
    for special in [missing, NaN, -0.0]
        name_w_special = DataFrame(ID=[1, 2, 3, special],
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test_throws ArgumentError innerjoin(name_w_special, job, on=:ID)
        @test_throws ArgumentError leftjoin(name_w_special, job, on=:ID)
        @test_throws ArgumentError rightjoin(name_w_special, job, on=:ID)
        @test_throws ArgumentError outerjoin(name_w_special, job, on=:ID)
        @test_throws ArgumentError semijoin(name_w_special, job, on=:ID)
        @test_throws ArgumentError antijoin(name_w_special, job, on=:ID)
    end

    for special in [missing, 0.0]
        name_w_special = DataFrame(ID=[1, 2, 3, special],
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test innerjoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal) ≅ inner
        @test leftjoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal) ≅
              vcat(left, DataFrame(ID=special, Name="Maria Tester", Job=missing))
        @test rightjoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal) ≅ right
        @test outerjoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal)[[1:4;6;5], :] ≅
              vcat(outer, DataFrame(ID=special, Name="Maria Tester", Job=missing))
        @test semijoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal) ≅ semi
        @test antijoin(name_w_special, job, on=:ID, validate=(true, false), matchmissing=:equal) ≅
              vcat(anti, DataFrame(ID=special, Name="Maria Tester"))

        # Make sure duplicated special values still an exception
        name_w_special_dups = DataFrame(ID=[1, 2, 3, special, special],
                                        Name=["John Doe", "Jane Doe", "Joe Blogs",
                                              "Maria Tester", "Jill Jillerson"])
        @test_throws ArgumentError innerjoin(name_w_special_dups, name, on=:ID,
                                        validate=(true, false), matchmissing=:equal)
    end

    for special in [NaN, -0.0]
        name_w_special = DataFrame(ID=categorical([1, 2, 3, special]),
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test innerjoin(name_w_special, transform(job, :ID => categorical => :ID), on=:ID, validate=(true, false)) == inner

        # Make sure duplicated special values still an exception
        name_w_special_dups = DataFrame(ID=categorical([1, 2, 3, special, special]),
                                        Name=["John Doe", "Jane Doe", "Joe Blogs",
                                              "Maria Tester", "Jill Jillerson"])
        @test_throws ArgumentError innerjoin(name_w_special_dups, transform(name, :ID => categorical => :ID), on=:ID,
                                        validate=(true, false))
    end

    # Check 0.0 and -0.0 seen as different
    name_w_zeros = DataFrame(ID=categorical([1, 2, 3, 0.0, -0.0]),
                             Name=["John Doe", "Jane Doe",
                                   "Joe Blogs", "Maria Tester",
                                   "Jill Jillerson"])
    name_w_zeros2 = DataFrame(ID=categorical([1, 2, 3, 0.0, -0.0]),
                              Name=["John Doe", "Jane Doe",
                                    "Joe Blogs", "Maria Tester",
                                    "Jill Jillerson"],
                              Name_1=["John Doe", "Jane Doe",
                                      "Joe Blogs", "Maria Tester",
                                      "Jill Jillerson"])

    @test innerjoin(name_w_zeros, name_w_zeros, on=:ID, validate=(true, true),
               makeunique=true) ≅ name_w_zeros2

    # Check for multiple-column merge keys
    name_multi = DataFrame(ID1=[1, 1, 2],
                           ID2=["a", "b", "a"],
                           Name=["John Doe", "Jane Doe", "Joe Blogs"])
    job_multi = DataFrame(ID1=[1, 2, 2, 4],
                          ID2=["a", "b", "b", "c"],
                          Job=["Lawyer", "Doctor", "Florist", "Farmer"])
    outer_multi = DataFrame(ID1=[1, 1, 2, 2, 2, 4],
                            ID2=["a", "b", "a", "b", "b", "c"],
                            Name=["John Doe", "Jane Doe", "Joe Blogs",
                                  missing, missing, missing],
                            Job=["Lawyer", missing, missing,
                                 "Doctor", "Florist",  "Farmer"])

     @test outerjoin(name_multi, job_multi, on=[:ID1, :ID2],
                validate=(true, false)) ≅ outer_multi
     @test_throws ArgumentError outerjoin(name_multi, job_multi, on=[:ID1, :ID2],
                                     validate=(false, true))
end

@testset "consistency" begin
    # Join on symbols or vectors of symbols
    cname = copy(name)
    cjob = copy(job)
    push!(cname[!, 1], cname[1, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)

    cname = copy(name)
    cjob = copy(job)
    push!(cjob[!, 1], cjob[1, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)

    cname = copy(name)
    push!(DataFrames._columns(cname), cname[:, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)
end

@testset "multi data frame join" begin
    df1 = DataFrame(id=[1, 2, 3], x=[1, 2, 3])
    df2 = DataFrame(id=[1, 2, 4], y=[1, 2, 4])
    df3 = DataFrame(id=[1, 3, 4], z=[1, 3, 4])
    @test innerjoin(df1, df2, df3, on=:id) == DataFrame(id=1, x=1, y=1, z=1)
    @test outerjoin(df1, df2, df3, on=:id) ≅ DataFrame(id=[1, 3, 4, 2],
                                                       x=[1, 3, missing, 2],
                                                       y=[1, missing, 4, 2],
                                                       z=[1, 3, 4, missing])
    @test_throws MethodError leftjoin(df1, df2, df3, on=:id)
    @test_throws MethodError rightjoin(df1, df2, df3, on=:id)
    @test_throws MethodError semijoin(df1, df2, df3, on=:id)
    @test_throws MethodError antijoin(df1, df2, df3, on=:id)

    dfc = crossjoin(df1, df2, df3, makeunique=true)
    @test dfc.x == dfc.id == repeat(1:3, inner=9)
    @test dfc.y == dfc.id_1 == repeat([1, 2, 4], inner=3, outer=3)
    @test dfc.z == dfc.id_2 == repeat([1, 3, 4], outer=9)

    df3[1, 1] = 4
    @test_throws ArgumentError innerjoin(df1, df2, df3, on=:id, validate=(true, true))
end

@testset "flexible on in join" begin
    df1 = DataFrame(id=[1, 2, 3], id2=[11, 12, 13], x=[1, 2, 3])
    df2 = DataFrame(id=[1, 2, 4], ID2=[11, 12, 14], y=[1, 2, 4])
    @test innerjoin(df1, df2, on=[:id, :id2=>:ID2]) == DataFrame(id=[1, 2], id2=[11, 12],
                                                                 x=[1, 2], y=[1, 2])
    @test innerjoin(df1, df2, on=[:id2=>:ID2, :id]) == DataFrame(id=[1, 2], id2=[11, 12],
                                                                 x=[1, 2], y=[1, 2])
    @test innerjoin(df1, df2, on=[:id=>:id, :id2=>:ID2]) == DataFrame(id=[1, 2], id2=[11, 12],
                                                                      x=[1, 2], y=[1, 2])
    @test innerjoin(df1, df2, on=[:id2=>:ID2, :id=>:id]) == DataFrame(id=[1, 2], id2=[11, 12],
                                                                      x=[1, 2], y=[1, 2])
end

@testset "check naming of source" begin
    df = DataFrame(a=1)
    @test_throws ArgumentError outerjoin(df, df, on=:a, source=:a)
    @test outerjoin(df, df, on=:a, source=:a, makeunique=true) == DataFrame(a=1, a_1="both")
    @test outerjoin(df, df, on=:a, source="_left") == DataFrame(a=1, _left="both")
    @test outerjoin(df, df, on=:a, source="_right") == DataFrame(a=1, _right="both")

    df = DataFrame(_left=1)
    @test outerjoin(df, df, on=:_left, source="_leftX") == DataFrame(_left=1, _leftX="both")
    df = DataFrame(_right=1)
    @test outerjoin(df, df, on=:_right, source="_rightX") == DataFrame(_right=1, _rightX="both")
end

@testset "validate error message composition" begin
    for validate in ((true, false), (false, true), (true, true)),
        a in ([1; 1], [1:2; 1:2], [1:3; 1:3]),
        on in ([:a], [:a, :b])
        df = DataFrame(a=a, b=1, c=1)
        @test_throws ArgumentError outerjoin(df, df, on=on, validate=validate)
    end
    for validate in ((true, false), (false, true), (true, true)),
        a in ([1; 1], [1:2; 1:2], [1:3; 1:3]),
        on in ([:a=>:d], [:a => :d, :b])
        df1 = DataFrame(a=a, b=1, c=1)
        df2 = DataFrame(d=a, b=1, c=1)
        @test_throws ArgumentError outerjoin(df1, df2, on=on, validate=validate)
    end

    # make sure we do not error when we should not
    for validate in ((false, false), (true, false), (false, true), (true, true))
        df1 = DataFrame(a=1, b=1)
        df2 = DataFrame(d=1, b=1)
        @test outerjoin(df1, df1, on=[:a, :b], validate=validate) == df1
        @test outerjoin(df1, df2, on=[:a => :d, :b], validate=validate) == df1
    end
    df1 = DataFrame(a=[1, 1], b=1)
    df2 = DataFrame(d=1, b=1)
    @test outerjoin(df1, df2, on=[:a => :d, :b], validate=(false, true)) == df1
    df1 = DataFrame(a=1, b=1)
    df2 = DataFrame(d=[1, 1], b=1)
    @test outerjoin(df1, df2, on=[:a => :d, :b], validate=(true, false)) == [df1; df1]
    df1 = DataFrame(a=[1, 1], b=1)
    df2 = DataFrame(d=[1, 1], b=1)
    @test outerjoin(df1, df2, on=[:a => :d, :b], validate=(false, false)) == [df1; df1]
end

@testset "renamecols tests" begin
    df1 = DataFrame(id1=[1, 2, 3], id2=[1, 2, 3], x=1:3)
    df2 = DataFrame(id1=[1, 2, 4], ID2=[1, 2, 4], x=1:3)

    @test_throws ArgumentError innerjoin(df1, df2, on=:id1, renamecols=1=>1, makeunique=true)
    @test_throws ArgumentError leftjoin(df1, df2, on=:id1, renamecols=1=>1, makeunique=true)
    @test_throws ArgumentError rightjoin(df1, df2, on=:id1, renamecols=1=>1, makeunique=true)
    @test_throws ArgumentError outerjoin(df1, df2, on=:id1, renamecols=1=>1, makeunique=true)

    @test_throws ArgumentError innerjoin(df1, df2, on=:id1)
    @test innerjoin(df1, df2, on=:id1, makeunique=true) ==
        DataFrame(id1=[1, 2], id2=[1, 2], x=[1, 2], ID2=[1, 2], x_1=[1, 2])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test innerjoin(df1, df2, on=:id1,
                        makeunique = mu, validate = vl => vr, renamecols = l => r) ==
            DataFrame(id1=[1, 2], id2_left=[1, 2], x_left=[1, 2], ID2_right=[1, 2], x_right=[1, 2])
    end

    @test_throws ArgumentError innerjoin(df1, df2, on=[:id1, :id2 => :ID2])
    @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2], makeunique=true) ==
        DataFrame(id1=[1, 2], id2=[1, 2], x=[1, 2], x_1=[1, 2])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2],
                        makeunique = mu, validate = vl => vr, renamecols = l => r) ==
            DataFrame(id1=[1, 2], id2=[1, 2], x_left=[1, 2], x_right=[1, 2])
    end

    @test_throws ArgumentError leftjoin(df1, df2, on=:id1)
    @test leftjoin(df1, df2, on=:id1, makeunique=true) ≅
        DataFrame(id1=[1, 2, 3], id2=[1, 2, 3], x=[1, 2, 3], ID2=[1, 2, missing], x_1=[1, 2, missing])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test leftjoin(df1, df2, on=:id1,
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 3], id2_left=[1, 2, 3], x_left=[1, 2, 3],
                      ID2_right=[1, 2, missing], x_right=[1, 2, missing])
    end

    @test_throws ArgumentError leftjoin(df1, df2, on=[:id1, :id2 => :ID2])
    @test leftjoin(df1, df2, on=[:id1, :id2 => :ID2], makeunique=true) ≅
        DataFrame(id1=[1, 2, 3], id2=[1, 2, 3], x=[1, 2, 3], x_1=[1, 2, missing])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test leftjoin(df1, df2, on=[:id1, :id2 => :ID2],
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 3], id2=[1, 2, 3], x_left=[1, 2, 3], x_right=[1, 2, missing])
    end

    @test_throws ArgumentError leftjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                        renamecols = "_left" => "_right", source=:id1)
    @test_throws ArgumentError leftjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                        renamecols = "_left" => "_right", source=:x_left)
    @test leftjoin(df1, df2, on=[:id1, :id2 => :ID2],
                   renamecols = "_left" => "_right", source=:ind) ≅
          DataFrame(id1=[1, 2, 3], id2=[1, 2, 3], x_left=[1, 2, 3],
                    x_right=[1, 2, missing], ind=["both", "both", "left_only"])

    @test_throws ArgumentError rightjoin(df1, df2, on=:id1)
    @test rightjoin(df1, df2, on=:id1, makeunique=true) ≅
        DataFrame(id1=[1, 2, 4], id2=[1, 2, missing], x=[1, 2, missing], ID2=[1, 2, 4], x_1=[1, 2, 3])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test rightjoin(df1, df2, on=:id1,
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 4], id2_left=[1, 2, missing], x_left=[1, 2, missing],
                      ID2_right=[1, 2, 4], x_right=[1, 2, 3])
    end

    @test_throws ArgumentError rightjoin(df1, df2, on=[:id1, :id2 => :ID2])
    @test rightjoin(df1, df2, on=[:id1, :id2 => :ID2], makeunique=true) ≅
        DataFrame(id1=[1, 2, 4], id2=[1, 2, 4], x=[1, 2, missing], x_1=[1, 2, 3])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test rightjoin(df1, df2, on=[:id1, :id2 => :ID2],
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 4], id2=[1, 2, 4], x_left=[1, 2, missing], x_right=[1, 2, 3])
    end

    @test_throws ArgumentError rightjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                         renamecols = "_left" => "_right", source=:id1)
    @test_throws ArgumentError rightjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                         renamecols = "_left" => "_right", source=:x_left)
    @test rightjoin(df1, df2, on=[:id1, :id2 => :ID2],
                    renamecols = "_left" => "_right", source=:ind) ≅
          DataFrame(id1=[1, 2, 4], id2=[1, 2, 4], x_left=[1, 2, missing],
                    x_right=[1, 2, 3], ind=["both", "both", "right_only"])

    @test_throws ArgumentError outerjoin(df1, df2, on=:id1)
    @test outerjoin(df1, df2, on=:id1, makeunique=true) ≅
        DataFrame(id1=[1, 2, 3, 4], id2=[1, 2, 3, missing], x=[1, 2, 3, missing],
                  ID2=[1, 2, missing, 4], x_1=[1, 2, missing, 3])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test outerjoin(df1, df2, on=:id1,
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 3, 4], id2_left=[1, 2, 3, missing], x_left=[1, 2, 3, missing],
                      ID2_right=[1, 2, missing, 4], x_right=[1, 2, missing, 3])
    end

    @test_throws ArgumentError outerjoin(df1, df2, on=[:id1, :id2 => :ID2])
    @test outerjoin(df1, df2, on=[:id1, :id2 => :ID2], makeunique=true) ≅
        DataFrame(id1=[1, 2, 3, 4], id2=[1, 2, 3, 4], x=[1, 2, 3, missing], x_1=[1, 2, missing, 3])
    for l in ["_left", :_left, x -> x * "_left"],
        r in ["_right", :_right, x -> x * "_right"],
        mu in [true, false], vl in [true, false], vr in [true, false]
        @test outerjoin(df1, df2, on=[:id1, :id2 => :ID2],
                       makeunique = mu, validate = vl => vr, renamecols = l => r) ≅
            DataFrame(id1=[1, 2, 3, 4], id2=[1, 2, 3, 4], x_left=[1, 2, 3, missing], x_right=[1, 2, missing, 3])
    end

    @test_throws ArgumentError outerjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                         renamecols = "_left" => "_right", source=:id1)
    @test_throws ArgumentError outerjoin(df1, df2, on=[:id1, :id2 => :ID2],
                                         renamecols = "_left" => "_right", source=:x_left)
    @test outerjoin(df1, df2, on=[:id1, :id2 => :ID2],
                    renamecols = "_left" => "_right", source=:ind) ≅
          DataFrame(id1=[1, 2, 3, 4], id2=[1, 2, 3, 4], x_left=[1, 2, 3, missing],
                    x_right=[1, 2, missing, 3], ind=["both", "both", "left_only", "right_only"])

    df1.x .+= 10
    df2.x .+= 100
    @test_throws ArgumentError innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = (x -> :id1) => "_right")
    @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = (x -> :id1) => "_right", makeunique=true) ==
          DataFrame(id1=1:2, id2=1:2, id1_1=11:12, x_right=101:102)
    @test_throws ArgumentError innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => (x -> :id2))
    @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => (x -> :id2), makeunique=true) ==
          DataFrame(id1=1:2, id2=1:2, x_left=11:12, id2_1=101:102)
    @test_throws ArgumentError innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => "_left")
    @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => "_left", makeunique=true) ==
          DataFrame(id1=1:2, id2=1:2, x_left=11:12, x_left_1=101:102)
    df2.y = df2.x .+ 1
    @test_throws ArgumentError innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => (x -> :newcol))
    @test innerjoin(df1, df2, on=[:id1, :id2 => :ID2], renamecols = "_left" => (x -> :newcol), makeunique=true) ==
          DataFrame(id1=1:2, id2=1:2, x_left=11:12, newcol=101:102, newcol_1=102:103)
end

@testset "careful source test" begin
    Random.seed!(1234)
    for i in 5:15, j in 5:15
        df1 = DataFrame(id=rand(1:10, i), x=1:i)
        df2 = DataFrame(id=rand(1:10, j), y=1:j)
        dfi = innerjoin(df1, df2, on=:id)
        dfl = leftjoin(df1, df2, on=:id, source=:ind)
        dfr = rightjoin(df1, df2, on=:id, source=:ind)
        dfo = outerjoin(df1, df2, on=:id, source=:ind)
        @test issorted(dfl, :ind)
        @test issorted(dfr, :ind)
        @test issorted(dfo, :ind)

        @test all(==("both"), dfl[1:nrow(dfi), :ind])
        @test dfl[1:nrow(dfi), 1:3] ≅ dfi
        @test all(==("left_only"), dfl[nrow(dfi)+1:end, :ind])

        @test all(==("both"), dfr[1:nrow(dfi), :ind])
        @test dfr[1:nrow(dfi), 1:3] ≅ dfi
        @test all(==("right_only"), dfr[nrow(dfi)+1:end, :ind])

        @test all(==("both"), dfo[1:nrow(dfi), :ind])
        @test dfl ≅ dfo[1:nrow(dfl), :]
        @test all(==("right_only"), dfo[nrow(dfl)+1:end, :ind])
    end
end

@testset "removed join function" begin
    df1 = DataFrame(id=[1, 2, 3], x=[1, 2, 3])
    df2 = DataFrame(id=[1, 2, 4], y=[1, 2, 4])
    df3 = DataFrame(id=[1, 3, 4], z=[1, 3, 4])
    @test_throws ArgumentError join(df1, df2, df3, on=:id, kind=:left)
    @test_throws ArgumentError join(df1, df2, on=:id, kind=:inner)
end

@testset "join mixing DataFrame and SubDataFrame" begin
    df1 = DataFrame(a=[1, 2, 3], b=[4, 5, 6])
    df1_copy = df1[df1.a .> 1, :]
    df1_view1 = @view df1[df1.a .> 1, :]
    df1_view2 = @view df1[df1.a .> 1, 1:2]
    df2 = DataFrame(a=[1, 2, 3], c=[7, 8, 9])
    @test innerjoin(df1_copy, df2, on=:a) ==
          innerjoin(df1_view1, df2, on=:a) ==
          innerjoin(df1_view2, df2, on=:a)
end

@testset "OnCol correctness tests" begin
    Random.seed!(1234)
    c1 = collect(1:10^2)
    c2 = collect(Float64, 1:10^2)
    c3 = collect(sort(string.(1:10^2)))
    c4 = repeat(1:10, inner=10)
    c5 = collect(Float64, repeat(1:50, inner=2))
    c6 = sort(string.(repeat(1:25,inner=4)))
    c7 = repeat(20:-1:1, inner=5)

    @test_throws AssertionError OnCol()
    @test_throws AssertionError OnCol(c1)
    @test_throws AssertionError OnCol(c1, [1])
    @test_throws MethodError OnCol(c1, 1)

    oncols = Any[OnCol(c1, c2), OnCol(c3, c4), OnCol(c5, c6), OnCol(c1, c2, c3),
                 OnCol(c2, c3, c4), OnCol(c4, c5, c6), OnCol(c1, c2, c3, c4),
                 OnCol(c2, c3, c4, c5), OnCol(c3, c4, c5, c6), OnCol(c1, c2, c3, c4, c5),
                 OnCol(c2, c3, c4, c5, c6), OnCol(c1, c2, c3, c4, c5, c6),
                 OnCol(c4, c7), OnCol(c4, c5, c7), OnCol(c4, c5, c6, c7)]
    tupcols = Any[tuple.(c1, c2), tuple.(c3, c4), tuple.(c5, c6), tuple.(c1, c2, c3),
                  tuple.(c2, c3, c4), tuple.(c4, c5, c6), tuple.(c1, c2, c3, c4),
                  tuple.(c2, c3, c4, c5), tuple.(c3, c4, c5, c6), tuple.(c1, c2, c3, c4, c5),
                  tuple.(c2, c3, c4, c5, c6), tuple.(c1, c2, c3, c4, c5, c6),
                  tuple.(c4, c7), tuple.(c4, c5, c7), tuple.(c4, c5, c6, c7)]

    for (oncol, tupcol) in zip(oncols, tupcols)
        @test issorted(oncol) == issorted(tupcol)
        @test IndexStyle(oncol) === IndexLinear()
        @test_throws MethodError oncol[1] == oncol[2]
    end

    for i in eachindex(c1), j in eachindex(oncols, tupcols)
        DataFrames._prehash(oncols[j])
        @test hash(oncols[j][i]) == hash(tupcols[j][i])
        for k in eachindex(c1)
            @test isequal(oncols[j][i], oncols[j][k]) == isequal(tupcols[j][i], tupcols[j][k])
            @test isequal(oncols[j][k], oncols[j][i]) == isequal(tupcols[j][k], tupcols[j][i])
            @test isless(oncols[j][i], oncols[j][k]) == isless(tupcols[j][i], tupcols[j][k])
            @test isless(oncols[j][k], oncols[j][i]) == isless(tupcols[j][k], tupcols[j][i])
        end
    end

    foreach(shuffle!, [c1, c2, c3, c4, c5, c6])

    tupcols = [tuple.(c1, c2), tuple.(c3, c4), tuple.(c5, c6), tuple.(c1, c2, c3),
               tuple.(c2, c3, c4), tuple.(c4, c5, c6), tuple.(c1, c2, c3, c4),
               tuple.(c2, c3, c4, c5), tuple.(c3, c4, c5, c6), tuple.(c1, c2, c3, c4, c5),
               tuple.(c2, c3, c4, c5, c6), tuple.(c1, c2, c3, c4, c5, c6),
               tuple.(c4, c7), tuple.(c4, c5, c7), tuple.(c4, c5, c6, c7)]

    for i in eachindex(c1), j in eachindex(oncols, tupcols)
        DataFrames._prehash(oncols[j])
        @test hash(oncols[j][i]) == hash(tupcols[j][i])
        for k in eachindex(c1)
            @test isequal(oncols[j][i], oncols[j][k]) == isequal(tupcols[j][i], tupcols[j][k])
            @test isequal(oncols[j][k], oncols[j][i]) == isequal(tupcols[j][k], tupcols[j][i])
            @test isless(oncols[j][i], oncols[j][k]) == isless(tupcols[j][i], tupcols[j][k])
            @test isless(oncols[j][k], oncols[j][i]) == isless(tupcols[j][k], tupcols[j][i])
        end
    end
end

@testset "join correctness tests" begin

    @test_throws ArgumentError DataFrames.prepare_on_col()

    function test_join(df1, df2)
        @assert names(df1) == ["id", "x"]
        @assert names(df2) == ["id", "y"]

        df_inner = DataFrame(id=[], x=[], y=[])
        for i in axes(df1, 1), j in axes(df2, 1)
            if isequal(df1.id[i], df2.id[j])
                v = df1.id[i] isa CategoricalValue ? unwrap(df1.id[i]) : df1.id[i]
                push!(df_inner, (id=v, x=df1.x[i], y=df2.y[j]))
            end
        end

        df_left_part = DataFrame(id=[], x=[], y=[])
        for i in axes(df1, 1)
            if !(df1.id[i] in Set(df2.id))
                v = df1.id[i] isa CategoricalValue ? unwrap(df1.id[i]) : df1.id[i]
                push!(df_left_part, (id=v, x=df1.x[i], y=missing))
            end
        end

        df_right_part = DataFrame(id=[], x=[], y=[])
        for i in axes(df2, 1)
            if !(df2.id[i] in Set(df1.id))
                v = df2.id[i] isa CategoricalValue ? unwrap(df2.id[i]) : df2.id[i]
                push!(df_right_part, (id=v, x=missing, y=df2.y[i]))
            end
        end

        df_left = vcat(df_inner, df_left_part)
        df_right = vcat(df_inner, df_right_part)
        df_outer = vcat(df_inner, df_left_part, df_right_part)

        df_semi = df1[[x in Set(df2.id) for x in df1.id], :]
        df_anti = df1[[!(x in Set(df2.id)) for x in df1.id], :]

        df1x = copy(df1)
        df1x.id2 = copy(df1x.id)
        df2x = copy(df2)
        df2x.id2 = copy(df2x.id)

        df1x2 = copy(df1x)
        df1x2.id3 = copy(df1x2.id)
        df2x2 = copy(df2x)
        df2x2.id3 = copy(df2x2.id)

        sort!(df_inner, [:x, :y])
        sort!(df_left, [:x, :y])
        sort!(df_right, [:x, :y])
        sort!(df_outer, [:x, :y])

        df_inner2 = copy(df_inner)
        df_left2 = copy(df_left)
        df_right2 = copy(df_right)
        df_outer2 = copy(df_outer)
        df_semi2 = copy(df_semi)
        df_anti2 = copy(df_anti)
        insertcols!(df_inner2, 3, :id2 => df_inner2.id)
        insertcols!(df_left2, 3, :id2 => df_left2.id)
        insertcols!(df_right2, 3, :id2 => df_right2.id)
        insertcols!(df_outer2, 3, :id2 => df_outer2.id)
        insertcols!(df_semi2, 3, :id2 => df_semi2.id)
        insertcols!(df_anti2, 3, :id2 => df_anti2.id)
        df_inner3 = copy(df_inner2)
        df_left3 = copy(df_left2)
        df_right3 = copy(df_right2)
        df_outer3 = copy(df_outer2)
        df_semi3 = copy(df_semi2)
        df_anti3 = copy(df_anti2)
        insertcols!(df_inner3, 4, :id3 => df_inner3.id)
        insertcols!(df_left3, 4, :id3 => df_left3.id)
        insertcols!(df_right3, 4, :id3 => df_right3.id)
        insertcols!(df_outer3, 4, :id3 => df_outer3.id)
        insertcols!(df_semi3, 4, :id3 => df_semi3.id)
        insertcols!(df_anti3, 4, :id3 => df_anti3.id)

        test_leftjoin! =
            (any(nonunique(df2, :id)) ||
             df_left ≅ sort(leftjoin!(copy(df1), df2, on=:id, matchmissing=:equal), [:x, :y])) &&
            (any(nonunique(df2x, [:id, :id2])) ||
             df_left2 ≅ sort(leftjoin!(copy(df1x), df2x, on=[:id, :id2], matchmissing=:equal), [:x, :y])) &&
            (any(nonunique(df2x2, [:id, :id2, :id3])) ||
             df_left3 ≅ sort(leftjoin!(copy(df1x2), df2x2, on=[:id, :id2, :id3], matchmissing=:equal), [:x, :y]))

        return df_inner ≅ sort(innerjoin(df1, df2, on=:id, matchmissing=:equal), [:x, :y]) &&
               df_inner2 ≅ sort(innerjoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal), [:x, :y]) &&
               df_inner3 ≅ sort(innerjoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal), [:x, :y]) &&
               df_left ≅ sort(leftjoin(df1, df2, on=:id, matchmissing=:equal), [:x, :y]) &&
               df_left2 ≅ sort(leftjoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal), [:x, :y]) &&
               df_left3 ≅ sort(leftjoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal), [:x, :y]) &&
               test_leftjoin! &&
               df_right ≅ sort(rightjoin(df1, df2, on=:id, matchmissing=:equal), [:x, :y]) &&
               df_right2 ≅ sort(rightjoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal), [:x, :y]) &&
               df_right3 ≅ sort(rightjoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal), [:x, :y]) &&
               df_outer ≅ sort(outerjoin(df1, df2, on=:id, matchmissing=:equal), [:x, :y]) &&
               df_outer2 ≅ sort(outerjoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal), [:x, :y]) &&
               df_outer3 ≅ sort(outerjoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal), [:x, :y]) &&
               df_semi ≅ semijoin(df1, df2, on=:id, matchmissing=:equal) &&
               df_semi2 ≅ semijoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal) &&
               df_semi3 ≅ semijoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal) &&
               df_anti ≅ antijoin(df1, df2, on=:id, matchmissing=:equal) &&
               df_anti2 ≅ antijoin(df1x, df2x, on=[:id, :id2], matchmissing=:equal) &&
               df_anti3 ≅ antijoin(df1x2, df2x2, on=[:id, :id2, :id3], matchmissing=:equal)
    end

    Random.seed!(1234)
    for i in 1:5, j in 0:2
        for df1 in [DataFrame(id=rand(1:i+j, i+j), x=1:i+j), DataFrame(id=rand(1:i, i), x=1:i),
                    DataFrame(id=[rand(1:i+j, i+j); missing], x=1:i+j+1),
                    DataFrame(id=[rand(1:i, i); missing], x=1:i+1)],
            df2 in [DataFrame(id=rand(1:i+j, i+j), y=1:i+j), DataFrame(id=rand(1:i, i), y=1:i),
                    DataFrame(id=[rand(1:i+j, i+j); missing], y=1:i+j+1),
                    DataFrame(id=[rand(1:i, i); missing], y=1:i+1)]
            for opleft = [identity, sort, x -> unique(x, :id), x -> sort(unique(x, :id))],
                opright = [identity, sort, x -> unique(x, :id), x -> sort(unique(x, :id))]

                # integers
                @test test_join(opleft(df1), opright(df2))
                @test test_join(opleft(df1), opright(rename(df1, :x => :y)))

                # strings
                df1s = copy(df1)
                df1s[!, 1] = passmissing(string).(df1s[!, 1])
                df2s = copy(df2)
                df2s[!, 1] = passmissing(string).(df2s[!, 1])
                @test test_join(opleft(df1s), opright(df2s))
                @test test_join(opleft(df1s), opright(rename(df1s, :x => :y)))

                # PooledArrays
                df1p = copy(df1)
                df1p[!, 1] = PooledArray(df1p[!, 1])
                df2p = copy(df2)
                df2p[!, 1] = PooledArray(df2p[!, 1])
                @test test_join(opleft(df1), opright(df2p))
                @test test_join(opleft(df1p), opright(df2))
                @test test_join(opleft(df1p), opright(df2p))
                @test test_join(opleft(df1p), opright(rename(df1p, :x => :y)))

                # add unused level
                df1p[1, 1] = 0
                df2p[1, 1] = 0
                df1p[1, 1] = 1
                df2p[1, 1] = 1
                @test test_join(opleft(df1), opright(df2p))
                @test test_join(opleft(df1p), opright(df2))
                @test test_join(opleft(df1p), opright(df2p))
                @test test_join(opleft(df1p), opright(rename(df1p, :x => :y)))

                # CategoricalArrays
                df1c = copy(df1)
                df1c[!, 1] = categorical(df1c[!, 1])
                df2c = copy(df2)
                df2c[!, 1] = categorical(df2c[!, 1])
                @test test_join(opleft(df1), opright(df2c))
                @test test_join(opleft(df1c), opright(df2c))
                @test test_join(opleft(df1c), opright(df2))
                @test test_join(opleft(df1c), opright(rename(df1c, :x => :y)))
                @test test_join(opleft(df1p), opright(df2c))
                @test test_join(opleft(df1c), opright(df2p))

                # add unused level
                df1c[1, 1] = 0
                df2c[1, 1] = 0
                df1c[1, 1] = 1
                df2c[1, 1] = 1
                @test test_join(opleft(df1), opright(df2c))
                @test test_join(opleft(df1c), opright(df2c))
                @test test_join(opleft(df1c), opright(df2))
                @test test_join(opleft(df1c), opright(rename(df1c, :x => :y)))
                @test test_join(opleft(df1p), opright(df2c))
                @test test_join(opleft(df1c), opright(df2p))
            end
        end
    end

    # some special cases
    @test isequal_coltyped(innerjoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(semijoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[1, 2, 3]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Any[1, 2, 3]))
    @test isequal_coltyped(semijoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[1, 2, 3]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=Any[]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=Any[1, 2, 3]))
    @test isequal_coltyped(semijoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[1, 2, 3]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[4, 5, 6]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[1, 2, 3]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[4, 5, 6, 1, 2, 3]))
    @test isequal_coltyped(semijoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[4, 5, 6]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[1, 2, 3]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[4, 5, 6]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[1, 2, 3, 4, 5, 6]))
    @test isequal_coltyped(semijoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=[1, 2, 3]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(antijoin(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))

    @test isequal_coltyped(innerjoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(rightjoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[1]))
    @test isequal_coltyped(semijoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(antijoin(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(rightjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[1]))
    @test isequal_coltyped(semijoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(antijoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(rightjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=[2, 1, 2]))
    @test isequal_coltyped(outerjoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[2, 1, 2]))
    @test isequal_coltyped(semijoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(antijoin(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(leftjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                    on=:id, matchmissing=:equal) ,
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(rightjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(antijoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[missing]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                    on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(antijoin(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(leftjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                    on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(rightjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=[missing, 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(antijoin(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                     on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int)]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int), typemin(Int) + 1]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int)]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int), typemin(Int) + 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int)]))
    @test isequal_coltyped(antijoin(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int) + 1]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int)]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int), typemax(Int) - 1]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int)]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int), typemax(Int) - 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int)]))
    @test isequal_coltyped(antijoin(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int) - 1]))

    @test isequal_coltyped(innerjoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 100]))
    @test isequal_coltyped(leftjoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 100, 2]))
    @test isequal_coltyped(rightjoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 100, 1]))
    @test isequal_coltyped(outerjoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 100, 2, 1]))
    @test isequal_coltyped(semijoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 100]))
    @test isequal_coltyped(antijoin(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2]))

    @test isequal_coltyped(outerjoin(DataFrame(id=[1]), DataFrame(id=[4.5]), on=:id),
                           DataFrame(id=[1, 4.5]))
    @test isequal_coltyped(outerjoin(DataFrame(id=categorical([1])), DataFrame(id=[(1, 2)]), on=:id),
                           DataFrame(id=[1, (1, 2)]))
end

@testset "legacy merge tests" begin
    Random.seed!(1)
    df1 = DataFrame(a=shuffle!(Vector{Union{Int, Missing}}(1:10)),
                    b=rand(Union{Symbol, Missing}[:A, :B], 10),
                    v1=Vector{Union{Float64, Missing}}(randn(10)))

    df2 = DataFrame(a=shuffle!(Vector{Union{Int, Missing}}(1:5)),
                    b2=rand(Union{Symbol, Missing}[:A, :B, :C], 5),
                    v2=Vector{Union{Float64, Missing}}(randn(5)))

    m1 = innerjoin(df1, df2, on=:a)
    @test m1[!, :a] == df1[!, :a][df1[!, :a] .<= 5] # preserves df1 order
    m2 = outerjoin(df1, df2, on=:a)
    @test m2[!, :a] != df1[!, :a] # does not preserve df1 order
    @test m2[!, :b] != df1[!, :b] # does not preserve df1 order
    @test sort(m2[!, [:a, :b]]) == sort(df1[!, [:a, :b]]) # but keeps values
    @test m1 == m2[1:nrow(m1), :] # and is consistent with innerjoin in the first rows
    @test m2[indexin(df1[!, :a], m2[!, :a]), :b] == df1[!, :b]
    @test m2[indexin(df2[!, :a], m2[!, :a]), :b2] == df2[!, :b2]
    @test m2[indexin(df1[!, :a], m2[!, :a]), :v1] == df1[!, :v1]
    @test m2[indexin(df2[!, :a], m2[!, :a]), :v2] == df2[!, :v2]
    @test all(ismissing, m2[map(x -> !in(x, df2[!, :a]), m2[!, :a]), :b2])
    @test all(ismissing, m2[map(x -> !in(x, df2[!, :a]), m2[!, :a]), :v2])

    df1 = DataFrame(a=Union{Int, Missing}[1, 2, 3],
                    b=Union{String, Missing}["America", "Europe", "Africa"])
    df2 = DataFrame(a=Union{Int, Missing}[1, 2, 4],
                    c=Union{String, Missing}["New World", "Old World", "New World"])

    m1 = innerjoin(df1, df2, on=:a)
    @test m1[!, :a] == [1, 2]

    m2 = leftjoin(df1, df2, on=:a)
    @test m2[!, :a] == [1, 2, 3]

    m3 = rightjoin(df1, df2, on=:a)
    @test m3[!, :a] == [1, 2, 4]

    m4 = outerjoin(df1, df2, on=:a)
    @test m4[!, :a] == [1, 2, 3, 4]

    # test with missings (issue #185)
    df1 = DataFrame()
    df1[!, :A] = ["a", "b", "a", missing]
    df1[!, :B] = Union{Int, Missing}[1, 2, 1, 3]

    df2 = DataFrame()
    df2[!, :A] = ["a", missing, "c"]
    df2[!, :C] = Union{Int, Missing}[1, 2, 4]

    @test_throws ArgumentError innerjoin(df1, df2, on=:A)
    m1 = innerjoin(df1, df2, on=:A, matchmissing=:equal)
    @test size(m1) == (3, 3)
    @test m1[!, :A] ≅ ["a", "a", missing]

    @test_throws ArgumentError outerjoin(df1, df2, on=:A)
    m2 = outerjoin(df1, df2, on=:A, matchmissing=:equal)
    @test size(m2) == (5, 3)
    @test m2[!, :A] ≅ ["a", "a", missing, "b", "c"]
end

@testset "legacy join tests" begin
    df1 = DataFrame(a=Union{Symbol, Missing}[:x, :y][[1, 1, 1, 2, 1, 1]],
                    b=Union{Symbol, Missing}[:A, :B, :D][[1, 1, 2, 2, 1, 3]],
                    v1=1:6)

    df2 = DataFrame(a=Union{Symbol, Missing}[:x, :y][[2, 2, 1, 1, 1, 1]],
                    b=Union{Symbol, Missing}[:A, :B, :C][[1, 2, 1, 2, 3, 1]],
                    v2=1:6)
    df2[1, :a] = missing

    m1 = innerjoin(df1, df2, on=[:a, :b], matchmissing=:equal)
    @test sort(m1) == sort(DataFrame(a=[:x, :x, :x, :x, :x, :y, :x, :x],
                                     b=[:A, :A, :A, :A, :B, :B, :A, :A],
                                     v1=[1, 1, 2, 2, 3, 4, 5, 5],
                                     v2=[3, 6, 3, 6, 4, 2, 3, 6]))
    m2 = outerjoin(df1, df2, on=[:a, :b], matchmissing=:equal)
    @test sort(m2) ≅ sort(DataFrame(a=[:x, :x, :x, :x, :x, :y, :x, :x, :x, missing, :x],
                                    b=[:A, :A, :A, :A, :B, :B, :A, :A, :D, :A, :C],
                                    v1=[1, 1, 2, 2, 3, 4, 5, 5, 6, missing, missing],
                                    v2=[3, 6, 3, 6, 4, 2, 3, 6, missing, 1, 5]))

    Random.seed!(1)
    df1 = DataFrame(a=["abc", "abx", "axz", "def", "dfr"], v1=randn(5))
    df2 = DataFrame(a=["def", "abc", "abx", "axz", "xyz"], v2=randn(5))
    transform!(df1, :a => ByRow(collect) => AsTable)
    transform!(df2, :a => ByRow(collect) => AsTable)

    m1 = innerjoin(df1, df2, on=:a, makeunique=true)
    m2 = innerjoin(df1, df2, on=[:x1, :x2, :x3], makeunique=true)
    @test m1[!, :a] == m2[!, :a]
end

@testset "threaded correctness" begin
    df1 = DataFrame(id=[1:10^5; 10^7+1:10^7+2])
    df1.left_row = axes(df1, 1)
    df2 = DataFrame(id=[1:10^5; 10^8+1:10^8+4])
    df2.right_row = axes(df2, 1)

    @test innerjoin(df1, df2, on=:id) ≅
          DataFrame(id=1:10^5, left_row=1:10^5, right_row=1:10^5)
    @test leftjoin(df1, df2, on=:id) ≅
          DataFrame(id=[1:10^5; 10^7+1:10^7+2], left_row=1:10^5+2,
                    right_row=[1:10^5; missing; missing])
    @test rightjoin(df1, df2, on=:id) ≅
          DataFrame(id=[1:10^5; 10^8+1:10^8+4],
                    left_row=[1:10^5; fill(missing, 4)],
                    right_row=1:10^5+4)
    @test outerjoin(df1, df2, on=:id) ≅
          DataFrame(id=[1:10^5; 10^7+1:10^7+2; 10^8+1:10^8+4],
                  left_row=[1:10^5+2; fill(missing, 4)],
                  right_row=[1:10^5; missing; missing; 10^5+1:10^5+4])
    @test semijoin(df1, df2, on=:id) ≅
          DataFrame(id=1:10^5, left_row=1:10^5)
    @test antijoin(df1, df2, on=:id) ≅
          DataFrame(id=10^7+1:10^7+2, left_row=10^5+1:10^5+2)

    Random.seed!(1234)
    for i in 1:4
        df1 = df1[shuffle(axes(df1, 1)), :]
        df2 = df2[shuffle(axes(df2, 1)), :]

        @test sort!(innerjoin(df1, df2, on=:id)) ≅
              DataFrame(id=1:10^5, left_row=1:10^5, right_row=1:10^5)
        @test sort!(leftjoin(df1, df2, on=:id)) ≅
              DataFrame(id=[1:10^5; 10^7+1:10^7+2], left_row=1:10^5+2,
                      right_row=[1:10^5; missing; missing])
        @test sort!(rightjoin(df1, df2, on=:id)) ≅
              DataFrame(id=[1:10^5; 10^8+1:10^8+4],
                          left_row=[1:10^5; fill(missing, 4)],
                          right_row=1:10^5+4)
        @test sort!(outerjoin(df1, df2, on=:id)) ≅
              DataFrame(id=[1:10^5; 10^7+1:10^7+2; 10^8+1:10^8+4],
                      left_row=[1:10^5+2; fill(missing, 4)],
                      right_row=[1:10^5; missing; missing; 10^5+1:10^5+4])
        @test sort!(semijoin(df1, df2, on=:id)) ≅
              DataFrame(id=1:10^5, left_row=1:10^5)
        @test sort!(antijoin(df1, df2, on=:id)) ≅
              DataFrame(id=10^7+1:10^7+2, left_row=10^5+1:10^5+2)
    end

    # test correctness of column order
    df1 = DataFrame(a=Int8(1), id2=-[1:10^5; 10^7+1:10^7+2], b=Int8(2),
                    id1=[1:10^5; 10^7+1:10^7+2], c=Int8(3), d=Int8(4))
    df2 = DataFrame(e=Int8(5), id1=[1:10^5; 10^8+1:10^8+4], f=Int8(6), g=Int8(7),
                    id2=-[1:10^5; 10^8+1:10^8+4], h=Int8(8))

    @test innerjoin(df1, df2, on=[:id1, :id2]) ≅
          DataFrame(a=Int8(1), id2=-(1:10^5), b=Int8(2), id1=1:10^5,
                  c=Int8(3), d=Int8(4), e=Int8(5), f=Int8(6), g=Int8(7), h=Int8(8))
    @test leftjoin(df1, df2, on=[:id1, :id2])[1:10^5, :] ≅
          DataFrame(a=Int8(1), id2=-(1:10^5), b=Int8(2), id1=1:10^5,
                  c=Int8(3), d=Int8(4), e=Int8(5), f=Int8(6), g=Int8(7), h=Int8(8))
    @test rightjoin(df1, df2, on=[:id1, :id2])[1:10^5, :] ≅
          DataFrame(a=Int8(1), id2=-(1:10^5), b=Int8(2), id1=1:10^5,
                  c=Int8(3), d=Int8(4), e=Int8(5), f=Int8(6), g=Int8(7), h=Int8(8))
    @test outerjoin(df1, df2, on=[:id1, :id2])[1:10^5, :] ≅
          DataFrame(a=Int8(1), id2=-(1:10^5), b=Int8(2), id1=1:10^5,
                  c=Int8(3), d=Int8(4), e=Int8(5), f=Int8(6), g=Int8(7), h=Int8(8))
    @test semijoin(df1, df2, on=[:id1, :id2]) ≅
          DataFrame(a=Int8(1), id2=-(1:10^5), b=Int8(2), id1=1:10^5, c=Int8(3), d=Int8(4))
    @test antijoin(df1, df2, on=[:id1, :id2]) ≅
          DataFrame(a=Int8(1), id2=-(10^7+1:10^7+2), b=Int8(2), id1=(10^7+1:10^7+2),
                  c=Int8(3), d=Int8(4))
end

@testset "matchmissing :notequal correctness" begin
    Random.seed!(1337)
    names = [
        DataFrame(ID=[1, 2, missing],
                  Name=["John Doe", "Jane Doe", "Joe Blogs"]),
        DataFrame(ID=[],
                  Name=[]),
        DataFrame(ID=missings(3),
                  Name=["John Doe", "Jane Doe", "Joe Blogs"]),
        DataFrame(ID=[1, 2, 3],
                  Name=[missing, "Jane Doe", missing]),
        DataFrame(ID=[1:100; missings(100)],
                  Name=repeat(["Jane Doe"], 200)),
        DataFrame(ID=[missings(100); 1:100],
                  Name=repeat(["Jane Doe"], 200)),
        DataFrame(ID=[1:50; missings(100); 51:100],
                  Name=repeat(["Jane Doe"], 200)),
        DataFrame(ID=[1:64; missings(64); 129:200],
                  Name=repeat(["Jane Doe"], 200)),
        DataFrame(ID=[1:63; missings(65); 129:200],
                  Name=repeat(["Jane Doe"], 200)),
        DataFrame(ID=rand([1:1000; missing], 10000),
                  Name=rand(["John Doe", "Jane Doe", "Joe Blogs", missing], 10000)),
    ]
    jobs = [
        DataFrame(ID=[1, 2, 2, 4],
                  Job=["Lawyer", "Doctor", "Florist", "Farmer"]),
        DataFrame(ID=[missing, 2, 2, 4],
                  Job=["Lawyer", "Doctor", "Florist", "Farmer"]),
        DataFrame(ID=[missing, 2, 2, 4],
                  Job=["Lawyer", "Doctor", missing, "Farmer"]),
        DataFrame(ID=[],
                  Job=[]),
        DataFrame(ID=[1:100; missings(100)],
                  Job=repeat(["Lawyer"], 200)),
        DataFrame(ID=[missings(100); 1:100],
                  Job=repeat(["Lawyer"], 200)),
        DataFrame(ID=[1:50; missings(100); 51:100],
                  Job=repeat(["Lawyer"], 200)),
        DataFrame(ID=[1:64; missings(64); 129:200],
                  Job=repeat(["Lawyer"], 200)),
        DataFrame(ID=[1:63; missings(65); 129:200],
                  Job=repeat(["Lawyer"], 200)),
        DataFrame(ID=rand([1:1000; missing], 10000),
                  Job=rand(["Lawyer", "Doctor", "Florist", missing], 10000)),
    ]
    for name in names, job in jobs
        @test leftjoin(name, dropmissing(job, :ID), on=:ID, matchmissing=:equal) ≅
            leftjoin(name, job, on=:ID, matchmissing=:notequal)
        @test leftjoin!(copy(name), dropmissing(unique(job, :ID), :ID), on=:ID, matchmissing=:equal) ≅
            leftjoin!(copy(name), unique(job, :ID), on=:ID, matchmissing=:notequal)
        @test semijoin(name, dropmissing(job, :ID), on=:ID, matchmissing=:equal) ≅
            semijoin(name, job, on=:ID, matchmissing=:notequal)
        @test antijoin(name, dropmissing(job, :ID), on=:ID, matchmissing=:equal) ≅
            antijoin(name, job, on=:ID, matchmissing=:notequal)
        @test rightjoin(dropmissing(name, :ID), job, on=:ID, matchmissing=:equal) ≅
            rightjoin(name, job, on=:ID, matchmissing=:notequal)
        @test innerjoin(dropmissing(name, :ID), dropmissing(job, :ID), on=:ID, matchmissing=:equal) ≅
            innerjoin(name, job, on=:ID, matchmissing=:notequal)
    end

    rl(n) = rand(["a", "b", "c"], n)
    names2 = [
        DataFrame(ID1=[1, 1, 2],
                  ID2=["a", "b", "a"],
                  Name=["John Doe", "Jane Doe", "Joe Blogs"]),
        DataFrame(ID1=[1, 1, 2, missing],
                  ID2=["a", "b", "a", missing],
                  Name=["John Doe", "Jane Doe", "Joe Blogs", missing]),
        DataFrame(ID1=[missing, 1, 2, missing],
                  ID2=["a", "b", missing, missing],
                  Name=[missing, "Jane Doe", "Joe Blogs", missing]),
        DataFrame(ID1=[missing, 1, 2, missing],
                  ID2=["a", "b", missing, missing],
                  Name=missings(4)),
        DataFrame(ID1=[missing, 1, 2, missing],
                  ID2=missings(4),
                  Name=["John Doe", "Jane Doe", "Joe Blogs", missing]),
        DataFrame(ID1=[1:100; missings(100)],
                  ID2=[rl(100); missings(100)],
                  Name=rand(["Jane Doe", "Jane Doe"], 200)),
        DataFrame(ID1=[missings(100); 1:100],
                  ID2=[missings(100); rl(100)],
                  Name=rand(["Jane Doe", "Jane Doe"], 200)),
        DataFrame(ID1=[1:50; missings(100); 51:100],
                  ID2=[rl(50); missings(100); rl(50)],
                  Name=rand(["Jane Doe", "Jane Doe"], 200)),
        DataFrame(ID1=[1:64; missings(64); 129:200],
                  ID2=[rl(64); missings(64); rl(200 - 128)],
                  Name=rand(["Jane Doe", "Jane Doe"], 200)),
        DataFrame(ID1=[1:63; missings(65); 129:200],
                  ID2=[rl(64); missings(65); rl(200 - 129)],
                  Name=rand(["Jane Doe", "Jane Doe"], 200)),
        DataFrame(ID1=rand([1:100; missing], 10000),
                  ID2=rand(["a", "b", "c", missing], 10000),
                  Name=rand(["John Doe", "Jane Doe", "Joe Blogs", missing], 10000)),
    ]
    jobs2 = [
        DataFrame(ID1=[1, 2, 2, 4],
                  ID2=["a", "b", "b", "c"],
                  Job=["Lawyer", "Doctor", "Florist", "Farmer"]),
        DataFrame(ID1=[1, 2, 2, 4, missing],
                  ID2=["a", "b", "b", "c", missing],
                  Job=["Lawyer", "Doctor", "Florist", "Farmer", missing]),
        DataFrame(ID1=[1, 2, missing, 4, missing],
                  ID2=["a", "b", missing, "c", missing],
                  Job=[missing, "Doctor", "Florist", "Farmer", missing]),
        DataFrame(ID1=[1:100; missings(100)],
                  ID2=[rl(100); missings(100)],
                  Job=rand(["Doctor", "Florist"], 200)),
        DataFrame(ID1=[missings(100); 1:100],
                  ID2=[missings(100); rl(100)],
                  Job=rand(["Doctor", "Florist"], 200)),
        DataFrame(ID1=[1:50; missings(100); 51:100],
                  ID2=[rl(50); missings(100); rl(50)],
                  Job=rand(["Doctor", "Florist"], 200)),
        DataFrame(ID1=[1:64; missings(64); 129:200],
                  ID2=[rl(64); missings(64); rl(200 - 128)],
                  Job=rand(["Doctor", "Florist"], 200)),
        DataFrame(ID1=[1:63; missings(65); 129:200],
                  ID2=[rl(64); missings(65); rl(200 - 129)],
                  Job=rand(["Doctor", "Florist"], 200)),
        DataFrame(ID1=rand([1:100; missing], 10000),
                  ID2=rand(["a", "b", "c", missing], 10000),
                  Job=rand(["Doctor", "Florist", "Farmer", missing], 10000)),
    ]
    k = [:ID1, :ID2]
    for name in names2, job in jobs2
        @test leftjoin(name, dropmissing(job, k), on=k, matchmissing=:equal) ≅
            leftjoin(name, job, on=k, matchmissing=:notequal)
        @test leftjoin!(copy(name), dropmissing(unique(job, k), k), on=k, matchmissing=:equal) ≅
            leftjoin!(copy(name), unique(job, k), on=k, matchmissing=:notequal)
        @test semijoin(name, dropmissing(job, k), on=k, matchmissing=:equal) ≅
            semijoin(name, job, on=k, matchmissing=:notequal)
        @test antijoin(name, dropmissing(job, k), on=k, matchmissing=:equal) ≅
            antijoin(name, job, on=k, matchmissing=:notequal)
        @test rightjoin(dropmissing(name, k), job, on=k, matchmissing=:equal) ≅
            rightjoin(name, job, on=k, matchmissing=:notequal)
        @test innerjoin(dropmissing(name, k), dropmissing(job, k), on=k, matchmissing=:equal) ≅
            innerjoin(name, job, on=k, matchmissing=:notequal)
    end
end

@testset "leftjoin!" begin
    dfl = copy(name)
    @test_throws ArgumentError leftjoin!(dfl, job, on=:ID)
    @test isequal_coltyped(name, dfl)

    df1 = DataFrame(A=1, B=2, C=3)
    df2 = DataFrame(A=1, B=2, D=4)
    @test leftjoin!(df1, df2, on=[:A, :B]) === df1
    @test df1 == DataFrame(A=1, B=2, C=3, D=4)

    simple_df1(len::Int) = DataFrame(A=allowmissing(1:len))
    @test leftjoin!(simple_df1(0), simple_df1(0), on=:A) == simple_df1(0)
    @test leftjoin!(simple_df1(2), simple_df1(0), on=:A) == simple_df1(2)

    simple_df2(len::Int) = DataFrame(A=1:len)
    @test leftjoin!(simple_df2(0), simple_df2(0), on=:A) ==  simple_df2(0)
    @test leftjoin!(simple_df2(2), simple_df2(0), on=:A) ==  simple_df2(2)
    @test leftjoin!(simple_df2(0), simple_df2(2), on=:A) ==  simple_df2(0)

    df = DataFrame(Name=Union{String, Missing}["A", "B", "C"],
                   Mass=[1.5, 2.2, 1.1])
    df2 = DataFrame(Name=["A", "B", "C", "A"],
                    Quantity=[3, 3, 2, 4])
    @test leftjoin!(df2, df, on=:Name) == DataFrame(Name=["A", "B", "C", "A"],
                                                    Quantity=[3, 3, 2, 4],
                                                    Mass=[1.5, 2.2, 1.1, 1.5])

    df1 = DataFrame(Any[[1, 3, 5], [1.0, 3.0, 5.0]], [:id, :fid])
    df2 = DataFrame(Any[[0, 1, 2, 3, 4], [0.0, 1.0, 2.0, 3.0, 4.0]], [:id, :fid])
    l(on) = leftjoin!(copy(df1), df2, on=on, makeunique=true)
    on = :id
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            fid_1=[1, 3, missing])
    @test typeof.(eachcol(l(on))) ==
        [Vector{Int}, Vector{Float64}, Vector{Union{Float64, Missing}}]
    on = :fid
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            id_1=[1, 3, missing])
    @test typeof.(eachcol(l(on))) == [Vector{Int}, Vector{Float64},
                                     Vector{Union{Int, Missing}}]
    on = [:id, :fid]
    @test l(on) == DataFrame(id=[1, 3, 5], fid=[1, 3, 5])
    @test typeof.(eachcol(l(on))) == [Vector{Int}, Vector{Float64}]

    df1 = DataFrame(Any[CategoricalArray([1, 3, 5]),
                        CategoricalArray([1.0, 3.0, 5.0])], [:id, :fid])
    df2 = DataFrame(Any[CategoricalArray([0, 1, 2, 3, 4]),
                        CategoricalArray([0.0, 1.0, 2.0, 3.0, 4.0])], [:id, :fid])
    on = :id
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            fid_1=[1, 3, missing])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Union{Float64, Missing})]))
    on = :fid
    @test l(on) ≅ DataFrame(id=[1, 3, 5],
                            fid=[1, 3, 5],
                            id_1=[1, 3, missing])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64, Union{Int, Missing})]))
    on = [:id, :fid]
    @test l(on) == DataFrame(id=[1, 3, 5],
                             fid=[1, 3, 5])
    @test all(isa.(eachcol(l(on)),
                   [CategoricalVector{T} for T in (Int, Float64)]))

    A = DataFrame(a=[1, 2, 3], b=["a", "b", "c"])
    B = DataFrame(b=["a", "b", "c"], c=CategoricalVector(["a", "b", "b"]))
    levels!(B.c, ["b", "a"])
    @test levels(leftjoin!(copy(A), B, on=:b).c) == ["b", "a"]
    A = DataFrame(a=[1, 2, 3, 4], b=CategoricalVector(["a", "b", "c", "d"]))
    levels!(A.b, ["d", "c", "b", "a"])
    B = DataFrame(b=CategoricalVector(["a", "b", "c"]), c=[5, 6, 7])
    @test levels(leftjoin!(copy(A), B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(leftjoin!(copy(B), A, on=:b).b) == ["a", "b", "c"]
    A = DataFrame(a=[1, 2, 3, 4], b=CategoricalVector(["a", "b", "c", "d"]))
    levels!(A.b, ["d", "c", "b", "a"])
    B = DataFrame(b=["a", "b", "c"], c=[5, 6, 7])
    @test levels(leftjoin!(copy(A), B, on=:b).b) == ["d", "c", "b", "a"]
    @test levels(leftjoin!(copy(B), A, on=:b).b) == ["a", "b", "c"]

    left = DataFrame(id=1:7, sid=string.(1:7))
    right = DataFrame(ID=3:10, SID=string.(3:10))
    @test leftjoin!(copy(left), right, on=:id => :ID) ≅
        DataFrame(id=1:7, sid=string.(1:7),
                  SID=[missing, missing, string.(3:7)...])
    @test leftjoin!(copy(left), right, on=[:id => :ID]) ≅
        DataFrame(id=1:7, sid=string.(1:7),
                  SID=[missing, missing, string.(3:7)...])
    @test leftjoin!(copy(left), right, on=[:id => :ID, :sid => :SID]) ==
        DataFrame(id=1:7, sid=string.(1:7))
    @test_throws ArgumentError leftjoin!(left, right, on=(:id, :ID))

    ldf = DataFrame(a=Any[1:7;], b=[1:7;])
    rdf = DataFrame(a=Any[3:10;], b=[3:10;])
    @test leftjoin!(copy(ldf), rdf, on=[:a, :b]) ≅ DataFrame(a=1:7, b=1:7)
    @test eltype.(eachcol(leftjoin!(copy(ldf), rdf, on=[:a, :b]))) == [Any, Int]
    @test leftjoin!(copy(ldf), rdf, on=:b, makeunique=true) ≅
        DataFrame(a=1:7, b=1:7, a_1=[missing; missing; 3:7])
    @test eltype.(eachcol(leftjoin!(copy(ldf), rdf, on=:b, makeunique=true))) == [Any, Int, Any]

    ldf = DataFrame(a=1:3, b=categorical(["a", "b", "c"]))
    rdf = DataFrame(a=4:5, b=categorical(["d", "e"]))
    nl = size(ldf, 1)
    nr = size(rdf, 1)
    CS = eltype(ldf.b)
    @test leftjoin!(copy(ldf), rdf, on=[:a, :b]) ≅ DataFrame(a=ldf.a, b=ldf.b)
    @test eltype.(eachcol(leftjoin!(copy(ldf), rdf, on=[:a, :b]))) == [Int, CS]
    @test leftjoin!(copy(ldf), rdf, on=:a, makeunique=true) ≅
        DataFrame(a=ldf.a, b=ldf.b, b_1=similar_missing(rdf.b, nl))
    @test eltype.(eachcol(leftjoin!(copy(ldf), rdf, on=:a, makeunique=true))) ==
        [Int, CS, Union{CS, Missing}]
    @test leftjoin!(copy(ldf), rdf, on=:b, makeunique=true) ≅
        DataFrame(a=ldf.a, b=ldf.b, a_1=fill(missing, nl))
    @test eltype.(eachcol(leftjoin!(copy(ldf), rdf, on=:b, makeunique=true))) ==
        [Int, CS, Union{Int, Missing}]

    namedf = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
    jobdf = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
    @test leftjoin!(namedf, jobdf, on=:ID) ≅
        DataFrame(ID=[1, 2, 3],
                  Name=["John Doe", "Jane Doe", "Joe Blogs"],
                  Job=["Lawyer", "Doctor", missing])
    jobdf2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
    @test leftjoin!(namedf, jobdf2, on=:ID => :identifier, makeunique=true, source=:source) ≅
        DataFrame(ID=[1, 2, 3],
                  Name=["John Doe", "Jane Doe", "Joe Blogs"],
                  Job=["Lawyer", "Doctor", missing],
                  Job_1=["Lawyer", "Doctor", missing],
                  source=["both", "both", "left_only"])

    jobdf = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
    for special in [missing, NaN, -0.0]
        name_w_special = DataFrame(ID=[1, 2, 3, special],
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test_throws ArgumentError leftjoin!(name_w_special, jobdf, on=:ID)
    end
    for special in [missing, 0.0]
        name_w_special = DataFrame(ID=[1, 2, 3, special],
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test leftjoin!(copy(name_w_special), jobdf, on=:ID, matchmissing=:equal) ≅
              hcat(name_w_special, DataFrame(Job=["Lawyer", "Doctor", missing, missing]))
        jobdf2 = DataFrame(ID=[1, 2, special], Job=["Lawyer", "Doctor", "Farmer"])
        @test leftjoin!(copy(name_w_special), jobdf2, on=:ID, matchmissing=:equal) ≅
              hcat(name_w_special, DataFrame(Job=["Lawyer", "Doctor", missing, "Farmer"]))
    end
    for special in [NaN, -0.0]
        name_w_special = DataFrame(ID=categorical([1, 2, 3, special]),
                                   Name=["John Doe", "Jane Doe", "Joe Blogs", "Maria Tester"])
        @test leftjoin!(copy(name_w_special),
                        transform(jobdf, :ID => categorical => :ID), on=:ID) ≅
              hcat(name_w_special, DataFrame(Job=["Lawyer", "Doctor", missing, missing]))
    end

    name_w_zeros = DataFrame(ID=categorical([1, 2, 3, 0.0, -0.0]),
                             Name=["John Doe", "Jane Doe",
                                   "Joe Blogs", "Maria Tester",
                                   "Jill Jillerson"])
    name_w_zeros2 = DataFrame(ID=categorical([1, 2, 3, 0.0, -0.0]),
                              Name=["John Doe", "Jane Doe",
                                    "Joe Blogs", "Maria Tester",
                                    "Jill Jillerson"],
                              Name_1=["John Doe", "Jane Doe",
                                      "Joe Blogs", "Maria Tester",
                                      "Jill Jillerson"])
    @test leftjoin!(copy(name_w_zeros), name_w_zeros, on=:ID,
                    makeunique=true) ≅ name_w_zeros2

    name_multi = DataFrame(ID1=[1, 1, 2],
                           ID2=["a", "b", "a"],
                           Name=["John Doe", "Jane Doe", "Joe Blogs"])
    job_multi = DataFrame(ID1=[1, 2, 2, 4],
                          ID2=["a", "b", "b", "c"],
                          Job=["Lawyer", "Doctor", "Florist", "Farmer"])
    # job_multi has non-offending duplicates
    @test leftjoin!(copy(name_multi), job_multi, on=[:ID1, :ID2]) ≅
          hcat(name_multi, DataFrame(Job=["Lawyer", missing, missing]))
    @test leftjoin!(copy(job_multi), name_multi, on=[:ID1, :ID2]) ≅
          hcat(job_multi, DataFrame(Name=["John Doe", missing, missing, missing]))

    namedf = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
    jobdf = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
    cname = copy(namedf)
    cjob = copy(jobdf)
    push!(cname[!, 1], cname[1, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)
    cname = copy(namedf)
    push!(cjob[!, 1], cjob[1, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)
    cjob = copy(jobdf)
    push!(DataFrames._columns(cname), cname[:, 1])
    @test_throws AssertionError innerjoin(cname, cjob, on=:ID)

    df1 = DataFrame(id=[1, 2, 3], id2=[11, 12, 13], x=[1, 2, 3])
    df2 = DataFrame(id=[1, 2, 4], ID2=[11, 12, 14], y=[1, 2, 4])
    @test leftjoin!(copy(df1), df2, on=[:id, :id2=>:ID2]) ≅
          hcat(df1, DataFrame(y=[1, 2, missing]))
    @test leftjoin!(copy(df1), df2, on=[:id2=>:ID2, :id]) ≅
          hcat(df1, DataFrame(y=[1, 2, missing]))
    @test leftjoin!(copy(df1), df2, on=[:id=>:id, :id2=>:ID2]) ≅
          hcat(df1, DataFrame(y=[1, 2, missing]))
    @test leftjoin!(copy(df1), df2, on=[:id2=>:ID2, :id=>:id]) ≅
          hcat(df1, DataFrame(y=[1, 2, missing]))

    df = DataFrame(a=1)
    @test_throws ArgumentError leftjoin!(copy(df), df, on=:a, source=:a)
    @test leftjoin!(copy(df), df, on=:a, source=:a, makeunique=true) == DataFrame(a=1, a_1="both")
    @test leftjoin!(copy(df), df, on=:a, source="_left") == DataFrame(a=1, _left="both")
    @test leftjoin!(copy(df), df, on=:a, source="_right") == DataFrame(a=1, _right="both")
    df = DataFrame(_left=1)
    @test leftjoin!(copy(df), df, on=:_left, source="_leftX") == DataFrame(_left=1, _leftX="both")
    df = DataFrame(_right=1)
    @test leftjoin!(copy(df), df, on=:_right, source="_rightX") == DataFrame(_right=1, _rightX="both")

    Random.seed!(1234)
    for i in 5:15, j in 5:15
        df1 = DataFrame(id=rand(1:10, i), x=1:i)
        df2 = unique(DataFrame(id=rand(1:10, j), y=1:j), :id)
        @test leftjoin!(copy(df1), df2, on=:id, source=:ind) ≅
              sort!(leftjoin(df1, df2, on=:id, source=:ind), :x)
    end

    @test isequal_coltyped(leftjoin!(DataFrame(id=[]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=[]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[1, 2, 3]), DataFrame(id=[]), on=:id),
                           DataFrame(id=[1, 2, 3]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[4, 5, 6]), DataFrame(id=[1, 2, 3]), on=:id),
                           DataFrame(id=Int[4, 5, 6]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[1, 2, 3]), DataFrame(id=[4, 5, 6]), on=:id),
                           DataFrame(id=Int[1, 2, 3]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[missing]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=Missing[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Missing[]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[1]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=Union{Int, Missing}[]), DataFrame(id=[2, 1, 2]), on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1]),
                                    on=:id, matchmissing=:equal) ,
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[missing]), DataFrame(id=[1, missing]),
                                    on=:id, matchmissing=:equal),
                           DataFrame(id=[missing]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=Union{Int, Missing}[missing]), DataFrame(id=[1, missing]),
                                    on=:id, matchmissing=:equal),
                           DataFrame(id=Union{Int, Missing}[missing]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[typemin(Int) + 1, typemin(Int)]), DataFrame(id=[typemin(Int)]), on=:id),
                           DataFrame(id=[typemin(Int) + 1, typemin(Int)]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[typemax(Int), typemax(Int) - 1]), DataFrame(id=[typemax(Int)]), on=:id),
                           DataFrame(id=[typemax(Int), typemax(Int) - 1]))
    @test isequal_coltyped(leftjoin!(DataFrame(id=[2000, 2, 100]), DataFrame(id=[2000, 1, 100]), on=:id),
                           DataFrame(id=[2000, 2, 100]))

    @test_throws ArgumentError leftjoin!(DataFrame(), DataFrame())
    @test_throws ArgumentError leftjoin!(DataFrame(), DataFrame(), on=Symbol[])
    @test_throws ArgumentError leftjoin!(DataFrame(a=1, b=2), DataFrame(a=1, b=2), on=:a)

    @test_throws ArgumentError leftjoin!(view(DataFrame(a=1, b=2), :, 1:2), DataFrame(a=1, c=2), on=:a)

    df1 = DataFrame(id=1:5, x=1:5)
    df2 = DataFrame(id=1:5, y=1:5)
    df1v = view(df1, [3, 2], :)
    @test leftjoin!(df1v, df2, on=:id) == DataFrame(id=[3, 2], x=[3, 2], y=[3, 2])
    @test df1 ≅ DataFrame(id=1:5, x=1:5, y=[missing, 2, 3, missing, missing])

    df1 = DataFrame(id=1, x=1:5)
    df2 = DataFrame(id=1:5, y=1:5)
    df1v = view(df1, [3, 2], :)
    @test leftjoin!(df1v, df2, on=:id) == DataFrame(id=[1, 1], x=[3, 2], y=[1, 1])
    @test df1 ≅ DataFrame(id=1, x=1:5, y=[missing, 1, 1, missing, missing])

    df1 = DataFrame(id=1:5, x=1:5)
    df2 = DataFrame(id=1:5, y=1:5)
    df1v = view(df1, 1:0, :)
    @test leftjoin!(df1v, df2, on=:id) == DataFrame(id=[], x=[], y=[])
    @test df1 ≅ DataFrame(id=1:5, x=1:5, y=[missing, missing, missing, missing, missing])
    @test df1.y isa Vector{Union{Int, Missing}}
end

@testset "passing matchmissing in multi-data frame innerjoin and outerjoin" begin
    @test innerjoin(DataFrame(a=missing, b=1),
                    DataFrame(a=missing, c=2),
                    DataFrame(a=missing, d=3),
                    on=:a, matchmissing=:equal) ≅ DataFrame(a=missing, b=1, c=2, d=3)
    @test isempty(innerjoin(DataFrame(a=missing, b=1),
                  DataFrame(a=missing, c=2),
                  DataFrame(a=missing, d=3),
                  on=:a, matchmissing=:notequal))
    @test outerjoin(DataFrame(a=missing, b=1),
                    DataFrame(a=missing, c=2),
                    DataFrame(a=missing, d=3),
                    on=:a, matchmissing=:equal) ≅ DataFrame(a=missing, b=1, c=2, d=3)
end

@testset "_count_sortperm" begin
    Random.seed!(1234)
    for i in 0:20, rep in 1:100
        x = rand(min(i, 1):i, i)
        @test sortperm(x) == DataFrames._count_sortperm(x)
        @test issorted(x[DataFrames._count_sortperm(x)])
    end
    for i in 0:20, rep in 1:100
        x = randperm(i)
        @test sortperm(x) == DataFrames._count_sortperm(x)
        @test issorted(x[DataFrames._count_sortperm(x)])
        x = randperm(i) .+ i
        @test sortperm(x) == DataFrames._count_sortperm(x)
        @test issorted(x[DataFrames._count_sortperm(x)])
    end
    for i in 1:20
        @test DataFrames._count_sortperm(ones(Int, i)) == 1:i
        @test DataFrames._count_sortperm(zeros(Int, i)) == 1:i
        @test DataFrames._count_sortperm([fill(1, i); fill(2, i)]) == 1:2*i
        @test DataFrames._count_sortperm([fill(2, i); fill(1, i)]) == [i+1:2i; 1:i]
    end
end

@testset "basic join tests with order" begin
    for fun in (innerjoin, leftjoin, rightjoin, outerjoin)
        df1 = DataFrame(x=[0, 3, 1, 2, 4], id1=1:5)
        df2 = DataFrame(x=[2, 5, 1, 3, 7, 6], id2=1:6)
        ref = fun(df1, df2, on=:x)
        res = fun(df1, df2, on=:x, order=:left)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
        df1.x = string.(df1.x)
        df2.x = string.(df2.x)
        ref = fun(df1, df2, on=:x)
        res = fun(df1, df2, on=:x, order=:left)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
    end

    for fun in (innerjoin, leftjoin, rightjoin, outerjoin)
        df1 = DataFrame(x=[0, 1, 2, 3, 4], id1=1:5)
        df2 = DataFrame(x=[1, 2, 3, 5, 6, 7], id2=1:6)
        ref = fun(df1, df2, on=:x)
        res = fun(df1, df2, on=:x, order=:left)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
        df1.x = string.(df1.x)
        df2.x = string.(df2.x)
        ref = fun(df1, df2, on=:x)
        res = fun(df1, df2, on=:x, order=:left)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
    end

    for fun in (leftjoin, rightjoin, outerjoin)
        df1 = DataFrame(x=[0, 3, 1, 2, 4], id1=1:5)
        df2 = DataFrame(x=[2, 5, 1, 3, 7, 6], id2=1:6)
        ref = fun(df1, df2, on=:x, source=:src)
        res = fun(df1, df2, on=:x, order=:left, source=:src)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right, source=:src)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
        df1.x = string.(df1.x)
        df2.x = string.(df2.x)
        ref = fun(df1, df2, on=:x, source=:src)
        res = fun(df1, df2, on=:x, order=:left, source=:src)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right, source=:src)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
    end

    for fun in (leftjoin, rightjoin, outerjoin)
        df1 = DataFrame(x=[0, 1, 2, 3, 4], id1=1:5)
        df2 = DataFrame(x=[1, 2, 3, 5, 6, 7], id2=1:6)
        ref = fun(df1, df2, on=:x, source=:src)
        res = fun(df1, df2, on=:x, order=:left, source=:src)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right, source=:src)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
        df1.x = string.(df1.x)
        df2.x = string.(df2.x)
        ref = fun(df1, df2, on=:x, source=:src)
        res = fun(df1, df2, on=:x, order=:left, source=:src)
        @test issorted(res.id1)
        @test sort(ref, :id1) ≅ res
        res = fun(df1, df2, on=:x, order=:right, source=:src)
        @test issorted(res.id2)
        @test sort(ref, :id2) ≅ res
    end

    df1 = DataFrame(x=[0, 3, 1, 2, 4], id1=1:5)
    df2 = DataFrame(x=[2, 5, 1, 3, 7, 6], id2=1:6)
    @test issorted(semijoin(df1, df2, on=:x).id1)
    @test issorted(semijoin(df2, df1, on=:x).id2)
    @test issorted(antijoin(df1, df2, on=:x).id1)
    @test issorted(antijoin(df2, df1, on=:x).id2)
    df1.x = string.(df1.x)
    df2.x = string.(df2.x)
    @test issorted(semijoin(df1, df2, on=:x).id1)
    @test issorted(semijoin(df2, df1, on=:x).id2)
    @test issorted(antijoin(df1, df2, on=:x).id1)
    @test issorted(antijoin(df2, df1, on=:x).id2)
    df1 = DataFrame(x=[0, 1, 2, 3, 4], id1=1:5)
    df2 = DataFrame(x=[1, 2, 3, 5, 6, 7], id2=1:6)
    @test issorted(semijoin(df1, df2, on=:x).id1)
    @test issorted(semijoin(df2, df1, on=:x).id2)
    @test issorted(antijoin(df1, df2, on=:x).id1)
    @test issorted(antijoin(df2, df1, on=:x).id2)
    df1.x = string.(df1.x)
    df2.x = string.(df2.x)
    @test issorted(semijoin(df1, df2, on=:x).id1)
    @test issorted(semijoin(df2, df1, on=:x).id2)
    @test issorted(antijoin(df1, df2, on=:x).id1)
    @test issorted(antijoin(df2, df1, on=:x).id2)

    @test_throws ArgumentError innerjoin(df1, df2, on=:x, order=:x)
    @test_throws ArgumentError leftjoin(df1, df2, on=:x, order=:x)
    @test_throws ArgumentError rightjoin(df1, df2, on=:x, order=:x)
    @test_throws ArgumentError outerjoin(df1, df2, on=:x, order=:x)
end

@testset "randomized join tests with sort" begin
    Random.seed!(1234)
    for lenl in 0:20, lenr in 0:20, rep in 1:10
        df1 = DataFrame(x=rand(0:lenl, lenl), id1=1:lenl)
        df2 = DataFrame(x=rand(0:lenr, lenr), id2=1:lenr)
        ref = innerjoin(df1, df2, on=:x)
        res = innerjoin(df1, df2, on=:x, order=:left)
        @test issorted(res, [:id1, :id2])
        @test sort(ref, :id1) ≅ res
        res = innerjoin(df1, df2, on=:x, order=:right)
        @test issorted(res, [:id2, :id1])
        @test sort(ref, :id2) ≅ res
        for fun in (leftjoin, rightjoin, outerjoin)
            ref = fun(df1, df2, on=:x, source=:src)
            res = fun(df1, df2, on=:x, order=:left, source=:src)
            @test issorted(res, [:id1, :id2])
            @test sort(ref, :id1) ≅ res
            res = fun(df1, df2, on=:x, order=:right, source=:src)
            @test issorted(res, [:id2, :id1])
            @test sort(ref, :id2) ≅ res
        end
        df1.x = string.(df1.x)
        df2.x = string.(df2.x)
        ref = innerjoin(df1, df2, on=:x)
        res = innerjoin(df1, df2, on=:x, order=:left)
        @test issorted(res, [:id1, :id2])
        @test sort(ref, :id1) ≅ res
        res = innerjoin(df1, df2, on=:x, order=:right)
        @test issorted(res, [:id2, :id1])
        @test sort(ref, :id2) ≅ res
        for fun in (leftjoin, rightjoin, outerjoin)
            ref = fun(df1, df2, on=:x, source=:src)
            res = fun(df1, df2, on=:x, order=:left, source=:src)
            @test issorted(res, [:id1, :id2])
            @test sort(ref, :id1) ≅ res
            res = fun(df1, df2, on=:x, order=:right, source=:src)
            @test issorted(res, [:id2, :id1])
            @test sort(ref, :id2) ≅ res
        end
    end
end

@testset "wide joins" begin
    Random.seed!(1234)
    # we need many repetitions to make sure we cover all cases
    for _ in 1:1000, k in 2:4
        dfs = [(n=rand(10:20);
                DataFrame("id" => randperm(n), "x$i" => 1:n)) for i in 1:4]
        @test issorted(innerjoin(dfs..., on="id", order=:left)[:, 2])
        @test issorted(outerjoin(dfs..., on="id", order=:left)[:, 2])
        @test issorted(innerjoin(dfs..., on="id", order=:right)[:, end])
        @test issorted(outerjoin(dfs..., on="id", order=:right)[:, end])
    end

    dfs = [DataFrame("id" => 0, "x$i" => i) for i in 1:10000]
    res = innerjoin(dfs..., on="id")
    @test res == DataFrame(["id" => 0; ["x$i" => i for i in 1:10000]])
    res = outerjoin(dfs..., on="id")
    @test res == DataFrame(["id" => 0; ["x$i" => i for i in 1:10000]])
end

end # module

"""
    DataFrame <: AbstractDataFrame

An `AbstractDataFrame` that stores a set of named columns.

The columns are normally `AbstractVector`s stored in memory,
particularly a `Vector`, `PooledVector` or `CategoricalVector`.

# Constructors
```julia
DataFrame(pairs::Pair...; makeunique::Bool=false, copycols::Bool=true)
DataFrame(pairs::AbstractVector{<:Pair}; makeunique::Bool=false, copycols::Bool=true)
DataFrame(ds::AbstractDict; copycols::Bool=true)
DataFrame(; kwargs..., copycols::Bool=true)

DataFrame(table; copycols::Union{Bool, Nothing}=nothing)
DataFrame(table, names::AbstractVector;
          makeunique::Bool=false, copycols::Union{Bool, Nothing}=nothing)
DataFrame(columns::AbstractVecOrMat, names::AbstractVector;
          makeunique::Bool=false, copycols::Bool=true)

DataFrame(::DataFrameRow; copycols::Bool=true)
DataFrame(::GroupedDataFrame; copycols::Bool=true, keepkeys::Bool=true)
```

# Keyword arguments

- `copycols` : whether vectors passed as columns should be copied; by default set
  to `true` and the vectors are copied; if set to `false` then the constructor
  will still copy the passed columns if it is not possible to construct a
  `DataFrame` without materializing new columns. Note the `copycols=nothing`
  default in the Tables.jl compatible constructor; it is provided as certain
  input table types may have already made a copy of columns or the columns may
  otherwise be immutable, in which case columns are not copied by default.
  To force a copy in such cases, or to get mutable columns from an immutable
  input table (like `Arrow.Table`), pass `copycols=true` explicitly.
- `makeunique` : if `false` (the default), an error will be raised

(note that not all constructors support these keyword arguments)

# Details on behavior of different constructors

It is allowed to pass a vector of `Pair`s, a list of `Pair`s as positional
arguments, or a list of keyword arguments. In this case each pair is considered
to represent a column name to column value mapping and column name must be a
`Symbol` or string. Alternatively a dictionary can be passed to the constructor
in which case its entries are considered to define the column name and column
value pairs. If the dictionary is a `Dict` then column names will be sorted in
the returned `DataFrame`.

In all the constructors described above column value can be a vector which is
consumed as is or an object of any other type (except `AbstractArray`). In the
latter case the passed value is automatically repeated to fill a new vector of
the appropriate length. As a particular rule values stored in a `Ref` or a
`0`-dimensional `AbstractArray` are unwrapped and treated in the same way.

It is also allowed to pass a vector of vectors or a matrix as as the first
argument. In this case the second argument must be
a vector of `Symbol`s or strings specifying column names, or the symbol `:auto`
to generate column names `x1`, `x2`, ... automatically. Note that in this case
if the first argument is a matrix and `copycols=false` the columns of the created
`DataFrame` will be views of columns the source matrix.

If a single positional argument is passed to a `DataFrame` constructor then it
is assumed to be of type that implements the
[Tables.jl](https://github.com/JuliaData/Tables.jl) interface using which the
returned `DataFrame` is materialized.

If two positional arguments are passed, where the second argument is an
`AbstractVector`, then the first argument is taken to be a table as described in
the previous paragraph, and columns names of the resulting data frame
are taken from the vector passed as the second positional argument.

Finally it is allowed to construct a `DataFrame` from a `DataFrameRow` or a
`GroupedDataFrame`. In the latter case the `keepkeys` keyword argument specifies
whether the resulting `DataFrame` should contain the grouping columns of the
passed `GroupedDataFrame` and the order of rows in the result follows the order
of groups in the `GroupedDataFrame` passed.

# Notes

The `DataFrame` constructor by default copies all columns vectors passed to it.
Pass the `copycols=false` keyword argument (where supported) to reuse vectors without
copying them.

By default an error will be raised if duplicates in column names are found. Pass
`makeunique=true` keyword argument (where supported) to accept duplicate names,
in which case they will be suffixed with `_i` (`i` starting at 1 for the first
duplicate).

If an `AbstractRange` is passed to a `DataFrame` constructor as a column it is
always collected to a `Vector` (even if `copycols=false`). As a general rule
`AbstractRange` values are always materialized to a `Vector` by all functions in
DataFrames.jl before being stored in a `DataFrame`.

`DataFrame` can store only columns that use 1-based indexing. Attempting
to store a vector using non-standard indexing raises an error.

The `DataFrame` type is designed to allow column types to vary and to be
dynamically changed also after it is constructed. Therefore `DataFrame`s are not
type stable. For performance-critical code that requires type-stability either
use the functionality provided by `select`/`transform`/`combine` functions, use
`Tables.columntable` and `Tables.namedtupleiterator` functions, use barrier
functions, or provide type assertions to the variables that hold columns
extracted from a `DataFrame`.

Metadata: this function preserves all table and column-level metadata.
As a special case if a `GroupedDataFrame` is passed then
only `:note`-style metadata from parent of the `GroupedDataFrame` is preserved.

# Examples
```jldoctest
julia> DataFrame((a=[1, 2], b=[3, 4])) # Tables.jl table constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> DataFrame([(a=1, b=0), (a=2, b=0)]) # Tables.jl table constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame("a" => 1:2, "b" => 0) # Pair constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([:a => 1:2, :b => 0]) # vector of Pairs constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame(Dict(:a => 1:2, :b => 0)) # dictionary constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame(a=1:2, b=0) # keyword argument constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([[1, 2], [0, 0]], [:a, :b]) # vector of vectors constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([1 0; 2 0], :auto) # matrix constructor
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0
```
"""
mutable struct DataFrame <: AbstractDataFrame
    columns::Vector{AbstractVector}
    colindex::Index
    metadata::Union{Nothing, Dict{String, Tuple{Any, Any}}}
    colmetadata::Union{Nothing, Dict{Int, Dict{String, Tuple{Any, Any}}}}
    # This is a helper field for optimizing performance of
    # _drop_all_nonnote_metadata! and _drop_table_nonnote_metadata!
    # so that if we only have :note-style metadata these functions are no-op.
    # The contract is that if allnotemetadata=true then it is guaranteed that
    # there are only :note-style metadata entries in the data frame.
    # metadata! and colmetadata! functions appropriately set this field if a
    # non-:note-style metadata is added.
    allnotemetadata::Bool

    # the inner constructor should not be used directly
    function DataFrame(columns::Union{Vector{Any}, Vector{AbstractVector}},
                       colindex::Index; copycols::Bool=true)
        if length(columns) == length(colindex) == 0
            return new(AbstractVector[], Index(), nothing, nothing, true)
        elseif length(columns) != length(colindex)
            throw(DimensionMismatch("Number of columns ($(length(columns))) and number of " *
                                    "column names ($(length(colindex))) are not equal"))
        end

        len = -1
        firstvec = -1
        for (i, col) in enumerate(columns)
            if col isa AbstractVector
                if len == -1
                    len = length(col)
                    firstvec = i
                elseif len != length(col)
                    n1 = _names(colindex)[firstvec]
                    n2 = _names(colindex)[i]
                    throw(DimensionMismatch("column :$n1 has length $len and column " *
                                            ":$n2 has length $(length(col))"))
                end
            end
        end
        len == -1 && (len = 1) # we got no vectors so make one row of scalars

        len_local = len

        # we write into columns as we know that it is guaranteed
        # that it was freshly allocated in the outer constructor
        if copycols && len_local >= 100_000 && length(columns) > 1 && Threads.nthreads() > 1
            @sync for i in eachindex(columns)
                @spawn columns[i] = _preprocess_column(columns[i], len_local, copycols)
            end
        else
            for i in eachindex(columns)
                columns[i] = _preprocess_column(columns[i], len_local, copycols)
            end
        end

        for (i, col) in enumerate(columns)
            firstindex(col) != 1 && _onebased_check_error(i, col)
        end

        return new(convert(Vector{AbstractVector}, columns), colindex, nothing, nothing, true)
    end
end

function _preprocess_column(col::Any, len::Integer, copycols::Bool)
    if col isa AbstractRange
        return collect(col)
    elseif col isa AbstractVector
        return copycols ? copy(col) : col
    elseif col isa Union{AbstractArray{<:Any, 0}, Ref}
        x = col[]
        return fill!(Tables.allocatecolumn(typeof(x), len), x)
    elseif col isa AbstractArray
        throw(ArgumentError("adding AbstractArray other than AbstractVector " *
                            "as a column of a data frame is not allowed"))
    else
        return fill!(Tables.allocatecolumn(typeof(col), len), col)
    end
end

DataFrame(df::DataFrame; copycols::Bool=true) = copy(df, copycols=copycols)

function DataFrame(pairs::Pair{Symbol, <:Any}...; makeunique::Bool=false,
                   copycols::Bool=true)::DataFrame
    colnames = [Symbol(k) for (k, v) in pairs]
    columns = Any[v for (k, v) in pairs]
    return DataFrame(columns, Index(colnames, makeunique=makeunique),
                     copycols=copycols)
end

function DataFrame(pairs::Pair{<:AbstractString, <:Any}...; makeunique::Bool=false,
                   copycols::Bool=true)::DataFrame
    colnames = [Symbol(k) for (k, v) in pairs]
    columns = Any[v for (k, v) in pairs]
    return DataFrame(columns, Index(colnames, makeunique=makeunique),
                     copycols=copycols)
end

# this is needed as a workaround for Tables.jl dispatch
function DataFrame(pairs::AbstractVector{<:Pair}; makeunique::Bool=false,
                   copycols::Bool=true)
    if isempty(pairs)
        return DataFrame()
    else
        if !(all(((k, v),) -> k isa Symbol, pairs) || all(((k, v),) -> k isa AbstractString, pairs))
            throw(ArgumentError("All column names must be either Symbols or strings (mixing is not allowed)"))
        end
        colnames = [Symbol(k) for (k, v) in pairs]
        columns = Any[v for (k, v) in pairs]
        return DataFrame(columns, Index(colnames, makeunique=makeunique),
                         copycols=copycols)
    end
end

function DataFrame(d::AbstractDict; copycols::Bool=true)
    if all(k -> k isa Symbol, keys(d))
        colnames = collect(Symbol, keys(d))
    elseif all(k -> k isa AbstractString, keys(d))
        colnames = [Symbol(k) for k in keys(d)]
    else
        throw(ArgumentError("All column names must be either Symbols or strings (mixing is not allowed)"))
    end

    colindex = Index(colnames)
    columns = Any[v for v in values(d)]
    df = DataFrame(columns, colindex, copycols=copycols)
    if d isa Dict
        select!(df, sort!(propertynames(df)))
    else
        # AbstractDict can potentially implement Tables.jl table interface
        _copy_all_all_metadata!(df, d)
    end
    return df
end

function DataFrame(; kwargs...)
    if isempty(kwargs)
        DataFrame([], Index())
    else
        cnames = Symbol[]
        columns = Any[]
        copycols = true
        for (kw, val) in kwargs
            if kw === :copycols
                if val isa Bool
                    copycols = val
                else
                    throw(ArgumentError("the `copycols` keyword argument must be Boolean"))
                end
            elseif kw === :makeunique
                    throw(ArgumentError("the `makeunique` keyword argument is not allowed " *
                                        "in DataFrame(; kwargs...) constructor"))
            else
                push!(cnames, kw)
                push!(columns, val)
            end
        end
        DataFrame(columns, Index(cnames), copycols=copycols)
    end
end

function DataFrame(columns::AbstractVector, cnames::AbstractVector{Symbol};
                   makeunique::Bool=false, copycols::Bool=true)::DataFrame
    if !(eltype(columns) <: AbstractVector) && !all(col -> isa(col, AbstractVector), columns)
        return rename!(DataFrame(columns, copycols=copycols), cnames, makeunique=makeunique)
    end
    return DataFrame(collect(AbstractVector, columns),
                     Index(convert(Vector{Symbol}, cnames), makeunique=makeunique),
                     copycols=copycols)
end

function _name2symbol(str::AbstractVector)
    if !(all(x -> x isa AbstractString, str) || all(x -> x isa Symbol, str))
        throw(ArgumentError("All passed column names must be strings or Symbols"))
    end
    return Symbol[Symbol(s) for s in str]
end

DataFrame(columns::AbstractVector, cnames::AbstractVector;
          makeunique::Bool=false, copycols::Bool=true) =
    DataFrame(columns, _name2symbol(cnames), makeunique=makeunique, copycols=copycols)

DataFrame(columns::AbstractVector{<:AbstractVector}, cnames::AbstractVector{Symbol};
          makeunique::Bool=false, copycols::Bool=true)::DataFrame =
    DataFrame(collect(AbstractVector, columns),
              Index(convert(Vector{Symbol}, cnames), makeunique=makeunique),
              copycols=copycols)

DataFrame(columns::AbstractVector{<:AbstractVector}, cnames::AbstractVector;
          makeunique::Bool=false, copycols::Bool=true) =
    DataFrame(columns, _name2symbol(cnames); makeunique=makeunique, copycols=copycols)

function DataFrame(columns::AbstractVector, cnames::Symbol; copycols::Bool=true)
    if cnames !== :auto
        throw(ArgumentError("if the first positional argument to DataFrame " *
                            "constructor is a vector of vectors and the second " *
                            "positional argument is passed then the second " *
                            "argument must be a vector of column names or :auto"))
    end
    return DataFrame(columns, gennames(length(columns)), copycols=copycols)
end

function DataFrame(columns::AbstractMatrix, cnames::AbstractVector{Symbol};
                   makeunique::Bool=false, copycols::Bool=true)
    getter = copycols ? getindex : view
    return DataFrame(AbstractVector[getter(columns, :, i) for i in 1:size(columns, 2)],
                     cnames, makeunique=makeunique, copycols=false)
end

DataFrame(columns::AbstractMatrix, cnames::AbstractVector;
          makeunique::Bool=false, copycols::Bool=true) =
    DataFrame(columns, _name2symbol(cnames); makeunique=makeunique, copycols=copycols)

function DataFrame(columns::AbstractMatrix, cnames::Symbol; copycols::Bool=true)
    if cnames !== :auto
        throw(ArgumentError("if the first positional argument to DataFrame " *
                            "constructor is a matrix and a second " *
                            "positional argument is passed then the second " *
                            "argument must be a vector of column names or :auto"))
    end
    return DataFrame(columns, gennames(size(columns, 2)), makeunique=false, copycols=copycols)
end

# Discontinued constructors

DataFrame(matrix::Matrix) =
    throw(ArgumentError("`DataFrame` constructor from a `Matrix` requires " *
                        "passing :auto as a second argument to automatically " *
                        "generate column names: `DataFrame(matrix, :auto)`"))

DataFrame(vecs::Vector{<:AbstractVector}) =
    throw(ArgumentError("`DataFrame` constructor from a `Vector` of vectors requires " *
                        "passing :auto as a second argument to automatically " *
                        "generate column names: `DataFrame(vecs, :auto)`"))

DataFrame(column_eltypes::AbstractVector{<:Type}, cnames::AbstractVector{Symbol},
          nrows::Integer=0; makeunique::Bool=false) =
    throw(ArgumentError("`DataFrame` constructor with passed eltypes is " *
                        "not supported. Pass explicitly created columns to a " *
                        "`DataFrame` constructor instead."))

DataFrame(column_eltypes::AbstractVector{<:Type}, cnames::AbstractVector{<:AbstractString},
          nrows::Integer=0; makeunique::Bool=false) =
    throw(ArgumentError("`DataFrame` constructor with passed eltypes is " *
                        "not supported. Pass explicitly created columns to a " *
                        "`DataFrame` constructor instead."))

##############################################################################
##
## AbstractDataFrame interface
##
##############################################################################

index(df::DataFrame) = getfield(df, :colindex)

# this function grants the access to the internal storage of columns of the
# `DataFrame` and its use is unsafe. If the returned vector is mutated then
# make sure that:
# 1. `AbstractRange` columns are not added to a `DataFrame`
# 2. all inserted columns use 1-based indexing
# 3. after several mutating operations on the vector are performed
#    each element (column) has the same length
# 4. if length of the vector is changed that the index of the `DataFrame`
#    is adjusted appropriately
_columns(df::DataFrame) = getfield(df, :columns)

_onebased_check_error() =
    throw(ArgumentError("Currently DataFrames.jl supports only columns " *
                        "that use 1-based indexing"))
_onebased_check_error(i, col) =
    throw(ArgumentError("Currently DataFrames.jl supports only " *
                        "columns that use 1-based indexing, but " *
                        "column $i has starting index equal to $(firstindex(col))"))

"""
    nrow(df::AbstractDataFrame)

Return the number of rows in an `AbstractDataFrame` `df`.

See also: [`ncol`](@ref), [`size`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:10, x=rand(10), y=rand(["a", "b", "c"], 10));

julia> nrow(df)
10
```
""" # note: these type assertions are required to pass tests
nrow(df::DataFrame) = ncol(df) > 0 ? length(_columns(df)[1])::Int : 0

##############################################################################
##
## DataFrame consistency check
##
##############################################################################

corrupt_msg(df::DataFrame, i::Integer) =
    "Data frame is corrupt: length of column " *
    ":$(_names(df)[i]) ($(length(df[!, i]))) " *
    "does not match length of column 1 ($(length(df[!, 1]))). " *
    "The column vector has likely been resized unintentionally " *
    "(either directly or because it is shared with another data frame)."

function _check_consistency(df::DataFrame)
    cols, idx = _columns(df), index(df)

    for (i, col) in enumerate(cols)
        firstindex(col) != 1 && _onebased_check_error(i, col)
    end

    ncols = length(cols)
    @assert length(idx.names) == length(idx.lookup) == ncols
    ncols == 0 && return nothing
    nrows = length(cols[1])
    for i in 2:length(cols)
        @assert length(cols[i]) == nrows corrupt_msg(df, i)
    end
    nothing
end

_check_consistency(df::AbstractDataFrame) = _check_consistency(parent(df))

##############################################################################
##
## getindex() definitions
##
##############################################################################

# df[SingleRowIndex, SingleColumnIndex] => Scalar
@inline function Base.getindex(df::DataFrame, row_ind::Integer,
                               col_ind::Union{Signed, Unsigned})
    cols = _columns(df)
    @boundscheck begin
        if !checkindex(Bool, axes(cols, 1), col_ind)
            throw(BoundsError(df, (row_ind, col_ind)))
        end
        if !checkindex(Bool, axes(df, 1), row_ind)
            throw(BoundsError(df, (row_ind, col_ind)))
        end
    end
    return @inbounds cols[col_ind][row_ind]
end

@inline function Base.getindex(df::DataFrame, row_ind::Integer,
                               col_ind::SymbolOrString)
    selected_column = index(df)[col_ind]
    @boundscheck if !checkindex(Bool, axes(df, 1), row_ind)
        throw(BoundsError(df, (row_ind, col_ind)))
    end
    return @inbounds _columns(df)[selected_column][row_ind]
end

# df[MultiRowIndex, SingleColumnIndex] => AbstractVector, copy
@inline function Base.getindex(df::DataFrame, row_inds::AbstractVector, col_ind::ColumnIndex)
    selected_column = index(df)[col_ind]
    @boundscheck if !checkindex(Bool, axes(df, 1), row_inds)
        throw(BoundsError(df, (row_inds, col_ind)))
    end
    return @inbounds _columns(df)[selected_column][row_inds]
end

@inline Base.getindex(df::DataFrame, row_inds::Not, col_ind::ColumnIndex) =
    df[axes(df, 1)[row_inds], col_ind]

# df[:, SingleColumnIndex] => AbstractVector
function Base.getindex(df::DataFrame, ::Colon, col_ind::ColumnIndex)
    selected_column = index(df)[col_ind]
    return copy(_columns(df)[selected_column])
end

# df[!, SingleColumnIndex] => AbstractVector, the same vector
@inline function Base.getindex(df::DataFrame, ::typeof(!), col_ind::Union{Signed, Unsigned})
    cols = _columns(df)
    @boundscheck if !checkindex(Bool, axes(cols, 1), col_ind)
        throw(BoundsError(df, (!, col_ind)))
    end
    return @inbounds cols[col_ind]
end

function Base.getindex(df::DataFrame, ::typeof(!), col_ind::SymbolOrString)
    selected_column = index(df)[col_ind]
    return _columns(df)[selected_column]
end

# df[MultiRowIndex, MultiColumnIndex] => DataFrame

function _threaded_getindex(selected_rows::AbstractVector,
                            selected_columns::AbstractVector,
                            df_columns::AbstractVector,
                            idx::AbstractIndex)
    if length(selected_rows) >= 100_000 && Threads.nthreads() > 1
        new_columns = Vector{AbstractVector}(undef, length(selected_columns))
        @sync for i in eachindex(new_columns)
            @spawn new_columns[i] = df_columns[selected_columns[i]][selected_rows]
        end
        return DataFrame(new_columns, idx, copycols=false)
    else
        return DataFrame(AbstractVector[df_columns[i][selected_rows] for i in selected_columns],
                            idx, copycols=false)
    end
end

@inline function Base.getindex(df::DataFrame, row_inds::AbstractVector{T},
                               col_inds::MultiColumnIndex) where T
    @boundscheck if !checkindex(Bool, axes(df, 1), row_inds)
        throw(BoundsError(df, (row_inds, col_inds)))
    end
    selected_columns = index(df)[col_inds]

    u = _names(df)[selected_columns]
    lookup = Dict{Symbol, Int}(zip(u, 1:length(u)))
    # use this constructor to avoid checking twice if column names are not
    # duplicate as index(df)[col_inds] already checks this
    idx = Index(lookup, u)

    if length(selected_columns) == 1
        new_df = DataFrame(AbstractVector[_columns(df)[selected_columns[1]][row_inds]],
                           idx, copycols=false)
    else
        # Computing integer indices once for all columns is faster
        selected_rows = T === Bool ? _findall(row_inds) : row_inds
        new_df = _threaded_getindex(selected_rows, selected_columns, _columns(df), idx)
    end

    _copy_all_note_metadata!(new_df, df)
    return new_df
end

@inline function Base.getindex(df::DataFrame, row_inds::AbstractVector{T}, ::Colon) where T
    @boundscheck if !checkindex(Bool, axes(df, 1), row_inds)
        throw(BoundsError(df, (row_inds, :)))
    end
    idx = copy(index(df))

    if ncol(df) == 1
        new_df = DataFrame(AbstractVector[_columns(df)[1][row_inds]], idx, copycols=false)
    else
        # Computing integer indices once for all columns is faster
        selected_rows = T === Bool ? _findall(row_inds) : row_inds
        new_df = _threaded_getindex(selected_rows, 1:ncol(df), _columns(df), idx)
    end

    _copy_all_note_metadata!(new_df, df)
    return new_df
end

@inline Base.getindex(df::DataFrame, row_inds::Not, col_inds::MultiColumnIndex) =
    df[axes(df, 1)[row_inds], col_inds]

# df[:, MultiColumnIndex] => DataFrame
Base.getindex(df::DataFrame, row_ind::Colon, col_inds::MultiColumnIndex) =
    select(df, index(df)[col_inds], copycols=true)

# df[!, MultiColumnIndex] => DataFrame
Base.getindex(df::DataFrame, row_ind::typeof(!), col_inds::MultiColumnIndex) =
    select(df, index(df)[col_inds], copycols=false)

##############################################################################
##
## setindex!()
##
##############################################################################

# Will automatically add a new column if needed
function insert_single_column!(df::DataFrame, v::AbstractVector, col_ind::ColumnIndex)
    if ncol(df) != 0 && nrow(df) != length(v)
        throw(ArgumentError("New columns must have the same length as old columns"))
    end
    dv = isa(v, AbstractRange) ? collect(v) : v
    firstindex(dv) != 1 && _onebased_check_error()

    if haskey(index(df), col_ind)
        j = index(df)[col_ind]
        _columns(df)[j] = dv
    else
        if col_ind isa SymbolOrString
            push!(index(df), Symbol(col_ind))
            push!(_columns(df), dv)
        else
            throw(ArgumentError("Cannot assign to non-existent column: $col_ind"))
        end
    end
    _drop_all_nonnote_metadata!(df)
    return dv
end

function insert_single_entry!(df::DataFrame, v::Any, row_ind::Integer, col_ind::ColumnIndex)
    if haskey(index(df), col_ind)
        _columns(df)[index(df)[col_ind]][row_ind] = v
        _drop_all_nonnote_metadata!(df)
        return v
    else
        throw(ArgumentError("Cannot assign to non-existent column: $col_ind"))
    end
end

# df[!, SingleColumnIndex] = AbstractVector
function Base.setindex!(df::DataFrame, v::AbstractVector, ::typeof(!), col_ind::ColumnIndex)
    insert_single_column!(df, v, col_ind)
    return df
end

# df.col = AbstractVector
# separate methods are needed due to dispatch ambiguity
Base.setproperty!(df::DataFrame, col_ind::Symbol, v::AbstractVector) =
    (df[!, col_ind] = v)
Base.setproperty!(df::DataFrame, col_ind::AbstractString, v::AbstractVector) =
    (df[!, col_ind] = v)
Base.setproperty!(::DataFrame, col_ind::Symbol, v::Any) =
    throw(ArgumentError("It is only allowed to pass a vector as a column of a DataFrame. " *
                        "Instead use `df[!, col_ind] .= v` if you want to use broadcasting."))
Base.setproperty!(::DataFrame, col_ind::AbstractString, v::Any) =
    throw(ArgumentError("It is only allowed to pass a vector as a column of a DataFrame. " *
                        "Instead use `df[!, col_ind] .= v` if you want to use broadcasting."))

# df[SingleRowIndex, SingleColumnIndex] = Single Item
function Base.setindex!(df::DataFrame, v::Any, row_ind::Integer, col_ind::ColumnIndex)
    insert_single_entry!(df, v, row_ind, col_ind)
    return df
end

# df[SingleRowIndex, MultiColumnIndex] = value
# the method for value of type DataFrameRow, AbstractDict and NamedTuple
# is defined in dataframerow.jl

for T in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(df::DataFrame,
                                  v::Union{Tuple, AbstractArray},
                                  row_ind::Integer,
                                  col_inds::$T)
        idxs = index(df)[col_inds]
        if length(v) != length(idxs)
            throw(DimensionMismatch("$(length(idxs)) columns were selected but the assigned " *
                                    "collection contains $(length(v)) elements"))
        end
        for (i, x) in zip(idxs, v)
            df[!, i][row_ind] = x
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end
end

# df[MultiRowIndex, SingleColumnIndex] = AbstractVector
for T in (:AbstractVector, :Not, :Colon)
    @eval function Base.setindex!(df::DataFrame,
                                  v::AbstractVector,
                                  row_inds::$T,
                                  col_ind::ColumnIndex)
        if row_inds isa Colon && !haskey(index(df), col_ind)
            df[!, col_ind] = copy(v)
            return df
        end
        x = df[!, col_ind]
        x[row_inds] = v
        _drop_all_nonnote_metadata!(df)
        return df
    end
end

# df[MultiRowIndex, MultiColumnIndex] = AbstractDataFrame
for T1 in (:AbstractVector, :Not, :Colon),
    T2 in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(df::DataFrame,
                                  new_df::AbstractDataFrame,
                                  row_inds::$T1,
                                  col_inds::$T2)
        idxs = index(df)[col_inds]
        if view(_names(df), idxs) != _names(new_df)
            throw(ArgumentError("column names in source and target do not match"))
        end
        for (j, col) in enumerate(idxs)
            df[!, col][row_inds] = new_df[!, j]
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end
end

for T in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(df::DataFrame,
                                  new_df::AbstractDataFrame,
                                  row_inds::typeof(!),
                                  col_inds::$T)
        idxs = index(df)[col_inds]
        if view(_names(df), idxs) != _names(new_df)
            throw(ArgumentError("Column names in source and target data frames do not match"))
        end
        for (j, col) in enumerate(idxs)
            # make sure we make a copy on assignment
            # this will drop metadata appropriately
            df[!, col] = new_df[:, j]
        end
        return df
    end
end

# df[MultiRowIndex, MultiColumnIndex] = AbstractMatrix
for T1 in (:AbstractVector, :Not, :Colon, :(typeof(!))),
    T2 in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(df::DataFrame,
                                  mx::AbstractMatrix,
                                  row_inds::$T1,
                                  col_inds::$T2)
        idxs = index(df)[col_inds]
        if size(mx, 2) != length(idxs)
            throw(DimensionMismatch("number of selected columns ($(length(idxs))) " *
                                    "and number of columns in " *
                                    "matrix ($(size(mx, 2))) do not match"))
        end
        for (j, col) in enumerate(idxs)
            # this will drop metadata appropriately
            df[row_inds, col] = (row_inds === !) ? mx[:, j] : view(mx, :, j)
        end
        return df
    end
end

"""
    copy(df::DataFrame; copycols::Bool=true)

Copy data frame `df`.
If `copycols=true` (the default), return a new  `DataFrame` holding
copies of column vectors in `df`.
If `copycols=false`, return a new `DataFrame` sharing column vectors with `df`.

Metadata: this function preserves all table-level and column-level metadata.
"""
function Base.copy(df::DataFrame; copycols::Bool=true)
    cdf = DataFrame(copy(_columns(df)), copy(index(df)), copycols=copycols)

    df_metadata = getfield(df, :metadata)
    if !isnothing(df_metadata)
        setfield!(cdf, :metadata, copy(df_metadata))
    end
    df_colmetadata = getfield(df, :colmetadata)
    if !isnothing(df_colmetadata)
        cdf_colmetadata = copy(df_colmetadata)
        map!(copy, values(cdf_colmetadata))
        setfield!(cdf, :colmetadata, cdf_colmetadata)
    end
    setfield!(cdf, :allnotemetadata, getfield(df, :allnotemetadata))

    return cdf
end

"""
    deleteat!(df::DataFrame, inds)

Delete rows specified by `inds` from a `DataFrame` `df` in place and return it.

Internally `deleteat!` is called for all columns so `inds` must be:
a vector of sorted and unique integers, a boolean vector, an integer,
or `Not` wrapping any valid selector.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> deleteat!(df, 2)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     3      6
```
"""
Base.deleteat!(df::DataFrame, inds)

Base.deleteat!(df::DataFrame, ::Colon) = empty!(df)

function Base.deleteat!(df::DataFrame, inds::Integer)
    inds isa Bool && throw(ArgumentError("Invalid index of type Bool"))
    size(df, 2) == 0 && throw(BoundsError(df, (inds, :)))
    return _deleteat!_helper(df, Int[inds])
end

function Base.deleteat!(df::DataFrame, inds::AbstractVector)
    if isempty(inds)
        _drop_all_nonnote_metadata!(df)
        return df
    elseif size(df, 2) == 0
        throw(BoundsError(df, (inds, :)))
    end

    if Bool <: eltype(inds) && any(x -> x isa Bool, inds)
        throw(ArgumentError("invalid index of type Bool"))
    end

    if !(eltype(inds) <: Integer || all(x -> x isa Integer, inds))
        throw(ArgumentError("unsupported index $inds"))
    end

    if !issorted(inds, lt=<=)
        throw(ArgumentError("Indices passed to deleteat! must be unique and sorted"))
    end

    return _deleteat!_helper(df, inds)
end

function Base.deleteat!(df::DataFrame, inds::AbstractVector{Bool})
    if length(inds) != size(df, 1)
        throw(BoundsError(df, (inds, :)))
    end
    return _deleteat!_helper(df, inds)
end

Base.deleteat!(df::DataFrame, inds::Not) =
    _deleteat!_helper(df, axes(df, 1)[inds])

function _deleteat!_helper(df::DataFrame, drop)
    cols = _columns(df)
    if isempty(cols)
        _drop_all_nonnote_metadata!(df)
        return df
    end

    drop_local = drop
    if any(c -> c === drop_local || Base.mightalias(c, drop_local), cols)
        drop = copy(drop_local)
    end

    n = nrow(df)
    col1 = cols[1]
    deleteat!(col1, drop)
    newn = length(col1)
    @assert newn <= n
    # the 0.06 threshold is heuristic; based on tests
    # the assignment makes the code type-unstable but it is a small union
    # so the overhead should be small
    if drop isa AbstractVector{Bool} && newn < 0.06 * n
        drop = findall(drop)
    end
    for i in 2:length(cols)
        col = cols[i]
        # this check is done to handle column aliases
        if length(col) == n
            deleteat!(col, drop)
        end
    end

    for i in 1:length(cols)
        # this should never happen, but we add it for safety
        @assert length(cols[i]) == newn corrupt_msg(df, i)
    end

    _drop_all_nonnote_metadata!(df)
    return df
end

"""
    keepat!(df::DataFrame, inds)

Delete rows at all indices not specified by `inds` from a `DataFrame` `df`
in place and return it.

Internally `deleteat!` is called for all columns so `inds` must be:
a vector of sorted and unique integers, a boolean vector, an integer,
or `Not` wrapping any valid selector.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> keepat!(df, [1, 3])
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     3      6
```
"""
keepat!(df::DataFrame, inds)

function keepat!(df::DataFrame, ::Colon)
    _drop_all_nonnote_metadata!(df)
    return df
end

function keepat!(df::DataFrame, inds::AbstractVector)
    isempty(inds) && return empty!(df)

    # this is required because of https://github.com/JuliaData/InvertedIndices.jl/issues/31
    if !((eltype(inds) <: Integer) || all(x -> x isa Integer, inds))
        throw(ArgumentError("unsupported index $inds"))
    end

    if Bool <: eltype(inds) && any(x -> x isa Bool, inds)
        throw(ArgumentError("invalid index of type Bool"))
    end

    if !issorted(inds, lt=<=)
        throw(ArgumentError("Indices passed to keepat! must be unique and sorted"))
    end

    return deleteat!(df, Not(inds))
end

function keepat!(df::DataFrame, inds::Integer)
    inds isa Bool && throw(ArgumentError("Invalid index of type Bool"))
    return deleteat!(df, Not(Int[inds]))
end

keepat!(df::DataFrame, inds::AbstractVector{Bool}) = deleteat!(df, .!inds)
keepat!(df::DataFrame, inds::Not) = deleteat!(df, Not(inds))

"""
    empty!(df::DataFrame)

Remove all rows from `df`, making each of its columns empty.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> empty!(df)
0×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┴──────────────

julia> df.a, df.b
(Int64[], Int64[])
```

"""
function Base.empty!(df::DataFrame)
    foreach(empty!, eachcol(df))
    _drop_all_nonnote_metadata!(df)
    return df
end

"""
    resize!(df::DataFrame, n::Integer)

Resize `df` to have `n` rows by calling `resize!` on all columns of `df`.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> resize!(df, 2)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
```
"""
function Base.resize!(df::DataFrame, n::Integer)
    if ncol(df) == 0 && n != 0
        throw(ArgumentError("data frame has no columns and requested number " *
                            "of rows is not zero"))
    end
    foreach(col -> resize!(col, n), eachcol(df))
    _drop_all_nonnote_metadata!(df)
    return df
end

"""
    pop!(df::DataFrame)

Remove the last row from `df` and return a `NamedTuple` created from this row.

!!! note

    Using this method for very wide data frames may lead to expensive compilation.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> pop!(df)
(a = 3, b = 6)

julia> df
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
```

"""
Base.pop!(df::DataFrame) = popat!(df, nrow(df))

"""
    popfirst!(df::DataFrame)

Remove the first row from `df` and return a `NamedTuple` created from this row.

!!! note

    Using this method for very wide data frames may lead to expensive compilation.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> popfirst!(df)
(a = 1, b = 4)

julia> df
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     2      5
   2 │     3      6
```
"""
Base.popfirst!(df::DataFrame) = popat!(df, 1)

"""
    popat!(df::DataFrame, i::Integer)

Remove the `i`-th row from `df` and return a `NamedTuple` created from this row.

!!! note

    Using this method for very wide data frames may lead to expensive compilation.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> popat!(df, 2)
(a = 2, b = 5)

julia> df
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     3      6
```
"""
function Base.popat!(df::DataFrame, i::Integer)
    i isa Bool && throw(ArgumentError("Invalid index of type Bool"))
    nt = NamedTuple(df[i, :])
    deleteat!(df, i)
    return nt
end

##############################################################################
##
## hcat!
##
##############################################################################

# hcat! for 2 arguments, only a vector or a data frame is allowed
function hcat!(df1::DataFrame, df2::AbstractDataFrame;
               makeunique::Bool=false, copycols::Bool=true)
    u = add_names(index(df1), index(df2), makeunique=makeunique)

    _drop_all_nonnote_metadata!(df1)
    _keep_matching_table_note_metadata!(df1, df2)
    for i in 1:length(u)
        df1[!, u[i]] = copycols ? df2[:, i] : df2[!, i]
        _copy_col_note_metadata!(df1, u[i], df2, i)
    end

    return df1
end

# TODO: after deprecation remove AbstractVector methods

function hcat!(df::DataFrame, x::AbstractVector; makeunique::Bool=false, copycols::Bool=true)
    Base.depwarn("horizontal concatenation of data frame with a vector is deprecated. " *
                 "Pass DataFrame(x1=x) instead.", :hcat!)
    return hcat!(df, DataFrame(AbstractVector[x], [:x1], copycols=false),
                 makeunique=makeunique, copycols=copycols)
end

function hcat!(x::AbstractVector, df::DataFrame; makeunique::Bool=false, copycols::Bool=true)
    Base.depwarn("horizontal concatenation of data frame with a vector is deprecated. " *
                 "Pass DataFrame(x1=x) instead.", :hcat!)
    return hcat!(DataFrame(AbstractVector[x], [:x1], copycols=copycols), df,
                 makeunique=makeunique, copycols=copycols)
end

# hcat! for 1-n arguments
function hcat!(df::DataFrame; makeunique::Bool=false, copycols::Bool=true)
    _drop_all_nonnote_metadata!(df)
    return df
end

hcat!(a::DataFrame, b::Union{AbstractDataFrame, AbstractVector},
      c::Union{AbstractDataFrame, AbstractVector}...;
      makeunique::Bool=false, copycols::Bool=true) =
    hcat!(hcat!(a, b, makeunique=makeunique, copycols=copycols),
          c..., makeunique=makeunique, copycols=copycols)

##############################################################################
##
## Missing values support
##
##############################################################################
"""
    allowmissing!(df::DataFrame, cols=:)

Convert columns `cols` of data frame `df` from element type `T` to
`Union{T, Missing}` to support missing values.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `cols` is omitted all columns in the data frame are converted.

$METADATA_FIXED
"""
function allowmissing! end

function allowmissing!(df::DataFrame, col::ColumnIndex)
    df[!, col] = allowmissing(df[!, col])
    return df
end

function allowmissing!(df::DataFrame, cols::AbstractVector{<:ColumnIndex})
    for col in cols
        allowmissing!(df, col)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

function allowmissing!(df::DataFrame, cols::AbstractVector{Bool})
    length(cols) == size(df, 2) || throw(BoundsError(df, (!, cols)))
    for (col, cond) in enumerate(cols)
        cond && allowmissing!(df, col)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

allowmissing!(df::DataFrame, cols::MultiColumnIndex) =
    allowmissing!(df, index(df)[cols])

allowmissing!(df::DataFrame, cols::Colon=:) =
    allowmissing!(df, axes(df, 2))

"""
    disallowmissing!(df::DataFrame, cols=:; error::Bool=true)

Convert columns `cols` of data frame `df` from element type `Union{T, Missing}` to
`T` to drop support for missing values.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).

If `cols` is omitted all columns in the data frame are converted.

If `error=false` then columns containing a `missing` value will be skipped instead
of throwing an error.

$METADATA_FIXED
"""
function disallowmissing! end

function disallowmissing!(df::DataFrame, col::ColumnIndex; error::Bool=true)
    x = df[!, col]
    if Missing <: eltype(x)
        try
            df[!, col] = disallowmissing(x)
        catch e
            row = findfirst(ismissing, x)
            if row !== nothing
                if error
                    col_name = only(names(df, col))
                    throw(ArgumentError("Missing value found in column " *
                                        ":$col_name in row $row"))
                end
            else
                rethrow(e)
            end
        end
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

function disallowmissing!(df::DataFrame, cols::AbstractVector{<:ColumnIndex};
                          error::Bool=true)
    for col in cols
        disallowmissing!(df, col, error=error)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

function disallowmissing!(df::DataFrame, cols::AbstractVector{Bool}; error::Bool=true)
    length(cols) == size(df, 2) || throw(BoundsError(df, (!, cols)))
    for (col, cond) in enumerate(cols)
        cond && disallowmissing!(df, col, error=error)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

disallowmissing!(df::DataFrame, cols::MultiColumnIndex; error::Bool=true) =
    disallowmissing!(df, index(df)[cols], error=error)

disallowmissing!(df::DataFrame, cols::Colon=:; error::Bool=true) =
    disallowmissing!(df, axes(df, 2), error=error)

"""
    repeat!(df::DataFrame; inner::Integer=1, outer::Integer=1)

Update a data frame `df` in-place by repeating its rows. `inner` specifies how many
times each row is repeated, and `outer` specifies how many times the full set
of rows is repeated. Columns of `df` are freshly allocated.

$METADATA_FIXED

# Example
```jldoctest
julia> df = DataFrame(a=1:2, b=3:4)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> repeat!(df, inner=2, outer=3);

julia> df
12×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     1      3
   3 │     2      4
   4 │     2      4
   5 │     1      3
   6 │     1      3
   7 │     2      4
   8 │     2      4
   9 │     1      3
  10 │     1      3
  11 │     2      4
  12 │     2      4
```
"""
function repeat!(df::DataFrame; inner::Integer=1, outer::Integer=1)
    inner < 0 && throw(ArgumentError("inner keyword argument must be non-negative"))
    outer < 0 && throw(ArgumentError("outer keyword argument must be non-negative"))
    cols = _columns(df)
    for (i, col) in enumerate(cols)
        col_new = repeat(col, inner=Int(inner), outer=Int(outer))
        firstindex(col_new) != 1 && _onebased_check_error(i, col_new)
        cols[i] = col_new
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

"""
    repeat!(df::DataFrame, count::Integer)

Update a data frame `df` in-place by repeating its rows the number of times
specified by `count`. Columns of `df` are freshly allocated.

$METADATA_FIXED

# Example
```jldoctest
julia> df = DataFrame(a=1:2, b=3:4)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> repeat(df, 2)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4
   3 │     1      3
   4 │     2      4
```
"""
function repeat!(df::DataFrame, count::Integer)
    count < 0 && throw(ArgumentError("count must be non-negative"))
    cols = _columns(df)
    for (i, col) in enumerate(cols)
        col_new = repeat(col, count)
        firstindex(col_new) != 1 && _onebased_check_error(i, col_new)
        cols[i] = col_new
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

# This is not exactly copy! as in general we allow axes to be different
# Also no table metadata needs to be copied as we use _replace_columns!
# only in situations when table metadata for `df` must be left as-is
function _replace_columns!(df::DataFrame, newdf::DataFrame)
    # for DataFrame object here we do not support keep_present keyword argument
    # like for SubDataFrame because here transform! always falls back to select!
    @assert ncol(newdf) == 0 || nrow(df) == nrow(newdf)
    copy!(_columns(df), _columns(newdf))
    copy!(_names(index(df)), _names(newdf))
    copy!(index(df).lookup, index(newdf).lookup)

    emptycolmetadata!(df)
    for (col, col_keys) in colmetadatakeys(newdf)
        if hasproperty(df, col)
            for key in col_keys
                val, style = colmetadata(newdf, col, key, style=true)
                style === :note && colmetadata!(df, col, key, val, style=:note)
            end
        end
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

allcombinations(::Type{DataFrame}; kwargs...) =
    isempty(kwargs) ? DataFrame() : allcombinations(DataFrame, kwargs...)

allcombinations(::Type{DataFrame}, pairs::Pair{<:AbstractString, <:Any}...) =
    allcombinations(DataFrame, (Symbol(k) => v for (k, v) in pairs)...)

"""
    allcombinations(DataFrame, pairs::Pair...)
    allcombinations(DataFrame; kwargs...)

Create a `DataFrame` from all combinations of values in passed arguments.
The first passed values vary fastest.

Arguments associating a column name with values to expand can be specified
either as `Pair`s passed as positional arguments, or as keyword arguments.
Column names must be `Symbol`s or strings and must be unique.

Column value can be a vector which is consumed as is or an object of any other
type (except `AbstractArray`). In the latter case the passed value is treated
as having length one for expansion. As a particular rule values stored in a `Ref`
or a `0`-dimensional `AbstractArray` are unwrapped and treated as having length one.

See also: [`crossjoin`](@ref) can be used to get the cartesian product
of rows from passed data frames.

# Examples

```jldoctest
julia> allcombinations(DataFrame, a=1:2, b='a':'c')
6×2 DataFrame
 Row │ a      b
     │ Int64  Char
─────┼─────────────
   1 │     1  a
   2 │     2  a
   3 │     1  b
   4 │     2  b
   5 │     1  c
   6 │     2  c

julia> allcombinations(DataFrame, "a" => 1:2, "b" => 'a':'c', "c" => "const")
6×3 DataFrame
 Row │ a      b     c
     │ Int64  Char  String
─────┼─────────────────────
   1 │     1  a     const
   2 │     2  a     const
   3 │     1  b     const
   4 │     2  b     const
   5 │     1  c     const
   6 │     2  c     const
```
"""
function allcombinations(::Type{DataFrame}, pairs::Pair{Symbol, <:Any}...)
    colnames = first.(pairs)
    if !allunique(colnames)
        throw(ArgumentError("All column names passed to allcombinations must be unique"))
    end
    colvalues = map(pairs) do p
        v = last(p)
        if v isa AbstractVector
            return v
        elseif v isa Union{AbstractArray{<:Any, 0}, Ref}
            x = v[]
            return fill!(Tables.allocatecolumn(typeof(x), 1), x)
        elseif v isa AbstractArray
            throw(ArgumentError("adding AbstractArray other than AbstractVector " *
                                "as a column of a data frame is not allowed"))
        else
            return fill!(Tables.allocatecolumn(typeof(v), 1), v)
        end
    end
    @assert length(colvalues) == length(colnames)
    @assert all(x -> x isa AbstractVector, colvalues)

    target_rows = Int(prod(x -> BigInt(length(x)), colvalues))
    out_df = DataFrame()
    inner = 1
    for (val, cname) in zip(colvalues, colnames)
        len = length(val)
        last_inner = inner
        inner *= len
        outer, remv = inner == 0 ? (0, 0) : divrem(target_rows, inner)
        @assert iszero(remv)
        out_df[!, cname] = repeat(val, inner=last_inner, outer=outer)
    end
    @assert inner == target_rows
    @assert size(out_df) == (target_rows, length(colnames))
    return out_df
end

_try_select_no_copy(df::DataFrame, cols) = select(df, cols, copycols=false)

"""
    AsTable(cols)

A type having a special meaning in `source => transformation => destination`
selection operations supported by [`combine`](@ref), [`select`](@ref), [`select!`](@ref),
[`transform`](@ref), [`transform!`](@ref), [`subset`](@ref), and [`subset!`](@ref).

If `AsTable(cols)` is used in `source` position it signals that the columns selected
by the wrapped selector `cols` should be passed as a `NamedTuple` to the function.

If `AsTable` is used in `destination` position it means that the result of
the `transformation` operation is a vector of containers
(or a single container if `ByRow(transformation)` is used)
that should be expanded  into multiple columns using `keys` to get column names.

# Examples
```jldoctest
julia> df1 = DataFrame(a=1:3, b=11:13)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13

julia> df2 = select(df1, AsTable([:a, :b]) => ByRow(identity))
3×1 DataFrame
 Row │ a_b_identity
     │ NamedTuple…
─────┼─────────────────
   1 │ (a = 1, b = 11)
   2 │ (a = 2, b = 12)
   3 │ (a = 3, b = 13)

julia> select(df2, :a_b_identity => AsTable)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13

julia> select(df1, AsTable([:a, :b]) => ByRow(nt -> map(x -> x^2, nt)) => AsTable)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1    121
   2 │     4    144
   3 │     9    169
```
"""
struct AsTable
    cols

    # the rules used here are simplified as not all column selectors
    # that pass through them are valid, but this is safe enough in practice
    function AsTable(cols)
        if cols isa Union{AbstractString, Symbol, Signed, Unsigned,
                          AbstractVector{<:Integer},
                          AbstractVector{Symbol},
                          AbstractVector{<:AbstractString},
                          Colon, Not, Between, All, Cols, Regex} ||
            (cols isa AbstractVector &&
             all(col -> col isa Union{Integer, Symbol, AbstractString}, cols))
            return new(cols)
        else
            throw(ArgumentError("Unrecognized column selector $cols"))
        end
    end
end

Base.broadcastable(x::AsTable) = Ref(x)

function make_unique!(names::Vector{Symbol}, src::AbstractVector{Symbol};
                      makeunique::Bool=false)
    if length(names) != length(src)
        throw(DimensionMismatch("Length of src doesn't match length of names."))
    end
    seen = Set{Symbol}()
    dups = Int[]
    for i in 1:length(names)
        name = src[i]
        if in(name, seen)
            push!(dups, i)
        else
            names[i] = src[i]
            push!(seen, name)
        end
    end

    if length(dups) > 0
        if !makeunique
            dupstr = join(string.(':', unique(src[dups])), ", ", " and ")
            msg = "Duplicate variable names: $dupstr. Pass makeunique=true " *
                  "to make them unique using a suffix automatically."
            throw(ArgumentError(msg))
        end
    end

    for i in dups
        nm = src[i]
        k = 1
        while true
            newnm = Symbol("$(nm)_$k")
            if !in(newnm, seen)
                names[i] = newnm
                push!(seen, newnm)
                break
            end
            k += 1
        end
    end

    return names
end

function make_unique(names::AbstractVector{Symbol}; makeunique::Bool=false)
    make_unique!(similar(names), names, makeunique=makeunique)
end

"""
    gennames(n::Integer)

Generate standardized names for columns of a DataFrame.
The first name will be `:x1`, the second `:x2`, etc.
"""
function gennames(n::Integer)
    res = Vector{Symbol}(undef, n)
    for i in 1:n
        res[i] = Symbol(@sprintf "x%d" i)
    end
    return res
end

function funname(f)
    if applicable(nameof, f)
        n = nameof(f)
        return String(n)[1] == '#' ? :function : n
    else
        # handle the case of functors that do not support nameof
        return :function
    end
end

funname(c::ComposedFunction) = Symbol(funname(c.outer), :_, funname(c.inner))

# Compute chunks of indices, each with at least `basesize` entries
# This method ensures balanced sizes by avoiding a small last chunk
function split_indices(len::Integer, basesize::Integer)
    len′ = Int64(len) # Avoid overflow on 32-bit machines
    @assert len′ > 0
    @assert basesize > 0
    np = Int64(max(1, len ÷ basesize))
    return split_to_chunks(len′, np)
end

function split_to_chunks(len::Integer, np::Integer)
    len′ = Int64(len) # Avoid overflow on 32-bit machines
    np′ = Int64(np)
    @assert len′ > 0
    @assert 0 < np′ <= len′
    return (Int(1 + ((i - 1) * len′) ÷ np):Int((i * len′) ÷ np) for i in 1:np)
end

function _spawn_for_chunks_helper(iter, lbody, basesize)
    lidx = iter.args[1]
    range = iter.args[2]
    quote
        let x = $(esc(range)), basesize = $(esc(basesize))
            @assert firstindex(x) == 1

            nt = Threads.nthreads()
            len = length(x)
            if nt > 1 && len > basesize
                tasks = [@spawn begin
                             for i in p
                                 local $(esc(lidx)) = @inbounds x[i]
                                 $(esc(lbody))
                             end
                         end
                         for p in split_indices(len, basesize)]
                foreach(wait, tasks)
            else
                for i in eachindex(x)
                    local $(esc(lidx)) = @inbounds x[i]
                    $(esc(lbody))
                end
            end
        end
        nothing
    end
end

"""
    @spawn_for_chunks basesize for i in range ... end

Parallelize a `for` loop by spawning separate tasks
iterating each over a chunk of at least `basesize` elements
in `range`.

A number of tasks higher than `Threads.nthreads()` may be spawned,
since that can allow for a more efficient load balancing in case
some threads are busy (nested parallelism).
"""
macro spawn_for_chunks(basesize, ex)
    if !(isa(ex, Expr) && ex.head === :for)
        throw(ArgumentError("@spawn_for_chunks requires a `for` loop expression"))
    end
    if !(ex.args[1] isa Expr && ex.args[1].head === :(=))
        throw(ArgumentError("nested outer loops are not currently supported by @spawn_for_chunks"))
    end
    return _spawn_for_chunks_helper(ex.args[1], ex.args[2], basesize)
end

"""
    @spawn_or_run_task threads expr

Equivalent to `Threads.@spawn` if `threads === true`,
otherwise run `expr` and return a `Task` that returns its value.
"""
macro spawn_or_run_task(threads, ex)
    letargs = Base._lift_one_interp!(ex)

    thunk = :(()->($(esc(ex))))
    Base.replace_linenums!(thunk, __source__)
    var = esc(Base.sync_varname)
    quote
        let $(letargs...)
            if $(esc(threads))
                local task = Task($thunk)
                task.sticky = false
                Base.Threads._spawn_set_thrpool(task, :default)
            else
                # Run expr immediately
                res = $thunk()
                # Return a Task that returns the value of expr
                local task = Task(() -> res)
                task.sticky = true
            end
            if $(Expr(:islocal, var))
                put!($var, task)
            end
            schedule(task)
            task
        end
    end
end

"""
    @spawn_or_run threads expr

Equivalent to `Threads.@spawn` if `threads === true`,
otherwise run `expr`.
"""
macro spawn_or_run(threads, ex)
    letargs = Base._lift_one_interp!(ex)

    thunk = :(()->($(esc(ex))))
    Base.replace_linenums!(thunk, __source__)
    var = esc(Base.sync_varname)
    quote
        let $(letargs...)
            if $(esc(threads))
                local task = Task($thunk)
                task.sticky = false
                Base.Threads._spawn_set_thrpool(task, :default)
                if $(Expr(:islocal, var))
                    put!($var, task)
                end
                schedule(task)
            else
                $thunk()
            end
            nothing
        end
    end
end

function _nt_like_hash(v, h::UInt)
    length(v) == 0 && return hash(NamedTuple(), h)

    h = hash((), h)
    for i in length(v):-1:1
        h = hash(v[i], h)
    end

    return xor(objectid(Tuple(propertynames(v))), h)
end

_findall(B) = findall(B)

function _findall(B::AbstractVector{Bool})
    @assert firstindex(B) == 1
    nnzB = count(B)

    # fast path returning range
    nnzB == 0 && return 1:0
    len = length(B)
    nnzB == len && return 1:len
    start::Int = findfirst(B)
    nnzB == 1 && return start:start
    start + nnzB - 1 == len && return start:len
    stop::Int = findnext(!, B, start + 1) - 1
    start + nnzB == stop + 1 && return start:stop

    # slow path returning Vector{Int}
    I = Vector{Int}(undef, nnzB)
    @inbounds for i in 1:stop - start + 1
        I[i] = start + i - 1
    end
    cnt = stop - start + 2
    @inbounds for i in stop+1:len
        if B[i]
            I[cnt] = i
            cnt += 1
        end
    end
    @assert cnt == nnzB + 1
    return I
end

@inline _blsr(x) = x & (x-1)

# findall returning a range when possible (all true indices are contiguous), and optimized for B::BitVector
# the main idea is taken from Base.findall(B::BitArray)
function _findall(B::BitVector)::Union{UnitRange{Int}, Vector{Int}}
    nnzB = count(B)
    nnzB == 0 && return 1:0
    nnzB == length(B) && return 1:length(B)
    local I
    Bc = B.chunks
    Bi = 1 # block index
    i1 = 1 # index of current block beginning in B
    i = 1  # index of the _next_ one in I
    c = Bc[1] # current block

    start = -1 # the beginning of ones block
    stop = -1  # the end of ones block

    @inbounds while true # I not materialized
        if i > nnzB # all ones in B found
            Ir = start:start + i - 2
            @assert length(Ir) == nnzB
            return Ir
        end

        if c == 0
            if start != -1 && stop == -1
                stop = i1 - 1
            end
            while c == 0 # no need to return here as we returned above
                i1 += 64
                Bi += 1
                c = Bc[Bi]
            end
        end
        if c == ~UInt64(0)
            if stop != -1
                I = Vector{Int}(undef, nnzB)
                for j in 1:i-1
                    I[j] = start + j - 1
                end
                break
            end
            if start == -1
                start = i1
            end
            while c == ~UInt64(0)
                if Bi == length(Bc)
                    Ir = start:length(B)
                    @assert length(Ir) == nnzB
                    return Ir
                end

                i += 64
                i1 += 64
                Bi += 1
                c = Bc[Bi]
            end
        end
        if c != 0 # mixed ones and zeros in block
            tz = trailing_zeros(c)
            lz = leading_zeros(c)
            co = c >> tz == (one(UInt64) << (64 - lz - tz)) - 1 # block of continuous ones in c
            if stop != -1  # already found block of ones and zeros, just not materialized
                I = Vector{Int}(undef, nnzB)
                for j in 1:i-1
                    I[j] = start + j - 1
                end
                break
            elseif !co # not continuous ones
                I = Vector{Int}(undef, nnzB)
                if start != -1
                    for j in 1:i-1
                        I[j] = start + j - 1
                    end
                end
                break
            else # continuous block of ones
                if start != -1
                    if tz > 0 # like __1111__ or 111111__
                        I = Vector{Int}(undef, nnzB)
                        for j in 1:i-1
                            I[j] = start + j - 1
                        end
                        break
                    else # lz > 0, like __111111
                        stop = i1 + (64 - lz) - 1
                        i += 64 - lz

                        # return if last block
                        if Bi == length(Bc)
                            Ir = start:stop
                            @assert length(Ir) == nnzB
                            return Ir
                        end

                        i1 += 64
                        Bi += 1
                        c = Bc[Bi]
                    end
                else # start == -1
                    start = i1 + tz

                    if lz > 0 # like __111111 or like __1111__
                        stop = i1 + (64 - lz) - 1
                        i += stop - start + 1
                    else # like 111111__
                        i += 64 - tz
                    end

                    # return if last block
                    if Bi == length(Bc)
                        Ir = start:start + i - 2
                        @assert length(Ir) == nnzB
                        return Ir
                    end

                    i1 += 64
                    Bi += 1
                    c = Bc[Bi]
                end
            end
        end
    end
    @inbounds while true # I materialized, process like in Base.findall
        if i > nnzB # all ones in B found
            @assert nnzB == i - 1
            return I
        end

        while c == 0 # no need to return here as we returned above
            i1 += 64
            Bi += 1
            c = Bc[Bi]
        end

        while c == ~UInt64(0)
            for j in 0:64-1
                I[i + j] = i1 + j
            end
            i += 64
            if Bi == length(Bc)
                @assert nnzB == i - 1
                return I
            end
            i1 += 64
            Bi += 1
            c = Bc[Bi]
        end

        while c != 0
            tz = trailing_zeros(c)
            c = _blsr(c) # zeros last nonzero bit
            I[i] = i1 + tz
            i += 1
        end
    end
    @assert false "should not be reached"
end

module TestReshape

using Test, DataFrames, Random, PooledArrays, CategoricalArrays
const ≅ = isequal

@testset "the output of unstack" begin
    df = DataFrame(Fish=CategoricalArray{Union{String, Missing}}(["Bob", "Bob", "Batman", "Batman"]),
                   Key=CategoricalArray{Union{String, Missing}}(["Mass", "Color", "Mass", "Color"]),
                   Value=Union{String, Missing}["12 g", "Red", "18 g", "Grey"])
    # Check that reordering levels does not confuse unstack
    levels!(df[!, 1], ["XXX", "Bob", "Batman"])
    levels!(df[!, 2], ["YYY", "Color", "Mass"])
    #Unstack specifying a row column
    df2 = unstack(df, :Fish, :Key, :Value)
    @test levels(df[!, 1]) == ["XXX", "Bob", "Batman"] # make sure we did not mess df[!, 1] levels
    @test levels(df[!, 2]) == ["YYY", "Color", "Mass"] # make sure we did not mess df[!, 2] levels
    #Unstack without specifying a row column
    df3 = unstack(df, :Key, :Value)
    # The expected output is in order of appearance
    df4 = DataFrame(Fish=Union{String, Missing}["Bob", "Batman"],
                    Mass=Union{String, Missing}["12 g", "18 g"],
                    Color=Union{String, Missing}["Red", "Grey"])
    @test df2 ≅ df4
    @test typeof(df2[!, :Fish]) <: CategoricalVector{Union{String, Missing}}
    # first column stays as CategoricalArray in df3
    @test df3 == df4
    #Make sure unstack works with missing values at the start of the value column
    df[1, :Value] = missing
    df2 = unstack(df, :Fish, :Key, :Value)
    #This changes the expected result
    df4[1, :Mass] = missing
    @test df2 ≅ df4

    df = DataFrame(Fish=CategoricalArray{Union{String, Missing}}(["Bob", "Bob", "Batman", "Batman"]),
                   Key=CategoricalArray{Union{String, Missing}}(["Mass", "Color", "Mass", "Color"]),
                   Value=Union{String, Missing}["12 g", "Red", "18 g", "Grey"])
    levels!(df[!, 1], ["XXX", "Bob", "Batman"])
    levels!(df[!, 2], ["YYY", "Color", "Mass"])
    df2 = unstack(df, :Fish, :Key, :Value, renamecols=x->string("_", uppercase(string(x)), "_"))
    df3 = unstack(df, :Key, :Value, renamecols=x->string("_", uppercase(string(x)), "_"))
    df4 = DataFrame(Fish=Union{String, Missing}["Bob", "Batman"],
                    _MASS_=Union{String, Missing}["12 g", "18 g"],
                    _COLOR_=Union{String, Missing}["Red", "Grey"])
    @test df2 == df4
    @test df3 == df4

    #The same as above but without CategoricalArray
    df = DataFrame(Fish=["Bob", "Bob", "Batman", "Batman"],
                   Key=["Mass", "Color", "Mass", "Color"],
                   Value=["12 g", "Red", "18 g", "Grey"])
    #Unstack specifying a row column
    df2 = unstack(df, :Fish, :Key, :Value)
    #Unstack without specifying a row column
    df3 = unstack(df, :Key, :Value)
    df4 = DataFrame(Fish=["Bob", "Batman"],
                    Mass=["12 g", "18 g"],
                    Color=["Red", "Grey"])
    @test df2 ≅ df4
    @test typeof(df2[!, :Fish]) <: Vector{String}
    # first column stays as CategoricalArray in df3
    @test df3 == df4
    #Make sure unstack works with missing values at the start of the value column
    allowmissing!(df, :Value)
    df[1, :Value] = missing
    df2 = unstack(df, :Fish, :Key, :Value)
    #This changes the expected result
    allowmissing!(df4, :Mass)
    df4[1, :Mass] = missing
    @test df2 ≅ df4

    df = DataFrame(Fish=["Bob", "Bob", "Batman", "Batman"],
                   Key=["Mass", "Color", "Mass", "Color"],
                   Value=["12 g", "Red", "18 g", "Grey"])
    df2 = unstack(df, :Fish, :Key, :Value, renamecols=x->string("_", uppercase(x), "_"))
    df3 = unstack(df, :Key, :Value, renamecols=x->string("_", uppercase(x), "_"))
    df4 = DataFrame(Fish=["Bob", "Batman"],
                    _MASS_=["12 g", "18 g"],
                    _COLOR_=["Red", "Grey"])
    @test df2 == df4
    @test df3 == df4

    # test empty set of grouping variables
    @test_throws ArgumentError unstack(df, Int[], :Key, :Value)
    @test_throws ArgumentError unstack(df, r"xxxxx", :Key, :Value)
    @test_throws ArgumentError unstack(df, Symbol[], :Key, :Value)
    @test_throws ArgumentError unstack(stack(DataFrame(rand(10, 10), :auto)),
                                  :id, :variable, :value)
    @test_throws TypeError unstack(df, :Key, :Value, renamecols=Symbol)

    # test missing value in grouping variable
    mdf = DataFrame(id=[missing, 1, 2, 3], a=1:4, b=1:4)
    @test unstack(stack(mdf, Not(:id)), :id, :variable, :value) ≅ mdf
    @test unstack(stack(mdf, Not(1)), :id, :variable, :value) ≅ mdf
    @test unstack(stack(mdf, Not(:id)), :id, :variable, :value) ≅ mdf
    @test unstack(stack(mdf, Not(1)), :id, :variable, :value) ≅ mdf

    # test more than one grouping column
    wide = DataFrame(id=1:12,
                     a=repeat([1:3;], inner=[4]),
                     b=repeat([1:4;], inner=[3]),
                     c=randn(12),
                     d=randn(12))
    w2 = wide[:, [1, 2, 4, 5]]
    rename!(w2, [:id, :a, :_C_, :_D_])
    long = stack(wide)
    wide3 = unstack(long, [:id, :a], :variable, :value)
    @test wide3 == wide[:, [1, 2, 4, 5]]
    wide3 = unstack(long, [:id, :a], :variable, :value,
                    renamecols=x->string("_", uppercase(string(x)), "_"))
    @test wide3 == w2

    wide3 = unstack(long, r"^[ia]", :variable, :value)
    @test wide3 == wide[:, [1, 2, 4, 5]]
    wide3 = unstack(long, r"^[ia]", :variable, :value,
                    renamecols=x->string("_", uppercase(string(x)), "_"))
    @test wide3 == w2
end

@testset "unstack promotion to support missing values" begin
    df = DataFrame([repeat(1:2, inner=4), repeat('a':'d', outer=2), collect(1:8)],
                   [:id, :variable, :value])
    udf = unstack(df, :variable, :value)
    @test udf == unstack(df, :variable, :value) == unstack(df, :id, :variable, :value)
    @test udf == DataFrame([Union{Int, Missing}[1, 2], Union{Int, Missing}[1, 5],
                            Union{Int, Missing}[2, 6], Union{Int, Missing}[3, 7],
                            Union{Int, Missing}[4, 8]], [:id, :a, :b, :c, :d])
    @test isa(udf[!, 1], Vector{Int})
    @test all(i -> isa(eachcol(udf)[i], Vector{Union{Int, Missing}}), 2:5)
    df = DataFrame(Any[categorical(repeat(1:2, inner=4)),
                       categorical(repeat('a':'d', outer=2)), categorical(1:8)],
                   [:id, :variable, :value])
    udf = unstack(df, :variable, :value)
    @test udf == unstack(df, :variable, :value) == unstack(df, :id, :variable, :value)
    @test udf == DataFrame([Union{Int, Missing}[1, 2], Union{Int, Missing}[1, 5],
                            Union{Int, Missing}[2, 6], Union{Int, Missing}[3, 7],
                            Union{Int, Missing}[4, 8]], [:id, :a, :b, :c, :d])
    @test isa(udf[!, 1], CategoricalVector{Int})
    @test all(i -> isa(eachcol(udf)[i], CategoricalVector{Union{Int, Missing}}), 2:5)
end

@testset "duplicate entries in unstack warnings" begin
    df = DataFrame(id=Union{Int, Missing}[1, 2, 1, 2],
                   id2=Union{Int, Missing}[1, 2, 1, 2],
                   variable=["a", "b", "a", "b"], value=[3, 4, 5, 6])
    @test_throws ArgumentError unstack(df, :id, :variable, :value)
    @test_throws ArgumentError unstack(df, :variable, :value)
    a = unstack(df, :id, :variable, :value, combine=last)
    b = unstack(df, :variable, :value, combine=last)
    @test a ≅ DataFrame(id=[1, 2], a=[5, missing], b=[missing, 6])
    @test b ≅ DataFrame(id=[1, 2], id2=[1, 2], a=[5, missing], b=[missing, 6])

    df = DataFrame(id=1:2, variable=["a", "b"], value=3:4)
    a = unstack(df, :id, :variable, :value)
    b = unstack(df, :variable, :value)
    @test a ≅ b ≅ DataFrame(id=[1, 2], a=[3, missing], b=[missing, 4])

    df = DataFrame(variable=["x", "x"], value=[missing, missing], id=[1, 1])
    @test_throws ArgumentError unstack(df, :variable, :value)
    @test_throws ArgumentError unstack(df, :id, :variable, :value)
    @test unstack(df, :variable, :value, combine=last) ≅ DataFrame(id=1, x=missing)
    @test unstack(df, :id, :variable, :value, combine=last) ≅ DataFrame(id=1, x=missing)
end

@testset "missing values in colkey" begin
    df = DataFrame(id=[1, 1, 1, missing, missing, missing, 2, 2, 2],
                   variable=["a", "b", missing, "a", "b", "missing", "a", "b", "missing"],
                   value=[missing, 2.0, 3.0, 4.0, 5.0, missing, 7.0, missing, 9.0])
    @test_throws ArgumentError unstack(df, :variable, :value)
    @test_throws ArgumentError unstack(df, :variable, :value, allowmissing=true)
    udf = unstack(df, :variable, :value, allowmissing=true, renamecols=x -> coalesce(x, "MISSING"))
    @test propertynames(udf) == [:id, :a, :b, :MISSING, :missing]
    @test udf[!, :missing] ≅ [missing, missing, 9.0]
    @test udf[!, :MISSING] ≅ [3.0, missing, missing]

    df = DataFrame(id=[1, 1, 1, missing, missing, missing, 2, 2, 2],
                   id2=[1, 1, 1, missing, missing, missing, 2, 2, 2],
                   variable=["a", "b", missing, "a", "b", "missing", "a", "b", "missing"],
                   value=[missing, 2.0, 3.0, 4.0, 5.0, missing, 7.0, missing, 9.0])
    @test_throws ArgumentError unstack(df, 3, 4)
    @test_throws ArgumentError unstack(df, 3, 4, allowmissing=true)
    udf = unstack(df, 3, 4, allowmissing=true, renamecols=x -> coalesce(x, "MISSING"))

    @test propertynames(udf) == [:id, :id2, :a, :b, :MISSING, :missing]
    @test udf[!, :missing] ≅ [missing, missing, 9.0]
    @test udf[!, :MISSING] ≅ [3.0, missing, missing]
end

@testset "stack-unstack correctness" begin
    Random.seed!(1234)
    x = DataFrame(rand(100, 50), :auto)
    x[!, :id] = [1:99; missing]
    x[!, :id2] = string.("a", x[!, :id])
    x[!, :s] = [i % 2 == 0 ? randstring() : missing for i in 1:100]
    allowmissing!(x, :x1)
    x[1, :x1] = missing
    y = stack(x, Not([:id, :id2]))
    @test y ≅ stack(x, Not(r"id"))
    @test y ≅ stack(x, Not(Not(Not(r"id"))))
    z = unstack(y, :id, :variable, :value)
    @test all(isequal(z[!, n], x[!, n]) for n in names(z))
    z = unstack(y, :variable, :value)
    @test all(isequal(z[!, n], x[!, n]) for n in names(x))
end

@testset "reshape" begin
    d1 = DataFrame(a=Array{Union{Int, Missing}}(repeat([1:3;], inner=[4])),
                   b=Array{Union{Int, Missing}}(repeat([1:4;], inner=[3])),
                   c=Array{Union{Float64, Missing}}(randn(12)),
                   d=Array{Union{Float64, Missing}}(randn(12)),
                   e=Array{Union{String, Missing}}(map(string, 'a':'l')))

    @test propertynames(stack(d1, :a)) == [:b, :c, :d, :e, :variable, :value]
    d1s = stack(d1, [:a, :b])
    @test d1s == stack(d1, r"[ab]")
    @test d1s == stack(d1, Not(r"[cde]"))
    @test d1s == stack(d1, Not(Not(r"[ab]")))
    d1s2 = stack(d1, [:c, :d])
    @test d1s2 == stack(d1, r"[cd]")
    @test d1s2 == stack(d1, Not([1, 2, 5]))
    d1s3 = stack(d1)
    d1m = stack(d1, Not([:c, :d, :e]))
    @test d1m == stack(d1, Not(r"[cde]"))
    @test d1s[1:12, :c] == d1[!, :c]
    @test d1s[13:24, :c] == d1[!, :c]
    @test d1s2 == d1s3
    @test propertynames(d1s) == [:c, :d, :e, :variable, :value]
    @test d1s == d1m
    d1m = stack(d1[:, [1, 3, 4]], Not(:a))
    @test propertynames(d1m) == [:a, :variable, :value]

    # Test naming of measure/value columns
    d1s_named = stack(d1, [:a, :b], variable_name=:letter, value_name=:someval)
    @test d1s_named == stack(d1, r"[ab]", variable_name=:letter, value_name=:someval)
    @test propertynames(d1s_named) == [:c, :d, :e, :letter, :someval]
    d1m_named = stack(d1[:, [1, 3, 4]], Not(:a), variable_name=:letter, value_name=:someval)
    @test propertynames(d1m_named) == [:a, :letter, :someval]

    # test empty measures or ids
    dx = stack(d1, [], [:a])
    @test dx == stack(d1, r"xxx", r"a")
    @test size(dx) == (0, 3)
    @test propertynames(dx) == [:a, :variable, :value]
    dx = stack(d1, :a, [])
    @test dx == stack(d1, r"a", r"xxx")
    @test size(dx) == (12, 2)
    @test propertynames(dx) == [:variable, :value]
    dx = stack(d1, [:a], [])
    @test dx == stack(d1, r"a", r"xxx")
    @test size(dx) == (12, 2)
    @test propertynames(dx) == [:variable, :value]
    dx = stack(d1, [], :a)
    @test dx == stack(d1, r"xxx", r"a")
    @test size(dx) == (0, 3)
    @test propertynames(dx) == [:a, :variable, :value]

    @test stack(d1, :a, view=true) == stack(d1, [:a], view=true)
    @test all(isa.(eachcol(stack(d1, :a, view=true)),
                   [fill(DataFrames.RepeatedVector, 5);
                    DataFrames.StackedVector]))
    @test all(isa.(eachcol(stack(d1, Not([:b, :c, :d, :e]), view=true)),
                   [fill(DataFrames.RepeatedVector, 5);
                    DataFrames.StackedVector]))

    # Tests of RepeatedVector and StackedVector indexing
    d1s = stack(d1, [:a, :b], view=true)
    @test d1s == stack(d1, r"[ab]", view=true)
    @test d1s[!, 4] isa DataFrames.RepeatedVector
    @test ndims(d1s[!, 4]) == 1
    @test ndims(typeof(d1s[!, 4])) == 1
    @test d1s[!, 5] isa DataFrames.StackedVector
    @test ndims(d1s[!, 5]) == 1
    @test ndims(typeof(d1s[!, 2])) == 1
    @test d1s[!, 4][[1, 24]] == ["a", "b"]
    @test d1s[!, 5][[1, 24]] == [1, 4]
    @test_throws ArgumentError d1s[!, 4][true]
    @test_throws ArgumentError d1s[!, 5][true]
    @test_throws ArgumentError d1s[!, 4][1.0]
    @test_throws ArgumentError d1s[!, 5][1.0]

    d1ss = stack(d1, [:a, :b], view=true)
    @test d1ss[!, 4][[1, 24]] == ["a", "b"]
    @test d1ss[!, 4] isa DataFrames.RepeatedVector
    d1ss = stack(d1, [:a, :b], view=true, variable_eltype=String)
    @test d1ss[!, 4][[1, 24]] == ["a", "b"]
    @test d1ss[!, 4] isa DataFrames.RepeatedVector
    d1ss = stack(d1, [:a, :b], view=true, variable_eltype=Symbol)
    @test d1ss[!, 4][[1, 24]] == [:a, :b]
    @test d1ss[!, 4] isa DataFrames.RepeatedVector

    # Those tests check indexing RepeatedVector/StackedVector by a vector
    @test d1s[!, 4][trues(24)] == d1s[!, 4]
    @test d1s[!, 5][trues(24)] == d1s[!, 5]
    @test d1s[!, 4][:] == d1s[!, 4]
    @test d1s[!, 5][:] == d1s[!, 5]
    @test d1s[!, 4][1:24] == d1s[!, 4]
    @test d1s[!, 5][1:24] == d1s[!, 5]
    @test [d1s[!, 4][1:12]; d1s[!, 4][13:24]] == d1s[!, 4]
    @test [d1s[!, 5][1:12]; d1s[!, 5][13:24]] == d1s[!, 5]

    d1s2 = stack(d1, [:c, :d], view=true)
    @test d1s2 == stack(d1, r"[cd]", view=true)
    d1s3 = stack(d1, view=true)
    d1m = stack(d1, Not([:c, :d, :e]), view=true)
    @test d1m == stack(d1, Not(r"[cde]"), view=true)
    @test d1s[1:12, :c] == d1[!, :c]
    @test d1s[13:24, :c] == d1[!, :c]
    @test d1s2 == d1s3
    @test propertynames(d1s) == [:c, :d, :e, :variable, :value]
    @test d1s == d1m
    d1m = stack(d1[:, [1, 3, 4]], Not(:a), view=true)
    @test propertynames(d1m) == [:a, :variable, :value]

    d1s_named = stack(d1, [:a, :b], variable_name=:letter, value_name=:someval, view=true)
    @test d1s_named == stack(d1, r"[ab]", variable_name=:letter, value_name=:someval, view=true)
    @test propertynames(d1s_named) == [:c, :d, :e, :letter, :someval]
    d1m_named = stack(d1, Not([:c, :d, :e]), variable_name=:letter, value_name=:someval, view=true)
    @test d1m_named == stack(d1, Not(r"[cde]"), variable_name=:letter, value_name=:someval, view=true)
    @test propertynames(d1m_named) == [:c, :d, :e, :letter, :someval]

    d1s[!, :id] = Union{Int, Missing}[1:12; 1:12]
    d1s2[!, :id] =  Union{Int, Missing}[1:12; 1:12]
    d1us = unstack(d1s, :id, :variable, :value)
    d1us2 = unstack(d1s2, :id, :variable, :value)
    d1us3 = unstack(d1s2, :variable, :value)
    @test d1us[!, :a] == d1[!, :a]
    @test d1us2[!, :d] == d1[!, :d]
    @test d1us2[!, 3] == d1[!, :d]
    @test d1us3[!, :d] == d1[!, :d]
    @test d1us3 == unstack(d1s2)

    # test unstack with exactly one key column that is not passed
    df1 = stack(DataFrame(rand(10, 10), :auto))
    df1[!, :id] = 1:100
    @test size(unstack(df1, :variable, :value)) == (100, 11)
    @test unstack(df1, :variable, :value) ≅ unstack(df1)

    # test empty keycol
    @test_throws ArgumentError unstack(stack(DataFrame(rand(3, 2), :auto)), :variable, :value)
end

@testset "column names duplicates" begin
    wide = DataFrame(id=1:12,
                     a=repeat([1:3;], inner=[4]),
                     b=repeat([1:4;], inner=[3]),
                     c=randn(12),
                     d=randn(12))
    w1 = wide[:, [1, 2, 4, 5]]
    rename!(w1, [:id, :a, :D, :d])
    w2 = wide[:, [1, 2, 4, 5]]
    rename!(w2, [:id, :a, :_D_, :_d_])
    long = stack(wide)
    long.variable = replace.(string.(long.variable), Ref("c" => "D"))
    wide3 = unstack(long, [:id, :a], :variable, :value)
    @test wide3 == w1
    wide3 = unstack(long, :id, :variable, :value)
    @test wide3 == w1[!, Not(2)]
    @test_throws ArgumentError unstack(long, [:id, :a], :variable, :value,
                                       renamecols=uppercase)
    wide3 = unstack(long, [:id, :a], :variable, :value,
                    renamecols=x->string("_", x, "_"))
    @test wide3 == w2
    wide3 = unstack(long, :id, :variable, :value,
                    renamecols=x->string("_", x, "_"))
    @test wide3 == w2[!, Not(2)]
end

@testset "flatten single column" begin
    df_vec = DataFrame(a=[1, 2], b=[[1, 2], [3, 4]])
    df_tup = DataFrame(a=[1, 2], b=[(1, 2), (3, 4)])
    @test flatten(empty(df_vec), :b) == DataFrame(a=[], b=[])
    @test flatten(empty(df_tup), :b) == DataFrame(a=[], b=[])
    ref = DataFrame(a=[1, 1, 2, 2], b=[1, 2, 3, 4])
    @test flatten(df_vec, :b) == flatten(df_tup, :b) == ref
    @test flatten(df_vec, "b") == flatten(df_tup, "b") == ref
    df_mixed_types = DataFrame(a=[1, 2], b=[[1, 2], ["x", "y"]])
    @test flatten(empty(df_mixed_types), :b) == DataFrame(a=[], b=[])
    ref_mixed_types = DataFrame(a=[1, 1, 2, 2], b=[1, 2, "x", "y"])
    @test flatten(df_mixed_types, :b) == ref_mixed_types
    df_three = DataFrame(a=[1, 2, 3], b=[[1, 2], [10, 20], [100, 200, 300]])
    ref_three = DataFrame(a=[1, 1, 2, 2, 3, 3, 3], b=[1, 2, 10, 20, 100, 200, 300])
    @test flatten(df_three, :b) == ref_three
    @test flatten(df_three, "b") == ref_three
    df_gen = DataFrame(a=[1, 2], b=[(i for i in 1:5), (i for i in 6:10)])
    ref_gen = DataFrame(a=[fill(1, 5); fill(2, 5)], b=collect(1:10))
    @test flatten(df_gen, :b) == ref_gen
    @test flatten(df_gen, "b") == ref_gen
    df_miss = DataFrame(a=[1, 2], b=[Union{Missing, Int}[1, 2], Union{Missing, Int}[3, 4]])
    @test flatten(empty(df_miss), :b) == DataFrame(a=[], b=[])
    ref = DataFrame(a=[1, 1, 2, 2], b=[1, 2, 3, 4])
    @test flatten(df_miss, :b) == ref
    @test flatten(df_miss, "b") == ref
    v1 = [[1, 2], [3, 4]]
    v2 = [[5, 6], [7, 8]]
    v = [v1, v2]
    df_vec_vec = DataFrame(a=[1, 2], b=v)
    @test flatten(empty(df_vec_vec), :b) == DataFrame(a=[], b=[])
    ref_vec_vec = DataFrame(a=[1, 1, 2, 2], b=[v1 ; v2])
    @test flatten(df_vec_vec, :b) == ref_vec_vec
    @test flatten(df_vec_vec, "b") == ref_vec_vec
    df_cat = DataFrame(a=[1, 2], b=[CategoricalArray([1, 2]), CategoricalArray([1, 2])])
    @test flatten(empty(df_cat), :b) == DataFrame(a=[], b=[])
    df_flat_cat = flatten(df_cat, :b)
    ref_cat = DataFrame(a=[1, 1, 2, 2], b=[1, 2, 1, 2])
    @test df_flat_cat == ref_cat
    @test df_flat_cat.b isa CategoricalArray
end

@testset "flatten multiple columns" begin
    df = DataFrame(a=[1, 2], b=[[1, 2], [3, 4]], c=[[5, 6], [7, 8]])
    @test flatten(empty(df), []) == DataFrame(a=[], b=[], c=[])
    @test flatten(empty(df), [:b, :c]) == DataFrame(a=[], b=[], c=[])
    @test flatten(empty(df), All()) == DataFrame(a=[], b=[], c=[])
    @test flatten(df, []) == df
    ref = DataFrame(a=[1, 1, 2, 2], b=[1, 2, 3, 4], c=[5, 6, 7, 8])
    @test flatten(df, [:b, :c]) == ref
    @test flatten(df, [:c, :b]) == ref
    @test flatten(df, ["b", "c"]) == ref
    @test flatten(df, ["c", "b"]) == ref
    @test flatten(df, 2:3) == ref
    @test flatten(df, r"[bc]") == ref
    @test flatten(df, Not(:a)) == ref
    @test flatten(df, Between(:b, :c)) == ref
    df_allcols = DataFrame(b=[[1, 2], [3, 4]], c=[[5, 6], [7, 8]])
    ref_allcols = DataFrame(b=[1, 2, 3, 4], c=[5, 6, 7, 8])
    @test flatten(df_allcols, All()) == ref_allcols
    @test flatten(df_allcols, Cols(:)) == ref_allcols
    @test flatten(df_allcols, :) == ref_allcols
    df_bad = DataFrame(a=[1, 2], b=[[1, 2], [3, 4]], c=[[5, 6], [7]])
    @test_throws ArgumentError flatten(df_bad, [:b, :c])
    @test flatten(DataFrame(), []) == DataFrame()
    @test flatten(DataFrame(), All()) == DataFrame()
end

@testset "flatten with scalar" begin
    df = DataFrame(a=[1, 2, 3],
                   b=[[1, 2], missing, [3, 4]],
                   c=[[5, 6], missing, missing])
    @test flatten(df, :a) ≅ df
    @test_throws MethodError flatten(df, :b)
    @test flatten(df, :b, scalar=Missing) ≅
          DataFrame(a=[1, 1, 2, 3, 3],
                    b=[1, 2, missing, 3, 4],
                    c=[[5, 6], [5, 6], missing, missing, missing])
    @test flatten(df, [:b, :c], scalar=Missing) ≅
          DataFrame(a=[1, 1, 2, 3, 3],
                    b=[1, 2, missing, 3, 4],
                    c=[5, 6, missing, missing, missing])
    @test flatten(df, [:b, :c], scalar=Any) ≅ df

    df = DataFrame(a=missing, b=[1], c=missing, d=[[1, 2]])
    @test_throws ArgumentError flatten(df, All(), scalar=Missing)
    @test flatten(df, Not(:d), scalar=Missing) ≅
        DataFrame(a=missing, b=1, c=missing, d=[[1, 2]])
    @test flatten(df, Not(:b), scalar=Missing) ≅
        DataFrame(a=[missing, missing], b=[1, 1], c=[missing, missing], d=[1, 2])

    df = DataFrame(a="xy", b=[[1, 2]])
    @test flatten(df, [:a, :b]) == DataFrame(a=['x', 'y'], b=[1, 2])
    @test flatten(df, [:a, :b], scalar=String) ==
          DataFrame(a=["xy", "xy"], b=[1, 2])

    df = DataFrame(a=[[1], [], [3, 4], missing], b = missings(4), id=1:4)
    @test flatten(df, [:a, :b], scalar=Missing) ≅
          DataFrame(a=[1, 3, 4, missing], b=missings(4), id=[1, 3, 3, 4])
    df = DataFrame(id=1:10, x=[1:i-1 for i in 1:10])
    df.y = [iseven(last(v)) ? missing : v for v in df.x]
    @test flatten(df, [:x, :y], scalar=Missing) ≅
          DataFrame(id=reduce(vcat, [fill(i, i-1) for i in 2:10]),
                    x=reduce(vcat, [1:i for i in 1:9]),
                    y=reduce(vcat, [iseven(i) ? missings(i) : (1:i) for i in 1:9]))

    # Below are tests showing handling of strings
    df = DataFrame(id=1:5,
                   col1=["a", missing, 1:2, 3:4, 5:6],
                   col2=[11:12, 111:112, 1111:1112, missing, "b"])
    @test flatten(df, [:col1, :col2], scalar=Union{Missing, AbstractString}) ≅
          DataFrame(id=[1 ,1, 2, 2, 3, 3, 4, 4, 5, 5],
                    col1=["a", "a", missing, missing, 1, 2, 3, 4, 5, 6],
                    col2=[11, 12, 111, 112, 1111, 1112, missing, missing, "b", "b"])
    @test_throws MethodError flatten(df, [:col1, :col2])
    @test_throws ArgumentError flatten(df, [:col1, :col2], scalar=Missing)
    @test_throws MethodError flatten(df, [:col1, :col2], scalar=AbstractString)

    df = DataFrame(id=1:5,
                   col1=["ab", missing, 1:2, 3:4, 5:6],
                   col2=[11:12, 111:112, 1111:1112, missing, "cd"])
    @test flatten(df, [:col1, :col2], scalar=Union{Missing, AbstractString}) ≅
          DataFrame(id=[1 ,1, 2, 2, 3, 3, 4, 4, 5, 5],
                    col1=["ab", "ab", missing, missing, 1, 2, 3, 4, 5, 6],
                    col2=[11, 12, 111, 112, 1111, 1112, missing, missing, "cd", "cd"])
    @test_throws MethodError flatten(df, [:col1, :col2])
    @test flatten(df, [:col1, :col2], scalar=Missing) ≅
          DataFrame(id=[1 ,1, 2, 2, 3, 3, 4, 4, 5, 5],
                    col1=['a', 'b', missing, missing, 1, 2, 3, 4, 5, 6],
                    col2=[11, 12, 111, 112, 1111, 1112, missing, missing, 'c', 'd'])
    @test_throws MethodError flatten(df, [:col1, :col2], scalar=AbstractString)
end

@testset "stack categorical test" begin
    Random.seed!(1234)
    d1 = DataFrame(a=repeat([1:3;], inner=[4]),
                   b=repeat([1:4;], inner=[3]),
                   c=randn(12),
                   d=randn(12),
                   e=map(string, 'a':'l'))
    d1s = stack(d1, [:d, :c])
    @test d1s.variable isa PooledVector{String}
    @test levels(d1s.variable) == ["c", "d"]
    d1s = stack(d1, [:d, :c], view=true)
    @test d1s.variable isa DataFrames.RepeatedVector{String}
    @test levels(d1s.variable) == ["c", "d"]
    @test d1s[:, 4] isa Vector{String}
    @test levels(d1s[:, 4]) == ["c", "d"]

    d1s = stack(d1, [:d, :c], variable_eltype=CategoricalValue{String})
    @test d1s.variable isa CategoricalVector{String}
    @test levels(d1s.variable) == ["d", "c"]
    d1s = stack(d1, [:d, :c], view=true, variable_eltype=CategoricalValue{String})
    @test d1s.variable isa DataFrames.RepeatedVector{<:CategoricalValue{String}}
    @test levels(d1s.variable) == ["d", "c"]
    @test d1s[:, 4] isa CategoricalVector{String}
    @test levels(d1s[:, 4]) == ["d", "c"]

    d1s = stack(d1, [:d, :c], variable_eltype=Symbol)
    @test d1s.variable isa PooledVector{Symbol}
    @test levels(d1s.variable) == [:c, :d]
    d1s = stack(d1, [:d, :c], view=true, variable_eltype=Symbol)
    @test d1s.variable isa DataFrames.RepeatedVector{Symbol}
    @test levels(d1s.variable) == [:c, :d]
    @test d1s[:, 4] isa Vector{Symbol}
    @test levels(d1s[:, 4]) == [:c, :d]

    d2 = mapcols(categorical, d1)
    levels!(d2.a, [2, 1, 3])
    ordered!(d2.a, true)
    ref_levels = shuffle!(unique([levels(d2.c); levels(d2.d)]))
    levels!(d2.c, ref_levels)
    ordered!(d2.c, true)
    levels!(d2.d, ref_levels)
    ordered!(d2.d, true)
    d2s = stack(d2, [:d, :c], variable_eltype=CategoricalValue{String})
    for col in eachcol(d2s)
        @test col isa CategoricalVector
    end
    @test levels(d2s.value) == ref_levels
    @test isordered(d2s.value)
    @test levels(d2.a) == levels(d2s.a)
    @test levels(d2.b) == levels(d2s.b)
    @test levels(d2.e) == levels(d2s.e)
    @test isordered(d2.a) == isordered(d2s.a)
    @test isordered(d2.b) == isordered(d2s.b)
    @test isordered(d2.e) == isordered(d2s.e)
end

@testset "test stack eltype" begin
    df = DataFrame(rand(4, 5), :auto)
    sdf = stack(df)
    @test eltype(sdf.variable) === String
    @test eltype(typeof(sdf.variable)) === String
    @test eltype(sdf.value) === Float64
    @test eltype(typeof(sdf.value)) === Float64
    sdf2 = first(sdf, 3)
    @test eltype(sdf2.variable) === String
    @test eltype(typeof(sdf2.variable)) === String
    @test eltype(sdf2.value) === Float64
    @test eltype(typeof(sdf2.value)) === Float64
end

@testset "additional unstack tests" begin
    df = DataFrame(id=repeat(1:3, inner=3),
                   id2=repeat(1:3, inner=3),
                   var=repeat('a':'c', 3),
                   val=1:9)
    @test unstack(df, :id, :var, :val) == DataFrame(id=1:3, a=1:3:7, b=2:3:8, c=3:3:9)
    @test unstack(df, [:id, :id2], :var, :val) == unstack(df, :var, :val) ==
          DataFrame(id=1:3, id2=1:3, a=1:3:7, b=2:3:8, c=3:3:9)

    # make sure we always use order of appearance
    Random.seed!(1234)
    # Use a large value to test several orders of appearance
    for i in 1:16
        df = df[Random.shuffle(1:9), :]
        wide1 = unstack(df, :id, :var, :val)
        wide2 = unstack(df, [:id, :id2], :var, :val)
        wide3 = unstack(df, :var, :val)
        @test wide1[sortperm(unique(df.id)), [1; 1 .+ sortperm(unique(df.var))]] ==
              DataFrame(id=1:3, a=1:3:7, b=2:3:8, c=3:3:9)
        @test wide2[sortperm(unique(df.id)), [1:2; 2 .+ sortperm(unique(df.var))]] ==
              DataFrame(id=1:3, id2=1:3, a=1:3:7, b=2:3:8, c=3:3:9)
        @test wide2 == wide3

        df2 = copy(df)
        df2.id = PooledArray(df.id)
        df2.var = PooledArray(df.var)
        @test unstack(df2, :id, :var, :val) == wide1
        @test unstack(df2, [:id, :id2], :var, :val) == wide2
        @test unstack(df2, :var, :val) == wide3

        df2 = transform(df, 1:3 .=> categorical, renamecols=false)
        @test unstack(df2, :id, :var, :val) == wide1
        @test unstack(df2, [:id, :id2], :var, :val) == wide2
        @test unstack(df2, :var, :val) == wide3
        levels!(df2.id, [10, 2, 11, 3, 1, 12])
        levels!(df2.var, ['x', 'b', 'y', 'c', 'a', 'z'])
        @test unstack(df2, :id, :var, :val) == wide1
        @test unstack(df2, [:id, :id2], :var, :val) == wide2
        @test unstack(df2, :var, :val) == wide3
    end

    df = DataFrame(id=repeat(1:3, inner=3),
                   a=repeat(1:3, inner=3),
                   var=repeat('a':'c', 3),
                   val=1:9)
    @test unstack(df, :id, :var, :val) == DataFrame(id=1:3, a=1:3:7, b=2:3:8, c=3:3:9)
    @test_throws ArgumentError unstack(df, :a, :var, :val)
    @test_throws ArgumentError unstack(df, [:id, :a], :var, :val)

    df = DataFrame(id=repeat(1:3, inner=3),
                   id2=repeat(1:3, inner=3),
                   var=repeat('a':'c', 3),
                   val=1:9)
    df[4, 1:2] .= 1
    @test_throws ArgumentError unstack(df, :id, :var, :val)
    @test_throws ArgumentError unstack(df, [:id, :id2], :var, :val)
    @test unstack(df, :id, :var, :val, combine=last) ≅
          DataFrame(id=1:3, a=[4, missing, 7], b=2:3:8, c=3:3:9)
    @test unstack(df, [:id, :id2], :var, :val, combine=last) ≅
          DataFrame(id=1:3, id2=1:3, a=[4, missing, 7], b=2:3:8, c=3:3:9)

    df = DataFrame(id=repeat(1:3, inner=3),
                   id2=repeat(1:3, inner=3),
                   var=repeat('a':'c', 3),
                   val=1:9)
    allowmissing!(df, :var)
    df.var[4] = missing
    @test_throws ArgumentError unstack(df, :id, :var, :val)
    @test_throws ArgumentError unstack(df, [:id, :id2], :var, :val)
    @test unstack(df, :id, :var, :val, allowmissing=true) ≅
          DataFrame(id=1:3, a=[1, missing, 7], b=2:3:8, c=3:3:9, missing=[missing, 4, missing])
    @test unstack(df, [:id, :id2], :var, :val, allowmissing=true) ≅
          DataFrame(id=1:3, id2=1:3, a=[1, missing, 7], b=2:3:8, c=3:3:9, missing=[missing, 4, missing])
end

# test scenario when sorting fails both in grouping and in variable
struct A_TYPE
    x
end

@testset "additional unstack tests not sortable" begin
    df = DataFrame(id=repeat(A_TYPE.([2, 1, 3]), inner=3),
                   id2=repeat(A_TYPE.([2, 1, 3]), inner=3),
                   var=repeat(A_TYPE.([3, 2, 1]), 3),
                   val=1:9)
    @test unstack(df, :id, :var, :val, renamecols=x -> Symbol(:x, x.x)) ==
          DataFrame(id=A_TYPE.([2, 1, 3]), x3=1:3:7, x2=2:3:8, x1=3:3:9)
    @test unstack(df, [:id, :id2], :var, :val, renamecols=x -> Symbol(:x, x.x)) ==
          DataFrame(id=A_TYPE.([2, 1, 3]), id2=A_TYPE.([2, 1, 3]), x3=1:3:7, x2=2:3:8, x1=3:3:9)
end

@testset "permutedims" begin
    df1 = DataFrame(a=["x", "y"], b=rand(2), c=[1, 2], d=rand(Bool, 2))

    @test_throws ArgumentError transpose(df1)
    @test_throws ArgumentError permutedims(df1, :bar)

    df1_pd = permutedims(df1, 1)
    @test size(df1_pd, 1) == ncol(df1) - 1
    @test size(df1_pd, 2) == nrow(df1) + 1
    @test names(df1_pd) == ["a", "x", "y"]
    @test df1_pd == permutedims(df1, :a) == permutedims(df1, 1)
    @test names(permutedims(df1, :a, :foo)) == ["foo", "x", "y"]

    orignames1 = names(df1)[2:end]
    for (i, row) in enumerate(eachrow(df1_pd))
        @test Vector(row) == [orignames1[i]; df1[!, orignames1[i]]]
    end

    # All columns should be promoted
    @test eltype(df1_pd.x) == Float64
    @test eltype(df1_pd.y) == Float64

    df2 = DataFrame(a=["x", "y"], b=[1.0, "str"], c=[1, 2], d=rand(Bool, 2))

    df2_pd = permutedims(df2, :a)
    @test size(df2_pd, 1) == ncol(df2) - 1
    @test size(df2_pd, 2) == nrow(df2) + 1
    @test names(df2_pd) == ["a", "x", "y"]

    orignames2 = names(df2)[2:end]
    for (i, row) in enumerate(eachrow(df2_pd))
        @test Vector(row) == [orignames2[i]; df2[!, orignames2[i]]]
    end
    @test Any == eltype(df2_pd.x)
    @test Any == eltype(df2_pd.y)

    df3 = DataFrame(a=fill("x", 10), b=rand(10), c=rand(Int, 10), d=rand(Bool, 10))

    d3pd_names = ["a", "x", ("x_$i" for i in 1:9)...]
    @test_throws ArgumentError permutedims(df3, 1)
    @test names(permutedims(df3, 1, makeunique=true)) == d3pd_names
    @test_throws ArgumentError permutedims(df3[!, [:a]], 1) # single column branch
    @test names(permutedims(df3[!, [:a]], 1, makeunique=true)) == d3pd_names

    df4 = DataFrame(a=rand(2), b=rand(2), c=[1, 2], d=[1.0, missing],
                    e=["x", "y"], f=[:x, :y], # valid src
                    g=[missing, "y"], h=Union{Missing, String}["x", "y"] # invalid src
                    )

    @test permutedims(df4[!, [:a, :b, :c, :e]], :e) ==
          permutedims(df4[!, [:e, :a, :b, :c]], 1) ==
          permutedims(df4[!, [:a, :b, :c, :f]], :f, :e)
    # Can permute single-column
    @test permutedims(df4[!, [:e]], 1) == DataFrame(e=String[], x=[], y=[])
    # Can't index float Column
    @test_throws ArgumentError permutedims(df4[!, [:a, :b, :c]], 1)
    # but can if it is empty
    @test permutedims(DataFrame(a=Float64[], b=Float64[]), 1) == DataFrame(a="b")
    # Can't index columns that allow for missing
    @test_throws ArgumentError permutedims(df4[!, [:g, :a, :b, :c]], 1)
    # but can if they do not contain missing
    @test permutedims(df4[!, [:h, :a, :b]], 1) == permutedims(df4[!, [:e, :a, :b]], 1, :h)
    # Can't permute empty `df` ...
    @test_throws BoundsError permutedims(DataFrame(), 1)
    # ... but can permute zero-row df
    @test permutedims(DataFrame(a=String[], b=Float64[]), 1) == DataFrame(a=["b"])

    # tests of strict handling
    df = DataFrame(a=["x", "y"], b=[1.0, 2.0], c=[3, 4], d=[true, false])
    ref = permutedims(df, 1)
    # allowed as contents is strings
    df.a = collect(Any, df.a)
    @test permutedims(df, 1) == ref
    # this is allowed as conversion from categorical to string is allowed
    df.a = categorical(df.a)
    @test permutedims(df, 1) == ref
    # allowed as contents is symbols
    df.a = Any[:x, :y]
    @test permutedims(df, 1) == ref
    # not allowed mixing of strings and symbols
    df.a = Any[:x, "y"]
    @test_throws ArgumentError permutedims(df, 1)
    # not allowed values that cannot be converted to string
    df.a = Any['x', 'y']
    @test_throws ArgumentError permutedims(df, 1)
    # but allowed with strict=false
    @test permutedims(df, 1, strict=false) == ref

    df = DataFrame(a=1:2, b=3:4)
    @test permutedims(df) == DataFrame(x1=[1, 3], x2=[2, 4])
    @test permutedims(df, [:p, :q]) == DataFrame(p=[1, 3], q=[2, 4])
    @test permutedims(df, ["p", "q"]) == DataFrame(p=[1, 3], q=[2, 4])
    @test_throws ArgumentError permutedims(df, ["p", "p"]) == DataFrame(p=[1, 3], q=[2, 4])
    @test permutedims(df, ["p", "p"], makeunique=true) == DataFrame(p=[1, 3], p_1=[2, 4])
    @test permutedims(DataFrame()) == permutedims(DataFrame(a=[], b=[])) ==
          permutedims(DataFrame(), []) == permutedims(DataFrame(a=[], b=[]), []) == DataFrame()
end

@testset "stack view=true additional tests" begin
    df = DataFrame(a=1:3, b=11:13, c=101:103)
    sdf = stack(df, [:b, :c], view=true)
    @test reverse(sdf.a) == reverse(copy(sdf.a))
    @test IndexStyle(DataFrames.StackedVector) == IndexLinear()
end

@testset "unstack with fill" begin
    df = DataFrame(factory=["Fac1", "Fac1", "Fac2", "Fac2"],
                   variable=["Var1", "Var2", "Var1", "Var2"],
                   value=[1, 2, 3, 4])
    dfu1 = DataFrame(factory=["Fac1", "Fac2"],
                     Var1=allowmissing([1, 3]),
                     Var2=allowmissing([2, 4]))
    dfu = unstack(df, :variable, :value)
    @test dfu ≅ dfu1
    @test eltype(dfu.Var1) === Union{Missing, Int}
    @test eltype(dfu.Var2) === Union{Missing, Int}

    for (sentinel, coleltype) in zip([1, 1., "1", nothing], [Int, Float64, Any, Union{Int, Nothing}])
        dfu = unstack(df, :variable, :value, fill=sentinel)
        @test dfu ≅ dfu1
        @test eltype(dfu.Var1) === coleltype
        @test eltype(dfu.Var2) === coleltype
    end

    df = DataFrame(factory=["Fac1", "Fac1", "Fac2"],
                   variable=["Var1", "Var2", "Var1"],
                   value=[1, 2, 3])
    for (sentinel, coleltype) in zip([1, 1.0, "1", nothing], [Int, Float64, Any, Union{Int, Nothing}])
        dfu = unstack(df, :variable, :value, fill=sentinel)
        @test dfu.Var1 == [1, 3]
        @test eltype(dfu.Var1) === coleltype
        @test dfu.Var2 == [2, sentinel]
        @test eltype(dfu.Var2) === coleltype
    end

    df = DataFrame(factory=["Fac1", "Fac1", "Fac2"],
                   variable=["Var1", "Var2", "Var1"],
                   value=categorical([1, 2, 3], ordered=true))
    # categorical is dropped here
    for (sentinel, coleltype) in zip([0, 0.0, "", nothing], [Int, Float64, Any, Union{Int, Nothing}])
        dfu = unstack(df, :variable, :value, fill=sentinel)
        @test dfu.Var1 == [1, 3]
        @test typeof(dfu.Var1) === Vector{coleltype}
        @test dfu.Var2 == [2, sentinel]
        @test typeof(dfu.Var2) === Vector{coleltype}
    end
    # categorical is kept here
    for (sentinel, coleltype) in zip([missing, CategoricalValue(1, df.value), ], [Union{Int, Missing}, Int])
        dfu = unstack(df, :variable, :value, fill=sentinel)
        @test dfu.Var1 == [1, 3]
        @test typeof(dfu.Var1) <: CategoricalVector{coleltype}
        @test dfu.Var2 ≅ [2, sentinel]
        @test typeof(dfu.Var2) <: CategoricalVector{coleltype}
        @test levels(dfu.Var1) == levels(dfu.Var2) == levels(df.value)
    end

    df = DataFrame(factory=["Fac1", "Fac1", "Fac2"],
                   variable=["Var1", "Var2", "Var1"],
                   value=categorical([1, 2, 3]))
    dfu = unstack(df, :variable, :value, fill=CategoricalValue(0, categorical([0])))
    @test dfu.Var1 == [1, 3]
    @test typeof(dfu.Var1) <: CategoricalVector{Int}
    @test dfu.Var2 ≅ [2, 0]
    @test typeof(dfu.Var2) <: CategoricalVector{Int}
    @test levels(dfu.Var1) == levels(dfu.Var2) == 0:3
    dfu = unstack(df, :variable, :value, fill=CategoricalValue("0", categorical(["0"])))
    @test dfu.Var1 == [1, 3]
    @test typeof(dfu.Var1) <: CategoricalVector{Union{Int,String}}
    @test dfu.Var2 ≅ [2, "0"]
    @test typeof(dfu.Var2) <: CategoricalVector{Union{Int,String}}
    @test levels(dfu.Var1) == levels(dfu.Var2) == ["0"; 1:3]
end

@testset "empty unstack" begin
    df = DataFrame(a=[], b=[], c=[])
    dfu = unstack(df, :b, :c)
    @test isempty(dfu)
    @test names(dfu) == ["a"]
    @test dfu.a isa Vector{Any}
end

@testset "no rowkey unstack" begin
    df = DataFrame(x=[:one, :two], y=[1, 2])
    @test unstack(df, :x, :y) == DataFrame(one=1, two=2)

    df = DataFrame(x=[:one, :two, :one], y=[1, 2, 3])
    @test_throws ArgumentError unstack(df, :x, :y)
    @test unstack(df, :x, :y, combine=last) == DataFrame(one=3, two=2)
    @test unstack(df, :x, :y, combine=identity) ==
          DataFrame(one=[[1, 3]], two=[[2]])
    @test unstack(df, :x, :y, combine=last) ==
          DataFrame(one=3, two=2)
    @test unstack(df, :x, :y, combine=first) ==
          DataFrame(one=1, two=2)
    @test unstack(df, :x, :y, combine=length) ==
          DataFrame(one=2, two=1)
end

@testset "combine kwarg" begin
    df = DataFrame(rowid=[1, 1, 1, 1, 2, 2], colid=[1, 1, 2, 2, 3, 3], values=1:6)
    @test_throws ArgumentError unstack(df, :rowid, :colid, :values)
    @test unstack(df, :rowid, :colid, :values, combine=last) ≅
          DataFrame("rowid" => 1:2, "1" => [2, missing],
                    "2" => [4, missing], "3" => [missing, 6])
    @test unstack(df, :rowid, :colid, :values, combine=last, fill=0) ==
          DataFrame("rowid" => 1:2, "1" => [2, 0],
                    "2" => [4, 0], "3" => [0, 6])
    @test unstack(df, :rowid, :colid, :values, combine=identity) ≅
          DataFrame("rowid" => 1:2, "1" => [1:2, missing],
                    "2" => [3:4, missing], "3" => [missing, 5:6])
    @test unstack(df, :rowid, :colid, :values,
                  combine=identity, fill=Int[]) ==
          DataFrame("rowid" => 1:2, "1" => [1:2, []],
                    "2" => [3:4, []], "3" => [[], 5:6])
    @test unstack(df, :rowid, :colid, :values, combine=sum) ≅
          DataFrame("rowid" => 1:2, "1" => [3, missing],
                    "2" => [7, missing], "3" => [missing, 11])
    @test unstack(df, :rowid, :colid, :values, combine=sum, fill=0) ==
          DataFrame("rowid" => 1:2, "1" => [3, 0],
                    "2" => [7, 0], "3" => [0, 11])
    @test unstack(df, :rowid, :colid, :values, combine=sum, fill="X") ==
          DataFrame("rowid" => 1:2, "1" => [3, "X"],
                    "2" => [7, "X"], "3" => ["X", 11])
    @test unstack(df, :rowid, :colid, :values, combine=length) ≅
          DataFrame("rowid" => 1:2, "1" => [2, missing],
                    "2" => [2, missing], "3" => [missing, 2])
    @test unstack(df, :rowid, :colid, :values, combine=length, fill=0) ==
          DataFrame("rowid" => 1:2, "1" => [2, 0],
                    "2" => [2, 0], "3" => [0, 2])
    @test unstack(df, :rowid, :colid, :values,
                  combine=x -> isempty(x) ? missing : length(x)) ≅
          DataFrame("rowid" => 1:2, "1" => [2, missing],
                    "2" => [2, missing], "3" => [missing, 2])
    @test unstack(df, :rowid, :colid, :values,
                  combine=x -> isempty(x) ? missing : x) ≅
          DataFrame("rowid" => 1:2, "1" => [1:2, missing],
                    "2" => [3:4, missing], "3" => [missing, 5:6])

    df = DataFrame(rowid=[2, 2, 2, 2, 1, 1], colid=[2, 2, 1, 1, 3, 3], values=1:6)
    @test unstack(df, :rowid, :colid, :values, combine=identity) ≅
          DataFrame("rowid" => [2,1], "2" => [1:2, missing],
                    "1" => [3:4, missing], "3" => [missing, 5:6])
    @test unstack(df, :rowid, :colid, :values, combine=identity, fill="X") ==
          DataFrame("rowid" => [2,1], "2" => [1:2, "X"],
                    "1" => [3:4, "X"], "3" => ["X", 5:6])

    Random.seed!(1234)
    # check correctness of row and column ordering
    for _ in 1:10
        df = DataFrame(rowid=rand(1:10, 50), colid=rand(1:10, 50), values=1:50)
        res = unstack(df, :rowid, :colid, :values, combine=last)
        @test res ≅ unstack(df, :rowid, :colid, :values, combine=last)
        @test res.rowid == unique(df.rowid)
        @test names(res, Not(1)) == string.(unique(df.colid))
        res = unstack(df, :rowid, :colid, :values, combine=last, fill=0)
        @test res ≅ unstack(df, :rowid, :colid, :values, combine=last, fill=0)
        @test res.rowid == unique(df.rowid)
        @test names(res, Not(1)) == string.(unique(df.colid))

        df.rowid=categorical(df.rowid, levels=shuffle(unique(df.rowid)))
        df.colid=categorical(df.colid, levels=shuffle(unique(df.colid)))
        res = unstack(df, :rowid, :colid, :values, combine=last)
        @test res ≅ unstack(df, :rowid, :colid, :values, combine=last)
        @test unwrap.(res.rowid) == unique(df.rowid)
        @test names(res, Not(1)) == string.(unique(df.colid))
        res = unstack(df, :rowid, :colid, :values, combine=last, fill=0)
        @test res ≅
            unstack(df, :rowid, :colid, :values, combine=last, fill=0)
        @test unwrap.(res.rowid) == unique(df.rowid)
        @test names(res, Not(1)) == string.(unique(df.colid))
    end
end

@testset "variable_eltype in stack tests" begin
    df = DataFrame(A=1:3, B=[2.0, -1.1, 2.8], C=["p", "q", "r"])
    @test_throws MethodError stack(df, :C, variable_name=:D, variable_eltype=Int)
    for T in (AbstractString, Any)
        sdf = stack(df, [:A, :B], variable_name=:D, variable_eltype=T)
        @test sdf == DataFrame(C=["p", "q", "r", "p", "q", "r"],
                               D=["A", "A", "A", "B", "B", "B"],
                               value=[1.0, 2.0, 3.0, 2.0, -1.1, 2.8])
        @test sdf.C isa Vector{String}
        @test sdf.value isa Vector{Float64}
        @test sdf.D isa PooledVector{T}
    end
end

@testset "unstack hard cases" begin
    df = DataFrame(a=["ax", "bx", "cx"], b=["x", "y", "z"], c=[1, 2, 3])

    @test unstack(df, :a, :a, :a) ≅ DataFrame(a=["ax", "bx", "cx"],
                                              ax=["ax", missing, missing],
                                              bx=[missing, "bx", missing],
                                              cx=[missing, missing, "cx"])
    @test unstack(df, :c, :b, :a) ≅ DataFrame(c=[1, 2, 3],
                                              x=["ax", missing, missing],
                                              y=[missing, "bx", missing],
                                              z=[missing, missing, "cx"])
    @test unstack(df, [:b, :c], :c, :a) ≅ DataFrame("b" => ["x", "y", "z"],
                                                    "c" => [1, 2, 3],
                                                    "1" => ["ax", missing, missing],
                                                    "2" => [missing, "bx", missing],
                                                    "3" => [missing, missing, "cx"])

    for r in (:a, :b, :c, "a", "b", "c", 1, 2, 3,
              [:a, :b], ["b", "a"], [2, 1],
              [:b, :a], ["a", "b"], [3, 2],
              [:a, :c], ["c", "a"], [1, 2],
              [1, 2, 3], [3, 2, 1], [2, 1, 3])
        for c in (:a, :b, :c, "a", "b", "c", 1, 2, 3)
            for v in (:a, :b, :c, "a", "b", "c", 1, 2, 3)
                @test unstack(df, r, c, v) ≅
                      broadcast(x -> x isa Vector ? only(x) : x, unstack(df, r, c, v, combine=copy))
            end
        end
    end

    df = DataFrame(values_out_3490283_=["a", "b", "c"],
                   values_out_3490283_1=["d", "e", "f"],
                   values_out_3490283_11=["g", "h", "i"])
    @test unstack(df, 3, 2, 1) ≅
          DataFrame(values_out_3490283_11=["g", "h", "i"],
                    d=["a", missing, missing],
                    e=[missing, "b", missing],
                    f=[missing, missing, "c"])
    @test unstack(df, 3, 2, 1, combine=only) ≅
          DataFrame(values_out_3490283_11=["g", "h", "i"],
                    d=["a", missing, missing],
                    e=[missing, "b", missing],
                    f=[missing, missing, "c"])
end

@testset "better unstack errors" begin
    df = DataFrame(x=1:3, y=["a", "b", "c"], z=11:13)
    @test unstack(df, :x, :y, :z) ≅
          DataFrame(x=1:3, a=[11, missing, missing], b=[missing, 12, missing], c=[missing, missing, 13])
    @test_throws ArgumentError unstack(df, :x, :y, :z, renamecols=x->"v")
    df = DataFrame(x=1:3, y=["a", "b", :a], z=11:13)
    @test_throws ArgumentError unstack(df, :x, :y, :z)
    df = DataFrame(x=1:3, y=["a", "b", "x"], z=11:13)
    @test_throws ArgumentError unstack(df, :x, :y, :z)
    df = DataFrame(x=1:3, y=["aa", "bb", "xc"], z=11:13)
    @test_throws ArgumentError unstack(df, :x, :y, :z, renamecols=first)
    df = DataFrame(x=1:3, y=["a", "b", missing], z=11:13)
    @test_throws ArgumentError unstack(df, :x, :y, :z)
    @test unstack(df, :x, :y, :z, allowmissing=true) ≅
    DataFrame(x=1:3, a=[11, missing, missing], b=[missing, 12, missing], missing=[missing, missing, 13])
end


@testset "better stack errors" begin
    df = DataFrame(foo=["a","a","b"], variable=["x","x","x"], v1=[1,1.5,2], v2=[10,11.5,13.5])
    @test_throws ArgumentError stack(df)
    @test_throws ArgumentError stack(df, [:v1, :v2], variable_name=:foo)
    @test_throws ArgumentError stack(df, [:v1, :v2], value_name=:foo)
    df2 = DataFrame(foo=["a","b"], value=["x","y"], v1=[1,2])
    @test_throws ArgumentError stack(df2, [:v1], value_name=:foo)
    # view=true path
    @test_throws ArgumentError stack(df, [:v1, :v2], view=true)
    @test_throws ArgumentError stack(df, [:v1, :v2], variable_name=:foo, view=true)
end


end # module

"""
    table_transformation(df_sel::AbstractDataFrame, fun)

This is the function called when `AsTable(...) => fun` is requested. The
`df_sel` argument is a data frame storing columns selected by the `AsTable(...)`
selector.

By default it calls `default_table_transformation`. However, it is
allowed to add special methods for specific types of `fun`, as long as
the result matches what would be produced by
`default_table_transformation`, except that it is allowed to perform `eltype`
conversion of the resulting vectors or value type promotions that are consistent
with `promote_type`.

It is guaranteed that `df_sel` has at least one column.

The main use of special `table_transformation` methods is to provide more
efficient than the default implementations of requested `fun` transformation.

This function might become a part of the public API of DataFrames.jl in the
future, currently it should be considered experimental.

Fast paths are implemented within DataFrames.jl for the following functions `fun`:
* `sum`, `ByRow(sum)`, `ByRow(sum∘skipmissing)`
* `length`, `ByRow(length)`, `ByRow(length∘skipmissing)`
* `mean`, `ByRow(mean)`, `ByRow(mean∘skipmissing)`
* `ByRow(var)`, `ByRow(var∘skipmissing)`
* `ByRow(std)`, `ByRow(std∘skipmissing)`
* `ByRow(median)`, `ByRow(median∘skipmissing)`
* `minimum`, `ByRow(minimum)`, `ByRow(minimum∘skipmissing)`
* `maximum`, `ByRow(maximum)`, `ByRow(maximum∘skipmissing)`
* `fun∘collect` and `ByRow(fun∘collect)` where `fun` is any function

Note that in order to improve the performance `ByRow(sum)`,
`ByRow(sum∘skipmissing)`, `ByRow(mean)`, and `ByRow(mean∘skipmissing)`
perform all operations in the target element type. In some very rare cases
(like mixing very large `Int64` values and `Float64` values)
it can lead to a result different from the one that would
be obtained by calling the function outside of DataFrames.jl. The way to
avoid this precision loss is to use an anonymous function, e.g. instead of
`ByRow(sum)` use `ByRow(x -> sum(x))`. However, in general for such
scenarios even standard aggregation functions should not be considered to
provide reliable output, and users are recommended to switch to higher precision
calculations. An example of a case when standard `sum` is affected by the
situation discussed is:
```
julia> sum(Any[typemax(Int), typemax(Int), 1.0])
-1.0

julia> sum(Any[1.0, typemax(Int), typemax(Int)])
1.8446744073709552e19
```
"""
table_transformation(df_sel::AbstractDataFrame, fun) =
    default_table_transformation(df_sel, fun)

"""
    isreadonly(fun)

Trait returning a `Bool` indicator if function `fun` is only reading the passed
argument. Such a function guarantees not to modify nor return in any form the
passed argument. By default `false` is returned.

This function might become a part of the public API of DataFrames.jl in the
future, currently it should be considered experimental. Adding a method to
`isreadonly` for a specific function `fun` will improve performance of
`AsTable(...) => ByRow(fun∘collect)` operation.
"""
isreadonly(::Any) = false
isreadonly(::typeof(sum)) = true
isreadonly(::typeof(sum∘skipmissing)) = true
isreadonly(::typeof(length)) = true
isreadonly(::typeof(mean)) = true
isreadonly(::typeof(mean∘skipmissing)) = true
isreadonly(::typeof(var)) = true
isreadonly(::typeof(var∘skipmissing)) = true
isreadonly(::typeof(std)) = true
isreadonly(::typeof(std∘skipmissing)) = true
isreadonly(::typeof(median)) = true
isreadonly(::typeof(median∘skipmissing)) = true
isreadonly(::typeof(minimum)) = true
isreadonly(::typeof(minimum∘skipmissing)) = true
isreadonly(::typeof(maximum)) = true
isreadonly(::typeof(maximum∘skipmissing)) = true
isreadonly(::typeof(prod)) = true
isreadonly(::typeof(prod∘skipmissing)) = true
isreadonly(::typeof(first)) = true
isreadonly(::typeof(first∘skipmissing)) = true
isreadonly(::typeof(last)) = true

"""
    default_table_transformation(df_sel::AbstractDataFrame, fun)

This is a default implementation called when `AsTable(...) => fun` is requested.
The `df_sel` argument is a data frame storing columns selected by
`AsTable(...)` selector.
"""
function default_table_transformation(df_sel::AbstractDataFrame, fun)
    if fun isa ByRow && fun.fun isa ComposedFunction{<:Any, typeof(collect)}
        vT = unique(typeof.(eachcol(df_sel)))
        if length(vT) == 1 # homogeneous type
            T = eltype(vT[1])
            cT = vT[1]
        elseif length(vT) == 2 # small union
            # Base.promote_typejoin is used wen collecting NamedTuple elements
            T = Base.promote_typejoin(eltype(vT[1]), eltype(vT[2]))
            cT = Union{vT[1], vT[2]}
        else # large union
            # use Base.promote_typejoin to make sure that in case all columns
            # have <:Real eltype the v vector has <:Real eltype which
            # is required by some functions, eg. in StatsBase.jl
            T = mapreduce(eltype, Base.promote_typejoin, vT)
            # use Any for cT, as the common type of columns will be abstract
            # anyway, so it is better to use Any as it should reduce compilation latency
            cT = Any
        end
        v = Vector{T}(undef, ncol(df_sel))
        cols = collect(cT, eachcol(df_sel))
        readonly = isreadonly(fun.fun.outer)
        return _fast_row_aggregate_collect(fun.fun.outer, v, cols, readonly)
    elseif fun isa ComposedFunction{<:Any, typeof(collect)}
        # this will narrow down eltype of the resulting vector
        # but will not perform conversion
        return fun(map(identity, eachcol(df_sel)))
    else
        return fun(Tables.columntable(df_sel))
    end
end

function _populate_v!(v::Vector, cols::Vector, len::Int, i::Int, readonly::Bool)
    for j in 1:len
        @inbounds v[j] = cols[j][i]
    end
    return readonly ? v : copy(v)
end

function _fast_row_aggregate_collect(fun, v::Vector, cols::Vector, readonly::Bool)
    len = length(v)
    n = length(cols[1])
    @assert all(x -> length(x) == n, cols)
    return [fun(_populate_v!(v, cols, len, i, readonly)) for i in 1:n]
end

# this is slower than _sum_fast below, but is required if we want
# to produce the same results as we would without using fast path
# due to the differences in the implementation in Julia Base of sum aggregation
table_transformation(df_sel::AbstractDataFrame, ::typeof(sum)) =
    sum(map(identity, eachcol(df_sel)))

function table_transformation(df_sel::AbstractDataFrame, fun::ByRow{typeof(sum)})
    fastsum = _sum_fast(map(identity, eachcol(df_sel)))
    isnothing(fastsum) || return fastsum
    slowsum = default_table_transformation(df_sel, fun)
    isconcretetype(nonmissingtype(eltype(slowsum))) && return slowsum
    T = mapreduce(typeof, promote_type, slowsum)
    return convert(AbstractVector{T}, slowsum)
end

function _sum_fast(cols::Vector{<:AbstractVector})
    local sumz
    hadmissing = false
    sumz_undefined = true
    for col in cols
        try
            ec = eltype(col)
            if ec >: Missing
                hadmissing = true
            end
            zec = zero(ec)
            zi = Base.add_sum(zec, zec)
            if sumz_undefined
                sumz_undefined = false
                sumz = zi
            else
                sumz = Base.add_sum(sumz, zi)
            end
        catch e
            if e isa MethodError && e.f === zero
                sumz_undefined = true
                break
            else
                throw(e)
            end
        end
    end
    # this will happen if eltype of some columns do not support zero
    sumz_undefined && return nothing
    if hadmissing
        Tres = Union{Missing, typeof(sumz)}
    else
        Tres = typeof(sumz)
    end

    Tres === Missing && return missings(length(cols[1]))

    res = fill!(Tables.allocatecolumn(Tres, length(cols[1])), sumz)

    for (i, col) in enumerate(cols)
        if i == 1
            res .= col
        else
            res .= Base.add_sum.(res, col)
        end
    end

    return res
end

function table_transformation(df_sel::AbstractDataFrame,
                              fun::typeof(ByRow(sum∘skipmissing)))
    fastsum = _sum_skipmissing_fast(map(identity, eachcol(df_sel)))
    isnothing(fastsum) || return fastsum
    slowsum = default_table_transformation(df_sel, fun)
    isconcretetype(nonmissingtype(eltype(slowsum))) && return slowsum
    T = mapreduce(typeof, promote_type, slowsum)
    return convert(AbstractVector{T}, slowsum)
end

function _sum_skipmissing_fast(cols::Vector{<:AbstractVector})
    local sumz
    sumz_undefined = true
    for col in cols
        try
            zec = zero(eltype(col))
            zi = Base.add_sum(zec, zec)
            if !ismissing(zi)
                if sumz_undefined
                    sumz_undefined = false
                    sumz = zi
                else
                    sumz = Base.add_sum(sumz, zi)
                end
            end
        catch e
            if e isa MethodError && e.f === zero
                sumz_undefined = true
                break
            else
                throw(e)
            end
        end
    end
    # this will happen if eltype of some columns do not support zero
    # or all columns have eltype Missing
    sumz_undefined && return nothing
    res = fill!(Tables.allocatecolumn(typeof(sumz), length(cols[1])), sumz)

    for col in cols
        res .= ifelse.(ismissing.(col), res, Base.add_sum.(res, col))
    end

    return res
end

table_transformation(df_sel::AbstractDataFrame, ::typeof(length)) = ncol(df_sel)

table_transformation(df_sel::AbstractDataFrame, ::ByRow{typeof(length)}) =
    fill(ncol(df_sel), nrow(df_sel))

table_transformation(df_sel::AbstractDataFrame,
                     ::ByRow{typeof(length∘skipmissing)}) =
    _length_skipmissing_fast(map(identity, eachcol(df_sel)))

function _length_skipmissing_fast(cols::Vector{<:AbstractVector})
    len = fill(length(cols), length(cols[1]))
    for col in cols
        (Missing <: eltype(col)) && (len .-= ismissing.(col))
    end
    return len
end

table_transformation(df_sel::AbstractDataFrame, ::typeof(mean)) =
    mean(map(identity, eachcol(df_sel)))

function table_transformation(df_sel::AbstractDataFrame, fun::ByRow{typeof(mean)})
    fastmean = _mean_fast(map(identity, eachcol(df_sel)))
    isnothing(fastmean) || return fastmean
    slowmean = default_table_transformation(df_sel, fun)
    isconcretetype(nonmissingtype(eltype(slowmean))) && return slowmean
    T = mapreduce(typeof, promote_type, slowmean)
    return convert(AbstractVector{T}, slowmean)
end

function _mean_fast(cols::Vector{<:AbstractVector})
    local sumz
    hadmissing = false
    sumz_undefined = true
    for col in cols
        try
            ec = eltype(col)
            if ec >: Missing
                hadmissing = true
            end
            zi = zero(ec) / 1
            if sumz_undefined
                sumz_undefined = false
                sumz = zi
            else
                sumz += zi
            end
        catch e
            if e isa MethodError && e.f === zero
                sumz_undefined = true
                break
            else
                throw(e)
            end
        end
    end
    # this will happen if eltype of some columns do not support zero
    sumz_undefined && return nothing
    if hadmissing
        Tres = Union{Missing, typeof(sumz)}
    else
        Tres = typeof(sumz)
    end

    Tres === Missing && return missings(length(cols[1]))

    res = fill!(Tables.allocatecolumn(Tres, length(cols[1])), sumz)

    for (i, col) in enumerate(cols)
        if i == 1
            res .= col
        else
            res .+= col
        end
    end
    res ./= length(cols)
    return res
end

function table_transformation(df_sel::AbstractDataFrame,
                              fun::typeof(ByRow(mean∘skipmissing)))
    fastmean = _mean_skipmissing_fast(map(identity, eachcol(df_sel)))
    isnothing(fastmean) || return fastmean
    slowmean = default_table_transformation(df_sel, fun)
    isconcretetype(nonmissingtype(eltype(slowmean))) && return slowmean
    T = mapreduce(typeof, promote_type, slowmean)
    return convert(AbstractVector{T}, slowmean)
end

function _mean_skipmissing_fast(cols::Vector{<:AbstractVector})
    local sumz
    sumz_undefined = true
    for col in cols
        T = nonmissingtype(eltype(col))
        T === Union{} && continue
        # if T is not concrete we cannot reliably implement fast path
        isconcretetype(T) || return nothing
        try
            zi = zero(T) / 1
            if sumz_undefined
                sumz_undefined = false
                sumz = zi
            else
                sumz += zi
            end
        catch e
            if e isa MethodError && e.f === zero
                sumz_undefined = true
                break
            else
                throw(e)
            end
        end
    end
    # this will happen if eltype of some columns do not support zero
    # or all columns have eltype Missing
    sumz_undefined && return nothing
    sumv = fill!(Tables.allocatecolumn(typeof(sumz), length(cols[1])), sumz)
    lenv = zeros(Int, length(sumv))

    for col in cols
        sumv .= ifelse.(ismissing.(col), sumv, sumv .+ col)
        lenv .+= .!ismissing.(col)
    end
    sumv ./= lenv
    return sumv
end

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(minimum))) =
    _minmax_row_fast(map(identity, eachcol(df_sel)), min)

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(maximum))) =
    _minmax_row_fast(map(identity, eachcol(df_sel)), max)

function _minmax_row_fast(cols::Vector{<:AbstractVector},
                          fun::Union{typeof(min), typeof(max)})
    T = mapreduce(eltype, promote_type, cols)
    res = Tables.allocatecolumn(T, length(cols[1]))
    res .= cols[1]
    for i in 2:length(cols)
        res .= fun.(res, cols[i])
    end
    return res
end

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(minimum∘skipmissing))) =
    _minmax_row_fast_skipmissing(map(identity, eachcol(df_sel)), _min_missing)

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(maximum∘skipmissing))) =
    _minmax_row_fast_skipmissing(map(identity, eachcol(df_sel)), _max_missing)

function _min_missing(a, b)
    ismissing(b) && return a
    ismissing(a) && return b
    return min(a, b)
end

function _max_missing(a, b)
    ismissing(b) && return a
    ismissing(a) && return b
    return max(a, b)
end

function _minmax_row_fast_skipmissing(cols::Vector{<:AbstractVector},
                                      fun::Union{typeof(_min_missing),
                                                 typeof(_max_missing)})
    T = mapreduce(eltype, promote_type, cols)
    res = Tables.allocatecolumn(Union{Missing, T}, length(cols[1]))
    res .= cols[1]
    for i in 2:length(cols)
        res .= fun.(res, cols[i])
    end
    if any(ismissing, res)
        throw(ArgumentError("some rows of selected columns contained only missing values"))
    end
    return disallowmissing(res)
end

function table_transformation(df_sel::AbstractDataFrame, ::typeof(minimum))
    return reduce(min, map(identity, eachcol(df_sel)))
end

function table_transformation(df_sel::AbstractDataFrame, ::typeof(maximum))
    return reduce(max, map(identity, eachcol(df_sel)))
end

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(std))) =
    table_transformation(df_sel, ByRow(std∘collect))
table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(std∘skipmissing))) =
    table_transformation(df_sel, ByRow(std∘skipmissing∘collect))

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(var))) =
    table_transformation(df_sel, ByRow(var∘collect))
table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(var∘skipmissing))) =
    table_transformation(df_sel, ByRow(var∘skipmissing∘collect))

table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(median))) =
    table_transformation(df_sel, ByRow(median!∘collect))
table_transformation(df_sel::AbstractDataFrame, ::typeof(ByRow(median∘skipmissing))) =
    table_transformation(df_sel, ByRow(median∘skipmissing∘collect))

abstract type FirstColCount end

struct FirstMultiCol <: FirstColCount end
struct FirstSingleCol <: FirstColCount end

firstcoltype(firstmulticol::Bool) =
    firstmulticol ? FirstMultiCol() : FirstSingleCol()

# Wrapping automatically adds column names when the value returned
# by the user-provided function lacks them
wrap(x::AbstractDataFrame) = x
wrap(x::DataFrameRow) = x
wrap(x::Tables.AbstractRow) = x
wrap(x::NamedTuple) = x
function wrap(x::NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}})
    if !isempty(x)
        len1 = length(x[1])
        for i in 2:length(x)
            length(x[i]) == len1 || throw(DimensionMismatch("all vectors returned in a " *
                                                            "NamedTuple must have the same length"))
        end
    end
    return x
end
wrap(x::AbstractMatrix) =
    NamedTuple{Tuple(gennames(size(x, 2)))}(Tuple(view(x, :, i) for i in 1:size(x, 2)))
wrap(x::Any) = (x1=x,)

const ERROR_ROW_COUNT = "return value must not change its kind " *
                        "(single row or variable number of rows) across groups"

const ERROR_COL_COUNT = "function must return only single-column values, " *
                        "or only multiple-column values"

wrap_table(x::Any, ::FirstSingleCol) =
    throw(ArgumentError(ERROR_ROW_COUNT))
wrap_table(x::Any, ::FirstMultiCol) =
    throw(ArgumentError(ERROR_ROW_COUNT))
wrap_table(x::Union{NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}},
                    AbstractDataFrame, AbstractMatrix}, ::FirstSingleCol) =
        throw(ArgumentError(ERROR_COL_COUNT))
wrap_table(x::Union{NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}},
                    AbstractDataFrame, AbstractMatrix}, ::FirstMultiCol) =
    wrap(x)
wrap_table(x::AbstractVector, ::FirstSingleCol) = wrap(x)
wrap_table(x::AbstractVector, ::FirstMultiCol) = throw(ArgumentError(ERROR_COL_COUNT))

wrap_row(x::DataFrameRow, ::FirstSingleCol) = throw(ArgumentError(ERROR_COL_COUNT))
wrap_row(x::DataFrameRow, ::FirstMultiCol) = wrap(x)

wrap_row(x::Tables.AbstractRow, ::FirstSingleCol) = throw(ArgumentError(ERROR_COL_COUNT))
wrap_row(x::Tables.AbstractRow, ::FirstMultiCol) = wrap(x)

wrap_row(x::Any, ::FirstSingleCol) = wrap(x)
# NamedTuple is not possible in this branch
wrap_row(x::Any, ::FirstMultiCol) = throw(ArgumentError(ERROR_COL_COUNT))

wrap_row(x::Union{AbstractArray{<:Any, 0}, Ref}, ::FirstMultiCol) =
    throw(ArgumentError(ERROR_COL_COUNT))
wrap_row(x::Union{AbstractArray{<:Any, 0}, Ref}, ::FirstSingleCol) =
    (x1 = x[],)
# note that also NamedTuple() is correctly captured by this definition
# as it is more specific than the one below
wrap_row(::Union{AbstractVecOrMat, AbstractDataFrame,
                 NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}}, ::FirstSingleCol) =
    throw(ArgumentError(ERROR_ROW_COUNT))
wrap_row(::Union{AbstractVecOrMat, AbstractDataFrame,
                 NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}}, ::FirstMultiCol) =
    throw(ArgumentError(ERROR_ROW_COUNT))

wrap_row(x::NamedTuple, ::FirstSingleCol) = throw(ArgumentError(ERROR_COL_COUNT))

function wrap_row(x::NamedTuple, ::FirstMultiCol)
    if any(v -> v isa AbstractVector, x)
        throw(ArgumentError("mixing single values and vectors in a named tuple is not allowed"))
    end
    return x
end

# idx, starts and ends are passed separately to avoid cost of field access in tight loop
# Manual unrolling of Tuple is used as it turned out more efficient than @generated
# for small number of columns passed.
# For more than 4 columns `map` is slower than @generated
# but this case is probably rare and if huge number of columns is passed @generated
# has very high compilation cost
function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::Tuple{}, i::Integer)
    if f isa ByRow
        return [f.fun() for _ in 1:(ends[i] - starts[i] + 1)]
    else
        return f()
    end
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::Tuple{AbstractVector}, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(view(incols[1], idx))
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::NTuple{2, AbstractVector}, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(view(incols[1], idx), view(incols[2], idx))
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::NTuple{3, AbstractVector}, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(view(incols[1], idx), view(incols[2], idx), view(incols[3], idx))
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::NTuple{4, AbstractVector}, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(view(incols[1], idx), view(incols[2], idx), view(incols[3], idx),
             view(incols[4], idx))
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::Tuple, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(map(c -> view(c, idx), incols)...)
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::NamedTuple, i::Integer)
    if f isa ByRow && isempty(incols)
        return [f.fun(NamedTuple()) for _ in 1:(ends[i] - starts[i] + 1)]
    else
        idx = view(idx, starts[i]:ends[i])
        return f(map(c -> view(c, idx), incols))
    end
end

function do_call(f::Base.Callable, idx::AbstractVector{<:Integer},
                 starts::AbstractVector{<:Integer}, ends::AbstractVector{<:Integer},
                 gd::GroupedDataFrame, incols::Nothing, i::Integer)
    idx = view(idx, starts[i]:ends[i])
    return f(view(parent(gd), idx, :))
end

### Broadcasting

Base.getindex(df::AbstractDataFrame, idx::CartesianIndex{2}) = df[idx[1], idx[2]]
Base.view(df::AbstractDataFrame, idx::CartesianIndex{2}) = view(df, idx[1], idx[2])
Base.setindex!(df::AbstractDataFrame, val, idx::CartesianIndex{2}) =
    (df[idx[1], idx[2]] = val)

Base.broadcastable(df::AbstractDataFrame) = df

struct DataFrameStyle <: Base.Broadcast.BroadcastStyle end

Base.Broadcast.BroadcastStyle(::Type{<:AbstractDataFrame}) =
    DataFrameStyle()

Base.Broadcast.BroadcastStyle(::DataFrameStyle, ::Base.Broadcast.BroadcastStyle) =
    DataFrameStyle()
Base.Broadcast.BroadcastStyle(::Base.Broadcast.BroadcastStyle, ::DataFrameStyle) =
    DataFrameStyle()
Base.Broadcast.BroadcastStyle(::DataFrameStyle, ::DataFrameStyle) = DataFrameStyle()
# The method below is added to avoid dispatch ambiguity
Base.Broadcast.BroadcastStyle(::DataFrameStyle, ::Base.Broadcast.Unknown) =
    DataFrameStyle()

function copyto_widen!(res::AbstractVector{T}, bc::Base.Broadcast.Broadcasted,
                       pos, col) where T
    for i in pos:length(axes(bc)[1])
        val = bc[CartesianIndex(i, col)]
        S = typeof(val)
        if S <: T || promote_type(S, T) <: T
            res[i] = val
        else
            newres = similar(Vector{promote_type(S, T)}, length(res))
            copyto!(newres, 1, res, 1, i-1)
            newres[i] = val
            return copyto_widen!(newres, bc, i + 1, col)
        end
    end
    return res
end

function getcolbc(bcf::Base.Broadcast.Broadcasted{Style}, colind) where {Style}
    # we assume that bcf is already flattened and unaliased
    newargs = map(bcf.args) do x
        Base.Broadcast.extrude(x isa AbstractDataFrame ? x[!, colind] : x)
    end
    return Base.Broadcast.Broadcasted{Style}(bcf.f, newargs, bcf.axes)
end

function Base.copy(bc::Base.Broadcast.Broadcasted{DataFrameStyle})
    ndim = length(axes(bc))
    if ndim != 2
        throw(DimensionMismatch("cannot broadcast a data frame into $ndim dimensions"))
    end
    bcf = Base.Broadcast.flatten(bc)
    colnames = unique!(Any[_names(df) for df in bcf.args if df isa AbstractDataFrame])
    if length(colnames) != 1
        wrongnames = setdiff(union(colnames...), intersect(colnames...))
        if isempty(wrongnames)
            throw(ArgumentError("Column names in broadcasted data frames " *
                                "must have the same order"))
        else
            msg = join(wrongnames, ", ", " and ")
            throw(ArgumentError("Column names in broadcasted data frames must match. " *
                                "Non matching column names are $msg"))
        end
    end
    nrows = length(axes(bcf)[1])
    df = DataFrame()
    for i in axes(bcf)[2]
        if nrows == 0
            col = Any[]
        else
            bcf′ = getcolbc(bcf, i)
            v1 = bcf′[CartesianIndex(1, i)]
            startcol = similar(Vector{typeof(v1)}, nrows)
            startcol[1] = v1
            col = copyto_widen!(startcol, bcf′, 2, i)
        end
        df[!, colnames[1][i]] = col
    end

    dfs = AbstractDataFrame[df for df in bcf.args if df isa AbstractDataFrame]
    @assert !isempty(dfs)

    _merge_matching_table_note_metadata!(df, dfs)

    if all(x -> !isempty(colmetadatakeys(x)), dfs)
        for colname in _names(df)
            if length(dfs) == 1
                _copy_col_note_metadata!(df, colname, only(dfs), colname)
            else
                if all(x -> !isempty(colmetadatakeys(x, colname)), dfs)
                    for key1 in colmetadatakeys(dfs[1], colname)
                        val1, style1 = colmetadata(dfs[1], colname, key1, style=true)
                        if style1 === :note
                            add_meta = true
                            for i in 2:length(dfs)
                                if key1 in colmetadatakeys(dfs[i], colname)
                                    vali, stylei = colmetadata(dfs[i], colname, key1, style=true)
                                    if !(stylei === :note && isequal(val1, vali))
                                        add_meta = false
                                        break
                                    end
                                else
                                    add_meta = false
                                    break
                                end
                            end
                            add_meta && colmetadata!(df, colname, key1, val1, style=:note)
                        end
                    end
                end
            end
        end
    end

    return df
end

### Broadcasting assignment

struct LazyNewColDataFrame{T,D}
    df::D
    col::T
end

Base.axes(x::LazyNewColDataFrame) = (Base.OneTo(nrow(x.df)),)
Base.ndims(::Type{<:LazyNewColDataFrame}) = 1

struct ColReplaceDataFrame{T<:AbstractDataFrame}
    df::T
    cols::Vector{Int}
end

Base.axes(x::ColReplaceDataFrame) = (axes(x.df, 1), Base.OneTo(length(x.cols)))
Base.ndims(::Type{<:ColReplaceDataFrame}) = 2

# In the functions below we need to call _drop_all_nonnote_metadata!
# upfront as the rest of the operations is handled by Base Julia

function Base.maybeview(df::AbstractDataFrame, idx::CartesianIndex{2})
    _drop_all_nonnote_metadata!(parent(df))
    return df[idx]
end

function Base.maybeview(df::AbstractDataFrame, row::Integer, col::ColumnIndex)
    _drop_all_nonnote_metadata!(parent(df))
    return df[row, col]
end

function Base.maybeview(df::AbstractDataFrame, rows, cols)
    _drop_all_nonnote_metadata!(parent(df))
    return view(df, rows, cols)
end

function Base.dotview(df::AbstractDataFrame, ::Colon, cols::ColumnIndex)
    if haskey(index(df), cols)
        _drop_all_nonnote_metadata!(parent(df))
        return view(df, :, cols)
    end
    if !(cols isa SymbolOrString)
        throw(ArgumentError("creating new columns using an integer index is disallowed"))
    end
    if !is_column_insertion_allowed(df)
        throw(ArgumentError("creating new columns in a SubDataFrame that subsets " *
                            "columns of its parent data frame is disallowed"))
    end
    return LazyNewColDataFrame(df, Symbol(cols))
end

function Base.dotview(df::AbstractDataFrame, ::typeof(!), cols)
    if !(cols isa ColumnIndex)
        return ColReplaceDataFrame(df, convert(Vector{Int}, index(df)[cols]))
    end
    if cols isa SymbolOrString
        if columnindex(df, cols) == 0 && !is_column_insertion_allowed(df)
            throw(ArgumentError("creating new columns in a SubDataFrame that subsets " *
                                "columns of its parent data frame is disallowed"))
        end
    elseif !(1 <= cols <= ncol(df))
        throw(ArgumentError("creating new columns using an integer index is disallowed"))
    end
    return LazyNewColDataFrame(df, cols isa AbstractString ? Symbol(cols) : cols)
end

function Base.dotgetproperty(df::AbstractDataFrame, col::SymbolOrString)
    if columnindex(df, col) == 0 && !is_column_insertion_allowed(df)
        throw(ArgumentError("creating new columns in a SubDataFrame that subsets " *
                            "columns of its parent data frame is disallowed"))
    end
    return LazyNewColDataFrame(df, Symbol(col))
end

function Base.copyto!(lazydf::LazyNewColDataFrame, bc::Base.Broadcast.Broadcasted{T}) where T
    df = lazydf.df
    if !haskey(index(df), lazydf.col) && df isa SubDataFrame && lazydf.col isa SymbolOrString
        @assert is_column_insertion_allowed(df)
    end
    if bc isa Base.Broadcast.Broadcasted{<:Base.Broadcast.AbstractArrayStyle{0}}
        bc_tmp = Base.Broadcast.Broadcasted{T}(bc.f, bc.args, ())
        v = Base.Broadcast.materialize(bc_tmp)
        col = similar(Vector{typeof(v)}, nrow(df))
        copyto!(col, bc)
    else
        col = Base.Broadcast.materialize(bc)
    end

    return df[!, lazydf.col] = col
end

function _copyto_helper!(dfcol::AbstractVector, bc::Base.Broadcast.Broadcasted, col::Int)
    if axes(dfcol, 1) != axes(bc)[1]
        # this should never happen unless data frame is corrupted (has unequal column lengths)
        throw(DimensionMismatch("Dimension mismatch in broadcasting. The updated" *
                                " data frame is invalid and should not be used"))
    end
    @inbounds for row in eachindex(dfcol)
        dfcol[row] = bc[CartesianIndex(row, col)]
    end
end

function Base.Broadcast.broadcast_unalias(dest::AbstractDataFrame, src)
    for col in eachcol(dest)
        src = Base.Broadcast.unalias(col, src)
    end
    return src
end

# The method below is added to avoid dispatch ambiguity
Base.Broadcast.broadcast_unalias(::Nothing, src::AbstractDataFrame) = src

function Base.Broadcast.broadcast_unalias(dest, src::AbstractDataFrame)
    wascopied = false
    for (i, col) in enumerate(eachcol(src))
        if Base.mightalias(dest, col)
            if src isa SubDataFrame
                if !wascopied
                    src = SubDataFrame(copy(parent(src), copycols=false),
                                       index(src), rows(src))
                end
                parentidx = parentcols(index(src), i)
                parent(src)[!, parentidx] = Base.unaliascopy(parent(src)[!, parentidx])
            else
                if !wascopied
                    src = copy(src, copycols=false)
                end
                src[!, i] = Base.unaliascopy(col)
            end
            wascopied = true
        end
    end
    return src
end

function _broadcast_unalias_helper(dest::AbstractDataFrame, scol::AbstractVector,
                                   src::AbstractDataFrame, col2::Int, wascopied::Bool)
    # col1 can be checked till col2 point as we are writing broadcasting
    # results from 1 to ncol
    # we go downwards because aliasing when col1 == col2 is most probable
    for col1 in col2:-1:1
        dcol = dest[!, col1]
        if Base.mightalias(dcol, scol)
            if src isa SubDataFrame
                if !wascopied
                    src =SubDataFrame(copy(parent(src), copycols=false),
                                      index(src), rows(src))
                end
                parentidx = parentcols(index(src), col2)
                parent(src)[!, parentidx] = Base.unaliascopy(parent(src)[!, parentidx])
            else
                if !wascopied
                    src = copy(src, copycols=false)
                end
                src[!, col2] = Base.unaliascopy(scol)
            end
            return src, true
        end
    end
    return src, wascopied
end

function Base.Broadcast.broadcast_unalias(dest::AbstractDataFrame, src::AbstractDataFrame)
    if size(dest, 2) != size(src, 2)
        throw(DimensionMismatch("Dimension mismatch in broadcasting."))
    end
    wascopied = false
    for col2 in axes(dest, 2)
        scol = src[!, col2]
        src, wascopied = _broadcast_unalias_helper(dest, scol, src, col2, wascopied)
    end
    return src
end

function Base.copyto!(df::AbstractDataFrame, bc::Base.Broadcast.Broadcasted)
    bcf = Base.Broadcast.flatten(bc)
    colnames = unique!(Any[_names(x) for x in bcf.args if x isa AbstractDataFrame])
    if length(colnames) > 1 || (length(colnames) == 1 && _names(df) != colnames[1])
        push!(colnames, _names(df))
        wrongnames = setdiff(union(colnames...), intersect(colnames...))
        if isempty(wrongnames)
            throw(ArgumentError("Column names in broadcasted data frames " *
                                "must have the same order"))
        else
            msg = join(wrongnames, ", ", " and ")
            throw(ArgumentError("Column names in broadcasted data frames must match. " *
                                "Non matching column names are $msg"))
        end
    end

    bcf′ = Base.Broadcast.preprocess(df, bcf)
    for i in axes(df, 2)
        _copyto_helper!(df[!, i], getcolbc(bcf′, i), i)
    end
    _drop_all_nonnote_metadata!(parent(df))
    return df
end

function Base.copyto!(df::AbstractDataFrame,
                      bc::Base.Broadcast.Broadcasted{<:Base.Broadcast.AbstractArrayStyle{0}})
    # special case of fast approach when bc is providing an untransformed scalar
    if bc.f === identity && bc.args isa Tuple{Any} && Base.Broadcast.isflat(bc)
        for col in axes(df, 2)
            fill!(df[!, col], bc.args[1][])
        end
        return df
    else
        return copyto!(df, convert(Base.Broadcast.Broadcasted{Nothing}, bc))
    end
end

create_bc_tmp(bcf′_col::Base.Broadcast.Broadcasted{T}) where {T} =
    Base.Broadcast.Broadcasted{T}(bcf′_col.f, bcf′_col.args, ())

function Base.copyto!(crdf::ColReplaceDataFrame, bc::Base.Broadcast.Broadcasted)
    bcf = Base.Broadcast.flatten(bc)
    colnames = unique!(Any[_names(x) for x in bcf.args if x isa AbstractDataFrame])
    if length(colnames) > 1 ||
        (length(colnames) == 1 && view(_names(crdf.df), crdf.cols) != colnames[1])
        push!(colnames, view(_names(crdf.df), crdf.cols))
        wrongnames = setdiff(union(colnames...), intersect(colnames...))
        if isempty(wrongnames)
            throw(ArgumentError("Column names in broadcasted data frames " *
                                "must have the same order"))
        else
            msg = join(wrongnames, ", ", " and ")
            throw(ArgumentError("Column names in broadcasted data frames must match. " *
                                "Non matching column names are $msg"))
        end
    end

    bcf′ = Base.Broadcast.preprocess(crdf, bcf)
    nrows = length(axes(bcf′)[1])
    for (i, col_idx) in enumerate(crdf.cols)
        bcf′_col = getcolbc(bcf′, i)
        if bcf′_col isa Base.Broadcast.Broadcasted{<:Base.Broadcast.AbstractArrayStyle{0}}
            bc_tmp = create_bc_tmp(bcf′_col)
            v = Base.Broadcast.materialize(bc_tmp)
            newcol = similar(Vector{typeof(v)}, nrow(crdf.df))
            copyto!(newcol, bc)
        else
            if nrows == 0
                newcol = Any[]
            else
                v1 = bcf′_col[CartesianIndex(1, i)]
                startcol = similar(Vector{typeof(v1)}, nrows)
                startcol[1] = v1
                newcol = copyto_widen!(startcol, bcf′_col, 2, i)
            end
        end
        crdf.df[!, col_idx] = newcol
    end
    return crdf.df
end

Base.Broadcast.broadcast_unalias(dest::DataFrameRow, src) =
    Base.Broadcast.broadcast_unalias(parent(dest), src)

# this is currently impossible but is added to avoid potential dispatch ambiguity in the future
Base.Broadcast.broadcast_unalias(dest::DataFrameRow, src::AbstractDataFrame) =
    Base.Broadcast.broadcast_unalias(parent(dest), src)

function Base.copyto!(dfr::DataFrameRow, bc::Base.Broadcast.Broadcasted)
    bc′ = Base.Broadcast.preprocess(dfr, bc)
    for I in eachindex(bc′)
        dfr[I] = bc′[I]
    end
    return dfr
end

Tables.istable(::Type{<:AbstractDataFrame}) = true
Tables.columnaccess(::Type{<:AbstractDataFrame}) = true
Tables.columns(df::AbstractDataFrame) = eachcol(df)
Tables.rowaccess(::Type{<:AbstractDataFrame}) = true
Tables.rows(df::AbstractDataFrame) = eachrow(df)
Tables.rowtable(df::AbstractDataFrame) = Tables.rowtable(Tables.columntable(df))
Tables.namedtupleiterator(df::AbstractDataFrame) =
    Tables.namedtupleiterator(Tables.columntable(df))

function Tables.columnindex(df::Union{AbstractDataFrame, DataFrameRow}, idx::Symbol)
    ind = index(df)
    if ind isa Index
        return get(ind.lookup, idx, 0)
    else
        parent_ind = ind.parent
        loc = get(parent_ind.lookup, idx, 0)
        return loc == 0 || loc > length(ind.remap) ? 0 : max(0, ind.remap[loc])
    end
end

Tables.columnindex(df::Union{AbstractDataFrame, DataFrameRow}, idx::AbstractString) =
    columnindex(df, Symbol(idx))

Tables.schema(df::AbstractDataFrame) = Tables.Schema(_names(df), [eltype(col) for col in eachcol(df)])
Tables.materializer(::Type{<:AbstractDataFrame}) = DataFrame

Tables.getcolumn(df::AbstractDataFrame, i::Int) = df[!, i]
Tables.getcolumn(df::AbstractDataFrame, nm::Symbol) = df[!, nm]

Tables.getcolumn(dfr::DataFrameRow, i::Int) = dfr[i]
Tables.getcolumn(dfr::DataFrameRow, nm::Symbol) = dfr[nm]

getvector(x::AbstractVector) = x
getvector(x) = [x[i] for i = 1:length(x)]

fromcolumns(x, names; copycols::Union{Nothing, Bool}=nothing) =
    DataFrame(AbstractVector[getvector(Tables.getcolumn(x, nm)) for nm in names],
              Index(names),
              copycols=something(copycols, true))

# note that copycols is false by default in this definition (Tables.CopiedColumns
# implies copies have already been made) but if `copycols=true`, a copy will still be
# made; this is useful for scenarios where the input is immutable so avoiding copies
# is desirable, but you may still want a copy for mutation (Arrow.Table is like this)
fromcolumns(x::Tables.CopiedColumns, names; copycols::Union{Nothing, Bool}=nothing) =
    fromcolumns(Tables.source(x), names; copycols=something(copycols, false))

function DataFrame(x; copycols::Union{Nothing, Bool}=nothing)
    # here we handle eltypes not specific enough to be dispatched
    # to other DataFrames constructors taking vector of `Pair`s
    if !Tables.istable(x) && x isa AbstractVector && !isempty(x) &&
        (all(v -> v isa Pair{Symbol, <:AbstractVector}, x) ||
         all(v -> v isa Pair{<:AbstractString, <:AbstractVector}, x))
        df = DataFrame(AbstractVector[last(v) for v in x], [first(v) for v in x],
                       copycols=something(copycols, true))
    else
        cols = Tables.columns(x)
        names = collect(Symbol, Tables.columnnames(cols))
        df = fromcolumns(cols, names, copycols=copycols)
    end
    _copy_all_all_metadata!(df, x)
    return df
end

# the logic here relies on the fact that Tables.CopiedColumns
# is the only exception for default copycols value
DataFrame(x, cnames::AbstractVector; makeunique::Bool=false,
          copycols::Union{Nothing, Bool}=nothing) =
    rename!(DataFrame(x, copycols=something(copycols, !(x isa Tables.CopiedColumns))),
            _name2symbol(cnames),
            makeunique=makeunique)

# This supports the Tables.RowTable type; needed to avoid ambiguities w/ another constructor
DataFrame(x::AbstractVector{NamedTuple{names, T}}; copycols::Bool=true) where {names, T} =
    fromcolumns(Tables.columns(Tables.IteratorWrapper(x)), collect(names), copycols=false)

Tables.istable(::Type{<:Union{DataFrameRows, DataFrameColumns}}) = true
Tables.columnaccess(::Type{<:Union{DataFrameRows, DataFrameColumns}}) = true
Tables.rowaccess(::Type{<:Union{DataFrameRows, DataFrameColumns}}) = true
Tables.columns(itr::Union{DataFrameRows, DataFrameColumns}) = Tables.columns(parent(itr))
Tables.rows(itr::Union{DataFrameRows, DataFrameColumns}) = Tables.rows(parent(itr))
Tables.schema(itr::Union{DataFrameRows, DataFrameColumns}) = Tables.schema(parent(itr))
Tables.rowtable(itr::Union{DataFrameRows, DataFrameColumns}) = Tables.rowtable(parent(itr))
Tables.namedtupleiterator(itr::Union{DataFrameRows, DataFrameColumns}) =
    Tables.namedtupleiterator(parent(itr))
Tables.materializer(::Type{<:Union{DataFrameRows, DataFrameColumns}}) =
    DataFrame

Tables.getcolumn(itr::Union{DataFrameRows, DataFrameColumns}, i::Int) =
    Tables.getcolumn(parent(itr), i)
Tables.getcolumn(itr::Union{DataFrameRows, DataFrameColumns}, nm::Symbol) =
    Tables.getcolumn(parent(itr), nm)

IteratorInterfaceExtensions.getiterator(df::AbstractDataFrame) =
    Tables.datavaluerows(Tables.columntable(df))
IteratorInterfaceExtensions.isiterable(x::AbstractDataFrame) = true
TableTraits.isiterabletable(x::AbstractDataFrame) = true

@inline function Tables.subset(df::AbstractDataFrame, inds; viewhint::Union{Bool, Nothing}=nothing)
    res = viewhint === true ? view(df, inds, :) : df[inds, :]
    if res isa DataFrameRow && viewhint === false
        return copy(res)
    else
        return res
    end
end

@inline function Tables.subset(itr::DataFrameRows, inds; viewhint::Union{Bool, Nothing}=nothing)
    res = Tables.subset(parent(itr), inds, viewhint=viewhint)
    return res isa AbstractDataFrame ? eachrow(res) : res
end

@inline function Tables.subset(itr::DataFrameColumns, inds; viewhint::Union{Bool, Nothing}=nothing)
    res = Tables.subset(parent(itr), inds, viewhint=viewhint)
    return res isa AbstractDataFrame ? eachcol(res) : res
end

# common utilities for getting and comparing column names

_getnames(x::NamedTuple) = propertynames(x)
_getnames(x::AbstractDataFrame) = _names(x)
_getnames(x::DataFrameRow) = _names(x)
_getnames(x::Tables.AbstractRow) = Tables.columnnames(x)
_getnames(x::GroupKey) = parent(x).cols

# this function is needed as == does not allow for comparison between tuples and vectors
function _equal_names(r1, r2)
    n1 = _getnames(r1)
    n2 = _getnames(r2)
    length(n1) == length(n2) || return false
    for (a, b) in zip(n1, n2)
        a == b || return false
    end
    return true
end

using Documenter
using DataFrames
using CategoricalArrays
using StableRNGs

DocMeta.setdocmeta!(DataFrames, :DocTestSetup, :(using DataFrames); recursive=true)

# Build documentation.
# ====================

makedocs(
    # options
    modules = [DataFrames],
    doctest = true,
    clean = false,
    sitename = "DataFrames.jl",
    format = Documenter.HTML(
        canonical = "https://juliadata.github.io/DataFrames.jl/stable/",
        assets = ["assets/favicon.ico"],
        edit_link = "main",
        size_threshold_ignore = ["man/basics.md", "lib/functions.md"],
    ),
    pages = Any[
        "Introduction" => "index.md",
        "First Steps with DataFrames.jl" => "man/basics.md",
        "User Guide" => Any[
            "Getting Started" => "man/getting_started.md",
            "Working with DataFrames" => "man/working_with_dataframes.md",
            "Importing and Exporting Data (I/O)" => "man/importing_and_exporting.md",
            "Joins" => "man/joins.md",
            "Split-apply-combine" => "man/split_apply_combine.md",
            "Reshaping" => "man/reshaping_and_pivoting.md",
            "Sorting" => "man/sorting.md",
            "Categorical Data" => "man/categorical.md",
            "Missing Data" => "man/missing.md",
            "Data manipulation frameworks" => "man/querying_frameworks.md",
            "Comparison with Python/R/Stata" => "man/comparisons.md"
        ],
        "API" => Any[
            "Types" => "lib/types.md",
            "Functions" => "lib/functions.md",
            "Indexing" => "lib/indexing.md",
            "Metadata" => "lib/metadata.md",
            hide("Internals" => "lib/internals.md"),
        ]
    ],
)

# Deploy built documentation.
# ===========================

deploydocs(
    # options
    repo = "github.com/JuliaData/DataFrames.jl.git",
    target = "build",
    deps = nothing,
    make = nothing,
    devbranch = "main"
)

function Base.summary(io::IO, gd::GroupedDataFrame)
    N = length(gd)
    keystr = length(gd.cols) > 1 ? "keys" : "key"
    groupstr = N == 1 ? "group" : "groups"
    print(io, "GroupedDataFrame with $N $groupstr based on $keystr: ")
    join(io, groupcols(gd), ", ")
end

function Base.show(io::IO, gd::GroupedDataFrame;
                   allgroups::Bool = !get(io, :limit, false),
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   truncate::Int = 32,
                   kwargs...)
    # Check for keywords that are valid in other backends but not here.
    _verify_kwargs_for_text(; kwargs...)

    N = length(gd)

    summary && Base.summary(io, gd)

    if allgroups
        for i = 1:N
            nrows = size(gd[i], 1)
            rows = nrows > 1 ? "rows" : "row"

            identified_groups = [string(col, " = ", repr(MIME("text/plain"), gd[i][1, col]))
                                 for col in gd.cols]

            print(io, "\nGroup $i ($nrows $rows): ")
            join(io, identified_groups, ", ")
            println(io)

            show(io, gd[i]; summary=false,
                 allrows=allrows, allcols=allcols, rowlabel=rowlabel,
                 truncate=truncate, kwargs...)
        end
    else
        N > 0 || return

        (h, w) = displaysize(io)

        # in the code below we accept that output for desired height less
        # than 15 does not have to always exactly match the passed value
        if h > 0
            # 2 lines for header and gap between groups, 3 lines for prompts;
            # correcting for this allows at least 8 lines (4 for each group)
            h = max(h - 5, 8)

            if N == 1
                h1 = h + 3 # add two lines for prompts and one line as there is no gap between groups
                h2 = 0 # not used
            else
                # line height of groups if printed in full; 4 lines for header
                # we assume scenario where eltype is printed for simplicity
                g1 = size(gd[1], 1) + 4
                g2 = size(gd[N], 1) + 4
                # below +2 is for 2 lines for prompts as we do not print summary
                if g1 + g2 > h # won't fit on screen
                    if g1 <= h ÷ 2
                        h1 = g1 + 2
                        h2 = h - g1 + 2 # show first group fully, squash last
                    elseif g2 <= h ÷ 2
                        h1 = h - g2 + 2 # show last group fully, squash first
                        h2 = g2 + 2
                    else
                        # squash both groups
                        h2 = h ÷ 2 + 2
                        h1 = h - h2 + 4
                    end
                else
                    h1 = g1 + 2
                    h2 = g2 + 2
                end
            end
        else
            h1 = h # no limit
            h2 = h # no limit
        end

        nrows = size(gd[1], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [string(col, " = ", repr(MIME("text/plain"), gd[1][1, col]))
                             for col in gd.cols]

        print(io, "\nFirst Group ($nrows $rows): ")
        join(io, identified_groups, ", ")
        println(io)

        show(io, gd[1]; summary=false,
             allrows=allrows, allcols=allcols, rowlabel=rowlabel,
             truncate=truncate, display_size=(h1, w), kwargs...)

        N > 1 || return

        nrows = size(gd[N], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [string(col, " = ", repr(MIME("text/plain"), gd[N][1, col]))
                             for col in gd.cols]
        print(io, "\n⋮")
        print(io, "\nLast Group ($nrows $rows): ")
        join(io, identified_groups, ", ")
        println(io)

        show(io, gd[N]; summary=false,
             allrows=allrows, allcols=allcols, rowlabel=rowlabel,
             truncate=truncate, display_size=(h2, w), kwargs...)
    end
end

function Base.show(df::GroupedDataFrame;
                   allrows::Bool = !get(stdout, :limit, true),
                   allcols::Bool = !get(stdout, :limit, true),
                   allgroups::Bool = !get(stdout, :limit, true),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   truncate::Int = 32,
                   kwargs...) # -> Nothing
    return show(stdout, df;
                allrows=allrows, allcols=allcols, allgroups=allgroups,
                rowlabel=rowlabel, summary=summary, truncate=truncate,
                kwargs...)
end

function Base.show(io::IO, mime::MIME"text/html", gd::GroupedDataFrame)
    N = length(gd)
    keys = html_escape(join(string.(groupcols(gd)), ", "))
    keystr = length(gd.cols) > 1 ? "keys" : "key"
    groupstr = N > 1 ? "groups" : "group"
    write(io, "<p><b>$(nameof(typeof(gd))) with $N $groupstr based on $keystr: $keys</b></p>")
    if N > 0
        nrows = size(gd[1], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [string(col, " = ", repr(MIME("text/plain"), first(gd[1][!, col])))
                             for col in gd.cols]

        title = "First Group ($nrows $rows): " * join(identified_groups, ", ")
        _show(io, mime, gd[1], title=title)
    end
    if N > 1
        nrows = size(gd[N], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [string(col, " = ", repr(MIME("text/plain"), first(gd[N][!, col])))
                             for col in gd.cols]

        write(io, "<p>&vellip;</p>")
        title = "Last Group ($nrows $rows): " * join(identified_groups, ", ")
        _show(io, mime, gd[N], title=title)
    end
end

function Base.show(io::IO, mime::MIME"text/latex", gd::GroupedDataFrame)
    N = length(gd)
    keys = join(latex_escape.(string.(groupcols(gd))), ", ")
    keystr = length(gd.cols) > 1 ? "keys" : "key"
    groupstr = N > 1 ? "groups" : "group"
    write(io, "$(nameof(typeof(gd))) with $N $groupstr based on $keystr: $keys\n\n")
    if N > 0
        nrows = size(gd[1], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [latex_escape(string(col, " = ",
                                                 repr(MIME("text/plain"), first(gd[1][!, col]))))
                             for col in gd.cols]

        write(io, "First Group ($nrows $rows): ")
        join(io, identified_groups, ", ")
        write(io, "\n\n")
        show(io, mime, gd[1])
    end
    if N > 1
        nrows = size(gd[N], 1)
        rows = nrows > 1 ? "rows" : "row"

        identified_groups = [latex_escape(string(col, " = ",
                                                 repr(MIME("text/plain"), first(gd[N][!, col]))))
                             for col in gd.cols]

        write(io, "\n\$\\dots\$\n\n")
        write(io, "Last Group ($nrows $rows): ")
        join(io, identified_groups, ", ")
        write(io, "\n\n")
        show(io, mime, gd[N])
    end
end

function Base.show(io::IO, mime::MIME"text/csv", gd::GroupedDataFrame)
    isfirst = true
    for sdf in gd
        printtable(io, sdf, header = isfirst, separator = ',')
        isfirst && (isfirst = false)
    end
end

function Base.show(io::IO, mime::MIME"text/tab-separated-values", gd::GroupedDataFrame)
    isfirst = true
    for sdf in gd
        printtable(io, sdf, header = isfirst, separator = '\t')
        isfirst && (isfirst = false)
    end
end

"""
    DataFrames.getmaxwidths(df::AbstractDataFrame,
                            io::IO,
                            rowindices1::AbstractVector{Int},
                            rowindices2::AbstractVector{Int},
                            rowlabel::Symbol,
                            rowid::Union{Integer, Nothing},
                            show_eltype::Bool,
                            buffer::IOBuffer)

Calculate, for each column of an AbstractDataFrame, the maximum
string width used to render the name of that column, its type, and the
longest entry in that column -- among the rows of the data frame
will be rendered to IO. The widths for all columns are returned as a
vector.

Return a `Vector{Int}` giving the maximum string widths required to render
each column, including that column's name and type.

NOTE: The last entry of the result vector is the string width of the
implicit row ID column contained in every `AbstractDataFrame`.

# Arguments
- `df::AbstractDataFrame`: The data frame whose columns will be printed.
- `io::IO`: The `IO` to which `df` is to be printed
- `rowindices1::AbstractVector{Int}: A set of indices of the first
  chunk of the AbstractDataFrame that would be rendered to IO.
- `rowindices2::AbstractVector{Int}: A set of indices of the second
  chunk of the AbstractDataFrame that would be rendered to IO. Can
  be empty if the AbstractDataFrame would be printed without any
  ellipses.
- `rowlabel::AbstractString`: The label that will be used when rendered the
  numeric ID's of each row. Typically, this will be set to "Row".
- `rowid`: Used to handle showing `DataFrameRow`.
- `show_eltype`: Whether to print the column type
   under the column name in the heading.
- `buffer`: buffer passed around to avoid reallocations in `ourstrwidth`
"""
function getmaxwidths(df::AbstractDataFrame,
                      io::IO,
                      rowindices1::AbstractVector{Int},
                      rowindices2::AbstractVector{Int},
                      rowlabel::Symbol,
                      rowid::Union{Integer, Nothing},
                      show_eltype::Bool,
                      buffer::IOBuffer,
                      truncstring::Int)
    maxwidths = Vector{Int}(undef, size(df, 2) + 1)

    undefstrwidth = ourstrwidth(io, "#undef", buffer, truncstring)

    ct = show_eltype ? batch_compacttype(Any[eltype(c) for c in eachcol(df)], 9) : String[]
    j = 1
    for (col_idx, (name, col)) in enumerate(pairs(eachcol(df)))
        # (1) Consider length of column name
        # do not truncate column name
        maxwidth = ourstrwidth(io, name, buffer, 0)

        # (2) Consider length of longest entry in that column
        for indices in (rowindices1, rowindices2), i in indices
            if isassigned(col, i)
                maxwidth = max(maxwidth, ourstrwidth(io, col[i], buffer, truncstring))
            else
                maxwidth = max(maxwidth, undefstrwidth)
            end
        end
        if show_eltype
            # do not truncate eltype name
            maxwidths[j] = max(maxwidth, ourstrwidth(io, ct[col_idx], buffer, 0))
        else
            maxwidths[j] = maxwidth
        end
        j += 1
    end

    # do not truncate rowlabel
    if rowid isa Nothing
        rowmaxwidth1 = isempty(rowindices1) ? 0 : ndigits(maximum(rowindices1))
        rowmaxwidth2 = isempty(rowindices2) ? 0 : ndigits(maximum(rowindices2))
        maxwidths[j] = max(max(rowmaxwidth1, rowmaxwidth2),
                           ourstrwidth(io, rowlabel, buffer, 0))
    else
        maxwidths[j] = max(ndigits(rowid), ourstrwidth(io, rowlabel, buffer, 0))
    end

    return maxwidths
end

"""
    show(io::IO, mime::MIME, df::AbstractDataFrame)

Render a data frame to an I/O stream in MIME type `mime`.

# Arguments
- `io::IO`: The I/O stream to which `df` will be printed.
- `mime::MIME`: supported MIME types are: `"text/plain"`, `"text/html"`, `"text/latex"`,
  `"text/csv"`, `"text/tab-separated-values"` (the last two MIME types do not support
   showing `#undef` values)
- `df::AbstractDataFrame`: The data frame to print.

Additionally selected MIME types support passing the following keyword arguments:
- MIME type `"text/plain"` accepts all listed keyword arguments and their behavior
  is identical as for `show(::IO, ::AbstractDataFrame)`
- MIME type `"text/html"` accepts the following keyword arguments:
    - `eltypes::Bool = true`: Whether to print the column types under column names.
    - `summary::Bool = true`: Whether to print a brief string summary of the data frame.
    - `max_column_width::AbstractString = ""`: The maximum column width. It must
          be a string containing a valid CSS length. For example, passing
          "100px" will limit the width of all columns to 100 pixels. If empty,
          the columns will be rendered without limits.
    - `kwargs...`: Any keyword argument supported by the function `pretty_table`
      of PrettyTables.jl can be passed here to customize the output.

# Examples
```jldoctest
julia> show(stdout, MIME("text/latex"), DataFrame(A=1:3, B=["x", "y", "z"]))
\\begin{tabular}{r|cc}
\t& A & B\\\\
\t\\hline
\t& Int64 & String\\\\
\t\\hline
\t1 & 1 & x \\\\
\t2 & 2 & y \\\\
\t3 & 3 & z \\\\
\\end{tabular}
14

julia> show(stdout, MIME("text/csv"), DataFrame(A=1:3, B=["x", "y", "z"]))
"A","B"
1,"x"
2,"y"
3,"z"
```
"""
Base.show(io::IO, mime::MIME, df::AbstractDataFrame)
function Base.show(io::IO, mime::MIME"text/html", df::AbstractDataFrame;
                   summary::Bool=true, eltypes::Bool=true,
                   max_column_width::AbstractString="", kwargs...)
    _verify_kwargs_for_html(; kwargs...)
    return _show(io, mime, df; summary=summary, eltypes=eltypes,
                 max_column_width=max_column_width, kwargs...)
end

Base.show(io::IO, mime::MIME"text/latex", df::AbstractDataFrame; eltypes::Bool=true) =
    _show(io, mime, df, eltypes=eltypes)
Base.show(io::IO, mime::MIME"text/csv", df::AbstractDataFrame) =
    printtable(io, df, header = true, separator = ',')
Base.show(io::IO, mime::MIME"text/tab-separated-values", df::AbstractDataFrame) =
    printtable(io, df, header = true, separator = '\t')
Base.show(io::IO, mime::MIME"text/plain", df::AbstractDataFrame; kwargs...) =
    show(io, df; kwargs...)

##############################################################################
#
# HTML output
#
##############################################################################

function html_escape(cell::AbstractString)
    cell = replace(cell, "&"=>"&amp;")
    cell = replace(cell, "<"=>"&lt;")
    cell = replace(cell, ">"=>"&gt;")
    # Replace quotes so that the resulting string could also be used in the attributes of
    # HTML tags
    cell = replace(cell, "\""=>"&quot;")
    cell = replace(cell, "'"=>"&apos;")
    return cell
end

@static if pkgversion(PrettyTables).major == 2
    # When PrettyTables v2 is more widely adopted in the ecosystem, we can remove this
    # function. In this case, we should also update the compat bounds in Project.toml to
    # list only PrettyTables v3.
    function _show(io::IO,
                   ::MIME"text/html",
                   df::AbstractDataFrame;
                   summary::Bool=true,
                   eltypes::Bool=true,
                   rowid::Union{Int, Nothing}=nothing,
                   title::AbstractString="",
                   max_column_width::AbstractString="",
                   kwargs...)
        _check_consistency(df)

        names_str = names(df)
        types = Any[eltype(c) for c in eachcol(df)]
        types_str = batch_compacttype(types, 9)
        types_str_complete = batch_compacttype(types, 256)

        # For consistency, if `kwargs` has `compact_printing`, we must use it.
        compact_printing::Bool = get(kwargs, :compact_printing, get(io, :compact, true))

        num_rows, num_cols = size(df)

        # By default, we align the columns to the left unless they are numbers,
        # which is checked in the following.
        alignment = fill(:l, num_cols)

        for i = 1:num_cols
            type_i = nonmissingtype(types[i])

            if type_i <: Number
                alignment[i] = :r
            end
        end

        if get(io, :limit, false)
            # Obtain the maximum number of rows and columns that we can print from
            # environment variables.
            mxrow = something(tryparse(Int, get(ENV, "DATAFRAMES_ROWS", "25")), 25)
            mxcol = something(tryparse(Int, get(ENV, "DATAFRAMES_COLUMNS", "100")), 100)
        else
            mxrow = -1
            mxcol = -1
        end

        # Check if the user wants to display a summary about the DataFrame that is
        # being printed. This will be shown using the `title` option of
        # `pretty_table`.
        if summary
            if isempty(title)
                title = Base.summary(df)
            end
        else
            title = ""
        end

        # If `rowid` is not `nothing`, then we are printing a data row. In this
        # case, we will add this information using the row name column of
        # PrettyTables.jl. Otherwise, we can just use the row number column.
        if (rowid === nothing) || (ncol(df) == 0)
            show_row_number::Bool = get(kwargs, :show_row_number, true)
            row_labels = nothing

            # If the columns with row numbers is not shown, then we should not
            # display a vertical line after the first column.
            vlines = fill(1, show_row_number)
        else
            nrow(df) != 1 &&
                throw(ArgumentError("rowid may be passed only with a single row data frame"))

            # In this case, if the user does not want to show the row number, then
            # we must hide the row name column, which is used to display the
            # `rowid`.
            if !get(kwargs, :show_row_number, true)
                row_labels = nothing
                vlines = Int[]
            else
                row_labels = [string(rowid)]
                vlines = Int[1]
            end

            show_row_number = false
        end

        pretty_table(io, df;
                     alignment                 = alignment,
                     backend                   = Val(:html),
                     compact_printing          = compact_printing,
                     formatters                = (_pretty_tables_general_formatter,),
                     header                    = (names_str, types_str),
                     header_alignment          = :l,
                     header_cell_titles        = (nothing, types_str_complete),
                     highlighters              = (_PRETTY_TABLES_HTML_HIGHLIGHTER,),
                     max_num_of_columns        = mxcol,
                     max_num_of_rows           = mxrow,
                     maximum_columns_width     = max_column_width,
                     minify                    = true,
                     row_label_column_title    = "Row",
                     row_labels                = row_labels,
                     row_number_alignment      = :r,
                     row_number_column_title   = "Row",
                     show_omitted_cell_summary = true,
                     show_row_number           = show_row_number,
                     show_subheader            = eltypes,
                     standalone                = false,
                     table_class               = "data-frame",
                     table_div_class           = "data-frame",
                     table_style               = _PRETTY_TABLES_HTML_TABLE_STYLE,
                     top_left_str              = String(title),
                     top_right_str_decoration  = HtmlDecoration(font_style = "italic"),
                     vcrop_mode                = :middle,
                     wrap_table_in_div         = true,
                     kwargs...)

        return nothing
    end
else
    function _show(io::IO,
                   ::MIME"text/html",
                   df::AbstractDataFrame;
                   summary::Bool=true,
                   eltypes::Bool=true,
                   rowid::Union{Int, Nothing}=nothing,
                   title::AbstractString="",
                   max_column_width::AbstractString="",
                   show_row_number::Bool=true,
                   kwargs...)
        _check_consistency(df)

        names_str = names(df)
        types = Any[eltype(c) for c in eachcol(df)]
        types_str = batch_compacttype(types, 9)
        types_str_complete = batch_compacttype(types, 256)

        # For consistency, if `kwargs` has `compact_printing`, we must use it.
        compact_printing::Bool = get(kwargs, :compact_printing, get(io, :compact, true))

        num_rows, num_cols = size(df)

        # By default, we align the columns to the left unless they are numbers,
        # which is checked in the following.
        alignment = fill(:l, num_cols)

        for i = 1:num_cols
            type_i = nonmissingtype(types[i])

            if type_i <: Number
                alignment[i] = :r
            end
        end

        if get(io, :limit, false)
            # Obtain the maximum number of rows and columns that we can print from
            # environment variables.
            mxrow = something(tryparse(Int, get(ENV, "DATAFRAMES_ROWS", "25")), 25)
            mxcol = something(tryparse(Int, get(ENV, "DATAFRAMES_COLUMNS", "100")), 100)
        else
            mxrow = -1
            mxcol = -1
        end

        # Check if the user wants to display a summary about the DataFrame that is
        # being printed. This will be shown using the `title` option of
        # `pretty_table`.
        if summary
            if isempty(title)
                title = Base.summary(df)
            end
        else
            title = ""
        end

        # If `rowid` is not `nothing`, then we are printing a data row. In this
        # case, we will add this information using the row name column of
        # PrettyTables.jl.
        if (rowid === nothing) || (ncol(df) == 0)
            row_labels = 1:num_rows
        else
            nrow(df) != 1 &&
                throw(ArgumentError("rowid may be passed only with a single row data frame"))

            row_labels = [string(rowid)]
        end

        # Keep compatibility with the previous behavior of PrettyTables.jl if the user does
        # not want to show the row numbers.
        if !show_row_number
            row_labels = nothing
        end

        pretty_table(io, df;
                     alignment                    = alignment,
                     backend                      = :html,
                     column_label_alignment       = :l,
                     column_labels                = [names_str, types_str],
                     column_label_titles          = [nothing, types_str_complete],
                     compact_printing             = compact_printing,
                     formatters                   = _PRETTY_TABLES_HTML_FORMATTER,
                     highlighters                 = _PRETTY_TABLES_HTML_HIGHLIGHTER,
                     maximum_column_width         = max_column_width,
                     maximum_number_of_columns    = mxcol,
                     maximum_number_of_rows       = mxrow,
                     minify                       = true,
                     row_label_column_alignment   = :r,
                     row_labels                   = row_labels,
                     show_first_column_label_only = !eltypes,
                     show_omitted_cell_summary    = true,
                     show_row_number_column       = false,
                     stand_alone                  = false,
                     stubhead_label               = "Row",
                     style                        = _PRETTY_TABLES_HTML_TABLE_STYLE,
                     table_class                  = "data-frame",
                     table_div_class              = "data-frame",
                     top_left_string              = String(title),
                     vertical_crop_mode           = :middle,
                     wrap_table_in_div            = true,
                     kwargs...)

        return nothing
    end
end

function Base.show(io::IO, mime::MIME"text/html", dfrs::DataFrameRows; kwargs...)
    _verify_kwargs_for_html(; kwargs...)
    df = parent(dfrs)
    title = "$(nrow(df))×$(ncol(df)) DataFrameRows"
    _show(io, mime, df; title=title, kwargs...)
end

function Base.show(io::IO, mime::MIME"text/html", dfcs::DataFrameColumns; kwargs...)
    _verify_kwargs_for_html(; kwargs...)
    df = parent(dfcs)
    title = "$(nrow(df))×$(ncol(df)) DataFrameColumns"
    _show(io, mime, df; title=title, kwargs...)
end

# Internal function to verify the keywords in show functions using the HTML
# backend.
function _verify_kwargs_for_html(; kwargs...)
    haskey(kwargs, :rowid) &&
        throw(ArgumentError("Keyword argument `rowid` is reserved and must not be used."))

    haskey(kwargs, :title) &&
        throw(ArgumentError("Use the `top_left_str` keyword argument instead of `title` " *
                            "to change the label above the data frame."))

    haskey(kwargs, :truncate) &&
        throw(ArgumentError("`truncate` is not supported in HTML. " *
                            "Use `max_column_width` to limit the size of the columns in this case."))

    return nothing
end

##############################################################################
#
# LaTeX output
#
##############################################################################

function latex_char_escape(char::Char)
    if char == '\\'
        return "\\textbackslash{}"
    elseif char == '~'
        return "\\textasciitilde{}"
    else
        return string('\\', char)
    end
end

function latex_escape(cell::AbstractString)
    replace(cell, ['\\','~', '#', '$', '%', '&', '_', '^', '{', '}']=>latex_char_escape)
end

function _show(io::IO, ::MIME"text/latex", df::AbstractDataFrame;
               eltypes::Bool=true, rowid=nothing)
    _check_consistency(df)

    # we will pass around this buffer to avoid its reallocation in ourstrwidth
    buffer = IOBuffer(Vector{UInt8}(undef, 80), read=true, write=true)

    if rowid !== nothing
        if size(df, 2) == 0
            rowid = nothing
        elseif size(df, 1) != 1
            throw(ArgumentError("rowid may be passed only with a single row data frame"))
        end
    end

    mxrow, mxcol = size(df)
    if get(io, :limit, false)
        tty_rows, tty_cols = get(io, :displaysize, displaysize(io))
        mxrow = min(mxrow, tty_rows)
        maxwidths = getmaxwidths(df, io, 1:mxrow, 0:-1, :X, nothing, true, buffer, 0) .+ 2
        mxcol = min(mxcol, searchsortedfirst(cumsum(maxwidths), tty_cols))
    end

    cnames = _names(df)[1:mxcol]
    alignment = repeat("c", mxcol)
    write(io, "\\begin{tabular}{r|")
    write(io, alignment)
    mxcol < size(df, 2) && write(io, "c")
    write(io, "}\n")
    write(io, "\t& ")
    header = join(map(c -> latex_escape(string(c)), cnames), " & ")
    write(io, header)
    mxcol < size(df, 2) && write(io, " & ")
    write(io, "\\\\\n")
    write(io, "\t\\hline\n")
    if eltypes
        write(io, "\t& ")
        ct = batch_compacttype(Any[eltype(df[!, idx]) for idx in 1:mxcol], 9)
        header = join(latex_escape.(ct), " & ")
        write(io, header)
        mxcol < size(df, 2) && write(io, " & ")
        write(io, "\\\\\n")
        write(io, "\t\\hline\n")
    end
    for row in 1:mxrow
        write(io, "\t")
        write(io, @sprintf("%d", rowid === nothing ? row : rowid))
        for col in 1:mxcol
            write(io, " & ")
            if !isassigned(df[!, col], row)
                print(io, "\\emph{\\#undef}")
            else
                cell = df[row, col]
                if ismissing(cell)
                    print(io, "\\emph{missing}")
                elseif cell isa Markdown.MD
                    print(io, strip(repr(MIME("text/latex"), cell)))
                elseif cell isa SHOW_TABULAR_TYPES
                    print(io, "\\emph{")
                    print(io, latex_escape(sprint(ourshow, cell, 0, context=io)))
                    print(io, "}")
                else
                    if showable(MIME("text/latex"), cell)
                        show(io, MIME("text/latex"), cell)
                    else
                        print(io, latex_escape(sprint(ourshow, cell, 0, context=io)))
                    end
                end
            end
        end
        mxcol < size(df, 2) && write(io, " & \$\\dots\$")
        write(io, " \\\\\n")
    end
    if size(df, 1) > mxrow
        write(io, "\t\$\\dots\$")
        for col in 1:mxcol
            write(io, " & \$\\dots\$")
        end
        mxcol < size(df, 2) && write(io, " & ")
        write(io, " \\\\\n")
    end
    write(io, "\\end{tabular}\n")
end

Base.show(io::IO, mime::MIME"text/latex", dfrs::DataFrameRows; eltypes::Bool=true) =
	_show(io, mime, parent(dfrs), eltypes=eltypes)
Base.show(io::IO, mime::MIME"text/latex", dfcs::DataFrameColumns; eltypes::Bool=true) =
	_show(io, mime, parent(dfcs), eltypes=eltypes)

##############################################################################
#
# MIME: text/csv and text/tab-separated-values
#
##############################################################################

escapedprint(io::IO, x::SHOW_TABULAR_TYPES, escapes::AbstractString) =
    escapedprint(io, summary(x), escapes)
escapedprint(io::IO, x::Any, escapes::AbstractString) =
    escapedprint(io, sprint(print, x), escapes)
escapedprint(io::IO, x::AbstractString, escapes::AbstractString) =
    escape_string(io, x, escapes)

function printtable(io::IO,
                    df::AbstractDataFrame;
                    header::Bool = true,
                    separator::Char = ',',
                    quotemark::Char = '"',
                    missingstring::AbstractString = "missing",
                    nothingstring::AbstractString = "nothing")
    _check_consistency(df)
    n, p = size(df)
    etypes = eltype.(eachcol(df))
    if header
        cnames = _names(df)
        for j in 1:p
            print(io, quotemark)
            print(io, cnames[j])
            print(io, quotemark)
            if j < p
                print(io, separator)
            else
                print(io, '\n')
            end
        end
    end
    quotestr = string(quotemark)
    for i in 1:n
        for j in 1:p
            cell = df[i, j]
            if ismissing(cell)
                print(io, missingstring)
            elseif isnothing(cell)
                print(io, nothingstring)
            else
                if cell isa Markdown.MD
                    print(io, quotemark)
                    r = repr(cell)
                    escapedprint(io, chomp(r), quotestr)
                    print(io, quotemark)
                elseif !(etypes[j] <: Real)
                    print(io, quotemark)
                    escapedprint(io, cell, quotestr)
                    print(io, quotemark)
                else
                    print(io, cell)
                end
            end
            if j < p
                print(io, separator)
            else
                print(io, '\n')
            end
        end
    end
    nothing
end

Base.show(io::IO, mime::MIME"text/csv",
          dfs::Union{DataFrameRows, DataFrameColumns}) =
    show(io, mime, parent(dfs))
Base.show(io::IO, mime::MIME"text/tab-separated-values",
          dfs::Union{DataFrameRows, DataFrameColumns}) =
    show(io, mime, parent(dfs))

module TestMetadata

using Test, DataFrames, Random, DataAPI

function check_allnotemetadata(x::Union{AbstractDataFrame,
                                        DataFrameRow,
                                        DataFrames.DataFrameRows,
                                        DataFrames.DataFrameColumns,
                                        GroupedDataFrame})
    p = parent(parent(x))
    getfield(p, :allnotemetadata) || return true
    if getfield(p, :metadata) !== nothing
        for (_, style) in values(getfield(p, :metadata))
            style == :note || return false
        end
    end
    if getfield(p, :colmetadata) !== nothing
        for colmeta in values(getfield(p, :colmetadata))
            for (_, style) in values(colmeta)
                style == :note || return false
            end
        end
    end
    return true
end

@testset "metadatasupport" begin
    df = DataFrame(a=1)

    @test DataAPI.metadatasupport(typeof(df)) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(view(df, :, :))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(view(df, :, 1:1))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(view(df, 1, :))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(view(df, 1, 1:1))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(eachrow(df))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(eachrow(view(df, :, :)))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(eachcol(df))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(eachcol(view(df, :, :)))) ==
          (read=true, write=true)
    @test DataAPI.metadatasupport(typeof(groupby(df, 1))) ==
          (read=false, write=false)
    @test DataAPI.metadatasupport(typeof(groupby(view(df, :, :), 1))) ==
          (read=false, write=false)

    @test DataAPI.colmetadatasupport(typeof(df)) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(view(df, :, :))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(view(df, :, 1:1))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(view(df, 1, :))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(view(df, 1, 1:1))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(eachrow(df))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(eachrow(view(df, :, :)))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(eachcol(df))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(eachcol(view(df, :, :)))) ==
          (read=true, write=true)
    @test DataAPI.colmetadatasupport(typeof(groupby(df, 1))) ==
          (read=false, write=false)
    @test DataAPI.colmetadatasupport(typeof(groupby(view(df, :, :), 1))) ==
          (read=false, write=false)
end

@testset "table-level metadata" begin
    for x in (DataFrame(), DataFrame(a=1))
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test check_allnotemetadata(x)
        @test isempty(metadatakeys(x))
        @test metadatakeys(x) isa Tuple
        @test check_allnotemetadata(x)
        metadata!(x, "name", "empty", style=:some)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadatakeys(x) isa Base.KeySet
        @test metadata(x, "name") == "empty"
        @test metadata(x, "name", style=true) == ("empty", :some)
        emptymetadata!(x)
        @test check_allnotemetadata(x)
        @test isempty(metadatakeys(x))
        @test metadatakeys(x) isa Tuple
        metadata!(x, "name1", "empty1", style=:note)
        metadata!(x, "name2", "empty2", style=:default)
        @test check_allnotemetadata(x)
        @test sort(collect(metadatakeys(x))) == ["name1", "name2"]
        deletemetadata!(x, "name2")
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name3")
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name1")
        @test isempty(metadatakeys(x))
        @test check_allnotemetadata(x)
        # this is just a no-op like for dictionaries
        @test deletemetadata!(x, "foobar") === x
    end

    for fun in (eachcol, eachrow,
                x -> x[1, :], x -> @view x[:, :])
        x = fun(DataFrame(a=1))
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test isempty(metadatakeys(x))
        metadata!(x, "name", "empty", style=:note)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test check_allnotemetadata(x)
        emptymetadata!(x)
        @test check_allnotemetadata(x)
        @test isempty(metadatakeys(x))
        metadata!(x, "name1", "empty1", style=:note)
        metadata!(x, "name2", "empty2", style=:note)
        @test check_allnotemetadata(x)
        @test sort(collect(metadatakeys(x))) == ["name1", "name2"]
        deletemetadata!(x, "name2")
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name3")
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name1")
        @test isempty(metadatakeys(x))
        @test check_allnotemetadata(x)
        # this is just a no-op like for dictionaries
        @test deletemetadata!(x, "foobar") === x
    end

    for fun in (eachcol, eachrow)
        x = fun(DataFrame(a=1))
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test isempty(metadatakeys(x))
        metadata!(x, "name", "empty", style=:default)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test metadata(x, "name", style=true) == ("empty", :default)
        emptymetadata!(x)
        @test check_allnotemetadata(x)
        @test isempty(metadatakeys(x))
        metadata!(x, "name1", "empty1", style=:default)
        metadata!(x, "name2", "empty2", style=:note)
        @test check_allnotemetadata(x)
        @test sort(collect(metadatakeys(x))) == ["name1", "name2"]
        deletemetadata!(x, "name2")
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name3")
        @test collect(metadatakeys(x)) == ["name1"]
        deletemetadata!(x, "name1")
        @test isempty(metadatakeys(x))
        @test check_allnotemetadata(x)
        # this is just a no-op like for dictionaries
        @test deletemetadata!(x, "foobar") === x
     end

    for fun in (x -> x[1, :], x -> @view x[:, :])
        x = fun(DataFrame(a=1))
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test check_allnotemetadata(x)
        @test isempty(metadatakeys(x))
        @test_throws ArgumentError metadata!(x, "name", "empty", style=:default)
        metadata!(parent(x), "name", "empty", style=:default)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test metadata(x, "foobar", 12) == 12
        @test metadata(x, "foobar", 12, style=true) == (12, :default)
        @test isempty(metadatakeys(x))
        @test collect(metadatakeys(parent(x))) == ["name"]
        metadata!(parent(x), "name1", "empty1", style=:default)
        metadata!(x, "name2", "empty2", style=:note)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError metadata(x, "foobar")
        @test sort(collect(metadatakeys(x))) == ["name2"]
        @test metadata(x, "name2") == "empty2"
        @test_throws ArgumentError metadata(x, "name1")
        deletemetadata!(x, "name2")
        @test isempty(metadatakeys(x))
        deletemetadata!(x, "name3")
        @test isempty(metadatakeys(x))
        deletemetadata!(x, "name1")
        @test isempty(metadatakeys(x))
        @test sort(collect(metadatakeys(parent(x)))) == ["name", "name1"]
        @test_throws ArgumentError metadata(x, "foobar")
        @test check_allnotemetadata(x)
        # this is just a no-op like for dictionaries
        @test deletemetadata!(x, "foobar") === x
    end

    df = DataFrame(a = 1:2)
    @test check_allnotemetadata(df)
    metadata!(df, "name", "value", style=:default)
    metadata!(df, "name2", "value2", style=:note)
    @test check_allnotemetadata(df)
    dfv = view(df, :, :)
    @test collect(metadatakeys(dfv)) == ["name2"]
    @test_throws ArgumentError metadata!(dfv, "name", "valuex", style=:note)
    metadata!(dfv, "name2", "value2x", style=:note)
    @test metadata(df, "name2") == "value2x"
    @test check_allnotemetadata(df)

    df = DataFrame(a = 1:2)
    @test check_allnotemetadata(df)
    metadata!(df, "name", "value", style=:default)
    metadata!(df, "name2", "value2", style=:note)
    @test check_allnotemetadata(df)
    dfr = df[1, :]
    @test collect(metadatakeys(dfr)) == ["name2"]
    @test_throws ArgumentError metadata!(dfr, "name", "valuex", style=:note)
    metadata!(dfr, "name2", "value2x", style=:note)
    @test metadata(df, "name2") == "value2x"
    @test check_allnotemetadata(df)
end

@testset "column-level metadata" begin
    for b in (:b, "b", 2, big(2)), a in (:a, "a", 1, big(1))
        x = DataFrame(a=1, b=2)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError colmetadata(x, a, "foobar")
        @test_throws BoundsError colmetadata(x, 10, "foobar")
        @test_throws ArgumentError colmetadata(x, "x", "foobar")
        @test colmetadata(x, a, "foobar", 12) == 12
        @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
        @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
        @test isempty(colmetadatakeys(x))
        @test colmetadatakeys(x) isa Tuple
        @test isempty(colmetadatakeys(x, a))
        @test colmetadatakeys(x, a) isa Tuple
        @test_throws ArgumentError colmetadatakeys(x, :c)
        colmetadata!(x, b, "name1", "empty1", style=:note)
        @test check_allnotemetadata(x)
        @test_throws ArgumentError colmetadata(x, a, "foobar")
        @test_throws ArgumentError colmetadata(x, b, "foobar")
        @test_throws ArgumentError colmetadata!(x, :c, "name", "empty", style=:note)
        @test colmetadata(x, a, "foobar", 12) == 12
        @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
        @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
        colmetadata!(x, b, "name2", "empty2", style=:note)
        colmetadata!(x, a, "name3", "empty3", style=:note)
        @test check_allnotemetadata(x)
        @test colmetadatakeys(x, a) == Set(["name3"])
        @test colmetadatakeys(x, b) == Set(["name1", "name2"])
        @test_throws ArgumentError colmetadatakeys(x, :c)
        @test Set(colmetadatakeys(x)) ==
              Set([:b => Set(["name1", "name2"]), :a => Set(["name3"])])
        @test colmetadata(x, b, "name1") == "empty1"
        @test colmetadata(x, b, "name1", style=true) == ("empty1", :note)
        @test_throws ArgumentError colmetadata(x, b, "namex")
        @test_throws ArgumentError colmetadata(x, :x, "name")
        emptycolmetadata!(x, a)
        @test check_allnotemetadata(x)
        @test isempty(colmetadatakeys(x, a))
        @test colmetadatakeys(x, b) == Set(["name1", "name2"])
        deletecolmetadata!(x, b, "name2")
        @test colmetadatakeys(x, b) == Set(["name1"])
        emptycolmetadata!(x)
        @test isempty((colmetadatakeys(x)))
        @test check_allnotemetadata(x)
        # this is just a no-op like for dictionaries
        @test deletecolmetadata!(x, a, "foobar") === x
        @test_throws ArgumentError deletecolmetadata!(x, :invalid, "foobar")

        for fun in (eachcol, eachrow,
                    x -> x[1, :], x -> @view(x[:, :]),
                    x -> x[1, 1:2], x -> @view x[:, 1:2])
            x = fun(DataFrame(a=1, b=2, d=3))
            @test check_allnotemetadata(x)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws BoundsError colmetadata(x, 10, "foobar")
            @test_throws ArgumentError colmetadata(x, "x", "foobar")
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            @test isempty(colmetadatakeys(x))
            @test colmetadatakeys(x) isa Tuple
            @test isempty(colmetadatakeys(x, a))
            @test colmetadatakeys(x, a) isa Tuple
            @test_throws ArgumentError colmetadatakeys(x, :c)
            colmetadata!(x, b, "name1", "empty1", style=:note)
            @test check_allnotemetadata(x)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws ArgumentError colmetadata(x, b, "foobar")
            @test_throws ArgumentError colmetadata!(x, :c, "name", "empty", style=:note)
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            colmetadata!(x, b, "name2", "empty2", style=:note)
            colmetadata!(x, a, "name3", "empty3", style=:note)
            @test check_allnotemetadata(x)
            @test collect(colmetadatakeys(x, a)) == ["name3"]
            @test sort(collect(colmetadatakeys(x, b))) == ["name1", "name2"]
            @test_throws ArgumentError colmetadatakeys(x, :c)
            @test Set([k => sort(collect(v)) for (k, v) in colmetadatakeys(x)]) ==
                Set([:b => ["name1", "name2"], :a => ["name3"]])
            @test colmetadata(x, b, "name1") == "empty1"
            @test colmetadata(x, b, "name1", style=true) == ("empty1", :note)
            @test_throws ArgumentError colmetadata(x, b, "namex")
            @test_throws ArgumentError colmetadata(x, :x, "name")
            emptycolmetadata!(x, a)
            @test check_allnotemetadata(x)
            @test isempty(colmetadatakeys(x, a))
            @test sort(collect(colmetadatakeys(x, b))) == ["name1", "name2"]
            deletecolmetadata!(x, b, "name2")
            @test check_allnotemetadata(x)
            @test collect(colmetadatakeys(x, b)) == ["name1"]
            emptycolmetadata!(x)
            @test isempty((colmetadatakeys(x)))
            @test check_allnotemetadata(x)
            # this is just a no-op like for dictionaries
            @test deletecolmetadata!(x, a, "foobar") === x
            @test_throws ArgumentError deletecolmetadata!(x, :invalid, "foobar")
        end

        for fun in (eachcol, eachrow)
            x = fun(DataFrame(a=1, b=2, d=3))
            @test check_allnotemetadata(x)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws BoundsError colmetadata(x, 10, "foobar")
            @test_throws ArgumentError colmetadata(x, "x", "foobar")
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            @test isempty(colmetadatakeys(x))
            @test colmetadatakeys(x) isa Tuple
            @test isempty(colmetadatakeys(x, a))
            @test colmetadatakeys(x, a) isa Tuple
            @test_throws ArgumentError colmetadatakeys(x, :c)
            colmetadata!(x, b, "name1", "empty1", style=:default)
            @test check_allnotemetadata(x)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws ArgumentError colmetadata(x, b, "foobar")
            @test_throws ArgumentError colmetadata!(x, :c, "name", "empty", style=:default)
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            colmetadata!(x, b, "name2", "empty2", style=:default)
            colmetadata!(x, a, "name3", "empty3", style=:default)
            @test check_allnotemetadata(x)
            @test collect(colmetadatakeys(x, a)) == ["name3"]
            @test sort(collect(colmetadatakeys(x, b))) == ["name1", "name2"]
            @test_throws ArgumentError colmetadatakeys(x, :c)
            @test Set([k => sort(collect(v)) for (k, v) in colmetadatakeys(x)]) ==
                Set([:b => ["name1", "name2"], :a => ["name3"]])
            @test colmetadata(x, b, "name1") == "empty1"
            @test colmetadata(x, b, "name1", style=true) == ("empty1", :default)
            @test_throws ArgumentError colmetadata(x, b, "namex")
            @test_throws ArgumentError colmetadata(x, :x, "name")
            emptycolmetadata!(x, a)
            @test check_allnotemetadata(x)
            @test isempty(colmetadatakeys(x, a))
            @test sort(collect(colmetadatakeys(x, b))) == ["name1", "name2"]
            deletecolmetadata!(x, b, "name2")
            @test check_allnotemetadata(x)
            @test collect(colmetadatakeys(x, b)) == ["name1"]
            emptycolmetadata!(x)
            @test isempty((colmetadatakeys(x)))
            @test check_allnotemetadata(x)
            # this is just a no-op like for dictionaries
            @test deletecolmetadata!(x, a, "foobar") === x
            @test_throws ArgumentError deletecolmetadata!(x, :invalid, "foobar")
        end

        for fun in (x -> x[1, :], x -> @view(x[:, :]),
                    x -> x[1, 1:2], x -> @view x[:, 1:2])
            x = fun(DataFrame(a=1, b=2, d=3))
            @test check_allnotemetadata(x)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws BoundsError colmetadata(x, 10, "foobar")
            @test_throws ArgumentError colmetadata(x, "x", "foobar")
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            p = parent(x)
            @test isempty(colmetadatakeys(x))
            @test colmetadatakeys(x) isa Tuple
            @test isempty(colmetadatakeys(x, a))
            @test colmetadatakeys(x, a) isa Tuple
            @test_throws ArgumentError colmetadatakeys(x, :c)
            @test_throws ArgumentError colmetadata!(x, b, "name1", "empty1", style=:default)
            @test_throws ArgumentError colmetadata(x, a, "foobar")
            @test_throws ArgumentError colmetadata(x, b, "foobar")
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            @test_throws ArgumentError colmetadata!(x, b, "name2", "empty2", style=:default)
            @test_throws ArgumentError colmetadata!(x, a, "name3", "empty3", style=:default)
            colmetadata!(p, b, "name1", "empty1", style=:default)
            colmetadata!(p, b, "name2", "empty2", style=:default)
            colmetadata!(p, a, "name3", "empty3", style=:default)
            @test check_allnotemetadata(x)
            @test isempty(colmetadatakeys(x, a))
            @test isempty(colmetadatakeys(x, b))
            @test_throws ArgumentError colmetadatakeys(x, :c)
            @test isempty(colmetadatakeys(x))
            emptycolmetadata!(x)
            @test check_allnotemetadata(x)
            @test colmetadatakeys(p, a) == Set(["name3"])
            @test colmetadatakeys(p, b) == Set(["name1", "name2"])
            colmetadata!(x, a, "label", "a", style=:note)
            @test check_allnotemetadata(x)
            @test colmetadata(x, a, "label") == "a"
            @test_throws ArgumentError colmetadata(x, a, "name3")
            if !("d" in names(x))
                @test_throws BoundsError colmetadata!(x, "d", "n", "e", style=:note)
            else
                colmetadata!(x, "d", "n", "e", style=:note)
                @test colmetadata(x, "d", "n") == "e"
            end
            @test check_allnotemetadata(x)
            @test colmetadata(x, a, "foobar", 12) == 12
            @test colmetadata(x, a, "foobar", 12, style=true) == (12, :default)
            @test_throws ArgumentError colmetadata(x, "x", "foobar", 12)
            # this is just a no-op like for dictionaries
            @test deletecolmetadata!(x, a, "foobar") === x
            @test_throws ArgumentError deletecolmetadata!(x, :invalid, "foobar")
        end
    end

    df = DataFrame(a = 1:2)
    @test check_allnotemetadata(df)
    colmetadata!(df, 1, "name", "value", style=:default)
    colmetadata!(df, 1, "name2", "value2", style=:note)
    @test check_allnotemetadata(df)
    dfv = view(df, :, :)
    @test collect(colmetadatakeys(dfv, 1)) == ["name2"]
    @test_throws ArgumentError colmetadata!(dfv, 1, "name", "valuex", style=:note)
    colmetadata!(dfv, 1, "name2", "value2x", style=:note)
    @test colmetadata(df, 1, "name2") == "value2x"
    @test check_allnotemetadata(df)

    df = DataFrame(a = 1:2)
    @test check_allnotemetadata(df)
    colmetadata!(df, 1, "name", "value", style=:default)
    colmetadata!(df, 1, "name2", "value2", style=:note)
    @test check_allnotemetadata(df)
    dfr = df[1, :]
    @test collect(colmetadatakeys(dfr, 1)) == ["name2"]
    @test_throws ArgumentError colmetadata!(dfr, 1, "name", "valuex", style=:note)
    colmetadata!(dfr, 1, "name2", "value2x", style=:note)
    @test colmetadata(df, 1, "name2") == "value2x"
    @test check_allnotemetadata(df)
end

@testset "metadata default" begin
    df = DataFrame(a=1)
    metadata!(df, "x", "y")
    colmetadata!(df, :a, "p", "q")
    @test metadata(df, "x", style=true) == ("y", :default)
    @test colmetadata(df, :a, "p", style=true) == ("q", :default)
    df = eachcol(DataFrame(a=1))
    metadata!(df, "x", "y")
    colmetadata!(df, :a, "p", "q")
    @test metadata(df, "x", style=true) == ("y", :default)
    @test colmetadata(df, :a, "p", style=true) == ("q", :default)
    df = view(DataFrame(a=1), :, :)
    @test_throws ArgumentError metadata!(df, "x", "y")
    @test_throws ArgumentError colmetadata!(df, :a, "p", "q")
end

@testset "fallback definitions of metadata and colmetadata" begin
    df = DataFrame()
    @test metadata(df) == Dict()
    @test metadata(df, style=true) == Dict()
    @test colmetadata(df) == Dict()
    @test colmetadata(df, style=true) == Dict()
    df.a = 1:2
    df.b = 2:3
    df.c = 3:4
    @test metadata(df) == Dict()
    @test metadata(df, style=true) == Dict()
    @test colmetadata(df) == Dict()
    @test colmetadata(df, style=true) == Dict()
    metadata!(df, "a1", "b1", style=:default)
    metadata!(df, "a2", "b2", style=:note)
    colmetadata!(df, :a, "x1", "y1", style=:default)
    colmetadata!(df, :a, "x2", "y2", style=:note)
    colmetadata!(df, :c, "x3", "y3", style=:note)
    @test metadata(df) == Dict("a1" => "b1", "a2" => "b2")
    @test metadata(df, style=true) == Dict("a1" => ("b1", :default),
                                           "a2" => ("b2", :note))
    @test colmetadata(df) == Dict(:a => Dict("x1" => "y1",
                                             "x2" => "y2"),
                                  :c => Dict("x3" => "y3"))
    @test colmetadata(df, style=true) == Dict(:a => Dict("x1" => ("y1", :default),
                                                         "x2" => ("y2", :note)),
                                              :c => Dict("x3" => ("y3", :note)))
    @test colmetadata(df, :a) == Dict("x1" => "y1",
                                      "x2" => "y2")
    @test colmetadata(df, :a, style=true) == Dict("x1" => ("y1", :default),
                                                  "x2" => ("y2", :note))
    @test colmetadata(df, :b) == Dict()
    @test colmetadata(df, :b, style=true) == Dict()
    @test colmetadata(df, :c) == Dict("x3" => "y3")
    @test colmetadata(df, :c, style=true) == Dict("x3" => ("y3", :note))
end

@testset "rename & rename!" begin
    df = DataFrame()
    df2 = rename(df)
    @test isempty(metadatakeys(df2))
    @test isempty(colmetadatakeys(df2))
    df2 = rename!(df)
    @test isempty(metadatakeys(df2))
    @test isempty(colmetadatakeys(df2))
    @test check_allnotemetadata(df)
    @test check_allnotemetadata(df2)

    df = DataFrame()
    @test check_allnotemetadata(df)
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "drop", "value", style=:default)
    @test check_allnotemetadata(df)
    df2 = rename(df)
    @test check_allnotemetadata(df2)
    @test metadatakeys(df2) == Set(["name"])
    @test metadata(df2, "name") == "empty"
    @test isempty(colmetadatakeys(df2))
    df2 = rename!(df)
    @test check_allnotemetadata(df2)
    @test metadatakeys(df2) == Set(["name"])
    @test metadata(df2, "name") == "empty"
    @test isempty(colmetadatakeys(df2))

    df = DataFrame(a=1, b=2, c=3, d=4, e=5, f=6, g=7, h=8)
    metadata!(df, "name", "empty", style=:note)
    colmetadata!(df, :a, "name", "a", style=:note)
    colmetadata!(df, :b, "name", "b", style=:note)
    colmetadata!(df, :c, "name", "c", style=:note)
    colmetadata!(df, :e, "name", "e", style=:note)
    colmetadata!(df, :g, "name", "g", style=:note)
    metadata!(df, "name2", "empty", style=:default)
    colmetadata!(df, :a, "name2", "a", style=:default)
    colmetadata!(df, :b, "name2", "b", style=:default)
    colmetadata!(df, :c, "name2", "c", style=:default)
    colmetadata!(df, :e, "name2", "e", style=:default)
    colmetadata!(df, :g, "name2", "g", style=:default)
    @test check_allnotemetadata(df)

    # other renaming methods rely on the same mechanism as the one tested below
    # so it is enough to run these tests
    df2 = rename(df, :a => :c, :b => :d, :c => :a, :d => :b, :e => :e1, :h => :h1)
    @test check_allnotemetadata(df2)
    @test metadatakeys(df2) == Set(["name"])
    @test metadata(df2, "name") == "empty"
    @test colmetadatakeys(df2, "c") == Set(["name"])
    @test colmetadata(df2, "c", "name") == "a"
    @test colmetadatakeys(df2, "d") == Set(["name"])
    @test colmetadata(df2, "d", "name") == "b"
    @test colmetadatakeys(df2, "a") == Set(["name"])
    @test colmetadata(df2, "a", "name") == "c"
    @test isempty(colmetadatakeys(df2, "b"))
    @test colmetadatakeys(df2, "e1") == Set(["name"])
    @test colmetadata(df2, "e1", "name") == "e"
    @test isempty(colmetadatakeys(df2, "f"))
    @test colmetadatakeys(df2, "g") == Set(["name"])
    @test colmetadata(df2, "g", "name") == "g"
    @test isempty(colmetadatakeys(df2, "h1"))

    dfv = view(df, 1:1, :)
    rename!(dfv, :a => :c, :b => :d, :c => :a, :d => :b, :e => :e1, :h => :h1)
    @test check_allnotemetadata(df)
    @test metadatakeys(df) == Set(["name"])
    @test metadata(df, "name") == "empty"
    @test colmetadatakeys(df, "c") == Set(["name"])
    @test colmetadata(df, "c", "name") == "a"
    @test colmetadatakeys(df, "d") == Set(["name"])
    @test colmetadata(df, "d", "name") == "b"
    @test colmetadatakeys(df, "a") == Set(["name"])
    @test colmetadata(df, "a", "name") == "c"
    @test isempty(colmetadatakeys(df, "b"))
    @test colmetadatakeys(df, "e1") == Set(["name"])
    @test colmetadata(df, "e1", "name") == "e"
    @test isempty(colmetadatakeys(df, "f"))
    @test colmetadatakeys(df, "g") == Set(["name"])
    @test colmetadata(df, "g", "name") == "g"
    @test isempty(colmetadatakeys(df, "h1"))
end

@testset "similar, empty, empty!" begin
    for fun in (x -> similar(x, 2), empty, empty!)
        df = DataFrame()
        df2 = fun(df)
        @test check_allnotemetadata(df2)
        @test getfield(df2, :metadata) === nothing
        @test getfield(df2, :colmetadata) === nothing

        df = DataFrame(a=1, b=2)
        df2 = fun(df)
        @test check_allnotemetadata(df2)
        @test getfield(df2, :metadata) === nothing
        @test getfield(df2, :colmetadata) === nothing
    end

    df = DataFrame(a=1, b=2)
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name2", "empty2", style=:default)
    colmetadata!(df, :b, "name", "some", style=:note)
    colmetadata!(df, :b, "name2", "some2", style=:default)
    @test check_allnotemetadata(df)

    for fun in (x -> similar(x, 2), empty), x in (df, view(df, :, :))
        df2 = fun(x)
        @test check_allnotemetadata(df2)
        @test metadatakeys(df2) == Set(["name"])
        @test metadata(df2, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(df2, :a))
        @test colmetadatakeys(df2, :b) == Set(["name"])
        @test colmetadata(df2, :b, "name", style=true) == ("some", :note)
    end

    empty!(df)
    @test check_allnotemetadata(df)
    @test metadatakeys(df) == Set(["name"])
    @test metadata(df, "name", style=true) == ("empty", :note)
    @test isempty(colmetadatakeys(df, :a))
    @test colmetadatakeys(df, :b) == Set(["name"])
    @test colmetadata(df, :b, "name", style=true) == ("some", :note)
end

@testset "only, first, last" begin
    for fun in (only, first, last,
                x -> first(x, 1, view=true),
                x -> last(x, 1, view=true))
        df = DataFrame(a=1, b=2)
        x = fun(df)
        @test getfield(parent(x), :metadata) === nothing
        @test getfield(parent(x), :colmetadata) === nothing
        @test check_allnotemetadata(x)

        df = DataFrame(a=1, b=2)
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :b, "name", "some", style=:note)
        colmetadata!(df, :b, "name2", "some2", style=:default)
        @test check_allnotemetadata(df)

        x = fun(df)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(x, :a))
        @test collect(colmetadatakeys(x, :b)) == ["name"]
        @test colmetadata(x, :b, "name", style=true) == ("some", :note)
        @test check_allnotemetadata(x)
    end

    for fun in (x -> first(x, 1),
                x -> last(x, 1))
        df = DataFrame(a=1, b=2)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test getfield(x, :metadata) === nothing
        @test getfield(x, :colmetadata) === nothing
        @test check_allnotemetadata(x)

        df = DataFrame(a=1, b=2)
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :b, "name", "some", style=:note)
        colmetadata!(df, :b, "name2", "some2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(x, :a))
        @test collect(colmetadatakeys(x, :b)) == ["name"]
        @test colmetadata(x, :b, "name", style=true) == ("some", :note)
    end
end

@testset "describe" begin
    df = DataFrame()
    @test check_allnotemetadata(df)
    x = describe(df)
    @test getfield(x, :metadata) === nothing
    @test getfield(x, :colmetadata) === nothing
    @test check_allnotemetadata(x)

    df = DataFrame(a=1, b="x")
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name2", "empty2", style=:default)
    colmetadata!(df, :b, "name", "some", style=:note)
    colmetadata!(df, :b, "name2", "some2", style=:default)
    @test check_allnotemetadata(df)
    x = describe(df)
    @test getfield(x, :metadata) === nothing
    @test getfield(x, :colmetadata) === nothing
    @test check_allnotemetadata(x)
end

@testset "functions that keep all metadata" begin
    df = DataFrame(a=1, b="x")
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name2", "empty2", style=:default)
    colmetadata!(df, :b, "name", "some", style=:note)
    colmetadata!(df, :b, "name2", "some2", style=:default)
    @test check_allnotemetadata(df)

    for fun in (copy,
                DataFrame,
                x -> DataFrame(eachrow(x)),
                x -> DataFrame(eachcol(x)),
                x -> DataFrame(x, copycols=false))
        df2 = fun(df)
        @test getfield(df, :metadata) == getfield(df2, :metadata)
        @test getfield(df, :colmetadata) == getfield(df2, :colmetadata)
        @test check_allnotemetadata(df2)
    end

    df = DataFrame(a=1, b="x")
    metadata!(df, "name", "empty", style=:note)
    colmetadata!(df, :b, "name", "some", style=:note)
    @test check_allnotemetadata(df)

    for fun in (copy,
                DataFrame,
                x -> DataFrame(eachrow(x)),
                x -> DataFrame(eachcol(x)),
                x -> DataFrame(x, copycols=false))
        df2 = fun(df)
        @test getfield(df, :metadata) == getfield(df2, :metadata)
        @test getfield(df, :colmetadata) == getfield(df2, :colmetadata)
        @test check_allnotemetadata(df2)
    end
end

@testset "functions that keep all :note-style metadata" begin
    # Tested functions:
    #   dropmissing, dropmissing!, filter, filter!, unique, unique!, repeat, repeat!,
    #   disallowmissing, allowmissing, disallowmissing!, allowmissing!, flatten,
    #   reverse, reverse!, permute!, invpermute!, shuffle, shuffle!,
    #   insertcols, insertcols!, mapcols, mapcols!, sort, sort!, subset, subset!,
    #   view, eachrow, eachcol
    #   deleteat!, keepat!, resize!, pop!, popfirst!, popat!
    #   getindex, setindex!, broadcasted assignment

    for fun in (dropmissing,
                x -> dropmissing(x, disallowmissing=false),
                x -> filter(v -> true, x),
                x -> filter(v -> false, x),
                unique,
                x -> repeat(x, 3),
                x -> repeat(x, inner=2, outer=2),
                x -> disallowmissing(x, error=false),
                allowmissing,
                x -> flatten(x, []),
                x -> flatten(x, 1),
                reverse,
                shuffle,
                x -> insertcols(x, :newcol => 1),
                x -> mapcols(v -> copy(v), x),
                sort,
                x -> subset(x, [] => ByRow(() -> true)),
                x -> subset(x, [] => ByRow(() -> false)),
                x -> parent(subset(groupby(x, []), [] => ByRow(() -> true), ungroup=false)),
                x -> parent(subset(groupby(x, []), [] => ByRow(() -> false), ungroup=false)))
        df = DataFrame(a=1)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test getfield(x, :metadata) === nothing
        @test getfield(x, :colmetadata) === nothing
        @test check_allnotemetadata(x)

        df = DataFrame(a=1, b="x")
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :b, "name", "some", style=:note)
        colmetadata!(df, :b, "name2", "some2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(x, :a))
        @test collect(colmetadatakeys(x, :b)) == ["name"]
        @test colmetadata(x, :b, "name", style=true) == ("some", :note)

        df = DataFrame(a=[1, 2], c=[1, 2], b=["x", missing])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :b, "name", "some", style=:note)
        colmetadata!(df, :b, "name2", "some2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(x, :a))
        @test collect(colmetadatakeys(x, :b)) == ["name"]
        @test colmetadata(x, :b, "name", style=true) == ("some", :note)
        x = fun(view(df, :, 1:1))
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test isempty(colmetadatakeys(x, :a))
        x = fun(view(df, :, 2:3))
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name", style=true) == ("empty", :note)
        @test collect(colmetadatakeys(x, :b)) == ["name"]
        @test colmetadata(x, :b, "name", style=true) == ("some", :note)
    end

    df = DataFrame(a=[[1, 2], [3, 4]], b=["x", "y"])
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name2", "empty2", style=:default)
    colmetadata!(df, :a, "name", "a", style=:note)
    colmetadata!(df, :a, "name2", "a2", style=:default)
    colmetadata!(df, :b, "name", "b", style=:note)
    colmetadata!(df, :b, "name2", "b2", style=:default)
    @test check_allnotemetadata(df)
    x = flatten(df, 1)
    @test check_allnotemetadata(x)
    @test collect(metadatakeys(x)) == ["name"]
    @test metadata(x, "name") == "empty"
    @test collect(colmetadatakeys(x, :a)) == ["name"]
    @test colmetadata(x, :a, "name") == "a"
    @test collect(colmetadatakeys(x, :b)) == ["name"]
    @test colmetadata(x, :b, "name") == "b"
    x = flatten(view(df, 1:2, 1:2), 1)
    @test check_allnotemetadata(x)
    @test collect(metadatakeys(x)) == ["name"]
    @test metadata(x, "name") == "empty"
    @test collect(colmetadatakeys(x, :a)) == ["name"]
    @test colmetadata(x, :a, "name") == "a"
    @test collect(colmetadatakeys(x, :b)) == ["name"]
    @test colmetadata(x, :b, "name") == "b"

    for fun in (dropmissing!,
                x -> dropmissing!(x, disallowmissing=false),
                x -> dropmissing(x, view=true),
                x -> filter!(v -> true, x),
                x -> filter!(v -> false, x),
                x -> filter(v -> true, x, view=true),
                x -> filter(v -> false, x, view=true),
                x -> filter(v -> true, groupby(x, ncol(x) == 0 ? [] : 1), ungroup=true),
                x -> filter(v -> false, groupby(x, ncol(x) == 0 ? [] : 1), ungroup=true),
                unique!,
                x -> unique(x, view=true),
                x -> repeat!(x, 3),
                x -> repeat!(x, inner=2, outer=2),
                x -> disallowmissing!(x, error=false),
                allowmissing!,
                reverse!,
                x -> permute!(x, 1:nrow(x)),
                x -> invpermute!(x, 1:nrow(x)),
                shuffle!,
                x -> insertcols!(x, :newcol => 1, makeunique=true),
                x -> mapcols!(v -> copy(v), x),
                sort!,
                x -> subset!(x, [] => ByRow(() -> true)),
                x -> subset!(x, [] => ByRow(() -> false)),
                x -> subset(x, [] => ByRow(() -> true), view=true),
                x -> subset(x, [] => ByRow(() -> false), view=true),
                x -> parent(subset!(groupby(x, []), [] => ByRow(() -> true), ungroup=false)),
                x -> parent(subset!(groupby(x, []), [] => ByRow(() -> false), ungroup=false)),
                x -> view(x, :, :),
                x -> nrow(x) > 0 ? x[1, :] : view(x, :, :))
        df = DataFrame()
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test getfield(parent(x), :metadata) === nothing
        @test getfield(parent(x), :colmetadata) === nothing
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"

        df = DataFrame(a=1, b="x")
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test collect(colmetadatakeys(x, :a)) == ["name"]
        @test colmetadata(x, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(x, :b)))

        df = DataFrame(a=[1, missing], b=["x", "y"])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test collect(colmetadatakeys(x, :a)) == ["name"]
        @test colmetadata(x, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(x, :b)))
    end

    for fun in (x -> deleteat!(x, 2),
                x -> keepat!(x, 2),
                x -> resize!(x, 2),
                pop!,
                popfirst!,
                x -> popat!(x, 2))
        df = DataFrame(a=1:3, b=["x", "y", "z"])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        fun(df)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["name"]
        @test metadata(df, "name") == "empty"
        @test collect(colmetadatakeys(df, :a)) == ["name"]
        @test colmetadata(df, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(df, :b)))
    end

    for fun in (x -> x[1:2, :],
                x -> x[1:2, 1:2],
                x -> x[:, :],
                x -> x[:, 1:2],
                x -> x[!, :],
                x -> x[!, 1:2])
        df = DataFrame(a=1:3, b=["x", "y", "z"])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test collect(colmetadatakeys(x, :a)) == ["name"]
        @test colmetadata(x, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(x, :b)))
    end

    for fun in (x -> x[1:2, :],
                x -> x[1:2, 1:1],
                x -> x[:, :],
                x -> x[:, 1:1],
                x -> x[!, :],
                x -> x[!, 1:1])
        df = DataFrame(a=1:3)
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
        @test collect(colmetadatakeys(x, :a)) == ["name"]
        @test colmetadata(x, :a, "name") == "a"
    end

    for fun in (x -> x[1:0, :],
                x -> x[1:0, 1:0],
                x -> x[:, :],
                x -> x[:, 1:0],
                x -> x[!, :],
                x -> x[!, 1:0])
        df = DataFrame()
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        @test check_allnotemetadata(df)
        x = fun(df)
        @test check_allnotemetadata(x)
        @test collect(metadatakeys(x)) == ["name"]
        @test metadata(x, "name") == "empty"
    end

    df = DataFrame(a=1:3, b=["x", "y", "z"])
    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name2", "empty2", style=:default)
    colmetadata!(df, :a, "name", "a", style=:note)
    colmetadata!(df, :a, "name2", "a2", style=:default)
    @test check_allnotemetadata(df)
    df2 = df[:, 2:2]
    @test check_allnotemetadata(df2)
    @test collect(metadatakeys(df2)) == ["name"]
    @test metadata(df2, "name") == "empty"
    @test isempty(collect(colmetadatakeys(df2, :b)))
    df2 = df[!, 2:2]
    @test check_allnotemetadata(df2)
    @test collect(metadatakeys(df2)) == ["name"]
    @test metadata(df2, "name") == "empty"
    @test isempty(collect(colmetadatakeys(df2, :b)))

    for fun in (x -> (x.a = 11:13),
                x -> (x[:, :a] = 11:13),
                x -> (x[!, :a] = 11:13),
                x -> (x.c = 11:13),
                x -> (x[:, :a] .= 11:13),
                x -> (x[!, :a] .= 11:13),
                x -> (x.c = 11:13),
                x -> (x[:, :c] = 11:13),
                x -> (x[!, :c] = 11:13),
                x -> (x[1, :a] = 1),
                x -> (x[:, :] = DataFrame(a=1:3, b=["x", "y", "z"])),
                x -> (x[!, :] = DataFrame(a=1:3, b=["x", "y", "z"])),
                x -> (x[:, :] = [1 "x"; 2 "y"; 3 "z"]),
                x -> (x[!, :] = [1 "x"; 2 "y"; 3 "z"]),
                x -> (x[1:1, :a] .= 1),
                x -> (x[:, :] .= DataFrame(a=1:3, b=["x", "y", "z"])),
                x -> (x[!, :] .= DataFrame(a=1:3, b=["x", "y", "z"])),
                x -> (x[:, :] .= [1 "x"; 2 "y"; 3 "z"]),
                x -> (x[!, :] .= [1 "x"; 2 "y"; 3 "z"]))
        df = DataFrame(a=1:3, b=["x", "y", "z"])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        fun(df)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["name"]
        @test metadata(df, "name") == "empty"
        @test collect(colmetadatakeys(df, :a)) == ["name"]
        @test colmetadata(df, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(df, :b)))

        df = view(DataFrame(a=1:3, b=["x", "y", "z"]), :, :)
        metadata!(df, "name", "empty", style=:note)
        metadata!(parent(df), "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(parent(df), :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        fun(df)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["name"]
        @test metadata(df, "name") == "empty"
        @test collect(colmetadatakeys(df, :a)) == ["name"]
        @test colmetadata(df, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(df, :b)))
    end

    for fun in (x -> (x.a .= 11:13), x -> (x.a .= 1))
        df = DataFrame(a=1:3, b=["x", "y", "z"])
        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        fun(df)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["name"]
        @test metadata(df, "name") == "empty"
        @test collect(colmetadatakeys(df, :a)) == ["name"]
        @test colmetadata(df, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(df, :b)))

        df = view(DataFrame(a=1:3, b=["x", "y", "z"]), :, :)
        metadata!(df, "name", "empty", style=:note)
        metadata!(parent(df), "name2", "empty2", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(parent(df), :a, "name2", "a2", style=:default)
        @test check_allnotemetadata(df)
        fun(df)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["name"]
        @test metadata(df, "name") == "empty"
        @test collect(colmetadatakeys(df, :a)) == ["name"]
        @test colmetadata(df, :a, "name") == "a"
        @test isempty(collect(colmetadatakeys(df, :b)))
    end
end

@testset "fillcombinations" begin
    for df in (DataFrame(x=1:2, y='a':'b', z=["x", "y"]), DataFrame(x=[], y=[], z=[]))
        df2 = fillcombinations(df, [:x, :y])
        @test getfield(df2, :metadata) === nothing
        @test getfield(df2, :colmetadata) === nothing
        @test check_allnotemetadata(df2)

        metadata!(df, "name", "empty", style=:note)
        metadata!(parent(df), "name2", "empty2", style=:default)
        colmetadata!(df, :y, "name", "y", style=:note)
        colmetadata!(parent(df), :y, "name2", "y2", style=:default)
        @test check_allnotemetadata(df)
        df2 = fillcombinations(df, [:x, :y])
        @test check_allnotemetadata(df2)
        @test collect(metadatakeys(df2)) == ["name"]
        @test metadata(df2, "name") == "empty"
        @test collect(colmetadatakeys(df2, :y)) == ["name"]
        @test colmetadata(df2, :y, "name") == "y"
        @test isempty(collect(colmetadatakeys(df2, :x)))
        @test isempty(collect(colmetadatakeys(df2, :z)))
    end
end

@testset "hcat" begin
    df1 = DataFrame(a=1:3, b=11:13)
    df2 = DataFrame(c=111:113, d=1111:1113)

    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    res = hcat(df1)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "name", "some", style=:note)
    metadata!(df2, "name2", "some2", style=:default)
    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df1,"type", "other", style=:note)
    metadata!(df1,"type2", "other2", style=:default)
    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    res = hcat(df1)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["type"]
    @test metadata(res, "type") == "other"
    @test getfield(res, :colmetadata) === nothing

    metadata!(df1, "name", "some", style=:default)
    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df1, "name", "some", style=:note)
    metadata!(df1, "name2", "some2", style=:note)
    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "some"
    @test getfield(res, :colmetadata) === nothing

    colmetadata!(df1, :b, "m1", "val1", style=:note)
    colmetadata!(df2, :d, "m2", "val2", style=:note)
    colmetadata!(df1, :a, "n1", "val1", style=:default)
    colmetadata!(df2, :c, "n2", "val2", style=:default)
    res = hcat(df1, df2)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "some"
    @test isempty(colmetadatakeys(res, :a))
    @test collect(colmetadatakeys(res, :b)) == ["m1"]
    @test colmetadata(res, :b, "m1") == "val1"
    @test isempty(colmetadatakeys(res, :c))
    @test collect(colmetadatakeys(res, :d)) == ["m2"]
    @test colmetadata(res, :d, "m2") == "val2"

    res = hcat(df1)
    @test check_allnotemetadata(res)
    @test sort(collect(metadatakeys(res))) == ["name", "name2", "type"]
    @test metadata(res, "name") == "some"
    @test metadata(res, "name2") == "some2"
    @test metadata(res, "type") == "other"
    @test isempty(colmetadatakeys(res, :a))
    @test collect(colmetadatakeys(res, :b)) == ["m1"]
    @test colmetadata(res, :b, "m1") == "val1"

    res = hcat(df1, df1, df1, makeunique=true)
    @test check_allnotemetadata(res)
    @test sort(collect(metadatakeys(res))) == ["name", "name2", "type"]
    @test metadata(res, "name") == "some"
    @test metadata(res, "name2") == "some2"
    @test metadata(res, "type") == "other"
    @test isempty(colmetadatakeys(res, :a))
    @test isempty(colmetadatakeys(res, :a_1))
    @test isempty(colmetadatakeys(res, :a_2))
    @test collect(colmetadatakeys(res, :b)) == ["m1"]
    @test colmetadata(res, :b, "m1") == "val1"
    @test collect(colmetadatakeys(res, :b_1)) == ["m1"]
    @test colmetadata(res, :b_1, "m1") == "val1"
    @test collect(colmetadatakeys(res, :b_2)) == ["m1"]
    @test colmetadata(res, :b_2, "m1") == "val1"
end

@testset "vcat" begin
    df1 = DataFrame(a=1)
    df2 = DataFrame(b=2)
    df3 = DataFrame(a=11, c=3)
    df4 = DataFrame(a=111, c=33, d=4)

    res = vcat(df1, df2, df3, df4, cols=Symbol[])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = vcat(df1)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df1, "a", 1, style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = vcat(DataFrame(), df1, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "a", 1, style=:note)
    metadata!(df3, "a", 1, style=:note)
    metadata!(df4, "a", 2, style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df4, "a", 1, style=:default)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df4, "a", 1, style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing
    res = vcat(df1, df2, df3, df4, cols=Symbol[])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing
    res = vcat(df1)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing

    colmetadata!(df1, :a, "x", "y", style=:note)
    colmetadata!(df1, :a, "x1", "y1", style=:default)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing

    res = vcat(df1, df2, df3, df4, cols=Symbol[])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing

    res = vcat(df1)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"

    res = vcat(df1, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"

    res = vcat(df1, cols=[:c, :b, :a, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"

    colmetadata!(df3, :a, "x", "y", style=:note)
    colmetadata!(df3, :a, "x1", "y1", style=:default)
    colmetadata!(df4, :a, "x", "y", style=:default)
    colmetadata!(df4, :a, "x1", "y1", style=:default)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing

    colmetadata!(df4, :a, "x", "yz", style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing

    colmetadata!(df4, :a, "x", "y", style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"
    @test isempty(colmetadatakeys(res, :b))
    @test isempty(colmetadatakeys(res, :c))
    @test isempty(colmetadatakeys(res, :d))
    @test isempty(colmetadatakeys(res, :e))

    colmetadata!(df4, :c, "a", "b", style=:note)
    colmetadata!(df4, :d, "p", "q", style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"
    @test isempty(colmetadatakeys(res, :b))
    @test isempty(colmetadatakeys(res, :c))
    @test collect(colmetadatakeys(res, :d)) == ["p"]
    @test colmetadata(res, :d, "p") == "q"
    @test isempty(colmetadatakeys(res, :e))

    colmetadata!(df3, :c, "a", "b", style=:note)
    res = vcat(df1, df2, df3, df4, cols=[:a, :b, :c, :d, :e])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"
    @test isempty(colmetadatakeys(res, :b))
    @test collect(colmetadatakeys(res, :c)) == ["a"]
    @test colmetadata(res, :c, "a") == "b"
    @test collect(colmetadatakeys(res, :d)) == ["p"]
    @test colmetadata(res, :d, "p") == "q"
    @test isempty(colmetadatakeys(res, :e))

    res = vcat(df1, df2, df3, df4, cols=[:b, :a, :e, :c, :d])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"
    @test isempty(colmetadatakeys(res, :b))
    @test collect(colmetadatakeys(res, :c)) == ["a"]
    @test colmetadata(res, :c, "a") == "b"
    @test collect(colmetadatakeys(res, :d)) == ["p"]
    @test colmetadata(res, :d, "p") == "q"
    @test isempty(colmetadatakeys(res, :e))

    res = vcat(df1, df2, df3, df4, cols=:union)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test collect(colmetadatakeys(res, :a)) == ["x"]
    @test colmetadata(res, :a, "x") == "y"
    @test isempty(colmetadatakeys(res, :b))
    @test collect(colmetadatakeys(res, :c)) == ["a"]
    @test colmetadata(res, :c, "a") == "b"
    @test collect(colmetadatakeys(res, :d)) == ["p"]
    @test colmetadata(res, :d, "p") == "q"

    res = vcat(df1, df2, df3, df4, cols=:intersect)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["a"]
    @test metadata(res, "a") == 1
    @test getfield(res, :colmetadata) === nothing
end

@testset "stack" begin
    df = DataFrame(a=repeat(1:3, inner=2),
                   b=repeat(1:2, inner=3),
                   c=repeat(1:1, inner=6),
                   d=repeat(1:6, inner=1),
                   e=string.('a':'f'))
    res = stack(df, [:c, :d])
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = stack(df, [:c, :d], view=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df, "name", "empty", style=:note)
    metadata!(df, "name1", "empty1", style=:default)
    res = stack(df, [:c, :d])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test getfield(res, :colmetadata) === nothing
    res = stack(df, [:c, :d], view=true)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test getfield(res, :colmetadata) === nothing

    colmetadata!(df, :e, "name", "e", style=:note)
    colmetadata!(df, :d, "name", "d", style=:note)
    colmetadata!(df, :e, "name1", "e1", style=:default)
    colmetadata!(df, :d, "name1", "d1", style=:default)
    res = stack(df, [:c, :d])
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test isempty(colmetadatakeys(res, :a))
    @test isempty(colmetadatakeys(res, :b))
    @test collect(colmetadatakeys(res, :e)) == ["name"]
    @test colmetadata(res, :e, "name") == "e"
    @test isempty(colmetadatakeys(res, :variable))
    @test isempty(colmetadatakeys(res, :value))

    res = stack(df, [:c, :d], view=true)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test isempty(colmetadatakeys(res, :a))
    @test isempty(colmetadatakeys(res, :b))
    @test collect(colmetadatakeys(res, :e)) == ["name"]
    @test colmetadata(res, :e, "name") == "e"
    @test isempty(colmetadatakeys(res, :variable))
    @test isempty(colmetadatakeys(res, :value))
end

@testset "unstack" begin
    wide = DataFrame(id=1:6,
                     a=repeat(1:3, inner=2),
                     b=repeat(1.0:2.0, inner=3),
                     c=repeat(1.0:1.0, inner=6),
                     d=repeat(1.0:3.0, inner=2))
    long = stack(wide)

    res = unstack(long)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = unstack(long, :id, :variable, :value)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing
    res = unstack(long, :a, :variable, :value, combine=copy)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(long, "name", "empty", style=:note)
    metadata!(long, "name1", "empty1", style=:default)
    colmetadata!(long, :a, "name", "a", style=:note)
    colmetadata!(long, :a, "name1", "a1", style=:default)
    colmetadata!(long, :variable, "var", "var", style=:note)
    colmetadata!(long, :variable, "var1", "var1", style=:default)
    colmetadata!(long, :value, "val", "val", style=:note)
    colmetadata!(long, :value, "val1", "val1", style=:default)

    res = unstack(long)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test isempty(colmetadatakeys(res, :id))
    @test collect(colmetadatakeys(res, :a)) == ["name"]
    @test colmetadata(res, :a, "name") == "a"
    @test isempty(colmetadatakeys(res, :b))
    @test isempty(colmetadatakeys(res, :c))
    @test isempty(colmetadatakeys(res, :d))

    res = unstack(long, :id, :variable, :value)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test isempty(colmetadatakeys(res, :id))
    @test isempty(colmetadatakeys(res, :b))
    @test isempty(colmetadatakeys(res, :c))
    @test isempty(colmetadatakeys(res, :d))

    res = unstack(long, :a, :variable, :value, combine=copy)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "empty"
    @test collect(colmetadatakeys(res, :a)) == ["name"]
    @test colmetadata(res, :a, "name") == "a"
    @test isempty(colmetadatakeys(res, :b))
    @test isempty(colmetadatakeys(res, :c))
    @test isempty(colmetadatakeys(res, :d))
end

@testset "permutedims" begin
    for fun in (x -> permutedims(x, 1), permutedims, x -> permutedims(x, [:a, :b]))
        df = DataFrame(a=["x", "y"], b=[1.0, 2.0], c=[3, 4], d=[true, false])
        res = fun(df)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df, "name", "empty", style=:note)
        metadata!(df, "name1", "empty1", style=:default)
        colmetadata!(df, :a, "name", "a", style=:note)
        colmetadata!(df, :a, "name1", "a1", style=:default)
        colmetadata!(df, :b, "name", "b", style=:note)
        colmetadata!(df, :b, "name1", "b1", style=:default)
        colmetadata!(df, :c, "name", "c", style=:note)
        colmetadata!(df, :c, "name1", "c1", style=:default)
        colmetadata!(df, :d, "name", "d", style=:note)
        colmetadata!(df, :d, "name1", "d1", style=:default)
        res = permutedims(df, 1)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["name"]
        @test metadata(res, "name") == "empty"
        @test getfield(res, :colmetadata) === nothing
    end
end

@testset "broadcasting" begin
    df1 = DataFrame(a=1:3, b=11:13)
    df2 = DataFrame(a=-1:-1:-3, b=-11:-1:-13)

    res = log.(df1)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df1, "name", "some", style=:note)
    metadata!(df1, "name1", "some1", style=:default)
    colmetadata!(df1, :b, "x", "y", style=:note)
    colmetadata!(df1, :b, "x1", "y1", style=:default)

    res = log.(df1)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "some"
    @test isempty(colmetadatakeys(res, :a))
    @test collect(colmetadatakeys(res, :b)) == ["x"]
    @test colmetadata(res, :b, "x") == "y"

    res = log.(df1) .+ df2
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "name", "somex", style=:note)
    colmetadata!(df2, :b, "x", "yx", style=:note)
    res = log.(df1) .+ df2
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "name", "some", style=:default)
    colmetadata!(df2, :b, "x", "y", style=:default)
    res = log.(df1) .+ df2
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "name", "some", style=:note)
    colmetadata!(df2, :b, "x", "y", style=:note)
    res = log.(df1) .+ df2
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "some"
    @test isempty(colmetadatakeys(res, :a))
    @test collect(colmetadatakeys(res, :b)) == ["x"]
    @test colmetadata(res, :b, "x") == "y"

    metadata!(df1, "caption", "other", style=:note)
    res = log.(df1) .+ df2
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["name"]
    @test metadata(res, "name") == "some"
    @test isempty(colmetadatakeys(res, :a))
    @test collect(colmetadatakeys(res, :b)) == ["x"]
    @test colmetadata(res, :b, "x") == "y"

    # complex case
    df1 = DataFrame(a=1, b=2, c=3, d=4)
    df2 = DataFrame(a=1, b=2, c=3, d=4)
    df3 = DataFrame(a=1, b=2, c=3, d=4)
    colmetadata!(df1, :a, "label", "a", style=:note)
    colmetadata!(df2, :a, "label", "a", style=:note)
    colmetadata!(df3, :a, "label", "a", style=:note)
    colmetadata!(df1, :b, "label", "b", style=:note)
    colmetadata!(df2, :b, "label", "b", style=:note)
    colmetadata!(df3, :b, "label", "x", style=:note)
    colmetadata!(df1, :c, "label", "c", style=:note)
    colmetadata!(df2, :c, "label", "c", style=:note)
    colmetadata!(df3, :c, "labelx", "c", style=:note)
    colmetadata!(df1, :d, "label", "b", style=:note)
    colmetadata!(df2, :d, "label", "b", style=:note)
    colmetadata!(df3, :d, "label", "b", style=:default)
    df4 = df1 .+ df2 .+ df3
    @test check_allnotemetadata(df4)
    @test isempty(metadatakeys(df4))
    @test collect(colmetadatakeys(df4, :a)) == ["label"]
    @test colmetadata(df4, :a, "label") == "a"
    @test isempty(colmetadatakeys(df4, :b))
    @test isempty(colmetadatakeys(df4, :c))
    @test isempty(colmetadatakeys(df4, :d))
end

@testset "push!, pushfirst!, insert!" begin
    for fun in ((x, y) -> push!(x, y, cols=:union),
                (x, y) -> pushfirst!(x, y, cols=:union),
                (x, y) -> insert!(x, 2, y, cols=:union))
        df = DataFrame(a=1:3, b=2:4)
        fun(df, (a=10, b=20))
        @test check_allnotemetadata(df)
        @test getfield(df, :metadata) === nothing
        @test getfield(df, :colmetadata) === nothing

        df2 = DataFrame(a=1:3, b=2:4, c=1:3)
        metadata!(df2, "caption", "other2", style=:note)
        colmetadata!(df2, :c, "name", "c", style=:note)
        metadata!(df2, "caption1", "other3", style=:default)
        colmetadata!(df2, :c, "name1", "c2", style=:default)
        dfr = df2[1, :]

        fun(df, dfr)
        @test check_allnotemetadata(df)
        @test getfield(df, :metadata) === nothing
        @test getfield(df, :colmetadata) === nothing

        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, dfr)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
    end
end

@testset "append!, prepend!" begin
    for fun in ((x, y) -> append!(x, y, cols=:union),
                (x, y) -> prepend!(x, y, cols=:union))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, b=2:4, c=1:3)

        fun(df, df2)
        @test check_allnotemetadata(df)
        @test getfield(df, :metadata) === nothing
        @test getfield(df, :colmetadata) === nothing

        metadata!(df2, "caption", "other2", style=:note)
        colmetadata!(df2, :a, "name", "a", style=:note)
        colmetadata!(df2, :c, "name", "c", style=:note)
        metadata!(df2, "caption1", "other3", style=:default)
        colmetadata!(df2, :c, "name1", "c2", style=:default)
        df = DataFrame(a=1:3, b=2:4)
        fun(df, df2)
        @test check_allnotemetadata(df)
        @test getfield(df, :metadata) === nothing
        @test isempty(colmetadatakeys(df, :a))
        @test isempty(colmetadatakeys(df, :b))
        @test collect(colmetadatakeys(df, :c)) == ["name"]
        @test colmetadata(df, :c, "name") == "c"

        df = DataFrame(a=1:3, b=2:4)
        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, df2)
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
        @test collect(colmetadatakeys(df, :c)) == ["name"]
        @test colmetadata(df, :c, "name") == "c"

        df = DataFrame(a=1:3, b=2:4)
        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, eachrow(df2))
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
        @test collect(colmetadatakeys(df, :c)) == ["name"]
        @test colmetadata(df, :c, "name") == "c"

        df = DataFrame(a=1:3, b=2:4)
        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, eachcol(df2))
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
        @test collect(colmetadatakeys(df, :c)) == ["name"]
        @test colmetadata(df, :c, "name") == "c"

        df = DataFrame(a=1:3, b=2:4)
        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, Tables.rowtable(df2))
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
        @test isempty(colmetadatakeys(df, :c))

        df = DataFrame(a=1:3, b=2:4)
        metadata!(df, "caption", "some", style=:note)
        colmetadata!(df, :b, "name", "b", style=:note)
        metadata!(df, "caption1", "some1", style=:default)
        colmetadata!(df, :b, "name1", "b2", style=:default)
        fun(df, Tables.columntable(df2))
        @test check_allnotemetadata(df)
        @test collect(metadatakeys(df)) == ["caption"]
        @test metadata(df, "caption") == "some"
        @test isempty(colmetadatakeys(df, :a))
        @test collect(colmetadatakeys(df, :b)) == ["name"]
        @test colmetadata(df, :b, "name") == "b"
        @test isempty(colmetadatakeys(df, :c))
    end
end

@testset "leftjoin!" begin
    df = DataFrame(a=1:3, b=2:4)
    df2 = DataFrame(a=1:3, c=1:3)

    leftjoin!(df, df2, on=:a)
    @test check_allnotemetadata(df)
    @test getfield(df, :metadata) === nothing
    @test getfield(df, :colmetadata) === nothing

    metadata!(df2, "caption", "some2", style=:note)
    colmetadata!(df2, :a, "name", "a2", style=:note)
    colmetadata!(df2, :c, "name", "c2", style=:note)
    metadata!(df2, "caption1", "some2x", style=:default)
    colmetadata!(df2, :a, "name1", "a2x", style=:default)
    colmetadata!(df2, :c, "name1", "c2x", style=:default)
    df = DataFrame(a=1:3, b=2:4)
    leftjoin!(df, df2, on=:a)
    @test check_allnotemetadata(df)
    @test getfield(df, :metadata) === nothing
    @test isempty(colmetadatakeys(df, :a))
    @test isempty(colmetadatakeys(df, :b))
    @test collect(colmetadatakeys(df, :c)) == ["name"]
    @test colmetadata(df, :c, "name") == "c2"

    df = DataFrame(a=1:3, b=2:4)
    metadata!(df, "caption", "some1", style=:note)
    colmetadata!(df, :a, "name", "a1", style=:note)
    colmetadata!(df, :b, "name", "b1", style=:note)
    metadata!(df, "caption1", "some1x", style=:default)
    colmetadata!(df, :a, "name1", "a1x", style=:default)
    colmetadata!(df, :b, "name1", "b1x", style=:default)
    leftjoin!(df, df2, on=:a)
    @test check_allnotemetadata(df)
    @test collect(metadatakeys(df)) == ["caption"]
    @test metadata(df, "caption") == "some1"
    @test collect(colmetadatakeys(df, :a)) == ["name"]
    @test colmetadata(df, :a, "name") == "a1"
    @test collect(colmetadatakeys(df, :b)) == ["name"]
    @test colmetadata(df, :b, "name") == "b1"
    @test collect(colmetadatakeys(df, :c)) == ["name"]
    @test colmetadata(df, :c, "name") == "c2"

    df = DataFrame(a=1:3, b=2:4)
    df2 = DataFrame(a=1:3, b=1:3)

    leftjoin!(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(df)
    @test getfield(df, :metadata) === nothing
    @test getfield(df, :colmetadata) === nothing

    metadata!(df2, "caption", "some2", style=:note)
    colmetadata!(df2, :a, "name", "a2", style=:note)
    colmetadata!(df2, :b, "name", "c2", style=:note)
    metadata!(df2, "caption1", "some2x", style=:default)
    colmetadata!(df2, :a, "name1", "a2x", style=:default)
    colmetadata!(df2, :b, "name1", "c2x", style=:default)
    df = DataFrame(a=1:3, b=2:4)
    leftjoin!(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(df)
    @test getfield(df, :metadata) === nothing
    @test isempty(colmetadatakeys(df, :a))
    @test isempty(colmetadatakeys(df, :b))
    @test collect(colmetadatakeys(df, :b_1)) == ["name"]
    @test colmetadata(df, :b_1, "name") == "c2"

    df = DataFrame(a=1:3, b=2:4)
    metadata!(df, "caption", "some1", style=:note)
    colmetadata!(df, :a, "name", "a1", style=:note)
    colmetadata!(df, :b, "name", "b1", style=:note)
    metadata!(df, "caption1", "some1x", style=:default)
    colmetadata!(df, :a, "name1", "a1x", style=:default)
    colmetadata!(df, :b, "name1", "b1x", style=:default)
    leftjoin!(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(df)
    @test collect(metadatakeys(df)) == ["caption"]
    @test metadata(df, "caption") == "some1"
    @test collect(colmetadatakeys(df, :a)) == ["name"]
    @test colmetadata(df, :a, "name") == "a1"
    @test collect(colmetadatakeys(df, :b)) == ["name"]
    @test colmetadata(df, :b, "name") == "b1"
    @test collect(colmetadatakeys(df, :b_1)) == ["name"]
    @test colmetadata(df, :b_1, "name") == "c2"
end

@testset "leftjoin" begin
    for fun in ((x, y) -> leftjoin(x, y, on=:a),
                (x, y) -> leftjoin(x, y, on=:a, renamecols = "_left" => "_right"))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, c=1:3)

        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df2, "caption", "some2", style=:note)
        colmetadata!(df2, :a, "name", "a2", style=:note)
        colmetadata!(df2, :c, "name", "c2", style=:note)
        metadata!(df2, "caption1", "some2x", style=:default)
        colmetadata!(df2, :a, "name1", "a2x", style=:default)
        colmetadata!(df2, :c, "name1", "c2x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test isempty(colmetadatakeys(res, 1))
        @test isempty(colmetadatakeys(res, 2))
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"

        metadata!(df, "caption", "some1", style=:note)
        colmetadata!(df, :a, "name", "a1", style=:note)
        colmetadata!(df, :b, "name", "b1", style=:note)
        metadata!(df, "caption1", "some1x", style=:default)
        colmetadata!(df, :a, "name1", "a1x", style=:default)
        colmetadata!(df, :b, "name1", "b1x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["caption"]
        @test metadata(res, "caption") == "some1"
        @test collect(colmetadatakeys(res, 1)) == ["name"]
        @test colmetadata(res, 1, "name") == "a1"
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"
    end

    df = DataFrame(a=1:3, b=2:4)
    df2 = DataFrame(a=1:3, b=1:3)

    res = leftjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df2, "caption", "some2", style=:note)
    colmetadata!(df2, :a, "name", "a2", style=:note)
    colmetadata!(df2, :b, "name", "c2", style=:note)
    metadata!(df2, "caption1", "some2x", style=:default)
    colmetadata!(df2, :a, "name1", "a2x", style=:default)
    colmetadata!(df2, :b, "name1", "c2x", style=:default)
    res = leftjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test isempty(colmetadatakeys(res, 1))
    @test isempty(colmetadatakeys(res, 2))
    @test collect(colmetadatakeys(res, 3)) == ["name"]
    @test colmetadata(res, 3, "name") == "c2"

    metadata!(df, "caption", "some1", style=:note)
    colmetadata!(df, :a, "name", "a1", style=:note)
    colmetadata!(df, :b, "name", "b1", style=:note)
    metadata!(df, "caption1", "some1x", style=:default)
    colmetadata!(df, :a, "name1", "a1x", style=:default)
    colmetadata!(df, :b, "name1", "b1x", style=:default)
    res = leftjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["caption"]
    @test metadata(res, "caption") == "some1"
    @test collect(colmetadatakeys(res, 1)) == ["name"]
    @test colmetadata(res, 1, "name") == "a1"
    @test collect(colmetadatakeys(res, 2)) == ["name"]
    @test colmetadata(res, 2, "name") == "b1"
    @test collect(colmetadatakeys(res, 3)) == ["name"]
    @test colmetadata(res, 3, "name") == "c2"
end

@testset "rightjoin" begin
    for fun in ((x, y) -> rightjoin(x, y, on=:a),
                (x, y) -> rightjoin(x, y, on=:a, renamecols = "_left" => "_right"))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, c=1:3)

        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df, "caption", "some1", style=:note)
        colmetadata!(df, :a, "name", "a1", style=:note)
        colmetadata!(df, :b, "name", "b1", style=:note)
        metadata!(df, "caption1", "some1x", style=:default)
        colmetadata!(df, :a, "name1", "a1x", style=:default)
        colmetadata!(df, :b, "name1", "b1x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test isempty(colmetadatakeys(res, 1))
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test isempty(colmetadatakeys(res, 3))

        metadata!(df2, "caption", "some2", style=:note)
        colmetadata!(df2, :a, "name", "a2", style=:note)
        colmetadata!(df2, :c, "name", "c2", style=:note)
        metadata!(df2, "caption1", "some2x", style=:default)
        colmetadata!(df2, :a, "name1", "a2x", style=:default)
        colmetadata!(df2, :c, "name1", "c2x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["caption"]
        @test metadata(res, "caption") == "some2"
        @test collect(colmetadatakeys(res, 1)) == ["name"]
        @test colmetadata(res, 1, "name") == "a2"
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"
    end

    df = DataFrame(a=1:3, b=2:4)
    df2 = DataFrame(a=1:3, b=1:3)

    res = rightjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df, "caption", "some1", style=:note)
    colmetadata!(df, :a, "name", "a1", style=:note)
    colmetadata!(df, :b, "name", "b1", style=:note)
    metadata!(df, "caption1", "some1x", style=:default)
    colmetadata!(df, :a, "name1", "a1x", style=:default)
    colmetadata!(df, :b, "name1", "b1x", style=:default)
    res = rightjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test isempty(colmetadatakeys(res, 1))
    @test collect(colmetadatakeys(res, 2)) == ["name"]
    @test colmetadata(res, 2, "name") == "b1"
    @test isempty(colmetadatakeys(res, 3))

    metadata!(df2, "caption", "some2", style=:note)
    colmetadata!(df2, :a, "name", "a2", style=:note)
    colmetadata!(df2, :b, "name", "c2", style=:note)
    metadata!(df2, "caption1", "some2x", style=:default)
    colmetadata!(df2, :a, "name1", "a2x", style=:default)
    colmetadata!(df2, :b, "name1", "c2x", style=:default)
    res = rightjoin(df, df2, on=:a, makeunique=true)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["caption"]
    @test metadata(res, "caption") == "some2"
    @test collect(colmetadatakeys(res, 1)) == ["name"]
    @test colmetadata(res, 1, "name") == "a2"
    @test collect(colmetadatakeys(res, 2)) == ["name"]
    @test colmetadata(res, 2, "name") == "b1"
    @test collect(colmetadatakeys(res, 3)) == ["name"]
    @test colmetadata(res, 3, "name") == "c2"
end

@testset "innerjoin, outerjoin" begin
    for fun in ((x, y) -> innerjoin(x, y, on=:a),
                (x, y) -> innerjoin(x, y, on=:a, renamecols = "_left" => "_right"),
                (x, y) -> outerjoin(x, y, on=:a),
                (x, y) -> outerjoin(x, y, on=:a, renamecols = "_left" => "_right"))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, c=1:3)

        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df, "caption", "some1", style=:note)
        colmetadata!(df, :a, "name", "a1", style=:note)
        colmetadata!(df, :b, "name", "b1", style=:note)
        metadata!(df, "caption1", "some1x", style=:default)
        colmetadata!(df, :a, "name1", "a1x", style=:default)
        colmetadata!(df, :b, "name1", "b1x", style=:default)
        metadata!(df2, "caption", "some2", style=:note)
        colmetadata!(df2, :a, "name", "a2", style=:note)
        colmetadata!(df2, :c, "name", "c2", style=:note)
        metadata!(df2, "caption1", "some2x", style=:default)
        colmetadata!(df2, :a, "name1", "a2x", style=:default)
        colmetadata!(df2, :c, "name1", "c2x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test isempty(colmetadatakeys(res, 1))
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"

        metadata!(df2, "caption", "some1", style=:note)
        colmetadata!(df2, :a, "name", "a1", style=:note)
        metadata!(df2, "caption1", "some1x", style=:default)
        colmetadata!(df2, :a, "name1", "a1x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["caption"]
        @test metadata(res, "caption") == "some1"
        @test collect(colmetadatakeys(res, 1)) == ["name"]
        @test colmetadata(res, 1, "name") == "a1"
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"
    end

    for fun in ((x, y) -> innerjoin(x, y, on=:a, makeunique=true),
                (x, y) -> outerjoin(x, y, on=:a, makeunique=true))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, b=1:3)

        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df, "caption", "some1", style=:note)
        colmetadata!(df, :a, "name", "a1", style=:note)
        colmetadata!(df, :b, "name", "b1", style=:note)
        metadata!(df, "caption1", "some1x", style=:default)
        colmetadata!(df, :a, "name1", "a1x", style=:default)
        colmetadata!(df, :b, "name1", "b1x", style=:default)
        metadata!(df2, "caption", "some2", style=:note)
        colmetadata!(df2, :a, "name", "a2", style=:note)
        colmetadata!(df2, :b, "name", "c2", style=:note)
        metadata!(df2, "caption1", "some2x", style=:default)
        colmetadata!(df2, :a, "name1", "a2x", style=:default)
        colmetadata!(df2, :b, "name1", "c2x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test isempty(colmetadatakeys(res, 1))
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"

        metadata!(df2, "caption", "some1", style=:note)
        colmetadata!(df2, :a, "name", "a1", style=:note)
        metadata!(df2, "caption1", "some1x", style=:default)
        colmetadata!(df2, :a, "name1", "a1x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["caption"]
        @test metadata(res, "caption") == "some1"
        @test collect(colmetadatakeys(res, 1)) == ["name"]
        @test colmetadata(res, 1, "name") == "a1"
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
        @test collect(colmetadatakeys(res, 3)) == ["name"]
        @test colmetadata(res, 3, "name") == "c2"
    end
end

@testset "semijoin, antijoin" begin
    for fun in ((x, y) -> semijoin(x, y, on=:a),
                (x, y) -> antijoin(x, y, on=:a))
        df = DataFrame(a=1:3, b=2:4)
        df2 = DataFrame(a=1:3, c=1:3)

        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test getfield(res, :colmetadata) === nothing

        metadata!(df2, "caption", "some2", style=:note)
        colmetadata!(df2, :a, "name", "a2", style=:note)
        colmetadata!(df2, :c, "name", "c2", style=:note)
        metadata!(df2, "caption1", "some2x", style=:default)
        colmetadata!(df2, :a, "name1", "a2x", style=:default)
        colmetadata!(df2, :c, "name1", "c2x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test getfield(res, :metadata) === nothing
        @test isempty(colmetadatakeys(res, 1))
        @test isempty(colmetadatakeys(res, 2))

        metadata!(df, "caption", "some1", style=:note)
        colmetadata!(df, :a, "name", "a1", style=:note)
        colmetadata!(df, :b, "name", "b1", style=:note)
        metadata!(df, "caption1", "some1x", style=:default)
        colmetadata!(df, :a, "name1", "a1x", style=:default)
        colmetadata!(df, :b, "name1", "b1x", style=:default)
        res = fun(df, df2)
        @test check_allnotemetadata(res)
        @test collect(metadatakeys(res)) == ["caption"]
        @test metadata(res, "caption") == "some1"
        @test collect(colmetadatakeys(res, 1)) == ["name"]
        @test colmetadata(res, 1, "name") == "a1"
        @test collect(colmetadatakeys(res, 2)) == ["name"]
        @test colmetadata(res, 2, "name") == "b1"
    end
end

@testset "crossjoin" begin
    df = DataFrame(a=1:3, b=2:4)
    df2 = DataFrame(a=1:3, c=1:3)

    res = crossjoin(df, df2, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test getfield(res, :colmetadata) === nothing

    metadata!(df, "caption", "some1", style=:note)
    colmetadata!(df, :a, "name", "a1", style=:note)
    colmetadata!(df, :b, "name", "b1", style=:note)
    metadata!(df, "caption1", "some1x", style=:default)
    colmetadata!(df, :a, "name1", "a1x", style=:default)
    colmetadata!(df, :b, "name1", "b1x", style=:default)
    metadata!(df2, "caption", "some2", style=:note)
    colmetadata!(df2, :a, "name", "a2", style=:note)
    colmetadata!(df2, :c, "name", "c2", style=:note)
    metadata!(df2, "caption1", "some2x", style=:default)
    colmetadata!(df2, :a, "name1", "a2x", style=:default)
    colmetadata!(df2, :c, "name1", "c2x", style=:default)
    res = crossjoin(df, df2, makeunique=true)
    @test check_allnotemetadata(res)
    @test getfield(res, :metadata) === nothing
    @test collect(colmetadatakeys(res, 1)) == ["name"]
    @test colmetadata(res, 1, "name") == "a1"
    @test collect(colmetadatakeys(res, 2)) == ["name"]
    @test colmetadata(res, 2, "name") == "b1"
    @test collect(colmetadatakeys(res, 3)) == ["name"]
    @test colmetadata(res, 3, "name") == "a2"
    @test collect(colmetadatakeys(res, 4)) == ["name"]
    @test colmetadata(res, 4, "name") == "c2"

    metadata!(df2, "caption", "some1", style=:note)
    colmetadata!(df2, :a, "name", "a1", style=:note)
    metadata!(df2, "caption1", "some1x", style=:default)
    colmetadata!(df2, :a, "name1", "a1x", style=:default)
    res = crossjoin(df, df2, makeunique=true)
    @test check_allnotemetadata(res)
    @test collect(metadatakeys(res)) == ["caption"]
    @test metadata(res, "caption") == "some1"
    @test collect(colmetadatakeys(res, 1)) == ["name"]
    @test colmetadata(res, 1, "name") == "a1"
    @test collect(colmetadatakeys(res, 2)) == ["name"]
    @test colmetadata(res, 2, "name") == "b1"
    @test collect(colmetadatakeys(res, 3)) == ["name"]
    @test colmetadata(res, 3, "name") == "a1"
    @test collect(colmetadatakeys(res, 4)) == ["name"]
    @test colmetadata(res, 4, "name") == "c2"
end

@testset "data frame combine, select, select!, transform, transform!" begin
    refdf = DataFrame(id=[1, 2, 3, 1, 2, 3], a=[1, 2, 3, 1, 2, 3], b=21:26, c=31:36)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    metadata!(refdf, "name_none", "none", style=:default)
    colmetadata!(refdf, :id, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :a, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :b, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :c, "name_none", "id_none", style=:default)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    metadata!(refdf, "name", "refdf", style=:note)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    colmetadata!(refdf, :id, "name", "id", style=:note)
    colmetadata!(refdf, :a, "name", "a", style=:note)
    colmetadata!(refdf, :c, "name", "c", style=:note)

    for fun in (combine, select, select!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => identity => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => copy => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => (x -> x) => :z)
            @test check_allnotemetadata(res)
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => sum => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => sum => :c)
            @test check_allnotemetadata(res)
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => sum)
            @test check_allnotemetadata(res)
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => (x -> x) => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => (x -> x) => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => (x -> x) => :c, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => (x -> x) => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => identity => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => copy => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => (x -> x) => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => identity => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => copy => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => AsTable)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => AsTable)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => [:a])
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => [:a])
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, identity)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(identity, df)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(x -> DataFrame(newcol=1:6), df)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df) do x
                v = DataFrame(newcol=1:6)
                colmetadata!(v, "newcol", "key", "value", style=:note)
            end
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    for fun in (transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => identity => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => copy => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => sum => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => sum => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => (x -> x) => :z)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :z))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :id => (x -> x) => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a => identity => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "a"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a => copy => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "a"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :a => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "a"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => (x -> x) => :c)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :b => (x -> x) => :c, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => (x -> x) => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => identity => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => copy => :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => (x -> x) => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => identity => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, [:c] => copy => :a, :)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => AsTable)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => AsTable)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => identity => [:a])
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, :c => copy => [:a])
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df, identity)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(identity, df)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(x -> DataFrame(id=x.id, a=x.a, b=x.b, c=x.c), df)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(df) do x
                v = DataFrame(id=x.id, a=x.a, b=x.b, c=x.c)
                colmetadata!(v, "a", "key", "value", style=:note)
            end
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end
end

@testset "grouped combine, select, select!, transform, transform!" begin
    refdf = DataFrame(id=[1, 2, 3, 1, 2, 3], a=[1, 2, 3, 1, 2, 3], b=21:26, c=31:36)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id))
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :a)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    metadata!(refdf, "name_none", "none", style=:default)
    colmetadata!(refdf, :id, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :a, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :b, "name_none", "id_none", style=:default)
    colmetadata!(refdf, :c, "name_none", "id_none", style=:default)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id))
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :a)
            @test check_allnotemetadata(res)
            @test getfield(parent(res), :metadata) === nothing
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    metadata!(refdf, "name", "refdf", style=:note)

    for fun in (combine, select, select!, transform, transform!)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id))
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :a)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test getfield(parent(res), :colmetadata) === nothing
        end
    end

    colmetadata!(refdf, :id, "name", "id", style=:note)
    colmetadata!(refdf, :a, "name", "a", style=:note)
    colmetadata!(refdf, :c, "name", "c", style=:note)

    for fun in (combine, select, select!), ug in (true, false)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => identity => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => copy => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => (x -> x) => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :z))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => sum => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => sum => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => (x -> x) => :id, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
        end
        if fun !== select!
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => (x -> x) => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                res = parent(parent(res))
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test getfield(parent(parent(res)), :colmetadata) === nothing
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => identity => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                res = parent(parent(res))
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => copy => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                res = parent(parent(res))
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                res = parent(parent(res))
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
            end
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => identity => :id)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => copy => :id)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => :id)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => (x -> x) => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => (x -> x) => :c, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :c))
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => (x -> x) => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => identity => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => copy => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => (x -> x) => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => identity => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => copy => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => AsTable, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => AsTable, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => [:a], ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => [:a], ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), identity, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(identity, groupby(df, :id), ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(x -> DataFrame(id=x.id, a=x.a, b=x.b, c=x.c), groupby(df, :id), ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), ungroup=ug) do x
                v = DataFrame(id=x.id, a=x.a, b=x.b, c=x.c)
                colmetadata!(v, "a", "key", "value", style=:note)
            end
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
    end

    for fun in (transform, transform!), ug in (true, false)
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => identity => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => copy => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test collect(colmetadatakeys(res, :z)) == ["name"]
            @test colmetadata(res, :z, "name") == "id"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => sum => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => sum => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => (x -> x) => :z, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :z))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :id => (x -> x) => :id, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        if fun !== transform!
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => (x -> x) => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test isempty(colmetadatakeys(res, :id))
                @test collect(colmetadatakeys(res, :a)) == ["name"]
                @test colmetadata(res, :a, "name") == "a"
                @test isempty(colmetadatakeys(res, :b))
                @test collect(colmetadatakeys(res, :c)) == ["name"]
                @test colmetadata(res, :c, "name") == "c"
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => identity => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
                @test collect(colmetadatakeys(res, :a)) == ["name"]
                @test colmetadata(res, :a, "name") == "a"
                @test isempty(colmetadatakeys(res, :b))
                @test collect(colmetadatakeys(res, :c)) == ["name"]
                @test colmetadata(res, :c, "name") == "c"
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => copy => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
                @test collect(colmetadatakeys(res, :a)) == ["name"]
                @test colmetadata(res, :a, "name") == "a"
                @test isempty(colmetadatakeys(res, :b))
                @test collect(colmetadatakeys(res, :c)) == ["name"]
                @test colmetadata(res, :c, "name") == "c"
            end
            for df in (copy(refdf), @view copy(refdf)[:, :])
                res = fun(groupby(df, :id), :a => :id, keepkeys=false)
                @test check_allnotemetadata(res)
                @test collect(metadatakeys(res)) == ["name"]
                @test metadata(res, "name") == "refdf"
                @test collect(colmetadatakeys(res, :id)) == ["name"]
                @test colmetadata(res, :id, "name") == "a"
                @test collect(colmetadatakeys(res, :a)) == ["name"]
                @test colmetadata(res, :a, "name") == "a"
                @test isempty(colmetadatakeys(res, :b))
                @test collect(colmetadatakeys(res, :c)) == ["name"]
                @test colmetadata(res, :c, "name") == "c"
            end
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => identity => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => copy => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            # note that here grouping column metadata is retained
            res = fun(groupby(df, :id), :a => :id)
            @test check_allnotemetadata(res)
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => (x -> x) => :c, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :b => (x -> x) => :c, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => (x -> x) => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => identity => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => copy => :a, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => (x -> x) => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => identity => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), [:c] => copy => :a, :, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "c"
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => AsTable, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => AsTable, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test collect(colmetadatakeys(res, :a)) == ["name"]
            @test colmetadata(res, :a, "name") == "a"
            @test isempty(colmetadatakeys(res, :x1))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => identity => [:a], ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), :c => copy => [:a], ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test collect(colmetadatakeys(res, :c)) == ["name"]
            @test colmetadata(res, :c, "name") == "c"
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :a))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), identity, ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(identity, groupby(df, :id), ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(x -> DataFrame(id=x.id, a=x.a, b=x.b, c=x.c), groupby(df, :id), ungroup=ug)
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
        for df in (copy(refdf), @view copy(refdf)[:, :])
            res = fun(groupby(df, :id), ungroup=ug) do x
                v = DataFrame(id=x.id, a=x.a, b=x.b, c=x.c)
                colmetadata!(v, "a", "key", "value", style=:note)
            end
            @test check_allnotemetadata(res)
            res = parent(parent(res))
            @test collect(metadatakeys(res)) == ["name"]
            @test metadata(res, "name") == "refdf"
            @test collect(colmetadatakeys(res, :id)) == ["name"]
            @test colmetadata(res, :id, "name") == "id"
            @test isempty(colmetadatakeys(res, :a))
            @test isempty(colmetadatakeys(res, :b))
            @test isempty(colmetadatakeys(res, :c))
        end
    end
end

@testset "insertcols! and insertcols" begin
    df = DataFrame(a=1, b=2)
    colmetadata!(df, :a, "x", "y", style=:note)
    colmetadata!(df, :a, "x1", "y1", style=:default)
    colmetadata!(df, :b, "p", "q", style=:note)
    colmetadata!(df, :b, "p1", "q1", style=:default)
    insertcols!(df, 2, :c => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1, :d => 4)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, :e => 5)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1, :f => 1, :g => 2, :h => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 6, :f2 => 1, :g2 => 2, :h2 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, :f3 => 1, :g3 => 2, :h3 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    @test colmetadata(df, :a, "x", style=true) == ("y", :note)
    @test colmetadata(df, :b, "p", style=true) == ("q", :note)

    df = DataFrame(a=1, b=2)
    colmetadata!(df, :a, "x", "y", style=:note)
    colmetadata!(df, :a, "x1", "y1", style=:default)
    colmetadata!(df, :b, "p", "q", style=:note)
    colmetadata!(df, :b, "p1", "q1", style=:default)
    df = view(df, :, :)
    insertcols!(df, 2, :c => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1, :d => 4)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, :e => 5)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 1, :f => 1, :g => 2, :h => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, 6, :f2 => 1, :g2 => 2, :h2 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    insertcols!(df, :f3 => 1, :g3 => 2, :h3 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    @test colmetadata(df, :a, "x", style=true) == ("y", :note)
    @test colmetadata(df, :b, "p", style=true) == ("q", :note)

    df = DataFrame(a=1, b=2)
    df2 = df
    colmetadata!(df, :a, "x", "y", style=:note)
    colmetadata!(df, :a, "x1", "y1", style=:default)
    colmetadata!(df, :b, "p", "q", style=:note)
    colmetadata!(df, :b, "p1", "q1", style=:default)
    df = insertcols(df, 2, :c => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, 1, :d => 4)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, :e => 5)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, 1)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, 1, :f => 1, :g => 2, :h => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, 6, :f2 => 1, :g2 => 2, :h2 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    df = insertcols(df, :f3 => 1, :g3 => 2, :h3 => 3)
    @test sort([k => collect(v) for  (k, v) in colmetadatakeys(df)]) ==
          [:a => ["x"], :b => ["p"]]
    @test colmetadata(df, :a, "x", style=true) == ("y", :note)
    @test colmetadata(df, :b, "p", style=true) == ("q", :note)
    @test sort([k => sort(collect(v)) for  (k, v) in colmetadatakeys(df2)]) ==
          [:a => ["x", "x1"], :b => ["p", "p1"]]
    @test colmetadata(df2, :a, "x", style=true) == ("y", :note)
    @test colmetadata(df2, :a, "x1", style=true) == ("y1", :default)
    @test colmetadata(df2, :b, "p", style=true) == ("q", :note)
    @test colmetadata(df2, :b, "p1", style=true) == ("q1", :default)
end

end # module

_nrow(df::AbstractDataFrame) = nrow(df)
_nrow(x::NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}) =
    isempty(x) ? 0 : length(x[1])
_ncol(df::AbstractDataFrame) = ncol(df)
_ncol(x::Union{NamedTuple, DataFrameRow}) = length(x)
_ncol(x::Tables.AbstractRow) = length(Tables.columnnames(x))

function _combine_multicol((firstres,)::Ref{Any}, wfun::Ref{Any}, gd::GroupedDataFrame,
                           wincols::Ref{Any}, threads::Bool)
    @assert only(wfun) isa Base.Callable
    @assert only(wincols) isa Union{Nothing, AbstractVector, Tuple, NamedTuple}
    firstmulticol = firstres isa MULTI_COLS_TYPE
    if !(firstres isa Union{AbstractVecOrMat, AbstractDataFrame,
                            NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}})
        idx_agg = Vector{Int}(undef, length(gd))
        fillfirst!(nothing, idx_agg, 1:length(gd.groups), gd)
    else
        idx_agg = NOTHING_IDX_AGG
    end
    return _combine_with_first(Ref{Any}(wrap(firstres)), wfun, gd, wincols,
                               firstmulticol, idx_agg, threads)
end

function _combine_with_first((first,)::Ref{Any},
                             (f,)::Ref{Any}, gd::GroupedDataFrame,
                             (incols,)::Ref{Any},
                             firstmulticol::Bool, idx_agg::Vector{Int},
                             threads::Bool)
    @assert first isa Union{NamedTuple, DataFrameRow, AbstractDataFrame,
                            Tables.AbstractRow}
    @assert f isa Base.Callable
    @assert incols isa Union{Nothing, AbstractVector, Tuple, NamedTuple}
    extrude = false

    lgd = length(gd)
    if first isa AbstractDataFrame
        n = 0
        eltys = eltype.(eachcol(first))
    elseif first isa NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}
        n = 0
        eltys = map(eltype, first)
    elseif first isa DataFrameRow
        n = lgd
        eltys = [eltype(parent(first)[!, i]) for i in parentcols(index(first))]
    elseif first isa Tables.AbstractRow
        n = lgd
        eltys = [typeof(Tables.getcolumn(first, name)) for name in Tables.columnnames(first)]
    elseif !firstmulticol && first[1] isa Union{AbstractArray{<:Any, 0}, Ref}
        extrude = true
        first = wrap_row(first[1], firstcoltype(firstmulticol))
        n = lgd
        eltys = (typeof(first[1]),)
    else # other NamedTuple giving a single row
        n = lgd
        eltys = map(typeof, first)
        if any(x -> x <: AbstractVector, eltys)
            throw(ArgumentError("mixing single values and vectors in a named tuple is not allowed"))
        end
    end

    idx = idx_agg === NOTHING_IDX_AGG ? Vector{Int}(undef, n) : idx_agg
    # assume that we will have at least one row per group;
    # if the user wants to drop some groups this will over-allocate idx
    # but this use case is uncommon and sizehint! is cheap.
    sizehint!(idx, lgd)

    local initialcols
    let eltys=eltys, n=n # Workaround for julia#15276
        initialcols = ntuple(i -> Tables.allocatecolumn(eltys[i], n), _ncol(first))
    end
    targetcolnames = first isa Tables.AbstractRow ?
                     tuple(Tables.columnnames(first)...) :
                     tuple(propertynames(first)...)
    if !extrude && first isa Union{AbstractDataFrame,
                                   NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}}
        outcols, finalcolnames = _combine_tables_with_first!(first, initialcols, idx, 1, 1,
                                                             f, gd, incols, targetcolnames,
                                                             firstcoltype(firstmulticol))
    else
        outcols, finalcolnames = _combine_rows_with_first!(Ref{Any}(first),
                                                           Ref{Any}(initialcols),
                                                           Ref{Any}(f),
                                                           gd,
                                                           Ref{Any}(incols),
                                                           Ref{Any}(targetcolnames),
                                                           firstmulticol,
                                                           threads)
    end
    return idx, outcols, collect(Symbol, finalcolnames)
end

function _names_match(r1, t::NTuple{N, Symbol}) where N
    n1 = _getnames(r1)
    length(n1) == length(t) || return false
    for (a, b) in zip(n1, t)
        a == b || return false
    end
    return true
end

function fill_row!(row, outcols::NTuple{N, AbstractVector},
                   i::Integer, colstart::Integer,
                   colnames::NTuple{N, Symbol}) where N
    if !_names_match(row, colnames)
        throw(ArgumentError("return value must have the same column names " *
                            "for all groups (got $colnames and $(propertynames(row)))"))
    end
    @inbounds for j in colstart:length(outcols)
        col = outcols[j]
        val = row isa Tables.AbstractRow ? Tables.getcolumn(row, j) : row[j]
        S = typeof(val)
        T = eltype(col)
        if S <: T || promote_type(S, T) <: T
            col[i] = val
        else
            return j
        end
    end
    return nothing
end

function _combine_rows_with_first_task!(tid::Integer,
                                        rowstart::Integer,
                                        rowend::Integer,
                                        rownext::Integer,
                                        outcols::NTuple{<:Any, AbstractVector},
                                        outcolsref::Ref{NTuple{<:Any, AbstractVector}},
                                        type_widened::AbstractVector{Bool},
                                        widen_type_lock::ReentrantLock,
                                        f::Base.Callable,
                                        gd::GroupedDataFrame,
                                        starts::AbstractVector{<:Integer},
                                        ends::AbstractVector{<:Integer},
                                        incols::Union{Nothing, AbstractVector,
                                                      Tuple, NamedTuple},
                                        colnames::NTuple{<:Any, Symbol},
                                        firstmulticol::FirstColCount)
    j = nothing
    gdidx = gd.idx
    local newoutcols
    for i in rownext:rowend
        row = wrap_row(do_call(f, gdidx, starts, ends, gd, incols, i),
                       firstmulticol)
        j = fill_row!(row, outcols, i, 1, colnames)
        if j !== nothing # Need to widen column
            # If another thread is already widening outcols, wait until it's done
            lock(widen_type_lock)
            try
                newoutcols = outcolsref[]
                # Workaround for julia#15276
                newoutcols = let i=i, j=j, newoutcols=newoutcols, row=row
                    ntuple(length(newoutcols)) do k
                        S = typeof(row[k])
                        T = eltype(newoutcols[k])
                        U = promote_type(S, T)
                        if S <: T || U <: T
                            newoutcols[k]
                        else
                            type_widened .= true
                            Tables.allocatecolumn(U, length(newoutcols[k]))
                        end
                    end
                end
                for k in 1:length(outcols)
                    if outcols[k] !== newoutcols[k]
                        copyto!(newoutcols[k], rowstart,
                                outcols[k], rowstart, i - rowstart + (k < j))
                    end
                end
                j = fill_row!(row, newoutcols, i, j, colnames)
                @assert j === nothing # eltype is guaranteed to match

                outcolsref[] = newoutcols
                type_widened[tid] = false
            finally
                unlock(widen_type_lock)
            end
            return _combine_rows_with_first_task!(tid, rowstart, rowend, i+1, newoutcols, outcolsref,
                                                  type_widened, widen_type_lock,
                                                  f, gd, starts, ends,
                                                  incols, colnames,
                                                  firstmulticol)
        end
        # If other thread widened columns, copy already processed data to new vectors
        # This doesn't have to happen immediately (hence type_widened isn't atomic),
        # but the more we wait the more data will have to be copied
        if type_widened[tid]
            lock(widen_type_lock) do
                type_widened[tid] = false
                newoutcols = outcolsref[]
                for k in 1:length(outcols)
                    # Check whether this particular column has been widened
                    if outcols[k] !== newoutcols[k]
                        copyto!(newoutcols[k], rowstart,
                                outcols[k], rowstart, i - rowstart + 1)
                    end
                end
            end
            return _combine_rows_with_first_task!(tid, rowstart, rowend, i+1, newoutcols, outcolsref,
                                                  type_widened, widen_type_lock,
                                                  f, gd, starts, ends,
                                                  incols, colnames,
                                                  firstmulticol)
        end
    end
    return outcols
end

# CategoricalArray is thread-safe only when input and output levels are equal
# since then all values are added upfront. Otherwise, if the function returns
# CategoricalValues mixed from different pools, one thread may add values,
# which may put the invpool in an invalid state while the other one is reading from it
function isthreadsafe(outcols::NTuple{<:Any, AbstractVector},
                      incols::Union{Tuple, NamedTuple})
    anycat = any(outcols) do col
        T = typeof(col)
        # If the first result is missing, widening can give a CategoricalArray
        # if later results are CategoricalValues
        eltype(col) === Missing ||
            (nameof(T) === :CategoricalArray &&
             nameof(parentmodule(T)) === :CategoricalArrays)
    end
    if anycat
        levs = nothing
        for col in incols
            T = typeof(col)
            if nameof(T) === :CategoricalArray &&
                nameof(parentmodule(T)) === :CategoricalArrays
                if levs !== nothing
                    levs == levels(col) || return false
                else
                    levs = levels(col)
                end
            end
        end
    end
    return true
end
isthreadsafe(outcols::NTuple{<:Any, AbstractVector}, incols::AbstractVector) =
    isthreadsafe(outcols, (incols,))
isthreadsafe(outcols::NTuple{<:Any, AbstractVector}, incols::Nothing) = true

function _combine_rows_with_first!((firstrow,)::Ref{Any},
                                   (outcols,)::Ref{Any},
                                   (f,)::Ref{Any},
                                   gd::GroupedDataFrame,
                                   (incols,)::Ref{Any},
                                   (colnames,)::Ref{Any},
                                   firstmulticol::Bool,
                                   threads::Bool)
    @assert firstrow isa Union{NamedTuple, DataFrameRow, Tables.AbstractRow}
    @assert outcols isa NTuple{N, AbstractVector} where N
    @assert f isa Base.Callable
    @assert incols isa Union{Nothing, AbstractVector, Tuple, NamedTuple}
    @assert colnames isa NTuple{N, Symbol} where N
    @assert length(colnames) == length(outcols)
    len = length(gd)
    starts = gd.starts
    ends = gd.ends

    # handle empty GroupedDataFrame
    len == 0 && return outcols, colnames

    # Handle first group
    j1 = fill_row!(firstrow, outcols, 1, 1, colnames)
    @assert j1 === nothing # eltype is guaranteed to match

    # Handle groups other than the first one
    # Create up to one task per thread
    # This has lower overhead than creating one task per group,
    # but is optimal only if operations take roughly the same time for all groups
    if isthreadsafe(outcols, incols)
        basesize = max(1, cld(len - 1, Threads.nthreads()))
        partitions = Iterators.partition(2:len, basesize)
    else
        partitions = (2:len,)
    end
    widen_type_lock = ReentrantLock()
    outcolsref = Ref{NTuple{<:Any, AbstractVector}}(outcols)
    type_widened = fill(false, length(partitions))
    tasks = Vector{Task}(undef, length(partitions))
    for (tid, idx) in enumerate(partitions)
        tasks[tid] =
            @spawn_or_run_task threads _combine_rows_with_first_task!(tid, first(idx), last(idx), first(idx),
                                                                      outcols, outcolsref,
                                                                      type_widened, widen_type_lock,
                                                                      f, gd, starts, ends, incols, colnames,
                                                                      firstcoltype(firstmulticol))
    end

    # Workaround JuliaLang/julia#38931:
    # we want to preserve the exception type thrown in user code,
    # and print the backtrace corresponding to it
    for t in tasks
        try
            wait(t)
        catch e
            throw(t.exception)
        end
    end

    # Copy data for any tasks that finished before others widened columns
    oldoutcols = outcols
    outcols = outcolsref[]
    if outcols !== oldoutcols # first group
        for k in 1:length(outcols)
            outcols[k][1] = oldoutcols[k][1]
        end
    end
    for (tid, idx) in enumerate(partitions)
        if type_widened[tid]
            oldoutcols = fetch(tasks[tid])
            for k in 1:length(outcols)
                # Check whether this particular column has been widened
                if oldoutcols[k] !== outcols[k]
                    copyto!(outcols[k], first(idx), oldoutcols[k], first(idx),
                            last(idx) - first(idx) + 1)
                end
            end
        end
    end

    return outcols, colnames
end

# This needs to be in a separate function
# to work around a crash due to JuliaLang/julia#29430
@inline function do_append!(do_it, col, vals)
    do_it && append!(col, vals)
    return do_it
end

_get_col(rows::AbstractDataFrame, j::Int) = rows[!, j]
_get_col(rows::NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}, j::Int) = rows[j]

function append_rows!(rows, outcols::NTuple{N, AbstractVector},
                      colstart::Integer, colnames::NTuple{N, Symbol}) where N
    if !_names_match(rows, colnames)
        throw(ArgumentError("return value must have the same column names " *
                            "for all groups (got $colnames and $(propertynames(rows)))"))
    end
    @inbounds for j in colstart:length(outcols)
        col = outcols[j]
        cn = colnames[j]
        vals = _get_col(rows, j)
        S = eltype(vals)
        T = eltype(col)
        if !do_append!(S <: T || promote_type(S, T) <: T, col, vals)
            return j
        end
    end
    return nothing
end

function _combine_tables_with_first!(first::Union{AbstractDataFrame,
                                     NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}},
                                     outcols::NTuple{N, AbstractVector},
                                     idx::Vector{Int}, rowstart::Integer, colstart::Integer,
                                     f::Base.Callable, gd::GroupedDataFrame,
                                     incols::Union{Nothing, AbstractVector, Tuple, NamedTuple},
                                     colnames::NTuple{N, Symbol},
                                     firstmulticol::FirstColCount) where N
    len = length(gd)
    gdidx = gd.idx
    starts = gd.starts
    ends = gd.ends
    # Handle first group

    @assert _ncol(first) == N
    if !isempty(colnames) && length(gd) > 0
        j = append_rows!(first, outcols, colstart, colnames)
        @assert j === nothing # eltype is guaranteed to match
        append_const!(idx, gdidx[starts[rowstart]], _nrow(first))
    end
    # Handle remaining groups
    @inbounds for i in rowstart+1:len
        rows = wrap_table(do_call(f, gdidx, starts, ends, gd, incols, i), firstmulticol)
        _ncol(rows) == 0 && continue
        if isempty(colnames)
            newcolnames = tuple(propertynames(rows)...)
            if rows isa AbstractDataFrame
                eltys = eltype.(eachcol(rows))
            else
                eltys = map(eltype, rows)
            end
            initialcols = ntuple(i -> Tables.allocatecolumn(eltys[i], 0), _ncol(rows))
            return _combine_tables_with_first!(rows, initialcols, idx, i, 1,
                                               f, gd, incols, newcolnames, firstmulticol)
        end
        j = append_rows!(rows, outcols, 1, colnames)
        if j !== nothing # Need to widen column type
            local newcols
            let i = i, j = j, outcols=outcols, rows=rows # Workaround for julia#15276
                newcols = ntuple(length(outcols)) do k
                    S = eltype(rows isa AbstractDataFrame ? rows[!, k] : rows[k])
                    T = eltype(outcols[k])
                    U = promote_type(S, T)
                    if S <: T || U <: T
                        outcols[k]
                    else
                        copyto!(Tables.allocatecolumn(U, length(outcols[k])), outcols[k])
                    end
                end
            end
            return _combine_tables_with_first!(rows, newcols, idx, i, j,
                                               f, gd, incols, colnames, firstmulticol)
        end
        append_const!(idx, gdidx[starts[i]], _nrow(rows))
    end
    return outcols, colnames
end

function append_const!(idx::Vector{Int}, val::Int, growsize::Int)
    if growsize > 0
        oldsize = length(idx)
        newsize = oldsize + growsize
        resize!(idx, newsize)
        idx[oldsize+1:newsize] .= val
    end
end

module TestCat

using Test, Random, DataFrames, CategoricalArrays
const ≅ = isequal

@testset "hcat" begin
    nvint = [1, 2, missing, 4]
    nvstr = ["one", "two", missing, "four"]

    df2 = DataFrame([nvint, nvstr], :auto)
    df3 = DataFrame([nvint], :auto)
    df4 = DataFrame([1:4 1:4], [:x1, :x2])
    df5 = DataFrame([Union{Int, Missing}[1, 2, 3, 4], nvstr], :auto)

    ref_df = copy(df3)
    dfh = hcat(df3, df4, makeunique=true)
    @test ref_df ≅ df3 # make sure that df3 is not mutated by hcat
    @test size(dfh, 2) == 3
    @test names(dfh) ≅ ["x1", "x1_1", "x2"]
    @test dfh[!, :x1] ≅ df3[!, :x1]
    @test dfh ≅ DataFrames.hcat!(DataFrame(), df3, df4, makeunique=true)

    dfa = DataFrame(a=[1, 2])
    dfb = DataFrame(b=[3, missing])
    @test hcat(dfa, dfb) ≅ [dfa dfb]

    dfh3 = hcat(df3, df4, df5, makeunique=true)
    @test names(dfh3) == ["x1", "x1_1", "x2", "x1_2", "x2_1"]
    @test dfh3 ≅ hcat(dfh, df5, makeunique=true)
    @test dfh3 ≅ DataFrames.hcat!(DataFrame(), df3, df4, df5, makeunique=true)

    @test df2 ≅ DataFrames.hcat!(df2, makeunique=true)
end

@testset "hcat: copying" begin
    df = DataFrame(x=1:3)
    @test hcat(df)[!, 1] == df[!, 1]
    @test hcat(df)[!, 1] !== df[!, 1]
    hdf = hcat(df, df, makeunique=true)
    @test hdf[!, 1] == df[!, 1]
    @test hdf[!, 1] !== df[!, 1]
    @test hdf[!, 2] == df[!, 1]
    @test hdf[!, 2] !== df[!, 1]
    @test hdf[!, 1] == hdf[!, 2]
    @test hdf[!, 1] !== hdf[!, 2]
    hdf = hcat(df, df, df, makeunique=true)
    @test hdf[!, 1] == df[!, 1]
    @test hdf[!, 1] !== df[!, 1]
    @test hdf[!, 2] == df[!, 1]
    @test hdf[!, 2] !== df[!, 1]
    @test hdf[!, 3] == df[!, 1]
    @test hdf[!, 3] !== df[!, 1]
    @test hdf[!, 1] == hdf[!, 2]
    @test hdf[!, 1] !== hdf[!, 2]
    @test hdf[!, 1] == hdf[!, 3]
    @test hdf[!, 1] !== hdf[!, 3]
    @test hdf[!, 2] == hdf[!, 3]
    @test hdf[!, 2] !== hdf[!, 3]
end

@testset "hcat ::AbstractDataFrame" begin
    df = DataFrame(A=repeat('A':'C', inner=4), B=1:12)
    gd = groupby(df, :A)
    answer = DataFrame(A=fill('A', 4), B=1:4, A_1='B', B_1=5:8, A_2='C', B_2=9:12)
    @test hcat(gd..., makeunique=true) == answer
    answer = answer[:, 1:4]
    @test hcat(gd[1], gd[2], makeunique=true) == answer

    @test_throws MethodError hcat("a", df, makeunique=true)
    @test_throws MethodError hcat(df, "a", makeunique=true)
end

@testset "hcat: copycols" begin
    df1 = DataFrame(a=1:3)
    df2 = DataFrame(b=1:3)
    dfv = view(df2, :, :)
    x = [1, 2, 3]

    df3 = hcat(df1)
    @test df3 == df1
    @test df3.a !== df1.a
    df3 = hcat(df1, copycols=true)
    @test df3 == df1
    @test df3.a !== df1.a
    df3 = hcat(df1, copycols=false)
    @test df3 == df1
    @test df3.a === df1.a

    df3 = hcat(df1, df2)
    @test propertynames(df3) == [:a, :b]
    @test df3.a == df1.a
    @test df3.b == df2.b
    @test df3.a !== df1.a
    @test df3.b !== df2.b
    df3 = hcat(df1, df2, copycols=true)
    @test propertynames(df3) == [:a, :b]
    @test df3.a == df1.a
    @test df3.b == df2.b
    @test df3.a !== df1.a
    @test df3.b !== df2.b
    df3 = hcat(df1, df2, copycols=false)
    @test propertynames(df3) == [:a, :b]
    @test df3.a === df1.a
    @test df3.b === df2.b

    df3 = hcat(df1, dfv)
    @test propertynames(df3) == [:a, :b]
    @test df3.a == df1.a
    @test df3.b == df2.b
    @test df3.a !== df1.a
    @test df3.b !== df2.b
    df3 = hcat(df1, dfv, copycols=true)
    @test propertynames(df3) == [:a, :b]
    @test df3.a == df1.a
    @test df3.b == df2.b
    @test df3.a !== df1.a
    @test df3.b !== df2.b
    df3 = hcat(df1, dfv, copycols=false)
    @test propertynames(df3) == [:a, :b]
    @test df3.a === df1.a
    @test df3.b === dfv.b
end

@testset "vcat" begin
    missing_df = DataFrame()
    df = DataFrame([3.0  2.0  2.0
                    2.0  2.0  2.0
                    3.0  1.0  2.0
                    3.0  3.0  3.0], :auto)
    df[!, 3] = Int.(df[!, 3])

    @test vcat(missing_df) == DataFrame()
    @test vcat(missing_df, missing_df) == DataFrame()
    @test vcat(missing_df) == DataFrame()
    @test vcat(missing_df, missing_df) == DataFrame()
    @test vcat(missing_df, df) == df
    @test vcat(df, missing_df) == df
    @test eltype.(eachcol(vcat(df, df))) == Type[Float64, Float64, Int]
    @test size(vcat(df, df)) == (size(df, 1) * 2, size(df, 2))
    res = vcat(df, df)
    @test res[1:size(df, 1), :] == df
    @test res[(1+size(df, 1)):end, :] == df
    res = vcat(df, df, df)
    @test eltype.(eachcol(res)) == Type[Float64, Float64, Int]
    @test size(res) == (size(df, 1) * 3, size(df, 2))

    s = size(df, 1)
    for i in 1:3
        @test res[1+(i-1)*s:i*s, :] == df
    end

    alt_df = deepcopy(df)
    @test vcat(df, alt_df) == DataFrame([[3.0, 2.0, 3.0, 3.0, 3.0, 2.0, 3.0, 3.0],
                                         [2.0, 2.0, 1.0, 3.0, 2.0, 2.0, 1.0, 3.0],
                                         [2, 2, 2, 3, 2, 2, 2, 3]], :auto)

    # Don't fail on non-matching types
    df[!, 1] = zeros(Int, nrow(df))
    @test vcat(df, alt_df) == DataFrame([[0.0, 0.0, 0.0, 0.0, 3.0, 2.0, 3.0, 3.0],
                                         [2.0, 2.0, 1.0, 3.0, 2.0, 2.0, 1.0, 3.0],
                                         [2, 2, 2, 3, 2, 2, 2, 3]], :auto)

    df1 = DataFrame(A=Int[], B=Float64[])
    df2 = DataFrame(B=1.0, A=1)
    @test vcat(df2, df1, df2, df1) == vcat(df2, df2)

    df = DataFrame(A=1:5, B=11:15, C=21:25)
    @test vcat(view(df, 1:2, :), view(df, 3:5, [3, 2, 1])) == df
    @test_throws ArgumentError view(df, 1:2, [1, 2, 3, 1, 2, 3])
    @test_throws ArgumentError view(df, 3:5, [3, 2, 1, 1, 2, 3])
end

@testset "vcat copy" begin
    df = DataFrame(x=1:3)
    @test vcat(df)[!, 1] == df[!, 1]
    @test vcat(df)[!, 1] !== df[!, 1]
end

@testset "vcat >2 args" begin
    empty_dfs = [DataFrame(), DataFrame(), DataFrame()]
    @test vcat(empty_dfs...) == reduce(vcat, empty_dfs) == DataFrame()
    @test reduce(vcat, Tuple(empty_dfs)) == DataFrame()

    df = DataFrame(x=trues(1), y=falses(1))
    dfs = [df, df, df]
    @test vcat(dfs...) == reduce(vcat, dfs) == DataFrame(x=trues(3), y=falses(3))
    @test reduce(vcat, Tuple(dfs)) == DataFrame(x=trues(3), y=falses(3))
end

@testset "vcat mixed coltypes" begin
    df = vcat(DataFrame([[1]], [:x]), DataFrame([[1.0]], [:x]))
    @test df == DataFrame([[1.0, 1.0]], [:x])
    @test typeof.(eachcol(df)) == [Vector{Float64}]
    df = vcat(DataFrame([[1]], [:x]), DataFrame([["1"]], [:x]))
    @test df == DataFrame([[1, "1"]], [:x])
    @test typeof.(eachcol(df)) == [Vector{Any}]
    df = vcat(DataFrame([Union{Missing, Int}[1]], [:x]), DataFrame([[1]], [:x]))
    @test df == DataFrame([[1, 1]], [:x])
    @test typeof.(eachcol(df)) == [Vector{Union{Missing, Int}}]
    df = vcat(DataFrame([CategoricalArray([1])], [:x]), DataFrame([[1]], [:x]))
    @test df == DataFrame([[1, 1]], [:x])
    @test df.x isa Vector{Int}
    df = vcat(DataFrame([CategoricalArray([1])], [:x]),
              DataFrame([Union{Missing, Int}[1]], [:x]))
    @test df == DataFrame([[1, 1]], [:x])
    @test df.x isa Vector{Union{Int, Missing}}
    df = vcat(DataFrame([CategoricalArray([1])], [:x]),
              DataFrame([CategoricalArray{Union{Int, Missing}}([1])], [:x]))
    @test df == DataFrame([[1, 1]], [:x])
    @test df.x isa CategoricalVector{Union{Int, Missing}}
    df = vcat(DataFrame([Union{Int, Missing}[1]], [:x]),
              DataFrame([["1"]], [:x]))
    @test df == DataFrame([[1, "1"]], [:x])
    @test typeof.(eachcol(df)) == [Vector{Any}]
    df = vcat(DataFrame([CategoricalArray([1])], [:x]),
              DataFrame([CategoricalArray([1.0])], [:x]))
    @test df == DataFrame([[1.0, 1.0]], [:x])
    @test df.x isa CategoricalVector{Float64}
    @test levels(df.x) == [1.0]
    df = vcat(DataFrame([trues(1)], [:x]), DataFrame([[false]], [:x]))
    @test df == DataFrame([[true, false]], [:x])
    @test typeof.(eachcol(df)) == [Vector{Bool}]
end

@testset "vcat out of order" begin
    df1 = DataFrame(A=1:3, B=4:6, C=7:9)
    df2 = DataFrame([2x for x in eachcol(df1)], reverse(names(df1)))
    @test vcat(df1, df2) == DataFrame(A=[1, 2, 3, 14, 16, 18],
                                      B=[4, 5, 6, 8, 10, 12],
                                      C=[7, 8, 9, 2, 4, 6])
    @test vcat(df1, df1, df2) == DataFrame(A=[1, 2, 3, 1, 2, 3, 14, 16, 18],
                                           B=[4, 5, 6, 4, 5, 6, 8, 10, 12],
                                           C=[7, 8, 9, 7, 8, 9, 2, 4, 6])
    @test vcat(df1, df2, df2) == DataFrame(A=[1, 2, 3, 14, 16, 18, 14, 16, 18],
                                           B=[4, 5, 6, 8, 10, 12, 8, 10, 12],
                                           C=[7, 8, 9, 2, 4, 6, 2, 4, 6])
    @test vcat(df2, df1, df2) == DataFrame(C=[2, 4, 6, 7, 8, 9, 2, 4, 6],
                                           B=[8, 10, 12, 4, 5, 6, 8, 10, 12],
                                           A=[14, 16, 18, 1, 2, 3, 14, 16, 18])
    @test size(vcat(df1, df1, df1, df2, df2, df2)) == (18, 3)
    df3 = df1[:, [1, 3, 2]]
    res = vcat(df1, df1, df1, df2, df2, df2, df3, df3, df3, df3)
    @test res == reduce(vcat, [df1, df1, df1, df2, df2, df2, df3, df3, df3, df3])
    @test res == reduce(vcat, (df1, df1, df1, df2, df2, df2, df3, df3, df3, df3))
    @test size(res) == (30, 3)
    @test res[1:3, :] == df1
    @test res[4:6, :] == df1
    @test res[7:9, :] == df1
    @test res[10:12, :] == df2[:, names(res)]
    @test res[13:15, :] == df2[:, names(res)]
    @test res[16:18, :] == df2[:, names(res)]
    @test res[19:21, :] == df3[:, names(res)]
    @test res[22:24, :] == df3[:, names(res)]
    @test res[25:27, :] == df3[:, names(res)]

    df1 = DataFrame(A=1, B=2)
    df2 = DataFrame(B=12, A=11)
    df3 = DataFrame(A=[1, 11], B=[2, 12])
    @test [df1; df2] == df3 == reduce(vcat, [df1, df2])
    @test df3 == reduce(vcat, (df1, df2))
    @test_throws ArgumentError vcat(df1, df2, cols=:orderequal)
    @test_throws ArgumentError reduce(vcat, [df1, df2], cols=:orderequal)
end

@testset "vcat with cols=:union" begin
    df1 = DataFrame(A=1:3, B=4:6)
    df2 = DataFrame(A=7:9)
    df3 = DataFrame(B=4:6, A=1:3)

    @test vcat(df1, df2; cols = :union) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9],
                  B=[4, 5, 6, missing, missing, missing])
    @test vcat(df1, df2; cols = :union) ≅ reduce(vcat, [df1, df2]; cols = :union)
    @test vcat(df1, df2; cols = :union) ≅ reduce(vcat, (df1, df2); cols = :union)
    @test vcat(df1, df2, df3; cols = :union) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9, 1, 2, 3],
                  B=[4, 5, 6, missing, missing, missing, 4, 5, 6])
    @test vcat(df1, df2, df3; cols = :union) ≅ reduce(vcat, [df1, df2, df3]; cols = :union)
    @test vcat(df1, df2, df3; cols = :union) ≅ reduce(vcat, (df1, df2, df3); cols = :union)
end

@testset "vcat with cols=:intersect" begin
    df1 = DataFrame(A=1:3, B=4:6)
    df2 = DataFrame(A=7:9)
    df3 = DataFrame(A=10:12, C=13:15)

    @test vcat(df1, df2; cols = :intersect) ≅ DataFrame(A=[1, 2, 3, 7, 8, 9])
    @test vcat(df1, df2; cols = :intersect) ≅ reduce(vcat, [df1, df2]; cols = :intersect)
    @test vcat(df1, df2; cols = :intersect) ≅ reduce(vcat, (df1, df2); cols = :intersect)
    @test vcat(df1, df2, df3; cols = :intersect) ≅ DataFrame(A=[1, 2, 3, 7, 8, 9,
                                                                10, 11, 12])
    @test vcat(df1, df2, df3; cols = :intersect) ≅ reduce(vcat, [df1, df2, df3]; cols = :intersect)
    @test vcat(df1, df2, df3; cols = :intersect) ≅ reduce(vcat, (df1, df2, df3); cols = :intersect)
end

@testset "vcat with cols::Vector" begin
    df1 = DataFrame(A=1:3, B=4:6)
    df2 = DataFrame(A=7:9)
    df3 = DataFrame(A=10:12, C=13:15)

    @test vcat(df1, df2; cols = [:A, :B, :C]) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9],
                  B=[4, 5, 6, missing, missing, missing],
                  C=[missing, missing, missing, missing, missing, missing])
    @test vcat(df1, df2; cols = [:A, :B, :C]) ≅
          reduce(vcat, [df1, df2]; cols = [:A, :B, :C])
    @test vcat(df1, df2; cols = [:A, :B, :C]) ≅
          reduce(vcat, (df1, df2); cols = [:A, :B, :C])

    @test vcat(df1, df2, df3; cols = [:A, :B, :C]) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9, 10, 11, 12],
                  B=[4, 5, 6, missing, missing, missing, missing, missing, missing],
                  C=[missing, missing, missing, missing, missing, missing, 13, 14, 15])
    @test vcat(df1, df2, df3; cols = [:A, :B, :C]) ≅
          reduce(vcat, [df1, df2, df3]; cols = [:A, :B, :C])
    @test vcat(df1, df2, df3; cols = [:A, :B, :C]) ≅
          reduce(vcat, (df1, df2, df3); cols = [:A, :B, :C])

    df1 = DataFrame(A=Int[], B=Float64[])
    df2 = DataFrame(B=1.0, A=1)
    @test vcat(df1, df2, df1, cols=[:A, :C, :B]) ≅ DataFrame(A=1, C=missing, B=1.0)
    @test vcat(df1, df2, df1, cols=[:A, :C, :B]) ≅
          reduce(vcat, [df1, df2, df1], cols=[:A, :C, :B])
    @test vcat(df1, df2, df1, cols=[:A, :C, :B]) ≅
          reduce(vcat, (df1, df2, df1), cols=[:A, :C, :B])
    @test vcat(df1, df2, df2, cols=[:C]) ≅ DataFrame(C=[missing, missing])
    @test vcat(df1, df2, df2, cols=[:C]) ≅ reduce(vcat, [df1, df2, df2], cols=[:C])
    @test vcat(df1, df2, df2, cols=[:C]) ≅ reduce(vcat, (df1, df2, df2), cols=[:C])
    @test_throws ArgumentError vcat(df1, df2, df2, cols=[:C, :C])
    @test_throws ArgumentError reduce(vcat, [df1, df2, df2], cols=[:C, :C])
    @test_throws ArgumentError reduce(vcat, (df1, df2, df2), cols=[:C, :C])

    df1 = DataFrame(A=1:3, B=4:6)
    df2 = DataFrame(A=7:9)
    df3 = DataFrame(A=10:12, C=13:15)

    @test vcat(df1, df2; cols = ["A", "B", "C"]) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9],
                  B=[4, 5, 6, missing, missing, missing],
                  C=[missing, missing, missing, missing, missing, missing])
    @test vcat(df1, df2; cols = ["A", "B", "C"]) ≅
          reduce(vcat, [df1, df2]; cols = ["A", "B", "C"])
    @test vcat(df1, df2; cols = ["A", "B", "C"]) ≅
          reduce(vcat, (df1, df2); cols = ["A", "B", "C"])

    @test vcat(df1, df2, df3; cols = ["A", "B", "C"]) ≅
        DataFrame(A=[1, 2, 3, 7, 8, 9, 10, 11, 12],
                  B=[4, 5, 6, missing, missing, missing, missing, missing, missing],
                  C=[missing, missing, missing, missing, missing, missing, 13, 14, 15])
    @test vcat(df1, df2, df3; cols = ["A", "B", "C"]) ≅
          reduce(vcat, [df1, df2, df3]; cols = ["A", "B", "C"])
    @test vcat(df1, df2, df3; cols = ["A", "B", "C"]) ≅
          reduce(vcat, (df1, df2, df3); cols = ["A", "B", "C"])

    df1 = DataFrame(A=Int[], B=Float64[])
    df2 = DataFrame(B=1.0, A=1)
    @test vcat(df1, df2, df1, cols=["A", "C", "B"]) ≅ DataFrame(A=1, C=missing, B=1.0)
    @test vcat(df1, df2, df1, cols=["A", "C", "B"]) ≅
          reduce(vcat, [df1, df2, df1], cols=["A", "C", "B"])
    @test vcat(df1, df2, df1, cols=["A", "C", "B"]) ≅
          reduce(vcat, (df1, df2, df1), cols=["A", "C", "B"])
    @test vcat(df1, df2, df2, cols=["C"]) ≅ DataFrame(C=[missing, missing])
    @test vcat(df1, df2, df2, cols=["C"]) ≅ reduce(vcat, [df1, df2, df2], cols=["C"])
    @test vcat(df1, df2, df2, cols=["C"]) ≅ reduce(vcat, (df1, df2, df2), cols=["C"])
    @test_throws ArgumentError vcat(df1, df2, df2, cols=[:C, :C])
    @test_throws ArgumentError reduce(vcat, [df1, df2, df2], cols=["C", "C"])
    @test_throws ArgumentError reduce(vcat, (df1, df2, df2), cols=["C", "C"])
end

@testset "vcat thrown exceptions" begin
    df1 = DataFrame(A=1:3, B=1:3)
    df2 = DataFrame(A=1:3)

    # wrong cols argument
    @test_throws ArgumentError vcat(df1, df1, cols=:unions)
    # right missing 1 column
    err = @test_throws ArgumentError vcat(df1, df2)
    @test err.value.msg == "column(s) B are missing from argument(s) 2"
    # left missing 1 column
    err = @test_throws ArgumentError vcat(df2, df1)
    @test err.value.msg == "column(s) B are missing from argument(s) 1"
    # multiple missing 1 column
    err1 = @test_throws ArgumentError vcat(df1, df2, df2, df2, df2, df2)
    err2 = @test_throws ArgumentError reduce(vcat, [df1, df2, df2, df2, df2, df2])
    @test_throws ArgumentError reduce(vcat, (df1, df2, df2, df2, df2, df2))
    @test err1.value.msg == err2.value.msg ==
          "column(s) B are missing from argument(s) 2, 3, 4, 5 and 6"
    # argument missing >1 columns
    df1 = DataFrame(A=1:3, B=1:3, C=1:3, D=1:3, E=1:3)
    err = @test_throws ArgumentError vcat(df1, df2)
    @test err.value.msg == "column(s) B, C, D and E are missing from argument(s) 2"
    # >1 arguments missing >1 columns
    err = @test_throws ArgumentError vcat(df1, df2, df2, df2, df2)
    @test err.value.msg == "column(s) B, C, D and E are missing from argument(s) 2, 3, 4 and 5"
    # missing columns throws error
    df1 = DataFrame(A=1, B=1)
    df2 = DataFrame(A=1)
    df3 = DataFrame(B=1, A=1)
    err = @test_throws ArgumentError vcat(df1, df2, df3)
    @test err.value.msg == "column(s) B are missing from argument(s) 2"
    # unique columns for both sides
    df1 = DataFrame(A=1, B=1, C=1, D=1)
    df2 = DataFrame(A=1, C=1, D=1, E=1, F=1)
    err = @test_throws ArgumentError vcat(df1, df2)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, " *
                           "and column(s) B are missing from argument(s) 2"
    err = @test_throws ArgumentError vcat(df1, df1, df2, df2)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1 and 2, " *
                           "and column(s) B are missing from argument(s) 3 and 4"
    df3 = DataFrame(A=1, B=1, C=1, D=1, E=1)
    err = @test_throws ArgumentError vcat(df1, df2, df3)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, " *
                           "column(s) B are missing from argument(s) 2, " *
                           "and column(s) F are missing from argument(s) 3"
    err = @test_throws ArgumentError vcat(df1, df1, df2, df2, df3, df3)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1 and 2, " *
                           "column(s) B are missing from argument(s) 3 and 4, " *
                           "and column(s) F are missing from argument(s) 5 and 6"
    err = @test_throws ArgumentError vcat(df1, df1, df1, df2, df2, df2, df3, df3, df3)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, 2 and 3, " *
                           "column(s) B are missing from argument(s) 4, 5 and 6, " *
                           "and column(s) F are missing from argument(s) 7, 8 and 9"
    # df4 is a superset of names found in all other DataFrames and won't be shown in error
    df4 = DataFrame(A=1, B=1, C=1, D=1, E=1, F=1)
    err = @test_throws ArgumentError vcat(df1, df2, df3, df4)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, " *
                           "column(s) B are missing from argument(s) 2, " *
                           "and column(s) F are missing from argument(s) 3"
    err = @test_throws ArgumentError vcat(df1, df1, df2, df2, df3, df3, df4, df4)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1 and 2, " *
                           "column(s) B are missing from argument(s) 3 and 4, " *
                           "and column(s) F are missing from argument(s) 5 and 6"
    err = @test_throws ArgumentError vcat(df1, df1, df1, df2, df2, df2,
                                          df3, df3, df3, df4, df4, df4)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, 2 " *
                           "and 3, column(s) B are missing from argument(s) 4, 5 " *
                           "and 6, and column(s) F are missing from argument(s) 7, 8 and 9"
    err = @test_throws ArgumentError vcat(df1, df2, df3, df4, df1, df2,
                                          df3, df4, df1, df2, df3, df4)
    @test err.value.msg == "column(s) E and F are missing from argument(s) 1, 5 and 9, " *
                           "column(s) B are missing from argument(s) 2, 6 and 10, " *
                           "and column(s) F are missing from argument(s) 3, 7 and 11"
end

@testset "vcat with view" begin
    x = view(DataFrame(A=Vector{Union{Missing, Int}}(1:3)), 2:2, :)
    y = DataFrame(A=4:5)
    @test vcat(x, y) == DataFrame(A=[2, 4, 5]) ==
          reduce(vcat, [x, y]) == reduce(vcat, (x, y))
end

@testset "reduce vcat corner cases" begin
    df = DataFrame(a=1, b=2)
    df1 = @view df[:, :]
    df2 = @view df[:, 1:2]
    @test typeof(df1) != typeof(df2)

    @test_throws Union{MethodError, ArgumentError} reduce(vcat, ())
    @test reduce(vcat, DataFrame[]) == DataFrame()
    @test reduce(vcat, SubDataFrame[]) == DataFrame()
    @test reduce(vcat, AbstractDataFrame[]) == DataFrame()

    @test reduce(vcat, [df]) == df
    @test reduce(vcat, [df1]) == df
    @test reduce(vcat, [df2]) == df
    @test reduce(vcat, [df, df]) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, [df, df1]) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, [df, df2]) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, [df1, df2]) == DataFrame(a=[1, 1], b=[2, 2])

    @test reduce(vcat, (df,)) == df
    @test reduce(vcat, (df1,)) == df
    @test reduce(vcat, (df2,)) == df
    @test reduce(vcat, (df, df)) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, (df, df1)) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, (df, df2)) == DataFrame(a=[1, 1], b=[2, 2])
    @test reduce(vcat, (df1, df2)) == DataFrame(a=[1, 1], b=[2, 2])
end

@testset "vcat type piracy" begin
    x = Int[]
    @test reduce(vcat, Union{}[], init=x) === x

    @test reduce(vcat, AbstractDataFrame[DataFrame(a=1), DataFrame(a=2)]) ==
          DataFrame(a=[1, 2])
    @test reduce(vcat, Union{DataFrame, SubDataFrame}[DataFrame(a=1), DataFrame(a=2)]) ==
          DataFrame(a=[1, 2])
    @test reduce(vcat, AbstractDataFrame[DataFrame(a=1), DataFrame(a=2)]; source=:source) ==
          DataFrame(a=[1, 2], source=[1, 2])
    @test reduce(vcat, Union{DataFrame,SubDataFrame}[DataFrame(a=1), DataFrame(a=2)]; source=:source) ==
          DataFrame(a=[1, 2], source=[1, 2])
end


end # module

##############################################################################
##
## Sorting
##
##############################################################################

#########################################
## Permutation & Ordering types/functions
#########################################
# Sorting in Julia works through Orderings, where each ordering is a type
# which defines a comparison function lt(o::Ord, a, b).

# UserColOrdering: user ordering of a column; this is just a convenience container
#                  which allows a user to specify column specific orderings
#                  with "order(column, rev=true, ...)"

import SortingAlgorithms.DataStructures.FasterForward,
       SortingAlgorithms.DataStructures.FasterReverse

struct UserColOrdering{T<:ColumnIndex}
    col::T
    kwargs
end

"""
    order(col::ColumnIndex; kwargs...)

Specify sorting order for a column `col` in a data frame.
`kwargs` can be `lt`, `by`, `rev`, and `order` with values
following the rules defined in [`sort!`](@ref).

See also: [`sort!`](@ref), [`sort`](@ref)

# Examples
```jldoctest
julia> df = DataFrame(x=[-3, -1, 0, 2, 4], y=1:5)
5×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │    -3      1
   2 │    -1      2
   3 │     0      3
   4 │     2      4
   5 │     4      5

julia> sort(df, order(:x, rev=true))
5×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     4      5
   2 │     2      4
   3 │     0      3
   4 │    -1      2
   5 │    -3      1

julia> sort(df, order(:x, by=abs))
5×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     0      3
   2 │    -1      2
   3 │     2      4
   4 │    -3      1
   5 │     4      5
```
"""
order(col::T; kwargs...) where {T<:ColumnIndex} = UserColOrdering{T}(col, kwargs)

# Allow getting the column even if it is not wrapped in a UserColOrdering
_getcol(o::UserColOrdering) = o.col
_getcol(x) = x

###
# Get an Ordering for a single column
###
function ordering(col_ord::UserColOrdering, lt::Function, by::Function,
                  rev::Bool, order::Ordering)
    for (k, v) in pairs(col_ord.kwargs)
        if     k == :lt;    lt    = v
        elseif k == :by;    by    = v
        elseif k == :rev;   rev   = v
        elseif k == :order; order = v
        else
            error("Unknown keyword argument: ", string(k))
        end
    end

    Order.ord(lt, by, rev, order)
end

ordering(col::ColumnIndex, lt::Function, by::Function, rev::Bool, order::Ordering) =
    Order.ord(lt, by, rev, order)

# DFPerm: defines a permutation on a particular DataFrame, using
#         a single ordering (O<:Ordering) or a list of column orderings
#         (NTuple of Ordering), one per DataFrame column
#
#         If a user only specifies a few columns, the DataFrame
#         contained in the DFPerm only contains those columns, and
#         the permutation induced by this ordering is used to
#         sort the original (presumably larger) DataFrame

struct DFPerm{O<:Union{Ordering, Tuple{Vararg{Ordering}}},
              T<:Tuple{Vararg{AbstractVector}}} <: Ordering
    ord::O
    cols::T
end

function DFPerm(ords::AbstractVector{O}, cols::T) where {O<:Ordering, T<:Tuple}
    if length(ords) != length(cols)
        error("DFPerm: number of column orderings does not equal the number of columns")
    end
    DFPerm(Tuple(ords), cols)
end

DFPerm(o::Union{Ordering, AbstractVector}, df::AbstractDataFrame) =
    DFPerm(o, ntuple(i -> df[!, i], ncol(df)))

@inline col_ordering(o::Ordering) = o
@inline ord_tail(o::Ordering) = o
@inline col_ordering(o::Tuple{Vararg{Ordering}}) = @inbounds o[1]
@inline ord_tail(o::Tuple{Vararg{Ordering}}) = Base.tail(o)

Sort.lt(o::DFPerm{<:Any, Tuple{}}, a, b) = false

function Sort.lt(o::DFPerm{<:Any, <:Tuple}, a, b)
    ord = o.ord
    cols = o.cols
    # if there are too many columns fall back to type unstable mode to avoid high compilation cost
    # it is expected that in practice users sort data frames on only few columns
    length(cols) > 16 && return unstable_lt(ord, cols, a, b)

    @inbounds begin
        ord1 = col_ordering(ord)
        col = first(cols)
        va = col[a]
        vb = col[b]
        lt(ord1, va, vb) && return true
        lt(ord1, vb, va) && return false
    end
    return Sort.lt(DFPerm(ord_tail(ord), Base.tail(cols)), a, b)
end

# get ordering function for the i-th column used for ordering
col_ordering(o::Ordering, ::Int) = o
col_ordering(o::Tuple{Vararg{Ordering}}, i::Int) = @inbounds o[i]

function unstable_lt(ord::Union{Ordering, Tuple{Vararg{Ordering}}},
                     cols::Tuple{Vararg{AbstractVector}}, a, b)
    for i in 1:length(cols)
        ordi = col_ordering(ord, i)
        @inbounds coli = cols[i]
        @inbounds va = coli[a]
        @inbounds vb = coli[b]
        lt(ordi, va, vb) && return true
        lt(ordi, vb, va) && return false
    end
    false # a and b are equal
end

###
# Get an Ordering for a DataFrame
###

################
## Case 1: no columns requested, so sort by all columns using requested order
################
## Case 1a: single order
######
ordering(df::AbstractDataFrame, lt::Function, by::Function, rev::Bool, order::Ordering) =
    DFPerm(Order.ord(lt, by, rev, order), df)

######
## Case 1b: lt, by, rev, and order are Arrays
######
function ordering(df::AbstractDataFrame,
                  lt::AbstractVector{S}, by::AbstractVector{T},
                  rev::AbstractVector{Bool},
                  order::AbstractVector) where {S<:Function, T<:Function}
    if !(length(lt) == length(by) == length(rev) == length(order) == size(df, 2))
        throw(ArgumentError("Orderings must be specified for all DataFrame columns"))
    end
    DFPerm([Order.ord(_lt, _by, _rev, _order) for
            (_lt, _by, _rev, _order) in zip(lt, by, rev, order)], df)
end

################
## Case 2:  Return a regular permutation when there's only one column
################
## Case 2a: The column is given directly
######
ordering(df::AbstractDataFrame, col::ColumnIndex, lt::Function, by::Function,
         rev::Bool, order::Ordering) =
    Perm(Order.ord(lt, by, rev, order), df[!, col])

######
## Case 2b: The column is given as a UserColOrdering
######
ordering(df::AbstractDataFrame, col_ord::UserColOrdering, lt::Function, by::Function,
         rev::Bool, order::Ordering) =
    Perm(ordering(col_ord, lt, by, rev, order), df[!, col_ord.col])

################
## Case 3:  General case: cols is an iterable of a combination of ColumnIndexes and UserColOrderings
################
## Case 3a: None of lt, by, rev, or order is an Array
######
function ordering(df::AbstractDataFrame, cols::AbstractVector, lt::Function,
                  by::Function, rev::Bool, order::Ordering)

    if length(cols) == 0
        if ncol(df) > 0
            Base.depwarn("When empty column selector is passed ordering is done on all columns. " *
                        "This behavior is deprecated and will change in the future.", :ordering)
        end
        return ordering(df, lt, by, rev, order)
    end

    if length(cols) == 1
        return ordering(df, cols[1], lt, by, rev, order)
    end

    # Collect per-column ordering info

    ords = Ordering[]
    newcols = Int[]

    for col in cols
        push!(ords, ordering(col, lt, by, rev, order))
        push!(newcols, index(df)[(_getcol(col))])
    end

    # Simplify ordering when all orderings are the same
    if all([ords[i] == ords[1] for i = 2:length(ords)])
        return DFPerm(ords[1], df[!, newcols])
    end

    return DFPerm(ords, df[!, newcols])
end

######
# Case 3b: cols, lt, by, rev, and order are all arrays
######
function ordering(df::AbstractDataFrame, cols::AbstractVector, lt::AbstractVector{S},
                  by::AbstractVector{T}, rev::AbstractVector{Bool},
                  order::AbstractVector) where {S<:Function, T<:Function}

    if !(length(lt) == length(by) == length(rev) == length(order))
        throw(ArgumentError("All ordering arguments must be 1 or the same length."))
    end

    if length(cols) == 0
        return ordering(df, lt, by, rev, order)
    end

    if length(lt) != length(cols)
        throw(ArgumentError("All ordering arguments must be 1 or the same length " *
                            "as the number of columns requested."))
    end

    if length(cols) == 1
        return ordering(df, only(cols), only(lt), only(by), only(rev), only(order))
    end

    # Collect per-column ordering info

    ords = Ordering[]
    newcols = Int[]

    for i in 1:length(cols)
        push!(ords, ordering(cols[i], lt[i], by[i], rev[i], order[i]))
        push!(newcols, index(df)[(_getcol(cols[i]))])
    end

    # Simplify ordering when all orderings are the same
    if all([ords[i] == ords[1] for i = 2:length(ords)])
        return DFPerm(ords[1], df[!, newcols])
    end

    return DFPerm(ords, df[!, newcols])
end

######
## At least one of lt, by, rev, or order is an array or tuple, so expand all to arrays
######
function ordering(df::AbstractDataFrame, cols::AbstractVector, lt, by, rev, order)
    to_array(src::AbstractVector, dims) = src
    to_array(src::Tuple, dims) = [src...]
    to_array(src, dims) = fill(src, dims)

    dims = length(cols) > 0 ? length(cols) : size(df, 2)
    ordering(df, cols,
             to_array(lt, dims),
             to_array(by, dims),
             to_array(rev, dims),
             to_array(order, dims))
end

# an explicit error is thrown as Tuple was supported in the past
ordering(df::AbstractDataFrame, cols::Tuple, args...) =
    throw(ArgumentError("Passing a tuple $cols of column selectors when sorting data " *
                        "frame is not supported. Pass a vector $([cols...]) instead."))

###########################
# Default sorting algorithm
###########################

# TimSort is fast for data with structure, but only if the DataFrame is large enough
# TODO: 8192 is informed but somewhat arbitrary

Sort.defalg(df::AbstractDataFrame) =
    size(df, 1) < 8192 ? Sort.MergeSort : SortingAlgorithms.TimSort

# For DataFrames, we can choose the algorithm based on the column type and requested ordering
function Sort.defalg(df::AbstractDataFrame, ::Type{T}, o::Ordering) where T<:Real
    # If we're sorting a single numerical column in forward or reverse,
    # RadixSort will generally be the fastest stable sort
    if isbitstype(T) && sizeof(T) <= 8 && (o==Order.Forward || o==Order.Reverse)
        SortingAlgorithms.RadixSort
    else
        Sort.defalg(df)
    end
end

Sort.defalg(df::AbstractDataFrame, ::Type, o::Ordering) = Sort.defalg(df)
Sort.defalg(df::AbstractDataFrame, col::ColumnIndex, o::Ordering) =
    Sort.defalg(df, eltype(df[!, col]), o)
Sort.defalg(df::AbstractDataFrame, col_ord::UserColOrdering, o::Ordering) =
    Sort.defalg(df, col_ord.col, o)
Sort.defalg(df::AbstractDataFrame, cols, o::Ordering) = Sort.defalg(df)
Sort.defalg(df::AbstractDataFrame, o::Ordering; alg=nothing, cols=[]) =
    alg !== nothing ? alg : Sort.defalg(df, cols, o)

########################
## Actual sort functions
########################

const SORT_ARGUMENTS =
"""
If `rev` is `true`, reverse sorting is performed. To enable reverse sorting only
for some columns, pass `order(c, rev=true)` in `cols`, with `c` the
corresponding column index (see example below).

Since having repeated elements makes multiple sorting orders valid, the
`checkunique` keyword allows for the situation to be caught. If `checkunique` is
`true` and duplicate elements are found an error will be thrown. The use of the
`checkunique` keyword is only supported when neither the `by` nor the `lt`
keywords are being used. Similarly, the use of `order(...)` clauses that specify
either `by` or `lt` are not supported, but specifying `rev` by itself is
allowed.

The `by` keyword allows providing a function that will be applied to each
cell before comparison; the `lt` keyword allows providing a custom "less
than" function. If both `by` and `lt` are specified, the `lt` function is
applied to the result of the `by` function.

Keyword arguments specifying sorting order (`rev`, `lt` or `by`) can either be
a single value, or a vector of length equal to the number of columns the
operation is performed on. When a single value is passed, it applies to all
columns. When a vector is passed, each entry applies to the column in the
corresponding position in `cols`.
"""

"""
    issorted(df::AbstractDataFrame, cols=All();
             lt::Union{Function, AbstractVector{<:Function}}=isless,
             by::Union{Function, AbstractVector{<:Function}}=identity,
             rev::Union{Bool, AbstractVector{Bool}}=false,
             order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
             checkunique::Bool=false)

Test whether data frame `df` sorted by column(s) `cols`. Checking against
multiple columns is done lexicographically.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR). If
`cols` selects no columns, check whether `df` is sorted on all columns (this
behaviour is deprecated and will change in future versions).

$SORT_ARGUMENTS

# Examples
```jldoctest
julia> df = DataFrame(a=[1, 2, 3, 4], b=[4, 3, 2, 1])
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      3
   3 │     3      2
   4 │     4      1

julia> issorted(df)
true

julia> issorted(df, :a)
true

julia> issorted(df, :b)
false

julia> issorted(df, :b, rev=true)
true
```
"""
function Base.issorted(df::AbstractDataFrame, cols=All();
                       lt::Union{Function, AbstractVector{<:Function}}=isless,
                       by::Union{Function, AbstractVector{<:Function}}=identity,
                       rev::Union{Bool, AbstractVector{Bool}}=false,
                       order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
                       checkunique::Bool=false)
    to_scalar(x::AbstractVector) = only(x)
    to_scalar(x::Any) = x

    # exclude AbstractVector as in that case cols can contain order(...) clauses
    if cols isa MultiColumnIndex && !(cols isa AbstractVector)
        cols = index(df)[cols]
    end
    checkunique && _perform_uniqueness_checks(df, cols, lt, by, order)
    if cols isa ColumnIndex
        return issorted(df[!, cols], lt=to_scalar(lt), by=to_scalar(by),
                        rev=to_scalar(rev), order=to_scalar(order))
    elseif cols isa AbstractVector{<:ColumnIndex} && length(cols) == 1
        return issorted(df[!, cols[1]], lt=to_scalar(lt), by=to_scalar(by),
                        rev=to_scalar(rev), order=to_scalar(order))
    else
        return issorted(1:nrow(df), ordering(df, cols, lt, by, rev, order))
    end
end

Base.issorted(::AbstractDataFrame, ::Base.Order.Ordering) =
    throw(ArgumentError("second positional argument of `issorted` on " *
                        "a data frame must be a column selector"))

"""
    sort(df::AbstractDataFrame, cols=All();
         alg::Union{Algorithm, Nothing}=nothing,
         lt::Union{Function, AbstractVector{<:Function}}=isless,
         by::Union{Function, AbstractVector{<:Function}}=identity,
         rev::Union{Bool, AbstractVector{Bool}}=false,
         order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
         view::Bool=false,
         checkunique::Bool=false)

Return a data frame containing the rows in `df` sorted by column(s) `cols`.
Sorting on multiple columns is done lexicographically.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).
If `cols` selects no columns, sort `df` on all columns
(this behaviour is deprecated and will change in future versions).

$SORT_ARGUMENTS

If `alg` is `nothing` (the default), the most appropriate algorithm is
chosen automatically among `TimSort`, `MergeSort` and `RadixSort` depending
on the type of the sorting columns and on the number of rows in `df`.

If `view=false` a freshly allocated `DataFrame` is returned.
If `view=true` then a `SubDataFrame` view into `df` is returned.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     2  a
   4 │     1  b

julia> sort(df, :x)
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  c
   2 │     1  b
   3 │     2  a
   4 │     3  b

julia> sort(df, [:x, :y])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  b
   2 │     1  c
   3 │     2  a
   4 │     3  b

julia> sort(df, [:x, :y], rev=true)
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a
   3 │     1  c
   4 │     1  b

julia> sort(df, [:x, order(:y, rev=true)])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  c
   2 │     1  b
   3 │     2  a
   4 │     3  b
```
"""
@inline function Base.sort(df::AbstractDataFrame, cols=All();
                           alg::Union{Algorithm, Nothing}=nothing,
                           lt::Union{Function, AbstractVector{<:Function}}=isless,
                           by::Union{Function, AbstractVector{<:Function}}=identity,
                           rev::Union{Bool, AbstractVector{Bool}}=false,
                           order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
                           view::Bool=false,
                           checkunique::Bool=false)
    rowidxs = sortperm(df, cols, alg=alg, lt=lt, by=by, rev=rev, order=order,
                       checkunique=checkunique)
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

"""
    sortperm(df::AbstractDataFrame, cols=All();
             alg::Union{Algorithm, Nothing}=nothing,
             lt::Union{Function, AbstractVector{<:Function}}=isless,
             by::Union{Function, AbstractVector{<:Function}}=identity,
             rev::Union{Bool, AbstractVector{Bool}}=false,
             order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
             checkunique::Bool=false)

Return a permutation vector of row indices of data frame `df` that puts them in
sorted order according to column(s) `cols`.
Order on multiple columns is computed lexicographically.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).
If `cols` selects no columns, return permutation vector based on sorting all columns
(this behaviour is deprecated and will change in future versions).

$SORT_ARGUMENTS

If `alg` is `nothing` (the default), the most appropriate algorithm is
chosen automatically among `TimSort`, `MergeSort` and `RadixSort` depending
on the type of the sorting columns and on the number of rows in `df`.

# Examples
```jldoctest
julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     2  a
   4 │     1  b

julia> sortperm(df, :x)
4-element Vector{Int64}:
 2
 4
 3
 1

julia> sortperm(df, [:x, :y])
4-element Vector{Int64}:
 4
 2
 3
 1

julia> sortperm(df, [:x, :y], rev=true)
4-element Vector{Int64}:
 1
 3
 2
 4

julia> sortperm(df, [:x, order(:y, rev=true)])
4-element Vector{Int64}:
 2
 4
 3
 1
```
"""
function Base.sortperm(df::AbstractDataFrame, cols=All();
                       alg::Union{Algorithm, Nothing}=nothing,
                       lt::Union{Function, AbstractVector{<:Function}}=isless,
                       by::Union{Function, AbstractVector{<:Function}}=identity,
                       rev::Union{Bool, AbstractVector{Bool}}=false,
                       order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
                       checkunique::Bool=false)
    # exclude AbstractVector as in that case cols can contain order(...) clauses
    if cols isa MultiColumnIndex && !(cols isa AbstractVector)
        cols = index(df)[cols]
    end
    ord = ordering(df, cols, lt, by, rev, order)
    _alg = Sort.defalg(df, ord; alg=alg, cols=cols)
    checkunique && _perform_uniqueness_checks(df, cols, lt, by, order)
    return _sortperm(df, _alg, ord)
end

_sortperm(df::AbstractDataFrame, a::Algorithm, o::Union{Perm, DFPerm}) =
    sort!([1:size(df, 1);], a, o)
_sortperm(df::AbstractDataFrame, a::Algorithm, o::Ordering) =
    sortperm(df, a, DFPerm(o, df))


"""
    sort!(df::AbstractDataFrame, cols=All();
          alg::Union{Algorithm, Nothing}=nothing,
          lt::Union{Function, AbstractVector{<:Function}}=isless,
          by::Union{Function, AbstractVector{<:Function}}=identity,
          rev::Union{Bool, AbstractVector{Bool}}=false,
          order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
          checkunique::Bool=false)

Sort data frame `df` by column(s) `cols` by permuting its rows in-place.
Sorting on multiple columns is done lexicographicallly.

`cols` can be any column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR). If
`cols` selects no columns, sort `df` on all columns (this behaviour is
deprecated and will change in future versions).

$SORT_ARGUMENTS

If `alg` is `nothing` (the default), the most appropriate algorithm is chosen
automatically among `TimSort`, `MergeSort` and `RadixSort` depending on the type
of the sorting columns and on the number of rows in `df`.

`sort!` will produce a correct result even if some columns of passed data frame
are identical (checked with `===`). Otherwise, if two columns share some part of
memory but are not identical (e.g. are different views of the same parent
vector) then `sort!` result might be incorrect.

$METADATA_FIXED
Metadata having other styles is dropped (from parent data frame when `df` is a `SubDataFrame`).

# Examples
```jldoctest
julia> df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     1  c
   3 │     2  a
   4 │     1  b

julia> sort!(df, :x)
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  c
   2 │     1  b
   3 │     2  a
   4 │     3  b

julia> sort!(df, [:x, :y])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  b
   2 │     1  c
   3 │     2  a
   4 │     3  b

julia> sort!(df, [:x, :y], rev=true)
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     3  b
   2 │     2  a
   3 │     1  c
   4 │     1  b

julia> sort!(df, [:x, order(:y, rev=true)])
4×2 DataFrame
 Row │ x      y
     │ Int64  String
─────┼───────────────
   1 │     1  c
   2 │     1  b
   3 │     2  a
   4 │     3  b
```
"""
function Base.sort!(df::AbstractDataFrame, cols=All();
                    alg::Union{Algorithm, Nothing}=nothing,
                    lt::Union{Function, AbstractVector{<:Function}}=isless,
                    by::Union{Function, AbstractVector{<:Function}}=identity,
                    rev::Union{Bool, AbstractVector{Bool}}=false,
                    order::Union{Ordering, AbstractVector{<:Ordering}}=Forward,
                    checkunique::Bool=false)

    # exclude AbstractVector as in that case cols can contain order(...) clauses
    if cols isa MultiColumnIndex && !(cols isa AbstractVector)
        cols = index(df)[cols]
    end
    ord = ordering(df, cols, lt, by, rev, order)
    _alg = Sort.defalg(df, ord; alg=alg, cols=cols)
    checkunique && _perform_uniqueness_checks(df, cols, lt, by, order)
    return sort!(df, _alg, ord)
end

# this sort! method does not support uniqueness checks since they can't be carried out
# without knowledge of which columns are to be sorted.
function Base.sort!(df::AbstractDataFrame, a::Base.Sort.Algorithm,
                    o::Base.Sort.Ordering)
    permute!(df, _sortperm(df, a, o))
end

# Functions to verify whether an Ordering has user-defined `by` or `lt` functions
# The complexity checks exploit `Base.Order`'s way of constructing `Order` objects.
# `DirectOrdering` is by definition an order that uses `isless` and `identity` as its
# `lt` and `by` functions, so they are not complex. The `By` and `Lt` types have
# attributes storing the defined `by` and `lt` functions respectively, simple identity
# checks are enough. `ReverseOrdering`s wrap another type of ordering, so we
# perform the check on the wrapped type.
is_complex(o::Union{DirectOrdering, FasterForward, FasterReverse}) = false
is_complex(o::By) = o.by !== identity
is_complex(o::Lt) = o.lt !== isless
is_complex(o::ReverseOrdering) = is_complex(o.fwd)
is_complex(o::Perm) = is_complex(o.order)

function is_complex(o::DFPerm)
    if o.ord isa Ordering
        return is_complex(o.ord)
    elseif o.ord isa Tuple
        return any(is_complex(ordering) for ordering in o.ord)
    end
    throw(ArgumentError("unsupported ord type"))
end

function is_complex(o::Ordering)
    throw(ArgumentError("The use of the keyword `checkunique` is currently " *
                        "not supported with Ordering type $(typeof(o))"))
end

function is_complex(o::UserColOrdering)
    has_lt = haskey(o.kwargs, :lt)
    has_by = haskey(o.kwargs, :by)
    if !has_lt && !has_by
        return false
    elseif has_lt && !has_by
        return o.kwargs[:lt] !== isless
    elseif has_by && !has_lt
        return o.kwargs[:by] !== identity
    else
        @assert has_lt && has_by
        return o.kwargs[:by] !== identity || o.kwargs[:lt] !== isless
    end
end

# Internal function that aids in uniqueness checks
# Converts column selectors to indices and checks necessary conditions for uniqueness
function _perform_uniqueness_checks(df::AbstractDataFrame, cols,
                                    lt::Union{Function, AbstractVector{<:Function}},
                                    by::Union{Function, AbstractVector{<:Function}},
                                    order::Union{Ordering, AbstractVector{<:Ordering}})

    if !(lt === isless && by === identity)
        throw(ArgumentError("Passing either lt or by along with checkunique=" *
                            "true is not supported."))
    end

    # Validating the order argument
    if order isa Ordering
        order = [order]
    end
    for o in order
        if is_complex(o)
            throw(ArgumentError("Using either lt or by functions through the " *
                                "order keyword argument simultaneously with " *
                                "checkunique=true is not supported."))
        end
    end

    # Easiest case, cols contains column indexes already
    if cols isa AbstractVector{<:ColumnIndex}
        by_or_lt_set = false
        col_idxs = cols
    # Second easiest, multicol index (no vector with orders clauses mixed in)
    elseif (cols isa MultiColumnIndex && !(cols isa AbstractVector)) || cols isa ColumnIndex
        by_or_lt_set = false
        col_idxs = index(df)[cols]
    elseif cols isa UserColOrdering
        by_or_lt_set = is_complex(cols)
        col_idxs = [index(df)[_getcol(cols)]]
    # Mix of ColOrdering and other ColumnSelectors
    else
        @assert cols isa AbstractVector
        newcols = Int[]
        by_or_lt_set = false
        for col in cols
            if col isa UserColOrdering
                by_or_lt_set = is_complex(col) || by_or_lt_set
            end

            push!(newcols, index(df)[_getcol(col)])
        end
        col_idxs = newcols
    end
    if by_or_lt_set
        throw(ArgumentError("Order clauses with either by or lt set in combination " *
                            "with checkunique=true are not supported"))
    end
    allunique(df, col_idxs) ||
        throw(ArgumentError("Non-unique elements found. Multiple orders are valid."))
end

@testset "begin and end tests" begin
    df = DataFrame([(i, j) for i in 1:3, j in 1:4], :auto)
    @test df[begin, begin] == df[1, 1]
    @test df[begin, end] == df[1, 4]
    @test df[end, begin] == df[3, 1]
    @test df[end, end] == df[3, 4]

    @test df[Not(begin), Not(begin)] == df[Not(1), Not(1)]
    @test df[Not(begin), Not(end)] == df[Not(1), Not(4)]
    @test df[Not(end), Not(begin)] == df[Not(3), Not(1)]
    @test df[Not(end), Not(end)] == df[Not(3), Not(4)]

    df[begin, begin] = (101, 101)
    @test df[begin, begin] == (101, 101)
    df[begin, end] = (101, 104)
    @test df[begin, end] == (101, 104)
    df[end, begin] = (103, 101)
    @test df[end, begin] == (103, 101)
    df[end, end] = (103, 104)
    @test df[end, end] == (103, 104)

    df[!, begin] .= [1, 2, 3]
    @test df[:, 1] == [1, 2, 3]
    df[!, end] .= [11, 12, 13]
    @test df[:, 4] == [11, 12, 13]

    @test df[begin:end, [begin, end]] == df[:, [1, 4]]
    df[begin:end, [begin, end]] .= [111, 222, 333]
    @test df.x1 == df.x4 == [111, 222, 333]
    @test df[[begin, end], [begin, end]] == df[[1, 3], [1, 4]]
    df[[begin, end], [begin, end]] .= 1000
    @test df.x1 == df.x4 == [1000, 222, 1000]

    @test eachcol(df)[begin] == df[!, begin]
    @test eachcol(df)[end] == df[!, end]
end

module TestSubset

using Test, DataFrames, Statistics, Random

const ≅ = isequal

function validate_gdf_subset(ogd::GroupedDataFrame)
    # To return original object to test when indices have not been computed
    gd = deepcopy(ogd)

    @assert allunique(gd.cols)
    @assert issubset(gd.cols, propertynames(parent(gd)))

    g = sort!(unique(gd.groups))
    if length(gd) > 0
        @assert g[1] == 1 # group dropping in subset is not allowed
        @assert g == g[1]:g[end]
        @assert gd.ngroups == g[end]
        @assert length(gd.starts) == length(gd.ends) == g[end]
    else
        @assert gd.ngroups == 0
        @assert length(gd.starts) == length(gd.ends) == 0
    end
    @assert isperm(gd.idx)
    @assert length(gd.idx) == length(gd.groups) == nrow(parent(gd))

    # checking that groups field is consistent with other fields
    # (since == and isequal do not use it)
    # and that idx is increasing per group
    new_groups = zeros(Int, length(gd.groups))
    for idx in eachindex(gd.starts)
        subidx = gd.idx[gd.starts[idx]:gd.ends[idx]]
        @assert issorted(subidx)
        new_groups[subidx] .= idx
    end
    @assert new_groups == gd.groups

    if length(gd) > 0
        se = sort!(collect(zip(gd.starts, gd.ends)))

        # correct start-end range
        @assert se[1][1] > 0
        @assert se[end][2] == length(gd.idx)

        # correct start-end relations
        for i in eachindex(se)
            @assert se[i][1] <= se[i][2]
            if i > 1
                # the blocks returned by groupby must be continuous
                @assert se[i-1][2] + 1 == se[i][1]
            end
        end

        # all grouping keys must be equal within a group
        for (s, e) in zip(gd.starts, gd.ends)
            firstkeys = gd.parent[gd.idx[s], gd.cols]
            @assert all(j -> gd.parent[gd.idx[j], gd.cols] ≅ firstkeys, s:e)
        end
        # all groups have different grouping keys
        @test allunique(eachrow(gd.parent[gd.idx[gd.starts], gd.cols]))
    end
    return ogd
end


@testset "subset and subset!" begin
    refdf = DataFrame(x=repeat(Any[true, false], 4),
                      y=repeat([true, false, missing, missing], 2),
                      z=repeat([1, 2, 3, 3], 2),
                      id=1:8)

    for df in (copy(refdf), @view copy(refdf)[1:end-1, :])
        df2 = copy(df)
        @test subset(df, :x) ≅ filter(:x => identity, df)
        @test df ≅ df2
        @test subset(df, :x) isa DataFrame
        @test subset(df, :x, view=true) ≅ filter(:x => identity, df)
        @test subset(df, :x, view=true) isa SubDataFrame
        @test_throws ArgumentError subset(df, :y)
        @test_throws ArgumentError subset(df, :y, :x)
        @test subset(df, :y, skipmissing=true) ≅ filter(:y => x -> x === true, df)
        @test subset(df, :y, skipmissing=true, view=true) ≅ filter(:y => x -> x === true, df)
        @test subset(df, :y, :y, skipmissing=true) ≅ filter(:y => x -> x === true, df)
        @test subset(df, :y, :y, skipmissing=true, view=true) ≅ filter(:y => x -> x === true, df)
        @test subset(df, :x, :y, skipmissing=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(df, :y, :x, skipmissing=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(df, :x, :y, skipmissing=true, view=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(df, :x, :y, :id => ByRow(<(4)), skipmissing=true) ≅
              filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, df)
        @test subset(df, :x, :y, :id => ByRow(<(4)), skipmissing=true, view=true) ≅
              filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, df)
        @test subset(df, :x, :id => ByRow(<(4))) ≅
              filter([:x, :id] => (x, id) -> x && id < 4, df)
        @test subset(df, :x, :id => ByRow(<(4)), view=true) ≅
              filter([:x, :id] => (x, id) -> x && id < 4, df)
        @test subset(df) ≅ df
        @test isempty(subset(df, :x, :x => ByRow(!)))
        @test_throws ArgumentError subset(df, :x => x -> false, :x => x -> missing)
        @test_throws ArgumentError subset(df, :x => x -> true, :x => x -> missing)
        @test_throws ArgumentError subset(df, :x => x -> true, :x => x -> 2)
    end

    for df in (copy(refdf), @view copy(refdf)[1:end-1, :]), ord in (true, false)
        if ord
            gdf = groupby(df, :z)
        else
            gdf = groupby(df, :z)[[3, 2, 1]]
        end
        df2 = copy(df)
        @test subset(gdf, :x) ≅ filter(:x => identity, df)
        @test df ≅ df2
        @test subset(gdf, :x) isa DataFrame
        out_gdf = subset(gdf, :x, ungroup=false)
        validate_gdf_subset(out_gdf)
        cmp_gdf = groupby(filter(:x => identity, df), :z)
        if !ord
            cmp_gdf = cmp_gdf[length(cmp_gdf):-1:1]
        end
        @test out_gdf ≅ cmp_gdf
        @test subset(gdf, :x, ungroup=false) isa GroupedDataFrame{DataFrame}
        @test subset(gdf, :x, view=true) ≅ filter(:x => identity, df)
        @test subset(gdf, :x, view=true) isa SubDataFrame
        out_gdf = subset(gdf, :x, view=true, ungroup=false)
        validate_gdf_subset(out_gdf)
        cmp_gdf = groupby(filter(:x => identity, df), :z)
        if !ord
            cmp_gdf = cmp_gdf[length(cmp_gdf):-1:1]
        end
        @test out_gdf ≅ cmp_gdf
        @test subset(gdf, :x, view=true, ungroup=false) isa GroupedDataFrame{<:SubDataFrame}
        @test_throws ArgumentError subset(gdf, :y)
        @test_throws ArgumentError subset(gdf, :y, :x)
        @test subset(gdf, :y, skipmissing=true) ≅ filter(:y => x -> x === true, df)
        @test subset(gdf, :y, skipmissing=true, view=true) ≅ filter(:y => x -> x === true, df)
        @test subset(gdf, :y, :y, skipmissing=true) ≅ filter(:y => x -> x === true, df)
        @test subset(gdf, :y, :y, skipmissing=true, view=true) ≅ filter(:y => x -> x === true, df)
        @test subset(gdf, :x, :y, skipmissing=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(gdf, :y, :x, skipmissing=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(gdf, :x, :y, skipmissing=true, view=true) ≅
              filter([:x, :y] => (x, y) -> x && y === true, df)
        @test subset(gdf, :x, :y, :id => ByRow(<(4)), skipmissing=true) ≅
              filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, df)
        @test subset(gdf, :x, :y, :id => ByRow(<(4)), skipmissing=true, view=true) ≅
              filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, df)
        @test subset(gdf, :x, :id => ByRow(<(4))) ≅
              filter([:x, :id] => (x, id) -> x && id < 4, df)
        @test subset(gdf, :x, :id => ByRow(<(4)), view=true) ≅
              filter([:x, :id] => (x, id) -> x && id < 4, df)
        @test subset(gdf) ≅ df
        @test isempty(subset(gdf, :x, :x => ByRow(!)))
        @test_throws ArgumentError subset(gdf, :x => x -> false, :x => x -> missing)
        @test_throws ArgumentError subset(gdf, :x => x -> true, :x => x -> missing)
        @test_throws ArgumentError subset(gdf, :x => x -> true, :x => x -> 2)
    end

    df = copy(refdf)
    @test subset!(df, :x) === df
    @test subset!(df, :x) ≅ df ≅ filter(:x => identity, refdf)
    df = copy(refdf)
    @test_throws ArgumentError subset!(df, :y)
    @test df ≅ refdf
    df = copy(refdf)
    @test subset!(df, :y, skipmissing=true) === df
    @test subset!(df, :y, skipmissing=true) ≅ df ≅ filter(:y => x -> x === true, refdf)
    df = copy(refdf)
    @test subset!(df, :x, :y, skipmissing=true) === df
    @test subset!(df, :x, :y, skipmissing=true) ≅ df ≅
          filter([:x, :y] => (x, y) -> x && y === true, refdf)
    df = copy(refdf)
    @test subset!(df, :x, :y, :id => ByRow(<(4)), skipmissing=true) ≅ df ≅
          filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, refdf)
    df = copy(refdf)
    @test subset!(df, :x, :id => ByRow(<(4))) ≅ df ≅
          filter([:x, :id] => (x, id) -> x && id < 4, refdf)
    df = copy(refdf)
    @test subset!(df) === df
    df = copy(refdf)
    @test isempty(subset!(df, :x, :x => ByRow(!)))
    @test isempty(df)

    df = copy(refdf)
    @test_throws ArgumentError subset!(df, :x => x -> false, :x => x -> missing)
    @test_throws ArgumentError subset!(df, :x => x -> true, :x => x -> missing)
    @test_throws ArgumentError subset!(df, :x => x -> true, :x => x -> 2)

    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x) === df

    df = copy(refdf)
    gdf = groupby(df, :z)
    gdf2 = subset!(gdf, :x, ungroup=false)
    validate_gdf_subset(gdf2)
    @test gdf2 isa GroupedDataFrame{DataFrame}
    @test parent(gdf2) === df
    @test gdf2 ≅ groupby(df, :z) ≅ groupby(filter(:x => identity, refdf), :z)

    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x) ≅ df ≅ filter(:x => identity, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test_throws ArgumentError subset!(gdf, :y)
    @test df ≅ refdf
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :y, skipmissing=true) === df
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :y, skipmissing=true) ≅ df ≅ filter(:y => x -> x === true, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x, :y, skipmissing=true) === df
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x, :y, skipmissing=true) ≅ df ≅
          filter([:x, :y] => (x, y) -> x && y === true, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x, :y, :id => ByRow(<(4)), skipmissing=true) ≅ df ≅
          filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf, :x, :id => ByRow(<(4))) ≅ df ≅
          filter([:x, :id] => (x, id) -> x && id < 4, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test subset!(gdf) === df
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test isempty(subset!(gdf, :x, :x => ByRow(!)))
    @test isempty(df)
    df = copy(refdf)
    gdf = groupby(df, :z)
    @test_throws ArgumentError subset!(gdf, :x => x -> false, :x => x -> missing)
    @test_throws ArgumentError subset!(gdf, :x => x -> true, :x => x -> missing)
    @test_throws ArgumentError subset!(gdf, :x => x -> true, :x => x -> 2)

    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf, :x) ≅ df ≅ filter(:x => identity, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test_throws ArgumentError subset!(gdf, :y)
    @test df ≅ refdf
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf, :y, skipmissing=true) ≅ df ≅ filter(:y => x -> x === true, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf, :x, :y, skipmissing=true) ≅ df ≅
          filter([:x, :y] => (x, y) -> x && y === true, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf, :x, :y, :id => ByRow(<(4)), skipmissing=true) ≅ df ≅
          filter([:x, :y, :id] => (x, y, id) -> x && y === true && id < 4, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf, :x, :id => ByRow(<(4))) ≅ df ≅
          filter([:x, :id] => (x, id) -> x && id < 4, refdf)
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test subset!(gdf) === df
    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test isempty(subset!(gdf, :x, :x => ByRow(!)))
    @test isempty(df)

    df = copy(refdf)
    gdf = groupby(df, :z)[[3, 2, 1]]
    @test_throws ArgumentError subset!(gdf, :x => x -> false, :x => x -> missing)
    @test_throws ArgumentError subset!(gdf, :x => x -> true, :x => x -> missing)
    @test_throws ArgumentError subset!(gdf, :x => x -> true, :x => x -> 2)

    @test_throws ArgumentError subset!(view(refdf, :, :), :x)
    @test_throws ArgumentError subset!(groupby(view(refdf, :, :), :z), :x)

    df = DataFrame(g=[2, 2, 1, 1, 1, 1, 3, 3, 3], x=1:9)
    @test subset(df, :x => x -> x .< mean(x)) == DataFrame(g=[2, 2, 1, 1], x=1:4)
    @test subset(groupby(df, :g), :x => x -> x .< mean(x)) ==
          DataFrame(g=[2, 1, 1, 3], x=[1, 3, 4, 7])

    @test_throws ArgumentError subset(df, :x => x -> missing)
    @test isempty(subset(df, :x => ByRow(x -> missing), skipmissing=true))
    @test_throws ArgumentError isempty(subset(df, :x => x -> missing, skipmissing=true))
    @test isempty(subset(df, :x => ByRow(x -> false)))
    @test_throws ArgumentError isempty(subset(df, :x => x -> false))
    @test subset(df, :x => ByRow(x -> true)) ≅ df
    @test_throws ArgumentError subset(df, :x => x -> true) ≅ df
    @test_throws ArgumentError subset(df, :x => x -> (a=x,))
    @test_throws ArgumentError subset(df, :x => (x -> (a=x,)) => AsTable)

    @test_throws ArgumentError subset(DataFrame(x=false, y=missing), :x, :y)
    @test_throws ArgumentError subset(DataFrame(x=missing, y=false), :x, :y)
    @test_throws ArgumentError subset(DataFrame(x=missing, y=false), :x)
    @test_throws ArgumentError subset(DataFrame(x=false, y=missing), :y)
    @test_throws ArgumentError subset(DataFrame(x=false, y=1), :x, :y)
    @test_throws ArgumentError subset(DataFrame(x=1, y=false), :x, :y)
    @test_throws ArgumentError subset(DataFrame(x=1, y=false), :y, :x)
    @test_throws ArgumentError subset(DataFrame(x=false, y=1), :y)

    @test_throws ArgumentError subset(DataFrame(x=false, y=1), :x, :y, skipmissing=true)
    @test_throws ArgumentError subset(DataFrame(x=1, y=false), :x, :y, skipmissing=true)
    @test_throws ArgumentError subset(DataFrame(x=1, y=false), :y, :x, skipmissing=true)
    @test_throws ArgumentError subset(DataFrame(x=false, y=1), :y, skipmissing=true)

    @test_throws ArgumentError DataFrames._and()
    @test_throws ArgumentError DataFrames._and_missing()
end

@testset "subsetting requires passing vector for data frame input" begin
    @test_throws ArgumentError subset(DataFrame(x=[]), :x => x -> 1)
    @test_throws ArgumentError subset(DataFrame(x=[]), :x => ByRow(x -> 1))
    @test_throws ArgumentError subset(DataFrame(x=1:3), [] => () -> true)
    @test subset(DataFrame(x=1:3), [] => ByRow(() -> true)) == DataFrame(x=1:3)
    @test_throws ArgumentError subset(DataFrame(x=[0, 1]), :x => ==(0))
    @test_throws ArgumentError subset(DataFrame(x=[0, missing]), :x => ismissing)
    @test subset(groupby(DataFrame(id=[0, 0, 1, 1],
                                   x=[-1, 1, 3, 4]), :id),
                 :x => (x -> sum(x) > 0)) == DataFrame(id=[1, 1], x=[3, 4])
    @test_throws ArgumentError subset(DataFrame(x=1:3), :x => x -> fill(missing, length(x)))
    @test isempty(subset(DataFrame(x=1:3), :x => x -> fill(missing, length(x)),
                         skipmissing=true))
    @test subset(DataFrame(x=1:3), :x => x -> fill(true, length(x))) == DataFrame(x=1:3)
    @test subset(DataFrame(x=1:3), :x => x -> trues(length(x))) == DataFrame(x=1:3)
    @test isempty(subset(DataFrame(x=1:3), :x => x -> fill(false, length(x))))
    @test isempty(subset(DataFrame(x=1:3), :x => x -> falses(length(x))))
    @test_throws ArgumentError subset(DataFrame(), [] => () -> Union{}[])
    @test_throws ArgumentError subset(DataFrame(), [] => () -> Union{}[], skipmissing=true)
    @test_throws ArgumentError subset(groupby(DataFrame(), []), [] => () -> Union{}[])
    @test_throws ArgumentError subset(groupby(DataFrame(), []), [] => () -> Union{}[], skipmissing=true)
    @test subset(DataFrame(x=1:3:15, y=1:5), [:x, :y] => (x, y) -> iseven.(x) .& iseven.(y)) ==
          DataFrame(x=[4, 10], y=[2, 4])
    @test subset(DataFrame(x=1:3:15, y=1:5),
                 AsTable([:x, :y]) => v -> iseven.(v.x) .& iseven.(v.y)) ==
          DataFrame(x=[4, 10], y=[2, 4])

    @test subset(DataFrame(x=1:3), :x => x -> Any[true, false, true]) ==
          DataFrame(x=[1, 3])
    @test subset(DataFrame(x=1:3), :x => x -> view(Any[true, false, true], :)) ==
          DataFrame(x=[1, 3])
    @test_throws ArgumentError subset(DataFrame(x=1:3), :x => x -> Any[true, false, missing])
    @test subset(DataFrame(x=1:3), :x => x -> Any[true, false, missing], skipmissing=true) ==
          DataFrame(x=[1])
    @test_throws ArgumentError subset(DataFrame(x=1:3), :x => x -> Any[true, false, 1])
    @test_throws ArgumentError subset(DataFrame(x=1:3), :x => x -> Any[true, false, 1],
                                      skipmissing=true)
    @test_throws ArgumentError subset(DataFrame(x=1:3), :x => x -> (true for i in 1:3))
    @test subset(groupby(DataFrame(x=1:5), :x), :x => x -> sum(x) > (2.5)) == DataFrame(x=3:5)
    out_gdf = subset(groupby(DataFrame(x=1:5), :x), :x => x -> sum(x) > (2.5), ungroup=false)
    @test out_gdf == groupby(DataFrame(x=3:5), :x)
    validate_gdf_subset(out_gdf)
end

@testset "multicolumn selectors" begin
    dfref = DataFrame(1:10 .!= permutedims(1:11), :auto)

    for df in (dfref, groupby(dfref, :x2), groupby(dfref, :x11))
        @test subset(df, Not(:x1) .=> identity) ==
            subset(df, Not(:x1) .=> [identity identity]) ==
            subset(df, (names(df, Not(:x1)) .=> identity)...)
        @test subset(df, Not(:x1)) == subset(df, names(df, Not(:x1))...)
        @test subset(df, :) == subset(df, names(df)) == subset(df, names(df)...)
        @test subset(df, Cols(:) .=> ByRow(x -> true)) == subset(df, (names(df, Cols(:)) .=> ByRow(x -> true))...)
        @test subset(df, [], [:x1]) == subset(df, :x1)
        @test subset(df, Matrix{Any}(undef, 0, 0), [:x1]) == subset(df, :x1)
        @test subset(df, [:x1, :x3, :x5]) == subset(df, [1, 3, 5]) == subset(df, :x1, :x3, :x5)
        @test subset(df, [false; fill(true, 10)]) == subset(df, (2:11)...)
        @test_throws ArgumentError subset(df, [:x1 => identity => :x1])
        @test_throws ArgumentError subset(df, Not(:x1) .=> identity .=> Not(:x1))
        @test_throws ArgumentError subset(df, Not(:x1) .=> [identity identity] .=> Not(:x1))
        @test_throws ArgumentError subset(df, [:y])
        @test_throws BoundsError subset(df, [-1])
        @test_throws BoundsError subset(df, [true])

        Random.seed!(12345)
        df = DataFrame(rand(100, 5), :auto)
        columns = names(df, Not(Between(:x3, ncol(df))))
        @test subset(df, vcat.(columns, "x5") .=> ByRow(<)) ==
              subset(df, [:x1, :x5] => ByRow(<), [:x2, :x5] => ByRow(<)) ==
              df[(df.x1 .< df.x5) .& (df.x2 .< df.x5), :]
    end
end

@testset "wide subsetting" begin
    # current threshold is at 16
    for i in 1:20
        df = DataFrame(a=1:10)
        @test subset(df, [:a => ByRow(x -> true) for _ in 1:i]) == df
        @test subset(df, [:a => ByRow(x -> true) for _ in 1:i], :a => ByRow(x -> false)) ==
              DataFrame(a=Int[])
        @test_throws ArgumentError subset(df, [:a => ByRow(x -> true) for _ in 1:i],
                                          :a => ByRow(x -> "a"))
        @test subset(df, [:a => ByRow(x -> true) for _ in 1:i], skipmissing=true) == df
        @test subset(df, [:a => ByRow(x -> true) for _ in 1:i],
                     :a => ByRow(x -> false), skipmissing=true) ==
              DataFrame(a=Int[])
        @test subset(df, [:a => ByRow(x -> true) for _ in 1:i],
                     :a => ByRow(x -> missing), skipmissing=true) ==
              DataFrame(a=Int[])
        @test subset(df, :a => ByRow(x -> missing), [:a => ByRow(x -> true) for _ in 1:i],
                     skipmissing=true) ==
              DataFrame(a=Int[])
        @test_throws ArgumentError subset(df, :a => ByRow(x -> missing),
                                          [:a => ByRow(x -> true) for _ in 1:i],
                                          :a => ByRow(x -> "a"), skipmissing=true)
        @test_throws ArgumentError subset(df, [:a => ByRow(x -> true) for _ in 1:i],
                                          :a => ByRow(x -> missing), :a => ByRow(x -> "a"),
                                          skipmissing=true)

        # randomized correctness tests across two selection options
        Random.seed!(1234)
        mat1 = rand(Bool, 10_000, 5)
        df = DataFrame(mat1, string.("y", 1:5))
        df.id = 1:nrow(df)
        df2 = [DataFrame(trues(10_000, i), :auto) df]
        @test subset(df, Not(:id)).id ==
              subset(df2, Not(:id)).id ==
              df.id[all.(eachrow(mat1))]

        mat2 = rand([true, false, missing], 10_000, 5)
        df = DataFrame(mat2, string.("y", 1:5))
        df.id = 1:nrow(df)
        df2 = [DataFrame(trues(10_000, i), :auto) df]
        @test subset(df, Not(:id), skipmissing=true).id ==
              subset(df2, Not(:id), skipmissing=true).id ==
              df.id[all.(isequal(true), eachrow(mat2))]
        # with so many rows we must see missing somewhere
        # so this condition is true in practice
        if any(ismissing, mat2)
            @test_throws ArgumentError subset(df, Not(:id))
            @test_throws ArgumentError subset(df2, Not(:id))
        end
    end
end

@testset "test grouping order after the operation" begin
    df = DataFrame(a=repeat(1:4, 2), b=1:8, c=repeat([true, false], inner=4))
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    @test subset(gdf, :c) == DataFrame(a=1:4, b=1:4, c=true)
    res = subset(gdf, :c, ungroup=false)
    validate_gdf_subset(res)
    @test getproperty.(keys(res), :a) == [4, 2, 1, 3]

    df = DataFrame(a=repeat(1:4, 2), b=1:8, c=repeat([true, false], inner=4))
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    @test subset!(gdf, :c) === df
    @test df == DataFrame(a=1:4, b=1:4, c=true)

    df = DataFrame(a=repeat(1:4, 2), b=1:8, c=repeat([true, false], inner=4))
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    res = subset!(gdf, :c, ungroup=false)
    @test res === gdf
    validate_gdf_subset(res)
    @test df == DataFrame(a=1:4, b=1:4, c=true)
    @test getproperty.(keys(gdf), :a) == [4, 2, 1, 3]

    Random.seed!(1234)
    for _ in 1:100
        df = DataFrame(x=rand(1:5, 100), y=rand(Bool, 100))
        gdf = groupby(df, :x, sort=true)
        @assert length(gdf) == 5
        perm = randperm(5) # no groups dropped
        gdf_p = gdf[perm]
        df2 = subset(df, :y)
        gdf2 = groupby(df2, :x)
        @assert length(gdf2) == 5 # no groups dropped
        gdf2_p = gdf2[perm]
        @test subset(gdf, :y) == df2
        res = subset(gdf, :y, ungroup=false)
        @test res == gdf2
        validate_gdf_subset(res)
        res = subset(gdf_p, :y, ungroup=false)
        @test res == gdf2_p
        validate_gdf_subset(res)
        res = subset!(gdf_p, :y, ungroup=false)
        @test res == gdf2_p
        validate_gdf_subset(res)
        @test df == df2
    end
    for _ in 1:100
        df = DataFrame(x=rand(1:50, 100), y=rand(Bool, 100))
        gdf = groupby(df, :x, sort=true)
        @assert length(gdf) < 50 # groups dropped
        gdf_p = gdf[randperm(length(gdf))]
        df2 = subset(df, :y)
        gdf2 = groupby(df2, :x)
        length(gdf2) < length(gdf) # more groups dropped
        perm2 = intersect([first(sdf.x) for sdf in gdf_p], df2.x)
        for i in 1:50
            i > maximum(perm2) && break
            while !(i in perm2)
                for j in eachindex(perm2)
                    if perm2[j] > i
                        perm2[j] -= 1
                    end
                end
            end
        end
        @assert sort(perm2) == 1:length(gdf2)
        gdf2_p = gdf2[perm2]
        @test subset(gdf, :y) == df2
        res = subset(gdf, :y, ungroup=false)
        @test res == gdf2
        validate_gdf_subset(res)
        res = subset(gdf_p, :y, ungroup=false)
        @test res == gdf2_p
        validate_gdf_subset(res)
        res = subset!(gdf_p, :y, ungroup=false)
        @test res == gdf2_p
        validate_gdf_subset(res)
        @test df == df2
    end

end

@testset "empty args" begin
    df = DataFrame()
    @test subset(df) == DataFrame()
    @test subset(df, view=true) isa SubDataFrame
    @test subset!(df) === df

    gdf = groupby(df, [])
    @test subset(gdf) == DataFrame()
    res = subset(gdf, ungroup=false)
    @test res == groupby(DataFrame(), [])
    validate_gdf_subset(res)
    @test subset!(gdf) === df
    res = subset!(gdf, ungroup=false)
    @test res === gdf
    validate_gdf_subset(res)

    df = DataFrame(a=repeat(1:4, 2), b=1:8)
    @test subset(df) == df
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    @test subset(gdf) == df
    res = subset(gdf, ungroup=false)
    @test res == groupby(df, :a)[[4, 2, 1, 3]]
    @test getproperty.(keys(res), :a) == [4, 2, 1, 3]
    validate_gdf_subset(res)

    df = DataFrame(a=repeat(1:4, 2), b=1:8)
    @test subset!(df) === df
    @test df == DataFrame(a=repeat(1:4, 2), b=1:8)
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    @test subset!(gdf) === df
    @test df == DataFrame(a=repeat(1:4, 2), b=1:8)

    df = DataFrame(a=repeat(1:4, 2), b=1:8)
    gdf = groupby(df, :a)[[4, 2, 1, 3]]
    res = subset!(gdf, ungroup=false)
    @test res === gdf
    @test df == DataFrame(a=repeat(1:4, 2), b=1:8)
    @test getproperty.(keys(gdf), :a) == [4, 2, 1, 3]
    validate_gdf_subset(res)

    df = DataFrame(a=Int[])
    gdf = groupby(df, :a)
    res = subset(gdf)
    @test nrow(res) == 0
    @test names(res) == ["a"]
    @test eltype(res.a) === Int
    res = subset(gdf, ungroup=false)
    @test res == gdf
    validate_gdf_subset(res)

    df = DataFrame(a=Int[])
    gdf = groupby(df, :a)
    res = subset!(gdf)
    @test res === df
    @test nrow(res) == 0
    @test names(res) == ["a"]
    @test eltype(res.a) === Int
    res = subset!(gdf, ungroup=false)
    @test res == groupby(DataFrame(a=Int[]), :a)
    validate_gdf_subset(res)

    df = DataFrame(a=1:3)
    gdf = groupby(df, :a)[[3, 1]]
    @test_throws ArgumentError subset(gdf)
    @test_throws ArgumentError subset!(gdf)
    @test df == DataFrame(a=1:3)
    @test gdf == groupby(DataFrame(a=1:3), :a)[[3, 1]]
end

@testset "empty conditions in subset" begin
    df = DataFrame(a=1:2)
    @test subset(df, Not(:a) .=> ByRow(x -> true)) == DataFrame(a=1:2)
    @test subset(groupby(df, :a), Not(:a) .=> ByRow(x -> true)) == DataFrame(a=1:2)
    @test subset!(df, Not(:a) .=> ByRow(x -> true)) == DataFrame(a=1:2)
    @test subset!(groupby(df, :a), Not(:a) .=> ByRow(x -> true)) == DataFrame(a=1:2)
end

end

module TestSort

using DataFrames, Random, Test, CategoricalArrays, SortingAlgorithms, InlineStrings

@testset "standard tests" begin
    dv1 = [9, 1, 8, missing, 3, 3, 7, missing]
    dv2 = [9, 1, 8, missing, 3, 3, 7, missing]
    dv3 = Vector{Union{Int, Missing}}(1:8)
    dv4 = 8:-1:1
    cv1 = CategoricalArray(dv1, ordered=true)

    d = DataFrame(dv1=dv1, dv2=dv2, dv3=dv3, dv4=dv4, cv1=cv1)

    @test sort(DataFrame()) == DataFrame()
    @test sort!(DataFrame()) == DataFrame()
    @test isempty(sortperm(DataFrame()))
    @test issorted(DataFrame())
    @test sortperm(d) == sortperm(dv1)
    @test sortperm(d[:, [:dv3, :dv1]]) == sortperm(dv3)
    @test sort(d, :dv1)[!, :dv3] == sort(d, "dv1")[!, "dv3"] == sortperm(dv1)
    @test sort(d, :dv2)[!, :dv3] == sortperm(dv1)
    @test sort(d, :cv1)[!, :dv3] == sortperm(dv1)
    @test sort(d, [:dv1, :cv1])[!, :dv3] == sortperm(dv1)
    @test sort(d, [:dv1, :dv3])[!, :dv3] == sortperm(dv1)

    df = DataFrame(rank=rand(1:12, 1000),
                   chrom=rand(1:24, 1000),
                   pos=rand(1:100000, 1000))

    @test issorted(sort(df))
    @test issorted(sort(df, rev=true), rev=true)
    @test issorted(sort(df, [:chrom, :pos])[:, [:chrom, :pos]])
    @test issorted(sort(df, ["chrom", "pos"])[:, ["chrom", "pos"]])

    ds = sort(df, [order(:rank, rev=true), :chrom, :pos])
    @test issorted(ds, [order(:rank, rev=true), :chrom, :pos])
    @test issorted(ds, rev=[true, false, false])

    ds = sort(df, [order("rank", rev=true), "chrom", "pos"])
    @test issorted(ds, [order("rank", rev=true), "chrom", "pos"])
    @test issorted(ds, rev=[true, false, false])

    ds2 = sort(df, [:rank, :chrom, :pos], rev=[true, false, false])
    @test issorted(ds2, [order(:rank, rev=true), :chrom, :pos])
    @test issorted(ds2, rev=[true, false, false])

    @test ds2 == ds

    ds2 = sort(df, ["rank", "chrom", "pos"], rev=[true, false, false])
    @test issorted(ds2, [order("rank", rev=true), "chrom", "pos"])
    @test issorted(ds2, rev=[true, false, false])

    @test ds2 == ds

    sort!(df, [:rank, :chrom, :pos], rev=[true, false, false])
    @test issorted(df, [order(:rank, rev=true), :chrom, :pos])
    @test issorted(df, rev=[true, false, false])

    @test df == ds

    sort!(df, ["rank", "chrom", "pos"], rev=[true, false, false])
    @test issorted(df, [order("rank", rev=true), "chrom", "pos"])
    @test issorted(df, rev=[true, false, false])

    @test df == ds

    @test_throws ArgumentError sort(df, (:rank, :chrom, :pos))

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test !issorted(df, :x)
    @test issorted(sort(df, :x), :x)

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test !issorted(df, "x")
    @test issorted(sort(df, "x"), "x")

    x = DataFrame(a=1:3, b=3:-1:1, c=3:-1:1)
    @test issorted(x)
    @test !issorted(x, [:b, :c])
    @test !issorted(x[:, 2:3], [:b, :c])
    @test issorted(sort(x, [2, 3]), [:b, :c])
    @test issorted(sort(x[:, 2:3]), [:b, :c])

    x = DataFrame(a=1:3, b=3:-1:1, c=3:-1:1)
    @test issorted(x)
    @test !issorted(x, ["b", "c"])
    @test !issorted(x[:, 2:3], ["b", "c"])
    @test issorted(sort(x, [2, 3]), ["b", "c"])
    @test issorted(sort(x[:, 2:3]), ["b", "c"])

    # Check that columns that shares the same underlying array are only permuted once PR#1072
    df = DataFrame(a=[2, 1])
    df.b = df.a
    sort!(df, :a)
    @test df == DataFrame(a=[1, 2], b=[1, 2])

    x = DataFrame(x=[1, 2, 3, 4], y=[1, 3, 2, 4])
    sort!(x, :y)
    @test x.y == [1, 2, 3, 4]
    @test x.x == [1, 3, 2, 4]

    @test_throws TypeError sort(x, by=:x)

    Random.seed!(1)
    # here there will be probably no ties
    df_rand1 = DataFrame(rand(100, 4), :auto)
    # but here we know we will have ties
    df_rand2 = copy(df_rand1)
    df_rand2.x1 = shuffle([fill(1, 50); fill(2, 50)])
    df_rand2.x4 = shuffle([fill(1, 50); fill(2, 50)])

    # test sorting by 1 column
    for df_rand in [df_rand1, df_rand2]
        # testing sort
        for n1 in names(df_rand)
            # passing column name
            @test sort(df_rand, n1) == df_rand[sortperm(df_rand[:, n1]), :]
            # passing vector with one column name
            @test sort(df_rand, [n1]) == df_rand[sortperm(df_rand[:, n1]), :]
            # passing vector with two column names
            for n2 in setdiff(names(df_rand), [n1])
                @test sort(df_rand, [n1, n2]) ==
                      df_rand[sortperm(collect(zip(df_rand[:, n1],
                                                   df_rand[:, n2]))), :]
            end
        end
        # testing if sort! is consistent with issorted and sort
        ref_df = df_rand
        for n1 in names(df_rand)
            df_rand = copy(ref_df)
            @test sort!(df_rand, n1) == sort(ref_df, n1)
            @test issorted(df_rand, n1)
            df_rand = copy(ref_df)
            @test sort!(df_rand, [n1]) == sort(ref_df, [n1])
            @test issorted(df_rand, [n1])
            for n2 in setdiff(names(df_rand), [n1])
                df_rand = copy(ref_df)
                @test sort!(df_rand, [n1, n2]) == sort(ref_df, [n1, n2])
                @test issorted(df_rand, n1)
                @test issorted(df_rand, [n1, n2])
            end
        end
    end
end

@testset "correctness of checkunique keyword" begin
    dv1 = [9, 1, 8, missing, 3, 3, 7, missing]
    dv2 = [9, 1, 8, missing, 3, 3, 7, missing]
    dv3 = Vector{Union{Int, Missing}}(1:8)
    dv4 = 8:-1:1
    cv1 = CategoricalArray(dv1, ordered=true)

    d = DataFrame(dv1=dv1, dv2=dv2, dv3=dv3, dv4=dv4, cv1=cv1)

    # Complex Orderings: ord(lt, by, rev, order)
    orderings = Dict(
        :cmplex => Base.Order.ord(isless, x -> -x, false), # Complex ∴ disallowed
        :simple => Base.Order.ord(isless, identity, true), # Simple ∴ allowed
        # Creating Order objects with their constructors directly
        :by_simple => Base.Order.By(identity), # Simple ∴ allowed
        :by_cmplex => Base.Order.By(x -> x), # Disallowed since x -> x !== identity
        :lt_simple => Base.Order.Lt(isless), # Simple ∴ allowed
        :lt_cmplex => Base.Order.Lt(<), # Disallowed since isless !== <
        # A test for robustness wrt complex orderings
        :sneaky_lt => Base.Order.ord(<, identity, true), # Disallowed
        # Tests with other subtypes of Ordering
        :perm_simple => Base.Order.Perm(Base.Order.ForwardOrdering(), dv3),
        :perm_cmplex => Base.Order.Perm(
            Base.Order.ord(isless, x -> -x, false), dv3
        ),
        :fforward => SortingAlgorithms.DataStructures.FasterForward(), # Simple ∴ allowed
        :freverse => SortingAlgorithms.DataStructures.FasterReverse() # Simple ∴ allowed
        )

    ords = [
        order(:dv4, lt = isless, by = identity, rev=true),
        order(:dv4, lt = >),
        order(:dv4, by = x -> -x),
        order(:dv4, lt = isless, by = x -> -x),
    ]

    # To test uncovered subtypes of Ordering throw error
    struct ArbitraryOrderSubtype <: Base.Sort.Ordering end

    ## logic:
    ### Test each every selector in the following order:
    ### Symbol, String, Vect{ColumnIndex}, Order, Vect{ColIndex, Order}

    # issorted
    # Possible selectors as cols
    @test_throws ArgumentError issorted(d, :dv1, checkunique=true)
    @test issorted(d, :dv3, checkunique=true)
    @test issorted(d, "dv3", checkunique=true)
    @test issorted(d, ["dv3", "dv4"], checkunique=true)
    @test issorted(d, :dv4, rev = true, checkunique=true)
    @test issorted(d, order(:dv4, rev=true), checkunique=true)
    # Non-standard lt or by functions
    @test_throws ArgumentError issorted(d, order(:dv4, by=x -> -x), checkunique=true)
    @test_throws ArgumentError issorted(d, order(:dv4, lt= >), checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, by=x-> -x, checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, lt = >, checkunique=true)
    # Mixed-in order clauses
    @test issorted(d, [:dv3, order(:dv4, rev=true)], checkunique=true)
    @test issorted(d, [:dv3, :dv4], rev = [false, true], checkunique=true)
    @test issorted(d, [order(:dv3, rev=false), order(:dv4, rev=true)], checkunique=true)
    @test issorted(d, [order(:dv3, by=identity), order(:dv4, rev=true)], checkunique=true)
    @test_throws ArgumentError issorted(d, [order(:dv1, by = round), order(:dv2, rev=true)], checkunique=true)
    # Orderings defined via Base.ord & Base.Order subtypes
    @test issorted(d, :dv4, order=Base.Reverse, checkunique=true)
    @test issorted(d, :dv4, order=orderings[:simple], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:cmplex], checkunique=true)
    @test issorted(d, :dv3, order=orderings[:by_simple], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:by_cmplex], checkunique=true)
    @test issorted(d, :dv3, order=orderings[:lt_simple], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:lt_cmplex], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:sneaky_lt], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:sneaky_lt], checkunique=true)
    @test issorted(d, :dv3, order=orderings[:fforward], checkunique=true)
    @test issorted(d, :dv4, order=orderings[:freverse], checkunique=true)
    @test issorted(d, :dv3, order=orderings[:perm_simple], checkunique=true)
    @test_throws ArgumentError issorted(d, :dv3, order=orderings[:perm_cmplex], checkunique=true)
    # UserColOrderings
    @test issorted(d, ords[1], checkunique=true)
    @test_throws ArgumentError issorted(d, ords[2], checkunique=true)

    # Checking correct complex order detection
    @test DataFrames.is_complex.(ords) == [false, true, true, true]
    @test DataFrames.is_complex(DataFrames.DFPerm([orderings[:cmplex], orderings[:by_cmplex]], d[!, [:dv3, :dv4]])) == true
    @test DataFrames.is_complex(DataFrames.DFPerm(orderings[:cmplex], d[!, [:dv3]])) == true
    # Error on unsupported Ordering subtypes
    @test_throws ArgumentError DataFrames.is_complex(ArbitraryOrderSubtype())

    # sort
    @test_throws ArgumentError sort(d, :dv1, checkunique=true)
    @test_throws ArgumentError sort(d, "dv1", checkunique=true)
    @test_throws ArgumentError sort(d, 1, checkunique=true)
    @test_throws ArgumentError sort(d, [:dv1, :dv2], checkunique=true)
    @test_throws ArgumentError sort(d, ["dv1", "dv2"], checkunique=true)
    @test_throws ArgumentError sort(d, order(:dv1, rev=true), checkunique=true)
    @test_throws ArgumentError sort(d, order(:dv1, by=x -> -x), checkunique=true)
    @test_throws ArgumentError sort(d, order(:dv1, lt= >), checkunique=true)
    @test_throws ArgumentError sort(d, [:dv2, order(:dv1, rev=true)], checkunique=true)
    @test_throws ArgumentError sort(d, [:dv1, :dv2], rev = [false, false], checkunique=true)
    @test_throws ArgumentError sort(d, :dv1, by = x -> -x, checkunique=true)
    @test_throws ArgumentError sort(d, :dv1, lt = >, checkunique=true)

    # sort!
    @test_throws ArgumentError sort!(d, :dv1, checkunique=true)
    @test_throws ArgumentError sort!(d[!, [:dv1, :dv2]], checkunique = true)
    # Orderings defined via Base.ord
    @test_throws ArgumentError sort!(d, :dv3, order=orderings[:cmplex], checkunique=true)
    @test_throws ArgumentError sort!(d, :dv3, order=orderings[:by_cmplex], checkunique=true)
    @test_throws ArgumentError sort!(d, :dv3, order=orderings[:lt_cmplex], checkunique=true)
    @test_throws ArgumentError sort!(d, :dv3, order=orderings[:sneaky_lt], checkunique=true)
    # UserColOrderings
    @test_throws ArgumentError sort!(d, ords[2], checkunique=true)

    # sortperm
    @test_throws ArgumentError sortperm(d, :dv1, checkunique=true)
    @test_throws ArgumentError sortperm(d, "dv1", checkunique=true)
    @test_throws ArgumentError sortperm(d, 1, checkunique=true)
    @test_throws ArgumentError sortperm(d, [:dv1, :dv2], checkunique=true)
    @test_throws ArgumentError sortperm(d, ["dv1", "dv2"], checkunique=true)
    @test_throws ArgumentError sortperm(d, order(:dv1, rev=true), checkunique=true)
    @test_throws ArgumentError sortperm(d, order(:dv1, by=x -> -x), checkunique=true)
    @test_throws ArgumentError sortperm(d, order(:dv1, lt= >), checkunique=true)
    @test_throws ArgumentError sortperm(d, [:dv2, order(:dv1, rev=true)], checkunique=true)
    @test_throws ArgumentError sortperm(d, [:dv1, :dv2], rev = [false, false], checkunique=true)
    @test_throws ArgumentError sortperm(d, :dv1, by = x -> -x, checkunique=true)
    @test_throws ArgumentError sortperm(d, :dv1, lt = >, checkunique=true)
end

@testset "non standard selectors" begin
    Random.seed!(1234)
    df = DataFrame(rand(1:2, 1000, 4), :auto)
    for f in [sort, sort!, sortperm, issorted]
        @test f(df) == f(df, :) == f(df, All()) == f(df, Cols(:)) == f(df, r"x") ==
              f(df, Between(1, 4)) == f(df, Not([]))
    end
end

@testset "view kwarg test" begin
    df = DataFrame(rand(3, 4), :auto)
    @test sort(df) isa DataFrame
    @inferred sort(df)
    @test sort(view(df, 1:2, 1:2)) isa DataFrame
    @test sort(df, view=false) isa DataFrame
    @test sort(view(df, 1:2, 1:2), view=false) isa DataFrame
    @test sort(df, view=true) isa SubDataFrame
    @test sort(df, view=true) == sort(df)
    @test sort(view(df, 1:2, 1:2), view=true) isa SubDataFrame
    @test sort(view(df, 1:2, 1:2), view=true) == sort(view(df, 1:2, 1:2))
end

@testset "hard tests of different sorting orders" begin
    Random.seed!(1234)
    df = DataFrame(rand([0, 1], 10^5, 3), :auto)
    @test sortperm(df, :x1) == sortperm(df.x1)
    @test sortperm(df, [:x1, :x2]) == sortperm(tuple.(df.x1, df.x2))
    @test sortperm(df, [:x1, :x2, :x3]) == sortperm(tuple.(df.x1, df.x2, df.x3))
    @test sortperm(df, :x1, rev=true) == sortperm(df.x1, rev=true)
    @test sortperm(df, [:x1, :x2], rev=true) ==
          sortperm(tuple.(df.x1, df.x2), rev=true)
    @test sortperm(df, [:x1, :x2, :x3], rev=true) ==
          sortperm(tuple.(df.x1, df.x2, df.x3), rev=true)

    @test issorted(sort(df, :x1), :x1)
    @test issorted(sort(df, [:x1, :x2]), [:x1, :x2])
    @test issorted(sort(df, [:x1, :x2, :x3]), [:x1, :x2, :x3])
    @test issorted(sort(df, :x1, rev=true), :x1, rev=true)
    @test issorted(sort(df, [:x1, :x2], rev=true), [:x1, :x2], rev=true)
    @test issorted(sort(df, [:x1, :x2, :x3], rev=true), [:x1, :x2, :x3], rev=true)

    for r1 in (true, false)
        @test sortperm(df, order(:x1, rev=r1)) == sortperm((1 - 2*r1) * df.x1)
        @test issorted(sort(df, order(:x1, rev=r1)), order(:x1, rev=r1))
        for r2 in (true, false)
            @test sortperm(df, [order(:x1, rev=r1), order(:x2, rev=r2)]) ==
                  sortperm(tuple.((1 - 2*r1) * df.x1, (1 - 2*r2) * df.x2))
            @test issorted(sort(df, [order(:x1, rev=r1), order(:x2, rev=r2)]),
                           [order(:x1, rev=r1), order(:x2, rev=r2)])
            for r3 in (true, false)
                @test sortperm(df, [order(:x1, rev=r1), order(:x2, rev=r2), order(:x3, rev=r3)]) ==
                      sortperm(tuple.((1 - 2*r1) * df.x1, (1 - 2*r2) * df.x2, (1 - 2*r3) * df.x3))
                @test issorted(sort(df, [order(:x1, rev=r1), order(:x2, rev=r2), order(:x3, rev=r3)]),
                               [order(:x1, rev=r1), order(:x2, rev=r2), order(:x3, rev=r3)])
            end
        end
    end

    for i in 2:20
        df = DataFrame(ones(10, i), :auto)
        df[!, end] = randperm(10)
        @test sortperm(df) == sortperm(df[!, end])
        @test sortperm(df, [1:i-1; order(i, rev=true)]) == sortperm(df[!, end], rev=true)
        df[!, 1] = randperm(10)
        @test sortperm(df) == sortperm(df[!, 1])
        @test sortperm(df, [order(1, rev=true); 2:i-1; order(i, rev=true)]) ==
              sortperm(df[!, 1], rev=true)
    end
end

@testset "sort! tests" begin
    # safe aliasing test
    # this works because 2:5 is immutable
    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, 2:5)
    df.x2 = view(x, 2:5)
    sort!(df)
    @test issorted(df)
    @test x == [10, 6, 7, 8, 9, 5, 4, 3, 2, 1]
    @test df == DataFrame(x1=6:9, x2=6:9)

    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, 2:5)
    df.x2 = view(x, [2:5;])
    sort!(df)
    @test_broken issorted(df)
    @test_broken x == [10, 6, 7, 8, 9, 5, 4, 3, 2, 1]
    @test_broken df == DataFrame(x1=6:9, x2=6:9)

    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, 2:5)
    df.x2 = view(x, 2:5)
    dfv = view(df, 2:4, :)
    sort!(dfv)
    @test issorted(dfv)
    @test x == [10, 9, 6, 7, 8, 5, 4, 3, 2, 1]
    @test df == DataFrame(x1=[9; 6:8], x2=[9; 6:8])

    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, [2:5;])
    df.x2 = view(x, 2:5)
    dfv = view(df, 2:4, :)
    sort!(dfv)
    @test_broken issorted(dfv)
    @test_broken x == [10, 9, 6, 7, 8, 5, 4, 3, 2, 1]
    @test_broken df == DataFrame(x1=[9; 6:8], x2=[9; 6:8])

    # unsafe aliasing test
    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, 2:5)
    df.x2 = view(x, 3:6)
    sort!(df)
    @test_broken x == 10:-1:1
    @test_broken df == DataFrame(x1=9:-1:6, x2=8:-1:5)

    df = DataFrame()
    x = [10:-1:1;]
    df.x1 = view(x, 2:5)
    df.x2 = view(x, 3:6)
    dfv = view(df, 2:4, :)
    sort!(dfv)
    @test_broken x == 10:-1:1
    @test_broken df == DataFrame(x1=9:-1:6, x2=8:-1:5)

    # complex view sort test
    Random.seed!(1234)
    df = DataFrame(rand(100, 10), :auto)
    insertcols!(df, 1, :id => axes(df, 1))
    df2 = copy(df)
    dfv = view(df, 100:-2:1, [5, 3, 1])
    sort!(dfv, :id)
    @test issorted(dfv, :id)
    @test select(df, Not([1, 3, 5])) == select(df2, Not([1, 3, 5]))
    @test sort(select(df, [1, 3, 5]), :id) == select(df2, [1, 3, 5])
    @test select(df, [1, 3, 5]) ==
          select(df2, [1, 3, 5])[[isodd(i) ? i : (102 - i) for i in 1:100], :]
end

@testset "check sorting kwarg argument correctness" begin
    for df in (DataFrame(x=1:3), DataFrame(x=1:3, y=1:3)), fun in (issorted, sort, sortperm, sort!)
        @test_throws TypeError fun(df, by=Int)
        @test_throws TypeError fun(df, lt=Int)
        @test_throws TypeError fun(df, rev=Int)
        @test_throws TypeError fun(df, order=Int)
        @test_throws TypeError fun(df, by=1)
        @test_throws TypeError fun(df, lt=1)
        @test_throws TypeError fun(df, rev=1)
        @test_throws TypeError fun(df, order=1)
        @test_throws TypeError fun(df, by=(identity,))
        @test_throws TypeError fun(df, lt=(isless,))
        @test_throws TypeError fun(df, rev=(true,))
        @test_throws TypeError fun(df, order=(Base.Forward,))
        @test_throws TypeError fun(df, by=(identity, identity))
        @test_throws TypeError fun(df, lt=(isless, isless))
        @test_throws TypeError fun(df, rev=(true, true))
        @test_throws TypeError fun(df, order=(Base.Forward, Base.Forward))
    end

    for df in (DataFrame(x=1:3), DataFrame(x=1:3, y=1:3)), fun in (sort, sort!)
        dfc = copy(df)
        @test fun(df, by=identity) == dfc
        @test fun(df, by=fill(identity, ncol(df))) == dfc
        @test fun(df, lt=isless) == dfc
        @test fun(df, lt=fill(isless, ncol(df))) == dfc
        @test fun(df, rev=false) == dfc
        @test fun(df, rev=fill(false, ncol(df))) == dfc
        @test fun(df, order=Base.Forward) == dfc
        @test fun(df, order=fill(Base.Forward, ncol(df))) == dfc
    end

    for df in (DataFrame(x=1:3), DataFrame(x=1:3, y=1:3))
        @test issorted(df, by=identity)
        @test issorted(df, by=fill(identity, ncol(df)))
        @test issorted(df, lt=isless)
        @test issorted(df, lt=fill(isless, ncol(df)))
        @test issorted(df, rev=false)
        @test issorted(df, rev=fill(false, ncol(df)))
        @test issorted(df, order=Base.Forward)
        @test issorted(df, order=fill(Base.Forward, ncol(df)))
        @test_throws ArgumentError issorted(df, Base.Order.Forward)

        @test issorted(df, :x, by=identity)
        @test issorted(df, :x, by=[identity])
        @test issorted(df, :x, lt=isless)
        @test issorted(df, :x, lt=[isless])
        @test issorted(df, :x, rev=false)
        @test issorted(df, :x, rev=[false])
        @test issorted(df, :x, order=Base.Forward)
        @test issorted(df, :x, order=[Base.Forward])

        @test sortperm(df, by=identity) == 1:3
        @test sortperm(df, by=fill(identity, ncol(df))) == 1:3
        @test sortperm(df, lt=isless) == 1:3
        @test sortperm(df, lt=fill(isless, ncol(df))) == 1:3
        @test sortperm(df, rev=false) == 1:3
        @test sortperm(df, rev=fill(false, ncol(df))) == 1:3
        @test sortperm(df, order=Base.Forward) == 1:3
        @test sortperm(df, order=fill(Base.Forward, ncol(df))) == 1:3
    end
end

@testset "correct aliasing detection" begin
    # make sure sorting a view does not produce an error
    for sel in ([1, 2, 3], 1:3)
        df = DataFrame(a=1:5, b=11:15, c=21:25)
        dfc = copy(df)
        sdf = view(df, sel, :)
        sort!(sdf)
        @test df[:, 1:3] == dfc
    end

    Random.seed!(1234)
    for sel in ([1:100;], 1:100)
        df = DataFrame(a=rand(100), b=rand(100), c=rand(100), id=1:100)
        dfc = sort(df)
        sdf = view(df, sel, :)
        sort!(sdf)
        @test df == dfc
        sort!(df, :id)
        df.d = df.a
        sort!(sdf)
        @test df[:, 1:4] == dfc
    end

    # this is a test that different views are incorrectly handled
    x = [1:6;]
    df = DataFrame(a=view(x, 1:5), b=view(x, 6:-1:2), copycols=false)
    dfv = view(df, 1:3, :)
    sort!(dfv, :b)
    @test df == DataFrame(a=[3, 2, 1, 6, 5], b=[4, 5, 6, 1, 2])
    # this is the "correct" result if we had no aliasing
    x = [1:6;]
    df = DataFrame(a=view(x, 1:5), b=view(x, 6:-1:2))
    dfv = view(df, 1:3, :)
    sort!(dfv, :b)
    @test df == DataFrame(a=[3, 2, 1, 4, 5], b=[4, 5, 6, 3, 2])

    df = DataFrame(x1=rand(10))
    df.x2 = df.x1
    df.x3 = df.x1
    df.x4 = df.x1
    df.x5 = df.x1
    sort!(df, :x4)
    @test issorted(df)

    df = DataFrame(x1=rand(10))
    df.x2 = df.x1
    df.x3 = df.x1
    df.x4 = df.x1
    df.x5 = df.x1
    dfv = @view df[1:5, 1:4]
    sort!(dfv, :x4)
    @test issorted(dfv)
    @test issorted(df[1:5, :])
end

@testset "issue #3340, mostly downstream testing for SortingAlgorithms.jl and Base.Sort" begin
    Random.seed!(1234)
    for i in 1:10
        df = DataFrame(units = round.(Int, 1 ./ rand(2000)),
                       sku = [rand() < .084 ? missing : String31(randstring(8)) for _ in 1:2000])
        @test issorted(sort(select(df, [:sku, :units]), :sku).sku)
        @test issorted(sort(select(df, [:sku, :units]), :units).units)
        @test issorted(sort(select(df, [:sku, :units]).sku))
        @test issorted(sort(df, :sku).sku)

        o = Base.Order.Perm(Base.Order.ForwardOrdering(), df.sku)
        a = DataFrames.SortingAlgorithms.TimSortAlg()
        x = collect(1:nrow(df))
        sort!(x, a, o)
        @test issorted(df[x, :sku])
    end
end

end # module

# an AbstractIndex is a thing that can be used to look up ordered things by name, but that
# will also accept a position or set of positions or range or other things and pass them
# through cleanly.
abstract type AbstractIndex end

function Base.summary(idx::AbstractIndex)
    l = length(idx)
    return "data frame with $l column$(l == 1 ? "" : "s")"
end
Base.summary(io::IO, idx::AbstractIndex) = print(io, summary(idx))

const SymbolOrString = Union{Symbol, AbstractString}
const ColumnIndex = Union{Signed, Unsigned, SymbolOrString}
const MultiColumnIndex = Union{AbstractVector, Regex, Not, Between, All, Cols, Colon}
const MULTICOLUMNINDEX_TUPLE = (:AbstractVector, :Regex, :Not, :Between, :All, :Cols, :Colon)

const COLUMNINDEX_STR = "`Symbol`, string or integer"
const MULTICOLUMNINDEX_STR = "`:`, `Cols`, `All`, `Between`, `Not`, a regular expression, " *
                             "or a vector of `Symbol`s, strings or integers"

struct Index <: AbstractIndex   # an OrderedDict would be nice here...
    lookup::Dict{Symbol, Int}      # name => names array position
    names::Vector{Symbol}
end

function Index(names::AbstractVector{Symbol}; makeunique::Bool=false)
    u = make_unique(names, makeunique=makeunique)
    lookup = Dict{Symbol, Int}(zip(u, 1:length(u)))
    return Index(lookup, u)
end

Index() = Index(Dict{Symbol, Int}(), Symbol[])
Base.length(x::Index) = length(x.names)
Base.names(x::Index) = string.(x.names)

# _names returns Vector{Symbol}
_names(x::Index) = x.names

Base.copy(x::Index) = Index(copy(x.lookup), copy(x.names))
Base.isequal(x::AbstractIndex, y::AbstractIndex) = _names(x) == _names(y) # it is enough to check names
Base.:(==)(x::AbstractIndex, y::AbstractIndex) = isequal(x, y)


function rename!(x::Index, nms::AbstractVector{Symbol}; makeunique::Bool=false)
    if !makeunique
        if length(unique(nms)) != length(nms)
            dup = unique(nms[nonunique(DataFrame(nms=nms))])
            dupstr = join(string.(':', dup), ", ", " and ")
            msg = "Duplicate variable names: $dupstr. Pass makeunique=true " *
                  "to make them unique using a suffix automatically."
            throw(ArgumentError(msg))
        end
    end
    if length(nms) != length(x)
        throw(DimensionMismatch("Length of nms doesn't match length of x."))
    end
    make_unique!(x.names, nms, makeunique=makeunique)
    empty!(x.lookup)
    for (i, n) in enumerate(x.names)
        x.lookup[n] = i
    end
    return x
end

function rename!(x::Index, nms::AbstractVector{Pair{Symbol, Symbol}})
    xbackup = copy(x)
    processedfrom = Set{Symbol}()
    processedto = Set{Symbol}()
    toholder = Dict{Symbol, Int}()
    for (from, to) in nms
        if from ∈ processedfrom
            copy!(x.lookup, xbackup.lookup)
            x.names .= xbackup.names
            throw(ArgumentError("Tried renaming :$from multiple times."))
        end
        if to ∈ processedto
            copy!(x.lookup, xbackup.lookup)
            x.names .= xbackup.names
            throw(ArgumentError("Tried renaming to :$to multiple times."))
        end
        push!(processedfrom, from)
        push!(processedto, to)
        from == to && continue # No change, nothing to do
        if !haskey(xbackup, from)
            copy!(x.lookup, xbackup.lookup)
            x.names .= xbackup.names
            if length(x) == 0
                throw(ArgumentError("Tried renaming :$from to :$to, when " *
                                    "data frame has no columns."))
            else
                throw(ArgumentError("Tried renaming :$from to :$to, when :$from " *
                                    "does not exist in the data frame."))
            end
        end
        if haskey(x, to)
            toholder[to] = x.lookup[to]
        end
        col = haskey(toholder, from) ? pop!(toholder, from) : pop!(x.lookup, from)
        x.lookup[to] = col
        x.names[col] = to
    end
    if !isempty(toholder)
        copy!(x.lookup, xbackup.lookup)
        x.names .= xbackup.names
        throw(ArgumentError("Tried renaming to :$(first(keys(toholder))), " *
                            "when it already exists in the data frame."))
    end
    return x
end

# we do not define keys on purpose;
# use names to get keys as strings with copying
# or _names to get keys as Symbols without copying
Base.haskey(::Index, key::Any) =
    throw(ArgumentError("invalid key: $key of type $(typeof(key))"))
Base.haskey(x::Index, key::Symbol) = haskey(x.lookup, key)
Base.haskey(x::Index, key::AbstractString) = haskey(x.lookup, Symbol(key))
Base.haskey(x::Index, key::Integer) = 1 <= key <= length(x.names)
Base.haskey(x::Index, key::Bool) =
    throw(ArgumentError("invalid key: $key of type Bool"))

function Base.push!(x::Index, nm::Symbol)
    haskey(x.lookup, nm) && throw(ArgumentError(":$nm already exists in the data frame"))
    x.lookup[nm] = length(x) + 1
    push!(x.names, nm)
    return x
end

function Base.merge!(x::Index, y::AbstractIndex; makeunique::Bool=false)
    adds = add_names(x, y, makeunique=makeunique)
    i = length(x)
    for add in adds
        i += 1
        x.lookup[add] = i
    end
    append!(x.names, adds)
    return x
end

Base.merge(x::AbstractIndex, y::AbstractIndex; makeunique::Bool=false) =
    merge!(copy(x), y, makeunique=makeunique)

function Base.delete!(x::Index, idx::Integer)
    # reset the lookup's beyond the deleted item
    for i in (idx + 1):length(x.names)
        x.lookup[x.names[i]] = i - 1
    end
    delete!(x.lookup, x.names[idx])
    deleteat!(x.names, idx)
    return x
end

function Base.delete!(x::Index, nm::Symbol)
    if !haskey(x.lookup, nm)
        return x
    end
    idx = x.lookup[nm]
    return delete!(x, idx)
end

Base.delete!(x::Index, nm::AbstractString) = delete!(x, Symbol(nm))

function Base.empty!(x::Index)
    empty!(x.lookup)
    empty!(x.names)
    return x
end

function Base.insert!(x::Index, idx::Integer, nm::Symbol)
    if !(1 <= idx <= length(x.names)+1)
        throw(BoundsError(x, idx))
     end
    for i = idx:length(x.names)
        x.lookup[x.names[i]] = i + 1
    end
    x.lookup[nm] = idx
    insert!(x.names, idx, nm)
    return x
end

Base.insert!(x::Index, idx::Integer, nm::AbstractString) = insert!(x, idx, Symbol(nm))

@inline Base.getindex(x::AbstractIndex, idx::T) where {T} =
    throw(ArgumentError("invalid index: $idx of type $T"))

@inline Base.getindex(x::AbstractIndex, idx::Bool) =
    throw(ArgumentError("invalid index: $idx of type Bool"))

@inline function Base.getindex(x::AbstractIndex, idx::Integer)
    if !(1 <= idx <= length(x))
        throw(BoundsError(x, idx))
    end
    return Int(idx)
end

@inline function Base.getindex(x::AbstractIndex, idx::AbstractVector{Int})
    isempty(idx) && return idx
    minidx, maxidx = extrema(idx)
    if minidx < 1
        throw(BoundsError(x, idx))
    end
    if maxidx > length(x)
        throw(BoundsError(x, idx))
    end
    allunique(idx) || throw(ArgumentError("Elements of $idx must be unique"))
    return idx
end

@inline function Base.getindex(x::AbstractIndex, idx::AbstractRange{Int})
    isempty(idx) && return idx
    minidx, maxidx = extrema(idx)
    if minidx < 1
        throw(BoundsError(x, idx))
    end
    if maxidx > length(x)
        throw(BoundsError(x, idx))
    end
    allunique(idx) || throw(ArgumentError("Elements of $idx must be unique"))
    return idx
end

@inline Base.getindex(x::AbstractIndex, idx::AbstractRange{<:Integer}) =
    getindex(x, collect(Int, idx))
@inline Base.getindex(x::AbstractIndex, ::Colon) = Base.OneTo(length(x))
@inline Base.getindex(x::AbstractIndex, notidx::Not) =
    setdiff(1:length(x), getindex(x, notidx.skip))

@inline function Base.getindex(x::AbstractIndex, notidx::Not{<:AbstractVector})
    skip = notidx.skip
    todrop = getindex(x, eltype(skip) === Bool ? skip : unique(skip))
    return setdiff(1:length(x), todrop)
end

@inline Base.getindex(x::AbstractIndex, notidx::Not{InvertedIndices.NotMultiIndex}) =
    setdiff(1:length(x), getindex(x, Cols(notidx.skip.indices...)))
@inline Base.getindex(x::AbstractIndex, idx::Between) = x[idx.first]:x[idx.last]
@inline Base.getindex(x::AbstractIndex, idx::All) =
    isempty(idx.cols) ? (1:length(x)) : throw(ArgumentError("All(args...) is not supported: use Cols(args...) instead"))

@inline _getindex_cols(x::AbstractIndex, idx::Any) = x[idx]
@inline _getindex_cols(x::AbstractIndex, idx::Function) = findall(idx, names(x))
# the definition below is needed because `:` is a Function
@inline _getindex_cols(x::AbstractIndex, idx::Colon) = x[idx]

@inline function Base.getindex(x::AbstractIndex, idx::Cols)
    isempty(idx.cols) && return Int[]
    return idx.operator(_getindex_cols.(Ref(x), idx.cols)...)
end

@inline function Base.getindex(x::AbstractIndex, idx::AbstractVector{<:Integer})
    if any(v -> v isa Bool, idx)
        throw(ArgumentError("Bool values except for AbstractVector{Bool} are not " *
                            "allowed for column indexing"))
    end
    return getindex(x, Vector{Int}(idx))
end

@inline Base.getindex(x::AbstractIndex, idx::AbstractRange{Bool}) =
    getindex(x, collect(idx))

@inline function Base.getindex(x::AbstractIndex, idx::AbstractVector{Bool})
    length(x) == length(idx) || throw(BoundsError(x, idx))
    return _findall(idx)
end

# catch all method handling cases when type of idx is not narrowest possible, Any in particular
@inline function Base.getindex(x::AbstractIndex, idxs::AbstractVector)
    isempty(idxs) && return Int[] # special case of empty idxs
    if idxs[1] isa Real
        if !all(v -> v isa Integer && !(v isa Bool), idxs)
            throw(ArgumentError("Only `Integer` values allowed when indexing by vector of numbers"))
        end
        return getindex(x, convert(Vector{Int}, idxs))
    elseif idxs[1] isa Symbol
        if all(x -> x isa Symbol, idxs)
            return getindex(x, convert(Vector{Symbol}, idxs))
        else
            throw(ArgumentError("mixing `Symbol`s with other selectors in a vector " *
                                "is not allowed. Maybe you wanted to use `Cols` instead?"))
        end
    elseif idxs[1] isa AbstractString
        if all(x -> x isa AbstractString, idxs)
            return getindex(x, Symbol.(idxs))
        else
            throw(ArgumentError("mixing `Symbol`s with other selectors in a vector " *
                                "is not allowed. Maybe you wanted to use `Cols` instead?"))
        end
    end
    throw(ArgumentError("idxs[1] has type $(typeof(idxs[1])); only Integer, Symbol, "*
                        "or string values allowed when indexing by vector. " *
                        "Maybe you wanted to use `Cols` instead?"))
end

@inline Base.getindex(x::AbstractIndex, rx::Regex) =
    getindex(x, filter(name -> occursin(rx, String(name)), _names(x)))

# Levenshtein Distance
# taken from https://github.com/JuliaLang/julia/blob/b5af119a6c608de43d6591a6c4129e9369239898/stdlib/REPL/src/docview.jl#L760-L776
function _levenshtein(s1, s2)
    a, b = collect(s1), collect(s2)
    m = length(a)
    n = length(b)
    d = Matrix{Int}(undef, m+1, n+1)

    d[1:m+1, 1] = 0:m
    d[1, 1:n+1] = 0:n

    for i = 1:m, j = 1:n
        d[i+1,j+1] = min(d[i  , j+1] + 1,
                         d[i+1, j  ] + 1,
                         d[i  , j  ] + (a[i] != b[j]))
    end

    return d[m+1, n+1]
end

# Fuzzy matching rules:
# 1. ignore case
# 2. maximum Levenshtein distance is 2
# 3. always show matches with 0 difference (wrong case)
# 4. on top of 3. do not show more than 8 matches in total
# Returns candidates ordered by (distance, name) pair
function fuzzymatch(l::Dict{Symbol, Int}, idx::Symbol)
        idxs = uppercase(string(idx))
        dist = [(_levenshtein(uppercase(string(x)), idxs), x) for x in keys(l)]
        sort!(dist)
        c = [count(x -> x[1] <= i, dist) for i in 0:2]
        maxd = max(0, searchsortedlast(c, 8) - 1)
        return [s for (d, s) in dist if d <= maxd]
end

# see JuliaLang/julia#42561; we keep our own list to ensure things work consistently on earlier versions of Julia
const _julia_charmap = Dict{Char,Char}(
    Char(0x025B) => Char(0x03B5),
    Char(0x00B5) => Char(0x03BC),
    Char(0x00B7) => Char(0x22C5),
    Char(0x0387) => Char(0x22C5),
    Char(0x2212) => Char(0x002D)
)

function _norm_eq(a1::String, a2::String, idx::Symbol)
    a1 == a2 && return true
    a1_std = [get(_julia_charmap, c, c) for c in a1]
    a2_std = [get(_julia_charmap, c, c) for c in a2]

    a1_std == a2_std || return false

    # here we are sure a1 and a2 have the same length
    # but are equal only because we performed character mapping
    for (c1, c2) in zip(a1, a2)
        if c1 != c2
            refc1 = get(_julia_charmap, c1, c1)
            refc2 = get(_julia_charmap, c2, c2)
            @assert refc1 == refc2
            throw(ArgumentError("column name :$idx not found in the " *
                                "data frame. However there is a similar " *
                                "column name in the data frame where character $c2 " *
                                "(codepoint: $(UInt32(c2))) is used instead of $c1 " *
                                "(codepoint: $(UInt32(c1))). The " *
                                "error is most likely caused by the Julia parser which " *
                                "normalizes `Symbol` literals containing such " *
                                "characters. If the passed name is intended " *
                                "to match the column name found in the data frame " *
                                "replace the non-matching character with the correct one."))
        end
    end
    throw(AssertionError("Unreachable reached. Please report issue to " *
                         "DataFrames.jl repository on GitHub."))
end

function normalized_match_test(l::Dict{Symbol, Int}, idx::Symbol)
    idx_raw = string(idx)
    idxs = Unicode.normalize(idx_raw)
    for x in keys(l)
        x_raw = string(x)
        xs = Unicode.normalize(x_raw)
        if _norm_eq(idxs, xs, idx)
            idx_ok = idx_raw == idxs
            x_ok = x_raw == xs
            if !idx_ok
                if x_ok
                    throw(ArgumentError("column name :$idx not found in the " *
                                        "data frame. However, after applying Unicode " *
                                        "normalization to it, the passed column name " *
                                        "matches a column name found in the data frame. " *
                                        "You can use the `Unicode.normalize` " *
                                        "function to normalize the passed column name."))
                else
                    throw(ArgumentError("column name :$idx not found in the " *
                                        "data frame. However, there is a match " *
                                        "after applying Unicode normalization both " *
                                        "to the passed column names " *
                                        "and to the column names of the data frame. " *
                                        "In the call both passed column and " *
                                        "matching column found in the data frame were not " *
                                        "normalized. It is recommended to use " *
                                        "normalized column names and then refer to them " *
                                        "using normalized names to avoid ambiguity. " *
                                        "In order to normalize column names in " *
                                        "an existing data frame `df` do " *
                                        "`using Unicode; rename!(Unicode.normalize, df)`. " *
                                        "Similarly, you can use the `Unicode.normalize` " *
                                        "function to normalize the passed column name."))
                end
            else
                @assert !x_ok
                throw(ArgumentError("column name :$idx not found in the " *
                                    "data frame. However, the passed column name " *
                                    "matches a column name found in the data frame " *
                                    "after applying Unicode normalization to the latter. " *
                                    "It is recommended to use " *
                                    "normalized column names to avoid ambiguity. " *
                                    "In order to normalize column names in " *
                                    "an existing data frame `df` do " *
                                    "`using Unicode; rename!(Unicode.normalize, df)`."))
            end
        end
    end
end

@inline function lookupname(l::Dict{Symbol, Int}, idx::Symbol)
    i = get(l, idx, nothing)
    if i === nothing
        normalized_match_test(l, idx)
        candidates = fuzzymatch(l, idx)
        if isempty(candidates)
            if isempty(l)
                throw(ArgumentError("column name \"$idx\" not found in the " *
                                    "data frame since it has no columns"))
            end
            throw(ArgumentError("column name :$idx not found in the data frame"))
        end
        candidatesstr = join(string.('"', candidates, '"'), ", ", " and ")
        throw(ArgumentError("column name \"$idx\" not found in the data frame; " *
                            "existing most similar names are: $candidatesstr"))
    end
    return i
end

@inline Base.getindex(x::Index, idx::Symbol) = lookupname(x.lookup, idx)
@inline Base.getindex(x::Index, idx::AbstractString) = x[Symbol(idx)]

@inline function Base.getindex(x::Index, idx::Union{AbstractVector{Symbol},
                                              AbstractVector{<:AbstractString}})
    allunique(idx) || throw(ArgumentError("Elements of $idx must be unique"))
    return [x[i] for i in idx]
end

# Helpers

# return Vector{Symbol} of names from add_ind that do not clash with `ind`.
# if `makeunique=false` error on collision
# if `makeunique=false` generate new names that are deduplicated
function add_names(ind::Index, add_ind::AbstractIndex; makeunique::Bool=false)
    u = copy(_names(add_ind))

    seen = Set(_names(ind))
    dups = Int[]

    for i in 1:length(u)
        name = u[i]
        in(name, seen) ? push!(dups, i) : push!(seen, name)
    end
    if length(dups) > 0
        if !makeunique
            dupstr = join(string.(':', unique(u[dups])), ", ", " and ")
            msg = "Duplicate variable names: $dupstr. Pass makeunique=true " *
                  "to make them unique using a suffix automatically."
            throw(ArgumentError(msg))
        end
    end
    for i in dups
        nm = u[i]
        k = 1
        while true
            newnm = Symbol("$(nm)_$k")
            if !in(newnm, seen)
                u[i] = newnm
                push!(seen, newnm)
                break
            end
            k += 1
        end
    end

    return u
end

@inline parentcols(ind::Index) = Base.OneTo(length(ind))
@inline parentcols(ind::Index, cols) = ind[cols]

### SubIndex of Index. Used by SubDataFrame, DataFrameRow, and DataFrameRows

struct SubIndex{I<:AbstractIndex, S<:AbstractVector{Int}, T<:AbstractVector{Int}} <: AbstractIndex
    parent::I
    cols::S # columns from idx selected in SubIndex
    remap::T # reverse mapping from cols to their position in the SubIndex
end

SubIndex(parent::AbstractIndex, ::Colon) = parent

Base.copy(x::SubIndex) = Index(_names(x))

@inline parentcols(ind::SubIndex) = ind.cols

Base.@propagate_inbounds parentcols(ind::SubIndex, idx::Union{Integer, AbstractVector{<:Integer}}) =
    ind.cols[idx]
Base.@propagate_inbounds parentcols(ind::SubIndex, idx::Bool) =
    throw(ArgumentError("column indexing with Bool is not allowed"))

Base.@propagate_inbounds function parentcols(ind::SubIndex, idx::Symbol)
    parentcol = ind.parent[idx]
    @boundscheck begin
        remap = ind.remap
        if parentcol > length(remap) || remap[parentcol] <= 0
            throw(ArgumentError("$idx not found"))
        end
    end
    return parentcol
end

Base.@propagate_inbounds parentcols(ind::SubIndex, idx::AbstractString) =
    parentcols(ind, Symbol(idx))

Base.@propagate_inbounds parentcols(ind::SubIndex, idx::AbstractVector{Symbol}) =
    [parentcols(ind, i) for i in idx]

Base.@propagate_inbounds parentcols(ind::SubIndex, idx::AbstractVector{<:AbstractString}) =
    [parentcols(ind, i) for i in idx]

Base.@propagate_inbounds parentcols(ind::SubIndex, idx::Regex) =
    [parentcols(ind, i) for i in _names(ind) if occursin(idx, String(i))]

Base.@propagate_inbounds parentcols(ind::SubIndex, idx) =
    parentcols(ind, ind[idx])

Base.@propagate_inbounds parentcols(ind::SubIndex, ::Colon) = ind.cols

function SubIndex(parent::AbstractIndex, cols::AbstractUnitRange{Int})
    l = last(cols)
    f = first(cols)
    if !checkindex(Bool, Base.OneTo(length(parent)), cols)
        throw(BoundsError(parent, cols))
    end
    remap = (1:l) .- f .+ 1
    return SubIndex(parent, cols, remap)
end

function SubIndex(parent::AbstractIndex, cols::AbstractVector{Int})
    ncols = length(parent)
    remap = zeros(Int, ncols)
    for (i, col) in enumerate(cols)
        if !(1 <= col <= ncols)
            throw(BoundsError(parent, cols))
        end
        if remap[col] != 0
            throw(ArgumentError("duplicate selected column detected"))
        end
        remap[col] = i
    end
    return SubIndex(parent, cols, remap)
end

@inline SubIndex(parent::AbstractIndex, cols::ColumnIndex) =
    throw(ArgumentError("cols argument must be a vector (got $cols)"))

Base.@propagate_inbounds SubIndex(parent::AbstractIndex, cols) =
    SubIndex(parent, parent[cols])

Base.length(x::SubIndex) = length(x.cols)
Base.names(x::SubIndex) = string.(_names(x))::Vector{String}
_names(x::SubIndex) = view(_names(x.parent), x.cols)

Base.haskey(::SubIndex, key::Any) =
    throw(ArgumentError("invalid key: $key of type $(typeof(key))"))

function Base.haskey(x::SubIndex, key::Symbol)
    haskey(x.parent, key) || return false
    pos = x.parent[key]
    remap = x.remap
    checkbounds(Bool, remap, pos) || return false
    return remap[pos] > 0
end

Base.haskey(x::SubIndex, key::AbstractString) = haskey(x, Symbol(key))
Base.haskey(x::SubIndex, key::Integer) = 1 <= key <= length(x)
Base.haskey(x::SubIndex, key::Bool) =
    throw(ArgumentError("invalid key: $key of type Bool"))

Base.getindex(x::SubIndex, idx::Symbol) = x.remap[x.parent[idx]]
Base.getindex(x::SubIndex, idx::AbstractString) = x[Symbol(idx)]

function Base.getindex(x::SubIndex, idx::Union{AbstractVector{Symbol},
                                               AbstractVector{AbstractString}})
    allunique(idx) || throw(ArgumentError("Elements of $idx must be unique"))
    return [x[i] for i in idx]
end

rename!(x::SubIndex, nms::AbstractVector{Symbol}; makeunique::Bool=false) =
    throw(ArgumentError("rename! is not supported for views other than created " *
                        "with Colon as a column selector"))

rename!(x::SubIndex, nms::AbstractVector{Pair{Symbol, Symbol}}) =
    throw(ArgumentError("rename! is not supported for views other than created " *
                        "with Colon as a column selector"))

rename!(f::Function, x::SubIndex) =
    throw(ArgumentError("rename! is not supported for views other than created " *
                        "with Colon as a column selector"))

_and() = throw(ArgumentError("at least one condition must be passed"))
_and(x::Bool) = x
_and(x::Bool, y::Bool...) = x && _and(y...)

function _and(x::Any...)
    loc = findfirst(x -> !(x isa Bool), x)
    # we know x has positive length and must contain non-boolean
    @assert !isnothing(loc)
    xv = x[loc]
    if ismissing(xv)
        throw(ArgumentError("missing was returned in condition number $loc " *
                            "but only true or false are allowed; pass " *
                            "skipmissing=true to skip missing values"))
    else
        throw(ArgumentError("value $xv was returned in condition number $loc" *
                            " but only true or false are allowed"))
    end
end

_and_long(x::Bool, y::Bool) = x && y

function _and_long(x, y)
    v = x isa Bool ? y : x
    @assert !(v isa Bool)
    if ismissing(v)
        throw(ArgumentError("missing was returned " *
                            "but only true or false are allowed; pass " *
                            "skipmissing=true to skip missing values"))
    else
        throw(ArgumentError("value $v was returned" *
                            " but only true or false are allowed"))
    end
end

_and_missing() = throw(ArgumentError("at least one condition must be passed"))
_and_missing(x::Bool) = x
_and_missing(x::Bool, y::Union{Bool, Missing}...) = x && _and_missing(y...)
_and_missing(x::Missing, y::Union{Bool, Missing}...) = false

function _and_missing(x::Any...)
    loc = findfirst(x -> !(x isa Union{Bool, Missing}), x)
    # we know x has positive length and must contain non-boolean
    @assert !isnothing(loc)
    xv = x[loc]
    throw(ArgumentError("value $xv was returned in condition number $loc " *
                        "but only true, false, or missing are allowed"))
end

_and_long_missing(x::Bool, y::Bool) = x && y
_and_long_missing(x::Bool, y::Missing) = false
_and_long_missing(x::Missing, y::Union{Bool, Missing}) = false

function _and_long_missing(x, y)
    v = x isa Union{Missing, Bool} ? y : x
    @assert !(v isa Union{Missing, Bool})
    throw(ArgumentError("value $v was returned " *
                        "but only true, false, or missing are allowed"))
end

# we are guaranteed that ByRow returns a vector
# this workaround is needed for 0-argument ByRow
assert_bool_vec(fun::ByRow) = fun

function assert_bool_vec(@nospecialize(fun))
    return function(x...)
        val = fun(x...)
        if !(val isa AbstractVector)
            throw(ArgumentError("function passed to `subset`/`subset!` returned " *
                                "value of type `$(typeof(val))` while it must return " *
                                "an `AbstractVector` when subsetting a data frame " *
                                "to ensure common mistakes in code are caught. Please " *
                                "report an issue if you find this restriction inconvenient."))
        end
        return val
    end
end

function _preprocess_subset_args(df::Union{AbstractDataFrame, GroupedDataFrame},
                                 (args,)::Ref{Any})
    cs_vec = []
    for v in map(x -> broadcast_pair(df isa GroupedDataFrame ? parent(df) : df, x), args)
        if v isa AbstractVecOrMat{<:Pair}
            append!(cs_vec, v)
        elseif v isa MultiColumnIndex
            append!(cs_vec, names(df, v))
        else
            push!(cs_vec, v)
        end
    end

    # subset allows a transformation specification without a target column name or a column
    conditions = Any[if a isa ColumnIndex
                         a => Symbol(:x, i)
                     elseif a isa Pair{<:Any, <:Base.Callable}
                         # we require that vector is returned by the condition only
                         # for AbstractDataFrame
                         if df isa GroupedDataFrame
                             first(a) => last(a) => Symbol(:x, i)
                         else
                             @assert df isa AbstractDataFrame
                             first(a) => assert_bool_vec(last(a)) => Symbol(:x, i)
                         end
                     else
                         throw(ArgumentError("condition specifier $a is not supported by `subset`"))
                     end for (i, a) in enumerate(cs_vec)]
    return conditions
end

function _get_subset_conditions(df::Union{AbstractDataFrame, GroupedDataFrame},
                                (conditions,)::Ref{Any}, skipmissing::Bool, threads::Bool)

    if df isa AbstractDataFrame
        df_conditions = select(df, conditions...,
                               copycols=!(df isa DataFrame), threads=threads)
    else
        df_conditions = select(df, conditions...,
                               copycols=!(parent(df) isa DataFrame), keepkeys=false,
                               threads=threads)
    end

    @assert ncol(df_conditions) == length(conditions)

    cols = eachcol(df_conditions)
    # with many columns, process each column sequentially to avoid large compilation time
    if length(conditions) > 16
        if skipmissing
            cond = _and_long_missing.(cols[1], cols[2])
            for i in 3:length(conditions)
                cond .= _and_long_missing.(cond, cols[i])
            end
        else
            cond = _and_long.(cols[1], cols[2])
            for i in 3:length(conditions)
                cond .= _and_long.(cond, cols[i])
            end
        end
    else
        if skipmissing
            cond = _and_missing.(cols...)
        else
            cond = _and.(cols...)
        end
    end

    # we special case 0-length cond, as in this case broadcasting does not
    # guarantee setting a proper eltype for the result
    if isempty(cond)
        if eltype(cond) !== Bool
            throw(ArgumentError("passed conditions produce $(eltype(cond)) " *
                                "as element type of the result while only " *
                                "Bool is allowed."))
        end
    else
        @assert eltype(cond) === Bool
    end
    return cond
end

"""
    subset(df::AbstractDataFrame, args...;
           skipmissing::Bool=false, view::Bool=false, threads::Bool=true)
    subset(gdf::GroupedDataFrame, args...;
           skipmissing::Bool=false, view::Bool=false,
           ungroup::Bool=true, threads::Bool=true)

Return a copy of data frame `df` or parent of `gdf` containing only rows for
which all values produced by transformation(s) `args` for a given row are
`true`. All transformations must produce vectors containing `true` or `false`.
When the first argument is a `GroupedDataFrame`, transformations are also
allowed to return a single `true` or `false` value, which results in including
or excluding a whole group.

If `skipmissing=false` (the default) `args` are required to produce results
containing only `Bool` values. If `skipmissing=true`, additionally `missing` is
allowed and it is treated as `false` (i.e. rows for which one of the conditions
returns `missing` are skipped).

Each argument passed in `args` can be any specifier following the rules
described for [`select`](@ref) with the restriction that:
* specifying target column name is not allowed as `subset` does not create new
  columns;
* every passed transformation must return a scalar or a vector (returning
  `AbstractDataFrame`, `NamedTuple`, `DataFrameRow` or `AbstractMatrix` is not
  supported).

If `view=true` a `SubDataFrame` view  is returned instead of a `DataFrame`.

If `ungroup=false` the resulting data frame is re-grouped based on the same
grouping columns as `gdf` and a `GroupedDataFrame` is returned (preserving
the order of groups from `gdf`).

If `threads=true` (the default) transformations may be run in separate tasks which
can execute in parallel (possibly being applied to multiple rows or groups at the same time).
Whether or not tasks are actually spawned and their number are determined automatically.
Set to `false` if some transformations require serial execution or are not thread-safe.

If a `GroupedDataFrame` is passed then it must include all groups present in the
`parent` data frame, like in [`select!`](@ref).

!!! note

    Note that as the `subset` function works in exactly the same way as other
    transformation functions defined in DataFrames.jl this is the preferred way to
    subset rows of a data frame or grouped data frame. In particular it uses a
    different set of rules for specifying transformations than [`filter`](@ref)
    which is implemented in DataFrames.jl to ensure support for the
    standard Julia API for collections.

$METADATA_FIXED

See also: [`subset!`](@ref), [`filter`](@ref), [`select`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(id=1:4, x=[true, false, true, false],
                      y=[true, true, false, false],
                      z=[true, true, missing, missing], v=[1, 2, 11, 12])
4×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     1   true   true     true      1
   2 │     2  false   true     true      2
   3 │     3   true  false  missing     11
   4 │     4  false  false  missing     12

julia> subset(df, :x)
2×5 DataFrame
 Row │ id     x     y      z        v
     │ Int64  Bool  Bool   Bool?    Int64
─────┼────────────────────────────────────
   1 │     1  true   true     true      1
   2 │     3  true  false  missing     11

julia> subset(df, :v => x -> x .> 3)
2×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     3   true  false  missing     11
   2 │     4  false  false  missing     12

julia> subset(df, :x, :y => ByRow(!))
1×5 DataFrame
 Row │ id     x     y      z        v
     │ Int64  Bool  Bool   Bool?    Int64
─────┼────────────────────────────────────
   1 │     3  true  false  missing     11

julia> subset(df, :x, :z, skipmissing=true)
1×5 DataFrame
 Row │ id     x     y     z      v
     │ Int64  Bool  Bool  Bool?  Int64
─────┼─────────────────────────────────
   1 │     1  true  true   true      1

julia> subset(df, :x, :z)
ERROR: ArgumentError: missing was returned in condition number 2 but only true or false are allowed; pass skipmissing=true to skip missing values

julia> subset(groupby(df, :y), :v => x -> x .> minimum(x))
2×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     2  false   true     true      2
   2 │     4  false  false  missing     12

julia> subset(groupby(df, :y), :v => x -> minimum(x) > 5)
2×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     3   true  false  missing     11
   2 │     4  false  false  missing     12
```
"""
function subset(df::AbstractDataFrame, @nospecialize(args...);
                skipmissing::Bool=false, view::Bool=false, threads::Bool=true)
    conditions = _preprocess_subset_args(df, Ref{Any}(args))
    if isempty(conditions)
        row_selector = axes(df, 1)
    else
        row_selector = _get_subset_conditions(df, Ref{Any}(conditions),
                                              skipmissing, threads)
    end
    return view ? Base.view(df, row_selector, :) : df[row_selector, :]
end

function subset(gdf::GroupedDataFrame, @nospecialize(args...);
                skipmissing::Bool=false, view::Bool=false,
                ungroup::Bool=true, threads::Bool=true)
    df = parent(gdf)
    conditions = _preprocess_subset_args(gdf, Ref{Any}(args))
    if isempty(conditions)
        if nrow(parent(gdf)) > 0 && minimum(gdf.groups) == 0
            throw(ArgumentError("subset does not support " *
                                "`GroupedDataFrame`s from which some groups have " *
                                "been dropped (including skipmissing=true)"))
        end
        row_selector = axes(df, 1)
    else
        row_selector = _get_subset_conditions(gdf, Ref{Any}(conditions),
                                              skipmissing, threads)
    end
    res = view ? Base.view(df, row_selector, :) : df[row_selector, :]

    ungroup && return res

    ngroups = length(gdf)
    groups = gdf.groups

    newgroups = groups[row_selector]
    @assert length(newgroups) == nrow(res)
    if nrow(res) <= length(groups) # we have removed some rows
        # TODO: add threading support
        seen = fill(false, ngroups)
        @inbounds for gix in newgroups
            @assert gix > 0 # having dropped groups in gdf is not allowed here
            seen[gix] = true
        end

        if sum(seen) < ngroups # subset has dropped some groups
            remap = cumsum(seen)
            @inbounds for i in eachindex(newgroups)
                newgroups[i] = remap[newgroups[i]]
            end
            ngroups = remap[end]
        end
    end

    return GroupedDataFrame(res, groupcols(gdf), newgroups, nothing, nothing, nothing,
                            ngroups, nothing, Threads.ReentrantLock())
end

"""
    subset!(df::AbstractDataFrame, args...;
            skipmissing::Bool=false, threads::Bool=true)
    subset!(gdf::GroupedDataFrame{DataFrame}, args...;
            skipmissing::Bool=false, ungroup::Bool=true, threads::Bool=true)

Update data frame `df` or the parent of `gdf` in place to contain only rows for
which all values produced by transformation(s) `args` for a given row is `true`.
All transformations must produce vectors containing `true` or `false`. When the
first argument is a `GroupedDataFrame`, transformations are also allowed to
return a single `true` or `false` value, which results in including or excluding
a whole group.

If `skipmissing=false` (the default) `args` are required to produce results
containing only `Bool` values. If `skipmissing=true`, additionally `missing` is
allowed and it is treated as `false` (i.e. rows for which one of the conditions
returns `missing` are skipped).

Each argument passed in `args` can be any specifier following the rules
described for [`select`](@ref) with the restriction that:
* specifying target column name is not allowed as `subset!` does not create new
  columns;
* every passed transformation must return a scalar or a vector (returning
  `AbstractDataFrame`, `NamedTuple`, `DataFrameRow` or `AbstractMatrix` is not
  supported).

If `ungroup=false` the passed `GroupedDataFrame` `gdf` is updated (preserving
the order of its groups) and returned.

If `threads=true` (the default) transformations may be run in separate tasks which
can execute in parallel (possibly being applied to multiple rows or groups at the same time).
Whether or not tasks are actually spawned and their number are determined automatically.
Set to `false` if some transformations require serial execution or are not thread-safe.

If `GroupedDataFrame` is subsetted then it must include all groups present in
the `parent` data frame, like in [`select!`](@ref). In this case the passed
`GroupedDataFrame` is updated to have correct groups after its parent is
updated.

!!! note

    Note that as the `subset!` function works in exactly the same way as other
    transformation functions defined in DataFrames.jl this is the preferred way to
    subset rows of a data frame or grouped data frame. In particular it uses a
    different set of rules for specifying transformations than [`filter!`](@ref)
    which is implemented in DataFrames.jl to ensure support for the
    standard Julia API for collections.

$METADATA_FIXED

See also: [`subset`](@ref), [`filter!`](@ref), [`select!`](@ref)

# Examples

```jldoctest
julia> df = DataFrame(id=1:4, x=[true, false, true, false], y=[true, true, false, false])
4×3 DataFrame
 Row │ id     x      y
     │ Int64  Bool   Bool
─────┼─────────────────────
   1 │     1   true   true
   2 │     2  false   true
   3 │     3   true  false
   4 │     4  false  false

julia> subset!(df, :x, :y => ByRow(!));

julia> df
1×3 DataFrame
 Row │ id     x     y
     │ Int64  Bool  Bool
─────┼────────────────────
   1 │     3  true  false

julia> df = DataFrame(id=1:4, y=[true, true, false, false], v=[1, 2, 11, 12]);

julia> subset!(groupby(df, :y), :v => x -> x .> minimum(x));

julia> df
2×3 DataFrame
 Row │ id     y      v
     │ Int64  Bool   Int64
─────┼─────────────────────
   1 │     2   true      2
   2 │     4  false     12

julia> df = DataFrame(id=1:4, x=[true, false, true, false],
                      z=[true, true, missing, missing], v=1:4)
4×4 DataFrame
 Row │ id     x      z        v
     │ Int64  Bool   Bool?    Int64
─────┼──────────────────────────────
   1 │     1   true     true      1
   2 │     2  false     true      2
   3 │     3   true  missing      3
   4 │     4  false  missing      4

julia> subset!(df, :x, :z)
ERROR: ArgumentError: missing was returned in condition number 2 but only true or false are allowed; pass skipmissing=true to skip missing values

julia> subset!(df, :x, :z, skipmissing=true);

julia> df
1×4 DataFrame
 Row │ id     x     z      v
     │ Int64  Bool  Bool?  Int64
─────┼───────────────────────────
   1 │     1  true   true      1

julia> df = DataFrame(id=1:4, x=[true, false, true, false], y=[true, true, false, false],
                      z=[true, true, missing, missing], v=[1, 2, 11, 12]);

julia> subset!(groupby(df, :y), :v => x -> x .> minimum(x));

julia> df
2×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     2  false   true     true      2
   2 │     4  false  false  missing     12

julia> df = DataFrame(id=1:4, x=[true, false, true, false], y=[true, true, false, false],
                      z=[true, true, missing, missing], v=[1, 2, 11, 12]);

julia> subset!(groupby(df, :y), :v => x -> minimum(x) > 5);

julia> df
2×5 DataFrame
 Row │ id     x      y      z        v
     │ Int64  Bool   Bool   Bool?    Int64
─────┼─────────────────────────────────────
   1 │     3   true  false  missing     11
   2 │     4  false  false  missing     12
```
"""
function subset!(df::AbstractDataFrame, @nospecialize(args...);
                skipmissing::Bool=false, threads::Bool=true)
    conditions = _preprocess_subset_args(df, Ref{Any}(args))
    isempty(conditions) && return df
    row_selector = _get_subset_conditions(df, Ref{Any}(conditions), skipmissing, threads)
    return deleteat!(df, .!row_selector)
end

function subset!(gdf::GroupedDataFrame, @nospecialize(args...); skipmissing::Bool=false,
                 ungroup::Bool=true, threads::Bool=true)
    df = parent(gdf)
    conditions = _preprocess_subset_args(gdf, Ref{Any}(args))
    if isempty(conditions)
        if nrow(parent(gdf)) > 0 && minimum(gdf.groups) == 0
            throw(ArgumentError("subset! does not support " *
                                "`GroupedDataFrame`s from which some groups have " *
                                "been dropped (including skipmissing=true)"))
        end
        return ungroup ? df : gdf
    end
    ngroups = length(gdf)
    groups = gdf.groups
    lazy_lock = gdf.lazy_lock
    row_selector = _get_subset_conditions(gdf, Ref{Any}(conditions), skipmissing, threads)
    res = deleteat!(df, .!row_selector)
    if nrow(res) == length(groups) # we have not removed any rows
        return ungroup ? res : gdf
    end
    newgroups = groups[row_selector]

    # TODO: add threading support
    seen = fill(false, ngroups)
    @inbounds for gix in newgroups
        @assert gix > 0 # having dropped groups in gdf is not allowed here
        seen[gix] = true
    end

    if sum(seen) < ngroups # subset! has dropped some groups
        remap = cumsum(seen)
        @inbounds for i in eachindex(newgroups)
            newgroups[i] = remap[newgroups[i]]
        end
        ngroups = remap[end]
    end

    # update GroupedDataFrame indices in a thread safe way
    Base.@lock lazy_lock begin
        gdf.groups = newgroups
        gdf.idx = nothing
        gdf.starts = nothing
        gdf.ends = nothing
        gdf.ngroups = ngroups
        gdf.keymap = nothing
    end
    return ungroup ? res : gdf
end

module TestConversions

using Test, DataFrames
using DataStructures: OrderedDict, SortedDict
const ≅ = isequal

@testset "Constructors to Base types" begin
    df = DataFrame()
    @test Matrix(df) isa Matrix{Union{}}
    @test size(Matrix(df)) == (0, 0)
    df[!, :A] = 1:5
    df[!, :B] = 1.0:5.0
    @test isa(Matrix(df), Matrix{Float64})
    @test isa(Matrix{Any}(df), Matrix{Any})
    @test isa(Matrix{Float64}(df), Matrix{Float64})
    @test isa(Array(df), Matrix{Float64})
    @test isa(Array{Any}(df), Matrix{Any})
    @test isa(Array{Float64}(df), Matrix{Float64})

    df = DataFrame()
    df.A = Vector{Union{Float64, Missing}}(1.0:5.0)
    df.B = Vector{Union{Float64, Missing}}(1.0:5.0)
    @test [df.A df.B] == Matrix(df)
    @test Matrix(df) isa Matrix{Union{Float64, Missing}}
    @test [df.A df.B] == Matrix{Any}(df)
    @test Matrix{Any}(df) isa Matrix{Any}
    @test [df.A df.B] == Matrix(df)
    @test Matrix{Int}(df) isa Matrix{Int}

    df[1, 1] = missing
    @test_throws ArgumentError Matrix{Float64}(df)
    na = Matrix{Union{Float64, Missing}}(df)
    naa = Matrix{Any}(df)
    nai = Matrix{Union{Int, Missing}}(df)
    @test isa(na, Matrix{Union{Float64, Missing}})
    @test isa(naa, Matrix{Union{Any, Missing}})
    @test isa(nai, Matrix{Union{Int, Missing}})
    @test na ≅ [df.A df.B]
    @test naa ≅ [df.A df.B]
    @test nai ≅ [df.A df.B]

    df = DataFrame()
    df.A = Vector{Union{Float64, Missing}}(1.0:5.0)
    df.B = Vector{Union{Float64, Missing}}(1.0:5.0)
    @test [df.A df.B] == Array(df)
    @test Array(df) isa Matrix{Union{Float64, Missing}}
    @test [df.A df.B] == Array{Any}(df)
    @test Array{Any}(df) isa Matrix{Any}
    @test [df.A df.B] == Array(df)
    @test Array{Int}(df) isa Matrix{Int}

    df[1, 1] = missing
    @test_throws ArgumentError Array{Float64}(df)
    na = Array{Union{Float64, Missing}}(df)
    naa = Array{Any}(df)
    nai = Array{Union{Int, Missing}}(df)
    @test isa(na, Matrix{Union{Float64, Missing}})
    @test isa(naa, Matrix{Union{Any, Missing}})
    @test isa(nai, Matrix{Union{Int, Missing}})
    @test na ≅ [df.A df.B]
    @test naa ≅ [df.A df.B]
    @test nai ≅ [df.A df.B]


    a = Union{Float64, Missing}[1.0, 2.0]
    b = Union{Float64, Missing}[-0.1, 3]
    c = Union{Float64, Missing}[-3.1, 7]
    di = Dict("a"=>a, "b"=>b, "c"=>c)

    df = DataFrame(di)
    @test isa(df, DataFrame)
    @test names(df) == [x for x in sort(collect(keys(di)))]
    @test df[!, :a] == a
    @test df[!, :b] == b
    @test df[!, :c] == c

    od = OrderedDict("c"=>c, "a"=>a, "b"=>b)
    df = DataFrame(od)
    @test isa(df, DataFrame)
    @test names(df) == [x for x in keys(od)]
    @test df[!, :a] == a
    @test df[!, :b] == b
    @test df[!, :c] == c

    sd = SortedDict("c"=>c, "a"=>a, "b"=>b)
    df = DataFrame(sd)
    @test isa(df, DataFrame)
    @test names(df) == [x for x in keys(sd)]
    @test df[!, :a] == a
    @test df[!, :b] == b
    @test df[!, :c] == c

    a = [1.0]
    di = Dict("a"=>a, "b"=>b, "c"=>c)
    @test_throws DimensionMismatch DataFrame(di)
end

@testset "conversion tests" begin
    df = DataFrame(a=1:3, b=4:6, c=7:9)
    dfv = @view df[2:3, 2:3]
    @test convert(DataFrame, dfv) == df[2:3, 2:3]
    @test convert(DataFrame, dfv) isa DataFrame
    @test DataFrame(dfv) == df[2:3, 2:3]
    @test DataFrame(dfv) isa DataFrame

    dfr = df[2, 2:3]
    @test convert(NamedTuple, dfr) == (b=5, c=8)
    @test convert(NamedTuple, dfr) isa NamedTuple
    @test NamedTuple(dfr) == (b=5, c=8)
    @test NamedTuple(dfr) isa NamedTuple

    gdf = groupby(df, [:b, :c])
    gk = keys(gdf)[2]
    @test convert(NamedTuple, gk) == (b=5, c=8)
    @test convert(NamedTuple, gk) isa NamedTuple
    @test NamedTuple(gk) == (b=5, c=8)
    @test NamedTuple(gk) isa NamedTuple
end

end # module

"""
    leftjoin!(df1, df2; on, makeunique=false, source=nothing,
              matchmissing=:error)


Perform a left join of two data frame objects by updating the `df1` with the
joined columns from `df2`.

A left join includes all rows from `df1` and leaves all rows and columns from `df1`
untouched. Note that each row in `df1` must have at most one match in `df2`. Otherwise,
this function would not be able to execute the join in-place since new rows would need to be
added to `df1`.

# Arguments
- `df1`, `df2`: the `AbstractDataFrames` to be joined

# Keyword Arguments
- `on` : The names of the key columns on which to join the data frames.
  This can be a single name, or a vector of names (for joining on multiple
  columns). A `left=>right` pair of names can be used instead of a name, for
  the case where a key has different names in `df1` and `df2` (it is allowed to
  mix names and name pairs in a vector). Key values are compared using
  `isequal`. `on` is a required argument.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found in columns not joined on;
  if `true`, duplicate names will be suffixed with `_i`
  (`i` starting at 1 for the first duplicate).
- `source` : Default: `nothing`. If a `Symbol` or string, adds indicator
  column with the given name, for whether a row appeared in only `df1` (`"left_only"`)
  or in both (`"both"`). If the name is already in use,
  the column name will be modified if `makeunique=true`.
- `matchmissing` : if equal to `:error` throw an error if `missing` is present
  in `on` columns; if equal to `:equal` then `missing` is allowed and missings are
  matched; if equal to `:notequal` then missings are dropped in `df2` `on` columns.

The columns added to `df1` from `df2` will support missing values.

It is not allowed to join on columns that contain `NaN` or `-0.0` in real or
imaginary part of the number. If you need to perform a join on such values use
CategoricalArrays.jl and transform a column containing such values into a
`CategoricalVector`.

Metadata: table-level and column-level `:note`-style metadata are taken from
`df1` (including key columns), except for columns added to it from `df2`,
whose column-level `:note`-style metadata is taken from `df2`.

See also: [`leftjoin`](@ref).

# Examples
```jldoctest
julia> name = DataFrame(ID=[1, 2, 3], Name=["John Doe", "Jane Doe", "Joe Blogs"])
3×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼──────────────────
   1 │     1  John Doe
   2 │     2  Jane Doe
   3 │     3  Joe Blogs

julia> job = DataFrame(ID=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │     1  Lawyer
   2 │     2  Doctor
   3 │     4  Farmer

julia> leftjoin!(name, job, on = :ID)
3×3 DataFrame
 Row │ ID     Name       Job
     │ Int64  String     String?
─────┼───────────────────────────
   1 │     1  John Doe   Lawyer
   2 │     2  Jane Doe   Doctor
   3 │     3  Joe Blogs  missing

julia> job2 = DataFrame(identifier=[1, 2, 4], Job=["Lawyer", "Doctor", "Farmer"])
3×2 DataFrame
 Row │ identifier  Job
     │ Int64       String
─────┼────────────────────
   1 │          1  Lawyer
   2 │          2  Doctor
   3 │          4  Farmer

julia> leftjoin!(name, job2, on = :ID => :identifier, makeunique=true, source=:source)
3×5 DataFrame
 Row │ ID     Name       Job      Job_1    source
     │ Int64  String     String?  String?  String
─────┼───────────────────────────────────────────────
   1 │     1  John Doe   Lawyer   Lawyer   both
   2 │     2  Jane Doe   Doctor   Doctor   both
   3 │     3  Joe Blogs  missing  missing  left_only
```
"""
function leftjoin!(df1::AbstractDataFrame, df2::AbstractDataFrame;
                   on::Union{<:OnType, AbstractVector}=Symbol[], makeunique::Bool=false,
                   source::Union{Nothing, Symbol, AbstractString}=nothing,
                   matchmissing::Symbol=:error)

    _check_consistency(df1)
    _check_consistency(df2)

    if !is_column_insertion_allowed(df1)
        throw(ArgumentError("leftjoin! is only supported if `df1` is a `DataFrame`, " *
                            "or a SubDataFrame created with `:` as column selector"))
    end

    if on == []
        throw(ArgumentError("Missing join argument 'on'."))
    end

    joiner = DataFrameJoiner(df1, df2, on, matchmissing, :left)

    right_noon_names = names(joiner.dfr, Not(joiner.right_on))
    if !(makeunique || isempty(intersect(right_noon_names, names(df1))))
        throw(ArgumentError("the following columns are present in both " *
                            "left and right data frames but not listed in `on`: " *
                            join(intersect(right_noon_names, names(df1)), ", ") *
                            ". Pass makeunique=true to add a suffix automatically to " *
                            "columns names from the right data frame."))
    end

    left_ixs_inner, right_ixs_inner = find_inner_rows(joiner)

    right_ixs = _map_leftjoin_ixs(nrow(df1), left_ixs_inner, right_ixs_inner)

    # need to call parent as df1 can be a SubDataFrame
    _drop_all_nonnote_metadata!(parent(df1))
    # TODO: consider adding threading support in the future
    for colname in right_noon_names
        rcol = joiner.dfr[!, colname] # note that joiner.dfr does not have to be df2
        rcol_joined = compose_joined_rcol!(rcol, similar_missing(rcol, nrow(df1)),
                                          right_ixs)
        # if df1 isa SubDataFrame we must copy columns
        insertcols!(df1, colname => rcol_joined, makeunique=makeunique,
                    copycols=!(df1 isa DataFrame))
        # need to call parent as df1 can be a SubDataFrame
        _copy_col_note_metadata!(parent(df1), ncol(df1), joiner.dfr, colname)
    end

    if source !== nothing
        pool = ["left_only", "right_only", "both"]
        invpool = Dict{String, UInt32}("left_only" => 1,
                                       "right_only" => 2,
                                       "both" => 3)
        indicatorcol = PooledArray(PooledArrays.RefArray(UInt32.(2 .* (right_ixs .> 0) .+ 1)),
                                   invpool, pool)

        unique_indicator = source
        if makeunique
            try_idx = 0
            while hasproperty(df1, unique_indicator)
                try_idx += 1
                unique_indicator = Symbol(source, "_", try_idx)
            end
        end

        if hasproperty(df1, unique_indicator)
            throw(ArgumentError("joined data frame already has column " *
                                ":$unique_indicator. Pass makeunique=true to " *
                                "make it unique using a suffix automatically."))
        end
        df1[!, unique_indicator] = indicatorcol
    end

    return df1
end

function _map_leftjoin_ixs(out_len::Int,
                           left_ixs_inner::Vector{Int},
                           right_ixs_inner::Vector{Int})
    right_ixs = zeros(Int, out_len)
    @inbounds for (li, ri) in zip(left_ixs_inner, right_ixs_inner)
        if right_ixs[li] > 0
            throw(ArgumentError("duplicate rows found in right table"))
        end
        right_ixs[li] = ri
    end
    return right_ixs
end

function compose_joined_rcol!(rcol::AbstractVector,
                              rcol_joined::AbstractVector,
                              right_ixs::Vector{Int})
    @assert length(rcol_joined) == length(right_ixs)
    @inbounds for (i, idx) in enumerate(right_ixs)
        if idx > 0
            rcol_joined[i] = rcol[idx]
        end
    end
    return rcol_joined
end

using CategoricalArrays
using DataFrames
using PooledArrays
using Random

fullgc() = (GC.gc(true); GC.gc(true); GC.gc(true); GC.gc(true))


function run_bench(llen, rlen, arr_type, dup_mode, sort_mode, num_keys, join_type)


    @assert llen > 1000
    @assert rlen > 2000

    @assert arr_type in ["int", "pool", "cat", "str"]
    @assert dup_mode in ["uniq", "dup", "manydup"]
    @assert sort_mode in ["sort", "rand"]
    @assert num_keys in ["1", "2"]
    @assert join_type in ["inner", "left", "right", "outer", "semi", "anti"]

    pad = maximum(length.(string.((llen, rlen))))

    if arr_type == "int"
        if dup_mode == "uniq"
            col1 = [1:llen;]
            col2 = [1:rlen;]
        elseif dup_mode == "dup"
            col1 = repeat(1:llen ÷ 2, inner=2)
            col2 = repeat(1:rlen ÷ 2, inner=2)
        else
            @assert dup_mode == "manydup"
            col1 = repeat(1:llen ÷ 20, inner=20)
            col2 = repeat(1:rlen ÷ 20, inner=20)
        end
    elseif arr_type == "pool"
        if dup_mode == "dup"
            col1 = PooledArray(repeat(string.(1:llen ÷ 2, pad=pad), inner=2))
            col2 = PooledArray(repeat(string.(1:rlen ÷ 2, pad=pad), inner=2))
        else
            @assert dup_mode == "manydup"
            col1 = PooledArray(repeat(string.(1:llen ÷ 20, pad=pad), inner=20))
            col2 = PooledArray(repeat(string.(1:rlen ÷ 20, pad=pad), inner=20))
        end
    elseif arr_type == "cat"
        if dup_mode == "dup"
            col1 = categorical(repeat(string.(1:llen ÷ 2, pad=pad), inner=2))
            col2 = categorical(repeat(string.(1:rlen ÷ 2, pad=pad), inner=2))
        else
            @assert dup_mode == "manydup"
            col1 = categorical(repeat(string.(1:llen ÷ 20, pad=pad), inner=20))
            col2 = categorical(repeat(string.(1:rlen ÷ 20, pad=pad), inner=20))
        end
    else
        @assert arr_type == "str"
        if dup_mode == "uniq"
            col1 = string.(1:llen, pad=pad)
            col2 = string.(1:rlen, pad=pad)
        elseif dup_mode == "dup"
            col1 = repeat(string.(1:llen ÷ 2, pad=pad), inner=2)
            col2 = repeat(string.(1:rlen ÷ 2, pad=pad), inner=2)
        else
            @assert dup_mode == "manydup"
            col1 = repeat(string.(1:llen ÷ 20, pad=pad), inner=20)
            col2 = repeat(string.(1:rlen ÷ 20, pad=pad), inner=20)
        end
    end

    Random.seed!(1234)

    if sort_mode == "rand"
        shuffle!(col1)
        shuffle!(col2)
    else
        @assert sort_mode == "sort"
    end

    joinfun = Dict("inner" => innerjoin, "left" => leftjoin,
                    "right" => rightjoin, "outer" => outerjoin,
                    "semi" => semijoin, "anti" => antijoin)[join_type]

    if num_keys == "1"
        df1 = DataFrame(id1=col1)
        df2 = DataFrame(id1=col2)
        joinfun(df1[1:1000, :], df2[1:2000, :], on=:id1)
        joinfun(df2[1:2000, :], df1[1:1000, :], on=:id1)
        fullgc()
        t1 = @elapsed joinfun(df1, df2, on=:id1)
        fullgc()
        t2 = @elapsed joinfun(df2, df1, on=:id1)
    else
        @assert num_keys == "2"
        df1 = DataFrame(id1=col1, id2=col1)
        df2 = DataFrame(id1=col2, id2=col2)
        joinfun(df1[1:1000, :], df2[1:2000, :], on=[:id1, :id2])
        joinfun(df2[1:2000, :], df1[1:1000, :], on=[:id1, :id2])
        fullgc()
        t1 = @elapsed joinfun(df1, df2, on=[:id1, :id2])
        fullgc()
        t2 = @elapsed joinfun(df2, df1, on=[:id1, :id2])
    end

    return (t1 + t2) / 2.0
end


if abspath(PROGRAM_FILE) == @__FILE__
    @info "$ARGS"

    llen = parse(Int, ARGS[1])
    rlen = parse(Int, ARGS[2])
    t = run_bench(llen, rlen, ARGS[3], ARGS[4], ARGS[5], ARGS[6], ARGS[7])
    @info("Timing: $t sec")
end

##############################################################################
##
## Iteration: eachrow, eachcol
##
##############################################################################

# Iteration by rows
"""
    DataFrameRows{D<:AbstractDataFrame} <: AbstractVector{DataFrameRow}

Iterator over rows of an `AbstractDataFrame`,
with each row represented as a `DataFrameRow`.

A value of this type is returned by the [`eachrow`](@ref) function.
"""
struct DataFrameRows{D<:AbstractDataFrame} <: AbstractVector{DataFrameRow}
    df::D
end

Base.summary(dfrs::DataFrameRows) = "$(length(dfrs))-element DataFrameRows"
Base.summary(io::IO, dfrs::DataFrameRows) = print(io, summary(dfrs))

Base.iterate(::AbstractDataFrame) =
    error("AbstractDataFrame is not iterable. Use eachrow(df) to get a row iterator " *
          "or eachcol(df) to get a column iterator")

"""
    eachrow(df::AbstractDataFrame)

Return a `DataFrameRows` that iterates a data frame row by row,
with each row represented as a `DataFrameRow`.

Because `DataFrameRow`s have an `eltype` of `Any`, use `copy(dfr::DataFrameRow)` to obtain
a named tuple, which supports iteration and property access like a `DataFrameRow`,
but also passes information on the `eltypes` of the columns of `df`.

# Examples
```jldoctest
julia> df = DataFrame(x=1:4, y=11:14)
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> eachrow(df)
4×2 DataFrameRows
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> copy.(eachrow(df))
4-element Vector{@NamedTuple{x::Int64, y::Int64}}:
 (x = 1, y = 11)
 (x = 2, y = 12)
 (x = 3, y = 13)
 (x = 4, y = 14)

julia> eachrow(view(df, [4, 3], [2, 1]))
2×2 DataFrameRows
 Row │ y      x
     │ Int64  Int64
─────┼──────────────
   1 │    14      4
   2 │    13      3
```
"""
Base.eachrow(df::AbstractDataFrame) = DataFrameRows(df)

nrow(itr::DataFrameRows) = nrow(parent(itr))
ncol(itr::DataFrameRows) = ncol(parent(itr))

Base.IndexStyle(::Type{<:DataFrameRows}) = Base.IndexLinear()
Base.size(itr::DataFrameRows) = (size(parent(itr), 1), )

Base.@propagate_inbounds Base.getindex(itr::DataFrameRows, i::Int) = parent(itr)[i, :]
Base.@propagate_inbounds Base.getindex(itr::DataFrameRows, i::CartesianIndex{1}) = itr[i[1]]
Base.@propagate_inbounds Base.getindex(itr::DataFrameRows, idx) =
    eachrow(@view parent(itr)[idx isa AbstractVector && !(eltype(idx) <: Bool) ? copy(idx) : idx, :])

# separate methods are needed due to dispatch ambiguity
Base.getproperty(itr::DataFrameRows, col_ind::Symbol) =
    getproperty(parent(itr), col_ind)
Base.getproperty(itr::DataFrameRows, col_ind::AbstractString) =
    getproperty(parent(itr), col_ind)
Compat.hasproperty(itr::DataFrameRows, s::Symbol) = haskey(index(parent(itr)), s)
Compat.hasproperty(itr::DataFrameRows, s::AbstractString) = haskey(index(parent(itr)), s)

# Private fields are never exposed since they can conflict with column names
Base.propertynames(itr::DataFrameRows, private::Bool=false) = propertynames(parent(itr))

"""
    Iterators.partition(dfr::DataFrameRows, n::Integer)

Iterate over `DataFrameRows` `dfr` `n` rows at a time, returning each block
as a `DataFrameRows` over a view of rows of parent of `dfr`.

# Examples

```jldoctest
julia> collect(Iterators.partition(eachrow(DataFrame(x=1:5)), 2))
3-element Vector{DataFrames.DataFrameRows{SubDataFrame{DataFrame, DataFrames.Index, UnitRange{Int64}}}}:
 2×1 DataFrameRows
 Row │ x
     │ Int64
─────┼───────
   1 │     1
   2 │     2
 2×1 DataFrameRows
 Row │ x
     │ Int64
─────┼───────
   1 │     3
   2 │     4
 1×1 DataFrameRows
 Row │ x
     │ Int64
─────┼───────
   1 │     5
```
"""
function Iterators.partition(dfr::DataFrameRows, n::Integer)
    n < 1 && throw(ArgumentError("cannot create partitions of length $n"))
    return Iterators.PartitionIterator(dfr, Int(n))
end

# use autodetection of eltype
Base.IteratorEltype(::Type{<:Iterators.PartitionIterator{<:DataFrameRows}}) =
    Base.EltypeUnknown()

# we do not need to be overly specific here as we rely on autodetection of eltype
# this method is needed only to override the fallback for `PartitionIterator`
Base.eltype(::Type{<:Iterators.PartitionIterator{<:DataFrameRows}}) =
    DataFrameRows

Base.IteratorSize(::Type{<:Iterators.PartitionIterator{<:DataFrameRows}}) =
    Base.HasLength()

function Base.length(itr::Iterators.PartitionIterator{<:DataFrameRows})
    l = nrow(parent(itr.c))
    return cld(l, itr.n)
end

function Base.iterate(itr::Iterators.PartitionIterator{<:DataFrameRows}, state::Int=1)
    df = parent(itr.c)
    last_idx = nrow(df)
    state > last_idx && return nothing
    r = min(state + itr.n - 1, last_idx)
    return eachrow(view(df, state:r, :)), r + 1
end

# Iteration by columns

const DATAFRAMECOLUMNS_DOCSTR = """
Indexing into `DataFrameColumns` objects using integer, `Symbol` or string
returns the corresponding column (without copying).
Indexing into `DataFrameColumns` objects using a multiple column selector
returns a subsetted `DataFrameColumns` object with a new parent containing
only the selected columns (without copying).

`DataFrameColumns` supports most of the `AbstractVector` API. The key
differences are that it is read-only and that the `keys` function returns a
vector of `Symbol`s (and not integers as for normal vectors).

In particular `findnext`, `findprev`, `findfirst`, `findlast`, and `findall`
functions are supported, and in `findnext` and `findprev` functions it is allowed
to pass an integer, string, or `Symbol` as a reference index.
"""

"""
    DataFrameColumns{<:AbstractDataFrame}

A vector-like object that allows iteration over columns of an `AbstractDataFrame`.

$DATAFRAMECOLUMNS_DOCSTR
"""
struct DataFrameColumns{T<:AbstractDataFrame}
    df::T
end

Base.summary(dfcs::DataFrameColumns)= "$(length(dfcs))-element DataFrameColumns"
Base.summary(io::IO, dfcs::DataFrameColumns) = print(io, summary(dfcs))

"""
    eachcol(df::AbstractDataFrame)

Return a `DataFrameColumns` object that is a vector-like that allows iterating
an `AbstractDataFrame` column by column.

$DATAFRAMECOLUMNS_DOCSTR

# Examples
```jldoctest
julia> df = DataFrame(x=1:4, y=11:14)
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> eachcol(df)
4×2 DataFrameColumns
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> collect(eachcol(df))
2-element Vector{AbstractVector}:
 [1, 2, 3, 4]
 [11, 12, 13, 14]

julia> map(eachcol(df)) do col
           maximum(col) - minimum(col)
       end
2-element Vector{Int64}:
 3
 3

julia> sum.(eachcol(df))
2-element Vector{Int64}:
 10
 50
```
"""
Base.eachcol(df::AbstractDataFrame) = DataFrameColumns(df)

nrow(itr::DataFrameColumns) = nrow(parent(itr))
ncol(itr::DataFrameColumns) = ncol(parent(itr))

Base.IteratorSize(::Type{<:DataFrameColumns}) = Base.HasShape{1}()
Base.size(itr::DataFrameColumns) = (size(parent(itr), 2),)

function Base.size(itr::DataFrameColumns, d::Integer)
    d != 1 && throw(ArgumentError("dimension out of range"))
    return size(itr)[1]
end

Base.ndims(::DataFrameColumns) = 1
Base.ndims(::Type{<:DataFrameColumns}) = 1

Base.length(itr::DataFrameColumns) = size(itr)[1]
Base.eltype(::Type{<:DataFrameColumns}) = AbstractVector

Base.firstindex(itr::DataFrameColumns) = 1
Base.lastindex(itr::DataFrameColumns) = length(itr)

Base.axes(itr::DataFrameColumns, i::Integer) = Base.OneTo(size(itr, i))

Base.iterate(itr::DataFrameColumns, i::Integer=1) =
    i <= length(itr) ? (itr[i], i + 1) : nothing
Base.@propagate_inbounds Base.getindex(itr::DataFrameColumns, idx::ColumnIndex) =
    parent(itr)[!, idx]
Base.@propagate_inbounds Base.getindex(itr::DataFrameColumns, idx::CartesianIndex{1}) =
    itr[idx[1]]
Base.@propagate_inbounds Base.getindex(itr::DataFrameColumns, idx::MultiColumnIndex) =
    eachcol(parent(itr)[!, idx])
Base.:(==)(itr1::DataFrameColumns, itr2::DataFrameColumns) =
    parent(itr1) == parent(itr2)
Base.isequal(itr1::DataFrameColumns, itr2::DataFrameColumns) =
    isequal(parent(itr1), parent(itr2))

# separate methods are needed due to dispatch ambiguity
Base.getproperty(itr::DataFrameColumns, col_ind::Symbol) =
    getproperty(parent(itr), col_ind)
Base.getproperty(itr::DataFrameColumns, col_ind::AbstractString) =
    getproperty(parent(itr), col_ind)
Compat.hasproperty(itr::DataFrameColumns, s::Symbol) =
    haskey(index(parent(itr)), s)
Compat.hasproperty(itr::DataFrameColumns, s::AbstractString) =
    haskey(index(parent(itr)), s)

# Private fields are never exposed since they can conflict with column names
Base.propertynames(itr::DataFrameColumns, private::Bool=false) =
    propertynames(parent(itr))

"""
    keys(dfc::DataFrameColumns)

Get a vector of column names of `dfc` as `Symbol`s.
"""
Base.keys(itr::DataFrameColumns) = propertynames(itr)

"""
    values(dfc::DataFrameColumns)

Get a vector of columns from `dfc`.
"""
Base.values(itr::DataFrameColumns) = collect(itr)

"""
    pairs(dfc::DataFrameColumns)

Return an iterator of pairs associating the name of each column of `dfc`
with the corresponding column vector, i.e. `name => col`
where `name` is the column name of the column `col`.
"""
Base.pairs(itr::DataFrameColumns) = Base.Iterators.Pairs(itr, keys(itr))

Base.haskey(itr::DataFrameColumns, col::Union{AbstractString, Symbol}) =
    columnindex(parent(itr), col) > 0
Base.haskey(itr::DataFrameColumns, col::Union{Signed, Unsigned}) =
    0 < col <= ncol(parent(itr))
Base.get(itr::DataFrameColumns, col::ColumnIndex, default) =
    haskey(itr, col) ? itr[col] : default

Base.findnext(f::Function, itr::DataFrameColumns, i::Integer) =
    findnext(f, values(itr), i)
Base.findnext(f::Function, itr::DataFrameColumns, i::Union{Symbol, AbstractString}) =
    findnext(f, values(itr), index(parent(itr))[i])
Base.findprev(f::Function, itr::DataFrameColumns, i::Integer) =
    findprev(f, values(itr), i)
Base.findprev(f::Function, itr::DataFrameColumns, i::Union{Symbol, AbstractString}) =
    findprev(f, values(itr), index(parent(itr))[i])
Base.findfirst(f::Function, itr::DataFrameColumns) =
    findfirst(f, values(itr))
Base.findlast(f::Function, itr::DataFrameColumns) =
    findlast(f, values(itr))
Base.findall(f::Function, itr::DataFrameColumns) =
    findall(f, values(itr))

Base.parent(itr::Union{DataFrameRows, DataFrameColumns}) = getfield(itr, :df)
Base.names(itr::Union{DataFrameRows, DataFrameColumns}) = names(parent(itr))
Base.names(itr::Union{DataFrameRows, DataFrameColumns}, cols) = names(parent(itr), cols)

function Base.show(io::IO, dfrs::DataFrameRows;
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   eltypes::Bool = true,
                   truncate::Int = 32,
                   kwargs...)
    df = parent(dfrs)
    title = summary ? "$(nrow(df))×$(ncol(df)) DataFrameRows" : ""
    _show(io, df; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
          summary=false, eltypes=eltypes, truncate=truncate, title=title,
          kwargs...)
end

Base.show(io::IO, mime::MIME"text/plain", dfrs::DataFrameRows;
          allrows::Bool = !get(io, :limit, false),
          allcols::Bool = !get(io, :limit, false),
          rowlabel::Symbol = :Row,
          summary::Bool = true,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(io, dfrs; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
         summary=summary, eltypes=eltypes, truncate=truncate, kwargs...)

Base.show(dfrs::DataFrameRows;
          allrows::Bool = !get(stdout, :limit, true),
          allcols::Bool = !get(stdout, :limit, true),
          rowlabel::Symbol = :Row,
          summary::Bool = true,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(stdout, dfrs; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
         summary=summary, eltypes=eltypes, truncate=truncate, kwargs...)

function Base.show(io::IO, dfcs::DataFrameColumns;
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   eltypes::Bool = true,
                   truncate::Int = 32,
                   kwargs...)
    df = parent(dfcs)
    title = summary ? "$(nrow(df))×$(ncol(df)) DataFrameColumns" : ""
    _show(io, parent(dfcs); allrows=allrows, allcols=allcols, rowlabel=rowlabel,
          summary=false, eltypes=eltypes, truncate=truncate, title=title,
          kwargs...)
end

Base.show(io::IO, mime::MIME"text/plain", dfcs::DataFrameColumns;
          allrows::Bool = !get(io, :limit, false),
          allcols::Bool = !get(io, :limit, false),
          rowlabel::Symbol = :Row,
          summary::Bool = true,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(io, dfcs; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
         summary=summary, eltypes=eltypes, truncate=truncate, kwargs...)

Base.show(dfcs::DataFrameColumns;
          allrows::Bool = !get(stdout, :limit, true),
          allcols::Bool = !get(stdout, :limit, true),
          rowlabel::Symbol = :Row,
          summary::Bool = true,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(stdout, dfcs; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
         summary=summary, eltypes=eltypes, truncate=truncate, kwargs...)

"""
    mapcols(f::Union{Function, Type}, df::AbstractDataFrame; cols=All())

Return a `DataFrame` where each column of `df` selected by `cols` (by default, all columns)
is transformed using function `f`.
Columns not selected by `cols` are copied.

`f` must return `AbstractVector` objects all with the same length or scalars
(all values other than `AbstractVector` are considered to be a scalar).

The `cols` column selector can be any value accepted as column selector by the `names` function.

Note that `mapcols` guarantees not to reuse the columns from `df` in the returned
`DataFrame`. If `f` returns its argument then it gets copied before being stored.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(x=1:4, y=11:14)
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> mapcols(x -> x.^2, df)
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1    121
   2 │     4    144
   3 │     9    169
   4 │    16    196

julia> mapcols(x -> x.^2, df, cols=r"y")
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1    121
   2 │     2    144
   3 │     3    169
   4 │     4    196
```
"""
function mapcols(f::Union{Function, Type}, df::AbstractDataFrame; cols=All())
    if cols === All() || cols === Colon()
        apply = Iterators.repeated(true)
    else
        picked = Set(names(df, cols))
        apply = Bool[name in picked for name in names(df)]
    end

    # note: `f` must return a consistent length
    vs = AbstractVector[]
    seenscalar = false
    seenvector = false
    for (v, doapply) in zip(eachcol(df), apply)
        fv = doapply ? f(v) : copy(v)
        if fv isa AbstractVector
            if seenscalar
                throw(ArgumentError("mixing scalars and vectors in mapcols not allowed"))
            end
            seenvector = true
            push!(vs, fv === v ? copy(fv) : fv)
        else
            if seenvector
                throw(ArgumentError("mixing scalars and vectors in mapcols not allowed"))
            end
            seenscalar = true
            push!(vs, [fv])
        end
    end

    new_df = DataFrame(vs, _names(df), copycols=false)
    _copy_all_note_metadata!(new_df, df)
    return new_df
end

"""
    mapcols!(f::Union{Function, Type}, df::DataFrame; cols=All())

Update a `DataFrame` in-place where each column of `df` selected by `cols` (by default, all columns)
is transformed using function `f`.
Columns not selected by `cols` are left unchanged.

`f` must return `AbstractVector` objects all with the same length or scalars
(all values other than `AbstractVector` are considered to be a scalar).

Note that `mapcols!` reuses the columns from `df` if they are returned by `f`.

$METADATA_FIXED

# Examples
```jldoctest
julia> df = DataFrame(x=1:4, y=11:14)
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1     11
   2 │     2     12
   3 │     3     13
   4 │     4     14

julia> mapcols!(x -> x.^2, df);

julia> df
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1    121
   2 │     4    144
   3 │     9    169
   4 │    16    196

julia> mapcols!(x -> 2 * x, df, cols=r"x");

julia> df
4×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     2    121
   2 │     8    144
   3 │    18    169
   4 │    32    196
```
"""
function mapcols!(f::Union{Function,Type}, df::DataFrame; cols=All())
    if ncol(df) == 0 # skip if no columns
        _drop_all_nonnote_metadata!(df)
        return df
    end

    if cols === All() || cols === Colon()
        apply = Iterators.repeated(true)
    else
        picked = Set(names(df, cols))
        apply = Bool[name in picked for name in names(df)]
    end

    # note: `f` must return a consistent length
    vs = AbstractVector[]
    seenscalar = false
    seenvector = false
    for (v, doapply) in zip(eachcol(df), apply)
        fv = doapply ? f(v) : v
        if fv isa AbstractVector
            if seenscalar
                throw(ArgumentError("mixing scalars and vectors in mapcols not allowed"))
            end
            seenvector = true
            push!(vs, fv isa AbstractRange ? collect(fv) : fv)
        else
            if seenvector
                throw(ArgumentError("mixing scalars and vectors in mapcols not allowed"))
            end
            seenscalar = true
            push!(vs, [fv])
        end
    end

    len_min, len_max = extrema(length(v) for v in vs)
    if len_min != len_max
        throw(DimensionMismatch("lengths of returned vectors must be identical"))
    end

    for (i, col) in enumerate(vs)
        firstindex(col) != 1 && _onebased_check_error(i, col)
    end

    @assert length(vs) == ncol(df)
    raw_columns = _columns(df)
    for i in 1:ncol(df)
        raw_columns[i] = vs[i]
    end

    _drop_all_nonnote_metadata!(df)
    return df
end

##############################################################################
##
## Reduction
##
##############################################################################

"""
    reduce(::typeof(vcat),
           dfs::Union{AbstractVector{<:AbstractDataFrame},
                      Tuple{AbstractDataFrame, Vararg{AbstractDataFrame}}};
           cols::Union{Symbol, AbstractVector{Symbol},
                       AbstractVector{<:AbstractString}}=:setequal,
           source::Union{Nothing, Symbol, AbstractString,
                         Pair{<:Union{Symbol, AbstractString}, <:AbstractVector}}=nothing,
           init::AbstractDataFrame=DataFrame())

Efficiently reduce the given vector or tuple of `AbstractDataFrame`s with
`vcat`.

See the [`vcat`](@ref) docstring for a description of keyword arguments `cols`
and `source`.

The keyword argument `init` is the initial value to use in the reductions.
It must be a data frame that has zero rows. It is not taken into account when
computing the value of the `source` column nor when determining metadata
of the produced data frame.

The column order, names, and types of the resulting `DataFrame`, and the
behavior of `cols` and `source` keyword arguments follow the rules specified for
[`vcat`](@ref) of `AbstractDataFrame`s.

Metadata: `vcat` propagates table-level `:note`-style metadata for keys that are
present in all passed data frames and have the same value. `vcat` propagates
column-level `:note`-style metadata for keys that are present in all passed data
frames that contain this column and have the same value.

# Example
```jldoctest
julia> df1 = DataFrame(A=1:3, B=1:3)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> df2 = DataFrame(A=4:6, B=4:6)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     4      4
   2 │     5      5
   3 │     6      6

julia> df3 = DataFrame(A=7:9, C=7:9)
3×2 DataFrame
 Row │ A      C
     │ Int64  Int64
─────┼──────────────
   1 │     7      7
   2 │     8      8
   3 │     9      9

julia> reduce(vcat, (df1, df2))
6×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3
   4 │     4      4
   5 │     5      5
   6 │     6      6

julia> reduce(vcat, [df1, df2, df3], cols=:union, source=:source)
9×4 DataFrame
 Row │ A      B        C        source
     │ Int64  Int64?   Int64?   Int64
─────┼─────────────────────────────────
   1 │     1        1  missing       1
   2 │     2        2  missing       1
   3 │     3        3  missing       1
   4 │     4        4  missing       2
   5 │     5        5  missing       2
   6 │     6        6  missing       2
   7 │     7  missing        7       3
   8 │     8  missing        8       3
   9 │     9  missing        9       3
```
"""
function Base.reduce(::typeof(vcat),
    dfs::Union{AbstractVector{AbstractDataFrame},
        AbstractVector{DataFrame},
        AbstractVector{SubDataFrame},
        AbstractVector{Union{DataFrame,SubDataFrame}},
        Tuple{AbstractDataFrame,Vararg{AbstractDataFrame}}};
    cols::Union{Symbol,AbstractVector{Symbol},
        AbstractVector{<:AbstractString}}=:setequal,
    source::Union{Nothing,SymbolOrString,
        Pair{<:SymbolOrString,<:AbstractVector}}=nothing,
    init::AbstractDataFrame=DataFrame())
    if nrow(init) > 0
        throw(ArgumentError("init data frame must have zero rows"))
    end
    dfs_init = AbstractDataFrame[emptycolmetadata!(copy(init))]
    append!(dfs_init, dfs)
    res = _vcat(AbstractDataFrame[df for df in dfs_init if ncol(df) != 0]; cols=cols)
    # only handle table-level metadata, as column-level metadata was done in _vcat
    _merge_matching_table_note_metadata!(res, dfs)

    if source !== nothing
        len = length(dfs)
        col, vals = if source isa SymbolOrString
            source, 1:len
        else
            @assert source isa Pair{<:SymbolOrString,<:AbstractVector}
            source
        end

        if columnindex(res, col) > 0
            idx = findfirst(df -> columnindex(df, col) > 0, dfs)
            @assert idx !== nothing
            throw(ArgumentError("source column name :$col already exists in data frame " *
                                " passed in position $idx"))
        end

        if len != length(vals)
            throw(ArgumentError("number of passed source identifiers ($(length(vals)))" *
                                "does not match the number of data frames ($len)"))
        end

        source_vec = Tables.allocatecolumn(eltype(vals), nrow(res))
        @assert firstindex(source_vec) == 1 && lastindex(source_vec) == nrow(res)
        start = 1
        for (v, df) in zip(vals, dfs)
            stop = start + nrow(df) - 1
            source_vec[start:stop] .= Ref(v)
            start = stop + 1
        end

        @assert start == nrow(res) + 1
        insertcols!(res, col => source_vec)
    end

    return res
end

# definition needed to avoid dispatch ambiguity
Base.reduce(::typeof(vcat),
    dfs::Union{SentinelArrays.ChainedVector{AbstractDataFrame,<:AbstractVector{AbstractDataFrame}},
        SentinelArrays.ChainedVector{DataFrame,<:AbstractVector{DataFrame}},
        SentinelArrays.ChainedVector{SubDataFrame,<:AbstractVector{SubDataFrame}},
        SentinelArrays.ChainedVector{Union{DataFrame,SubDataFrame},<:AbstractVector{Union{DataFrame,SubDataFrame}}}};
    cols::Union{Symbol,AbstractVector{Symbol},
        AbstractVector{<:AbstractString}}=:setequal,
    source::Union{Nothing,SymbolOrString,
        Pair{<:SymbolOrString,<:AbstractVector}}=nothing,
    init::AbstractDataFrame=DataFrame()) =
    reduce(vcat, collect(AbstractDataFrame, dfs), cols=cols, source=source, init=init)

function _vcat(dfs::AbstractVector{AbstractDataFrame};
    cols::Union{Symbol,AbstractVector{Symbol},
        AbstractVector{<:AbstractString}}=:setequal)
    # note that empty DataFrame() objects are dropped from dfs before we call _vcat
    if isempty(dfs)
        cols isa Symbol && return DataFrame()
        return DataFrame([col => Missing[] for col in cols])
    end
    # Array of all headers
    allheaders = map(names, dfs)
    # Array of unique headers across all data frames
    uniqueheaders = unique(allheaders)
    # All symbols present across all headers
    unionunique = union(uniqueheaders...)
    # List of symbols present in all dataframes
    intersectunique = intersect(uniqueheaders...)

    if cols === :orderequal
        header = unionunique
        if length(uniqueheaders) > 1
            throw(ArgumentError("when `cols=:orderequal` all data frames need to " *
                                "have the same column names and be in the same order"))
        end
    elseif cols === :setequal || cols === :equal
        # an explicit error is thrown as :equal was supported in the past
        if cols === :equal
            throw(ArgumentError("`cols=:equal` is not supported. " *
                                "Use `:setequal` instead."))
        end

        header = unionunique
        coldiff = setdiff(unionunique, intersectunique)

        if !isempty(coldiff)
            # if any DataFrames are a full superset of names, skip them
            let header = header     # julia #15276
                filter!(u -> !issetequal(u, header), uniqueheaders)
            end
            estrings = map(enumerate(uniqueheaders)) do (i, head)
                matching = findall(h -> head == h, allheaders)
                headerdiff = setdiff(coldiff, head)
                badcols = join(headerdiff, ", ", " and ")
                args = join(matching, ", ", " and ")
                return "column(s) $badcols are missing from argument(s) $args"
            end
            throw(ArgumentError(join(estrings, ", ", ", and ")))
        end
    elseif cols === :intersect
        header = intersectunique
    elseif cols === :union
        header = unionunique
    elseif cols isa Symbol
        throw(ArgumentError("Invalid `cols` value :$cols. " *
                            "Only `:orderequal`, `:setequal`, `:intersect`, " *
                            "`:union`, or a vector of column names is allowed."))
    elseif cols isa AbstractVector{Symbol}
        header = cols
    else
        @assert cols isa AbstractVector{<:AbstractString}
        header = Symbol.(cols)
    end

    if isempty(header)
        out_df = DataFrame()
    else
        all_cols = Vector{AbstractVector}(undef, length(header))
        for (i, name) in enumerate(header)
            newcols = map(dfs) do df
                if hasproperty(df, name)
                    return df[!, name]
                else
                    Iterators.repeated(missing, nrow(df))
                end
            end

            lens = map(length, newcols)
            T = mapreduce(eltype, promote_type, newcols)
            all_cols[i] = Tables.allocatecolumn(T, sum(lens))
            offset = 1
            for j in 1:length(newcols)
                copyto!(all_cols[i], offset, newcols[j])
                offset += lens[j]
            end
        end

        out_df = DataFrame(all_cols, header, copycols=false)
    end

    # here we process column-level metadata, table-level metadata is processed in reduce

    # first check if all data frames do not have column-level metadata
    # in which case we do not have to do anything
    all(df -> getfield(parent(df), :colmetadata) === nothing, dfs) && return out_df

    for colname in _names(out_df)
        if length(dfs) == 1
            df1 = dfs[1]
            hasproperty(df1, colname) && _copy_col_note_metadata!(out_df, colname, df1, colname)
        else
            start = findfirst(x -> hasproperty(x, colname), dfs)
            start === nothing && continue
            df_start = dfs[start]
            for key_start in colmetadatakeys(df_start, colname)
                meta_val_start, meta_style_start = colmetadata(df_start, colname, key_start, style=true)
                if meta_style_start === :note
                    good_key = true
                    for i in start+1:length(dfs)
                        dfi = dfs[i]
                        if hasproperty(dfi, colname)
                            if key_start in colmetadatakeys(dfi, colname)
                                meta_vali, meta_stylei = colmetadata(dfi, colname, key_start, style=true)
                                if !(meta_stylei === :note && isequal(meta_val_start, meta_vali))
                                    good_key = false
                                    break
                                end
                            else
                                good_key = false
                                break
                            end
                        end
                    end
                    good_key && colmetadata!(out_df, colname, key_start, meta_val_start, style=:note)
                end
            end
        end
    end

    return out_df
end

"""
    stack(df::AbstractDataFrame[, measure_vars[, id_vars] ];
          variable_name=:variable, value_name=:value,
          view::Bool=false, variable_eltype::Type=String)

Stack a data frame `df`, i.e. convert it from wide to long format.

Return the long-format `DataFrame` with: columns for each of the `id_vars`,
column `value_name` (`:value` by default)
holding the values of the stacked columns (`measure_vars`), and
column `variable_name` (`:variable` by default) a vector holding
the name of the corresponding `measure_vars` variable.

If `view=true` then return a stacked view of a data frame (long format).
The result is a view because the columns are special `AbstractVectors`
that return views into the original data frame.

# Arguments
- `df` : the AbstractDataFrame to be stacked
- `measure_vars` : the columns to be stacked (the measurement variables),
  as a column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).
  If neither `measure_vars` or `id_vars` are given, `measure_vars`
  defaults to all floating point columns.
- `id_vars` : the identifier columns that are repeated during stacking,
  as a column selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR).
  Defaults to all variables that are not `measure_vars`
- `variable_name` : the name (`Symbol` or string) of the new stacked column that
  shall hold the names of each of `measure_vars`
- `value_name` : the name (`Symbol` or string) of the new stacked column containing
  the values from each of `measure_vars`
- `view` : whether the stacked data frame should be a view rather than contain
  freshly allocated vectors.
- `variable_eltype` : determines the element type of column `variable_name`.
  By default a `PooledArray{String}` is created.
  If `variable_eltype=Symbol` a `PooledVector{Symbol}` is created,
  and if `variable_eltype=CategoricalValue{String}`
  a `CategoricalArray{String}` is produced (call `using CategoricalArrays` first if needed)
  Passing any other type `T` will produce a `PooledVector{T}` column
  as long as it supports conversion from `String`.
  When `view=true`, a `RepeatedVector{T}` is produced.

Metadata: table-level `:note`-style metadata and column-level `:note`-style metadata
for identifier columns are preserved.

# Examples
```jldoctest
julia> df = DataFrame(a=repeat(1:3, inner=2),
                      b=repeat(1:2, inner=3),
                      c=repeat(1:1, inner=6),
                      d=repeat(1:6, inner=1),
                      e=string.('a':'f'))
6×5 DataFrame
 Row │ a      b      c      d      e
     │ Int64  Int64  Int64  Int64  String
─────┼────────────────────────────────────
   1 │     1      1      1      1  a
   2 │     1      1      1      2  b
   3 │     2      1      1      3  c
   4 │     2      2      1      4  d
   5 │     3      2      1      5  e
   6 │     3      2      1      6  f

julia> stack(df, [:c, :d])
12×5 DataFrame
 Row │ a      b      e       variable  value
     │ Int64  Int64  String  String    Int64
─────┼───────────────────────────────────────
   1 │     1      1  a       c             1
   2 │     1      1  b       c             1
   3 │     2      1  c       c             1
   4 │     2      2  d       c             1
   5 │     3      2  e       c             1
   6 │     3      2  f       c             1
   7 │     1      1  a       d             1
   8 │     1      1  b       d             2
   9 │     2      1  c       d             3
  10 │     2      2  d       d             4
  11 │     3      2  e       d             5
  12 │     3      2  f       d             6

julia> stack(df, [:c, :d], [:a])
12×3 DataFrame
 Row │ a      variable  value
     │ Int64  String    Int64
─────┼────────────────────────
   1 │     1  c             1
   2 │     1  c             1
   3 │     2  c             1
   4 │     2  c             1
   5 │     3  c             1
   6 │     3  c             1
   7 │     1  d             1
   8 │     1  d             2
   9 │     2  d             3
  10 │     2  d             4
  11 │     3  d             5
  12 │     3  d             6

julia> stack(df, Not([:a, :b, :e]))
12×5 DataFrame
 Row │ a      b      e       variable  value
     │ Int64  Int64  String  String    Int64
─────┼───────────────────────────────────────
   1 │     1      1  a       c             1
   2 │     1      1  b       c             1
   3 │     2      1  c       c             1
   4 │     2      2  d       c             1
   5 │     3      2  e       c             1
   6 │     3      2  f       c             1
   7 │     1      1  a       d             1
   8 │     1      1  b       d             2
   9 │     2      1  c       d             3
  10 │     2      2  d       d             4
  11 │     3      2  e       d             5
  12 │     3      2  f       d             6

julia> stack(df, Not([:a, :b, :e]), variable_name=:somemeasure)
12×5 DataFrame
 Row │ a      b      e       somemeasure  value
     │ Int64  Int64  String  String       Int64
─────┼──────────────────────────────────────────
   1 │     1      1  a       c                1
   2 │     1      1  b       c                1
   3 │     2      1  c       c                1
   4 │     2      2  d       c                1
   5 │     3      2  e       c                1
   6 │     3      2  f       c                1
   7 │     1      1  a       d                1
   8 │     1      1  b       d                2
   9 │     2      1  c       d                3
  10 │     2      2  d       d                4
  11 │     3      2  e       d                5
  12 │     3      2  f       d                6
```
"""
function stack(df::AbstractDataFrame,
               measure_vars = findall(col -> eltype(col) <: Union{AbstractFloat, Missing},
                                      eachcol(df)),
               id_vars = Not(measure_vars);
               variable_name::SymbolOrString=:variable,
               value_name::SymbolOrString=:value, view::Bool=false,
               variable_eltype::Type=String)
    variable_name_s = Symbol(variable_name)
    value_name_s = Symbol(value_name)
    # getindex from index returns either Int or AbstractVector{Int}
    mv_tmp = index(df)[measure_vars]
    ints_measure_vars = mv_tmp isa Int ? [mv_tmp] : mv_tmp
    idv_tmp = index(df)[id_vars]
    ints_id_vars = idv_tmp isa Int ? [idv_tmp] : idv_tmp
    if view
        return _stackview(df, ints_measure_vars, ints_id_vars,
                          variable_name=variable_name_s,
                          value_name=value_name_s,
                          variable_eltype=variable_eltype)
    end
    N = length(ints_measure_vars)
    cnames = _names(df)[ints_id_vars]
    push!(cnames, variable_name_s)
    push!(cnames, value_name_s)
    if variable_eltype === Symbol
        catnms = PooledArray(_names(df)[ints_measure_vars])
    elseif variable_eltype === String
        catnms = PooledArray(names(df, ints_measure_vars))
    else
        # this covers CategoricalArray{String} in particular
        # (note that copyto! inserts levels in their order of appearance)
        nms = names(df, ints_measure_vars)
        simnms = similar(nms, variable_eltype)
        catnms = simnms isa Vector ? PooledArray(simnms) : simnms
        copyto!(catnms, nms)
    end
    out_df =  DataFrame(AbstractVector[[repeat(df[!, c], outer=N) for c in ints_id_vars]..., # id_var columns
                                       repeat(catnms, inner=nrow(df)),                       # variable
                                       vcat([df[!, c] for c in ints_measure_vars]...)],      # value
                        cnames, copycols=false)
    _copy_table_note_metadata!(out_df, df)
    if !isempty(colmetadatakeys(df))
        for (i_out, i_in) in enumerate(ints_id_vars)
            _copy_col_note_metadata!(out_df, i_out, df, i_in)
        end
    end
    return out_df
end

function _stackview(df::AbstractDataFrame, measure_vars::AbstractVector{Int},
                    ints_id_vars::AbstractVector{Int}; variable_name::Symbol,
                    value_name::Symbol, variable_eltype::Type)
    N = length(measure_vars)
    cnames = _names(df)[ints_id_vars]
    push!(cnames, variable_name)
    push!(cnames, value_name)
    if variable_eltype === Symbol
        catnms = _names(df)[measure_vars]
    elseif variable_eltype === String
        catnms = names(df, measure_vars)
    else
        # this covers CategoricalArray{String} in particular,
        # as copyto! inserts levels in their order of appearance
        nms = names(df, measure_vars)
        catnms = copyto!(similar(nms, variable_eltype), nms)
    end
    out_df = DataFrame(AbstractVector[[RepeatedVector(df[!, c], 1, N) for c in ints_id_vars]..., # id_var columns
                                      RepeatedVector(catnms, nrow(df), 1),                       # variable
                                      StackedVector(Any[df[!, c] for c in measure_vars])],       # value
                       cnames, copycols=false)
    _copy_table_note_metadata!(out_df, df)
    if !isempty(colmetadatakeys(df))
        for (i_out, i_in) in enumerate(ints_id_vars)
            _copy_col_note_metadata!(out_df, i_out, df, i_in)
        end
    end
    return out_df
end

"""
    unstack(df::AbstractDataFrame, rowkeys, colkey, value;
            renamecols::Function=identity, allowmissing::Bool=false,
            combine=only, fill=missing, threads::Bool=true)
    unstack(df::AbstractDataFrame, colkey, value;
            renamecols::Function=identity, allowmissing::Bool=false,
            combine=only, fill=missing, threads::Bool=true)
    unstack(df::AbstractDataFrame;
            renamecols::Function=identity, allowmissing::Bool=false,
            combine=only, fill=missing, threads::Bool=true)

Unstack data frame `df`, i.e. convert it from long to wide format.

Row and column keys are ordered in the order of their first appearance.

# Positional arguments
- `df` : the AbstractDataFrame to be unstacked
- `rowkeys` : the columns with a unique key for each row, if not given, find a
  key by grouping on anything not a `colkey` or `value`. Can be any column
  selector ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR). If `rowkeys` contains no
  columns all rows are assumed to have the same key.
- `colkey` : the column ($COLUMNINDEX_STR) holding the column names in wide
  format, defaults to `:variable`
- `values` : the column storing values ($COLUMNINDEX_STR), defaults to `:value`

# Keyword arguments

- `renamecols`: a function called on each unique value in `colkey`; it must
  return the name of the column to be created (typically as a string or a
  `Symbol`). Duplicates in resulting names when converted to `Symbol` are not
  allowed. By default no transformation is performed.
- `allowmissing`: if `false` (the default) then an error is thrown if
  `colkey` contains `missing` values; if `true` then a column referring to
  `missing` value is created.
- `combine`: if `only` (the default) then an error is thrown if combination
  of `rowkeys` and `colkey` contains duplicate entries. Otherwise the passed
  value must be a function that is called on a vector view containing all
  elements for each combination of `rowkeys` and `colkey` present in the data.
- `fill`: missing row/column combinations are filled with this value. The
  default is `missing`. If the `value` column is a `CategoricalVector` and
  `fill` is not `missing` then in order to keep unstacked value columns also
  `CategoricalVector` the `fill` must be passed as `CategoricalValue`
- `threads`: whether `combine` function may be run in separate tasks which can
  execute in parallel (possibly being applied to multiple groups at the same
  time). Whether or not tasks are actually spawned and their number are
  determined automatically. Set to `false` if `combine` requires serial
  execution or is not thread-safe.

Metadata: table-level `:note`-style metadata and column-level `:note`-style
metadata for row keys columns are preserved.

# Deprecations

- `allowduplicates` keyword argument is deprecated; instead use `combine`
  keyword argument; an equivalent to `allowduplicates=true` is `combine=last`
  and to `allowduplicates=false` is `combine=only` (the default);

# Examples

```jldoctest
julia> wide = DataFrame(id=1:6,
                        a=repeat(1:3, inner=2),
                        b=repeat(1.0:2.0, inner=3),
                        c=repeat(1.0:1.0, inner=6),
                        d=repeat(1.0:3.0, inner=2))
6×5 DataFrame
 Row │ id     a      b        c        d
     │ Int64  Int64  Float64  Float64  Float64
─────┼─────────────────────────────────────────
   1 │     1      1      1.0      1.0      1.0
   2 │     2      1      1.0      1.0      1.0
   3 │     3      2      1.0      1.0      2.0
   4 │     4      2      2.0      1.0      2.0
   5 │     5      3      2.0      1.0      3.0
   6 │     6      3      2.0      1.0      3.0

julia> long = stack(wide)
18×4 DataFrame
 Row │ id     a      variable  value
     │ Int64  Int64  String    Float64
─────┼─────────────────────────────────
   1 │     1      1  b             1.0
   2 │     2      1  b             1.0
   3 │     3      2  b             1.0
   4 │     4      2  b             2.0
   5 │     5      3  b             2.0
   6 │     6      3  b             2.0
   7 │     1      1  c             1.0
   8 │     2      1  c             1.0
  ⋮  │   ⋮      ⋮       ⋮         ⋮
  12 │     6      3  c             1.0
  13 │     1      1  d             1.0
  14 │     2      1  d             1.0
  15 │     3      2  d             2.0
  16 │     4      2  d             2.0
  17 │     5      3  d             3.0
  18 │     6      3  d             3.0
                         3 rows omitted

julia> unstack(long)
6×5 DataFrame
 Row │ id     a      b         c         d
     │ Int64  Int64  Float64?  Float64?  Float64?
─────┼────────────────────────────────────────────
   1 │     1      1       1.0       1.0       1.0
   2 │     2      1       1.0       1.0       1.0
   3 │     3      2       1.0       1.0       2.0
   4 │     4      2       2.0       1.0       2.0
   5 │     5      3       2.0       1.0       3.0
   6 │     6      3       2.0       1.0       3.0

julia> unstack(long, :variable, :value)
6×5 DataFrame
 Row │ id     a      b         c         d
     │ Int64  Int64  Float64?  Float64?  Float64?
─────┼────────────────────────────────────────────
   1 │     1      1       1.0       1.0       1.0
   2 │     2      1       1.0       1.0       1.0
   3 │     3      2       1.0       1.0       2.0
   4 │     4      2       2.0       1.0       2.0
   5 │     5      3       2.0       1.0       3.0
   6 │     6      3       2.0       1.0       3.0

julia> unstack(long, :id, :variable, :value)
6×4 DataFrame
 Row │ id     b         c         d
     │ Int64  Float64?  Float64?  Float64?
─────┼─────────────────────────────────────
   1 │     1       1.0       1.0       1.0
   2 │     2       1.0       1.0       1.0
   3 │     3       1.0       1.0       2.0
   4 │     4       2.0       1.0       2.0
   5 │     5       2.0       1.0       3.0
   6 │     6       2.0       1.0       3.0

julia> unstack(long, [:id, :a], :variable, :value)
6×5 DataFrame
 Row │ id     a      b         c         d
     │ Int64  Int64  Float64?  Float64?  Float64?
─────┼────────────────────────────────────────────
   1 │     1      1       1.0       1.0       1.0
   2 │     2      1       1.0       1.0       1.0
   3 │     3      2       1.0       1.0       2.0
   4 │     4      2       2.0       1.0       2.0
   5 │     5      3       2.0       1.0       3.0
   6 │     6      3       2.0       1.0       3.0

julia> unstack(long, :id, :variable, :value, renamecols=x->Symbol(:_, x))
6×4 DataFrame
 Row │ id     _b        _c        _d
     │ Int64  Float64?  Float64?  Float64?
─────┼─────────────────────────────────────
   1 │     1       1.0       1.0       1.0
   2 │     2       1.0       1.0       1.0
   3 │     3       1.0       1.0       2.0
   4 │     4       2.0       1.0       2.0
   5 │     5       2.0       1.0       3.0
   6 │     6       2.0       1.0       3.0
```
Note that there are some differences between the widened results above.

```jldoctest
julia> df = DataFrame(id=["1", "1", "2"],
                      variable=["Var1", "Var2", "Var1"],
                      value=[1, 2, 3])
3×3 DataFrame
 Row │ id      variable  value
     │ String  String    Int64
─────┼─────────────────────────
   1 │ 1       Var1          1
   2 │ 1       Var2          2
   3 │ 2       Var1          3

julia> unstack(df, :variable, :value, fill=0)
2×3 DataFrame
 Row │ id      Var1   Var2
     │ String  Int64  Int64
─────┼──────────────────────
   1 │ 1           1      2
   2 │ 2           3      0

julia> df = DataFrame(cols=["a", "a", "b"], values=[1, 2, 4])
3×2 DataFrame
 Row │ cols    values
     │ String  Int64
─────┼────────────────
   1 │ a            1
   2 │ a            2
   3 │ b            4

julia> unstack(df, :cols, :values, combine=copy)
1×2 DataFrame
 Row │ a        b
     │ Array…?  Array…?
─────┼──────────────────
   1 │ [1, 2]   [4]

julia> unstack(df, :cols, :values, combine=sum)
1×2 DataFrame
 Row │ a       b
     │ Int64?  Int64?
─────┼────────────────
   1 │      3       4
```
"""
function unstack(df::AbstractDataFrame, rowkeys, colkey::ColumnIndex,
                 values::ColumnIndex; renamecols::Function=identity,
                 allowmissing::Bool=false,  allowduplicates::Bool=false,
                 combine=only, fill=missing, threads::Bool=true)
    if allowduplicates
        Base.depwarn("allowduplicates keyword argument is deprecated. " *
                     "Pass `combine=last` instead of `allowduplicates=true`.", :unstack)
        combine = last
    end
    # first make sure that rowkeys are unique and
    # normalize all selectors as a strings
    # if some of the selectors are wrong we will get an early error here
    rowkeys = names(df, index(df)[rowkeys])
    colkey = only(names(df, colkey))
    values = only(names(df, values))

    if combine !== only
        # potentially colkey can be also part of rowkeys so we need to do unique
        groupcols = unique!([rowkeys; colkey])
        @assert groupcols isa Vector{String}

        # generate some column name that is not conflicting with column name
        # already present in the data frame
        values_out = "values_out_3490283_"
        while hasproperty(df, values_out)
            values_out *= "1"
        end

        gdf = groupby(df, groupcols)
        if check_aggregate(combine, df[!, values]) isa AbstractAggregate
            # if combine function is AbstractAggregate
            # then we are sure it will return a scalar number so we can
            # leave it as is and be sure we use fast path in combine
            agg_fun = combine
        else
            # in general combine function could return e.g. a vector,
            # which would get expanded to multiple rows so we protect it with
            # Ref that will get unwrapped by combine
            agg_fun = Ref∘combine
        end
        df_op = DataFrames.combine(gdf, values => agg_fun => values_out,
                                   threads=threads)

        group_rows = find_group_row(gdf)
        if !issorted(group_rows)
            df_op = df_op[sortperm(group_rows), :]
        end
        # we should not have any duplicates in df_op now
        noduplicates = true
    else
        df_op = df
        values_out = values
        noduplicates = false
    end

    g_rowkey = groupby(df_op, rowkeys)
    g_colkey = groupby(df_op, colkey)
    valuecol = df_op[!, values_out]
    return _unstack(df_op, index(df_op)[rowkeys], index(df_op)[colkey], g_colkey,
                    valuecol, g_rowkey, renamecols, allowmissing, noduplicates, fill)
end

function unstack(df::AbstractDataFrame, colkey::ColumnIndex, values::ColumnIndex;
                 renamecols::Function=identity, allowmissing::Bool=false,
                  allowduplicates::Bool=false, combine=only, fill=missing,
                  threads::Bool=true)
    if allowduplicates
        Base.depwarn("allowduplicates keyword argument is deprecated. " *
                     "Pass `combine=last` instead of allowduplicates=true.", :unstack)
        combine = last
    end
    colkey_int = index(df)[colkey]
    value_int = index(df)[values]
    return unstack(df, Not(colkey_int, value_int), colkey_int, value_int,
            renamecols=renamecols, allowmissing=allowmissing,
            combine=combine,
            fill=fill, threads=threads)
end

function unstack(df::AbstractDataFrame; renamecols::Function=identity,
                 allowmissing::Bool=false, allowduplicates::Bool=false,
                 combine=only, fill=missing, threads::Bool=true)
    if allowduplicates
        Base.depwarn("allowduplicates keyword argument is deprecated. " *
                     "Pass `combine=last` instead of allowduplicates=true.", :unstack)
        combine = last
    end
    unstack(df, :variable, :value, renamecols=renamecols, allowmissing=allowmissing,
            combine=combine, fill=fill, threads=threads)
end

# we take into account the fact that idx, starts and ends are computed lazily
# so we rather directly reference the gdf.groups
# this function is tailor made for unstack so it does assume that no groups were
# dropped (i.e. gdf.groups does not contain 0 entries)
function find_group_row(gdf::GroupedDataFrame)
    rows = zeros(Int, length(gdf))
    isempty(rows) && return rows

    filled = 0
    i = 1
    groups = gdf.groups
    while filled < length(gdf)
        group = groups[i]
        if rows[group] == 0
            rows[group] = i
            filled += 1
        end
        i += 1
    end
    return rows # return row index of first occurrence of each group in gdf.groups
end

function _unstack(df::AbstractDataFrame, rowkeys::AbstractVector{Int},
                  colkey::Int, g_colkey::GroupedDataFrame,
                  valuecol::AbstractVector, g_rowkey::GroupedDataFrame,
                  renamecols::Function, allowmissing::Bool, noduplicates::Bool, fill)
    rowref = g_rowkey.groups
    row_group_row_idxs = find_group_row(g_rowkey)
    Nrow = length(g_rowkey)

    @assert groupcols(g_colkey) == _names(df)[colkey:colkey]
    colref = g_colkey.groups
    Ncol = length(g_colkey)
    col_group_row_idxs = find_group_row(g_colkey)
    colref_map = df[col_group_row_idxs, colkey]
    if any(ismissing, colref_map) && !allowmissing
        throw(ArgumentError("Missing value in variable :$(_names(df)[colkey]). " *
                            "Pass `allowmissing=true` to create a :missing column " *
                            "referring to `missing` values."))
    end
    @assert length(rowref) == length(colref) == length(valuecol)

    unstacked_val = [fill!(similar(valuecol,
                           promote_type(eltype(valuecol), typeof(fill)),
                           Nrow),
                     fill) for _ in 1:Ncol]

    # use a separate path for noduplicates to reduce memory use and increase speed
    if noduplicates
        for (k, (row_id, col_id, val)) in enumerate(zip(rowref, colref, valuecol))
            unstacked_val[col_id][row_id] = val
        end
    else
        mask_filled = falses(Nrow, Ncol)
        for (k, (row_id, col_id, val)) in enumerate(zip(rowref, colref, valuecol))
            if mask_filled[row_id, col_id]
                bad_key = tuple((df[k, s] for s in rowkeys)...)
                bad_var = colref_map[col_id]
                throw(ArgumentError("Duplicate entries in unstack at row $k for key "*
                                    "$bad_key and variable $bad_var. " *
                                    "Pass `combine` keyword argument to specify " *
                                    "how they should be handled."))
            end
            unstacked_val[col_id][row_id] = val
            mask_filled[row_id, col_id] = true
        end
    end

    # note that Symbol(renamecols(x)) must produce unique column names
    # and names between df1 and df2 must be unique
    # here df1 gets proper column-level metadata with :note style
    df1 = df[row_group_row_idxs, g_rowkey.cols]
    new_col_names = Symbol[Symbol(renamecols(x)) for x in colref_map]
    if !allunique(new_col_names)
        throw(ArgumentError("Non-unique column names produced. " *
                            "Non equal values in `colkey` were mapped " *
                            "to the same column name."))
    end
    df2 = DataFrame(unstacked_val, new_col_names,
                    copycols=false)

    @assert length(col_group_row_idxs) == ncol(df2)
    # avoid reordering when col_group_row_idxs was already ordered
    if !issorted(col_group_row_idxs)
        df2 = df2[!, sortperm(col_group_row_idxs)]
    end

    if !isempty(intersect(_names(df1), _names(df2)))
        throw(ArgumentError("Non-unique column names produced. " *
                            "Column names created using the `colkey` " *
                            "conflict with `rowkeys` column names."))
    end

    res_df = hcat(df1, df2, copycols=false)

    @assert length(row_group_row_idxs) == nrow(res_df)
    # avoid reordering when row_group_row_idxs was already ordered
    if !issorted(row_group_row_idxs)
        res_df = res_df[sortperm(row_group_row_idxs), :]
    end

    # only table-level :note-style metadata needs to be copied
    # as column-level :note-style metadata is already correctly set
    _copy_table_note_metadata!(res_df, df)

    return res_df
end

"""
    StackedVector <: AbstractVector

An `AbstractVector` that is a linear, concatenated view into
another set of AbstractVectors

NOTE: Not exported.

# Constructor
```julia
StackedVector(d::AbstractVector)
```

# Arguments
- `d...` : one or more AbstractVectors

# Examples
```julia
StackedVector(Any[[1, 2], [9, 10], [11, 12]])  # [1, 2, 9, 10, 11, 12]
```
"""
struct StackedVector{T} <: AbstractVector{T}
    components::Vector{Any}
end

StackedVector(d::AbstractVector) =
    StackedVector{promote_type(map(eltype, d)...)}(d)

function Base.getindex(v::StackedVector{T}, i::Int)::T where T
    lengths = [length(x)::Int for x in v.components]
    cumlengths = [0; cumsum(lengths)]
    j = searchsortedlast(cumlengths .+ 1, i)
    if j > length(cumlengths)
        error("indexing bounds error")
    end
    k = i - cumlengths[j]
    if k < 1 || k > length(v.components[j])
        error("indexing bounds error")
    end
    return v.components[j][k]
end

Base.IndexStyle(::Type{StackedVector}) = Base.IndexLinear()
Base.size(v::StackedVector) = (length(v),)
Base.length(v::StackedVector) = sum(map(length, v.components))
Base.eltype(v::Type{StackedVector{T}}) where {T} = T
Base.similar(v::StackedVector, T::Type, dims::Union{Integer, AbstractUnitRange}...) =
    similar(v.components[1], T, dims...)

"""
    RepeatedVector{T} <: AbstractVector{T}

An AbstractVector that is a view into another AbstractVector with
repeated elements

NOTE: Not exported.

# Constructor
```julia
RepeatedVector(parent::AbstractVector, inner::Int, outer::Int)
```

# Arguments
- `parent` : the AbstractVector that's repeated
- `inner` : the number of times each element is repeated
- `outer` : the number of times the whole vector is repeated after
  expanded by `inner`

`inner` and `outer` have the same meaning as similarly named arguments
to `repeat`.

# Examples
```julia
RepeatedVector([1, 2], 3, 1)   # [1, 1, 1, 2, 2, 2]
RepeatedVector([1, 2], 1, 3)   # [1, 2, 1, 2, 1, 2]
RepeatedVector([1, 2], 2, 2)   # [1, 1, 2, 2, 1, 1, 2, 2]
```
"""
struct RepeatedVector{T} <: AbstractVector{T}
    parent::AbstractVector{T}
    inner::Int
    outer::Int
end

Base.parent(v::RepeatedVector) = v.parent

function Base.getindex(v::RepeatedVector, i::Int)
    N = length(parent(v))
    idx = Base.fld1(mod1(i, v.inner*N), v.inner)
    parent(v)[idx]
end

Base.IndexStyle(::Type{<:RepeatedVector}) = Base.IndexLinear()
Base.size(v::RepeatedVector) = (length(v),)
Base.length(v::RepeatedVector) = v.inner * v.outer * length(parent(v))
Base.eltype(v::Type{RepeatedVector{T}}) where {T} = T
Base.reverse(v::RepeatedVector) = RepeatedVector(reverse(parent(v)), v.inner, v.outer)
Base.similar(v::RepeatedVector, T::Type, dims::Dims) = similar(parent(v), T, dims)
Base.unique(v::RepeatedVector) = unique(parent(v))

Base.transpose(::AbstractDataFrame, args...; kwargs...) =
    throw(ArgumentError("`transpose` not defined for `AbstractDataFrame`s. Try `permutedims` instead"))

"""
    permutedims(df::AbstractDataFrame,
                [src_namescol::Union{Int, Symbol, AbstractString}],
                [dest_namescol::Union{Symbol, AbstractString}];
                makeunique::Bool=false, strict::Bool=true)

Turn `df` on its side such that rows become columns
and values in the column indexed by `src_namescol` become the names of new columns.
In the resulting `DataFrame`, column names of `df` will become the first column
with name specified by `dest_namescol`.

# Arguments
- `df` : the `AbstractDataFrame`
- `src_namescol` : the column that will become the new header.
   If omitted then column names `:x1`, `:x2`, ... are generated automatically.
- `dest_namescol` : the name of the first column in the returned `DataFrame`.
  Defaults to the same name as `src_namescol`.
  Not supported when `src_namescol` is a vector or is omitted.
- `makeunique` : if `false` (the default), an error will be raised
  if duplicate names are found; if `true`, duplicate names will be suffixed
  with `_i` (`i` starting at 1 for the first duplicate).
  Not supported when `src_namescol` is omitted.
- `strict` : if `true` (the default), an error will be raised if the values
  contained in the `src_namescol` are not all `Symbol` or all `AbstractString`,
  or can all be converted to `String` using `convert`. If `false`
  then any values are accepted and the will be changed to strings using
  the `string` function.
  Not supported when `src_namescol` is a vector or is omitted.

Note: The element types of columns in resulting `DataFrame`
(other than the first column if it is created from `df` column names,
which always has element type `String`) will depend on the element types of
_all_ input columns based on the result of `promote_type`.
That is, if the source data frame contains `Int` and `Float64` columns,
resulting columns will have element type `Float64`. If the source has
`Int` and `String` columns, resulting columns will have element type `Any`.

Metadata: table-level `:note`-style metadata is preserved and
column-level metadata is dropped.

# Examples

```jldoctest
julia> df = DataFrame(a=1:2, b=3:4)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> permutedims(df)
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     3      4

julia> permutedims(df, [:p, :q])
2×2 DataFrame
 Row │ p      q
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     3      4

julia> df1 = DataFrame(a=["x", "y"], b=[1.0, 2.0], c=[3, 4], d=[true, false])
2×4 DataFrame
 Row │ a       b        c      d
     │ String  Float64  Int64  Bool
─────┼───────────────────────────────
   1 │ x           1.0      3   true
   2 │ y           2.0      4  false

julia> permutedims(df1, 1) # note the column types
3×3 DataFrame
 Row │ a       x        y
     │ String  Float64  Float64
─────┼──────────────────────────
   1 │ b           1.0      2.0
   2 │ c           3.0      4.0
   3 │ d           1.0      0.0

julia> df2 = DataFrame(a=["x", "y"], b=[1, "two"], c=[3, 4], d=[true, false])
2×4 DataFrame
 Row │ a       b    c      d
     │ String  Any  Int64  Bool
─────┼───────────────────────────
   1 │ x       1        3   true
   2 │ y       two      4  false

julia> permutedims(df2, 1, "different_name")
3×3 DataFrame
 Row │ different_name  x     y
     │ String          Any   Any
─────┼─────────────────────────────
   1 │ b               1     two
   2 │ c               3     4
   3 │ d               true  false
```
"""
function Base.permutedims(df::AbstractDataFrame, src_namescol::ColumnIndex,
                          dest_namescol::Union{Symbol, AbstractString};
                          makeunique::Bool=false, strict::Bool=true)

    if src_namescol isa Integer
        1 <= src_namescol <= ncol(df) || throw(BoundsError(index(df), src_namescol))
    end
    src_col_names = df[!, src_namescol]
    local new_col_names
    if eltype(src_col_names) <: SymbolOrString
        new_col_names = src_col_names
    elseif all(x -> x isa Symbol, src_col_names)
        new_col_names = collect(Symbol, src_col_names)
    elseif !strict
        new_col_names = string.(src_col_names)
    else
        try
            new_col_names = collect(String, src_col_names)
        catch e
            if e isa MethodError && e.f === convert
                throw(ArgumentError("all elements of src_namescol must support " *
                                    "conversion to String"))
            else
                rethrow(e)
            end
        end
    end

    df_notsrc = df[!, Not(src_namescol)]
    df_permuted = DataFrame(dest_namescol => names(df_notsrc))

    if ncol(df_notsrc) == 0
        df_tmp = DataFrame(AbstractVector[[] for _ in 1:nrow(df)], new_col_names,
                           makeunique=makeunique, copycols=false)
    else
        m = permutedims(Matrix(df_notsrc))
        df_tmp = rename!(DataFrame(Tables.table(m)), new_col_names, makeunique=makeunique)
    end
    out_df = hcat!(df_permuted, df_tmp, makeunique=makeunique, copycols=false)
    _copy_table_note_metadata!(out_df, df)
    return out_df
end

function Base.permutedims(df::AbstractDataFrame, src_namescol::ColumnIndex;
                          makeunique::Bool=false, strict::Bool=true)
    if src_namescol isa Integer
        1 <= src_namescol <= ncol(df) || throw(BoundsError(index(df), src_namescol))
        dest_namescol = _names(df)[src_namescol]
    else
        dest_namescol = src_namescol
    end
    return permutedims(df, src_namescol, dest_namescol;
                       makeunique=makeunique, strict=strict)
end

function Base.permutedims(df::AbstractDataFrame)
    out_df = DataFrame(permutedims(Matrix(df)), :auto)
    _copy_table_note_metadata!(out_df, df)
    return out_df
end

function Base.permutedims(df::AbstractDataFrame, cnames::AbstractVector;
                          makeunique::Bool=false)
    out_df = DataFrame(permutedims(Matrix(df)), cnames, makeunique=makeunique)
    _copy_table_note_metadata!(out_df, df)
    return out_df
end

module TestData

using Test, DataFrames, Random, Statistics, CategoricalArrays
const ≅ = isequal

"""Check if passed data frames are `isequal` and have the same types of columns"""
isequal_coltyped(df1::AbstractDataFrame, df2::AbstractDataFrame) =
    isequal(df1, df2) && typeof.(eachcol(df1)) == typeof.(eachcol(df2))

@testset "constructors" begin
    df1 = DataFrame([[1, 2, missing, 4], ["one", "two", missing, "four"]], [:Ints, :Strs])
    df2 = DataFrame([[1, 2, missing, 4], ["one", "two", missing, "four"]], :auto)
    df3 = DataFrame([[1, 2, missing, 4]], :auto)
    df6 = DataFrame([[1, 2, missing, 4], [1, 2, missing, 4], ["one", "two", missing, "four"]],
                    [:A, :B, :C])
    df7 = DataFrame(x=[1, 2, missing, 4], y=["one", "two", missing, "four"])
    @test size(df7) == (4, 2)
    @test df7[!, :x] ≅ [1, 2, missing, 4]

    #test_group("description functions")
    @test size(df6, 1) == 4
    @test size(df6, 2) == 3
    @test propertynames(df6) == [:A, :B, :C]
    @test propertynames(df2) == [:x1, :x2]
    @test propertynames(df7) == [:x, :y]

    #test_group("ref")
    @test df6[2, 3] == "two"
    @test ismissing(df6[3, 3])
    @test df6[2, :C] == "two"
    @test df6[!, :B] ≅ [1, 2, missing, 4]
    @test size(df6[:, [2, 3]], 2) == 2
    @test size(df6[2, :], 1) == ncol(df6) # this is a DataFrameRow
    @test size(df6[2:2, :], 1) == 1
    @test size(df6[[1, 3], [1, 3]]) == (2, 2)
    @test size(df6[1:2, 1:2]) == (2, 2)
    @test size(first(df6, 2)) == (2, 3)
    # lots more to do

    #test_group("assign")
    df6[!, 3] = ["un", "deux", "trois", "quatre"]
    @test df6[1, 3] == "un"
    df6[!, :B] = [4, 3, 2, 1]
    @test df6[1, 2] == 4
    df6[!, :D] = [true, false, true, false]
    @test df6[1, 4]
    select!(df6, Not(:D))
    @test propertynames(df6) == [:A, :B, :C]
    @test size(df6, 2) == 3

    #test_context("SubDataFrames")

    #test_group("constructors")
    # single index is rows
    sdf6a = view(df6, 1:1, :)
    sdf6b = view(df6, 2:3, :)
    sdf6c = view(df6, [true, false, true, false], :)
    @test size(sdf6a) == (1, 3)
    sdf6d = view(df6, [1, 3], [:B])
    @test size(sdf6d) == (2, 1)
    sdf6e = view(df6, [0x01], :)
    @test size(sdf6e) == (1, 3)
    sdf6f = view(df6, UInt64[1, 2], :)
    @test size(sdf6f) == (2, 3)
    sdf6g = view(df6, [1, 3], :B)
    sdf6h = view(df6, 1, :B)
    sdf6i = view(df6, 1, [:B])

    #test_group("ref")
    @test sdf6a[1, 2] == 4

    #test_context("Within")
    #test_group("Associative")

    #test_group("DataFrame")
    Random.seed!(1)
    N = 20
    d1 = Vector{Union{Int64, Missing}}(rand(1:2, N))
    d2 = CategoricalArray(["A", "B", missing])[rand(1:3, N)]
    d3 = randn(N)
    d4 = randn(N)
    df7 = DataFrame([d1, d2, d3], [:d1, :d2, :d3])

    #test_group("groupby")
    gd = groupby(df7, :d1)
    @test length(gd) == 2
    @test gd[1][:, :d2] ≅ d2[d1 .== 1]
    @test gd[2][:, :d2] ≅ d2[d1 .== 2]
    @test gd[1][:, :d3] == d3[d1 .== 1]
    @test gd[2][:, :d3] == d3[d1 .== 2]

    g1 = groupby(df7, [:d1, :d2])
    g2 = groupby(df7, [:d2, :d1])
    @test g1[1][:, :d3] == g2[1][:, :d3]

    res = 0.0
    for x in g1
        res += sum(x[:, :d1])
    end
    @test res == sum(df7[!, :d1])

    df10 = DataFrame([[1:4;], [2:5;],
                      ["a", "a", "a", "b" ], ["c", "d", "c", "d"]],
                     [:d1, :d2, :d3, :d4])

    gd = groupby(df10, [:d3], sort=true)
    ggd = groupby(gd[1], [:d3, :d4], sort=true) # make sure we can groupby SubDataFrames
    @test ggd[1][1, :d3] == "a"
    @test ggd[1][1, :d4] == "c"
    @test ggd[1][2, :d3] == "a"
    @test ggd[1][2, :d4] == "c"
    @test ggd[2][1, :d3] == "a"
    @test ggd[2][1, :d4] == "d"
end

@testset "completecases and dropmissing" begin
    df1 = DataFrame([Vector{Union{Int, Missing}}(1:4), Vector{Union{Int, Missing}}(1:4)],
                    :auto)
    df2 = DataFrame([Union{Int, Missing}[1, 2, 3, 4], ["one", "two", missing, "four"]],
                    :auto)
    df3 = DataFrame(x=Int[1, 2, 3, 4], y=Union{Int, Missing}[1, missing, 2, 3],
                    z=Missing[missing, missing, missing, missing])

    @test completecases(df2) == .!ismissing.(df2.x2)
    @test @inferred(completecases(df3, :x)) == trues(nrow(df3))
    @test completecases(df3, :y) == .!ismissing.(df3.y)
    @test completecases(df3, :z) == completecases(df3, [:z, :x]) ==
          completecases(df3, [:x, :z]) == completecases(df3, [:y, :x, :z]) ==
          falses(nrow(df3))
    @test @inferred(completecases(df3, [:y, :x])) ==
          completecases(df3, [:x, :y]) == .!ismissing.(df3.y)
    @test dropmissing(df2) == df2[[1, 2, 4], :]
    returned = dropmissing(df1)
    @test df1 == returned && df1 !== returned
    df2b = copy(df2)
    @test dropmissing!(df2b) === df2b
    @test df2b == df2[[1, 2, 4], :]
    df1b = copy(df1)
    @test dropmissing!(df1b) === df1b
    @test df1b == df1

    @test isempty(completecases(DataFrame())) && completecases(DataFrame()) isa BitVector

    @test_throws ArgumentError completecases(DataFrame(a=1), Not(:a))
    @test_throws ArgumentError completecases(DataFrame(a=1), [])

    @test completecases(DataFrame(x=1:3, y=1:3), [:x]) == trues(3)
    @test completecases(DataFrame(x=[1, missing, 3], y=1:3), [:x]) == [true, false, true]
    @test_throws ArgumentError completecases(DataFrame(x=1:3), Cols())
    @test_throws MethodError completecases(DataFrame(x=1), true)
    @test_throws ArgumentError completecases(df3, :a)

    for cols in (:x2, "x2", [:x2], ["x2"], [:x1, :x2], ["x1", "x2"], 2, [2], 1:2,
                 [true, true], [false, true], :,
                 r"x2", r"x", Not(1), Not([1]), Not(Int[]), Not([]), Not(Symbol[]),
                 Not(1:0), Not([true, false]), Not(:x1), Not([:x1]))
        @test df2[completecases(df2, cols), :] == df2[[1, 2, 4], :]
        @test dropmissing(df2, cols) == df2[[1, 2, 4], :]
        returned = dropmissing(df1, cols)
        @test df1 == returned && df1 !== returned
        df2b = copy(df2)
        @test dropmissing!(df2b, cols) === df2b
        @test df2b == df2[[1, 2, 4], :]
        @test dropmissing(df2, cols) == df2b
        @test df2 != df2b
        df1b = copy(df1)
        @test dropmissing!(df1b, cols) === df1b
        @test df1b == df1
    end

    # Zero column case
    @test isempty(dropmissing(DataFrame())) && dropmissing(DataFrame()) isa DataFrame
    @test isempty(dropmissing!(DataFrame())) && dropmissing!(DataFrame()) isa DataFrame
    df = DataFrame(a=1:3, b=4:6)
    dfv = @view df[:, 2:1]
    @test isempty(dropmissing(dfv)) && dropmissing(dfv) isa DataFrame
    @test_throws ArgumentError dropmissing!(dfv)
    @test_throws ArgumentError dropmissing(df1, [])
    @test_throws ArgumentError dropmissing!(df1, [])

    df = DataFrame(a=[1, missing, 3])
    sdf = view(df, :, :)
    @test dropmissing(sdf) == DataFrame(a=[1, 3])
    @test eltype(dropmissing(df, disallowmissing=false).a) == Union{Int, Missing}
    @test eltype(dropmissing(df, disallowmissing=true).a) == Int
    @test eltype(dropmissing(sdf, disallowmissing=false).a) == Union{Int, Missing}
    @test eltype(dropmissing(sdf, disallowmissing=true).a) == Int
    @test df ≅ DataFrame(a=[1, missing, 3]) # make sure we did not mutate df

    @test_throws ArgumentError dropmissing!(sdf)

    df2 = copy(df)
    @test dropmissing!(df, disallowmissing=true) === df
    @test dropmissing!(df2, disallowmissing=false) === df2
    @test eltype(df.a) == Int
    @test eltype(df2.a) == Union{Int, Missing}
    @test df.a == df2.a == [1, 3]

    # view=true
    df = DataFrame(a=[1, missing, 3])
    @test dropmissing(df, view=false) == DataFrame(a=[1, 3])
    @test dropmissing(df, view=true) == view(df, [1, 3], :)
    @test typeof(dropmissing(df, view=true)) <: SubDataFrame
    @test eltype(dropmissing(df, view=true, disallowmissing=false).a) == Union{Int, Missing}
    @test_throws ArgumentError dropmissing(df, view=true, disallowmissing=true)
    @test eltype(dropmissing(df, view=false, disallowmissing=false).a) == Union{Int, Missing}
    @test eltype(dropmissing(df, view=false, disallowmissing=true).a) == Int

    a = [1, 2]
    df = DataFrame(a=a, copycols=false)
    @test dropmissing!(df) === df
    @test a === df.a
    dfx = dropmissing(df)
    @test df == df
    @test dfx !== df
    @test dfx.a !== df.a
    @test a === df.a # we did not touch df

    b = Union{Int, Missing}[1, 2]
    df = DataFrame(b=b)
    @test eltype(dropmissing(df).b) == Int
    @test eltype(dropmissing!(df).b) == Int

    # disallowmissing argument
    a = Union{Int, Missing}[3, 4]
    b = Union{Int, Missing}[1, 2]
    df = DataFrame(;a,b)
    @test eltype(dropmissing(df, disallowmissing=false).a) == Union{Int, Missing}
    @test eltype(dropmissing!(copy(df), disallowmissing=false).a) == Union{Int, Missing}
    @test eltype(dropmissing(df, disallowmissing=true).a) == Int
    @test eltype(dropmissing!(copy(df), disallowmissing=true).a) == Int
    @test eltype(dropmissing(df, :a, disallowmissing=true).a) == Int
    @test eltype(dropmissing!(copy(df), :a, disallowmissing=true).a) == Int
    @test eltype(dropmissing(df, :b, disallowmissing=true).a) == Union{Int, Missing}
    @test eltype(dropmissing!(copy(df), :b, disallowmissing=true).a) == Union{Int, Missing}

    # CategoricalArrays
    c = categorical([1, 2, 1, missing])
    df = DataFrame(c=c)
    @test dropmissing(df) == DataFrame(c=categorical([1, 2, 1]))
    @test eltype(dropmissing(df).c) == CategoricalValue{Int, UInt32}
    @test eltype(dropmissing!(df).c) == CategoricalValue{Int, UInt32}

    # Multithreaded execution test (must be at least ncol > 1, nrow > 100_000)
    N_rows, N_cols = 110_000, 3
    df = DataFrame([rand(N_rows) for i in 1:N_cols], :auto) |> allowmissing
    # Deterministic drop mask: IF remainder of index position divided by 10 == column index THEN missing
    for i in 1:ncol(df)
        missing_mask = (eachindex(df[!, i]) .% 10) .== i
        df[missing_mask, i] .= missing
    end

    notmissing_rows = [i for i in 1:N_rows if i % 10 == 0 || i % 10 > ncol(df)]
    @test dropmissing(df) ≅ df[notmissing_rows, :]

    cols = [:x1, :x2]
    notmissing_rows = [i for i in 1:N_rows if i % 10 == 0 || i % 10 > length(cols)]
    returned = dropmissing(df, cols)
    @test returned ≅ df[notmissing_rows, :]
    @test eltype(returned[:, cols[1]]) == nonmissingtype(eltype(df[:, cols[1]]))
    @test eltype(returned[:, cols[2]]) == nonmissingtype(eltype(df[:, cols[2]]))
    @test eltype(returned[:, ncol(df)]) == eltype(df[:, ncol(df)])

    # correct handling of not propagating views
    df = DataFrame(a=1:3, b=Any[11, missing, 13])
    df2 = dropmissing(df)
    @test df2 == DataFrame(a=[1, 3], b=[11, 13])
    @test df2.a isa Vector{Int}
    @test df2.b isa Vector{Any}
end

@testset "deleteat! https://github.com/JuliaLang/julia/pull/41646 bug workaround" begin
    # these tests will crash Julia if they are not correct
    df = DataFrame(a= Vector{Union{Bool,Missing}}(missing, 10^4));
    deleteat!(df, 2:(nrow(df) - 5))
    @test nrow(df) == 6

    df = DataFrame(a= Vector{Union{Bool,Missing}}(missing, 10^4));
    deleteat!(df, [false; trues(nrow(df) - 6); falses(5)])
    @test nrow(df) == 6
end

@testset "dropmissing and unique view kwarg test" begin
    df = DataFrame(rand(3, 4), :auto)
    for fun in (dropmissing, unique)
        @test fun(df) isa DataFrame
        @inferred fun(df)
        @test fun(view(df, 1:2, 1:2)) isa DataFrame
        @test fun(df, view=false) isa DataFrame
        @test fun(view(df, 1:2, 1:2), view=false) isa DataFrame
        @test fun(df, view=true) isa SubDataFrame
        @test fun(df, view=true) == fun(df)
        @test fun(view(df, 1:2, 1:2), view=true) isa SubDataFrame
        @test fun(view(df, 1:2, 1:2), view=true) == fun(view(df, 1:2, 1:2))
    end
    @test_throws ArgumentError dropmissing(df, view=true, disallowmissing=true)
end

@testset "filter() and filter!()" begin
    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter(r -> r[:x] > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!(r -> r[:x] > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter(:x => x -> x > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!(:x => x -> x > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter("x" => x -> x > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!("x" => x -> x > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter(1 => x -> x > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!(1 => x -> x > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter([:x] => x -> x > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!([:x] => x -> x > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter(["x"] => x -> x > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!(["x"] => x -> x > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter((:) => (r...) -> r[1] > 1, df) == DataFrame(x=[3, 2], y=["b", "a"])
    @test filter!((:) => (r...) -> r[1] > 1, df) === df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter([:x, :x] => ==, df) == df
    @test filter!([:x, :x] => ==, df) === df == DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter(["x", "x"] => ==, df) == df
    @test filter!(["x", "x"] => ==, df) === df == DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])
    @test filter([2, 2] => !=, df) == DataFrame(x=Int[], y=String[])
    @test filter!([2, 2] => !=, df) === df == DataFrame(x=Int[], y=String[])

    for sel in [r"x", [1, 2], [:x1, :x2], ["x1", "x2"], :, Not(r"y")]
        df = DataFrame(x1=[3, 1, 2, 1], x2=["b", "c", "aa", "bbb"])
        @test filter(sel => (a, b) -> a == length(b), df) ==
              DataFrame(x1=[1, 2], x2=["c", "aa"])
        @test filter!(sel => (a, b) -> a == length(b), df) === df ==
              DataFrame(x1=[1, 2], x2=["c", "aa"])
    end

    df = DataFrame(x=[3, 1, 2, 1, missing], y=["b", "c", "a", "b", "c"])
    @test_throws TypeError filter(r -> r[:x] > 1, df)
    @test_throws TypeError filter!(r -> r[:x] > 1, df)
    @test_throws TypeError filter(:x => x -> x > 1, df)
    @test_throws TypeError filter("x" => x -> x > 1, df)
    @test_throws TypeError filter!(:x => x -> x > 1, df)
    @test_throws TypeError filter!("x" => x -> x > 1, df)
    @test_throws TypeError filter(1 => x -> x > 1, df)
    @test_throws TypeError filter!(1 => x -> x > 1, df)
    @test_throws TypeError filter([:x] => x -> x > 1, df)
    @test_throws TypeError filter(["x"] => x -> x > 1, df)
    @test_throws TypeError filter!([:x] => x -> x > 1, df)
    @test_throws TypeError filter!(["x"] => x -> x > 1, df)
    @test_throws TypeError filter((:) => (r...) -> r[1] > 1, df)
    @test_throws TypeError filter!((:) => (r...) -> r[1] > 1, df)
end

@testset "filter view kwarg test" begin
    df = DataFrame(rand(3, 4), :auto)
    for fun in (row -> row.x1 > 0, :x1 => x -> x > 0, "x1" => x -> x > 0,
                [:x1] => x -> x > 0, ["x1"] => x -> x > 0,
                r"1" => x -> x > 0, AsTable(:) => x -> x.x1 > 0)
        @test filter(fun, df) isa DataFrame
        @inferred filter(fun, df)
        @test filter(fun, view(df, 1:2, 1:2)) isa DataFrame
        @test filter(fun, df, view=false) isa DataFrame
        @test filter(fun, view(df, 1:2, 1:2), view=false) isa DataFrame
        @test filter(fun, df, view=true) isa SubDataFrame
        @test filter(fun, df, view=true) == filter(fun, df)
        @test filter(fun, view(df, 1:2, 1:2), view=true) isa SubDataFrame
        @test filter(fun, view(df, 1:2, 1:2), view=true) == filter(fun, view(df, 1:2, 1:2))
    end
end

@testset "filter and filter! with SubDataFrame" begin
    dfv = view(DataFrame(x=[0, 0, 3, 1, 3, 1], y=1:6), 3:6, 1:1)

    @test filter(:x => x -> x > 2, dfv) == DataFrame(x=[3, 3])
    @test filter(:x => x -> x > 2, dfv, view=true) == DataFrame(x=[3, 3])
    @test parent(filter(:x => x -> x > 2, dfv, view=true)) === parent(dfv)

    @test_throws ArgumentError filter!(:x => x -> x > 2, dfv)
end

@testset "filter and filter! with AsTable" begin
    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])

    function testfun(x)
        @assert x isa NamedTuple
        @assert propertynames(x) == (:x,)
        return x.x > 1
    end

    @test filter(AsTable(:x) => testfun, df) == DataFrame(x=[3, 2], y=["b", "a"])
    filter!(AsTable(:x) => testfun, df)
    @test df == DataFrame(x=[3, 2], y=["b", "a"])

    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])

    @test filter(AsTable("x") => testfun, df) == DataFrame(x=[3, 2], y=["b", "a"])
    filter!(AsTable("x") => testfun, df)
    @test df == DataFrame(x=[3, 2], y=["b", "a"])
end

@testset "empty arg to filter and filter!" begin
    df = DataFrame(x=[3, 1, 2, 1], y=["b", "c", "a", "b"])

    @test filter([] => () -> true, df) == df
    @test filter(AsTable(r"z") => x -> true, df) == df
    @test filter!([] => () -> true, copy(df)) == df
    @test filter!(AsTable(r"z") => x -> true, copy(df)) == df

    flipflop0 = let
        state = false
        () -> (state = !state)
    end

    flipflop1 = let
        state = false
        x -> (state = !state)
    end

    @test filter([] => flipflop0, df) == df[[1, 3], :]
    @test filter(Int[] => flipflop0, df) == df[[1, 3], :]
    @test filter(String[] => flipflop0, df) == df[[1, 3], :]
    @test filter(Symbol[] => flipflop0, df) == df[[1, 3], :]
    @test filter(r"z" => flipflop0, df) == df[[1, 3], :]
    @test filter(Not(All()) => flipflop0, df) == df[[1, 3], :]
    @test filter(Cols() => flipflop0, df) == df[[1, 3], :]
    @test filter(AsTable(r"z") => flipflop1, df) == df[[1, 3], :]
    @test filter(AsTable([]) => flipflop1, df) == df[[1, 3], :]
    @test filter!([] => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(Int[] => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(String[] => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(Symbol[] => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(r"z" => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(Not(All()) => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(Cols() => flipflop0, copy(df)) == df[[1, 3], :]
    @test filter!(AsTable(r"z") => flipflop1, copy(df)) == df[[1, 3], :]
    @test filter!(AsTable([]) => flipflop1, copy(df)) == df[[1, 3], :]

    @test_throws MethodError filter([] => flipflop1, df)
    @test_throws MethodError filter(AsTable([]) => flipflop0, df)
end

@testset "names with cols" begin
    df = DataFrame(a=1, x1=2, x2=3, x3=4, x4=5)

    for v in [df, groupby(df, :a)]
        @test names(v, All()) == names(v, :) == names(v) == ["a", "x1", "x2", "x3", "x4"]
        @test names(v, Between(:x1, :x3)) == ["x1", "x2", "x3"]
        @test names(v, Not(:a)) == names(v, r"x") == ["x1", "x2", "x3", "x4"]
        @test names(v, :x1) == names(v, 2) == ["x1"]
        @test names(v, Cols()) == names(v, Cols()) == []
    end

    for v in [view(df, :, [4, 3, 2, 1]), groupby(view(df, :, [4, 3, 2, 1]), 1), view(df, 1, [4, 3, 2, 1])]
        @test names(v, All()) == names(v, :) == names(v) ==  ["x3", "x2", "x1", "a"]
        @test names(v, Between(:x2, :x1)) == ["x2", "x1"]
        @test names(v, Not(:a)) == names(v, r"x") == ["x3", "x2", "x1"]
        @test names(v, :x1) == names(v, 3) == ["x1"]
        @test names(v, Cols()) == names(v, Cols()) == []
    end
end

@testset "empty and empty!" begin
    df = DataFrame(a=1, b="x")
    df1 = empty(df)
    @test df == DataFrame(a=1, b="x")
    @test names(df1) == ["a", "b"]
    @test nrow(df1) == 0
    @test eltype(df1.a) <: Int
    @test eltype(df1.b) <: String
    @test empty!(df) === df
    @test names(df) == ["a", "b"]
    @test nrow(df) == 0
    @test eltype(df.a) <: Int
    @test eltype(df.b) <: String
end

@testset "isapprox" begin
    df = DataFrame([:x1 => zeros(3), :x2 => ones(3)])
    @test isapprox(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.0, 1.0, 1.0]))
    @test isapprox(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.000000010000, 1.0, 1.0]))
    @test_throws DimensionMismatch isapprox(DataFrame(a=1), DataFrame(a=[1,2]))
    @test_throws ArgumentError isapprox(DataFrame(a=1), DataFrame(b=1))
    @test !isapprox(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.1, 1.0, 1.0]))
    @test !isapprox(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.1, 1.0, 1.0]), atol=0.09)
    @test isapprox(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.1, 1.0, 1.0]), atol=0.11)
end

@testset "fillcombinations"  begin
    df1 = DataFrame(a=[1, 2, missing], b=[1, 1, 2],
                    c=categorical([11, 12, missing]), d=111:113)
    levels!(df1.c, [12, 11, 10])

    for ad in (true, false)
        res = fillcombinations(df1, [:a, :b], allowduplicates=ad)
        @test levels(res.c) == levels(df1.c)
        @test isequal_coltyped(res,
                               DataFrame(a=[1, 2, missing, 1, 2, missing],
                                         b=[1, 1, 1, 2, 2, 2],
                                         c=categorical([11, 12, missing, missing, missing, missing]),
                                         d=[111, 112, missing, missing, missing, 113]))

        # fill in the pool - column :c becomes Vector
        res = fillcombinations(df1, [:a, :b], fill=12, allowduplicates=ad)
        @test isequal_coltyped(res,
                               DataFrame(a=[1, 2, missing, 1, 2, missing],
                                         b=[1, 1, 1, 2, 2, 2],
                                         c=[11, 12, 12, 12, 12, missing],
                                         d=Union{Int, Missing}[111, 112, 12, 12, 12, 113]))
        # fill not in the pool - column :c becomes Vector
        res = fillcombinations(df1, [:a, :b], fill=-100, allowduplicates=ad)
        @test isequal_coltyped(res,
                               DataFrame(a=[1, 2, missing, 1, 2, missing],
                                         b=[1, 1, 1, 2, 2, 2],
                                         c=[11, 12, -100, -100, -100, missing],
                                         d=Union{Int, Missing}[111, 112, -100, -100, -100, 113]))
        # fill is CategoricalValue - in column :d it gets unwrapped to its integer value
        res = fillcombinations(df1, [:a, :b], fill=CategoricalValue(12, df1.c), allowduplicates=ad)
        @test levels(res.c) == levels(df1.c)
        @test isequal_coltyped(res,
                               DataFrame(a=[1, 2, missing, 1, 2, missing],
                                         b=[1, 1, 1, 2, 2, 2],
                                         c=categorical([11, 12, 12, 12, 12, missing]),
                                         d=Union{Int, Missing}[111, 112, 12, 12, 12, 113]))
        res = fillcombinations(df1, [:a, :b], fill="X", allowduplicates=ad)

        @test isequal_coltyped(res,
                               DataFrame(a=[1, 2, missing, 1, 2, missing],
                                         b=[1, 1, 1, 2, 2, 2],
                                         c=[11, 12, "X", "X", "X", missing],
                                         d=[111, 112, "X", "X", "X", 113]))
        res = fillcombinations(df1, :c, allowduplicates=ad)
        @test levels(res.c) == levels(df1.c)
        @test isequal_coltyped(res,
                               DataFrame(a=[2, 1, missing, missing],
                                         b=[1, 1, missing, 2],
                                         c=categorical([12, 11, 10, missing]),
                                         d=[112, 111, missing, 113]))
        res = fillcombinations(df1, :c, fill="X", allowduplicates=ad)
        @test levels(res.c) == levels(df1.c)
        @test isequal_coltyped(res,
                               DataFrame(a=[2, 1, "X", missing],
                                         b=[1, 1, "X", 2],
                                         c=categorical([12, 11, 10, missing]),
                                         d=[112, 111, "X", 113]))
        res = fillcombinations(df1, [:c, :b], allowduplicates=ad)
        @test levels(res.c) == levels(df1.c)
        @test isequal_coltyped(res,
                               DataFrame(a=[2; 1; fill(missing, 6)],
                                         b=[1, 1, 1, 1, 2, 2, 2, 2],
                                         c=categorical([12, 11, 10, missing, 12, 11, 10, missing]),
                                         d=[112; 111; fill(missing, 5); 113]))
    end

    df2 = DataFrame(a=[1, missing, 2, 1], b=[3, 1, 2, 2],
                    c=categorical([11, 12, missing, 11]), d=111:114)
    levels!(df2.c, [12, 11, 10])
    @test_throws ArgumentError fillcombinations(df2, :a)
    @test_throws ArgumentError fillcombinations(df2, :b)
    @test_throws ArgumentError fillcombinations(df2, [:a, :c])
    @test isequal_coltyped(fillcombinations(df2, [:a, :c], allowduplicates=true, fill=0),
                           DataFrame(a=[1, 2, missing, 1, 1, 2, missing, 1, 2, missing, 1, 2, missing],
                                     b=Union{Int,Missing}[0, 0, 1, 3, 2, 0, 0, 0, 0, 0, 0, 2, 0],
                                     c=categorical([12, 12, 12, 11, 11, 11, 11, 10, 10, 10, missing, missing, missing]),
                                     d=Union{Int,Missing}[0, 0, 112, 111, 114, 0, 0, 0, 0, 0, 0, 113, 0]))
    @test isequal_coltyped(fillcombinations(df2, [:a, :c], allowduplicates=true),
                           DataFrame(a=[1, 2, missing, 1, 1, 2, missing, 1, 2, missing, 1, 2, missing],
                                     b=[missing, missing, 1, 3, 2, missing, missing, missing, missing, missing, missing, 2, missing],
                                     c=categorical([12, 12, 12, 11, 11, 11, 11, 10, 10, 10, missing, missing, missing]),
                                     d=[missing, missing, 112, 111, 114, missing, missing, missing, missing, missing, missing, 113, missing]))

    # test of a larger scenario
    Random.seed!(1234)
    df3 = DataFrame(a=rand(1:10, 100), b=rand(1:10, 100), c=1:100)
    @test_throws ArgumentError fillcombinations(df3, [:a, :b])
    large_res = fillcombinations(df3, [:a, :b], allowduplicates=true)
    @test issorted(large_res.b)
    @test levels(large_res.b) == levels(large_res.b) == 1:10
    for (i, sdf) in enumerate(groupby(large_res, :b))
        @test first(sdf.b) == i
        @test issorted(sdf.a)
        @test levels(sdf.a) == 1:10
    end
    gdf3 = groupby(df3, [:a, :b])
    glarge_res = groupby(large_res, [:a, :b])
    @test length(glarge_res) == 100
    kt_gdf3 = Tuple.(keys(gdf3))
    kt_glarge_res = Tuple.(keys(glarge_res))
    @test isempty(setdiff(kt_gdf3, kt_glarge_res))
    for t in kt_glarge_res
        if t in kt_gdf3
            @test gdf3[t] == glarge_res[t]
        else
            @test DataFrame(a=t[1], b=t[2], c=missing) ≅ glarge_res[t]
        end
    end

    # empty indexcols
    @test_throws ArgumentError fillcombinations(DataFrame(a=1), [])

    # empty data frame case
    df = DataFrame(a=Int[], b=categorical(Int[]), c=String[])
    levels!(df.b, [1, 2])
    @test isequal_coltyped(fillcombinations(df, :a), df)
    @test isequal_coltyped(fillcombinations(df, :b),
                           DataFrame(a=missings(Int, 2), b=categorical([1, 2]), c=missings(String, 2)))
    @test isequal_coltyped(fillcombinations(df, :c), df)
    @test isequal_coltyped(fillcombinations(df, [:c, :b]), df)

    df = DataFrame(order94270=[1,1], source72490=1:2)
    @test fillcombinations(df, 1, allowduplicates=true) == df

    df = DataFrame(a=[[1, 1], [2, 2], missing], b=[[1, 1, 1], [1, 1, 1], [2, 2, 2]])
    @test fillcombinations(df, 1:2) ≅
        DataFrame(a=[[1, 1], [2, 2], missing, [1, 1], [2, 2], missing],
                  b=[[1, 1, 1], [1, 1, 1], [1, 1, 1], [2, 2, 2], [2, 2, 2], [2, 2, 2]])

    df = DataFrame(a=[1, 1, 2, 3], b=["a", "a", "a", "b"])
    @test fillcombinations(df, 1:2, allowduplicates=true) ==
          DataFrame(a=[1, 1, 2, 3, 1, 2, 3],
                    b=["a", "a", "a", "a", "b", "b", "b"])
    @test_throws ArgumentError fillcombinations(df, 1:2)
    @test_throws ArgumentError fillcombinations(df, 1)
    @test_throws ArgumentError fillcombinations(df, 2)
end

@testset "allcombinations" begin
    @test allcombinations(DataFrame) == DataFrame()
    @test allcombinations(DataFrame, a=1:2, b=3:4) ==
          allcombinations(DataFrame, "a" => 1:2, "b" => 3:4) ==
          allcombinations(DataFrame, :a => 1:2, :b => 3:4) ==
          DataFrame(a=[1, 2, 1, 2], b=[3, 3, 4, 4])
    @test_throws MethodError allcombinations(DataFrame, "a" => 1:2, :b => 3:4)
    @test_throws ArgumentError allcombinations(DataFrame, "a" => 1:2, "a" => 3:4)

    res = allcombinations(DataFrame, a=categorical(["a", "b", "a"], levels=["c", "b", "a"]))
    @test res == DataFrame(a=["a", "b", "a"])
    @test res.a isa CategoricalVector
    @test levels(res.a) == ["c", "b", "a"]

    @test allcombinations(DataFrame, a=categorical(["a", "b", "a"]),
                          b=Ref([1, 2]),
                          c=fill(1:2),
                          d=DataFrame(p=1, q=2)) ==
          DataFrame(a=categorical(["a", "b", "a"]),
                    b=Ref([1, 2]),
                    c=fill(1:2),
                    d=DataFrame(p=1, q=2))
    @test allcombinations(DataFrame, a=categorical(["a", "b", "a"]),
                          b=Ref([1, 2]),
                          c=fill(1:2),
                          d=DataFrame(p=1, q=2),
                          e=1:2) ==
          DataFrame(a=categorical(["a", "b", "a", "a", "b", "a"]),
                    b=Ref([1, 2]),
                    c=fill(1:2),
                    d=DataFrame(p=1, q=2),
                    e=[1, 1, 1, 2, 2, 2])
    @test_throws ArgumentError allcombinations(DataFrame, a=[1 2; 3 4])

    @test allcombinations(DataFrame, a=[1, 1, 1], b=[2, 2, 2]) ==
          DataFrame(a=fill(1, 9), b=fill(2, 9))
    @test allcombinations(DataFrame, a=[1, 1, 1], b='a':'b', c=[2, 2, 2]) ==
          DataFrame(a=fill(1, 18), b=repeat('a':'b', inner=3, outer=3), c=fill(2, 18))

    res = allcombinations(DataFrame, b=categorical(String[], levels=["a"]))
    @test nrow(res) == 0
    @test names(res) == ["b"]
    @test typeof(res.b) <: CategoricalVector{String}
    @test levels(res.b) == ["a"]

    res = allcombinations(DataFrame, b=categorical(String[], levels=["a"]), c='a':'b')
    @test nrow(res) == 0
    @test names(res) == ["b", "c"]
    @test typeof(res.b) <: CategoricalVector{String}
    @test levels(res.b) == ["a"]
    @test typeof(res.c) === Vector{Char}

    res = allcombinations(DataFrame, a=1:3, b=categorical(String[], levels=["a"]))
    @test nrow(res) == 0
    @test names(res) == ["a", "b"]
    @test typeof(res.a) === Vector{Int}
    @test typeof(res.b) <: CategoricalVector{String}
    @test levels(res.b) == ["a"]

    res = allcombinations(DataFrame, a=1:3, b=categorical(String[], levels=["a"]), c='a':'b')
    @test nrow(res) == 0
    @test names(res) == ["a", "b", "c"]
    @test typeof(res.a) === Vector{Int}
    @test typeof(res.b) <: CategoricalVector{String}
    @test levels(res.b) == ["a"]
    @test typeof(res.c) === Vector{Char}
end

end # module

"""
    append!(df::DataFrame, tables...; cols::Symbol=:setequal,
            promote::Bool=(cols in [:union, :subset]))

Add the rows of tables passed as `tables` to the end of `df`. If the table is not
an `AbstractDataFrame` then it is converted using
`DataFrame(table, copycols=false)` before being appended.

The exact behavior of `append!` depends on the `cols` argument:
* If `cols == :setequal` (this is the default) then `df2` must contain exactly
  the same columns as `df` (but possibly in a different order).
* If `cols == :orderequal` then `df2` must contain the same columns in the same
  order (for `AbstractDict` this option requires that `keys(row)` matches
  `propertynames(df)` to allow for support of ordered dicts; however, if `df2`
  is a `Dict` an error is thrown as it is an unordered collection).
* If `cols == :intersect` then `df2` may contain more columns than `df`, but all
  column names that are present in `df` must be present in `df2` and only these
  are used.
* If `cols == :subset` then `append!` behaves like for `:intersect` but if some
  column is missing in `df2` then a `missing` value is pushed to `df`.
* If `cols == :union` then `append!` adds columns missing in `df` that are
  present in `df2`, for columns present in `df` but missing in `df2` a `missing`
  value is pushed.

If `promote=true` and element type of a column present in `df` does not allow
the type of a pushed argument then a new column with a promoted element type
allowing it is freshly allocated and stored in `df`. If `promote=false` an error
is thrown.

The above rule has the following exceptions:
* If `df` has no columns then copies of columns from `df2` are added to it.
* If `df2` has no columns then calling `append!` leaves `df` unchanged.

Please note that `append!` must not be used on a `DataFrame` that contains
columns that are aliases (equal when compared with `===`).

Metadata: table-level `:note`-style metadata and column-level `:note`-style metadata for
columns present in `df` are preserved. If new columns are added their
`:note`-style metadata is copied from the appended table. Other metadata is
dropped.

See also: use [`push!`](@ref) to add individual rows to a data frame,
[`prepend!`](@ref) to add a table at the beginning, and [`vcat`](@ref) to
vertically concatenate data frames.

# Examples
```jldoctest
julia> df1 = DataFrame(A=1:3, B=1:3)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> df2 = DataFrame(A=4.0:6.0, B=4:6)
3×2 DataFrame
 Row │ A        B
     │ Float64  Int64
─────┼────────────────
   1 │     4.0      4
   2 │     5.0      5
   3 │     6.0      6

julia> append!(df1, df2);

julia> df1
6×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3
   4 │     4      4
   5 │     5      5
   6 │     6      6

julia> append!(df2, DataFrame(A=1), (; C=1:2), cols=:union)
6×3 DataFrame
 Row │ A          B        C
     │ Float64?   Int64?   Int64?
─────┼─────────────────────────────
   1 │       4.0        4  missing
   2 │       5.0        5  missing
   3 │       6.0        6  missing
   4 │       1.0  missing  missing
   5 │ missing    missing        1
   6 │ missing    missing        2
```
"""
Base.append!(df1::DataFrame, df2::AbstractDataFrame; cols::Symbol=:setequal,
             promote::Bool=(cols in [:union, :subset])) =
    _append_or_prepend!(df1, df2, cols=cols, promote=promote, atend=true)

function Base.append!(df::DataFrame, table; cols::Symbol=:setequal,
                      promote::Bool=(cols in [:union, :subset]))
    if table isa Dict && cols == :orderequal
        throw(ArgumentError("passing `Dict` as `table` when `cols` is equal to " *
                            "`:orderequal` is not allowed as it is unordered"))
    end
    append!(df, DataFrame(table, copycols=false), cols=cols, promote=promote)
end

function Base.append!(df::DataFrame, @nospecialize tables...;
                      cols::Symbol=:setequal,
                      promote::Bool=(cols in [:union, :subset]))
    if !(cols in (:orderequal, :setequal, :intersect, :subset, :union))
        throw(ArgumentError("`cols` keyword argument must be " *
                            ":orderequal, :setequal, :intersect, :subset or :union)"))
    end

    return foldl((df, table) -> append!(df, table, cols=cols, promote=promote),
                 collect(Any, tables), init=df)
end

"""
    prepend!(df::DataFrame, tables...; cols::Symbol=:setequal,
             promote::Bool=(cols in [:union, :subset]))

Add the rows of tables passed as `tables` to the beginning of `df`. If the table is not
an `AbstractDataFrame` then it is converted using
`DataFrame(table, copycols=false)` before being appended.

Add the rows of `df2` to the beginning of `df`. If the second argument `table`
is not an `AbstractDataFrame` then it is converted using `DataFrame(table,
copycols=false)` before being prepended.

The exact behavior of `prepend!` depends on the `cols` argument:
* If `cols == :setequal` (this is the default) then `df2` must contain exactly
  the same columns as `df` (but possibly in a different order).
* If `cols == :orderequal` then `df2` must contain the same columns in the same
  order (for `AbstractDict` this option requires that `keys(row)` matches
  `propertynames(df)` to allow for support of ordered dicts; however, if `df2`
  is a `Dict` an error is thrown as it is an unordered collection).
* If `cols == :intersect` then `df2` may contain more columns than `df`, but all
  column names that are present in `df` must be present in `df2` and only these
  are used.
* If `cols == :subset` then `append!` behaves like for `:intersect` but if some
  column is missing in `df2` then a `missing` value is pushed to `df`.
* If `cols == :union` then `append!` adds columns missing in `df` that are
  present in `df2`, for columns present in `df` but missing in `df2` a `missing`
  value is pushed.

If `promote=true` and element type of a column present in `df` does not allow
the type of a pushed argument then a new column with a promoted element type
allowing it is freshly allocated and stored in `df`. If `promote=false` an error
is thrown.

The above rule has the following exceptions:
* If `df` has no columns then copies of columns from `df2` are added to it.
* If `df2` has no columns then calling `prepend!` leaves `df` unchanged.

Please note that `prepend!` must not be used on a `DataFrame` that contains
columns that are aliases (equal when compared with `===`).

Metadata: table-level `:note`-style metadata and column-level `:note`-style metadata for
columns present in `df` are preserved. If new columns are added their
`:note`-style metadata is copied from the appended table. Other metadata is
dropped.

See also: use [`pushfirst!`](@ref) to add individual rows at the beginning of a
data frame, [`append!`](@ref) to add a table at the end, and [`vcat`](@ref) to
vertically concatenate data frames.

# Examples
```jldoctest
julia> df1 = DataFrame(A=1:3, B=1:3)
3×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3

julia> df2 = DataFrame(A=4.0:6.0, B=4:6)
3×2 DataFrame
 Row │ A        B
     │ Float64  Int64
─────┼────────────────
   1 │     4.0      4
   2 │     5.0      5
   3 │     6.0      6

julia> prepend!(df1, df2);

julia> df1
6×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     4      4
   2 │     5      5
   3 │     6      6
   4 │     1      1
   5 │     2      2
   6 │     3      3

julia> prepend!(df2, DataFrame(A=1), (; C=1:2), cols=:union)
6×3 DataFrame
 Row │ A          B        C
     │ Float64?   Int64?   Int64?
─────┼─────────────────────────────
   1 │       1.0  missing  missing
   2 │ missing    missing        1
   3 │ missing    missing        2
   4 │       4.0        4  missing
   5 │       5.0        5  missing
   6 │       6.0        6  missing
```
"""
Base.prepend!(df1::DataFrame, df2::AbstractDataFrame; cols::Symbol=:setequal,
              promote::Bool=(cols in [:union, :subset])) =
    _append_or_prepend!(df1, df2, cols=cols, promote=promote, atend=false)

function Base.prepend!(df::DataFrame, table; cols::Symbol=:setequal,
                       promote::Bool=(cols in [:union, :subset]))
    if table isa Dict && cols == :orderequal
        throw(ArgumentError("passing `Dict` as `table` when `cols` is equal to " *
                            "`:orderequal` is not allowed as it is unordered"))
    end
    prepend!(df, DataFrame(table, copycols=false), cols=cols, promote=promote)
end

function Base.prepend!(df::DataFrame, @nospecialize tables...;
                       cols::Symbol=:setequal,
                       promote::Bool=(cols in [:union, :subset]))
    if !(cols in (:orderequal, :setequal, :intersect, :subset, :union))
        throw(ArgumentError("`cols` keyword argument must be " *
                            ":orderequal, :setequal, :intersect, :subset or :union)"))
    end

    return foldr((table, df) -> prepend!(df, table, cols=cols, promote=promote),
                 collect(Any, tables), init=df)
end

function _append_or_prepend!(df1::DataFrame, df2::AbstractDataFrame; cols::Symbol,
                             promote::Bool, atend::Bool)
    if !(cols in (:orderequal, :setequal, :intersect, :subset, :union))
        throw(ArgumentError("`cols` keyword argument must be " *
                            ":orderequal, :setequal, :intersect, :subset or :union)"))
    end

    _drop_all_nonnote_metadata!(df1)
    if ncol(df1) == 0
        for (n, v) in pairs(eachcol(df2))
            df1[!, n] = copy(v) # make sure df1 does not reuse df2
            _copy_col_note_metadata!(df1, n, df2, n)
        end
        return df1
    end
    ncol(df2) == 0 && return df1

    if cols == :orderequal && _names(df1) != _names(df2)
        wrongnames = symdiff(_names(df1), _names(df2))
        if isempty(wrongnames)
            mismatches = findall(_names(df1) .!= _names(df2))
            @assert !isempty(mismatches)
            throw(ArgumentError("Columns number " *
                                join(mismatches, ", ", " and ") *
                                " do not have the same names in both passed " *
                                "data frames and `cols == :orderequal`"))
        else
            mismatchmsg = " Column names :" *
            throw(ArgumentError("Column names :" *
                                join(wrongnames, ", :", " and :") *
                                " were found in only one of the passed data frames " *
                                "and `cols == :orderequal`"))
        end
    elseif cols == :setequal
        wrongnames = symdiff(_names(df1), _names(df2))
        if !isempty(wrongnames)
            throw(ArgumentError("Column names :" *
                                join(wrongnames, ", :", " and :") *
                                " were found in only one of the passed data frames " *
                                "and `cols == :setequal`"))
        end
    elseif cols == :intersect
        wrongnames = setdiff(_names(df1), _names(df2))
        if !isempty(wrongnames)
            throw(ArgumentError("Column names :" *
                                join(wrongnames, ", :", " and :") *
                                " were found in only in destination data frame " *
                                "and `cols == :intersect`"))
        end
    end

    nrow1 = nrow(df1)
    nrow2 = nrow(df2)
    targetrows = nrow1 + nrow2
    current_col = 0
    # in the code below we use a direct access to _columns because
    # we resize the columns so temporarily the `DataFrame` is internally
    # inconsistent and normal data frame indexing would error.
    try
        for (j, n) in enumerate(_names(df1))
            current_col += 1
            if hasproperty(df2, n)
                df2_c = df2[!, n]
                S = eltype(df2_c)
                df1_c = df1[!, j]
                T = eltype(df1_c)
                if S <: T || !promote || promote_type(S, T) <: T
                    # if S <: T || promote_type(S, T) <: T this should never throw an exception
                    if atend
                        append!(df1_c, df2_c)
                    else
                        prepend!(df1_c, df2_c)
                    end
                else
                    newcol = similar(df1_c, promote_type(S, T), targetrows)
                    firstindex(newcol) != 1 && _onebased_check_error()
                    if atend
                        copyto!(newcol, 1, df1_c, 1, nrow1)
                        copyto!(newcol, nrow1+1, df2_c, 1, nrow2)
                    else
                        copyto!(newcol, 1, df2_c, 1, nrow2)
                        copyto!(newcol, nrow2+1, df1_c, 1, nrow1)
                    end
                    _columns(df1)[j] = newcol
                end
            else
                if Missing <: eltype(df1[!, j])
                    if atend
                        resize!(df1[!, j], targetrows)
                        df1[nrow1+1:targetrows, j] .= missing
                    else
                        prepend!(df1[!, j], Iterators.repeated(missing, nrow2))
                    end
                elseif promote
                    newcol = similar(df1[!, j], Union{Missing, eltype(df1[!, j])},
                                     targetrows)
                    firstindex(newcol) != 1 && _onebased_check_error()
                    if atend
                        copyto!(newcol, 1, df1[!, j], 1, nrow1)
                        newcol[nrow1+1:targetrows] .= missing
                    else
                        copyto!(newcol, nrow2+1, df1[!, j], 1, nrow1)
                        newcol[1:nrow2] .= missing
                    end
                    _columns(df1)[j] = newcol
                else
                    throw(ArgumentError("promote=false and source data frame does " *
                                        "not contain column :$n, while destination " *
                                        "column does not allow for missing values"))
                end
            end
        end
        current_col = 0
        for col in _columns(df1)
            current_col += 1
            @assert length(col) == targetrows
        end
    catch err
        # Undo changes in case of error
        for col in _columns(df1)
            @assert length(col) >= nrow1
            if atend
                resize!(col, nrow1)
            elseif length(col) != nrow1
                deleteat!(col, 1:length(col) - nrow1)
            end
        end
        if promote
            @error "Error adding value to column :$(_names(df1)[current_col])."
        else
            @error "Error adding value to column :$(_names(df1)[current_col]). " *
                   "Maybe you forgot passing `promote=true`?"
        end
        rethrow(err)
    end

    if cols == :union
        for n in setdiff(_names(df2), _names(df1))
            newcol = similar(df2[!, n], Union{Missing, eltype(df2[!, n])},
                             targetrows)
            firstindex(newcol) != 1 && _onebased_check_error()
            if atend
                newcol[1:nrow1] .= missing
                copyto!(newcol, nrow1+1, df2[!, n], 1, targetrows - nrow1)
            else
                newcol[nrow2+1:targetrows] .= missing
                copyto!(newcol, 1, df2[!, n], 1, nrow2)
            end
            df1[!, n] = newcol
            _copy_col_note_metadata!(df1, n, df2, n)
        end
    end

    return df1
end

const INSERTION_COMMON = """
Column types of `df` are preserved, and new values are converted if necessary.
An error is thrown if conversion fails.

If `row` is neither a `DataFrameRow`, `NamedTuple` nor `AbstractDict` then
it must be a `Tuple` or an `AbstractArray`
and columns are matched by order of appearance. In this case `row` must contain
the same number of elements as the number of columns in `df`.

If `row` is a `DataFrameRow`, `NamedTuple`, `AbstractDict`, or
`Tables.AbstractRow` then values in `row` are matched to columns in `df` based
on names. The exact behavior depends on the `cols` argument value in the
following way:
* If `cols == :setequal` (this is the default)
  then `row` must contain exactly the same columns as `df` (but possibly in a
  different order).
* If `cols == :orderequal` then `row` must contain the same columns in the same
  order (for `AbstractDict` this option requires that `keys(row)` matches
  `propertynames(df)` to allow for support of ordered dicts; however, if `row`
  is a `Dict` an error is thrown as it is an unordered collection).
* If `cols == :intersect` then `row` may contain more columns than `df`,
  but all column names that are present in `df` must be present in `row` and only
  they are used to populate a new row in `df`.
* If `cols == :subset` then the behavior is like for `:intersect` but if some
  column is missing in `row` then a `missing` value is pushed to `df`.
* If `cols == :union` then columns missing in `df` that are present in `row` are
  added to `df` (using `missing` for existing rows) and a `missing` value is
  pushed to columns missing in `row` that are present in `df`.

If `row` is not a `DataFrameRow`, `NamedTuple`, `AbstractDict`, or `Tables.AbstractRow`
the `cols` keyword argument must be `:setequal` (the default),
because such rows do not provide column name information.

If `promote=true` and element type of a column present in `df` does not allow
the type of a pushed argument then a new column with a promoted element type
allowing it is freshly allocated and stored in `df`. If `promote=false` an error
is thrown.

As a special case, if `df` has no columns and `row` is a `NamedTuple`,
`DataFrameRow`, or `Tables.AbstractRow`, columns are created for all values in
`row`, using their names and order.

Please note that this function must not be used on a
`DataFrame` that contains columns that are aliases (equal when compared with `===`).

$METADATA_FIXED
"""

"""
    push!(df::DataFrame, row::Union{Tuple, AbstractArray}...;
          cols::Symbol=:setequal, promote::Bool=false)
    push!(df::DataFrame, row::Union{DataFrameRow, NamedTuple, AbstractDict,
                                    Tables.AbstractRow}...;
          cols::Symbol=:setequal, promote::Bool=(cols in [:union, :subset]))

Add one row at the end of `df` in-place, taking the values from `row`.
Several rows can be added by passing them as separate arguments.

$INSERTION_COMMON

See also: [`pushfirst!`](@ref), [`insert!`](@ref)

# Examples
```jldoctest
julia> df = DataFrame(A='a':'c', B=1:3)
3×2 DataFrame
 Row │ A     B
     │ Char  Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3

julia> push!(df, (true, false), promote=true)
4×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3
   4 │ true      0

julia> push!(df, df[1, :])
5×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3
   4 │ true      0
   5 │ a         1

julia> push!(df, (C="something", A=11, B=12), cols=:intersect)
6×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3
   4 │ true      0
   5 │ a         1
   6 │ 11       12

julia> push!(df, Dict(:A=>1.0, :C=>1.0), cols=:union)
7×3 DataFrame
 Row │ A     B        C
     │ Any   Int64?   Float64?
─────┼──────────────────────────
   1 │ a           1  missing
   2 │ b           2  missing
   3 │ c           3  missing
   4 │ true        0  missing
   5 │ a           1  missing
   6 │ 11         12  missing
   7 │ 1.0   missing        1.0

julia> push!(df, NamedTuple(), cols=:subset)
8×3 DataFrame
 Row │ A        B        C
     │ Any      Int64?   Float64?
─────┼─────────────────────────────
   1 │ a              1  missing
   2 │ b              2  missing
   3 │ c              3  missing
   4 │ true           0  missing
   5 │ a              1  missing
   6 │ 11            12  missing
   7 │ 1.0      missing        1.0
   8 │ missing  missing  missing

julia> push!(DataFrame(a=1, b=2), (3, 4), (5, 6))
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     3      4
   3 │     5      6
```
"""
function Base.push!(df::DataFrame, row::Any;
                    cols=:setequal, promote::Bool=false)
    if cols !== :setequal
        throw(ArgumentError("`cols` can only be `:setequal` when `row` is a `$(typeof(row))` " *
                            "as this type does not provide column names"))
    end

    return _row_inserter!(df, -1, row, Val{:push}(), promote)
end

"""
    pushfirst!(df::DataFrame, row::Union{Tuple, AbstractArray}...;
               cols::Symbol=:setequal, promote::Bool=false)
    pushfirst!(df::DataFrame, row::Union{DataFrameRow, NamedTuple, AbstractDict,
                                         Tables.AbstractRow}...;
               cols::Symbol=:setequal, promote::Bool=(cols in [:union, :subset]))

Add one row at the beginning of `df` in-place, taking the values from `row`.
Several rows can be added by passing them as separate arguments.

$INSERTION_COMMON

See also: [`push!`](@ref), [`insert!`](@ref)

# Examples
```jldoctest
julia> df = DataFrame(A='a':'c', B=1:3)
3×2 DataFrame
 Row │ A     B
     │ Char  Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3

julia> pushfirst!(df, (true, false), promote=true)
4×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ true      0
   2 │ a         1
   3 │ b         2
   4 │ c         3

julia> pushfirst!(df, df[1, :])
5×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ true      0
   2 │ true      0
   3 │ a         1
   4 │ b         2
   5 │ c         3

julia> pushfirst!(df, (C="something", A=11, B=12), cols=:intersect)
6×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ 11       12
   2 │ true      0
   3 │ true      0
   4 │ a         1
   5 │ b         2
   6 │ c         3

julia> pushfirst!(df, Dict(:A=>1.0, :C=>1.0), cols=:union)
7×3 DataFrame
 Row │ A     B        C
     │ Any   Int64?   Float64?
─────┼──────────────────────────
   1 │ 1.0   missing        1.0
   2 │ 11         12  missing
   3 │ true        0  missing
   4 │ true        0  missing
   5 │ a           1  missing
   6 │ b           2  missing
   7 │ c           3  missing

julia> pushfirst!(df, NamedTuple(), cols=:subset)
8×3 DataFrame
 Row │ A        B        C
     │ Any      Int64?   Float64?
─────┼─────────────────────────────
   1 │ missing  missing  missing
   2 │ 1.0      missing        1.0
   3 │ 11            12  missing
   4 │ true           0  missing
   5 │ true           0  missing
   6 │ a              1  missing
   7 │ b              2  missing
   8 │ c              3  missing

julia> pushfirst!(DataFrame(a=1, b=2), (3, 4), (5, 6))
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     3      4
   2 │     5      6
   3 │     1      2
```
"""
function Base.pushfirst!(df::DataFrame, row::Any;
                         cols=:setequal, promote::Bool=false)
    if cols !== :setequal
        throw(ArgumentError("`cols` can only be `:setequal` when `row` is a `$(typeof(row))` " *
                            "as this type does not provide column names"))
    end

    return _row_inserter!(df, -1, row, Val{:pushfirst}(), promote)
end

"""
    insert!(df::DataFrame, index::Integer, row::Union{Tuple, AbstractArray};
            cols::Symbol=:setequal, promote::Bool=false)
    insert!(df::DataFrame, index::Integer, row::Union{DataFrameRow, NamedTuple,
                                                      AbstractDict, Tables.AbstractRow};
            cols::Symbol=:setequal, promote::Bool=(cols in [:union, :subset]))

Add one row to `df` at position `index` in-place, taking the values from `row`.
`index` must be a integer between `1` and `nrow(df)+1`.

$INSERTION_COMMON

See also: [`push!`](@ref), [`pushfirst!`](@ref)

# Examples
```jldoctest
julia> df = DataFrame(A='a':'c', B=1:3)
3×2 DataFrame
 Row │ A     B
     │ Char  Int64
─────┼─────────────
   1 │ a         1
   2 │ b         2
   3 │ c         3

julia> insert!(df, 2, (true, false), promote=true)
4×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ a         1
   2 │ true      0
   3 │ b         2
   4 │ c         3

julia> insert!(df, 5, df[1, :])
5×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ a         1
   2 │ true      0
   3 │ b         2
   4 │ c         3
   5 │ a         1

julia> insert!(df, 1, (C="something", A=11, B=12), cols=:intersect)
6×2 DataFrame
 Row │ A     B
     │ Any   Int64
─────┼─────────────
   1 │ 11       12
   2 │ a         1
   3 │ true      0
   4 │ b         2
   5 │ c         3
   6 │ a         1

julia> insert!(df, 7, Dict(:A=>1.0, :C=>1.0), cols=:union)
7×3 DataFrame
 Row │ A     B        C
     │ Any   Int64?   Float64?
─────┼──────────────────────────
   1 │ 11         12  missing
   2 │ a           1  missing
   3 │ true        0  missing
   4 │ b           2  missing
   5 │ c           3  missing
   6 │ a           1  missing
   7 │ 1.0   missing        1.0

julia> insert!(df, 3, NamedTuple(), cols=:subset)
8×3 DataFrame
 Row │ A        B        C
     │ Any      Int64?   Float64?
─────┼─────────────────────────────
   1 │ 11            12  missing
   2 │ a              1  missing
   3 │ missing  missing  missing
   4 │ true           0  missing
   5 │ b              2  missing
   6 │ c              3  missing
   7 │ a              1  missing
   8 │ 1.0      missing        1.0
```
"""
function Base.insert!(df::DataFrame, index::Integer, row::Any;
                      cols=:setequal, promote::Bool=false)
    if cols !== :setequal
        throw(ArgumentError("`cols` can only be `:setequal` when `row` is a `$(typeof(row))` " *
                            "as this type does not provide column names"))
    end

    index isa Bool && throw(ArgumentError("invalid index: $index of type Bool"))
    1 <= index <= nrow(df)+1 ||
        throw(ArgumentError("invalid index: $index for data frame with $(nrow(df)) rows"))
    return _row_inserter!(df, index, row, Val{:insert}(), promote)
end

function _row_inserter!(df::DataFrame, loc::Integer, row::Any,
                        mode::Union{Val{:push}, Val{:pushfirst}, Val{:insert}},
                        promote::Bool)
    if !(row isa Union{Tuple, AbstractArray})
        # an explicit error is thrown as this was allowed in the past
        throw(ArgumentError("it is not allowed to insert collections of type " *
                            "$(typeof(row)) into a DataFrame. Only " *
                            "`Tuple`, `AbstractArray`, `AbstractDict`, `DataFrameRow` " *
                            "and `NamedTuple` are allowed."))
    end
    nrows, ncols = size(df)
    targetrows = nrows + 1
    if length(row) != ncols
        msg = "Length of `row` does not match `DataFrame` column count."
        throw(DimensionMismatch(msg))
    end
    current_col = 0
    try
        for (i, (col, val)) in enumerate(zip(_columns(df), row))
            current_col += 1
            @assert length(col) == nrows
            S = typeof(val)
            T = eltype(col)
            if S <: T || !promote || promote_type(S, T) <: T
                mode isa Val{:push} && push!(col, val)
                mode isa Val{:pushfirst} && pushfirst!(col, val)
                mode isa Val{:insert} && insert!(col, loc, val)
            else
                newcol = Tables.allocatecolumn(promote_type(S, T), targetrows)
                firstindex(newcol) != 1 && _onebased_check_error()
                if mode isa Val{:push}
                    copyto!(newcol, 1, col, 1, nrows)
                    newcol[end] = val
                elseif mode isa Val{:pushfirst}
                    newcol[1] = val
                    copyto!(newcol, 2, col, 1, nrows)
                elseif mode isa Val{:insert}
                    copyto!(newcol, 1, col, 1, loc-1)
                    newcol[loc] = val
                    copyto!(newcol, loc+1, col, loc, nrows-loc+1)
                end
                _columns(df)[i] = newcol
            end
        end
    catch err
        # clean up partial row
        for j in 1:current_col
            col2 = _columns(df)[j]
            if length(col2) == targetrows
                mode isa Val{:push} && pop!(col2)
                mode isa Val{:pushfirst} && popfirst!(col2)
                mode isa Val{:insert} && deleteat!(col2, loc)
            end
            @assert length(col2) == nrows
        end
        if promote
            @error "Error adding value to column :$(_names(df)[current_col])."
        else
            @error "Error adding value to column :$(_names(df)[current_col]). " *
                   "Maybe you forgot passing `promote=true`?"
        end
        rethrow(err)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

Base.push!(df::DataFrame, row::DataFrameRow;
           cols::Symbol=:setequal,
           promote::Bool=(cols in [:union, :subset])) =
    _dfr_row_inserter!(df, -1, row, Val{:push}(), cols, promote)

Base.pushfirst!(df::DataFrame, row::DataFrameRow;
                cols::Symbol=:setequal,
                promote::Bool=(cols in [:union, :subset])) =
    _dfr_row_inserter!(df, -1, row, Val{:pushfirst}(), cols, promote)

function Base.insert!(df::DataFrame, index::Integer, row::DataFrameRow;
                      cols::Symbol=:setequal, promote::Bool=(cols in [:union, :subset]))
    index isa Bool && throw(ArgumentError("invalid index: $index of type Bool"))
    1 <= index <= nrow(df)+1 ||
        throw(ArgumentError("invalid index: $index for data frame with $(nrow(df)) rows"))
    _dfr_row_inserter!(df, index, row, Val{:insert}(), cols, promote)
end

@noinline pushhelper!(x::AbstractVector, r::Any) =
    push!(x, x[r])

@noinline pushfirsthelper!(x::AbstractVector, r::Any) =
    pushfirst!(x, x[r])

@noinline inserthelper!(x::AbstractVector, loc::Integer, r::Any) =
    insert!(x, loc, x[r])

function _dfr_row_inserter!(df::DataFrame, loc::Integer, dfr::DataFrameRow,
                            mode::Union{Val{:push}, Val{:pushfirst}, Val{:insert}},
                            cols::Symbol, promote::Bool)
    possible_cols = (:orderequal, :setequal, :intersect, :subset, :union)
    if !(cols in possible_cols)
        throw(ArgumentError("`cols` keyword argument must be any of :" *
                            join(possible_cols, ", :")))
    end

    nrows = nrow(df)
    targetrows = nrows + 1

    if parent(dfr) === df && index(dfr) isa Index
        # in this case we are sure that all we do is safe
        r = row(dfr)
        for (col_num, col) in enumerate(_columns(df))
            if length(col) != nrows
                for j in 1:col_num
                    col2 = _columns(df)[j]
                    if length(col2) == targetrows
                        mode isa Val{:push} && pop!(col2)
                        mode isa Val{:pushfirst} && popfirst!(col2)
                        mode isa Val{:insert} && deleteat!(col2, loc)
                    end
                    @assert length(col2) == nrows
                end
                colname = _names(df)[col_num]
                throw(AssertionError("Error adding value to column :$colname."))
            end
            # use a function barrier to improve performance
            mode isa Val{:push} && pushhelper!(col, r)
            mode isa Val{:pushfirst} && pushfirsthelper!(col, r)
            mode isa Val{:insert} && inserthelper!(col, loc, r)
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end

    return _row_inserter!(df, loc, dfr, mode, cols, promote, nrows)
end

Base.push!(df::DataFrame,
           row::Union{AbstractDict, NamedTuple, Tables.AbstractRow};
           cols::Symbol=:setequal,
           promote::Bool=(cols in [:union, :subset])) =
    _row_inserter!(df, -1, row, Val{:push}(), cols, promote, -1)

Base.pushfirst!(df::DataFrame,
                row::Union{AbstractDict, NamedTuple, Tables.AbstractRow};
                cols::Symbol=:setequal,
                promote::Bool=(cols in [:union, :subset])) =
    _row_inserter!(df, -1, row, Val{:pushfirst}(), cols, promote, -1)

function Base.insert!(df::DataFrame, loc::Integer,
                      row::Union{AbstractDict, NamedTuple, Tables.AbstractRow};
                      cols::Symbol=:setequal,
                      promote::Bool=(cols in [:union, :subset]))
    loc isa Bool && throw(ArgumentError("invalid index: $loc of type Bool"))
    1 <= loc <= nrow(df)+1 ||
        throw(ArgumentError("invalid index: $loc for data frame with $(nrow(df)) rows"))
    return _row_inserter!(df, loc, row, Val{:insert}(), cols, promote, -1)
end

function _row_inserter!(df::DataFrame, loc::Integer,
                        row::Union{AbstractDict, NamedTuple, DataFrameRow,
                                   Tables.AbstractRow},
                        mode::Union{Val{:push}, Val{:pushfirst}, Val{:insert}},
                        cols::Symbol, promote::Bool, nrows::Int)
    if nrows == -1
        @assert row isa Union{AbstractDict, NamedTuple, Tables.AbstractRow}
        possible_cols = (:orderequal, :setequal, :intersect, :subset, :union)
        if !(cols in possible_cols)
            throw(ArgumentError("`cols` keyword argument must be any of :" *
                                join(possible_cols, ", :")))
        end
        nrows = nrow(df)
    else
        @assert row isa DataFrameRow
    end

    ncols = ncol(df)
    targetrows = nrows + 1

    if ncols == 0 && row isa Union{NamedTuple, DataFrameRow, Tables.AbstractRow}
        for (n, v) in pairs(row)
            setproperty!(df, n, fill!(Tables.allocatecolumn(typeof(v), 1), v))
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end

    old_row_type = typeof(row)
    if row isa AbstractDict && keytype(row) !== Symbol &&
        (keytype(row) <: AbstractString || all(x -> x isa AbstractString, keys(row)))
        row = (;(Symbol.(keys(row)) .=> values(row))...)
    end

    # in the code below we use a direct access to _columns because
    # we resize the columns so temporarily the `DataFrame` is internally
    # inconsistent and normal data frame indexing would error.
    if cols == :union
        if row isa AbstractDict && keytype(row) !== Symbol && !all(x -> x isa Symbol, keys(row))
            throw(ArgumentError("when `cols == :union` all keys of row must be Symbol"))
        end
        for (i, colname) in enumerate(_names(df))
            col = _columns(df)[i]
            if length(col) != nrows
                for j in 1:i
                    col2 = _columns(df)[j]
                    if length(col2) == targetrows
                        mode isa Val{:push} && pop!(col2)
                        mode isa Val{:pushfirst} && popfirst!(col2)
                        mode isa Val{:insert} && deleteat!(col2, loc)
                    end
                    @assert length(col2) == nrows
                end
                throw(AssertionError("Error adding value to column :$colname."))
            end
            val = get(row, colname, missing)
            S = typeof(val)
            T = eltype(col)
            if S <: T || promote_type(S, T) <: T
                mode isa Val{:push} && push!(col, val)
                mode isa Val{:pushfirst} && pushfirst!(col, val)
                mode isa Val{:insert} && insert!(col, loc, val)
            elseif !promote
                try
                    mode isa Val{:push} && push!(col, val)
                    mode isa Val{:pushfirst} && pushfirst!(col, val)
                    mode isa Val{:insert} && insert!(col, loc, val)
                catch err
                    for j in 1:i
                        col2 = _columns(df)[j]
                        if length(col2) == targetrows
                            mode isa Val{:push} && pop!(col2)
                            mode isa Val{:pushfirst} && popfirst!(col2)
                            mode isa Val{:insert} && deleteat!(col2, loc)
                        end
                        @assert length(col2) == nrows
                    end
                    @error "Error adding value to column :$colname. " *
                           "Maybe you forgot passing `promote=true`?"
                    rethrow(err)
                end
            else
                newcol = similar(col, promote_type(S, T), targetrows)
                firstindex(newcol) != 1 && _onebased_check_error()
                if mode isa Val{:push}
                    copyto!(newcol, 1, col, 1, nrows)
                    newcol[end] = val
                elseif mode isa Val{:pushfirst}
                    newcol[1] = val
                    copyto!(newcol, 2, col, 1, nrows)
                elseif mode isa Val{:insert}
                    copyto!(newcol, 1, col, 1, loc-1)
                    newcol[loc] = val
                    copyto!(newcol, loc+1, col, loc, nrows-loc+1)
                end
                _columns(df)[i] = newcol
            end
        end
        for colname in setdiff(keys(row), _names(df))
            val = row[colname]
            S = typeof(val)
            if nrows == 0
                mode isa Val{:insert} && @assert loc == 1
                newcol = Tables.allocatecolumn(S, targetrows)
            else
                newcol = Tables.allocatecolumn(Union{Missing, S}, targetrows)
                fill!(newcol, missing)
            end
            firstindex(newcol) != 1 && _onebased_check_error()
            mode isa Val{:push} && (newcol[end] = val)
            mode isa Val{:pushfirst} && (newcol[1] = val)
            mode isa Val{:insert} && (newcol[loc] = val)
            df[!, colname] = newcol
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end

    if cols == :orderequal
        if old_row_type <: Dict
            throw(ArgumentError("passing `Dict` as `row` when `cols == :orderequal` " *
                                "is not allowed as it is unordered"))
        elseif length(row) != ncol(df) || any(x -> x[1] != x[2], zip(keys(row), _names(df)))
            throw(ArgumentError("when `cols == :orderequal` pushed row must " *
                                "have the same column names and in the " *
                                "same order as the target data frame"))
        end
    elseif cols === :setequal
        # Only check for equal lengths if :setequal is selected,
        # as an error will be thrown below if some names don't match
        if length(row) != ncols
            # an explicit error is thrown as this was allowed in the past
            throw(ArgumentError("row insertion with `cols` equal to `:setequal` " *
                                "requires `row` to have the same number of elements " *
                                "as the number of columns in `df`."))
        end
    end

    current_col = 0
    try
        for (col, nm) in zip(_columns(df), _names(df))
            current_col += 1
            @assert length(col) == nrows
            if cols === :subset
                val = get(row, nm, missing)
            else
                val = row[nm]
            end
            S = typeof(val)
            T = eltype(col)
            if S <: T || !promote || promote_type(S, T) <: T
                mode isa Val{:push} && push!(col, val)
                mode isa Val{:pushfirst} && pushfirst!(col, val)
                mode isa Val{:insert} && insert!(col, loc, val)
            else
                newcol = similar(col, promote_type(S, T), targetrows)
                firstindex(newcol) != 1 && _onebased_check_error()
                if mode isa Val{:push}
                    copyto!(newcol, 1, col, 1, nrows)
                    newcol[end] = val
                elseif mode isa Val{:pushfirst}
                    newcol[1] = val
                    copyto!(newcol, 2, col, 1, nrows)
                elseif mode isa Val{:insert}
                    copyto!(newcol, 1, col, 1, loc-1)
                    newcol[loc] = val
                    copyto!(newcol, loc+1, col, loc, nrows-loc+1)
                end
                _columns(df)[columnindex(df, nm)] = newcol
            end
        end
    catch err
        @assert current_col > 0
        for j in 1:current_col
            col2 = _columns(df)[j]
            if length(col2) == targetrows
                mode isa Val{:push} && pop!(col2)
                mode isa Val{:pushfirst} && popfirst!(col2)
                mode isa Val{:insert} && deleteat!(col2, loc)
            end
            @assert length(col2) == nrows
        end
        if promote
            @error "Error adding value to column :$(_names(df)[current_col])."
        else
            @error "Error adding value to column :$(_names(df)[current_col]). " *
                   "Maybe you forgot passing `promote=true`?"
        end
        rethrow(err)
    end
    _drop_all_nonnote_metadata!(df)
    return df
end

function Base.push!(df::DataFrame, @nospecialize rows...;
                    cols::Symbol=:setequal,
                    promote::Bool=(cols in [:union, :subset]))
    if !(cols in (:orderequal, :setequal, :intersect, :subset, :union))
        throw(ArgumentError("`cols` keyword argument must be " *
                            ":orderequal, :setequal, :intersect, :subset or :union)"))
    end
    with_names_count = count(rows) do row
        row isa Union{DataFrameRow,AbstractDict,NamedTuple,Tables.AbstractRow}
    end
    if 0 < with_names_count < length(rows)
        throw(ArgumentError("Mixing rows with column names and without column names " *
                            "in a single `push!` call is not allowed"))
    end
    return foldl((df, row) -> push!(df, row, cols=cols, promote=promote), rows, init=df)
end

function Base.pushfirst!(df::DataFrame, @nospecialize rows...;
                         cols::Symbol=:setequal,
                         promote::Bool=(cols in [:union, :subset]))
    if !(cols in (:orderequal, :setequal, :intersect, :subset, :union))
        throw(ArgumentError("`cols` keyword argument must be " *
                            ":orderequal, :setequal, :intersect, :subset or :union)"))
    end
    with_names_count = count(rows) do row
        row isa Union{DataFrameRow,AbstractDict,NamedTuple,Tables.AbstractRow}
    end
    if 0 < with_names_count < length(rows)
        throw(ArgumentError("Mixing rows with column names and without column names " *
                            "in a single `push!` call is not allowed"))
    end
    return foldr((row, df) -> pushfirst!(df, row, cols=cols, promote=promote), rows, init=df)
end

module TestMultithreading

using Test, DataFrames

@testset "split_indices" begin
    for len in 1:100, basesize in 1:10
        x = DataFrames.split_indices(len, basesize)

        @test length(x) == max(1, div(len, basesize))
        @test reduce(vcat, x) == 1:len
        vmin, vmax = extrema(length(v) for v in x)
        @test vmin + 1 == vmax || vmin == vmax
        @test len < basesize || vmin >= basesize
    end

    @test_throws AssertionError DataFrames.split_indices(0, 10)
    @test_throws AssertionError DataFrames.split_indices(10, 0)

    # Check overflow on 32-bit
    len = typemax(Int32)
    basesize = 100_000_000
    x = collect(DataFrames.split_indices(len, basesize))
    @test length(x) == div(len, basesize)
    @test x[1][1] === 1
    @test x[end][end] === Int(len)
    vmin, vmax = extrema(length(v) for v in x)
    @test vmin + 1 == vmax || vmin == vmax
    @test len < basesize || vmin >= basesize
end

@testset "split_to_chunks" begin
    for lg in 1:100, nt in 1:11
        if lg < nt
            @test_throws AssertionError DataFrames.split_to_chunks(lg, nt)
            continue
        end
        x = collect(DataFrames.split_to_chunks(lg, nt))
        @test reduce(vcat, x) == 1:lg
        @test sum(length, x) == lg
        @test first(x[1]) == 1
        @test last(x[end]) == lg
        @test length(x) == nt
        for i in 1:nt-1
            @test first(x[i+1])-last(x[i]) == 1
        end
    end

    @test_throws AssertionError DataFrames.split_to_chunks(0, 10)
    @test_throws AssertionError DataFrames.split_to_chunks(10, 0)
    @test_throws AssertionError DataFrames.split_to_chunks(10, 11)
end

@testset "@spawn_or_run_task and @spawn_or_run" begin
    for threads in (true, false)
        t = DataFrames.@spawn_or_run_task threads 1
        @test fetch(t) === 1

        x = Ref(false)
        @sync begin
            t = DataFrames.@spawn_or_run_task threads begin
                sleep(0.1)
                x[] = true
            end
        end
        @test x[]

        x = Ref(false)
        @sync begin
            res = DataFrames.@spawn_or_run threads begin
                sleep(0.1)
                x[] = true
            end
            @test res === nothing
        end
        @test x[]
    end
end

@testset "disabling multithreading via keyword argument" begin
    refdf = DataFrame(x=1:1000, y=rand(1:4, 1000))

    # On DataFrame
    df = copy(refdf)
    n = Ref(0)
    @test combine(df, [] => (() -> n[] += 1) => :n1,
                  [] => (() -> n[] += 1) => :n2,
                  threads=false) ==
        DataFrame(n1=1, n2=2)
    n = Ref(0)
    @test combine(df, [] => ByRow(() -> n[] += 1) => :n1,
                  [] => ByRow(() -> n[] += 1) => :n2,
                  threads=false) ==
        DataFrame(n1=1:1000, n2=1001:2000)

    df = copy(refdf)
    m = Ref(0)
    n = Ref(0)
    @test select(df, [] => (() -> m[] += 1) => :n1,
                  [] => (() -> m[] += 1) => :n2,
                  threads=false) ==
        select!(df, [] => (() -> n[] += 1) => :n1,
                  [] => (() -> n[] += 1) => :n2,
                  threads=false) ==
        DataFrame(n1=fill(1, 1000), n2=fill(2, 1000))
    df = copy(refdf)
    m = Ref(0)
    n = Ref(0)
    @test select(df, [] => ByRow(() -> m[] += 1) => :n1,
                  [] => ByRow(() -> m[] += 1) => :n2,
                  threads=false) ==
        select!(df, [] => ByRow(() -> n[] += 1) => :n1,
                  [] => ByRow(() -> n[] += 1) => :n2,
                  threads=false) ==
        DataFrame(n1=1:1000, n2=1001:2000)

    df = copy(refdf)
    m = Ref(0)
    n = Ref(0)
    @test transform(df, [] => (() -> m[] += 1) => :n1,
                    [] => (() -> m[] += 1) => :n2,
                    threads=false) ==
        transform!(df, [] => (() -> n[] += 1) => :n1,
                   [] => (() -> n[] += 1) => :n2,
                   threads=false) ==
        [refdf DataFrame(n1=fill(1, 1000), n2=fill(2, 1000))]
    df = copy(refdf)
    m = Ref(0)
    n = Ref(0)
    @test transform(df, [] => ByRow(() -> m[] += 1) => :n1,
                    [] => ByRow(() -> m[] += 1) => :n2,
                    threads=false) ==
        transform(df, [] => ByRow(() -> n[] += 1) => :n1,
                  [] => ByRow(() -> n[] += 1) => :n2,
                  threads=false) ==
        [refdf DataFrame(n1=1:1000, n2=1001:2000)]

    df = copy(refdf)
    m = Ref(0)
    n = Ref(0)
    @test df[1:100,:] ==
        subset(df, [] => ByRow(() -> (m[] += 1; m[] <= 100)),
                 [] => ByRow(() -> (m[] += 1; m[] <= 1100)),
                 threads=false) ==
        subset(df, [] => ByRow(() -> (n[] += 1; n[] <= 100)),
                 [] => ByRow(() -> (n[] += 1; n[] <= 1100)),
                 threads=false)

    # On GroupedDataFrame
    df = copy(refdf)
    gd = groupby(df, :y)
    n = Ref(0)
    @test combine(gd, [] => (() -> n[] += 1) => :n1,
                  [] => (() -> n[] += 1) => :n2,
                  threads=false) ==
        DataFrame(y=1:4, n1=1:4, n2=5:8)
    if Threads.nthreads() > 1
        @test combine(gd, [] => (() -> Threads.threadid()) => :id1,
                      [] => (() -> Threads.threadid()) => :id2,
                      threads=true) !=
            DataFrame(y=1:4, id1=1, id2=1)
    end

    df = copy(refdf)
    gd = groupby(df, :y)
    m = Ref(0)
    n = Ref(0)
    @test select(gd, [] => (() -> m[] += 1) => :n1,
                 [] => (() -> m[] += 1) => :n2,
                 threads=false) ==
        select!(gd, [] => (() -> n[] += 1) => :n1,
                [] => (() -> n[] += 1) => :n2,
                threads=false) ==
        select(leftjoin(refdf, DataFrame(y=1:4, n1=1:4, n2=5:8), on=:y), :y, :n1, :n2)
    if Threads.nthreads() > 1
        df = copy(refdf)
        gd = groupby(df, :y)
        @test select(gd, [] => (() -> Threads.threadid()) => :id1,
                     [] => (() -> Threads.threadid()) => :id2,
                     threads=true) !=
            DataFrame(y=refdf.y, id1=1, id2=1)
        @test select!(gd, [] => (() -> Threads.threadid()) => :id1,
                      [] => (() -> Threads.threadid()) => :id2,
                      threads=true) !=
            DataFrame(y=refdf.y, id1=1, id2=1)
    end

    df = copy(refdf)
    gd = groupby(df, :y)
    m = Ref(0)
    n = Ref(0)
    @test transform(gd, [] => (() -> m[] += 1) => :n1,
                    [] => (() -> m[] += 1) => :n2,
                    threads=false) ==
        transform!(gd, [] => (() -> n[] += 1) => :n1,
                [] => (() -> n[] += 1) => :n2,
                    threads=false) ==
        leftjoin(refdf, DataFrame(y=1:4, n1=1:4, n2=5:8), on=:y)
    if Threads.nthreads() > 1
        df = copy(refdf)
        gd = groupby(df, :y)
        @test transform(gd, [] => (() -> Threads.threadid()) => :id1,
                        [] => (() -> Threads.threadid()) => :id2,
                        threads=true) !=
            [refdf DataFrame(id1=fill(1, nrow(refdf)), id2=1)]
        @test transform!(gd, [] => (() -> Threads.threadid()) => :id1,
                         [] => (() -> Threads.threadid()) => :id2,
                         threads=true) !=
            [refdf DataFrame(id1=fill(1, nrow(refdf)), id2=1)]
    end

    df = copy(refdf)
    gd = groupby(df, :y)
    m = Ref(0)
    n = Ref(0)
    @test df[in.(df.y, Ref((keys(gd)[1].y, keys(gd)[2].y))),:] ==
        subset(gd, [:y] => (y -> (m[] += 1; fill(m[] <= 2, length(y)))),
               [:y] => (y -> (m[] += 1; fill(m[] <= 6, length(y)))),
               threads=false) ==
        subset!(gd, [:y] => (y -> (n[] += 1; fill(n[] <= 2, length(y)))),
                [:y] => (y -> (n[] += 1; fill(n[] <= 6, length(y)))),
                threads=false)

    # unstack
    df = DataFrame(id=[1, 1, 1, 2, 2, 3, 3],
                   variable=[:a, :a, :b, :a, :b, :a, :b],
                   value=1:7)
    l = Ref(0)
    m = Ref(0)
    n = Ref(0)
    unstack(df, combine=x -> (l[] += 1),
            threads=false) ==
            DataFrame(id=1:3, a=[1, 3, 5], b=[2, 4, 6]) ==
    unstack(df, :variable, :value, combine=x -> (m[] += 1),
            threads=false) ==
            DataFrame(id=1:3, a=[1, 3, 5], b=[2, 4, 6]) ==
    unstack(df, :id, :variable, :value, combine=x -> (n[] += 1),
            threads=false) ==
            DataFrame(id=1:3, a=[1, 3, 5], b=[2, 4, 6])

    # describe
    df = DataFrame(x=1:10, y=2:11)
    n = Ref(0)
    @test describe(df, cols=All() .=> (x -> (n[] += 1))) ==
        describe(DataFrame(x_function=1, y_function=2))
    n = Ref(0)
    @test describe(df, cols=All() .=> ByRow(x -> (n[] += 1))) ==
        describe(DataFrame(x_function=1:10, y_function=11:20))

    # nonunique
    df = DataFrame(x=1:10, y=2:11)
    n = Ref(0)
    @test nonunique(df, [:x => (x -> (@assert(n[] == 0); n[] += 1)),
                         :y => (y -> (@assert(n[] == 1); n[] += 1))]) ==
        [false, true, true, true, true, true, true, true, true, true]
    n = Ref(0)
    @test nonunique(df, [:x => ByRow(x -> (n[] == 2 ? n[] = 1 : n[] += 1)),
                         :y => ByRow(x -> (n[] == 4 ? n[] = 1 : n[] += 1))]) ==
        [false, false, false, false, true, true, true, true, true, true]

end

end # module

function Base.show(io::IO, dfr::DataFrameRow;
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   eltypes::Bool = true,
                   truncate::Int = 32,
                   kwargs...)
    # Check for keywords that are valid in other backends but not here.
    _verify_kwargs_for_text(; kwargs...)

    r, c = parentindices(dfr)
    _show(io, view(parent(dfr), [r], c); allcols=allcols, rowlabel=rowlabel,
          summary=false, rowid=r, eltypes=eltypes, truncate=truncate,
          title="DataFrameRow", kwargs...)
end

Base.show(io::IO, mime::MIME"text/plain", dfr::DataFrameRow;
          allcols::Bool = !get(io, :limit, false),
          rowlabel::Symbol = :Row,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(io, dfr; allcols=allcols, rowlabel=rowlabel, eltypes=eltypes,
         truncate=truncate, kwargs...)

Base.show(dfr::DataFrameRow;
          allcols::Bool = !get(stdout, :limit, true),
          rowlabel::Symbol = :Row,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(stdout, dfr; allcols=allcols, rowlabel=rowlabel, eltypes=eltypes,
         truncate=truncate, kwargs...)

function Base.show(io::IO, mime::MIME"text/html", dfr::DataFrameRow; kwargs...)
    _verify_kwargs_for_html(; kwargs...)
    r, c = parentindices(dfr)
    title = "DataFrameRow ($(length(dfr)) columns)"
    _show(io, mime, view(parent(dfr), [r], c); rowid=r, title=title, kwargs...)
end

function Base.show(io::IO, mime::MIME"text/latex", dfr::DataFrameRow; eltypes::Bool=true)
    r, c = parentindices(dfr)
    _show(io, mime, view(parent(dfr), [r], c), eltypes=eltypes, rowid=r)
end

function Base.show(io::IO, mime::MIME"text/csv", dfr::DataFrameRow)
    r, c = parentindices(dfr)
    show(io, mime, view(parent(dfr), [r], c))
end

function Base.show(io::IO, mime::MIME"text/tab-separated-values", dfr::DataFrameRow)
    r, c = parentindices(dfr)
    show(io, mime, view(parent(dfr), [r], c))
end

module TestStringIndexing

using Test, DataFrames

@testset "iteration" begin
    df = DataFrame(a=1:2, b=3:4)
    er = eachrow(df)
    ec = eachcol(df)
    @test er.a == er."a" == ec.a == ec."a" == df.a == df."a"
    @test_throws ArgumentError er.c
    @test_throws ArgumentError er."c"
    @test_throws ArgumentError ec.c
    @test_throws ArgumentError ec."c"
    @test_throws ArgumentError df.c
    @test_throws ArgumentError df."c"
    @test hasproperty(er, :a) == hasproperty(er, "a") ==
          hasproperty(ec, :a) == hasproperty(ec, "a") ==
          hasproperty(df, :a) == hasproperty(df, "a") == true
    @test hasproperty(er, :c) == hasproperty(er, "c") ==
          hasproperty(ec, :c) == hasproperty(ec, "c") ==
          hasproperty(df, :c) == hasproperty(df, "c") == false

    @test keys(er) == 1:2
    @test propertynames(er) == propertynames(ec) == propertynames(df) ==
          keys(ec) == [:a, :b]
    @test_throws MethodError keys(df)
end

@testset "joins" begin
    df1 = DataFrame(a=1, b=2)
    df2 = DataFrame(a=1, c=2)
    df3 = DataFrame(a=1, d=2)

    # only check if the output is the same in all cases
    for f in (innerjoin, leftjoin, rightjoin, outerjoin, antijoin, semijoin)
        @test f(df1, df2, on=:a) == f(df1, df2, on="a") ==
              f(df1, df2, on=[:a]) == f(df1, df2, on=["a"]) ==
              f(df1, df2, on=:a => :a) == f(df1, df2, on="a" => "a") ==
              f(df1, df2, on=[:a => :a]) == f(df1, df2, on=["a" => "a"])
        @test_throws TypeError f(df1, df2, on = :a => "a")
        @test_throws ArgumentError f(df1, df2, on = [:a => "a"])

        if f === innerjoin || f === outerjoin
            @test f(df1, df2, df3, on=:a) == f(df1, df2, df3, on="a") ==
                  f(df1, df2, df3, on=[:a]) == f(df1, df2, df3, on=["a"]) ==
                  f(df1, df2, df3, on=:a => :a) == f(df1, df2, df3, on="a" => "a") ==
                  f(df1, df2, df3, on=[:a => :a]) == f(df1, df2, df3, on=["a" => "a"])
            @test_throws TypeError f(df1, df2, df3, on = :a => "a")
            @test_throws ArgumentError f(df1, df2, df3, on = [:a => "a"])
        end
    end
end

@testset "reshape" begin
    df = DataFrame(a=repeat([1:3;], inner=[4]),
                   b=repeat([1:4;], inner=[3]),
                   c=1:12, d=1.0:12.0,
                   e=map(string, 'a':'l'))

    # only check if the output is the same in all cases
    for v in (true, false)
        @test stack(df, [:c, :d], [:a], variable_name=:varn, value_name=:valn, view=v) ==
              stack(df, ["c", "d"], ["a"], variable_name="varn", value_name="valn", view=v)
    end

    wide = DataFrame(id=1:12,
                     a=repeat([1:3;], inner=[4]),
                     b=repeat([1:4;], inner=[3]),
                     c=randn(12),
                     d=randn(12))

    long = stack(wide)
    @test unstack(long, :variable, :value) == unstack(long, "variable", "value")
    @test unstack(long, :id, :variable, :value) ==
          unstack(long, "id", "variable", "value")
    @test unstack(long, [:id, :a], :variable, :value) ==
          unstack(long, ["id", "a"], "variable", "value")
    @test unstack(long, :id, :variable, :value, renamecols=x->Symbol(:_, x)) ==
          unstack(long, "id", "variable", "value", renamecols=x->"_"*x)
end

@testset "selection" begin
    df = DataFrame(a=1:2, b=3:4)
    # only check if the output is the same in all cases
    @test select(df, :a, :b => :d, :b => identity => :d2, :b => identity,
                 [:a, :a] => (+), [:a, :a] => (+) => :e, AsTable(:a) => ByRow(first),
                 nrow => :xxx) ==
          select(df, "a", "b" => "d", "b" => identity => "d2", "b" => identity,
                 ["a", "a"] => (+), ["a", "a"] => (+) => "e", AsTable("a") => ByRow(first),
                 nrow => "xxx")
    @test transform(df, :a, :b => :d, :b => identity => :d2, :b => identity,
                    [:a, :a] => (+), [:a, :a] => (+) => :e, AsTable(:a) => ByRow(first),
                    nrow => :xxx) ==
          transform(df, "a", "b" => "d", "b" => identity => "d2", "b" => identity,
                    ["a", "a"] => (+), ["a", "a"] => (+) => "e", AsTable("a") => ByRow(first),
                    nrow => "xxx")
    @test select(df, [:a]) == select(df, ["a"]) ==
          select(df, :a) == select(df, "a")
    @test transform(df, [:a]) == transform(df, ["a"]) ==
          transform(df, :a) == transform(df, "a")

    df2 = copy(df)
    @test select!(df, :a, :b => :d, :b => identity => :d2, :b => identity,
                  [:a, :a] => (+), [:a, :a] => (+) => :e, AsTable(:a) => ByRow(first),
                  nrow => :xxx) ==
          select!(df2, "a", "b" => "d", "b" => identity => "d2", "b" => identity,
                  ["a", "a"] => (+), ["a", "a"] => (+) => "e", AsTable("a") => ByRow(first),
                  nrow => "xxx")

    df = DataFrame(a=1:2, b=3:4)
    df2 = copy(df)
    @test select!(df, [:a]) == select!(df2, ["a"])

    df = DataFrame(a=1:2, b=3:4)
    df2 = copy(df)
    @test select!(df, :a) == select!(df2, "a")

    df = DataFrame(a=1:2, b=3:4)
    df2 = copy(df)
    @test transform!(df, :a, :b => :d, :b => identity => :d2, :b => identity,
                    [:a, :a] => (+), [:a, :a] => (+) => :e, AsTable(:a) => ByRow(first),
                    nrow => :xxx) ==
          transform!(df2, "a", "b" => "d", "b" => identity => "d2", "b" => identity,
                    ["a", "a"] => (+), ["a", "a"] => (+) => "e", AsTable("a") => ByRow(first),
                    nrow => "xxx")

    df = DataFrame(a=1:2, b=3:4)
    df2 = copy(df)
    @test transform!(df, [:a]) == transform!(df2, ["a"])

    df = DataFrame(a=1:2, b=3:4)
    df2 = copy(df)
    @test transform!(df, :a) == transform!(df2, "a")

    df = DataFrame(a=1:2, b=3:4)
    @test_throws ArgumentError select(df, [:a, "b"])
    @test_throws ArgumentError select(df, ["a", :b])
    @test_throws ArgumentError select(df, ["a", "b", "a"])
end

@testset "tables" begin
    df = DataFrame(a=1:2, b=3:4)

    @test columnindex(df, :a) == columnindex(df, "a")
    @test columnindex(df, :c) == columnindex(df, "c")

    @test Tables.schema(df) == Tables.schema(Tables.columntable(df))
    @test [:a, :b] == Tables.columnnames(df) == Tables.columnnames(df[1, :]) ==
          Tables.columnnames(eachrow(df)) == Tables.columnnames(eachcol(df))
end

@testset "split-apply-combine" begin
    df = DataFrame(g=[1, 1, 1, 2, 2], a=1:5)

    # only check if the output is the same in all cases
    gdf = groupby(df, :g)
    @test gdf == groupby(df, "g")
    @test groupby(df, [:g, :a]) == groupby(df, ["g", "a"])

    @test names(gdf) == ["g", "a"]

    k = keys(gdf)
    @test names(k[1]) == ["g"]
    @test propertynames(k[1]) == keys(k[1]) == [:g]
    @test haskey(k[1], :g) == haskey(k[1], "g") == true
    @test haskey(k[1], :a) == haskey(k[1], "a") == false
    @test  k[1].g == k[1]."g" == k[1][:g] == k[1]["g"]

    @test combine(gdf, :a) == combine(gdf, "a") ==
          combine(gdf, [:a]) == combine(gdf, ["a"])

    @test combine(gdf, "a" => identity, ungroup=false) ==
          combine(gdf, :a => identity, ungroup=false)
    @test combine(gdf, ["a"] => identity, ungroup=false) ==
          combine(gdf, [:a] => identity, ungroup=false)
    @test combine(gdf, nrow => :n, ungroup=false) ==
          combine(gdf, nrow => "n", ungroup=false)

    @test combine(gdf, "a" => identity) == combine(gdf, :a => identity)
    @test combine(gdf, ["a"] => identity) == combine(gdf, [:a] => identity)
    @test combine(gdf, nrow => :n) == combine(gdf, nrow => "n")
end

@testset "DataFrameRow" begin
    dfr = DataFrame(a=1:2, b=3:4, c=5:6)[2, ["c", "a"]]
    @test names(dfr) == ["c", "a"]
    @test names(dfr, "a") == names(dfr, :a) == names(dfr, 2) == names(dfr, Not("c")) ==
          names(dfr, ["a"]) == names(dfr, Cols("a")) == names(dfr, Between("a", "a")) == ["a"]
    @test keys(dfr) == propertynames(dfr) == [:c, :a]
    @test haskey(dfr, :a) == haskey(dfr, "a") == true
    @test haskey(dfr, :z) == haskey(dfr, "z") == false
    @test hasproperty(dfr, :a) == hasproperty(dfr, "a") == true
    @test hasproperty(dfr, :z) == hasproperty(dfr, "z") == false
    @test dfr["a"] == dfr[:a] == dfr[2]
    dfr["a"] = 1000
    @test dfr."a" == 1000
    dfr[1:2] = Dict("a" => 100, "c" => 500)
    @test dfr.a == 100
    @test dfr.c == 500
    @test_throws ArgumentError dfr[1:2] = Dict("a" => 100, "f" => 500)
    @test_throws ArgumentError dfr[1:2] = Dict("a" => 100, :c => 500)
end

@testset "names, propertynames and hasproperty" begin
    df = DataFrame(a=1, x1=2, x2=3, x3=4)
    sdf = view(df, 1:1, 1:3)
    dfr = view(df, 1:1, 1:3)
    er = eachrow(df)
    ec = eachcol(df)
    gdf = groupby(df, :a)

    for v in [df, er, ec]
        @test names(v) == ["a", "x1", "x2", "x3"]
        @test propertynames(v) == [:a, :x1, :x2, :x3]
        @test hasproperty(v, :a)
        @test !hasproperty(v, :x)
        @test hasproperty(v, "a")
        @test !hasproperty(v, "x")
        @test names(v, 1) == names(v, :a) == names(v, "a") == ["a"]
        @test names(v, Not(:a)) == names(v, Not("a")) == names(v, Not(1)) ==
              names(v, r"x") == ["x1", "x2", "x3"]
    end

    @test names(gdf) == ["a", "x1", "x2", "x3"]
    @test names(gdf, 1) == names(gdf, :a) == names(gdf, "a") == ["a"]
    @test names(gdf, Not(:a)) == names(gdf, Not("a")) == names(gdf, Not(1)) ==
          names(gdf, r"x") == ["x1", "x2", "x3"]


    for v in [sdf, dfr]
        @test names(v) == ["a", "x1", "x2"]
        @test propertynames(v) == [:a, :x1, :x2]
        @test names(v, 1) == names(v, :a) == names(v, "a") == ["a"]
        @test names(v, Not(:a)) == names(v, Not("a")) == names(v, Not(1)) ==
              names(v, r"x") == ["x1", "x2"]
        @test hasproperty(v, :a)
        @test !hasproperty(v, :x)
        @test hasproperty(v, "a")
        @test !hasproperty(v, "x")
    end
end

@testset "append! and push!" begin
    df = DataFrame(a=1, b=2)
    append!(df, Dict("a" => 2, "b" => 3))
    @test df == DataFrame(a=1:2, b=2:3)

    df = DataFrame()
    append!(df, Dict("a" => 2, "b" => 3))
    @test df == DataFrame(a=2, b=3)

    df = DataFrame(a=1, b=2)
    push!(df, Dict("a" => 2, "b" => 3))
    @test df == DataFrame(a=1:2, b=2:3)
    @test_throws ArgumentError push!(df, Dict("a" => 2, "b" => 3), cols=:orderequal)
    push!(df, Dict("b" => 4, "c" => 0), cols=:union)
    @test isequal(df, DataFrame(a=[1:2; missing], b=2:4, c=[missing, missing, 0]))
end

end # module

import PrecompileTools

PrecompileTools.@compile_workload begin
    df = DataFrame(a=[2, 5, 3, 1, 0], b=["a", "b", "c", "a", "b"], c=1:5,
                   p=PooledArray(["a", "b", "c", "a", "b"]),
                   q=[true, false, true, false, true],
                   f=Float64[2, 5, 3, 1, 0])
    describe(df)
    names(df[1, 1:2])
    sort(df, :a)
    combine(df, :c, [:c :f] .=> [sum, mean, std], :c => :d, [:a, :c] => cor)
    transform(df, :c, [:c :f] .=> [sum, mean, std], :c => :d, [:a, :c] => cor)
    groupby(df, :a)
    groupby(df, :p)
    groupby(df, :q)
    gdf = groupby(df, :b)
    combine(gdf, :c, [:c :f] .=> [sum, mean, std], :c => :d, [:a, :c] => cor)
    transform(gdf, :c, [:c :f] .=> [sum, mean, std], :c => :d, [:a, :c] => cor)
    innerjoin(df, df, on=:a, makeunique=true)
    innerjoin(df, df, on=:b, makeunique=true)
    innerjoin(df, df, on=:c, makeunique=true)
    outerjoin(df, df, on=:a, makeunique=true)
    outerjoin(df, df, on=:b, makeunique=true)
    outerjoin(df, df, on=:c, makeunique=true)
    leftjoin!(df, DataFrame(a=[2, 5, 3, 1, 0]), on=:a)
    leftjoin!(df, DataFrame(b=["a", "b", "c", "d", "e"]), on=:b)
    leftjoin!(df, DataFrame(c=1:5), on=:c)
    reduce(vcat, [df, df])
    show(IOBuffer(), df)
    subset(df, :q)
    subset!(copy(df), :q)
    df[:, 1:2]
    df[1:2, :]
    df[1:2, 1:2]
    @view df[:, 1:2]
    @view df[1:2, :]
    @view df[1:2, 1:2]
    transform!(df, :c, [:c :f] .=> [sum, mean, std], :c => :d, [:a, :c] => cor)
    deleteat!(df, 1)
    append!(df, copy(df))
    push!(df, copy(df[1, :]))
    eachrow(df)
    eachcol(df)
    empty(df)
    empty!(copy(df))
    filter(:q => identity, df)
    filter!(:q => identity, df)
    first(df)
    last(df)
    hcat(df, df, makeunique=true)
    issorted(df)
    pop!(df)
    popfirst!(df)
    repeat(df, 2)
    reverse(df)
    reverse!(df)
    unique(df, :a)
    unique!(df, :a)
    wide = DataFrame(id=1:6,
                     a=repeat(1:3, inner=2),
                     b=repeat(1.0:2.0, inner=3),
                     c=repeat(1.0:1.0, inner=6),
                     d=repeat(1.0:3.0, inner=2))
    long = stack(wide)
    unstack(long)
    unstack(long, :variable, :value, combine=sum)
    flatten(DataFrame(a=[[1, 2], [3, 4]], b=[1, 2]), :a)
    dropmissing(DataFrame(a=[1, 2, 3, missing], b=["a", missing, "c", "d"]))
    df = DataFrame(rand(20, 2), :auto)
    df.id = repeat(1:2, 10)
    combine(df, AsTable(r"x") .=> [ByRow(sum), ByRow(mean)])
    combine(groupby(df, :id), AsTable(r"x") .=> [ByRow(sum), ByRow(mean)])
end

"""
    nonunique(df::AbstractDataFrame; keep::Symbol=:first)
    nonunique(df::AbstractDataFrame, cols; keep::Symbol=:first)

Return a `Vector{Bool}` in which `true` entries indicate duplicate rows.

Duplicate rows are those for which at least another row contains equal values
(according to `isequal`) for all columns in `cols` (by default, all columns).
If `keep=:first` (the default), only the first occurrence of a set of duplicate
rows is indicated with a `false` entry.
If `keep=:last`, only the last occurrence of a set of duplicate rows is
indicated with a `false` entry.
If `keep=:noduplicates`, only rows without any duplicates are indicated with a
`false` entry.

# Arguments
- `df` : `AbstractDataFrame`
- `cols` : a selector specifying the column(s) or their transformations to
  compare. Can be any column selector or transformation accepted by
  [`select`](@ref) that returns at least one column if `df` has at least one
  column.

See also [`unique`](@ref) and [`unique!`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:4, x=[1, 2, 1, 2])
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> df = vcat(df, df)
8×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2
   5 │     1      1
   6 │     2      2
   7 │     3      1
   8 │     4      2

julia> nonunique(df)
8-element Vector{Bool}:
 0
 0
 0
 0
 1
 1
 1
 1

julia> nonunique(df, keep=:last)
8-element Vector{Bool}:
 1
 1
 1
 1
 0
 0
 0
 0

julia> nonunique(df, 2)
8-element Vector{Bool}:
 0
 0
 1
 1
 1
 1
 1
 1
```
"""
function nonunique(df::AbstractDataFrame; keep::Symbol=:first)
    if !(keep in (:first, :last, :noduplicates))
        throw(ArgumentError("`keep` must be :first, :last, or :noduplicates"))
    end
    nrow(df) == 0 && return Bool[]
    res = fill(true, nrow(df))
    cols = ntuple(i -> df[!, i], ncol(df))
    if keep == :first
        rpa = refpool_and_array.(cols)
        refpools = first.(rpa)
        refarrays = last.(rpa)
        # if refarray cannot be used, we can avoid allocating a groups vector
        if any(isnothing, refpools) || any(isnothing, refarrays)
            _, _, gslots, _ = row_group_slots!(cols, Val(true), nothing,
                                               false, nothing, false)
            # unique rows are the first encountered group representatives,
            # nonunique are everything else
            @inbounds for g_row in gslots
                g_row > 0 && (res[g_row] = false)
            end
        else # faster refarray method but allocates a groups vector
            groups = Vector{Int}(undef, nrow(df))
            ngroups = row_group_slots!(cols, refpools, refarrays,
                                       Val(false), groups, false, false, false)[1]
            seen = fill(false, ngroups)
            for i in 1:nrow(df)
                g = groups[i]
                if !seen[g]
                    seen[g] = true
                    res[i] = false
                end
            end
        end
    else
       # always allocate a group vector, use refarray automatically if possible
        groups = Vector{Int}(undef, nrow(df))
        ngroups = row_group_slots!(cols, Val(false), groups, false, nothing, false)[1]
        if keep == :last
            seen = fill(false, ngroups)
            for i in nrow(df):-1:1
                g = groups[i]
                if !seen[g]
                    seen[g] = true
                    res[i] = false
                end
            end
        else
            @assert keep == :noduplicates
            # -1 indicates that we have not seen the group yet
            # positive value indicates the first position we have seen the group
            # 0 indicates that we have seen the group at least twice
            firstseen = fill(-1, ngroups)
            for i in 1:nrow(df)
                g = groups[i]
                j = firstseen[g]
                if j == -1
                    # this is possibly a non duplicate row
                    firstseen[g] = i
                    res[i] = false
                elseif j > 0
                    # the row had a duplicate
                    res[j] = true
                    firstseen[g] = 0
                end
            end
        end
    end
    return res
end

function nonunique(df::AbstractDataFrame, cols; keep::Symbol=:first)
    udf = _try_select_no_copy(df, cols)
    if ncol(df) > 0 && ncol(udf) == 0
         throw(ArgumentError("finding duplicate rows in data frame when " *
                             "`cols` selects no columns is not allowed"))
    end
    return nonunique(udf, keep=keep)
end

"""
    allunique(df::AbstractDataFrame, cols=:)

Return `true` if none of the rows of `df` are duplicated. Two rows are
duplicates if all their columns contain equal values (according to `isequal`)
for all columns in `cols` (by default, all columns).

# Arguments
- `df` : `AbstractDataFrame`
- `cols` : a selector specifying the column(s) or their transformations to
  compare. Can be any column selector or transformation accepted by
  [`select`](@ref).

See also [`unique`](@ref) and [`nonunique`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:4, x=[1, 2, 1, 2])
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> allunique(df)
true

julia> allunique(df, :x)
false

julia> allunique(df, :i => ByRow(isodd))
false
```
"""
function Base.allunique(df::AbstractDataFrame, cols=:)
    udf = _try_select_no_copy(df, cols)
    nrow(udf) == 0 && return true
    return row_group_slots!(ntuple(i -> udf[!, i], ncol(udf)),
                            Val(false), nothing, false, nothing, true)[1] == nrow(df)
end

# avoid invoking Base.allunique(f, iterator) introduced in Julia 1.11

Base.allunique(df::AbstractDataFrame, cols::Tuple) =
    invoke(Base.allunique, Tuple{AbstractDataFrame, Any}, df, cols)

"""
    unique(df::AbstractDataFrame; view::Bool=false, keep::Symbol=:first)
    unique(df::AbstractDataFrame, cols; view::Bool=false, keep::Symbol=:first)

Return a data frame containing only unique rows in `df`.

Non-unique (duplicate) rows are those for which at least another row contains
equal values (according to `isequal`) for all columns in `cols` (by default,
all columns).
If `keep=:first` (the default), only the first occurrence of a set of duplicate
rows is kept.
If `keep=:last`, only the last occurrence of a set of duplicate rows is kept.
If `keep=:noduplicates`, only rows without any duplicates are kept.

If `view=false` a freshly allocated `DataFrame` is returned, and if `view=true`
then a `SubDataFrame` view into `df` is returned.

# Arguments
- `df` : the AbstractDataFrame
- `cols` : a selector specifying the column(s) or their transformations to
  compare. Can be any column selector or transformation accepted by
  [`select`](@ref) that returns at least one column if `df` has at least one
  column.

$METADATA_FIXED

See also: [`unique!`](@ref), [`nonunique`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:4, x=[1, 2, 1, 2])
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> df = vcat(df, df)
8×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2
   5 │     1      1
   6 │     2      2
   7 │     3      1
   8 │     4      2

julia> unique(df)   # doesn't modify df
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> unique(df, 2)
2×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2

julia> unique(df, keep=:noduplicates)
0×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┴──────────────
```
"""
@inline function Base.unique(df::AbstractDataFrame; view::Bool=false,
                             keep::Symbol=:first)
    rowidxs = (!).(nonunique(df, keep=keep))
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

@inline function Base.unique(df::AbstractDataFrame, cols; view::Bool=false,
                             keep::Symbol=:first)
    rowidxs = (!).(nonunique(df, cols, keep=keep))
    return view ? Base.view(df, rowidxs, :) : df[rowidxs, :]
end

"""
    unique!(df::AbstractDataFrame; keep::Symbol=:first)
    unique!(df::AbstractDataFrame, cols; keep::Symbol=:first)

Update `df` in-place to contain only unique rows.

Non-unique (duplicate) rows are those for which at least another row contains
equal values (according to `isequal`) for all columns in `cols` (by default,
all columns).
If `keep=:first` (the default), only the first occurrence of a set of duplicate
rows is kept.
If `keep=:last`, only the last occurrence of a set of duplicate rows is kept.
If `keep=:noduplicates`, only rows without any duplicates are kept.

# Arguments
- `df` : the AbstractDataFrame
- `cols` :  column indicator (`Symbol`, `Int`, `Vector{Symbol}`, `Regex`, etc.)
  specifying the column(s) to compare. Can be any column selector or
  transformation accepted by [`select`](@ref) that returns at least one column
  if `df` has at least one column.

$METADATA_FIXED

See also: [`unique!`](@ref), [`nonunique`](@ref).

# Examples

```jldoctest
julia> df = DataFrame(i=1:4, x=[1, 2, 1, 2])
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> df = vcat(df, df)
8×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2
   5 │     1      1
   6 │     2      2
   7 │     3      1
   8 │     4      2

julia> unique!(copy(df))  # modifies df
4×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      1
   4 │     4      2

julia> unique(df, keep=:noduplicates)
0×2 DataFrame
 Row │ i      x
     │ Int64  Int64
─────┴──────────────
```
"""
Base.unique!(df::AbstractDataFrame; keep::Symbol=:first) =
    deleteat!(df, _findall(nonunique(df, keep=keep)))
Base.unique!(df::AbstractDataFrame, cols::AbstractVector; keep::Symbol=:first) =
    deleteat!(df, _findall(nonunique(df, cols, keep=keep)))
Base.unique!(df::AbstractDataFrame, cols; keep::Symbol=:first) =
    deleteat!(df, _findall(nonunique(df, cols, keep=keep)))

module TestBroadcasting

using Test, DataFrames, PooledArrays, Random, CategoricalArrays

const ≅ = isequal

refdf = DataFrame(reshape(1.5:15.5, (3, 5)), :auto)

@testset "CartesianIndex" begin
    df = DataFrame(rand(2, 3), :auto)
    for i in axes(df, 1), j in axes(df, 2)
        @test df[i, j] == df[CartesianIndex(i, j)]
        r = rand()
        df[CartesianIndex(i, j)] = r
        @test df[i, j] == r
    end
    @test_throws BoundsError df[CartesianIndex(0, 1)]
    @test_throws BoundsError df[CartesianIndex(0, 0)]
    @test_throws BoundsError df[CartesianIndex(1, 0)]
    @test_throws BoundsError df[CartesianIndex(5, 1)]
    @test_throws BoundsError df[CartesianIndex(5, 5)]
    @test_throws BoundsError df[CartesianIndex(1, 5)]

    @test_throws BoundsError df[CartesianIndex(0, 1)] = 1
    @test_throws ArgumentError df[CartesianIndex(0, 0)] = 1
    @test_throws ArgumentError df[CartesianIndex(1, 0)] = 1
    @test_throws BoundsError df[CartesianIndex(5, 1)] = 1
    @test_throws ArgumentError df[CartesianIndex(5, 5)] = 1
    @test_throws ArgumentError df[CartesianIndex(1, 5)] = 1
end

@testset "broadcasting of AbstractDataFrame objects" begin
    for df in (copy(refdf), view(copy(refdf), :, :))
        @test identity.(df) == refdf
        @test identity.(df) !== df
        @test (x->x).(df) == refdf
        @test (x->x).(df) !== df
        @test (df .+ df) ./ 2 == refdf
        @test (df .+ df) ./ 2 !== df
        @test df .+ Matrix(df) == 2 .* df
        @test Matrix(df) .+ df == 2 .* df
        @test (Matrix(df) .+ df .== 2 .* df) == DataFrame(trues(size(df)), names(df))
        @test df .+ 1 == df .+ ones(size(df))
        @test df .+ axes(df, 1) == DataFrame(Matrix(df) .+ axes(df, 1), names(df))
        @test df .+ permutedims(axes(df, 2)) == DataFrame(Matrix(df) .+ permutedims(axes(df, 2)), names(df))
    end

    df1 = copy(refdf)
    df2 = view(copy(refdf), :, :)
    @test (df1 .+ df2) ./ 2 == refdf
    @test (df1 .- df2) == DataFrame(zeros(size(refdf)), names(refdf))
    @test (df1 .* df2) == refdf .^ 2
    @test (df1 ./ df2) == DataFrame(ones(size(refdf)), names(refdf))
end

@testset "broadcasting of AbstractDataFrame objects thrown exceptions" begin
    df = copy(refdf)
    dfv = view(df, :, 2:ncol(df))

    @test_throws DimensionMismatch df .+ dfv
    @test_throws DimensionMismatch df .+ df[2:end, :]

    @test_throws DimensionMismatch df .+ [1, 2]
    @test_throws DimensionMismatch df .+ [1 2]
    @test_throws DimensionMismatch df .+ rand(2, 2)
    @test_throws DimensionMismatch dfv .+ [1, 2]
    @test_throws DimensionMismatch dfv .+ [1 2]
    @test_throws DimensionMismatch dfv .+ rand(2, 2)

    df2 = copy(df)
    rename!(df2, [:x1, :x2, :x3, :x4, :y])
    @test_throws ArgumentError df .+ df2
    @test_throws ArgumentError df .+ 1 .+ df2
end

@testset "broadcasting data frames" begin
    df1 = DataFrame(x=1, y=2)
    df2 = DataFrame(x=[1, 11], y=[2, 12])
    @test df1 .+ df2 == DataFrame(x=[2, 12], y=[4, 14])

    df1 = DataFrame(x=1, y=2)
    df2 = DataFrame(x=[1, 11], y=[2, 12])
    x = df2.x
    y = df2.y
    df2 .+= df1
    @test df2.x === x
    @test df2.y === y
    @test df2 == DataFrame(x=[2, 12], y=[4, 14])

    df = DataFrame(x=[1, 11], y=[2, 12])
    dfv = view(df, 1:1, 1:2)
    df .-= dfv
    @test df == DataFrame(x=[0, 10], y=[0, 10])

    @test DataFrame() .+ DataFrame() == DataFrame()
    @test_throws ArgumentError DataFrame(a=1, b=1) .+ DataFrame(b=1, a=1)

    df = DataFrame(a=1, b=2)
    @test_throws ArgumentError df .= DataFrame(b=1, a=2)
    @test_throws ArgumentError df .= DataFrame(a=1, c=2)
    @test_throws ArgumentError df[!, [:a, :b]] .= DataFrame(b=1, a=2)
    @test_throws ArgumentError df[!, [:a, :b]] .= DataFrame(a=1, c=2)
end

@testset "broadcasting of AbstractDataFrame objects corner cases" begin
    df = DataFrame(c11=categorical(["a", "b"]), c12=categorical([missing, "b"]), c13=categorical(["a", missing]),
                   c21=categorical([1, 2]), c22=categorical([missing, 2]), c23=categorical([1, missing]),
                   p11=PooledArray(["a", "b"]), p12=PooledArray([missing, "b"]), p13=PooledArray(["a", missing]),
                   p21=PooledArray([1, 2]), p22=PooledArray([missing, 2]), p23=PooledArray([1, missing]),
                   b1=[true, false], b2=[missing, false], b3=[true, missing],
                   f1=[1.0, 2.0], f2=[missing, 2.0], f3=[1.0, missing],
                   s1=["a", "b"], s2=[missing, "b"], s3=["a", missing])

    df2 = DataFrame(c11=categorical(["a", "b"]), c12=[nothing, "b"], c13=["a", nothing],
                    c21=categorical([1, 2]), c22=[nothing, 2], c23=[1, nothing],
                    p11=["a", "b"], p12=[nothing, "b"], p13=["a", nothing],
                    p21=[1, 2], p22=[nothing, 2], p23=[1, nothing],
                    b1=[true, false], b2=[nothing, false], b3=[true, nothing],
                    f1=[1.0, 2.0], f2=[nothing, 2.0], f3=[1.0, nothing],
                    s1=["a", "b"], s2=[nothing, "b"], s3=["a", nothing])

    @test df ≅ identity.(df)
    @test df ≅ (x->x).(df)
    df3 = coalesce.(df, nothing)
    @test df2 == df3
    @test eltype.(eachcol(df2)) == eltype.(eachcol(df3))
    for i in axes(df, 2)
        @test typeof(df2[!, i]) == typeof(df3[!, i])
    end
    df4 = (x -> df[1, 1]).(df)
    @test names(df4) == names(df)
    @test all(isa.(eachcol(df4), Ref(CategoricalArray)))
    @test all(eachcol(df4) .== Ref(categorical(["a", "a"])))

    df5 = DataFrame(x=Any[1, 2, 3], y=Any[1, 2.0, big(3)])
    @test identity.(df5) == df5
    @test (x->x).(df5) == df5
    @test df5 .+ 1 == DataFrame(Matrix(df5) .+ 1, names(df5))
    @test eltype.(eachcol(identity.(df5))) == [Int, BigFloat]
    @test eltype.(eachcol((x->x).(df5))) == [Int, BigFloat]
    @test eltype.(eachcol(df5 .+ 1)) == [Int, BigFloat]
end

@testset "normal data frame and data frame row in broadcasted assignment - one column" begin
    df = copy(refdf)
    df[!, 1] .+= 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[!, 1] .+= 100
    @test df.x2 == [104.5, 105.5, 6.5]
    # reverse the performed operations
    df.x1 -= [1, 1, 1]
    df.x2 -= [100, 100, 0]
    @test df == DataFrame(reshape(1.5:15.5, (3, 5)), :auto)

    df = copy(refdf)
    df[:, 1] .+= 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv.x2 .+= 1
    @test dfv.x2 == [5.5, 6.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    dfr = df[1, 3:end]
    dfr[end-1:end] .= 10
    @test Vector(dfr) == [7.5, 10.0, 10.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  10.0
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[!, 1] .+= [1, 2, 3]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    df = copy(refdf)
    df.x1 .+= [1, 2, 3]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv.x2 .+= [1, 2]
    @test dfv.x2 == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    dfr = df[1, 3:end]
    dfr[end-1:end] .= [10, 11]
    @test Vector(dfr) == [7.5, 10.0, 11.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  11.0
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, 1] .+= [1, 2, 3]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, 1] .+= [1, 2]
    @test dfv.x2 == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    # test a more complex broadcasting pattern
    df = copy(refdf)
    df[!, 1] .+= [0, 1, 2] .+ 1
    @test df.x1 == df[!, 1] == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    df = copy(refdf)
    df[!, "x1"] .+= [0, 1, 2] .+ 1
    @test df."x1" == df[!, 1] == [2.5, 4.5, 6.5]
    @test df[:, Not("x1")] == refdf[:, 2:end]

    df = copy(refdf)
    dfv = @view df[1:2, 2:end]
    dfv[!, 1] .+= [0, 1] .+ 1
    @test df == DataFrame([1.5  5.5  7.5  10.5  13.5
                           2.5  7.5  8.5  11.5  14.5
                           3.5  6.5  9.5  12.5  15.5], :auto)

    dfv = @view df[1:2, 2:end]
    @test_throws ArgumentError dfv[!, "x1"] .+= [0, 1] .+ 1
    @test df == DataFrame([1.5  5.5  7.5  10.5  13.5
                           2.5  7.5  8.5  11.5  14.5
                           3.5  6.5  9.5  12.5  15.5], :auto)

    df = copy(refdf)
    df.x1 .+= [0, 1, 2] .+ 1
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv.x2 .+= [0, 1] .+ 1
    @test dfv.x2 == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df."x1" .+= [0, 1, 2] .+ 1
    @test df."x1" == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv."x2" .+= [0, 1] .+ 1
    @test dfv."x2" == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    dfr = df[1, 3:end]
    dfr[end-1:end] .= [9, 10] .+ 1
    @test Vector(dfr) == [7.5, 10.0, 11.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  11.0
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, 1] .+= [0, 1, 2] .+ 1
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, 1] .+= [0, 1] .+ 1
    @test dfv.x2 == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, "x1"] .+= [0, 1, 2] .+ 1
    @test df."x1" == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, "x2"] .+= [0, 1] .+ 1
    @test dfv."x2" == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    dfv = @view df[1:2, 2:end]
    dfr = df[1, 3:end]
    @test_throws DimensionMismatch dfv[!, 1] .= fill(100, 2, 2)
    @test_throws DimensionMismatch dfv[!, 1] .= reshape(fill(200, 4), :, 2)
    @test_throws DimensionMismatch df[!, 1] .= rand(1, 2)
    @test_throws DimensionMismatch dfr[end-1:end] .= rand(3, 1)
    @test_throws DimensionMismatch df[:, 1] .= rand(1, 3)
    @test_throws DimensionMismatch dfv[:, 1] .= rand(1, 2)
    @test_throws DimensionMismatch df[!, 1] .= reshape(rand(3), 1, :)
    @test_throws DimensionMismatch dfr[end-1:end] .= reshape(rand(3), :, 1)
    @test_throws DimensionMismatch df[:, 1] .= reshape(rand(3), 1, :, 1)
    @test_throws DimensionMismatch dfv[:, 1] .= reshape(rand(2), 1, :, 1)

    df = copy(refdf)
    df[!, :x1] .+= 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[!, :x2] .+= 1

    dfr = df[1, 3:end]
    dfr[[:x4, :x5]] .= 10
    @test Vector(dfr) == [7.5, 10.0, 10.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  10.0
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[!, "x1"] .+= 1
    @test df."x1" == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[!, "x2"] .+= 1

    dfr = df[1, 3:end]
    dfr[["x4", "x5"]] .= 10
    @test Vector(dfr) == [7.5, 10.0, 10.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  10.0
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, :x1] .+= 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, :x2] .+= 1
    @test dfv.x2 == [5.5, 6.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, "x1"] .+= 1
    @test df."x1" == [2.5, 3.5, 4.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, "x2"] .+= 1
    @test dfv."x2" == [5.5, 6.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         3.5  6.5  8.5  11.5  14.5
                         4.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[!, :x1] .+= [1, 2, 3]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[!, :x2] .+= [1, 2]

    dfr = df[1, 3:end]
    dfr[[:x4, :x5]] .= [10, 11]
    @test Vector(dfr) == [7.5, 10.0, 11.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  11.0
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[!, "x1"] .+= [1, 2, 3]
    @test df."x1" == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[!, :x2] .+= [1, 2]

    dfr = df[1, 3:end]
    dfr[["x4", "x5"]] .= [10, 11]
    @test Vector(dfr) == [7.5, 10.0, 11.0]
    @test Matrix(df) == [2.5  5.5  7.5  10.0  11.0
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, :x1] .+= [1, 2, 3]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, :x2] .+= [1, 2]
    @test dfv.x2 == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, "x1"] .+= [1, 2, 3]
    @test df."x1" == [2.5, 4.5, 6.5]
    @test df[:, 2:end] == refdf[:, 2:end]

    dfv = @view df[1:2, 2:end]
    dfv[:, "x2"] .+= [1, 2]
    @test dfv."x2" == [5.5, 7.5]
    @test dfv[:, 2:end] == refdf[1:2, 3:end]
    @test Matrix(df) == [2.5  5.5  7.5  10.5  13.5
                         4.5  7.5  8.5  11.5  14.5
                         6.5  6.5  9.5  12.5  15.5]

    df = copy(refdf)
    dfv = @view df[1:2, 2:end]
    dfr = df[1, 3:end]

    @test_throws DimensionMismatch dfv[!, :x2] .= fill(100, 2, 2)
    @test_throws DimensionMismatch dfv[!, 1] .= reshape(fill(200, 4), :, 2)
    @test_throws DimensionMismatch dfv[!, "x2"] .= fill(100, 2, 2)
    @test_throws DimensionMismatch df[!, :x1] .= rand(1, 3)
    @test_throws DimensionMismatch dfr[[:x4, :x5]] .= rand(3, 1)
    @test_throws DimensionMismatch df[:, :x1] .= rand(1, 3)
    @test_throws DimensionMismatch dfv[:, :x2] .= rand(1, 2)
    @test_throws DimensionMismatch df[!, 1] .= reshape(rand(3), 1, :)
    @test_throws DimensionMismatch dfr[end-1:end] .= reshape(rand(3), :, 1)
    @test_throws DimensionMismatch df[:, 1] .= reshape(rand(3), 1, :)
    @test_throws DimensionMismatch dfv[:, 1] .= reshape(rand(2), 1, :)
    @test_throws DimensionMismatch df[!, "x1"] .= rand(1, 3)
    @test_throws DimensionMismatch dfr[["x4", "x5"]] .= rand(3, 1)
    @test_throws DimensionMismatch df[:, "x1"] .= rand(1, 3)
    @test_throws DimensionMismatch dfv[:, "x2"] .= rand(1, 2)
end

@testset "normal data frame and data frame view in broadcasted assignment - two columns" begin
    df = copy(refdf)
    df[:, [1, 2]] .= Matrix(df[:, [1, 2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [1, 2]] .= Matrix(dfv[:, [1, 2]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= Matrix(df[:, [1, 2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [1, 2]] .= Matrix(dfv[:, [1, 2]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= Matrix(df[:, [1, 2]]) .+ [1 4
                                               2 5
                                               3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [1, 2]] .= Matrix(dfv[:, [1, 2]]) .+ [1 3
                                               2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= Matrix(df[:, [1, 2]]) .+ [1 4
                                               2 5
                                               3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [1, 2]] .= Matrix(dfv[:, [1, 2]]) .+ [1 3
                                               2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    dfv = @view df[1:2, 2:end]
    @test_throws DimensionMismatch df[:, [1, 2]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, [1, 2]] .= rand(2, 10)
    @test_throws DimensionMismatch df[:, [1, 2]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, [1, 2]] .= rand(2, 10)

    df = copy(refdf)
    df[:, [:x1, :x2]] .= Matrix(df[:, [:x1, :x2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [:x3, :x4]] .= Matrix(dfv[:, [:x3, :x4]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, ["x1", "x2"]] .= Matrix(df[:, [:x1, :x2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, ["x3", "x4"]] .= Matrix(dfv[:, [:x3, :x4]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [:x1, :x2]] .= Matrix(df[:, [:x1, :x2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [:x3, :x4]] .= Matrix(dfv[:, [:x3, :x4]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, ["x1", "x2"]] .= Matrix(df[:, [:x1, :x2]]) .+ 1
    @test df.x1 == [2.5, 3.5, 4.5]
    @test df.x2 == [5.5, 6.5, 7.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, ["x3", "x4"]] .= Matrix(dfv[:, [:x3, :x4]]) .+ 1
    @test dfv.x3 == [8.5, 9.5]
    @test dfv.x4 == [11.5, 12.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5  5.5  8.5  11.5  13.5
                         3.5  6.5  9.5  12.5  14.5
                         4.5  7.5  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [:x1, :x2]] .= Matrix(df[:, [:x1, :x2]]) .+ [1 4
                                                       2 5
                                                       3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [:x3, :x4]] .= Matrix(dfv[:, [:x3, :x4]]) .+ [1 3
                                                         2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    df[:, ["x1", "x2"]] .= Matrix(df[:, ["x1", "x2"]]) .+ [1 4
                                                           2 5
                                                           3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, ["x3", "x4"]] .= Matrix(dfv[:, ["x3", "x4"]]) .+ [1 3
                                                             2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [:x1, :x2]] .= Matrix(df[:, [:x1, :x2]]) .+ [1 4
                                                       2 5
                                                       3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, [:x3, :x4]] .= Matrix(dfv[:, [:x3, :x4]]) .+ [1 3
                                                         2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    df[:, ["x1", "x2"]] .= Matrix(df[:, ["x1", "x2"]]) .+ [1 4
                                                           2 5
                                                           3 6]
    @test df.x1 == [2.5, 4.5, 6.5]
    @test df.x2 == [8.5, 10.5, 12.5]
    @test df[:, 3:end] == refdf[:, 3:end]

    dfv = @view df[1:2, 3:end]
    dfv[:, ["x3", "x4"]] .= Matrix(dfv[:, ["x3", "x4"]]) .+ [1 3
                                                             2 4]
    @test dfv.x3 == [8.5, 10.5]
    @test dfv.x4 == [13.5, 15.5]
    @test dfv[:, 3:end] == refdf[1:2, 5:end]
    @test Matrix(df) == [2.5   8.5   8.5  13.5  13.5
                         4.5  10.5  10.5  15.5  14.5
                         6.5  12.5   9.5  12.5  15.5]

    df = copy(refdf)
    dfv = @view df[1:2, 2:end]
    @test_throws DimensionMismatch df[:, [:x1, :x2]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, [:x3, :x4]] .= rand(2, 10)
    @test_throws DimensionMismatch df[:, [:x1, :x2]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, [:x3, :x4]] .= rand(2, 10)
    @test_throws DimensionMismatch df[:, ["x1", "x2"]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, ["x3", "x4"]] .= rand(2, 10)
    @test_throws DimensionMismatch df[:, ["x1", "x2"]] .= rand(3, 10)
    @test_throws DimensionMismatch dfv[:, ["x3", "x4"]] .= rand(2, 10)

    df = copy(refdf)
    df[:, [1, 2]] .= [1 2
                      3 4
                      5 6]
    @test Matrix(df) == [1.0  2.0  7.5  10.5  13.5
                         3.0  4.0  8.5  11.5  14.5
                         5.0  6.0  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= [1, 3, 5]
    @test Matrix(df) == [1.0  1.0  7.5  10.5  13.5
                         3.0  3.0  8.5  11.5  14.5
                         5.0  5.0  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= reshape([1, 3, 5], 3, 1)
    @test Matrix(df) == [1.0  1.0  7.5  10.5  13.5
                         3.0  3.0  8.5  11.5  14.5
                         5.0  5.0  9.5  12.5  15.5]

    df = copy(refdf)
    df[:, [1, 2]] .= 1
    @test Matrix(df) == [1.0  1.0  7.5  10.5  13.5
                         1.0  1.0  8.5  11.5  14.5
                         1.0  1.0  9.5  12.5  15.5]

    df = copy(refdf)
    dfv = view(df, 2:3, 2:4)
    dfv[:, [1, 2]] .= [1 2
                       3 4]
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5
                         2.5  1.0  2.0  11.5  14.5
                         3.5  3.0  4.0  12.5  15.5]

    df = copy(refdf)
    dfv = view(df, 2:3, 2:4)
    dfv[:, [1, 2]] .= [1, 3]
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5
                         2.5  1.0  1.0  11.5  14.5
                         3.5  3.0  3.0  12.5  15.5]

    df = copy(refdf)
    dfv = view(df, 2:3, 2:4)
    dfv[:, [1, 2]] .= reshape([1, 3], 2, 1)
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5
                         2.5  1.0  1.0  11.5  14.5
                         3.5  3.0  3.0  12.5  15.5]

    df = copy(refdf)
    dfv = view(df, 2:3, 2:4)
    dfv[:, [1, 2]] .= 1
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5
                         2.5  1.0  1.0  11.5  14.5
                         3.5  1.0  1.0  12.5  15.5]
end

@testset "assignment to a whole data frame and data frame row" begin
    df = copy(refdf)
    df .= 10
    @test all(Matrix(df) .== 10)
    dfv = view(df, 1:2, 1:4)
    dfv .= 100
    @test Matrix(df) == [100.0  100.0  100.0  100.0  10.0
                        100.0  100.0  100.0  100.0  10.0
                         10.0   10.0   10.0   10.0  10.0]
    dfr = df[1, 1:2]
    dfr .= 1000
    @test Matrix(df) == [1000.0  1000.0  100.0  100.0  10.0
                         100.0   100.0  100.0  100.0  10.0
                         10.0    10.0   10.0   10.0  10.0]

    df = copy(refdf)
    df[:, :] .= 10
    @test all(Matrix(df) .== 10)
    dfv = view(df, 1:2, 1:4)
    dfv[:, :] .= 100
    @test Matrix(df) == [100.0  100.0  100.0  100.0  10.0
                         100.0  100.0  100.0  100.0  10.0
                         10.0   10.0   10.0   10.0  10.0]
    dfr = df[1, 1:2]
    dfr[:] .= 1000
    @test Matrix(df) == [1000.0  1000.0  100.0  100.0  10.0
                         100.0   100.0   100.0  100.0  10.0
                         10.0    10.0    10.0   10.0   10.0]

    df = copy(refdf)
    df[:, :] .= 10
    @test all(Matrix(df) .== 10)
    dfv = view(df, 1:2, 1:4)
    dfv[:, :] .= 100
    @test Matrix(df) == [100.0  100.0  100.0  100.0  10.0
                         100.0  100.0  100.0  100.0  10.0
                         10.0   10.0   10.0   10.0  10.0]
end

@testset "extending data frame in broadcasted assignment - one column" begin
    df = copy(refdf)
    df[!, :a] .= 1
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5  1.0
                         2.5  5.5  8.5  11.5  14.5  1.0
                         3.5  6.5  9.5  12.5  15.5  1.0]
    @test names(df)[end] == "a"
    @test df[:, 1:end-1] == refdf
    df[!, :b] .= [1, 2, 3]
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5  1.0 1.0
                         2.5  5.5  8.5  11.5  14.5  1.0 2.0
                         3.5  6.5  9.5  12.5  15.5  1.0 3.0]
    @test names(df)[end] == "b"
    @test df[:, 1:end-2] == refdf
    cdf = copy(df)
    @test_throws DimensionMismatch df[!, :c] .= ones(1, 3)
    @test df == cdf
    @test_throws DimensionMismatch df[!, :x] .= ones(4)
    @test df == cdf
    @test_throws ArgumentError df[!, 10] .= ones(3)
    @test df == cdf

    dfv = @view df[1:2, 2:end]
    @test_throws ArgumentError dfv[!, 10] .= ones(3)
    @test_throws ArgumentError dfv[!, :z] .= ones(3)
    @test df == cdf
    dfr = df[1, 3:end]
    @test_throws BoundsError dfr[10] .= ones(3)
    @test_throws ArgumentError dfr[:z] .= ones(3)
    @test df == cdf

    df = DataFrame()
    @test_throws DimensionMismatch df[!, :a] .= sin.(1:3)
    df[!, :b] .= sin.(1)
    df[!, :c] .= sin(1) .+ 1
    @test df == DataFrame(b=Float64[], c=Float64[])

    df = copy(refdf)
    df[!, "a"] .= 1
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5  1.0
                         2.5  5.5  8.5  11.5  14.5  1.0
                         3.5  6.5  9.5  12.5  15.5  1.0]
    @test names(df)[end] == "a"
    @test df[:, 1:end-1] == refdf
    df[!, "b"] .= [1, 2, 3]
    @test Matrix(df) == [1.5  4.5  7.5  10.5  13.5  1.0 1.0
                         2.5  5.5  8.5  11.5  14.5  1.0 2.0
                         3.5  6.5  9.5  12.5  15.5  1.0 3.0]
    @test names(df)[end] == "b"
    @test df[:, 1:end-2] == refdf
    cdf = copy(df)
    @test_throws DimensionMismatch df[!, "c"] .= ones(1, 3)
    @test df == cdf
    @test_throws DimensionMismatch df[!, "x"] .= ones(4)
    @test df == cdf
    @test_throws ArgumentError df[!, 10] .= ones(3)
    @test df == cdf

    dfv = @view df[1:2, 2:end]
    @test_throws ArgumentError dfv[!, 10] .= ones(3)
    @test_throws ArgumentError dfv[!, "z"] .= ones(3)
    @test df == cdf
    dfr = df[1, 3:end]
    @test_throws BoundsError dfr[10] .= ones(3)
    @test_throws ArgumentError dfr["z"] .= ones(3)
    @test df == cdf

    df = DataFrame()
    @test_throws DimensionMismatch df[!, "a"] .= sin.(1:3)
    df[!, "b"] .= sin.(1)
    df[!, "c"] .= sin(1) .+ 1
    @test df == DataFrame(b=Float64[], c=Float64[])
end

@testset "empty data frame corner case" begin
    df = DataFrame()
    @test_throws ArgumentError df[!, 1] .= 1
    @test_throws ArgumentError df[!, 2] .= 1
    @test_throws ArgumentError df[!, [:a, :b]] .= [1]
    @test_throws ArgumentError df[!, [:a, :b]] .= 1
    @test_throws DimensionMismatch df[!, :a] .= [1 2]
    @test_throws DimensionMismatch df[!, :a] .= [1, 2]
    @test_throws DimensionMismatch df[!, :a] .= sin.(1) .+ [1, 2]
    @test_throws ArgumentError df[!, ["a", "b"]] .= [1]
    @test_throws ArgumentError df[!, ["a", "b"]] .= 1
    @test_throws DimensionMismatch df[!, "a"] .= [1 2]
    @test_throws DimensionMismatch df[!, "a"] .= [1, 2]
    @test_throws DimensionMismatch df[!, "a"] .= sin.(1) .+ [1, 2]

    for rhs in [1, [1], Int[], "abc", ["abc"]]
        df = DataFrame()
        df[!, :a] .= rhs
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == (rhs isa AbstractVector ? eltype(rhs) : typeof(rhs))

        df = DataFrame()
        df[!, :a] .= length.(rhs)
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame()
        df[!, :a] .= length.(rhs) .+ 1
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame()
        @. df[!, :a] = length(rhs) + 1
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame(x=Int[])
        df[!, :a] .= rhs
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == (rhs isa AbstractVector ? eltype(rhs) : typeof(rhs))

        df = DataFrame(x=Int[])
        df[!, :a] .= length.(rhs)
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int

        df = DataFrame(x=Int[])
        df[!, :a] .= length.(rhs) .+ 1
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int

        df = DataFrame(x=Int[])
        @. df[!, :a] = length(rhs) + 1
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int

        df = DataFrame()
        df[!, "a"] .= rhs
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == (rhs isa AbstractVector ? eltype(rhs) : typeof(rhs))

        df = DataFrame()
        df[!, "a"] .= length.(rhs)
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame()
        df[!, "a"] .= length.(rhs) .+ 1
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame()
        @. df[!, "a"] = length(rhs) + 1
        @test size(df) == (0, 1)
        @test eltype(df[!, 1]) == Int

        df = DataFrame(x=Int[])
        df[!, "a"] .= rhs
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == (rhs isa AbstractVector ? eltype(rhs) : typeof(rhs))

        df = DataFrame(x=Int[])
        df[!, "a"] .= length.(rhs)
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int

        df = DataFrame(x=Int[])
        df[!, "a"] .= length.(rhs) .+ 1
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int

        df = DataFrame(x=Int[])
        @. df[!, "a"] = length(rhs) + 1
        @test size(df) == (0, 2)
        @test eltype(df[!, 2]) == Int
    end

    df = DataFrame()
    df .= 1
    @test df == DataFrame()
    df .= [1]
    @test df == DataFrame()
    df .= ones(1, 1)
    @test df == DataFrame()
    @test_throws DimensionMismatch df .= ones(1, 2)
    @test_throws DimensionMismatch df .= ones(1, 2, 1)

    df = DataFrame(a=[])
    df[!, :b] .= sin.(1)
    @test eltype(df.b) == Float64
    df[!, :b] .= [1]
    @test eltype(df.b) == Int
    df[!, :b] .= 'a'
    @test eltype(df.b) == Char
    @test names(df) == ["a", "b"]

    c = categorical(["a", "b", "c"])
    df = DataFrame()
    @test_throws DimensionMismatch df[!, :a] .= c

    df[!, :b] .= c[1]
    @test nrow(df) == 0
    @test df.b isa CategoricalVector{String}

    df = DataFrame(a=[])
    df[!, "b"] .= sin.(1)
    @test eltype(df."b") == Float64
    df[!, "b"] .= [1]
    @test eltype(df."b") == Int
    df[!, "b"] .= 'a'
    @test eltype(df."b") == Char
    @test names(df) == ["a", "b"]

    c = categorical(["a", "b", "c"])
    df = DataFrame()
    @test_throws DimensionMismatch df[!, "a"] .= c

    df[!, "b"] .= c[1]
    @test nrow(df) == 0
    @test df."b" isa CategoricalVector{String}
end

@testset "test categorical values" begin
    for v in Any[categorical([1, 2, 3]), categorical([1, 2, missing]),
                 categorical([missing, 1, 2]),
                 categorical(["1", "2", "3"]), categorical(["1", "2", missing]),
                 categorical([missing, "1", "2"])]
        df = copy(refdf)
        df[!, :c1] .= v
        @test df.c1 ≅ v
        @test df.c1 !== v
        @test df.c1 isa CategoricalVector
        @test levels(df.c1) == levels(v)
        @test levels(df.c1) !== levels(v)
        df[!, :c2] .= v[2]
        @test df.c2 == fill(v[2], 3)
        @test df.c2 isa CategoricalVector
        @test levels(df.c2) == levels(v)
        df[!, :c3] .= (x->x).(v)
        @test df.c3 ≅ v
        @test df.c3 !== v
        @test df.c3 isa CategoricalVector
        @test levels(df.c3) == levels(v)
        @test levels(df.c3) !== levels(v)
        df[!, :c4] .= identity.(v)
        @test df.c4 ≅ v
        @test df.c4 !== v
        @test df.c4 isa CategoricalVector
        @test levels(df.c4) == levels(v)
        @test levels(df.c4) !== levels(v)
        df[!, :c5] .= (x->v[2]).(v)
        @test unique(df.c5) == [unwrap(v[2])]
        @test df.c5 isa CategoricalVector
        @test levels(df.c5) == levels(v)
    end
end

@testset "scalar broadcasting" begin
    a = DataFrame(x=zeros(2))
    a .= 1 ./ (1 + 2)
    @test a.x == [1/3, 1/3]
    a .= 1 ./ (1 .+ 3)
    @test a.x == [1/4, 1/4]
    a .= sqrt.(1 ./ 2)
    @test a.x == [sqrt(1/2), sqrt(1/2)]
end

@testset "tuple broadcasting" begin
    X = DataFrame(zeros(2, 3), :auto)
    X .= (1, 2)
    @test X == DataFrame([1 1 1; 2 2 2], :auto)

    X = DataFrame(zeros(2, 3), :auto)
    X .= (1, 2) .+ 10 .- X
    @test X == DataFrame([11 11 11; 12 12 12], :auto)

    X = DataFrame(zeros(2, 3), :auto)
    X .+= (1, 2) .+ 10
    @test X == DataFrame([11 11 11; 12 12 12], :auto)

    df = DataFrame(rand(2, 3), :auto)
    @test floor.(Int, df ./ (1,)) == DataFrame(zeros(Int, 2, 3), :auto)
    df .= floor.(Int, df ./ (1,))
    @test df == DataFrame(zeros(2, 3), :auto)

    df = DataFrame(rand(2, 3), :auto)
    @test_throws InexactError convert.(Int, df)
    df2 = convert.(Int, floor.(df))
    @test df2 == DataFrame(zeros(Int, 2, 3), :auto)
    @test eltype.(eachcol(df2)) == [Int, Int, Int]
end

@testset "scalar on assignment side" begin
    df = DataFrame(rand(2, 3), :auto)
    @test_throws MethodError df[1, 1] .= df[1, 1] .- df[1, 1]
    df[1, 1:1] .= df[1, 1] .- df[1, 1]
    @test df[1, 1] == 0
    @test_throws MethodError df[1, 2] .-= df[1, 2]
    df[1:1, 2] .-= df[1, 2]
    @test df[1, 2] == 0
end

@testset "nothing test" begin
    X = DataFrame(Any[1 2; 3 4], :auto)
    X .= nothing
    @test (X .== nothing) == DataFrame(trues(2, 2), :auto)

    X = DataFrame([1 2; 3 4], :auto)
    @test_throws MethodError X .= nothing
    @test X == DataFrame([1 2; 3 4], :auto)

    X = DataFrame([1 2; 3 4], :auto)
    foreach(i -> X[!, i] .= nothing, axes(X, 2))
    @test (X .== nothing) == DataFrame(trues(2, 2), :auto)
end

@testset "aliasing test" begin
    df = DataFrame(x=[1, 2])
    y = view(df.x, [2, 1])
    df .= y
    @test df.x == [2, 1]

    df = DataFrame(x=[1, 2])
    y = view(df.x, [2, 1])
    dfv = view(df, :, :)
    dfv .= y
    @test df.x == [2, 1]

    df = DataFrame(x=2, y=1, z=1)
    dfr = df[1, :]
    y = view(df.x, 1)
    dfr .= 2 .* y
    @test Vector(dfr) == [4, 4, 4]

    df = DataFrame(x=[1, 2], y=[11, 12])
    df2 = DataFrame()
    df2.x = [-1, -2]
    df2.y = df.x
    df3 = copy(df2)
    df .= df2
    @test df == df3

    Random.seed!(1234)
    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
        end
        df3 = copy(df2)
        df1 .= df2
        @test df1 == df3
        @test df2 != df3
    end

    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
        end
        df3 = copy(df2)
        df1 .= view(df2, :, :)
        @test df1 == df3
        @test df2 != df3
    end

    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
        end
        df3 = copy(df2)
        view(df1, :, :) .= df2
        @test df1 == df3
        @test df2 != df3
    end

    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        df3 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
            df3[!, rand(1:100)] = df1[!, i]
        end
        df6 = copy(df2)
        df7 = copy(df3)
        df4 = DataFrame(sin.(df1[1, 1] .+ copy(df1[!, 1]) .+ Matrix(df2) ./ Matrix(df3)), names(df3))
        df5 = sin.(view(df1, 1, 1) .+ df1[!, 1] .+ df2 ./ df3)
        df1 .= sin.(view(df1, 1, 1) .+ df1[!, 1] .+ df2 ./ df3)
        @test df1 == df4 == df5
        @test df2 != df6
        @test df3 != df7
    end

    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        df3 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
            df3[!, rand(1:100)] = df1[!, i]
        end
        df6 = copy(df2)
        df7 = copy(df3)
        df4 = DataFrame(sin.(df1[1, 1] .+ copy(df1[!, 1]) .+ Matrix(df2) ./ Matrix(df3)), names(df3))
        df5 = sin.(view(df1, 1, 1) .+ df1[!, 1] .+ view(df2, :, :) ./ df3)
        df1 .= sin.(view(df1[!, 1], 1) .+ view(df1[!, 1], :) .+ df2 ./ view(df3, :, :))
        @test df1 == df4 == df5
        @test df2 != df6
        @test df3 != df7
    end

    for i in 1:10
        df1 = DataFrame(rand(100, 100), :auto)
        df2 = copy(df1)
        df3 = copy(df1)
        for i in 1:100
            df2[!, rand(1:100)] = df1[!, i]
            df3[!, rand(1:100)] = df1[!, i]
        end
        df6 = copy(df2)
        df7 = copy(df3)
        df4 = DataFrame(sin.(df1[1, 1] .+ copy(df1[!, 1]) .+ Matrix(df2) ./ Matrix(df3)), names(df3))
        df5 = sin.(view(df1, 1, 1) .+ df1[!, 1] .+ view(df2, :, :) ./ df3)
        view(df1, :, :) .= sin.(view(df1[!, 1], 1) .+ view(df1[!, 1], :) .+ df2 ./ view(df3, :, :))
        @test df1 == df4 == df5
        @test df2 != df6
        @test df3 != df7
    end
end

@testset "@. test" begin
    df = DataFrame(rand(2, 3), :auto)
    sdf = view(df, 1:1, :)
    dfm = Matrix(df)
    sdfm = Matrix(sdf)

    r1 = @. (df + sdf + 5) / sdf
    @test r1 isa DataFrame

    @. df = sin(sdf / (df + 1))
    @. dfm = sin(sdfm / (dfm + 1))
    @test df == DataFrame(dfm, names(df))
end

@testset "test common cases" begin
    m = rand(1000, 10)
    df = DataFrame(m, :auto)
    @test df .+ 1 == DataFrame(m .+ 1, names(df))
    @test df .+ transpose(1:10) == DataFrame(m .+ transpose(1:10), names(df))
    @test df .+ (1:1000) == DataFrame(m .+ (1:1000), names(df))
    @test df .+ m == DataFrame(m .+ m, names(df))
    @test m .+ df == DataFrame(m .+ m, names(df))
    @test df .+ df == DataFrame(m .+ m, names(df))

    df .+= 1
    m .+= 1
    @test df == DataFrame(m, names(df))
    df .+= transpose(1:10)
    m .+= transpose(1:10)
    @test df == DataFrame(m, names(df))
    df .+= (1:1000)
    m .+= (1:1000)
    @test df == DataFrame(m, names(df))
    df .+= df
    m .+= m
    @test df == DataFrame(m, names(df))
    df2 = copy(df)
    m2 = copy(m)
    df .+= df .+ df2 .+ m2 .+ 1
    m .+= m .+ df2 .+ m2 .+ 1
    @test df == DataFrame(m, names(df))
end

@testset "data frame only on left hand side broadcasting assignment" begin
    Random.seed!(1234)

    m = rand(3, 4);
    m2 = copy(m);
    m3 = copy(m);
    df = DataFrame(a=view(m, :, 1), b=view(m, :, 1),
                   c=view(m, :, 1), d=view(m, :, 1), copycols=false);
    df2 = copy(df)
    mdf = Matrix(df)

    @test m .+ df == m2 .+ df
    @test Matrix(m .+ df) == m .+ mdf
    @test sin.(m .+ df) .+ 1 .+ m2 == sin.(m2 .+ df) .+ 1 .+ m
    @test Matrix(m .+ df ./ 2 .* df2) == m .+ mdf ./ 2 .* mdf

    m2 .+= df .+ 1 ./ df2
    m .+= df .+ 1 ./ df2
    @test m2 == m
    for col in eachcol(df)
        @test col == m[:, 1]
    end
    for col in eachcol(df2)
        @test col == m3[:, 1]
    end

    m = rand(3, 4);
    m2 = copy(m);
    m3 = copy(m);
    df = view(DataFrame(a=view(m, :, 1), b=view(m, :, 1),
                        c=view(m, :, 1), d=view(m, :, 1), copycols=false),
              [3, 2, 1], :)
    df2 = copy(df)
    mdf = Matrix(df)

    @test m .+ df == m2 .+ df
    @test Matrix(m .+ df) == m .+ mdf
    @test sin.(m .+ df) .+ 1 .+ m2 == sin.(m2 .+ df) .+ 1 .+ m
    @test Matrix(m .+ df ./ 2 .* df2) == m .+ mdf ./ 2 .* mdf

    m2 .+= df .+ 1 ./ df2
    m .+= df .+ 1 ./ df2
    @test m2 == m
    for col in eachcol(df)
        @test col == m[3:-1:1, 1]
    end
    for col in eachcol(df2)
        @test col == m3[3:-1:1, 1]
    end
end

@testset "broadcasting with 3-dimensional object" begin
    y = zeros(4, 3, 2)
    df = DataFrame(ones(4, 3), :auto)
    @test_throws DimensionMismatch df .+ y
    @test_throws DimensionMismatch y .+ df
    @test_throws DimensionMismatch df .+= y
    y .+= df
    @test y == ones(4, 3, 2)
end

@testset "additional checks of post-! broadcasting rules" begin
    df = copy(refdf)
    v1 = df[!, 1]
    @test_throws MethodError df[CartesianIndex(1, 1)] .= 1
    @test_throws MethodError df[CartesianIndex(1, 1)] .= "d"
    @test_throws DimensionMismatch df[CartesianIndex(1, 1)] .= [1, 2]

    df = copy(refdf)
    v1 = df[!, 1]
    @test_throws MethodError df[1, 1] .= 1
    @test_throws MethodError df[1, 1] .= "d"
    @test_throws DimensionMismatch df[1, 1] .= [1, 2]

    df = copy(refdf)
    v1 = df[!, 1]
    @test_throws MethodError df[1, :x1] .= 1
    @test_throws MethodError df[1, :x1] .= "d"
    @test_throws DimensionMismatch df[1, :x1] .= [1, 2]

    df = copy(refdf)
    v1 = df[!, 1]
    @test_throws MethodError df[1, "x1"] .= 1
    @test_throws MethodError df[1, "x1"] .= "d"
    @test_throws DimensionMismatch df[1, "x1"] .= [1, 2]

    df = copy(refdf)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[1, 1:2] .= 'd'
    @test v1 == [100.0, 2.5, 3.5]
    @test v2 == [100.0, 5.5, 6.5]
    @test_throws MethodError df[1, 1:2] .= "d"
    @test v1 == [100.0, 2.5, 3.5]
    @test v2 == [100.0, 5.5, 6.5]
    df[1, 1:2] .= 'e':'f'
    @test v1 == [101.0, 2.5, 3.5]
    @test v2 == [102.0, 5.5, 6.5]
    @test_throws DimensionMismatch df[1, 1:2] .= ['d' 'd']
    @test v1 == [101.0, 2.5, 3.5]
    @test v2 == [102.0, 5.5, 6.5]

    df = copy(refdf)
    v1 = df[!, 1]
    df[:, 1] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, 1] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, 1] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]

    df = copy(refdf)
    v1 = df[!, 1]
    df[:, :x1] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, :x1] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, :x1] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]

    df = copy(refdf)
    v1 = df[!, 1]
    df[:, 1] .= 'd':'f'
    @test v1 == [100.0, 101.0, 102.0]
    @test_throws MethodError df[:, 1] .= ["d", "e", "f"]
    @test v1 == [100.0, 101.0, 102.0]

    df = copy(refdf)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, 1:2] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, 1:2] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]

    df = copy(refdf)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= 'd':'f'
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [100.0, 101.0, 102.0]
    @test_throws MethodError df[:, 1:2] .= ["d", "e", "f"]
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [100.0, 101.0, 102.0]

    df = copy(refdf)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= permutedims('d':'e')
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [101.0, 101.0, 101.0]

    df = copy(refdf)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= reshape('d':'i', 3, :)
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [103.0, 104.0, 105.0]
    @test_throws DimensionMismatch df[:, 1:2] .= reshape('d':'i', 1, :, 3)
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [103.0, 104.0, 105.0]

    df = copy(refdf)
    v1 = df[!, 1]
    v1′ = df[:, 1]
    df[!, 1] .= 100.0
    @test df.x1 == [100.0, 100.0, 100.0]
    @test v1 == v1′
    df[!, 1] .= 'd'
    @test df.x1 == ['d', 'd', 'd']
    @test v1 == v1′
    @test_throws DimensionMismatch df[!, 1] .= [1 2 3]
    @test df.x1 == ['d', 'd', 'd']
    @test v1 == v1′

    df = copy(refdf)
    v1 = df[!, 1]
    v1′ = df[:, 1]
    df[!, :x1] .= 100.0
    @test df.x1 == [100.0, 100.0, 100.0]
    @test v1 == v1′
    df[!, :x1] .= 'd'
    @test df.x1 == ['d', 'd', 'd']
    @test v1 == v1′
    @test_throws DimensionMismatch df[!, :x1] .= [1 2 3]
    @test df.x1 == ['d', 'd', 'd']
    @test v1 == v1′

    df = copy(refdf)
    df[!, :newcol] .= 100.0
    @test df.newcol == [100.0, 100.0, 100.0]
    @test df[:, 1:end-1] == refdf

    df = copy(refdf)
    df[!, "newcol"] .= 100.0
    @test df.newcol == [100.0, 100.0, 100.0]
    @test df[:, 1:end-1] == refdf

    df = copy(refdf)
    df[!, :newcol] .= 'd'
    @test df.newcol == ['d', 'd', 'd']
    @test df[:, 1:end-1] == refdf

    df = copy(refdf)
    df[!, "newcol"] .= 'd'
    @test df.newcol == ['d', 'd', 'd']
    @test df[:, 1:end-1] == refdf

    df = copy(refdf)
    @test_throws DimensionMismatch df[!, :newcol] .= [1 2 3]
    @test df == refdf

    df = copy(refdf)
    @test_throws DimensionMismatch df[!, "newcol"] .= [1 2 3]
    @test df == refdf

    df = copy(refdf)
    @test_throws ArgumentError df[!, 10] .= 'a'
    @test df == refdf
    @test_throws ArgumentError df[!, 10] .= [1, 2, 3]
    @test df == refdf
    @test_throws ArgumentError df[!, 10] .= [1 2 3]
    @test df == refdf

    df = copy(refdf)
    df[!, 1:2] .= 'a'
    @test Matrix(df) == ['a'  'a'  7.5  10.5  13.5
                         'a'  'a'  8.5  11.5  14.5
                         'a'  'a'  9.5  12.5  15.5]

    df = copy(refdf)
    v1 = df[!, 1]
    df.x1 .= 'd'
    @test df.x1 == ['d', 'd', 'd']
    @test eltype(df.x1) === Char
    @test_throws MethodError df[:, 1] .= "d"
    @test_throws DimensionMismatch df[:, 1] .= [1 2 3]
    @test v1 == [1.5, 2.5, 3.5]

    df = DataFrame(a=1:4, b=1, c=2)
    df.a .= 'a':'d'
    @test df == DataFrame(a='a':'d', b=1, c=2)
    dfv = view(df, 2:3, 2:3)
    x = df.b
    dfv.b .= 0
    @test df.b == [1, 0, 0, 1]
    @test x == [1, 1, 1, 1]

    df = copy(refdf)
    df.newcol .= 'd'
    @test df == [refdf DataFrame(newcol=fill('d', 3))]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    @test_throws MethodError df[CartesianIndex(1, 1)] .= 1
    @test_throws MethodError df[CartesianIndex(1, 1)] .= "d"
    @test_throws DimensionMismatch df[CartesianIndex(1, 1)] .= [1, 2]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    @test_throws MethodError df[1, 1] .= 1
    @test_throws MethodError df[1, 1] .= "d"
    @test_throws DimensionMismatch df[1, 1] .= [1, 2]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    @test_throws MethodError df[1, :x1] .= 1
    @test_throws MethodError df[1, :x1] .= "d"
    @test_throws DimensionMismatch df[1, :x1] .= [1, 2]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[1, 1:2] .= 'd'
    @test v1 == [100.0, 2.5, 3.5]
    @test v2 == [100.0, 5.5, 6.5]
    @test_throws MethodError df[1, 1:2] .= "d"
    @test v1 == [100.0, 2.5, 3.5]
    @test v2 == [100.0, 5.5, 6.5]
    df[1, 1:2] .= 'e':'f'
    @test v1 == [101.0, 2.5, 3.5]
    @test v2 == [102.0, 5.5, 6.5]
    @test_throws DimensionMismatch df[1, 1:2] .= ['d' 'd']
    @test v1 == [101.0, 2.5, 3.5]
    @test v2 == [102.0, 5.5, 6.5]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    df[:, 1] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, 1] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, 1] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    df[:, :x1] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, :x1] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, :x1] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    df[:, 1] .= 'd':'f'
    @test v1 == [100.0, 101.0, 102.0]
    @test_throws MethodError df[:, 1] .= ["d", "e", "f"]
    @test v1 == [100.0, 101.0, 102.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= 'd'
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]
    @test_throws MethodError df[:, 1:2] .= "d"
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]
    @test_throws DimensionMismatch df[:, 1:2] .= [1 2 3]
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [100.0, 100.0, 100.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= 'd':'f'
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [100.0, 101.0, 102.0]
    @test_throws MethodError df[:, 1:2] .= ["d", "e", "f"]
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [100.0, 101.0, 102.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= permutedims('d':'e')
    @test v1 == [100.0, 100.0, 100.0]
    @test v2 == [101.0, 101.0, 101.0]

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    v2 = df[!, 2]
    df[:, 1:2] .= reshape('d':'i', 3, :)
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [103.0, 104.0, 105.0]
    @test_throws DimensionMismatch df[:, 1:2] .= reshape('d':'i', 1, :, 3)
    @test v1 == [100.0, 101.0, 102.0]
    @test v2 == [103.0, 104.0, 105.0]

    df = view(copy(refdf), :, :)
    df[!, 1] .= 100
    @test parent(df).x1 == [100, 100, 100]
    @test eltype(parent(df).x1) == Float64

    df = view(copy(refdf), :, :)
    df[!, :x1] .= 100.0
    @test parent(df).x1 == [100, 100, 100]
    @test eltype(parent(df).x1) == Float64

    df = view(copy(refdf), :, :)
    df[!, :newcol] .= 100.0
    @test parent(df).newcol == [100, 100, 100]
    @test eltype(parent(df).newcol) == Union{Float64, Missing}

    df = view(copy(refdf), :, :)
    @test_throws ArgumentError df[!, 10] .= 'a'
    @test df == refdf
    @test_throws ArgumentError df[!, 10] .= [1, 2, 3]
    @test df == refdf
    @test_throws ArgumentError df[!, 10] .= [1 2 3]
    @test df == refdf

    df = view(copy(refdf), :, :)
    df[!, 1:2] .= 'a'
    @test parent(df).x1 == parent(df).x2 == ['a', 'a', 'a']
    @test eltype(parent(df).x1) === Any

    df = view(copy(refdf), :, :)
    v1 = df[!, 1]
    df.x1 .= 'd'
    @test df.x1 == ['d', 'd', 'd']
    @test eltype(df.x1) === Any
    df[:, 1] .= "d"
    @test df.x1 == ["d", "d", "d"]
    @test_throws DimensionMismatch df[:, 1] .= [1 2 3]
    @test v1 == [1.5, 2.5, 3.5]

    df = view(copy(refdf), :, :)
    df.newcol .= 'd'
    @test df.newcol == fill('d', 3)
end

@testset "DataFrameRow getproperty broadcasted assignment" begin
    df = DataFrame(a=[[1, 2], [3, 4]], b=[[5, 6], [7, 8]])
    dfr = df[1, :]
    dfr.a .= 10
    @test df == DataFrame(a=[[10, 10], [3, 4]], b=[[5, 6], [7, 8]])
    @test_throws MethodError dfr.a .= ["a", "b"]

    df = DataFrame(a=[[1, 2], [3, 4]], b=[[5, 6], [7, 8]])
    dfr = df[1, 1:1]
    dfr.a .= 10
    @test df == DataFrame(a=[[10, 10], [3, 4]], b=[[5, 6], [7, 8]])
    @test_throws MethodError dfr.a .= ["a", "b"]

    df = DataFrame(a=[[1, 2], [3, 4]], b=[[5, 6], [7, 8]])
    dfr = df[1, :]
    dfr."a" .= 10
    @test df == DataFrame(a=[[10, 10], [3, 4]], b=[[5, 6], [7, 8]])
    @test_throws MethodError dfr."a" .= ["a", "b"]

    df = DataFrame(a=[[1, 2], [3, 4]], b=[[5, 6], [7, 8]])
    dfr = df[1, 1:1]
    dfr."a" .= 10
    @test df == DataFrame(a=[[10, 10], [3, 4]], b=[[5, 6], [7, 8]])
    @test_throws MethodError dfr."a" .= ["a", "b"]
end

@testset "make sure that : is in place and ! allocates" begin
    df = DataFrame(a=[1, 2, 3])
    a = df.a
    df[:, :a] .+= 1
    @test a == [2, 3, 4]
    @test df.a === a
    df[!, :a] .+= 1
    @test a == [2, 3, 4]
    @test df.a == [3, 4, 5]
    @test df.a !== a

    df = DataFrame(a=[1, 2, 3])
    a = df.a
    df[:, "a"] .+= 1
    @test a == [2, 3, 4]
    @test df.a === a
    df[!, "a"] .+= 1
    @test a == [2, 3, 4]
    @test df.a == [3, 4, 5]
    @test df.a !== a
end

@testset "add new correct rules for df[row, col] .= v broadcasting" begin
    for v in [:a, "a"]
        df = DataFrame(a=1)
        @test_throws MethodError df[1, 1] .= 10
        @test_throws MethodError df[1, v] .= 10
        @test_throws MethodError df[CartesianIndex(1, 1)] .= 10
        df = DataFrame(a=[[1, 2, 3]])
        df[1, 1] .= 10
        @test df == DataFrame(a=[[10, 10, 10]])
        df[1, v] .= 100
        @test df == DataFrame(a=[[100, 100, 100]])
        df[CartesianIndex(1, 1)] .= 1000
        @test df == DataFrame(a=[[1000, 1000, 1000]])
    end
end

@testset "broadcasting into df[!, cols]" begin
    for selector in [1:2, Between(:x1, :x2), Not(r"x3"), [:x1, :x2],
                     ["x1", "x2"], Between("x1", "x2")]
        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= "a"
        @test df == DataFrame(fill("a", 3, 2), :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= Ref((a=1, b=2))
        @test df == DataFrame(fill((a=1, b=2), 3, 2), :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= ["a" "b"]
        @test df == DataFrame(["a" "b"
                               "a" "b"
                               "a" "b"], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= ["a", "b", "c"]
        @test df == DataFrame(["a" "a"
                               "b" "b"
                               "c" "c"], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= categorical(["a"])
        @test df == DataFrame(["a" "a"
                               "a" "a"
                               "a" "a"], :auto)
        @test df.x1 isa CategoricalVector
        @test df.x2 isa CategoricalVector
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= DataFrame(["a" "b"], :auto)
        @test df == DataFrame(["a" "b"
                               "a" "b"
                               "a" "b"], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= DataFrame(["a" "d"
                                      "b" "e"
                                      "c" "f"], :auto)
        @test df == DataFrame(["a" "d"
                               "b" "e"
                               "c" "f"], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6)
        df[!, selector] .= ["a" "d"
                            "b" "e"
                            "c" "f"]
        @test df == DataFrame(["a" "d"
                               "b" "e"
                               "c" "f"], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= "a"
        @test df == DataFrame(["a" "a" 1
                               "a" "a" 1
                               "a" "a" 1], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= Ref((a=1, b=2))
        @test df[:, 1:2] == DataFrame(fill((a=1, b=2), 3, 2), :auto)
        @test df[:, 3] == [1, 1, 1]
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= ["a" "b"]
        @test df == DataFrame(["a" "b" 1
                               "a" "b" 1
                               "a" "b" 1], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= ["a", "b", "c"]
        @test df == DataFrame(["a" "a" 1
                               "b" "b" 1
                               "c" "c" 1], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= categorical(["a"])
        @test df == DataFrame(["a" "a" 1
                               "a" "a" 1
                               "a" "a" 1], :auto)
        @test df.x1 isa CategoricalVector
        @test df.x2 isa CategoricalVector
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= DataFrame(["a" "b"], :auto)
        @test df == DataFrame(["a" "b" 1
                               "a" "b" 1
                               "a" "b" 1], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= DataFrame(["a" "d"
                                      "b" "e"
                                      "c" "f"], :auto)
        @test df == DataFrame(["a" "d" 1
                               "b" "e" 1
                               "c" "f" 1], :auto)
        @test df.x1 !== df.x2

        df = DataFrame(x1=1:3, x2=4:6, x3=1)
        df[!, selector] .= ["a" "d"
                            "b" "e"
                            "c" "f"]
        @test df == DataFrame(["a" "d" 1
                               "b" "e" 1
                               "c" "f" 1], :auto)
        @test df.x1 !== df.x2
    end

    df = DataFrame(x1=1:3, x2=4:6)
    @test_throws ArgumentError df[!, [:x1, :x3]] .= "a"
end

@testset "broadcasting over heterogeneous columns" begin
    df = DataFrame(x=[1, 1.0, big(1), "1"])
    f_identity(x) = x
    @test df == f_identity.(df)
end

@testset "@views on df[!, col]" begin
    df = DataFrame(ones(3, 4), :auto)
    @views df[!, 1] .+= 1
    @test df[!, 1] == [2.0, 2.0, 2.0]
    @views df[:, 2] .= df[!, 4] .+ df[!, 3]
    @test df[!, 2] == [2.0, 2.0, 2.0]

    # make sure we do not mess with maybeview
    @test @views typeof(df[!, 1:2]) <: SubDataFrame
end

@testset "broadcasting of df[:, col] = value" begin
    df = DataFrame(ones(3, 4), :auto)
    z = ["a", "b", "c"]
    df[:, :z] .= z
    @test df.z == z
    @test df.z !== z
    @test_throws ArgumentError df[:, 6] .= z
    @test_throws MethodError df[:, 1] .= z

    df = DataFrame(ones(3, 4), :auto)
    z = "abc"
    df[:, :z] .= z
    @test df.z == fill("abc", 3)
    @test_throws ArgumentError df[:, 6] .= z
    @test_throws MethodError df[:, 1] .= z

    df = DataFrame(ones(3, 4), :auto)
    z = fill("abc", 1, 1, 2)
    @test_throws DimensionMismatch df[:, :z] .= z

    df = DataFrame(ones(3, 4), :auto)
    z = ["a", "b", "c"]
    df[:, "z"] .= z
    @test df.z == z
    @test df.z !== z

    df = DataFrame(ones(3, 4), :auto)
    z = "abc"
    df[:, "z"] .= z
    @test df.z == fill("abc", 3)

    df = DataFrame(ones(3, 4), :auto)
    z = fill("abc", 1, 1, 2)
    @test_throws DimensionMismatch df[:, "z"] .= z
end

@testset "broadcasting of getproperty" begin
    df = DataFrame(a=1:4)
    df.b .= 1
    x = df.b
    df.c .= 4:-1:1
    df.a .= 'a':'d'
    @test df.a isa Vector{Char}
    @test df == DataFrame(a='a':'d', b=1, c=4:-1:1)

    # in views also column replacement is performed
    dfv = view(df, 2:3, 2:3)
    dfv.b .= 0
    @test x == [1, 1, 1, 1]
    @test df.b !== x
    @test df == DataFrame(a='a':'d', b=[1, 0, 0, 1], c=4:-1:1)
    dfv.c .= ["p", "q"]
    @test df == DataFrame(a='a':'d', b=[1, 0, 0, 1], c=[4, "p", "q", 1])
end

@testset "dotgetproperty on SubDataFrame" begin
    df = DataFrame(a=1:3, b=4:6)
    dfv = @view df[[3, 1], :]
    dfv.c .= [1, 2]
    @test df ≅ DataFrame(a=1:3, b=4:6, c=[2, missing, 1])

    df = DataFrame(a=1:3, b=4:6)
    dfv = @view df[[3, 1], 1:2]
    @test_throws ArgumentError dfv.c .= [1, 2]
end

@testset "test coverage for corner cases that are not normally called" begin
    @test Base.Broadcast.BroadcastStyle(DataFrames.DataFrameStyle(),
                                        Base.Broadcast.Unknown()) isa DataFrames.DataFrameStyle
    df = DataFrame(a=1)
    @test Base.Broadcast.broadcast_unalias(nothing, df) === df
    @test Base.Broadcast.broadcast_unalias(df[1, :], df) == df
    @test Base.Broadcast.broadcast_unalias(df[1, :], df) !== df
    @test Base.Broadcast.broadcast_unalias(copy(df)[1, :], df) === df
end

end # module

# "kernel" functions for hashrows()
# adjust row hashes by the hashes of column elements
function hashrows_col!(h::Vector{UInt},
                       n::Vector{Bool},
                       v::AbstractVector{T},
                       rp::Nothing,
                       firstcol::Bool) where T
    @spawn_for_chunks 100_000 for i in eachindex(h)
        @inbounds begin
            el = v[i]
            h[i] = hash(el, h[i])
            if length(n) > 0
                n[i] |= ismissing(el)
            end
        end
    end
    h
end

# should give the same hash as AbstractVector{T}
function hashrows_col!(h::Vector{UInt},
                       n::Vector{Bool},
                       v::AbstractVector,
                       rp::Any,
                       firstcol::Bool)
    # When hashing the first column, no need to take into account previous hash,
    # which is always zero
    # also when the number of values in the pool is more than half the length
    # of the vector avoid using this path. 50% is roughly based on benchmarks
    if firstcol && Int64(2) * length(rp) < length(v)
        ra = DataAPI.refarray(v)
        firp = firstindex(rp)
        fira = firstindex(ra)

        hashes = Vector{UInt}(undef, length(rp))
        @spawn_for_chunks 100_000 for i in eachindex(hashes)
            @inbounds hashes[i] = hash(rp[i+firp-1])
        end

        # here we rely on the fact that `DataAPI.refpool` has a continuous
        # block of indices
        @spawn_for_chunks 100_000 for i in eachindex(h)
            @inbounds ref = ra[i+fira-1]
            @inbounds h[i] = hashes[ref+1-firp]
        end
    else
        @spawn_for_chunks 100_000 for i in eachindex(h, v)
            @inbounds h[i] = hash(v[i], h[i])
        end
    end
    # Doing this step separately is faster, as it would disable SIMD above
    if eltype(v) >: Missing && length(n) > 0
        n .|= ismissing.(v)
    end
    h
end

# Calculate the vector of `df` rows hash values.
function hashrows(cols::Tuple{Vararg{AbstractVector}}, skipmissing::Bool)
    len = length(cols[1])
    ref_val = @static Base.VERSION >= v"1.13.0-DEV" ? Base.HASH_SEED : UInt(0)
    rhashes = fill(ref_val, len)
    missings = fill(false, skipmissing ? len : 0)
    for (i, col) in enumerate(cols)
        rp = DataAPI.refpool(col)
        hashrows_col!(rhashes, missings, col, rp, i == 1)
    end
    return (rhashes, missings)
end

# table columns are passed as a tuple of vectors to ensure type specialization
isequal_row(cols::Tuple{AbstractVector}, r1::Int, r2::Int) =
    isequal(cols[1][r1], cols[1][r2])
isequal_row(cols::Tuple{Vararg{AbstractVector}}, r1::Int, r2::Int) =
    isequal(cols[1][r1], cols[1][r2]) && isequal_row(Base.tail(cols), r1, r2)

isequal_row(cols1::Tuple{AbstractVector}, r1::Int, cols2::Tuple{AbstractVector}, r2::Int) =
    isequal(cols1[1][r1], cols2[1][r2])
isequal_row(cols1::Tuple{Vararg{AbstractVector}}, r1::Int,
            cols2::Tuple{Vararg{AbstractVector}}, r2::Int) =
    isequal(cols1[1][r1], cols2[1][r2]) &&
        isequal_row(Base.tail(cols1), r1, Base.tail(cols2), r2)

# IntegerRefarray and IntegerRefPool are two complementary view types that allow
# wrapping arrays with Union{Real, Missing} eltype to satisfy the DataAPI.refpool
# and DataAPI.refarray API when calling row_group_slots!.
# IntegerRefarray converts values to Int and replaces missing with an integer
# (set by the caller to the maximum value + 1)
# IntegerRefPool subtracts the minimum value - 1 and replaces back the maximum
# value + 1 to missing. This ensures all values are in 1:length(refpool), while
# row_group_slots! knows the number of (potential) groups via length(refpool)
# and is able to skip missing values when skipmissing=true

struct IntegerRefarray{T<:AbstractArray} <: AbstractVector{Int}
    x::T
    offset::Int
    replacement::Int
end

Base.size(x::IntegerRefarray) = size(x.x)
Base.axes(x::IntegerRefarray) = axes(x.x)
Base.IndexStyle(::Type{<:IntegerRefarray{T}}) where {T} = Base.IndexStyle(T)
@inline function Base.getindex(x::IntegerRefarray, i)
    @boundscheck checkbounds(x.x, i)
    @inbounds v = x.x[i]
    if eltype(x.x) >: Missing && v === missing
        return x.replacement
    else
        # Overflow is guaranteed not to happen by checks before calling the constructor
        return Int(v - x.offset)
    end
end

struct IntegerRefpool{T<:Union{Int, Missing}} <: AbstractVector{T}
    max::Int
    function IntegerRefpool{T}(max::Integer) where T<:Union{Int, Missing}
        @assert max < typemax(Int) # to store missing values as max + 1
        new{T}(max)
    end
end

Base.size(x::IntegerRefpool{T}) where {T} = (x.max + (T >: Missing),)
Base.axes(x::IntegerRefpool{T}) where {T} = (Base.OneTo(x.max + (T >: Missing)),)
Base.IndexStyle(::Type{<:IntegerRefpool}) = Base.IndexLinear()
@inline function Base.getindex(x::IntegerRefpool{T}, i::Real) where T
    @boundscheck checkbounds(x, i)
    if T >: Missing && i == x.max + 1
        return missing
    else
        return Int(i)
    end
end
Base.allunique(::IntegerRefpool) = true
Base.issorted(::IntegerRefpool) = true

function refpool_and_array(x::AbstractArray)
    refpool = DataAPI.refpool(x)
    refarray = DataAPI.refarray(x)

    if refpool !== nothing
        # When invrefpool is defined, values are necessarily unique
        if DataAPI.invrefpool(x) !== nothing || allunique(refpool)
            return refpool, refarray
        else
            return nothing, nothing
        end
    elseif x isa AbstractArray{<:Union{Real, Missing}} && length(x) > 0 &&
        (x isa AbstractArray{<:Union{Integer, Missing}} ||
         all(v -> (ismissing(v) | isinteger(v)) & !isequal(v, -0.0), x))
        if Missing <: eltype(x)
            smx = skipmissing(x)
            if isempty(smx)
                return nothing, nothing
            else
                minval, maxval = extrema(smx)
            end
        else
            minval, maxval = extrema(x)
        end
        ngroups = BigInt(maxval) - BigInt(minval) + 1
        # Threshold chosen with the same rationale as the row_group_slots! refpool method:
        # refpool approach is faster but we should not allocate too much memory either
        # We also have to avoid overflow, including with ngroups + 1 for missing values
        # (note that it would be possible to allow minval and maxval to be outside of the
        # range supported by Int by adding a type parameter for minval to IntegerRefarray)
        if typemin(Int) < minval <= maxval < typemax(Int) &&
            ngroups + 1 <= Int64(2) * length(x) <= typemax(Int)
            T = eltype(x) >: Missing ? Union{Int, Missing} : Int
            refpool′ = IntegerRefpool{T}(Int(ngroups))
            refarray′ = IntegerRefarray(x, Int(minval) - 1, Int(ngroups) + 1)
            return refpool′, refarray′
        end
    end
    return nothing, nothing
end

# Returns a tuple:
# 1) the highest group index in the `groups` vector
# 2) vector of row hashes (may be empty if hash=Val(false))
# 3) slot array for a hash map, non-zero values are
#    the indices of the first row in a group
#    (returned only if hashes are generated)
# 4) whether groups are already sorted
# Optional `groups` vector is set to the group indices of each row (starting at 1)
# With skipmissing=true, rows with missing values are attributed index 0.
#
# Also the last argument is `compress`. If it is `false` then groups are not
# compressed to form a continuous sequence. Normally `true` should be passed
# as this ensures that returned `ngroups` indeed indicates the number of groups
# but e.g. in `nonunique` we do not use this information so compressing
# can be skipped by passing `compress=false`
function row_group_slots!(cols::Tuple{Vararg{AbstractVector}},
                          hash::Val,
                          groups::Union{Vector{Int}, Nothing},
                          skipmissing::Bool,
                          sort::Union{Bool, Nothing},
                          compress::Bool)::Tuple{Int, Vector{UInt}, Vector{Int}, Bool}
    rpa = refpool_and_array.(cols)
    if sort === false
        refpools = nothing
        refarrays = nothing
    else
        refpools = first.(rpa)
        refarrays = last.(rpa)
    end
    row_group_slots!(cols, refpools, refarrays, hash, groups, skipmissing,
                     sort === true, compress)
end

# Generic fallback method based on open addressing hash table
function row_group_slots!(cols::Tuple{Vararg{AbstractVector}},
                          refpools::Any,  # Ignored
                          refarrays::Any, # Ignored
                          hash::Val,
                          groups::Union{Vector{Int}, Nothing},
                          skipmissing::Bool,
                          sort::Bool,
                          compress::Bool)::Tuple{Int, Vector{UInt}, Vector{Int}, Bool}
    @assert groups === nothing || length(groups) == length(cols[1])
    rhashes, missings = hashrows(cols, skipmissing)
    # inspired by Dict code from base cf. https://github.com/JuliaData/DataTables.jl/pull/17#discussion_r102481481
    # but using open addressing with a table with at least 5/4 as many slots as rows
    # (rounded up to nearest power of 2) to avoid performance degradation
    # in a corner case of groups having exactly one row
    sz = max(1 + ((5 * length(rhashes)) >> 2), 16)
    sz = 1 << (8 * sizeof(sz) - leading_zeros(sz - 1))
    @assert 4 * sz >= 5 * length(rhashes)
    szm1 = sz-1
    gslots = zeros(Int, sz)
    # If missings are to be skipped, they will all go to group 0,
    # which will be removed by functions down the stream
    ngroups = 0
    @inbounds for i in eachindex(rhashes)
        # find the slot and group index for a row
        slotix = rhashes[i] & szm1 + 1
        # Use -1 for non-missing values to catch bugs if group is not found
        gix = skipmissing && missings[i] ? 0 : -1
        probe = 0
        if !skipmissing || !missings[i]
            while true
                g_row = gslots[slotix]
                if g_row == 0 # unoccupied slot, current row starts a new group
                    gslots[slotix] = i
                    gix = ngroups += 1
                    break
                elseif rhashes[i] == rhashes[g_row] # occupied slot, check if miss or hit
                    if isequal_row(cols, i, g_row) # hit
                        gix = groups !== nothing ? groups[g_row] : 0
                        break
                    end
                end
                slotix = slotix & szm1 + 1 # check the next slot
                probe += 1
                @assert probe < sz
            end
        end
        if groups !== nothing
            groups[i] = gix
        end
    end
    return ngroups, rhashes, gslots, false
end

# Optimized method for arrays for which DataAPI.refpool is defined and returns an AbstractVector
function row_group_slots!(cols::NTuple{N, AbstractVector},
                          refpools::NTuple{N, AbstractVector},
                          refarrays::NTuple{N,
                              Union{AbstractVector{<:Real},
                                    Missings.EachReplaceMissing{
                                        <:AbstractVector{<:Union{Real, Missing}}}}},
                          hash::Val{false},
                          groups::Vector{Int},
                          skipmissing::Bool,
                          sort::Bool,
                          compress::Bool)::Tuple{Int, Vector{UInt}, Vector{Int}, Bool} where N
    # Computing neither hashes nor groups isn't very useful,
    # and this method needs to allocate a groups vector anyway
    @assert all(col -> length(col) == length(groups), cols)

    missinginds = map(refpools) do refpool
        eltype(refpool) >: Missing ?
            something(findfirst(ismissing, refpool), lastindex(refpool)+1) : lastindex(refpool)+1
    end

    # If skipmissing=true, rows with missings all go to group 0,
    # which will be removed by functions down the stream
    ngroupstup = map(refpools, missinginds) do refpool, missingind
        len = length(refpool)
        if skipmissing && missingind <= lastindex(refpool)
            return len - 1
        else
            return len
        end
    end
    ngroups = prod(ngroupstup)

    # Fall back to hashing if there would be too many empty combinations
    # or if the pool does not contain only unique values
    # The first check ensures the computation of ngroups did not overflow.
    # The rationale for the 2 threshold is that while the fallback method is always slower,
    # it allocates a hash table of size length(groups) instead of the remap vector
    # of size ngroups (i.e. the number of possible combinations) in this method:
    # so it makes sense to allocate more memory for better performance,
    # but it needs to remain reasonable compared with the size of the data frame.
    if prod(big.(ngroupstup)) > typemax(Int) ||
       ngroups > Int64(2) * length(groups)
        # In the simplest case, we can work directly with the reference codes
        newcols = (skipmissing && any(refpool -> eltype(refpool) >: Missing, refpools)) ||
                  !(refarrays isa NTuple{<:Any, AbstractVector}) ||
                  sort ? cols : refarrays
        return invoke(row_group_slots!,
                      Tuple{Tuple{Vararg{AbstractVector}}, Any, Any, Val,
                            Union{Vector{Int}, Nothing}, Bool, Bool, Bool},
                      newcols, refpools, refarrays, hash, groups, skipmissing, sort, compress)
    end

    strides = (cumprod(collect(reverse(ngroupstup)))[end-1:-1:1]..., 1)::NTuple{N, Int}
    firstinds = map(firstindex, refpools)
    if sort
        nminds = map(refpools, missinginds) do refpool, missingind
            missingind > lastindex(refpool) ?
                eachindex(refpool) : setdiff(eachindex(refpool), missingind)
        end
        if skipmissing
            sorted = all(issorted(view(refpool, nmind))
                         for (refpool, nmind) in zip(refpools, nminds))
        else
            sorted = all(issorted, refpools)
        end
    else
        sorted = false
    end

    lg = length(groups)
    nt = Threads.nthreads()
    # make sure we are processing at least 100_000 rows per task if we do threading
    if lg < 100_000 * nt
       nt = max(1, lg ÷ 100_000)
    end
    # if there are few rows per group limit the number of threads used
    if ngroups == 0
        nt = 1
    else
        nt = clamp(round(Int, (lg / 4) / ngroups - 2), 1, nt)
    end

    seen = fill(false, ngroups)
    seen_vec = Vector{Vector{Bool}}(undef, nt)
    seen_vec[1] = seen
    for i in 2:nt
        seen_vec[i] = fill(false, ngroups)
    end
    range_chunks = split_to_chunks(lg, nt)

    if sort && !sorted
        # Compute vector mapping missing to -1 if skipmissing=true
        refmaps = map(cols, refpools, missinginds, nminds) do col, refpool, missingind, nmind
            refmap = collect(0:length(refpool)-1)
            if skipmissing
                fi = firstindex(refpool)
                if missingind <= lastindex(refpool)
                    refmap[missingind-fi+1] = -1
                    refmap[missingind-fi+2:end] .-= 1
                end
                if sort
                    perm = sortperm(view(refpool, nmind))
                    invpermute!(view(refmap, nmind .- fi .+ 1), perm)
                end
            elseif sort
                # collect is needed for CategoricalRefPool
                invpermute!(refmap, sortperm(collect(refpool)))
            end
            refmap
        end
        @sync for (seeni, range_chunk) in zip(seen_vec, range_chunks)
            @spawn for i in range_chunk
                @inbounds begin
                    local refs_i
                    let i=i # Workaround for julia#15276
                        refs_i = map(refarrays) do c
                            return @inbounds c[i]
                        end
                    end
                    vals = map(refmaps, refs_i, strides, firstinds) do m, r, s, fi
                        return @inbounds m[r-fi+1] * s
                    end
                    j = sum(vals) + 1
                    # x < 0 happens with -1 in refmap, which corresponds to missing
                    if skipmissing && any(x -> x < 0, vals)
                        j = 0
                    else
                        seeni[j] = true
                    end
                    groups[i] = j
                end
            end
        end
    else
        @sync for (seeni, range_chunk) in zip(seen_vec, range_chunks)
            @spawn for i in range_chunk
                @inbounds begin
                    local refs_i
                    let i=i # Workaround for julia#15276
                        refs_i = map(refarrays, missinginds) do ref, missingind
                            r = @inbounds Int(ref[i])
                            if skipmissing
                                return r == missingind ? -1 : (r > missingind ? r-1 : r)
                            else
                                return r
                            end
                        end
                    end
                    vals = map((r, s, fi) -> (r-fi) * s, refs_i, strides, firstinds)
                    j = sum(vals) + 1
                    # x < 0 happens with -1, which corresponds to missing
                    if skipmissing && any(x -> x < 0, vals)
                        j = 0
                    else
                        seeni[j] = true
                    end
                    groups[i] = j
                end
            end
        end
    end

    function reduce_or!(x::AbstractVector{Vector{Bool}})
        len = length(x)
        if len < 2
            return
        elseif len == 2
            x[1] .|= x[2]
        else
            xl = view(x, 1:len ÷ 2)
            xr = view(x, len ÷ 2 + 1:len)
            t1 = @spawn reduce_or!(xl)
            t2 = @spawn reduce_or!(xr)
            fetch(t1)
            fetch(t2)
            xl[1] .|= xr[1]
        end
        return
    end

    reduce_or!(seen_vec)

    # If some groups are unused, compress group indices to drop them
    # sum(seen) is faster than all(seen) when not short-circuiting,
    # and short-circuit would only happen in the slower case anyway
    #
    # This process is not needed if row_group_slots! is called with compress=false
    if compress && sum(seen) < length(seen)
        oldngroups = ngroups
        remap = zeros(Int, ngroups)
        ngroups = 0
        @inbounds for i in eachindex(remap, seen)
            ngroups += seen[i]
            remap[i] = ngroups
        end
        @inbounds for i in eachindex(groups)
            gix = groups[i]
            groups[i] = gix > 0 ? remap[gix] : 0
        end
        # To catch potential bugs inducing unnecessary computations
        @assert oldngroups != ngroups
    end
    return ngroups, UInt[], Int[], sort
end


# Return a 3-tuple of a permutation that sorts rows into groups,
# and the positions of the first and last rows in each group in that permutation
# `groups` must contain group indices in 0:ngroups
# Rows with group index 0 are skipped (used when skipmissing=true)
# Partly uses the code of Wes McKinney's groupsort_indexer in pandas (file: src/groupby.pyx).
function compute_indices(groups::AbstractVector{<:Integer}, ngroups::Integer)
    # count elements in each group
    stops = zeros(Int, ngroups+1)
    @inbounds for gix in groups
        stops[gix+1] += 1
    end

    # group start positions in a sorted table
    starts = Vector{Int}(undef, ngroups+1)
    if length(starts) > 0
        starts[1] = 1
        @inbounds for i in 1:ngroups
            starts[i+1] = starts[i] + stops[i]
        end
    end

    # define row permutation that sorts them into groups
    rperm = Vector{Int}(undef, length(groups))
    copyto!(stops, starts)
    @inbounds for (i, gix) in enumerate(groups)
        rperm[stops[gix+1]] = i
        stops[gix+1] += 1
    end
    stops .-= 1

    # When skipmissing=true was used, group 0 corresponds to missings to drop
    # Otherwise it's empty
    popfirst!(starts)
    popfirst!(stops)

    return rperm, starts, stops
end

module TestConstructors

using Test, DataFrames, CategoricalArrays, DataStructures
using DataFrames: Index, _columns, index
const ≅ = isequal

#
# DataFrame
#
@testset "constructors" begin
    df = DataFrame()
    @inferred DataFrame()

    @test isempty(_columns(df))
    @test _columns(df) isa Vector{AbstractVector}
    @test index(df) == Index()
    @test size(DataFrame(copycols=false)) == (0, 0)

    vecvec = [CategoricalVector{Union{Float64, Missing}}(zeros(3)),
              CategoricalVector{Union{Float64, Missing}}(ones(3))]

    df = DataFrame(collect(Any, vecvec), Index([:x1, :x2]))
    @test size(df, 1) == 3
    @test size(df, 2) == 2

    df2 = DataFrame(collect(Any, vecvec), Index([:x1, :x2]), copycols=false)
    @test size(df2, 1) == 3
    @test size(df2, 2) == 2
    @test df2.x1 === vecvec[1]
    @test df2.x2 === vecvec[2]

    @test_throws ArgumentError DataFrame([[1, 2]], :autos)
    @test_throws ArgumentError DataFrame([1 2], :autos)

    for copycolsarg in (true, false)
        @test df == DataFrame(vecvec, :auto, copycols=copycolsarg)
        @test df == DataFrame(collect(Any, vecvec), :auto, copycols=copycolsarg)
        @test df == DataFrame(collect(AbstractVector, vecvec), :auto, copycols=copycolsarg)
        @test df == DataFrame(x1=vecvec[1], x2=vecvec[2], copycols=copycolsarg)

        for cols in ([:x1, :x2], ["x1", "x2"])
            @test df == DataFrame(vecvec, cols, copycols=copycolsarg)
            @test df == DataFrame(collect(Any, vecvec), cols, copycols=copycolsarg)
            @test df == DataFrame(collect(AbstractVector, vecvec), cols, copycols=copycolsarg)
            @test df == DataFrame([col=>vect for (col, vect) in zip(cols, vecvec)], copycols=copycolsarg)
        end
    end

    @test DataFrame([1:3, 1:3], :auto) == DataFrame(Any[1:3, 1:3], :auto) ==
          DataFrame(UnitRange[1:3, 1:3], :auto) == DataFrame(AbstractVector[1:3, 1:3], :auto) ==
          DataFrame([[1, 2, 3], [1, 2, 3]], :auto) == DataFrame(Any[[1, 2, 3], [1, 2, 3]], :auto) ==
          DataFrame([1:3, [1, 2, 3]], :auto)
          DataFrame([:x1=>1:3, :x2=>[1, 2, 3]]) == DataFrame(["x1"=>1:3, "x2"=>[1, 2, 3]])

    @inferred DataFrame([1:3, 1:3], :auto)
    @inferred DataFrame([1:3, 1:3], [:a, :b])
    @inferred DataFrame([1:3, 1:3], ["a", "b"])

    @inferred DataFrame([:x1=>1:3, :x2=>[1, 2, 3]])
    @inferred DataFrame(["x1"=>1:3, "x2"=>[1, 2, 3]])

    @test df !== DataFrame(df)
    @test df == DataFrame(df)

    @test df == DataFrame(x1=Union{Float64, Missing}[0.0, 0.0, 0.0],
                          x2=Union{Float64, Missing}[1.0, 1.0, 1.0])
    @test df == DataFrame(x1=Union{Float64, Missing}[0.0, 0.0, 0.0],
                          x2=Union{Float64, Missing}[1.0, 1.0, 1.0],
                          x3=Union{Float64, Missing}[2.0, 2.0, 2.0])[:, [:x1, :x2]]
    @test df == DataFrame(x1=Union{Float64, Missing}[0.0, 0.0, 0.0],
                          x2=Union{Float64, Missing}[1.0, 1.0, 1.0],
                          x3=Union{Float64, Missing}[2.0, 2.0, 2.0])[:, ["x1", "x2"]]

    @test_throws BoundsError SubDataFrame(DataFrame(A=1), 0:0, :)
    @test_throws ArgumentError SubDataFrame(DataFrame(A=1), 0, :)
    @test_throws BoundsError DataFrame(A=1)[0, :]
    @test_throws BoundsError DataFrame(A=1)[0, 1:1]
    @test SubDataFrame(DataFrame(A=1), 1:1, :) == DataFrame(A=1)
    @test SubDataFrame(DataFrame(A=1:10), 1:4, :) == DataFrame(A=1:4)
    @test view(SubDataFrame(DataFrame(A=1:10), 1:4, :), 2:2, :) == DataFrame(A=2)
    @test view(SubDataFrame(DataFrame(A=1:10), 1:4, :), [true, true, false, false], :) == DataFrame(A=1:2)

    @test DataFrame(a=1, b=1:2) == DataFrame(a=[1, 1], b=[1, 2])

    @test_throws ArgumentError DataFrame(makeunique=true)
    @test_throws ArgumentError DataFrame(a=1, makeunique=true)
    @test_throws ArgumentError DataFrame(a=1, makeunique=true, copycols=false)
end

@testset "DataFrame keyword argument constructor" begin
    x = [1, 2, 3]
    y = [4, 5, 6]

    df = DataFrame(x=x, y=y)
    @test size(df) == (3, 2)
    @test propertynames(df) == [:x, :y]
    @test df.x == x
    @test df.y == y
    @test df.x !== x
    @test df.y !== y
    df = DataFrame(x=x, y=y, copycols=true)
    @test size(df) == (3, 2)
    @test propertynames(df) == [:x, :y]
    @test df.x == x
    @test df.y == y
    @test df.x !== x
    @test df.y !== y
    df = DataFrame(x=x, y=y, copycols=false)
    @test size(df) == (3, 2)
    @test propertynames(df) == [:x, :y]
    @test df.x === x
    @test df.y === y
    @test_throws ArgumentError DataFrame(x=x, y=y, copycols=1)

    df = DataFrame(x=x, y=y, copycols=false)
    @test size(df) == (3, 2)
    @test propertynames(df) == [:x, :y]
    @test df.x === x
    @test df.y === y
end

@testset "DataFrame constructor" begin
    df1 = DataFrame(x=1:3, y=1:3)

    df2 = DataFrame(df1)
    df3 = copy(df1)
    @test df1 == df2 == df3
    @test df1.x !== df2.x
    @test df1.x !== df3.x
    @test df1.y !== df2.y
    @test df1.y !== df3.y

    df2 = DataFrame(df1, copycols=false)
    df3 = copy(df1, copycols=false)
    @test df1 == df2 == df3
    @test df1.x === df2.x
    @test df1.x === df3.x
    @test df1.y === df2.y
    @test df1.y === df3.y

    df1 = view(df1, :, :)
    df2 = DataFrame(df1)
    df3 = copy(df1)
    @test df1 == df2 == df3
    @test df1.x !== df2.x
    @test df1.x !== df3.x
    @test df1.y !== df2.y
    @test df1.y !== df3.y

    df2 = DataFrame(df1, copycols=false)
    @test df1 == df2
    @test df1.x === df2.x
    @test df1.y === df2.y
end

@testset "pair constructor" begin
    @test DataFrame(:x1 => zeros(3), :x2 => ones(3)) ==
          DataFrame([:x1 => zeros(3), :x2 => ones(3)]) ==
          DataFrame("x1" => zeros(3), "x2" => ones(3)) ==
          DataFrame("x1" => zeros(3), "x2" => ones(3))

    @inferred DataFrame(:x1 => zeros(3), :x2 => ones(3))
    df = DataFrame([:x1 => zeros(3), :x2 => ones(3)])
    @test size(df, 1) == 3
    @test size(df, 2) == 2
    @test isequal(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.0, 1.0, 1.0]))

    df = DataFrame(:type => [], :begin => [])
    @test propertynames(df) == [:type, :begin]

    a=[1, 2, 3]
    df = DataFrame(:a=>a, :b=>1, :c=>1:3)
    @test propertynames(df) == [:a, :b, :c]
    @test df.a == a
    @test df.a !== a

    df = DataFrame(:a=>a, :b=>1, :c=>1:3, copycols=false)
    @test propertynames(df) == [:a, :b, :c]
    @test df.a === a

    df = DataFrame("x1" => zeros(3), "x2" => ones(3))
    @inferred DataFrame("x1" => zeros(3), "x2" => ones(3))
    @test size(df, 1) == 3
    @test size(df, 2) == 2
    @test isequal(df, DataFrame(x1=[0.0, 0.0, 0.0], x2=[1.0, 1.0, 1.0]))

    df = DataFrame("type" => [], "begin" => [])
    @test propertynames(df) == [:type, :begin]

    a=[1, 2, 3]
    df = DataFrame("a"=>a, "b"=>1, "c"=>1:3)
    @test propertynames(df) == [:a, :b, :c]
    @test df."a" == a
    @test df."a" !== a

    df = DataFrame("a"=>a, "b"=>1, "c"=>1:3, copycols=false)
    @test propertynames(df) == [:a, :b, :c]
    @test df."a" === a

    @test_throws ArgumentError DataFrame(["type" => 1, :begin => 2])
end

@testset "associative" begin
    df = DataFrame(Dict(:A => 1:3, :B => 4:6))
    @inferred DataFrame(Dict(:A => 1:3, :B => 4:6))
    @test df == DataFrame(A=1:3, B=4:6)
    @test eltype.(eachcol(df)) == [Int, Int]

    a=[1, 2, 3]
    df = DataFrame(Dict(:a=>a, :b=>1, :c=>1:3))
    @test propertynames(df) == [:a, :b, :c]
    @test df.a == a
    @test df.a !== a

    df = DataFrame(Dict(:a=>a, :b=>1, :c=>1:3), copycols=false)
    @test propertynames(df) == [:a, :b, :c]
    @test df.a === a

    df = DataFrame(Dict("A" => 1:3, "B" => 4:6))
    @inferred DataFrame(Dict("A" => 1:3, "B" => 4:6))
    @test df == DataFrame(A=1:3, B=4:6)
    @test eltype.(eachcol(df)) == [Int, Int]

    a=[1, 2, 3]
    df = DataFrame(Dict("a"=>a, "b"=>1, "c"=>1:3))
    @test propertynames(df) == [:a, :b, :c]
    @test df."a" == a
    @test df."a" !== a
    df = DataFrame(Dict("a"=>a, "b"=>1, "c"=>1:3), copycols=false)
    @test propertynames(df) == [:a, :b, :c]
    @test df."a" === a
end

@testset "vector constructors" begin
    x = [1, 2, 3]
    y = [1, 2, 3]

    df = DataFrame([x, y], :auto)
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 == x
    @test df.x2 == y
    @test df.x1 !== x
    @test df.x2 !== y
    df = DataFrame([x, y], :auto, copycols=true)
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 == x
    @test df.x2 == y
    @test df.x1 !== x
    @test df.x2 !== y
    df = DataFrame([x, y], :auto, copycols=false)
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 === x
    @test df.x2 === y

    df = DataFrame([x, y], [:x1, :x2])
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 == x
    @test df.x2 == y
    @test df.x1 !== x
    @test df.x2 !== y
    df = DataFrame([x, y], [:x1, :x2], copycols=true)
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 == x
    @test df.x2 == y
    @test df.x1 !== x
    @test df.x2 !== y
    df = DataFrame([x, y], [:x1, :x2], copycols=false)
    @test propertynames(df) == [:x1, :x2]
    @test df.x1 === x
    @test df.x2 === y

    df = DataFrame([x, y], ["x1", "x2"])
    @test names(df) == ["x1", "x2"]
    @test df."x1" == x
    @test df."x2" == y
    @test df."x1" !== x
    @test df."x2" !== y
    df = DataFrame([x, y], ["x1", "x2"], copycols=true)
    @test names(df) == ["x1", "x2"]
    @test df."x1" == x
    @test df."x2" == y
    @test df."x1" !== x
    @test df."x2" !== y
    df = DataFrame([x, y], ["x1", "x2"], copycols=false)
    @test names(df) == ["x1", "x2"]
    @test df."x1" === x
    @test df."x2" === y

    n = [:x1, :x2]
    v = AbstractVector[1:3, [1, 2, 3]]
    @test DataFrame(v, n).x1 isa Vector{Int}
    @test v[1] isa AbstractRange

    n = ["x1", "x2"]
    v = AbstractVector[1:3, [1, 2, 3]]
    @test DataFrame(v, n)."x1" isa Vector{Int}
    @test v[1] isa AbstractRange
end

@testset "recyclers" begin
    @test DataFrame(a=1:5, b=1) == DataFrame(a=collect(1:5), b=fill(1, 5))
    @test DataFrame(a=1, b=1:5) == DataFrame(a=fill(1, 5), b=collect(1:5))
    @test size(DataFrame(a=1, b=[])) == (0, 2)
    @test size(DataFrame(a=1, b=[], copycols=false)) == (0, 2)
end

@testset "constructor thrown exceptions" begin
    for copycolsarg in (true, false)
        @test_throws DimensionMismatch DataFrame(Any[collect(1:10)], DataFrames.Index([:A, :B]), copycols=copycolsarg)
        @test_throws ArgumentError DataFrame(A=rand(2, 2), copycols=copycolsarg)
        @test_throws ArgumentError DataFrame(A=rand(2, 1), copycols=copycolsarg)
        @test_throws ArgumentError DataFrame([1, 2, 3], :auto, copycols=copycolsarg)
        @test_throws DimensionMismatch DataFrame(AbstractVector[1:3, [1, 2]], :auto, copycols=copycolsarg)
        @test_throws ErrorException DataFrame([1:3, 1], [:x1, :x2], copycols=copycolsarg)
        @test_throws ErrorException DataFrame([1:3, 1], ["x1", "x2"], copycols=copycolsarg)
        @test_throws ErrorException DataFrame([1:3, 1], copycols=copycolsarg)
    end
end

@testset "column types" begin
    df = DataFrame(A=1:3, B=2:4, C=3:5)
    answer = [Array{Int, 1}, Array{Int, 1}, Array{Int, 1}]
    @test map(typeof, eachcol(df)) == answer
    df[!, :D] = [4, 5, missing]
    push!(answer, Vector{Union{Int, Missing}})
    @test map(typeof, eachcol(df)) == answer
    df[!, :E] .= 'c'
    push!(answer, Vector{Char})
    @test map(typeof, eachcol(df)) == answer
end

@testset "expansion of Ref and 0-dimensional arrays" begin
    @test DataFrame(a=Ref(1), b=fill(1)) == DataFrame(a=[1], b=[1])
    @test DataFrame(a=Ref(1), b=fill(1), c=1:3) ==
          DataFrame(a=[1, 1, 1], b=[1, 1, 1], c=1:3)
end

@testset "broadcasting into 0 rows" begin
    for df in [DataFrame(x1=1:0, x2=1), DataFrame(x1=1, x2=1:0)]
        @test size(df) == (0, 2)
        @test df.x1 isa Vector{Int}
        @test df.x2 isa Vector{Int}
    end
end

@testset "Dict constructor corner case" begin
    @test_throws ArgumentError DataFrame(Dict('a' => 1, true => 2))
    @test_throws ArgumentError DataFrame(Dict(:z => 1, "true" => 2))
    @test DataFrame(Dict("z" => 1, "true" => 2)) == DataFrame("true" => 2, "z" => 1)
    @test DataFrame(Dict([Symbol(c) => i for (i, c) in enumerate('a':'z')])) ==
          DataFrame(Dict([string(c) => i for (i, c) in enumerate('a':'z')])) ==
          DataFrame([Symbol(c) => i for (i, c) in enumerate('a':'z')])
    @test DataFrame(OrderedDict(:z => 1, :a => 2)) == DataFrame(z=1, a=2)

end

@testset "removed constructors" begin
    @test_throws ArgumentError DataFrame([1 2; 3 4])
    @test_throws ArgumentError DataFrame([[1, 2], [3, 4]])
    @test_throws ArgumentError DataFrame([Int, Float64], [:a, :b])
    @test_throws ArgumentError DataFrame([Int, Float64], [:a, :b], 2)
    @test_throws ArgumentError DataFrame([Int, Float64], ["a", "b"])
    @test_throws ArgumentError DataFrame([Int, Float64], ["a", "b"], 2)
    @test_throws ArgumentError DataFrame([Int, Float64], ["a", :b])
    @test_throws MethodError DataFrame([Int, Float64], ["a", :b], 2)
end

@testset "threading correctness tests" begin
    for x in (10, 2*10^6), y in 1:4
        df = DataFrame(rand(x, y), :auto)
        @test df == copy(df)
    end
end

@testset "non-specific vector of column names" begin
    ref = DataFrame(a=1:2, b=3:4)
    for x in ([1 3; 2 4], [[1, 2], [3, 4]], [1:2, 3:4], Any[[1, 2], [3, 4]], Any[1:2, 3:4])
        @test DataFrame(x, Any[:a, :b]) == ref
        @test DataFrame(x, Any["a", "b"]) == ref
        @test DataFrame(x, Union{String, Symbol}[:a, :b]) == ref
        @test DataFrame(x, Union{String, Symbol}["a", "b"]) == ref
        @test_throws ArgumentError DataFrame(x, Any["a", :b])
        @test_throws ArgumentError DataFrame(x, Union{String, Symbol}["a", :b])
    end
    @test DataFrame([], []) == DataFrame()
    @test DataFrame(fill(0, 0, 0), []) == DataFrame()
    @test_throws ArgumentError DataFrame(Type[], Symbol[])
    @test_throws ArgumentError DataFrame(Type[], String[])
    @test_throws MethodError DataFrame(Type[], [])
end

@testset "DataFrame matrix constructor copycols kwarg" begin
    m = [1 4; 2 5; 3 6]
    refdf = DataFrame(x1=1:3, x2=4:6)
    for cnames in ([:x1, :x2], ["x1", "x2"], Any[:x1, :x2], Any["x1", "x2"], :auto)
        df = DataFrame(m, cnames)
        @test df == refdf
        @test df.x1 isa Vector{Int}
        @test df.x2 isa Vector{Int}
        df = DataFrame(m, cnames, copycols=true)
        @test df == refdf
        @test df.x1 isa Vector{Int}
        @test df.x2 isa Vector{Int}
        df = DataFrame(m, cnames, copycols=false)
        @test df == refdf
        @test df.x1 isa SubArray{Int, 1, Matrix{Int}}
        @test df.x2 isa SubArray{Int, 1, Matrix{Int}}
        @test parent(df.x1) === m
        @test parent(df.x2) === m
    end
end

@testset "constructor with names passed as a second argument" begin
    for cols in Any[[:a, :b], ["a", "b"], Any[:a, :b], Any["a", "b"]]
        for cc in [true, false]
            @test DataFrame(Tables.table([1 2; 3 4]), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([1 2; 3 4], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([[1, 3], [2, 4]], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([(1, 2), (3, 4)], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame(DataFrame(x=[1, 3], y=[2, 4]), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame(view(DataFrame(x=[1, 3], y=[2, 4]), :, :), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame(Dict(:x=>[1, 3], :y=>[2, 4]), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame((x=[1, 3], y=[2, 4]), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([(x=1, y=2), (x=3, y=4)], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame(((x=1, y=2), (x=3, y=4)), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([(1, 2), (3, 4)], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame(((1, 2), (3, 4)), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame((1=>2, 3=>4), cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
            @test DataFrame([:x => [1, 3], :y => [2, 4]], cols, copycols=cc) == DataFrame(a=[1, 3], b=[2, 4])
        end
        @test DataFrame(groupby(DataFrame(x=[1, 3], y=[2, 4]), :x), cols, copycols=true) == DataFrame(a=[1, 3], b=[2, 4])
        @test DataFrame(DataFrame(x=[1, 3], y=[2, 4])[1, :], cols, copycols=true) == DataFrame(a=1, b=2)
        @test_throws ArgumentError DataFrame(groupby(DataFrame(x=[1, 3], y=[2, 4]), :x), cols, copycols=false)
        @test_throws ArgumentError DataFrame(DataFrame(x=[1, 3], y=[2, 4])[1, :], cols, copycols=false)
    end
    @test_throws ArgumentError DataFrame([1=>2, 3=>4], [:a, :b])
end

end # module

# normalize_selection function makes sure that whatever input format of idx is it
# will end up in one of four canonical forms
# 1) AbstractVector{Int}
# 2) Pair{Int, <:Pair{<:Base.Callable, <:Union{Symbol, Vector{Symbol}, Type{AsTable}}}}
# 3) Pair{AbstractVector{Int}, <:Pair{<:Base.Callable, <:Union{Symbol, AbstractVector{Symbol}, Type{AsTable}}}}
# 4) Pair{AsTable, <:Pair{<:Base.Callable, <:Union{Symbol, Vector{Symbol}, Type{AsTable}}}}
# 5) Callable

const TRANSFORM_METADATA =
    """
    Metadata: this function propagates table-level `:note`-style metadata.
    Column-level `:note`-style metadata is propagated if:
    a) a single column is transformed to a single column and the name of the column
      does not change (this includes all column selection operations), or
    b) a single column is transformed with `identity` or `copy` to a single column
       even if column name is changed (this includes column renaming).
       As a special case for `GroupedDataFrame` if the output has the same name
       as a grouping column and `keepkeys=true`, metadata is taken from
       original grouping column.
    """

const TRANSFORMATION_COMMON_RULES =
    """
    Below detailed common rules for all transformation functions supported by
    DataFrames.jl are explained and compared.

    All these operations are supported both for
    `AbstractDataFrame` (when split and combine steps are skipped) and
    `GroupedDataFrame`. Technically, `AbstractDataFrame` is just considered as being
    grouped on no columns (meaning it has a single group, or zero groups if it is
    empty). The only difference is that in this case the `keepkeys` and `ungroup`
    keyword arguments (described below) are not supported and a data frame is always
    returned, as there are no split and combine steps in this case.

    In order to perform operations by groups you first need to create a `GroupedDataFrame`
    object from your data frame using the `groupby` function that takes two arguments:
    (1) a data frame to be grouped, and (2) a set of columns to group by.

    Operations can then be applied on each group using one of the following functions:
    * `combine`: does not put restrictions on number of rows returned per group;
      the returned values are vertically concatenated following order of groups in
      `GroupedDataFrame`; it is typically used to compute summary statistics by group;
      for `GroupedDataFrame` if grouping columns are kept they are put as first columns
      in the result;
    * `select`: return a data frame with the number and order of rows exactly the same
      as the source data frame, including only new calculated columns;
      `select!` is an in-place version of `select`; for `GroupedDataFrame` if grouping columns
      are kept they are put as first columns in the result;
    * `transform`: return a data frame with the number and order of rows exactly the same
      as the source data frame, including all columns from the source and new calculated columns;
      `transform!` is an in-place version of `transform`;
      existing columns in the source data frame are put as first columns in the result;

    As a special case, if a `GroupedDataFrame` that has zero groups is passed then
    the result of the operation is determined by performing a single call to the
    transformation function with a 0-row argument passed to it. The output of this
    operation is only used to identify the number and type of produced columns, but
    the result has zero rows.

    All these functions take a specification of one or more functions to apply to
    each subset of the `DataFrame`. This specification can be of the following forms:
    1. standard column selectors (integers, `Symbol`s, strings, vectors of integers,
       vectors of `Symbol`s, vectors of strings,
       `All`, `Cols`, `:`, `Between`, `Not` and regular expressions)
    2. a `cols => function` pair indicating that `function` should be called with
       positional arguments holding columns `cols`, which can be any valid column selector;
       in this case target column name is automatically generated and it is assumed that
       `function` returns a single value or a vector; the generated name is created by
       concatenating source column name and `function` name by default (see examples below).
    3. a `cols => function => target_cols` form additionally explicitly specifying
       the target column or columns, which must be a single name (as a `Symbol` or a string),
       a vector of names or `AsTable`. Additionally it can be a `Function` which
       takes a string or a vector of strings as an argument containing names of columns
       selected by `cols`, and returns the target columns names (all accepted types
       except `AsTable` are allowed).
    4. a `col => target_cols` pair, which renames the column `col` to `target_cols`, which
       must be single name (as a `Symbol` or a string), a vector of names or `AsTable`.
    5. column-independent operations `function => target_cols` or just `function`
       for specific `function`s where the input columns are omitted;
       without `target_cols` the new column has the same name as `function`, otherwise
       it must be single name (as a `Symbol` or a string). Supported `function`s are:
       * `nrow` to efficiently compute the number of rows in each group.
       * `proprow` to efficiently compute the proportion of rows in each group.
       * `eachindex` to return a vector holding the number of each row within each group.
       * `groupindices` to return the group number.
    6. vectors or matrices containing transformations specified by the `Pair` syntax
       described in points 2 to 5
    7. a function which will be called with a `SubDataFrame` corresponding to each group
       if a `GroupedDataFrame` is processed, or with the data frame itself if
       an `AbstractDataFrame` is processed;
       this form should be avoided due to its poor performance unless the number of groups
       is small or a very large number of columns are processed
       (in which case `SubDataFrame` avoids excessive compilation)

    Note! If the expression of the form `x => y` is passed then except for the special
    convenience form `nrow => target_cols` it is always interpreted as
    `cols => function`. In particular the following expression `function => target_cols`
    is not a valid transformation specification.

    Note! If `cols` or `target_cols` are one of `All`, `Cols`, `Between`, or `Not`,
    broadcasting using `.=>` is supported and is equivalent to broadcasting
    the result of `names(df, cols)` or `names(df, target_cols)`.
    This behaves as if broadcasting happened after replacing the selector
    with selected column names within the data frame scope.

    All functions have two types of signatures. One of them takes a `GroupedDataFrame`
    as the first argument and an arbitrary number of transformations described above
    as following arguments. The second type of signature is when a `Function` or a `Type`
    is passed as the first argument and a `GroupedDataFrame` as the second argument
    (similar to `map`).

    As a special rule, with the `cols => function` and `cols => function =>
    target_cols` syntaxes, if `cols` is wrapped in an `AsTable`
    object then a `NamedTuple` containing columns selected by `cols` is passed to
    `function`. The documentation of [`DataFrames.table_transformation`](@ref) provides
    more information about this functionality, in particular covering performance
    considerations.

    What is allowed for `function` to return is determined by the `target_cols` value:
    1. If both `cols` and `target_cols` are omitted (so only a `function` is passed),
       then returning a data frame, a matrix, a `NamedTuple`, a `Tables.AbstractRow`
       or a `DataFrameRow` will
       produce multiple columns in the result. Returning any other value produces
       a single column.
    2. If `target_cols` is a `Symbol` or a string then the function is assumed to return
       a single column. In this case returning a data frame, a matrix, a `NamedTuple`,
       a `Tables.AbstractRow`, or a `DataFrameRow` raises an error.
    3. If `target_cols` is a vector of `Symbol`s or strings or `AsTable` it is assumed
       that `function` returns multiple columns.
       If `function` returns one of `AbstractDataFrame`, `NamedTuple`, `DataFrameRow`,
       `Tables.AbstractRow`, `AbstractMatrix` then rules described in point 1 above apply.
       If `function` returns an `AbstractVector` then each element of this vector must
       support the `keys` function, which must return a collection of `Symbol`s, strings
       or integers; the return value of `keys` must be identical for all elements.
       Then as many columns are created as there are elements in the return value
       of the `keys` function. If `target_cols` is `AsTable` then their names
       are set to be equal to the key names except if `keys` returns integers, in
       which case they are prefixed by `x` (so the column names are e.g. `x1`,
       `x2`, ...). If `target_cols` is a vector of `Symbol`s or strings then
       column names produced using the rules above are ignored and replaced by
       `target_cols` (the number of columns must be the same as the length of
       `target_cols` in this case).
       If `fun` returns a value of any other type then it is assumed that it is a
       table conforming to the Tables.jl API and the `Tables.columntable` function
       is called on it to get the resulting columns and their names. The names are
       retained when `target_cols` is `AsTable` and are replaced if
       `target_cols` is a vector of `Symbol`s or strings.

    In all of these cases, `function` can return either a single row or multiple
    rows. As a particular rule, values wrapped in a `Ref` or a `0`-dimensional
    `AbstractArray` are unwrapped and then treated as a single row.

    `select`/`select!` and `transform`/`transform!` always return a data frame
    with the same number and order of rows as the source (even if `GroupedDataFrame`
    had its groups reordered), except when selection results in zero columns
    in the resulting data frame (in which case the result has zero rows).

    For `combine`, rows in the returned object appear in the order of groups in the
    `GroupedDataFrame`. The functions can return an arbitrary number of rows for
    each group, but the kind of returned object and the number and names of columns
    must be the same for all groups, except when a `DataFrame()` or `NamedTuple()`
    is returned, in which case a given group is skipped.

    It is allowed to mix single values and vectors if multiple transformations
    are requested. In this case single value will be repeated to match the length
    of columns specified by returned vectors.

    To apply `function` to each row instead of whole columns, it can be wrapped in a
    `ByRow` struct. `cols` can be any column indexing syntax, in which case
    `function` will be passed one argument for each of the columns specified by
    `cols` or a `NamedTuple` of them if specified columns are wrapped in `AsTable`.
    If `ByRow` is used it is allowed for `cols` to select an empty set of columns,
    in which case `function` is called for each row without any arguments and an
    empty `NamedTuple` is passed if empty set of columns is wrapped in `AsTable`.

    If a collection of column names is passed then requesting duplicate column
    names in target data frame are accepted (e.g. `select!(df, [:a], :, r"a")`
    is allowed) and only the first occurrence is used. In particular a syntax to
    move column `:col` to the first position in the data frame is
    `select!(df, :col, :)`. On the contrary, output column names of renaming,
    transformation and single column selection operations must be unique, so e.g.
    `select!(df, :a, :a => :a)` or `select!(df, :a, :a => ByRow(sin) => :a)` are not allowed.

    In general columns returned by transformations are stored in the target data
    frame without copying. An exception to this rule is when columns from
    the source data frame are reused in the target data frame.
    This can happen via expressions like: `:x1`, `[:x1, :x2]`, `:x1 => :x2`,
    `:x1 => identity => :x2`, or `:x1 => (x -> @view x[inds])`
    (note that in the last case the source column is reused
    indirectly via a view). In such cases the
    behavior depends on the value of the `copycols` keyword argument:
    * if `copycols=true` then results of such transformations always perform a
      copy of the source column or its view;
    * if `copycols=false` then copies are only performed to avoid storing the
      same column several times in the target data frame; more precisely, no
      copy is made the first time a column is used, but each subsequent
      reuse of a source column (when compared using `===`,
      which excludes views of source columns) performs a copy;

    Note that performing `transform!` or `select!` assumes that `copycols=false`.

    If `df` is a `SubDataFrame` and `copycols=true` then a `DataFrame` is
    returned and the same copying rules apply as for a `DataFrame` input: this
    means in particular that selected columns will be copied. If
    `copycols=false`, a `SubDataFrame` is returned without copying columns and
    in this case transforming or renaming columns is not allowed.

    If a `GroupedDataFrame` is passed and `threads=true` (the default),
    a separate task is spawned for each specified transformation;
    each transformation then spawns as many tasks
    as Julia threads, and splits processing of groups across them
    (however, currently transformations with optimized implementations like `sum`
    and transformations that return multiple rows use a single task for all groups).
    This allows for parallel operation when Julia was started with more than one
    thread. Passed transformation functions must therefore not modify global
    variables (i.e. they must be pure), use locks to control parallel accesses,
    or `threads=false` must be passed to disable multithreading.
    In the future, parallelism may be extended to other cases, so this requirement
    also holds for `DataFrame` inputs.

    In order to improve the performance of the operations some transformations
    invoke optimized implementation, see [`DataFrames.table_transformation`](@ref) for details.
    """

broadcast_pair(df::AbstractDataFrame, @nospecialize(p::Any)) = p

function broadcast_pair(df::AbstractDataFrame, @nospecialize(p::Pair))
    src, second = p
    src_broadcast = src isa Union{InvertedIndices.BroadcastedInvertedIndex,
                                  DataAPI.BroadcastedSelector}
    second_broadcast = second isa Union{InvertedIndices.BroadcastedInvertedIndex,
                                        DataAPI.BroadcastedSelector}
    if second isa Pair
        fun, dst = second
        dst_broadcast = dst isa Union{InvertedIndices.BroadcastedInvertedIndex,
                                      DataAPI.BroadcastedSelector}
        if src_broadcast || dst_broadcast
            new_src = src_broadcast ? names(df, src.sel) : src
            new_dst = dst_broadcast ? names(df, dst.sel) : dst
            new_p = new_src .=> fun .=> new_dst
            return isempty(new_p) ? [] : new_p
        else
            return p
        end
    else
        if src_broadcast || second_broadcast
            new_src = src_broadcast ? names(df, src.sel) : src
            new_second = second_broadcast ? names(df, second.sel) : second
            new_p = new_src .=> new_second
            return isempty(new_p) ? [] : new_p
        else
            return p
        end
    end
end

# this is needed in broadcasting when one of dimensions has length 0
# as then broadcasting produces Matrix{Any} rather than Matrix{<:Pair}
broadcast_pair(df::AbstractDataFrame, @nospecialize(p::AbstractMatrix)) =
    isempty(p) ? [] : p

function broadcast_pair(df::AbstractDataFrame, @nospecialize(p::AbstractVecOrMat{<:Pair}))
    isempty(p) && return []
    need_broadcast = false

    src = first.(p)
    first_src = first(src)
    if first_src isa Union{InvertedIndices.BroadcastedInvertedIndex,
                           DataAPI.BroadcastedSelector}
        if any(!=(first_src), src)
            throw(ArgumentError("when broadcasting column selector it must " *
                                "have a constant value"))
        end
        need_broadcast = true
        new_names = names(df, first_src.sel)
        if !(length(new_names) == size(p, 1) || size(p, 1) == 1)
            throw(ArgumentError("broadcasted dimension does not match the " *
                                "number of selected columns"))
        end
        new_src = new_names
    else
        new_src = src
    end

    second = last.(p)
    first_second = first(second)
    if first_second isa Union{InvertedIndices.BroadcastedInvertedIndex,
                              DataAPI.BroadcastedSelector}
        if any(!=(first_second), second)
            throw(ArgumentError("when using broadcasted column selector it " *
                                "must have a constant value"))
        end
        need_broadcast = true
        new_names = names(df, first_second.sel)
        if !(length(new_names) == size(p, 1) || size(p, 1) == 1)
            throw(ArgumentError("broadcasted dimension does not match the " *
                                "number of selected columns"))
        end
        new_second = new_names
    else
        if first_second isa Pair
            fun, dst = first_second
            if dst isa Union{InvertedIndices.BroadcastedInvertedIndex,
                             DataAPI.BroadcastedSelector}
                if !all(x -> x isa Pair && last(x) == dst, second)
                    throw(ArgumentError("when using broadcasted column selector " *
                                        "it must have a constant value"))
                end
                need_broadcast = true
                new_names = names(df, dst.sel)
                if !(length(new_names) == size(p, 1) || size(p, 1) == 1)
                    throw(ArgumentError("broadcasted dimension does not match the " *
                                        "number of selected columns"))
                end
                new_dst = new_names
                new_second = first.(second) .=> new_dst
            else
                new_second = second
            end
        else
            new_second = second
        end
    end

    if need_broadcast
        new_p = new_src .=> new_second
        return isempty(new_p) ? [] : new_p
    else
        return p
    end
end

# add a method to funname defined in other/utils.jl
funname(row::ByRow) = funname(row.fun)

make_pair_concrete(@nospecialize(x::Pair)) =
    make_pair_concrete(x.first) => make_pair_concrete(x.second)
make_pair_concrete(@nospecialize(x)) = x

normalize_selection(idx::AbstractIndex, @nospecialize(sel), renamecols::Bool) = idx[sel]

normalize_selection(idx::AbstractIndex, @nospecialize(sel::Base.Callable), renamecols::Bool) = sel
normalize_selection(idx::AbstractIndex, sel::Colon, renamecols::Bool) = idx[:]

normalize_selection(idx::AbstractIndex, sel::Pair{typeof(nrow), Symbol},
                    renamecols::Bool) =
    length(idx) == 0 ? (Int[] => (() -> 0) => last(sel)) : (1 => length => last(sel))
normalize_selection(idx::AbstractIndex, sel::Pair{typeof(nrow), <:AbstractString},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => Symbol(last(sel)), renamecols)
normalize_selection(idx::AbstractIndex, sel::typeof(nrow), renamecols::Bool) =
    normalize_selection(idx, nrow => :nrow, renamecols)

normalize_selection(idx::AbstractIndex, sel::Pair{typeof(eachindex), Symbol},
                    renamecols::Bool) =
    length(idx) == 0 ? (Int[] => (() -> Base.OneTo(0)) => last(sel)) : (1 => eachindex => last(sel))
normalize_selection(idx::AbstractIndex, sel::Pair{typeof(eachindex), <:AbstractString},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => Symbol(last(sel)), renamecols)
normalize_selection(idx::AbstractIndex, sel::typeof(eachindex), renamecols::Bool) =
    normalize_selection(idx, eachindex => :eachindex, renamecols)

normalize_selection(idx::AbstractIndex, sel::Pair{typeof(groupindices), Symbol},
                    renamecols::Bool) =
    Int[] => groupindices => last(sel)
normalize_selection(idx::AbstractIndex, sel::Pair{typeof(groupindices), <:AbstractString},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => Symbol(last(sel)), renamecols)
normalize_selection(idx::AbstractIndex, sel::typeof(groupindices), renamecols::Bool) =
    normalize_selection(idx, groupindices => :groupindices, renamecols)

normalize_selection(idx::AbstractIndex, sel::Pair{typeof(proprow), Symbol},
                    renamecols::Bool) =
    Int[] => proprow => last(sel)
normalize_selection(idx::AbstractIndex, sel::Pair{typeof(proprow), <:AbstractString},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => Symbol(last(sel)), renamecols)
normalize_selection(idx::AbstractIndex, sel::typeof(proprow), renamecols::Bool) =
    normalize_selection(idx, proprow => :proprow, renamecols)

function normalize_selection(idx::AbstractIndex, sel::ColumnIndex, renamecols::Bool)
    c = idx[sel]
    return c => identity => _names(idx)[c]
end

function normalize_selection(idx::AbstractIndex, sel::Pair{<:ColumnIndex, Symbol},
                             renamecols::Bool)
    c = idx[first(sel)]
    return c => identity => last(sel)
end

normalize_selection(idx::AbstractIndex, sel::Pair{<:ColumnIndex, <:AbstractString},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => Symbol(last(sel)), renamecols)

normalize_selection(idx::AbstractIndex, sel::Pair{<:ColumnIndex,
                                                  <:Union{AbstractVector{Symbol},
                                                          AbstractVector{<:AbstractString}}},
                    renamecols::Bool) =
    normalize_selection(idx, first(sel) => identity => last(sel), renamecols)

function normalize_selection(idx::AbstractIndex,
                             @nospecialize(sel::Pair{<:ColumnIndex,
                                                     <:Pair{<:Base.Callable,
                                                            <:Union{Symbol, AbstractString}}}),
                             renamecols::Bool)
    src, (fun, dst) = sel
    return idx[src] => fun => Symbol(dst)
end

function normalize_selection(idx::AbstractIndex,
                             @nospecialize(sel::Pair{<:Any,
                                                     <:Pair{<:Base.Callable,
                                                            <:Union{Symbol, AbstractString, DataType,
                                                                    AbstractVector{Symbol},
                                                                    AbstractVector{<:AbstractString},
                                                                    Function}}}),
                             renamecols::Bool)
    lls = last(last(sel))

    if lls isa DataType
        lls === AsTable || throw(ArgumentError("Only DataType supported as target is AsTable"))
    end

    if first(sel) isa AsTable
        rawc = first(sel).cols
        wanttable = true
    else
        rawc = first(sel)
        wanttable = false
    end

    if rawc isa AbstractVector{Int}
        c = rawc
    elseif rawc isa Union{AbstractVector{Symbol}, AbstractVector{<:AbstractString}}
        c = [idx[n] for n in rawc]
    else
        c = try
                idx[rawc]
            catch e
                if e isa MethodError && e.f === getindex && e.args === (idx, rawc)
                    throw(ArgumentError("Unrecognized column selector: $rawc"))
                else
                    rethrow(e)
                end
            end
    end

    if lls isa Function
        fun_colnames = _names(idx)[c]
        # if AsTable was used as source we always treat it as multicolumn selector
        if wanttable && fun_colnames isa Symbol
            fun_colnames = [fun_colnames]
        end
        lls = lls(string.(fun_colnames))
        if !(lls isa Union{Symbol, AbstractString, AbstractVector{Symbol},
                           AbstractVector{<:AbstractString}})
            throw(ArgumentError("function producing target column names must " *
                                "return a Symbol, a string, a vector of Symbols " *
                                "or a vector of strings"))
        end
    end
    if lls isa AbstractString
        combine_target_col = Symbol(lls)
    elseif lls isa AbstractVector{<:AbstractString}
        combine_target_col = Symbol.(lls)
    else
        combine_target_col = lls
    end

    if combine_target_col isa AbstractVector{Symbol}
        allunique(combine_target_col) || throw(ArgumentError("target column names must be unique"))
    end

    if wanttable
        combine_src = AsTable(c)
    else
        combine_src = (length(c) == 1 ? only(c) : c)
    end

    combine_func = first(last(sel))

    return combine_src => combine_func => combine_target_col
end

function normalize_selection(idx::AbstractIndex,
                             @nospecialize(sel::Pair{<:ColumnIndex, <:Base.Callable}), renamecols::Bool)
    c = idx[first(sel)]
    fun = last(sel)

    if fun === AsTable
        return normalize_selection(idx, first(sel) => identity => AsTable, renamecols)
    end

    if renamecols
        newcol = Symbol(_names(idx)[c], "_", funname(fun))
    else
        newcol = _names(idx)[c]
    end
    return c => fun => newcol
end

function normalize_selection(idx::AbstractIndex,
                             @nospecialize(sel::Pair{<:Any, <:Base.Callable}), renamecols::Bool)
    if first(sel) isa AsTable
        rawc = first(sel).cols
        wanttable = true
    else
        rawc = first(sel)
        wanttable = false
    end
    if rawc isa AbstractVector{Int}
        c = rawc
    elseif rawc isa Union{AbstractVector{Symbol}, AbstractVector{<:AbstractString}}
        c = [idx[n] for n in rawc]
    else
        c = try
                idx[rawc]
            catch e
                if e isa MethodError && e.f === getindex && e.args === (idx, rawc)
                    throw(ArgumentError("Unrecognized column selector: $rawc"))
                else
                    rethrow(e)
                end
            end
    end
    fun = last(sel)

    fun === AsTable && throw(ArgumentError("Passing AsTable in $sel is not supported"))

    if length(c) > 3
        prefix = join(@views(_names(idx)[c[1:2]]), '_')
        if renamecols
            newcol = Symbol(prefix, "_etc_", funname(fun))
        else
            newcol = Symbol(prefix, "_etc")
        end
    elseif isempty(c)
        renamecols || throw(ArgumentError("when renamecols=false target column name " *
                                          "must be passed if there are no input columns"))
        newcol = Symbol(funname(fun))
    else
        prefix = join(view(_names(idx), c), '_')
        if renamecols
            newcol = Symbol(prefix, '_', funname(fun))
        else
            newcol = Symbol(prefix)
        end
    end

    if wanttable
        combine_src = AsTable(c)
    else
        combine_src = (length(c) == 1 ? only(c) : c)
    end

    return combine_src => fun => newcol
end

_transformation_helper(df::AbstractDataFrame, col_idx::Nothing, (fun,)::Ref{Any}) =
    fun(df)
_transformation_helper(df::AbstractDataFrame, col_idx::Int, (fun,)::Ref{Any}) =
    fun(df[!, col_idx])

_empty_astable_helper(fun, len) = [fun(NamedTuple()) for _ in 1:len]

function _transformation_helper(df::AbstractDataFrame, col_idx::AsTable, (fun,)::Ref{Any})
    cols = index(df)[col_idx.cols]
    df_sel = select(df, cols, copycols=false)
    if ncol(df_sel) == 0
        if fun isa ByRow
            # work around fact that length∘skipmissing is not supported in Julia Base yet
            if fun === ByRow(length∘skipmissing)
                return _empty_astable_helper(length, nrow(df))
            else
                return _empty_astable_helper(fun.fun, nrow(df))
            end
        else
            return fun(NamedTuple())
        end
    else
        return table_transformation(df_sel, fun)
    end
end

_empty_selector_helper(fun, len) = [fun() for _ in 1:len]

function _transformation_helper(df::AbstractDataFrame, col_idx::AbstractVector{Int}, (fun,)::Ref{Any})
    if isempty(col_idx)
        if fun isa ByRow
            return _empty_selector_helper(fun.fun, nrow(df))
        else
            return fun()
        end
    else
        cdf = eachcol(df)
        cols = map(c -> cdf[c], col_idx)
        if (fun === +) || fun === ByRow(+) # removing parentheses leads to a parsing error
            return reduce(+, cols)
        elseif fun === ByRow(min)
            return _minmax_row_fast(cols, min)
        elseif fun === ByRow(max)
            return _minmax_row_fast(cols, max)
        else
            return fun(cols...)
        end
    end
end

function _gen_colnames(@nospecialize(res), newname::Union{AbstractVector{Symbol},
                                                          Type{AsTable}, Nothing})
    if res isa AbstractMatrix
        colnames = gennames(size(res, 2))
    elseif res isa Tables.AbstractRow
        colnames = Tables.columnnames(res)
    else
        colnames = propertynames(res)
    end

    if newname !== AsTable && newname !== nothing
        if length(colnames) != length(newname)
            throw(ArgumentError("Number of returned columns is $(length(colnames)) " *
                                "and it does not match the number of provided output " *
                                "names which is $(length(newname))"))
        end
        colnames = newname
    end

    # fix the type to avoid unnecessary compilations of methods
    # this should be cheap
    return colnames isa Vector{Symbol} ? colnames : collect(Symbol, colnames)
end

function _insert_row_multicolumn(newdf::DataFrame, df::AbstractDataFrame,
                                 allow_resizing_newdf::Ref{Bool}, colnames::AbstractVector{Symbol},
                                 @nospecialize(res::Union{NamedTuple, DataFrameRow, Tables.AbstractRow}))
    if ncol(newdf) == 0
        # if allow_resizing_newdf[] is false we know this is select or transform
        rows = allow_resizing_newdf[] ? 1 : nrow(df)
    else
        # allow squashing a scalar to 0 rows
        rows = nrow(newdf)
    end
    @assert length(colnames) == length(res)
    for (newname, v) in zip(colnames, res)
        # note that newdf potentially can contain newname in general
        newdf[!, newname] = fill!(Tables.allocatecolumn(typeof(v), rows), v)
    end
end

function _fix_existing_columns_for_vector(newdf::DataFrame, df::AbstractDataFrame,
                                          allow_resizing_newdf::Ref{Bool}, lr::Int,
                                          (fun,)::Ref{Any})
    # allow shortening to 0 rows
    if allow_resizing_newdf[] && nrow(newdf) == 1
        newdfcols = _columns(newdf)
        for (i, col) in enumerate(newdfcols)
            newcol = fill!(similar(col, lr), first(col))
            firstindex(newcol) != 1 && _onebased_check_error()
            newdfcols[i] = newcol
        end
    end
    # !allow_resizing_newdf[] && ncol(newdf) == 0
    # means that we use `select` or `transform` not `combine`
    if !allow_resizing_newdf[] && ncol(newdf) == 0 && lr != nrow(df)
        throw(ArgumentError("length $(lr) of vector returned from " *
                            "function $fun is different from number of rows " *
                            "$(nrow(df)) of the source data frame."))
    end
    allow_resizing_newdf[] = false
end

function _add_col_check_copy(newdf::DataFrame, df::AbstractDataFrame,
                             col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                             copycols::Bool, (fun,)::Ref{Any},
                             newname::Symbol, v::AbstractVector,
                             column_to_copy::BitVector)
    cdf = eachcol(df)
    vpar = parent(v)
    parent_cols = col_idx isa AsTable ? col_idx.cols : something(col_idx, 1:ncol(df))
    # note that if col_idx is AsTable thanks to normalization in preprocessing
    # we know that cols is vector of integers here
    @assert parent_cols isa Union{Int, AbstractVector{Int}}
    if copycols
        if !(fun isa ByRow) && (v isa SubArray || any(i -> vpar === parent(cdf[i]), parent_cols))
            newdf[!, newname] = copy(v)
        else
            newdf[!, newname] = v
        end
    else
        if fun isa ByRow
            newdf[!, newname] = v
        else
            must_copy = false
            for i in parent_cols
                # there might be multiple aliases of the same column
                if v === cdf[i]
                    if column_to_copy[i]
                        must_copy = true
                        break
                    else
                        column_to_copy[i] = true
                    end
                end
            end
            newdf[!, newname] = must_copy ? copy(v) : v
        end
    end
end

function _add_multicol_res(res::AbstractDataFrame, newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    lr = nrow(res)
    _fix_existing_columns_for_vector(newdf, df, allow_resizing_newdf, lr, wfun)
    @assert length(colnames) == ncol(res)
    for (newname, v) in zip(colnames, eachcol(res))
        _add_col_check_copy(newdf, df, col_idx, copycols, wfun, newname, v, column_to_copy)
    end
end

function _add_multicol_res(res::AbstractMatrix, newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    lr = size(res, 1)
    _fix_existing_columns_for_vector(newdf, df, allow_resizing_newdf, lr, wfun)
    @assert length(colnames) == size(res, 2)
    for (i, newname) in enumerate(colnames)
        newdf[!, newname] = res[:, i]
    end
end

function _add_multicol_res(@nospecialize(res::NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}),
                           newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    lr = length(res[1])
    _fix_existing_columns_for_vector(newdf, df, allow_resizing_newdf, lr, wfun)
    @assert length(colnames) == length(res)
    for (newname, v) in zip(colnames, res)
        _add_col_check_copy(newdf, df, col_idx, copycols, wfun, newname, v, column_to_copy)
    end
end

function _add_multicol_res(@nospecialize(res::NamedTuple), newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    if any(v -> v isa AbstractVector, res)
        throw(ArgumentError("mixing single values and vectors in a named tuple is not allowed"))
    else
        _insert_row_multicolumn(newdf, df, allow_resizing_newdf, colnames, res)
    end
end

function _add_multicol_res(res::DataFrameRow, newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    _insert_row_multicolumn(newdf, df, allow_resizing_newdf, colnames, res)
end

function _add_multicol_res(res::Tables.AbstractRow, newdf::DataFrame, df::AbstractDataFrame,
                           colnames::AbstractVector{Symbol},
                           allow_resizing_newdf::Ref{Bool}, wfun::Ref{Any},
                           col_idx::Union{Nothing, Int, AbstractVector{Int}, AsTable},
                           copycols::Bool, newname::Union{Nothing, Type{AsTable}, AbstractVector{Symbol}},
                           column_to_copy::BitVector)
    _insert_row_multicolumn(newdf, df, allow_resizing_newdf, colnames, res)
end

function select_transform!((nc,)::Ref{Any}, df::AbstractDataFrame, newdf::DataFrame,
                           transformed_cols::Set{Symbol}, copycols::Bool,
                           allow_resizing_newdf::Ref{Bool},
                           column_to_copy::BitVector)
    @assert nc isa Union{Base.Callable,
                         Pair{<:Union{Int, AbstractVector{Int}, AsTable},
                              <:Pair{<:Base.Callable, <:Union{Symbol, AbstractVector{Symbol}, DataType}}}}
    if nc isa Base.Callable
        col_idx, fun, newname = nothing, nc, nothing
    else
        col_idx, (fun, newname) = nc
    end
    wfun = Ref{Any}(fun)

    if newname isa DataType
        newname === AsTable || throw(ArgumentError("Only DataType supported as target is AsTable"))
    end
    # It is allowed to request a transformation operation into a newname column
    # only once. This is ensured by the logic related to transformed_cols set
    # in _manipulate, therefore in select_transform! such a duplicate should not happen
    res = _transformation_helper(df, col_idx, Ref{Any}(fun))

    if newname === AsTable || newname isa AbstractVector{Symbol}
        if res isa AbstractVector && !isempty(res)
            kp1 = keys(res[1])
            prepend = all(x -> x isa Integer, kp1)
            if !(prepend || all(x -> x isa Symbol, kp1) || all(x -> x isa AbstractString, kp1))
                throw(ArgumentError("keys of the returned elements must be " *
                                    "`Symbol`s, strings or integers"))
            end
            if any(x -> !isequal(keys(x), kp1), res)
                throw(ArgumentError("keys of the returned elements must be identical"))
            end
            newres = DataFrame()
            for n in kp1
                newres[!, prepend ? Symbol("x", n) : Symbol(n)] = [x[n] for x in res]
            end
            res = newres
        elseif !(res isa Union{AbstractDataFrame, NamedTuple, DataFrameRow, AbstractMatrix,
                               Tables.AbstractRow})
            if res isa Union{AbstractVector{Any}, AbstractVector{<:AbstractVector}}
                @assert isempty(res)
                res = DataFrame()
            else
                res = Tables.columntable(res)
            end
        end
    end

    if res isa Union{AbstractDataFrame, NamedTuple, DataFrameRow, AbstractMatrix,
                     Tables.AbstractRow}
        if newname isa Symbol
            throw(ArgumentError("Table returned but a single output column was expected"))
        end
        colnames = _gen_colnames(res, newname)
        isempty(colnames) && return # nothing to do

        if any(in(transformed_cols), colnames)
            throw(ArgumentError("Duplicate column name(s) returned: :" *
                                "$(join(intersect(colnames, transformed_cols), ", :"))"))
        else
            startlen = length(transformed_cols)
            union!(transformed_cols, colnames)
            @assert startlen + length(colnames) == length(transformed_cols)
        end
        _add_multicol_res(res, newdf, df, colnames, allow_resizing_newdf, wfun,
                          col_idx, copycols, newname, column_to_copy)
        if !isempty(colmetadatakeys(newdf))
            for cn_multi in colnames
                emptycolmetadata!(newdf, cn_multi)
            end
        end
    elseif res isa AbstractVector
        if newname === nothing
            newname = :x1
        end
        if newname in transformed_cols
            throw(ArgumentError("duplicate output column name: :$newname"))
        else
            push!(transformed_cols, newname)
        end
        lr = length(res)
        _fix_existing_columns_for_vector(newdf, df, allow_resizing_newdf, lr, wfun)
        _add_col_check_copy(newdf, df, col_idx, copycols, wfun, newname, res, column_to_copy)
        if (col_idx isa Int || (col_idx isa AbstractVector{Int} && length(col_idx) == 1)) &&
           (fun === identity || fun === copy || _names(df)[only(col_idx)] == newname)
           _copy_col_note_metadata!(newdf, newname, df, only(col_idx))
        else
            emptycolmetadata!(newdf, newname)
        end
    else
        if newname === nothing
            newname = :x1
        end
        if newname in transformed_cols
            throw(ArgumentError("duplicate output column name: :$newname"))
        else
            push!(transformed_cols, newname)
        end
        res_unwrap = res isa Union{AbstractArray{<:Any, 0}, Ref} ? res[] : res
        if ncol(newdf) == 0
            # if allow_resizing_newdf[] is false we know this is select or transform
            rows = allow_resizing_newdf[] ? 1 : nrow(df)
        else
            # allow squashing a scalar to 0 rows
            rows = nrow(newdf)
        end
        newdf[!, newname] = fill!(Tables.allocatecolumn(typeof(res_unwrap), rows),
                                  res_unwrap)
        if (col_idx isa Int || (col_idx isa AbstractVector{Int} && length(col_idx) == 1)) &&
           (fun === identity || fun === copy || _names(df)[only(col_idx)] == newname)
           _copy_col_note_metadata!(newdf, newname, df, only(col_idx))
        else
            emptycolmetadata!(newdf, newname)
        end
    end
end

"""
    select!(df::AbstractDataFrame, args...;
            renamecols::Bool=true, threads::Bool=true)
    select!(args::Base.Callable, df::DataFrame;
            renamecols::Bool=true, threads::Bool=true)
    select!(gd::GroupedDataFrame, args...; ungroup::Bool=true,
            renamecols::Bool=true, threads::Bool=true)
    select!(f::Base.Callable, gd::GroupedDataFrame; ungroup::Bool=true,
            renamecols::Bool=true, threads::Bool=true)

Mutate `df` or `gd` in place to retain only columns or transformations specified by `args...` and
return it. The result is guaranteed to have the same number of rows as `df` or
parent of `gd`, except when no columns are selected (in which case the result
has zero rows).

If a `SubDataFrame` or `GroupedDataFrame{SubDataFrame}` is passed, the parent data frame
is updated using columns generated by `args...`, following the same rules as indexing:
- for existing columns filtered-out rows are filled with values present in the
  old columns
- for new columns (which is only allowed if `SubDataFrame` was created with `:`
  as column selector) filtered-out rows are filled with `missing`
- dropped columns (which are only allowed if `SubDataFrame` was created with `:`
  as column selector) are removed
- if `SubDataFrame` was not created with `:` as column selector then `select!`
  is only allowed if the transformations keep exactly the same sequence of column
  names as is in the passed `df`

If a `GroupedDataFrame` is passed then it is updated to reflect the new rows of its updated
parent. If there are independent `GroupedDataFrame` objects constructed using
the same parent data frame they might get corrupt.

$TRANSFORMATION_COMMON_RULES

# Keyword arguments
- `renamecols::Bool=true` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `ungroup::Bool=true` : whether the return value of the operation on `gd` should be a data
  frame or a `GroupedDataFrame`.
- `threads::Bool=true` : whether transformations may be run in separate tasks which
  can execute in parallel (possibly being applied to multiple rows or groups at the same time).
  Whether or not tasks are actually spawned and their number are determined automatically.
  Set to `false` if some transformations require serial execution or are not thread-safe.

$TRANSFORM_METADATA

See [`select`](@ref) for examples.
"""
select!(df::DataFrame, @nospecialize(args...);
        renamecols::Bool=true, threads::Bool=true) =
    _replace_columns!(df, select(df, args..., copycols=false,
                                 renamecols=renamecols, threads=threads))

select!(df::SubDataFrame, @nospecialize(args...);
        renamecols::Bool=true, threads::Bool=true) =
    _replace_columns!(df, select(df, args..., copycols=true,
                                 renamecols=renamecols, threads=threads),
                      keep_present=false)

function select!(@nospecialize(arg::Base.Callable), df::AbstractDataFrame;
                 renamecols::Bool=true, threads::Bool=true)
    if arg isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a data frame"))
    end
    return select!(df, arg, threads=threads)
end

"""
    transform!(df::AbstractDataFrame, args...;
               renamecols::Bool=true, threads::Bool=true)
    transform!(args::Callable, df::AbstractDataFrame;
               renamecols::Bool=true, threads::Bool=true)
    transform!(gd::GroupedDataFrame, args...;
               ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)
    transform!(f::Base.Callable, gd::GroupedDataFrame;
               ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)

Mutate `df` or `gd` in place to add columns specified by `args...` and return it.
The result is guaranteed to have the same number of rows as `df`.
Equivalent to `select!(df, :, args...)` or `select!(gd, :, args...)`,
except that column renaming performs a copy.

$TRANSFORMATION_COMMON_RULES

# Keyword arguments
- `renamecols::Bool=true` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `ungroup::Bool=true` : whether the return value of the operation on `gd` should be a data
  frame or a `GroupedDataFrame`.
- `threads::Bool=true` : whether transformations may be run in separate tasks which
  can execute in parallel (possibly being applied to multiple rows or groups at the same time).
  Whether or not tasks are actually spawned and their number are determined automatically.
  Set to `false` if some transformations require serial execution or are not thread-safe.

$TRANSFORM_METADATA

See [`select`](@ref) for examples.
"""
transform!(df::DataFrame, @nospecialize(args...);
           renamecols::Bool=true, threads::Bool=true) =
    select!(df, :, args..., renamecols=renamecols, threads=threads)

transform!(df::SubDataFrame, @nospecialize(args...); renamecols::Bool=true, threads::Bool=true) =
    _replace_columns!(df, select(df, args..., copycols=true, renamecols=renamecols, threads=threads),
                      keep_present=true)

function transform!(@nospecialize(arg::Base.Callable), df::AbstractDataFrame;
                    renamecols::Bool=true, threads::Bool=true)
    if arg isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a data frame"))
    end
    return transform!(df, arg, threads=threads)
end

"""
    select(df::AbstractDataFrame, args...;
           copycols::Bool=true, renamecols::Bool=true, threads::Bool=true)
    select(args::Callable, df::DataFrame;
           renamecols::Bool=true, threads::Bool=true)
    select(gd::GroupedDataFrame, args...;
           copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true,
           renamecols::Bool=true, threads::Bool=true)
    select(f::Base.Callable, gd::GroupedDataFrame;
           copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true,
           renamecols::Bool=true, threads::Bool=true)

Create a new data frame that contains columns from `df` or `gd` specified by
`args` and return it. The result is guaranteed to have the same number of rows
as `df`, except when no columns are selected (in which case the result has zero
rows).

$TRANSFORMATION_COMMON_RULES

# Keyword arguments
- `copycols::Bool=true` : whether columns of the source data frame should be copied if
  no transformation is applied to them.
- `renamecols::Bool=true` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `keepkeys::Bool=true` : whether grouping columns of `gd` should be kept in the returned
  data frame.
- `ungroup::Bool=true` : whether the return value of the operation on `gd` should be a data
  frame or a `GroupedDataFrame`.
- `threads::Bool=true` : whether transformations may be run in separate tasks which
  can execute in parallel (possibly being applied to multiple rows or groups at the same time).
  Whether or not tasks are actually spawned and their number are determined automatically.
  Set to `false` if some transformations require serial execution or are not thread-safe.

$TRANSFORM_METADATA

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> select(df, 2)
3×1 DataFrame
 Row │ b
     │ Int64
─────┼───────
   1 │     4
   2 │     5
   3 │     6

julia> select(df, :a => ByRow(sin) => :c, :b)
3×2 DataFrame
 Row │ c         b
     │ Float64   Int64
─────┼─────────────────
   1 │ 0.841471      4
   2 │ 0.909297      5
   3 │ 0.14112       6

julia> select(df, :, [:a, :b] => (a, b) -> a .+ b .- sum(b)/length(b))
3×3 DataFrame
 Row │ a      b      a_b_function
     │ Int64  Int64  Float64
─────┼────────────────────────────
   1 │     1      4           0.0
   2 │     2      5           2.0
   3 │     3      6           4.0

julia> select(df, All() .=> [minimum maximum])
3×4 DataFrame
 Row │ a_minimum  b_minimum  a_maximum  b_maximum
     │ Int64      Int64      Int64      Int64
─────┼────────────────────────────────────────────
   1 │         1          4          3          6
   2 │         1          4          3          6
   3 │         1          4          3          6

julia> using Statistics

julia> select(df, AsTable(:) => ByRow(mean), renamecols=false)
3×1 DataFrame
 Row │ a_b
     │ Float64
─────┼─────────
   1 │     2.5
   2 │     3.5
   3 │     4.5

julia> select(df, AsTable(:) => ByRow(mean) => x -> join(x, "_"))
3×1 DataFrame
 Row │ a_b
     │ Float64
─────┼─────────
   1 │     2.5
   2 │     3.5
   3 │     4.5

julia> select(first, df)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     1      4
   3 │     1      4

julia> df = DataFrame(a=1:3, b=4:6, c=7:9)
3×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      7
   2 │     2      5      8
   3 │     3      6      9

julia> select(df, AsTable(:) => ByRow(x -> (mean=mean(x), std=std(x))) => :stats,
              AsTable(:) => ByRow(x -> (mean=mean(x), std=std(x))) => AsTable)
3×3 DataFrame
 Row │ stats                    mean     std
     │ NamedTup…                Float64  Float64
─────┼───────────────────────────────────────────
   1 │ (mean = 4.0, std = 3.0)      4.0      3.0
   2 │ (mean = 5.0, std = 3.0)      5.0      3.0
   3 │ (mean = 6.0, std = 3.0)      6.0      3.0

julia> df = DataFrame(a=[1, 1, 1, 2, 2, 1, 1, 2],
                      b=repeat([2, 1], outer=[4]),
                      c=1:8)
8×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      1      2
   3 │     1      2      3
   4 │     2      1      4
   5 │     2      2      5
   6 │     1      1      6
   7 │     1      2      7
   8 │     2      1      8

julia> gd = groupby(df, :a)
GroupedDataFrame with 2 groups based on key: a
First Group (5 rows): a = 1
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      1      2
   3 │     1      2      3
   4 │     1      1      6
   5 │     1      2      7
⋮
Last Group (3 rows): a = 2
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      1      4
   2 │     2      2      5
   3 │     2      1      8
```

# specifying a name for target column
```jldoctest
julia> df = DataFrame(a=[1, 1, 1, 2, 2, 1, 1, 2],
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> select(gd, :c => (x -> sum(log, x)) => :sum_log_c)
8×2 DataFrame
 Row │ a      sum_log_c
     │ Int64  Float64
─────┼──────────────────
   1 │     1    5.52943
   2 │     1    5.52943
   3 │     1    5.52943
   4 │     2    5.07517
   5 │     2    5.07517
   6 │     1    5.52943
   7 │     1    5.52943
   8 │     2    5.07517

julia> select(gd, [:b, :c] .=> sum) # passing a vector of pairs
8×3 DataFrame
 Row │ a      b_sum  c_sum
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      8     19
   2 │     1      8     19
   3 │     1      8     19
   4 │     2      4     17
   5 │     2      4     17
   6 │     1      8     19
   7 │     1      8     19
   8 │     2      4     17
```

# multiple arguments, renaming and keepkeys
```jldoctest
julia> df = DataFrame(a=[1, 1, 1, 2, 2, 1, 1, 2],
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> select(gd, :b => :b1, :c => :c1, [:b, :c] => +, keepkeys=false)
8×3 DataFrame
 Row │ b1     c1     b_c_+
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      1      3
   2 │     1      2      3
   3 │     2      3      5
   4 │     1      4      5
   5 │     2      5      7
   6 │     1      6      7
   7 │     2      7      9
   8 │     1      8      9
```

# broadcasting and column expansion
```jldoctest
julia> df = DataFrame(a=[1, 1, 1, 2, 2, 1, 1, 2],
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> select(gd, :b, AsTable([:b, :c]) => ByRow(extrema) => [:min, :max])
8×4 DataFrame
 Row │ a      b      min    max
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      1      2
   2 │     1      1      1      2
   3 │     1      2      2      3
   4 │     2      1      1      4
   5 │     2      2      2      5
   6 │     1      1      1      6
   7 │     1      2      2      7
   8 │     2      1      1      8

julia> select(gd, :, AsTable(Not(:a)) => sum, renamecols=false)
8×4 DataFrame
 Row │ a      b      c      b_c
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      1      3
   2 │     1      1      2      3
   3 │     1      2      3      5
   4 │     2      1      4      5
   5 │     2      2      5      7
   6 │     1      1      6      7
   7 │     1      2      7      9
   8 │     2      1      8      9
```

# column-independent operations
```jldoctest
julia> df = DataFrame(a=[1, 1, 1, 2, 2, 1, 1, 2],
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> select(gd, nrow, proprow, groupindices, eachindex)
8×5 DataFrame
 Row │ a      nrow   proprow  groupindices  eachindex
     │ Int64  Int64  Float64  Int64         Int64
─────┼────────────────────────────────────────────────
   1 │     1      5    0.625             1          1
   2 │     1      5    0.625             1          2
   3 │     1      5    0.625             1          3
   4 │     2      3    0.375             2          1
   5 │     2      3    0.375             2          2
   6 │     1      5    0.625             1          4
   7 │     1      5    0.625             1          5
   8 │     2      3    0.375             2          3
```
"""
select(df::AbstractDataFrame, @nospecialize(args...);
       copycols::Bool=true, renamecols::Bool=true, threads::Bool=true) =
    manipulate(df, map(x -> broadcast_pair(df, x), args)...,
               copycols=copycols, keeprows=true, renamecols=renamecols)

function select(@nospecialize(arg::Base.Callable), df::AbstractDataFrame;
                renamecols::Bool=true, threads::Bool=true)
    if arg isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a data frame"))
    end
    return select(df, arg, threads=threads)
end

"""
    transform(df::AbstractDataFrame, args...;
              copycols::Bool=true, renamecols::Bool=true, threads::Bool=true)
    transform(f::Callable, df::DataFrame;
              renamecols::Bool=true, threads::Bool=true)
    transform(gd::GroupedDataFrame, args...;
              copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true,
              renamecols::Bool=true, threads::Bool=true)
    transform(f::Base.Callable, gd::GroupedDataFrame;
              copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true,
              renamecols::Bool=true, threads::Bool=true)

Create a new data frame that contains columns from `df` or `gd` plus columns
specified by `args` and return it. The result is guaranteed to have the same
number of rows as `df`. Equivalent to `select(df, :, args...)` or `select(gd, :, args...)`.

$TRANSFORMATION_COMMON_RULES

# Keyword arguments
- `copycols::Bool=true` : whether columns of the source data frame should be copied if
  no transformation is applied to them.
- `renamecols::Bool=true` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `keepkeys::Bool=true` : whether grouping columns of `gd` should be kept in the returned
  data frame.
- `ungroup::Bool=true` : whether the return value of the operation on `gd` should be a data
  frame or a `GroupedDataFrame`.
- `threads::Bool=true` : whether transformations may be run in separate tasks which
  can execute in parallel (possibly being applied to multiple rows or groups at the same time).
  Whether or not tasks are actually spawned and their number are determined automatically.
  Set to `false` if some transformations require serial execution or are not thread-safe.

Note that when the first argument is a `GroupedDataFrame`, `keepkeys=false`
is needed to be able to return a different value for the grouping column:

$TRANSFORM_METADATA

# Examples
```jldoctest
julia> gdf = groupby(DataFrame(x=1:2), :x)
GroupedDataFrame with 2 groups based on key: x
First Group (1 row): x = 1
 Row │ x
     │ Int64
─────┼───────
   1 │     1
⋮
Last Group (1 row): x = 2
 Row │ x
     │ Int64
─────┼───────
   1 │     2

julia> transform(gdf, x -> (x=10,), keepkeys=false)
2×1 DataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │    10
   2 │    10

julia> transform(gdf, x -> (x=10,), keepkeys=true)
ERROR: ArgumentError: column :x in returned data frame is not equal to grouping key :x
```

See [`select`](@ref) for more examples.
"""
transform(df::AbstractDataFrame, @nospecialize(args...);
          copycols::Bool=true, renamecols::Bool=true, threads::Bool=true) =
    select(df, :, args..., copycols=copycols,
           renamecols=renamecols, threads=threads)

function transform(@nospecialize(arg::Base.Callable), df::AbstractDataFrame;
                   renamecols::Bool=true, threads::Bool=true)
    if arg isa Colon
        throw(ArgumentError("First argument to must be a transformation if the second argument is a data frame"))
    end
    return transform(df, arg, threads=threads)
end

"""
    combine(df::AbstractDataFrame, args...;
            renamecols::Bool=true, threads::Bool=true)
    combine(f::Callable, df::AbstractDataFrame;
            renamecols::Bool=true, threads::Bool=true)
    combine(gd::GroupedDataFrame, args...;
            keepkeys::Bool=true, ungroup::Bool=true,
            renamecols::Bool=true, threads::Bool=true)
    combine(f::Base.Callable, gd::GroupedDataFrame;
            keepkeys::Bool=true, ungroup::Bool=true,
            renamecols::Bool=true, threads::Bool=true)

Create a new data frame that contains columns from `df` or `gd` specified by
`args` and return it. The result can have any number of rows that is determined
by the values returned by passed transformations.

$TRANSFORMATION_COMMON_RULES

# Keyword arguments
- `renamecols::Bool=true` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `keepkeys::Bool=true` : whether grouping columns of `gd` should be kept in the returned
  data frame.
- `ungroup::Bool=true` : whether the return value of the operation on `gd` should be a data
  frame or a `GroupedDataFrame`.
- `threads::Bool=true` : whether transformations may be run in separate tasks which
  can execute in parallel (possibly being applied to multiple rows or groups at the same time).
  Whether or not tasks are actually spawned and their number are determined automatically.
  Set to `false` if some transformations require serial execution or are not thread-safe.

$TRANSFORM_METADATA

# Examples
```jldoctest
julia> df = DataFrame(a=1:3, b=4:6)
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> combine(df, :a => sum, nrow, renamecols=false)
1×2 DataFrame
 Row │ a      nrow
     │ Int64  Int64
─────┼──────────────
   1 │     6      3

julia> combine(df, :a => ByRow(sin) => :c, :b)
3×2 DataFrame
 Row │ c         b
     │ Float64   Int64
─────┼─────────────────
   1 │ 0.841471      4
   2 │ 0.909297      5
   3 │ 0.14112       6

julia> combine(df, :, [:a, :b] => (a, b) -> a .+ b .- sum(b)/length(b))
3×3 DataFrame
 Row │ a      b      a_b_function
     │ Int64  Int64  Float64
─────┼────────────────────────────
   1 │     1      4           0.0
   2 │     2      5           2.0
   3 │     3      6           4.0

julia> combine(df, All() .=> [minimum maximum])
1×4 DataFrame
 Row │ a_minimum  b_minimum  a_maximum  b_maximum
     │ Int64      Int64      Int64      Int64
─────┼────────────────────────────────────────────
   1 │         1          4          3          6

julia> using Statistics

julia> combine(df, AsTable(:) => ByRow(mean), renamecols=false)
3×1 DataFrame
 Row │ a_b
     │ Float64
─────┼─────────
   1 │     2.5
   2 │     3.5
   3 │     4.5

julia> combine(df, AsTable(:) => ByRow(mean) => x -> join(x, "_"))
3×1 DataFrame
 Row │ a_b
     │ Float64
─────┼─────────
   1 │     2.5
   2 │     3.5
   3 │     4.5

julia> combine(first, df)
1×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4

julia> df = DataFrame(a=1:3, b=4:6, c=7:9)
3×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      7
   2 │     2      5      8
   3 │     3      6      9

julia> combine(df, AsTable(:) => ByRow(x -> (mean=mean(x), std=std(x))) => :stats,
               AsTable(:) => ByRow(x -> (mean=mean(x), std=std(x))) => AsTable)
3×3 DataFrame
 Row │ stats                    mean     std
     │ NamedTup…                Float64  Float64
─────┼───────────────────────────────────────────
   1 │ (mean = 4.0, std = 3.0)      4.0      3.0
   2 │ (mean = 5.0, std = 3.0)      5.0      3.0
   3 │ (mean = 6.0, std = 3.0)      6.0      3.0

julia> df = DataFrame(a=repeat([1, 2, 3, 4], outer=[2]),
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> combine(gd, :c => sum, nrow)
4×3 DataFrame
 Row │ a      c_sum  nrow
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6      2
   2 │     2      8      2
   3 │     3     10      2
   4 │     4     12      2

julia> combine(gd, :c => sum, nrow, ungroup=false)
GroupedDataFrame with 4 groups based on key: a
First Group (1 row): a = 1
 Row │ a      c_sum  nrow
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      6      2
⋮
Last Group (1 row): a = 4
 Row │ a      c_sum  nrow
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     4     12      2

julia> combine(gd) do d # do syntax for the slower variant
           sum(d.c)
       end
4×2 DataFrame
 Row │ a      x1
     │ Int64  Int64
─────┼──────────────
   1 │     1      6
   2 │     2      8
   3 │     3     10
   4 │     4     12

julia> combine(gd, :c => (x -> sum(log, x)) => :sum_log_c) # specifying a name for target column
4×2 DataFrame
 Row │ a      sum_log_c
     │ Int64  Float64
─────┼──────────────────
   1 │     1    1.60944
   2 │     2    2.48491
   3 │     3    3.04452
   4 │     4    3.46574

julia> combine(gd, [:b, :c] .=> sum) # passing a vector of pairs
4×3 DataFrame
 Row │ a      b_sum  c_sum
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      6
   2 │     2      2      8
   3 │     3      4     10
   4 │     4      2     12

julia> combine(gd) do sdf # dropping group when DataFrame() is returned
          sdf.c[1] != 1 ? sdf : DataFrame()
       end
6×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      1      2
   2 │     2      1      6
   3 │     3      2      3
   4 │     3      2      7
   5 │     4      1      4
   6 │     4      1      8
```

# auto-splatting, renaming and keepkeys
```jldoctest
julia> df = DataFrame(a=repeat([1, 2, 3, 4], outer=[2]),
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> combine(gd, :b => :b1, :c => :c1, [:b, :c] => +, keepkeys=false)
8×3 DataFrame
 Row │ b1     c1     b_c_+
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      1      3
   2 │     2      5      7
   3 │     1      2      3
   4 │     1      6      7
   5 │     2      3      5
   6 │     2      7      9
   7 │     1      4      5
   8 │     1      8      9
```

# broadcasting and column expansion
```jldoctest
julia> df = DataFrame(a=repeat([1, 2, 3, 4], outer=[2]),
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a);

julia> combine(gd, :b, AsTable([:b, :c]) => ByRow(extrema) => [:min, :max])
8×4 DataFrame
 Row │ a      b      min    max
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      1      2
   2 │     1      2      2      5
   3 │     2      1      1      2
   4 │     2      1      1      6
   5 │     3      2      2      3
   6 │     3      2      2      7
   7 │     4      1      1      4
   8 │     4      1      1      8

julia> combine(gd, [:b, :c] .=> Ref) # preventing vector from being spread across multiple rows
4×3 DataFrame
 Row │ a      b_Ref      c_Ref
     │ Int64  SubArray…  SubArray…
─────┼─────────────────────────────
   1 │     1  [2, 2]     [1, 5]
   2 │     2  [1, 1]     [2, 6]
   3 │     3  [2, 2]     [3, 7]
   4 │     4  [1, 1]     [4, 8]

julia> combine(gd, AsTable(Not(:a)) => Ref) # protecting result
4×2 DataFrame
 Row │ a      b_c_Ref
     │ Int64  NamedTup…
─────┼─────────────────────────────────
   1 │     1  (b = [2, 2], c = [1, 5])
   2 │     2  (b = [1, 1], c = [2, 6])
   3 │     3  (b = [2, 2], c = [3, 7])
   4 │     4  (b = [1, 1], c = [4, 8])

julia> combine(gd, :, AsTable(Not(:a)) => sum, renamecols=false)
8×4 DataFrame
 Row │ a      b      c      b_c
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      1      3
   2 │     1      2      5      7
   3 │     2      1      2      3
   4 │     2      1      6      7
   5 │     3      2      3      5
   6 │     3      2      7      9
   7 │     4      1      4      5
   8 │     4      1      8      9
```

# protecting returned vectors from being expanded into multiple rows
```jldoctest
julia> df = DataFrame(a=[1, 1, 2, 2],
                      b=[[1, 2], [2, 3], [3, 4], [4, 5]]);

julia> gd = groupby(df, :a);

julia> combine(gd, :b => Ref∘sum)
2×2 DataFrame
 Row │ a      b_Ref_sum
     │ Int64  Array…
─────┼──────────────────
   1 │     1  [3, 5]
   2 │     2  [7, 9]
```
"""
combine(df::AbstractDataFrame, @nospecialize(args...);
        renamecols::Bool=true, threads::Bool=true) =
    manipulate(df, map(x -> broadcast_pair(df, x), args)...,
               copycols=true, keeprows=false, renamecols=renamecols)

function combine(@nospecialize(arg::Base.Callable), df::AbstractDataFrame;
                 renamecols::Bool=true, threads::Bool=true)
    if arg isa Colon
        throw(ArgumentError("First argument to select! must be a transformation if the second argument is a data frame"))
    end
    return combine(df, arg, threads=threads)
end

combine(@nospecialize(f::Pair), gd::AbstractDataFrame;
        renamecols::Bool=true, threads::Bool=true) =
    throw(ArgumentError("First argument must be a transformation if the second argument is a data frame. " *
                        "You can pass a `Pair` as the second argument of the transformation. If you want the return " *
                        "value to be processed as having multiple columns add `=> AsTable` suffix to the pair."))

function manipulate(df::DataFrame, @nospecialize(cs...); copycols::Bool, keeprows::Bool, renamecols::Bool)
    cs_vec = []
    for v in cs
        if v isa AbstractVecOrMat{<:Pair}
            append!(cs_vec, v)
        else
            push!(cs_vec, v)
        end
    end
    normalized_cs = Any[normalize_selection(index(df), make_pair_concrete(c), renamecols) for c in cs_vec]
    return _manipulate(df, normalized_cs, copycols, keeprows)
end

function _manipulate(df::AbstractDataFrame, normalized_cs::Vector{Any}, copycols::Bool, keeprows::Bool)
    @assert !(df isa SubDataFrame && copycols==false)
    newdf = DataFrame()
    # the role of transformed_cols is the following
    # * make sure that we do not use the same target column name twice in transformations;
    #   note though that it can appear in no-transformation selection like
    #   `select(df, :, :a => ByRow(sin) => :a), where :a is produced both by `:`
    #   and by `:a => ByRow(sin) => :a`
    # * make sure that if some column is produced by transformation like
    #   `:a => ByRow(sin) => :a` and it appears earlier or later in non-transforming
    #   selection like `:` or `:a` then the transformation is computed and inserted
    #   in to the target data frame once and only once the first time the target column
    #   is requested to be produced.
    #
    # For example in:
    #
    # julia> df = DataFrame(a=1:2, b=3:4)
    # 2×2 DataFrame
    #  Row │ a      b
    #      │ Int64  Int64
    # ─────┼──────────────
    #    1 │     1      3
    #    2 │     2      4
    #
    # julia> select(df, :, :a => ByRow(sin) => :a)
    # 2×2 DataFrame
    #  Row │ a         b
    #      │ Float64   Int64
    # ─────┼─────────────────
    #    1 │ 0.841471      3
    #    2 │ 0.909297      4
    #
    # julia> select(df, :, :a => ByRow(sin) => :a, :a)
    # ERROR: ArgumentError: duplicate output column name: :a
    #
    # transformed_cols keeps a set of columns that were generated via a transformation
    # up till the point. Note that single column selection and column renaming is
    # considered to be a transformation
    transformed_cols = Set{Symbol}()
    # we allow resizing newdf only if up to some point only scalars were put
    # in it. The moment we put any vector into newdf its number of rows becomes fixed
    # Also if keeprows is true then we make sure to produce nrow(df) rows so resizing
    # is not allowed
    allow_resizing_newdf = Ref(!keeprows)
    # keep track of the fact if single column transformation like
    # :x or :x => :y or :x => identity
    # should make a copy
    # this ensures that we store a column from a source data frame in a
    # destination data frame without copying at most once
    column_to_copy = copycols ? trues(ncol(df)) : falses(ncol(df))

    for nc in normalized_cs
        if nc isa AbstractVector{Int} # only this case is NOT considered to be a transformation
            allunique(nc) || throw(ArgumentError("duplicate column names selected"))
            for i in nc
                newname = _names(df)[i]
                # as nc is a multiple column selection without transformations
                # we allow duplicate column names with selections applied earlier
                # and ignore them for convenience, to allow for e.g. select(df, :x1, :)
                if !hasproperty(newdf, newname)
                    # allow shortening to 0 rows
                    if allow_resizing_newdf[] && nrow(newdf) == 1
                        newdfcols = _columns(newdf)
                        for (i, col) in enumerate(newdfcols)
                            newcol = fill!(similar(col, nrow(df)), first(col))
                            firstindex(newcol) != 1 && _onebased_check_error()
                            newdfcols[i] = newcol
                        end
                    end
                    # here even if keeprows is true all is OK
                    newdf[!, newname] = column_to_copy[i] ? df[:, i] : df[!, i]
                    column_to_copy[i] = true
                    allow_resizing_newdf[] = false
                    _copy_col_note_metadata!(newdf, newname, df, i)
                end
            end
        else
            select_transform!(Ref{Any}(nc), df, newdf, transformed_cols, copycols,
                              allow_resizing_newdf, column_to_copy)
        end
    end
    _copy_table_note_metadata!(newdf, df)
    return newdf
end

function manipulate(dfv::SubDataFrame, @nospecialize(args...); copycols::Bool, keeprows::Bool,
                    renamecols::Bool)
    if copycols
        cs_vec = []
        for v in args
            if v isa AbstractVecOrMat{<:Pair}
                append!(cs_vec, v)
            else
                push!(cs_vec, v)
            end
        end
        normalized_cs = Any[normalize_selection(index(dfv), make_pair_concrete(c), renamecols) for c in cs_vec]
        return _manipulate(dfv, normalized_cs, true, keeprows)
    else
        # we do not support transformations here
        # newinds contains only indexing; making it Vector{Any} avoids some compilation
        newinds = Any[]
        seen_single_column = Set{Int}()
        for ind in args
            if ind isa Pair || ind isa AbstractVecOrMat{<:Pair}
                throw(ArgumentError(
                "Transformations are not supported for SubDataFrame with copycols=false. " *
                "Only column selection is allowed."
                ))
            end
            ind_idx = index(dfv)[ind]
            if ind isa ColumnIndex
                if ind_idx in seen_single_column
                    throw(ArgumentError(
                    "selecting the same column multiple times " *
                    "using Symbol, string or integer is not allowed " *
                    "($ind was passed more than once)"
                    ))
                end
                push!(seen_single_column, ind_idx)
            end
            push!(newinds, ind_idx)
        end
        return view(dfv, :, Cols(newinds...))
    end
end

function manipulate(df::DataFrame, args::AbstractVector{Int};
                    copycols::Bool, keeprows::Bool, renamecols::Bool)
    new_df = DataFrame(_columns(df)[args], Index(_names(df)[args]), copycols=copycols)
    _copy_all_note_metadata!(new_df, df)
    return new_df
end

function manipulate(df::DataFrame, c::MultiColumnIndex; copycols::Bool, keeprows::Bool,
                    renamecols::Bool)
    if c isa AbstractVector{<:Pair}
        return manipulate(df, c..., copycols=copycols, keeprows=keeprows,
                          renamecols=renamecols)
    else
        return manipulate(df, index(df)[c], copycols=copycols, keeprows=keeprows,
                          renamecols=renamecols)
    end
end

function manipulate(dfv::SubDataFrame, args::MultiColumnIndex;
                    copycols::Bool, keeprows::Bool, renamecols::Bool)
    if args isa AbstractVector{<:Pair}
        return manipulate(dfv, args..., copycols=copycols, keeprows=keeprows,
                          renamecols=renamecols)
    else
        return copycols ? dfv[:, args] : view(dfv, :, args)
    end
end

manipulate(df::DataFrame, c::ColumnIndex; copycols::Bool, keeprows::Bool,
           renamecols::Bool) =
    manipulate(df, Int[index(df)[c]], copycols=copycols, keeprows=keeprows, renamecols=renamecols)

manipulate(dfv::SubDataFrame, c::ColumnIndex; copycols::Bool, keeprows::Bool,
           renamecols::Bool) =
    manipulate(dfv, Int[index(dfv)[c]], copycols=copycols, keeprows=keeprows, renamecols=renamecols)

# in this file we use cs and cs_i variable names that mean "target columns specification"

# this constant defines which types of values returned by aggregation function
# in combine are considered to produce multiple columns in the resulting data frame
const MULTI_COLS_TYPE = Union{AbstractDataFrame, NamedTuple, DataFrameRow,
                              Tables.AbstractRow, AbstractMatrix}

# use a constant Vector{Int} as a sentinel to signal that idx_agg has not been computed yet
# we do not use nothing to avoid excessive specialization
const NOTHING_IDX_AGG = Int[]

function gen_groups(idx::Vector{Int})
    groups = zeros(Int, length(idx))
    groups[1] = 1
    j = 1
    last_idx = idx[1]
    @inbounds for i in 2:length(idx)
        cur_idx = idx[i]
        j += cur_idx != last_idx
        last_idx = cur_idx
        groups[i] = j
    end
    return groups
end

function _combine_prepare(gd::GroupedDataFrame,
                          (cs,)::Ref{Any};
                          keepkeys::Bool, ungroup::Bool, copycols::Bool,
                          keeprows::Bool, renamecols::Bool,
                          threads::Bool)
    for cei in cs
        if !(cei isa AbstractMatrix && isempty(cei))
            @assert cei isa Union{Pair, Base.Callable, ColumnIndex,
                                  MultiColumnIndex,
                                  AbstractVecOrMat{<:Pair}}
        end
    end
    if !ungroup && !keepkeys
        throw(ArgumentError("keepkeys=false when ungroup=false is not allowed"))
    end

    cs_vec = []
    for p in cs
        if p === nrow
            push!(cs_vec, nrow => :nrow)
        elseif p isa AbstractVecOrMat{<:Pair}
            append!(cs_vec, p)
        else !(p isa AbstractMatrix && isempty(p))
            push!(cs_vec, p)
        end
    end
    return _combine_prepare_norm(gd, cs_vec, keepkeys, ungroup, copycols,
                                 keeprows, renamecols, threads)
end

function _combine_prepare_norm(gd::GroupedDataFrame,
                               cs_vec::Vector{Any},
                               keepkeys::Bool, ungroup::Bool, copycols::Bool,
                               keeprows::Bool, renamecols::Bool,
                               threads::Bool)
    if any(x -> x isa Pair && first(x) isa Tuple, cs_vec)
        x = cs_vec[findfirst(x -> first(x) isa Tuple, cs_vec)]
        # an explicit error is thrown as this was allowed in the past
        throw(ArgumentError("passing a Tuple $(first(x)) as column selector is not " *
                            "supported, use a vector $(collect(first(x))) instead"))
    end

    cs_norm = []
    optional_transform = Bool[]
    for c in cs_vec
        arg = normalize_selection(index(parent(gd)), make_pair_concrete(c), renamecols)
        if arg isa AbstractVector{Int}
            for col_idx in arg
                push!(cs_norm, col_idx => identity => _names(gd)[col_idx])
                push!(optional_transform, true)
            end
        else
            push!(cs_norm, arg)
            push!(optional_transform, false)
        end
    end

    # cs_norm holds now either src => fun => dst or just fun
    # if optional_transform[i] is true then the transformation will be skipped
    # if earlier column with a column with the same name was created

    idx, valscat, metacols = _combine(gd, cs_norm, optional_transform, copycols,
                                      keeprows, renamecols, threads)

    pgd = parent(gd)
    _copy_table_note_metadata!(valscat, pgd)
    @assert ncol(valscat) == length(metacols)
    for (out_col_idx, in_col_idx) in enumerate(metacols)
        in_col_idx > 0 && _copy_col_note_metadata!(valscat, out_col_idx, pgd, in_col_idx)
    end

    !keepkeys && ungroup && return valscat

    gd_keys = groupcols(gd)
    for key in gd_keys
        if hasproperty(valscat, key)
            if (keeprows && !isequal(valscat[!, key], parent(gd)[!, key])) ||
                (!keeprows && !isequal(valscat[!, key], view(parent(gd)[!, key], idx)))
                throw(ArgumentError("column :$key in returned data frame " *
                                    "is not equal to grouping key :$key"))
            end
        end
    end
    if keeprows
        newparent = select(parent(gd), gd.cols, copycols=copycols)
    else
        newparent = length(gd) > 0 ? parent(gd)[idx, gd.cols] : parent(gd)[1:0, gd.cols]
    end
    added_cols = select(valscat, Not(intersect(gd_keys, _names(valscat))), copycols=false)
    hcat!(newparent, length(gd) > 0 ? added_cols : similar(added_cols, 0), copycols=false)
    ungroup && return newparent

    if length(idx) == 0 && !(keeprows && length(gd_keys) > 0)
        @assert nrow(newparent) == 0
        return GroupedDataFrame(newparent, copy(gd.cols), Int[],
                                Int[], Int[], Int[], 0, Dict{Any, Int}(),
                                Threads.ReentrantLock())
    elseif keeprows
        @assert length(gd_keys) > 0 || idx == gd.idx
        # in this case we are sure that the result GroupedDataFrame has the
        # same structure as the source except that grouping columns are at the start
        Base.@lock gd.lazy_lock begin
            return GroupedDataFrame(newparent, copy(gd.cols), gd.groups,
                                    getfield(gd, :idx), getfield(gd, :starts),
                                    getfield(gd, :ends), gd.ngroups,
                                    getfield(gd, :keymap), Threads.ReentrantLock())
        end
    else
        groups = gen_groups(idx)
        @assert groups[end] <= length(gd)
        return GroupedDataFrame(newparent, copy(gd.cols), groups,
                                nothing, nothing, nothing, groups[end], nothing,
                                Threads.ReentrantLock())
    end
end

# Find first value matching condition for each group
# Optimized for situations where a matching value is typically encountered
# among the first rows for each group
# rev keyword argument should be only used to signal that we process the `last` function
function fillfirst!(condf, outcol::AbstractVector, incol::AbstractVector,
                    gd::GroupedDataFrame; rev::Bool=false)
    ngroups = gd.ngroups
    # Use group indices if they have already been computed
    idx = getfield(gd, :idx)
    if idx !== nothing && condf === nothing
        v = rev ? gd.ends : gd.starts
        @inbounds for i in 1:ngroups
            outcol[i] = incol[idx[v[i]]]
        end
    elseif idx !== nothing
        nfilled = 0
        starts = gd.starts
        @inbounds for i in eachindex(outcol)
            s = starts[i]
            offsets = rev ? (nrow(gd[i])-1:-1:0) : (0:nrow(gd[i])-1)
            for j in offsets
                x = incol[idx[s+j]]
                if !condf === nothing || condf(x)
                    outcol[i] = x
                    nfilled += 1
                    break
                end
            end
        end
        if nfilled < length(outcol)
            throw(ArgumentError("some groups contain only missing values"))
        end
    else # Finding first row is faster than computing all group indices
        groups = gd.groups
        if rev
            r = length(groups):-1:1
        else
            r = 1:length(groups)
        end
        filled = fill(false, ngroups)
        nfilled = 0
        @inbounds for i in r
            gix = groups[i]
            x = incol[i]
            if gix > 0 && (condf === nothing || condf(x)) && !filled[gix]
                filled[gix] = true
                outcol[gix] = x
                nfilled += 1
                nfilled == ngroups && break
            end
        end
        if nfilled < length(outcol)
            throw(ArgumentError("some groups contain only missing values"))
        end
    end
    return outcol
end

function _agg2idx_map_helper(idx::Vector{Int}, idx_agg::Vector{Int})
    agg2idx_map = fill(-1, length(idx))
    aggj = 1
    @inbounds for (j, idxj) in enumerate(idx)
        while idx_agg[aggj] != idxj
            aggj += 1
            @assert aggj <= length(idx_agg)
        end
        agg2idx_map[j] = aggj
    end
    return agg2idx_map
end

struct TransformationResult
    col_idx::Vector{Int} # index for a column
    col::AbstractVector # computed value of a column
    name::Symbol # name of a column
    optional::Bool # whether a column is allowed to be replaced in the future
    metadatacol::Int # whether metadata should be propagated:
                     # 0 if not
                     # if greater than zero column number of metadata source
end

# the transformation is an aggregation for which we have the fast path
function _combine_process_agg((cs_i,)::Ref{Any},
                              optional_i::Bool,
                              parentdf::AbstractDataFrame,
                              gd::GroupedDataFrame,
                              seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                              trans_res::Vector{TransformationResult},
                              idx_agg::Vector{Int})
    @assert cs_i isa Pair{Int, <:Pair{<:Function, Symbol}}
    @assert isagg(cs_i, gd)
    @assert !optional_i
    out_col_name = last(last(cs_i))
    in_col_idx = first(cs_i)
    incol = parentdf[!, in_col_idx]
    agg = check_aggregate(first(last(cs_i)), incol)
    outcol = agg(incol, gd)

    return function()
        if haskey(seen_cols, out_col_name)
            optional, loc = seen_cols[out_col_name]
            # we have seen this col but it is not allowed to replace it
            optional || throw(ArgumentError("duplicate output column name: :$out_col_name"))
            @assert trans_res[loc].optional && trans_res[loc].name == out_col_name
            trans_res[loc] = TransformationResult(idx_agg, outcol, out_col_name, optional_i,
                                                  columnindex(parentdf, out_col_name) == in_col_idx ? in_col_idx : 0)
            seen_cols[out_col_name] = (optional_i, loc)
        else
            push!(trans_res, TransformationResult(idx_agg, outcol, out_col_name, optional_i,
                                                  columnindex(parentdf, out_col_name) == in_col_idx ? in_col_idx : 0))
            seen_cols[out_col_name] = (optional_i, length(trans_res))
        end
    end
end

function _combine_process_groupindices((cs_i,)::Ref{Any},
                                       optional_i::Bool,
                                       parentdf::AbstractDataFrame,
                                       gd::GroupedDataFrame,
                                       seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                                       trans_res::Vector{TransformationResult},
                                       idx_agg::Vector{Int})
    @assert cs_i isa Pair{Vector{Int}, Pair{typeof(groupindices), Symbol}}
    @assert first(cs_i) isa Vector{Int} && isempty(first(cs_i))
    @assert !optional_i
    @assert idx_agg !== NOTHING_IDX_AGG
    out_col_name = last(last(cs_i))
    outcol = 1:length(gd)

    return function()
        if haskey(seen_cols, out_col_name)
            optional, loc = seen_cols[out_col_name]
            # we have seen this col but it is not allowed to replace it
            optional || throw(ArgumentError("duplicate output column name: :$out_col_name"))
            @assert trans_res[loc].optional && trans_res[loc].name == out_col_name
            trans_res[loc] = TransformationResult(idx_agg, outcol, out_col_name, optional_i, 0)
            seen_cols[out_col_name] = (optional_i, loc)
        else
            push!(trans_res, TransformationResult(idx_agg, outcol, out_col_name, optional_i, 0))
            seen_cols[out_col_name] = (optional_i, length(trans_res))
        end
    end
end

function _combine_process_proprow((cs_i,)::Ref{Any},
                                  optional_i::Bool,
                                  parentdf::AbstractDataFrame,
                                  gd::GroupedDataFrame,
                                  seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                                  trans_res::Vector{TransformationResult},
                                  idx_agg::Vector{Int})
    @assert cs_i isa Pair{Vector{Int}, Pair{typeof(proprow), Symbol}}
    @assert first(cs_i) isa Vector{Int} && isempty(first(cs_i))
    @assert !optional_i
    @assert idx_agg !== NOTHING_IDX_AGG
    out_col_name = last(last(cs_i))

    # introduce outcol1 and outcol2 as without it outcol is boxed
    # since it is later used inside the anonymous function we return
    outcol = if getfield(gd, :idx) === nothing
        outcol1 = zeros(Float64, length(gd) + 1)
        @inbounds @simd for gix in gd.groups
            outcol1[gix + 1] += 1
        end
        popfirst!(outcol1)
        outcol1 ./= sum(outcol1)
        outcol1
    else
        outcol2 = Vector{Float64}(undef, length(gd))
        outcol2 .= gd.ends .- gd.starts .+ 1
        outcol2 ./= sum(outcol2)
        outcol2
    end

    return function()
        if haskey(seen_cols, out_col_name)
            optional, loc = seen_cols[out_col_name]
            # we have seen this col but it is not allowed to replace it
            optional || throw(ArgumentError("duplicate output column name: :$out_col_name"))
            @assert trans_res[loc].optional && trans_res[loc].name == out_col_name
            trans_res[loc] = TransformationResult(idx_agg, outcol, out_col_name, optional_i, 0)
            seen_cols[out_col_name] = (optional_i, loc)
        else
            push!(trans_res, TransformationResult(idx_agg, outcol, out_col_name, optional_i, 0))
            seen_cols[out_col_name] = (optional_i, length(trans_res))
        end
    end
end

# move one column without transforming it
function _combine_process_noop(cs_i::Pair{<:Union{Int, AbstractVector{Int}}, Pair{typeof(identity), Symbol}},
                               optional_i::Bool,
                               parentdf::AbstractDataFrame,
                               seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                               trans_res::Vector{TransformationResult},
                               idx_keeprows::AbstractVector{Int},
                               copycols::Bool)
    source_cols = first(cs_i)
    out_col_name = last(last(cs_i))
    if length(source_cols) != 1
        throw(ArgumentError("Exactly one column can be transformed to one output column " *
                            "when using identity transformation"))
    end
    outcol = parentdf[!, first(source_cols)]

    return function()
        if haskey(seen_cols, out_col_name)
            optional, loc = seen_cols[out_col_name]
            @assert trans_res[loc].name == out_col_name
            if optional
                if !optional_i
                    @assert trans_res[loc].optional
                    trans_res[loc] = TransformationResult(idx_keeprows, copycols ? copy(outcol) : outcol,
                                                          out_col_name, optional_i, only(source_cols))
                    seen_cols[out_col_name] = (optional_i, loc)
                end
            else
                # if optional_i is true, then we ignore processing this column
                optional_i || throw(ArgumentError("duplicate output column name: :$out_col_name"))
            end
        else
            push!(trans_res, TransformationResult(idx_keeprows, copycols ? copy(outcol) : outcol,
                                                  out_col_name, optional_i, only(source_cols)))
            seen_cols[out_col_name] = (optional_i, length(trans_res))
        end
    end
end

# perform a transformation taking SubDataFrame as an input
function _combine_process_callable(wcs_i::Ref{Any},
                                   optional_i::Bool,
                                   parentdf::AbstractDataFrame,
                                   gd::GroupedDataFrame,
                                   seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                                   trans_res::Vector{TransformationResult},
                                   idx_agg::Ref{Vector{Int}},
                                   threads::Bool)
    cs_i = only(wcs_i)
    @assert cs_i isa Base.Callable
    firstres = length(gd) > 0 ? cs_i(gd[1]) : cs_i(similar(parentdf, 0))
    idx, outcols, nms = _combine_multicol(Ref{Any}(firstres), wcs_i, gd,
                                          Ref{Any}(nothing), threads)

    if !(firstres isa Union{AbstractVecOrMat, AbstractDataFrame,
                            NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}})
        Base.@lock gd.lazy_lock begin
            # if idx_agg was not computed yet it is NOTHING_IDX_AGG
            # in this case if we are not passed a vector compute it.
            if idx_agg[] === NOTHING_IDX_AGG
                idx_agg[] = Vector{Int}(undef, length(gd))
                fillfirst!(nothing, idx_agg[], 1:length(gd.groups), gd)
            end
            @assert idx == idx_agg[]
            idx = idx_agg[]
        end
    end
    @assert length(outcols) == length(nms)
    idx_local = idx
    return function()
        for j in eachindex(outcols)
            outcol = outcols[j]
            out_col_name = nms[j]
            if haskey(seen_cols, out_col_name)
                optional, loc = seen_cols[out_col_name]
                # if column was seen and it is optional now ignore it
                if !optional_i
                    optional, loc = seen_cols[out_col_name]
                    # we have seen this col but it is not allowed to replace it
                    optional || throw(ArgumentError("duplicate output column name: :$out_col_name"))
                    @assert trans_res[loc].optional && trans_res[loc].name == out_col_name
                    trans_res[loc] = TransformationResult(idx_local, outcol, out_col_name, optional_i, 0)
                    seen_cols[out_col_name] = (optional_i, loc)
                end
            else
                push!(trans_res, TransformationResult(idx_local, outcol, out_col_name, optional_i, 0))
                seen_cols[out_col_name] = (optional_i, length(trans_res))
            end
        end
    end
end

# perform a transformation specified using the Pair notation with a single output column
function _combine_process_pair_symbol(optional_i::Bool,
                                      gd::GroupedDataFrame,
                                      seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                                      trans_res::Vector{TransformationResult},
                                      idx_agg::Ref{Vector{Int}},
                                      out_col_name::Symbol,
                                      firstmulticol::Bool,
                                      (firstres,)::Ref{Any},
                                      wfun::Ref{Any},
                                      wincols::Ref{Any},
                                      threads::Bool,
                                      (source_cols,)::Ref{Any})
    @assert only(wfun) isa Base.Callable
    @assert only(wincols) isa Union{Tuple, NamedTuple}

    if firstmulticol
        throw(ArgumentError("a single value or vector result is required " *
                            "(got $(typeof(firstres))). Maybe you " *
                            "forgot to wrap the return value of " *
                            "the operation with `Ref`?"))
    end
    # if idx_agg was not computed yet it is NOTHING_IDX_AGG
    # in this case if we are not passed a vector compute it.
    Base.@lock gd.lazy_lock begin
        if !(firstres isa AbstractVector) && idx_agg[] === NOTHING_IDX_AGG
            idx_agg[] = Vector{Int}(undef, length(gd))
            fillfirst!(nothing, idx_agg[], 1:length(gd.groups), gd)
        end
    end
    # TODO: if firstres is a vector we recompute idx for every function
    # this could be avoided - it could be computed only the first time
    # and later we could just check if lengths of groups match this first idx

    # the last argument passed to _combine_with_first informs it about precomputed
    # idx. Currently we do it only for single-row return values otherwise we pass
    # NOTHING_IDX_AGG to signal that idx has to be computed in _combine_with_first
    idx, outcols, _ = _combine_with_first(Ref{Any}(wrap(firstres)), wfun, gd, wincols,
                                          firstmulticol,
                                          firstres isa AbstractVector ? NOTHING_IDX_AGG : idx_agg[],
                                          threads)
    @assert length(outcols) == 1
    outcol = outcols[1]

    metacol = if (source_cols isa Int ||
        (source_cols isa AbstractVector{Int} && length(source_cols) == 1)) &&
       (only(source_cols) == columnindex(parent(gd), out_col_name) ||
        only(wfun) === identity || only(wfun) === copy)
        only(source_cols)
    else
        0
    end

    return function()
        if haskey(seen_cols, out_col_name)
            # if column was seen and it is optional now ignore it
            if !optional_i
                optional, loc = seen_cols[out_col_name]
                # we have seen this col but it is not allowed to replace it
                optional || throw(ArgumentError("duplicate output column name: :$out_col_name"))
                @assert trans_res[loc].optional && trans_res[loc].name == out_col_name
                trans_res[loc] = TransformationResult(idx, outcol, out_col_name, optional_i, metacol)
                seen_cols[out_col_name] = (optional_i, loc)
            end
        else
            push!(trans_res, TransformationResult(idx, outcol, out_col_name, optional_i, metacol))
            seen_cols[out_col_name] = (optional_i, length(trans_res))
        end
    end
end

@noinline function expand_res_astable(res, kp1, emptyres::Bool)
    prepend = all(x -> x isa Integer, kp1)
    if !(prepend || all(x -> x isa Symbol, kp1) || all(x -> x isa AbstractString, kp1))
        throw(ArgumentError("keys of the returned elements must be " *
                            "`Symbol`s, strings or integers"))
    end
    if any(x -> !isequal(keys(x), kp1), res)
        throw(ArgumentError("keys of the returned elements must be equal"))
    end
    outcols = [[x[n] for x in res] for n in kp1]
    # make sure we only infer column names and types for empty res, but do not
    # produce values that were generated when computing firstres
    emptyres && foreach(empty!, outcols)
    nms = [prepend ? Symbol("x", n) : Symbol(n) for n in kp1]
    return outcols, nms
end

# perform a transformation specified using the Pair notation with multiple output columns
function _combine_process_pair_astable(optional_i::Bool,
                                       gd::GroupedDataFrame,
                                       seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                                       trans_res::Vector{TransformationResult},
                                       idx_agg::Ref{Vector{Int}},
                                       out_col_name::Union{Type{AsTable}, AbstractVector{Symbol}},
                                       firstmulticol::Bool,
                                       (firstres,)::Ref{Any},
                                       wfun::Ref{Any},
                                       wincols::Ref{Any},
                                       threads::Bool)
    fun = only(wfun)
    @assert fun isa Base.Callable
    @assert only(wincols) isa Union{Tuple, NamedTuple}
    if firstres isa AbstractVector
        idx, outcol_vec, _ = _combine_with_first(Ref{Any}(wrap(firstres)), wfun, gd, wincols,
                                                 firstmulticol, NOTHING_IDX_AGG, threads)
        @assert length(outcol_vec) == 1
        res = outcol_vec[1]
        if isempty(res)
            emptyres = true
            res = firstres
        else
            emptyres = false
        end
        kp1 = isempty(res) ? () : keys(res[1])

        outcols, nms = expand_res_astable(res, kp1, emptyres)
    else
        if !firstmulticol
            firstres = Tables.columntable(firstres)
            oldfun = fun
            fun = (x...) -> Tables.columntable(oldfun(x...))
        end
        idx, outcols, nms = _combine_multicol(Ref{Any}(firstres), Ref{Any}(fun), gd,
                                              wincols, threads)
        if !(firstres isa Union{AbstractVecOrMat, AbstractDataFrame,
             NamedTuple{<:Any, <:Tuple{Vararg{AbstractVector}}}})
            Base.@lock gd.lazy_lock begin
                # if idx_agg was not computed yet it is nothing
                # in this case if we are not passed a vector compute it.
                if idx_agg[] === NOTHING_IDX_AGG
                    idx_agg[] = Vector{Int}(undef, length(gd))
                    fillfirst!(nothing, idx_agg[], 1:length(gd.groups), gd)
                end
                @assert idx == idx_agg[]
                idx = idx_agg[]
            end
        end
    end
    @assert length(outcols) == length(nms)
    if out_col_name isa AbstractVector{Symbol}
        if length(out_col_name) != length(nms)
            throw(ArgumentError("Number of returned columns is $(length(nms)) " *
                                "and it does not match the number of provided output " *
                                "names which is $(length(out_col_name))"))
        else
            nms = out_col_name
        end
    end
    outcols_local = outcols
    nms_local = nms
    idx_local = idx
    return function()
        for j in eachindex(outcols_local)
            outcol = outcols_local[j]
            out_col_name_j = nms_local[j]
            if haskey(seen_cols, out_col_name_j)
                optional, loc = seen_cols[out_col_name_j]
                # if column was seen and it is optional now ignore it
                if !optional_i
                    optional, loc = seen_cols[out_col_name_j]
                    # we have seen this col but it is not allowed to replace it
                    optional || throw(ArgumentError("duplicate output column name: :$out_col_name_j"))
                    @assert trans_res[loc].optional && trans_res[loc].name == out_col_name_j
                    trans_res[loc] = TransformationResult(idx_local, outcol, out_col_name_j, optional_i, 0)
                    seen_cols[out_col_name_j] = (optional_i, loc)
                end
            else
                push!(trans_res, TransformationResult(idx_local, outcol, out_col_name_j, optional_i, 0))
                seen_cols[out_col_name_j] = (optional_i, length(trans_res))
            end
        end
    end
end

# helper function allowing us to identify groupindices and proprow transforms
function isspecialtransform((cs_i,)::Ref{Any})
    cs_i isa Pair || return false
    (first(cs_i) isa Vector{Int} && isempty(first(cs_i))) || return false
    fun = first(last(cs_i))
    fun === groupindices && return true
    fun === proprow && return true
    return false
end

# perform a transformation specified using the Pair notation
# cs_i is a Pair that has many possible forms so this function is used to dispatch
# to an appropriate more specialized function
function _combine_process_pair((cs_i,)::Ref{Any},
                               optional_i::Bool,
                               parentdf::AbstractDataFrame,
                               gd::GroupedDataFrame,
                               seen_cols::Dict{Symbol, Tuple{Bool, Int}},
                               trans_res::Vector{TransformationResult},
                               idx_agg::Ref{Vector{Int}},
                               threads::Bool)
    @assert cs_i isa Pair

    source_cols, (fun, out_col_name) = cs_i

    if source_cols isa Int
        incols = (parentdf[!, source_cols],)
    elseif source_cols isa AsTable
        incols = Tables.columntable(select(parentdf,
                                           source_cols.cols,
                                           copycols=false))
    else
        @assert source_cols isa AbstractVector{Int}
        incols = ntuple(i -> parentdf[!, source_cols[i]], length(source_cols))
    end

    firstres = length(gd) > 0 ?
               do_call(fun, gd.idx, gd.starts, gd.ends, gd, incols, 1) :
               do_call(fun, Int[], 1:1, 0:0, gd, incols, 1)
    firstmulticol = firstres isa MULTI_COLS_TYPE

    if out_col_name isa Symbol
        return _combine_process_pair_symbol(optional_i, gd, seen_cols, trans_res, idx_agg,
                                            out_col_name, firstmulticol, Ref{Any}(firstres),
                                            Ref{Any}(fun), Ref{Any}(incols), threads, Ref{Any}(source_cols))
    end
    if out_col_name == AsTable || out_col_name isa AbstractVector{Symbol}
        return _combine_process_pair_astable(optional_i, gd, seen_cols, trans_res, idx_agg,
                                             out_col_name, firstmulticol, Ref{Any}(firstres),
                                             Ref{Any}(fun), Ref{Any}(incols), threads)
    end
    throw(ArgumentError("unsupported target column name specifier $out_col_name"))
end

function prepare_idx_keeprows(idx::AbstractVector{<:Integer},
                              starts::AbstractVector{<:Integer},
                              ends::AbstractVector{<:Integer},
                              nrowparent::Integer)
    idx_keeprows = Vector{Int}(undef, nrowparent)
    i = 0
    for (s, e) in zip(starts, ends)
        v = idx[s]
        for k in s:e
            i += 1
            idx_keeprows[i] = v
        end
    end
    @assert i == nrowparent
    return idx_keeprows
end

function _combine(gd::GroupedDataFrame,
                  cs_norm::Vector{Any}, optional_transform::Vector{Bool},
                  copycols::Bool, keeprows::Bool, renamecols::Bool,
                  threads::Bool)
    if isempty(cs_norm)
        if keeprows && nrow(parent(gd)) > 0 && minimum(gd.groups) == 0
            throw(ArgumentError("select and transform do not support " *
                                "`GroupedDataFrame`s from which some groups have "*
                                "been dropped (including skipmissing=true)"))
        end
        return Int[], DataFrame(), Int[]
    end

    idx_keeprows = if keeprows
        if nrow(parent(gd)) > 0 && minimum(gd.groups) == 0
            throw(ArgumentError("select and transform do not support " *
                                "`GroupedDataFrame`s from which some groups have "*
                                "been dropped (including skipmissing=true)"))
        end
        prepare_idx_keeprows(gd.idx, gd.starts, gd.ends, nrow(parent(gd)))
    else
        Int[]
    end

    idx_agg = Ref(NOTHING_IDX_AGG)
    if any(x -> isagg(x, gd) || isspecialtransform(Ref{Any}(x)), cs_norm)
        # Compute indices of representative rows only once for all AbstractAggregates
        # or special transforms
        idx_agg[] = Vector{Int}(undef, length(gd))
        fillfirst!(nothing, idx_agg[], 1:length(gd.groups), gd)
    end
    if length(gd) == 0 || !all(x -> isagg(x, gd) || isspecialtransform(Ref{Any}(x)), cs_norm)
        # Trigger computation of indices
        # This can speed up some aggregates that would not trigger this on their own
        @assert length(gd.idx) >= 0
    end

    trans_res = Vector{TransformationResult}()

    # seen_cols keeps an information about location of columns already processed
    # and if a given column can be replaced in the future
    seen_cols = Dict{Symbol, Tuple{Bool, Int}}()

    tasks = similar(cs_norm, Task)

    parentdf = parent(gd)
    # Operations are run in separate tasks, except two parts:
    # - the first task that needs idx_agg computes it;
    #   a lock ensures others wait for it to complete
    # - once all tasks are done, they need sequential postprocessing
    #   since their order affects that of columns
    for i in eachindex(cs_norm, optional_transform, tasks)
        cs_i = cs_norm[i]
        optional_i = optional_transform[i]
        tasks[i] = @spawn_or_run_task threads if length(gd) > 0 && isagg(cs_i, gd)
            _combine_process_agg(Ref{Any}(cs_i), optional_i, parentdf, gd,
                                 seen_cols, trans_res, idx_agg[])
        elseif keeprows && cs_i isa Pair && first(last(cs_i)) === identity &&
               !(first(cs_i) isa AsTable) && (last(last(cs_i)) isa Symbol)
            # this is a fast path used when
            # we pass a column or rename a column in select or transform
            _combine_process_noop(cs_i, optional_i, parentdf,
                                  seen_cols, trans_res, idx_keeprows, copycols)
        elseif cs_i isa Base.Callable
            _combine_process_callable(Ref{Any}(cs_i), optional_i, parentdf, gd,
                                      seen_cols, trans_res, idx_agg, threads)
        else
            @assert cs_i isa Pair
            if first(cs_i) isa Vector{Int} && isempty(first(cs_i)) &&
               first(last(cs_i)) === groupindices
                _combine_process_groupindices(Ref{Any}(cs_i), optional_i, parentdf, gd,
                                              seen_cols, trans_res, idx_agg[])
            elseif first(cs_i) isa Vector{Int} && isempty(first(cs_i)) &&
                   first(last(cs_i)) === proprow
                _combine_process_proprow(Ref{Any}(cs_i), optional_i, parentdf, gd,
                                         seen_cols, trans_res, idx_agg[])
            else
                _combine_process_pair(Ref{Any}(cs_i), optional_i, parentdf, gd,
                                      seen_cols, trans_res, idx_agg, threads)
            end
        end
    end
    # Workaround JuliaLang/julia#38931:
    # we want to preserve the exception type thrown in user code,
    # and print the backtrace corresponding to it
    for t in tasks
        try
            wait(t)
        catch e
            if e isa TaskFailedException
                throw(t.exception)
            else
                rethrow(e)
            end
        end
    end
    # Post-processing has to be run sequentially
    # since the order of operations determines that of columns
    for t in tasks
        postprocessf = fetch(t)
        postprocessf()
    end

    isempty(trans_res) && return Int[], DataFrame(), Int[]
    # idx_agg[] === NOTHING_IDX_AGG then we have only functions that
    # returned multiple rows and idx_loc = 1
    idx_loc = findfirst(x -> x.col_idx !== idx_agg[], trans_res)
    if !keeprows && isnothing(idx_loc)
        @assert idx_agg[] !== NOTHING_IDX_AGG
        idx = idx_agg[]
    else
        idx = keeprows ? idx_keeprows : trans_res[idx_loc].col_idx
        agg2idx_map = nothing
        for i in 1:length(trans_res)
            if trans_res[i].col_idx !== idx
                if trans_res[i].col_idx === idx_agg[]
                    # we perform pseudo broadcasting here
                    # keep -1 as a sentinel for errors
                    if isnothing(agg2idx_map)
                        agg2idx_map = _agg2idx_map_helper(idx, idx_agg[])
                    end
                    trans_res[i] = TransformationResult(idx_agg[], trans_res[i].col[agg2idx_map],
                                                        trans_res[i].name, trans_res[i].optional,
                                                        trans_res[i].metadatacol)
                elseif idx != trans_res[i].col_idx
                    if keeprows
                        throw(ArgumentError("all functions must return vectors with " *
                                            "as many values as rows in each group"))
                    else
                        throw(ArgumentError("all functions must return vectors of the same length"))
                    end
                end
            end
        end
    end

    # here first field in trans_res[i] is used to keep track how the column was generated
    # a correct index is stored in idx variable

    @sync for i in eachindex(trans_res)
        let i=i
            @spawn_or_run threads reorder_cols!(trans_res, i, trans_res[i].col, trans_res[i].col_idx,
                                                keeprows, idx_keeprows, gd)
        end
    end

    outcols = AbstractVector[x.col for x in trans_res]
    nms = Symbol[x.name for x in trans_res]
    metacols = Int[x.metadatacol for x in trans_res]
    # this check is redundant given we check idx above
    # but it is safer to double check and it is cheap
    @assert all(x -> length(x) == length(outcols[1]), outcols)
    return idx, DataFrame(outcols, nms, copycols=false), metacols
end

function reorder_cols!(trans_res::Vector{TransformationResult}, i::Integer,
                       col::AbstractVector, col_idx::Vector{Int}, keeprows::Bool,
                       idx_keeprows::Vector{Int}, gd::GroupedDataFrame)
    if keeprows && col_idx !== idx_keeprows # we need to reorder the column
        newcol = similar(col)
        # we can probably make it more efficient, but I leave it as an optimization for the future
        gd_idx = gd.idx
        k = 0
        for (s, e) in zip(gd.starts, gd.ends)
            for j in s:e
                k += 1
                @inbounds newcol[gd_idx[j]] = col[k]
            end
        end
        @assert k == length(gd_idx)
        trans_res[i] = TransformationResult(col_idx, newcol, trans_res[i].name,
                                            trans_res[i].optional, trans_res[i].metadatacol)
    end
end

function combine(@nospecialize(f::Base.Callable), gd::GroupedDataFrame;
                 keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
                 threads::Bool=true)
    if f isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a GroupedDataFrame"))
    end
    return combine(gd, f, keepkeys=keepkeys, ungroup=ungroup, renamecols=renamecols,
                   threads=threads)
end

combine(@nospecialize(f::Pair), gd::GroupedDataFrame;
        keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
        threads::Bool=true) =
    throw(ArgumentError("First argument must be a transformation if the second argument is a GroupedDataFrame. " *
                        "You can pass a `Pair` as the second argument of the transformation. If you want the return " *
                        "value to be processed as having multiple columns add `=> AsTable` suffix to the pair."))

combine(gd::GroupedDataFrame,
        @nospecialize(args::Union{Pair, Base.Callable, ColumnIndex, MultiColumnIndex,
                                  AbstractVecOrMat}...);
        keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
        threads::Bool=true) =
    _combine_prepare(gd, Ref{Any}(map(x -> broadcast_pair(parent(gd), x), args)),
                     keepkeys=keepkeys, ungroup=ungroup,
                     copycols=true, keeprows=false, renamecols=renamecols,
                     threads=threads)

function _dealias_dataframe!(df::DataFrame)
    seen_cols = IdDict{Any, Nothing}()
    for (i, col) in enumerate(eachcol(df))
        if !haskey(seen_cols, col)
            seen_cols[col] = nothing
        else
            df[!, i] = df[:, i]
        end
    end
end

function select(@nospecialize(f::Base.Callable), gd::GroupedDataFrame; copycols::Bool=true,
                keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
                threads::Bool=true)
    if f isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a grouped data frame"))
    end
    return select(gd, f, copycols=copycols, keepkeys=keepkeys, ungroup=ungroup,
                  threads=threads)
end

function select(gd::GroupedDataFrame, @nospecialize(args::Union{Pair, Base.Callable, ColumnIndex,
                                                                MultiColumnIndex, AbstractVecOrMat}...);
                copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
                threads::Bool=true)
    res = _combine_prepare(gd, Ref{Any}(map(x -> broadcast_pair(parent(gd), x), args)),
                           copycols=copycols, keepkeys=keepkeys,
                           ungroup=ungroup, keeprows=true, renamecols=renamecols,
                           threads=threads)
    # res can be a GroupedDataFrame based on DataFrame or a DataFrame,
    # so parent always gives a DataFrame
    copycols || _dealias_dataframe!(parent(res))
    return res
end

function transform(@nospecialize(f::Base.Callable), gd::GroupedDataFrame; copycols::Bool=true,
                   keepkeys::Bool=true, ungroup::Bool=true, renamecols::Bool=true,
                   threads::Bool=true)
    if f isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a grouped data frame"))
    end
    return transform(gd, f, copycols=copycols, keepkeys=keepkeys, ungroup=ungroup,
                     threads=threads)
end

function transform(gd::GroupedDataFrame, @nospecialize(args::Union{Pair, Base.Callable, ColumnIndex, MultiColumnIndex,
                                                                   AbstractVecOrMat}...);
                   copycols::Bool=true, keepkeys::Bool=true, ungroup::Bool=true,
                   renamecols::Bool=true,
                   threads::Bool=true)
    res = select(gd, :, args..., copycols=copycols, keepkeys=keepkeys,
                 ungroup=ungroup, renamecols=renamecols, threads=threads)
    # res can be a GroupedDataFrame based on DataFrame or a DataFrame,
    # so parent always gives a data frame
    select!(parent(res), propertynames(parent(gd)), :, threads=threads)
    return res
end

function select!(@nospecialize(f::Base.Callable), gd::GroupedDataFrame;
                 ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)
    if f isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a grouped data frame"))
    end
    return select!(gd, f, ungroup=ungroup, threads=threads)
end

function select!(gd::GroupedDataFrame,
                 @nospecialize(args::Union{Pair, Base.Callable, ColumnIndex, MultiColumnIndex,
                                           AbstractVecOrMat}...);
                 ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)
    df = parent(gd)
    if df isa DataFrame
        newdf = select(gd, args..., copycols=false, renamecols=renamecols,
                       threads=threads)
        _replace_columns!(df, newdf)
    else
        @assert df isa SubDataFrame
        newdf = select(gd, args..., copycols=true, renamecols=renamecols,
                       threads=threads)
        _replace_columns!(df, newdf, keep_present=false)
    end
    return ungroup ? df : gd
end

function transform!(@nospecialize(f::Base.Callable), gd::GroupedDataFrame;
                    ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)
    if f isa Colon
        throw(ArgumentError("First argument must be a transformation if the second argument is a grouped data frame"))
    end
    return transform!(gd, f, ungroup=ungroup)
end

function transform!(gd::GroupedDataFrame,
                    @nospecialize(args::Union{Pair, Base.Callable, ColumnIndex, MultiColumnIndex,
                                              AbstractVecOrMat}...);
                    ungroup::Bool=true, renamecols::Bool=true, threads::Bool=true)
    df = parent(gd)
    if df isa DataFrame
        newdf = select(gd, :, args..., copycols=false, renamecols=renamecols,
                       threads=threads)
        # need to recover column order of df in newdf and add new columns at the end
        select!(newdf, propertynames(df), :, threads=threads)
        _replace_columns!(df, newdf)
    else
        @assert df isa SubDataFrame
        newdf = select(gd, args..., copycols=true, renamecols=renamecols,
                       threads=threads)
        # here column order of df is retained due to keep_present=true
        _replace_columns!(df, newdf, keep_present=true)
    end
    return ungroup ? df : gd
end

Base.summary(df::AbstractDataFrame) =
    @sprintf("%d×%d %s", size(df)..., nameof(typeof(df)))
Base.summary(io::IO, df::AbstractDataFrame) = print(io, summary(df))

"""
    DataFrames.ourstrwidth(io::IO, x::Any, buffer::IOBuffer, truncstring::Int)

Determine the number of characters that would be used to print a value.
"""
function ourstrwidth(io::IO, x::Any, buffer::IOBuffer, truncstring::Int)
    truncate(buffer, 0)
    ourshow(IOContext(buffer, :compact=>get(io, :compact, true)), x, truncstring)
    return textwidth(String(take!(buffer)))
end

function truncatestring(s::AbstractString, truncstring::Int)
    truncstring <= 0 && return s
    totalwidth = 0
    for (i, c) in enumerate(s)
        totalwidth += textwidth(c)
        if totalwidth > truncstring
            return first(s, i-1) * '…'
        end
    end
    return s
end

"""
    DataFrames.ourshow(io::IO, x::Any, truncstring::Int)

Render a value to an `IO` object compactly using print.
`truncstring` indicates the approximate number of text characters width to truncate
the output (if it is a non-positive value then no truncation is applied).
"""
function ourshow(io::IO, x::Any, truncstring::Int; styled::Bool=false)
    io_ctx = IOContext(io, :compact=>get(io, :compact, true), :typeinfo=>typeof(x))
    sx = sprint(print, x, context=io_ctx)
    sx = escape_string(sx, ()) # do not escape "
    sx = truncatestring(sx, truncstring)
    styled ? printstyled(io_ctx, sx, color=:light_black) : print(io_ctx, sx)
end

const SHOW_TABULAR_TYPES = Union{AbstractDataFrame, DataFrameRow, DataFrameRows,
                                 DataFrameColumns, GroupedDataFrame}

# workaround Julia 1.0 for Char
ourshow(io::IO, x::Char, truncstring::Int; styled::Bool=false) =
    ourshow(io, string(x), styled=styled, truncstring)

ourshow(io::IO, x::Nothing, truncstring::Int; styled::Bool=false) =
    ourshow(io, "", styled=styled, truncstring)
ourshow(io::IO, x::SHOW_TABULAR_TYPES, truncstring::Int; styled::Bool=false) =
    ourshow(io, summary(x), truncstring, styled=styled)

function ourshow(io::IO, x::Markdown.MD, truncstring::Int)
    r = repr(x)
    truncstring <= 0 && return chomp(truncstring)
    len = min(length(r, 1, something(findfirst(==('\n'), r), lastindex(r)+1)-1), truncstring)
    return print(io, len < length(r) - 1 ? first(r, len)*'…' : first(r, len))
end

# For most data frames, especially wide, columns having the same element type
# occur multiple times. batch_compacttype ensures that we compute string
# representation of a specific column element type only once and then reuse it.

function batch_compacttype(types::Vector{Any}, maxwidths::Vector{Int})
    @assert length(types) == length(maxwidths)
    cache = Dict{Any, String}()
    return map(types, maxwidths) do T, maxwidth
        get!(cache, T) do
            compacttype(T, maxwidth)
        end
    end
end

function batch_compacttype(types::Vector{Any}, maxwidth::Int)
    cache = Dict{Type, String}()
    return map(types) do T
        get!(cache, T) do
            compacttype(T, maxwidth)
        end
    end
end

"""
    compacttype(T::Type, maxwidth::Int=8, initial::Bool=true)

Return compact string representation of type `T`.

For displaying data frame we do not want string representation of type to be
longer than `maxwidth`. This function implements rules how type names are
cropped if they are longer than `maxwidth`.
"""
function compacttype(T::Type, maxwidth::Int)
    maxwidth = max(8, maxwidth)

    T === Any && return "Any"
    T === Missing && return "Missing"

    sT = string(T)
    textwidth(sT) ≤ maxwidth && return sT

    if T >: Missing
        T = nonmissingtype(T)
        sT = string(T)
        suffix = "?"
        textwidth(sT) ≤ maxwidth && return sT * suffix
    else
        suffix = ""
    end

    maxwidth -= 1 # we will add "…" at the end

    # This is only type display shortening so we
    # are OK with any T whose name starts with CategoricalValue here
    if startswith(sT, "CategoricalValue") || startswith(sT, "CategoricalArrays.CategoricalValue")
        sT = string(nameof(T))
        if textwidth(sT) ≤ maxwidth
            return sT * "…" * suffix
        else
            return (maxwidth ≥ 11 ? "Categorical…" : "Cat…") * suffix
        end
    elseif T isa Union
        return "Union…" * suffix
    else
        sTfull = sT
        sT = string(nameof(T))
    end

    # handle the case when the type printed is not parametric but string(T)
    # prefixed it with the module name which caused it to be overlong
    textwidth(sT) ≤ maxwidth + 1 && endswith(sTfull, sT) && return sT * suffix

    cumwidth = 0
    stop = 0
    for (i, c) in enumerate(sT)
        cumwidth += textwidth(c)
        if cumwidth ≤ maxwidth
            stop = i
        else
            break
        end
    end
    return first(sT, stop) * "…" * suffix
end

@static if pkgversion(PrettyTables).major == 2
    # When PrettyTables v2 is more widely adopted in the ecosystem, we can remove this
    # function. In this case, we should also update the compat bounds in Project.toml to
    # list only PrettyTables v3.
    function _show(io::IO,
                   df::AbstractDataFrame;
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   eltypes::Bool = true,
                   rowid = nothing,
                   truncate::Int = 32,
                   kwargs...)

        _check_consistency(df)

        names_str = names(df)
        names_len = Int[textwidth(n) for n in names_str]
        maxwidth = Int[max(9, nl) for nl in names_len]
        types = Any[eltype(c) for c in eachcol(df)]
        types_str = batch_compacttype(types, maxwidth)

        if allcols && allrows
            crop = :none
        elseif allcols
            crop = :vertical
        elseif allrows
            crop = :horizontal
        else
            crop = :both
        end

        # For consistency, if `kwargs` has `compact_printng`, we must use it.
        compact_printing::Bool = get(kwargs, :compact_printing, get(io, :compact, true))

        num_rows, num_cols = size(df)

        # By default, we align the columns to the left unless they are numbers,
        # which is checked in the following.
        alignment = fill(:l, num_cols)

        # Create the dictionary with the anchor regex that is used to align the
        # floating points.
        alignment_anchor_regex = Dict{Int, Vector{Regex}}()

        # Regex to align real numbers.
        alignment_regex_real = [r"\."]

        # Regex for columns with complex numbers.
        #
        # Here we are matching `+` or `-` unless it is not at the beginning of the
        # string or an `e` precedes it.
        alignment_regex_complex = [r"(?<!^)(?<!e)[+-]"]

        # Make sure that `truncate` does not hide the type and the column name.
        maximum_columns_width = Int[truncate == 0 ? 0 : max(truncate + 1, l, textwidth(t))
                                    for (l, t) in zip(names_len, types_str)]

        # Apply configurations according to the column's type.
        for i = 1:num_cols
            type_i = nonmissingtype(types[i])

            if type_i <: Complex
                alignment_anchor_regex[i] = alignment_regex_complex
                alignment[i] = :r
            elseif type_i <: Real
                alignment_anchor_regex[i] = alignment_regex_real
                alignment[i] = :r
            elseif type_i <: Number
                alignment[i] = :r
            elseif type_i <: Base.UUID
                maximum_columns_width[i] = 36
            end
        end

        # Check if the user wants to display a summary about the DataFrame that is
        # being printed. This will be shown using the `title` option of
        # `pretty_table`.
        title = summary ? Base.summary(df) : ""

        # If `rowid` is not `nothing`, then we are printing a data row. In this
        # case, we will add this information using the row name column of
        # PrettyTables.jl. Otherwise, we can just use the row number column.
        if (rowid === nothing) || (ncol(df) == 0)
            show_row_number::Bool = get(kwargs, :show_row_number, true)
            row_labels = nothing

            # If the columns with row numbers is not shown, then we should not
            # display a vertical line after the first column.
            vlines = fill(1, show_row_number)
        else
            nrow(df) != 1 &&
                throw(ArgumentError("rowid may be passed only with a single row data frame"))

            # In this case, if the user does not want to show the row number, then
            # we must hide the row name column, which is used to display the
            # `rowid`.
            if !get(kwargs, :show_row_number, true)
                row_labels = nothing
                vlines = Int[]
            else
                row_labels = [string(rowid)]
                vlines = Int[1]
            end

            show_row_number = false
        end

        # Print the table with the selected options.
        pretty_table(io, df;
                     alignment                   = alignment,
                     alignment_anchor_fallback   = :r,
                     alignment_anchor_regex      = alignment_anchor_regex,
                     compact_printing            = compact_printing,
                     crop                        = crop,
                     ellipsis_line_skip          = 3,
                     formatters                  = (_pretty_tables_general_formatter,),
                     header                      = (names_str, types_str),
                     header_alignment            = :l,
                     hlines                      = [:header],
                     highlighters                = (_PRETTY_TABLES_HIGHLIGHTER,),
                     maximum_columns_width       = maximum_columns_width,
                     newline_at_end              = false,
                     reserved_display_lines      = 2,
                     row_label_alignment         = :r,
                     row_label_crayon            = Crayon(),
                     row_label_column_title      = string(rowlabel),
                     row_labels                  = row_labels,
                     row_number_alignment        = :r,
                     row_number_column_title     = string(rowlabel),
                     show_row_number             = show_row_number,
                     show_subheader              = eltypes,
                     title                       = title,
                     vcrop_mode                  = :middle,
                     vlines                      = vlines,
                     kwargs...)

        return nothing
    end
else
    function _show(io::IO,
                   df::AbstractDataFrame;
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   eltypes::Bool = true,
                   rowid = nothing,
                   show_row_number::Bool=true,
                   truncate::Int = 32,
                   kwargs...)

        _check_consistency(df)

        names_str = names(df)
        names_len = Int[textwidth(n) for n in names_str]
        maxwidth = Int[max(9, nl) for nl in names_len]
        types = Any[eltype(c) for c in eachcol(df)]
        types_str = batch_compacttype(types, maxwidth)

        fit_table_in_display_horizontally = !allcols
        fit_table_in_display_vertically = !allrows

        # For consistency, if `kwargs` has `compact_printng`, we must use it.
        compact_printing::Bool = get(kwargs, :compact_printing, get(io, :compact, true))

        num_rows, num_cols = size(df)

        # By default, we align the columns to the left unless they are numbers,
        # which is checked in the following.
        alignment = fill(:l, num_cols)

        # Create the dictionary with the anchor regex that is used to align the
        # floating points.
        alignment_anchor_regex = Pair{Int, Vector{Regex}}[]

        # Regex to align real numbers.
        alignment_regex_real = [r"\."]

        # Regex for columns with complex numbers.
        #
        # Here we are matching `+` or `-` unless it is not at the beginning of the
        # string or an `e` precedes it.
        alignment_regex_complex = [r"(?<!^)(?<!e)[+-]"]

        # Make sure that `truncate` does not hide the type and the column name.
        maximum_data_column_widths = Int[
            truncate == 0 ? 0 : max(truncate + 1, l, textwidth(t))
            for (l, t) in zip(names_len, types_str)
        ]

        # Apply configurations according to the column's type.
        for i = 1:num_cols
            type_i = nonmissingtype(types[i])

            if type_i <: Complex
                push!(alignment_anchor_regex, i => alignment_regex_complex)
                alignment[i] = :r
            elseif type_i <: Real
                push!(alignment_anchor_regex, i => alignment_regex_real)
                alignment[i] = :r
            elseif type_i <: Number
                alignment[i] = :r
            elseif type_i <: Base.UUID
                maximum_data_column_widths[i] = 36
            end
        end

        # Check if the user wants to display a summary about the DataFrame that is
        # being printed. This will be shown using the `title` option of
        # `pretty_table`.
        title = summary ? Base.summary(df) : ""

        # If `rowid` is not `nothing`, then we are printing a data row. In this
        # case, we will add this information using the row name column of
        # PrettyTables.jl.
        if (rowid === nothing) || (ncol(df) == 0)
            row_labels = 1:num_rows
        else
            nrow(df) != 1 &&
                throw(ArgumentError("rowid may be passed only with a single row data frame"))

            row_labels = [string(rowid)]
        end

        # Keep compatibility with the previous behavior of PrettyTables.jl if the user does not
        # want to show the row numbers.
        if !show_row_number
            row_labels = nothing
        end

        # Print the table with the selected options.
        pretty_table(io, df;
                     alignment                         = alignment,
                     alignment_anchor_fallback         = :r,
                     alignment_anchor_regex            = alignment_anchor_regex,
                     column_label_alignment            = :l,
                     column_labels                     = [names_str, types_str],
                     compact_printing                  = compact_printing,
                     continuation_row_alignment        = :c,
                     fit_table_in_display_horizontally = fit_table_in_display_horizontally,
                     fit_table_in_display_vertically   = fit_table_in_display_vertically,
                     formatters                        = _PRETTY_TABLES_TEXT_FORMATTER,
                     highlighters                      = _PRETTY_TABLES_TEXT_HIGHLIGHTER,
                     maximum_data_column_widths        = maximum_data_column_widths,
                     new_line_at_end                   = false,
                     reserved_display_lines            = 2,
                     row_label_column_alignment        = :r,
                     row_labels                        = row_labels,
                     show_first_column_label_only      = !eltypes,
                     show_row_number_column            = false,
                     stubhead_label                    = string(rowlabel),
                     style                             = _PRETTY_TABLES_TEXT_TABLE_STYLE,
                     table_format                      = _PRETTY_TABLES_TEXT_TABLE_FORMAT,
                     title                             = title,
                     title_alignment                   = :l,
                     vertical_crop_mode                = :middle,
                     kwargs...)

        return nothing
    end
end

"""
    show([io::IO, ]df::AbstractDataFrame;
         allrows::Bool = !get(io, :limit, false),
         allcols::Bool = !get(io, :limit, false),
         allgroups::Bool = !get(io, :limit, false),
         rowlabel::Symbol = :Row,
         summary::Bool = true,
         eltypes::Bool = true,
         truncate::Int = 32,
         kwargs...)

Render a data frame to an I/O stream. The specific visual
representation chosen depends on the width of the display.

If `io` is omitted, the result is printed to `stdout`,
and `allrows`, `allcols` and `allgroups` default to `false`.

# Arguments
- `io::IO`: The I/O stream to which `df` will be printed.
- `df::AbstractDataFrame`: The data frame to print.
- `allrows::Bool `: Whether to print all rows, rather than
  a subset that fits the device height. By default this is the case only if
  `io` does not have the `IOContext` property `limit` set.
- `allcols::Bool`: Whether to print all columns, rather than
  a subset that fits the device width. By default this is the case only if
  `io` does not have the `IOContext` property `limit` set.
- `allgroups::Bool`: Whether to print all groups rather than
  the first and last, when `df` is a `GroupedDataFrame`.
  By default this is the case only if `io` does not have the `IOContext` property
  `limit` set.
- `rowlabel::Symbol = :Row`: The label to use for the column containing row numbers.
- `summary::Bool = true`: Whether to print a brief string summary of the data frame.
- `eltypes::Bool = true`: Whether to print the column types under column names.
- `truncate::Int = 32`: the maximal display width the output can use before
  being truncated (in the `textwidth` sense, excluding `…`).
  If `truncate` is 0 or less, no truncation is applied.
- `kwargs...`: Any keyword argument supported by the function `pretty_table` of
  PrettyTables.jl can be passed here to customize the output.

# Examples
```jldoctest
julia> using DataFrames

julia> df = DataFrame(A=1:3, B=["x", "y", "z"]);

julia> show(df, row_labels=nothing)
3×2 DataFrame
 A      B
 Int64  String
───────────────
     1  x
     2  y
     3  z
```
"""
function Base.show(io::IO,
                   df::AbstractDataFrame;
                   allrows::Bool = !get(io, :limit, false),
                   allcols::Bool = !get(io, :limit, false),
                   rowlabel::Symbol = :Row,
                   summary::Bool = true,
                   eltypes::Bool = true,
                   truncate::Int = 32,
                   kwargs...)

    # Check for keywords that are valid in other backends but not here.
    _verify_kwargs_for_text(; kwargs...)

    _show(io, df; allrows=allrows, allcols=allcols, rowlabel=rowlabel,
          summary=summary, eltypes=eltypes, truncate=truncate, kwargs...)
end

Base.show(df::AbstractDataFrame;
          allrows::Bool = !get(stdout, :limit, true),
          allcols::Bool = !get(stdout, :limit, true),
          rowlabel::Symbol = :Row,
          summary::Bool = true,
          eltypes::Bool = true,
          truncate::Int = 32,
          kwargs...) =
    show(stdout, df;
         allrows=allrows, allcols=allcols, rowlabel=rowlabel, summary=summary,
         eltypes=eltypes, truncate=truncate, kwargs...)

# Internal function to verify the keywords in show functions using the text
# backend.
function _verify_kwargs_for_text(; kwargs...)
    haskey(kwargs, :max_column_width) &&
        throw(ArgumentError("`max_column_width` is not supported in text mode. " *
                            "Use `truncate` to limit the maximum number of characters in the columns."))
    return nothing
end

# Implementation note
# There are two important design features of GroupedDataFrame
# 1. idx, starts, ends and keymap are by default left uninitialized;
#    they get populated only on demand; this means that every GroupedDataFrame
#    has lazy_lock field which is used to make sure that two threads concurrently
#    do not try to create them. The lock should be used in every function that
#    does a direct access to these fields via getfield.
# 2. Except for point 1 above currently fields of GroupedDataFrame are never
#    mutated after it is created. This means that internally when copying
#    a GroupedDataFrame they are not copied for efficiency. If in the future
#    operations that mutate GroupedDataFrame are introduced all non-copying
#    passing of the internal fields to a new GroupedDataFrame should be
#    updated. Currently this applies to `getindex` and `combine_helper` functions

"""
    GroupedDataFrame

The result of a [`groupby`](@ref) operation on an `AbstractDataFrame`; a
view into the `AbstractDataFrame` grouped by rows.

Not meant to be constructed directly, see [`groupby`](@ref).

One can get the names of columns used to create `GroupedDataFrame`
using the [`groupcols`](@ref) function. Similarly the [`groupindices`](@ref)
function returns a vector of group indices for each row of the parent data frame.

After its creation, a `GroupedDataFrame` reflects the grouping of rows that was
valid at its creation time. Therefore
grouping columns of its parent data frame must not be mutated, and
rows must not be added nor removed from it.
To safeguard the user against such cases, if the number of rows in the parent
data frame changes then trying to use `GroupedDataFrame` will throw an error.
However, one can add or remove columns to the parent data frame without
invalidating the `GroupedDataFrame` provided that columns used for grouping are
not changed.
"""
mutable struct GroupedDataFrame{T<:AbstractDataFrame}
    parent::T
    cols::Vector{Symbol}                   # column names used for grouping
    groups::Vector{Int}                    # group indices for each row in 0:ngroups, 0 skipped
    idx::Union{Vector{Int}, Nothing}       # indexing vector sorting rows into groups
    starts::Union{Vector{Int}, Nothing}    # starts of groups after permutation by idx
    ends::Union{Vector{Int}, Nothing}      # ends of groups after permutation by idx
    ngroups::Int                           # number of groups
    keymap::Union{Dict{Any, Int}, Nothing} # mapping of key tuples to group indices
    lazy_lock::Threads.ReentrantLock       # lock is needed to make lazy operations
                                           # thread safe
end

"""
    groupby(df::AbstractDataFrame, cols;
            sort::Union{Bool, Nothing, NamedTuple}=nothing,
            skipmissing::Bool=false)

Return a `GroupedDataFrame` representing a view of an `AbstractDataFrame` split
into row groups.

# Arguments
- `df` : an `AbstractDataFrame` to split
- `cols` : data frame columns to group by. Can be any column selector
  ($COLUMNINDEX_STR; $MULTICOLUMNINDEX_STR). In particular if the selector
  picks no columns then a single-group `GroupedDataFrame` is created. As a
  special case, if `cols` is a single column or a vector of columns then
  it can contain columns wrapped in [`order`](@ref) that will be used to
  determine the order of groups if `sort` is `true` or a `NamedTuple` (if `sort`
  is `false`, then passing `order` is an error; if `sort` is `nothing`
  then it is set to `true` when `order` is passed).
- `sort` : if `sort=true` sort groups according to the values of the grouping
  columns `cols`; if `sort=false` groups are created in their order of
  appearance in `df`; if `sort=nothing` (the default) then the fastest available
  grouping algorithm is picked and in consequence the order of groups in the
  result is undefined and may change in future releases; below a description of
  the current implementation is provided. Additionally `sort` can be a
  `NamedTuple` having some or all of `alg`, `lt`, `by`, `rev`, and `order`
  fields. In this case the groups are sorted and their order follows the
  [`sortperm`](@ref) order.
- `skipmissing` : whether to skip groups with `missing` values in one of the
  grouping columns `cols`

# Details

An iterator over a `GroupedDataFrame` returns a `SubDataFrame` view
for each grouping into `df`.
Within each group, the order of rows in `df` is preserved.

A `GroupedDataFrame` also supports indexing by groups, `select`, `transform`,
and `combine` (which applies a function to each group and combines the result
into a data frame).

`GroupedDataFrame` also supports the dictionary interface. The keys are
[`GroupKey`](@ref) objects returned by [`keys(::GroupedDataFrame)`](@ref),
which can also be used to get the values of the grouping columns for each group.
`Tuples` and `NamedTuple`s containing the values of the grouping columns (in the
same order as the `cols` argument) are also accepted as indices. Finally,
an `AbstractDict` can be used to index into a grouped data frame where
the keys are column names of the data frame. The order of the keys does
not matter in this case.

In the current implementation if `sort=nothing` groups are ordered following the
order of appearance of values in the grouping columns, except when all grouping
columns provide non-`nothing` `DataAPI.refpool`, in which case the order of groups
follows the order of values returned by `DataAPI.refpool`. As a particular application
of this rule if all `cols` are `CategoricalVector`s then groups are always sorted.
Integer columns with a narrow range also use this this optimization, so to the
order of groups when grouping on integer columns is undefined.
A column is considered to be an integer column when deciding on the grouping
algorithm choice if its `eltype` is a subtype of `Union{Missing, Real}`,
all its elements are either `missing` or pass `isinteger` test,
and none of them is equal to `-0.0`.

# See also

[`combine`](@ref), [`select`](@ref), [`select!`](@ref), [`transform`](@ref),
[`transform!`](@ref)

# Examples
```jldoctest
julia> df = DataFrame(a=repeat([1, 2, 3, 4], outer=[2]),
                      b=repeat([2, 1], outer=[4]),
                      c=1:8);

julia> gd = groupby(df, :a)
GroupedDataFrame with 4 groups based on key: a
First Group (2 rows): a = 1
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      2      5
⋮
Last Group (2 rows): a = 4
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     4      1      4
   2 │     4      1      8

julia> gd[1]
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      2      5

julia> last(gd)
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     4      1      4
   2 │     4      1      8

julia> gd[(a=3,)]
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     3      2      3
   2 │     3      2      7

julia> gd[Dict("a" => 3)]
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     3      2      3
   2 │     3      2      7

julia> gd[(3,)]
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     3      2      3
   2 │     3      2      7

julia> k = first(keys(gd))
GroupKey: (a = 1,)

julia> gd[k]
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      2      5

julia> for g in gd
           println(g)
       end
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      1
   2 │     1      2      5
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      1      2
   2 │     2      1      6
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     3      2      3
   2 │     3      2      7
2×3 SubDataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     4      1      4
   2 │     4      1      8
```
"""
function groupby(df::AbstractDataFrame, cols;
                 sort::Union{Bool, Nothing, NamedTuple}=nothing,
                 skipmissing::Bool=false)
    _check_consistency(df)
    if cols isa UserColOrdering ||
       (cols isa AbstractVector && any(x -> x isa UserColOrdering, cols))
        if isnothing(sort) || sort === true
            # if sort === true replace it with NamedTuple to avoid sorting
            # in row_group_slots! as we will perform sorting later
            sort = NamedTuple()
        elseif sort === false
            throw(ArgumentError("passing `order` is only allowed if `sort` " *
                                "is `true`, `nothing`, or a `NamedTuple`"))
        end
        gcols = if cols isa UserColOrdering
                    cols.col
                else
                    Any[x isa UserColOrdering ? x.col : x for x in cols]
                end
    else
        gcols = cols
    end

    idxcols = index(df)[gcols]
    if isempty(idxcols)
        return GroupedDataFrame(df, Symbol[], ones(Int, nrow(df)),
                                nothing, nothing, nothing, nrow(df) == 0 ? 0 : 1,
                                nothing, Threads.ReentrantLock())
    end
    sdf = select(df, idxcols, copycols=false)

    groups = Vector{Int}(undef, nrow(df))
    ngroups, rhashes, gslots, sorted =
        row_group_slots!(ntuple(i -> sdf[!, i], ncol(sdf)), Val(false),
                         groups, skipmissing,
                         sort isa NamedTuple ? nothing : sort, true)

    gd = GroupedDataFrame(df, copy(_names(sdf)), groups, nothing, nothing, nothing,
                          ngroups, nothing, Threads.ReentrantLock())

    # sort groups if row_group_slots! hasn't already done that
    if (sort === true && !sorted) || (sort isa NamedTuple)
        # Find index of representative row for each group
        idx = Vector{Int}(undef, length(gd))
        fillfirst!(nothing, idx, 1:nrow(parent(gd)), gd)
        sort_kwargs = sort isa NamedTuple ? sort : NamedTuple()
        group_invperm = invperm(sortperm(view(parent(gd), idx, :),
                                         cols; sort_kwargs...))
        groups = gd.groups
        @inbounds for i in eachindex(groups)
            gix = groups[i]
            groups[i] = gix == 0 ? 0 : group_invperm[gix]
        end
    end

    return gd
end

function genkeymap(gd, cols)
    # currently we use Dict{Any, Int} because then field :keymap in GroupedDataFrame
    # has a concrete type which makes the access to it faster as we do not have a dynamic
    # dispatch when indexing into it. In the future an optimization of this approach
    # can be investigated (also taking compilation time into account).
    d = Dict{Any, Int}()
    gdidx = gd.idx
    sizehint!(d, length(gd.starts))
    for (i, s) in enumerate(gd.starts)
        d[getindex.(cols, gdidx[s])] = i
    end
    d
end

corrupt_msg(gd::GroupedDataFrame) =
    "The current number of rows in the parent data frame is " *
    "$(nrow(parent(gd))) and it does not match the number of " *
    "rows it contained when GroupedDataFrame was created which was " *
    "$(length(getfield(gd, :groups))). The number of rows in the parent " *
    "data frame has likely been changed unintentionally " *
    "(e.g. using subset!, filter!, deleteat!, push!, or append! functions)."

function Base.getproperty(gd::GroupedDataFrame, f::Symbol)
    @assert length(getfield(gd, :groups)) == nrow(getfield(gd, :parent)) corrupt_msg(gd)
    if f in (:idx, :starts, :ends)
        # Group indices are computed lazily the first time they are accessed
        # Do not lock when field is already initialized
        if getfield(gd, f) === nothing
            Threads.lock(gd.lazy_lock) do
                if getfield(gd, f) === nothing # Do not lock when field is already initialized
                    gd.idx, gd.starts, gd.ends = compute_indices(gd.groups, gd.ngroups)
                end
            end
        end
        return getfield(gd, f)::Vector{Int}
    elseif f === :keymap
        # Keymap is computed lazily the first time it is accessed
        if getfield(gd, f) === nothing # Do not lock when field is already initialized
            Threads.lock(gd.lazy_lock) do
                if getfield(gd, f) === nothing
                    gd.keymap = genkeymap(gd, ntuple(i -> parent(gd)[!, gd.cols[i]], length(gd.cols)))
                end
            end
        end
        return getfield(gd, f)::Dict{Any, Int}
    else
        return getfield(gd, f)
    end
end

Base.broadcastable(::GroupedDataFrame) =
    throw(ArgumentError("broadcasting over `GroupedDataFrame`s is reserved"))

"""
    parent(gd::GroupedDataFrame)

Return the parent data frame of `gd`.
"""
Base.parent(gd::GroupedDataFrame) = getfield(gd, :parent)

function Base.:(==)(gd1::GroupedDataFrame, gd2::GroupedDataFrame)
    gd1.cols == gd2.cols &&
        length(gd1) == length(gd2) &&
        all(x -> ==(x...), zip(gd1, gd2))
end

function Base.isequal(gd1::GroupedDataFrame, gd2::GroupedDataFrame)
    isequal(gd1.cols, gd2.cols) &&
        isequal(length(gd1), length(gd2)) &&
        all(x -> isequal(x...), zip(gd1, gd2))
end

Base.names(gd::GroupedDataFrame) = names(parent(gd))
Base.names(gd::GroupedDataFrame, cols) = names(parent(gd), cols)
_names(gd::GroupedDataFrame) = _names(parent(gd))

function DataFrame(gd::GroupedDataFrame; copycols::Bool=true, keepkeys::Bool=true)
    if !copycols
        throw(ArgumentError("It is not possible to construct a `DataFrame`" *
                            "from GroupedDataFrame with `copycols=false`"))
    end
    length(gd) == 0 && return similar(parent(gd), 0)
    gdidx = gd.idx
    idx = similar(gdidx)
    doff = 1
    for (s, e) in zip(gd.starts, gd.ends)
        n = e - s + 1
        copyto!(idx, doff, gdidx, s, n)
        doff += n
    end
    resize!(idx, doff - 1)
    if keepkeys
        return parent(gd)[idx, :]
    else
        return parent(gd)[idx, Not(gd.cols)]
    end
end


#
# Accessing group indices, columns, and values
#

"""
    groupindices(gd::GroupedDataFrame)

Return a vector of group indices for each row of `parent(gd)`.

Rows appearing in group `gd[i]` are attributed index `i`. Rows not present in
any group are attributed `missing` (this can happen if `skipmissing=true` was
passed when creating `gd`, or if `gd` is a subset from
a larger [`GroupedDataFrame`](@ref)).

The `groupindices => target_col_name` syntax (or just `groupindices` without
specifying the target column name) is also supported in the transformation
mini-language when passing a `GroupedDataFrame` to transformation functions
([`combine`](@ref), [`select`](@ref), etc.).

# Examples

```jldoctest
julia> df = DataFrame(id=["a", "c", "b", "b", "a"])
5×1 DataFrame
 Row │ id
     │ String
─────┼────────
   1 │ a
   2 │ c
   3 │ b
   4 │ b
   5 │ a

julia> gdf = groupby(df, :id);

julia> combine(gdf, groupindices)
3×2 DataFrame
 Row │ id      groupindices
     │ String  Int64
─────┼──────────────────────
   1 │ a                  1
   2 │ c                  2
   3 │ b                  3

julia> select(gdf, groupindices => :gid)
5×2 DataFrame
 Row │ id      gid
     │ String  Int64
─────┼───────────────
   1 │ a           1
   2 │ c           2
   3 │ b           3
   4 │ b           3
   5 │ a           1
```
"""
groupindices(gd::GroupedDataFrame) = replace(gd.groups, 0=>missing)
groupindices(args...) =
    throw(ArgumentError("groupindices only supports `GroupedDataFrame` as an argument. " *
                        "Additionally it can be used in transformation functions " *
                        "(combine, select, etc.) when processing a `GroupedDataFrame`, " *
                        "using the syntax `groupindices => target_col_name` or just `groupindices`"))

"""
    proprow

Compute the proportion of rows which belong to each group, i.e. its number of rows
divided by the total number of rows in a `GroupedDataFrame`.

This function can only be used in the transformation mini-language
via the `proprow => target_col_name` syntax (or just `proprow` without
specifying the target column name), when passing a `GroupedDataFrame`
to transformation functions ([`combine`](@ref), [`select`](@ref), etc.).

# Examples

```jldoctest
julia> df = DataFrame(id=["a", "c", "b", "b", "a", "b"])
6×1 DataFrame
 Row │ id
     │ String
─────┼────────
   1 │ a
   2 │ c
   3 │ b
   4 │ b
   5 │ a
   6 │ b

julia> gdf = groupby(df, :id);

julia> combine(gdf, proprow)
3×2 DataFrame
 Row │ id      proprow
     │ String  Float64
─────┼──────────────────
   1 │ a       0.333333
   2 │ c       0.166667
   3 │ b       0.5

julia> select(gdf, proprow => :frac)
6×2 DataFrame
 Row │ id      frac
     │ String  Float64
─────┼──────────────────
   1 │ a       0.333333
   2 │ c       0.166667
   3 │ b       0.5
   4 │ b       0.5
   5 │ a       0.333333
   6 │ b       0.5
```
"""
proprow(args...) =
    throw(ArgumentError("proprow can only be used in transformation functions " *
                        "(combine, select, etc.) when processing a `GroupedDataFrame`, " *
                        "using the syntax `proprow => target_col_name` or just `proprow`"))

"""
    groupcols(gd::GroupedDataFrame)

Return a vector of `Symbol` column names in `parent(gd)` used for grouping.
"""
function groupcols(gd::GroupedDataFrame)
    issubset(gd.cols, _names(parent(gd))) ||
        throw(ErrorException("grouping column names not found in data frame column names"))
    return copy(gd.cols)
end

"""
    valuecols(gd::GroupedDataFrame)

Return a vector of `Symbol` column names in `parent(gd)` not used for grouping.
"""
function valuecols(gd::GroupedDataFrame)
    issubset(gd.cols, _names(parent(gd))) || throw(ErrorException("grouping column " *
        "names not found in data frame column names"))
    return setdiff(_names(gd), gd.cols)
end


# Get grouping variable index by its name
function _groupvar_idx(gd::GroupedDataFrame, name::Symbol, strict::Bool)
    i = findfirst(==(name), gd.cols)
    i === nothing && strict && throw(ArgumentError("$name is not a grouping column"))
    return i
end

# Get values of grouping columns for single group
_groupvalues(gd::GroupedDataFrame, i::Integer) =
    gd.parent[gd.idx[gd.starts[i]], gd.cols]

# Get values of single grouping column for single group
_groupvalues(gd::GroupedDataFrame, i::Integer, col::Integer) =
    gd.parent[gd.idx[gd.starts[i]], gd.cols[col]]
_groupvalues(gd::GroupedDataFrame, i::Integer, col::Symbol) =
    _groupvalues(gd, i, _groupvar_idx(gd, col, true))


#
# Vector interface and integer indexing
#

Base.length(gd::GroupedDataFrame) = gd.ngroups

function Base.iterate(gd::GroupedDataFrame, i=1)
    if i > length(gd)
        return nothing
    else
        return (view(gd.parent, gd.idx[gd.starts[i]:gd.ends[i]], :), i+1)
    end
end

Base.size(gd::GroupedDataFrame) = (length(gd),)
Base.size(gd::GroupedDataFrame, i::Integer) = size(gd)[i]

Base.ndims(::GroupedDataFrame) = 1
Base.ndims(::Type{<:GroupedDataFrame}) = 1

Base.firstindex(gd::GroupedDataFrame) = 1
Base.lastindex(gd::GroupedDataFrame) = gd.ngroups

Base.axes(gd::GroupedDataFrame, i::Integer) = Base.OneTo(size(gd, i))

Base.first(gd::GroupedDataFrame) = gd[1]
function Base.first(gd::GroupedDataFrame, n::Integer)
    n < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    return gd[1:min(n, end)]
end

Base.last(gd::GroupedDataFrame) = gd[end]
function Base.last(gd::GroupedDataFrame, n::Integer)
    n < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    return gd[max(1, end - n + 1):end]
end
# These have to be defined for some to_indices() logic to work, as long
# as GroupedDataFrame is not <: AbstractArray
Base.IndexStyle(::Type{<:GroupedDataFrame}) = IndexLinear()
Base.IndexStyle(::GroupedDataFrame) = IndexLinear()
Base.keys(::IndexLinear, gd::GroupedDataFrame) = Base.OneTo(length(gd))

# Single integer indexing
Base.getindex(gd::GroupedDataFrame, idx::Integer) =
    view(gd.parent, gd.idx[gd.starts[idx]:gd.ends[idx]], :)

# Index with array of integers OR bools
function Base.getindex(gd::GroupedDataFrame, idxs::AbstractVector{<:Integer})
    new_starts = gd.starts[idxs]
    new_ends = gd.ends[idxs]
    if !allunique(new_starts)
        throw(ArgumentError("duplicates in idxs argument are not allowed"))
    end
    new_groups = zeros(Int, length(gd.groups))
    idx = gd.idx
    for i in eachindex(new_starts)
        @inbounds for j in new_starts[i]:new_ends[i]
            new_groups[idx[j]] = i
        end
    end
    GroupedDataFrame(gd.parent, copy(gd.cols), new_groups, gd.idx,
                     new_starts, new_ends, length(new_starts), nothing,
                     Threads.ReentrantLock())
end

# Index with colon (creates copy)
Base.getindex(gd::GroupedDataFrame, idxs::Colon) =
    Threads.lock(gd.lazy_lock) do
        return GroupedDataFrame(gd.parent, copy(gd.cols), gd.groups, getfield(gd, :idx),
                                getfield(gd, :starts), getfield(gd, :ends), gd.ngroups,
                                getfield(gd, :keymap), Threads.ReentrantLock())
    end


#
# GroupKey and GroupKeys
#

"""
    GroupKey{T<:GroupedDataFrame}

Key for one of the groups of a [`GroupedDataFrame`](@ref). Contains the values
of the corresponding grouping columns and behaves similarly to a `NamedTuple`,
but using it to index its `GroupedDataFrame` is more efficient than using the
equivalent `Tuple` and `NamedTuple`, and much more efficient than using
the equivalent `AbstractDict`.

Instances of this type are returned by `keys(::GroupedDataFrame)` and are not
meant to be constructed directly.

Indexing fields of `GroupKey` is allowed using an integer, a `Symbol`, or a string.
It is also possible to access the data in a `GroupKey` using the `getproperty`
function. A `GroupKey` can be converted to a `Tuple`, `NamedTuple`, a `Vector`, or
a `Dict`. When converted to a `Dict`, the keys of the `Dict` are `Symbol`s.

See [`keys(::GroupedDataFrame)`](@ref) for more information.
"""
struct GroupKey{T<:GroupedDataFrame}
    parent::T
    idx::Int
end

function Base.show(io::IO, k::GroupKey)
    print(io, "GroupKey: ")
    show(io, NamedTuple(k))
end

Base.parent(key::GroupKey) = getfield(key, :parent)
Base.length(key::GroupKey) = length(parent(key).cols)

Base.size(key::GroupKey) = (length(key),)
Base.size(key::GroupKey, i::Integer) = size(key)[i]

Base.ndims(::GroupKey) = 1
Base.ndims(::Type{<:GroupKey}) = 1

Base.firstindex(key::GroupKey) = 1
Base.lastindex(key::GroupKey) = length(key)

Base.axes(key::GroupKey, i::Integer) = Base.OneTo(size(key, i))

Base.names(key::GroupKey) = string.(parent(key).cols)
# Private fields are never exposed since they can conflict with column names
Base.propertynames(key::GroupKey, private::Bool=false) = copy(parent(key).cols)
Base.keys(key::GroupKey) = propertynames(key)
# a generic fallback for values not handled explicitly
Base.haskey(::GroupKey, key::Any) =
    throw(ArgumentError("invalid key: $key of type $(typeof(key))"))
Base.haskey(key::GroupKey, idx::Symbol) = idx in parent(key).cols
Base.haskey(key::GroupKey, idx::AbstractString) = haskey(key, Symbol(idx))
Base.haskey(key::GroupKey, idx::Union{Signed, Unsigned}) = 1 <= idx <= length(key)
Base.values(key::GroupKey) = Tuple(_groupvalues(parent(key), getfield(key, :idx)))
Base.IteratorEltype(::Type{<:GroupKey}) = Base.EltypeUnknown()
Base.iterate(key::GroupKey, i::Integer=1) =
    i <= length(key) ? (key[i], i + 1) : nothing
Base.getindex(key::GroupKey, i::Integer) =
    _groupvalues(parent(key), getfield(key, :idx), i)

function Base.getindex(key::GroupKey, n::Symbol)
    try
        return _groupvalues(parent(key), getfield(key, :idx), n)
    catch e
        throw(KeyError(n))
    end
end

Base.getindex(key::GroupKey, n::AbstractString) = key[Symbol(n)]

function Base.getproperty(key::GroupKey, p::Symbol)
    try
        return key[p]
    catch e
        throw(ArgumentError("$(typeof(key)) has no property $p"))
    end
end

Base.getproperty(key::GroupKey, p::AbstractString) = getproperty(key, Symbol(p))

Base.hash(key::GroupKey, h::UInt) = _nt_like_hash(key, h)

for eqfun in (:isequal, :(==)),
    (leftarg, rightarg) in ((:GroupKey, :GroupKey),
                            (:DataFrameRow, :GroupKey),
                            (:GroupKey, :DataFrameRow),
                            (:NamedTuple, :GroupKey),
                            (:GroupKey, :NamedTuple))
    @eval function Base.$eqfun(k1::$leftarg, k2::$rightarg)
        _equal_names(k1, k2) || return false
        return all(((a, b),) -> $eqfun(a, b), zip(k1, k2))
    end
end

for (eqfun, cmpfun) in ((:isequal, :isless), (:(==), :(<))),
    (leftarg, rightarg) in ((:GroupKey, :GroupKey),
                            (:DataFrameRow, :GroupKey),
                            (:GroupKey, :DataFrameRow),
                            (:NamedTuple, :GroupKey),
                            (:GroupKey, :NamedTuple))
    @eval function Base.$cmpfun(k1::$leftarg, k2::$rightarg)
        if !_equal_names(k1, k2)
            length(k1) == length(k2) ||
                throw(ArgumentError("compared objects must have the same number " *
                                    "of columns (got $(length(k1)) and $(length(k2)))"))
            mismatch = findfirst(i -> _getnames(k1)[i] != _getnames(k2)[i], 1:length(k1))
            throw(ArgumentError("compared objects must have the same column " *
                                "names but they differ in column number $mismatch " *
                                "where the names are :$(_getnames(k1)[mismatch]) and " *
                                ":$(_getnames(k2)[mismatch]) respectively"))
        end
        for (a, b) in zip(k1, k2)
            eq = $eqfun(a, b)
            if ismissing(eq)
                return missing
            elseif !eq
                return $cmpfun(a, b)
            end
        end
        return false # here we know that r1 and r2 have equal lengths and all values were equal
    end
end

function Base.NamedTuple(key::GroupKey)
    N = NamedTuple{Tuple(parent(key).cols)}
    N(_groupvalues(parent(key), getfield(key, :idx)))
end

"""
    copy(key::GroupKey)

Construct a `NamedTuple` with the same contents as the [`GroupKey`](@ref).
"""
Base.copy(key::GroupKey) = NamedTuple(key)

Base.convert(::Type{NamedTuple}, key::GroupKey) = NamedTuple(key)

Base.Vector(key::GroupKey) = [v for v in key]
Base.Vector{T}(key::GroupKey) where T = T[v for v in key]

Base.Array(key::GroupKey) = Vector(key)
Base.Array{T}(key::GroupKey) where {T} = Vector{T}(key)

Base.Dict(key::GroupKey) = Dict(pairs(key)...)

Base.broadcastable(::GroupKey) =
    throw(ArgumentError("broadcasting over `GroupKey`s is reserved"))

"""
    GroupKeys{T<:GroupedDataFrame} <: AbstractVector{GroupKey{T}}

A vector containing all [`GroupKey`](@ref) objects for a given
[`GroupedDataFrame`](@ref).

See [`keys(::GroupedDataFrame)`](@ref) for more information.
"""
struct GroupKeys{T<:GroupedDataFrame} <: AbstractVector{GroupKey{T}}
    parent::T
end

Base.parent(gk::GroupKeys) = gk.parent

Base.size(gk::GroupKeys) = (length(parent(gk)),)
Base.IndexStyle(::Type{<:GroupKeys}) = IndexLinear()
@Base.propagate_inbounds function Base.getindex(gk::GroupKeys, i::Integer)
    @boundscheck checkbounds(gk, i)
    return GroupKey(parent(gk), i)
end

#
# Non-standard indexing
#

# Non-standard indexing relies on converting to integer indices first
# The full version (to_indices) is required rather than to_index even though
# GroupedDataFrame behaves as a 1D array due to the behavior of Not.
# Note that this behavior would be the default if it was <:AbstractArray
function Base.getindex(gd::GroupedDataFrame, idx...)
    length(idx) == 1 || throw(ArgumentError("GroupedDataFrame requires a single index"))
    return getindex(gd, Base.to_indices(gd, idx)...)
end

# The allowed key types for dictionary-like indexing
const GroupKeyTypes = Union{GroupKey, Tuple, NamedTuple, AbstractDict{Symbol}, AbstractDict{<:AbstractString}}
# All allowed scalar index types
const GroupIndexTypes = Union{Integer, GroupKeyTypes}

# GroupedDataFrame is not a multidimensional array, so it does not support cartesian indexing
Base.to_indices(gd::GroupedDataFrame, (idx,)::Tuple{CartesianIndex}) =
    throw(ArgumentError("Invalid index: $idx of type $(typeof(idx))"))

# Find integer index for dictionary keys
function Base.to_index(gd::GroupedDataFrame, key::GroupKey)
    gd === parent(key) && return getfield(key, :idx)
    throw(ErrorException("Cannot use a GroupKey to index a GroupedDataFrame " *
                         "other than the one it was derived from."))
end

Base.to_index(gd::GroupedDataFrame, key::Tuple) = gd.keymap[key]

function Base.to_index(gd::GroupedDataFrame, key::NamedTuple{N}) where {N}
    if length(key) != length(gd.cols) || any(n != c for (n, c) in zip(N, gd.cols))
        throw(KeyError(key))
    end
    return Base.to_index(gd, Tuple(key))
end

function _dict_to_tuple(key::AbstractDict{<:AbstractString}, gd::GroupedDataFrame)
    if length(key) != length(gd.cols)
        throw(KeyError(key))
    end

    return ntuple(i -> key[String(gd.cols[i])], length(gd.cols))
end

function _dict_to_tuple(key::AbstractDict{Symbol}, gd::GroupedDataFrame)
    if length(key) != length(gd.cols)
        throw(KeyError(key))
    end

    return ntuple(i -> key[gd.cols[i]], length(gd.cols))
end

Base.to_index(gd::GroupedDataFrame, key::Union{AbstractDict{Symbol}, AbstractDict{<:AbstractString}}) =
    Base.to_index(gd, _dict_to_tuple(key, gd))

# Array of (possibly non-standard) indices
function Base.to_index(gd::GroupedDataFrame, idxs::AbstractVector{T}) where {T}
    # A concrete eltype which is <: GroupKeyTypes, don't need to check
    if isconcretetype(T) && T <: GroupKeyTypes
        return [Base.to_index(gd, i) for i in idxs]
    end

    # Edge case - array is empty
    isempty(idxs) && return Int[]

    # Infer eltype based on type of first index, expect rest to match
    idx1 = idxs[1]
    E1 = typeof(idx1)

    E = if E1 <: Integer && E1 !== Bool
        Integer
    elseif E1 <: GroupKey
        GroupKey
    elseif E1 <: Tuple
        Tuple
    elseif E1 <: NamedTuple
        NamedTuple
    elseif E1 <: AbstractDict{Symbol}
        AbstractDict{Symbol}
    elseif E1 <: AbstractDict{<:AbstractString}
        AbstractDict{<:AbstractString}
    else
        throw(ArgumentError("Invalid index: $idx1 of type $E1"))
    end

    # Convert each index to integer format
    ints = Vector{Int}(undef, length(idxs))
    for (i, idx) in enumerate(idxs)
        if !(idx isa GroupIndexTypes) || idx isa Bool
            throw(ArgumentError("Invalid index: $idx of type $(typeof(idx))"))
        end
        idx isa E || throw(ArgumentError("Mixed index types in array not allowed"))
        ints[i] = Base.to_index(gd, idx)
    end

    return ints
end


#
# Indexing with Not/InvertedIndex
#

# InvertedIndex wrapping any other valid index type
# to_indices() is needed here rather than to_index() in order to override the
# to_indices(::Any, ::Tuple{Not}) methods defined in InvertedIndices.jl
function Base.to_indices(gd::GroupedDataFrame, (idx,)::Tuple{<:Not})
    (skip_idx,) = Base.to_indices(gd, (idx.skip,))
    idxs = Base.OneTo(length(gd))[Not(skip_idx)]
    return (idxs,)
end

# InvertedIndex wrapping a boolean array
# The definition above works but we need to define specialized methods to avoid
# ambiguity in dispatch
function Base.to_indices(gd::GroupedDataFrame,
                         (idx,)::Tuple{Not{<:Union{BitArray{1}, Vector{Bool}}}})
    if length(idx.skip) != length(gd)
        throw(BoundsError("attempt to index $(length(gd))-group GroupedDataFrame " *
                          "with $(length(idx.skip))-element Boolean vector"))
    end
    return (findall(!, idx.skip),)
end
function Base.to_indices(gd::GroupedDataFrame,
                         (idx,)::Tuple{Not{<:AbstractVector{Bool}}})
    if length(idx.skip) != length(gd)
        throw(BoundsError("attempt to index $(length(gd))-group GroupedDataFrame " *
                          "with $(length(idx.skip))-element Boolean vector"))
    end
    return (findall(!, idx.skip),)
end

# Needed to avoid ambiguity
@inline Base.to_indices(gd::GroupedDataFrame, I::Tuple{Not{<:InvertedIndices.NIdx{1}}}) =
    throw(ArgumentError("attempt to index GroupedDataFrame with $(typeof(I))"))

@inline Base.to_indices(gd::GroupedDataFrame, I::Tuple{Not{<:InvertedIndices.NIdx}}) =
    throw(ArgumentError("attempt to index GroupedDataFrame with $(typeof(I))"))

@inline Base.to_indices(gd::GroupedDataFrame, I::Tuple{Not{<:Union{Array{Bool}, BitArray}}}) =
    throw(ArgumentError("attempt to index GroupedDataFrame with $(typeof(I))"))

#
# Dictionary interface
#

"""
    keys(gd::GroupedDataFrame)

Get the set of keys for each group of the `GroupedDataFrame` `gd` as a
[`GroupKeys`](@ref) object. Each key is a [`GroupKey`](@ref), which behaves like
a `NamedTuple` holding the values of the grouping columns for a given group.
Unlike the equivalent `Tuple`, `NamedTuple`, and `AbstractDict`, these keys can be used to index
into `gd` efficiently. The ordering of the keys is identical to the ordering of
the groups of `gd` under iteration and integer indexing.

# Examples

```jldoctest groupkeys
julia> df = DataFrame(a=repeat([:foo, :bar, :baz], outer=[4]),
                      b=repeat([2, 1], outer=[6]),
                      c=1:12);

julia> gd = groupby(df, [:a, :b])
GroupedDataFrame with 6 groups based on keys: a, b
First Group (2 rows): a = :foo, b = 2
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ foo         2      1
   2 │ foo         2      7
⋮
Last Group (2 rows): a = :baz, b = 1
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ baz         1      6
   2 │ baz         1     12

julia> keys(gd)
6-element DataFrames.GroupKeys{GroupedDataFrame{DataFrame}}:
 GroupKey: (a = :foo, b = 2)
 GroupKey: (a = :bar, b = 1)
 GroupKey: (a = :baz, b = 2)
 GroupKey: (a = :foo, b = 1)
 GroupKey: (a = :bar, b = 2)
 GroupKey: (a = :baz, b = 1)

julia> k = keys(gd)[1]
GroupKey: (a = :foo, b = 2)

julia> keys(k)
2-element Vector{Symbol}:
 :a
 :b

julia> values(k)  # Same as Tuple(k)
(:foo, 2)

julia> NamedTuple(k)
(a = :foo, b = 2)

julia> k.a
:foo

julia> k[:a]
:foo

julia> k[1]
:foo
```

Keys can be used as indices to retrieve the corresponding group from their
`GroupedDataFrame`:

```jldoctest groupkeys
julia> gd[k]
2×3 SubDataFrame
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ foo         2      1
   2 │ foo         2      7

julia> gd[keys(gd)[1]] == gd[1]
true
```
"""
Base.keys(gd::GroupedDataFrame) = GroupKeys(gd)

Base.in(key::Union{GroupKeyTypes, Signed, Unsigned}, gk::GroupKeys) =
    haskey(parent(gk), key)

# a generic fallback for values not handled explicitly
Base.haskey(::GroupedDataFrame, key::Any) =
    throw(ArgumentError("invalid key: $key of type $(typeof(key))"))

function Base.haskey(gd::GroupedDataFrame, key::GroupKey)
    if gd === parent(key)
        if 1 <= getfield(key, :idx) <= length(gd)
            return true
        else
            throw(BoundsError(gd, getfield(key, :idx)))
        end
    else
        msg = "The parent of key does not match the passed GroupedDataFrame"
        throw(ArgumentError(msg))
    end
end

function Base.haskey(gd::GroupedDataFrame, key::Tuple)
    if length(key) != length(gd.cols)
        return throw(ArgumentError("The length of key does not match the " *
                                   "number of grouping columns"))
    end
    return haskey(gd.keymap, key)
end

function Base.haskey(gd::GroupedDataFrame, key::NamedTuple{N}) where {N}
    if length(key) != length(gd.cols) || any(((n, c),) -> n != c, zip(N, gd.cols))
        return throw(ArgumentError("The column names of key do not match " *
                                   "the names of grouping columns"))
    end
    return haskey(gd, Tuple(key))
end

Base.haskey(gd::GroupedDataFrame, key::AbstractDict{<:Union{Symbol, <:AbstractString}}) =
    haskey(gd, _dict_to_tuple(key, gd))

Base.haskey(gd::GroupedDataFrame, key::Union{Signed, Unsigned}) =
    1 <= key <= length(gd)

"""
    get(gd::GroupedDataFrame, key, default)

Get a group based on the values of the grouping columns.

`key` may be a `GroupKey`, `NamedTuple` or `Tuple` of grouping column values (in the same
order as the `cols` argument to `groupby`). It may also be an `AbstractDict`, in which case the
order of the arguments does not matter.

# Examples

```jldoctest
julia> df = DataFrame(a=repeat([:foo, :bar, :baz], outer=[2]),
                      b=repeat([2, 1], outer=[3]),
                      c=1:6);

julia> gd = groupby(df, :a)
GroupedDataFrame with 3 groups based on key: a
First Group (2 rows): a = :foo
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ foo         2      1
   2 │ foo         1      4
⋮
Last Group (2 rows): a = :baz
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ baz         2      3
   2 │ baz         1      6

julia> get(gd, (a=:bar,), nothing)
2×3 SubDataFrame
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ bar         1      2
   2 │ bar         2      5

julia> get(gd, (:baz,), nothing)
2×3 SubDataFrame
 Row │ a       b      c
     │ Symbol  Int64  Int64
─────┼──────────────────────
   1 │ baz         2      3
   2 │ baz         1      6

julia> get(gd, (:qux,), nothing)
```
"""
function Base.get(gd::GroupedDataFrame, key::GroupKeyTypes, default)
    try
        return gd[key]
    catch KeyError
        return default
    end
end

"""
    filter(fun, gdf::GroupedDataFrame; ungroup::Bool=false)
    filter(cols => fun, gdf::GroupedDataFrame; ungroup::Bool=false)

Return only groups in `gd` for which `fun` returns `true` as a
`GroupedDataFrame` if `ungroup=false` (the default), or as a data frame if
`ungroup=true`.

If `cols` is not specified then the predicate `fun` is called with a
`SubDataFrame` for each group.

If `cols` is specified then the predicate `fun` is called for each group with
views of the corresponding columns as separate positional arguments, unless
`cols` is an `AsTable` selector, in which case a `NamedTuple` of these arguments
is passed. `cols` can be any column selector ($COLUMNINDEX_STR;
$MULTICOLUMNINDEX_STR), and column duplicates are allowed if a vector of
`Symbol`s, strings, or integers is passed.

!!! note

    This method is defined so that DataFrames.jl implements the Julia API for
    collections, but it is generally recommended to use the [`subset`](@ref)
    function instead as it is consistent with other DataFrames.jl functions
    (as opposed to `filter`).

# Examples
```jldoctest
julia> df = DataFrame(g=[1, 2], x=['a', 'b']);

julia> gd = groupby(df, :g)
GroupedDataFrame with 2 groups based on key: g
First Group (1 row): g = 1
 Row │ g      x
     │ Int64  Char
─────┼─────────────
   1 │     1  a
⋮
Last Group (1 row): g = 2
 Row │ g      x
     │ Int64  Char
─────┼─────────────
   1 │     2  b

julia> filter(x -> x.x[1] == 'a', gd)
GroupedDataFrame with 1 group based on key: g
First Group (1 row): g = 1
 Row │ g      x
     │ Int64  Char
─────┼─────────────
   1 │     1  a

julia> filter(:x => x -> x[1] == 'a', gd)
GroupedDataFrame with 1 group based on key: g
First Group (1 row): g = 1
 Row │ g      x
     │ Int64  Char
─────┼─────────────
   1 │     1  a

julia> filter(:x => x -> x[1] == 'a', gd, ungroup=true)
1×2 DataFrame
 Row │ g      x
     │ Int64  Char
─────┼─────────────
   1 │     1  a
```
"""
@inline function Base.filter(f, gdf::GroupedDataFrame; ungroup::Bool=false)
    res = gdf[[f(sdf)::Bool for sdf in gdf]]
    return ungroup ? DataFrame(res) : res
end

@inline function Base.filter((col, f)::Pair{<:ColumnIndex}, gdf::GroupedDataFrame;
                             ungroup::Bool=false)
    res::typeof(gdf) = _filter_helper_gdf(gdf, f, gdf.idx, gdf.starts, gdf.ends,
                                          parent(gdf)[!, col])
    return ungroup ? DataFrame(res) : res
end

@inline function Base.filter((cols, f)::Pair{<:AbstractVector{Symbol}}, gdf::GroupedDataFrame;
                             ungroup::Bool=false)
    res = filter([index(parent(gdf))[col] for col in cols] => f, gdf)
    return ungroup ? DataFrame(res) : res
end

@inline function Base.filter((cols, f)::Pair{<:AbstractVector{<:AbstractString}},
                             gdf::GroupedDataFrame; ungroup::Bool=false)
    res = filter([index(parent(gdf))[col] for col in cols] => f, gdf)
    return ungroup ? DataFrame(res) : res
end

@inline function Base.filter((cols, f)::Pair, gdf::GroupedDataFrame;
                             ungroup::Bool=false)
    res = filter(index(parent(gdf))[cols] => f, gdf)
    return ungroup ? DataFrame(res) : res
end

@inline function Base.filter((cols, f)::Pair{<:AbstractVector{Int}}, gdf::GroupedDataFrame;
                             ungroup::Bool=false)
    res::typeof(gdf) = _filter_helper_gdf(gdf, f, gdf.idx, gdf.starts, gdf.ends,
                                          (parent(gdf)[!, i] for i in cols)...)
    return ungroup ? DataFrame(res) : res
end

function _filter_helper_gdf(gdf::GroupedDataFrame, f, idx::Vector{Int},
                            starts::Vector{Int}, ends::Vector{Int}, cols...)
    function mapper(i::Integer)
        idxs = idx[starts[i]:ends[i]]
        return map(x -> view(x, idxs), cols)
    end

    if length(cols) == 0
        throw(ArgumentError("At least one column must be passed to filter on"))
    end
    sel = [f(mapper(i)...)::Bool for i in 1:length(gdf)]
    return gdf[sel]
end

@inline function Base.filter((cols, f)::Pair{<:AsTable}, gdf::GroupedDataFrame;
                             ungroup::Bool=false)
    cols = index(parent(gdf))[cols.cols]
    df_tmp = select(parent(gdf), cols, copycols=false)
    if ncol(df_tmp) == 0
        throw(ArgumentError("At least one column must be passed to filter on"))
    end
    res::typeof(gdf) = _filter_helper_gdf_astable(gdf, Tables.columntable(df_tmp), f,
                                                  gdf.idx, gdf.starts, gdf.ends)
    return ungroup ? DataFrame(res) : res
end

function _filter_helper_gdf_astable(gdf::GroupedDataFrame, nt::NamedTuple, f,
                                    idx::Vector{Int}, starts::Vector{Int},
                                    ends::Vector{Int})
    function mapper(i::Integer)
        idxs = idx[starts[i]:ends[i]]
        return map(x -> view(x, idxs), nt)
    end

    return gdf[[f(mapper(i))::Bool for i in 1:length(gdf)]]
end

Base.map(f, gdf::GroupedDataFrame) =
    throw(ArgumentError("using map over `GroupedDataFrame`s is reserved"))

abstract type AbstractAggregate end

struct Reduce{O, C, A} <: AbstractAggregate
    op::O
    condf::C
    adjust::A
    checkempty::Bool
end
Reduce(f, condf=nothing, adjust=nothing) = Reduce(f, condf, adjust, false)

check_aggregate(f::Any, ::AbstractVector) = f
check_aggregate(f::typeof(sum), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.add_sum)
check_aggregate(f::typeof(sum∘skipmissing), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.add_sum, !ismissing)
check_aggregate(f::typeof(prod), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.mul_prod)
check_aggregate(f::typeof(prod∘skipmissing), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.mul_prod, !ismissing)
check_aggregate(f::typeof(maximum), ::AbstractVector{<:Union{Missing, Real}}) =
    Reduce(max)
check_aggregate(f::typeof(maximum∘skipmissing), ::AbstractVector{<:Union{Missing, Real}}) =
    Reduce(max, !ismissing, nothing, true)
check_aggregate(f::typeof(minimum), ::AbstractVector{<:Union{Missing, Real}}) =
    Reduce(min)
check_aggregate(f::typeof(minimum∘skipmissing), ::AbstractVector{<:Union{Missing, Real}}) =
    Reduce(min, !ismissing, nothing, true)
check_aggregate(f::typeof(mean), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.add_sum, nothing, /)
check_aggregate(f::typeof(mean∘skipmissing), ::AbstractVector{<:Union{Missing, Number}}) =
    Reduce(Base.add_sum, !ismissing, /)

# Other aggregate functions which are not strictly reductions
struct Aggregate{F, C} <: AbstractAggregate
    f::F
    condf::C
end
Aggregate(f) = Aggregate(f, nothing)

check_aggregate(f::typeof(var), ::AbstractVector{<:Union{Missing, Number}}) =
    Aggregate(var)
check_aggregate(f::typeof(var∘skipmissing), ::AbstractVector{<:Union{Missing, Number}}) =
    Aggregate(var, !ismissing)
check_aggregate(f::typeof(std), ::AbstractVector{<:Union{Missing, Number}}) =
    Aggregate(std)
check_aggregate(f::typeof(std∘skipmissing), ::AbstractVector{<:Union{Missing, Number}}) =
    Aggregate(std, !ismissing)
check_aggregate(f::typeof(first), v::AbstractVector) =
    eltype(v) === Any ? f : Aggregate(first)
check_aggregate(f::typeof(first),
                ::AbstractVector{<:Union{Missing, MULTI_COLS_TYPE, AbstractVector}}) = f
check_aggregate(f::typeof(first∘skipmissing), v::AbstractVector) =
    eltype(v) === Any ? f : Aggregate(first, !ismissing)
check_aggregate(f::typeof(first∘skipmissing),
                ::AbstractVector{<:Union{Missing, MULTI_COLS_TYPE, AbstractVector}}) = f
check_aggregate(f::typeof(last), v::AbstractVector) =
    eltype(v) === Any ? f : Aggregate(last)
check_aggregate(f::typeof(last),
                ::AbstractVector{<:Union{Missing, MULTI_COLS_TYPE, AbstractVector}}) = f
check_aggregate(f::typeof(last∘skipmissing), v::AbstractVector) =
    eltype(v) === Any ? f : Aggregate(last, !ismissing)
check_aggregate(f::typeof(last∘skipmissing),
                ::AbstractVector{<:Union{Missing, MULTI_COLS_TYPE, AbstractVector}}) = f
check_aggregate(f::typeof(length), ::AbstractVector) = Aggregate(length)

# SkipMissing does not support length

# Use a strategy similar to reducedim_init from Base to get the vector of the right type
function groupreduce_init(op, condf, adjust,
                          incol::AbstractVector{U}, gd::GroupedDataFrame) where U
    T = Base.promote_union(U)

    if op === Base.add_sum
        initf = zero
    elseif op === Base.mul_prod
        initf = one
    else
        throw(ErrorException("Unrecognized op $op"))
    end

    Tnm = nonmissingtype(T)
    if isconcretetype(Tnm) && applicable(initf, Tnm)
        tmpv = initf(Tnm)
        initv = op(tmpv, tmpv)
        if adjust isa Nothing
            x = Tnm <: AbstractIrrational ? float(initv) : initv
        else
            x = adjust(initv, 1)
        end
        if condf === !ismissing
            V = typeof(x)
        else
            V = U >: Missing ? Union{typeof(x), Missing} : typeof(x)
        end
        # here we are sure that only Base.add_sum or Base.mul_prod are performed
        # so we always fall back to Vector as output column type
        v = Tables.allocatecolumn(V, length(gd))
        fill!(v, x)
        return v
    else
        # do not try to determine the narrowest possible type nor starting value
        # as this is not possible to do correctly in general without processing
        # groups; it will get fixed later in groupreduce!; later we
        # will make use of the fact that this vector is filled with #undef
        # while above the vector is filled with a concrete value
        return Vector{Any}(undef, length(gd))
    end
end

for (op, initf) in ((:max, :typemin), (:min, :typemax))
    @eval begin
        function groupreduce_init(::typeof($op), condf, adjust,
                                  incol::AbstractVector{T}, gd::GroupedDataFrame) where T
            @assert isnothing(adjust)
            S = nonmissingtype(T)
            # !ismissing check is purely an optimization to avoid a copy later
            outcol = similar(incol, condf === !ismissing ? S : T, length(gd))
            # Comparison is possible only between CatValues from the same pool
            resT = typeof(outcol)
            if nameof(resT) === :CategoricalArray && nameof(parentmodule(resT)) === :CategoricalArrays
                # we know that CategoricalArray has `pool` field
                outcol.pool = incol.pool
            end
            # It is safe to use a non-missing init value
            # since missing will poison the result if present
            # we assume here that groups are non-empty (current design assures this)
            # + workaround for https://github.com/JuliaLang/julia/issues/36978
            if isconcretetype(S) && hasmethod($initf, Tuple{S}) && !(S <: Irrational)
                fill!(outcol, $initf(S))
            else
                fillfirst!(condf, outcol, incol, gd)
            end
            return outcol
        end
    end
end

function copyto_widen!(res::AbstractVector{T}, x::AbstractVector) where T
    @inbounds for i in eachindex(res, x)
        val = x[i]
        S = typeof(val)
        if S <: T || promote_type(S, T) <: T
            res[i] = val
        else
            newres = Tables.allocatecolumn(promote_type(S, T), length(x))
            return copyto_widen!(newres, x)
        end
    end
    return res
end

function groupreduce!_helper(res::AbstractVector, f, op, condf, adjust, checkempty::Bool,
                             incol::AbstractVector, groups::Vector{Int}, counts::Vector{Int},
                             batches)
    for batch in batches
        # Allow other tasks to do garbage collection while this one runs
        GC.safepoint()

        @inbounds for i in batch
            gix = groups[i]
            x = incol[i]
            if gix > 0 && (condf === nothing || condf(x))
                # this check should be optimized out if U is not Any
                if eltype(res) === Any && !isassigned(res, gix)
                    res[gix] = f(x, gix)
                else
                    res[gix] = op(res[gix], f(x, gix))
                end
                # this check is optimized out by constant propagation
                if adjust !== nothing || checkempty
                    counts[gix] += 1
                end
            end
        end
    end
end

function groupreduce!(res::AbstractVector, f, op, condf, adjust, checkempty::Bool,
                      incol::AbstractVector, gd::GroupedDataFrame)
    n = length(gd)
    if adjust !== nothing || checkempty
        counts = zeros(Int, n)
    else
        counts = Int[]
    end
    groups = gd.groups
    batchsize = Threads.nthreads() > 1 ? 100_000 : typemax(Int)
    batches = Iterators.partition(eachindex(incol, groups), batchsize)

    groupreduce!_helper(res, f, op, condf, adjust, checkempty,
                             incol, groups, counts, batches)
    # handle the case of an uninitialized reduction
    if eltype(res) === Any
        if op === Base.add_sum
            initf = zero
        elseif op === Base.mul_prod
            initf = one
        else
            initf = x -> throw(ErrorException("Unrecognized op $op"))
        end
        @inbounds for gix in eachindex(res)
            if !isassigned(res, gix)
                res[gix] = initf(nonmissingtype(eltype(incol)))
            end
        end
    end
    if adjust !== nothing
        res .= adjust.(res, counts)
    end
    if checkempty && any(iszero, counts)
        throw(ArgumentError("some groups contain only missing values"))
    end
    # Reallocate Vector created in groupreduce_init with min or max
    # for CategoricalVector
    resT = typeof(res)
    if nameof(resT) === :CategoricalArray && nameof(parentmodule(resT)) === :CategoricalArrays
        @assert op === min || op === max
        # we know that CategoricalArray has `pool` field
        @assert res.pool === incol.pool
        res.pool = copy(incol.pool)
    end
    if isconcretetype(eltype(res))
        return res
    else
        return copyto_widen!(Tables.allocatecolumn(typeof(first(res)), n), res)
    end
end

# function barrier works around type instability of groupreduce_init due to applicable
groupreduce(f, op, condf, adjust, checkempty::Bool,
            incol::AbstractVector, gd::GroupedDataFrame) =
    groupreduce!(groupreduce_init(op, condf, adjust, incol, gd),
                 f, op, condf, adjust, checkempty, incol, gd)
# Avoids the overhead due to Missing when computing reduction
groupreduce(f, op, condf::typeof(!ismissing), adjust, checkempty::Bool,
            incol::AbstractVector, gd::GroupedDataFrame) =
    groupreduce!(disallowmissing(groupreduce_init(op, condf, adjust, incol, gd)),
                 f, op, condf, adjust, checkempty, incol, gd)

(r::Reduce)(incol::AbstractVector, gd::GroupedDataFrame) =
    groupreduce((x, i) -> x, r.op, r.condf, r.adjust, r.checkempty, incol, gd)

function (agg::Aggregate{typeof(var)})(incol::AbstractVector, gd::GroupedDataFrame)
    means = groupreduce((x, i) -> x, Base.add_sum, agg.condf, /, false, incol, gd)
    z = zero(eltype(incol)) - zero(eltype(means))
    S = typeof((abs2(z) + abs2(z))/2)
    # !ismissing check is purely an optimization to avoid a copy later
    T = eltype(incol) >: Missing && agg.condf !== !ismissing ?
        T = Union{Missing, S} : S
    res = zeros(T, length(gd))
    return groupreduce!(res, (x, i) -> @inbounds(abs2(x - means[i])), +, agg.condf,
                        (x, l) -> l <= 1 ? x/0 : x/(l-1),
                        false, incol, gd)
end

function (agg::Aggregate{typeof(std)})(incol::AbstractVector, gd::GroupedDataFrame)
    outcol = Aggregate(var, agg.condf)(incol, gd)
    if typeof(sqrt(zero(eltype(outcol)))) === eltype(outcol)
        return map!(sqrt, outcol, outcol)
    else
        return map(sqrt, outcol)
    end
end

for f in (first, last)
    function (agg::Aggregate{typeof(f)})(incol::AbstractVector, gd::GroupedDataFrame)
        n = length(gd)
        outcol = similar(incol, n)
        fillfirst!(agg.condf, outcol, incol, gd, rev=agg.f === last)
        if isconcretetype(eltype(outcol))
            return outcol
        else
            return copyto_widen!(Tables.allocatecolumn(typeof(first(outcol)), n), outcol)
        end
    end
end

function (agg::Aggregate{typeof(length)})(incol::AbstractVector, gd::GroupedDataFrame)
    if getfield(gd, :idx) === nothing
        lens = zeros(Int, length(gd))
        @inbounds for gix in gd.groups
            gix > 0 && (lens[gix] += 1)
        end
        return lens
    else
        return gd.ends .- gd.starts .+ 1
    end
end

isagg((col, (fun, outcol))::Pair{<:ColumnIndex, <:Pair{<:Any, <:SymbolOrString}}, gdf::GroupedDataFrame) =
    check_aggregate(fun, parent(gdf)[!, col]) isa AbstractAggregate
isagg(::Any, gdf::GroupedDataFrame) = false

"""
    DataFrameRow{<:AbstractDataFrame, <:AbstractIndex}

A view of one row of an `AbstractDataFrame`.

A `DataFrameRow` is returned by `getindex` or `view` functions when one row and a
selection of columns are requested, or when iterating the result
of the call to the [`eachrow`](@ref) function.

The `DataFrameRow` constructor can also be called directly:

```
DataFrameRow(parent::AbstractDataFrame, row::Integer, cols=:)
```

A `DataFrameRow` supports the iteration interface and can therefore be passed to
functions that expect a collection as an argument. Its element type is always `Any`.

Indexing is one-dimensional like specifying a column of a `DataFrame`.
You can also access the data in a `DataFrameRow` using the `getproperty` and
`setproperty!` functions and convert it to a `Tuple`, `NamedTuple`, or `Vector`
using the corresponding functions.

If the selection of columns in a parent data frame is passed as `:` (a colon)
then `DataFrameRow` will always have all columns from the parent,
even if they are added or removed after its creation.

# Examples
```jldoctest
julia> df = DataFrame(a=repeat([1, 2], outer=[2]),
                      b=repeat(["a", "b"], inner=[2]),
                      c=1:4)
4×3 DataFrame
 Row │ a      b       c
     │ Int64  String  Int64
─────┼──────────────────────
   1 │     1  a           1
   2 │     2  a           2
   3 │     1  b           3
   4 │     2  b           4

julia> df[1, :]
DataFrameRow
 Row │ a      b       c
     │ Int64  String  Int64
─────┼──────────────────────
   1 │     1  a           1

julia> @view df[end, [:a]]
DataFrameRow
 Row │ a
     │ Int64
─────┼───────
   4 │     2

julia> eachrow(df)[1]
DataFrameRow
 Row │ a      b       c
     │ Int64  String  Int64
─────┼──────────────────────
   1 │     1  a           1

julia> Tuple(df[1, :])
(1, "a", 1)

julia> NamedTuple(df[1, :])
(a = 1, b = "a", c = 1)

julia> Vector(df[1, :])
3-element Vector{Any}:
 1
  "a"
 1
```
"""
struct DataFrameRow{D<:AbstractDataFrame, S<:AbstractIndex}
    # although we allow D to be AbstractDataFrame to support extensions
    # in DataFrames.jl it will always be a DataFrame unless an inner constructor
    # is used. In this way we have a fast access to the data frame that
    # actually stores the data that DataFrameRow refers to
    df::D
    colindex::S
    dfrow::Int # row number in df
    rownumber::Int # row number in the direct source AbstractDataFrame from which DataFrameRow was created

    @inline DataFrameRow(df::D, colindex::S, row::Union{Signed, Unsigned},
                         rownumber::Union{Signed, Unsigned}) where
        {D<:AbstractDataFrame, S<:AbstractIndex} = new{D, S}(df, colindex, row, rownumber)
end

Base.@propagate_inbounds function DataFrameRow(df::DataFrame, row::Integer, cols)
    @boundscheck if !checkindex(Bool, axes(df, 1), row)
        throw(BoundsError(df, (row, cols)))
    end
    DataFrameRow(df, SubIndex(index(df), cols), row, row)
end

Base.@propagate_inbounds DataFrameRow(df::DataFrame, row::Bool, cols) =
    throw(ArgumentError("invalid row index of type Bool"))

Base.@propagate_inbounds function DataFrameRow(sdf::SubDataFrame, row::Integer, cols)
    @boundscheck if !checkindex(Bool, axes(sdf, 1), row)
        throw(BoundsError(sdf, (row, cols)))
    end
    if index(sdf) isa Index # sdf was created using : as row selector
        colindex = SubIndex(index(sdf), cols)
    else
        colindex = SubIndex(index(parent(sdf)), parentcols(index(sdf), cols))
    end
    @inbounds DataFrameRow(parent(sdf), colindex, rows(sdf)[row], row)
end

Base.@propagate_inbounds DataFrameRow(df::SubDataFrame, row::Bool, cols) =
    throw(ArgumentError("invalid row index of type Bool"))

Base.@propagate_inbounds DataFrameRow(df::AbstractDataFrame, row::Integer) =
    DataFrameRow(df, row, :)

row(r::DataFrameRow) = getfield(r, :dfrow)

"""
    rownumber(dfr::DataFrameRow)

Return a row number in the `AbstractDataFrame` that `dfr` was created from.

Note that this differs from the first element in the tuple returned by
`parentindices`. The latter gives the row number in the `parent(dfr)`, which is
the source `DataFrame` where data that `dfr` gives access to is stored.

# Examples
```jldoctest
julia> df = DataFrame(reshape(1:12, 3, 4), :auto)
3×4 DataFrame
 Row │ x1     x2     x3     x4
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      4      7     10
   2 │     2      5      8     11
   3 │     3      6      9     12

julia> dfr = df[2, :]
DataFrameRow
 Row │ x1     x2     x3     x4
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   2 │     2      5      8     11

julia> rownumber(dfr)
2

julia> parentindices(dfr)
(2, Base.OneTo(4))

julia> parent(dfr)
3×4 DataFrame
 Row │ x1     x2     x3     x4
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      4      7     10
   2 │     2      5      8     11
   3 │     3      6      9     12

julia> dfv = @view df[2:3, 1:3]
2×3 SubDataFrame
 Row │ x1     x2     x3
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      5      8
   2 │     3      6      9

julia> dfrv = dfv[2, :]
DataFrameRow
 Row │ x1     x2     x3
     │ Int64  Int64  Int64
─────┼─────────────────────
   3 │     3      6      9

julia> rownumber(dfrv)
2

julia> parentindices(dfrv)
(3, 1:3)

julia> parent(dfrv)
3×4 DataFrame
 Row │ x1     x2     x3     x4
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      4      7     10
   2 │     2      5      8     11
   3 │     3      6      9     12
```
"""
rownumber(r::DataFrameRow) = getfield(r, :rownumber)

Base.parent(r::DataFrameRow) = getfield(r, :df)
Base.parentindices(r::DataFrameRow) = (row(r), parentcols(index(r)))

Base.summary(dfr::DataFrameRow) = # -> String
    @sprintf("%d-element %s", length(dfr), nameof(typeof(dfr)))
Base.summary(io::IO, dfr::DataFrameRow) = print(io, summary(dfr))

Base.@propagate_inbounds Base.view(adf::AbstractDataFrame, rowind::Integer,
                                   colinds::MultiColumnIndex) =
    DataFrameRow(adf, rowind, colinds)

Base.@propagate_inbounds Base.getindex(df::AbstractDataFrame, rowind::Integer,
                                       colinds::MultiColumnIndex) =
    DataFrameRow(df, rowind, colinds)
Base.@propagate_inbounds Base.getindex(df::AbstractDataFrame, rowind::Integer, ::Colon) =
    DataFrameRow(df, rowind, :)
Base.@propagate_inbounds Base.getindex(r::DataFrameRow, idx::ColumnIndex) =
    parent(r)[row(r), parentcols(index(r), idx)]

Base.@propagate_inbounds function Base.getindex(r::DataFrameRow, idxs::MultiColumnIndex)
    # we create a temporary DataFrameRow object to compute the SubIndex
    # in the parent(r), but this object has an incorrect rownumber
    # so we later copy rownumber from r
    # the Julia compiler should be able to optimize out this indirection
    # and in this way we avoid duplicating the code that computes the correct SubIndex
    dfr_tmp = DataFrameRow(parent(r), row(r), parentcols(index(r), idxs))
    return DataFrameRow(parent(dfr_tmp), index(dfr_tmp), row(r), rownumber(r))
end

Base.@propagate_inbounds Base.getindex(r::DataFrameRow, ::Colon) = r

for T in MULTICOLUMNINDEX_TUPLE
    @eval function Base.setindex!(df::DataFrame,
                                  v::Union{DataFrameRow, NamedTuple, AbstractDict},
                                  row_ind::Integer,
                                  col_inds::$(T))
        idxs = index(df)[col_inds]
        if length(v) != length(idxs)
            throw(DimensionMismatch("$(length(idxs)) columns were selected but the assigned " *
                                    "collection contains $(length(v)) elements"))
        end

        if v isa AbstractDict
            if keytype(v) !== Symbol &&
                (keytype(v) <: AbstractString || all(x -> x isa AbstractString, keys(v)))
                v = (;(Symbol.(keys(v)) .=> values(v))...)
            end
            for n in view(_names(df), idxs)
                if !haskey(v, n)
                    throw(ArgumentError("Column :$n not found in source dictionary"))
                end
            end
        elseif !all(((a, b),) -> a == b, zip(view(_names(df), idxs), keys(v)))
            mismatched = findall(view(_names(df), idxs) .!= collect(keys(v)))
            throw(ArgumentError("Selected column names do not match the names in assigned " *
                                "value in positions $(join(mismatched, ", ", " and "))"))
        end

        for (col, val) in pairs(v)
            df[row_ind, col] = val
        end
        _drop_all_nonnote_metadata!(df)
        return df
    end
end

Base.@propagate_inbounds Base.setindex!(r::DataFrameRow, value, idx) =
    setindex!(parent(r), value, row(r), parentcols(index(r), idx))

index(r::DataFrameRow) = getfield(r, :colindex)

Base.names(r::DataFrameRow, cols::Colon=:) = names(index(r))

function Base.names(r::DataFrameRow, cols)
    nms = _names(index(r))
    idx = index(r)[cols]
    idxs = idx isa Int ? (idx:idx) : idx
    return [string(nms[i]) for i in idxs]
end

Base.names(r::DataFrameRow, T::Type) =
    [String(n) for n in _names(r) if eltype(parent(r)[!, n]) <: T]
Base.names(r::DataFrameRow, fun::Function) = filter!(fun, names(r))

_names(r::DataFrameRow) = view(_names(parent(r)), parentcols(index(r), :))

Base.haskey(::DataFrameRow, key::Any) =
    throw(ArgumentError("invalid key: $key of type $(typeof(key))"))
Base.haskey(::DataFrameRow, key::Bool) =
    throw(ArgumentError("invalid key: $key of type Bool"))
Base.haskey(r::DataFrameRow, key::Integer) = 1 ≤ key ≤ size(r, 1)

function Base.haskey(r::DataFrameRow, key::Symbol)
    hasproperty(parent(r), key) || return false
    index(r) isa Index && return true
    # here index(r) is a SubIndex
    pos = index(parent(r))[key]
    remap = index(r).remap
    length(remap) == 0 && lazyremap!(index(r))
    checkbounds(Bool, remap, pos) || return false
    return remap[pos] > 0
end

Base.haskey(r::DataFrameRow, key::AbstractString) = haskey(r, Symbol(key))

# separate methods are needed due to dispatch ambiguity
Base.getproperty(r::DataFrameRow, idx::Symbol) = r[idx]
Base.getproperty(r::DataFrameRow, idx::AbstractString) = r[idx]
Base.setproperty!(r::DataFrameRow, idx::Symbol, x::Any) = (r[idx] = x)
Base.setproperty!(r::DataFrameRow, idx::AbstractString, x::Any) = (r[idx] = x)
Compat.hasproperty(r::DataFrameRow, s::Symbol) = haskey(index(r), s)
Compat.hasproperty(r::DataFrameRow, s::AbstractString) = haskey(index(r), s)

# Private fields are never exposed since they can conflict with column names
Base.propertynames(r::DataFrameRow, private::Bool=false) = copy(_names(r))

Base.view(r::DataFrameRow, col::ColumnIndex) =
    view(parent(r)[!, parentcols(index(r), col)], row(r))

function Base.view(r::DataFrameRow, cols::MultiColumnIndex)
    # we create a temporary DataFrameRow object to compute the SubIndex
    # in the parent(r), but this object has an incorrect rownumber
    # so we later copy rownumber from r
    # the Julia compiler should be able to optimize out this indirection
    # and in this way we avoid duplicating the code that computes the correct SubIndex
    dfr_tmp = DataFrameRow(parent(r), row(r), parentcols(index(r), cols))
    return DataFrameRow(parent(dfr_tmp), index(dfr_tmp), row(r), rownumber(r))
end

Base.view(r::DataFrameRow, ::Colon) = r

"""
    size(dfr::DataFrameRow[, dim])

Return a 1-tuple containing the number of elements of `dfr`.
If an optional dimension `dim` is specified, it must be `1`, and the number of
elements is returned directly as a number.

See also: [`length`](@ref)

# Examples
```jldoctest
julia> dfr = DataFrame(a=1:3, b='a':'c')[1, :]
DataFrameRow
 Row │ a      b
     │ Int64  Char
─────┼─────────────
   1 │     1  a

julia> size(dfr)
(2,)

julia> size(dfr, 1)
2
```
"""
Base.size(r::DataFrameRow) = (length(index(r)),)
Base.size(r::DataFrameRow, i) = size(r)[i]

"""
    length(dfr::DataFrameRow)

Return the number of elements of `dfr`.

See also: [`size`](@ref)

# Examples
```jldoctest
julia> dfr = DataFrame(a=1:3, b='a':'c')[1, :]
DataFrameRow
 Row │ a      b
     │ Int64  Char
─────┼─────────────
   1 │     1  a

julia> length(dfr)
2
```
"""
Base.length(r::DataFrameRow) = size(r, 1)

"""
    ndims(::DataFrameRow)
    ndims(::Type{<:DataFrameRow})

Return the number of dimensions of a data frame row, which is always `1`.
"""
Base.ndims(::DataFrameRow) = 1
Base.ndims(::Type{<:DataFrameRow}) = 1

Base.firstindex(r::DataFrameRow) = 1
Base.lastindex(r::DataFrameRow) = length(r)

Base.axes(r::DataFrameRow, i::Integer) = Base.OneTo(size(r, i))

Base.iterate(r::DataFrameRow) = iterate(r, 1)

function Base.iterate(r::DataFrameRow, st)
    st > length(r) && return nothing
    return (r[st], st + 1)
end

# Computing the element type requires going over all columns,
# so better let collect() do it only if necessary (widening)
Base.IteratorEltype(::Type{<:DataFrameRow}) = Base.EltypeUnknown()

function Base.Vector(dfr::DataFrameRow)
    df = parent(dfr)
    T = reduce(promote_type, (eltype(df[!, i]) for i in parentcols(index(dfr))))
    return Vector{T}(dfr)
end
Base.Vector{T}(dfr::DataFrameRow) where T =
    T[dfr[i] for i in 1:length(dfr)]

Base.Array(dfr::DataFrameRow) = Vector(dfr)
Base.Array{T}(dfr::DataFrameRow) where {T} = Vector{T}(dfr)

Base.keys(r::DataFrameRow) = propertynames(r)
Base.values(r::DataFrameRow) =
    ntuple(col -> parent(r)[row(r), parentcols(index(r), col)], length(r))
Base.map(f, r::DataFrameRow, rs::DataFrameRow...) = map(f, copy(r), copy.(rs)...)
Base.get(dfr::DataFrameRow, key::ColumnIndex, default) =
    haskey(dfr, key) ? dfr[key] : default
Base.get(f::Base.Callable, dfr::DataFrameRow, key::ColumnIndex) =
    haskey(dfr, key) ? dfr[key] : f()
Base.broadcastable(::DataFrameRow) =
    throw(ArgumentError("broadcasting over `DataFrameRow`s is reserved"))

function Base.NamedTuple(dfr::DataFrameRow)
    k = Tuple(_names(dfr))
    v = ntuple(i -> dfr[i], length(dfr))
    pc = parentcols(index(dfr))
    cols = _columns(parent(dfr))
    s = ntuple(i -> eltype(cols[pc[i]]), length(dfr))
    NamedTuple{k, Tuple{s...}}(v)
end

"""
    copy(dfr::DataFrameRow)

Construct a `NamedTuple` with the same contents as the [`DataFrameRow`](@ref).
This method returns a `NamedTuple` so that the returned object
is not affected by changes to the parent data frame of which `dfr` is a view.

"""
Base.copy(dfr::DataFrameRow) = NamedTuple(dfr)

Base.convert(::Type{NamedTuple}, dfr::DataFrameRow) = NamedTuple(dfr)

Base.merge(a::DataFrameRow) = NamedTuple(a)
Base.merge(a::DataFrameRow, b::NamedTuple) = merge(NamedTuple(a), b)
Base.merge(a::NamedTuple, b::DataFrameRow) = merge(a, NamedTuple(b))
Base.merge(a::DataFrameRow, b::DataFrameRow) = merge(NamedTuple(a), NamedTuple(b))
Base.merge(a::DataFrameRow, b::Base.Iterators.Pairs) = merge(NamedTuple(a), b)
Base.merge(a::DataFrameRow, itr) = merge(NamedTuple(a), itr)

Base.hash(r::DataFrameRow, h::UInt) = _nt_like_hash(r, h)

for eqfun in (:isequal, :(==)),
    (leftarg, rightarg) in ((:DataFrameRow, :DataFrameRow),
                            (:DataFrameRow, :NamedTuple),
                            (:NamedTuple, :DataFrameRow))
    @eval function Base.$eqfun(r1::$leftarg, r2::$rightarg)
        _equal_names(r1, r2) || return false
        return all(((a, b),) -> $eqfun(a, b), zip(r1, r2))
    end
end

for (eqfun, cmpfun) in ((:isequal, :isless), (:(==), :(<))),
    (leftarg, rightarg) in ((:DataFrameRow, :DataFrameRow),
                            (:DataFrameRow, :NamedTuple),
                            (:NamedTuple, :DataFrameRow))
    @eval function Base.$cmpfun(r1::$leftarg, r2::$rightarg)
        if !_equal_names(r1, r2)
            length(r1) == length(r2) ||
                throw(ArgumentError("compared objects must have the same number " *
                                    "of columns (got $(length(r1)) and $(length(r2)))"))
            mismatch = findfirst(i -> _getnames(r1)[i] != _getnames(r2)[i], 1:length(r1))
            throw(ArgumentError("compared objects must have the same property " *
                                "names but they differ in column number $mismatch " *
                                "where the names are :$(_getnames(r1)[mismatch]) and " *
                                ":$(_getnames(r2)[mismatch]) respectively"))
        end
        for (a, b) in zip(r1, r2)
            eq = $eqfun(a, b)
            if ismissing(eq)
                return missing
            elseif !eq
                return $cmpfun(a, b)
            end
        end
        return false # here we know that r1 and r2 have equal lengths and all values were equal
    end
end

function DataFrame(dfr::DataFrameRow; copycols::Bool=true)
    if !copycols
        throw(ArgumentError("It is not possible to construct a `DataFrame`" *
                            "from DataFrameRow with `copycols=false`"))
    end
    row, cols = parentindices(dfr)
    parent(dfr)[row:row, cols]
end

module TestInsertion

using DataFrames, Test, Logging, DataStructures, PooledArrays
const ≅ = isequal

@testset "push!(df, row)" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfc = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, Any[3, "pear"])
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, (3, "pear"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws InexactError push!(dfb, (33.33, "pear"))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    @test_throws DimensionMismatch push!(dfb, (1, "2", 3))
    @test dfc == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, ("coconut", 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, (11, 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, Dict(:first=>3, :second=>"pear"))
    @test df == dfb

    df = DataFrame(first=[1, 2, 3], second=["apple", "orange", "banana"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, Dict(:first=>3, :second=>"banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, (first=3, second="banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, (second=3, first=3))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    push!(dfb, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, Dict(:first=>true, :second=>false))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, Dict(:first=>"chicken", :second=>"stuff"))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError push!(dfb, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df = DataFrame(x=1)
    push!(df, Dict(:x=>2), Dict(:x=>3))
    @test df[!, :x] == [1, 2, 3]

    df = DataFrame(x=1, y=2)
    push!(df, [3, 4], [5, 6])
    @test df[!, :x] == [1, 3, 5] && df[!, :y] == [2, 4, 6]

    df = DataFrame(x=1, y=2)
    with_logger(sl) do
        @test_throws KeyError push!(df, Dict(:x=>1, "y"=>2))
    end
    @test df == DataFrame(x=1, y=2)
    @test occursin("Error adding value to column :y", String(take!(buf)))

    df = DataFrame()
    @test push!(df, (a=1, b=true)) === df
    @test df == DataFrame(a=1, b=true)

    df = DataFrame()
    df.a = [1, 2, 3]
    df.b = df.a
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError push!(df, [1, 2])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError push!(df, (a=1, b=2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError push!(df, Dict(:a=>1, :b=>2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError push!(df, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError push!(df, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame()
    df.a = [1, 2, 3, 4]
    df.b = df.a
    df.c = [1, 2, 3, 4]
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError push!(df, [1, 2, 3])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError push!(df, (a=1, b=2, c=3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError push!(df, Dict(:a=>1, :b=>2, :c=>3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError push!(df, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError push!(df, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame(a=1, b=2)
    push!(df, [11 12])
    @test df == DataFrame(a=[1, 11], b=[2, 12])
    push!(df, (111, 112))
    @test df == DataFrame(a=[1, 11, 111], b=[2, 12, 112])

    @test_throws ArgumentError push!(df, "ab")
end

@testset "pushfirst!(df, row)" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df = DataFrame(first=[3, 1, 2], second=["pear", "apple", "orange"])

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfc = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, Any[3, "pear"])
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, (3, "pear"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws InexactError pushfirst!(dfb, (33.33, "pear"))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    @test_throws DimensionMismatch pushfirst!(dfb, (1, "2", 3))
    @test dfc == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, ("coconut", 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, (11, 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, Dict(:first=>3, :second=>"pear"))
    @test df == dfb

    df = DataFrame(first=[3, 1, 2], second=["banana", "apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, Dict(:first=>3, :second=>"banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, (first=3, second="banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, (second=3, first=3))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    pushfirst!(dfb, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, Dict(:first=>true, :second=>false))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, Dict(:first=>"chicken", :second=>"stuff"))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError pushfirst!(dfb, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df = DataFrame(x=1)
    pushfirst!(df, Dict(:x=>2), Dict(:x=>3))
    @test df[!, :x] == [2, 3, 1]

    df = DataFrame(x=1, y=2)
    pushfirst!(df, [3, 4], [5, 6])
    @test df[!, :x] == [3, 5, 1] && df[!, :y] == [4, 6, 2]

    df = DataFrame(x=1, y=2)
    with_logger(sl) do
        @test_throws KeyError pushfirst!(df, Dict(:x=>1, "y"=>2))
    end
    @test df == DataFrame(x=1, y=2)
    @test occursin("Error adding value to column :y", String(take!(buf)))

    df = DataFrame()
    @test pushfirst!(df, (a=1, b=true)) === df
    @test df == DataFrame(a=1, b=true)

    df = DataFrame()
    df.a = [1, 2, 3]
    df.b = df.a
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, [1, 2])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, (a=1, b=2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, Dict(:a=>1, :b=>2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError pushfirst!(df, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame()
    df.a = [1, 2, 3, 4]
    df.b = df.a
    df.c = [1, 2, 3, 4]
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, [1, 2, 3])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, (a=1, b=2, c=3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, Dict(:a=>1, :b=>2, :c=>3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError pushfirst!(df, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame(a=1, b=2)
    pushfirst!(df, [11 12])
    @test df == DataFrame(a=[11, 1], b=[12, 2])
    pushfirst!(df, (111, 112))
    @test df == DataFrame(a=[111, 11, 1], b=[112, 12, 2])

    @test_throws ArgumentError pushfirst!(df, "ab")
end

@testset "insert!(df, idx, row)" begin
    @test_throws ArgumentError insert!(DataFrame(), -1, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(), true, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(), 2, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(), -1, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(), true, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(), 2, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(), -1, DataFrame(a=1, b=2)[1, :])
    @test_throws ArgumentError insert!(DataFrame(), true, DataFrame(a=1, b=2)[1, :])
    @test_throws ArgumentError insert!(DataFrame(), 2, DataFrame(a=1, b=2)[1, :])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), -1, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), true, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), 3, [1, 2])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), -1, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), true, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), 3, (a=1, b=2))
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), -1, DataFrame(a=1, b=2)[1, :])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), true, DataFrame(a=1, b=2)[1, :])
    @test_throws ArgumentError insert!(DataFrame(a=1, b=2), 3, DataFrame(a=1, b=2)[1, :])

    buf = IOBuffer()
    sl = SimpleLogger(buf)

    df = DataFrame(first=[1, 3, 2], second=["apple", "pear", "orange"])

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfc = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, Any[3, "pear"])
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, (3, "pear"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws InexactError insert!(dfb, 2, (33.33, "pear"))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    @test_throws DimensionMismatch insert!(dfb, 2, (1, "2", 3))
    @test dfc == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, ("coconut", 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, (11, 22))
    end
    @test dfc == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, Dict(:first=>3, :second=>"pear"))
    @test df == dfb

    df = DataFrame(first=[1, 3, 2], second=["apple", "banana", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, Dict(:first=>3, :second=>"banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, (first=3, second="banana"))
    @test df == dfb

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, (second=3, first=3))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    insert!(dfb, 2, (second="banana", first=3))
    @test df == dfb

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, Dict(:first=>true, :second=>false))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df0 = DataFrame(first=[1, 2], second=["apple", "orange"])
    dfb = DataFrame(first=[1, 2], second=["apple", "orange"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, Dict(:first=>"chicken", :second=>"stuff"))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=[1, 2, 3], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :first", String(take!(buf)))

    df0 = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    dfb = DataFrame(first=["1", "2", "3"], second=["apple", "orange", "pear"])
    with_logger(sl) do
        @test_throws MethodError insert!(dfb, 2, Dict(:first=>"chicken", :second=>1))
    end
    @test df0 == dfb
    @test occursin("Error adding value to column :second", String(take!(buf)))

    df = DataFrame(x=1, y=2)
    with_logger(sl) do
        @test_throws KeyError insert!(df, 2, Dict(:x=>1, "y"=>2))
    end
    @test df == DataFrame(x=1, y=2)
    @test occursin("Error adding value to column :y", String(take!(buf)))

    df = DataFrame()
    @test insert!(df, 1, (a=1, b=true)) === df
    @test df == DataFrame(a=1, b=true)

    df = DataFrame()
    df.a = [1, 2, 3]
    df.b = df.a
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, [1, 2])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, (a=1, b=2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, Dict(:a=>1, :b=>2))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError insert!(df, 2, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame()
    df.a = [1, 2, 3, 4]
    df.b = df.a
    df.c = [1, 2, 3, 4]
    dfc = copy(df)
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, [1, 2, 3])
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, (a=1, b=2, c=3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, Dict(:a=>1, :b=>2, :c=>3))
    end
    @test df == dfc
    @test occursin("Error adding value to column :b", String(take!(buf)))
    @test_throws AssertionError insert!(df, 2, df[1, :])
    @test df == dfc
    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, dfc[1, :])
    end
    @test df == dfc

    df = DataFrame(a=1:4, b=11:14)
    insert!(df, 3, [-1 -2])
    @test df == DataFrame(a=[1, 2, -1, 3, 4], b=[11, 12, -2, 13, 14])
    insert!(df, 3, (-11, -12))
    @test df == DataFrame(a=[1, 2, -11, -1, 3, 4], b=[11, 12, -12, -2, 13, 14])

    @test_throws ArgumentError insert!(df, 2, "ab")
end

@testset "extra push! tests" begin
    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test push!(df, (b=1,), cols=:union) ≅
              DataFrame(a=[1, 2, 3, missing], b=[missing, missing, missing, 1])
        @test push!(df, (b=11,), cols=:union) ≅
              DataFrame(a=[1, 2, 3, missing, missing], b=[missing, missing, missing, 1, 11])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError push!(df, (b=1,), cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[1, 2, 3, missing, missing],
                             b=[missing, missing, missing, 1, 11], x=1:5)
        allowmissing!(df, :x)
        @test push!(df, (b=111,), cols=:union, promote=false) ≅
              DataFrame(a=[1, 2, 3, missing, missing, missing],
                        b=[missing, missing, missing, 1, 11, 111], x=[1:5; missing])
    end

    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test push!(df, DataFrame(b=1)[1, :], cols=:union) ≅
              DataFrame(a=[1, 2, 3, missing], b=[missing, missing, missing, 1])
        @test push!(df, DataFrame(b=11)[1, :], cols=:union) ≅
              DataFrame(a=[1, 2, 3, missing, missing], b=[missing, missing, missing, 1, 11])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError push!(df, DataFrame(b=1)[1, :], cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[1, 2, 3, missing, missing],
                             b=[missing, missing, missing, 1, 11], x=1:5)
        allowmissing!(df, :x)
        @test push!(df, DataFrame(b=111)[1, :], cols=:union, promote=false) ≅
              DataFrame(a=[1, 2, 3, missing, missing, missing],
                        b=[missing, missing, missing, 1, 11, 111], x=[1:5; missing])
    end

    @test_throws ArgumentError push!(DataFrame(), (a=1, b=2), cols=:unions)
    @test_throws ArgumentError push!(DataFrame(), DataFrame(a=1, b=2)[1, :], cols=:unions)
    @test_throws ArgumentError push!(DataFrame(), Dict('a'=>1, 'b'=>2), cols=:union)
end

@testset "extra pushfirst! tests" begin
    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test pushfirst!(df, (b=1,), cols=:union) ≅
              DataFrame(a=[missing, 1, 2, 3], b=[1, missing, missing, missing])
        @test pushfirst!(df, (b=11,), cols=:union) ≅
              DataFrame(a=[missing, missing, 1, 2, 3], b=[11, 1, missing, missing, missing])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError pushfirst!(df, (b=1,), cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[missing, missing, 1, 2, 3],
                             b=[11, 1, missing, missing, missing], x=1:5)
        allowmissing!(df, :x)
        @test pushfirst!(df, (b=111,), cols=:union, promote=false) ≅
              DataFrame(a=[missing, missing, missing, 1, 2, 3],
                        b=[111, 11, 1, missing, missing, missing], x=[missing; 1:5])
    end

    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test pushfirst!(df, DataFrame(b=1)[1, :], cols=:union) ≅
              DataFrame(a=[missing, 1, 2, 3], b=[1, missing, missing, missing])
        @test pushfirst!(df, DataFrame(b=11)[1, :], cols=:union) ≅
              DataFrame(a=[missing, missing, 1, 2, 3], b=[11, 1, missing, missing, missing])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError pushfirst!(df, DataFrame(b=1)[1, :], cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[missing, missing, 1, 2, 3],
                             b=[11, 1, missing, missing, missing], x=1:5)
        allowmissing!(df, :x)
        @test pushfirst!(df, DataFrame(b=111)[1, :], cols=:union, promote=false) ≅
              DataFrame(a=[missing, missing, missing, 1, 2, 3],
                        b=[111, 11, 1, missing, missing, missing], x=[missing; 1:5])
    end

    @test_throws ArgumentError pushfirst!(DataFrame(), (a=1, b=2), cols=:unions)
    @test_throws ArgumentError pushfirst!(DataFrame(), DataFrame(a=1, b=2)[1, :], cols=:unions)
    @test_throws ArgumentError pushfirst!(DataFrame(), Dict('a'=>1, 'b'=>2), cols=:union)
end

@testset "extra insert! tests" begin
    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test insert!(df, 2, (b=1,), cols=:union) ≅
              DataFrame(a=[1, missing, 2, 3], b=[missing, 1, missing, missing])
        @test insert!(df, 2, (b=11,), cols=:union) ≅
              DataFrame(a=[1, missing, missing, 2, 3], b=[missing, 11, 1, missing, missing])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError insert!(df, 2, (b=1,), cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[1, missing, missing, 2, 3],
                             b=[missing, 11, 1, missing, missing], x=1:5)
        allowmissing!(df, :x)
        @test insert!(df, 2, (b=111,), cols=:union, promote=false) ≅
              DataFrame(a=[1, missing, missing, missing, 2, 3],
                        b=[missing, 111, 11, 1, missing, missing], x=[1, missing, 2, 3, 4, 5])
    end

    for df in [DataFrame(a=Any[1, 2, 3]), DataFrame(a=1:3)]
        @test insert!(df, 2, DataFrame(b=1)[1, :], cols=:union) ≅
              DataFrame(a=[1, missing, 2, 3], b=[missing, 1, missing, missing])
        @test insert!(df, 2, DataFrame(b=11)[1, :], cols=:union) ≅
              DataFrame(a=[1, missing, missing, 2, 3], b=[missing, 11, 1, missing, missing])
        df.x = 1:5
        with_logger(SimpleLogger(IOBuffer())) do
            @test_throws MethodError insert!(df, 2, DataFrame(b=1)[1, :], cols=:union, promote=false)
        end
        @test df ≅ DataFrame(a=[1, missing, missing, 2, 3],
                             b=[missing, 11, 1, missing, missing], x=1:5)
        allowmissing!(df, :x)
        @test insert!(df, 2, DataFrame(b=111)[1, :], cols=:union, promote=false) ≅
              DataFrame(a=[1, missing, missing, missing, 2, 3],
                        b=[missing, 111, 11, 1, missing, missing], x=[1, missing, 2, 3, 4, 5])
    end

    @test_throws ArgumentError insert!(DataFrame(), 2, (a=1, b=2), cols=:unions)
    @test_throws ArgumentError insert!(DataFrame(), 2, DataFrame(a=1, b=2)[1, :], cols=:unions)
    @test_throws ArgumentError insert!(DataFrame(), 2, Dict('a'=>1, 'b'=>2), cols=:union)
end

@testset "push!/pushfirst!/insert! with :orderequal" begin
    for v in ((a=10, b=20, c=30),
              DataFrame(a=10, b=20, c=30)[1, :],
              OrderedDict(:a=>10, :b=>20, :c=>30))
        df = DataFrame(a=1:3, b=2:4, c=3:5)
        push!(df, v, cols=:orderequal)
        @test df == DataFrame(a=[1:3; 10], b=[2:4; 20], c=[3:5; 30])
        pushfirst!(df, v, cols=:orderequal)
        @test df == DataFrame(a=[10; 1:3; 10], b=[20; 2:4; 20], c=[30; 3:5; 30])
        insert!(df, 3, v, cols=:orderequal)
        @test df == DataFrame(a=[10; 1; 10; 2:3; 10], b=[20; 2; 20; 3:4; 20], c=[30; 3; 30; 4:5; 30])
    end

    for v in ((a=10, b=20, d=30), (a=10, c=20, b=30),
              DataFrame(a=10, c=20, b=30)[1, :],
              (a=10, b=20, c=30, d=0),
              DataFrame(a=10, b=20, c=30, d=0)[1, :],
              Dict(:a=>10, :b=>20, :c=>30),
              OrderedDict(:c=>10, :b=>20, :a=>30))
        df = DataFrame(a=1:3, b=2:4, c=3:5)
        @test_throws ArgumentError push!(df, v, cols=:orderequal)
        @test_throws ArgumentError pushfirst!(df, v, cols=:orderequal)
        @test_throws ArgumentError insert!(df, 2, v, cols=:orderequal)
        @test df == DataFrame(a=1:3, b=2:4, c=3:5)
    end
end

@testset "push!/pushfirst!/insert! with :subset" begin
    for v in (Dict(:a=>10, :b=>20, :d=>30), (a=10, b=20, d=30),
              DataFrame(a=10, b=20, d=30)[1, :])
        df = DataFrame(a=1:3, b=2:4, c=3:5)
        old_logger = global_logger(NullLogger())
        @test_throws MethodError push!(df, v, cols=:subset, promote=false)
        global_logger(old_logger)
        @test df == DataFrame(a=1:3, b=2:4, c=3:5)
        old_logger = global_logger(NullLogger())
        @test_throws MethodError pushfirst!(df, v, cols=:subset, promote=false)
        global_logger(old_logger)
        @test df == DataFrame(a=1:3, b=2:4, c=3:5)
        old_logger = global_logger(NullLogger())
        @test_throws MethodError insert!(df, 2, v, cols=:subset, promote=false)
        global_logger(old_logger)
        @test df == DataFrame(a=1:3, b=2:4, c=3:5)
    end

    for v in (Dict(:a=>10, :b=>20, :d=>30), (a=10, b=20, d=30),
              DataFrame(a=10, b=20, d=30)[1, :])
        df = DataFrame(a=1:3, b=2:4, c=3:5)
        allowmissing!(df, :c)
        push!(df, v, cols=:subset, promote=false)
        @test df ≅ DataFrame(a=[1, 2, 3, 10], b=[2, 3, 4, 20], c=[3, 4, 5, missing])
        old_logger = global_logger(NullLogger())
        @test_throws MethodError push!(df, Dict(), cols=:subset, promote=false)
        global_logger(old_logger)
        @test df ≅ DataFrame(a=[1, 2, 3, 10], b=[2, 3, 4, 20], c=[3, 4, 5, missing])
        allowmissing!(df, [:a, :b])
        push!(df, Dict(), cols=:subset)
        @test df ≅ DataFrame(a=[1, 2, 3, 10, missing], b=[2, 3, 4, 20, missing],
                             c=[3, 4, 5, missing, missing])

        df = DataFrame(a=1:3, b=2:4, c=3:5)
        allowmissing!(df, :c)
        pushfirst!(df, v, cols=:subset, promote=false)
        @test df ≅ DataFrame(a=[10, 1, 2, 3], b=[20, 2, 3, 4], c=[missing, 3, 4, 5])
        old_logger = global_logger(NullLogger())
        @test_throws MethodError pushfirst!(df, Dict(), cols=:subset, promote=false)
        global_logger(old_logger)
        @test df ≅ DataFrame(a=[10, 1, 2, 3], b=[20, 2, 3, 4], c=[missing, 3, 4, 5])
        allowmissing!(df, [:a, :b])
        pushfirst!(df, Dict(), cols=:subset)
        @test df ≅ DataFrame(a=[missing, 10, 1, 2, 3], b=[missing, 20, 2, 3, 4],
                             c=[missing, missing, 3, 4, 5])

        df = DataFrame(a=1:3, b=2:4, c=3:5)
        allowmissing!(df, :c)
        insert!(df, 2, v, cols=:subset, promote=false)
        @test df ≅ DataFrame(a=[1, 10, 2, 3], b=[2, 20, 3, 4], c=[3, missing, 4, 5])
        old_logger = global_logger(NullLogger())
        @test_throws MethodError insert!(df, 2, Dict(), cols=:subset, promote=false)
        global_logger(old_logger)
        @test df ≅ DataFrame(a=[1, 10, 2, 3], b=[2, 20, 3, 4], c=[3, missing, 4, 5])
        allowmissing!(df, [:a, :b])
        insert!(df, 2, Dict(), cols=:subset)
        @test df ≅ DataFrame(a=[1, missing, 10, 2, 3], b=[2, missing, 20, 3, 4],
                             c=[3, missing, missing, 4, 5])
    end
end

@testset "push!/pushfirst!/insert! with :intersect" begin
    for row in ((y=4, x=3), Dict(:y=>4, :x=>3), (z=1, y=4, x=3), Dict(:y=>4, :x=>3, :z=>1))
        df = DataFrame(x=[1, 1], y=[2, 2])
        push!(df, row, cols=:intersect)
        @test df == DataFrame(x=[1, 1, 3], y=[2, 2, 4])
        pushfirst!(df, row, cols=:intersect)
        @test df == DataFrame(x=[3, 1, 1, 3], y=[4, 2, 2, 4])
        insert!(df, 3, row, cols=:intersect)
        @test df == DataFrame(x=[3, 1, 3, 1, 3], y=[4, 2, 4, 2, 4])
    end

    old_logger = global_logger(NullLogger())
    for row in ((z=4, x=3), (z=1, p=4, x=3))
        df = DataFrame(x=1:3, y=2:4)
        @test_throws ErrorException push!(df, row, cols=:intersect)
        @test_throws ErrorException pushfirst!(df, row, cols=:intersect)
        @test_throws ErrorException insert!(df, 2, row, cols=:intersect)
        @test df == DataFrame(x=1:3, y=2:4)
    end

    for row in (Dict(:z=>4, :x=>3), Dict(:p=>4, :x=>3, :z=>1))
        df = DataFrame(x=1:3, y=2:4)
        @test_throws KeyError push!(df, row, cols=:intersect)
        @test_throws KeyError pushfirst!(df, row, cols=:intersect)
        @test_throws KeyError insert!(df, 2, row, cols=:intersect)
        @test df == DataFrame(x=1:3, y=2:4)
    end
    global_logger(old_logger)
end

@testset "push! with :union" begin
    df = DataFrame()
    push!(df, (a=1, b=2))
    a = df.a
    push!(df, (a=1, c=2), cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[2, missing],
                         c=[missing, 2])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    push!(df, (a=1, c=2), cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    push!(df, (c=2,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    push!(df, (c=missing,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    push!(df, (c="a", d=1), cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    push!(df, (a="b",), cols=:union)
    @test df ≅ DataFrame(a=[missing, missing, "b"],
                         c=[missing, "a", missing],
                         d=[missing, 1, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    push!(df, (a=11,), cols=:union)
    @test df.a === a
    push!(df, (a=12.0,), cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError push!(df, (a=1, b=2, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError push!(df, (a=1, b=2.0, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    df = DataFrame()
    push!(df, DataFrame(a=1, b=2)[1, :])
    a = df.a
    push!(df, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[2, missing], c=[missing, 2])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    push!(df, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    push!(df, DataFrame(c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    push!(df, DataFrame(c=missing)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    push!(df, DataFrame(c="a", d=1)[1, :], cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    push!(df, DataFrame(a="b")[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing, missing, "b"],
                         c=[missing, "a", missing],
                         d=[missing, 1, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    push!(df, DataFrame(a=1)[1, :], cols=:union)
    @test df.a === a
    push!(df, DataFrame(a=1.0)[1, :], cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError push!(df, DataFrame(a=1, b=2, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError push!(df, DataFrame(a=1, b=2.0, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x
end

@testset "pushfirst! with :union" begin
    df = DataFrame()
    pushfirst!(df, (a=1, b=2))
    a = df.a
    pushfirst!(df, (a=1, c=2), cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[missing, 2],
                         c=[2, missing])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, (a=1, c=2), cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, (c=2,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, (c=missing,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    pushfirst!(df, (c="a", d=1), cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    pushfirst!(df, (a="b",), cols=:union)
    @test df ≅ DataFrame(a=["b", missing, missing],
                         c=[missing, "a", missing],
                         d=[missing, 1, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    pushfirst!(df, (a=11,), cols=:union)
    @test df.a === a
    pushfirst!(df, (a=12.0,), cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError pushfirst!(df, (a=1, b=2, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError pushfirst!(df, (a=1, b=2.0, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    df = DataFrame()
    pushfirst!(df, DataFrame(a=1, b=2)[1, :])
    a = df.a
    pushfirst!(df, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[missing, 2], c=[2, missing])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, DataFrame(c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, DataFrame(c=missing)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    pushfirst!(df, DataFrame(c="a", d=1)[1, :], cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    pushfirst!(df, DataFrame(a="b")[1, :], cols=:union)
    @test df ≅ DataFrame(a=["b", missing, missing],
                         c=[missing, "a", missing],
                         d=[missing, 1, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    pushfirst!(df, DataFrame(a=1)[1, :], cols=:union)
    @test df.a === a
    pushfirst!(df, DataFrame(a=1.0)[1, :], cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError pushfirst!(df, DataFrame(a=1, b=2, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError pushfirst!(df, DataFrame(a=1, b=2.0, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x
end

@testset "insert! with :union" begin
    df = DataFrame()
    insert!(df, 1, (a=1, b=2))
    a = df.a
    insert!(df, 1, (a=1, c=2), cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[missing, 2],
                         c=[2, missing])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    pushfirst!(df, (a=1, c=2), cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    insert!(df, 1, (c=2,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    insert!(df, 1, (c=missing,), cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    insert!(df, 1, (c="a", d=1), cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    insert!(df, 2, (a="b",), cols=:union)
    @test df ≅ DataFrame(a=[missing, "b", missing],
                         c=["a", missing, missing],
                         d=[1, missing, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    insert!(df, 2, (a=11,), cols=:union)
    @test df.a === a
    insert!(df, 2, (a=12.0,), cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError insert!(df, 2, (a=1, b=2, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError insert!(df, 2, (a=1, b=2.0, c=3), cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    df = DataFrame()
    insert!(df, 1, DataFrame(a=1, b=2)[1, :])
    a = df.a
    insert!(df, 1, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[1, 1], b=[missing, 2], c=[2, missing])
    @test df.a === a
    @test eltype(df.a) === Int

    df = DataFrame(a=Int[])
    insert!(df, 1, DataFrame(a=1, c=2)[1, :], cols=:union)
    @test df == DataFrame(a=[1], c=[2])
    @test eltype(df.a) === Int
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    insert!(df, 1, DataFrame(c=2)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[2])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Int

    df = DataFrame(a=Int[])
    insert!(df, 1, DataFrame(c=missing)[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing], c=[missing])
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Missing

    insert!(df, 1, DataFrame(c="a", d=1)[1, :], cols=:union)
    @test eltype(df.a) === Union{Int, Missing}
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    insert!(df, 2, DataFrame(a="b")[1, :], cols=:union)
    @test df ≅ DataFrame(a=[missing, "b", missing],
                         c=["a", missing, missing],
                         d=[1, missing, missing])
    @test eltype(df.a) === Any
    @test eltype(df.c) === Union{String, Missing}
    @test eltype(df.d) === Union{Int, Missing}

    a = [1, 2, 3]
    df = DataFrame(a=a, copycols=false)
    insert!(df, 2, DataFrame(a=1)[1, :], cols=:union)
    @test df.a === a
    insert!(df, 2, DataFrame(a=1.0)[1, :], cols=:union)
    @test df.a !== a
    @test eltype(df.a) === Float64

    x = [1, 2, 3]
    df = DataFrame(a=x, b=x, copycols=false)
    @test_throws AssertionError insert!(df, 2, DataFrame(a=1, b=2, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x

    @test_throws AssertionError insert!(df, 2, DataFrame(a=1, b=2.0, c=3)[1, :], cols=:union)
    @test df == DataFrame(a=x, b=x, copycols=false)
    @test df.a === df.b === x
end

@testset "push!/pushfirst!/insert! with promote options" begin
    df = DataFrame(a=1:3)
    with_logger(SimpleLogger(IOBuffer())) do
        @test_throws MethodError push!(df, ["a"])
    end
    @test push!(df, ["a"], promote=true) == DataFrame(a=[1:3; "a"])

    df = DataFrame(a=1:3)
    with_logger(SimpleLogger(IOBuffer())) do
        @test_throws MethodError pushfirst!(df, ["a"])
    end
    @test pushfirst!(df, ["a"], promote=true) == DataFrame(a=["a"; 1:3])

    df = DataFrame(a=1:3)
    with_logger(SimpleLogger(IOBuffer())) do
        @test_throws MethodError insert!(df, 2, ["a"])
    end
    @test insert!(df, 2, ["a"], promote=true) == DataFrame(a=[1, "a", 2, 3])

    for v in ((a="a",), DataFrame(a="a")[1, :])
        for cols in [:orderequal, :setequal, :intersect]
            df = DataFrame(a=1:3)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError push!(df, v, cols=cols)
            end
            @test push!(df, v, cols=cols, promote=true) == DataFrame(a=[1:3; "a"])

            df = DataFrame(a=1:3)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError pushfirst!(df, v, cols=cols)
            end
            @test pushfirst!(df, v, cols=cols, promote=true) == DataFrame(a=["a"; 1:3])

            df = DataFrame(a=1:3)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError insert!(df, 2, v, cols=cols)
            end
            @test insert!(df, 2, v, cols=cols, promote=true) == DataFrame(a=[1, "a", 2, 3])

        end
        for cols in [:subset, :union]
            df = DataFrame(a=1:3, b=11:13)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError push!(df, v, cols=cols, promote=false)
            end
            @test push!(df, v, cols=cols) ≅ DataFrame(a=[1:3; "a"], b=[11:13; missing])

            df = DataFrame(a=1:3, b=11:13)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError pushfirst!(df, v, cols=cols, promote=false)
            end
            @test pushfirst!(df, v, cols=cols) ≅ DataFrame(a=["a"; 1:3], b=[missing; 11:13])

            df = DataFrame(a=1:3, b=11:13)
            with_logger(SimpleLogger(IOBuffer())) do
                @test_throws MethodError insert!(df, 2, v, cols=cols, promote=false)
            end
            @test insert!(df, 2, v, cols=cols) ≅ DataFrame(a=[1, "a", 2, 3], b=[11, missing, 12, 13])
        end
    end
end

@testset "push!/pushfirst!/insert! with :setequal and wrong number of entries" begin
    df = DataFrame(a=1:3)
    @test_throws ArgumentError push!(df, (a=10, b=20))
    @test_throws ArgumentError push!(df, "a")
    @test_throws ArgumentError pushfirst!(df, (a=10, b=20))
    @test_throws ArgumentError pushfirst!(df, "a")
    @test_throws ArgumentError insert!(df, 2, (a=10, b=20))
    @test_throws ArgumentError insert!(df, 2, "a")
end

@testset "push!/pushfirst!/insert! with self" begin
    df = DataFrame(a=1:3, b=2:4, c=3:5)
    @test push!(df, df[2, :]) == DataFrame(a=[1:3; 2], b=[2:4; 3], c=[3:5; 4])
    @test pushfirst!(df, df[3, :]) == DataFrame(a=[3; 1:3; 2], b=[4; 2:4; 3], c=[5; 3:5; 4])
    @test insert!(df, 3, df[1, :]) == DataFrame(a=[3; 1; 3; 2:3; 2], b=[4; 2; 4; 3:4; 3], c=[5; 3; 5; 4:5; 4])
    df = DataFrame(a=1:3, b=2:4)
    df.c = df.a
    @test_throws AssertionError push!(df, df[2, :])
    @test_throws AssertionError pushfirst!(df, df[2, :])
    @test_throws AssertionError insert!(df, 2, df[2, :])
    @test df == DataFrame(a=1:3, b=2:4, c=1:3)
end

@testset "multicolumn aliasing" begin
    df = DataFrame(a1=1:3, b1=11:13)
    df.a2 = df.a1
    df.a3 = df.a1
    df.b2 = df.b1
    df.b3 = df.b1
    df.a4 = df.a1
    refdf = copy(df)

    buf = IOBuffer()
    sl = SimpleLogger(buf)

    with_logger(sl) do
        @test_throws AssertionError push!(df, 1:7)
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf

    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, 1:7)
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf

    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, 1:7)
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf

    with_logger(sl) do
        @test_throws AssertionError push!(df, (a1=1, b1=2, a2=3, a3=4, b2=5, b3=6, a4=7))
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf

    with_logger(sl) do
        @test_throws AssertionError pushfirst!(df, (a1=1, b1=2, a2=3, a3=4, b2=5, b3=6, a4=7))
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf

    with_logger(sl) do
        @test_throws AssertionError insert!(df, 2, (a1=1, b1=2, a2=3, a3=4, b2=5, b3=6, a4=7))
    end
    @test occursin("Error adding value to column :a2", String(take!(buf)))
    @test df == refdf
end

@testset "Tables.AbstractRow insertion" begin
    tab = Tables.table([1 2 3; 4 5 6; 9 10 11; 12 13 14], header=[:a, :b, :c])
    rows = tab |> Tables.rows |> collect
    df = DataFrame()
    @test push!(df, rows[2]) == DataFrame(a=4, b=5, c=6)
    @test pushfirst!(df, rows[1], promote=false, cols=:union) ==
          DataFrame(a=[1, 4], b=[2, 5], c=[3, 6])
    @test insert!(df, 2, rows[3], promote=true, cols=:intersect) ==
        DataFrame(a=[1, 9, 4], b=[2, 10, 5], c=[3, 11, 6])
    @test push!(df, rows[1], promote=true, cols=:orderequal) ==
        DataFrame(a=[1, 9, 4, 1], b=[2, 10, 5, 2], c=[3, 11, 6, 3])
    deleteat!(df, nrow(df))

    df2 = DataFrame(d="x", a="y")
    push!(df2, rows[1], cols=:union)
    @test df2 ≅ DataFrame(d=["x", missing], a=["y", 1], b=[missing, 2], c=[missing, 3])

    tab = Tables.table(Any[15 16.5], header=[:d, :c])
    row = tab |> Tables.rows |> first
    @test push!(df, row, cols=:union) ≅
                DataFrame(a=[1, 9, 4, missing],
                          b=[2, 10, 5, missing],
                          c=[3.0, 11.0, 6.0, 16.5],
                          d=[missing, missing, missing, 15])

    tab = Tables.table(Any[21 22.5], header=[:x, :b])
    row = tab |> Tables.rows |> first
    @test pushfirst!(df, row, cols=:subset) ≅
                     DataFrame(a=[missing, 1, 9, 4, missing],
                               b=[22.5, 2.0, 10.0, 5.0, missing],
                               c=[missing, 3.0, 11.0, 6.0, 16.5],
                               d=[missing, missing, missing, missing, 15])

    tab = Tables.table(["a" "b" "c" "d" "e"], header=[:a, :b, :c, :d, :e])
    row = tab |> Tables.rows |> first

    buf = IOBuffer()
    sl = SimpleLogger(buf)
    with_logger(sl) do
        @test_throws MethodError insert!(df, 3, row, cols=:intersect)
    end
    @test occursin("Error adding value to column :a", String(take!(buf)))

    @test insert!(df, 3, row, cols=:intersect, promote=true) ≅
                  DataFrame(a=[missing, 1, "a", 9, 4, missing],
                            b=[22.5, 2.0, "b", 10.0, 5.0, missing],
                            c=[missing, 3.0, "c", 11.0, 6.0, 16.5],
                            d=[missing, missing, "d", missing, missing, 15])
    for i in [1, 2, 4, 8, 16, 32, 64, 100, 1000, 10000, 20_000, 210_000]
        df = DataFrame()
        mat = Any[a + 100 * b + (iseven(b) ? 0.5 : 0) for a in 1:2, b in 1:i]
        tab = Tables.table(mat, header=Symbol.("x", 1:i))
        for row in Tables.rows(tab)
            push!(df, row)
        end
        @test eltype.(eachcol(df)) == [(isodd(i) ? Int : Float64) for i in 1:ncol(df)]
        @test df == DataFrame(mat, :auto)
    end
end

@testset "PooledArray error #3356" begin
    buf = IOBuffer()
    sl = SimpleLogger(buf)

    with_logger(sl) do
        @test_throws ErrorException append!(DataFrame(x=PooledArray(1:255, UInt8)),
                                            DataFrame(x=PooledArray(256:500, UInt8)))
        @test_throws ErrorException append!(DataFrame(x=PooledArray(1:255, UInt8)),
                                            DataFrame(x=PooledArray(256:500, UInt8)),
                                            promote=true)
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), [1000])
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), [1000],
                                          promote=true)
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), (x=1000,))
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), (x=1000,),
                                          promote=true)
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), (x=1000,),
                                          cols=:union, promote=true)
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), (x=1000,),
                                          cols=:union, promote=false)
        @test_throws ErrorException push!(DataFrame(x=PooledArray(1:255, UInt8)), (x="x",),
                                          cols=:union, promote=true)
        @test_throws MethodError push!(DataFrame(x=PooledArray(1:255, UInt8)), (x="x",),
                                       cols=:union, promote=false)
    end
end

@testset "multi element append!/prepend!/push!/pushfirst!" begin
    df = DataFrame(a=1, b=2)
    @test append!(df) == DataFrame(a=1, b=2)
    @test prepend!(df) == DataFrame(a=1, b=2)
    @test push!(df) == DataFrame(a=1, b=2)
    @test pushfirst!(df) == DataFrame(a=1, b=2)
    @test_throws ArgumentError append!(df, cols=:x) == DataFrame(a=1, b=2)
    @test_throws ArgumentError prepend!(df, cols=:x) == DataFrame(a=1, b=2)
    @test_throws ArgumentError push!(df, cols=:x) == DataFrame(a=1, b=2)
    @test_throws ArgumentError pushfirst!(df, cols=:x) == DataFrame(a=1, b=2)

    for x in (DataFrame(a=3, b=4), (a=[3], b=[4]), [(a=3, b=4)]),
        y in (DataFrame(a=5, b=6), (a=[5], b=[6]), [(a=5, b=6)]),
        z in (DataFrame(a=7, b=8), (a=[7], b=[8]), [(a=7, b=8)])
        @test append!(copy(df), x, y) ==
              DataFrame(a=1:2:5, b=2:2:6)
        @test append!(copy(df), x, y, z) ==
              DataFrame(a=1:2:7, b=2:2:8)
        @test prepend!(copy(df), x, y) ==
              DataFrame(a=[3, 5, 1], b=[4, 6, 2])
        @test prepend!(copy(df), x, y, z) ==
              DataFrame(a=[3, 5, 7, 1], b=[4, 6, 8, 2])
    end

    for x in (DataFrame(a=3, b=4)[1, :], (a=3, b=4)),
        y in (DataFrame(a=5, b=6)[1, :], (a=5, b=6)),
        z in (DataFrame(a=7, b=8)[1, :], (a=7, b=8))
        @test push!(copy(df), x, y) ==
              DataFrame(a=1:2:5, b=2:2:6)
        @test push!(copy(df), x, y, z) ==
              DataFrame(a=1:2:7, b=2:2:8)
        @test pushfirst!(copy(df), x, y) ==
              DataFrame(a=[3, 5, 1], b=[4, 6, 2])
        @test pushfirst!(copy(df), x, y, z) ==
              DataFrame(a=[3, 5, 7, 1], b=[4, 6, 8, 2])
        for cols in (:orderequal, :setequal, :union, :subset, :intersect)
            @test push!(copy(df), x, y, cols=cols) ==
                DataFrame(a=1:2:5, b=2:2:6)
            @test push!(copy(df), x, y, z, cols=cols) ==
                DataFrame(a=1:2:7, b=2:2:8)
            @test pushfirst!(copy(df), x, y, cols=cols) ==
                DataFrame(a=[3, 5, 1], b=[4, 6, 2])
            @test pushfirst!(copy(df), x, y, z, cols=cols) ==
                DataFrame(a=[3, 5, 7, 1], b=[4, 6, 8, 2])
        end
    end

    for x in ((3, 4), [3, 4]), y in ((5, 6), [5, 6]), z in ((7, 8), [7, 8])
        @test push!(copy(df), x, y) ==
              DataFrame(a=1:2:5, b=2:2:6)
        @test push!(copy(df), x, y, z) ==
              DataFrame(a=1:2:7, b=2:2:8)
        @test pushfirst!(copy(df), x, y) ==
              DataFrame(a=[3, 5, 1], b=[4, 6, 2])
        @test pushfirst!(copy(df), x, y, z) ==
              DataFrame(a=[3, 5, 7, 1], b=[4, 6, 8, 2])
    end

    for x in (DataFrame(a=3, b=4), (a=[3], b=[4]), [(a=3, b=4)]),
        y in (DataFrame(a=5, c=6), (a=[5], c=[6]), [(a=5, c=6)]),
        z in (DataFrame(a="7", d=8), (a=["7"], d=[8]), [(a="7", d=8)])
        @test append!(copy(df), x, y, cols=:union) ≅
              DataFrame(a=1:2:5, b=[2, 4, missing], c=[missing, missing, 6])
        @test append!(copy(df), x, y, z, cols=:union) ≅
              DataFrame(a=[1, 3, 5, "7"], b=[2, 4, missing, missing],
                        c=[missing, missing, 6, missing],
                        d=[missing, missing, missing, 8])
        @test prepend!(copy(df), x, y, cols=:union) ≅
              DataFrame(a=[3, 5, 1], b=[4, missing, 2], c=[missing, 6, missing])
        @test prepend!(copy(df), x, y, z, cols=:union) ≅
              DataFrame(a=[3, 5, "7", 1], b=[4, missing, missing, 2],
                        d=[missing, missing, 8, missing],
                        c=[missing, 6, missing, missing],)
    end

    for x in (DataFrame(a=3, b=4)[1, :], (a=3, b=4)),
        y in (DataFrame(a=5, c=6)[1, :], (a=5, c=6)),
        z in (DataFrame(a="7", d=8)[1, :], (a="7", d=8))
        @test push!(copy(df), x, y, cols=:union) ≅
              DataFrame(a=1:2:5, b=[2, 4, missing], c=[missing, missing, 6])
        @test push!(copy(df), x, y, z, cols=:union) ≅
              DataFrame(a=[1, 3, 5, "7"], b=[2, 4, missing, missing],
                        c=[missing, missing, 6, missing],
                        d=[missing, missing, missing, 8])
        @test pushfirst!(copy(df), x, y, cols=:union) ≅
              DataFrame(a=[3, 5, 1], b=[4, missing, 2], c=[missing, 6, missing])
        @test pushfirst!(copy(df), x, y, z, cols=:union) ≅
              DataFrame(a=[3, 5, "7", 1], b=[4, missing, missing, 2],
                        d=[missing, missing, 8, missing],
                        c=[missing, 6, missing, missing],)
    end

    @test_throws ArgumentError push!(df, (1, 2), cols=:union)
    @test_throws ArgumentError pushfirst!(df, (1, 2), cols=:union)

    @test_throws ArgumentError push!(df, (1, 2), (1, 2), cols=:union)
    @test_throws ArgumentError pushfirst!(df, (1, 2), (1, 2), cols=:union)

    @test_throws ArgumentError push!(df, (a=1, b=2), (1, 2))
    @test_throws ArgumentError pushfirst!(df, (a=1, b=2), (1, 2))
    @test_throws ArgumentError push!(df, (1, 2), (a=1, b=2))
    @test_throws ArgumentError pushfirst!(df, (1, 2), (a=1, b=2))

    @test insert!(DataFrame(a=1:3, b=11:13), 2, (0, 10), cols=:setequal) ==
          DataFrame(a=[1, 0, 2, 3], b=[11, 10, 12, 13])
    @test_throws ArgumentError insert!(df, 1, (1, 2), cols=:orderequal)
end

end # module

julia runtests.jl 100000 50000000 inner
julia runtests.jl 5000000 10000000 inner
julia runtests.jl 100000 50000000 left
julia runtests.jl 5000000 10000000 left
julia runtests.jl 100000 50000000 right
julia runtests.jl 5000000 10000000 right
julia runtests.jl 100000 50000000 outer
julia runtests.jl 5000000 10000000 outer
julia runtests.jl 100000 50000000 semi
julia runtests.jl 5000000 10000000 semi
julia runtests.jl 100000 50000000 anti
julia runtests.jl 5000000 10000000 anti

# Reshaping and Pivoting Data

Reshape data from wide to long format using the `stack` function:

```jldoctest reshape
julia> using DataFrames, CSV

julia> path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "iris.csv");

julia> iris = CSV.read(path, DataFrame)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         6.8         3.2          5.9         2.3  Iris-virginica
 145 │         6.7         3.3          5.7         2.5  Iris-virginica
 146 │         6.7         3.0          5.2         2.3  Iris-virginica
 147 │         6.3         2.5          5.0         1.9  Iris-virginica
 148 │         6.5         3.0          5.2         2.0  Iris-virginica
 149 │         6.2         3.4          5.4         2.3  Iris-virginica
 150 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                        135 rows omitted

julia> stack(iris, 1:4)
600×3 DataFrame
 Row │ Species         variable     value
     │ String15        String       Float64
─────┼──────────────────────────────────────
   1 │ Iris-setosa     SepalLength      5.1
   2 │ Iris-setosa     SepalLength      4.9
   3 │ Iris-setosa     SepalLength      4.7
   4 │ Iris-setosa     SepalLength      4.6
   5 │ Iris-setosa     SepalLength      5.0
   6 │ Iris-setosa     SepalLength      5.4
   7 │ Iris-setosa     SepalLength      4.6
   8 │ Iris-setosa     SepalLength      5.0
  ⋮  │       ⋮              ⋮          ⋮
 594 │ Iris-virginica  PetalWidth       2.3
 595 │ Iris-virginica  PetalWidth       2.5
 596 │ Iris-virginica  PetalWidth       2.3
 597 │ Iris-virginica  PetalWidth       1.9
 598 │ Iris-virginica  PetalWidth       2.0
 599 │ Iris-virginica  PetalWidth       2.3
 600 │ Iris-virginica  PetalWidth       1.8
                            585 rows omitted
```

The second optional argument to `stack` indicates the columns to be stacked.
These are normally referred to as the measured variables. Column names can also
be given:

```jldoctest reshape
julia> stack(iris, [:SepalLength, :SepalWidth, :PetalLength, :PetalWidth])
600×3 DataFrame
 Row │ Species         variable     value
     │ String15        String       Float64
─────┼──────────────────────────────────────
   1 │ Iris-setosa     SepalLength      5.1
   2 │ Iris-setosa     SepalLength      4.9
   3 │ Iris-setosa     SepalLength      4.7
   4 │ Iris-setosa     SepalLength      4.6
   5 │ Iris-setosa     SepalLength      5.0
   6 │ Iris-setosa     SepalLength      5.4
   7 │ Iris-setosa     SepalLength      4.6
   8 │ Iris-setosa     SepalLength      5.0
  ⋮  │       ⋮              ⋮          ⋮
 594 │ Iris-virginica  PetalWidth       2.3
 595 │ Iris-virginica  PetalWidth       2.5
 596 │ Iris-virginica  PetalWidth       2.3
 597 │ Iris-virginica  PetalWidth       1.9
 598 │ Iris-virginica  PetalWidth       2.0
 599 │ Iris-virginica  PetalWidth       2.3
 600 │ Iris-virginica  PetalWidth       1.8
                            585 rows omitted
```

Note that all columns can be of different types. Type promotion follows the
rules of `vcat`.

The stacked `DataFrame` that results includes all of the columns not specified
to be stacked. These are repeated for each stacked column. These are normally
referred to as identifier (id) columns. In addition to the id columns, two
additional columns labeled `:variable` and `:values` contain the column
identifier and the stacked columns.

A third optional argument to `stack` represents the id columns that are
repeated. This makes it easier to specify which variables you want included in
the long format:

```jldoctest reshape
julia> stack(iris, [:SepalLength, :SepalWidth], :Species)
300×3 DataFrame
 Row │ Species         variable     value
     │ String15        String       Float64
─────┼──────────────────────────────────────
   1 │ Iris-setosa     SepalLength      5.1
   2 │ Iris-setosa     SepalLength      4.9
   3 │ Iris-setosa     SepalLength      4.7
   4 │ Iris-setosa     SepalLength      4.6
   5 │ Iris-setosa     SepalLength      5.0
   6 │ Iris-setosa     SepalLength      5.4
   7 │ Iris-setosa     SepalLength      4.6
   8 │ Iris-setosa     SepalLength      5.0
  ⋮  │       ⋮              ⋮          ⋮
 294 │ Iris-virginica  SepalWidth       3.2
 295 │ Iris-virginica  SepalWidth       3.3
 296 │ Iris-virginica  SepalWidth       3.0
 297 │ Iris-virginica  SepalWidth       2.5
 298 │ Iris-virginica  SepalWidth       3.0
 299 │ Iris-virginica  SepalWidth       3.4
 300 │ Iris-virginica  SepalWidth       3.0
                            285 rows omitted
```

If you prefer to specify the id columns then use `Not` with `stack` like this:

```jldoctest reshape
julia> stack(iris, Not(:Species))
600×3 DataFrame
 Row │ Species         variable     value
     │ String15        String       Float64
─────┼──────────────────────────────────────
   1 │ Iris-setosa     SepalLength      5.1
   2 │ Iris-setosa     SepalLength      4.9
   3 │ Iris-setosa     SepalLength      4.7
   4 │ Iris-setosa     SepalLength      4.6
   5 │ Iris-setosa     SepalLength      5.0
   6 │ Iris-setosa     SepalLength      5.4
   7 │ Iris-setosa     SepalLength      4.6
   8 │ Iris-setosa     SepalLength      5.0
  ⋮  │       ⋮              ⋮          ⋮
 594 │ Iris-virginica  PetalWidth       2.3
 595 │ Iris-virginica  PetalWidth       2.5
 596 │ Iris-virginica  PetalWidth       2.3
 597 │ Iris-virginica  PetalWidth       1.9
 598 │ Iris-virginica  PetalWidth       2.0
 599 │ Iris-virginica  PetalWidth       2.3
 600 │ Iris-virginica  PetalWidth       1.8
                            585 rows omitted
```

`unstack` converts from a long format to a wide format.
The default is requires specifying which columns are an id variable,
column variable names, and column values:

```jldoctest reshape
julia> iris.id = 1:size(iris, 1)
1:150

julia> longdf = stack(iris, Not([:Species, :id]))
600×4 DataFrame
 Row │ Species         id     variable     value
     │ String15        Int64  String       Float64
─────┼─────────────────────────────────────────────
   1 │ Iris-setosa         1  SepalLength      5.1
   2 │ Iris-setosa         2  SepalLength      4.9
   3 │ Iris-setosa         3  SepalLength      4.7
   4 │ Iris-setosa         4  SepalLength      4.6
   5 │ Iris-setosa         5  SepalLength      5.0
   6 │ Iris-setosa         6  SepalLength      5.4
   7 │ Iris-setosa         7  SepalLength      4.6
   8 │ Iris-setosa         8  SepalLength      5.0
  ⋮  │       ⋮           ⋮         ⋮          ⋮
 594 │ Iris-virginica    144  PetalWidth       2.3
 595 │ Iris-virginica    145  PetalWidth       2.5
 596 │ Iris-virginica    146  PetalWidth       2.3
 597 │ Iris-virginica    147  PetalWidth       1.9
 598 │ Iris-virginica    148  PetalWidth       2.0
 599 │ Iris-virginica    149  PetalWidth       2.3
 600 │ Iris-virginica    150  PetalWidth       1.8
                                   585 rows omitted

julia> unstack(longdf, :id, :variable, :value)
150×5 DataFrame
 Row │ id     SepalLength  SepalWidth  PetalLength  PetalWidth
     │ Int64  Float64?     Float64?    Float64?     Float64?
─────┼─────────────────────────────────────────────────────────
   1 │     1          5.1         3.5          1.4         0.2
   2 │     2          4.9         3.0          1.4         0.2
   3 │     3          4.7         3.2          1.3         0.2
   4 │     4          4.6         3.1          1.5         0.2
   5 │     5          5.0         3.6          1.4         0.2
   6 │     6          5.4         3.9          1.7         0.4
   7 │     7          4.6         3.4          1.4         0.3
   8 │     8          5.0         3.4          1.5         0.2
  ⋮  │   ⋮         ⋮           ⋮            ⋮           ⋮
 144 │   144          6.8         3.2          5.9         2.3
 145 │   145          6.7         3.3          5.7         2.5
 146 │   146          6.7         3.0          5.2         2.3
 147 │   147          6.3         2.5          5.0         1.9
 148 │   148          6.5         3.0          5.2         2.0
 149 │   149          6.2         3.4          5.4         2.3
 150 │   150          5.9         3.0          5.1         1.8
                                               135 rows omitted
```

If the remaining columns are unique, you can skip the id variable and use:

```jldoctest reshape
julia> unstack(longdf, :variable, :value)
150×6 DataFrame
 Row │ Species         id     SepalLength  SepalWidth  PetalLength  PetalWidth
     │ String15        Int64  Float64?     Float64?    Float64?     Float64?
─────┼─────────────────────────────────────────────────────────────────────────
   1 │ Iris-setosa         1          5.1         3.5          1.4         0.2
   2 │ Iris-setosa         2          4.9         3.0          1.4         0.2
   3 │ Iris-setosa         3          4.7         3.2          1.3         0.2
   4 │ Iris-setosa         4          4.6         3.1          1.5         0.2
   5 │ Iris-setosa         5          5.0         3.6          1.4         0.2
   6 │ Iris-setosa         6          5.4         3.9          1.7         0.4
   7 │ Iris-setosa         7          4.6         3.4          1.4         0.3
   8 │ Iris-setosa         8          5.0         3.4          1.5         0.2
  ⋮  │       ⋮           ⋮         ⋮           ⋮            ⋮           ⋮
 144 │ Iris-virginica    144          6.8         3.2          5.9         2.3
 145 │ Iris-virginica    145          6.7         3.3          5.7         2.5
 146 │ Iris-virginica    146          6.7         3.0          5.2         2.3
 147 │ Iris-virginica    147          6.3         2.5          5.0         1.9
 148 │ Iris-virginica    148          6.5         3.0          5.2         2.0
 149 │ Iris-virginica    149          6.2         3.4          5.4         2.3
 150 │ Iris-virginica    150          5.9         3.0          5.1         1.8
                                                               135 rows omitted
```

You can even skip passing the `:variable` and `:value` values as positional
arguments, as they will be used by default, and write:
```jldoctest reshape
julia> unstack(longdf)
150×6 DataFrame
 Row │ Species         id     SepalLength  SepalWidth  PetalLength  PetalWidth
     │ String15        Int64  Float64?     Float64?    Float64?     Float64?
─────┼─────────────────────────────────────────────────────────────────────────
   1 │ Iris-setosa         1          5.1         3.5          1.4         0.2
   2 │ Iris-setosa         2          4.9         3.0          1.4         0.2
   3 │ Iris-setosa         3          4.7         3.2          1.3         0.2
   4 │ Iris-setosa         4          4.6         3.1          1.5         0.2
   5 │ Iris-setosa         5          5.0         3.6          1.4         0.2
   6 │ Iris-setosa         6          5.4         3.9          1.7         0.4
   7 │ Iris-setosa         7          4.6         3.4          1.4         0.3
   8 │ Iris-setosa         8          5.0         3.4          1.5         0.2
  ⋮  │       ⋮           ⋮         ⋮           ⋮            ⋮           ⋮
 144 │ Iris-virginica    144          6.8         3.2          5.9         2.3
 145 │ Iris-virginica    145          6.7         3.3          5.7         2.5
 146 │ Iris-virginica    146          6.7         3.0          5.2         2.3
 147 │ Iris-virginica    147          6.3         2.5          5.0         1.9
 148 │ Iris-virginica    148          6.5         3.0          5.2         2.0
 149 │ Iris-virginica    149          6.2         3.4          5.4         2.3
 150 │ Iris-virginica    150          5.9         3.0          5.1         1.8
                                                               135 rows omitted
```

Passing `view=true` to `stack` returns a data frame whose columns are views into
the original wide data frame. Here is an example:

```jldoctest reshape
julia> stack(iris, view=true)
600×4 DataFrame
 Row │ Species         id     variable     value
     │ String15        Int64  String       Float64
─────┼─────────────────────────────────────────────
   1 │ Iris-setosa         1  SepalLength      5.1
   2 │ Iris-setosa         2  SepalLength      4.9
   3 │ Iris-setosa         3  SepalLength      4.7
   4 │ Iris-setosa         4  SepalLength      4.6
   5 │ Iris-setosa         5  SepalLength      5.0
   6 │ Iris-setosa         6  SepalLength      5.4
   7 │ Iris-setosa         7  SepalLength      4.6
   8 │ Iris-setosa         8  SepalLength      5.0
  ⋮  │       ⋮           ⋮         ⋮          ⋮
 594 │ Iris-virginica    144  PetalWidth       2.3
 595 │ Iris-virginica    145  PetalWidth       2.5
 596 │ Iris-virginica    146  PetalWidth       2.3
 597 │ Iris-virginica    147  PetalWidth       1.9
 598 │ Iris-virginica    148  PetalWidth       2.0
 599 │ Iris-virginica    149  PetalWidth       2.3
 600 │ Iris-virginica    150  PetalWidth       1.8
                                   585 rows omitted
```

This saves memory. To create the view, several `AbstractVector`s are defined:

`:variable` column -- `EachRepeatedVector`
This repeats the variables N times where N is the number of rows of the original AbstractDataFrame.

`:value` column -- `StackedVector`
This is provides a view of the original columns stacked together.

Id columns -- `RepeatedVector`
This repeats the original columns N times where N is the number of columns stacked.

To do aggregation, use the split-apply-combine functions in combination with
`unstack` or use the `combine` keyword argument in `unstack`. Here is an example:

```jldoctest reshape
julia> using Statistics

julia> d = stack(iris, Not(:Species))
750×3 DataFrame
 Row │ Species         variable     value
     │ String15        String       Float64
─────┼──────────────────────────────────────
   1 │ Iris-setosa     SepalLength      5.1
   2 │ Iris-setosa     SepalLength      4.9
   3 │ Iris-setosa     SepalLength      4.7
   4 │ Iris-setosa     SepalLength      4.6
   5 │ Iris-setosa     SepalLength      5.0
   6 │ Iris-setosa     SepalLength      5.4
   7 │ Iris-setosa     SepalLength      4.6
   8 │ Iris-setosa     SepalLength      5.0
  ⋮  │       ⋮              ⋮          ⋮
 744 │ Iris-virginica  id             144.0
 745 │ Iris-virginica  id             145.0
 746 │ Iris-virginica  id             146.0
 747 │ Iris-virginica  id             147.0
 748 │ Iris-virginica  id             148.0
 749 │ Iris-virginica  id             149.0
 750 │ Iris-virginica  id             150.0
                            735 rows omitted

julia> agg = combine(groupby(d, [:variable, :Species]), :value => mean => :vmean)
15×3 DataFrame
 Row │ variable     Species          vmean
     │ String       String15         Float64
─────┼───────────────────────────────────────
   1 │ SepalLength  Iris-setosa        5.006
   2 │ SepalLength  Iris-versicolor    5.936
   3 │ SepalLength  Iris-virginica     6.588
   4 │ SepalWidth   Iris-setosa        3.418
   5 │ SepalWidth   Iris-versicolor    2.77
   6 │ SepalWidth   Iris-virginica     2.974
   7 │ PetalLength  Iris-setosa        1.464
   8 │ PetalLength  Iris-versicolor    4.26
   9 │ PetalLength  Iris-virginica     5.552
  10 │ PetalWidth   Iris-setosa        0.244
  11 │ PetalWidth   Iris-versicolor    1.326
  12 │ PetalWidth   Iris-virginica     2.026
  13 │ id           Iris-setosa       25.5
  14 │ id           Iris-versicolor   75.5
  15 │ id           Iris-virginica   125.5

julia> unstack(agg, :variable, :Species, :vmean)
5×4 DataFrame
 Row │ variable     Iris-setosa  Iris-versicolor  Iris-virginica
     │ String       Float64?     Float64?         Float64?
─────┼───────────────────────────────────────────────────────────
   1 │ SepalLength        5.006            5.936           6.588
   2 │ SepalWidth         3.418            2.77            2.974
   3 │ PetalLength        1.464            4.26            5.552
   4 │ PetalWidth         0.244            1.326           2.026
   5 │ id                25.5             75.5           125.5

julia> unstack(d, :variable, :Species, :value, combine=mean)
5×4 DataFrame
 Row │ variable     Iris-setosa  Iris-versicolor  Iris-virginica
     │ String       Float64?     Float64?         Float64?
─────┼───────────────────────────────────────────────────────────
   1 │ SepalLength        5.006            5.936           6.588
   2 │ SepalWidth         3.418            2.77            2.974
   3 │ PetalLength        1.464            4.26            5.552
   4 │ PetalWidth         0.244            1.326           2.026
   5 │ id                25.5             75.5           125.5
```

To turn an `AbstractDataFrame` on its side, use [`permutedims`](@ref).

```jldoctest reshape
julia> df1 = DataFrame(a=["x", "y"], b=[1.0, 2.0], c=[3, 4], d=[true, false])
2×4 DataFrame
 Row │ a       b        c      d
     │ String  Float64  Int64  Bool
─────┼───────────────────────────────
   1 │ x           1.0      3   true
   2 │ y           2.0      4  false

julia> permutedims(df1, 1)
3×3 DataFrame
 Row │ a       x        y
     │ String  Float64  Float64
─────┼──────────────────────────
   1 │ b           1.0      2.0
   2 │ c           3.0      4.0
   3 │ d           1.0      0.0
```

Note that the column indexed by `src_colnames` in the original `df`
becomes the column names in the permuted result,
and the column names of the original become a new column.
Typically, this would be used on columns with homogeneous element types,
since the element types of the other columns
are the result of `promote_type` on _all_ the permuted columns.
Note also that, by default, the new column created from the column names
of the original `df` has the same name as `src_namescol`.
An optional positional argument `dest_namescol` can alter this:

```jldoctest reshape
julia> df2 = DataFrame(a=["x", "y"], b=[1, "two"], c=[3, 4], d=[true, false])
2×4 DataFrame
 Row │ a       b    c      d
     │ String  Any  Int64  Bool
─────┼───────────────────────────
   1 │ x       1        3   true
   2 │ y       two      4  false

julia> permutedims(df2, 1, "different_name")
3×3 DataFrame
 Row │ different_name  x     y
     │ String          Any   Any
─────┼─────────────────────────────
   1 │ b               1     two
   2 │ c               3     4
   3 │ d               true  false
```

# Customizing Display Output

DataFrames.jl uses [PrettyTables.jl](https://github.com/ronisbr/PrettyTables.jl) to render
tables in both plain text (`show(df; ...)`) and HTML
(`show(stdout, MIME("text/html"), df; ...)` in notebook-like environments).

The `show` function exposes DataFrames-specific controls and also forwards `kwargs...` to
PrettyTables.jl, so you can customize formatting, styling, and highlights.

DataFrames-specific keywords accepted by `show` are:

- `allrows::Bool` (text): print all rows instead of only the rows that fit the display
   height.
- `allcols::Bool` (text): print all columns instead of only the columns that fit the display
   width.
- `rowlabel::Symbol` (text): set the label used for the row-number column (default: `:Row`).
- `summary::Bool` (text and HTML): show or hide the summary line above the table (for
   example, `3×3 DataFrame`).
- `eltypes::Bool` (text and HTML): show or hide the column element types under the column
   names.
- `truncate::Int` (text): maximum display width for each data column before truncation with
   `…`; `0` or negative disables truncation.
- `show_row_number::Bool` (text and HTML): show or hide row numbers.
- `max_column_width::AbstractString` (HTML): maximum column width as a CSS length (for
   example, `"120px"`); empty string means no width limit.

The remaining `kwargs...` are forwarded to PrettyTables.jl for backend-specific
customization.

For HTML output, DataFrames.jl reserves `rowid`, `title`, and `truncate` keywords. Use
`max_column_width` (instead of `truncate`) to control cell width in HTML rendering, and
`top_left_str` (instead of `title`) to set the table title in HTML rendering.

```jldoctest customizing_output
julia> using DataFrames

julia> df = DataFrame(
           a = [1, 2, 3],
           b = [3.14, -1.2, 42.0],
           c = ["short", "a very very very very very long string", "ok"]
       );

julia> # This is the default output.

julia> df
3×3 DataFrame
 Row │ a      b        c
     │ Int64  Float64  String
─────┼───────────────────────────────────────────────────
   1 │     1     3.14  short
   2 │     2    -1.2   a very very very very very long …
   3 │     3    42.0   ok

julia> # Using this option, no cell will be truncated if there is room to display it.

julia> show(df; truncate = 0)
3×3 DataFrame
 Row │ a      b        c
     │ Int64  Float64  String
─────┼────────────────────────────────────────────────────────
   1 │     1     3.14  short
   2 │     2    -1.2   a very very very very very long string
   3 │     3    42.0   ok

julia> # Hide row numbers.

julia> show(df; show_row_number = false)
3×3 DataFrame
 a      b        c
 Int64  Float64  String
───────────────────────────────────────────────────
     1     3.14  short
     2    -1.2   a very very very very very long …
     3    42.0   ok

julia> # Hide the column element types in text output.

julia> show(df; eltypes = false)
3×3 DataFrame
 Row │ a  b      c
─────┼─────────────────────────────────────────────
   1 │ 1   3.14  short
   2 │ 2  -1.2   a very very very very very long …
   3 │ 3  42.0   ok
```

!!! note

    The following examples assume that PrettyTables.jl v3.0 or later is installed. If you
    have an older version of PrettyTables.jl, you may need to update it to use the features
    shown in the examples below.

We can use formatters in PrettyTables.jl to change how cells are displayed. The following
example shows how to replace negative values with parentheses in text output. We define a
formatter function:

```julia
function parentheses_fmt(v, i, j)
    !(v isa Number) && return v
    v < 0 && return "($(-v))"
    return v
end
```

This function is called for each cell in the table. `v` is the current cell value, `i` and
`j` are the row and column indices of the cell. It must return the new object which will
be printed in the cell. In this case, we only want to change cells that are negative
numbers, so we return the original value for all other cells. This function must be
encapsulated in a `Vector` and passed to the `formatters` keyword as follows:

```jldoctest customizing_output
julia> using PrettyTables

julia> df = DataFrame(
           A = [ 0.73, -1.28,  1.91, -0.44,  0.12, -2.35,  1.08],
           B = [-0.55,  0.67, -1.49,  2.11, -0.03,  0.94, -2.20],
           C = [ 1.34, -0.88,  0.45, -1.76,  2.53, -0.61,  0.07],
           D = [-1.02,  2.40, -0.31,  0.58, -2.14,  1.77, -0.90],
           E = [ 0.26, -1.67,  2.22, -0.75,  1.05, -0.48, -2.93]
       );

julia> # This is the default output.

julia> df
7×5 DataFrame
 Row │ A        B        C        D        E
     │ Float64  Float64  Float64  Float64  Float64 
─────┼─────────────────────────────────────────────
   1 │    0.73    -0.55     1.34    -1.02     0.26
   2 │   -1.28     0.67    -0.88     2.4     -1.67
   3 │    1.91    -1.49     0.45    -0.31     2.22
   4 │   -0.44     2.11    -1.76     0.58    -0.75
   5 │    0.12    -0.03     2.53    -2.14     1.05
   6 │   -2.35     0.94    -0.61     1.77    -0.48
   7 │    1.08    -2.2      0.07    -0.9     -2.93

julia> function parentheses_fmt(v, i, j)
           !(v isa Number) && return v
           v < 0 && return "($(-v))"
           return v
       end;

julia> show(df; formatters = [parentheses_fmt])
7×5 DataFrame
 Row │ A        B        C        D        E
     │ Float64  Float64  Float64  Float64  Float64
─────┼─────────────────────────────────────────────
   1 │   0.73    (0.55)    1.34    (1.02)    0.26
   2 │  (1.28)    0.67    (0.88)    2.4     (1.67)
   3 │   1.91    (1.49)    0.45    (0.31)    2.22
   4 │  (0.44)    2.11    (1.76)    0.58    (0.75)
   5 │   0.12    (0.03)    2.53    (2.14)    1.05
   6 │  (2.35)    0.94    (0.61)    1.77    (0.48)
   7 │   1.08    (2.2)     0.07    (0.9)    (2.93)
```

The color of the cells can be changed using highlighters. The following example shows how to
highlight negative values in red in HTML output (e.g. in Jupyter).

```julia
julia> hl = HtmlHighlighter((data, i, j) -> data[i, j] < 0, ["color" => "red"]);

julia> show(
           stdout,
           MIME("text/html"),
           df;
           highlighters = [hl]
       )
```

You can also add summary rows at the bottom of a table using PrettyTables.jl keywords.  Pass
a vector of functions to the `summary_rows` parameter to compute metrics, and optionally use
`summary_row_labels` to set labels for those rows.

In the following example, a table displays quarterly profits for a fictional company. The
columns represent years (2020 through 2025), the rows represent quarters, and the summary
rows show the mean and standard deviation for each year, calculated across the four
quarterly values in that column.

```jldoctest customizing_output
julia> using Statistics, PrettyTables

julia> profit = DataFrame(
           "2020" => [ 94.6, -105.6, -104.9,  -88.0],
           "2021" => [-84.3,   -8.7, -109.6,   75.8],
           "2022" => [172.6,  -42.5,   95.5, -141.0],
           "2023" => [-71.2,   51.6,  114.3,   15.5],
           "2024" => [-35.4,  -44.9,  140.3,   30.8],
           "2025" => [ 24.1,  136.1,   34.8, -183.7]
       );

julia> show(
           profit;
           # We use this option to align the summary rows with the data rows at the decimal
           # point.
           apply_alignment_regex_to_summary_rows = true,
           summary_rows = [mean, std],
           summary_row_labels = ["Mean", "Std. Dev."]
       )
4×6 DataFrame
       Row │ 2020       2021       2022      2023      2024      2025
           │ Float64    Float64    Float64   Float64   Float64   Float64
───────────┼──────────────────────────────────────────────────────────────
         1 │   94.6      -84.3      172.6    -71.2     -35.4       24.1
         2 │ -105.6       -8.7      -42.5     51.6     -44.9      136.1
         3 │ -104.9     -109.6       95.5    114.3     140.3       34.8
         4 │  -88.0       75.8     -141.0     15.5      30.8     -183.7
───────────┼──────────────────────────────────────────────────────────────
      Mean │  -50.975    -31.7       21.15    27.55     22.7        2.825
 Std. Dev. │   97.3905    83.5073   140.011   77.4612   85.3244   134.2
```

For more customization options, check the
[PrettyTables.jl documentation](https://ronisbr.github.io/PrettyTables.jl/stable/).

# Metadata

## Design of metadata support

DataFrames.jl allows you to store and retrieve metadata on table and column
level. This is supported using the functions defined by the DataAPI.jl interface:

* for table-level metadata: [`metadata`](@ref), [`metadatakeys`](@ref),
  [`metadata!`](@ref), [`deletemetadata!`](@ref), [`emptymetadata!`](@ref);
* for column-level metadata: [`colmetadata`](@ref), [`colmetadatakeys`](@ref),
  [`colmetadata!`](@ref), [`deletecolmetadata!`](@ref), [`emptycolmetadata!`](@ref).

Additionally you might find the
[TableMetadataTools.jl](https://github.com/JuliaData/TableMetadataTools.jl)
package useful. This package defines several convenience functions for
performing typical metadata operations.

Assume that we work with a data frame-like object `df` that has a column `col`
(referred to either via a `Symbol`, a string or an integer index).

Table-level metadata are key-value pairs that are attached to `df`.
Column-level metadata are key-value pairs that are attached to
a specific column `col` of `df` data frame.

To check whether some key `key` is present in table-level metadata of data frame `df`
you can write `key in metadatakeys(df)`. Similarly to check whether key `key` is present
in column-level metadata of data frame `df` for column `col` write
`key in colmetadatakeys(df, col)`.

Additionally each metadata key-value pair has a style information attached to
it.
In DataFrames.jl the metadata style influences how metadata is propagated when
`df` is transformed. The following metadata styles are supported:

* `:default`: Metadata having this style is considered to be attached to a concrete
  state of `df`. This means that any operation on this data frame
  invalidates such metadata and it is dropped in the result of such operation.
  Note that this happens even if the operation eventually does not change
  the data frame: the rule is that calling a function that might alter a data
  frame drops such metadata; in this way it is possible to statically determine
  whether metadata of styles other than `:note` is dropped after a function call.
  Only two functions are exceptions that keep non-`:note`-style metadata, as these
  operations are specifically designed to create an identical copy of the source
  data frame:
    - [`DataFrame`](@ref) constructor;
    - [`copy`](@ref) of a data frame;
* `:note`: Metadata having this style is considered to be an annotation of
  a table or a column that should be propagated under transformations
  (exact propagation rules of such metadata are described below).
* All other metadata styles are allowed but they are currently treated as having
  `:default`-style (this might change in the future if other standard metadata
  styles are defined).

All DataAPI.jl metadata functions work with [`DataFrame`](@ref),
[`SubDataFrame`](@ref), [`DataFrameRow`](@ref)
objects, and objects returned by [`eachrow`](@ref) and [`eachcol`](@ref)
functions. In this section collectively these objects will be called
*data frame-like*, and follow the rules:

* objects returned by
  [`eachrow`](@ref) and [`eachcol`](@ref) functions have the same metadata
  as their parent `AbstractDataFrame`;
* [`SubDataFrame`](@ref) and [`DataFrameRow`](@ref) only expose metadata from
  their parent `DataFrame` whose style is `:note`.

Notably, metadata is not supported for [`GroupedDataFrame`](@ref) and you can't
add, modify, nor view metadata through the [`GroupedDataFrame`](@ref) itself.
It is possible only through its `parent`.

!!! note

    DataFrames.jl allows users to extract out columns of a data frame
    and perform operations on them. Such operations will not affect
    metadata. Therefore, even if some metadata has `:default` style it might
    no longer correctly describe the column's contents if the user mutates
    columns directly.

### DataFrames.jl-specific design principles for use of metadata

DataFrames.jl supports storing any object as metadata values. However,
it is recommended to use strings as values of the metadata,
as some storage formats, like for example Apache Arrow, only support
strings.

For all functions that operate on column-level metadata, an `ArgumentError` is
thrown if passed column is not present in a data frame.

If [`metadata!`](@ref) or [`colmetadata!`](@ref) is used to add metadata
to a [`SubDataFrame`](@ref) or a [`DataFrameRow`](@ref) then:

* using metadata that has style other than `:note` throws an error;
* trying to add key-value pair for which a mapping for key already exists
  with style other than `:note` in the parent data frame throws an error.

DataFrames.jl is designed so that there is no performance overhead due to metadata support
when there is no metadata in a data frame. Therefore if you need maximum performance
of operations that do not rely on metadata call `emptymetadata!` and
`emptycolmetadata!` before running these operations.

Processing metadata for `SubDataFrame` and `DataFrameRow` has more overhead
than for other types defined in DataFrames.jl that support metadata, because
they have a more complex logic of handling it (they support only `:note`-style
metadata, which means that other metadata needs to be filtered-out).

## Examples

Here is a simple example how you can work with metadata in DataFrames.jl:

```jldoctest dataframe
julia> using DataFrames

julia> df = DataFrame(name=["Jan Krzysztof Duda", "Jan Krzysztof Duda",
                            "Radosław Wojtaszek", "Radosław Wojtaszek"],
                      date=["2022-Jun", "2021-Jun", "2022-Jun", "2021-Jun"],
                      rating=[2750, 2729, 2708, 2687])
4×3 DataFrame
 Row │ name                date      rating
     │ String              String    Int64
─────┼──────────────────────────────────────
   1 │ Jan Krzysztof Duda  2022-Jun    2750
   2 │ Jan Krzysztof Duda  2021-Jun    2729
   3 │ Radosław Wojtaszek  2022-Jun    2708
   4 │ Radosław Wojtaszek  2021-Jun    2687

julia> metadatakeys(df)
()

julia> metadata!(df, "caption", "ELO ratings of chess players", style=:note);

julia> collect(metadatakeys(df))
1-element Vector{String}:
 "caption"

julia> "caption" in metadatakeys(df)
true

julia> metadata(df, "caption")
"ELO ratings of chess players"

julia> metadata(df, "caption", style=true)
("ELO ratings of chess players", :note)

julia> emptymetadata!(df);

julia> metadatakeys(df)
()

julia> colmetadatakeys(df)
()

julia> colmetadata!(df, :name, "label", "First and last name of a player", style=:note);

julia> colmetadata!(df, :date, "label", "Rating date in yyyy-u format", style=:note);

julia> colmetadata!(df, :rating, "label", "ELO rating in classical time control", style=:note);

julia> "label" in colmetadatakeys(df, :rating)
true

julia> colmetadata(df, :rating, "label")
"ELO rating in classical time control"

julia> colmetadata(df, :rating, "label", style=true)
("ELO rating in classical time control", :note)

julia> collect(colmetadatakeys(df))
3-element Vector{Pair{Symbol, Base.KeySet{String, Dict{String, Tuple{Any, Any}}}}}:
   :date => ["label"]
 :rating => ["label"]
   :name => ["label"]

julia> [only(names(df, col)) =>
        [key => colmetadata(df, col, key) for key in metakeys] for
        (col, metakeys) in colmetadatakeys(df)]
3-element Vector{Pair{String, Vector{Pair{String, String}}}}:
   "date" => ["label" => "Rating date in yyyy-u format"]
 "rating" => ["label" => "ELO rating in classical time control"]
   "name" => ["label" => "First and last name of a player"]

julia> emptycolmetadata!(df);

julia> colmetadatakeys(df)
()
```

## Propagation of `:note`-style metadata

An important design feature of `:note`-style metadata is how it is handled when
data frames are transformed.

!!! note

    The provided rules might slightly change in the future. Any change to
    `:note`-style metadata propagation rules will not be considered as breaking
    and can be done in any minor release of DataFrames.jl.
    Such changes might be made based on users' feedback about what metadata
    propagation rules are most convenient in practice.

The general design rules for propagation of `:note`-style metadata are as follows.

For operations that take a single data frame as an input:
* Table level metadata is propagated to the returned data frame object.
* For column-level metadata:
  - in all cases when a single column is transformed to
    a single column and the name of the column does
    not change (or is automatically changed e.g. to de-duplicate column names or
    via column renaming in joins)
    column-level metadata is preserved (example operations of this kind are
    `getindex`, `subset`, joins, `mapcols`).
  - in all cases when a single column is transformed with `identity` or `copy` to a single column,
    column-level metadata is preserved even if column name is changed (example
    operations of this kind are `rename`, or the `:x => :y` or
    `:x => copy => :y` operation specification in `select`).

For operations that take multiple data frames as their input two cases are distinguished:

- When there is a natural main table in the operation (`append!`, `prepend!`,
  `leftjoin`, `leftjoin!`, `rightjoin`, `semijoin`, `antijoin`, `setindex!`):
  - table-level metadata is taken from the main table;
  - column-level metadata for columns from the main table is taken from main table;
  - column-level metadata for columns from the non-main table is taken only for
    columns not present in the main table.
- When all tables are equivalent (`hcat`, `vcat`, `innerjoin`, `outerjoin`):
  - table-level metadata is preserved only for keys which are defined
    in all passed tables and have the same value;
  - column-level metadata is preserved only for keys which are defined
    in all passed tables that contain this column and have the same value.
In all these operations when metadata is preserved the values in the key-value
pairs are not copied (this is relevant in case of mutable values).

!!! note

    The rules for column-level `:note`-style metadata propagation are designed
    to make the right decision in common cases. In particular, they assume that if
    source and target column name is the same then the metadata for the column is
    not changed. While this is valid for many operations, it is not always true
    in general. For example the `:x => ByRow(log) => :x` transformation might
    invalidate metadata if it contained unit of measure of the variable. In such
    cases user must either use a different name for the output column,
    set metadata style to `:default` before the operation,
    or manually drop or update such metadata from the `:x` column
    after the transformation.

### Operations that preserve `:note`-style metadata

Most of the functions in DataFrames.jl only preserve table and column metadata
whose style is `:note`.
Some functions use a more complex logic, even if they follow the general rules
described above (in particular under any transformation all non-`:note`-style
metadata is always dropped). These are:

* [`describe`](@ref) drops all metadata.
* [`hcat`](@ref): propagates table-level metadata only for keys which are defined
  in all passed tables and have the same value;
  column-level metadata is preserved.
* [`vcat`](@ref): propagates table-level metadata only for keys which are defined
  in all passed tables and have the same value;
  column-level metadata is preserved only for keys which are defined
  in all passed tables that contain this column and have the same value;
* [`stack`](@ref): propagates table-level metadata and column-level metadata
  for identifier columns.
* [`unstack`](@ref): propagates table-level metadata and column-level metadata
  for row keys columns.
* [`permutedims`](@ref): propagates table-level metadata and drops column-level
   metadata.
* broadcasted assignment does not change target metadata:
  operation preserves only `:note`-style metadata
* broadcasting propagates table-level metadata if some key is present
  in all passed data frames and value associated with it is identical in all
  passed data frames; column-level metadata is propagated for columns if some
  key for a given column is present in all passed data frames and value
  associated with it is identical in all passed data frames.
* `getindex` preserves table-level metadata and column-level metadata
  for selected columns
* `setindex!` does not affect table-level and column-level metadata
* [`push!`](@ref), [`pushfirst!`](@ref), [`insert!`](@ref) do not affect
  table-level nor column-level metadata (even if they add new columns and pushed row is
  a `DataFrameRow` or other value supporting metadata interface)
* [`append!`](@ref) and [`prepend!`](@ref) do not change table and column-level
  metadata of the destination data frame, except that if new columns are added
  and these columns have metadata in the appended/prepended table then this
  metadata is preserved.
* [`leftjoin!`](@ref), [`leftjoin`](@ref): table and column-level metadata is
  taken from the left table except for non-key columns from right table for which
  metadata is taken from right table;
* [`rightjoin`](@ref): table and column-level metadata is taken from the right
  table except for non-key columns from left table for which metadata is
  taken from left table;
* [`innerjoin`](@ref), [`outerjoin`](@ref): propagates table-level metadata only for keys
  that are defined in all passed data frames and have the same value;
  column-level metadata is propagated for all columns except for key
  columns, for which it is propagated only for keys that are defined
  in all passed data frames and have the same value.
* [`semijoin`](@ref), [`antijoin`](@ref): table and column-level metadata is
  taken from the left table.
* [`crossjoin`](@ref): propagates table-level metadata only for keys
  that are defined in both passed data frames and have the same value;
  propagates column-level metadata from both passed data frames.
* [`select`](@ref), [`select!`](@ref), [`transform`](@ref),
  [`transform!`](@ref), [`combine`](@ref): propagate table-level metadata;
  column-level metadata is propagated if:
  a) a single column is transformed to a single column and the name of the column does not change
     (this includes all column selection operations), or
  b) a single column is transformed with `identity` or `copy` to a single column
     even if column name is changed (this includes column renaming).

```@meta
CurrentModule = DataFrames
```

# Functions

## Multithreading support

By default, selected operations in DataFrames.jl automatically use multiple threads
when available. Multi-threading is task-based and implemented using the `@spawn`
macro from Julia Base. Tasks are therefore scheduled on the `:default` threadpool.
Functions that take user-defined functions and may run it in parallel
accept a `threads` keyword argument which allows disabling multithreading
when the provided function requires serial execution or is not thread-safe.

This is a list of operations that currently make use of multi-threading:
- `DataFrame` constructor with `copycols=true`; also recursively all functions
  that call this constructor, e.g. `copy`.
- `getindex` when multiple columns are selected.
- `groupby` (both when hashing is required and when fast path using `DataAPI.refpool`
  is used).
- `*join` functions for composing output data frame (but currently not for finding
  matching rows in joined data frames).
- `combine`, `select[!]`, and `transform[!]` on `GroupedDataFrame` when either of the conditions below is met:
  * multiple transformations are performed (each transformation is spawned in a separate task)
  * a transformation produces one row per group and the passed transformation
    is a custom function (i.e. not for standard reductions, which use
    optimized single-threaded methods).
- `dropmissing` when the provided data frame has more than 1 column and `view=false` 
  (subsetting of individual columns is spawned in separate tasks).

In general to ensure that multi-threading is used Julia process must be started with more than one thread.
Some operations turn on multi-threading only if enough rows are present
in the processed data frame.
(the exact threshold when multi-threading is enabled is considered to be undefined
and might change in the future).

Except for the list above, where multi-threading is used automatically,
all functions provided by DataFrames.jl that update a data frame are not thread safe.
This means that while they can be called from any thread, the caller is responsible
for ensuring that a given `DataFrame` object is never modified by one thread while
others are using it (either for reading or writing). Using the same `DataFrame`
at the same time from different threads is safe as long as it is not modified.

## Index
```@index
Pages = ["functions.md"]
```

## Constructing data frames
```@docs
allcombinations
copy
similar
```

## Summary information
```@docs
describe
isempty
length
ncol
ndims
nrow
rownumber
show
size
```

## Working with column names
```@docs
names
propertynames
rename
rename!
```

## Mutating and transforming data frames and grouped data frames
```@docs
append!
combine
fillcombinations
flatten
hcat
insert!
insertcols
insertcols!
invpermute!
mapcols
mapcols!
permute!
prepend!
push!
pushfirst!
reduce
repeat
repeat!
reverse
reverse!
select
select!
shuffle
shuffle!
table_transformation
transform
transform!
vcat
```

## Reshaping data frames between tall and wide formats
```@docs
stack
unstack
permutedims
```

## Sorting
```@docs
issorted
order
sort
sort!
sortperm
```

## Joining
```@docs
antijoin
crossjoin
innerjoin
leftjoin
leftjoin!
outerjoin
rightjoin
semijoin
```

## Grouping
```@docs
get
groupby
groupcols
groupindices
keys
parent
proprow
valuecols
```

## Filtering rows
```@docs
allunique
deleteat!
empty
empty!
filter
filter!
keepat!
first
last
nonunique
only
pop!
popat!
popfirst!
resize!
subset
subset!
unique
unique!
```

## Working with missing values
```@docs
allowmissing
allowmissing!
completecases
disallowmissing
disallowmissing!
dropmissing
dropmissing!
```

## Iteration
```@docs
eachcol
eachrow
values
pairs
Iterators.partition
```

## Equality
```@docs
isapprox
```

## Metadata
```@docs
metadata
metadatakeys
metadata!
deletemetadata!
emptymetadata!
colmetadata
colmetadatakeys
colmetadata!
deletecolmetadata!
emptycolmetadata!
```

# Data manipulation frameworks

Four frameworks provide convenience methods to manipulate `DataFrame`s:
TidierData.jl, DataFramesMeta.jl, DataFrameMacros.jl and Query.jl. They implement a functionality similar to
[dplyr](https://dplyr.tidyverse.org/) or
[LINQ](https://en.wikipedia.org/wiki/Language_Integrated_Query).

These frameworks are designed both to make it easier for new users to start working with data frames in Julia
and to allow advanced users to write more compact code.

## TidierData.jl
[TidierData.jl](https://tidierorg.github.io/TidierData.jl/latest/), part of 
the [Tidier](https://tidierorg.github.io/Tidier.jl/dev/) ecosystem, is a macro-based 
data analysis interface that wraps DataFrames.jl.  The instructions below are for version 
0.16.0 of TidierData.jl.

First, install the TidierData.jl package:

```julia
using Pkg
Pkg.add("TidierData")
```

TidierData.jl enables clean, readable, and fast code for all major data transformation 
functions including 
[aggregating](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/summarize/), 
[pivoting](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/pivots/), 
[nesting](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/nesting/), 
and [joining](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/joins/) 
data frames. TidierData re-exports `DataFrame` from DataFrames.jl, `@chain` from Chain.jl, and 
Statistics.jl to streamline data operations. 

TidierData.jl is heavily inspired by the `dplyr` and `tidyr` R packages (part of the R 
`tidyverse`), which it aims to implement using pure Julia by wrapping DataFrames.jl. While
TidierData.jl borrows conventions from the `tidyverse`, it is important to note that the 
`tidyverse` itself is often not considered idiomatic R code. TidierData.jl brings 
data analysis conventions from `tidyverse` into Julia to have the best of both worlds: 
tidy syntax and the speed and flexibility of the Julia language.

TidierData.jl has two major differences from other macro-based packages. First, TidierData.jl 
uses tidy expressions. An example of a tidy expression is `a = mean(b)`, where `b` refers 
to an existing column in the data frame, and `a` refers to either a new or existing column. 
Referring to variables outside of the data frame requires prefixing variables with `!!`. 
For example, `a = mean(!!b)` refers to a variable `b` outside the data frame. Second, 
TidierData.jl aims to make broadcasting mostly invisible through 
[auto-vectorization](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/autovec/). TidierData.jl currently uses a lookup table to decide which functions not to 
vectorize; all other functions are automatically vectorized. This allows for 
writing of concise expressions: `@mutate(df, a = a - mean(a))` transforms the `a` column 
by subtracting each value by the mean of the column. Behind the scenes, the right-hand 
expression is converted to `a .- mean(a)` because `mean()` is in the lookup table as a 
function that should not be vectorized. Take a look at the 
[auto-vectorization](https://tidierorg.github.io/TidierData.jl/latest/examples/generated/UserGuide/autovec/) documentation for details.

One major benefit of combining tidy expressions with auto-vectorization is that 
TidierData.jl code (which uses DataFrames.jl as its backend) can work directly on 
databases using [TidierDB.jl](https://github.com/TidierOrg/TidierDB.jl), 
which converts tidy expressions into SQL, supporting DuckDB and several other backends.

```jldoctest tidierdata
julia> using TidierData

julia> df = DataFrame(
                name = ["John", "Sally", "Roger"],
                age = [54.0, 34.0, 79.0],
                children = [0, 2, 4]
            )
3×3 DataFrame
 Row │ name    age      children
     │ String  Float64  Int64
─────┼───────────────────────────
   1 │ John       54.0         0
   2 │ Sally      34.0         2
   3 │ Roger      79.0         4

julia> @chain df begin
           @filter(children != 2)
           @select(name, num_children = children)
       end
2×2 DataFrame
 Row │ name    num_children 
     │ String  Int64        
─────┼──────────────────────
   1 │ John               0
   2 │ Roger              4
```

Below are examples showcasing `@group_by` with `@summarize` or `@mutate` - analagous to the split, apply, combine pattern.

```jldoctest tidierdata
julia> df = DataFrame(
                groups = repeat('a':'e', inner = 2), 
                b_col = 1:10, 
                c_col = 11:20, 
                d_col = 111:120
            )
10×4 DataFrame
 Row │ groups  b_col  c_col  d_col 
     │ Char    Int64  Int64  Int64 
─────┼─────────────────────────────
   1 │ a           1     11    111
   2 │ a           2     12    112
   3 │ b           3     13    113
   4 │ b           4     14    114
   5 │ c           5     15    115
   6 │ c           6     16    116
   7 │ d           7     17    117
   8 │ d           8     18    118
   9 │ e           9     19    119
  10 │ e          10     20    120

julia> @chain df begin
           @filter(b_col > 2)
           @group_by(groups)
           @summarise(median_b = median(b_col), 
                      across((b_col:d_col), mean))   
       end
4×5 DataFrame
 Row │ groups  median_b  b_col_mean  c_col_mean  d_col_mean 
     │ Char    Float64   Float64     Float64     Float64    
─────┼──────────────────────────────────────────────────────
   1 │ b            3.5         3.5        13.5       113.5
   2 │ c            5.5         5.5        15.5       115.5
   3 │ d            7.5         7.5        17.5       117.5
   4 │ e            9.5         9.5        19.5       119.5

julia> @chain df begin
           @filter(b_col > 4 && c_col <= 18)
           @group_by(groups)
           @mutate(
               new_col = b_col + maximum(d_col),
               new_col2 = c_col - maximum(d_col),
               new_col3 = case_when(c_col >= 18  => "high",
                                    c_col > 15   => "medium",
                                    true         => "low"))
           @select(starts_with("new"))
           @ungroup # required because `@mutate` does not ungroup
       end
4×4 DataFrame
 Row │ groups  new_col  new_col2  new_col3 
     │ Char    Int64    Int64     String   
─────┼─────────────────────────────────────
   1 │ c           121      -101  low
   2 │ c           122      -100  medium
   3 │ d           125      -101  medium
   4 │ d           126      -100  high
```

For more examples, please visit the [TidierData.jl](https://tidierorg.github.io/TidierData.jl/latest/) documentation.

## DataFramesMeta.jl

The [DataFramesMeta.jl](https://github.com/JuliaStats/DataFramesMeta.jl) package
provides a convenient yet fast macro-based interface to work with `DataFrame`s.
The instructions below are for version 0.10.0 of DataFramesMeta.jl.

First install the DataFramesMeta.jl package:

```julia
using Pkg
Pkg.add("DataFramesMeta")
```

The major benefit of the package is it provides a more convenient syntax
for the transformation functions `transform`, `select`, and `combine` 
via the macros `@transform`, `@select`, `@combine`, and more.

DataFramesMeta.jl also reexports the `@chain` macro from 
[Chain.jl](https://github.com/jkrumbiegel/Chain.jl), allowing users to
pipe the output of one transformation as an input to another, as with 
`|>` and `%>%` in R. 

Below we present several selected examples of usage of the package.

First we subset rows of the source data frame using a logical condition
and select two of its columns, renaming one of them:

```jldoctest dataframesmeta
julia> using DataFramesMeta

julia> df = DataFrame(name=["John", "Sally", "Roger"],
                      age=[54.0, 34.0, 79.0],
                      children=[0, 2, 4])
3×3 DataFrame
 Row │ name    age      children
     │ String  Float64  Int64
─────┼───────────────────────────
   1 │ John       54.0         0
   2 │ Sally      34.0         2
   3 │ Roger      79.0         4

julia> @chain df begin
           @rsubset :age > 40 
           @select(:number_of_children = :children, :name)
       end
2×2 DataFrame
 Row │ number_of_children  name
     │ Int64               String
─────┼────────────────────────────
   1 │                  0  John
   2 │                  4  Roger
```

In the following examples we show that DataFramesMeta.jl also supports the split-apply-combine pattern:

```jldoctest dataframesmeta
julia> df = DataFrame(key=repeat(1:3, 4), value=1:12)
12×2 DataFrame
 Row │ key    value
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3
   4 │     1      4
   5 │     2      5
   6 │     3      6
   7 │     1      7
   8 │     2      8
   9 │     3      9
  10 │     1     10
  11 │     2     11
  12 │     3     12

julia> @chain df begin
           @rsubset :value > 3 
           @by(:key, :min = minimum(:value), :max = maximum(:value))
           @select(:key, :range = :max - :min)
        end
3×2 DataFrame
 Row │ key    range
     │ Int64  Int64
─────┼──────────────
   1 │     1      6
   2 │     2      6
   3 │     3      6

julia> @chain df begin
           groupby(:key)
           @transform :value0 = :value .- minimum(:value)
       end
12×3 DataFrame
 Row │ key    value  value0
     │ Int64  Int64  Int64
─────┼──────────────────────
   1 │     1      1       0
   2 │     2      2       0
   3 │     3      3       0
   4 │     1      4       3
   5 │     2      5       3
   6 │     3      6       3
   7 │     1      7       6
   8 │     2      8       6
   9 │     3      9       6
  10 │     1     10       9
  11 │     2     11       9
  12 │     3     12       9
```

You can find more details about how this package can be used on the
[DataFramesMeta.jl GitHub page](https://github.com/JuliaData/DataFramesMeta.jl).

## DataFrameMacros.jl

[DataFrameMacros.jl](https://github.com/jkrumbiegel/DataFrameMacros.jl) is
an alternative to DataFramesMeta.jl with an additional focus on convenient
solutions for the transformation of multiple columns at once.
The instructions below are for version 0.3 of DataFrameMacros.jl.

First, install the DataFrameMacros.jl package:

```julia
using Pkg
Pkg.add("DataFrameMacros")
```

In DataFrameMacros.jl, all but the `@combine` macro are row-wise by default.
There is also a `@groupby` which allows creating grouping columns on the fly
using the same syntax as `@transform`, for grouping by new columns
without writing them out twice.

In the example below, you can also see some of DataFrameMacros.jl's multi-column
features, where `mean` is applied to both age columns at once by selecting
them with the `r"age"` regex. The new column names are then derived using the
`"{}"` shortcut which splices the transformed column names into a string.

```jldoctest dataframemacros
julia> using DataFrames, DataFrameMacros, Chain, Statistics

julia> df = DataFrame(name=["John", "Sally", "Roger"],
                      age=[54.0, 34.0, 79.0],
                      children=[0, 2, 4])
3×3 DataFrame
 Row │ name    age      children 
     │ String  Float64  Int64    
─────┼───────────────────────────
   1 │ John       54.0         0
   2 │ Sally      34.0         2
   3 │ Roger      79.0         4

julia> @chain df begin
           @transform :age_months = :age * 12
           @groupby :has_child = :children > 0
           @combine "mean_{}" = mean({r"age"})
       end
2×3 DataFrame
 Row │ has_child  mean_age  mean_age_months 
     │ Bool       Float64   Float64         
─────┼──────────────────────────────────────
   1 │     false      54.0            648.0
   2 │      true      56.5            678.0
```

There's also the capability to reference a group of multiple columns as a single unit,
for example to run aggregations over them, with the `{{ }}` syntax.
In the following example, the first quarter is compared to the maximum of the other three:

```jldoctest dataframemacros
julia> df = DataFrame(q1 = [12.0, 0.4, 42.7],
                      q2 = [6.4, 2.3, 40.9],
                      q3 = [9.5, 0.2, 13.6],
                      q4 = [6.3, 5.4, 39.3])
3×4 DataFrame
 Row │ q1       q2       q3       q4      
     │ Float64  Float64  Float64  Float64 
─────┼────────────────────────────────────
   1 │    12.0      6.4      9.5      6.3
   2 │     0.4      2.3      0.2      5.4
   3 │    42.7     40.9     13.6     39.3

julia> @transform df :q1_best = :q1 > maximum({{Not(:q1)}})
3×5 DataFrame
 Row │ q1       q2       q3       q4       q1_best 
     │ Float64  Float64  Float64  Float64  Bool    
─────┼─────────────────────────────────────────────
   1 │    12.0      6.4      9.5      6.3     true
   2 │     0.4      2.3      0.2      5.4    false
   3 │    42.7     40.9     13.6     39.3     true
```

## Query.jl

The [Query.jl](https://github.com/queryverse/Query.jl) package provides advanced
data manipulation capabilities for `DataFrame`s (and many other data
structures). This section provides a short introduction to the package, the
[Query.jl documentation](http://www.queryverse.org/Query.jl/stable/) has a more
comprehensive documentation of the package. The instructions here are for version
1.0.0 of Query.jl.

To get started, install the Query.jl package:

```julia
using Pkg
Pkg.add("Query")
```

A query is started with the `@from` macro and consists of a series of query
commands. Query.jl provides commands that can filter, project, join, flatten and
group data from a `DataFrame`. A query can return an iterator, or one can
materialize the results of a query into a variety of data structures, including
a new `DataFrame`.

A simple example of a query looks like this:

```jldoctest query
julia> using DataFrames, Query

julia> df = DataFrame(name=["John", "Sally", "Roger"],
                      age=[54.0, 34.0, 79.0],
                      children=[0, 2, 4])
3×3 DataFrame
 Row │ name    age      children
     │ String  Float64  Int64
─────┼───────────────────────────
   1 │ John       54.0         0
   2 │ Sally      34.0         2
   3 │ Roger      79.0         4

julia> q1 = @from i in df begin
            @where i.age > 40
            @select {number_of_children=i.children, i.name}
            @collect DataFrame
       end
2×2 DataFrame
 Row │ number_of_children  name
     │ Int64               String
─────┼────────────────────────────
   1 │                  0  John
   2 │                  4  Roger
```

The query starts with the `@from` macro. The first argument `i` is the name of
the range variable that will be used to refer to an individual row in later
query commands. The next argument `df` is the data source that one wants to
query. The `@where` command in this query will filter the source data by
applying the filter condition `i.age > 40`. This filters out any rows in which
the `age` column is not larger than 40. The `@select` command then projects the
columns of the source data onto a new column structure. The example here applies
three specific modifications: 1) it only keeps a subset of the columns in the
source `DataFrame`, i.e. the `age` column will not be part of the transformed
data; 2) it changes the order of the two columns that are selected; and 3) it
renames one of the columns that is selected from `children` to
`number_of_children`. The example query uses the `{}` syntax to achieve this. A
`{}` in a Query.jl expression instantiates a new
[NamedTuple](https://github.com/blackrock/NamedTuples.jl), i.e. it is a shortcut
for writing `@NT(number_of_children=>i.children, name=>i.name)`. The `@collect`
statement determines the data structure that the query returns. In this example
the results are returned as a `DataFrame`.

A query without a `@collect` statement returns a standard julia iterator that
can be used with any normal julia language construct that can deal with
iterators. The following code returns a julia iterator for the query results:

```jldoctest query
julia> q2 = @from i in df begin
                   @where i.age > 40
                   @select {number_of_children=i.children, i.name}
              end; # suppress printing the iterator type

```

One can loop over the results using a standard julia `for` statement:

```jldoctest query
julia> total_children = 0
0

julia> for i in q2
           global total_children += i.number_of_children
       end

julia> total_children
4

```

Or one can use a comprehension to extract the name of a subset of rows:

```jldoctest query
julia> y = [i.name for i in q2 if i.number_of_children > 0]
1-element Vector{String}:
 "Roger"

```

The last example (extracting only the name and applying a second filter) could
of course be completely expressed as a query expression:

```jldoctest query
julia> q3 = @from i in df begin
            @where i.age > 40 && i.children > 0
            @select i.name
            @collect
       end
1-element Vector{String}:
 "Roger"

```

A query that ends with a `@collect` statement without a specific type will
materialize the query results into an array. Note also the difference in the
`@select` statement: The previous queries all used the `{}` syntax in the
`@select` statement to project results into a tabular format. The last query
instead just selects a single value from each row in the `@select` statement.

These examples only scratch the surface of what one can do with
[Query.jl](https://github.com/queryverse/Query.jl), and the interested reader is
referred to the [Query.jl
documentation](http://www.queryverse.org/Query.jl/stable/) for more
information.

# Comparisons

This section compares DataFrames.jl with other data manipulation frameworks in Python, R, and Stata.

A sample data set can be created using the following code:

```julia
using DataFrames
using Statistics

df = DataFrame(grp=repeat(1:2, 3), x=6:-1:1, y=4:9, z=[3:7; missing], id='a':'f')
df2 = DataFrame(grp=[1, 3], w=[10, 11])
```

!!! note

    Some of the operations mutate the tables so every operation assumes that it is done on the original data frame.

Note that in the comparisons presented below predicates like `x -> x >= 1` can
be more compactly written as `>=(1)`. The latter form has an additional benefit
that it is compiled only once per Julia session (as opposed to `x -> x >= 1`
which defines a new anonymous function every time it is introduced).

## Comparison with the Python package pandas

The following table compares the main functions of DataFrames.jl with the Python package pandas (version 1.1.0):

```python
import pandas as pd
import numpy as np

df = pd.DataFrame({'grp': [1, 2, 1, 2, 1, 2],
                   'x': range(6, 0, -1),
                   'y': range(4, 10),
                   'z': [3, 4, 5, 6, 7, None]},
                   index = list('abcdef'))
df2 = pd.DataFrame({'grp': [1, 3], 'w': [10, 11]})
```

Because pandas supports multi-index, this example data frame is set up with `a` to `f`
as row indices rather than a separate `id` column.

### Accessing data

| Operation                  | pandas                  | DataFrames.jl                      |
|:---------------------------|:------------------------|:-----------------------------------|
| Cell indexing by location  | `df.iloc[1, 1]`         | `df[2, 2]`                         |
| Row slicing by location    | `df.iloc[1:3]`          | `df[2:3, :]`                       |
| Column slicing by location | `df.iloc[:, 1:]`        | `df[:, 2:end]`                     |
| Row indexing by label      | `df.loc['c']`           | `df[findfirst(==('c'), df.id), :]` |
| Column indexing by label   | `df.loc[:, 'x']`        | `df[:, :x]`                        |
| Column slicing by label    | `df.loc[:, ['x', 'z']]` | `df[:, [:x, :z]]`                  |
|                            | `df.loc[:, 'x':'z']`    | `df[:, Between(:x, :z)]`           |
| Mixed indexing             | `df.loc['c'][1]`        | `df[findfirst(==('c'), df.id), 2]` |

Note that Julia uses 1-based indexing, inclusive on both ends. A special keyword `end` can be used to
indicate the last index. Likewise, the `begin` keyword can be used to indicate the first index.

In addition, when indexing a data frame with the `findfirst` function, a single
`DataFrameRow` object is returned. In the case that `id` is not unique, you can use the `findall` function
or boolean indexing instead. It would then return a `DataFrame` object containing all matched rows. The following
two lines of code are functionally equivalent:

```julia
df[findall(==('c'), df.id), :]
df[df.id .== 'c', :]
```

DataFrames.jl's indexing always produces a consistent and predictable return type.
By contrast, pandas' `loc` function returns a `Series` object when there is exactly
one `'c'` value in the index, and it returns a `DataFrame` object when there are multiple
rows having the index value of `'c'`.

### Common operations

| Operation                | pandas                                                         | DataFrames.jl                               |
|:-------------------------|:---------------------------------------------------------------|:--------------------------------------------|
| Reduce multiple values   | `df['z'].mean(skipna = False)`                                 | `mean(df.z)`                                |
|                          | `df['z'].mean()`                                               | `mean(skipmissing(df.z))`                   |
|                          | `df[['z']].agg(['mean'])`                                      | `combine(df, :z => mean ∘ skipmissing)`     |
| Add new columns          | `df.assign(z1 = df['z'] + 1)`                                  | `transform(df, :z => (v -> v .+ 1) => :z1)` |
| Rename columns           | `df.rename(columns = {'x': 'x_new'})`                          | `rename(df, :x => :x_new)`                  |
| Pick & transform columns | `df.assign(x_mean = df['x'].mean())[['x_mean', 'y']]`          | `select(df, :x => mean, :y)`                |
| Sort rows                | `df.sort_values(by = 'x')`                                     | `sort(df, :x)`                              |
|                          | `df.sort_values(by = ['grp', 'x'], ascending = [True, False])` | `sort(df, [:grp, order(:x, rev = true)])`   |
| Drop missing rows        | `df.dropna()`                                                  | `dropmissing(df)`                           |
| Select unique rows       | `df.drop_duplicates()`                                         | `unique(df)`                                |

Note that pandas skips `NaN` values in its analytic functions by default. By contrast,
Julia functions do not skip `NaN`'s. If necessary, you can filter out
the `NaN`'s before processing, for example, `mean(Iterators.filter(!isnan, x))`.

Pandas uses `NaN` for representing both missing data and the floating point "not a number" value.
Julia defines a special value `missing` for representing missing data. DataFrames.jl respects
general rules in Julia in propagating `missing` values by default. If necessary,
the `skipmissing` function can be used to remove missing data.
See the [Missing Data](@ref) section for more information.

In addition, pandas keeps the original column name after applying a function.
DataFrames.jl appends a suffix to the column name by default. To keep it simple, the
examples above do not synchronize the column names between pandas and DataFrames.jl
(you can pass `renamecols=false` keyword argument to `select`, `transform` and
`combine` functions to retain old column names).

### Mutating operations

| Operation          | pandas                                                | DataFrames.jl                                |
|:-------------------|:------------------------------------------------------|:---------------------------------------------|
| Add new columns    | `df['z1'] = df['z'] + 1`                              | `df.z1 = df.z .+ 1`                          |
|                    |                                                       | `transform!(df, :z => (x -> x .+ 1) => :z1)` |
|                    | `df.insert(1, 'const', 10)`                           | `insertcols!(df, 2, :const => 10)`           |
| Rename columns     | `df.rename(columns = {'x': 'x_new'}, inplace = True)` | `rename!(df, :x => :x_new)`                  |
| Sort rows          | `df.sort_values(by = 'x', inplace = True)`            | `sort!(df, :x)`                              |
| Drop missing rows  | `df.dropna(inplace = True)`                           | `dropmissing!(df)`                           |
| Select unique rows | `df.drop_duplicates(inplace = True)`                  | `unique!(df)`                                |

Generally speaking, DataFrames.jl follows the Julia convention of using `!` in the
function name to indicate mutation behavior.

### Grouping data and aggregation

DataFrames.jl provides a `groupby` function to apply operations
over each group independently. The result of `groupby` is a `GroupedDataFrame` object
which may be processed using the `combine`, `transform`, or `select` functions.
The following table illustrates some common grouping and aggregation usages.


| Operation                       | pandas                                                                                 | DataFrames.jl                                        |
|:--------------------------------|:---------------------------------------------------------------------------------------|:-----------------------------------------------------|
| Aggregate by groups             | `df.groupby('grp')['x'].mean()`                                                        | `combine(groupby(df, :grp), :x => mean)`             |
| Rename column after aggregation | `df.groupby('grp')['x'].mean().rename("my_mean")`                                      | `combine(groupby(df, :grp), :x => mean => :my_mean)` |
| Add aggregated data as column   | `df.join(df.groupby('grp')['x'].mean(), on='grp', rsuffix='_mean')`                    | `transform(groupby(df, :grp), :x => mean)`           |
| ...and select output columns    | `df.join(df.groupby('grp')['x'].mean(), on='grp', rsuffix='_mean')[['grp', 'x_mean']]` | `select(groupby(df, :grp), :id, :x => mean)`         |

Note that pandas returns a `Series` object for 1-dimensional result unless `reset_index` is called afterwards.
The corresponding DataFrames.jl examples return an equivalent `DataFrame` object.
Consider the first example:

```python
>>> df.groupby('grp')['x'].mean()
grp
1    4
2    3
Name: x, dtype: int64
```

For DataFrames.jl, it looks like this:

```julia
julia> combine(groupby(df, :grp), :x => mean)
2×2 DataFrame
 Row │ grp    x_mean
     │ Int64  Float64
─────┼────────────────
   1 │     1      4.0
   2 │     2      3.0
```

In DataFrames.jl, the `GroupedDataFrame` object supports an efficient key lookup.
Hence, it performs well when you need to perform lookups repeatedly.

### More advanced commands

This section includes more complex examples.

| Operation                              | pandas                                                                       | DataFrames.jl                                             |
|:---------------------------------------|:-----------------------------------------------------------------------------|:------------------------------------------------------------------------|
| Complex Function                       | `df[['z']].agg(lambda v: np.mean(np.cos(v)))`                                | `combine(df, :z => v -> mean(cos, skipmissing(v)))`                     |
| Aggregate multiple columns             | `df.agg({'x': max, 'y': min})`                                               | `combine(df, :x => maximum, :y => minimum)`                             |
|                                        | `df[['x', 'y']].mean()`                                                      | `combine(df, [:x, :y] .=> mean)`                                        |
|                                        | `df.filter(regex=("^x")).mean()`                                             | `combine(df, names(df, r"^x") .=> mean)`                                |
| Apply function over multiple variables | `df.assign(x_y_cor = np.corrcoef(df.x, df.y)[0, 1])`                         | `transform(df, [:x, :y] => cor)`                                        |
| Row-wise operation                     | `df.assign(x_y_min = df.apply(lambda v: min(v.x, v.y), axis=1))`             | `transform(df, [:x, :y] => ByRow(min))`                                 |
|                                        | `df.assign(x_y_argmax = df.apply(lambda v: df.columns[v.argmax()], axis=1))` | `transform(df, AsTable([:x, :y]) => ByRow(argmax))`                     |
| DataFrame as input                     | `df.groupby('grp').head(2)`                                                  | `combine(d -> first(d, 2), groupby(df, :grp))`                          |
| DataFrame as output                    | `df[['x']].agg(lambda x: [min(x), max(x)])`                                  | `combine(df, :x => (x -> (x=[minimum(x), maximum(x)],)) => AsTable)`  |

Note that pandas preserves the same row order after `groupby` whereas DataFrames.jl
shows them grouped by the provided keys after the `combine` operation,
but `select` and `transform` retain an original row ordering.

### Joining data frames

DataFrames.jl supports join operations similar to a relational database.

| Operation             | pandas                                         | DataFrames.jl                   |
|:----------------------|:-----------------------------------------------|:--------------------------------|
| Inner join            | `pd.merge(df, df2, how = 'inner', on = 'grp')` | `innerjoin(df, df2, on = :grp)` |
| Outer join            | `pd.merge(df, df2, how = 'outer', on = 'grp')` | `outerjoin(df, df2, on = :grp)` |
| Left join             | `pd.merge(df, df2, how = 'left', on = 'grp')`  | `leftjoin(df, df2, on = :grp)`  |
| Right join            | `pd.merge(df, df2, how = 'right', on = 'grp')` | `rightjoin(df, df2, on = :grp)` |
| Semi join (filtering) | `df[df.grp.isin(df2.grp)]`                     | `semijoin(df, df2, on = :grp)`  |
| Anti join (filtering) | `df[~df.grp.isin(df2.grp)]`                    | `antijoin(df, df2, on = :grp)`  |

For multi-column joins, both pandas and DataFrames.jl accept an array for the `on` keyword argument.

In the cases of semi joins and anti joins, the `isin` function in pandas can still be used as long as
the join keys are [combined in a tuple](https://stackoverflow.com/questions/63660610/how-to-perform-semi-join-with-multiple-columns-in-pandas).
In DataFrames.jl, it just works normally with an array of join keys specified in the `on` keyword argument.

## Comparison with the R package dplyr

The following table compares the main functions of DataFrames.jl with the R package dplyr (version 1):

```R
df <- tibble(grp = rep(1:2, 3), x = 6:1, y = 4:9,
             z = c(3:7, NA), id = letters[1:6])
```

| Operation                | dplyr                          | DataFrames.jl                          |
|:-------------------------|:-------------------------------|:---------------------------------------|
| Reduce multiple values   | `summarize(df, mean(x))`       | `combine(df, :x => mean)`              |
| Add new columns          | `mutate(df, x_mean = mean(x))` | `transform(df, :x => mean => :x_mean)` |
| Rename columns           | `rename(df, x_new = x)`        | `rename(df, :x => :x_new)`             |
| Pick columns             | `select(df, x, y)`             | `select(df, :x, :y)`                   |
| Pick & transform columns | `transmute(df, mean(x), y)`    | `select(df, :x => mean, :y)`           |
| Pick rows                | `filter(df, x >= 1)`           | `subset(df, :x => ByRow(x -> x >= 1))` |
| Sort rows                | `arrange(df, x)`               | `sort(df, :x)`                         |

As in dplyr, some of these functions can be applied to grouped data frames, in which case they operate by group:

| Operation                | dplyr                                      | DataFrames.jl                               |
|:-------------------------|:-------------------------------------------|:--------------------------------------------|
| Reduce multiple values   | `summarize(group_by(df, grp), mean(x))`    | `combine(groupby(df, :grp), :x => mean)`    |
| Add new columns          | `mutate(group_by(df, grp), mean(x))`       | `transform(groupby(df, :grp), :x => mean)`  |
| Pick & transform columns | `transmute(group_by(df, grp), mean(x), y)` | `select(groupby(df, :grp), :x => mean, :y)` |

The table below compares more advanced commands:

| Operation                 | dplyr                                                     | DataFrames.jl                                                              |
|:--------------------------|:----------------------------------------------------------|:---------------------------------------------------------------------------|
| Complex Function          | `summarize(df, mean(x, na.rm = T))`                       | `combine(df, :x => x -> mean(skipmissing(x)))`                             |
| Transform several columns | `summarize(df, max(x), min(y))`                           | `combine(df, :x => maximum,  :y => minimum)`                               |
|                           | `summarize(df, across(c(x, y), mean))`                    | `combine(df, [:x, :y] .=> mean)`                                           |
|                           | `summarize(df, across(starts_with("x"), mean))`           | `combine(df, names(df, r"^x") .=> mean)`                                   |
|                           | `summarize(df, across(c(x, y), list(max, min)))`          | `combine(df, ([:x, :y] .=> [maximum minimum])...)`                         |
| Multivariate function     | `mutate(df, cor(x, y))`                                   | `transform(df, [:x, :y] => cor)`                                           |
| Row-wise                  | `mutate(rowwise(df), min(x, y))`                          | `transform(df, [:x, :y] => ByRow(min))`                                    |
|                           | `mutate(rowwise(df), which.max(c_across(matches("^x"))))` | `transform(df, AsTable(r"^x") => ByRow(argmax))`                           |
| DataFrame as input        | `summarize(df, head(across(), 2))`                        | `combine(d -> first(d, 2), df)`                                            |
| DataFrame as output       | `summarize(df, tibble(value = c(min(x), max(x))))`        | `combine(df, :x => (x -> (value = [minimum(x), maximum(x)],)) => AsTable)` |


## Comparison with the R package data.table

The following table compares the main functions of DataFrames.jl with the R package data.table (version 1.14.1).

```R
library(data.table)
df  <- data.table(grp = rep(1:2, 3), x = 6:1, y = 4:9,
                  z = c(3:7, NA), id = letters[1:6])
df2 <- data.table(grp=c(1,3), w = c(10,11))
```

| Operation                          | data.table                                       | DataFrames.jl                                |
|:-----------------------------------|:-------------------------------------------------|:---------------------------------------------|
| Reduce multiple values             | `df[, .(mean(x))]`                               | `combine(df, :x => mean)`                    |
| Add new columns                    | `df[, x_mean:=mean(x) ]`                         | `transform!(df, :x => mean => :x_mean)`      |
| Rename column (in place)           | `setnames(df, "x", "x_new")`                     | `rename!(df, :x => :x_new)`                  |
| Rename multiple columns (in place) | `setnames(df, c("x", "y"), c("x_new", "y_new"))` | `rename!(df, [:x, :y] .=> [:x_new, :y_new])` |
| Pick columns as dataframe          | `df[, .(x, y)]`                                  | `select(df, :x, :y)`                         |
| Pick column as a vector            | `df[, x]`                                        | `df[!, :x]`                                  |
| Remove columns                     | `df[, -"x"]`                                     | `select(df, Not(:x))`                        |
| Remove columns (in place)          | `df[, x:=NULL]`                                  | `select!(df, Not(:x))`                       |
| Remove columns (in place)          | `df[, c("x", "y"):=NULL]`                        | `select!(df, Not([:x, :y]))`                 |
| Pick & transform columns           | `df[, .(mean(x), y)]`                            | `select(df, :x => mean, :y)`                 |
| Pick rows                          | `df[ x >= 1 ]`                                   | `filter(:x => >=(1), df)`                    |
| Sort rows (in place)               | `setorder(df, x)`                                | `sort!(df, :x)`                              |
| Sort rows                          | `df[ order(x) ]`                                 | `sort(df, :x)`                               |

### Grouping data and aggregation

| Operation                   | data.table                                        | DataFrames.jl                             |
|:----------------------------|:--------------------------------------------------|:------------------------------------------|
| Reduce multiple values      | `df[, mean(x), by=id ]`                           | `combine(groupby(df, :id), :x => mean)`   |
| Add new columns (in place)  | `df[, x_mean:=mean(x), by=id]`                    | `transform!(groupby(df, :id), :x => mean)`|
| Pick & transform columns    | `df[, .(x_mean = mean(x), y), by=id]`             | `select(groupby(df, :id), :x => mean, :y)`|

### More advanced commands

| Operation                         | data.table                                                                                 | DataFrames.jl                                                               |
|:----------------------------------|:-------------------------------------------------------------------------------------------|:----------------------------------------------------------------------------|
| Complex Function                  | `df[, .(mean(x, na.rm=TRUE)) ]`                                                            | `combine(df, :x => x -> mean(skipmissing(x)))`                              |
| Transform certain rows (in place) | `df[x<=0, x:=0]`                                                                           | `df.x[df.x .<= 0] .= 0`                                                     |
| Transform several columns         | `df[, .(max(x), min(y)) ]`                                                                 | `combine(df, :x => maximum, :y => minimum)`                                 |
|                                   | `df[, lapply(.SD, mean), .SDcols = c("x", "y") ]`                                          | `combine(df, [:x, :y] .=> mean)`                                            |
|                                   | `df[, lapply(.SD, mean), .SDcols = patterns("*x") ]`                                       | `combine(df, names(df, r"^x") .=> mean)`                                    |
|                                   | `dcast(df, . ~ ., list(max,min), value.var = c("x","y"))`                                  | `combine(df, ([:x, :y] .=> [maximum minimum])...)`                          |
| Multivariate function             | `df[, .(cor(x,y)) ]`                                                                       | `transform(df, [:x, :y] => cor)`                                            |
| Row-wise                          | `df[, min_xy := min(x, y), by = 1:nrow(df)]`                                               | `transform!(df, [:x, :y] => ByRow(min))`                                    |
|                                   | `df[, argmax_xy := which.max(.SD) , .SDcols = patterns("*x"), by = 1:nrow(df) ]`           | `transform!(df, AsTable(r"^x") => ByRow(argmax))`                           |
| DataFrame as output               | `df[, .SD[1], by=grp]`                                                                     | `combine(groupby(df, :grp), first)`                                         |
| DataFrame as output               | `df[, .SD[which.max(x)], by=grp]`                                                          | `combine(groupby(df, :grp), sdf -> sdf[argmax(sdf.x), :])`                  |
| Reshape longer                    | `longdf = melt(df, measure.vars=c("x","y"), id.vars="id")`                                 | `longdf = stack(df, [:x, :y], :id)`                                         |
| Reshape wider                     | `dcast(longdf, id ~ variable, value.var="value")`                                          | `unstack(longdf, :id, :variable, :value)`

### Joining data frames

| Operation             | data.table                                      | DataFrames.jl                   |
|:----------------------|:------------------------------------------------|:--------------------------------|
| Inner join            | `merge(df, df2, on = "grp")`                    | `innerjoin(df, df2, on = :grp)` |
| Outer join            | `merge(df, df2, all = TRUE, on = "grp")`        | `outerjoin(df, df2, on = :grp)` |
| Left join             | `merge(df, df2, all.x = TRUE, on = "grp")`      | `leftjoin(df, df2, on = :grp)`  |
| Right join            | `merge(df, df2, all.y = TRUE, on = "grp")`      | `rightjoin(df, df2, on = :grp)` |
| Anti join (filtering) | `df[!df2, on = "grp" ]`                         | `antijoin(df, df2, on = :grp)`  |
| Semi join (filtering) | `merge(df1, df2[, .(grp)])   `                  | `semijoin(df, df2, on = :grp)`  |


## Comparison with Stata (version 8 and above)

The following table compares the main functions of DataFrames.jl with Stata:

| Operation              | Stata                   | DataFrames.jl                           |
|:-----------------------|:------------------------|:----------------------------------------|
| Reduce multiple values | `collapse (mean) x`     | `combine(df, :x => mean)`               |
| Add new columns        | `egen x_mean = mean(x)` | `transform!(df, :x => mean => :x_mean)` |
| Rename columns         | `rename x x_new`        | `rename!(df, :x => :x_new)`             |
| Pick columns           | `keep x y`              | `select!(df, :x, :y)`                   |
| Pick rows              | `keep if x >= 1`        | `subset!(df, :x => ByRow(x -> x >= 1))` |
| Sort rows              | `sort x`                | `sort!(df, :x)`                         |

Note that the suffix `!` (i.e. `transform!`, `select!`, etc) ensures that the operation transforms the dataframe in place, as in Stata

Some of these functions can be applied to grouped data frames, in which case they operate by group:

| Operation              | Stata                            | DataFrames.jl                               |
|:-----------------------|:---------------------------------|:--------------------------------------------|
| Add new columns        | `egen x_mean = mean(x), by(grp)` | `transform!(groupby(df, :grp), :x => mean)` |
| Reduce multiple values | `collapse (mean) x, by(grp)`     | `combine(groupby(df, :grp), :x => mean)`    |

The table below compares more advanced commands:

| Operation                 | Stata                          | DataFrames.jl                                              |
|:--------------------------|:-------------------------------|:-----------------------------------------------------------|
| Transform certain rows    | `replace x = 0 if x <= 0`      | `transform(df, :x => (x -> ifelse.(x .<= 0, 0, x)) => :x)` |
| Transform several columns | `collapse (max) x (min) y`     | `combine(df, :x => maximum,  :y => minimum)`               |
|                           | `collapse (mean) x y`          | `combine(df, [:x, :y] .=> mean)`                           |
|                           | `collapse (mean) x*`           | `combine(df, names(df, r"^x") .=> mean)`                   |
|                           | `collapse (max) x y (min) x y` | `combine(df, ([:x, :y] .=> [maximum minimum])...)`         |
| Multivariate function     | `egen z = corr(x y)`           | `transform!(df, [:x, :y] => cor => :z)`                    |
| Row-wise                  | `egen z = rowmin(x y)`         | `transform!(df, [:x, :y] => ByRow(min) => :z)`             |

# Working with Data Frames

## Examining the Data

The default printing of `DataFrame` objects only includes a sample of rows and
columns that fits on screen:

```jldoctest dataframe
julia> using DataFrames

julia> df = DataFrame(A=1:2:1000, B=repeat(1:10, inner=50), C=1:500)
500×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     3      1      2
   3 │     5      1      3
   4 │     7      1      4
   5 │     9      1      5
   6 │    11      1      6
   7 │    13      1      7
   8 │    15      1      8
  ⋮  │   ⋮      ⋮      ⋮
 494 │   987     10    494
 495 │   989     10    495
 496 │   991     10    496
 497 │   993     10    497
 498 │   995     10    498
 499 │   997     10    499
 500 │   999     10    500
           485 rows omitted
```

Printing options can be adjusted by calling the `show` function manually:
`show(df, allrows=true)` prints all rows even if they do not fit on screen and
`show(df, allcols=true)` does the same for columns.

The `first` and `last` functions can be used to look at the first and last rows
of a data frame (respectively):

```jldoctest dataframe
julia> first(df, 6)
6×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     3      1      2
   3 │     5      1      3
   4 │     7      1      4
   5 │     9      1      5
   6 │    11      1      6

julia> last(df, 6)
6×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │   989     10    495
   2 │   991     10    496
   3 │   993     10    497
   4 │   995     10    498
   5 │   997     10    499
   6 │   999     10    500
```

Also notice that when `DataFrame` is printed to the console or rendered in HTML
(e.g. in Jupyter Notebook) you get an information about type of elements held in
its columns. For example in this case:

```jldoctest dataframe
julia> using CategoricalArrays

julia> DataFrame(a=1:2, b=[1.0, missing],
                 c=categorical('a':'b'), d=[1//2, missing])
2×4 DataFrame
 Row │ a      b          c     d
     │ Int64  Float64?   Cat…  Rational…?
─────┼────────────────────────────────────
   1 │     1        1.0  a           1//2
   2 │     2  missing    b        missing

```

we can observe that:

* the first column `:a` can hold elements of type `Int64`;
* the second column `:b` can hold `Float64` or `Missing`, which is indicated by
  `?` printed after the name of type;
* the third column `:c` can hold categorical data; here we notice `…`, which
  indicates that the actual name of the type was long and got truncated;
* the type information in fourth column `:d` presents a situation where the name
  is both truncated and the type allows `Missing`.

## Taking a Subset

### Indexing syntax

Specific subsets of a data frame can be extracted using the indexing syntax,
similar to matrices. In the [Indexing](@ref) section of the manual you can find
all the details about the available options. Here we highlight the basic options.

The colon `:` indicates that all items (rows or columns
depending on its position) should be retained:

```jldoctest dataframe
julia> df[1:3, :]
3×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     3      1      2
   3 │     5      1      3

julia> df[[1, 5, 10], :]
3×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     9      1      5
   3 │    19      1     10

julia> df[:, [:A, :B]]
500×2 DataFrame
 Row │ A      B
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     3      1
   3 │     5      1
   4 │     7      1
   5 │     9      1
   6 │    11      1
   7 │    13      1
   8 │    15      1
  ⋮  │   ⋮      ⋮
 494 │   987     10
 495 │   989     10
 496 │   991     10
 497 │   993     10
 498 │   995     10
 499 │   997     10
 500 │   999     10
    485 rows omitted

julia> df[1:3, [:B, :A]]
3×2 DataFrame
 Row │ B      A
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     1      3
   3 │     1      5

julia> df[[3, 1], [:C]]
2×1 DataFrame
 Row │ C
     │ Int64
─────┼───────
   1 │     3
   2 │     1
```

Do note that `df[!, [:A]]` and `df[:, [:A]]` return a `DataFrame` object, while
`df[!, :A]` and `df[:, :A]` return a vector:

```jldoctest dataframe
julia> df[!, [:A]]
500×1 DataFrame
 Row │ A
     │ Int64
─────┼───────
   1 │     1
   2 │     3
   3 │     5
   4 │     7
   5 │     9
   6 │    11
   7 │    13
   8 │    15
  ⋮  │   ⋮
 494 │   987
 495 │   989
 496 │   991
 497 │   993
 498 │   995
 499 │   997
 500 │   999
485 rows omitted

julia> df[!, [:A]] == df[:, [:A]]
true

julia> df[!, :A]
500-element Vector{Int64}:
   1
   3
   5
   7
   9
  11
  13
  15
  17
  19
   ⋮
 983
 985
 987
 989
 991
 993
 995
 997
 999

julia> df[!, :A] == df[:, :A]
true
```

In the first case, `[:A]` is a vector, indicating that the resulting object
should be a `DataFrame`. On the other hand, `:A` is a single symbol, indicating
that a single column vector should be extracted. Note that in the first case a
vector is required to be passed (not just any iterable), so e.g. `df[:, (:x1,
:x2)]` is not allowed, but `df[:, [:x1, :x2]]` is valid.

It is also possible to use a regular expression as a selector of columns
matching it:
```jldoctest dataframe
julia> df = DataFrame(x1=1, x2=2, y=3)
1×3 DataFrame
 Row │ x1     x2     y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> df[!, r"x"]
1×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
```

A `Not` selector (from the
[InvertedIndices](https://github.com/mbauman/InvertedIndices.jl) package) can be
used to select all columns excluding a specific subset:

```jldoctest dataframe
julia> df[!, Not(:x1)]
1×2 DataFrame
 Row │ x2     y
     │ Int64  Int64
─────┼──────────────
   1 │     2      3
```

Finally, you can use `Not`, `Between`, `Cols` and `All` selectors in more
complex column selection scenarios (note that `Cols()` selects no columns while
`All()` selects all columns therefore `Cols` is a preferred selector if you
write generic code). Here are examples of using each of these selectors:

```jldoctest dataframe
julia> df = DataFrame(r=1, x1=2, x2=3, y=4)
1×4 DataFrame
 Row │ r      x1     x2     y
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      3      4

julia> df[:, Not(:r)] # drop :r column
1×3 DataFrame
 Row │ x1     x2     y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     2      3      4

julia> df[:, Between(:r, :x2)] # keep columns between :r and :x2
1×3 DataFrame
 Row │ r      x1     x2
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      3

julia> df[:, All()] # keep all columns
1×4 DataFrame
 Row │ r      x1     x2     y
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      3      4

julia> df[:, Cols(x -> startswith(x, "x"))] # keep columns whose name starts with "x"
1×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     2      3
```

The following examples show a more complex use of the `Cols` selector, which
moves all columns whose names match `r"x"` regular expression respectively to
the front and to the end of the data frame:
```jldoctest dataframe
julia> df[:, Cols(r"x", :)]
1×4 DataFrame
 Row │ x1     x2     r      y
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     2      3      1      4

julia> df[:, Cols(Not(r"x"), :)]
1×4 DataFrame
 Row │ r      y      x1     x2
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      4      2      3
```

The indexing syntax can also be used to select rows based on conditions on
variables:

```jldoctest dataframe
julia> df = DataFrame(A=1:2:1000, B=repeat(1:10, inner=50), C=1:500)
500×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     3      1      2
   3 │     5      1      3
   4 │     7      1      4
   5 │     9      1      5
   6 │    11      1      6
   7 │    13      1      7
   8 │    15      1      8
  ⋮  │   ⋮      ⋮      ⋮
 494 │   987     10    494
 495 │   989     10    495
 496 │   991     10    496
 497 │   993     10    497
 498 │   995     10    498
 499 │   997     10    499
 500 │   999     10    500
           485 rows omitted

julia> df[df.A .> 500, :]
250×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │   501      6    251
   2 │   503      6    252
   3 │   505      6    253
   4 │   507      6    254
   5 │   509      6    255
   6 │   511      6    256
   7 │   513      6    257
   8 │   515      6    258
  ⋮  │   ⋮      ⋮      ⋮
 244 │   987     10    494
 245 │   989     10    495
 246 │   991     10    496
 247 │   993     10    497
 248 │   995     10    498
 249 │   997     10    499
 250 │   999     10    500
           235 rows omitted

julia> df[(df.A .> 500) .& (300 .< df.C .< 400), :]
99×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │   601      7    301
   2 │   603      7    302
   3 │   605      7    303
   4 │   607      7    304
   5 │   609      7    305
   6 │   611      7    306
   7 │   613      7    307
   8 │   615      7    308
  ⋮  │   ⋮      ⋮      ⋮
  93 │   785      8    393
  94 │   787      8    394
  95 │   789      8    395
  96 │   791      8    396
  97 │   793      8    397
  98 │   795      8    398
  99 │   797      8    399
            84 rows omitted
```

Where a specific subset of values needs to be matched, the `in()` function can
be applied:

```jldoctest dataframe
julia> df[in.(df.A, Ref([1, 5, 601])), :]
3×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     5      1      3
   3 │   601      7    301
```

The `Ref` wrapper to `[1, 5, 601]` is needed to protect the vector against being
broadcasted over (the vector will be treated as a scalar when wrapped in `Ref`).
You could write this operation using a comprehension like this (note that it would be slower
so it is not recommended):
`[a in [1, 5, 601] for a in df.A]`.

Equivalently, the `in` function can be called with a single argument to create
a function object that tests whether each value belongs to the subset
(partial application of `in`): `df[in([1, 5, 601]).(df.A), :]`.

!!! note

    As with matrices, subsetting from a data frame will usually return a copy of
    columns, not a view or direct reference.

    The only indexing situations where data frames will **not** return a copy are:

    - when a `!` is placed in the first indexing position
      (`df[!, :A]`, or `df[!, [:A, :B]]`),
    - when using `.` (`getpropery`) notation (`df.A`),
    - when a single row is selected using an integer (`df[1, [:A, :B]]`)
    - when `view` or `@view` is used (e.g. `@view df[1:3, :A]`).

    More details on copies, views, and references can be found
    in the [`getindex` and `view`](@ref) section.

### Subsetting functions

An alternative approach to row subsetting in a data frame is to use
the [`subset`](@ref) function, or the [`subset!`](@ref) function,
which is its in-place variant.

These functions take a data frame as their first argument. The
following positional arguments (one or more) are filtering condition
specifications that must be jointly met. Each condition should be passed as a
`Pair` consisting of source column(s) and a function specifying the filtering
condition taking this or these column(s) as arguments:

```jldoctest dataframe
julia> subset(df, :A => a -> a .< 10, :C => c -> isodd.(c))
3×3 DataFrame
 Row │ A      B      C
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      1      1
   2 │     5      1      3
   3 │     9      1      5
```

It is a frequent situation that `missing` values might be present in the
filtering columns, which could then lead the filtering condition to return
`missing` instead of the expected `true` or `false`. In order
to handle this situation one can either use the `coalesce` function or pass
the `skipmissing=true` keyword argument to `subset`. Here is an example:

```jldoctest dataframe
julia> df = DataFrame(x=[1, 2, missing, 4])
4×1 DataFrame
 Row │ x
     │ Int64?
─────┼─────────
   1 │       1
   2 │       2
   3 │ missing
   4 │       4

julia> subset(df, :x => x -> coalesce.(iseven.(x), false))
2×1 DataFrame
 Row │ x
     │ Int64?
─────┼────────
   1 │      2
   2 │      4

julia> subset(df, :x => x -> iseven.(x), skipmissing=true)
2×1 DataFrame
 Row │ x
     │ Int64?
─────┼────────
   1 │      2
   2 │      4
```

The [`subset`](@ref) function has been designed in a way that is
consistent with how column transformations are specified in functions like
[`combine`](@ref), [`select`](@ref), and [`transform`](@ref). Examples of column
transformations accepted by these functions are provided in the following
section.

Additionally DataFrames.jl extends the [`filter`](@ref) and [`filter!`](@ref)
functions provided in Julia Base, which also allow subsetting a data frame.
These methods are defined so that DataFrames.jl implements the Julia API
for collections, but it is generally recommended to use the [`subset`](@ref)
and [`subset!`](@ref) functions instead, as they are consistent with other
DataFrames.jl functions (as opposed to [`filter`](@ref) and [`filter!`](@ref)).

## Selecting and transforming columns

You can also use the [`select`](@ref)/[`select!`](@ref) and
[`transform`](@ref)/[`transform!`](@ref) functions to select, rename and
transform columns in a data frame.

The `select` function creates a new data frame:
```jldoctest dataframe
julia> df = DataFrame(x1=[1, 2], x2=[3, 4], y=[5, 6])
2×3 DataFrame
 Row │ x1     x2     y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      3      5
   2 │     2      4      6

julia> select(df, Not(:x1)) # drop column :x1 in a new data frame
2×2 DataFrame
 Row │ x2     y
     │ Int64  Int64
─────┼──────────────
   1 │     3      5
   2 │     4      6

julia> select(df, r"x") # select columns containing 'x' character
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> select(df, :x1 => :a1, :x2 => :a2) # rename columns
2×2 DataFrame
 Row │ a1     a2
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> select(df, :x1, :x2 => (x -> x .- minimum(x)) => :x2) # transform columns
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      1

julia> select(df, :x2, :x2 => ByRow(sqrt)) # transform columns by row
2×2 DataFrame
 Row │ x2     x2_sqrt
     │ Int64  Float64
─────┼────────────────
   1 │     3  1.73205
   2 │     4  2.0

julia> select(df, :x1, :x2, [:x1, :x2] => ((x1, x2) -> x1 ./ x2) => :z) # transform multiple columns
2×3 DataFrame
 Row │ x1     x2     z
     │ Int64  Int64  Float64
─────┼────────────────────────
   1 │     1      3  0.333333
   2 │     2      4  0.5

julia> select(df, :x1, :x2, [:x1, :x2] => ByRow((x1, x2) -> x1 / x2) => :z)  # transform multiple columns by row
2×3 DataFrame
 Row │ x1     x2     z
     │ Int64  Int64  Float64
─────┼────────────────────────
   1 │     1      3  0.333333
   2 │     2      4  0.5

julia> select(df, AsTable(:) => ByRow(extrema) => [:lo, :hi]) # return multiple columns
2×2 DataFrame
 Row │ lo     hi
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
```

It is important to note that `select` always returns a data frame,
even if a single column is selected (as opposed to indexing syntax).
```jldoctest dataframe
julia> select(df, :x1)
2×1 DataFrame
 Row │ x1
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> df[:, :x1]
2-element Vector{Int64}:
 1
 2
```

By default `select` copies columns of a passed source data frame.
In order to avoid copying, pass `copycols=false`:
```
julia> df2 = select(df, :x1)
2×1 DataFrame
 Row │ x1
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> df2.x1 === df.x1
false

julia> df2 = select(df, :x1, copycols=false)
2×1 DataFrame
 Row │ x1
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> df2.x1 === df.x1
true
```

To perform the selection operation in-place use `select!`:
```jldoctest dataframe
julia> select!(df, Not(:x1));

julia> df
2×2 DataFrame
 Row │ x2     y
     │ Int64  Int64
─────┼──────────────
   1 │     3      5
   2 │     4      6
```

`transform` and `transform!` functions work identically to `select` and
`select!`, with the only difference that they retain all columns that are present
in the source data frame. Here are some more advanced examples.

First we show how to generate a column that is a sum of all other columns in the
data frame using the `All()` selector:

```jldoctest dataframe
julia> df = DataFrame(x1=[1, 2], x2=[3, 4], y=[5, 6])
2×3 DataFrame
 Row │ x1     x2     y
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      3      5
   2 │     2      4      6

julia> transform(df, All() => +)
2×4 DataFrame
 Row │ x1     x2     y      x1_x2_y_+
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────────
   1 │     1      3      5          9
   2 │     2      4      6         12
```

Using the `ByRow` wrapper, we can easily compute for each row the name of column
with the highest score:

```
julia> using Random

julia> Random.seed!(1);

julia> df = DataFrame(rand(10, 3), [:a, :b, :c])
10×3 DataFrame
 Row │ a           b          c
     │ Float64     Float64    Float64
─────┼──────────────────────────────────
   1 │ 0.236033    0.555751   0.0769509
   2 │ 0.346517    0.437108   0.640396
   3 │ 0.312707    0.424718   0.873544
   4 │ 0.00790928  0.773223   0.278582
   5 │ 0.488613    0.28119    0.751313
   6 │ 0.210968    0.209472   0.644883
   7 │ 0.951916    0.251379   0.0778264
   8 │ 0.999905    0.0203749  0.848185
   9 │ 0.251662    0.287702   0.0856352
  10 │ 0.986666    0.859512   0.553206

julia> transform(df, AsTable(:) => ByRow(argmax) => :prediction)
10×4 DataFrame
 Row │ a           b          c          prediction
     │ Float64     Float64    Float64    Symbol
─────┼──────────────────────────────────────────────
   1 │ 0.236033    0.555751   0.0769509  b
   2 │ 0.346517    0.437108   0.640396   c
   3 │ 0.312707    0.424718   0.873544   c
   4 │ 0.00790928  0.773223   0.278582   b
   5 │ 0.488613    0.28119    0.751313   c
   6 │ 0.210968    0.209472   0.644883   c
   7 │ 0.951916    0.251379   0.0778264  a
   8 │ 0.999905    0.0203749  0.848185   a
   9 │ 0.251662    0.287702   0.0856352  b
  10 │ 0.986666    0.859512   0.553206   a
```

In the most complex example below we compute row-wise sum, number of
elements, and mean, while ignoring missing values.

```
julia> using Statistics

julia> df = DataFrame(x=[1, 2, missing], y=[1, missing, missing])
3×2 DataFrame
 Row │ x        y
     │ Int64?   Int64?
─────┼──────────────────
   1 │       1        1
   2 │       2  missing
   3 │ missing  missing

julia> transform(df, AsTable(:) .=>
                     ByRow.([sum∘skipmissing,
                             x -> count(!ismissing, x),
                             mean∘skipmissing]) .=>
                     [:sum, :n, :mean])
3×5 DataFrame
 Row │ x        y        sum    n      mean
     │ Int64?   Int64?   Int64  Int64  Float64
─────┼─────────────────────────────────────────
   1 │       1        1      2      2      1.0
   2 │       2  missing      2      1      2.0
   3 │ missing  missing      0      0    NaN
```

While the DataFrames.jl package provides basic data manipulation capabilities,
users are encouraged to use querying frameworks for more convenient and powerful
operations:
- the [Query.jl](https://github.com/davidanthoff/Query.jl) package provides a
  [LINQ](https://en.wikipedia.org/wiki/Language_Integrated_Query)-like interface
  to a large number of data sources
- the [DataFramesMeta.jl](https://github.com/JuliaStats/DataFramesMeta.jl)
  package provides interfaces similar to LINQ and
  [dplyr](https://dplyr.tidyverse.org)
- the [DataFrameMacros.jl](https://github.com/jkrumbiegel/DataFrameMacros.jl)
  package provides macros for most standard functions from DataFrames.jl,
  with convenient syntax for the manipulation of multiple columns at once.

See the [Data manipulation frameworks](@ref) section for more information.

## Summarizing Data

The `describe` function returns a data frame summarizing the elementary
statistics and information about each column:

```jldoctest dataframe
julia> df = DataFrame(A=1:4, B=["M", "F", "F", "M"])
4×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┼───────────────
   1 │     1  M
   2 │     2  F
   3 │     3  F
   4 │     4  M

julia> describe(df)
2×7 DataFrame
 Row │ variable  mean    min  median  max  nmissing  eltype
     │ Symbol    Union…  Any  Union…  Any  Int64     DataType
─────┼────────────────────────────────────────────────────────
   1 │ A         2.5     1    2.5     4           0  Int64
   2 │ B                 F            M           0  String
```

If you are interested in describing only a subset of columns, then the easiest
way to do it is to pass a subset of an original data frame to `describe` like
this:

```jldoctest dataframe
julia> describe(df[!, [:A]])
1×7 DataFrame
 Row │ variable  mean     min    median   max    nmissing  eltype
     │ Symbol    Float64  Int64  Float64  Int64  Int64     DataType
─────┼──────────────────────────────────────────────────────────────
   1 │ A             2.5      1      2.5      4         0  Int64
```

Of course, one can also compute descriptive statistics directly on individual
columns:

```jldoctest dataframe
julia> using Statistics

julia> mean(df.A)
2.5
```

We can also apply a function to each column of a `DataFrame` using `combine`.
For example:

```jldoctest dataframe
julia> df = DataFrame(A=1:4, B=4.0:-1.0:1.0)
4×2 DataFrame
 Row │ A      B
     │ Int64  Float64
─────┼────────────────
   1 │     1      4.0
   2 │     2      3.0
   3 │     3      2.0
   4 │     4      1.0

julia> combine(df, All() .=> sum)
1×2 DataFrame
 Row │ A_sum  B_sum
     │ Int64  Float64
─────┼────────────────
   1 │    10     10.0

julia> combine(df, All() .=> sum, All() .=> prod)
1×4 DataFrame
 Row │ A_sum  B_sum    A_prod  B_prod
     │ Int64  Float64  Int64   Float64
─────┼─────────────────────────────────
   1 │    10     10.0      24     24.0

julia> combine(df, All() .=> [sum prod]) # the same using 2-dimensional broadcasting
1×4 DataFrame
 Row │ A_sum  B_sum    A_prod  B_prod
     │ Int64  Float64  Int64   Float64
─────┼─────────────────────────────────
   1 │    10     10.0      24     24.0
```

If you would prefer the result to have the same number of rows as the source
data frame, use `select` instead of `combine`.

In the remainder of this section we will discuss more advanced topics related
to the operation specification syntax, so you may decide to skip them if you
want to focus on the most common usage patterns.

A `DataFrame` can store values of any type as its columns, for example
below we show how one can store a `Tuple`:

```
julia> df2 = combine(df, All() .=> extrema)
1×2 DataFrame
 Row │ A_extrema  B_extrema
     │ Tuple…     Tuple…
─────┼───────────────────────
   1 │ (1, 4)     (1.0, 4.0)
```

Later you might want to expand the tuples into separate columns storing the computed
minima and maxima. This can be achieved by passing multiple columns for the output.
Here is an example of how this can be done by writing the column names by-hand for a single
input column:

```
julia> combine(df2, "A_extrema" => identity => ["A_min", "A_max"])
1×2 DataFrame
 Row │ A_min  A_max
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
```

You can extend it to handling all columns in `df2` using broadcasting:

```
julia> combine(df2, All() .=> identity .=> [["A_min", "A_max"], ["B_min", "B_max"]])
1×4 DataFrame
 Row │ A_min  A_max  B_min    B_max
     │ Int64  Int64  Float64  Float64
─────┼────────────────────────────────
   1 │     1      4      1.0      4.0
```

This approach works, but can be improved. Instead of writing all the column names
manually we can instead use a function as a way to specify target column names
based on source column names:

```
julia> combine(df2, All() .=> identity .=> c -> first(c) .* ["_min", "_max"])
1×4 DataFrame
 Row │ A_min  A_max  B_min    B_max
     │ Int64  Int64  Float64  Float64
─────┼────────────────────────────────
   1 │     1      4      1.0      4.0
```

Note that in this example we needed to pass `identity` explicitly since with
`All() => (c -> first(c) .* ["_min", "_max"])` the right-hand side part would be
treated as a transformation and not as a rule for target column names generation.

You might want to perform the transformation of the source data frame into the result
we have just shown in one step. This can be achieved with the following expression:

```
julia> combine(df, All() .=> Ref∘extrema .=> c -> c .* ["_min", "_max"])
1×4 DataFrame
 Row │ A_min  A_max  B_min    B_max
     │ Int64  Int64  Float64  Float64
─────┼────────────────────────────────
   1 │     1      4      1.0      4.0
```

Note that in this case we needed to add a `Ref` call in the `Ref∘extrema` operation specification.
Without `Ref`, `combine` iterates the contents of the value returned by the operation specification function,
which in our case is a tuple of numbers, and tries to expand it assuming that each produced value represents one row,
so one gets an error:

```
julia> combine(df, All() .=> extrema .=> [c -> c .* ["_min", "_max"]])
ERROR: ArgumentError: 'Tuple{Int64, Int64}' iterates 'Int64' values,
which doesn't satisfy the Tables.jl `AbstractRow` interface
```

Note that we used `Ref` as it is a container that is typically used in DataFrames.jl when one
wants to store one row, however, in general it could be another iterator (e.g. a tuple).

## Handling of Columns Stored in a `DataFrame`

Functions that transform a `DataFrame` to produce a
new `DataFrame` always perform a copy of the columns by default, for example:

```jldoctest dataframe
julia> df = DataFrame(A=1:4, B=4.0:-1.0:1.0)
4×2 DataFrame
 Row │ A      B
     │ Int64  Float64
─────┼────────────────
   1 │     1      4.0
   2 │     2      3.0
   3 │     3      2.0
   4 │     4      1.0

julia> df2 = copy(df);

julia> df2.A === df.A
false
```

On the other hand, in-place functions, whose names end with `!`, may mutate the
column vectors of the `DataFrame` they take as an argument. For example:

```jldoctest dataframe
julia> x = [3, 1, 2];

julia> df = DataFrame(x=x)
3×1 DataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     3
   2 │     1
   3 │     2

julia> sort!(df)
3×1 DataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> x
3-element Vector{Int64}:
 3
 1
 2

julia> df.x[1] = 100
100

julia> df
3×1 DataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │   100
   2 │     2
   3 │     3

julia> x
3-element Vector{Int64}:
 3
 1
 2
```
Note that in the above example the original `x` vector is not mutated in the
process, as the `DataFrame(x=x)` constructor makes a copy by default.

In-place functions are safe to call, except when a view of the `DataFrame`
(created via a `view`, `@view` or [`groupby`](@ref))
or when a `DataFrame` created with `copycols=false` are in use.

It is possible to have a direct access to a column `col` of a `DataFrame` `df`
using the syntaxes `df.col`, `df[!, :col]`, via the [`eachcol`](@ref) function,
by accessing a `parent` of a `view` of a column of a `DataFrame`,
or simply by storing the reference to the column vector before the `DataFrame`
was created with `copycols=false`.

```jldoctest dataframe
julia> x = [3, 1, 2];

julia> df = DataFrame(x=x)
3×1 DataFrame
 Row │ x
     │ Int64
─────┼───────
   1 │     3
   2 │     1
   3 │     2

julia> df.x == x
true

julia> df[!, 1] !== x
true

julia> eachcol(df)[1] === df.x
true
```

Note that a column obtained from a `DataFrame` using one of these methods should
not be mutated without caution.

The exact rules of handling columns of a `DataFrame` are explained in [The
design of handling of columns of a `DataFrame`](@ref man-columnhandling) section
of the manual.


## Replacing Data

Several approaches can be used to replace some values with others in a data
frame. Some apply the replacement to all values in a data frame, and others to
individual columns or subset of columns.

Do note that in-place replacement requires that the replacement value can be
converted to the column's element type. In particular, this implies that
replacing a value with `missing` requires a call to `allowmissing!` if the
column did not allow for missing values.

Replacement operations affecting a single column can be performed using `replace!`:
```jldoctest replace
julia> using DataFrames

julia> df = DataFrame(a=["a", "None", "b", "None"], b=1:4,
                      c=["None", "j", "k", "h"], d=["x", "y", "None", "z"])
4×4 DataFrame
 Row │ a       b      c       d
     │ String  Int64  String  String
─────┼───────────────────────────────
   1 │ a           1  None    x
   2 │ None        2  j       y
   3 │ b           3  k       None
   4 │ None        4  h       z

julia> replace!(df.a, "None" => "c")
4-element Vector{String}:
 "a"
 "c"
 "b"
 "c"

julia> df
4×4 DataFrame
 Row │ a       b      c       d
     │ String  Int64  String  String
─────┼───────────────────────────────
   1 │ a           1  None    x
   2 │ c           2  j       y
   3 │ b           3  k       None
   4 │ c           4  h       z
```

This is equivalent to `df.a = replace(df.a, "None" => "c")`, but operates
in-place, without allocating a new column vector.

Replacement operations on multiple columns or on the whole data frame can be
performed in-place using the broadcasting syntax:

```jldoctest replace
# replacement on a subset of columns [:c, :d]
julia> df[:, [:c, :d]] .= ifelse.(df[!, [:c, :d]] .== "None", "c", df[!, [:c, :d]])
4×2 SubDataFrame
 Row │ c       d
     │ String  String
─────┼────────────────
   1 │ c       x
   2 │ j       y
   3 │ k       c
   4 │ h       z

julia> df
4×4 DataFrame
 Row │ a       b      c       d
     │ String  Int64  String  String
─────┼───────────────────────────────
   1 │ a           1  c       x
   2 │ c           2  j       y
   3 │ b           3  k       c
   4 │ c           4  h       z

julia> df .= ifelse.(df .== "c", "None", df) # replacement on entire data frame
4×4 DataFrame
 Row │ a       b      c       d
     │ String  Int64  String  String
─────┼───────────────────────────────
   1 │ a           1  None    x
   2 │ None        2  j       y
   3 │ b           3  k       None
   4 │ None        4  h       z
```

Do note that in the above examples, changing `.=` to just `=` will allocate new
column vectors instead of applying the operation in-place.

When replacing values with `missing`, if the columns do not already allow for
missing values, one has to either avoid in-place operation and use `=` instead
of `.=`, or call `allowmissing!` beforehand:

```jldoctest replace
julia> df2 = ifelse.(df .== "None", missing, df) # do not operate in-place (`df = ` would also work)
4×4 DataFrame
 Row │ a        b      c        d
     │ String?  Int64  String?  String?
─────┼──────────────────────────────────
   1 │ a            1  missing  x
   2 │ missing      2  j        y
   3 │ b            3  k        missing
   4 │ missing      4  h        z

julia> allowmissing!(df) # operate in-place after allowing for missing
4×4 DataFrame
 Row │ a        b       c        d
     │ String?  Int64?  String?  String?
─────┼───────────────────────────────────
   1 │ a             1  None     x
   2 │ None          2  j        y
   3 │ b             3  k        None
   4 │ None          4  h        z

julia> df .= ifelse.(df .== "None", missing, df)
4×4 DataFrame
 Row │ a        b       c        d
     │ String?  Int64?  String?  String?
─────┼───────────────────────────────────
   1 │ a             1  missing  x
   2 │ missing       2  j        y
   3 │ b             3  k        missing
   4 │ missing       4  h        z
```

# First Steps with DataFrames.jl

## Setting up the Environment

If want to use the DataFrames.jl package you need to install it first.
You can do it using the following commands:

```julia
julia> using Pkg

julia> Pkg.add("DataFrames")
```

or

```julia
julia> ] # ']' should be pressed

(@v1.9) pkg> add DataFrames
```

If you want to make sure everything works as expected you can run the tests
bundled with DataFrames.jl, but be warned that it will take more than 30
minutes:

```julia
julia> using Pkg

julia> Pkg.test("DataFrames") # Warning! This will take more than 30 minutes.
```

Additionally, it is recommended to check the version of DataFrames.jl that
you have installed with the `status` command.

```julia
julia> ]

(@v1.9) pkg> status DataFrames
      Status `~\v1.13\Project.toml`
  [a93c6f00] DataFrames v1.8.0
```

Throughout the rest of the tutorial we will assume that you have installed the
DataFrames.jl package and have already typed `using DataFrames` which loads the
package:

```jldoctest dataframe
julia> using DataFrames
```

The most fundamental type provided by DataFrames.jl is `DataFrame`, where
typically each row is interpreted as an observation and each column as a
feature.

!!! note "Advanced installation configuration"

    DataFrames.jl puts in extra time and effort when the package is being built
    (precompiled) to make sure it is more responsive when you are using it.
    However, in some scenarios users might want to avoid this extra
    precompilaion effort to reduce the time needed to build the package and
    later to load it. To disable precompilation of DataFrames.jl in your current
    project follow the instructions given in the
    [PrecompileTools.jl documentation](https://julialang.github.io/PrecompileTools.jl/stable/#Package-developers:-reducing-the-cost-of-precompilation-during-development)

## Constructors and Basic Utility Functions

### Constructors

In this section you will see several ways to create a `DataFrame` using the
constructor. You can find a detailed list of supported constructors along with
more examples in the documentation of the [`DataFrame`](@ref) object.

We start by creating an empty `DataFrame`:

```jldoctest dataframe
julia> DataFrame()
0×0 DataFrame
```

Now let us initialize a `DataFrame` with several columns. This is a basic way to
do it is the following:

```jldoctest dataframe
julia> DataFrame(A=1:3, B=5:7, fixed=1)
3×3 DataFrame
 Row │ A      B      fixed
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      1
   2 │     2      6      1
   3 │     3      7      1
```

Observe that using this constructor scalars, like `1` for the column `:fixed`
get automatically broadcasted to fill all rows of the created `DataFrame`.

Sometimes one needs to create a data frame whose column names are not valid
Julia identifiers. In such a case the following form, where `=` is replaced by
`=>` is handy:

```jldoctest dataframe
julia> DataFrame("customer age" => [15, 20, 25],
                 "first name" => ["Rohit", "Rahul", "Akshat"])
3×2 DataFrame
 Row │ customer age  first name
     │ Int64         String
─────┼──────────────────────────
   1 │           15  Rohit
   2 │           20  Rahul
   3 │           25  Akshat
```

Notice that this time we have passed column names as strings.

Often you have your source data stored in a dictionary.
Provided that the keys of the dictionary are strings or `Symbol`s
you can also easily create a `DataFrame` from it:

```jldoctest dataframe
julia> dict = Dict("customer age" => [15, 20, 25],
                   "first name" => ["Rohit", "Rahul", "Akshat"])
Dict{String, Vector} with 2 entries:
  "first name"   => ["Rohit", "Rahul", "Akshat"]
  "customer age" => [15, 20, 25]

julia> DataFrame(dict)
3×2 DataFrame
 Row │ customer age  first name
     │ Int64         String
─────┼──────────────────────────
   1 │           15  Rohit
   2 │           20  Rahul
   3 │           25  Akshat

julia> dict = Dict(:customer_age => [15, 20, 25],
                   :first_name => ["Rohit", "Rahul", "Akshat"])
Dict{Symbol, Vector} with 2 entries:
  :customer_age => [15, 20, 25]
  :first_name   => ["Rohit", "Rahul", "Akshat"]

julia> DataFrame(dict)
3×2 DataFrame
 Row │ customer_age  first_name
     │ Int64         String
─────┼──────────────────────────
   1 │           15  Rohit
   2 │           20  Rahul
   3 │           25  Akshat
```

Using `Symbol`s, e.g. `:customer_age` rather than strings, e.g. `"customer age"`
to denote column names is preferred as it is faster. However, as you can see
in the example above if our column name contains a space it is not very
convenient to pass it as a `Symbol` (you would have to write `Symbol("customer age")`,
which is verbose) so using a string is more convenient.

It is also quite common to create a `DataFrame` from a `NamedTuple` of vectors
or a vector of `NamedTuple`s. Here are some examples of these operations:

```jldoctest dataframe
julia> DataFrame((a=[1, 2], b=[3, 4]))
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> DataFrame([(a=1, b=0), (a=2, b=0)])
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0
```

Sometimes your source data might have a heterogeneous set of columns for each observation.
Here is an example:

```
julia> source = [(type="circle", radius=10), (type="square", side=20)]
2-element Vector{NamedTuple{names, Tuple{String, Int64}} where names}:
 (type = "circle", radius = 10)
 (type = "square", side = 20)
```

If you want to create a data frame from such data containing all columns present in at least
one of the source observations, with a `missing` entry if some column is not present then
you can use `Tables.dictcolumntable` function to help you create the desired data frame:

```
julia> DataFrame(Tables.dictcolumntable(source))
2×3 DataFrame
 Row │ type    radius   side
     │ String  Int64?   Int64?
─────┼──────────────────────────
   1 │ circle       10  missing
   2 │ square  missing       20
```

The role of `Tables.dictcolumntable` is to make sure that the `DataFrame` constructor gets information
about all columns present in the source data and properly instantiates them. If we did not use
this function the `DataFrame` constructor would assume that the first row of data contains the set
of columns present in the source, which would lead to an error in our example:

```
julia> DataFrame(source)
ERROR: type NamedTuple has no field radius
```

Let us finish our review of constructors by showing how to create a `DataFrame`
from a matrix. In this case you pass a matrix as a first argument. If the second
argument is just `:auto` then column names `x1`, `x2`, ... will be auto generated.

```jldoctest dataframe
julia> DataFrame([1 0; 2 0], :auto)
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0
```

Alternatively you can pass a vector of column names as a second argument to the
`DataFrame` constructor:

```jldoctest dataframe
julia> mat = [1 2 4 5; 15 58 69 41; 23 21 26 69]
3×4 Matrix{Int64}:
  1   2   4   5
 15  58  69  41
 23  21  26  69

julia> nms = ["a", "b", "c", "d"]
4-element Vector{String}:
 "a"
 "b"
 "c"
 "d"

julia> DataFrame(mat, nms)
3×4 DataFrame
 Row │ a      b      c      d
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      2      4      5
   2 │    15     58     69     41
   3 │    23     21     26     69
```

You now know how to create a `DataFrame` from data that you already have in your
Julia session. In the next section we show how to load data to a `DataFrame`
from disk.

### Reading Data From CSV Files

Here we focus on one of the most common scenarios, where one has data stored on
disk in the CSV format.

First make sure you have CSV.jl installed. You can do it using the following
instructions:

```julia
julia> using Pkg

julia> Pkg.add("CSV")
```

In order to read the file in we will use the `CSV.read` function.

```jldoctest dataframe
julia> using CSV

julia> path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "german.csv");

julia> german_ref = CSV.read(path, DataFrame)
1000×10 DataFrame
  Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accou ⋯
      │ Int64  Int64  String7  Int64  String7  String15         String15       ⋯
──────┼─────────────────────────────────────────────────────────────────────────
    1 │     0     67  male         2  own      NA               little         ⋯
    2 │     1     22  female       2  own      little           moderate
    3 │     2     49  male         1  own      little           NA
    4 │     3     45  male         2  free     little           little
    5 │     4     53  male         2  free     little           little         ⋯
    6 │     5     35  male         1  free     NA               NA
    7 │     6     53  male         2  own      quite rich       NA
    8 │     7     35  male         3  rent     little           moderate
  ⋮   │   ⋮      ⋮       ⋮       ⋮       ⋮            ⋮                ⋮       ⋱
  994 │   993     30  male         3  own      little           little         ⋯
  995 │   994     50  male         2  own      NA               NA
  996 │   995     31  female       1  own      little           NA
  997 │   996     40  male         3  own      little           little
  998 │   997     38  male         2  own      little           NA             ⋯
  999 │   998     23  male         2  free     little           little
 1000 │   999     27  male         2  own      moderate         moderate
                                                  4 columns and 985 rows omitted
```

As you can see the data frame is wider and taller than the display width, so it
got cropped and its 4 rightmost columns and middle 985 rows were not printed.
Later in the tutorial we will discuss how to force Julia to show the whole
data frame if we wanted so.

Also observe that DataFrames.jl displays the data type of the column
below its name. In our case, it is an `Int64`, or `String7` and `String15`.

Let us mention here the difference between the standard `String` type in Julia
and e.g. the `String7` or `String15` types. The types with number suffix denote
strings that have a fixed width (similar `CHAR(N)` type provided by many data
bases). Such strings are much faster to work with (especially if you have many
of them) than the standard `String` type because their instances are not heap
allocated. For this reason `CSV.read` by default reads in narrow string columns
using these fixed-width types.

Let us now explain in detail the following code block:
```julia
path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "german.csv");

german_ref = CSV.read(path, DataFrame)
```
- we are storing the `german.csv` file in the DataFrames.jl repository to make
  user's life easier and avoid having to download it each time;
- `pkgdir(DataFrames)` gives us the full path to the root of the DataFrames.jl
  package.
- then from this directory we need to move to the directory where the
  `german.csv` file is stored; we use `joinpath` as this is a recommended way to
  compose paths to resources stored on disk in an operating system independent
  way (remember that Windows and Unix differ as they use either `/` or `\` as
  path separator; the `joinpath` function ensures we are not running into issues
  with this);
- then we read the CSV file; the second argument to `CSV.read` is `DataFrame` to
  indicate that we want to read in the file into a `DataFrame` (as `CSV.read`
  allows for many different target formats of data it can read-into).

Before proceeding copy the reference data frame:

```jldoctest dataframe
julia> german = copy(german_ref); # we copy the data frame
```

In this way we can always easily restore our data even if we mess up the
`german` data frame by modifying it.

### Basic Operations on Data Frames

To extract the columns of a data frame directly (i.e. without copying)
you can use one of the following syntaxes:
`german.Sex`, `german."Sex"`, `german[!, :Sex]` or `german[!, "Sex"]`.

The two latter syntaxes using indexing are more flexible as they allow
us passing a variable holding the name of the column, and not only a literal name
as in the case of the syntax using a `.`.

```jldoctest dataframe
julia> german.Sex
1000-element PooledArrays.PooledVector{String7, UInt32, Vector{UInt32}}:
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 ⋮
 "male"
 "male"
 "male"
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"

julia> colname = "Sex"
"Sex"

julia> german[!, colname]
1000-element PooledArrays.PooledVector{String7, UInt32, Vector{UInt32}}:
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 ⋮
 "male"
 "male"
 "male"
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"
```

Since `german.Sex` does not make a copy when extracting a column from the data
frame, changing the elements of the vector returned by this operation will
affect the values stored in the original `german` data frame. To get a *copy* of
the column you can use `german[:, :Sex]` or `german[:, "Sex"]`. In this case
changing the vector returned by this operation does not affect the data stored
in the `german` data frame.

The `===` function allows us to check if both expressions produce the same object
and confirm the behavior described above:

```jldoctest dataframe
julia> german.Sex === german[!, :Sex]
true

julia> german.Sex === german[:, :Sex]
false
```

You can obtain a vector of column names of the data frame as `String`s using the
`names` function:

```jldoctest dataframe
julia> names(german)
10-element Vector{String}:
 "id"
 "Age"
 "Sex"
 "Job"
 "Housing"
 "Saving accounts"
 "Checking account"
 "Credit amount"
 "Duration"
 "Purpose"
```

Sometimes you are interested in names of columns that meet a particular condition.

For example you can get column names with a given element type by passing this
type as a second argument to the `names` function:

```jldoctest dataframe
julia> names(german, AbstractString)
5-element Vector{String}:
 "Sex"
 "Housing"
 "Saving accounts"
 "Checking account"
 "Purpose"
```

You can explore more options of filtering column names in the documentation of
the [`names`](@ref) function.

If instead you wanted to get column names of a data frame as `Symbol`s use the
`propertynames` function:

```jldoctest dataframe
julia> propertynames(german)
10-element Vector{Symbol}:
 :id
 :Age
 :Sex
 :Job
 :Housing
 Symbol("Saving accounts")
 Symbol("Checking account")
 Symbol("Credit amount")
 :Duration
 :Purpose
```

As you can see the column names containing spaces are not very convenient to work with
as `Symbol`s because they require more typing and introduce some visual noise.

If you were interested in element types of the columns instead. You can use the
`eachcol(german)` function to get an iterator over the columns of the data frame.
Then you can broadcast the `eltype` function over it to get the desired result:

```jldoctest dataframe
julia> eltype.(eachcol(german))
10-element Vector{DataType}:
 Int64
 Int64
 String7
 Int64
 String7
 String15
 String15
 Int64
 Int64
 String31
```

!!! note

    Remember that DataFrames.jl allows to use `Symbol`s (like `:id`) and strings
    (like `"id"`) for all column indexing operations for convenience.
    However, using `Symbol`s is slightly faster, but strings are simpler to work
    with when non standard characters are present in column names or one wants
    to manipulate them.

Before we wrap up let us discuss the `empty` and `empty!` functions that
remove all rows from a `DataFrame`. Understanding the difference between the
behavior of these two functions will help you to understand the function naming
scheme in DataFrames.jl in general.

Let us start with the example of using the `empty` and `empty!` functions:

```jldoctest dataframe
julia> empty(german)
0×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┴──────────────────────────────────────────────────────────────────────────
                                                               4 columns omitted

julia> german
1000×10 DataFrame
  Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accou ⋯
      │ Int64  Int64  String7  Int64  String7  String15         String15       ⋯
──────┼─────────────────────────────────────────────────────────────────────────
    1 │     0     67  male         2  own      NA               little         ⋯
    2 │     1     22  female       2  own      little           moderate
    3 │     2     49  male         1  own      little           NA
    4 │     3     45  male         2  free     little           little
    5 │     4     53  male         2  free     little           little         ⋯
    6 │     5     35  male         1  free     NA               NA
    7 │     6     53  male         2  own      quite rich       NA
    8 │     7     35  male         3  rent     little           moderate
  ⋮   │   ⋮      ⋮       ⋮       ⋮       ⋮            ⋮                ⋮       ⋱
  994 │   993     30  male         3  own      little           little         ⋯
  995 │   994     50  male         2  own      NA               NA
  996 │   995     31  female       1  own      little           NA
  997 │   996     40  male         3  own      little           little
  998 │   997     38  male         2  own      little           NA             ⋯
  999 │   998     23  male         2  free     little           little
 1000 │   999     27  male         2  own      moderate         moderate
                                                  4 columns and 985 rows omitted

julia> empty!(german)
0×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┴──────────────────────────────────────────────────────────────────────────
                                                               4 columns omitted

julia> german
0×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┴──────────────────────────────────────────────────────────────────────────
                                                               4 columns omitted
```

In the above example `empty` function created a new `DataFrame` with the same
column names and column element types as `german` but with zero rows. On the
other hand `empty!` function removed all rows from `german` in-place and made
each of its columns empty.

The difference between the behavior of the `empty` and `empty!` functions is an
application of the
[stylistic convention](https://docs.julialang.org/en/v1/manual/variables/#Stylistic-Conventions)
employed in the Julia language. This convention is followed in all functions
provided by the DataFrames.jl package.

### Getting Basic Information about a Data Frame

In this section we will learn about how to get basic information on our `german`
`DataFrame`:

The `size` function returns the dimensions of the data frame.
First we restore the `german` data frame, as we have just emptied it above.

```jldoctest dataframe
julia> german = copy(german_ref);

julia> size(german)
(1000, 10)

julia> size(german, 1)
1000

julia> size(german, 2)
10
```

Additionally the `nrow` and `ncol` functions can be used to get the number of rows
and columns in a data frame:
```jldoctest dataframe
julia> nrow(german)
1000

julia> ncol(german)
10
```

To get basic statistics of data in your data frame use the `describe` function
(check out the help of [`describe`](@ref) for information on how to customize
the shown statistics).

```jldoctest dataframe
julia> describe(german)
10×7 DataFrame
 Row │ variable          mean     min       median  max              nmissing  ⋯
     │ Symbol            Union…   Any       Union…  Any              Int64     ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │ id                499.5    0         499.5   999                     0  ⋯
   2 │ Age               35.546   19        33.0    75                      0
   3 │ Sex                        female            male                    0
   4 │ Job               1.904    0         2.0     3                       0
   5 │ Housing                    free              rent                    0  ⋯
   6 │ Saving accounts            NA                rich                    0
   7 │ Checking account           NA                rich                    0
   8 │ Credit amount     3271.26  250       2319.5  18424                   0
   9 │ Duration          20.903   4         18.0    72                      0  ⋯
  10 │ Purpose                    business          vacation/others         0
                                                                1 column omitted
```

To limit the columns processed by `describe` use `cols` keyword argument, e.g.:

```jldoctest dataframe
julia> describe(german, cols=1:3)
3×7 DataFrame
 Row │ variable  mean    min     median  max   nmissing  eltype
     │ Symbol    Union…  Any     Union…  Any   Int64     DataType
─────┼────────────────────────────────────────────────────────────
   1 │ id        499.5   0       499.5   999          0  Int64
   2 │ Age       35.546  19      33.0    75           0  Int64
   3 │ Sex               female          male         0  String7
```

The default statistics reported are mean, min, median, max, number of missing
values, and element type of the column. `missing` values are skipped when
computing the summary statistics.

You can adjust how data frame is displayed by calling the `show` function manually:
`show(german, allrows=true)` prints all rows even if they do not fit on screen and
`show(german, allcols=true)` does the same for columns, e.g.:

```jldoctest dataframe
julia> show(german, allcols=true)
1000×10 DataFrame
  Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking account  Credit amount  Duration  Purpose
      │ Int64  Int64  String7  Int64  String7  String15         String15          Int64          Int64     String31
──────┼────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────
    1 │     0     67  male         2  own      NA               little                     1169         6  radio/TV
    2 │     1     22  female       2  own      little           moderate                   5951        48  radio/TV
    3 │     2     49  male         1  own      little           NA                         2096        12  education
    4 │     3     45  male         2  free     little           little                     7882        42  furniture/equipment
    5 │     4     53  male         2  free     little           little                     4870        24  car
    6 │     5     35  male         1  free     NA               NA                         9055        36  education
    7 │     6     53  male         2  own      quite rich       NA                         2835        24  furniture/equipment
    8 │     7     35  male         3  rent     little           moderate                   6948        36  car
  ⋮   │   ⋮      ⋮       ⋮       ⋮       ⋮            ⋮                ⋮                ⋮           ⋮               ⋮
  994 │   993     30  male         3  own      little           little                     3959        36  furniture/equipment
  995 │   994     50  male         2  own      NA               NA                         2390        12  car
  996 │   995     31  female       1  own      little           NA                         1736        12  furniture/equipment
  997 │   996     40  male         3  own      little           little                     3857        30  car
  998 │   997     38  male         2  own      little           NA                          804        12  radio/TV
  999 │   998     23  male         2  free     little           little                     1845        45  radio/TV
 1000 │   999     27  male         2  own      moderate         moderate                   4576        45  car
                                                                                                               985 rows omitted
```

It is easy to compute descriptive statistics directly on individual columns using
the functions defined in the `Statistics` module:

```jldoctest dataframe
julia> using Statistics

julia> mean(german.Age)
35.546
```

If instead we want to apply some function to all columns of a data frame we can
use the `mapcols` function. It returns a `DataFrame` where each column of the
source data frame is transformed using a function passed as a first argument.
Note that `mapcols` guarantees not to reuse the columns from `german` in the
returned `DataFrame`. If the transformation returns its argument then it gets
copied before being stored.

```jldoctest dataframe
julia> mapcols(id -> id .^ 2, german)
1000×10 DataFrame
  Row │ id      Age    Sex           Job    Housing   Saving accounts       Ch ⋯
      │ Int64   Int64  String        Int64  String    String                St ⋯
──────┼─────────────────────────────────────────────────────────────────────────
    1 │      0   4489  malemale          4  ownown    NANA                  li ⋯
    2 │      1    484  femalefemale      4  ownown    littlelittle          mo
    3 │      4   2401  malemale          1  ownown    littlelittle          NA
    4 │      9   2025  malemale          4  freefree  littlelittle          li
    5 │     16   2809  malemale          4  freefree  littlelittle          li ⋯
    6 │     25   1225  malemale          1  freefree  NANA                  NA
    7 │     36   2809  malemale          4  ownown    quite richquite rich  NA
    8 │     49   1225  malemale          9  rentrent  littlelittle          mo
  ⋮   │   ⋮       ⋮         ⋮          ⋮       ⋮               ⋮               ⋱
  994 │ 986049    900  malemale          9  ownown    littlelittle          li ⋯
  995 │ 988036   2500  malemale          4  ownown    NANA                  NA
  996 │ 990025    961  femalefemale      1  ownown    littlelittle          NA
  997 │ 992016   1600  malemale          9  ownown    littlelittle          li
  998 │ 994009   1444  malemale          4  ownown    littlelittle          NA ⋯
  999 │ 996004    529  malemale          4  freefree  littlelittle          li
 1000 │ 998001    729  malemale          4  ownown    moderatemoderate      mo
                                                  4 columns and 985 rows omitted
```

If you want to look at first and last rows of a data frame then you can do this
using the `first` and `last` functions respectively:

```jldoctest dataframe
julia> first(german, 6)
6×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │     0     67  male         2  own      NA               little          ⋯
   2 │     1     22  female       2  own      little           moderate
   3 │     2     49  male         1  own      little           NA
   4 │     3     45  male         2  free     little           little
   5 │     4     53  male         2  free     little           little          ⋯
   6 │     5     35  male         1  free     NA               NA
                                                               4 columns omitted

julia> last(german, 5)
5×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │   995     31  female       1  own      little           NA              ⋯
   2 │   996     40  male         3  own      little           little
   3 │   997     38  male         2  own      little           NA
   4 │   998     23  male         2  free     little           little
   5 │   999     27  male         2  own      moderate         moderate        ⋯
                                                               4 columns omitted
```

Using `first` and `last` without passing the number of rows will return a
first/last `DataFrameRow` in the data frame. `DataFrameRow` is a view into a
single row of an `AbstractDataFrame`. It stores a reference to a parent
`DataFrame` and information about which row and columns from the parent are
selected. You can think of `DataFrameRow` as a `NamedTuple` that is mutable,
i.e. allows to update the source data frame, which is often useful.

```jldoctest dataframe
julia> first(german)
DataFrameRow
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │     0     67  male         2  own      NA               little          ⋯
                                                               4 columns omitted

julia> last(german)
DataFrameRow
  Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accou ⋯
      │ Int64  Int64  String7  Int64  String7  String15         String15       ⋯
──────┼─────────────────────────────────────────────────────────────────────────
 1000 │   999     27  male         2  own      moderate         moderate       ⋯
                                                               4 columns omitted
```

## Getting and Setting Data in a Data Frame

### Indexing Syntax

Data frame can be indexed in a similar way to matrices.
In the [Indexing](@ref) section of the manual you can find all details about all
the available options. Here we highlight the basic ones.

The general syntax for indexing is `data_frame[selected_rows, selected_columns]`.
Observe that, as opposed to matrices in Julia Base, it is required to always pass
both row and column selector. The colon `:` indicates that all items (rows or
columns depending on its position) should be retained. Here are a few examples:

```jldoctest dataframe
julia> german[1:5, [:Sex, :Age]]
5×2 DataFrame
 Row │ Sex      Age
     │ String7  Int64
─────┼────────────────
   1 │ male        67
   2 │ female      22
   3 │ male        49
   4 │ male        45
   5 │ male        53

julia> german[1:5, :]
5×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │     0     67  male         2  own      NA               little          ⋯
   2 │     1     22  female       2  own      little           moderate
   3 │     2     49  male         1  own      little           NA
   4 │     3     45  male         2  free     little           little
   5 │     4     53  male         2  free     little           little          ⋯
                                                               4 columns omitted

julia> german[[1, 6, 15], :]
3×10 DataFrame
 Row │ id     Age    Sex      Job    Housing  Saving accounts  Checking accoun ⋯
     │ Int64  Int64  String7  Int64  String7  String15         String15        ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │     0     67  male         2  own      NA               little          ⋯
   2 │     5     35  male         1  free     NA               NA
   3 │    14     28  female       2  rent     little           little
                                                               4 columns omitted

julia> german[:, [:Age, :Sex]]
1000×2 DataFrame
  Row │ Age    Sex
      │ Int64  String7
──────┼────────────────
    1 │    67  male
    2 │    22  female
    3 │    49  male
    4 │    45  male
    5 │    53  male
    6 │    35  male
    7 │    53  male
    8 │    35  male
  ⋮   │   ⋮       ⋮
  994 │    30  male
  995 │    50  male
  996 │    31  female
  997 │    40  male
  998 │    38  male
  999 │    23  male
 1000 │    27  male
       985 rows omitted
```

Pay attention that `german[!, [:Sex]]` and `german[:, [:Sex]]` returns a data
frame object, while `german[!, :Sex]` and `german[:, :Sex]` returns a vector. In
the first case, `[:Sex]` is a vector, indicating that the resulting object
should be a data frame. On the other hand, `:Sex` is a single `Symbol`,
indicating that a single column vector should be extracted. Note that in the
first case a vector is required to be passed (not just any iterable), so e.g.
`german[:, (:Age, :Sex)]` is not allowed, but `german[:, [:Age, :Sex]]` is
valid. Below we show both operations to highlight this difference:

```jldoctest dataframe
julia> german[!, [:Sex]]
1000×1 DataFrame
  Row │ Sex
      │ String7
──────┼─────────
    1 │ male
    2 │ female
    3 │ male
    4 │ male
    5 │ male
    6 │ male
    7 │ male
    8 │ male
  ⋮   │    ⋮
  994 │ male
  995 │ male
  996 │ female
  997 │ male
  998 │ male
  999 │ male
 1000 │ male
985 rows omitted

julia> german[!, :Sex]
1000-element PooledArrays.PooledVector{String7, UInt32, Vector{UInt32}}:
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 "male"
 ⋮
 "male"
 "male"
 "male"
 "male"
 "female"
 "male"
 "male"
 "male"
 "male"
```

As it was explained earlier in this tutorial the difference between using `!`
and `:` when passing a row index is that `!` does not perform a copy of columns,
while `:` does when reading data from a data frame. Therefore
`german[!, [:Sex]]` data frame stores the same vector as the source `german`
data frame, while `german[:, [:Sex]]` stores its copy.

The `!` selector normally should be avoided as using it can lead to hard to
catch bugs. However, when working with very large data frames it can be useful
to save memory and improve performance of operations.

Recapping what we have already learned,
To get the column `:Age` from the `german` data frame you can do the following:

- to copy the vector: `german[:, :Age]`, `german[:, "Age"]` or `german[:, 2]`;
- to get a vector without copying: `german.Age`, `german."Age"`, `german[!, :Age]`,
  `german[!, "Age"]` or `german[!, 2]`.

To get the first two columns as a `DataFrame`, we can index as follows:
- to get the copied columns: `german[:, 1:2]`, `german[:, [:id, :Age]]`,
  or `german[:, ["id", "Age"]]`;
- to reuse the columns without copying: `german[!, 1:2]`, `german[!, [:id, :Age]]`,
  or `german[!, ["id", "Age"]]`.

If you want to can get a single cell of a data frame use the same syntax as the
one that gets a cell of a matrix:

```jldoctest dataframe
julia> german[4, 4]
2
```

### Views

We can also create a `view` of a data frame. It is often useful as it is more
memory efficient than creating a materialized selection. You can create it using
a `view` function:

```jldoctest dataframe
julia> view(german, :, 2:5)
1000×4 SubDataFrame
  Row │ Age    Sex      Job    Housing
      │ Int64  String7  Int64  String7
──────┼────────────────────────────────
    1 │    67  male         2  own
    2 │    22  female       2  own
    3 │    49  male         1  own
    4 │    45  male         2  free
    5 │    53  male         2  free
    6 │    35  male         1  free
    7 │    53  male         2  own
    8 │    35  male         3  rent
  ⋮   │   ⋮       ⋮       ⋮       ⋮
  994 │    30  male         3  own
  995 │    50  male         2  own
  996 │    31  female       1  own
  997 │    40  male         3  own
  998 │    38  male         2  own
  999 │    23  male         2  free
 1000 │    27  male         2  own
                       985 rows omitted
```

or using a `@view` macro:

```jldoctest dataframe
julia> @view german[end:-1:1, [1, 4]]
1000×2 SubDataFrame
  Row │ id     Job
      │ Int64  Int64
──────┼──────────────
    1 │   999      2
    2 │   998      2
    3 │   997      2
    4 │   996      3
    5 │   995      1
    6 │   994      2
    7 │   993      3
    8 │   992      1
  ⋮   │   ⋮      ⋮
  994 │     6      2
  995 │     5      1
  996 │     4      2
  997 │     3      2
  998 │     2      1
  999 │     1      2
 1000 │     0      2
     985 rows omitted
```

Similarly we can get a view of one column of a data frame:

```jldoctest dataframe
julia> @view german[1:5, 1]
5-element view(::Vector{Int64}, 1:5) with eltype Int64:
 0
 1
 2
 3
 4
```

its single cell:

```jldoctest dataframe
julia> @view german[2, 2]
0-dimensional view(::Vector{Int64}, 2) with eltype Int64:
22
```

or a single row:

```jldoctest dataframe
julia> @view german[3, 2:5]
DataFrameRow
 Row │ Age    Sex      Job    Housing
     │ Int64  String7  Int64  String7
─────┼────────────────────────────────
   3 │    49  male         1  own
```

As you can see the row and column indexing syntax is exactly the same as for
indexing. The only difference is that we do not create a new object, but a view
into an existing one.

In order to compare the performance of indexing vs creation of a view let us
run the following benchmark using the BenchmarkTools.jl package (please install
it if you want to re-run this comparison):

```julia
julia> using BenchmarkTools

julia> @btime $german[1:end-1, 1:end-1];
  9.900 μs (44 allocations: 57.56 KiB)

julia> @btime @view $german[1:end-1, 1:end-1];
  67.332 ns (2 allocations: 32 bytes)
```

As you can see creation of a view is:
- an order of magnitude faster;
- allocates much less memory.

The downside of the view is that:
- it points to the same memory as its parent (so changing a view changes the
  parent, which is sometimes undesirable);
- some operations might be a bit slower (as DataFrames.jl needs to perform a
  mapping of indices of a view to indices of the parent).

### Changing the Data Stored in a Data Frame

In order to show how to perform mutating operations on a data frame we make a
subset of a `german` data frame first:

```jldoctest dataframe
julia> df1 = german[1:6, 2:4]
6×3 DataFrame
 Row │ Age    Sex      Job
     │ Int64  String7  Int64
─────┼───────────────────────
   1 │    67  male         2
   2 │    22  female       2
   3 │    49  male         1
   4 │    45  male         2
   5 │    53  male         2
   6 │    35  male         1
```

In the following example we replace the column `:Age` in our `df1` data frame
with a new vector:

```jldoctest dataframe
julia> val = [80, 85, 98, 95, 78, 89]
6-element Vector{Int64}:
 80
 85
 98
 95
 78
 89

julia> df1.Age = val
6-element Vector{Int64}:
 80
 85
 98
 95
 78
 89

julia> df1
6×3 DataFrame
 Row │ Age    Sex      Job
     │ Int64  String7  Int64
─────┼───────────────────────
   1 │    80  male         2
   2 │    85  female       2
   3 │    98  male         1
   4 │    95  male         2
   5 │    78  male         2
   6 │    89  male         1
```

This is a non-copying operation. One can perform it only if `val` vector has the
same length as number of rows of `df1` or as a special case if `df1` would not
have any columns.

```jldoctest dataframe
julia> df1.Age === val # no copy is performed
true
```

If in indexing you select a subset of rows from a data frame the mutation is
performed in place, i.e. writing to an existing vector.
Below setting values of column `:Job` in rows `1:3` to values `[2, 3, 2]`:

```jldoctest dataframe
julia> df1[1:3, :Job] = [2, 3, 2]
3-element Vector{Int64}:
 2
 3
 2

julia> df1
6×3 DataFrame
 Row │ Age    Sex      Job
     │ Int64  String7  Int64
─────┼───────────────────────
   1 │    80  male         2
   2 │    85  female       3
   3 │    98  male         2
   4 │    95  male         2
   5 │    78  male         2
   6 │    89  male         1
```

As a special rule using `!` as row selector replaces column without copying
(just like in the `df1.Age = val` example above).
For example below we replace the `:Sex` column:

```jldoctest dataframe
julia> df1[!, :Sex] = ["male", "female", "female", "transgender", "female", "male"]
6-element Vector{String}:
 "male"
 "female"
 "female"
 "transgender"
 "female"
 "male"

julia> df1
6×3 DataFrame
 Row │ Age    Sex          Job
     │ Int64  String       Int64
─────┼───────────────────────────
   1 │    80  male             2
   2 │    85  female           3
   3 │    98  female           2
   4 │    95  transgender      2
   5 │    78  female           2
   6 │    89  male             1
```

Similarly to setting selected rows of a single column we can also set
selected columns of a given row of a data frame:

```jldoctest dataframe
julia> df1[3, 1:3] = [78, "male", 4]
3-element Vector{Any}:
 78
   "male"
  4

julia> df1
6×3 DataFrame
 Row │ Age    Sex          Job
     │ Int64  String       Int64
─────┼───────────────────────────
   1 │    80  male             2
   2 │    85  female           3
   3 │    78  male             4
   4 │    95  transgender      2
   5 │    78  female           2
   6 │    89  male             1
```

We have already mentioned that `DataFrameRow` can be used to mutate its parent
data frame. Here are a few examples:

```jldoctest dataframe
julia> dfr = df1[2, :] # DataFrameRow with the second row and all columns of df1
DataFrameRow
 Row │ Age    Sex     Job
     │ Int64  String  Int64
─────┼──────────────────────
   2 │    85  female      3

julia> dfr.Age = 98 # set value of col `:Age` in row `2` to `98` in-place
98

julia> dfr
DataFrameRow
 Row │ Age    Sex     Job
     │ Int64  String  Int64
─────┼──────────────────────
   2 │    98  female      3

julia> dfr[2:3] = ["male", 2] # set values of entries in columns `:Sex` and `:Job`
2-element Vector{Any}:
  "male"
 2

julia> dfr
DataFrameRow
 Row │ Age    Sex     Job
     │ Int64  String  Int64
─────┼──────────────────────
   2 │    98  male        2
```

These operations updated the data stored in the `df1` data frame.

In a similar fashion views can be used to update data stored in their parent
data frame. Here are some examples:

```jldoctest dataframe
julia> sdf = view(df1, :, 2:3)
6×2 SubDataFrame
 Row │ Sex          Job
     │ String       Int64
─────┼────────────────────
   1 │ male             2
   2 │ male             2
   3 │ male             4
   4 │ transgender      2
   5 │ female           2
   6 │ male             1

julia> sdf[2, :Sex] = "female" # set value of col `:Sex` in second row to `female` in-place
"female"

julia> sdf
6×2 SubDataFrame
 Row │ Sex          Job
     │ String       Int64
─────┼────────────────────
   1 │ male             2
   2 │ female           2
   3 │ male             4
   4 │ transgender      2
   5 │ female           2
   6 │ male             1

julia> sdf[6, 1:2] = ["female", 3]
2-element Vector{Any}:
  "female"
 3

julia> sdf
6×2 SubDataFrame
 Row │ Sex          Job
     │ String       Int64
─────┼────────────────────
   1 │ male             2
   2 │ female           2
   3 │ male             4
   4 │ transgender      2
   5 │ female           2
   6 │ female           3
```

In all these cases the parent of `sdf` view was also updated.

### Broadcasting Assignment

Apart from normal assignment one can perform broadcasting assignment using the
`.=` operation.

Before we move forward let us explain how broadcasting works in Julia.
The standard syntax to perform
[broadcasting](https://docs.julialang.org/en/v1/manual/mathematical-operations/#man-dot-operators)
is to use `.`. For example, as opposed to R this operation fails:

```jldoctest dataframe
julia> s = [25, 26, 35, 56]
4-element Vector{Int64}:
 25
 26
 35
 56

julia> s[2:3] = 0
ERROR: ArgumentError: indexed assignment with a single value to possibly many locations is not supported; perhaps use broadcasting `.=` instead?
```

Instead we have to write:

```jldoctest dataframe
julia> s[2:3] .= 0
2-element view(::Vector{Int64}, 2:3) with eltype Int64:
 0
 0

julia> s
4-element Vector{Int64}:
 25
  0
  0
 56
```

Similar syntax is fully supported in DataFrames.jl. Here, Column `:Age` is
replaced freshly allocated vector because of broadcasting assignment:

```jldoctest dataframe
julia> df1[!, :Age] .= [85, 89, 78, 58, 96, 68] # col `:Age` is replaced freshly allocated vector
6-element Vector{Int64}:
 85
 89
 78
 58
 96
 68

julia> df1
6×3 DataFrame
 Row │ Age    Sex          Job
     │ Int64  String       Int64
─────┼───────────────────────────
   1 │    85  male             2
   2 │    89  female           2
   3 │    78  male             4
   4 │    58  transgender      2
   5 │    96  female           2
   6 │    68  female           3
```

Using the `:` instead of `!` above would perform a broadcasting assignment
in-place into an existing column. The major difference between in-place and
replace operations is that replacing columns is needed if new values have a
different type than the old ones.

In the examples below we operate on columns `:Customers` and `:City` that are not
present in `df1`. In this case using `!` and `:` are equivalent and a new column
is allocated:

```jldoctest dataframe
julia> df1[!, :Customers] .= ["Rohit", "Akshat", "Rahul", "Aayush", "Prateek", "Anam"]
6-element Vector{String}:
 "Rohit"
 "Akshat"
 "Rahul"
 "Aayush"
 "Prateek"
 "Anam"

julia> df1[:, :City] .= ["Kanpur", "Lucknow", "Bhuvneshwar", "Jaipur", "Ranchi", "Dehradoon"]
6-element Vector{String}:
 "Kanpur"
 "Lucknow"
 "Bhuvneshwar"
 "Jaipur"
 "Ranchi"
 "Dehradoon"

julia> df1
6×5 DataFrame
 Row │ Age    Sex          Job    Customers  City
     │ Int64  String       Int64  String     String
─────┼───────────────────────────────────────────────────
   1 │    85  male             2  Rohit      Kanpur
   2 │    89  female           2  Akshat     Lucknow
   3 │    78  male             4  Rahul      Bhuvneshwar
   4 │    58  transgender      2  Aayush     Jaipur
   5 │    96  female           2  Prateek    Ranchi
   6 │    68  female           3  Anam       Dehradoon
```

A most common broadcasting assignment operation is when a scalar is used on the
right hand side, e.g:

```jldoctest dataframe
julia> df1[:, 3] .= 4 # an in-place replacement of values stored in column number 3 by 4
6-element view(::Vector{Int64}, :) with eltype Int64:
 4
 4
 4
 4
 4
 4

julia> df1
6×5 DataFrame
 Row │ Age    Sex          Job    Customers  City
     │ Int64  String       Int64  String     String
─────┼───────────────────────────────────────────────────
   1 │    85  male             4  Rohit      Kanpur
   2 │    89  female           4  Akshat     Lucknow
   3 │    78  male             4  Rahul      Bhuvneshwar
   4 │    58  transgender      4  Aayush     Jaipur
   5 │    96  female           4  Prateek    Ranchi
   6 │    68  female           4  Anam       Dehradoon
```

For `:` row selector the broadcasting assignment operation works in-place,
so the following operation throws an error:

```jldoctest dataframe
julia> df1[:, :Age] .= "Economics"
ERROR: MethodError: Cannot `convert` an object of type String to an object of type Int64
```

We need to use `!` instead as it replaces the old vector with a freshly allocated one:

```jldoctest dataframe
julia> df1[!, :Age] .= "Economics"
6-element Vector{String}:
 "Economics"
 "Economics"
 "Economics"
 "Economics"
 "Economics"
 "Economics"

julia> df1
6×5 DataFrame
 Row │ Age        Sex          Job    Customers  City
     │ String     String       Int64  String     String
─────┼───────────────────────────────────────────────────────
   1 │ Economics  male             4  Rohit      Kanpur
   2 │ Economics  female           4  Akshat     Lucknow
   3 │ Economics  male             4  Rahul      Bhuvneshwar
   4 │ Economics  transgender      4  Aayush     Jaipur
   5 │ Economics  female           4  Prateek    Ranchi
   6 │ Economics  female           4  Anam       Dehradoon
```

There are some scenarios in DataFrames.jl, when we naturally want a
broadcasting-like behaviour, but do not allow for the use of `.` operation. In
such cases a so-called pseudo-broadcasting is performed for user convenience. We
have already seen it in examples of `DataFrame` constructor. Below we show
pseudo-broadcasting at work in the `insertcols!` function, that inserts a column
into a data frame in an arbitrary position.

In the example below we are creating a column `:Country` with the `insertcols!`
function. Since we pass a scalar `"India"` value of the column it is broadcasted
to all rows in the output data frame:

```jldoctest dataframe
julia> insertcols!(df1, 1, :Country => "India")
6×6 DataFrame
 Row │ Country  Age        Sex          Job    Customers  City
     │ String   String     String       Int64  String     String
─────┼────────────────────────────────────────────────────────────────
   1 │ India    Economics  male             4  Rohit      Kanpur
   2 │ India    Economics  female           4  Akshat     Lucknow
   3 │ India    Economics  male             4  Rahul      Bhuvneshwar
   4 │ India    Economics  transgender      4  Aayush     Jaipur
   5 │ India    Economics  female           4  Prateek    Ranchi
   6 │ India    Economics  female           4  Anam       Dehradoon
```

You can pass a column location where you want to put the inserted column as a
second argument to the `insertcols!` function:
```
julia> insertcols!(df1, 4, :b => exp(4))
6×7 DataFrame
 Row │ Country  Age        Sex          b        Job    Customers  City        ⋯
     │ String   String     String       Float64  Int64  String     String      ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │ India    Economics  male         54.5982      4  Rohit      Kanpur      ⋯
   2 │ India    Economics  female       54.5982      4  Akshat     Lucknow
   3 │ India    Economics  male         54.5982      4  Rahul      Bhuvneshwar
   4 │ India    Economics  transgender  54.5982      4  Aayush     Jaipur
   5 │ India    Economics  female       54.5982      4  Prateek    Ranchi      ⋯
   6 │ India    Economics  female       54.5982      4  Anam       Dehradoon
```

### Not, Between, Cols, and All Column Selectors

You can use `Not`, `Between`, `Cols`, and `All` selectors in more complex column
selection scenarios:
- `Not` selector (from the [InvertedIndices.jl](https://github.com/mbauman/InvertedIndices.jl)
  package) allows us to specify the columns we want to exclude from the resulting
  data frame. We can put any valid other column selector inside `Not`;
- `Between` selector allows us to specify a range of columns (we can pass the
  start and stop column using any of the single column selector syntaxes);
- `Cols(...)` selector picks a union of other selectors passed as its arguments;
- `All()` allows us to select all columns of `DataFrame`; this is the same as passing `:`;
- regular expression to select columns whose names match it.

Let us give some examples of these selectors.

Drop `:Age` column:

```jldoctest dataframe
julia> german[:, Not(:Age)]
1000×9 DataFrame
  Row │ id     Sex      Job    Housing  Saving accounts  Checking account  Cre ⋯
      │ Int64  String7  Int64  String7  String15         String15          Int ⋯
──────┼─────────────────────────────────────────────────────────────────────────
    1 │     0  male         2  own      NA               little                ⋯
    2 │     1  female       2  own      little           moderate
    3 │     2  male         1  own      little           NA
    4 │     3  male         2  free     little           little
    5 │     4  male         2  free     little           little                ⋯
    6 │     5  male         1  free     NA               NA
    7 │     6  male         2  own      quite rich       NA
    8 │     7  male         3  rent     little           moderate
  ⋮   │   ⋮       ⋮       ⋮       ⋮            ⋮                ⋮              ⋱
  994 │   993  male         3  own      little           little                ⋯
  995 │   994  male         2  own      NA               NA
  996 │   995  female       1  own      little           NA
  997 │   996  male         3  own      little           little
  998 │   997  male         2  own      little           NA                    ⋯
  999 │   998  male         2  free     little           little
 1000 │   999  male         2  own      moderate         moderate
                                                  3 columns and 985 rows omitted
```

Select columns starting from `:Sex` and ending at `:Housing`:

```
julia> german[:, Between(:Sex, :Housing)]
1000×3 DataFrame
  Row │ Sex     Job    Housing
      │ String  Int64  String
──────┼────────────────────────
    1 │ male        2  own
    2 │ female      2  own
    3 │ male        1  own
    4 │ male        2  free
    5 │ male        2  free
    6 │ male        1  free
    7 │ male        2  own
    8 │ male        3  rent
  ⋮   │   ⋮       ⋮       ⋮
  994 │ male        3  own
  995 │ male        2  own
  996 │ female      1  own
  997 │ male        3  own
  998 │ male        2  own
  999 │ male        2  free
 1000 │ male        2  own
               985 rows omitted
```

In the example below `Cols` selector is picking a union of `"Age"` and
`Between("Sex", "Job")` selectors passed as its arguments:

```jldoctest dataframe
julia> german[:, Cols("Age", Between("Sex", "Job"))]
1000×3 DataFrame
  Row │ Age    Sex      Job
      │ Int64  String7  Int64
──────┼───────────────────────
    1 │    67  male         2
    2 │    22  female       2
    3 │    49  male         1
    4 │    45  male         2
    5 │    53  male         2
    6 │    35  male         1
    7 │    53  male         2
    8 │    35  male         3
  ⋮   │   ⋮       ⋮       ⋮
  994 │    30  male         3
  995 │    50  male         2
  996 │    31  female       1
  997 │    40  male         3
  998 │    38  male         2
  999 │    23  male         2
 1000 │    27  male         2
              985 rows omitted
```

You can also use `Regex` (regular expressions) to select columns. In the example
below we select columns that have `"S"` in their name and also we use `Not` to
drop row number 5:

```jldoctest dataframe
julia> german[Not(5), r"S"]
999×2 DataFrame
 Row │ Sex      Saving accounts
     │ String7  String15
─────┼──────────────────────────
   1 │ male     NA
   2 │ female   little
   3 │ male     little
   4 │ male     little
   5 │ male     NA
   6 │ male     quite rich
   7 │ male     little
   8 │ male     rich
  ⋮  │    ⋮            ⋮
 993 │ male     little
 994 │ male     NA
 995 │ female   little
 996 │ male     little
 997 │ male     little
 998 │ male     little
 999 │ male     moderate
                984 rows omitted
```

## Manipulation Functions

The seven functions below can be used to manipulate data frames
by applying operations to them.

The functions without a `!` in their name
will create a new data frame based on the source data frame,
so you will probably want to store the new data frame to a new variable name,
e.g. `new_df = transform(source_df, operation)`.
The functions with a `!` at the end of their name
will modify an existing data frame in-place,
so there is typically no need to assign the result to a variable,
e.g. `transform!(source_df, operation)` instead of
`source_df = transform(source_df, operation)`.

The number of columns and rows in the resultant data frame varies
depending on the manipulation function employed.

| Function     | Memory Usage                     | Column Retention                        | Row Retention                                       |
| ------------ | -------------------------------- | --------------------------------------- | --------------------------------------------------- |
| `transform`  | Creates a new data frame.        | Retains original and resultant columns. | Retains same number of rows as original data frame. |
| `transform!` | Modifies an existing data frame. | Retains original and resultant columns. | Retains same number of rows as original data frame. |
| `select`     | Creates a new data frame.        | Retains only resultant columns.         | Retains same number of rows as original data frame. |
| `select!`    | Modifies an existing data frame. | Retains only resultant columns.         | Retains same number of rows as original data frame. |
| `subset`     | Creates a new data frame.        | Retains original columns.               | Retains only rows where condition is true.          |
| `subset!`    | Modifies an existing data frame. | Retains original columns.               | Retains only rows where condition is true.          |
| `combine`    | Creates a new data frame.        | Retains only resultant columns.         | Retains only resultant rows.                        |

### Constructing Operations

All of the functions above use the same syntax which is commonly
`manipulation_function(dataframe, operation)`.
The `operation` argument defines the
operation to be applied to the source `dataframe`,
and it can take any of the following common forms explained below:

* `source_column_selector`

  selects source column(s) without manipulating or renaming them

  Examples: `:a`, `[:a, :b]`, `All()`, `Not(:a)`

* `source_column_selector => operation_function`

  passes source column(s) as arguments to a function
  and automatically names the resulting column(s)

  Examples: `:a => sum`, `[:a, :b] => +`, `:a => ByRow(==(3))`

* `source_column_selector => operation_function => new_column_names`

  passes source column(s) as arguments to a function
  and names the resulting column(s) `new_column_names`

  Examples: `:a => sum => :sum_of_a`, `[:a, :b] => (+) => :a_plus_b`

  *(Not available for `subset` or `subset!`)*

* `source_column_selector => new_column_names`

  renames a source column,
  or splits a column containing collection elements into multiple new columns

  Examples: `:a => :new_a`, `:a_b => [:a, :b]`, `:nt => AsTable`

  (*Not available for `subset` or `subset!`*)

The `=>` operator constructs a
[Pair](https://docs.julialang.org/en/v1/base/collections/#Core.Pair),
which is a type to link one object to another.
(Pairs are commonly used to create elements of a
[Dictionary](https://docs.julialang.org/en/v1/base/collections/#Dictionaries).)
In DataFrames.jl manipulation functions,
`Pair` arguments are used to define column `operations` to be performed.
The examples shown above will be explained in more detail later.

*The manipulation functions also have methods for applying multiple operations.
See the later sections [Applying Multiple Operations per Manipulation](@ref)
and [Broadcasting Operation Pairs](@ref) for more information.*

#### `source_column_selector`
Inside an `operation`, `source_column_selector` is usually a column name
or column index which identifies a data frame column.

`source_column_selector` may be used as the entire `operation`
with `select` or `select!` to isolate or reorder columns.

```julia
julia> df = DataFrame(a = [1, 2, 3], b = [4, 5, 6], c = [7, 8, 9])
3×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      7
   2 │     2      5      8
   3 │     3      6      9

julia> select(df, :b)
3×1 DataFrame
 Row │ b
     │ Int64
─────┼───────
   1 │     4
   2 │     5
   3 │     6

julia> select(df, "b")
3×1 DataFrame
 Row │ b
     │ Int64
─────┼───────
   1 │     4
   2 │     5
   3 │     6

julia> select(df, 2)
3×1 DataFrame
 Row │ b
     │ Int64
─────┼───────
   1 │     4
   2 │     5
   3 │     6
```

`source_column_selector` may also be used as the entire `operation`
with `subset` or `subset!` if the source column contains `Bool` values.

```julia
julia> df = DataFrame(
           name = ["Scott", "Jill", "Erica", "Jimmy"],
           minor = [false, true, false, true],
       )
4×2 DataFrame
 Row │ name    minor
     │ String  Bool
─────┼───────────────
   1 │ Scott   false
   2 │ Jill     true
   3 │ Erica   false
   4 │ Jimmy    true

julia> subset(df, :minor)
2×2 DataFrame
 Row │ name    minor
     │ String  Bool
─────┼───────────────
   1 │ Jill     true
   2 │ Jimmy    true
```

`source_column_selector` may instead be a collection of columns such as a vector,
a [regular expression](https://docs.julialang.org/en/v1/manual/strings/#man-regex-literals),
a `Not`, `Between`, `All`, or `Cols` expression,
or a `:`.
See the [Indexing](@ref) API for the full list of possible values with references.

!!! note

    The Julia parser sometimes prevents `:` from being used by itself.
    If you get
    `ERROR: syntax: whitespace not allowed after ":" used for quoting`,
    try using `All()`, `Cols(:)`, or `(:)` instead to select all columns.

```julia
julia> df = DataFrame(
           id = [1, 2, 3],
           first_name = ["José", "Emma", "Nathan"],
           last_name = ["Garcia", "Marino", "Boyer"],
           age = [61, 24, 33]
       )
3×4 DataFrame
 Row │ id     first_name  last_name  age
     │ Int64  String      String     Int64
─────┼─────────────────────────────────────
   1 │     1  José        Garcia        61
   2 │     2  Emma        Marino        24
   3 │     3  Nathan      Boyer         33

julia> select(df, [:last_name, :first_name])
3×2 DataFrame
 Row │ last_name  first_name
     │ String     String
─────┼───────────────────────
   1 │ Garcia     José
   2 │ Marino     Emma
   3 │ Boyer      Nathan

julia> select(df, r"name")
3×2 DataFrame
 Row │ first_name  last_name
     │ String      String
─────┼───────────────────────
   1 │ José        Garcia
   2 │ Emma        Marino
   3 │ Nathan      Boyer

julia> select(df, Not(:id))
3×3 DataFrame
 Row │ first_name  last_name  age
     │ String      String     Int64
─────┼──────────────────────────────
   1 │ José        Garcia        61
   2 │ Emma        Marino        24
   3 │ Nathan      Boyer         33

julia> select(df, Between(2,4))
3×3 DataFrame
 Row │ first_name  last_name  age
     │ String      String     Int64
─────┼──────────────────────────────
   1 │ José        Garcia        61
   2 │ Emma        Marino        24
   3 │ Nathan      Boyer         33

julia> df2 = DataFrame(
           name = ["Scott", "Jill", "Erica", "Jimmy"],
           minor = [false, true, false, true],
           male = [true, false, false, true],
       )
4×3 DataFrame
 Row │ name    minor  male
     │ String  Bool   Bool
─────┼──────────────────────
   1 │ Scott   false   true
   2 │ Jill     true  false
   3 │ Erica   false  false
   4 │ Jimmy    true   true

julia> subset(df2, [:minor, :male])
1×3 DataFrame
 Row │ name    minor  male
     │ String  Bool   Bool
─────┼─────────────────────
   1 │ Jimmy    true  true
```

!!! note

    Using `Symbol` in `source_column_selector` will perform slightly faster than using string.
    However, a string is convenient when column names contain spaces.

    All elements of `source_column_selector` must be the same type
    (unless wrapped in `Cols`),
    e.g. `subset(df2, [:minor, "male"])` will error
    since `Symbol` and string are used simultaneously.

#### `operation_function`
Inside an `operation` pair, `operation_function` is a function
which operates on data frame columns passed as vectors.
When multiple columns are selected by `source_column_selector`,
the `operation_function` will receive the columns as separate positional arguments
in the order they were selected, e.g. `f(column1, column2, column3)`.

```julia
julia> df = DataFrame(a = [1, 2, 3], b = [4, 5, 4])
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      4

julia> combine(df, :a => sum)
1×1 DataFrame
 Row │ a_sum
     │ Int64
─────┼───────
   1 │     6

julia> transform(df, :b => maximum) # `transform` and `select` copy scalar result to all rows
3×3 DataFrame
 Row │ a      b      b_maximum
     │ Int64  Int64  Int64
─────┼─────────────────────────
   1 │     1      4          5
   2 │     2      5          5
   3 │     3      4          5

julia> transform(df, [:b, :a] => -) # vector subtraction is okay
3×3 DataFrame
 Row │ a      b      b_a_-
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      3
   2 │     2      5      3
   3 │     3      4      1

julia> transform(df, [:a, :b] => *) # vector multiplication is not defined
ERROR: MethodError: no method matching *(::Vector{Int64}, ::Vector{Int64})
```

Don't worry! There is a quick fix for the previous error.
If you want to apply a function to each element in a column
instead of to the entire column vector,
then you can wrap your element-wise function in `ByRow` like
`ByRow(my_elementwise_function)`.
This will apply `my_elementwise_function` to every element in the column
and then collect the results back into a vector.

```julia
julia> transform(df, [:a, :b] => ByRow(*))
3×3 DataFrame
 Row │ a      b      a_b_*
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      4
   2 │     2      5     10
   3 │     3      4     12

julia> transform(df, Cols(:) => ByRow(max))
3×3 DataFrame
 Row │ a      b      a_b_max
     │ Int64  Int64  Int64
─────┼───────────────────────
   1 │     1      4        4
   2 │     2      5        5
   3 │     3      4        4

julia> f(x) = x + 1
f (generic function with 1 method)

julia> transform(df, :a => ByRow(f))
3×3 DataFrame
 Row │ a      b      a_f
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      2
   2 │     2      5      3
   3 │     3      4      4
```

Alternatively, you may just want to define the function itself so it
[broadcasts](https://docs.julialang.org/en/v1/manual/arrays/#Broadcasting)
over vectors.

```julia
julia> g(x) = x .+ 1
g (generic function with 1 method)

julia> transform(df, :a => g)
3×3 DataFrame
 Row │ a      b      a_g
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      2
   2 │     2      5      3
   3 │     3      4      4

julia> h(x, y) = x .+ y .+ 1
h (generic function with 1 method)

julia> transform(df, [:a, :b] => h)
3×3 DataFrame
 Row │ a      b      a_b_h
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      6
   2 │     2      5      8
   3 │     3      4      8
```

[Anonymous functions](https://docs.julialang.org/en/v1/manual/functions/#man-anonymous-functions)
are a convenient way to define and use an `operation_function`
all within the manipulation function call.

```julia
julia> select(df, :a => ByRow(x -> x + 1))
3×1 DataFrame
 Row │ a_function
     │ Int64
─────┼────────────
   1 │          2
   2 │          3
   3 │          4

julia> transform(df, [:a, :b] => ByRow((x, y) -> 2x + y))
3×3 DataFrame
 Row │ a      b      a_b_function
     │ Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      4             6
   2 │     2      5             9
   3 │     3      4            10

julia> subset(df, :b => ByRow(x -> x < 5))
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     3      4

julia> subset(df, :b => ByRow(<(5))) # shorter version of the previous
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     3      4
```

!!! note

    `operation_functions` within `subset` or `subset!` function calls
    must return a Boolean vector.
    `true` elements in the Boolean vector will determine
    which rows are retained in the resulting data frame.

As demonstrated above, `DataFrame` columns are usually passed
from `source_column_selector` to `operation_function` as one or more
vector arguments.
However, when `AsTable(source_column_selector)` is used,
the selected columns are collected and passed as a single `NamedTuple`
to `operation_function`.

This is often useful when your `operation_function` is defined to operate
on a single collection argument rather than on multiple positional arguments.
The distinction is somewhat similar to the difference between the built-in
`min` and `minimum` functions.
`min` is defined to find the minimum value among multiple positional arguments,
while `minimum` is defined to find the minimum value
among the elements of a single collection argument.

```julia
julia> df = DataFrame(a = 1:2, b = 3:4, c = 5:6, d = 2:-1:1)
2×4 DataFrame
 Row │ a      b      c      d
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      3      5      2
   2 │     2      4      6      1

julia> select(df, Cols(:) => ByRow(min)) # min operates on multiple arguments
2×1 DataFrame
 Row │ a_b_etc_min
     │ Int64
─────┼─────────────
   1 │           1
   2 │           1

julia> select(df, AsTable(:) => ByRow(minimum)) # minimum operates on a collection
2×1 DataFrame
 Row │ a_b_etc_minimum
     │ Int64
─────┼─────────────────
   1 │               1
   2 │               1

julia> select(df, [:a,:b] => ByRow(+)) # `+` operates on a multiple arguments
2×1 DataFrame
 Row │ a_b_+
     │ Int64
─────┼───────
   1 │     4
   2 │     6

julia> select(df, AsTable([:a,:b]) => ByRow(sum)) # `sum` operates on a collection
2×1 DataFrame
 Row │ a_b_sum
     │ Int64
─────┼─────────
   1 │       4
   2 │       6

julia> using Statistics # contains the `mean` function

julia> select(df, AsTable(Between(:b, :d)) => ByRow(mean)) # `mean` operates on a collection
2×1 DataFrame
 Row │ b_c_d_mean
     │ Float64
─────┼────────────
   1 │    3.33333
   2 │    3.66667
```

`AsTable` can also be used to pass columns to a function which operates
on fields of a `NamedTuple`.

```julia
julia> df = DataFrame(a = 1:2, b = 3:4, c = 5:6, d = 7:8)
2×4 DataFrame
 Row │ a      b      c      d
     │ Int64  Int64  Int64  Int64
─────┼────────────────────────────
   1 │     1      3      5      7
   2 │     2      4      6      8

julia> f(nt) = nt.a + nt.d
f (generic function with 1 method)

julia> transform(df, AsTable(:) => ByRow(f))
2×5 DataFrame
 Row │ a      b      c      d      a_b_etc_f
     │ Int64  Int64  Int64  Int64  Int64
─────┼───────────────────────────────────────
   1 │     1      3      5      7          8
   2 │     2      4      6      8         10
```

As demonstrated above,
in the `source_column_selector => operation_function` operation pair form,
the results of an operation will be placed into a new column with an
automatically-generated name based on the operation;
the new column name will be the `operation_function` name
appended to the source column name(s) with an underscore.

This automatic column naming behavior can be avoided in two ways.
First, the operation result can be placed back into the original column
with the original column name by switching the keyword argument `renamecols`
from its default value (`true`) to `renamecols=false`.
This option prevents the function name from being appended to the column name
as it usually would be.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> transform(df, :a => ByRow(x->x+10), renamecols=false) # add 10 in-place
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │    11      5
   2 │    12      6
   3 │    13      7
   4 │    14      8
```

The second method to avoid the default manipulation column naming is to
specify your own `new_column_names`.

#### `new_column_names`

`new_column_names` can be included at the end of an `operation` pair to specify
the name of the new column(s).
`new_column_names` may be a symbol, string, function, vector of symbols, vector of strings, or `AsTable`.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> transform(df, Cols(:) => ByRow(+) => :c)
4×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      6
   2 │     2      6      8
   3 │     3      7     10
   4 │     4      8     12

julia> transform(df, Cols(:) => ByRow(+) => "a+b")
4×3 DataFrame
 Row │ a      b      a+b
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      6
   2 │     2      6      8
   3 │     3      7     10
   4 │     4      8     12

julia> transform(df, :a => ByRow(x->x+10) => "a+10")
4×3 DataFrame
 Row │ a      b      a+10
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5     11
   2 │     2      6     12
   3 │     3      7     13
   4 │     4      8     14
```

The `source_column_selector => new_column_names` operation form
can be used to rename columns without an intermediate function.
However, there are `rename` and `rename!` functions,
which accept similar syntax,
that tend to be more useful for this operation.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> transform(df, :a => :apple) # adds column `apple`
4×3 DataFrame
 Row │ a      b      apple
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      1
   2 │     2      6      2
   3 │     3      7      3
   4 │     4      8      4

julia> select(df, :a => :apple) # retains only column `apple`
4×1 DataFrame
 Row │ apple
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3
   4 │     4

julia> rename(df, :a => :apple) # renames column `a` to `apple` in-place
4×2 DataFrame
 Row │ apple  b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8
```

If `new_column_names` already exist in the source data frame,
those columns will be replaced in the existing column location
rather than being added to the end.
This can be done by manually specifying an existing column name
or by using the `renamecols=false` keyword argument.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> transform(df, :b => (x -> x .+ 10))  # automatic new column and column name
4×3 DataFrame
 Row │ a      b      b_function
     │ Int64  Int64  Int64
─────┼──────────────────────────
   1 │     1      5          15
   2 │     2      6          16
   3 │     3      7          17
   4 │     4      8          18

julia> transform(df, :b => (x -> x .+ 10), renamecols=false)  # transform column in-place
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1     15
   2 │     2     16
   3 │     3     17
   4 │     4     18

julia> transform(df, :b => (x -> x .+ 10) => :a)  # replace column :a
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │    15      5
   2 │    16      6
   3 │    17      7
   4 │    18      8
```

Actually, `renamecols=false` just prevents the function name from being appended
to the final column name such that the operation is *usually* returned to the same column.

```julia
julia> transform(df, [:a, :b] => +)  # new column name is all source columns and function name
4×3 DataFrame
 Row │ a      b      a_b_+
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      6
   2 │     2      6      8
   3 │     3      7     10
   4 │     4      8     12

julia> transform(df, [:a, :b] => +, renamecols=false)  # same as above but with no function name
4×3 DataFrame
 Row │ a      b      a_b
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      6
   2 │     2      6      8
   3 │     3      7     10
   4 │     4      8     12

julia> transform(df, [:a, :b] => (+) => :a)  # manually overwrite column :a (see Note below about parentheses)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     6      5
   2 │     8      6
   3 │    10      7
   4 │    12      8
```

In the `source_column_selector => operation_function => new_column_names` operation form,
`new_column_names` may also be a renaming function which operates on a string
to create the destination column names programmatically.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> add_prefix(s) = "new_" * s
add_prefix (generic function with 1 method)

julia> transform(df, :a => (x -> 10 .* x) => add_prefix) # with named renaming function
4×3 DataFrame
 Row │ a      b      new_a
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5     10
   2 │     2      6     20
   3 │     3      7     30
   4 │     4      8     40

julia> transform(df, :a => (x -> 10 .* x) => (s -> "new_" * s)) # with anonymous renaming function
4×3 DataFrame
 Row │ a      b      new_a
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5     10
   2 │     2      6     20
   3 │     3      7     30
   4 │     4      8     40
```

!!! note

    It is a good idea to wrap anonymous functions in parentheses
    to avoid the `=>` operator accidently becoming part of the anonymous function.
    The examples above do not work correctly without the parentheses!
    ```julia
    julia> transform(df, :a => x -> 10 .* x => add_prefix)  # Not what we wanted!
    4×3 DataFrame
     Row │ a      b      a_function
         │ Int64  Int64  Pair…
    ─────┼────────────────────────────────────────────
       1 │     1      5  [10, 20, 30, 40]=>add_prefix
       2 │     2      6  [10, 20, 30, 40]=>add_prefix
       3 │     3      7  [10, 20, 30, 40]=>add_prefix
       4 │     4      8  [10, 20, 30, 40]=>add_prefix
    julia> transform(df, :a => x -> 10 .* x => s -> "new_" * s)  # Not what we wanted!
    4×3 DataFrame
     Row │ a      b      a_function
         │ Int64  Int64  Pair…
    ─────┼─────────────────────────────────────
       1 │     1      5  [10, 20, 30, 40]=>#18
       2 │     2      6  [10, 20, 30, 40]=>#18
       3 │     3      7  [10, 20, 30, 40]=>#18
       4 │     4      8  [10, 20, 30, 40]=>#18
    ```

A renaming function will not work in the
`source_column_selector => new_column_names` operation form
because a function in the second element of the operation pair is assumed to take
the `source_column_selector => operation_function` operation form.
To work around this limitation, use the
`source_column_selector => operation_function => new_column_names` operation form
with `identity` as the `operation_function`.

```julia
julia> transform(df, :a => add_prefix)
ERROR: MethodError: no method matching *(::String, ::Vector{Int64})

julia> transform(df, :a => identity => add_prefix)
4×3 DataFrame
 Row │ a      b      new_a
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      5      1
   2 │     2      6      2
   3 │     3      7      3
   4 │     4      8      4
```

In this case though,
it is probably again more useful to use the `rename` or `rename!` function
rather than one of the manipulation functions
in order to rename in-place and avoid the intermediate `operation_function`.
```julia
julia> rename(add_prefix, df)  # rename all columns with a function
4×2 DataFrame
 Row │ new_a  new_b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> rename(add_prefix, df; cols=:a)  # rename some columns with a function
4×2 DataFrame
 Row │ new_a  b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8
```

In the `source_column_selector => new_column_names` operation form,
only a single source column may be selected per operation,
so why is `new_column_names` plural?
It is possible to split the data contained inside a single column
into multiple new columns by supplying a vector of strings or symbols
as `new_column_names`.

```julia
julia> df = DataFrame(data = [(1,2), (3,4)]) # vector of tuples
2×1 DataFrame
 Row │ data
     │ Tuple…
─────┼────────
   1 │ (1, 2)
   2 │ (3, 4)

julia> transform(df, :data => [:first, :second]) # manual naming
2×3 DataFrame
 Row │ data    first  second
     │ Tuple…  Int64  Int64
─────┼───────────────────────
   1 │ (1, 2)      1       2
   2 │ (3, 4)      3       4
```

This kind of data splitting can even be done automatically with `AsTable`.

```julia
julia> transform(df, :data => AsTable) # default automatic naming with tuples
2×3 DataFrame
 Row │ data    x1     x2
     │ Tuple…  Int64  Int64
─────┼──────────────────────
   1 │ (1, 2)      1      2
   2 │ (3, 4)      3      4
```

If a data frame column contains `NamedTuple`s,
then `AsTable` will preserve the field names.
```julia
julia> df = DataFrame(data = [(a=1,b=2), (a=3,b=4)]) # vector of named tuples
2×1 DataFrame
 Row │ data
     │ NamedTup…
─────┼────────────────
   1 │ (a = 1, b = 2)
   2 │ (a = 3, b = 4)

julia> transform(df, :data => AsTable) # keeps names from named tuples
2×3 DataFrame
 Row │ data            a      b
     │ NamedTup…       Int64  Int64
─────┼──────────────────────────────
   1 │ (a = 1, b = 2)      1      2
   2 │ (a = 3, b = 4)      3      4
```

!!! note

    To pack multiple columns into a single column of `NamedTuple`s
    (reverse of the above operation)
    apply the `identity` function `ByRow`, e.g.
    `transform(df, AsTable([:a, :b]) => ByRow(identity) => :data)`.

Renaming functions also work for multi-column transformations,
but they must operate on a vector of strings.

```julia
julia> df = DataFrame(data = [(1,2), (3,4)])
2×1 DataFrame
 Row │ data
     │ Tuple…
─────┼────────
   1 │ (1, 2)
   2 │ (3, 4)

julia> new_names(v) = ["primary ", "secondary "] .* v
new_names (generic function with 1 method)

julia> transform(df, :data => identity => new_names)
2×3 DataFrame
 Row │ data    primary data  secondary data
     │ Tuple…  Int64         Int64
─────┼──────────────────────────────────────
   1 │ (1, 2)             1               2
   2 │ (3, 4)             3               4
```

### Applying Multiple Operations per Manipulation
All data frame manipulation functions can accept multiple `operation` pairs
at once using any of the following methods:
- `manipulation_function(dataframe, operation1, operation2)`   : multiple arguments
- `manipulation_function(dataframe, [operation1, operation2])` : vector argument
- `manipulation_function(dataframe, [operation1 operation2])`  : matrix argument

Passing multiple operations is especially useful for the `select`, `select!`,
and `combine` manipulation functions,
since they only retain columns which are a result of the passed operations.

```julia
julia> df = DataFrame(a = 1:4, b = [50,50,60,60], c = ["hat","bat","cat","dog"])
4×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     1     50  hat
   2 │     2     50  bat
   3 │     3     60  cat
   4 │     4     60  dog

julia> combine(df, :a => maximum, :b => sum, :c => join) # 3 combine operations
1×3 DataFrame
 Row │ a_maximum  b_sum  c_join
     │ Int64      Int64  String
─────┼────────────────────────────────
   1 │         4    220  hatbatcatdog

julia> select(df, :c, :b, :a) # re-order columns
4×3 DataFrame
 Row │ c       b      a
     │ String  Int64  Int64
─────┼──────────────────────
   1 │ hat        50      1
   2 │ bat        50      2
   3 │ cat        60      3
   4 │ dog        60      4

ulia> select(df, :b, :) # `:` here means all other columns
4×3 DataFrame
 Row │ b      a      c
     │ Int64  Int64  String
─────┼──────────────────────
   1 │    50      1  hat
   2 │    50      2  bat
   3 │    60      3  cat
   4 │    60      4  dog

julia> select(
           df,
           :c => (x -> "a " .* x) => :one_c,
           :a => (x -> 100x),
           :b,
           renamecols=false
       ) # can mix operation forms
4×3 DataFrame
 Row │ one_c   a      b
     │ String  Int64  Int64
─────┼──────────────────────
   1 │ a hat     100     50
   2 │ a bat     200     50
   3 │ a cat     300     60
   4 │ a dog     400     60

julia> select(
           df,
           :c => ByRow(reverse),
           :c => ByRow(uppercase)
       ) # multiple operations on same column
4×2 DataFrame
 Row │ c_reverse  c_uppercase
     │ String     String
─────┼────────────────────────
   1 │ tah        HAT
   2 │ tab        BAT
   3 │ tac        CAT
   4 │ god        DOG
```

In the last two examples,
the manipulation function arguments were split across multiple lines.
This is a good way to make manipulations with many operations more readable.

Passing multiple operations to `subset` or `subset!` is an easy way to narrow in
on a particular row of data.

```julia
julia> subset(
           df,
           :b => ByRow(==(60)),
           :c => ByRow(contains("at"))
       ) # rows with 60 and "at"
1×3 DataFrame
 Row │ a      b      c
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     3     60  cat
```

Note that all operations within a single manipulation must use the data
as it existed before the function call
i.e. you cannot use newly created columns for subsequent operations
within the same manipulation.

```julia
julia> transform(
           df,
           [:a, :b] => ByRow(+) => :d,
           :d => (x -> x ./ 2),
       ) # requires two separate transformations
ERROR: ArgumentError: column name :d not found in the data frame; existing most similar names are: :a, :b and :c

julia> new_df = transform(df, [:a, :b] => ByRow(+) => :d)
4×4 DataFrame
 Row │ a      b      c       d
     │ Int64  Int64  String  Int64
─────┼─────────────────────────────
   1 │     1     50  hat        51
   2 │     2     50  bat        52
   3 │     3     60  cat        63
   4 │     4     60  dog        64

julia> transform!(new_df, :d => (x -> x ./ 2) => :d_2)
4×5 DataFrame
 Row │ a      b      c       d      d_2
     │ Int64  Int64  String  Int64  Float64
─────┼──────────────────────────────────────
   1 │     1     50  hat        51     25.5
   2 │     2     50  bat        52     26.0
   3 │     3     60  cat        63     31.5
   4 │     4     60  dog        64     32.0
```


### Broadcasting Operation Pairs

[Broadcasting](https://docs.julialang.org/en/v1/manual/arrays/#Broadcasting)
pairs with `.=>` is often a convenient way to generate multiple
similar `operation`s to be applied within a single manipulation.
Broadcasting within the `Pair` of an `operation` is no different than
broadcasting in base Julia.
The broadcasting `.=>` will be expanded into a vector of pairs
(`[operation1, operation2, ...]`),
and this expansion will occur before the manipulation function is invoked.
Then the manipulation function will use the
`manipulation_function(dataframe, [operation1, operation2, ...])` method.
This process will be explained in more detail below.

To illustrate these concepts, let us first examine the `Type` of a basic `Pair`.
In DataFrames.jl, a symbol, string, or integer
may be used to select a single column.
Some `Pair`s with these types are below.

```julia
julia> typeof(:x => :a)
Pair{Symbol, Symbol}

julia> typeof("x" => "a")
Pair{String, String}

julia> typeof(1 => "a")
Pair{Int64, String}
```

Any of the `Pair`s above could be used to rename the first column
of the data frame below to `a`.

```julia
julia> df = DataFrame(x = 1:3, y = 4:6)
3×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> select(df, :x => :a)
3×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> select(df, 1 => "a")
3×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3
```

What should we do if we want to keep and rename both the `x` and `y` column?
One option is to supply a `Vector` of operation `Pair`s to `select`.
`select` will process all of these operations in order.

```julia
julia> ["x" => "a", "y" => "b"]
2-element Vector{Pair{String, String}}:
 "x" => "a"
 "y" => "b"

julia> select(df, ["x" => "a", "y" => "b"])
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6
```

We can use broadcasting to simplify the syntax above.

```julia
julia> ["x", "y"] .=> ["a", "b"]
2-element Vector{Pair{String, String}}:
 "x" => "a"
 "y" => "b"

julia> select(df, ["x", "y"] .=> ["a", "b"])
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6
```

Notice that `select` sees the same `Vector{Pair{String, String}}` operation
argument whether the individual pairs are written out explicitly or
constructed with broadcasting.
The broadcasting is applied before the call to `select`.

```julia
julia> ["x" => "a", "y" => "b"] == (["x", "y"] .=> ["a", "b"])
true
```

!!! note

    These operation pairs (or vector of pairs) can be given variable names.
    This is uncommon in practice but could be helpful for intermediate
    inspection and testing.
    ```julia
    df = DataFrame(x = 1:3, y = 4:6)       # create data frame
    operation = ["x", "y"] .=> ["a", "b"]  # save operation to variable
    typeof(operation)                      # check type of operation
    first(operation)                       # check first pair in operation
    last(operation)                        # check last pair in operation
    select(df, operation)                  # manipulate `df` with `operation`
    ```

In Julia,
a non-vector broadcasted with a vector will be repeated in each resultant pair element.

```julia
julia> ["x", "y"] .=> :a    # :a is repeated
2-element Vector{Pair{String, Symbol}}:
 "x" => :a
 "y" => :a

julia> 1 .=> [:a, :b]       # 1 is repeated
2-element Vector{Pair{Int64, Symbol}}:
 1 => :a
 1 => :b
```

We can use this fact to easily broadcast an `operation_function` to multiple columns.

```julia
julia> f(x) = 2 * x
f (generic function with 1 method)

julia> ["x", "y"] .=> f  # f is repeated
2-element Vector{Pair{String, typeof(f)}}:
 "x" => f
 "y" => f

julia> select(df, ["x", "y"] .=> f)  # apply f with automatic column renaming
3×2 DataFrame
 Row │ x_f    y_f
     │ Int64  Int64
─────┼──────────────
   1 │     2      8
   2 │     4     10
   3 │     6     12

julia> ["x", "y"] .=> f .=> ["a", "b"]  # f is repeated
2-element Vector{Pair{String, Pair{typeof(f), String}}}:
 "x" => (f => "a")
 "y" => (f => "b")

julia> select(df, ["x", "y"] .=> f .=> ["a", "b"])  # apply f with manual column renaming
3×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     2      8
   2 │     4     10
   3 │     6     12
```

A renaming function can be applied to multiple columns in the same way.
It will also be repeated in each operation `Pair`.

```julia
julia> newname(s::String) = s * "_new"
newname (generic function with 1 method)

julia> ["x", "y"] .=> f .=> newname  # both f and newname are repeated
2-element Vector{Pair{String, Pair{typeof(f), typeof(newname)}}}:
 "x" => (f => newname)
 "y" => (f => newname)

julia> select(df, ["x", "y"] .=> f .=> newname)  # apply f then rename column with newname
3×2 DataFrame
 Row │ x_new  y_new
     │ Int64  Int64
─────┼──────────────
   1 │     2      8
   2 │     4     10
   3 │     6     12
```

You can see from the type output above
that a three element pair does not actually exist.
A `Pair` (as the name implies) can only contain two elements.
Thus, `:x => :y => :z` becomes a nested `Pair`,
where `:x` is the first element and points to the `Pair` `:y => :z`,
which is the second element.

```julia
julia> p = :x => :y => :z
:x => (:y => :z)

julia> p[1]
:x

julia> p[2]
:y => :z

julia> p[2][1]
:y

julia> p[2][2]
:z

julia> p[3] # there is no index 3 for a pair
ERROR: BoundsError: attempt to access Pair{Symbol, Pair{Symbol, Symbol}} at index [3]
```

In the previous examples, the source columns have been individually selected.
When broadcasting multiple columns to the same function,
often similarities in the column names or position can be exploited to avoid
tedious selection.
Consider a data frame with temperature data at three different locations
taken over time.
```julia
julia> df = DataFrame(Time = 1:4,
                      Temperature1 = [20, 23, 25, 28],
                      Temperature2 = [33, 37, 41, 44],
                      Temperature3 = [15, 10, 4, 0])
4×4 DataFrame
 Row │ Time   Temperature1  Temperature2  Temperature3
     │ Int64  Int64         Int64         Int64
─────┼─────────────────────────────────────────────────
   1 │     1            20            33            15
   2 │     2            23            37            10
   3 │     3            25            41             4
   4 │     4            28            44             0
```

To convert all of the temperature data in one transformation,
we just need to define a conversion function and broadcast
it to all of the "Temperature" columns.

```julia
julia> celsius_to_kelvin(x) = x + 273
celsius_to_kelvin (generic function with 1 method)

julia> transform(
           df,
           Cols(r"Temp") .=> ByRow(celsius_to_kelvin),
           renamecols = false
       )
4×4 DataFrame
 Row │ Time   Temperature1  Temperature2  Temperature3
     │ Int64  Int64         Int64         Int64
─────┼─────────────────────────────────────────────────
   1 │     1           293           306           288
   2 │     2           296           310           283
   3 │     3           298           314           277
   4 │     4           301           317           273
```
Or, simultaneously changing the column names:

```julia
julia> rename_function(s) = "Temperature $(last(s)) (K)"
rename_function (generic function with 1 method)

julia> select(
           df,
           "Time",
           Cols(r"Temp") .=> ByRow(celsius_to_kelvin) .=> rename_function
       )
4×4 DataFrame
 Row │ Time   Temperature 1 (K)  Temperature 2 (K)  Temperature 3 (K)
     │ Int64  Int64              Int64              Int64
─────┼────────────────────────────────────────────────────────────────
   1 │     1                293                306                288
   2 │     2                296                310                283
   3 │     3                298                314                277
   4 │     4                301                317                273
```

!!! note "Notes"

    * `Not("Time")` or `2:4` would have been equally good choices
      for `source_column_selector` in the above operations.

    * Don't forget `ByRow` if your function is to be applied to elements
      rather than entire column vectors.
      Without `ByRow`, the manipulations above would have thrown
      `ERROR: MethodError: no method matching +(::Vector{Int64}, ::Int64)`.

    * Regular expression (`r""`) and `:` `source_column_selectors`
      must be wrapped in `Cols` to be properly broadcasted
      because otherwise the broadcasting occurs before the expression
      is expanded into a vector of matches.

You could also broadcast different columns to different functions
by supplying a vector of functions.

```julia
julia> df = DataFrame(a=1:4, b=5:8)
4×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      5
   2 │     2      6
   3 │     3      7
   4 │     4      8

julia> f1(x) = x .+ 1
f1 (generic function with 1 method)

julia> f2(x) = x ./ 10
f2 (generic function with 1 method)

julia> transform(df, [:a, :b] .=> [f1, f2])
4×4 DataFrame
 Row │ a      b      a_f1   b_f2
     │ Int64  Int64  Int64  Float64
─────┼──────────────────────────────
   1 │     1      5      2      0.5
   2 │     2      6      3      0.6
   3 │     3      7      4      0.7
   4 │     4      8      5      0.8
```

However, this form is not much more convenient than supplying
multiple individual operations.

```julia
julia> transform(df, [:a => f1, :b => f2]) # same manipulation as previous
4×4 DataFrame
 Row │ a      b      a_f1   b_f2
     │ Int64  Int64  Int64  Float64
─────┼──────────────────────────────
   1 │     1      5      2      0.5
   2 │     2      6      3      0.6
   3 │     3      7      4      0.7
   4 │     4      8      5      0.8
```

Perhaps more useful for broadcasting syntax
is to apply multiple functions to multiple columns
by changing the vector of functions to a 1-by-x matrix of functions.
(Recall that a list, a vector, or a matrix of operation pairs are all valid
for passing to the manipulation functions.)

```julia
julia> [:a, :b] .=> [f1 f2] # No comma `,` between f1 and f2
2×2 Matrix{Pair{Symbol}}:
 :a=>f1  :a=>f2
 :b=>f1  :b=>f2

julia> transform(df, [:a, :b] .=> [f1 f2]) # No comma `,` between f1 and f2
4×6 DataFrame
 Row │ a      b      a_f1   b_f1   a_f2     b_f2
     │ Int64  Int64  Int64  Int64  Float64  Float64
─────┼──────────────────────────────────────────────
   1 │     1      5      2      6      0.1      0.5
   2 │     2      6      3      7      0.2      0.6
   3 │     3      7      4      8      0.3      0.7
   4 │     4      8      5      9      0.4      0.8
```

In this way, every combination of selected columns and functions will be applied.

Pair broadcasting is a simple but powerful tool
that can be used in any of the manipulation functions listed under
[Manipulation Functions](@ref).
Experiment for yourself to discover other useful operations.

### Additional Resources
More details and examples of operation pair syntax can be found in
[this blog post](https://bkamins.github.io/julialang/2020/12/24/minilanguage.html).
(The official wording describing the syntax has changed since the blog post was written,
but the examples are still illustrative.
The operation pair syntax is sometimes referred to as the DataFrames.jl mini-language
or Domain-Specific Language.)

For additional syntax niceties,
many users find the [Chain.jl](https://github.com/jkrumbiegel/Chain.jl)
and [DataFramesMeta.jl](https://github.com/JuliaData/DataFramesMeta.jl)
packages useful
to help simplify manipulations that may be tedious with operation pairs alone.

## Approach Comparison

After that deep dive into [Manipulation Functions](@ref),
it is a good idea to review the alternative approaches covered in
[Getting and Setting Data in a Data Frame](@ref).
Let us compare the approaches with a few examples.

For simple operations,
often getting/setting data with dot syntax
is simpler than the equivalent data frame manipulation.
Here we will add the two columns of our data frame together
and place the result in a new third column.

**Setup:**

```julia
julia> df = DataFrame(x = 1:3, y = 4:6)  # define a data frame
3×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6
```

**Manipulation:**

```julia
julia> transform!(df, [:x, :y] => (+) => :z)
3×3 DataFrame
 Row │ x      y      z
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      5
   2 │     2      5      7
   3 │     3      6      9
```

**Dot Syntax:**

```julia
julia> df.z = df.x + df.y
3-element Vector{Int64}:
 5
 7
 9

julia> df  # see that the previous expression updated the data frame `df`
3×3 DataFrame
 Row │ x      y      z
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      5
   2 │     2      5      7
   3 │     3      6      9
```

Recall that the return type from a data frame manipulation function call
is always a data frame.
The return type of a data frame column accessed with dot syntax is a `Vector`.
Thus the expression `df.x + df.y` gets the column data as vectors
and returns the result of the vector addition.
However, in that same line,
we assigned the resultant `Vector` to a new column `z` in the data frame `df`.
We could have instead assigned the resultant `Vector` to some other variable,
and then `df` would not have been altered.
The approach with dot syntax is very versatile
since the data getting, mathematics, and data setting can be separate steps.

```julia
julia> df.x  # dot syntax returns a vector
3-element Vector{Int64}:
 1
 2
 3

julia> v = df.x + df.y  # assign mathematical result to a vector `v`
3-element Vector{Int64}:
 5
 7
 9

julia> df.z = v  # place `v` into the data frame `df` with the column name `z`
3-element Vector{Int64}:
 5
 7
 9
```

However, one way in which dot syntax is less versatile
is that the column name must be explicitly written in the code.
Indexing syntax is a good alternative in these cases
which is only slightly longer to write than dot syntax.
Both indexing syntax and manipulation functions can operate on dynamic column names
stored in variables.

**Setup:**

Imagine this setup data was read from a file and/or entered by a user at runtime.

```julia
julia> df = DataFrame("My First Column" => 1:3, "My Second Column" => 4:6)  # define a data frame
3×2 DataFrame
 Row │ My First Column  My Second Column
     │ Int64            Int64
─────┼───────────────────────────────────
   1 │               1                 4
   2 │               2                 5
   3 │               3                 6

julia> c1 = "My First Column"; c2 = "My Second Column"; c3 = "My Third Column";  # define column names
```

**Dot Syntax:**

```julia
julia> df.c1  # dot syntax expects an explicit column name and cannot be used to access variable column name
ERROR: ArgumentError: column name :c1 not found in the data frame
```

**Indexing:**

```julia
julia> df[:, c3] = df[:, c1] + df[:, c2]  # access columns with names stored in variables
3-element Vector{Int64}:
 5
 7
 9

julia> df  # see that the previous expression updated the data frame `df`
3×3 DataFrame
 Row │ My First Column  My Second Column  My Third Column
     │ Int64            Int64             Int64
─────┼────────────────────────────────────────────────────
   1 │               1                 4                5
   2 │               2                 5                7
   3 │               3                 6                9
```

**Manipulation:**

```julia
julia> transform!(df, [c1, c2] => (+) => c3)  # access columns with names stored in variables
3×3 DataFrame
 Row │ My First Column  My Second Column  My Third Column
     │ Int64            Int64             Int64
─────┼────────────────────────────────────────────────────
   1 │               1                 4                5
   2 │               2                 5                7
   3 │               3                 6                9
```

Additionally, manipulation functions only require
the name of the data frame to be written once.
This can be helpful when dealing with long variable and column names.

**Setup:**

```julia
julia> my_very_long_data_frame_name = DataFrame(
           "My First Column" => 1:3,
           "My Second Column" => 4:6
       )  # define a data frame
3×2 DataFrame
 Row │ My First Column  My Second Column
     │ Int64            Int64
─────┼───────────────────────────────────
   1 │               1                 4
   2 │               2                 5
   3 │               3                 6

julia> c1 = "My First Column"; c2 = "My Second Column"; c3 = "My Third Column";  # define column names
```
**Manipulation:**

```julia

julia> transform!(my_very_long_data_frame_name, [c1, c2] => (+) => c3)
3×3 DataFrame
 Row │ My First Column  My Second Column  My Third Column
     │ Int64            Int64             Int64
─────┼────────────────────────────────────────────────────
   1 │               1                 4                5
   2 │               2                 5                7
   3 │               3                 6                9
```

**Indexing:**

```julia
julia> my_very_long_data_frame_name[:, c3] = my_very_long_data_frame_name[:, c1] + my_very_long_data_frame_name[:, c2]
3-element Vector{Int64}:
 5
 7
 9

julia> df  # see that the previous expression updated the data frame `df`
3×3 DataFrame
 Row │ My First Column  My Second Column  My Third Column
     │ Int64            Int64             Int64
─────┼────────────────────────────────────────────────────
   1 │               1                 4                5
   2 │               2                 5                7
   3 │               3                 6                9
```

Another benefit of manipulation functions and indexing over dot syntax is that
it is easier to operate on a subset of columns.

**Setup:**

```julia
julia> df = DataFrame(x = 1:3, y = 4:6, z = 7:9)  # define data frame
3×3 DataFrame
 Row │ x      y      z
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      4      7
   2 │     2      5      8
   3 │     3      6      9
```

**Dot Syntax:**

```julia
julia> df.Not(:x)  # will not work; requires a literal column name
ERROR: ArgumentError: column name :Not not found in the data frame
```

**Manipulation:**

```julia
julia> transform!(df, Not(:x) => ByRow(max))  # find maximum value across all rows except for column `x`
3×4 DataFrame
 Row │ x      y      z      y_z_max
     │ Int64  Int64  Int64  Int64
─────┼──────────────────────────────
   1 │     1      4      7        7
   2 │     2      5      8        8
   3 │     3      6      9        9
```

**Indexing:**

```julia
julia> df[:, :y_z_max] = maximum.(eachrow(df[:, Not(:x)]))  # find maximum value across all rows except for column `x`
3-element Vector{Int64}:
 7
 8
 9

julia> df  # see that the previous expression updated the data frame `df`
3×4 DataFrame
 Row │ x      y      z      y_z_max
     │ Int64  Int64  Int64  Int64
─────┼──────────────────────────────
   1 │     1      4      7        7
   2 │     2      5      8        8
   3 │     3      6      9        9
```

Moreover, indexing can operate on a subset of columns *and* rows.

**Indexing:**

```julia
julia> y_z_max_row3 = maximum(df[3, Not(:x)])  # find maximum value across row 3 except for column `x`
9
```

Hopefully this small comparison has illustrated some of the benefits and drawbacks
of the various syntaxes available in DataFrames.jl.
The best syntax to use depends on the situation.

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

We follow the ColPrac guide for collaborative practices. New contributor should make sure to read that guide.
Following here are some additional clarifications and practices we follow.

Thanks for taking the plunge!

## Reporting Issues

* It's always good to start with a quick search for an existing issue to post on,
  or related issues for context, before opening a new issue
* Including minimal examples is greatly appreciated
* If it's a bug, or unexpected behaviour, reproducing on the latest development version
  (`Pkg.add(name="DataFrames", rev="main")`) is a good gut check and can streamline the process,
  along with including the first two lines of output from `versioninfo()`

## Modifying an existing docstring in `src/`

All docstrings are written inline above the methods or types they are associated with and can
be found by clicking on the `source` link that appears below each docstring in the documentation.
The steps needed to make a change to an existing docstring are listed below:

* Create a new branch;
* Find the docstring in `src/`;
* Update the text in the docstring;
* run `julia make.jl` from the `/docs` directory;
* check the output in `doc/_build/html/` to make sure the changes are correct;
* commit your changes and open a pull request.
* a preferred structure of docstring for a function is:
  + list of accepted signatures;
  + a short information what function does;
  + description of its arguments;
  + additional details if needed;
  + examples.

## Adding a new docstring to `src/`

The steps required to add a new docstring are listed below:
* find a suitable object definition in `src/` that the docstring
  will be most applicable to;
* add a doctring above the definition;
* find a suitable `@docs` code block in the `docs/src/lib/functions.md` file 
  where you would like the docstring to appear; (if the docstring is added
  to an object that is not exported add it to `docs/src/lib/internals.md`);
* add the name of the definition to the `@docs` code block. For example, with a docstring
  added to a function `bar`.
```
"..."
function bar(args...)
    # ...
end
```

you would add the name `bar` to a `@docs` block in `docs/src/lib/functions.md`
````
```@docs
foo
bar # <-- Added this one.
baz
```
````

* run `julia make.jl` from the `/docs` directory;
* check the output in `docs/_build/html` to make sure the changes are correct;
* commit your changes and open a pull request.

## Doctests

Examples written within docstrings can be used as test cases known as *doctests* by annotating code 
blocks with `jldoctest`:
````
```jldoctest
julia> uppercase("Docstring test")
"DOCSTRING TEST"
```
````
A doctest needs to match an interactive REPL including the `julia>` prompt. To run 
doctests run `julia make.jl` from the `/docs` directory.

It is recommended to add the header `# Examples` above the doctests.

## Contributing

* DataFrames.jl is a relatively complex package that also has many external dependencies.
  Therefore if you would want to propose a new functionality (which is encouraged) it is
  strongly recommended to open an issue first and reach a decision on the final design.
  Then a pull request serves an implementation of the agreed way how things should work.
* If you are a new contributor and would like to get a guidance on what area
  you could focus your first PR please do not hesitate to ask and JuliaData members
  will help you with picking a topic matching your experience.
* Feel free to open, or comment on, an issue and solicit feedback early on,
  especially if you're unsure about aligning with design goals and direction,
  or if relevant historical comments are ambiguous.
* Pair new functionality with tests, and bug fixes with tests that fail pre-fix.
  Increasing test coverage as you go is always nice.
* Aim for atomic commits, if possible, e.g. `change 'foo' behavior like so` &
  `'bar' handles such and such corner case`,
  rather than `update 'foo' and 'bar'` & `fix typo` & `fix 'bar' better`.
* Pull requests are tested against release and development branches of Julia,
  so using `Pkg.test("DataFrames")` as you develop can be helpful.
* The style guidelines outlined below are not the personal style of most contributors,
  but for consistency throughout the project, we've adopted them.
* It is recommended to disable GitHub Actions on your fork; check Settings > Actions.
* If a PR adds a new exported name then make sure to add a docstring for it and
  add a reference to it in the documentation.
* A PR with breaking changes should have `[BREAKING]` as a first part of its name.
* If a PR changes or adds functionality please update NEWS.md file accordingly as
  a part of the PR (along with the link to the PR); please do not add entries
  to NEWS.md for changes that are bug fixes or are not user visible, such as
  adding tests, updating documentation or improving code layout.
* If you make a PR please try to avoid pushing many small commits to GitHub in
  a sequence as each such commit triggers a separate CI job, which takes over
  an hour. This has a consequence of making other PRs in packages from the JuliaData
  ecosystem wait for such CI jobs to finish as they share a common pool of CI resources.

## Style Guidelines

* Include spaces
    + After commas
    + Around operators: `=`, `<:`, comparison operators, and generally around others
    + But not after opening parentheses or before closing parentheses
* Use four spaces for indentation (test data files and Makefiles excepted)
* Don't leave trailing whitespace at the end of lines
* Don't go over the 79 per-line character limit
* Avoid squashing code blocks onto one line, e.g. `for foo in bar; baz += qux(foo); end`
* Don't explicitly parameterize types unless it's necessary
* Never leave things without type qualifications. Use an explicit `::Any`.
* Order method definitions from most specific to least specific type constraints
* Always include a digit after decimal when writing a float, e.g. `[1.0, 2.0]`
  rather than `[1., 2.]`
* In docstrings, optional arguments, including separators and spaces, are surrounded by brackets,
  e.g. `mymethod(required[, optional1[, optional2] ]; kwargs...)`

## Git Recommendations For Pull Requests

* Avoid working from the `main` branch of your fork, creating a new branch will make it
  easier if DataFrames.jl `main` branch changes and you need to update your pull request;
* All PRs and issues should be opened against the `main` branch not against the current release;
* Run tests of your code before sending any commit to GitHub. Only push changes when 
  the tests of the change are passing locally. In particular note that it is not a problem
  if you send several commits in one push command to GitHub as CI will be run only once then;
* If any conflicts arise due to changes in DataFrames.jl `main` branch, prefer updating your pull
  request branch with `git rebase` (rather than `git merge`), since the latter will introduce a merge 
  commit that might confuse GitHub when displaying the diff of your PR, which makes your changes more 
  difficult to review. Alternatively use conflict resolution tool available at GitHub;
* Please try to use descriptive commit messages to simplify the review process;
* Using `git add -p` or `git add -i` can be useful to avoid accidentally committing unrelated changes;
* Maintainers get notified of all changes made on GitHub. However, what is useful is writing a short
  message after a sequence of changes is made summarizing what has changed and that the PR is ready
  for a review;
* When linking to specific lines of code in discussion of an issue or pull request, hit the `y` key
  while viewing code on GitHub to reload the page with a URL that includes the specific commit that 
  you're viewing. That way any lines of code that you refer to will still be correct in the future, even 
  if additional commits are pushed to the branch you are reviewing;
* Please make sure you follow the code formatting guidelines when submitting a PR;
  Also preferably do not modify parts of code that you are not editing as this makes
  reviewing the PR harder (it is better to open a separate maintenance PR
  if e.g. code layout can be improved);
* If a PR is not finished yet and should not be reviewed yet then it should be opened as DRAFT 
  (in this way maintainers will know that they can ignore such PR until it is made non-draft or the author
  asks for a review).

```@meta
CurrentModule = DataFrames
```

# Internals

!!! warning "Internal API"

    The functions, methods and types listed on this page are internal to DataFrames and are
    **not considered to be part of the public API**.

```@docs
compacttype
gennames
getmaxwidths
ourshow
ourstrwidth
@spawn_for_chunks
@spawn_or_run_task
@spawn_or_run
default_table_transformation
isreadonly
```

# The Split-Apply-Combine Strategy

## Design of the split-apply-combine support

Many data analysis tasks involve three steps:
1. splitting a data set into groups,
2. applying some functions to each of the groups,
3. combining the results.

Note that any of the steps 1 and 3 of this general procedure can be dropped,
in which case we just transform a data frame without grouping it and later
combining the result.

A standardized framework for handling this sort of computation is described in
the paper "[The Split-Apply-Combine Strategy for Data
Analysis](http://www.jstatsoft.org/v40/i01)", written by Hadley Wickham.

The DataFrames package supports the split-apply-combine strategy through the
`groupby` function that creates a `GroupedDataFrame`,
followed by `combine`, `select`/`select!` or `transform`/`transform!`.

All operations described in this section of the manual are supported both for
`AbstractDataFrame` (when split and combine steps are skipped) and
`GroupedDataFrame`. Technically, `AbstractDataFrame` is just considered as being
grouped on no columns (meaning it has a single group, or zero groups if it is
empty). The only difference is that in this case the `keepkeys` and `ungroup`
keyword arguments (described below) are not supported and a data frame is always
returned, as there are no split and combine steps in this case.

In order to perform operations by groups you first need to create a `GroupedDataFrame`
object from your data frame using the `groupby` function that takes two arguments:
(1) a data frame to be grouped, and (2) a set of columns to group by.

Operations can then be applied on each group using one of the following functions:
* `combine`: does not put restrictions on number of rows returned per group;
  the returned values are vertically concatenated following order of groups in
  `GroupedDataFrame`; it is typically used to compute summary statistics by group;
  for `GroupedDataFrame` if grouping columns are kept they are put as first columns
  in the result;
* `select`: return a data frame with the number and order of rows exactly the same
  as the source data frame, including only new calculated columns;
  `select!` is an in-place version of `select`;
* `transform`: return a data frame with the number and order of rows exactly the same
  as the source data frame, including all columns from the source and new calculated columns;
  `transform!` is an in-place version of `transform`;
  existing columns in the source data frame are put as first columns in the result;

As a special case, if a `GroupedDataFrame` that has zero groups is passed then
the result of the operation is determined by performing a single call to the
transformation function with a 0-row argument passed to it. The output of this
operation is only used to identify the number and type of produced columns, but
the result has zero rows.

All these functions take a specification of one or more functions to apply to
each subset of the `DataFrame`. This specification can be of the following forms:
1. standard column selectors (integers, `Symbol`s, strings, vectors of integers,
   vectors of `Symbol`s, vectors of strings,
   `All`, `Cols`, `:`, `Between`, `Not` and regular expressions)
2. a `cols => function` pair indicating that `function` should be called with
   positional arguments holding columns `cols`, which can be any valid column selector;
   in this case target column name is automatically generated and it is assumed that
   `function` returns a single value or a vector; the generated name is created by
   concatenating source column name and `function` name by default (see examples below).
3. a `cols => function => target_cols` form additionally explicitly specifying
   the target column or columns, which must be a single name (as a `Symbol` or a string),
   a vector of names or `AsTable`. Additionally it can be a `Function` which
   takes a string or a vector of strings as an argument containing names of columns
   selected by `cols`, and returns the target columns names (all accepted types
   except `AsTable` are allowed).
4. a `col => target_cols` pair, which renames the column `col` to `target_cols`, which
   must be single name (as a `Symbol` or a string), a vector of names or `AsTable`.
5. column-independent operations `function => target_cols` or just `function`
   for specific `function`s where the input columns are omitted;
   without `target_cols` the new column has the same name as `function`, otherwise
   it must be single name (as a `Symbol` or a string). Supported `function`s are:
   * `nrow` to efficiently compute the number of rows in each group.
   * `proprow` to efficiently compute the proportion of rows in each group.
   * `eachindex` to return a vector holding the number of each row within each group.
   * `groupindices` to return the group number.
6. vectors or matrices containing transformations specified by the `Pair` syntax
   described in points 2 to 5
7. a function which will be called with a `SubDataFrame` corresponding to each group
   if a `GroupedDataFrame` is processed, or with the data frame itself if
   an `AbstractDataFrame` is processed;
   this form should be avoided due to its poor performance unless the number of groups
   is small or a very large number of columns are processed
   (in which case `SubDataFrame` avoids excessive compilation)

Note! If the expression of the form `x => y` is passed then except for the special
convenience form `nrow => target_cols` it is always interpreted as
`cols => function`. In particular the following expression `function => target_cols`
is not a valid transformation specification.

Note! If `cols` or `target_cols` are one of `All`, `Cols`, `Between`, or `Not`,
broadcasting using `.=>` is supported and is equivalent to broadcasting
the result of `names(df, cols)` or `names(df, target_cols)`.
This behaves as if broadcasting happened after replacing the selector
with selected column names within the data frame scope.

All functions have two types of signatures. One of them takes a `GroupedDataFrame`
as the first argument and an arbitrary number of transformations described above
as following arguments. The second type of signature is when a `Function` or a `Type`
is passed as the first argument and a `GroupedDataFrame` as the second argument
(similar to `map`).

As a special rule, with the `cols => function` and
`cols => function => target_cols` syntaxes, if `cols` is wrapped in an `AsTable`
object then a `NamedTuple` containing columns selected by `cols` is passed to
`function`.

What is allowed for `function` to return is determined by the `target_cols` value:
1. If both `cols` and `target_cols` are omitted (so only a `function` is passed),
   then returning a data frame, a matrix, a `NamedTuple`, a `Tables.AbstractRow`
   or a `DataFrameRow` will
   produce multiple columns in the result. Returning any other value produces
   a single column.
2. If `target_cols` is a `Symbol` or a string then the function is assumed to return
   a single column. In this case returning a data frame, a matrix, a `NamedTuple`,
   a `Tables.AbstractRow`, or a `DataFrameRow` raises an error.
3. If `target_cols` is a vector of `Symbol`s or strings or `AsTable` it is assumed
   that `function` returns multiple columns.
   If `function` returns one of `AbstractDataFrame`, `NamedTuple`, `DataFrameRow`,
   `Tables.AbstractRow`, `AbstractMatrix` then rules described in point 1 above apply.
   If `function` returns an `AbstractVector` then each element of this vector must
   support the `keys` function, which must return a collection of `Symbol`s, strings
   or integers; the return value of `keys` must be identical for all elements.
   Then as many columns are created as there are elements in the return value
   of the `keys` function. If `target_cols` is `AsTable` then their names
   are set to be equal to the key names except if `keys` returns integers, in
   which case they are prefixed by `x` (so the column names are e.g. `x1`,
   `x2`, ...). If `target_cols` is a vector of `Symbol`s or strings then
   column names produced using the rules above are ignored and replaced by
   `target_cols` (the number of columns must be the same as the length of
   `target_cols` in this case).
   If `fun` returns a value of any other type then it is assumed that it is a
   table conforming to the Tables.jl API and the `Tables.columntable` function
   is called on it to get the resulting columns and their names. The names are
   retained when `target_cols` is `AsTable` and are replaced if
   `target_cols` is a vector of `Symbol`s or strings.

In all of these cases, `function` can return either a single row or multiple
rows. As a particular rule, values wrapped in a `Ref` or a `0`-dimensional
`AbstractArray` are unwrapped and then treated as a single row.

`select`/`select!` and `transform`/`transform!` always return a data frame
with the same number and order of rows as the source (even if `GroupedDataFrame`
had its groups reordered), except when selection results in zero columns
in the resulting data frame (in which case the result has zero rows).

For `combine`, rows in the returned object appear in the order of groups in the
`GroupedDataFrame`. The functions can return an arbitrary number of rows for
each group, but the kind of returned object and the number and names of columns
must be the same for all groups, except when a `DataFrame()` or `NamedTuple()`
is returned, in which case a given group is skipped.

It is allowed to mix single values and vectors if multiple transformations
are requested. In this case single value will be repeated to match the length
of columns specified by returned vectors.

By default (`threads=true`) a separate task is spawned for each
specified transformation; each transformation then spawns as many tasks
as Julia threads, and splits processing of groups across them
(however, currently transformations with optimized implementations like `sum`
and transformations that return multiple rows use a single task for all groups).
This allows for parallel operation when Julia was started with more than one
thread. Passed transformation functions must therefore not modify global variables
(i.e. they must be pure), use locks to control parallel accesses,
or `threads=false` must be passed to disable multithreading.

To apply `function` to each row instead of whole columns, it can be wrapped in a
`ByRow` struct. `cols` can be any column indexing syntax, in which case
`function` will be passed one argument for each of the columns specified by
`cols` or a `NamedTuple` of them if specified columns are wrapped in `AsTable`.
If `ByRow` is used it is allowed for `cols` to select an empty set of columns,
in which case `function` is called for each row without any arguments and an
empty `NamedTuple` is passed if empty set of columns is wrapped in `AsTable`.

The following keyword arguments are supported by the transformation functions
(not all keyword arguments are supported in all cases; in general they are allowed
in situations when they are meaningful, see the documentation of the specific functions
for details):
- `keepkeys` : whether grouping columns should be kept in the returned data frame.
- `ungroup` : whether the return value of the operation should be a data frame or a
  `GroupedDataFrame`.
- `copycols` : whether columns of the source data frame should be copied if no
  transformation is applied to them.
- `renamecols` : whether in the `cols => function` form automatically generated
  column names should include the name of transformation functions or not.
- `threads` : whether transformations may be run in separate tasks which can execute
  in parallel

## Examples of the split-apply-combine operations

We show several examples of these functions applied to the `iris` dataset below:

```jldoctest sac
julia> using DataFrames, CSV, Statistics

julia> path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "iris.csv");

julia> iris = CSV.read(path, DataFrame)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         6.8         3.2          5.9         2.3  Iris-virginica
 145 │         6.7         3.3          5.7         2.5  Iris-virginica
 146 │         6.7         3.0          5.2         2.3  Iris-virginica
 147 │         6.3         2.5          5.0         1.9  Iris-virginica
 148 │         6.5         3.0          5.2         2.0  Iris-virginica
 149 │         6.2         3.4          5.4         2.3  Iris-virginica
 150 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                        135 rows omitted

julia> iris_gdf = groupby(iris, :Species)
GroupedDataFrame with 3 groups based on key: Species
First Group (50 rows): Species = "Iris-setosa"
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮            ⋮
  49 │         5.3         3.7          1.5         0.2  Iris-setosa
  50 │         5.0         3.3          1.4         0.2  Iris-setosa
                                                      46 rows omitted
⋮
Last Group (50 rows): Species = "Iris-virginica"
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         6.3         3.3          6.0         2.5  Iris-virginica
   2 │         5.8         2.7          5.1         1.9  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
  50 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                         47 rows omitted

julia> combine(iris_gdf, :PetalLength => mean)
3×2 DataFrame
 Row │ Species          PetalLength_mean
     │ String15         Float64
─────┼───────────────────────────────────
   1 │ Iris-setosa                 1.464
   2 │ Iris-versicolor             4.26
   3 │ Iris-virginica              5.552

julia> combine(iris_gdf, nrow, proprow, groupindices)
3×4 DataFrame
 Row │ Species          nrow   proprow   groupindices
     │ String15         Int64  Float64   Int64
─────┼────────────────────────────────────────────────
   1 │ Iris-setosa         50  0.333333             1
   2 │ Iris-versicolor     50  0.333333             2
   3 │ Iris-virginica      50  0.333333             3

julia> combine(iris_gdf, nrow, :PetalLength => mean => :mean)
3×3 DataFrame
 Row │ Species          nrow   mean
     │ String15         Int64  Float64
─────┼─────────────────────────────────
   1 │ Iris-setosa         50    1.464
   2 │ Iris-versicolor     50    4.26
   3 │ Iris-virginica      50    5.552

julia> combine(iris_gdf,
               [:PetalLength, :SepalLength] =>
               ((p, s) -> (a=mean(p)/mean(s), b=sum(p))) =>
               AsTable) # multiple columns are passed as arguments
3×3 DataFrame
 Row │ Species          a         b
     │ String15         Float64   Float64
─────┼────────────────────────────────────
   1 │ Iris-setosa      0.292449     73.2
   2 │ Iris-versicolor  0.717655    213.0
   3 │ Iris-virginica   0.842744    277.6

julia> combine(iris_gdf,
               AsTable([:PetalLength, :SepalLength]) =>
               x -> std(x.PetalLength) / std(x.SepalLength)) # passing a NamedTuple
3×2 DataFrame
 Row │ Species          PetalLength_SepalLength_function
     │ String15         Float64
─────┼───────────────────────────────────────────────────
   1 │ Iris-setosa                              0.492245
   2 │ Iris-versicolor                          0.910378
   3 │ Iris-virginica                           0.867923

julia> combine(x -> std(x.PetalLength) / std(x.SepalLength), iris_gdf) # passing a SubDataFrame
3×2 DataFrame
 Row │ Species          x1
     │ String15         Float64
─────┼───────────────────────────
   1 │ Iris-setosa      0.492245
   2 │ Iris-versicolor  0.910378
   3 │ Iris-virginica   0.867923

julia> combine(iris_gdf, 1:2 => cor, nrow)
3×3 DataFrame
 Row │ Species          SepalLength_SepalWidth_cor  nrow
     │ String15         Float64                     Int64
─────┼────────────────────────────────────────────────────
   1 │ Iris-setosa                        0.74678      50
   2 │ Iris-versicolor                    0.525911     50
   3 │ Iris-virginica                     0.457228     50

julia> combine(iris_gdf, :PetalLength => (x -> [extrema(x)]) => [:min, :max])
3×3 DataFrame
 Row │ Species          min      max
     │ String15         Float64  Float64
─────┼───────────────────────────────────
   1 │ Iris-setosa          1.0      1.9
   2 │ Iris-versicolor      3.0      5.1
   3 │ Iris-virginica       4.5      6.9
```

To get row number for each observation within each group use the `eachindex` function:
```
julia> combine(iris_gdf, eachindex)
150×2 DataFrame
 Row │ Species         eachindex
     │ String15        Int64
─────┼───────────────────────────
   1 │ Iris-setosa             1
   2 │ Iris-setosa             2
   3 │ Iris-setosa             3
  ⋮  │       ⋮             ⋮
 148 │ Iris-virginica         48
 149 │ Iris-virginica         49
 150 │ Iris-virginica         50
                 144 rows omitted
```

Contrary to `combine`, the `select` and `transform` functions always return
a data frame with the same number and order of rows as the source.
In the example below
the return values in columns `:SepalLength_SepalWidth_cor` and `:nrow` are
broadcasted to match the number of elements in each group:
```
julia> select(iris_gdf, 1:2 => cor)
150×2 DataFrame
 Row │ Species         SepalLength_SepalWidth_cor
     │ String          Float64
─────┼────────────────────────────────────────────
   1 │ Iris-setosa                       0.74678
   2 │ Iris-setosa                       0.74678
   3 │ Iris-setosa                       0.74678
   4 │ Iris-setosa                       0.74678
  ⋮  │       ⋮                     ⋮
 148 │ Iris-virginica                    0.457228
 149 │ Iris-virginica                    0.457228
 150 │ Iris-virginica                    0.457228
                                  143 rows omitted

julia> transform(iris_gdf, :Species => x -> chop.(x, head=5, tail=0))
150×6 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species         Species_function
     │ Float64      Float64     Float64      Float64     String          SubString…
─────┼────────────────────────────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa     setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa     setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa     setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa     setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮                ⋮
 148 │         6.5         3.0          5.2         2.0  Iris-virginica  virginica
 149 │         6.2         3.4          5.4         2.3  Iris-virginica  virginica
 150 │         5.9         3.0          5.1         1.8  Iris-virginica  virginica
                                                                          143 rows omitted
```

All functions also support the `do` block form. However, as noted above,
this form is slow and should therefore be avoided when performance matters.

```jldoctest sac
julia> combine(iris_gdf) do df
           (m = mean(df.PetalLength), s² = var(df.PetalLength))
       end
3×3 DataFrame
 Row │ Species          m        s²
     │ String15         Float64  Float64
─────┼─────────────────────────────────────
   1 │ Iris-setosa        1.464  0.0301061
   2 │ Iris-versicolor    4.26   0.220816
   3 │ Iris-virginica     5.552  0.304588
```

To apply a function to each non-grouping column of a `GroupedDataFrame` you can write:

```jldoctest sac
julia> combine(iris_gdf, valuecols(iris_gdf) .=> mean)
3×5 DataFrame
 Row │ Species          SepalLength_mean  SepalWidth_mean  PetalLength_mean  P ⋯
     │ String15         Float64           Float64          Float64           F ⋯
─────┼──────────────────────────────────────────────────────────────────────────
   1 │ Iris-setosa                 5.006            3.418             1.464    ⋯
   2 │ Iris-versicolor             5.936            2.77              4.26
   3 │ Iris-virginica              6.588            2.974             5.552
                                                                1 column omitted
```

Note that `GroupedDataFrame` is a view: therefore
grouping columns of its parent data frame must not be mutated, and
rows must not be added nor removed from it. If the number or rows
of the parent changes then an error is thrown when a child `GroupedDataFrame`
is used:

```jldoctest sac
julia> df = DataFrame(id=1:2)
2×1 DataFrame
 Row │ id
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> gd = groupby(df, :id)
GroupedDataFrame with 2 groups based on key: id
First Group (1 row): id = 1
 Row │ id
     │ Int64
─────┼───────
   1 │     1
⋮
Last Group (1 row): id = 2
 Row │ id
     │ Int64
─────┼───────
   1 │     2

julia> push!(df, [3])
3×1 DataFrame
 Row │ id
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> gd[1]
ERROR: AssertionError: The current number of rows in the parent data frame is 3 and it does not match the number of rows it contained when GroupedDataFrame was created which was 2. The number of rows in the parent data frame has likely been changed unintentionally (e.g. using subset!, filter!, deleteat!, push!, or append! functions).
```

Sometimes it is useful to append rows to the source data frame of a
`GroupedDataFrame`, without affecting the rows used for grouping.
In such a scenario you can create the grouped data frame using a `view`
of the parent data frame to avoid the error:

```jldoctest sac
julia> df = DataFrame(id=1:2)
2×1 DataFrame
 Row │ id
     │ Int64
─────┼───────
   1 │     1
   2 │     2

julia> gd = groupby(view(df, :, :), :id)
GroupedDataFrame with 2 groups based on key: id
First Group (1 row): id = 1
 Row │ id
     │ Int64
─────┼───────
   1 │     1
⋮
Last Group (1 row): id = 2
 Row │ id
     │ Int64
─────┼───────
   1 │     2

julia> push!(df, [3])
3×1 DataFrame
 Row │ id
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3

julia> gd[1]
1×1 SubDataFrame
 Row │ id
     │ Int64
─────┼───────
   1 │     1
```

## Using `GroupedDataFrame` as an iterable and indexable object

If you only want to split the data set into subsets, use the [`groupby`](@ref)
function. You can then iterate `SubDataFrame`s that constitute the identified
groups:

```jldoctest sac
julia> for subdf in iris_gdf
           println(size(subdf, 1))
       end
50
50
50
```

To also get the values of the grouping columns along with each group, use the
`pairs` function:

```jldoctest sac
julia> for (key, subdf) in pairs(iris_gdf)
           println("Number of data points for $(key.Species): $(nrow(subdf))")
       end
Number of data points for Iris-setosa: 50
Number of data points for Iris-versicolor: 50
Number of data points for Iris-virginica: 50
```

The value of `key` in the example above where we iterated `pairs(iris_gdf)` is
a [`DataFrames.GroupKey`](@ref) object, which can be used in a similar fashion
to a `NamedTuple`.

Grouping a data frame using the `groupby` function can be seen as adding a
lookup key to it. Such lookups can be performed efficiently by indexing the
resulting `GroupedDataFrame` with [`DataFrames.GroupKey`](@ref) (as it was
presented above) a `Tuple`, a `NamedTuple`, or a dictionary. Here are some
more examples of such indexing.

```jldoctest sac
julia> iris_gdf[(Species="Iris-virginica",)]  # a NamedTuple
50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         6.3         3.3          6.0         2.5  Iris-virginica
   2 │         5.8         2.7          5.1         1.9  Iris-virginica
   3 │         7.1         3.0          5.9         2.1  Iris-virginica
   4 │         6.3         2.9          5.6         1.8  Iris-virginica
   5 │         6.5         3.0          5.8         2.2  Iris-virginica
   6 │         7.6         3.0          6.6         2.1  Iris-virginica
   7 │         4.9         2.5          4.5         1.7  Iris-virginica
   8 │         7.3         2.9          6.3         1.8  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
  44 │         6.8         3.2          5.9         2.3  Iris-virginica
  45 │         6.7         3.3          5.7         2.5  Iris-virginica
  46 │         6.7         3.0          5.2         2.3  Iris-virginica
  47 │         6.3         2.5          5.0         1.9  Iris-virginica
  48 │         6.5         3.0          5.2         2.0  Iris-virginica
  49 │         6.2         3.4          5.4         2.3  Iris-virginica
  50 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                         35 rows omitted

julia> iris_gdf[[("Iris-virginica",), ("Iris-setosa",)]] # a vector of Tuples
GroupedDataFrame with 2 groups based on key: Species
First Group (50 rows): Species = "Iris-virginica"
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         6.3         3.3          6.0         2.5  Iris-virginica
   2 │         5.8         2.7          5.1         1.9  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
  49 │         6.2         3.4          5.4         2.3  Iris-virginica
  50 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                         46 rows omitted
⋮
Last Group (50 rows): Species = "Iris-setosa"
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮            ⋮
  50 │         5.0         3.3          1.4         0.2  Iris-setosa
                                                      47 rows omitted

julia> key = keys(iris_gdf) |> last # last key in iris_gdf
GroupKey: (Species = String15("Iris-virginica"),)

julia> iris_gdf[key]
50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         6.3         3.3          6.0         2.5  Iris-virginica
   2 │         5.8         2.7          5.1         1.9  Iris-virginica
   3 │         7.1         3.0          5.9         2.1  Iris-virginica
   4 │         6.3         2.9          5.6         1.8  Iris-virginica
   5 │         6.5         3.0          5.8         2.2  Iris-virginica
   6 │         7.6         3.0          6.6         2.1  Iris-virginica
   7 │         4.9         2.5          4.5         1.7  Iris-virginica
   8 │         7.3         2.9          6.3         1.8  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
  44 │         6.8         3.2          5.9         2.3  Iris-virginica
  45 │         6.7         3.3          5.7         2.5  Iris-virginica
  46 │         6.7         3.0          5.2         2.3  Iris-virginica
  47 │         6.3         2.5          5.0         1.9  Iris-virginica
  48 │         6.5         3.0          5.2         2.0  Iris-virginica
  49 │         6.2         3.4          5.4         2.3  Iris-virginica
  50 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                         35 rows omitted

julia> iris_gdf[Dict("Species" => "Iris-setosa")] # a dictionary
50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮            ⋮
  44 │         5.0         3.5          1.6         0.6  Iris-setosa
  45 │         5.1         3.8          1.9         0.4  Iris-setosa
  46 │         4.8         3.0          1.4         0.3  Iris-setosa
  47 │         5.1         3.8          1.6         0.2  Iris-setosa
  48 │         4.6         3.2          1.4         0.2  Iris-setosa
  49 │         5.3         3.7          1.5         0.2  Iris-setosa
  50 │         5.0         3.3          1.4         0.2  Iris-setosa
                                                      35 rows omitted
```

Note that although `GroupedDataFrame` is iterable and indexable it is not an
`AbstractVector`. For this reason currently it was decided that it does not
support `map` nor broadcasting (to allow for making a decision in the future
what result type they should produce). To apply a function to all groups of a
data frame and get a vector of results either use a comprehension or `collect`
`GroupedDataFrame` into a vector first. Here are examples of both approaches:

```jldoctest sac
julia> sdf_vec = collect(iris_gdf)
3-element Vector{Any}:
 50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮            ⋮
  44 │         5.0         3.5          1.6         0.6  Iris-setosa
  45 │         5.1         3.8          1.9         0.4  Iris-setosa
  46 │         4.8         3.0          1.4         0.3  Iris-setosa
  47 │         5.1         3.8          1.6         0.2  Iris-setosa
  48 │         4.6         3.2          1.4         0.2  Iris-setosa
  49 │         5.3         3.7          1.5         0.2  Iris-setosa
  50 │         5.0         3.3          1.4         0.2  Iris-setosa
                                                      35 rows omitted
 50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────────
   1 │         7.0         3.2          4.7         1.4  Iris-versicolor
   2 │         6.4         3.2          4.5         1.5  Iris-versicolor
   3 │         6.9         3.1          4.9         1.5  Iris-versicolor
   4 │         5.5         2.3          4.0         1.3  Iris-versicolor
   5 │         6.5         2.8          4.6         1.5  Iris-versicolor
   6 │         5.7         2.8          4.5         1.3  Iris-versicolor
   7 │         6.3         3.3          4.7         1.6  Iris-versicolor
   8 │         4.9         2.4          3.3         1.0  Iris-versicolor
  ⋮  │      ⋮           ⋮            ⋮           ⋮              ⋮
  44 │         5.0         2.3          3.3         1.0  Iris-versicolor
  45 │         5.6         2.7          4.2         1.3  Iris-versicolor
  46 │         5.7         3.0          4.2         1.2  Iris-versicolor
  47 │         5.7         2.9          4.2         1.3  Iris-versicolor
  48 │         6.2         2.9          4.3         1.3  Iris-versicolor
  49 │         5.1         2.5          3.0         1.1  Iris-versicolor
  50 │         5.7         2.8          4.1         1.3  Iris-versicolor
                                                          35 rows omitted
 50×5 SubDataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         6.3         3.3          6.0         2.5  Iris-virginica
   2 │         5.8         2.7          5.1         1.9  Iris-virginica
   3 │         7.1         3.0          5.9         2.1  Iris-virginica
   4 │         6.3         2.9          5.6         1.8  Iris-virginica
   5 │         6.5         3.0          5.8         2.2  Iris-virginica
   6 │         7.6         3.0          6.6         2.1  Iris-virginica
   7 │         4.9         2.5          4.5         1.7  Iris-virginica
   8 │         7.3         2.9          6.3         1.8  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
  44 │         6.8         3.2          5.9         2.3  Iris-virginica
  45 │         6.7         3.3          5.7         2.5  Iris-virginica
  46 │         6.7         3.0          5.2         2.3  Iris-virginica
  47 │         6.3         2.5          5.0         1.9  Iris-virginica
  48 │         6.5         3.0          5.2         2.0  Iris-virginica
  49 │         6.2         3.4          5.4         2.3  Iris-virginica
  50 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                         35 rows omitted

julia> map(nrow, sdf_vec)
3-element Vector{Int64}:
 50
 50
 50

julia> nrow.(sdf_vec)
3-element Vector{Int64}:
 50
 50
 50
```

Since `GroupedDataFrame` is iterable, you can achieve the same result with a
comprehension:

```jldoctest sac
julia> [nrow(sdf) for sdf in iris_gdf]
3-element Vector{Int64}:
 50
 50
 50
```

Note that using the split-apply-combine strategy with the operation specification
syntax in `combine`, `select` or `transform` will usually be faster for large
`GroupedDataFrame` objects than iterating them, with the difference that they
produce a data frame. An operation corresponding to the example above is:

```
julia> combine(iris_gdf, nrow)
3×2 DataFrame
 Row │ Species          nrow
     │ String15         Int64
─────┼────────────────────────
   1 │ Iris-setosa         50
   2 │ Iris-versicolor     50
   3 │ Iris-virginica      50
```

## Simulating the SQL `where` clause

You can conveniently work on subsets of a data frame by using `SubDataFrame`s.
Operations performed on such objects can either create a new data frame or be
performed in-place. Here are some examples:

```jldoctest sac
julia> df = DataFrame(a=1:5)
5×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │     2
   3 │     3
   4 │     4
   5 │     5

julia> sdf = @view df[2:3, :]
2×1 SubDataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     2
   2 │     3

julia> transform(sdf, :a => ByRow(string)) # create a new data frame
2×2 DataFrame
 Row │ a      a_string
     │ Int64  String
─────┼─────────────────
   1 │     2  2
   2 │     3  3

julia> transform!(sdf, :a => ByRow(string)) # update the source df in-place
2×2 SubDataFrame
 Row │ a      a_string
     │ Int64  String?
─────┼─────────────────
   1 │     2  2
   2 │     3  3

julia> df # new column was created filled with missing in filtered-out rows
5×2 DataFrame
 Row │ a      a_string
     │ Int64  String?
─────┼─────────────────
   1 │     1  missing
   2 │     2  2
   3 │     3  3
   4 │     4  missing
   5 │     5  missing

julia> select!(sdf, :a => -, renamecols=false) # update the source df in-place
2×1 SubDataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │    -2
   2 │    -3

julia> df # the column replaced an existing column; previously stored values are re-used in filtered-out rows
5×1 DataFrame
 Row │ a
     │ Int64
─────┼───────
   1 │     1
   2 │    -2
   3 │    -3
   4 │     4
   5 │     5
```

Similar operations can be performed on `GroupedDataFrame` as well:
```jldoctest sac
julia> df = DataFrame(a=[1, 1, 1, 2, 2, 3], b=1:6)
6×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     1      2
   3 │     1      3
   4 │     2      4
   5 │     2      5
   6 │     3      6

julia> sdf = @view df[2:4, :]
3×2 SubDataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     1      3
   3 │     2      4

julia> gsdf = groupby(sdf, :a)
GroupedDataFrame with 2 groups based on key: a
First Group (2 rows): a = 1
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     1      3
⋮
Last Group (1 row): a = 2
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     2      4

julia> transform(gsdf, nrow) # create a new data frame
3×3 DataFrame
 Row │ a      b      nrow
     │ Int64  Int64  Int64
─────┼─────────────────────
   1 │     1      2      2
   2 │     1      3      2
   3 │     2      4      1

julia> transform!(gsdf, nrow, :b => :b_copy)
3×4 SubDataFrame
 Row │ a      b      nrow    b_copy
     │ Int64  Int64  Int64?  Int64?
─────┼──────────────────────────────
   1 │     1      2       2       2
   2 │     1      3       2       3
   3 │     2      4       1       4

julia> df
6×4 DataFrame
 Row │ a      b      nrow     b_copy
     │ Int64  Int64  Int64?   Int64?
─────┼────────────────────────────────
   1 │     1      1  missing  missing
   2 │     1      2        2        2
   3 │     1      3        2        3
   4 │     2      4        1        4
   5 │     2      5  missing  missing
   6 │     3      6  missing  missing

julia> select!(gsdf, :b_copy, :b => sum, renamecols=false)
3×3 SubDataFrame
 Row │ a      b_copy  b
     │ Int64  Int64?  Int64
─────┼──────────────────────
   1 │     1       2      5
   2 │     1       3      5
   3 │     2       4      4

julia> df
6×3 DataFrame
 Row │ a      b_copy   b
     │ Int64  Int64?   Int64
─────┼───────────────────────
   1 │     1  missing      1
   2 │     1        2      5
   3 │     1        3      5
   4 │     2        4      4
   5 │     2  missing      5
   6 │     3  missing      6
```

## Column-independent operations

The operation specification language used with `combine`, `select` and `transform`
supports the following column-independent operations:

* getting the number of rows in a group (`nrow`);
* getting the proportion of rows in a group (`proprow`);
* getting the group number (`groupindices`);
* getting a vector of indices within groups (`eachindex`).

These operations are column-independent, because they do not require specifying the input column
name in the operation specification syntax.

These four exceptions to the standard operation specification syntax were
introduced for user convenience as these operations are often needed in
practice.

Below each of them is explained by example.

First create a data frame we will work with:

```jldoctest sac
julia> df = DataFrame(customer_id=["a", "b", "b", "b", "c", "c"],
                      transaction_id=[12, 15, 19, 17, 13, 11],
                      volume=[2, 3, 1, 4, 5, 9])
6×3 DataFrame
 Row │ customer_id  transaction_id  volume
     │ String       Int64           Int64
─────┼─────────────────────────────────────
   1 │ a                        12       2
   2 │ b                        15       3
   3 │ b                        19       1
   4 │ b                        17       4
   5 │ c                        13       5
   6 │ c                        11       9

julia> gdf = groupby(df, :customer_id, sort=true);

julia> show(gdf, allgroups=true)
GroupedDataFrame with 3 groups based on key: customer_id
Group 1 (1 row): customer_id = "a"
 Row │ customer_id  transaction_id  volume
     │ String       Int64           Int64
─────┼─────────────────────────────────────
   1 │ a                        12       2
Group 2 (3 rows): customer_id = "b"
 Row │ customer_id  transaction_id  volume
     │ String       Int64           Int64
─────┼─────────────────────────────────────
   1 │ b                        15       3
   2 │ b                        19       1
   3 │ b                        17       4
Group 3 (2 rows): customer_id = "c"
 Row │ customer_id  transaction_id  volume
     │ String       Int64           Int64
─────┼─────────────────────────────────────
   1 │ c                        13       5
   2 │ c                        11       9
```

### Getting the number of rows

You can get the number of rows per group in a `GroupedDataFrame` by just
writing `nrow`, in which case the generated column name with the number of rows
is `:nrow`:

```jldoctest sac
julia> combine(gdf, nrow)
3×2 DataFrame
 Row │ customer_id  nrow
     │ String       Int64
─────┼────────────────────
   1 │ a                1
   2 │ b                3
   3 │ c                2
```

Additionally you are allowed to pass target column name:

```jldoctest sac
julia> combine(gdf, nrow => "transaction_count")
3×2 DataFrame
 Row │ customer_id  transaction_count
     │ String       Int64
─────┼────────────────────────────────
   1 │ a                            1
   2 │ b                            3
   3 │ c                            2
```

Note that in both cases we did not pass source column name as it is not needed
to determine the number of rows per group. This is the reason why column-independent
operations are exceptions to standard operation specification syntax.

The `nrow` expression also works in the operation specification syntax
applied to a data frame. Here is an example:

```jldoctest sac
julia> combine(df, nrow => "transaction_count")
1×1 DataFrame
 Row │ transaction_count
     │ Int64
─────┼───────────────────
   1 │                 6
```

Finally, recall that [`nrow`](@ref) is also a regular function that returns a
number of rows in a data frame:


```jldoctest sac
julia> nrow(df)
6
```

This dual use of `nrow` does not lead to ambiguities, and is meant to make it
easier to remember this exception.

### Getting the proportion of rows

If you want to get a proportion of rows per group in a `GroupedDataFrame`
you can use the `proprow` and `proprow => [target column name]` column-independent
operations. Here are some examples:

```jldoctest sac
julia> combine(gdf, proprow)
3×2 DataFrame
 Row │ customer_id  proprow
     │ String       Float64
─────┼───────────────────────
   1 │ a            0.166667
   2 │ b            0.5
   3 │ c            0.333333

julia> combine(gdf, proprow => "transaction_fraction")
3×2 DataFrame
 Row │ customer_id  transaction_fraction
     │ String       Float64
─────┼───────────────────────────────────
   1 │ a                        0.166667
   2 │ b                        0.5
   3 │ c                        0.333333
```

As opposed to `nrow`, `proprow` cannot be used outside of the operation
specification syntax and is only allowed when processing a `GroupedDataFrame`.

### Getting the group number

Another common operation is getting group number. Use the `groupindices` and
`groupindices => [target column name]` column-independent operations to get it:


```jldoctest sac
julia> combine(gdf, groupindices)
3×2 DataFrame
 Row │ customer_id  groupindices
     │ String       Int64
─────┼───────────────────────────
   1 │ a                       1
   2 │ b                       2
   3 │ c                       3

julia> transform(gdf, groupindices)
6×4 DataFrame
 Row │ customer_id  transaction_id  volume  groupindices
     │ String       Int64           Int64   Int64
─────┼───────────────────────────────────────────────────
   1 │ a                        12       2             1
   2 │ b                        15       3             2
   3 │ b                        19       1             2
   4 │ b                        17       4             2
   5 │ c                        13       5             3
   6 │ c                        11       9             3

julia> combine(gdf, groupindices => "group_number")
3×2 DataFrame
 Row │ customer_id  group_number
     │ String       Int64
─────┼───────────────────────────
   1 │ a                       1
   2 │ b                       2
   3 │ c                       3
```

Outside of the operation specification syntax, [`groupindices`](@ref)
is also a regular function which returns group indices for each row
in the parent data frame of the passed `GroupedDataFrame`:

```jldoctest sac
julia> groupindices(gdf)
6-element Vector{Union{Missing, Int64}}:
 1
 2
 2
 2
 3
 3
```

### Getting a vector of indices within groups

The last column-independent operation supported by the operation
specification syntax is getting the index of each row within each group:


```jldoctest sac
julia> combine(gdf, eachindex)
6×2 DataFrame
 Row │ customer_id  eachindex
     │ String       Int64
─────┼────────────────────────
   1 │ a                    1
   2 │ b                    1
   3 │ b                    2
   4 │ b                    3
   5 │ c                    1
   6 │ c                    2

julia> select(gdf, eachindex, groupindices)
6×3 DataFrame
 Row │ customer_id  eachindex  groupindices
     │ String       Int64      Int64
─────┼──────────────────────────────────────
   1 │ a                    1             1
   2 │ b                    1             2
   3 │ b                    2             2
   4 │ b                    3             2
   5 │ c                    1             3
   6 │ c                    2             3

julia> combine(gdf, eachindex => "transaction_number")
6×2 DataFrame
 Row │ customer_id  transaction_number
     │ String       Int64
─────┼─────────────────────────────────
   1 │ a                             1
   2 │ b                             1
   3 │ b                             2
   4 │ b                             3
   5 │ c                             1
   6 │ c                             2
```

Note that this operation also makes sense in a data frame context,
where all rows are considered to be in the same group:

```jldoctest sac
julia> transform(df, eachindex)
6×4 DataFrame
 Row │ customer_id  transaction_id  volume  eachindex
     │ String       Int64           Int64   Int64
─────┼────────────────────────────────────────────────
   1 │ a                        12       2          1
   2 │ b                        15       3          2
   3 │ b                        19       1          3
   4 │ b                        17       4          4
   5 │ c                        13       5          5
   6 │ c                        11       9          6
```

Finally recall that `eachindex` is a standard function for getting all indices
in an array. This similarity of functionality was the reason why this name was
picked:

```jldoctest sac
julia> collect(eachindex(df.customer_id))
6-element Vector{Int64}:
 1
 2
 3
 4
 5
 6
```

This, for example, means that in the following example the two created columns
have the same contents:

```jldoctest sac
julia> combine(gdf, eachindex, :customer_id => eachindex)
6×3 DataFrame
 Row │ customer_id  eachindex  customer_id_eachindex
     │ String       Int64      Int64
─────┼───────────────────────────────────────────────
   1 │ a                    1                      1
   2 │ b                    1                      1
   3 │ b                    2                      2
   4 │ b                    3                      3
   5 │ c                    1                      1
   6 │ c                    2                      2
```


## Column-independent operations versus functions

When discussing column-independent operations it is important to remember
that operation specification syntax allows you to pass a function (without
source and target column names), in which case such a function gets passed a
`SubDataFrame` that represents a group in a `GroupedDataFrame`. Here is an
example comparing a column-independent operation and a function:

```jldoctest sac
julia> combine(gdf, eachindex, sdf -> axes(sdf, 1))
6×3 DataFrame
 Row │ customer_id  eachindex  x1
     │ String       Int64      Int64
─────┼───────────────────────────────
   1 │ a                    1      1
   2 │ b                    1      1
   3 │ b                    2      2
   4 │ b                    3      3
   5 │ c                    1      1
   6 │ c                    2      2
```

Notice that the column-independent operation `eachindex` produces the same result
as using the anonymous function `sdf -> axes(sdf, 1)` that takes a `SubDataFrame`
as its first argument and returns indices along its first axes.
Importantly if it wasn't defined as a column-independent operation
the `eachindex` function would fail when being passed as you can see here:

```jldoctest sac
julia> combine(gdf, sdf -> eachindex(sdf))
ERROR: MethodError: no method matching keys(::SubDataFrame{DataFrame, DataFrames.Index, Vector{Int64}})
```

The reason for this error is that the `eachindex` function does not allow passing a
`SubDataFrame` as its argument.

The same applies to `proprow` and `groupindices`: they would not work
with a `SubDataFrame` as stand-alone functions.

The `nrow` column-independent operation is a different case, as
the `nrow` function accepts `SubDataFrame` as an argument:

```jldoctest sac
julia> combine(gdf, nrow, sdf -> nrow(sdf))
3×3 DataFrame
 Row │ customer_id  nrow   x1
     │ String       Int64  Int64
─────┼───────────────────────────
   1 │ a                1      1
   2 │ b                3      3
   3 │ c                2      2
```

Notice that columns `:nrow` and `:x1` have identical contents, but the
difference is that they do not have the same names. `nrow` is a
column-independent operation generating the `:nrow` column name by default with
number of rows per group. On the other hand, the `sdf -> nrow(sdf)` anonymous
function does gets a `SubDataFrame` as its argument and returns its number of
rows. The `:x1` column name is the default auto-generated column name when
processing anonymous functions.

Passing a function taking a `SubDataFrame` is a flexible functionality allowing
you to perform complex operations on your data. However, you should bear in mind
two aspects:

* Using the full operation specification syntax (where source and target column
  names are passed) or column-independent operations will lead to faster
  execution of your code (as the Julia compiler is able to better optimize
  execution of such operations) in comparison to passing a function
  taking a `SubDataFrame`.
* Although writing `nrow`, `proprow`, `groupindices`, and `eachindex` looks
  like just passing a function they internally **do not** take a `SubDataFrame`
  as their argument. As we explained in this section, `proprow`,
  `groupindices`, and `eachindex` would not work with `SubDataFrame` as their
  argument, and `nrow` would work, but would produce a different column name.
  Instead, these four operations are special column-independent operations that
  are exceptions to the standard operation specification syntax rules. They
  were added for user convenience.

## Specifying group order in `groupby`

By default order of groups produced by `groupby` is undefined.
If you want the order of groups to follow the order of first appearance in
the source data frame of a grouping key then pass the `sort=false` keyword argument
to `groupby`:

```jldoctest sac
julia> push!(df, ["a", 100, 100]) # push row with large integer values to disable default sorting
7×3 DataFrame
 Row │ customer_id  transaction_id  volume
     │ String       Int64           Int64
─────┼─────────────────────────────────────
   1 │ a                        12       2
   2 │ b                        15       3
   3 │ b                        19       1
   4 │ b                        17       4
   5 │ c                        13       5
   6 │ c                        11       9
   7 │ a                       100     100

julia> keys(groupby(df, :volume))
7-element DataFrames.GroupKeys{GroupedDataFrame{DataFrame}}:
 GroupKey: (volume = 2,)
 GroupKey: (volume = 3,)
 GroupKey: (volume = 1,)
 GroupKey: (volume = 4,)
 GroupKey: (volume = 5,)
 GroupKey: (volume = 9,)
 GroupKey: (volume = 100,)
```

If you want to have them sorted in ascending order pass `sort=true`:

```
julia> keys(groupby(df, :volume, sort=true))
7-element DataFrames.GroupKeys{GroupedDataFrame{DataFrame}}:
 GroupKey: (volume = 1,)
 GroupKey: (volume = 2,)
 GroupKey: (volume = 3,)
 GroupKey: (volume = 4,)
 GroupKey: (volume = 5,)
 GroupKey: (volume = 9,)
 GroupKey: (volume = 100,)
```

You can also use the [`order`](@ref) wrapper when passing a column name to group
by or pass a named tuple as `sort` keyword argument containing one or more of
`alg`, `lt`, `by`, `rev`, and `order` fields that will be treated just like in
[`sortperm`](@ref):

```
julia> keys(groupby(df, [:customer_id, order(:volume, rev=true)]))
6-element DataFrames.GroupKeys{GroupedDataFrame{DataFrame}}:
 GroupKey: (customer_id = "a", volume = 2)
 GroupKey: (customer_id = "b", volume = 4)
 GroupKey: (customer_id = "b", volume = 3)
 GroupKey: (customer_id = "b", volume = 1)
 GroupKey: (customer_id = "c", volume = 9)
 GroupKey: (customer_id = "c", volume = 5)

julia> keys(groupby(df, :customer_id, sort=(rev=true,)))
3-element DataFrames.GroupKeys{GroupedDataFrame{DataFrame}}:
 GroupKey: (customer_id = "c",)
 GroupKey: (customer_id = "b",)
 GroupKey: (customer_id = "a",)
```

# Getting Started

## Installation

The DataFrames package is available through the Julia package system and can be installed using the following commands:

```julia
using Pkg
Pkg.add("DataFrames")
```

Throughout the rest of this tutorial, we will assume that you have installed the
DataFrames package and have already typed `using DataFrames` to bring all of the
relevant variables into your current namespace.

!!! note

    By default DataFrames.jl limits the number of rows and columns when displaying a data frame in a Jupyter
    Notebook to 25 and 100, respectively. You can override this behavior by changing the values of the
    `ENV["DATAFRAMES_COLUMNS"]` and `ENV["DATAFRAMES_ROWS"]` variables to hold the maximum number of columns
    and rows of the output. All columns or rows will be printed if those numbers are equal or lower than 0.

    Alternatively, you may want to set the maximum number of data frame rows to print to `100` and the maximum
    number of columns to print to `1000` for every Julia session using some Jupyter kernel file (numbers `100`
    and `1000` are only examples and can be adjusted). In such case add a
    `"DATAFRAME_COLUMNS": "1000", "DATAFRAMES_ROWS": "100"` entry to the `"env"` variable in this Jupyter kernel
    file. See [here](https://jupyter-client.readthedocs.io/en/stable/kernels.html) for information about location
    and specification of Jupyter kernels.

## The `DataFrame` Type

Objects of the `DataFrame` type represent a data table as a series of vectors,
each corresponding to a column or variable. The simplest way of constructing a
`DataFrame` is to pass column vectors using keyword arguments or pairs:

```jldoctest dataframe
julia> using DataFrames

julia> DataFrame(a=1:4, b=["M", "F", "F", "M"]) # keyword argument constructor
4×2 DataFrame
 Row │ a      b
     │ Int64  String
─────┼───────────────
   1 │     1  M
   2 │     2  F
   3 │     3  F
   4 │     4  M
```

Here are examples of other commonly used ways to construct a data frame:

```jldoctest dataframe
julia> DataFrame((a=[1, 2], b=[3, 4])) # Tables.jl table constructor from a named tuple of vectors
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      3
   2 │     2      4

julia> DataFrame([(a=1, b=0), (a=2, b=0)]) # Tables.jl table constructor from a vector of named tuples
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame("a" => 1:2, "b" => 0) # Pair constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([:a => 1:2, :b => 0]) # vector of Pairs constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame(Dict(:a => 1:2, :b => 0)) # dictionary constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([[1, 2], [0, 0]], [:a, :b]) # vector of vectors constructor
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0

julia> DataFrame([1 0; 2 0], :auto) # matrix constructor
2×2 DataFrame
 Row │ x1     x2
     │ Int64  Int64
─────┼──────────────
   1 │     1      0
   2 │     2      0
```

Columns can be directly (i.e. without copying) extracted using `df.col`,
`df."col"`, `df[!, :col]` or `df[!, "col"]` (this rule applies to getting data
from a data frame, not writing data to a data frame). The two latter syntaxes
are more flexible as they allow passing a variable holding the name of the
column, and not only a literal name. Note that column names can be either
symbols (written as `:col`, `:var"col"` or `Symbol("col")`) or strings (written
as `"col"`). In the forms `df."col"` and `:var"col"` variable interpolation into
a string using `$` does not work. Columns can also be extracted using an integer
index specifying their position.

Since `df[!, :col]` does not make a copy, changing the elements of the column
vector returned by this syntax will affect the values stored in the original
`df`. To get a copy of the column use `df[:, :col]`: changing the vector
returned by this syntax does not change `df`.


```jldoctest dataframe
julia> df = DataFrame(A=1:4, B=["M", "F", "F", "M"])
4×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┼───────────────
   1 │     1  M
   2 │     2  F
   3 │     3  F
   4 │     4  M

julia> df.A
4-element Vector{Int64}:
 1
 2
 3
 4

julia> df."A"
4-element Vector{Int64}:
 1
 2
 3
 4

julia> df.A === df[!, :A]
true

julia> df.A === df[:, :A]
false

julia> df.A == df[:, :A]
true

julia> df.A === df[!, "A"]
true

julia> df.A === df[:, "A"]
false

julia> df.A == df[:, "A"]
true

julia> df.A === df[!, 1]
true

julia> df.A === df[:, 1]
false

julia> df.A == df[:, 1]
true

julia> firstcolumn = :A
:A

julia> df[!, firstcolumn] === df.A
true

julia> df[:, firstcolumn] === df.A
false

julia> df[:, firstcolumn] == df.A
true
```

Column names can be obtained as strings using the `names` function:

```jldoctest dataframe
julia> names(df)
2-element Vector{String}:
 "A"
 "B"
```

You can also filter column names by passing a column selector condition as a second argument.
See the [`names`](@ref) docstring for a detailed list of available conditions.
Here we give some selected examples:

```jldoctest dataframe
julia> names(df, r"A") # a regular expression selector
1-element Vector{String}:
 "A"

julia> names(df, Int) # a selector using column element type
1-element Vector{String}:
 "A"

julia> names(df, Not(:B)) # selector keeping all columns except :B
1-element Vector{String}:
 "A"
```

To get column names as `Symbol`s use the `propertynames` function:

```jldoctest dataframe
julia> propertynames(df)
2-element Vector{Symbol}:
 :A
 :B
```

!!! note

    DataFrames.jl allows to use `Symbol`s (like `:A`) and strings (like `"A"`)
    for all column indexing operations for convenience. However, using `Symbol`s
    is slightly faster and should generally be preferred, if not generating them
    via string manipulation.

### Constructing Column by Column

It is also possible to start with an empty `DataFrame` and add columns to it one by one:

```jldoctest dataframe
julia> df = DataFrame()
0×0 DataFrame

julia> df.A = 1:8
1:8

julia> df[:, :B] = ["M", "F", "F", "M", "F", "M", "M", "F"]
8-element Vector{String}:
 "M"
 "F"
 "F"
 "M"
 "F"
 "M"
 "M"
 "F"

julia> df[!, :C] .= 0
8-element Vector{Int64}:
 0
 0
 0
 0
 0
 0
 0
 0

julia> df
8×3 DataFrame
 Row │ A      B       C
     │ Int64  String  Int64
─────┼──────────────────────
   1 │     1  M           0
   2 │     2  F           0
   3 │     3  F           0
   4 │     4  M           0
   5 │     5  F           0
   6 │     6  M           0
   7 │     7  M           0
   8 │     8  F           0
```

The `DataFrame` we build in this way has 8 rows and 3 columns.
This can be checked using the `size` function:

```jldoctest dataframe
julia> size(df, 1)
8

julia> size(df, 2)
3

julia> size(df)
(8, 3)
```

In the above example notice that the `df[!, :C] .= 0` expression created a new
column in the data frame by broadcasting a scalar.

When setting a column of a data frame the `df[!, :C]` and `df.C` syntaxes are
equivalent and they would replace (or create) the `:C` column in `df`. This
is different from using `df[:, :C]` to set a column in a data frame, which
updates the contents of column in-place if it already exists.

Here is an example showing this difference. Let us try changing the `:B` column
to a binary variable.

```jldoctest dataframe
julia> df[:, :B] = df.B .== "F"
ERROR: MethodError: Cannot `convert` an object of type Bool to an object of type String

julia> df[:, :B] .= df.B .== "F"
ERROR: MethodError: Cannot `convert` an object of type Bool to an object of type String
```

The above operations did not work because when you use `:` as row selector the
`:B` column is updated in-place, and it only supports storing strings.

On the other hand the following works:

```jldoctest dataframe
julia> df.B = df.B .== "F"
8-element BitVector:
 0
 1
 1
 0
 1
 0
 0
 1

julia> df
8×3 DataFrame
 Row │ A      B      C
     │ Int64  Bool   Int64
─────┼─────────────────────
   1 │     1  false      0
   2 │     2   true      0
   3 │     3   true      0
   4 │     4  false      0
   5 │     5   true      0
   6 │     6  false      0
   7 │     7  false      0
   8 │     8   true      0
```

As you can see because we used `df.B` on the right-hand side of the assignment
the `:B` column was replaced. The same effect would be achieved if we used
`df[!, :B]` instead or if we used broadcasted assignment `.=`.

In the [Indexing](@ref) section of the manual you can find all details about all
the available indexing options.

### Constructing Row by Row

It is also possible to fill a `DataFrame` row by row. Let us construct an empty
data frame with two columns (note that the first column can only contain
integers and the second one can only contain strings):

```jldoctest dataframe
julia> df = DataFrame(A=Int[], B=String[])
0×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┴───────────────
```

Rows can then be added as tuples or vectors, where the order of elements matches that of columns.
To add new rows at the end of a data frame use [`push!`](@ref):

```jldoctest dataframe
julia> push!(df, (1, "M"))
1×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┼───────────────
   1 │     1  M

julia> push!(df, [2, "N"])
2×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┼───────────────
   1 │     1  M
   2 │     2  N
```

Rows can also be added as `Dict`s, where the dictionary keys match the column names:

```jldoctest dataframe
julia> push!(df, Dict(:B => "F", :A => 3))
3×2 DataFrame
 Row │ A      B
     │ Int64  String
─────┼───────────────
   1 │     1  M
   2 │     2  N
   3 │     3  F
```

Note that constructing a `DataFrame` row by row is significantly less performant than
constructing it all at once, or column by column. For many use-cases this will not matter,
but for very large `DataFrame`s  this may be a consideration.

If you want to add rows at the beginning of a data frame use [`pushfirst!`](@ref)
and to insert a row in an arbitrary location use [`insert!`](@ref).

You can also add whole tables to a data frame using the [`append!`](@ref)
and [`prepend!`](@ref) functions.

### Constructing from another table type

DataFrames supports the [Tables.jl](https://github.com/JuliaData/Tables.jl) interface for
interacting with tabular data. This means that a `DataFrame` can be used as a "source"
to any package that expects a Tables.jl interface input, (file format packages,
data manipulation packages, etc.). A `DataFrame` can also be a sink for any Tables.jl
interface input. Some example uses are:

```julia
df = DataFrame(a=[1, 2, 3], b=[:a, :b, :c])

# write DataFrame out to CSV file
CSV.write("dataframe.csv", df)

# store DataFrame in an SQLite database table
SQLite.load!(df, db, "dataframe_table")

# transform a DataFrame through Query.jl package
df = df |> @map({a=_.a + 1, _.b}) |> DataFrame
```

A particular common case of a collection that supports the
[Tables.jl](https://github.com/JuliaData/Tables.jl) interface is
a vector of `NamedTuple`s:
```jldoctest dataframe
julia> v = [(a=1, b=2), (a=3, b=4)]
2-element Vector{@NamedTuple{a::Int64, b::Int64}}:
 (a = 1, b = 2)
 (a = 3, b = 4)

julia> df = DataFrame(v)
2×2 DataFrame
 Row │ a      b
     │ Int64  Int64
─────┼──────────────
   1 │     1      2
   2 │     3      4
```
You can also easily convert a data frame back to a vector of `NamedTuple`s:
```jldoctest dataframe
julia> using Tables

julia> Tables.rowtable(df)
2-element Vector{@NamedTuple{a::Int64, b::Int64}}:
 (a = 1, b = 2)
 (a = 3, b = 4)
```

# Missing Data

In Julia, missing values in data are represented using the special object
`missing`, which is the single instance of the type `Missing`.

```jldoctest
julia> missing
missing

julia> typeof(missing)
Missing
```

The `Missing` type lets users create vectors and `DataFrame` columns with
missing values. Here we create a vector with a missing value and the
element-type of the returned vector is `Union{Missing, Int64}`.

```jldoctest missings
julia> x = [1, 2, missing]
3-element Vector{Union{Missing, Int64}}:
 1
 2
  missing

julia> eltype(x)
Union{Missing, Int64}

julia> Union{Missing, Int}
Union{Missing, Int64}

julia> eltype(x) == Union{Missing, Int}
true
```

`missing` values can be excluded when performing operations by using
`skipmissing`, which returns a memory-efficient iterator.

```jldoctest missings
julia> skipmissing(x)
skipmissing(Union{Missing, Int64}[1, 2, missing])
```

The output of `skipmissing` can be passed directly into functions as an
argument. For example, we can find the `sum` of all non-missing values or
`collect` the non-missing values into a new missing-free vector.

```jldoctest missings
julia> sum(skipmissing(x))
3

julia> collect(skipmissing(x))
2-element Vector{Int64}:
 1
 2
```

The function `coalesce` can be used to replace missing values with another value
(note the dot, indicating that the replacement should be applied to all entries
in `x`):

```jldoctest missings
julia> coalesce.(x, 0)
3-element Vector{Int64}:
 1
 2
 0
```

The functions [`dropmissing`](@ref) and [`dropmissing!`](@ref) can be used to
remove the rows containing `missing` values from a data frame and either create
a new `DataFrame` or mutate the original in-place respectively.

```jldoctest missings
julia> using DataFrames

julia> df = DataFrame(i=1:5,
                      x=[missing, 4, missing, 2, 1],
                      y=[missing, missing, "c", "d", "e"])
5×3 DataFrame
 Row │ i      x        y
     │ Int64  Int64?   String?
─────┼─────────────────────────
   1 │     1  missing  missing
   2 │     2        4  missing
   3 │     3  missing  c
   4 │     4        2  d
   5 │     5        1  e

julia> dropmissing(df)
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e
```

One can specify the column(s) in which to search for rows containing `missing`
values to be removed.

```jldoctest missings
julia> dropmissing(df, :x)
3×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String?
─────┼───────────────────────
   1 │     2      4  missing
   2 │     4      2  d
   3 │     5      1  e
```

By default the [`dropmissing`](@ref) and [`dropmissing!`](@ref) functions keep
the `Union{T, Missing}` element type in columns selected for row removal. To
remove the `Missing` part, if present, set the `disallowmissing` keyword
argument to `true` (it will become the default behavior in the future).

```jldoctest missings
julia> dropmissing(df, disallowmissing=true)
2×3 DataFrame
 Row │ i      x      y
     │ Int64  Int64  String
─────┼──────────────────────
   1 │     4      2  d
   2 │     5      1  e
```

Sometimes it is useful to allow or disallow support of missing values in some
columns of a data frame. These operations are supported by the
[`allowmissing`](@ref), [`allowmissing!`](@ref), [`disallowmissing`](@ref), and
[`disallowmissing!`](@ref) functions. Here is an example:

```jldoctest missings
julia> df = DataFrame(x=1:3, y=4:6)
3×2 DataFrame
 Row │ x      y
     │ Int64  Int64
─────┼──────────────
   1 │     1      4
   2 │     2      5
   3 │     3      6

julia> allowmissing!(df)
3×2 DataFrame
 Row │ x       y
     │ Int64?  Int64?
─────┼────────────────
   1 │      1       4
   2 │      2       5
   3 │      3       6
```

Now `df` allows missing values in all its columns. We can take advantage of this
fact and set some of the values in `df` to `missing`, e.g.:

```jldoctest missings
julia> df[1, 1] = missing
missing

julia> df
3×2 DataFrame
 Row │ x        y
     │ Int64?   Int64?
─────┼─────────────────
   1 │ missing       4
   2 │       2       5
   3 │       3       6
```

Note that a column selector can be passed as the second positional argument to
[`allowmissing`](@ref) and [`allowmissing!`](@ref) to restrict the change to
only some columns in our data frame.

Now let us perform the reverse operation by disallowing missing values in `df`. We
know that column `:y` does not contain missing values so we can use the
[`disallowmissing`](@ref) function passing a column selector as the second
positional argument:

```jldoctest missings
julia> disallowmissing(df, :y)
3×2 DataFrame
 Row │ x        y
     │ Int64?   Int64
─────┼────────────────
   1 │ missing      4
   2 │       2      5
   3 │       3      6
```

This operation created a new `DataFrame`. If we wanted to update the `df`
in-place the [`disallowmissing!`](@ref) function should be used.

If we tried to disallow missings in the whole data frame using
`disallowmissing(df)` we would get an error. However, it is often useful to
disallow missings in all columns that actually do not contain them but keep the
columns that have some `missing` values unchanged without having to list them
explicitly. This can be accomplished by passing the `error=false` keyword argument:

```jldoctest missings
julia> disallowmissing(df, error=false)
3×2 DataFrame
 Row │ x        y
     │ Int64?   Int64
─────┼────────────────
   1 │ missing      4
   2 │       2      5
   3 │       3      6
```

The [Missings.jl](https://github.com/JuliaData/Missings.jl) package provides a
few convenience functions to work with missing values.

One of the most commonly used is `passmissing`. It is a higher order function
that takes some function `f` as its argument and returns a new function
which returns `missing` if any of its positional arguments are `missing`
and otherwise applies the function `f` to these arguments. This functionality
is useful in combination with functions that do not support passing `missing`
values as their arguments. For example, trying `uppercase(missing)` would
produce an error, while the following works:

```jldoctest missings
julia> passmissing(uppercase)("a")
"A"

julia> passmissing(uppercase)(missing)
missing
```

The function `Missings.replace` returns an iterator which replaces `missing`
elements with another value:

```jldoctest missings
julia> using Missings

julia> Missings.replace(x, 1)
Missings.EachReplaceMissing{Vector{Union{Missing, Int64}}, Int64}(Union{Missing, Int64}[1, 2, missing], 1)

julia> collect(Missings.replace(x, 1))
3-element Vector{Int64}:
 1
 2
 1

julia> collect(Missings.replace(x, 1)) == coalesce.(x, 1)
true
```

The function `nonmissingtype` returns the element-type `T` in `Union{T, Missing}`.

```jldoctest missings
julia> eltype(x)
Union{Missing, Int64}

julia> nonmissingtype(eltype(x))
Int64
```

The `missings` function constructs `Vector`s and `Array`s supporting missing
values, using the optional first argument to specify the element-type.

```jldoctest missings
julia> missings(1)
1-element Vector{Missing}:
 missing

julia> missings(3)
3-element Vector{Missing}:
 missing
 missing
 missing

julia> missings(1, 3)
1×3 Matrix{Missing}:
 missing  missing  missing

julia> missings(Int, 1, 3)
1×3 Matrix{Union{Missing, Int64}}:
 missing  missing  missing
```

See the [Julia manual](https://docs.julialang.org/en/v1/manual/missing/) for
more information about missing values.

# [Categorical Data](@id man-categorical)

Often, we have to deal with columns in a data frame that take on a small number
of levels:

```jldoctest categorical
julia> v = ["Group A", "Group A", "Group A", "Group B", "Group B", "Group B"]
6-element Vector{String}:
 "Group A"
 "Group A"
 "Group A"
 "Group B"
 "Group B"
 "Group B"
```

The naive encoding used in a `Vector` represents every entry of this vector as a
full string. In contrast, we can represent the data more efficiently by
replacing the strings with indices into a small pool of levels. There are two
benefits of doing this. The first is that such vectors will tend to use less
memory. The second is that they can be efficiently grouped using the `groupby`
function.

There are two common types that allow to perform level pooling:
* `PooledVector` from PooledArrays.jl;
* `CategoricalVector` from CategoricalArrays.jl.

The difference between `PooledVector` and `CategoricalVector` is the following:
* `PooledVector` is intended for cases where data compression is the only objective;
* `CategoricalVector` is designed to additionally provide full support
   for working with categorical variables, both with unordered
  (nominal variables) and ordered categories (ordinal variables) at the expense
  of allowing only `AbstractString`, `AbstractChar`, or `Number` element types
  (optionally in a union with `Missing`).

`CategoricalVector` is useful in particular when unique values in the array
(levels) should respect a meaningful ordering, like when printing tables, drawing plots or
fitting regression models. CategoricalArrays.jl provides functions to set and retrieve
this order and compare values according to it. On the contrary, the `PooledVector` type
is essentially a drop-in replacement for `Vector` with almost no user-visible differences
except for lower memory use and higher performance. 

Below we show selected examples of working with CategoricalArrays.jl.
See the [CategoricalArrays.jl documentation](https://categoricalarrays.juliadata.org/stable/)
package for more information regarding categorical arrays.
Also note that in this section we discuss only vectors because
we are considering a data frame context. However, in
general both packages allow to work with arrays of any dimensionality.

In order to follow the examples below you need to install the
CategoricalArrays.jl package first.

```jldoctest categorical
julia> using CategoricalArrays

julia> cv = categorical(v)
6-element CategoricalArray{String,1,UInt32}:
 "Group A"
 "Group A"
 "Group A"
 "Group B"
 "Group B"
 "Group B"
```

`CategoricalVectors`s support missing values.

```jldoctest categorical
julia> cv = categorical(["Group A", missing, "Group A",
                         "Group B", "Group B", missing])
6-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Group A"
 missing
 "Group A"
 "Group B"
 "Group B"
 missing
```

In addition to representing repeated data efficiently, the `CategoricalArray`
type allows us to determine efficiently the allowed levels of the variable at
any time using the `levels` function (note that levels may or may not be
actually used in the data):

```jldoctest categorical
julia> levels(cv)
2-element CategoricalArray{String,1,UInt32}:
 "Group A"
 "Group B"
```

The `levels!` function also allows changing the order of appearance of the
levels, which can be useful for display purposes or when working with ordered
variables.

```jldoctest categorical
julia> levels!(cv, ["Group B", "Group A"])
6-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Group A"
 missing
 "Group A"
 "Group B"
 "Group B"
 missing

julia> levels(cv)
2-element CategoricalArray{String,1,UInt32}:
 "Group B"
 "Group A"

julia> sort(cv)
6-element CategoricalArray{Union{Missing, String},1,UInt32}:
 "Group B"
 "Group B"
 "Group A"
 "Group A"
 missing
 missing
```

By default, a `CategoricalVector` is able to represent ``2^{32}`` different
levels. You can use less memory by calling the `compress` function:

```jldoctest categorical
julia> cv = compress(cv)
6-element CategoricalArray{Union{Missing, String},1,UInt8}:
 "Group A"
 missing
 "Group A"
 "Group B"
 "Group B"
 missing

```

The `categorical` function additionally accepts a keyword argument `compress`
which when set to `true` is equivalent to calling `compress` on the new vector:

```jldoctest categorical
julia> cv1 = categorical(["A", "B"], compress=true)
2-element CategoricalArray{String,1,UInt8}:
 "A"
 "B"
```

If the `ordered` keyword argument is set to `true`, the resulting
`CategoricalVector` will be ordered, which means that its levels can be tested
for order (rather than throwing an error):

```jldoctest categorical
julia> cv2 = categorical(["A", "B"], ordered=true)
2-element CategoricalArray{String,1,UInt32}:
 "A"
 "B"

julia> cv1[1] < cv1[2]
ERROR: ArgumentError: Unordered CategoricalValue objects cannot be tested for order using <. Use isless instead, or call the ordered! function on the parent array to change this

julia> cv2[1] < cv2[2]
true
```

You can check if a `CategoricalVector` is ordered using the `isordered` function
and change between ordered and unordered using `ordered!` function.

```jldoctest categorical
julia> isordered(cv1)
false

julia> ordered!(cv1, true)
2-element CategoricalArray{String,1,UInt8}:
 "A"
 "B"

julia> isordered(cv1)
true

julia> cv1[1] < cv1[2]
true
```

# Importing and Exporting Data (I/O)

## CSV Files

For reading and writing tabular data from CSV and other delimited text files,
use the [CSV.jl](https://github.com/JuliaData/CSV.jl) package.

If you have not used the CSV.jl package before then you may need to install it first:
```julia
using Pkg
Pkg.add("CSV")
```

The CSV.jl functions are not loaded automatically and must be imported into the session.
```julia
using CSV
```

A dataset can now be read from a CSV file at path `input` using
```julia
DataFrame(CSV.File(input))
```

A `DataFrame` can be written to a CSV file at path `output` using
```julia
df = DataFrame(x=1, y=2)
CSV.write(output, df)
```

The behavior of CSV functions can be adapted via keyword arguments. For more
information, see `?CSV.File`, `?CSV.read` and `?CSV.write`, or checkout the
online [CSV.jl documentation](https://juliadata.github.io/CSV.jl/stable/).

In simple cases, when compilation latency of CSV.jl might be an issue,
using the `DelimitedFiles` module from the Julia standard library can be considered.
Here is an example showing how to read in the data and perform its
post-processing:

```jldoctest readdlm
julia> using DelimitedFiles, DataFrames

julia> path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "iris.csv");

julia> data, header = readdlm(path, ',', header=true);

julia> iris_raw = DataFrame(data, vec(header))
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Any          Any         Any          Any         Any
─────┼──────────────────────────────────────────────────────────────────
   1 │ 5.1          3.5         1.4          0.2         Iris-setosa
   2 │ 4.9          3.0         1.4          0.2         Iris-setosa
   3 │ 4.7          3.2         1.3          0.2         Iris-setosa
   4 │ 4.6          3.1         1.5          0.2         Iris-setosa
   5 │ 5.0          3.6         1.4          0.2         Iris-setosa
   6 │ 5.4          3.9         1.7          0.4         Iris-setosa
   7 │ 4.6          3.4         1.4          0.3         Iris-setosa
   8 │ 5.0          3.4         1.5          0.2         Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │ 6.8          3.2         5.9          2.3         Iris-virginica
 145 │ 6.7          3.3         5.7          2.5         Iris-virginica
 146 │ 6.7          3.0         5.2          2.3         Iris-virginica
 147 │ 6.3          2.5         5.0          1.9         Iris-virginica
 148 │ 6.5          3.0         5.2          2.0         Iris-virginica
 149 │ 6.2          3.4         5.4          2.3         Iris-virginica
 150 │ 5.9          3.0         5.1          1.8         Iris-virginica
                                                        135 rows omitted

julia> iris = identity.(iris_raw)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     SubStrin…
─────┼──────────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         6.8         3.2          5.9         2.3  Iris-virginica
 145 │         6.7         3.3          5.7         2.5  Iris-virginica
 146 │         6.7         3.0          5.2         2.3  Iris-virginica
 147 │         6.3         2.5          5.0         1.9  Iris-virginica
 148 │         6.5         3.0          5.2         2.0  Iris-virginica
 149 │         6.2         3.4          5.4         2.3  Iris-virginica
 150 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                        135 rows omitted
```

Observe that in our example:
* `header` is a `Matrix` therefore we had to pass `vec(header)` to the `DataFrame`
  constructor;
* we broadcasted the `identity` function over the `iris_raw` data frame to perform
  narrowing of `eltype` of columns of `iris_raw`; the reason is that read in by
  the `readdlm` function is stored into a `data` `Matrix` so all columns in
  `iris_raw` initially have the same `eltype` -- in this case it had to be `Any`
  as some of the columns are numeric and some are string.

All such operations (and many more) are automatically handled by CSV.jl.

Similarly, you can use the `writedlm` function from the `DelimitedFiles` module to
save a data frame like this:

```julia
writedlm("test.csv", Iterators.flatten(([names(iris)], eachrow(iris))), ',')
```

As you can see the code required to transform `iris` into a proper input to the
`writedlm` function so that you can create the CSV file having the expected
format is not easy. Therefore CSV.jl is the preferred package to write CSV files
for data stored in data frames.

### `DataFrame` Definition in Source Code
Sometimes, you might want to define a `DataFrame` with data directly in the source
code. For better readability you probably want to define it in a way which resembles
a table. This can be done with `CSV.jl` like this:

```julia
df = CSV.read("""
    name,age,children
    John,54.0,0
    Sally,34.0,2
    Roger,79.0,4
    """ |> IOBuffer, DataFrame)
```

This will result in the following `DataFrame`:

```
3×3 DataFrame
 Row │ name     age      children 
     │ String7  Float64  Int64    
─────┼────────────────────────────
   1 │ John        54.0         0
   2 │ Sally       34.0         2
   3 │ Roger       79.0         4
```

As the readability in the source code of the above format is not great, you can make
use of [`CSV.jl`'s options](https://csv.juliadata.org/stable/examples.html#csv_string)
to find a format which works for you, e.g. using
[Unicode box drawing characters](https://en.wikipedia.org/wiki/Box-drawing_characters#Unicode)

```julia
data = """
┌───────┬──────┬──────────┐
│ name  │ age  │ children │
├───────┼──────┼──────────┤
│ John  │ 54.0 │    0     │
│ Sally │ 34.0 │    2     │
│ Roger │ 79.0 │    4     │
└───────┴──────┴──────────┘
"""
```

You can then create the above `DataFrame` object with

```julia
df = CSV.read(data |> IOBuffer, DataFrame, normalizenames=true,
              header=2, skipto=4, footerskip=1, delim='│',
              drop=(i, name) -> startswith(name |> String, "Column")
     ) .|> x -> x isa AbstractString ? strip(x) : x
```

## Other formats

Other data formats are supported for reading and writing in the following packages
(non exhaustive list):
* Apache Arrow (including Feather v2): [Arrow.jl](https://github.com/JuliaData/Arrow.jl)
* Apache Feather (v1): [Feather.jl](https://github.com/JuliaData/Feather.jl)
* Apache Avro: [Avro.jl](https://github.com/JuliaData/Avro.jl)
* JSON: [JSONTables.jl](https://github.com/JuliaData/JSONTables.jl)
* Parquet: [Parquet2.jl](https://gitlab.com/ExpandingMan/Parquet2.jl)
* Stata, SAS and SPSS: [ReadStatTables.jl](https://github.com/junyuan-chen/ReadStatTables.jl)
  (alternatively [Queryverse](https://www.queryverse.org/)
   users can choose [StatFiles.jl](https://github.com/queryverse/StatFiles.jl))
* reading R data files (.rda, .RData): [RData.jl](https://github.com/JuliaData/RData.jl)
* Microsoft Excel (XLSX): [XLSX.jl](https://github.com/felipenoris/XLSX.jl)
* Copying/pasting to clipboard, for sending data to and from spreadsheets: [ClipData.jl](https://github.com/pdeffebach/ClipData.jl)

# Database-Style Joins

## Introduction to joins

We often need to combine two or more data sets together to provide a complete
picture of the topic we are studying. For example, suppose that we have the
following two data sets:

```jldoctest joins
julia> using DataFrames

julia> people = DataFrame(ID=[20, 40], Name=["John Doe", "Jane Doe"])
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │    20  John Doe
   2 │    40  Jane Doe

julia> jobs = DataFrame(ID=[20, 40], Job=["Lawyer", "Doctor"])
2×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │    20  Lawyer
   2 │    40  Doctor
```

We might want to work with a larger data set that contains both the names and
jobs for each ID. We can do this using the `innerjoin` function:

```jldoctest joins
julia> innerjoin(people, jobs, on = :ID)
2×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String    String
─────┼─────────────────────────
   1 │    20  John Doe  Lawyer
   2 │    40  Jane Doe  Doctor
```

In relational database theory, this operation is generally referred to as a
join. The columns used to determine which rows should be combined during a join
are called keys.

The following functions are provided to perform seven kinds of joins:

- `innerjoin`: the output contains rows for values of the key that exist in all
  passed data frames.
- `leftjoin`: the output contains rows for values of the key that exist in the
  first (left) argument, whether or not that value exists in the second (right)
  argument.
- `rightjoin`: the output contains rows for values of the key that exist in the
  second (right) argument, whether or not that value exists in the first (left)
  argument.
- `outerjoin`: the output contains rows for values of the key that exist in any
  of the passed data frames.
- `semijoin`: Like an inner join, but output is restricted to columns from the
  first (left) argument.
- `antijoin`: The output contains rows for values of the key that exist in the
  first (left) but not the second (right) argument. As with `semijoin`, output
  is restricted to columns from the first (left) argument.
- `crossjoin`: The output is the cartesian product of rows from all passed data
  frames.

See [the Wikipedia page on SQL joins](https://en.wikipedia.org/wiki/Join_(SQL)) for more information.

Here are examples of different kinds of join:

```jldoctest joins
julia> jobs = DataFrame(ID=[20, 60], Job=["Lawyer", "Astronaut"])
2×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼──────────────────
   1 │    20  Lawyer
   2 │    60  Astronaut

julia> innerjoin(people, jobs, on = :ID)
1×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String    String
─────┼─────────────────────────
   1 │    20  John Doe  Lawyer

julia> leftjoin(people, jobs, on = :ID)
2×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String    String?
─────┼──────────────────────────
   1 │    20  John Doe  Lawyer
   2 │    40  Jane Doe  missing

julia> rightjoin(people, jobs, on = :ID)
2×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String?   String
─────┼────────────────────────────
   1 │    20  John Doe  Lawyer
   2 │    60  missing   Astronaut

julia> outerjoin(people, jobs, on = :ID)
3×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String?   String?
─────┼────────────────────────────
   1 │    20  John Doe  Lawyer
   2 │    40  Jane Doe  missing
   3 │    60  missing   Astronaut

julia> semijoin(people, jobs, on = :ID)
1×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │    20  John Doe

julia> antijoin(people, jobs, on = :ID)
1×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │    40  Jane Doe
```

Cross joins are the only kind of join that does not use a `on` key:

```jldoctest joins
julia> crossjoin(people, jobs, makeunique = true)
4×4 DataFrame
 Row │ ID     Name      ID_1   Job
     │ Int64  String    Int64  String
─────┼───────────────────────────────────
   1 │    20  John Doe     20  Lawyer
   2 │    20  John Doe     60  Astronaut
   3 │    40  Jane Doe     20  Lawyer
   4 │    40  Jane Doe     60  Astronaut
```

## Key value comparisons and floating point values

Key values from the two or more data frames are compared using the `isequal`
function. This is consistent with the `Set` and `Dict` types in Julia Base.

It is not recommended to use floating point numbers as keys: floating point
comparisons can be surprising and unpredictable. If you do use floating point
keys, note that by default an error is raised when keys include `-0.0`
(negative zero) or `NaN` values.
Here is an example:

```jldoctest joins
julia> innerjoin(DataFrame(id=[-0.0]), DataFrame(id=[0.0]), on=:id)
ERROR: ArgumentError: Currently for numeric values `NaN` and `-0.0` in their real or imaginary components are not allowed. Such value was found in column :id in left data frame. Use CategoricalArrays.jl to wrap these values in a CategoricalVector to perform the requested join.
```

This can be overridden by wrapping the key
values in a [categorical](@ref man-categorical) vector.

## Joining on key columns with different names

In order to join data frames on keys which have different names in the left and
right tables, you may pass `left => right` pairs as `on` argument:

```jldoctest joins
julia> a = DataFrame(ID=[20, 40], Name=["John Doe", "Jane Doe"])
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼─────────────────
   1 │    20  John Doe
   2 │    40  Jane Doe

julia> b = DataFrame(IDNew=[20, 40], Job=["Lawyer", "Doctor"])
2×2 DataFrame
 Row │ IDNew  Job
     │ Int64  String
─────┼───────────────
   1 │    20  Lawyer
   2 │    40  Doctor

julia> innerjoin(a, b, on = :ID => :IDNew)
2×3 DataFrame
 Row │ ID     Name      Job
     │ Int64  String    String
─────┼─────────────────────────
   1 │    20  John Doe  Lawyer
   2 │    40  Jane Doe  Doctor
```

Here is another example with multiple columns:

```jldoctest joins
julia> a = DataFrame(City=["Amsterdam", "London", "London", "New York", "New York"],
                     Job=["Lawyer", "Lawyer", "Lawyer", "Doctor", "Doctor"],
                     Category=[1, 2, 3, 4, 5])
5×3 DataFrame
 Row │ City       Job     Category
     │ String     String  Int64
─────┼─────────────────────────────
   1 │ Amsterdam  Lawyer         1
   2 │ London     Lawyer         2
   3 │ London     Lawyer         3
   4 │ New York   Doctor         4
   5 │ New York   Doctor         5

julia> b = DataFrame(Location=["Amsterdam", "London", "London", "New York", "New York"],
                     Work=["Lawyer", "Lawyer", "Lawyer", "Doctor", "Doctor"],
                     Name=["a", "b", "c", "d", "e"])
5×3 DataFrame
 Row │ Location   Work    Name
     │ String     String  String
─────┼───────────────────────────
   1 │ Amsterdam  Lawyer  a
   2 │ London     Lawyer  b
   3 │ London     Lawyer  c
   4 │ New York   Doctor  d
   5 │ New York   Doctor  e

julia> innerjoin(a, b, on = [:City => :Location, :Job => :Work])
9×4 DataFrame
 Row │ City       Job     Category  Name
     │ String     String  Int64     String
─────┼─────────────────────────────────────
   1 │ Amsterdam  Lawyer         1  a
   2 │ London     Lawyer         2  b
   3 │ London     Lawyer         3  b
   4 │ London     Lawyer         2  c
   5 │ London     Lawyer         3  c
   6 │ New York   Doctor         4  d
   7 │ New York   Doctor         5  d
   8 │ New York   Doctor         4  e
   9 │ New York   Doctor         5  e
```

## Handling of duplicate keys and tracking source data frame

Additionally, notice that in the last join rows 2 and 3 had the same values on
`on` variables in both joined `DataFrame`s. In such a situation `innerjoin`,
`outerjoin`, `leftjoin` and `rightjoin` will produce all combinations of
matching rows. In our example rows from 2 to 5 were created as a result. The
same behavior can be observed for rows 4 and 5 in both joined `DataFrame`s.

In order to check that columns passed as the `on` argument define unique keys
(according to `isequal`) in each input data frame you can set the `validate`
keyword argument to a two-element tuple or a pair of `Bool` values, with each
element indicating whether to run check for the corresponding data frame. Here
is an example for the join operation described above:

```jldoctest joins
julia> innerjoin(a, b, on = [(:City => :Location), (:Job => :Work)], validate=(true, true))
ERROR: ArgumentError: Merge key(s) are not unique in both df1 and df2. df1 contains 2 duplicate keys: (City = "London", Job = "Lawyer") and (City = "New York", Job = "Doctor"). df2 contains 2 duplicate keys: (Location = "London", Work = "Lawyer") and (Location = "New York", Work = "Doctor").
```

Finally, using the `source` keyword argument you can add a column to the
resulting data frame indicating whether the given row appeared only in the left,
the right or both data frames. Here is an example:

```jldoctest joins
julia> a = DataFrame(ID=[20, 40], Name=["John", "Jane"])
2×2 DataFrame
 Row │ ID     Name
     │ Int64  String
─────┼───────────────
   1 │    20  John
   2 │    40  Jane

julia> b = DataFrame(ID=[20, 60], Job=["Lawyer", "Doctor"])
2×2 DataFrame
 Row │ ID     Job
     │ Int64  String
─────┼───────────────
   1 │    20  Lawyer
   2 │    60  Doctor

julia> outerjoin(a, b, on=:ID, validate=(true, true), source=:source)
3×4 DataFrame
 Row │ ID     Name     Job      source
     │ Int64  String?  String?  String
─────┼─────────────────────────────────────
   1 │    20  John     Lawyer   both
   2 │    40  Jane     missing  left_only
   3 │    60  missing  Doctor   right_only
```

Note that this time we also used the `validate` keyword argument and it did not
produce errors as the keys defined in both source data frames were unique.

## Renaming joined columns

Often you want to keep track of the source data frame.
This feature is supported with the `renamecols` keyword argument:

```jldoctest joins
julia> innerjoin(a, b, on=:ID, renamecols = "_left" => "_right")
1×3 DataFrame
 Row │ ID     Name_left  Job_right
     │ Int64  String     String
─────┼─────────────────────────────
   1 │    20  John       Lawyer
```

In the above example we added the `"_left"` suffix to the non-key columns from
the left table and the `"_right"` suffix to the non-key columns from the right
table.

Alternatively it is allowed to pass a function transforming column names:
```jldoctest joins
julia> innerjoin(a, b, on=:ID, renamecols = lowercase => uppercase)
1×3 DataFrame
 Row │ ID     name    JOB
     │ Int64  String  String
─────┼───────────────────────
   1 │    20  John    Lawyer

```

## Matching missing values in joins

By default when you try to to perform a join on a key that has `missing` values
you get an error:

```jldoctest joins
julia> df1 = DataFrame(id=[1, missing, 3], a=1:3)
3×2 DataFrame
 Row │ id       a
     │ Int64?   Int64
─────┼────────────────
   1 │       1      1
   2 │ missing      2
   3 │       3      3

julia> df2 = DataFrame(id=[1, 2, missing], b=1:3)
3×2 DataFrame
 Row │ id       b
     │ Int64?   Int64
─────┼────────────────
   1 │       1      1
   2 │       2      2
   3 │ missing      3

julia> innerjoin(df1, df2, on=:id)
ERROR: ArgumentError: Missing values in key columns are not allowed when matchmissing == :error. `missing` found in column :id in left data frame.
```

If you would prefer `missing` values to be treated as equal pass
the `matchmissing=:equal` keyword argument:

```jldoctest joins
julia> innerjoin(df1, df2, on=:id, matchmissing=:equal)
2×3 DataFrame
 Row │ id       a      b
     │ Int64?   Int64  Int64
─────┼───────────────────────
   1 │       1      1      1
   2 │ missing      2      3
```

Alternatively you might want to drop all rows with `missing` values. In this
case pass `matchmissing=:notequal`:

```jldoctest joins
julia> innerjoin(df1, df2, on=:id, matchmissing=:notequal)
1×3 DataFrame
 Row │ id      a      b
     │ Int64?  Int64  Int64
─────┼──────────────────────
   1 │      1      1      1
```

## Specifying row order in the join result

By default the order of rows produced by the join operation is undefined:

```jldoctest joins
julia> df_left = DataFrame(id=[1, 2, 4, 5], left=1:4)
4×2 DataFrame
 Row │ id     left
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     4      3
   4 │     5      4

julia> df_right = DataFrame(id=[2, 1, 3, 6, 7], right=1:5)
5×2 DataFrame
 Row │ id     right
     │ Int64  Int64
─────┼──────────────
   1 │     2      1
   2 │     1      2
   3 │     3      3
   4 │     6      4
   5 │     7      5

julia> outerjoin(df_left, df_right, on=:id)
7×3 DataFrame
 Row │ id     left     right
     │ Int64  Int64?   Int64?
─────┼─────────────────────────
   1 │     2        2        1
   2 │     1        1        2
   3 │     4        3  missing
   4 │     5        4  missing
   5 │     3  missing        3
   6 │     6  missing        4
   7 │     7  missing        5
```

If you would like the result to keep the row order of the left table pass
the `order=:left` keyword argument:

```jldoctest joins
julia> outerjoin(df_left, df_right, on=:id, order=:left)
7×3 DataFrame
 Row │ id     left     right
     │ Int64  Int64?   Int64?
─────┼─────────────────────────
   1 │     1        1        2
   2 │     2        2        1
   3 │     4        3  missing
   4 │     5        4  missing
   5 │     3  missing        3
   6 │     6  missing        4
   7 │     7  missing        5
```

Note that in this case keys missing from the left table are put after the keys
present in it.

Similarly `order=:right` keeps the order of the right table (and puts keys
not present in it at the end):

```jldoctest joins
julia> outerjoin(df_left, df_right, on=:id, order=:right)
7×3 DataFrame
 Row │ id     left     right
     │ Int64  Int64?   Int64?
─────┼─────────────────────────
   1 │     2        2        1
   2 │     1        1        2
   3 │     3  missing        3
   4 │     6  missing        4
   5 │     7  missing        5
   6 │     4        3  missing
   7 │     5        4  missing
```

## In-place left join

A common operation is adding data from a reference table to some main table.
It is possible to perform such an in-place update using the `leftjoin!`
function. In this case the left table is updated in place with matching rows from
the right table.

```jldoctest joins
julia> main = DataFrame(id=1:4, main=1:4)
4×2 DataFrame
 Row │ id     main
     │ Int64  Int64
─────┼──────────────
   1 │     1      1
   2 │     2      2
   3 │     3      3
   4 │     4      4

julia> leftjoin!(main, DataFrame(id=[2, 4], info=["a", "b"]), on=:id);

julia> main
4×3 DataFrame
 Row │ id     main   info
     │ Int64  Int64  String?
─────┼───────────────────────
   1 │     1      1  missing
   2 │     2      2  a
   3 │     3      3  missing
   4 │     4      4  b
```

Note that in this case the order and number of rows in the left table is not
changed. Therefore, in particular, it is not allowed to have duplicate keys
in the right table:

```
julia> leftjoin!(main, DataFrame(id=[2, 2], info_bad=["a", "b"]), on=:id)
ERROR: ArgumentError: duplicate rows found in right table
```

# DataFrames.jl

Welcome to the DataFrames.jl documentation!

This resource aims to teach you everything you need to know to get up and
running with tabular data manipulation using the DataFrames.jl package.

For more illustrations of DataFrames.jl usage, in particular in conjunction with
other packages you can check-out the following resources
(they are kept up to date with the released version of DataFrames.jl):
* [DataFrames.jl: Flexible and Fast Tabular Data in Julia](https://www.jstatsoft.org/article/view/v107i04) article published in the *Journal of Statistical Software*
* [Data Wrangling with DataFrames.jl Cheat Sheet](https://ahsmart.com/posts/data-wrangling-with-data-frames-jl-cheat-eheet/DataFramesCheatSheet_v1.x_rev1.pdf)
* [DataFrames Tutorial using Jupyter Notebooks](https://github.com/bkamins/Julia-DataFrames-Tutorial/)
* [Julia Academy DataFrames.jl tutorial](https://github.com/JuliaAcademy/DataFrames)
* [JuliaCon 2023](https://github.com/bkamins/JuliaCon2023-Tutorial),
  [JuliaCon 2022](https://github.com/bkamins/JuliaCon2022-DataFrames-Tutorial),
  [JuliaCon 2021](https://github.com/bkamins/JuliaCon2021-DataFrames-Tutorial),
  [JuliaCon 2020](https://github.com/bkamins/JuliaCon2020-DataFrames-Tutorial),
  [JuliaCon 2019](https://github.com/bkamins/JuliaCon2019-DataFrames-Tutorial),
  [ODSC Europe 2021](https://github.com/bkamins/ODSC-EUROPE-2021) tutorials,
  and [PyData Global 2020](https://github.com/bkamins/PyDataGlobal2020)
* [DataFrames.jl showcase](https://github.com/bkamins/DataFrames-Showcase)

If you prefer to learn DataFrames.jl from a book you can consider reading:
* [Julia for Data Analysis](https://github.com/bkamins/JuliaForDataAnalysis);
* [Julia Data Science](https://juliadatascience.io/).

## What is DataFrames.jl?

DataFrames.jl provides a set of tools for working with tabular data in Julia.
Its design and functionality are similar to those of
[pandas](https://pandas.pydata.org/) (in Python) and `data.frame`,
[`data.table`](https://rdatatable.gitlab.io/data.table/)
and [dplyr](https://dplyr.tidyverse.org/) (in R),
making it  a great general purpose data science tool.

DataFrames.jl plays a central role in the Julia Data ecosystem, and has tight
integrations with a range of different libraries. DataFrames.jl isn't the only
tool for working with tabular data in Julia -- as noted below, there are some
other great libraries for certain use-cases -- but it provides great data
wrangling functionality through a familiar interface.

To understand the toolchain in more detail, have a look at the tutorials in this manual.
New users can start with the [First Steps with DataFrames.jl](@ref) section.

You may find the
[DataFramesMeta.jl](https://juliadata.github.io/DataFramesMeta.jl/stable/)
package or one of the other convenience packages discussed in the [Data
manipulation frameworks](@ref) section of this manual helpful when writing more
advanced data transformations, especially if you do not have a significant
programming experience. These packages provide convenience syntax similar to
[dplyr](https://dplyr.tidyverse.org/) in R.

If you use metadata when working with DataFrames.jl you might find the
[TableMetadataTools.jl](https://github.com/JuliaData/TableMetadataTools.jl)
package useful. This package defines several convenience functions for
performing typical metadata operations.

## DataFrames.jl and the Julia Data Ecosystem

The Julia data ecosystem can be a difficult space for new users to navigate, in
part because the Julia ecosystem tends to distribute functionality across
different libraries more than some other languages. Because many people coming
to DataFrames.jl are just starting to explore the Julia data ecosystem, below is
a list of well-supported libraries that provide different data science tools,
along with a few notes about what makes each library special, and how well
integrated they are with DataFrames.jl.


- **Statistics**
    - [StatsKit.jl](https://github.com/JuliaStats/StatsKit.jl): A convenience
      meta-package which loads a set of essential packages for statistics,
      including those mentioned below in this section and DataFrames.jl itself.
    - [Statistics](https://docs.julialang.org/en/v1/stdlib/Statistics/):
      The Julia standard library comes with a wide range of statistics functionality,
      but to gain access to these functions you must call `using Statistics`.
    - [LinearAlgebra](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/):
      Like `Statistics`, many linear algebra features (factorizations, inversions, etc.)
      live in a library you have to load to use.
    - [SparseArrays](https://docs.julialang.org/en/v1/stdlib/SparseArrays/)
      are also in the standard library but must be loaded to be used.
    - [FreqTables.jl](https://github.com/nalimilan/FreqTables.jl): Create
      frequency tables / cross-tabulations. Tightly integrated with DataFrames.jl.
    - [HypothesisTests.jl](https://juliastats.org/HypothesisTests.jl/stable/):
      A range of hypothesis testing tools.
    - [GLM.jl](https://juliastats.org/GLM.jl/stable/manual/): Tools for estimating
      linear and generalized linear models. Tightly integrated with DataFrames.jl.
    - [StatsModels.jl](https://juliastats.org/StatsModels.jl/stable/):
      For converting heterogeneous `DataFrame` into homogeneous matrices for use
      with linear algebra libraries or machine learning applications that don't
      directly support `DataFrame`s. Will do things like convert categorical
      variables into indicators/one-hot-encodings, create interaction terms, etc.
    - [MultivariateStats.jl](https://multivariatestatsjl.readthedocs.io/en/stable/index.html):
      linear regression, ridge regression, PCA, component analyses tools.
      Not well integrated with DataFrames.jl,
      but easily used in combination with `StatsModels`.
- **Machine Learning**
    - [MLJ.jl](https://github.com/alan-turing-institute/MLJ.jl):
      if you're more of an applied user, there is a single package the pulls
      from all these different libraries and provides a single, scikit-learn
      inspired API: MLJ.jl. MLJ.jl provides a common interface for a wide range
      of machine learning algorithms.
    - [ScikitLearn.jl](https://cstjean.github.io/ScikitLearn.jl/stable/):
      A Julia wrapper around the full Python scikit-learn machine learning library.
      Not well integrated with DataFrames.jl, but can be combined using StatsModels.jl.
    - [AutoMLPipeline](https://github.com/IBM/AutoMLPipeline.jl):
      A package that makes it trivial to create complex ML
      pipeline structures using simple expressions. It leverages
      on the built-in macro programming features of Julia to
      symbolically process, manipulate pipeline expressions,
      and makes it easy to discover optimal structures for
      machine learning regression and classification.
    - Deep learning:
      [KNet.jl](https://denizyuret.github.io/Knet.jl/stable/tutorial/#Introduction-to-Knet-1)
      and [Flux.jl](https://github.com/FluxML/Flux.jl).
- **Plotting**
    - [Plots.jl](http://docs.juliaplots.org/latest/): Powerful, modern plotting
      library with a syntax akin to that of [matplotlib](https://matplotlib.org/)
      (in Python) or `plot` (in R).
      [StatsPlots.jl](http://docs.juliaplots.org/latest/tutorial/#Using-Plot-Recipes-1)
      provides Plots.jl with recipes for many standard statistical plots.
    - [Gadfly.jl](http://gadflyjl.org/stable/): High-level plotting library with
      a "grammar of graphics" syntax akin to that of
      [ggplot](https://ggplot2.tidyverse.org/reference/ggplot.html) (in R).
    - [AlgebraOfGraphics.jl](http://juliaplots.org/AlgebraOfGraphics.jl/stable/): A
      "grammar of graphics" library build upon [Makie.jl](https://docs.makie.org/stable/).
    - [VegaLite.jl](https://www.queryverse.org/VegaLite.jl/stable/): High-level
      plotting library that uses a different "grammar of graphics" syntax and has
      an emphasis on interactive graphics.
- **Data Wrangling**:
    - [Impute.jl](https://github.com/invenia/Impute.jl):
      various methods for handling missing data in vectors, matrices and tables.
    - [DataFramesMeta.jl](https://github.com/JuliaData/DataFramesMeta.jl):
      A range of convenience functions for DataFrames.jl that augment `select` and
      `transform` to provide a user experience similar to that provided by
      [dplyr](https://dplyr.tidyverse.org/) in R.
    - [DataFrameMacros.jl](https://github.com/jkrumbiegel/DataFrameMacros.jl):
      Provides macro versions of the common DataFrames.jl functions similar to DataFramesMeta.jl,
      with convenient syntax for the manipulation of multiple columns at once.
    - [Query.jl](https://github.com/queryverse/Query.jl): Query.jl provides a single
      framework for data wrangling that works with a range of libraries, including
      DataFrames.jl, other tabular data libraries (more on those below), and even
      non-tabular data. Provides many convenience functions analogous to those in
      dplyr in R or [LINQ](https://en.wikipedia.org/wiki/Language_Integrated_Query).
    - You can find more information on these packages in the
      [Data manipulation frameworks](@ref) section of this manual.
- **And More!**
    - [Graphs.jl](https://github.com/JuliaGraphs/Graphs.jl): A pure-Julia,
      high performance network analysis library. Edgelists in `DataFrame`s can be
      easily converted into graphs using the
      [GraphDataFrameBridge.jl](https://github.com/JuliaGraphs/GraphDataFrameBridge.jl)
      package.
- **IO**:
    - DataFrames.jl work well with a range of formats, including:
        - CSV files (using [CSV.jl](https://github.com/JuliaData/CSV.jl)),
        - Apache Arrow (using [Arrow.jl](https://github.com/JuliaData/Arrow.jl))
        - reading Stata, SAS and SPSS files (using [ReadStatTables.jl](https://github.com/junyuan-chen/ReadStatTables.jl);
          alternatively [Queryverse](https://www.queryverse.org/) users
          can choose [StatFiles.jl](https://github.com/queryverse/StatFiles.jl)),
        - Parquet files
          (using [Parquet2.jl](https://gitlab.com/ExpandingMan/Parquet2.jl)),
        - reading R data files (.rda, .RData) (using [RData.jl](https://github.com/JuliaData/RData.jl)).

While not all of these libraries are tightly integrated with DataFrames.jl,
because `DataFrame`s are essentially collections of aligned Julia vectors, so it
is easy to (a) pull out a vector for use with a non-DataFrames-integrated
library, or (b) convert your table into a homogeneously-typed matrix using the
`Matrix` constructor or StatsModels.jl.

### Other Julia Tabular Libraries

DataFrames.jl is a great general purpose tool for data manipulation and
wrangling, but it's not ideal for all applications. For users with more
specialized needs, consider using:

- [TypedTables.jl](https://juliadata.github.io/TypedTables.jl/stable/):
  Type-stable heterogeneous tables. Useful for improved performance when the
  structure of your table is relatively stable and does not feature thousands of
  columns.
- [JuliaDB.jl](https://juliadata.github.io/JuliaDB.jl/stable/): For users
  working with data that is too large to fit in memory, we suggest JuliaDB.jl,
  which offers better performance for large datasets, and can handle out-of-core
  data manipulations (Python users can think of JuliaDB.jl as the Julia version of
  [dask](https://dask.org/)).

Note that most tabular data libraries in the Julia ecosystem (including
DataFrames.jl) support a common interface (defined in the
[Tables.jl](https://github.com/JuliaData/Tables.jl) package). As a result, some
libraries are capable or working with a range of tabular data structures, making
it easy to move between tabular libraries as your needs change. A user of
[Query.jl](https://github.com/queryverse/Query.jl), for example, can use the
same code to manipulate data in a `DataFrame`, a `Table` (defined by
TypedTables.jl), or a JuliaDB table.

## Questions?

If there is something you expect DataFrames to be capable of, but
cannot figure out how to do, please reach out with questions in Domains/Data on
[Discourse](https://discourse.julialang.org/new-topic?title=[DataFrames%20Question]:%20&body=%23%20Question:%0A%0A%23%20Dataset%20(if%20applicable):%0A%0A%23%20Minimal%20Working%20Example%20(if%20applicable):%0A&category=Domains/Data&tags=question).
Additionally you might want to listen to an introduction to DataFrames.jl on
[JuliaAcademy](https://juliaacademy.com/p/introduction-to-dataframes-jl).

Please report bugs by
[opening an issue](https://github.com/JuliaData/DataFrames.jl/issues/new).

You can follow the **source** links throughout the documentation to jump right
to the source files on GitHub to make pull requests for improving the
documentation and function capabilities.

Please review [DataFrames contributing
guidelines](https://github.com/JuliaData/DataFrames.jl/blob/main/CONTRIBUTING.md)
before submitting your first PR!

Information on specific versions can be found on the [Release
page](https://github.com/JuliaData/DataFrames.jl/releases).

## Package Manual

```@contents
Pages = ["man/basics.md",
         "man/getting_started.md",
         "man/joins.md",
         "man/split_apply_combine.md",
         "man/reshaping_and_pivoting.md",
         "man/sorting.md",
         "man/categorical.md",
         "man/missing.md",
         "man/comparisons.md",
         "man/querying_frameworks.md"]
Depth = 2
```

## API

Only exported (i.e. available for use without `DataFrames.` qualifier after
loading the DataFrames.jl package with `using DataFrames`) types and functions
are considered a part of the public API of the DataFrames.jl package. In general
all such objects are documented in this manual (in case some documentation is
missing please kindly report an issue
[here](https://github.com/JuliaData/DataFrames.jl/issues/new)).

!!! note

    Breaking changes to public and documented API are avoided in
    DataFrames.jl where possible.

    The following changes are not considered breaking:

    * specific floating point values computed by operations may change at any
      time; users should rely only on approximate accuracy;
    * in functions that use the default random number generator provided by
      Base Julia the specific random numbers computed may change across Julia versions;
    * if the changed functionality is classified as a bug;
    * if the changed behavior was not documented; two major cases are:
      1. in its implementation some function accepted a wider range of arguments
         that it was documented to handle - changes in handling of undocumented
         arguments are not considered as breaking;
      2. the type of the value returned by a function changes, but it still follows
         the contract specified in the documentation; for example if a function
         is documented to return a vector then changing its type from `Vector`
         to `PooledVector` is not considered as breaking;
    * error behavior: code that threw an exception can change exception type
      thrown or stop throwing an exception;
    * changes in display (how objects are printed);
    * changes to the state of global objects from Base Julia whose state
      normally is considered volatile (e.g. state of global random number
      generator).

    All types and functions that are part of public API are guaranteed to go
    through a deprecation period before a breaking change is made to them
    or they would be removed.

    The standard practice is that breaking changes are implemented when a major
    release of DataFrames.jl is made (e.g. functionalities deprecated in a 1.x release
    would be changed in the 2.0 release).

    In rare cases a breaking change might be introduced in a minor release.
    In such a case the changed behavior still goes through one minor release
    during which it is deprecated. The situations where such a breaking change
    might be allowed are (still such breaking changes will be avoided if
    possible):

    * the affected functionality was previously clearly identified in the
      documentation as being subject to changes (for example in DataFrames.jl 1.4
      release propagation rules of `:note`-style metadata are documented as such);
    * the change is on the border of being classified as a bug (in rare cases
      even if a behavior of some function was documented its consequences for
      certain argument combinations could be decided to be unintended and not
      wanted);
    * the change is needed to adjust DataFrames.jl functionality to changes in
      Base Julia.

Please be warned that while Julia allows you to access internal functions or
types of DataFrames.jl these can change without warning between versions of
DataFrames.jl. In particular it is not safe to directly access fields of types
that are a part of public API of the DataFrames.jl package using e.g. the
`getfield` function. Whenever some operation on fields of defined types is
considered allowed an appropriate exported function should be used instead.

```@contents
Pages = ["lib/types.md", "lib/functions.md", "lib/indexing.md"]
Depth = 2
```

## Index

```@index
Pages = ["lib/types.md", "lib/functions.md"]
```

# Sorting

Sorting is a fundamental component of data analysis. Basic sorting is trivial:
just calling `sort!` will sort all columns, in place:

```jldoctest sort
julia> using DataFrames, CSV

julia> path = joinpath(pkgdir(DataFrames), "docs", "src", "assets", "iris.csv");

julia> iris = CSV.read(path, DataFrame)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         5.1         3.5          1.4         0.2  Iris-setosa
   2 │         4.9         3.0          1.4         0.2  Iris-setosa
   3 │         4.7         3.2          1.3         0.2  Iris-setosa
   4 │         4.6         3.1          1.5         0.2  Iris-setosa
   5 │         5.0         3.6          1.4         0.2  Iris-setosa
   6 │         5.4         3.9          1.7         0.4  Iris-setosa
   7 │         4.6         3.4          1.4         0.3  Iris-setosa
   8 │         5.0         3.4          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         6.8         3.2          5.9         2.3  Iris-virginica
 145 │         6.7         3.3          5.7         2.5  Iris-virginica
 146 │         6.7         3.0          5.2         2.3  Iris-virginica
 147 │         6.3         2.5          5.0         1.9  Iris-virginica
 148 │         6.5         3.0          5.2         2.0  Iris-virginica
 149 │         6.2         3.4          5.4         2.3  Iris-virginica
 150 │         5.9         3.0          5.1         1.8  Iris-virginica
                                                        135 rows omitted

julia> sort!(iris)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         4.3         3.0          1.1         0.1  Iris-setosa
   2 │         4.4         2.9          1.4         0.2  Iris-setosa
   3 │         4.4         3.0          1.3         0.2  Iris-setosa
   4 │         4.4         3.2          1.3         0.2  Iris-setosa
   5 │         4.5         2.3          1.3         0.3  Iris-setosa
   6 │         4.6         3.1          1.5         0.2  Iris-setosa
   7 │         4.6         3.2          1.4         0.2  Iris-setosa
   8 │         4.6         3.4          1.4         0.3  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         7.4         2.8          6.1         1.9  Iris-virginica
 145 │         7.6         3.0          6.6         2.1  Iris-virginica
 146 │         7.7         2.6          6.9         2.3  Iris-virginica
 147 │         7.7         2.8          6.7         2.0  Iris-virginica
 148 │         7.7         3.0          6.1         2.3  Iris-virginica
 149 │         7.7         3.8          6.7         2.2  Iris-virginica
 150 │         7.9         3.8          6.4         2.0  Iris-virginica
                                                        135 rows omitted
```

Observe that all columns are taken into account lexicographically when sorting the `DataFrame`.

You can also call the `sort` function to create a new `DataFrame` with freshly allocated sorted vectors.

In sorting `DataFrame`s, you may want to sort different columns with different options.
Here are some examples showing most of the possible options:

```jldoctest sort
julia> sort!(iris, rev = true)
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         7.9         3.8          6.4         2.0  Iris-virginica
   2 │         7.7         3.8          6.7         2.2  Iris-virginica
   3 │         7.7         3.0          6.1         2.3  Iris-virginica
   4 │         7.7         2.8          6.7         2.0  Iris-virginica
   5 │         7.7         2.6          6.9         2.3  Iris-virginica
   6 │         7.6         3.0          6.6         2.1  Iris-virginica
   7 │         7.4         2.8          6.1         1.9  Iris-virginica
   8 │         7.3         2.9          6.3         1.8  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         4.6         3.2          1.4         0.2  Iris-setosa
 145 │         4.6         3.1          1.5         0.2  Iris-setosa
 146 │         4.5         2.3          1.3         0.3  Iris-setosa
 147 │         4.4         3.2          1.3         0.2  Iris-setosa
 148 │         4.4         3.0          1.3         0.2  Iris-setosa
 149 │         4.4         2.9          1.4         0.2  Iris-setosa
 150 │         4.3         3.0          1.1         0.1  Iris-setosa
                                                        135 rows omitted

julia> sort!(iris, [:Species, :SepalWidth])
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         4.5         2.3          1.3         0.3  Iris-setosa
   2 │         4.4         2.9          1.4         0.2  Iris-setosa
   3 │         5.0         3.0          1.6         0.2  Iris-setosa
   4 │         4.9         3.0          1.4         0.2  Iris-setosa
   5 │         4.8         3.0          1.4         0.3  Iris-setosa
   6 │         4.8         3.0          1.4         0.1  Iris-setosa
   7 │         4.4         3.0          1.3         0.2  Iris-setosa
   8 │         4.3         3.0          1.1         0.1  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         6.7         3.3          5.7         2.1  Iris-virginica
 145 │         6.3         3.3          6.0         2.5  Iris-virginica
 146 │         6.3         3.4          5.6         2.4  Iris-virginica
 147 │         6.2         3.4          5.4         2.3  Iris-virginica
 148 │         7.2         3.6          6.1         2.5  Iris-virginica
 149 │         7.9         3.8          6.4         2.0  Iris-virginica
 150 │         7.7         3.8          6.7         2.2  Iris-virginica
                                                        135 rows omitted

julia> sort!(iris, [order(:Species, by=length), order(:SepalLength, rev=true)])
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼───────────────────────────────────────────────────────────────────
   1 │         5.8         4.0          1.2         0.2  Iris-setosa
   2 │         5.7         3.8          1.7         0.3  Iris-setosa
   3 │         5.7         4.4          1.5         0.4  Iris-setosa
   4 │         5.5         3.5          1.3         0.2  Iris-setosa
   5 │         5.5         4.2          1.4         0.2  Iris-setosa
   6 │         5.4         3.4          1.7         0.2  Iris-setosa
   7 │         5.4         3.4          1.5         0.4  Iris-setosa
   8 │         5.4         3.7          1.5         0.2  Iris-setosa
  ⋮  │      ⋮           ⋮            ⋮           ⋮              ⋮
 144 │         5.5         2.6          4.4         1.2  Iris-versicolor
 145 │         5.4         3.0          4.5         1.5  Iris-versicolor
 146 │         5.2         2.7          3.9         1.4  Iris-versicolor
 147 │         5.1         2.5          3.0         1.1  Iris-versicolor
 148 │         5.0         2.0          3.5         1.0  Iris-versicolor
 149 │         5.0         2.3          3.3         1.0  Iris-versicolor
 150 │         4.9         2.4          3.3         1.0  Iris-versicolor
                                                         135 rows omitted
```

Keywords used above include `rev` (to sort in reverse),
and `by` (to apply a function to values before comparing them).
Each keyword can either be a single value, a vector with values corresponding to
individual columns, or a selector: `:`, `Cols`, `All`, `Not`, `Between`, or `Regex`.

As an alternative to using a vector values you can use `order` to specify
an ordering for a particular column within a set of columns.

The following two examples show two ways to sort the `iris` dataset with the
same result: `:Species` will be ordered in reverse order, and within groups,
rows will be sorted by increasing `:PetalLength`:

```jldoctest sort
julia> sort!(iris, [:Species, :PetalLength], rev=[true, false])
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         4.9         2.5          4.5         1.7  Iris-virginica
   2 │         6.2         2.8          4.8         1.8  Iris-virginica
   3 │         6.0         3.0          4.8         1.8  Iris-virginica
   4 │         6.3         2.7          4.9         1.8  Iris-virginica
   5 │         6.1         3.0          4.9         1.8  Iris-virginica
   6 │         5.6         2.8          4.9         2.0  Iris-virginica
   7 │         6.3         2.5          5.0         1.9  Iris-virginica
   8 │         6.0         2.2          5.0         1.5  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         4.7         3.2          1.6         0.2  Iris-setosa
 145 │         5.7         3.8          1.7         0.3  Iris-setosa
 146 │         5.4         3.4          1.7         0.2  Iris-setosa
 147 │         5.4         3.9          1.7         0.4  Iris-setosa
 148 │         5.1         3.3          1.7         0.5  Iris-setosa
 149 │         5.1         3.8          1.9         0.4  Iris-setosa
 150 │         4.8         3.4          1.9         0.2  Iris-setosa
                                                        135 rows omitted

julia> sort!(iris, [order(:Species, rev=true), :PetalLength])
150×5 DataFrame
 Row │ SepalLength  SepalWidth  PetalLength  PetalWidth  Species
     │ Float64      Float64     Float64      Float64     String15
─────┼──────────────────────────────────────────────────────────────────
   1 │         4.9         2.5          4.5         1.7  Iris-virginica
   2 │         6.2         2.8          4.8         1.8  Iris-virginica
   3 │         6.0         3.0          4.8         1.8  Iris-virginica
   4 │         6.3         2.7          4.9         1.8  Iris-virginica
   5 │         6.1         3.0          4.9         1.8  Iris-virginica
   6 │         5.6         2.8          4.9         2.0  Iris-virginica
   7 │         6.3         2.5          5.0         1.9  Iris-virginica
   8 │         6.0         2.2          5.0         1.5  Iris-virginica
  ⋮  │      ⋮           ⋮            ⋮           ⋮             ⋮
 144 │         4.7         3.2          1.6         0.2  Iris-setosa
 145 │         5.7         3.8          1.7         0.3  Iris-setosa
 146 │         5.4         3.4          1.7         0.2  Iris-setosa
 147 │         5.4         3.9          1.7         0.4  Iris-setosa
 148 │         5.1         3.3          1.7         0.5  Iris-setosa
 149 │         5.1         3.8          1.9         0.4  Iris-setosa
 150 │         4.8         3.4          1.9         0.2  Iris-setosa
                                                        135 rows omitted
```

```@meta
CurrentModule = DataFrames
```

# Types

```@index
Pages = ["types.md"]
```

## Type hierarchy design

`AbstractDataFrame` is an abstract type that provides an interface for data frame types.
It is not intended as a fully generic interface for working with tabular data, which is the role of
interfaces defined by [Tables.jl](https://github.com/JuliaData/Tables.jl/) instead.

`DataFrame` is the most fundamental subtype of `AbstractDataFrame`, which stores a set of columns
as `AbstractVector` objects. Indexing of all stored columns must be 1-based. Also, all functions
exposed by DataFrames.jl API make sure to `collect` passed `AbstractRange` source columns before
storing them in a `DataFrame`.

`SubDataFrame` is an `AbstractDataFrame` subtype representing a view into a `DataFrame`.
It stores only a reference to the parent `DataFrame` and information about which rows and columns
from the parent are selected (both as integer indices referring to the parent).
Typically it is created using the `view` function or is returned by indexing into a `GroupedDataFrame` object.

`GroupedDataFrame` is a type that stores the result of a  grouping operation performed on an `AbstractDataFrame`.
It is intended to be created as a result of a call to the `groupby` function.

`DataFrameRow` is a view into a single row of an `AbstractDataFrame`. It stores only a reference
to a parent `DataFrame` and information about which row and columns from the parent are selected
(both as integer indices referring to the parent).
The `DataFrameRow` type supports iteration over columns of the row and is similar in functionality to
the `NamedTuple` type, but allows for modification of data stored in the parent `DataFrame`
and reflects changes done to the parent after the creation of the view.
Typically objects of the `DataFrameRow` type are encountered when returned by the `eachrow` function,
or when accessing a single row of a `DataFrame` or `SubDataFrame` via `getindex` or `view`.

The `eachrow` function returns a value of the `DataFrameRows` type, which
serves as an iterator over rows of an `AbstractDataFrame`, returning `DataFrameRow` objects.
The `DataFrameRows` is a subtype of `AbstractVector` and supports its interface
with the exception that it is read-only.

Similarly, the `eachcol` function returns a value of the `DataFrameColumns` type, which
is not an `AbstractVector`, but supports most of its API. The key differences are that it is read-only and
that the `keys` function returns a vector of `Symbol`s (and not integers as for normal vectors).

Note that `DataFrameRows` and `DataFrameColumns` are not exported and should not be constructed directly,
but using the `eachrow` and `eachcol` functions.

The `RepeatedVector` and `StackedVector` types are subtypes of `AbstractVector` and support its interface
with the exception that they are read only. Note that they are not exported and should not be constructed directly,
but they are columns of a `DataFrame` returned by `stack` with `view=true`.

The `ByRow` type is a special type used for selection operations to signal that the wrapped function should be applied
to each element (row) of the selection.

The `AsTable` type is a special type used for selection operations to signal that the columns selected by a wrapped
selector should be passed as a `NamedTuple` to the function or to signal that it is requested
to expand the return value of a transformation into multiple columns.

## [The design of handling of columns of a `DataFrame`](@id man-columnhandling)

When a `DataFrame` is constructed columns are copied by default. You can disable
this behavior by setting `copycols` keyword argument to `false`.
The exception is if an `AbstractRange` is passed as a column, then it is always collected to a `Vector`.

Also functions that transform a `DataFrame` to produce a new `DataFrame` perform a copy of the columns,
unless they are passed `copycols=false` (available only for functions
that could perform a transformation without copying the columns). Examples of such functions are [`vcat`](@ref),
[`hcat`](@ref), [`filter`](@ref), [`dropmissing`](@ref), `getindex`,
[`copy`](@ref) or the [`DataFrame`](@ref) constructor mentioned above.

The generic single-argument constructor `DataFrame(table)` has `copycols=nothing`
by default, meaning that columns are copied unless `table`
signals that a copy of columns doesn't need to be made (this is done by wrapping
the source table in `Tables.CopiedColumns`).
[CSV.jl](https://csv.juliadata.org/stable) does this when
`CSV.read(file, DataFrame)` is called, since columns are built only for the purpose
of use in a `DataFrame` constructor.
Another example is [`Arrow.Table`](https://arrow.juliadata.org/dev/manual/#Arrow.Table),
where arrow data is inherently immutable so columns can't be accidentally mutated
anyway. To be able to mutate arrow data, columns must be materialized,
which can be accomplished via `DataFrame(arrow_table, copycols=true)`.

On the contrary, functions that create a view of a `DataFrame` *do not* by definition make copies of
the columns, and therefore require particular caution. This includes `view`, which returns
a `SubDataFrame` or a `DataFrameRow`, and `groupby`, which returns a `GroupedDataFrame`.

A partial exception to this rule is the [`stack`](@ref) function with `view=true` which
creates a `DataFrame` that contains views of the columns from the source `DataFrame`.

In-place functions whose names end with `!` (like `sort!` or [`dropmissing!`](@ref),
`setindex!`, `push!`, `append!`) may mutate the column vectors of the `DataFrame` they take
as an argument. These functions are safe to call due to the rules described above,
*except* when a view of the `DataFrame` is in use (via a `SubDataFrame`, a `DataFrameRow`
or a `GroupedDataFrame`). In the latter case, calling such a function on the parent might corrupt the view,
which make trigger errors, silently return invalid data or even cause Julia to crash.
The same caution applies when `DataFrame` was created using columns of another `DataFrame` without copying
(for instance when `copycols=false` in functions such as `DataFrame` or `hcat`).

It is possible to have a direct access to a column `col` of a `DataFrame` `df`
(e.g. this can be useful in performance critical code to avoid copying),
using one of the following methods:

* via the `getproperty` function using the syntax `df.col`;
* via the `getindex` function using the syntax `df[!, :col]` (note this is in contrast to `df[:, :col]` which copies);
* by creating a `DataFrameColumns` object using the [`eachcol`](@ref) function;
* by calling the `parent` function on a view of a column of the `DataFrame`, e.g. `parent(@view df[:, :col])`;
* by storing the reference to the column before creating a `DataFrame` with `copycols=false`;

A column obtained from a `DataFrame` using one of the above methods should not be mutated
without caution because:

* resizing a column vector will corrupt its parent `DataFrame` and any associated views
  as methods only check the length of the column when it is added
  to the `DataFrame` and later assume that all columns have the same length;
* reordering values in a column vector (e.g. using `sort!`) will break the consistency of rows
  with other columns, which will also affect views (if any);
* changing values contained in a column vector is acceptable as long as it is not used as
  a grouping column in a `GroupedDataFrame` created based on the `DataFrame`.

## Types specification

```@docs
AbstractDataFrame
AsTable
DataFrame
DataFrameRow
GroupedDataFrame
GroupKey
GroupKeys
SubDataFrame
DataFrameRows
DataFrameColumns
RepeatedVector
StackedVector
```

```@meta
CurrentModule = DataFrames
```

# Indexing

```@index
Pages = ["indexing.md"]
```

## General rules

The following rules explain target functionality of how `getindex`, `setindex!`,
`view`, and broadcasting are intended to work with `DataFrame`, `SubDataFrame`
and `DataFrameRow` objects.

The following values are a valid column index:
* a scalar, later denoted as `col`:
    * a `Symbol`;
    * an `AbstractString`;
    * an `Integer` that is not `Bool`;
* a vector, later denoted as `cols`:
    * a vector of `Symbol` (does not have to be a subtype of
      `AbstractVector{Symbol}`);
    * a vector of `AbstractString` (does not have to be a subtype of
      `AbstractVector{<:AbstractString}`);
    * a vector of `Integer` that are not `Bool` (does not have to be a subtype of
      `AbstractVector{<:Integer}`);
    * a vector of `Bool` (must be a subtype of `AbstractVector{Bool}`);
    * a [regular expression](https://docs.julialang.org/en/v1/manual/strings/#Regular-Expressions)
      (will be expanded to a vector of matching column names);
    * a `Not` expression (see
      [InvertedIndices.jl](https://github.com/JuliaData/InvertedIndices.jl));
      `Not(idx)` selects all indices not in the passed `idx`;
      when passed as column selector `Not(idx...)` is equivalent to
      `Not(Cols(idx...))`.
    * a `Cols` expression (see
      [DataAPI.jl](https://github.com/JuliaData/DataAPI.jl)); `Cols(idxs...)`
      selects the union of the selections in `idxs`; in particular `Cols()`
      selects no columns and `Cols(:)` selects all columns; a special rule is
      `Cols(predicate)`, where `predicate` is a predicate function; in this case
      the columns whose names passed to `predicate` as strings return `true` are
      selected.
    * a `Between` expression (see
      [DataAPI.jl](https://github.com/JuliaData/DataAPI.jl));
      `Between(first, last)` selects the columns between `first` and `last` inclusively;
    * an `All` expression (see
      [DataAPI.jl](https://github.com/JuliaData/DataAPI.jl)); `All()` selects
      all columns, equivalent to `:`;
    * a literal colon `:` (selects all columns).

The following values are a valid row index:
* a scalar, later denoted as `row`:
    * an `Integer` that is not `Bool`;
* a vector, later denoted as `rows`:
    * a vector of `Integer` that are not `Bool` (does not have to be a subtype of
      `AbstractVector{<:Integer}`);
    * a vector of `Bool` (must be a subtype of `AbstractVector{Bool}`);
    * a `Not` expression (see
      [InvertedIndices.jl](https://github.com/JuliaData/InvertedIndices.jl));
    * a literal colon `:` (selects all rows with copying);
    * a literal exclamation mark `!` (selects all rows without copying).

Additionally it is allowed to index into an `AbstractDataFrame` using a
two-dimensional `CartesianIndex`.

In the descriptions below `df` represents a `DataFrame`, `sdf` is a
`SubDataFrame` and `dfr` is a `DataFrameRow`.

`:` always expands to `axes(df, 1)` or `axes(sdf, 1)`.

`df.col` works like `df[!, col]` and `sdf.col` works like `sdf[!, col]` in all
cases.

## `getindex` and `view`

The following list specifies the behavior of `getindex` and `view` operations
depending on argument types.

In particular a description explicitly mentions that the data is *copied* or
*reused without copying*.

For performance reasons, accessing, via `getindex` or `view`, a single `row` and
multiple `cols` of a `DataFrame`, a `SubDataFrame` or a `DataFrameRow` always
returns a `DataFrameRow` (which is a view type).

`getindex` on `DataFrame`:
* `df[row, col]` -> the value contained in row `row` of column `col`, the same
  as `df[!, col][row]`;
* `df[CartesianIndex(row, col)]` -> the same as `df[row, col]`;
* `df[row, cols]` -> a `DataFrameRow` with parent `df`;
* `df[rows, col]` -> a copy of the vector `df[!, col]` with only the entries
                     corresponding to `rows` selected, the same as `df[!, col][rows]`;
* `df[rows, cols]` -> a `DataFrame` containing copies of columns `cols` with
                      only the entries corresponding to `rows` selected;
* `df[!, col]` -> the vector contained in column `col` returned without copying;
                  the same as `df.col` if `col` is a valid identifier.
* `df[!, cols]` -> create a new `DataFrame` with columns `cols` without copying
                   of columns; the same as `select(df, cols, copycols=false)`.

`view` on `DataFrame`:
* `@view df[row, col]` -> a `0`-dimensional view into `df[!, col]` in row `row`,
                          the same as `view(df[!, col], row)`;
* `@view df[CartesianIndex(row, col)]` -> the same as `@view df[row, col]`;
* `@view df[row, cols]` -> the same as `df[row, cols]`;
* `@view df[rows, col]` -> a view into `df[!, col]` with `rows` selected, the
                           same as `view(df[!, col], rows)`;
* `@view df[rows, cols]` -> a `SubDataFrame` with `rows` selected with parent
  `df`;
* `@view df[!, col]` -> a view into `df[!, col]`  with all rows.
* `@view df[!, cols]` -> the same as `@view df[:, cols]`.

`getindex` on `SubDataFrame`:
* `sdf[row, col]` -> a value contained in row `row` of column `col`;
* `sdf[CartesianIndex(row, col)]` -> the same as `sdf[row, col]`;
* `sdf[row, cols]` -> a `DataFrameRow` with parent `parent(sdf)`;
* `sdf[rows, col]` -> a copy of `sdf[!, col]` with only rows `rows` selected,
                      the same as `sdf[!, col][rows]`;
* `sdf[rows, cols]` -> a `DataFrame` containing columns `cols` and
  `sdf[rows, col]` as a vector for each `col` in `cols`;
* `sdf[!, col]` -> a view of entries corresponding to `sdf` in the vector
                   `parent(sdf)[!, col]`; the same as `sdf.col` if `col` is a
                   valid identifier.
* `sdf[!, cols]` -> create a new `SubDataFrame` with columns `cols`, the same
                    parent as `sdf`, and the same rows selected; the same as
                    `select(sdf, cols, copycols=false)`.


`view` on `SubDataFrame`:
* `@view sdf[row, col]` -> a `0`-dimensional view into `df[!, col]` at row
                           `row`, the same as `view(sdf[!, col], row)`;
* `@view sdf[CartesianIndex(row, col)]` -> the same as `@view sdf[row, col]`;
* `@view sdf[row, cols]` -> a `DataFrameRow` with parent `parent(sdf)`;
* `@view sdf[rows, col]` -> a view into `sdf[!, col]` vector with `rows`
                            selected, the same as `view(sdf[!, col], rows)`;
* `@view sdf[rows, cols]` -> a `SubDataFrame` with parent `parent(sdf)`;
* `@view sdf[!, col]` -> a view into `sdf[!, col]` vector with all rows.
* `@view sdf[!, cols]` -> the same as `@view sdf[:, cols]`.

`getindex` on `DataFrameRow`:
* `dfr[col]` -> the value contained in column `col` of `dfr`; the same as
                `dfr.col` if `col` is a valid identifier;
* `dfr[cols]` -> a `DataFrameRow` with parent `parent(dfr)`;

`view` on `DataFrameRow`:
* `@view dfr[col]` -> a `0`-dimensional view into
                      `parent(dfr)[DataFrames.row(dfr), col]`;
* `@view dfr[cols]` -> a `DataFrameRow` with parent `parent(dfr)`;

Note that views created with columns selector set to `:` change their columns'
count if columns are added/removed/renamed in the parent; if column selector is
other than `:` then view points to selected columns by their number at the
moment of creation of the view.

## `setindex!`

The following list specifies the behavior of `setindex!` operations depending on
argument types.

In particular a description explicitly mentions if the assignment is *in-place*.

Note that if a `setindex!` operation throws an error the target data frame may
be partially changed so it is unsafe to use it afterwards (the column length
correctness will be preserved).

`setindex!` on `DataFrame`:
* `df[row, col] = v` -> set value of `col` in row `row` to `v` in-place;
* `df[CartesianIndex(row, col)] = v` -> the same as `df[row, col] = v`;
* `df[row, cols] = v` -> set row `row` of columns `cols` in-place; the same as
                         `dfr = df[row, cols]; dfr[:] = v`;
* `df[rows, col] = v` -> set rows `rows` of column `col` in-place; `v` must be
                         an `AbstractVector`; if `rows` is `:` and `col` is a
                         `Symbol` or `AbstractString` that is not present in
                         `df` then a new column in `df` is created and holds a
                         `copy` of `v`; equivalent to `df.col = copy(v)` if
                         `col` is a valid identifier;
* `df[rows, cols] = v` -> set rows `rows` of columns `cols` in-place; `v` must
                          be an `AbstractMatrix` or an `AbstractDataFrame` (in
                          this case column names must match);
* `df[!, col] = v` -> replaces `col` with `v` without copying (with the
                      exception that if `v` is an `AbstractRange` it gets
                      converted to a `Vector`); also if `col` is a `Symbol` or
                      `AbstractString` that is not present in `df` then a new
                      column in `df` is created and holds `v`; equivalent to
                      `df.col = v` if `col` is a valid identifier; this is
                      allowed if `ncol(df) == 0 || length(v) == nrow(df)`;
* `df[!, cols] = v` -> replaces existing columns `cols` in data frame `df` with
                       copying; `v` must be an `AbstractMatrix` or an
                       `AbstractDataFrame` (in the latter case column names must
                       match);

`setindex!` on `SubDataFrame`:
* `sdf[row, col] = v` -> set value of `col` in row `row` to `v` in-place;
* `sdf[CartesianIndex(row, col)] = v` -> the same as `sdf[row, col] = v`;
* `sdf[row, cols] = v` -> the same as `dfr = df[row, cols]; dfr[:] = v` in-place;
* `sdf[rows, col] = v` -> set rows `rows` of column `col`, in-place; `v` must be
                          an abstract vector;
* `sdf[rows, cols] = v` -> set rows `rows` of columns `cols` in-place; `v` can
                           be an `AbstractMatrix` or `v` can be
                           `AbstractDataFrame` in which case column names must
                           match;
* `sdf[!, col] = v` -> replaces `col` with `v` with copying; if `col` is present
                       in `sdf` then filtered-out rows in newly created vector
                       are filled with values already present in that column and
                       `promote_type` is used to determine the `eltype` of the
                       new column; if `col` is not present in `sdf` then the
                       operation is only allowed if `sdf` was created with `:`
                       as column selector, in which case filtered-out rows are
                       filled with `missing`; equivalent to `sdf.col = v` if
                       `col` is a valid identifier; operation is allowed if
                       `length(v) == nrow(sdf)`;
* `sdf[!, cols] = v` -> replaces existing columns `cols` in data frame `sdf`
                        with copying; `v` must be an `AbstractMatrix` or an
                        `AbstractDataFrame` (in the latter case column names
                        must match); filtered-out rows in newly created vectors
                        are filled with values already present in respective
                        columns and `promote_type` is used to determine the
                        `eltype` of the new columns;

!!! note

    The rules above mean that `sdf[:, col] = v` is an in-place operation if
    `col` is present in `sdf`, therefore it will be fast in general. On the
    other hand using `sdf[!, col] = v` or `sdf.col = v` will always allocate a
    new vector, which is more expensive computationally.


`setindex!` on `DataFrameRow`:
* `dfr[col] = v` -> set value of `col` in row `row` to `v` in-place;
                    equivalent to `dfr.col = v` if `col` is a valid identifier;
* `dfr[cols] = v` -> set values of entries in columns `cols` in `dfr` by
                     elements of `v` in place; `v` can be: 1) a `Tuple` or an
                     `AbstractArray`, in which cases it must have a number of
                     elements equal to `length(dfr)`, 2) an `AbstractDict`, in
                     which case column names must match, 3) a `NamedTuple` or
                     `DataFrameRow`, in which case column names and order must
                     match;

## Broadcasting

The following broadcasting rules apply to `AbstractDataFrame` objects:
* `AbstractDataFrame` behaves in broadcasting like a two-dimensional collection
  compatible with matrices.
* If an `AbstractDataFrame` takes part in broadcasting then a `DataFrame` is
  always produced as a result. In this case the requested broadcasting operation
  produces an object with exactly two dimensions. An exception is when an
  `AbstractDataFrame` is used only as a source of broadcast assignment into an
  object of dimensionality higher than two.
* If multiple `AbstractDataFrame` objects take part in broadcasting then they
  have to have identical column names.

Note that if broadcasting assignment operation throws an error the target data
frame may be partially changed so it is unsafe to use it afterwards (the column
length correctness will be preserved).

Broadcasting `DataFrameRow` is currently not allowed (which is consistent with
`NamedTuple`).

It is possible to assign a value to `AbstractDataFrame` and `DataFrameRow`
objects using the `.=` operator. In such an operation `AbstractDataFrame` is
considered as two-dimensional and `DataFrameRow` as single-dimensional.

!!! note

    The rule above means that, similar to single-dimensional objects in Base
    (e.g. vectors), `DataFrameRow` is considered to be column-oriented.

Additional rules:
* in the `df[CartesianIndex(row, col)] .= v`, `df[row, col] .= v` syntaxes `v`
  is broadcasted into the contents of `df[row, col]` (this is consistent with
  Julia Base);
* in the `df[row, cols] .= v` syntaxes the assignment to `df` is performed
  in-place;
* in the `df[rows, col] .= v` and `df[rows, cols] .= v` syntaxes the assignment
  to `df` is performed in-place; if `rows` is `:` and `col` is `Symbol` or
  `AbstractString` and it is missing from `df` then a new column is allocated
  and added; the length of the column is always the value of `nrow(df)` before
  the assignment takes place;
* in the `df[!, col] .= v` syntax column `col` is replaced by a freshly
  allocated vector; if `col` is `Symbol` or `AbstractString` and it is missing
  from `df` then a new column is allocated added; the length of the column is
  always the value of `nrow(df)` before the assignment takes place;
* the `df[!, cols] .= v` syntax replaces existing columns `cols` in data frame
  `df` with freshly allocated vectors;
* `df.col .= v` syntax currently performs in-place assignment to an existing
  vector `df.col`; this behavior is deprecated and a new column will be
  allocated in the future. If `:col` is not present in
  `df` then a new column will be created in `df`.
* in the `sdf[CartesianIndex(row, col)] .= v`, `sdf[row, col] .= v` and
  `sdf[row, cols] .= v` syntaxes the assignment to `sdf` is performed in-place;
* in the `sdf[rows, col] .= v` and `sdf[rows, cols] .= v` syntaxes the
  assignment to `sdf` is performed in-place; if `rows` is `:` and `col` is a
  `Symbol` or `AbstractString` referring to a column missing from `sdf` and
  `sdf` was created with `:` as column selector then a new column is allocated
  and added; the filtered-out rows are filled with `missing`;
* in the `sdf[!, col] .= v` syntax column `col` is replaced by a freshly
  allocated vector; the filtered-out rows are filled with values already present
  in `col`; if `col` is a `Symbol` or `AbstractString` referring to a column
  missing from `sdf` and was `sdf` created with `:` as column selector then a
  new column is allocated and added; in this case the filtered-out rows are
  filled with `missing`;
* the `sdf[!, cols] .= v` syntax replaces existing columns `cols` in data frame
  `sdf` with freshly allocated vectors; the filtered-out rows are filled with
  values already present in `cols`;
* `sdf.col .= v` syntax currently performs in-place assignment to an existing
  vector `sdf.col`; this behavior is deprecated and a new column will be
  allocated in the future. If `:col` is not present in
  `sdf` then a new column will be created in `sdf` if `sdf` was created with `:`
  as a column selector.
* `dfr.col .= v` syntax is allowed and performs in-place assignment to a value
  extracted by `dfr.col`.

Note that `sdf[!, col] .= v` and `sdf[!, cols] .= v` syntaxes are not allowed as
`sdf` can be only modified in-place.

If column indexing using `Symbol` or `AbstractString` names in `cols` is
performed, the order of columns in the operation is specified by the order of
names.

## Indexing `GroupedDataFrame`s

A [`GroupedDataFrame`](@ref) can behave as either an `AbstractVector` or
`AbstractDict` depending on the type of index used. Integers (or arrays of them)
trigger vector-like indexing while `Tuples`s and `NamedTuple`s trigger
dictionary-like indexing. An intermediate between the two is the
[`GroupKey`](@ref) type returned by [`keys(::GroupedDataFrame)`](@ref), which
behaves similarly to a `NamedTuple` but has performance on par with integer
indexing.

The elements of a `GroupedDataFrame` are [`SubDataFrame`](@ref)s of its parent.

* `gd[i::Integer]` -> Get the `i`th group.
* `gd[key::NamedTuple]` -> Get the group corresponding to the given values of
  the grouping columns. The fields of the `NamedTuple` must match the grouping
  columns columns passed to [`groupby`](@ref) (including order).
* `gd[key::Tuple]` -> Same as previous, but omitting the names on `key`.
* `get(gd, key::Union{Tuple, NamedTuple}, default)` -> Get group for key `key`,
  returning `default` if it does not exist.
* `gd[key::GroupKey]` -> Get the group corresponding to the [`GroupKey`](@ref)
  `key` (one of the elements of the vector returned by
  [`keys(::GroupedDataFrame)`](@ref)). This should be nearly as fast as integer
  indexing.
* `gd[a::AbstractVector]` -> Select multiple groups and return them in a new
  `GroupedDataFrame` object. Groups may be selected by integer position using an
  array of `Integer`s or `Bool`s, similar to a standard array. Alternatively the
  array may contain keys of any of the types supported for dictionary-like
  indexing (`GroupKey`, `Tuple`, or `NamedTuple`). Selected groups must be
  unique, and different types of indices cannot be mixed.
* `gd[n::Not]` -> Any of the above types wrapped in `Not`. The result will be a
   new `GroupedDataFrame` containing all groups in `gd` *not* selected by the
   wrapped index.

# Common API for types defined in DataFrames.jl

This table presents return value types of calling `names`, `propertynames`,
`keys`, `length` and `ndims` on types exposed to the user by DataFrames.jl:

| Type                | `names`          | `propertynames`  | `keys`           | `length`  | `ndims` |
|---------------------|------------------|------------------|------------------|-----------|---------|
| `AbstractDataFrame` | `Vector{String}` | `Vector{Symbol}` | undefined        | undefined | `2`     |
| `DataFrameRow`      | `Vector{String}` | `Vector{Symbol}` | `Vector{Symbol}` | `Int`     | `1`     |
| `DataFrameRows`     | `Vector{String}` | `Vector{Symbol}` | vector of `Int`  | `Int`     | `1`     |
| `DataFrameColumns`  | `Vector{String}` | `Vector{Symbol}` | `Vector{Symbol}` | `Int`     | `1`     |
| `GroupedDataFrame`  | `Vector{String}` | tuple of fields  | `GroupKeys`      | `Int`     | `1`     |
| `GroupKeys`         | undefined        | tuple of fields  | vector of `Int`  | `Int`     | `1`     |
| `GroupKey`          | `Vector{String}` | `Vector{Symbol}` | `Vector{Symbol}` | `Int`     | `1`     |

Additionally the above types `T` (i.e. `AbstractDataFrame`, `DataFrameRow`,
`DataFrameRows`, `DataFrameColumns`, `GroupedDataFrame`, `GroupKeys`,
`GroupKey`) the following methods are defined:
* `size(::T)` returning a `Tuple` of `Int`.
* `size(::T, ::Integer)` returning an `Int`.
* `axes(::T)` returning a `Tuple` of `Int` vectors.
* `axes(::T, ::Integer)` returning an `Int` vector for a valid dimension (except
   `DataFrameRows` and `GroupKeys` for which `Base.OneTo(1)` is also returned
   for a dimension higher than a valid one because they are `AbstractVector`).
* `firstindex(::T)` returning `1` (except `AbstractDataFrame` for which it is
  undefined).
* `firstindex(::T, ::Integer)` returning `1` for a valid dimension (except
   `DataFrameRows` and `GroupKeys` for which `1` is also returned for a
   dimension higher than a valid one because they are `AbstractVector`).
* `lastindex(::T)` returning `Int` (except `AbstractDataFrame` for which it is
  undefined).
* `lastindex(::T, ::Integer)` returning `Int` for a valid dimension  (except
   `DataFrameRows` and `GroupKeys` for which `1` is also returned for a
   dimension higher than a valid one because they are `AbstractVector`).
